"use strict";class DoubleLinkedList{constructor(){this.last=null,this.root=null,this.count=0,this.indexKey="index"}add(node){this.root?(this.last.next=node,node.prev=this.last,this.last=node):this.root=this.last=node,this.count++}remove(node){node.prev&&(node.prev.next=node.next),node.next&&(node.next.prev=node.prev),node===this.root&&(this.root=node.next),node===this.last&&(this.last=node.prev),node.next=node.prev=null,this.count--}insertSorted(node){this.count==0?this.add(node):this.insertInOrder(node)}insertInOrder(node){let current=this.root;for(;current;){if(node[this.indexKey]<=current[this.indexKey]){this.insertBefore(node,current);return}current=current.next}this.add(node)}insertWithPivot(node){if(!node[this.indexKey])throw new Error("Node must have an 'index' property.");if(this.count==0){this.add(node);return}let minNode=this.root,maxNode=this.last,count=this.count;for(;count>2;){let slow=minNode,fast=minNode;for(;fast!==maxNode&&fast.next!==maxNode;)slow=slow.next,fast=fast.next.next;const middleNode=slow;node[this.indexKey]<=middleNode[this.indexKey]?(maxNode=middleNode,count=Math.floor(count/2)):(minNode=middleNode,count=count-Math.floor(count/2))}node[this.indexKey]<=minNode[this.indexKey]?this.insertBefore(node,minNode):node[this.indexKey]>=maxNode[this.indexKey]?this.insertAfter(node,maxNode):this.insertAfter(node,minNode)}insertAfter(node,afterNode){if(node==afterNode){console.warn("node == afterNode");return}const tmp=afterNode.next;afterNode.next=node,node.prev=afterNode,tmp===null?this.last=node:(node.next=tmp,tmp.prev=node),this.count++}insertBefore(node,beforeNode){if(node==beforeNode){console.warn("node == beforeNode");return}const tmp=beforeNode.prev;beforeNode.prev=node,node.next=beforeNode,node.prev=tmp,tmp===null?this.root=node:tmp.next=node,this.count++}pop(){if(this.isEmpty())return null;const node=this.last;return this.remove(node),node}shift(){if(this.isEmpty())return null;const node=this.root;return this.remove(node),node}getNodeAtIdx(idx){if(idx>=this.count||idx<0)return null;let node=this.root;for(let i2=0;i2<idx&&node;i2++)node=node.next;return node}toArray(){const array2=[];let node=this.root;for(;node;)array2.push(node),node=node.next;return array2}fromArray(array2){this.reset();for(const item of array2)item.prev=item.next=null,this.add(item)}reset(){this.last=this.root=null,this.count=0}isEmpty(){return this.count===0}log(){let s2=`DoubleLinkedList[${this.count}] : `,current=this.root;for(;current;)s2+=`${current[this.indexKey]},`,current=current.next;console.log(s2)}}class ObjectPool{constructor(createFunc,initialSize=0,canExpand=!0){this.size=initialSize,this.canExpand=canExpand,this.createFunc=createFunc,this.availableItems=[];for(let i2=0;i2<initialSize;i2++)this.availableItems.push(this.createFunc())}checkOut(){return this.size===0?(console.warn("The pool is empty."),this.canExpand?this.createFunc():null):(this.size--,this.availableItems.pop())}checkIn(item){this.size++,this.availableItems.push(item)}get(){return this.checkOut()}release(item){return this.checkIn(item)}}class SignalNode{constructor(){this.prev=null,this.next=null,this.listener=null}}class Signal{static POOL=new ObjectPool(()=>new SignalNode,4096);constructor(){this.listeners=new DoubleLinkedList,this.listenersOnce=[]}add(listener){const node=Signal.POOL.get();node.listener=listener,listener.__signalNode=node,this.listeners.add(node)}remove(listener){listener.__signalNode&&(this.listeners.remove(listener.__signalNode),Signal.POOL.release(listener.__signalNode),listener.__signalNode=null)}once(listener){this.addOnce(listener)}addOnce(listener){this.listenersOnce.push(listener)}dispatch(){const n2=this.listenersOnce.length;if(n2>0){for(let i2=0;i2<n2;i2++)this.listenersOnce[i2].apply(null,arguments);this.listenersOnce=[]}let node=this.listeners.root;for(;node;)node.listener.apply(null,arguments),node=node.next}dispose(){let node=this.listeners.root;for(;node;)Signal.POOL.release(node),node.listener.__signalNode=null,node=node.next;this.listeners=null,this.listenersOnce=null}removeAll(){let node=this.listeners.root;for(;node;)Signal.POOL.release(node),node.listener.__signalNode=null,node=node.next;this.listeners.reset(),this.listenersOnce=[]}}const REVISION="174dev",CullFaceNone=0,CullFaceBack=1,CullFaceFront=2,BasicShadowMap=0,PCFShadowMap=1,VSMShadowMap=3,FrontSide=0,BackSide=1,DoubleSide=2,NoBlending=0,NormalBlending=1,AdditiveBlending=2,SubtractiveBlending=3,MultiplyBlending=4,CustomBlending=5,AddEquation=100,SubtractEquation=101,ReverseSubtractEquation=102,MinEquation=103,MaxEquation=104,ZeroFactor=200,OneFactor=201,SrcColorFactor=202,OneMinusSrcColorFactor=203,SrcAlphaFactor=204,OneMinusSrcAlphaFactor=205,DstAlphaFactor=206,OneMinusDstAlphaFactor=207,DstColorFactor=208,OneMinusDstColorFactor=209,SrcAlphaSaturateFactor=210,NeverDepth=0,AlwaysDepth=1,LessDepth=2,LessEqualDepth=3,EqualDepth=4,GreaterEqualDepth=5,GreaterDepth=6,NotEqualDepth=7,MultiplyOperation=0,MixOperation=1,AddOperation=2,NoToneMapping=0,LinearToneMapping=1,ReinhardToneMapping=2,CineonToneMapping=3,ACESFilmicToneMapping=4,AgXToneMapping=6,NeutralToneMapping=7,UVMapping=300,CubeReflectionMapping=301,CubeRefractionMapping=302,EquirectangularReflectionMapping=303,EquirectangularRefractionMapping=304,CubeUVReflectionMapping=306,RepeatWrapping=1e3,ClampToEdgeWrapping=1001,MirroredRepeatWrapping=1002,NearestFilter=1003,NearestMipmapNearestFilter=1004,NearestMipmapLinearFilter=1005,LinearFilter=1006,LinearMipmapNearestFilter=1007,LinearMipmapLinearFilter=1008,LinearMipMapLinearFilter=1008,UnsignedByteType=1009,ByteType=1010,ShortType=1011,UnsignedShortType=1012,IntType=1013,UnsignedIntType=1014,FloatType=1015,HalfFloatType=1016,UnsignedShort4444Type=1017,UnsignedShort5551Type=1018,UnsignedInt248Type=1020,UnsignedInt5999Type=35902,AlphaFormat=1021,RGBFormat=1022,RGBAFormat=1023,LuminanceFormat=1024,LuminanceAlphaFormat=1025,DepthFormat=1026,DepthStencilFormat=1027,RedFormat=1028,RedIntegerFormat=1029,RGFormat=1030,RGIntegerFormat=1031,RGBIntegerFormat=1032,RGBAIntegerFormat=1033,RGB_S3TC_DXT1_Format=33776,RGBA_S3TC_DXT1_Format=33777,RGBA_S3TC_DXT3_Format=33778,RGBA_S3TC_DXT5_Format=33779,RGB_PVRTC_4BPPV1_Format=35840,RGB_PVRTC_2BPPV1_Format=35841,RGBA_PVRTC_4BPPV1_Format=35842,RGBA_PVRTC_2BPPV1_Format=35843,RGB_ETC1_Format=36196,RGB_ETC2_Format=37492,RGBA_ETC2_EAC_Format=37496,RGBA_ASTC_4x4_Format=37808,RGBA_ASTC_5x4_Format=37809,RGBA_ASTC_5x5_Format=37810,RGBA_ASTC_6x5_Format=37811,RGBA_ASTC_6x6_Format=37812,RGBA_ASTC_8x5_Format=37813,RGBA_ASTC_8x6_Format=37814,RGBA_ASTC_8x8_Format=37815,RGBA_ASTC_10x5_Format=37816,RGBA_ASTC_10x6_Format=37817,RGBA_ASTC_10x8_Format=37818,RGBA_ASTC_10x10_Format=37819,RGBA_ASTC_12x10_Format=37820,RGBA_ASTC_12x12_Format=37821,RGBA_BPTC_Format=36492,RED_RGTC1_Format=36283,SIGNED_RED_RGTC1_Format=36284,RED_GREEN_RGTC2_Format=36285,SIGNED_RED_GREEN_RGTC2_Format=36286,TangentSpaceNormalMap=0,ObjectSpaceNormalMap=1,NoColorSpace="",SRGBColorSpace="srgb",LinearSRGBColorSpace="srgb-linear",LinearTransfer="linear",SRGBTransfer="srgb",ZeroStencilOp=0,KeepStencilOp=7680,ReplaceStencilOp=7681,IncrementStencilOp=7682,DecrementStencilOp=7683,IncrementWrapStencilOp=34055,DecrementWrapStencilOp=34056,InvertStencilOp=5386,NeverStencilFunc=512,LessStencilFunc=513,EqualStencilFunc=514,LessEqualStencilFunc=515,GreaterStencilFunc=516,NotEqualStencilFunc=517,GreaterEqualStencilFunc=518,AlwaysStencilFunc=519,NeverCompare=512,LessCompare=513,EqualCompare=514,LessEqualCompare=515,GreaterCompare=516,NotEqualCompare=517,GreaterEqualCompare=518,AlwaysCompare=519,StaticDrawUsage=35044,DynamicDrawUsage=35048,WebGLCoordinateSystem=2e3,WebGPUCoordinateSystem=2001,TimestampQuery={RENDER:"render"};class EventDispatcher{addEventListener(type,listener){this._listeners===void 0&&(this._listeners={});const listeners=this._listeners;listeners[type]===void 0&&(listeners[type]=[]),listeners[type].indexOf(listener)===-1&&listeners[type].push(listener)}hasEventListener(type,listener){const listeners=this._listeners;return listeners===void 0?!1:listeners[type]!==void 0&&listeners[type].indexOf(listener)!==-1}removeEventListener(type,listener){const listeners=this._listeners;if(listeners===void 0)return;const listenerArray=listeners[type];if(listenerArray!==void 0){const index=listenerArray.indexOf(listener);index!==-1&&listenerArray.splice(index,1)}}dispatchEvent(event){const listeners=this._listeners;if(listeners===void 0)return;const listenerArray=listeners[event.type];if(listenerArray!==void 0){event.target=this;const array2=listenerArray.slice(0);for(let i2=0,l2=array2.length;i2<l2;i2++)array2[i2].call(this,event);event.target=null}}}const _lut=["00","01","02","03","04","05","06","07","08","09","0a","0b","0c","0d","0e","0f","10","11","12","13","14","15","16","17","18","19","1a","1b","1c","1d","1e","1f","20","21","22","23","24","25","26","27","28","29","2a","2b","2c","2d","2e","2f","30","31","32","33","34","35","36","37","38","39","3a","3b","3c","3d","3e","3f","40","41","42","43","44","45","46","47","48","49","4a","4b","4c","4d","4e","4f","50","51","52","53","54","55","56","57","58","59","5a","5b","5c","5d","5e","5f","60","61","62","63","64","65","66","67","68","69","6a","6b","6c","6d","6e","6f","70","71","72","73","74","75","76","77","78","79","7a","7b","7c","7d","7e","7f","80","81","82","83","84","85","86","87","88","89","8a","8b","8c","8d","8e","8f","90","91","92","93","94","95","96","97","98","99","9a","9b","9c","9d","9e","9f","a0","a1","a2","a3","a4","a5","a6","a7","a8","a9","aa","ab","ac","ad","ae","af","b0","b1","b2","b3","b4","b5","b6","b7","b8","b9","ba","bb","bc","bd","be","bf","c0","c1","c2","c3","c4","c5","c6","c7","c8","c9","ca","cb","cc","cd","ce","cf","d0","d1","d2","d3","d4","d5","d6","d7","d8","d9","da","db","dc","dd","de","df","e0","e1","e2","e3","e4","e5","e6","e7","e8","e9","ea","eb","ec","ed","ee","ef","f0","f1","f2","f3","f4","f5","f6","f7","f8","f9","fa","fb","fc","fd","fe","ff"];let _seed=1234567;const DEG2RAD=Math.PI/180,RAD2DEG=180/Math.PI;function generateUUID(){const d0=Math.random()*4294967295|0,d1=Math.random()*4294967295|0,d2=Math.random()*4294967295|0,d3=Math.random()*4294967295|0;return(_lut[d0&255]+_lut[d0>>8&255]+_lut[d0>>16&255]+_lut[d0>>24&255]+"-"+_lut[d1&255]+_lut[d1>>8&255]+"-"+_lut[d1>>16&15|64]+_lut[d1>>24&255]+"-"+_lut[d2&63|128]+_lut[d2>>8&255]+"-"+_lut[d2>>16&255]+_lut[d2>>24&255]+_lut[d3&255]+_lut[d3>>8&255]+_lut[d3>>16&255]+_lut[d3>>24&255]).toLowerCase()}function clamp$4(value,min2,max2){return Math.max(min2,Math.min(max2,value))}function euclideanModulo(n2,m){return(n2%m+m)%m}function mapLinear(x,a1,a2,b1,b2){return b1+(x-a1)*(b2-b1)/(a2-a1)}function inverseLerp(x,y,value){return x!==y?(value-x)/(y-x):0}function lerp$2(x,y,t2){return(1-t2)*x+t2*y}function damp(x,y,lambda,dt){return lerp$2(x,y,1-Math.exp(-lambda*dt))}function pingpong(x,length2=1){return length2-Math.abs(euclideanModulo(x,length2*2)-length2)}function smoothstep$2(x,min2,max2){return x<=min2?0:x>=max2?1:(x=(x-min2)/(max2-min2),x*x*(3-2*x))}function smootherstep(x,min2,max2){return x<=min2?0:x>=max2?1:(x=(x-min2)/(max2-min2),x*x*x*(x*(x*6-15)+10))}function randInt(low,high){return low+Math.floor(Math.random()*(high-low+1))}function randFloat(low,high){return low+Math.random()*(high-low)}function randFloatSpread(range2){return range2*(.5-Math.random())}function seededRandom(s2){s2!==void 0&&(_seed=s2);let t2=_seed+=1831565813;return t2=Math.imul(t2^t2>>>15,t2|1),t2^=t2+Math.imul(t2^t2>>>7,t2|61),((t2^t2>>>14)>>>0)/4294967296}function degToRad$1(degrees2){return degrees2*DEG2RAD}function radToDeg$1(radians2){return radians2*RAD2DEG}function isPowerOfTwo(value){return(value&value-1)===0&&value!==0}function ceilPowerOfTwo(value){return Math.pow(2,Math.ceil(Math.log(value)/Math.LN2))}function floorPowerOfTwo(value){return Math.pow(2,Math.floor(Math.log(value)/Math.LN2))}function setQuaternionFromProperEuler(q,a2,b,c2,order){const cos2=Math.cos,sin2=Math.sin,c22=cos2(b/2),s2=sin2(b/2),c13=cos2((a2+c2)/2),s13=sin2((a2+c2)/2),c1_3=cos2((a2-c2)/2),s1_3=sin2((a2-c2)/2),c3_1=cos2((c2-a2)/2),s3_1=sin2((c2-a2)/2);switch(order){case"XYX":q.set(c22*s13,s2*c1_3,s2*s1_3,c22*c13);break;case"YZY":q.set(s2*s1_3,c22*s13,s2*c1_3,c22*c13);break;case"ZXZ":q.set(s2*c1_3,s2*s1_3,c22*s13,c22*c13);break;case"XZX":q.set(c22*s13,s2*s3_1,s2*c3_1,c22*c13);break;case"YXY":q.set(s2*c3_1,c22*s13,s2*s3_1,c22*c13);break;case"ZYZ":q.set(s2*s3_1,s2*c3_1,c22*s13,c22*c13);break;default:console.warn("THREE.MathUtils: .setQuaternionFromProperEuler() encountered an unknown order: "+order)}}function denormalize(value,array2){switch(array2.constructor){case Float32Array:return value;case Uint32Array:return value/4294967295;case Uint16Array:return value/65535;case Uint8Array:return value/255;case Int32Array:return Math.max(value/2147483647,-1);case Int16Array:return Math.max(value/32767,-1);case Int8Array:return Math.max(value/127,-1);default:throw new Error("Invalid component type.")}}function normalize$2(value,array2){switch(array2.constructor){case Float32Array:return value;case Uint32Array:return Math.round(value*4294967295);case Uint16Array:return Math.round(value*65535);case Uint8Array:return Math.round(value*255);case Int32Array:return Math.round(value*2147483647);case Int16Array:return Math.round(value*32767);case Int8Array:return Math.round(value*127);default:throw new Error("Invalid component type.")}}const MathUtils={DEG2RAD,RAD2DEG,generateUUID,clamp:clamp$4,euclideanModulo,mapLinear,inverseLerp,lerp:lerp$2,damp,pingpong,smoothstep:smoothstep$2,smootherstep,randInt,randFloat,randFloatSpread,seededRandom,degToRad:degToRad$1,radToDeg:radToDeg$1,isPowerOfTwo,ceilPowerOfTwo,floorPowerOfTwo,setQuaternionFromProperEuler,normalize:normalize$2,denormalize};class Vector2{constructor(x=0,y=0){Vector2.prototype.isVector2=!0,this.x=x,this.y=y}get width(){return this.x}set width(value){this.x=value}get height(){return this.y}set height(value){this.y=value}set(x,y){return this.x=x,this.y=y,this}setScalar(scalar){return this.x=scalar,this.y=scalar,this}setX(x){return this.x=x,this}setY(y){return this.y=y,this}setComponent(index,value){switch(index){case 0:this.x=value;break;case 1:this.y=value;break;default:throw new Error("index is out of range: "+index)}return this}getComponent(index){switch(index){case 0:return this.x;case 1:return this.y;default:throw new Error("index is out of range: "+index)}}clone(){return new this.constructor(this.x,this.y)}copy(v){return this.x=v.x,this.y=v.y,this}add(v){return this.x+=v.x,this.y+=v.y,this}addScalar(s2){return this.x+=s2,this.y+=s2,this}addVectors(a2,b){return this.x=a2.x+b.x,this.y=a2.y+b.y,this}addScaledVector(v,s2){return this.x+=v.x*s2,this.y+=v.y*s2,this}sub(v){return this.x-=v.x,this.y-=v.y,this}subScalar(s2){return this.x-=s2,this.y-=s2,this}subVectors(a2,b){return this.x=a2.x-b.x,this.y=a2.y-b.y,this}multiply(v){return this.x*=v.x,this.y*=v.y,this}multiplyScalar(scalar){return this.x*=scalar,this.y*=scalar,this}divide(v){return this.x/=v.x,this.y/=v.y,this}divideScalar(scalar){return this.multiplyScalar(1/scalar)}applyMatrix3(m){const x=this.x,y=this.y,e2=m.elements;return this.x=e2[0]*x+e2[3]*y+e2[6],this.y=e2[1]*x+e2[4]*y+e2[7],this}min(v){return this.x=Math.min(this.x,v.x),this.y=Math.min(this.y,v.y),this}max(v){return this.x=Math.max(this.x,v.x),this.y=Math.max(this.y,v.y),this}clamp(min2,max2){return this.x=clamp$4(this.x,min2.x,max2.x),this.y=clamp$4(this.y,min2.y,max2.y),this}clampScalar(minVal,maxVal){return this.x=clamp$4(this.x,minVal,maxVal),this.y=clamp$4(this.y,minVal,maxVal),this}clampLength(min2,max2){const length2=this.length();return this.divideScalar(length2||1).multiplyScalar(clamp$4(length2,min2,max2))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}roundToZero(){return this.x=Math.trunc(this.x),this.y=Math.trunc(this.y),this}negate(){return this.x=-this.x,this.y=-this.y,this}dot(v){return this.x*v.x+this.y*v.y}cross(v){return this.x*v.y-this.y*v.x}lengthSq(){return this.x*this.x+this.y*this.y}length(){return Math.sqrt(this.x*this.x+this.y*this.y)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)}normalize(){return this.divideScalar(this.length()||1)}angle(){return Math.atan2(-this.y,-this.x)+Math.PI}angleTo(v){const denominator=Math.sqrt(this.lengthSq()*v.lengthSq());if(denominator===0)return Math.PI/2;const theta=this.dot(v)/denominator;return Math.acos(clamp$4(theta,-1,1))}distanceTo(v){return Math.sqrt(this.distanceToSquared(v))}distanceToSquared(v){const dx=this.x-v.x,dy=this.y-v.y;return dx*dx+dy*dy}manhattanDistanceTo(v){return Math.abs(this.x-v.x)+Math.abs(this.y-v.y)}setLength(length2){return this.normalize().multiplyScalar(length2)}lerp(v,alpha){return this.x+=(v.x-this.x)*alpha,this.y+=(v.y-this.y)*alpha,this}lerpVectors(v1,v2,alpha){return this.x=v1.x+(v2.x-v1.x)*alpha,this.y=v1.y+(v2.y-v1.y)*alpha,this}equals(v){return v.x===this.x&&v.y===this.y}fromArray(array2,offset=0){return this.x=array2[offset],this.y=array2[offset+1],this}toArray(array2=[],offset=0){return array2[offset]=this.x,array2[offset+1]=this.y,array2}fromBufferAttribute(attribute2,index){return this.x=attribute2.getX(index),this.y=attribute2.getY(index),this}rotateAround(center,angle){const c2=Math.cos(angle),s2=Math.sin(angle),x=this.x-center.x,y=this.y-center.y;return this.x=x*c2-y*s2+center.x,this.y=x*s2+y*c2+center.y,this}random(){return this.x=Math.random(),this.y=Math.random(),this}*[Symbol.iterator](){yield this.x,yield this.y}}class Matrix3{constructor(n11,n12,n13,n21,n22,n23,n31,n32,n33){Matrix3.prototype.isMatrix3=!0,this.elements=[1,0,0,0,1,0,0,0,1],n11!==void 0&&this.set(n11,n12,n13,n21,n22,n23,n31,n32,n33)}set(n11,n12,n13,n21,n22,n23,n31,n32,n33){const te=this.elements;return te[0]=n11,te[1]=n21,te[2]=n31,te[3]=n12,te[4]=n22,te[5]=n32,te[6]=n13,te[7]=n23,te[8]=n33,this}identity(){return this.set(1,0,0,0,1,0,0,0,1),this}copy(m){const te=this.elements,me=m.elements;return te[0]=me[0],te[1]=me[1],te[2]=me[2],te[3]=me[3],te[4]=me[4],te[5]=me[5],te[6]=me[6],te[7]=me[7],te[8]=me[8],this}extractBasis(xAxis,yAxis,zAxis){return xAxis.setFromMatrix3Column(this,0),yAxis.setFromMatrix3Column(this,1),zAxis.setFromMatrix3Column(this,2),this}setFromMatrix4(m){const me=m.elements;return this.set(me[0],me[4],me[8],me[1],me[5],me[9],me[2],me[6],me[10]),this}multiply(m){return this.multiplyMatrices(this,m)}premultiply(m){return this.multiplyMatrices(m,this)}multiplyMatrices(a2,b){const ae=a2.elements,be=b.elements,te=this.elements,a11=ae[0],a12=ae[3],a13=ae[6],a21=ae[1],a22=ae[4],a23=ae[7],a31=ae[2],a32=ae[5],a33=ae[8],b11=be[0],b12=be[3],b13=be[6],b21=be[1],b22=be[4],b23=be[7],b31=be[2],b32=be[5],b33=be[8];return te[0]=a11*b11+a12*b21+a13*b31,te[3]=a11*b12+a12*b22+a13*b32,te[6]=a11*b13+a12*b23+a13*b33,te[1]=a21*b11+a22*b21+a23*b31,te[4]=a21*b12+a22*b22+a23*b32,te[7]=a21*b13+a22*b23+a23*b33,te[2]=a31*b11+a32*b21+a33*b31,te[5]=a31*b12+a32*b22+a33*b32,te[8]=a31*b13+a32*b23+a33*b33,this}multiplyScalar(s2){const te=this.elements;return te[0]*=s2,te[3]*=s2,te[6]*=s2,te[1]*=s2,te[4]*=s2,te[7]*=s2,te[2]*=s2,te[5]*=s2,te[8]*=s2,this}determinant(){const te=this.elements,a2=te[0],b=te[1],c2=te[2],d2=te[3],e2=te[4],f2=te[5],g=te[6],h=te[7],i2=te[8];return a2*e2*i2-a2*f2*h-b*d2*i2+b*f2*g+c2*d2*h-c2*e2*g}invert(){const te=this.elements,n11=te[0],n21=te[1],n31=te[2],n12=te[3],n22=te[4],n32=te[5],n13=te[6],n23=te[7],n33=te[8],t11=n33*n22-n32*n23,t12=n32*n13-n33*n12,t13=n23*n12-n22*n13,det=n11*t11+n21*t12+n31*t13;if(det===0)return this.set(0,0,0,0,0,0,0,0,0);const detInv=1/det;return te[0]=t11*detInv,te[1]=(n31*n23-n33*n21)*detInv,te[2]=(n32*n21-n31*n22)*detInv,te[3]=t12*detInv,te[4]=(n33*n11-n31*n13)*detInv,te[5]=(n31*n12-n32*n11)*detInv,te[6]=t13*detInv,te[7]=(n21*n13-n23*n11)*detInv,te[8]=(n22*n11-n21*n12)*detInv,this}transpose(){let tmp;const m=this.elements;return tmp=m[1],m[1]=m[3],m[3]=tmp,tmp=m[2],m[2]=m[6],m[6]=tmp,tmp=m[5],m[5]=m[7],m[7]=tmp,this}getNormalMatrix(matrix4){return this.setFromMatrix4(matrix4).invert().transpose()}transposeIntoArray(r2){const m=this.elements;return r2[0]=m[0],r2[1]=m[3],r2[2]=m[6],r2[3]=m[1],r2[4]=m[4],r2[5]=m[7],r2[6]=m[2],r2[7]=m[5],r2[8]=m[8],this}setUvTransform(tx,ty,sx,sy,rotation2,cx,cy){const c2=Math.cos(rotation2),s2=Math.sin(rotation2);return this.set(sx*c2,sx*s2,-sx*(c2*cx+s2*cy)+cx+tx,-sy*s2,sy*c2,-sy*(-s2*cx+c2*cy)+cy+ty,0,0,1),this}scale(sx,sy){return this.premultiply(_m3.makeScale(sx,sy)),this}rotate(theta){return this.premultiply(_m3.makeRotation(-theta)),this}translate(tx,ty){return this.premultiply(_m3.makeTranslation(tx,ty)),this}makeTranslation(x,y){return x.isVector2?this.set(1,0,x.x,0,1,x.y,0,0,1):this.set(1,0,x,0,1,y,0,0,1),this}makeRotation(theta){const c2=Math.cos(theta),s2=Math.sin(theta);return this.set(c2,-s2,0,s2,c2,0,0,0,1),this}makeScale(x,y){return this.set(x,0,0,0,y,0,0,0,1),this}equals(matrix){const te=this.elements,me=matrix.elements;for(let i2=0;i2<9;i2++)if(te[i2]!==me[i2])return!1;return!0}fromArray(array2,offset=0){for(let i2=0;i2<9;i2++)this.elements[i2]=array2[i2+offset];return this}toArray(array2=[],offset=0){const te=this.elements;return array2[offset]=te[0],array2[offset+1]=te[1],array2[offset+2]=te[2],array2[offset+3]=te[3],array2[offset+4]=te[4],array2[offset+5]=te[5],array2[offset+6]=te[6],array2[offset+7]=te[7],array2[offset+8]=te[8],array2}clone(){return new this.constructor().fromArray(this.elements)}}const _m3=new Matrix3;function arrayNeedsUint32(array2){for(let i2=array2.length-1;i2>=0;--i2)if(array2[i2]>=65535)return!0;return!1}function createElementNS(name){return document.createElementNS("http://www.w3.org/1999/xhtml",name)}function createCanvasElement(){const canvas=createElementNS("canvas");return canvas.style.display="block",canvas}const _cache$2={};function warnOnce(message){message in _cache$2||(_cache$2[message]=!0,console.warn(message))}const LINEAR_REC709_TO_XYZ=new Matrix3().set(.4123908,.3575843,.1804808,.212639,.7151687,.0721923,.0193308,.1191948,.9505322),XYZ_TO_LINEAR_REC709=new Matrix3().set(3.2409699,-1.5373832,-.4986108,-.9692436,1.8759675,.0415551,.0556301,-.203977,1.0569715);function createColorManagement(){const ColorManagement2={enabled:!0,workingColorSpace:LinearSRGBColorSpace,spaces:{},convert:function(color2,sourceColorSpace,targetColorSpace){return this.enabled===!1||sourceColorSpace===targetColorSpace||!sourceColorSpace||!targetColorSpace||(this.spaces[sourceColorSpace].transfer===SRGBTransfer&&(color2.r=SRGBToLinear(color2.r),color2.g=SRGBToLinear(color2.g),color2.b=SRGBToLinear(color2.b)),this.spaces[sourceColorSpace].primaries!==this.spaces[targetColorSpace].primaries&&(color2.applyMatrix3(this.spaces[sourceColorSpace].toXYZ),color2.applyMatrix3(this.spaces[targetColorSpace].fromXYZ)),this.spaces[targetColorSpace].transfer===SRGBTransfer&&(color2.r=LinearToSRGB(color2.r),color2.g=LinearToSRGB(color2.g),color2.b=LinearToSRGB(color2.b))),color2},fromWorkingColorSpace:function(color2,targetColorSpace){return this.convert(color2,this.workingColorSpace,targetColorSpace)},toWorkingColorSpace:function(color2,sourceColorSpace){return this.convert(color2,sourceColorSpace,this.workingColorSpace)},getPrimaries:function(colorSpace){return this.spaces[colorSpace].primaries},getTransfer:function(colorSpace){return colorSpace===NoColorSpace?LinearTransfer:this.spaces[colorSpace].transfer},getLuminanceCoefficients:function(target,colorSpace=this.workingColorSpace){return target.fromArray(this.spaces[colorSpace].luminanceCoefficients)},define:function(colorSpaces){Object.assign(this.spaces,colorSpaces)},_getMatrix:function(targetMatrix,sourceColorSpace,targetColorSpace){return targetMatrix.copy(this.spaces[sourceColorSpace].toXYZ).multiply(this.spaces[targetColorSpace].fromXYZ)},_getDrawingBufferColorSpace:function(colorSpace){return this.spaces[colorSpace].outputColorSpaceConfig.drawingBufferColorSpace},_getUnpackColorSpace:function(colorSpace=this.workingColorSpace){return this.spaces[colorSpace].workingColorSpaceConfig.unpackColorSpace}},REC709_PRIMARIES=[.64,.33,.3,.6,.15,.06],REC709_LUMINANCE_COEFFICIENTS=[.2126,.7152,.0722],D65=[.3127,.329];return ColorManagement2.define({[LinearSRGBColorSpace]:{primaries:REC709_PRIMARIES,whitePoint:D65,transfer:LinearTransfer,toXYZ:LINEAR_REC709_TO_XYZ,fromXYZ:XYZ_TO_LINEAR_REC709,luminanceCoefficients:REC709_LUMINANCE_COEFFICIENTS,workingColorSpaceConfig:{unpackColorSpace:SRGBColorSpace},outputColorSpaceConfig:{drawingBufferColorSpace:SRGBColorSpace}},[SRGBColorSpace]:{primaries:REC709_PRIMARIES,whitePoint:D65,transfer:SRGBTransfer,toXYZ:LINEAR_REC709_TO_XYZ,fromXYZ:XYZ_TO_LINEAR_REC709,luminanceCoefficients:REC709_LUMINANCE_COEFFICIENTS,outputColorSpaceConfig:{drawingBufferColorSpace:SRGBColorSpace}}}),ColorManagement2}const ColorManagement=createColorManagement();function SRGBToLinear(c2){return c2<.04045?c2*.0773993808:Math.pow(c2*.9478672986+.0521327014,2.4)}function LinearToSRGB(c2){return c2<.0031308?c2*12.92:1.055*Math.pow(c2,.41666)-.055}let _canvas;class ImageUtils{static getDataURL(image){if(/^data:/i.test(image.src)||typeof HTMLCanvasElement>"u")return image.src;let canvas;if(image instanceof HTMLCanvasElement)canvas=image;else{_canvas===void 0&&(_canvas=createElementNS("canvas")),_canvas.width=image.width,_canvas.height=image.height;const context2=_canvas.getContext("2d");image instanceof ImageData?context2.putImageData(image,0,0):context2.drawImage(image,0,0,image.width,image.height),canvas=_canvas}return canvas.toDataURL("image/png")}static sRGBToLinear(image){if(typeof HTMLImageElement<"u"&&image instanceof HTMLImageElement||typeof HTMLCanvasElement<"u"&&image instanceof HTMLCanvasElement||typeof ImageBitmap<"u"&&image instanceof ImageBitmap){const canvas=createElementNS("canvas");canvas.width=image.width,canvas.height=image.height;const context2=canvas.getContext("2d");context2.drawImage(image,0,0,image.width,image.height);const imageData=context2.getImageData(0,0,image.width,image.height),data=imageData.data;for(let i2=0;i2<data.length;i2++)data[i2]=SRGBToLinear(data[i2]/255)*255;return context2.putImageData(imageData,0,0),canvas}else if(image.data){const data=image.data.slice(0);for(let i2=0;i2<data.length;i2++)data instanceof Uint8Array||data instanceof Uint8ClampedArray?data[i2]=Math.floor(SRGBToLinear(data[i2]/255)*255):data[i2]=SRGBToLinear(data[i2]);return{data,width:image.width,height:image.height}}else return console.warn("THREE.ImageUtils.sRGBToLinear(): Unsupported image type. No color space conversion applied."),image}}let _sourceId=0,Source$1=class{constructor(data=null){this.isSource=!0,Object.defineProperty(this,"id",{value:_sourceId++}),this.uuid=generateUUID(),this.data=data,this.dataReady=!0,this.version=0}set needsUpdate(value){value===!0&&this.version++}toJSON(meta){const isRootObject=meta===void 0||typeof meta=="string";if(!isRootObject&&meta.images[this.uuid]!==void 0)return meta.images[this.uuid];const output2={uuid:this.uuid,url:""},data=this.data;if(data!==null){let url;if(Array.isArray(data)){url=[];for(let i2=0,l2=data.length;i2<l2;i2++)data[i2].isDataTexture?url.push(serializeImage(data[i2].image)):url.push(serializeImage(data[i2]))}else url=serializeImage(data);output2.url=url}return isRootObject||(meta.images[this.uuid]=output2),output2}};function serializeImage(image){return typeof HTMLImageElement<"u"&&image instanceof HTMLImageElement||typeof HTMLCanvasElement<"u"&&image instanceof HTMLCanvasElement||typeof ImageBitmap<"u"&&image instanceof ImageBitmap?ImageUtils.getDataURL(image):image.data?{data:Array.from(image.data),width:image.width,height:image.height,type:image.data.constructor.name}:(console.warn("THREE.Texture: Unable to serialize Texture."),{})}let _textureId=0;class Texture extends EventDispatcher{constructor(image=Texture.DEFAULT_IMAGE,mapping=Texture.DEFAULT_MAPPING,wrapS=ClampToEdgeWrapping,wrapT=ClampToEdgeWrapping,magFilter=LinearFilter,minFilter=LinearMipmapLinearFilter,format=RGBAFormat,type=UnsignedByteType,anisotropy2=Texture.DEFAULT_ANISOTROPY,colorSpace=NoColorSpace){super(),this.isTexture=!0,Object.defineProperty(this,"id",{value:_textureId++}),this.uuid=generateUUID(),this.name="",this.source=new Source$1(image),this.mipmaps=[],this.mapping=mapping,this.channel=0,this.wrapS=wrapS,this.wrapT=wrapT,this.magFilter=magFilter,this.minFilter=minFilter,this.anisotropy=anisotropy2,this.format=format,this.internalFormat=null,this.type=type,this.offset=new Vector2(0,0),this.repeat=new Vector2(1,1),this.center=new Vector2(0,0),this.rotation=0,this.matrixAutoUpdate=!0,this.matrix=new Matrix3,this.generateMipmaps=!0,this.premultiplyAlpha=!1,this.flipY=!0,this.unpackAlignment=4,this.colorSpace=colorSpace,this.userData={},this.version=0,this.onUpdate=null,this.renderTarget=null,this.isRenderTargetTexture=!1,this.pmremVersion=0}get image(){return this.source.data}set image(value=null){this.source.data=value}updateMatrix(){this.matrix.setUvTransform(this.offset.x,this.offset.y,this.repeat.x,this.repeat.y,this.rotation,this.center.x,this.center.y)}clone(){return new this.constructor().copy(this)}copy(source){return this.name=source.name,this.source=source.source,this.mipmaps=source.mipmaps.slice(0),this.mapping=source.mapping,this.channel=source.channel,this.wrapS=source.wrapS,this.wrapT=source.wrapT,this.magFilter=source.magFilter,this.minFilter=source.minFilter,this.anisotropy=source.anisotropy,this.format=source.format,this.internalFormat=source.internalFormat,this.type=source.type,this.offset.copy(source.offset),this.repeat.copy(source.repeat),this.center.copy(source.center),this.rotation=source.rotation,this.matrixAutoUpdate=source.matrixAutoUpdate,this.matrix.copy(source.matrix),this.generateMipmaps=source.generateMipmaps,this.premultiplyAlpha=source.premultiplyAlpha,this.flipY=source.flipY,this.unpackAlignment=source.unpackAlignment,this.colorSpace=source.colorSpace,this.renderTarget=source.renderTarget,this.isRenderTargetTexture=source.isRenderTargetTexture,this.userData=JSON.parse(JSON.stringify(source.userData)),this.needsUpdate=!0,this}toJSON(meta){const isRootObject=meta===void 0||typeof meta=="string";if(!isRootObject&&meta.textures[this.uuid]!==void 0)return meta.textures[this.uuid];const output2={metadata:{version:4.6,type:"Texture",generator:"Texture.toJSON"},uuid:this.uuid,name:this.name,image:this.source.toJSON(meta).uuid,mapping:this.mapping,channel:this.channel,repeat:[this.repeat.x,this.repeat.y],offset:[this.offset.x,this.offset.y],center:[this.center.x,this.center.y],rotation:this.rotation,wrap:[this.wrapS,this.wrapT],format:this.format,internalFormat:this.internalFormat,type:this.type,colorSpace:this.colorSpace,minFilter:this.minFilter,magFilter:this.magFilter,anisotropy:this.anisotropy,flipY:this.flipY,generateMipmaps:this.generateMipmaps,premultiplyAlpha:this.premultiplyAlpha,unpackAlignment:this.unpackAlignment};return Object.keys(this.userData).length>0&&(output2.userData=this.userData),isRootObject||(meta.textures[this.uuid]=output2),output2}dispose(){this.dispatchEvent({type:"dispose"})}transformUv(uv2){if(this.mapping!==UVMapping)return uv2;if(uv2.applyMatrix3(this.matrix),uv2.x<0||uv2.x>1)switch(this.wrapS){case RepeatWrapping:uv2.x=uv2.x-Math.floor(uv2.x);break;case ClampToEdgeWrapping:uv2.x=uv2.x<0?0:1;break;case MirroredRepeatWrapping:Math.abs(Math.floor(uv2.x)%2)===1?uv2.x=Math.ceil(uv2.x)-uv2.x:uv2.x=uv2.x-Math.floor(uv2.x);break}if(uv2.y<0||uv2.y>1)switch(this.wrapT){case RepeatWrapping:uv2.y=uv2.y-Math.floor(uv2.y);break;case ClampToEdgeWrapping:uv2.y=uv2.y<0?0:1;break;case MirroredRepeatWrapping:Math.abs(Math.floor(uv2.y)%2)===1?uv2.y=Math.ceil(uv2.y)-uv2.y:uv2.y=uv2.y-Math.floor(uv2.y);break}return this.flipY&&(uv2.y=1-uv2.y),uv2}set needsUpdate(value){value===!0&&(this.version++,this.source.needsUpdate=!0)}set needsPMREMUpdate(value){value===!0&&this.pmremVersion++}}Texture.DEFAULT_IMAGE=null;Texture.DEFAULT_MAPPING=UVMapping;Texture.DEFAULT_ANISOTROPY=1;class Vector4{constructor(x=0,y=0,z=0,w=1){Vector4.prototype.isVector4=!0,this.x=x,this.y=y,this.z=z,this.w=w}get width(){return this.z}set width(value){this.z=value}get height(){return this.w}set height(value){this.w=value}set(x,y,z,w){return this.x=x,this.y=y,this.z=z,this.w=w,this}setScalar(scalar){return this.x=scalar,this.y=scalar,this.z=scalar,this.w=scalar,this}setX(x){return this.x=x,this}setY(y){return this.y=y,this}setZ(z){return this.z=z,this}setW(w){return this.w=w,this}setComponent(index,value){switch(index){case 0:this.x=value;break;case 1:this.y=value;break;case 2:this.z=value;break;case 3:this.w=value;break;default:throw new Error("index is out of range: "+index)}return this}getComponent(index){switch(index){case 0:return this.x;case 1:return this.y;case 2:return this.z;case 3:return this.w;default:throw new Error("index is out of range: "+index)}}clone(){return new this.constructor(this.x,this.y,this.z,this.w)}copy(v){return this.x=v.x,this.y=v.y,this.z=v.z,this.w=v.w!==void 0?v.w:1,this}add(v){return this.x+=v.x,this.y+=v.y,this.z+=v.z,this.w+=v.w,this}addScalar(s2){return this.x+=s2,this.y+=s2,this.z+=s2,this.w+=s2,this}addVectors(a2,b){return this.x=a2.x+b.x,this.y=a2.y+b.y,this.z=a2.z+b.z,this.w=a2.w+b.w,this}addScaledVector(v,s2){return this.x+=v.x*s2,this.y+=v.y*s2,this.z+=v.z*s2,this.w+=v.w*s2,this}sub(v){return this.x-=v.x,this.y-=v.y,this.z-=v.z,this.w-=v.w,this}subScalar(s2){return this.x-=s2,this.y-=s2,this.z-=s2,this.w-=s2,this}subVectors(a2,b){return this.x=a2.x-b.x,this.y=a2.y-b.y,this.z=a2.z-b.z,this.w=a2.w-b.w,this}multiply(v){return this.x*=v.x,this.y*=v.y,this.z*=v.z,this.w*=v.w,this}multiplyScalar(scalar){return this.x*=scalar,this.y*=scalar,this.z*=scalar,this.w*=scalar,this}applyMatrix4(m){const x=this.x,y=this.y,z=this.z,w=this.w,e2=m.elements;return this.x=e2[0]*x+e2[4]*y+e2[8]*z+e2[12]*w,this.y=e2[1]*x+e2[5]*y+e2[9]*z+e2[13]*w,this.z=e2[2]*x+e2[6]*y+e2[10]*z+e2[14]*w,this.w=e2[3]*x+e2[7]*y+e2[11]*z+e2[15]*w,this}divide(v){return this.x/=v.x,this.y/=v.y,this.z/=v.z,this.w/=v.w,this}divideScalar(scalar){return this.multiplyScalar(1/scalar)}setAxisAngleFromQuaternion(q){this.w=2*Math.acos(q.w);const s2=Math.sqrt(1-q.w*q.w);return s2<1e-4?(this.x=1,this.y=0,this.z=0):(this.x=q.x/s2,this.y=q.y/s2,this.z=q.z/s2),this}setAxisAngleFromRotationMatrix(m){let angle,x,y,z;const te=m.elements,m11=te[0],m12=te[4],m13=te[8],m21=te[1],m22=te[5],m23=te[9],m31=te[2],m32=te[6],m33=te[10];if(Math.abs(m12-m21)<.01&&Math.abs(m13-m31)<.01&&Math.abs(m23-m32)<.01){if(Math.abs(m12+m21)<.1&&Math.abs(m13+m31)<.1&&Math.abs(m23+m32)<.1&&Math.abs(m11+m22+m33-3)<.1)return this.set(1,0,0,0),this;angle=Math.PI;const xx=(m11+1)/2,yy=(m22+1)/2,zz=(m33+1)/2,xy=(m12+m21)/4,xz=(m13+m31)/4,yz=(m23+m32)/4;return xx>yy&&xx>zz?xx<.01?(x=0,y=.707106781,z=.707106781):(x=Math.sqrt(xx),y=xy/x,z=xz/x):yy>zz?yy<.01?(x=.707106781,y=0,z=.707106781):(y=Math.sqrt(yy),x=xy/y,z=yz/y):zz<.01?(x=.707106781,y=.707106781,z=0):(z=Math.sqrt(zz),x=xz/z,y=yz/z),this.set(x,y,z,angle),this}let s2=Math.sqrt((m32-m23)*(m32-m23)+(m13-m31)*(m13-m31)+(m21-m12)*(m21-m12));return Math.abs(s2)<.001&&(s2=1),this.x=(m32-m23)/s2,this.y=(m13-m31)/s2,this.z=(m21-m12)/s2,this.w=Math.acos((m11+m22+m33-1)/2),this}setFromMatrixPosition(m){const e2=m.elements;return this.x=e2[12],this.y=e2[13],this.z=e2[14],this.w=e2[15],this}min(v){return this.x=Math.min(this.x,v.x),this.y=Math.min(this.y,v.y),this.z=Math.min(this.z,v.z),this.w=Math.min(this.w,v.w),this}max(v){return this.x=Math.max(this.x,v.x),this.y=Math.max(this.y,v.y),this.z=Math.max(this.z,v.z),this.w=Math.max(this.w,v.w),this}clamp(min2,max2){return this.x=clamp$4(this.x,min2.x,max2.x),this.y=clamp$4(this.y,min2.y,max2.y),this.z=clamp$4(this.z,min2.z,max2.z),this.w=clamp$4(this.w,min2.w,max2.w),this}clampScalar(minVal,maxVal){return this.x=clamp$4(this.x,minVal,maxVal),this.y=clamp$4(this.y,minVal,maxVal),this.z=clamp$4(this.z,minVal,maxVal),this.w=clamp$4(this.w,minVal,maxVal),this}clampLength(min2,max2){const length2=this.length();return this.divideScalar(length2||1).multiplyScalar(clamp$4(length2,min2,max2))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this.w=Math.floor(this.w),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this.w=Math.ceil(this.w),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this.w=Math.round(this.w),this}roundToZero(){return this.x=Math.trunc(this.x),this.y=Math.trunc(this.y),this.z=Math.trunc(this.z),this.w=Math.trunc(this.w),this}negate(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this.w=-this.w,this}dot(v){return this.x*v.x+this.y*v.y+this.z*v.z+this.w*v.w}lengthSq(){return this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w}length(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)+Math.abs(this.w)}normalize(){return this.divideScalar(this.length()||1)}setLength(length2){return this.normalize().multiplyScalar(length2)}lerp(v,alpha){return this.x+=(v.x-this.x)*alpha,this.y+=(v.y-this.y)*alpha,this.z+=(v.z-this.z)*alpha,this.w+=(v.w-this.w)*alpha,this}lerpVectors(v1,v2,alpha){return this.x=v1.x+(v2.x-v1.x)*alpha,this.y=v1.y+(v2.y-v1.y)*alpha,this.z=v1.z+(v2.z-v1.z)*alpha,this.w=v1.w+(v2.w-v1.w)*alpha,this}equals(v){return v.x===this.x&&v.y===this.y&&v.z===this.z&&v.w===this.w}fromArray(array2,offset=0){return this.x=array2[offset],this.y=array2[offset+1],this.z=array2[offset+2],this.w=array2[offset+3],this}toArray(array2=[],offset=0){return array2[offset]=this.x,array2[offset+1]=this.y,array2[offset+2]=this.z,array2[offset+3]=this.w,array2}fromBufferAttribute(attribute2,index){return this.x=attribute2.getX(index),this.y=attribute2.getY(index),this.z=attribute2.getZ(index),this.w=attribute2.getW(index),this}random(){return this.x=Math.random(),this.y=Math.random(),this.z=Math.random(),this.w=Math.random(),this}*[Symbol.iterator](){yield this.x,yield this.y,yield this.z,yield this.w}}class RenderTarget extends EventDispatcher{constructor(width=1,height=1,options={}){super(),this.isRenderTarget=!0,this.width=width,this.height=height,this.depth=1,this.scissor=new Vector4(0,0,width,height),this.scissorTest=!1,this.viewport=new Vector4(0,0,width,height);const image={width,height,depth:1};options=Object.assign({generateMipmaps:!1,internalFormat:null,minFilter:LinearFilter,depthBuffer:!0,stencilBuffer:!1,resolveDepthBuffer:!0,resolveStencilBuffer:!0,depthTexture:null,samples:0,count:1},options);const texture2=new Texture(image,options.mapping,options.wrapS,options.wrapT,options.magFilter,options.minFilter,options.format,options.type,options.anisotropy,options.colorSpace);texture2.flipY=!1,texture2.generateMipmaps=options.generateMipmaps,texture2.internalFormat=options.internalFormat,this.textures=[];const count=options.count;for(let i2=0;i2<count;i2++)this.textures[i2]=texture2.clone(),this.textures[i2].isRenderTargetTexture=!0,this.textures[i2].renderTarget=this;this.depthBuffer=options.depthBuffer,this.stencilBuffer=options.stencilBuffer,this.resolveDepthBuffer=options.resolveDepthBuffer,this.resolveStencilBuffer=options.resolveStencilBuffer,this._depthTexture=null,this.depthTexture=options.depthTexture,this.samples=options.samples}get texture(){return this.textures[0]}set texture(value){this.textures[0]=value}set depthTexture(current){this._depthTexture!==null&&(this._depthTexture.renderTarget=null),current!==null&&(current.renderTarget=this),this._depthTexture=current}get depthTexture(){return this._depthTexture}setSize(width,height,depth2=1){if(this.width!==width||this.height!==height||this.depth!==depth2){this.width=width,this.height=height,this.depth=depth2;for(let i2=0,il=this.textures.length;i2<il;i2++)this.textures[i2].image.width=width,this.textures[i2].image.height=height,this.textures[i2].image.depth=depth2;this.dispose()}this.viewport.set(0,0,width,height),this.scissor.set(0,0,width,height)}clone(){return new this.constructor().copy(this)}copy(source){this.width=source.width,this.height=source.height,this.depth=source.depth,this.scissor.copy(source.scissor),this.scissorTest=source.scissorTest,this.viewport.copy(source.viewport),this.textures.length=0;for(let i2=0,il=source.textures.length;i2<il;i2++)this.textures[i2]=source.textures[i2].clone(),this.textures[i2].isRenderTargetTexture=!0,this.textures[i2].renderTarget=this;const image=Object.assign({},source.texture.image);return this.texture.source=new Source$1(image),this.depthBuffer=source.depthBuffer,this.stencilBuffer=source.stencilBuffer,this.resolveDepthBuffer=source.resolveDepthBuffer,this.resolveStencilBuffer=source.resolveStencilBuffer,source.depthTexture!==null&&(this.depthTexture=source.depthTexture.clone()),this.samples=source.samples,this}dispose(){this.dispatchEvent({type:"dispose"})}}class WebGLRenderTarget extends RenderTarget{constructor(width=1,height=1,options={}){super(width,height,options),this.isWebGLRenderTarget=!0}}class DataArrayTexture extends Texture{constructor(data=null,width=1,height=1,depth2=1){super(null),this.isDataArrayTexture=!0,this.image={data,width,height,depth:depth2},this.magFilter=NearestFilter,this.minFilter=NearestFilter,this.wrapR=ClampToEdgeWrapping,this.generateMipmaps=!1,this.flipY=!1,this.unpackAlignment=1,this.layerUpdates=new Set}addLayerUpdate(layerIndex){this.layerUpdates.add(layerIndex)}clearLayerUpdates(){this.layerUpdates.clear()}}class Quaternion{constructor(x=0,y=0,z=0,w=1){this.isQuaternion=!0,this._x=x,this._y=y,this._z=z,this._w=w}static slerpFlat(dst,dstOffset,src0,srcOffset0,src1,srcOffset1,t2){let x0=src0[srcOffset0+0],y0=src0[srcOffset0+1],z0=src0[srcOffset0+2],w02=src0[srcOffset0+3];const x1=src1[srcOffset1+0],y1=src1[srcOffset1+1],z1=src1[srcOffset1+2],w12=src1[srcOffset1+3];if(t2===0){dst[dstOffset+0]=x0,dst[dstOffset+1]=y0,dst[dstOffset+2]=z0,dst[dstOffset+3]=w02;return}if(t2===1){dst[dstOffset+0]=x1,dst[dstOffset+1]=y1,dst[dstOffset+2]=z1,dst[dstOffset+3]=w12;return}if(w02!==w12||x0!==x1||y0!==y1||z0!==z1){let s2=1-t2;const cos2=x0*x1+y0*y1+z0*z1+w02*w12,dir=cos2>=0?1:-1,sqrSin=1-cos2*cos2;if(sqrSin>Number.EPSILON){const sin2=Math.sqrt(sqrSin),len=Math.atan2(sin2,cos2*dir);s2=Math.sin(s2*len)/sin2,t2=Math.sin(t2*len)/sin2}const tDir=t2*dir;if(x0=x0*s2+x1*tDir,y0=y0*s2+y1*tDir,z0=z0*s2+z1*tDir,w02=w02*s2+w12*tDir,s2===1-t2){const f2=1/Math.sqrt(x0*x0+y0*y0+z0*z0+w02*w02);x0*=f2,y0*=f2,z0*=f2,w02*=f2}}dst[dstOffset]=x0,dst[dstOffset+1]=y0,dst[dstOffset+2]=z0,dst[dstOffset+3]=w02}static multiplyQuaternionsFlat(dst,dstOffset,src0,srcOffset0,src1,srcOffset1){const x0=src0[srcOffset0],y0=src0[srcOffset0+1],z0=src0[srcOffset0+2],w02=src0[srcOffset0+3],x1=src1[srcOffset1],y1=src1[srcOffset1+1],z1=src1[srcOffset1+2],w12=src1[srcOffset1+3];return dst[dstOffset]=x0*w12+w02*x1+y0*z1-z0*y1,dst[dstOffset+1]=y0*w12+w02*y1+z0*x1-x0*z1,dst[dstOffset+2]=z0*w12+w02*z1+x0*y1-y0*x1,dst[dstOffset+3]=w02*w12-x0*x1-y0*y1-z0*z1,dst}get x(){return this._x}set x(value){this._x=value,this._onChangeCallback()}get y(){return this._y}set y(value){this._y=value,this._onChangeCallback()}get z(){return this._z}set z(value){this._z=value,this._onChangeCallback()}get w(){return this._w}set w(value){this._w=value,this._onChangeCallback()}set(x,y,z,w){return this._x=x,this._y=y,this._z=z,this._w=w,this._onChangeCallback(),this}clone(){return new this.constructor(this._x,this._y,this._z,this._w)}copy(quaternion){return this._x=quaternion.x,this._y=quaternion.y,this._z=quaternion.z,this._w=quaternion.w,this._onChangeCallback(),this}setFromEuler(euler,update=!0){const x=euler._x,y=euler._y,z=euler._z,order=euler._order,cos2=Math.cos,sin2=Math.sin,c1=cos2(x/2),c2=cos2(y/2),c3=cos2(z/2),s1=sin2(x/2),s2=sin2(y/2),s3=sin2(z/2);switch(order){case"XYZ":this._x=s1*c2*c3+c1*s2*s3,this._y=c1*s2*c3-s1*c2*s3,this._z=c1*c2*s3+s1*s2*c3,this._w=c1*c2*c3-s1*s2*s3;break;case"YXZ":this._x=s1*c2*c3+c1*s2*s3,this._y=c1*s2*c3-s1*c2*s3,this._z=c1*c2*s3-s1*s2*c3,this._w=c1*c2*c3+s1*s2*s3;break;case"ZXY":this._x=s1*c2*c3-c1*s2*s3,this._y=c1*s2*c3+s1*c2*s3,this._z=c1*c2*s3+s1*s2*c3,this._w=c1*c2*c3-s1*s2*s3;break;case"ZYX":this._x=s1*c2*c3-c1*s2*s3,this._y=c1*s2*c3+s1*c2*s3,this._z=c1*c2*s3-s1*s2*c3,this._w=c1*c2*c3+s1*s2*s3;break;case"YZX":this._x=s1*c2*c3+c1*s2*s3,this._y=c1*s2*c3+s1*c2*s3,this._z=c1*c2*s3-s1*s2*c3,this._w=c1*c2*c3-s1*s2*s3;break;case"XZY":this._x=s1*c2*c3-c1*s2*s3,this._y=c1*s2*c3-s1*c2*s3,this._z=c1*c2*s3+s1*s2*c3,this._w=c1*c2*c3+s1*s2*s3;break;default:console.warn("THREE.Quaternion: .setFromEuler() encountered an unknown order: "+order)}return update===!0&&this._onChangeCallback(),this}setFromAxisAngle(axis,angle){const halfAngle=angle/2,s2=Math.sin(halfAngle);return this._x=axis.x*s2,this._y=axis.y*s2,this._z=axis.z*s2,this._w=Math.cos(halfAngle),this._onChangeCallback(),this}setFromRotationMatrix(m){const te=m.elements,m11=te[0],m12=te[4],m13=te[8],m21=te[1],m22=te[5],m23=te[9],m31=te[2],m32=te[6],m33=te[10],trace=m11+m22+m33;if(trace>0){const s2=.5/Math.sqrt(trace+1);this._w=.25/s2,this._x=(m32-m23)*s2,this._y=(m13-m31)*s2,this._z=(m21-m12)*s2}else if(m11>m22&&m11>m33){const s2=2*Math.sqrt(1+m11-m22-m33);this._w=(m32-m23)/s2,this._x=.25*s2,this._y=(m12+m21)/s2,this._z=(m13+m31)/s2}else if(m22>m33){const s2=2*Math.sqrt(1+m22-m11-m33);this._w=(m13-m31)/s2,this._x=(m12+m21)/s2,this._y=.25*s2,this._z=(m23+m32)/s2}else{const s2=2*Math.sqrt(1+m33-m11-m22);this._w=(m21-m12)/s2,this._x=(m13+m31)/s2,this._y=(m23+m32)/s2,this._z=.25*s2}return this._onChangeCallback(),this}setFromUnitVectors(vFrom,vTo){let r2=vFrom.dot(vTo)+1;return r2<Number.EPSILON?(r2=0,Math.abs(vFrom.x)>Math.abs(vFrom.z)?(this._x=-vFrom.y,this._y=vFrom.x,this._z=0,this._w=r2):(this._x=0,this._y=-vFrom.z,this._z=vFrom.y,this._w=r2)):(this._x=vFrom.y*vTo.z-vFrom.z*vTo.y,this._y=vFrom.z*vTo.x-vFrom.x*vTo.z,this._z=vFrom.x*vTo.y-vFrom.y*vTo.x,this._w=r2),this.normalize()}angleTo(q){return 2*Math.acos(Math.abs(clamp$4(this.dot(q),-1,1)))}rotateTowards(q,step2){const angle=this.angleTo(q);if(angle===0)return this;const t2=Math.min(1,step2/angle);return this.slerp(q,t2),this}identity(){return this.set(0,0,0,1)}invert(){return this.conjugate()}conjugate(){return this._x*=-1,this._y*=-1,this._z*=-1,this._onChangeCallback(),this}dot(v){return this._x*v._x+this._y*v._y+this._z*v._z+this._w*v._w}lengthSq(){return this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w}length(){return Math.sqrt(this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w)}normalize(){let l2=this.length();return l2===0?(this._x=0,this._y=0,this._z=0,this._w=1):(l2=1/l2,this._x=this._x*l2,this._y=this._y*l2,this._z=this._z*l2,this._w=this._w*l2),this._onChangeCallback(),this}multiply(q){return this.multiplyQuaternions(this,q)}premultiply(q){return this.multiplyQuaternions(q,this)}multiplyQuaternions(a2,b){const qax=a2._x,qay=a2._y,qaz=a2._z,qaw=a2._w,qbx=b._x,qby=b._y,qbz=b._z,qbw=b._w;return this._x=qax*qbw+qaw*qbx+qay*qbz-qaz*qby,this._y=qay*qbw+qaw*qby+qaz*qbx-qax*qbz,this._z=qaz*qbw+qaw*qbz+qax*qby-qay*qbx,this._w=qaw*qbw-qax*qbx-qay*qby-qaz*qbz,this._onChangeCallback(),this}slerp(qb,t2){if(t2===0)return this;if(t2===1)return this.copy(qb);const x=this._x,y=this._y,z=this._z,w=this._w;let cosHalfTheta=w*qb._w+x*qb._x+y*qb._y+z*qb._z;if(cosHalfTheta<0?(this._w=-qb._w,this._x=-qb._x,this._y=-qb._y,this._z=-qb._z,cosHalfTheta=-cosHalfTheta):this.copy(qb),cosHalfTheta>=1)return this._w=w,this._x=x,this._y=y,this._z=z,this;const sqrSinHalfTheta=1-cosHalfTheta*cosHalfTheta;if(sqrSinHalfTheta<=Number.EPSILON){const s2=1-t2;return this._w=s2*w+t2*this._w,this._x=s2*x+t2*this._x,this._y=s2*y+t2*this._y,this._z=s2*z+t2*this._z,this.normalize(),this}const sinHalfTheta=Math.sqrt(sqrSinHalfTheta),halfTheta=Math.atan2(sinHalfTheta,cosHalfTheta),ratioA=Math.sin((1-t2)*halfTheta)/sinHalfTheta,ratioB=Math.sin(t2*halfTheta)/sinHalfTheta;return this._w=w*ratioA+this._w*ratioB,this._x=x*ratioA+this._x*ratioB,this._y=y*ratioA+this._y*ratioB,this._z=z*ratioA+this._z*ratioB,this._onChangeCallback(),this}slerpQuaternions(qa,qb,t2){return this.copy(qa).slerp(qb,t2)}random(){const theta1=2*Math.PI*Math.random(),theta2=2*Math.PI*Math.random(),x0=Math.random(),r1=Math.sqrt(1-x0),r2=Math.sqrt(x0);return this.set(r1*Math.sin(theta1),r1*Math.cos(theta1),r2*Math.sin(theta2),r2*Math.cos(theta2))}equals(quaternion){return quaternion._x===this._x&&quaternion._y===this._y&&quaternion._z===this._z&&quaternion._w===this._w}fromArray(array2,offset=0){return this._x=array2[offset],this._y=array2[offset+1],this._z=array2[offset+2],this._w=array2[offset+3],this._onChangeCallback(),this}toArray(array2=[],offset=0){return array2[offset]=this._x,array2[offset+1]=this._y,array2[offset+2]=this._z,array2[offset+3]=this._w,array2}fromBufferAttribute(attribute2,index){return this._x=attribute2.getX(index),this._y=attribute2.getY(index),this._z=attribute2.getZ(index),this._w=attribute2.getW(index),this._onChangeCallback(),this}toJSON(){return this.toArray()}_onChange(callback){return this._onChangeCallback=callback,this}_onChangeCallback(){}*[Symbol.iterator](){yield this._x,yield this._y,yield this._z,yield this._w}}class Vector3{constructor(x=0,y=0,z=0){Vector3.prototype.isVector3=!0,this.x=x,this.y=y,this.z=z}set(x,y,z){return z===void 0&&(z=this.z),this.x=x,this.y=y,this.z=z,this}setScalar(scalar){return this.x=scalar,this.y=scalar,this.z=scalar,this}setX(x){return this.x=x,this}setY(y){return this.y=y,this}setZ(z){return this.z=z,this}setComponent(index,value){switch(index){case 0:this.x=value;break;case 1:this.y=value;break;case 2:this.z=value;break;default:throw new Error("index is out of range: "+index)}return this}getComponent(index){switch(index){case 0:return this.x;case 1:return this.y;case 2:return this.z;default:throw new Error("index is out of range: "+index)}}clone(){return new this.constructor(this.x,this.y,this.z)}copy(v){return this.x=v.x,this.y=v.y,this.z=v.z,this}add(v){return this.x+=v.x,this.y+=v.y,this.z+=v.z,this}addScalar(s2){return this.x+=s2,this.y+=s2,this.z+=s2,this}addVectors(a2,b){return this.x=a2.x+b.x,this.y=a2.y+b.y,this.z=a2.z+b.z,this}addScaledVector(v,s2){return this.x+=v.x*s2,this.y+=v.y*s2,this.z+=v.z*s2,this}sub(v){return this.x-=v.x,this.y-=v.y,this.z-=v.z,this}subScalar(s2){return this.x-=s2,this.y-=s2,this.z-=s2,this}subVectors(a2,b){return this.x=a2.x-b.x,this.y=a2.y-b.y,this.z=a2.z-b.z,this}multiply(v){return this.x*=v.x,this.y*=v.y,this.z*=v.z,this}multiplyScalar(scalar){return this.x*=scalar,this.y*=scalar,this.z*=scalar,this}multiplyVectors(a2,b){return this.x=a2.x*b.x,this.y=a2.y*b.y,this.z=a2.z*b.z,this}applyEuler(euler){return this.applyQuaternion(_quaternion$4.setFromEuler(euler))}applyAxisAngle(axis,angle){return this.applyQuaternion(_quaternion$4.setFromAxisAngle(axis,angle))}applyMatrix3(m){const x=this.x,y=this.y,z=this.z,e2=m.elements;return this.x=e2[0]*x+e2[3]*y+e2[6]*z,this.y=e2[1]*x+e2[4]*y+e2[7]*z,this.z=e2[2]*x+e2[5]*y+e2[8]*z,this}applyNormalMatrix(m){return this.applyMatrix3(m).normalize()}applyMatrix4(m){const x=this.x,y=this.y,z=this.z,e2=m.elements,w=1/(e2[3]*x+e2[7]*y+e2[11]*z+e2[15]);return this.x=(e2[0]*x+e2[4]*y+e2[8]*z+e2[12])*w,this.y=(e2[1]*x+e2[5]*y+e2[9]*z+e2[13])*w,this.z=(e2[2]*x+e2[6]*y+e2[10]*z+e2[14])*w,this}applyQuaternion(q){const vx=this.x,vy=this.y,vz=this.z,qx=q.x,qy=q.y,qz=q.z,qw=q.w,tx=2*(qy*vz-qz*vy),ty=2*(qz*vx-qx*vz),tz=2*(qx*vy-qy*vx);return this.x=vx+qw*tx+qy*tz-qz*ty,this.y=vy+qw*ty+qz*tx-qx*tz,this.z=vz+qw*tz+qx*ty-qy*tx,this}project(camera){return this.applyMatrix4(camera.matrixWorldInverse).applyMatrix4(camera.projectionMatrix)}unproject(camera){return this.applyMatrix4(camera.projectionMatrixInverse).applyMatrix4(camera.matrixWorld)}transformDirection(m){const x=this.x,y=this.y,z=this.z,e2=m.elements;return this.x=e2[0]*x+e2[4]*y+e2[8]*z,this.y=e2[1]*x+e2[5]*y+e2[9]*z,this.z=e2[2]*x+e2[6]*y+e2[10]*z,this.normalize()}divide(v){return this.x/=v.x,this.y/=v.y,this.z/=v.z,this}divideScalar(scalar){return this.multiplyScalar(1/scalar)}min(v){return this.x=Math.min(this.x,v.x),this.y=Math.min(this.y,v.y),this.z=Math.min(this.z,v.z),this}max(v){return this.x=Math.max(this.x,v.x),this.y=Math.max(this.y,v.y),this.z=Math.max(this.z,v.z),this}clamp(min2,max2){return this.x=clamp$4(this.x,min2.x,max2.x),this.y=clamp$4(this.y,min2.y,max2.y),this.z=clamp$4(this.z,min2.z,max2.z),this}clampScalar(minVal,maxVal){return this.x=clamp$4(this.x,minVal,maxVal),this.y=clamp$4(this.y,minVal,maxVal),this.z=clamp$4(this.z,minVal,maxVal),this}clampLength(min2,max2){const length2=this.length();return this.divideScalar(length2||1).multiplyScalar(clamp$4(length2,min2,max2))}floor(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this}ceil(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this}round(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this}roundToZero(){return this.x=Math.trunc(this.x),this.y=Math.trunc(this.y),this.z=Math.trunc(this.z),this}negate(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this}dot(v){return this.x*v.x+this.y*v.y+this.z*v.z}lengthSq(){return this.x*this.x+this.y*this.y+this.z*this.z}length(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)}manhattanLength(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)}normalize(){return this.divideScalar(this.length()||1)}setLength(length2){return this.normalize().multiplyScalar(length2)}lerp(v,alpha){return this.x+=(v.x-this.x)*alpha,this.y+=(v.y-this.y)*alpha,this.z+=(v.z-this.z)*alpha,this}lerpVectors(v1,v2,alpha){return this.x=v1.x+(v2.x-v1.x)*alpha,this.y=v1.y+(v2.y-v1.y)*alpha,this.z=v1.z+(v2.z-v1.z)*alpha,this}cross(v){return this.crossVectors(this,v)}crossVectors(a2,b){const ax=a2.x,ay=a2.y,az=a2.z,bx=b.x,by=b.y,bz=b.z;return this.x=ay*bz-az*by,this.y=az*bx-ax*bz,this.z=ax*by-ay*bx,this}projectOnVector(v){const denominator=v.lengthSq();if(denominator===0)return this.set(0,0,0);const scalar=v.dot(this)/denominator;return this.copy(v).multiplyScalar(scalar)}projectOnPlane(planeNormal){return _vector$c.copy(this).projectOnVector(planeNormal),this.sub(_vector$c)}reflect(normal2){return this.sub(_vector$c.copy(normal2).multiplyScalar(2*this.dot(normal2)))}angleTo(v){const denominator=Math.sqrt(this.lengthSq()*v.lengthSq());if(denominator===0)return Math.PI/2;const theta=this.dot(v)/denominator;return Math.acos(clamp$4(theta,-1,1))}distanceTo(v){return Math.sqrt(this.distanceToSquared(v))}distanceToSquared(v){const dx=this.x-v.x,dy=this.y-v.y,dz=this.z-v.z;return dx*dx+dy*dy+dz*dz}manhattanDistanceTo(v){return Math.abs(this.x-v.x)+Math.abs(this.y-v.y)+Math.abs(this.z-v.z)}setFromSpherical(s2){return this.setFromSphericalCoords(s2.radius,s2.phi,s2.theta)}setFromSphericalCoords(radius,phi,theta){const sinPhiRadius=Math.sin(phi)*radius;return this.x=sinPhiRadius*Math.sin(theta),this.y=Math.cos(phi)*radius,this.z=sinPhiRadius*Math.cos(theta),this}setFromCylindrical(c2){return this.setFromCylindricalCoords(c2.radius,c2.theta,c2.y)}setFromCylindricalCoords(radius,theta,y){return this.x=radius*Math.sin(theta),this.y=y,this.z=radius*Math.cos(theta),this}setFromMatrixPosition(m){const e2=m.elements;return this.x=e2[12],this.y=e2[13],this.z=e2[14],this}setFromMatrixScale(m){const sx=this.setFromMatrixColumn(m,0).length(),sy=this.setFromMatrixColumn(m,1).length(),sz=this.setFromMatrixColumn(m,2).length();return this.x=sx,this.y=sy,this.z=sz,this}setFromMatrixColumn(m,index){return this.fromArray(m.elements,index*4)}setFromMatrix3Column(m,index){return this.fromArray(m.elements,index*3)}setFromEuler(e2){return this.x=e2._x,this.y=e2._y,this.z=e2._z,this}setFromColor(c2){return this.x=c2.r,this.y=c2.g,this.z=c2.b,this}equals(v){return v.x===this.x&&v.y===this.y&&v.z===this.z}fromArray(array2,offset=0){return this.x=array2[offset],this.y=array2[offset+1],this.z=array2[offset+2],this}toArray(array2=[],offset=0){return array2[offset]=this.x,array2[offset+1]=this.y,array2[offset+2]=this.z,array2}fromBufferAttribute(attribute2,index){return this.x=attribute2.getX(index),this.y=attribute2.getY(index),this.z=attribute2.getZ(index),this}random(){return this.x=Math.random(),this.y=Math.random(),this.z=Math.random(),this}randomDirection(){const theta=Math.random()*Math.PI*2,u=Math.random()*2-1,c2=Math.sqrt(1-u*u);return this.x=c2*Math.cos(theta),this.y=u,this.z=c2*Math.sin(theta),this}*[Symbol.iterator](){yield this.x,yield this.y,yield this.z}}const _vector$c=new Vector3,_quaternion$4=new Quaternion;class Box3{constructor(min2=new Vector3(1/0,1/0,1/0),max2=new Vector3(-1/0,-1/0,-1/0)){this.isBox3=!0,this.min=min2,this.max=max2}set(min2,max2){return this.min.copy(min2),this.max.copy(max2),this}setFromArray(array2){this.makeEmpty();for(let i2=0,il=array2.length;i2<il;i2+=3)this.expandByPoint(_vector$b.fromArray(array2,i2));return this}setFromBufferAttribute(attribute2){this.makeEmpty();for(let i2=0,il=attribute2.count;i2<il;i2++)this.expandByPoint(_vector$b.fromBufferAttribute(attribute2,i2));return this}setFromPoints(points){this.makeEmpty();for(let i2=0,il=points.length;i2<il;i2++)this.expandByPoint(points[i2]);return this}setFromCenterAndSize(center,size){const halfSize=_vector$b.copy(size).multiplyScalar(.5);return this.min.copy(center).sub(halfSize),this.max.copy(center).add(halfSize),this}setFromObject(object,precise=!1){return this.makeEmpty(),this.expandByObject(object,precise)}clone(){return new this.constructor().copy(this)}copy(box){return this.min.copy(box.min),this.max.copy(box.max),this}makeEmpty(){return this.min.x=this.min.y=this.min.z=1/0,this.max.x=this.max.y=this.max.z=-1/0,this}isEmpty(){return this.max.x<this.min.x||this.max.y<this.min.y||this.max.z<this.min.z}getCenter(target){return this.isEmpty()?target.set(0,0,0):target.addVectors(this.min,this.max).multiplyScalar(.5)}getSize(target){return this.isEmpty()?target.set(0,0,0):target.subVectors(this.max,this.min)}expandByPoint(point){return this.min.min(point),this.max.max(point),this}expandByVector(vector){return this.min.sub(vector),this.max.add(vector),this}expandByScalar(scalar){return this.min.addScalar(-scalar),this.max.addScalar(scalar),this}expandByObject(object,precise=!1){object.updateWorldMatrix(!1,!1);const geometry2=object.geometry;if(geometry2!==void 0){const positionAttribute=geometry2.getAttribute("position");if(precise===!0&&positionAttribute!==void 0&&object.isInstancedMesh!==!0)for(let i2=0,l2=positionAttribute.count;i2<l2;i2++)object.isMesh===!0?object.getVertexPosition(i2,_vector$b):_vector$b.fromBufferAttribute(positionAttribute,i2),_vector$b.applyMatrix4(object.matrixWorld),this.expandByPoint(_vector$b);else object.boundingBox!==void 0?(object.boundingBox===null&&object.computeBoundingBox(),_box$4.copy(object.boundingBox)):(geometry2.boundingBox===null&&geometry2.computeBoundingBox(),_box$4.copy(geometry2.boundingBox)),_box$4.applyMatrix4(object.matrixWorld),this.union(_box$4)}const children=object.children;for(let i2=0,l2=children.length;i2<l2;i2++)this.expandByObject(children[i2],precise);return this}containsPoint(point){return point.x>=this.min.x&&point.x<=this.max.x&&point.y>=this.min.y&&point.y<=this.max.y&&point.z>=this.min.z&&point.z<=this.max.z}containsBox(box){return this.min.x<=box.min.x&&box.max.x<=this.max.x&&this.min.y<=box.min.y&&box.max.y<=this.max.y&&this.min.z<=box.min.z&&box.max.z<=this.max.z}getParameter(point,target){return target.set((point.x-this.min.x)/(this.max.x-this.min.x),(point.y-this.min.y)/(this.max.y-this.min.y),(point.z-this.min.z)/(this.max.z-this.min.z))}intersectsBox(box){return box.max.x>=this.min.x&&box.min.x<=this.max.x&&box.max.y>=this.min.y&&box.min.y<=this.max.y&&box.max.z>=this.min.z&&box.min.z<=this.max.z}intersectsSphere(sphere){return this.clampPoint(sphere.center,_vector$b),_vector$b.distanceToSquared(sphere.center)<=sphere.radius*sphere.radius}intersectsPlane(plane){let min2,max2;return plane.normal.x>0?(min2=plane.normal.x*this.min.x,max2=plane.normal.x*this.max.x):(min2=plane.normal.x*this.max.x,max2=plane.normal.x*this.min.x),plane.normal.y>0?(min2+=plane.normal.y*this.min.y,max2+=plane.normal.y*this.max.y):(min2+=plane.normal.y*this.max.y,max2+=plane.normal.y*this.min.y),plane.normal.z>0?(min2+=plane.normal.z*this.min.z,max2+=plane.normal.z*this.max.z):(min2+=plane.normal.z*this.max.z,max2+=plane.normal.z*this.min.z),min2<=-plane.constant&&max2>=-plane.constant}intersectsTriangle(triangle){if(this.isEmpty())return!1;this.getCenter(_center),_extents.subVectors(this.max,_center),_v0$2.subVectors(triangle.a,_center),_v1$7.subVectors(triangle.b,_center),_v2$4.subVectors(triangle.c,_center),_f0.subVectors(_v1$7,_v0$2),_f1.subVectors(_v2$4,_v1$7),_f2.subVectors(_v0$2,_v2$4);let axes=[0,-_f0.z,_f0.y,0,-_f1.z,_f1.y,0,-_f2.z,_f2.y,_f0.z,0,-_f0.x,_f1.z,0,-_f1.x,_f2.z,0,-_f2.x,-_f0.y,_f0.x,0,-_f1.y,_f1.x,0,-_f2.y,_f2.x,0];return!satForAxes(axes,_v0$2,_v1$7,_v2$4,_extents)||(axes=[1,0,0,0,1,0,0,0,1],!satForAxes(axes,_v0$2,_v1$7,_v2$4,_extents))?!1:(_triangleNormal.crossVectors(_f0,_f1),axes=[_triangleNormal.x,_triangleNormal.y,_triangleNormal.z],satForAxes(axes,_v0$2,_v1$7,_v2$4,_extents))}clampPoint(point,target){return target.copy(point).clamp(this.min,this.max)}distanceToPoint(point){return this.clampPoint(point,_vector$b).distanceTo(point)}getBoundingSphere(target){return this.isEmpty()?target.makeEmpty():(this.getCenter(target.center),target.radius=this.getSize(_vector$b).length()*.5),target}intersect(box){return this.min.max(box.min),this.max.min(box.max),this.isEmpty()&&this.makeEmpty(),this}union(box){return this.min.min(box.min),this.max.max(box.max),this}applyMatrix4(matrix){return this.isEmpty()?this:(_points[0].set(this.min.x,this.min.y,this.min.z).applyMatrix4(matrix),_points[1].set(this.min.x,this.min.y,this.max.z).applyMatrix4(matrix),_points[2].set(this.min.x,this.max.y,this.min.z).applyMatrix4(matrix),_points[3].set(this.min.x,this.max.y,this.max.z).applyMatrix4(matrix),_points[4].set(this.max.x,this.min.y,this.min.z).applyMatrix4(matrix),_points[5].set(this.max.x,this.min.y,this.max.z).applyMatrix4(matrix),_points[6].set(this.max.x,this.max.y,this.min.z).applyMatrix4(matrix),_points[7].set(this.max.x,this.max.y,this.max.z).applyMatrix4(matrix),this.setFromPoints(_points),this)}translate(offset){return this.min.add(offset),this.max.add(offset),this}equals(box){return box.min.equals(this.min)&&box.max.equals(this.max)}}const _points=[new Vector3,new Vector3,new Vector3,new Vector3,new Vector3,new Vector3,new Vector3,new Vector3],_vector$b=new Vector3,_box$4=new Box3,_v0$2=new Vector3,_v1$7=new Vector3,_v2$4=new Vector3,_f0=new Vector3,_f1=new Vector3,_f2=new Vector3,_center=new Vector3,_extents=new Vector3,_triangleNormal=new Vector3,_testAxis=new Vector3;function satForAxes(axes,v0,v1,v2,extents){for(let i2=0,j=axes.length-3;i2<=j;i2+=3){_testAxis.fromArray(axes,i2);const r2=extents.x*Math.abs(_testAxis.x)+extents.y*Math.abs(_testAxis.y)+extents.z*Math.abs(_testAxis.z),p0=v0.dot(_testAxis),p1=v1.dot(_testAxis),p2=v2.dot(_testAxis);if(Math.max(-Math.max(p0,p1,p2),Math.min(p0,p1,p2))>r2)return!1}return!0}const _box$3=new Box3,_v1$6=new Vector3,_v2$3=new Vector3;class Sphere{constructor(center=new Vector3,radius=-1){this.isSphere=!0,this.center=center,this.radius=radius}set(center,radius){return this.center.copy(center),this.radius=radius,this}setFromPoints(points,optionalCenter){const center=this.center;optionalCenter!==void 0?center.copy(optionalCenter):_box$3.setFromPoints(points).getCenter(center);let maxRadiusSq=0;for(let i2=0,il=points.length;i2<il;i2++)maxRadiusSq=Math.max(maxRadiusSq,center.distanceToSquared(points[i2]));return this.radius=Math.sqrt(maxRadiusSq),this}copy(sphere){return this.center.copy(sphere.center),this.radius=sphere.radius,this}isEmpty(){return this.radius<0}makeEmpty(){return this.center.set(0,0,0),this.radius=-1,this}containsPoint(point){return point.distanceToSquared(this.center)<=this.radius*this.radius}distanceToPoint(point){return point.distanceTo(this.center)-this.radius}intersectsSphere(sphere){const radiusSum=this.radius+sphere.radius;return sphere.center.distanceToSquared(this.center)<=radiusSum*radiusSum}intersectsBox(box){return box.intersectsSphere(this)}intersectsPlane(plane){return Math.abs(plane.distanceToPoint(this.center))<=this.radius}clampPoint(point,target){const deltaLengthSq=this.center.distanceToSquared(point);return target.copy(point),deltaLengthSq>this.radius*this.radius&&(target.sub(this.center).normalize(),target.multiplyScalar(this.radius).add(this.center)),target}getBoundingBox(target){return this.isEmpty()?(target.makeEmpty(),target):(target.set(this.center,this.center),target.expandByScalar(this.radius),target)}applyMatrix4(matrix){return this.center.applyMatrix4(matrix),this.radius=this.radius*matrix.getMaxScaleOnAxis(),this}translate(offset){return this.center.add(offset),this}expandByPoint(point){if(this.isEmpty())return this.center.copy(point),this.radius=0,this;_v1$6.subVectors(point,this.center);const lengthSq2=_v1$6.lengthSq();if(lengthSq2>this.radius*this.radius){const length2=Math.sqrt(lengthSq2),delta=(length2-this.radius)*.5;this.center.addScaledVector(_v1$6,delta/length2),this.radius+=delta}return this}union(sphere){return sphere.isEmpty()?this:this.isEmpty()?(this.copy(sphere),this):(this.center.equals(sphere.center)===!0?this.radius=Math.max(this.radius,sphere.radius):(_v2$3.subVectors(sphere.center,this.center).setLength(sphere.radius),this.expandByPoint(_v1$6.copy(sphere.center).add(_v2$3)),this.expandByPoint(_v1$6.copy(sphere.center).sub(_v2$3))),this)}equals(sphere){return sphere.center.equals(this.center)&&sphere.radius===this.radius}clone(){return new this.constructor().copy(this)}}const _vector$a=new Vector3,_segCenter=new Vector3,_segDir=new Vector3,_diff=new Vector3,_edge1=new Vector3,_edge2=new Vector3,_normal$1=new Vector3;class Ray{constructor(origin=new Vector3,direction=new Vector3(0,0,-1)){this.origin=origin,this.direction=direction}set(origin,direction){return this.origin.copy(origin),this.direction.copy(direction),this}copy(ray){return this.origin.copy(ray.origin),this.direction.copy(ray.direction),this}at(t2,target){return target.copy(this.origin).addScaledVector(this.direction,t2)}lookAt(v){return this.direction.copy(v).sub(this.origin).normalize(),this}recast(t2){return this.origin.copy(this.at(t2,_vector$a)),this}closestPointToPoint(point,target){target.subVectors(point,this.origin);const directionDistance=target.dot(this.direction);return directionDistance<0?target.copy(this.origin):target.copy(this.origin).addScaledVector(this.direction,directionDistance)}distanceToPoint(point){return Math.sqrt(this.distanceSqToPoint(point))}distanceSqToPoint(point){const directionDistance=_vector$a.subVectors(point,this.origin).dot(this.direction);return directionDistance<0?this.origin.distanceToSquared(point):(_vector$a.copy(this.origin).addScaledVector(this.direction,directionDistance),_vector$a.distanceToSquared(point))}distanceSqToSegment(v0,v1,optionalPointOnRay,optionalPointOnSegment){_segCenter.copy(v0).add(v1).multiplyScalar(.5),_segDir.copy(v1).sub(v0).normalize(),_diff.copy(this.origin).sub(_segCenter);const segExtent=v0.distanceTo(v1)*.5,a01=-this.direction.dot(_segDir),b0=_diff.dot(this.direction),b1=-_diff.dot(_segDir),c2=_diff.lengthSq(),det=Math.abs(1-a01*a01);let s0,s1,sqrDist,extDet;if(det>0)if(s0=a01*b1-b0,s1=a01*b0-b1,extDet=segExtent*det,s0>=0)if(s1>=-extDet)if(s1<=extDet){const invDet=1/det;s0*=invDet,s1*=invDet,sqrDist=s0*(s0+a01*s1+2*b0)+s1*(a01*s0+s1+2*b1)+c2}else s1=segExtent,s0=Math.max(0,-(a01*s1+b0)),sqrDist=-s0*s0+s1*(s1+2*b1)+c2;else s1=-segExtent,s0=Math.max(0,-(a01*s1+b0)),sqrDist=-s0*s0+s1*(s1+2*b1)+c2;else s1<=-extDet?(s0=Math.max(0,-(-a01*segExtent+b0)),s1=s0>0?-segExtent:Math.min(Math.max(-segExtent,-b1),segExtent),sqrDist=-s0*s0+s1*(s1+2*b1)+c2):s1<=extDet?(s0=0,s1=Math.min(Math.max(-segExtent,-b1),segExtent),sqrDist=s1*(s1+2*b1)+c2):(s0=Math.max(0,-(a01*segExtent+b0)),s1=s0>0?segExtent:Math.min(Math.max(-segExtent,-b1),segExtent),sqrDist=-s0*s0+s1*(s1+2*b1)+c2);else s1=a01>0?-segExtent:segExtent,s0=Math.max(0,-(a01*s1+b0)),sqrDist=-s0*s0+s1*(s1+2*b1)+c2;return optionalPointOnRay&&optionalPointOnRay.copy(this.origin).addScaledVector(this.direction,s0),optionalPointOnSegment&&optionalPointOnSegment.copy(_segCenter).addScaledVector(_segDir,s1),sqrDist}intersectSphere(sphere,target){_vector$a.subVectors(sphere.center,this.origin);const tca=_vector$a.dot(this.direction),d2=_vector$a.dot(_vector$a)-tca*tca,radius2=sphere.radius*sphere.radius;if(d2>radius2)return null;const thc=Math.sqrt(radius2-d2),t0=tca-thc,t1=tca+thc;return t1<0?null:t0<0?this.at(t1,target):this.at(t0,target)}intersectsSphere(sphere){return this.distanceSqToPoint(sphere.center)<=sphere.radius*sphere.radius}distanceToPlane(plane){const denominator=plane.normal.dot(this.direction);if(denominator===0)return plane.distanceToPoint(this.origin)===0?0:null;const t2=-(this.origin.dot(plane.normal)+plane.constant)/denominator;return t2>=0?t2:null}intersectPlane(plane,target){const t2=this.distanceToPlane(plane);return t2===null?null:this.at(t2,target)}intersectsPlane(plane){const distToPoint=plane.distanceToPoint(this.origin);return distToPoint===0||plane.normal.dot(this.direction)*distToPoint<0}intersectBox(box,target){let tmin,tmax,tymin,tymax,tzmin,tzmax;const invdirx=1/this.direction.x,invdiry=1/this.direction.y,invdirz=1/this.direction.z,origin=this.origin;return invdirx>=0?(tmin=(box.min.x-origin.x)*invdirx,tmax=(box.max.x-origin.x)*invdirx):(tmin=(box.max.x-origin.x)*invdirx,tmax=(box.min.x-origin.x)*invdirx),invdiry>=0?(tymin=(box.min.y-origin.y)*invdiry,tymax=(box.max.y-origin.y)*invdiry):(tymin=(box.max.y-origin.y)*invdiry,tymax=(box.min.y-origin.y)*invdiry),tmin>tymax||tymin>tmax||((tymin>tmin||isNaN(tmin))&&(tmin=tymin),(tymax<tmax||isNaN(tmax))&&(tmax=tymax),invdirz>=0?(tzmin=(box.min.z-origin.z)*invdirz,tzmax=(box.max.z-origin.z)*invdirz):(tzmin=(box.max.z-origin.z)*invdirz,tzmax=(box.min.z-origin.z)*invdirz),tmin>tzmax||tzmin>tmax)||((tzmin>tmin||tmin!==tmin)&&(tmin=tzmin),(tzmax<tmax||tmax!==tmax)&&(tmax=tzmax),tmax<0)?null:this.at(tmin>=0?tmin:tmax,target)}intersectsBox(box){return this.intersectBox(box,_vector$a)!==null}intersectTriangle(a2,b,c2,backfaceCulling,target){_edge1.subVectors(b,a2),_edge2.subVectors(c2,a2),_normal$1.crossVectors(_edge1,_edge2);let DdN=this.direction.dot(_normal$1),sign2;if(DdN>0){if(backfaceCulling)return null;sign2=1}else if(DdN<0)sign2=-1,DdN=-DdN;else return null;_diff.subVectors(this.origin,a2);const DdQxE2=sign2*this.direction.dot(_edge2.crossVectors(_diff,_edge2));if(DdQxE2<0)return null;const DdE1xQ=sign2*this.direction.dot(_edge1.cross(_diff));if(DdE1xQ<0||DdQxE2+DdE1xQ>DdN)return null;const QdN=-sign2*_diff.dot(_normal$1);return QdN<0?null:this.at(QdN/DdN,target)}applyMatrix4(matrix4){return this.origin.applyMatrix4(matrix4),this.direction.transformDirection(matrix4),this}equals(ray){return ray.origin.equals(this.origin)&&ray.direction.equals(this.direction)}clone(){return new this.constructor().copy(this)}}class Matrix4{constructor(n11,n12,n13,n14,n21,n22,n23,n24,n31,n32,n33,n34,n41,n42,n43,n44){Matrix4.prototype.isMatrix4=!0,this.elements=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],n11!==void 0&&this.set(n11,n12,n13,n14,n21,n22,n23,n24,n31,n32,n33,n34,n41,n42,n43,n44)}set(n11,n12,n13,n14,n21,n22,n23,n24,n31,n32,n33,n34,n41,n42,n43,n44){const te=this.elements;return te[0]=n11,te[4]=n12,te[8]=n13,te[12]=n14,te[1]=n21,te[5]=n22,te[9]=n23,te[13]=n24,te[2]=n31,te[6]=n32,te[10]=n33,te[14]=n34,te[3]=n41,te[7]=n42,te[11]=n43,te[15]=n44,this}identity(){return this.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1),this}clone(){return new Matrix4().fromArray(this.elements)}copy(m){const te=this.elements,me=m.elements;return te[0]=me[0],te[1]=me[1],te[2]=me[2],te[3]=me[3],te[4]=me[4],te[5]=me[5],te[6]=me[6],te[7]=me[7],te[8]=me[8],te[9]=me[9],te[10]=me[10],te[11]=me[11],te[12]=me[12],te[13]=me[13],te[14]=me[14],te[15]=me[15],this}copyPosition(m){const te=this.elements,me=m.elements;return te[12]=me[12],te[13]=me[13],te[14]=me[14],this}setFromMatrix3(m){const me=m.elements;return this.set(me[0],me[3],me[6],0,me[1],me[4],me[7],0,me[2],me[5],me[8],0,0,0,0,1),this}extractBasis(xAxis,yAxis,zAxis){return xAxis.setFromMatrixColumn(this,0),yAxis.setFromMatrixColumn(this,1),zAxis.setFromMatrixColumn(this,2),this}makeBasis(xAxis,yAxis,zAxis){return this.set(xAxis.x,yAxis.x,zAxis.x,0,xAxis.y,yAxis.y,zAxis.y,0,xAxis.z,yAxis.z,zAxis.z,0,0,0,0,1),this}extractRotation(m){const te=this.elements,me=m.elements,scaleX=1/_v1$5.setFromMatrixColumn(m,0).length(),scaleY=1/_v1$5.setFromMatrixColumn(m,1).length(),scaleZ=1/_v1$5.setFromMatrixColumn(m,2).length();return te[0]=me[0]*scaleX,te[1]=me[1]*scaleX,te[2]=me[2]*scaleX,te[3]=0,te[4]=me[4]*scaleY,te[5]=me[5]*scaleY,te[6]=me[6]*scaleY,te[7]=0,te[8]=me[8]*scaleZ,te[9]=me[9]*scaleZ,te[10]=me[10]*scaleZ,te[11]=0,te[12]=0,te[13]=0,te[14]=0,te[15]=1,this}makeRotationFromEuler(euler){const te=this.elements,x=euler.x,y=euler.y,z=euler.z,a2=Math.cos(x),b=Math.sin(x),c2=Math.cos(y),d2=Math.sin(y),e2=Math.cos(z),f2=Math.sin(z);if(euler.order==="XYZ"){const ae=a2*e2,af=a2*f2,be=b*e2,bf=b*f2;te[0]=c2*e2,te[4]=-c2*f2,te[8]=d2,te[1]=af+be*d2,te[5]=ae-bf*d2,te[9]=-b*c2,te[2]=bf-ae*d2,te[6]=be+af*d2,te[10]=a2*c2}else if(euler.order==="YXZ"){const ce=c2*e2,cf=c2*f2,de=d2*e2,df=d2*f2;te[0]=ce+df*b,te[4]=de*b-cf,te[8]=a2*d2,te[1]=a2*f2,te[5]=a2*e2,te[9]=-b,te[2]=cf*b-de,te[6]=df+ce*b,te[10]=a2*c2}else if(euler.order==="ZXY"){const ce=c2*e2,cf=c2*f2,de=d2*e2,df=d2*f2;te[0]=ce-df*b,te[4]=-a2*f2,te[8]=de+cf*b,te[1]=cf+de*b,te[5]=a2*e2,te[9]=df-ce*b,te[2]=-a2*d2,te[6]=b,te[10]=a2*c2}else if(euler.order==="ZYX"){const ae=a2*e2,af=a2*f2,be=b*e2,bf=b*f2;te[0]=c2*e2,te[4]=be*d2-af,te[8]=ae*d2+bf,te[1]=c2*f2,te[5]=bf*d2+ae,te[9]=af*d2-be,te[2]=-d2,te[6]=b*c2,te[10]=a2*c2}else if(euler.order==="YZX"){const ac=a2*c2,ad=a2*d2,bc=b*c2,bd=b*d2;te[0]=c2*e2,te[4]=bd-ac*f2,te[8]=bc*f2+ad,te[1]=f2,te[5]=a2*e2,te[9]=-b*e2,te[2]=-d2*e2,te[6]=ad*f2+bc,te[10]=ac-bd*f2}else if(euler.order==="XZY"){const ac=a2*c2,ad=a2*d2,bc=b*c2,bd=b*d2;te[0]=c2*e2,te[4]=-f2,te[8]=d2*e2,te[1]=ac*f2+bd,te[5]=a2*e2,te[9]=ad*f2-bc,te[2]=bc*f2-ad,te[6]=b*e2,te[10]=bd*f2+ac}return te[3]=0,te[7]=0,te[11]=0,te[12]=0,te[13]=0,te[14]=0,te[15]=1,this}makeRotationFromQuaternion(q){return this.compose(_zero,q,_one)}lookAt(eye,target,up){const te=this.elements;return _z.subVectors(eye,target),_z.lengthSq()===0&&(_z.z=1),_z.normalize(),_x.crossVectors(up,_z),_x.lengthSq()===0&&(Math.abs(up.z)===1?_z.x+=1e-4:_z.z+=1e-4,_z.normalize(),_x.crossVectors(up,_z)),_x.normalize(),_y.crossVectors(_z,_x),te[0]=_x.x,te[4]=_y.x,te[8]=_z.x,te[1]=_x.y,te[5]=_y.y,te[9]=_z.y,te[2]=_x.z,te[6]=_y.z,te[10]=_z.z,this}multiply(m){return this.multiplyMatrices(this,m)}premultiply(m){return this.multiplyMatrices(m,this)}multiplyMatrices(a2,b){const ae=a2.elements,be=b.elements,te=this.elements,a11=ae[0],a12=ae[4],a13=ae[8],a14=ae[12],a21=ae[1],a22=ae[5],a23=ae[9],a24=ae[13],a31=ae[2],a32=ae[6],a33=ae[10],a34=ae[14],a41=ae[3],a42=ae[7],a43=ae[11],a44=ae[15],b11=be[0],b12=be[4],b13=be[8],b14=be[12],b21=be[1],b22=be[5],b23=be[9],b24=be[13],b31=be[2],b32=be[6],b33=be[10],b34=be[14],b41=be[3],b42=be[7],b43=be[11],b44=be[15];return te[0]=a11*b11+a12*b21+a13*b31+a14*b41,te[4]=a11*b12+a12*b22+a13*b32+a14*b42,te[8]=a11*b13+a12*b23+a13*b33+a14*b43,te[12]=a11*b14+a12*b24+a13*b34+a14*b44,te[1]=a21*b11+a22*b21+a23*b31+a24*b41,te[5]=a21*b12+a22*b22+a23*b32+a24*b42,te[9]=a21*b13+a22*b23+a23*b33+a24*b43,te[13]=a21*b14+a22*b24+a23*b34+a24*b44,te[2]=a31*b11+a32*b21+a33*b31+a34*b41,te[6]=a31*b12+a32*b22+a33*b32+a34*b42,te[10]=a31*b13+a32*b23+a33*b33+a34*b43,te[14]=a31*b14+a32*b24+a33*b34+a34*b44,te[3]=a41*b11+a42*b21+a43*b31+a44*b41,te[7]=a41*b12+a42*b22+a43*b32+a44*b42,te[11]=a41*b13+a42*b23+a43*b33+a44*b43,te[15]=a41*b14+a42*b24+a43*b34+a44*b44,this}multiplyScalar(s2){const te=this.elements;return te[0]*=s2,te[4]*=s2,te[8]*=s2,te[12]*=s2,te[1]*=s2,te[5]*=s2,te[9]*=s2,te[13]*=s2,te[2]*=s2,te[6]*=s2,te[10]*=s2,te[14]*=s2,te[3]*=s2,te[7]*=s2,te[11]*=s2,te[15]*=s2,this}determinant(){const te=this.elements,n11=te[0],n12=te[4],n13=te[8],n14=te[12],n21=te[1],n22=te[5],n23=te[9],n24=te[13],n31=te[2],n32=te[6],n33=te[10],n34=te[14],n41=te[3],n42=te[7],n43=te[11],n44=te[15];return n41*(+n14*n23*n32-n13*n24*n32-n14*n22*n33+n12*n24*n33+n13*n22*n34-n12*n23*n34)+n42*(+n11*n23*n34-n11*n24*n33+n14*n21*n33-n13*n21*n34+n13*n24*n31-n14*n23*n31)+n43*(+n11*n24*n32-n11*n22*n34-n14*n21*n32+n12*n21*n34+n14*n22*n31-n12*n24*n31)+n44*(-n13*n22*n31-n11*n23*n32+n11*n22*n33+n13*n21*n32-n12*n21*n33+n12*n23*n31)}transpose(){const te=this.elements;let tmp;return tmp=te[1],te[1]=te[4],te[4]=tmp,tmp=te[2],te[2]=te[8],te[8]=tmp,tmp=te[6],te[6]=te[9],te[9]=tmp,tmp=te[3],te[3]=te[12],te[12]=tmp,tmp=te[7],te[7]=te[13],te[13]=tmp,tmp=te[11],te[11]=te[14],te[14]=tmp,this}setPosition(x,y,z){const te=this.elements;return x.isVector3?(te[12]=x.x,te[13]=x.y,te[14]=x.z):(te[12]=x,te[13]=y,te[14]=z),this}invert(){const te=this.elements,n11=te[0],n21=te[1],n31=te[2],n41=te[3],n12=te[4],n22=te[5],n32=te[6],n42=te[7],n13=te[8],n23=te[9],n33=te[10],n43=te[11],n14=te[12],n24=te[13],n34=te[14],n44=te[15],t11=n23*n34*n42-n24*n33*n42+n24*n32*n43-n22*n34*n43-n23*n32*n44+n22*n33*n44,t12=n14*n33*n42-n13*n34*n42-n14*n32*n43+n12*n34*n43+n13*n32*n44-n12*n33*n44,t13=n13*n24*n42-n14*n23*n42+n14*n22*n43-n12*n24*n43-n13*n22*n44+n12*n23*n44,t14=n14*n23*n32-n13*n24*n32-n14*n22*n33+n12*n24*n33+n13*n22*n34-n12*n23*n34,det=n11*t11+n21*t12+n31*t13+n41*t14;if(det===0)return this.set(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);const detInv=1/det;return te[0]=t11*detInv,te[1]=(n24*n33*n41-n23*n34*n41-n24*n31*n43+n21*n34*n43+n23*n31*n44-n21*n33*n44)*detInv,te[2]=(n22*n34*n41-n24*n32*n41+n24*n31*n42-n21*n34*n42-n22*n31*n44+n21*n32*n44)*detInv,te[3]=(n23*n32*n41-n22*n33*n41-n23*n31*n42+n21*n33*n42+n22*n31*n43-n21*n32*n43)*detInv,te[4]=t12*detInv,te[5]=(n13*n34*n41-n14*n33*n41+n14*n31*n43-n11*n34*n43-n13*n31*n44+n11*n33*n44)*detInv,te[6]=(n14*n32*n41-n12*n34*n41-n14*n31*n42+n11*n34*n42+n12*n31*n44-n11*n32*n44)*detInv,te[7]=(n12*n33*n41-n13*n32*n41+n13*n31*n42-n11*n33*n42-n12*n31*n43+n11*n32*n43)*detInv,te[8]=t13*detInv,te[9]=(n14*n23*n41-n13*n24*n41-n14*n21*n43+n11*n24*n43+n13*n21*n44-n11*n23*n44)*detInv,te[10]=(n12*n24*n41-n14*n22*n41+n14*n21*n42-n11*n24*n42-n12*n21*n44+n11*n22*n44)*detInv,te[11]=(n13*n22*n41-n12*n23*n41-n13*n21*n42+n11*n23*n42+n12*n21*n43-n11*n22*n43)*detInv,te[12]=t14*detInv,te[13]=(n13*n24*n31-n14*n23*n31+n14*n21*n33-n11*n24*n33-n13*n21*n34+n11*n23*n34)*detInv,te[14]=(n14*n22*n31-n12*n24*n31-n14*n21*n32+n11*n24*n32+n12*n21*n34-n11*n22*n34)*detInv,te[15]=(n12*n23*n31-n13*n22*n31+n13*n21*n32-n11*n23*n32-n12*n21*n33+n11*n22*n33)*detInv,this}scale(v){const te=this.elements,x=v.x,y=v.y,z=v.z;return te[0]*=x,te[4]*=y,te[8]*=z,te[1]*=x,te[5]*=y,te[9]*=z,te[2]*=x,te[6]*=y,te[10]*=z,te[3]*=x,te[7]*=y,te[11]*=z,this}getMaxScaleOnAxis(){const te=this.elements,scaleXSq=te[0]*te[0]+te[1]*te[1]+te[2]*te[2],scaleYSq=te[4]*te[4]+te[5]*te[5]+te[6]*te[6],scaleZSq=te[8]*te[8]+te[9]*te[9]+te[10]*te[10];return Math.sqrt(Math.max(scaleXSq,scaleYSq,scaleZSq))}makeTranslation(x,y,z){return x.isVector3?this.set(1,0,0,x.x,0,1,0,x.y,0,0,1,x.z,0,0,0,1):this.set(1,0,0,x,0,1,0,y,0,0,1,z,0,0,0,1),this}makeRotationX(theta){const c2=Math.cos(theta),s2=Math.sin(theta);return this.set(1,0,0,0,0,c2,-s2,0,0,s2,c2,0,0,0,0,1),this}makeRotationY(theta){const c2=Math.cos(theta),s2=Math.sin(theta);return this.set(c2,0,s2,0,0,1,0,0,-s2,0,c2,0,0,0,0,1),this}makeRotationZ(theta){const c2=Math.cos(theta),s2=Math.sin(theta);return this.set(c2,-s2,0,0,s2,c2,0,0,0,0,1,0,0,0,0,1),this}makeRotationAxis(axis,angle){const c2=Math.cos(angle),s2=Math.sin(angle),t2=1-c2,x=axis.x,y=axis.y,z=axis.z,tx=t2*x,ty=t2*y;return this.set(tx*x+c2,tx*y-s2*z,tx*z+s2*y,0,tx*y+s2*z,ty*y+c2,ty*z-s2*x,0,tx*z-s2*y,ty*z+s2*x,t2*z*z+c2,0,0,0,0,1),this}makeScale(x,y,z){return this.set(x,0,0,0,0,y,0,0,0,0,z,0,0,0,0,1),this}makeShear(xy,xz,yx,yz,zx,zy){return this.set(1,yx,zx,0,xy,1,zy,0,xz,yz,1,0,0,0,0,1),this}compose(position,quaternion,scale2){const te=this.elements,x=quaternion._x,y=quaternion._y,z=quaternion._z,w=quaternion._w,x2=x+x,y2=y+y,z2=z+z,xx=x*x2,xy=x*y2,xz=x*z2,yy=y*y2,yz=y*z2,zz=z*z2,wx=w*x2,wy=w*y2,wz=w*z2,sx=scale2.x,sy=scale2.y,sz=scale2.z;return te[0]=(1-(yy+zz))*sx,te[1]=(xy+wz)*sx,te[2]=(xz-wy)*sx,te[3]=0,te[4]=(xy-wz)*sy,te[5]=(1-(xx+zz))*sy,te[6]=(yz+wx)*sy,te[7]=0,te[8]=(xz+wy)*sz,te[9]=(yz-wx)*sz,te[10]=(1-(xx+yy))*sz,te[11]=0,te[12]=position.x,te[13]=position.y,te[14]=position.z,te[15]=1,this}decompose(position,quaternion,scale2){const te=this.elements;let sx=_v1$5.set(te[0],te[1],te[2]).length();const sy=_v1$5.set(te[4],te[5],te[6]).length(),sz=_v1$5.set(te[8],te[9],te[10]).length();this.determinant()<0&&(sx=-sx),position.x=te[12],position.y=te[13],position.z=te[14],_m1$2.copy(this);const invSX=1/sx,invSY=1/sy,invSZ=1/sz;return _m1$2.elements[0]*=invSX,_m1$2.elements[1]*=invSX,_m1$2.elements[2]*=invSX,_m1$2.elements[4]*=invSY,_m1$2.elements[5]*=invSY,_m1$2.elements[6]*=invSY,_m1$2.elements[8]*=invSZ,_m1$2.elements[9]*=invSZ,_m1$2.elements[10]*=invSZ,quaternion.setFromRotationMatrix(_m1$2),scale2.x=sx,scale2.y=sy,scale2.z=sz,this}makePerspective(left,right,top,bottom,near,far,coordinateSystem=WebGLCoordinateSystem){const te=this.elements,x=2*near/(right-left),y=2*near/(top-bottom),a2=(right+left)/(right-left),b=(top+bottom)/(top-bottom);let c2,d2;if(coordinateSystem===WebGLCoordinateSystem)c2=-(far+near)/(far-near),d2=-2*far*near/(far-near);else if(coordinateSystem===WebGPUCoordinateSystem)c2=-far/(far-near),d2=-far*near/(far-near);else throw new Error("THREE.Matrix4.makePerspective(): Invalid coordinate system: "+coordinateSystem);return te[0]=x,te[4]=0,te[8]=a2,te[12]=0,te[1]=0,te[5]=y,te[9]=b,te[13]=0,te[2]=0,te[6]=0,te[10]=c2,te[14]=d2,te[3]=0,te[7]=0,te[11]=-1,te[15]=0,this}makeOrthographic(left,right,top,bottom,near,far,coordinateSystem=WebGLCoordinateSystem){const te=this.elements,w=1/(right-left),h=1/(top-bottom),p=1/(far-near),x=(right+left)*w,y=(top+bottom)*h;let z,zInv;if(coordinateSystem===WebGLCoordinateSystem)z=(far+near)*p,zInv=-2*p;else if(coordinateSystem===WebGPUCoordinateSystem)z=near*p,zInv=-1*p;else throw new Error("THREE.Matrix4.makeOrthographic(): Invalid coordinate system: "+coordinateSystem);return te[0]=2*w,te[4]=0,te[8]=0,te[12]=-x,te[1]=0,te[5]=2*h,te[9]=0,te[13]=-y,te[2]=0,te[6]=0,te[10]=zInv,te[14]=-z,te[3]=0,te[7]=0,te[11]=0,te[15]=1,this}equals(matrix){const te=this.elements,me=matrix.elements;for(let i2=0;i2<16;i2++)if(te[i2]!==me[i2])return!1;return!0}fromArray(array2,offset=0){for(let i2=0;i2<16;i2++)this.elements[i2]=array2[i2+offset];return this}toArray(array2=[],offset=0){const te=this.elements;return array2[offset]=te[0],array2[offset+1]=te[1],array2[offset+2]=te[2],array2[offset+3]=te[3],array2[offset+4]=te[4],array2[offset+5]=te[5],array2[offset+6]=te[6],array2[offset+7]=te[7],array2[offset+8]=te[8],array2[offset+9]=te[9],array2[offset+10]=te[10],array2[offset+11]=te[11],array2[offset+12]=te[12],array2[offset+13]=te[13],array2[offset+14]=te[14],array2[offset+15]=te[15],array2}}const _v1$5=new Vector3,_m1$2=new Matrix4,_zero=new Vector3(0,0,0),_one=new Vector3(1,1,1),_x=new Vector3,_y=new Vector3,_z=new Vector3,_matrix$2=new Matrix4,_quaternion$3=new Quaternion;class Euler{constructor(x=0,y=0,z=0,order=Euler.DEFAULT_ORDER){this.isEuler=!0,this._x=x,this._y=y,this._z=z,this._order=order}get x(){return this._x}set x(value){this._x=value,this._onChangeCallback()}get y(){return this._y}set y(value){this._y=value,this._onChangeCallback()}get z(){return this._z}set z(value){this._z=value,this._onChangeCallback()}get order(){return this._order}set order(value){this._order=value,this._onChangeCallback()}set(x,y,z,order=this._order){return this._x=x,this._y=y,this._z=z,this._order=order,this._onChangeCallback(),this}clone(){return new this.constructor(this._x,this._y,this._z,this._order)}copy(euler){return this._x=euler._x,this._y=euler._y,this._z=euler._z,this._order=euler._order,this._onChangeCallback(),this}setFromRotationMatrix(m,order=this._order,update=!0){const te=m.elements,m11=te[0],m12=te[4],m13=te[8],m21=te[1],m22=te[5],m23=te[9],m31=te[2],m32=te[6],m33=te[10];switch(order){case"XYZ":this._y=Math.asin(clamp$4(m13,-1,1)),Math.abs(m13)<.9999999?(this._x=Math.atan2(-m23,m33),this._z=Math.atan2(-m12,m11)):(this._x=Math.atan2(m32,m22),this._z=0);break;case"YXZ":this._x=Math.asin(-clamp$4(m23,-1,1)),Math.abs(m23)<.9999999?(this._y=Math.atan2(m13,m33),this._z=Math.atan2(m21,m22)):(this._y=Math.atan2(-m31,m11),this._z=0);break;case"ZXY":this._x=Math.asin(clamp$4(m32,-1,1)),Math.abs(m32)<.9999999?(this._y=Math.atan2(-m31,m33),this._z=Math.atan2(-m12,m22)):(this._y=0,this._z=Math.atan2(m21,m11));break;case"ZYX":this._y=Math.asin(-clamp$4(m31,-1,1)),Math.abs(m31)<.9999999?(this._x=Math.atan2(m32,m33),this._z=Math.atan2(m21,m11)):(this._x=0,this._z=Math.atan2(-m12,m22));break;case"YZX":this._z=Math.asin(clamp$4(m21,-1,1)),Math.abs(m21)<.9999999?(this._x=Math.atan2(-m23,m22),this._y=Math.atan2(-m31,m11)):(this._x=0,this._y=Math.atan2(m13,m33));break;case"XZY":this._z=Math.asin(-clamp$4(m12,-1,1)),Math.abs(m12)<.9999999?(this._x=Math.atan2(m32,m22),this._y=Math.atan2(m13,m11)):(this._x=Math.atan2(-m23,m33),this._y=0);break;default:console.warn("THREE.Euler: .setFromRotationMatrix() encountered an unknown order: "+order)}return this._order=order,update===!0&&this._onChangeCallback(),this}setFromQuaternion(q,order,update){return _matrix$2.makeRotationFromQuaternion(q),this.setFromRotationMatrix(_matrix$2,order,update)}setFromVector3(v,order=this._order){return this.set(v.x,v.y,v.z,order)}reorder(newOrder){return _quaternion$3.setFromEuler(this),this.setFromQuaternion(_quaternion$3,newOrder)}equals(euler){return euler._x===this._x&&euler._y===this._y&&euler._z===this._z&&euler._order===this._order}fromArray(array2){return this._x=array2[0],this._y=array2[1],this._z=array2[2],array2[3]!==void 0&&(this._order=array2[3]),this._onChangeCallback(),this}toArray(array2=[],offset=0){return array2[offset]=this._x,array2[offset+1]=this._y,array2[offset+2]=this._z,array2[offset+3]=this._order,array2}_onChange(callback){return this._onChangeCallback=callback,this}_onChangeCallback(){}*[Symbol.iterator](){yield this._x,yield this._y,yield this._z,yield this._order}}Euler.DEFAULT_ORDER="XYZ";class Layers{constructor(){this.mask=1}set(channel){this.mask=(1<<channel|0)>>>0}enable(channel){this.mask|=1<<channel|0}enableAll(){this.mask=-1}toggle(channel){this.mask^=1<<channel|0}disable(channel){this.mask&=~(1<<channel|0)}disableAll(){this.mask=0}test(layers2){return(this.mask&layers2.mask)!==0}isEnabled(channel){return(this.mask&(1<<channel|0))!==0}}let _object3DId=0;const _v1$4=new Vector3,_q1=new Quaternion,_m1$1$1=new Matrix4,_target$1=new Vector3,_position$3=new Vector3,_scale$2=new Vector3,_quaternion$2=new Quaternion,_xAxis=new Vector3(1,0,0),_yAxis=new Vector3(0,1,0),_zAxis=new Vector3(0,0,1),_addedEvent={type:"added"},_removedEvent={type:"removed"},_childaddedEvent={type:"childadded",child:null},_childremovedEvent={type:"childremoved",child:null};class Object3D extends EventDispatcher{constructor(){super(),this.isObject3D=!0,Object.defineProperty(this,"id",{value:_object3DId++}),this.uuid=generateUUID(),this.name="",this.type="Object3D",this.parent=null,this.children=[],this.up=Object3D.DEFAULT_UP.clone();const position=new Vector3,rotation2=new Euler,quaternion=new Quaternion,scale2=new Vector3(1,1,1);function onRotationChange(){quaternion.setFromEuler(rotation2,!1)}function onQuaternionChange(){rotation2.setFromQuaternion(quaternion,void 0,!1)}rotation2._onChange(onRotationChange),quaternion._onChange(onQuaternionChange),Object.defineProperties(this,{position:{configurable:!0,enumerable:!0,value:position},rotation:{configurable:!0,enumerable:!0,value:rotation2},quaternion:{configurable:!0,enumerable:!0,value:quaternion},scale:{configurable:!0,enumerable:!0,value:scale2},modelViewMatrix:{value:new Matrix4},normalMatrix:{value:new Matrix3}}),this.matrix=new Matrix4,this.matrixWorld=new Matrix4,this.matrixAutoUpdate=Object3D.DEFAULT_MATRIX_AUTO_UPDATE,this.matrixWorldAutoUpdate=Object3D.DEFAULT_MATRIX_WORLD_AUTO_UPDATE,this.matrixWorldNeedsUpdate=!1,this.layers=new Layers,this.visible=!0,this.castShadow=!1,this.receiveShadow=!1,this.frustumCulled=!0,this.renderOrder=0,this.animations=[],this.userData={}}onBeforeShadow(){}onAfterShadow(){}onBeforeRender(){}onAfterRender(){}applyMatrix4(matrix){this.matrixAutoUpdate&&this.updateMatrix(),this.matrix.premultiply(matrix),this.matrix.decompose(this.position,this.quaternion,this.scale)}applyQuaternion(q){return this.quaternion.premultiply(q),this}setRotationFromAxisAngle(axis,angle){this.quaternion.setFromAxisAngle(axis,angle)}setRotationFromEuler(euler){this.quaternion.setFromEuler(euler,!0)}setRotationFromMatrix(m){this.quaternion.setFromRotationMatrix(m)}setRotationFromQuaternion(q){this.quaternion.copy(q)}rotateOnAxis(axis,angle){return _q1.setFromAxisAngle(axis,angle),this.quaternion.multiply(_q1),this}rotateOnWorldAxis(axis,angle){return _q1.setFromAxisAngle(axis,angle),this.quaternion.premultiply(_q1),this}rotateX(angle){return this.rotateOnAxis(_xAxis,angle)}rotateY(angle){return this.rotateOnAxis(_yAxis,angle)}rotateZ(angle){return this.rotateOnAxis(_zAxis,angle)}translateOnAxis(axis,distance2){return _v1$4.copy(axis).applyQuaternion(this.quaternion),this.position.add(_v1$4.multiplyScalar(distance2)),this}translateX(distance2){return this.translateOnAxis(_xAxis,distance2)}translateY(distance2){return this.translateOnAxis(_yAxis,distance2)}translateZ(distance2){return this.translateOnAxis(_zAxis,distance2)}localToWorld(vector){return this.updateWorldMatrix(!0,!1),vector.applyMatrix4(this.matrixWorld)}worldToLocal(vector){return this.updateWorldMatrix(!0,!1),vector.applyMatrix4(_m1$1$1.copy(this.matrixWorld).invert())}lookAt(x,y,z){x.isVector3?_target$1.copy(x):_target$1.set(x,y,z);const parent=this.parent;this.updateWorldMatrix(!0,!1),_position$3.setFromMatrixPosition(this.matrixWorld),this.isCamera||this.isLight?_m1$1$1.lookAt(_position$3,_target$1,this.up):_m1$1$1.lookAt(_target$1,_position$3,this.up),this.quaternion.setFromRotationMatrix(_m1$1$1),parent&&(_m1$1$1.extractRotation(parent.matrixWorld),_q1.setFromRotationMatrix(_m1$1$1),this.quaternion.premultiply(_q1.invert()))}add(object){if(arguments.length>1){for(let i2=0;i2<arguments.length;i2++)this.add(arguments[i2]);return this}return object===this?(console.error("THREE.Object3D.add: object can't be added as a child of itself.",object),this):(object&&object.isObject3D?(object.removeFromParent(),object.parent=this,this.children.push(object),object.dispatchEvent(_addedEvent),_childaddedEvent.child=object,this.dispatchEvent(_childaddedEvent),_childaddedEvent.child=null):console.error("THREE.Object3D.add: object not an instance of THREE.Object3D.",object),this)}remove(object){if(arguments.length>1){for(let i2=0;i2<arguments.length;i2++)this.remove(arguments[i2]);return this}const index=this.children.indexOf(object);return index!==-1&&(object.parent=null,this.children.splice(index,1),object.dispatchEvent(_removedEvent),_childremovedEvent.child=object,this.dispatchEvent(_childremovedEvent),_childremovedEvent.child=null),this}removeFromParent(){const parent=this.parent;return parent!==null&&parent.remove(this),this}clear(){return this.remove(...this.children)}attach(object){return this.updateWorldMatrix(!0,!1),_m1$1$1.copy(this.matrixWorld).invert(),object.parent!==null&&(object.parent.updateWorldMatrix(!0,!1),_m1$1$1.multiply(object.parent.matrixWorld)),object.applyMatrix4(_m1$1$1),object.removeFromParent(),object.parent=this,this.children.push(object),object.updateWorldMatrix(!1,!0),object.dispatchEvent(_addedEvent),_childaddedEvent.child=object,this.dispatchEvent(_childaddedEvent),_childaddedEvent.child=null,this}getObjectById(id){return this.getObjectByProperty("id",id)}getObjectByName(name){return this.getObjectByProperty("name",name)}getObjectByProperty(name,value){if(this[name]===value)return this;for(let i2=0,l2=this.children.length;i2<l2;i2++){const object=this.children[i2].getObjectByProperty(name,value);if(object!==void 0)return object}}getObjectsByProperty(name,value,result=[]){this[name]===value&&result.push(this);const children=this.children;for(let i2=0,l2=children.length;i2<l2;i2++)children[i2].getObjectsByProperty(name,value,result);return result}getWorldPosition(target){return this.updateWorldMatrix(!0,!1),target.setFromMatrixPosition(this.matrixWorld)}getWorldQuaternion(target){return this.updateWorldMatrix(!0,!1),this.matrixWorld.decompose(_position$3,target,_scale$2),target}getWorldScale(target){return this.updateWorldMatrix(!0,!1),this.matrixWorld.decompose(_position$3,_quaternion$2,target),target}getWorldDirection(target){this.updateWorldMatrix(!0,!1);const e2=this.matrixWorld.elements;return target.set(e2[8],e2[9],e2[10]).normalize()}raycast(){}traverse(callback){callback(this);const children=this.children;for(let i2=0,l2=children.length;i2<l2;i2++)children[i2].traverse(callback)}traverseVisible(callback){if(this.visible===!1)return;callback(this);const children=this.children;for(let i2=0,l2=children.length;i2<l2;i2++)children[i2].traverseVisible(callback)}traverseAncestors(callback){const parent=this.parent;parent!==null&&(callback(parent),parent.traverseAncestors(callback))}updateMatrix(){this.matrix.compose(this.position,this.quaternion,this.scale),this.matrixWorldNeedsUpdate=!0}updateMatrixWorld(force){this.matrixAutoUpdate&&this.updateMatrix(),(this.matrixWorldNeedsUpdate||force)&&(this.matrixWorldAutoUpdate===!0&&(this.parent===null?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix)),this.matrixWorldNeedsUpdate=!1,force=!0);const children=this.children;for(let i2=0,l2=children.length;i2<l2;i2++)children[i2].updateMatrixWorld(force)}updateWorldMatrix(updateParents,updateChildren){const parent=this.parent;if(updateParents===!0&&parent!==null&&parent.updateWorldMatrix(!0,!1),this.matrixAutoUpdate&&this.updateMatrix(),this.matrixWorldAutoUpdate===!0&&(this.parent===null?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix)),updateChildren===!0){const children=this.children;for(let i2=0,l2=children.length;i2<l2;i2++)children[i2].updateWorldMatrix(!1,!0)}}toJSON(meta){const isRootObject=meta===void 0||typeof meta=="string",output2={};isRootObject&&(meta={geometries:{},materials:{},textures:{},images:{},shapes:{},skeletons:{},animations:{},nodes:{}},output2.metadata={version:4.6,type:"Object",generator:"Object3D.toJSON"});const object={};object.uuid=this.uuid,object.type=this.type,this.name!==""&&(object.name=this.name),this.castShadow===!0&&(object.castShadow=!0),this.receiveShadow===!0&&(object.receiveShadow=!0),this.visible===!1&&(object.visible=!1),this.frustumCulled===!1&&(object.frustumCulled=!1),this.renderOrder!==0&&(object.renderOrder=this.renderOrder),Object.keys(this.userData).length>0&&(object.userData=this.userData),object.layers=this.layers.mask,object.matrix=this.matrix.toArray(),object.up=this.up.toArray(),this.matrixAutoUpdate===!1&&(object.matrixAutoUpdate=!1),this.isInstancedMesh&&(object.type="InstancedMesh",object.count=this.count,object.instanceMatrix=this.instanceMatrix.toJSON(),this.instanceColor!==null&&(object.instanceColor=this.instanceColor.toJSON())),this.isBatchedMesh&&(object.type="BatchedMesh",object.perObjectFrustumCulled=this.perObjectFrustumCulled,object.sortObjects=this.sortObjects,object.drawRanges=this._drawRanges,object.reservedRanges=this._reservedRanges,object.visibility=this._visibility,object.active=this._active,object.bounds=this._bounds.map(bound=>({boxInitialized:bound.boxInitialized,boxMin:bound.box.min.toArray(),boxMax:bound.box.max.toArray(),sphereInitialized:bound.sphereInitialized,sphereRadius:bound.sphere.radius,sphereCenter:bound.sphere.center.toArray()})),object.maxInstanceCount=this._maxInstanceCount,object.maxVertexCount=this._maxVertexCount,object.maxIndexCount=this._maxIndexCount,object.geometryInitialized=this._geometryInitialized,object.geometryCount=this._geometryCount,object.matricesTexture=this._matricesTexture.toJSON(meta),this._colorsTexture!==null&&(object.colorsTexture=this._colorsTexture.toJSON(meta)),this.boundingSphere!==null&&(object.boundingSphere={center:object.boundingSphere.center.toArray(),radius:object.boundingSphere.radius}),this.boundingBox!==null&&(object.boundingBox={min:object.boundingBox.min.toArray(),max:object.boundingBox.max.toArray()}));function serialize(library,element2){return library[element2.uuid]===void 0&&(library[element2.uuid]=element2.toJSON(meta)),element2.uuid}if(this.isScene)this.background&&(this.background.isColor?object.background=this.background.toJSON():this.background.isTexture&&(object.background=this.background.toJSON(meta).uuid)),this.environment&&this.environment.isTexture&&this.environment.isRenderTargetTexture!==!0&&(object.environment=this.environment.toJSON(meta).uuid);else if(this.isMesh||this.isLine||this.isPoints){object.geometry=serialize(meta.geometries,this.geometry);const parameters=this.geometry.parameters;if(parameters!==void 0&&parameters.shapes!==void 0){const shapes=parameters.shapes;if(Array.isArray(shapes))for(let i2=0,l2=shapes.length;i2<l2;i2++){const shape=shapes[i2];serialize(meta.shapes,shape)}else serialize(meta.shapes,shapes)}}if(this.isSkinnedMesh&&(object.bindMode=this.bindMode,object.bindMatrix=this.bindMatrix.toArray(),this.skeleton!==void 0&&(serialize(meta.skeletons,this.skeleton),object.skeleton=this.skeleton.uuid)),this.material!==void 0)if(Array.isArray(this.material)){const uuids=[];for(let i2=0,l2=this.material.length;i2<l2;i2++)uuids.push(serialize(meta.materials,this.material[i2]));object.material=uuids}else object.material=serialize(meta.materials,this.material);if(this.children.length>0){object.children=[];for(let i2=0;i2<this.children.length;i2++)object.children.push(this.children[i2].toJSON(meta).object)}if(this.animations.length>0){object.animations=[];for(let i2=0;i2<this.animations.length;i2++){const animation=this.animations[i2];object.animations.push(serialize(meta.animations,animation))}}if(isRootObject){const geometries=extractFromCache(meta.geometries),materials=extractFromCache(meta.materials),textures=extractFromCache(meta.textures),images=extractFromCache(meta.images),shapes=extractFromCache(meta.shapes),skeletons=extractFromCache(meta.skeletons),animations=extractFromCache(meta.animations),nodes=extractFromCache(meta.nodes);geometries.length>0&&(output2.geometries=geometries),materials.length>0&&(output2.materials=materials),textures.length>0&&(output2.textures=textures),images.length>0&&(output2.images=images),shapes.length>0&&(output2.shapes=shapes),skeletons.length>0&&(output2.skeletons=skeletons),animations.length>0&&(output2.animations=animations),nodes.length>0&&(output2.nodes=nodes)}return output2.object=object,output2;function extractFromCache(cache2){const values=[];for(const key2 in cache2){const data=cache2[key2];delete data.metadata,values.push(data)}return values}}clone(recursive){return new this.constructor().copy(this,recursive)}copy(source,recursive=!0){if(this.name=source.name,this.up.copy(source.up),this.position.copy(source.position),this.rotation.order=source.rotation.order,this.quaternion.copy(source.quaternion),this.scale.copy(source.scale),this.matrix.copy(source.matrix),this.matrixWorld.copy(source.matrixWorld),this.matrixAutoUpdate=source.matrixAutoUpdate,this.matrixWorldAutoUpdate=source.matrixWorldAutoUpdate,this.matrixWorldNeedsUpdate=source.matrixWorldNeedsUpdate,this.layers.mask=source.layers.mask,this.visible=source.visible,this.castShadow=source.castShadow,this.receiveShadow=source.receiveShadow,this.frustumCulled=source.frustumCulled,this.renderOrder=source.renderOrder,this.animations=source.animations.slice(),this.userData=JSON.parse(JSON.stringify(source.userData)),recursive===!0)for(let i2=0;i2<source.children.length;i2++){const child=source.children[i2];this.add(child.clone())}return this}}Object3D.DEFAULT_UP=new Vector3(0,1,0);Object3D.DEFAULT_MATRIX_AUTO_UPDATE=!0;Object3D.DEFAULT_MATRIX_WORLD_AUTO_UPDATE=!0;const _v0$1=new Vector3,_v1$3=new Vector3,_v2$2=new Vector3,_v3$2=new Vector3,_vab=new Vector3,_vac=new Vector3,_vbc=new Vector3,_vap=new Vector3,_vbp=new Vector3,_vcp=new Vector3,_v40=new Vector4,_v41=new Vector4,_v42=new Vector4;class Triangle{constructor(a2=new Vector3,b=new Vector3,c2=new Vector3){this.a=a2,this.b=b,this.c=c2}static getNormal(a2,b,c2,target){target.subVectors(c2,b),_v0$1.subVectors(a2,b),target.cross(_v0$1);const targetLengthSq=target.lengthSq();return targetLengthSq>0?target.multiplyScalar(1/Math.sqrt(targetLengthSq)):target.set(0,0,0)}static getBarycoord(point,a2,b,c2,target){_v0$1.subVectors(c2,a2),_v1$3.subVectors(b,a2),_v2$2.subVectors(point,a2);const dot00=_v0$1.dot(_v0$1),dot01=_v0$1.dot(_v1$3),dot02=_v0$1.dot(_v2$2),dot11=_v1$3.dot(_v1$3),dot12=_v1$3.dot(_v2$2),denom=dot00*dot11-dot01*dot01;if(denom===0)return target.set(0,0,0),null;const invDenom=1/denom,u=(dot11*dot02-dot01*dot12)*invDenom,v=(dot00*dot12-dot01*dot02)*invDenom;return target.set(1-u-v,v,u)}static containsPoint(point,a2,b,c2){return this.getBarycoord(point,a2,b,c2,_v3$2)===null?!1:_v3$2.x>=0&&_v3$2.y>=0&&_v3$2.x+_v3$2.y<=1}static getInterpolation(point,p1,p2,p3,v1,v2,v3,target){return this.getBarycoord(point,p1,p2,p3,_v3$2)===null?(target.x=0,target.y=0,"z"in target&&(target.z=0),"w"in target&&(target.w=0),null):(target.setScalar(0),target.addScaledVector(v1,_v3$2.x),target.addScaledVector(v2,_v3$2.y),target.addScaledVector(v3,_v3$2.z),target)}static getInterpolatedAttribute(attr,i1,i2,i3,barycoord,target){return _v40.setScalar(0),_v41.setScalar(0),_v42.setScalar(0),_v40.fromBufferAttribute(attr,i1),_v41.fromBufferAttribute(attr,i2),_v42.fromBufferAttribute(attr,i3),target.setScalar(0),target.addScaledVector(_v40,barycoord.x),target.addScaledVector(_v41,barycoord.y),target.addScaledVector(_v42,barycoord.z),target}static isFrontFacing(a2,b,c2,direction){return _v0$1.subVectors(c2,b),_v1$3.subVectors(a2,b),_v0$1.cross(_v1$3).dot(direction)<0}set(a2,b,c2){return this.a.copy(a2),this.b.copy(b),this.c.copy(c2),this}setFromPointsAndIndices(points,i0,i1,i2){return this.a.copy(points[i0]),this.b.copy(points[i1]),this.c.copy(points[i2]),this}setFromAttributeAndIndices(attribute2,i0,i1,i2){return this.a.fromBufferAttribute(attribute2,i0),this.b.fromBufferAttribute(attribute2,i1),this.c.fromBufferAttribute(attribute2,i2),this}clone(){return new this.constructor().copy(this)}copy(triangle){return this.a.copy(triangle.a),this.b.copy(triangle.b),this.c.copy(triangle.c),this}getArea(){return _v0$1.subVectors(this.c,this.b),_v1$3.subVectors(this.a,this.b),_v0$1.cross(_v1$3).length()*.5}getMidpoint(target){return target.addVectors(this.a,this.b).add(this.c).multiplyScalar(1/3)}getNormal(target){return Triangle.getNormal(this.a,this.b,this.c,target)}getPlane(target){return target.setFromCoplanarPoints(this.a,this.b,this.c)}getBarycoord(point,target){return Triangle.getBarycoord(point,this.a,this.b,this.c,target)}getInterpolation(point,v1,v2,v3,target){return Triangle.getInterpolation(point,this.a,this.b,this.c,v1,v2,v3,target)}containsPoint(point){return Triangle.containsPoint(point,this.a,this.b,this.c)}isFrontFacing(direction){return Triangle.isFrontFacing(this.a,this.b,this.c,direction)}intersectsBox(box){return box.intersectsTriangle(this)}closestPointToPoint(p,target){const a2=this.a,b=this.b,c2=this.c;let v,w;_vab.subVectors(b,a2),_vac.subVectors(c2,a2),_vap.subVectors(p,a2);const d1=_vab.dot(_vap),d2=_vac.dot(_vap);if(d1<=0&&d2<=0)return target.copy(a2);_vbp.subVectors(p,b);const d3=_vab.dot(_vbp),d4=_vac.dot(_vbp);if(d3>=0&&d4<=d3)return target.copy(b);const vc=d1*d4-d3*d2;if(vc<=0&&d1>=0&&d3<=0)return v=d1/(d1-d3),target.copy(a2).addScaledVector(_vab,v);_vcp.subVectors(p,c2);const d5=_vab.dot(_vcp),d6=_vac.dot(_vcp);if(d6>=0&&d5<=d6)return target.copy(c2);const vb=d5*d2-d1*d6;if(vb<=0&&d2>=0&&d6<=0)return w=d2/(d2-d6),target.copy(a2).addScaledVector(_vac,w);const va=d3*d6-d5*d4;if(va<=0&&d4-d3>=0&&d5-d6>=0)return _vbc.subVectors(c2,b),w=(d4-d3)/(d4-d3+(d5-d6)),target.copy(b).addScaledVector(_vbc,w);const denom=1/(va+vb+vc);return v=vb*denom,w=vc*denom,target.copy(a2).addScaledVector(_vab,v).addScaledVector(_vac,w)}equals(triangle){return triangle.a.equals(this.a)&&triangle.b.equals(this.b)&&triangle.c.equals(this.c)}}const _colorKeywords={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074},_hslA={h:0,s:0,l:0},_hslB={h:0,s:0,l:0};function hue2rgb$1(p,q,t2){return t2<0&&(t2+=1),t2>1&&(t2-=1),t2<1/6?p+(q-p)*6*t2:t2<1/2?q:t2<2/3?p+(q-p)*6*(2/3-t2):p}class Color{constructor(r2,g,b){return this.isColor=!0,this.r=1,this.g=1,this.b=1,this.set(r2,g,b)}set(r2,g,b){if(g===void 0&&b===void 0){const value=r2;value&&value.isColor?this.copy(value):typeof value=="number"?this.setHex(value):typeof value=="string"&&this.setStyle(value)}else this.setRGB(r2,g,b);return this}setScalar(scalar){return this.r=scalar,this.g=scalar,this.b=scalar,this}setHex(hex,colorSpace=SRGBColorSpace){return hex=Math.floor(hex),this.r=(hex>>16&255)/255,this.g=(hex>>8&255)/255,this.b=(hex&255)/255,ColorManagement.toWorkingColorSpace(this,colorSpace),this}setRGB(r2,g,b,colorSpace=ColorManagement.workingColorSpace){return this.r=r2,this.g=g,this.b=b,ColorManagement.toWorkingColorSpace(this,colorSpace),this}setHSL(h,s2,l2,colorSpace=ColorManagement.workingColorSpace){if(h=euclideanModulo(h,1),s2=clamp$4(s2,0,1),l2=clamp$4(l2,0,1),s2===0)this.r=this.g=this.b=l2;else{const p=l2<=.5?l2*(1+s2):l2+s2-l2*s2,q=2*l2-p;this.r=hue2rgb$1(q,p,h+1/3),this.g=hue2rgb$1(q,p,h),this.b=hue2rgb$1(q,p,h-1/3)}return ColorManagement.toWorkingColorSpace(this,colorSpace),this}setStyle(style,colorSpace=SRGBColorSpace){function handleAlpha(string2){string2!==void 0&&parseFloat(string2)<1&&console.warn("THREE.Color: Alpha component of "+style+" will be ignored.")}let m;if(m=/^(\w+)\(([^\)]*)\)/.exec(style)){let color2;const name=m[1],components=m[2];switch(name){case"rgb":case"rgba":if(color2=/^\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(components))return handleAlpha(color2[4]),this.setRGB(Math.min(255,parseInt(color2[1],10))/255,Math.min(255,parseInt(color2[2],10))/255,Math.min(255,parseInt(color2[3],10))/255,colorSpace);if(color2=/^\s*(\d+)\%\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(components))return handleAlpha(color2[4]),this.setRGB(Math.min(100,parseInt(color2[1],10))/100,Math.min(100,parseInt(color2[2],10))/100,Math.min(100,parseInt(color2[3],10))/100,colorSpace);break;case"hsl":case"hsla":if(color2=/^\s*(\d*\.?\d+)\s*,\s*(\d*\.?\d+)\%\s*,\s*(\d*\.?\d+)\%\s*(?:,\s*(\d*\.?\d+)\s*)?$/.exec(components))return handleAlpha(color2[4]),this.setHSL(parseFloat(color2[1])/360,parseFloat(color2[2])/100,parseFloat(color2[3])/100,colorSpace);break;default:console.warn("THREE.Color: Unknown color model "+style)}}else if(m=/^\#([A-Fa-f\d]+)$/.exec(style)){const hex=m[1],size=hex.length;if(size===3)return this.setRGB(parseInt(hex.charAt(0),16)/15,parseInt(hex.charAt(1),16)/15,parseInt(hex.charAt(2),16)/15,colorSpace);if(size===6)return this.setHex(parseInt(hex,16),colorSpace);console.warn("THREE.Color: Invalid hex color "+style)}else if(style&&style.length>0)return this.setColorName(style,colorSpace);return this}setColorName(style,colorSpace=SRGBColorSpace){const hex=_colorKeywords[style.toLowerCase()];return hex!==void 0?this.setHex(hex,colorSpace):console.warn("THREE.Color: Unknown color "+style),this}clone(){return new this.constructor(this.r,this.g,this.b)}copy(color2){return this.r=color2.r,this.g=color2.g,this.b=color2.b,this}copySRGBToLinear(color2){return this.r=SRGBToLinear(color2.r),this.g=SRGBToLinear(color2.g),this.b=SRGBToLinear(color2.b),this}copyLinearToSRGB(color2){return this.r=LinearToSRGB(color2.r),this.g=LinearToSRGB(color2.g),this.b=LinearToSRGB(color2.b),this}convertSRGBToLinear(){return this.copySRGBToLinear(this),this}convertLinearToSRGB(){return this.copyLinearToSRGB(this),this}getHex(colorSpace=SRGBColorSpace){return ColorManagement.fromWorkingColorSpace(_color.copy(this),colorSpace),Math.round(clamp$4(_color.r*255,0,255))*65536+Math.round(clamp$4(_color.g*255,0,255))*256+Math.round(clamp$4(_color.b*255,0,255))}getHexString(colorSpace=SRGBColorSpace){return("000000"+this.getHex(colorSpace).toString(16)).slice(-6)}getHSL(target,colorSpace=ColorManagement.workingColorSpace){ColorManagement.fromWorkingColorSpace(_color.copy(this),colorSpace);const r2=_color.r,g=_color.g,b=_color.b,max2=Math.max(r2,g,b),min2=Math.min(r2,g,b);let hue2,saturation2;const lightness=(min2+max2)/2;if(min2===max2)hue2=0,saturation2=0;else{const delta=max2-min2;switch(saturation2=lightness<=.5?delta/(max2+min2):delta/(2-max2-min2),max2){case r2:hue2=(g-b)/delta+(g<b?6:0);break;case g:hue2=(b-r2)/delta+2;break;case b:hue2=(r2-g)/delta+4;break}hue2/=6}return target.h=hue2,target.s=saturation2,target.l=lightness,target}getRGB(target,colorSpace=ColorManagement.workingColorSpace){return ColorManagement.fromWorkingColorSpace(_color.copy(this),colorSpace),target.r=_color.r,target.g=_color.g,target.b=_color.b,target}getStyle(colorSpace=SRGBColorSpace){ColorManagement.fromWorkingColorSpace(_color.copy(this),colorSpace);const r2=_color.r,g=_color.g,b=_color.b;return colorSpace!==SRGBColorSpace?`color(${colorSpace} ${r2.toFixed(3)} ${g.toFixed(3)} ${b.toFixed(3)})`:`rgb(${Math.round(r2*255)},${Math.round(g*255)},${Math.round(b*255)})`}offsetHSL(h,s2,l2){return this.getHSL(_hslA),this.setHSL(_hslA.h+h,_hslA.s+s2,_hslA.l+l2)}add(color2){return this.r+=color2.r,this.g+=color2.g,this.b+=color2.b,this}addColors(color1,color2){return this.r=color1.r+color2.r,this.g=color1.g+color2.g,this.b=color1.b+color2.b,this}addScalar(s2){return this.r+=s2,this.g+=s2,this.b+=s2,this}sub(color2){return this.r=Math.max(0,this.r-color2.r),this.g=Math.max(0,this.g-color2.g),this.b=Math.max(0,this.b-color2.b),this}multiply(color2){return this.r*=color2.r,this.g*=color2.g,this.b*=color2.b,this}multiplyScalar(s2){return this.r*=s2,this.g*=s2,this.b*=s2,this}lerp(color2,alpha){return this.r+=(color2.r-this.r)*alpha,this.g+=(color2.g-this.g)*alpha,this.b+=(color2.b-this.b)*alpha,this}lerpColors(color1,color2,alpha){return this.r=color1.r+(color2.r-color1.r)*alpha,this.g=color1.g+(color2.g-color1.g)*alpha,this.b=color1.b+(color2.b-color1.b)*alpha,this}lerpHSL(color2,alpha){this.getHSL(_hslA),color2.getHSL(_hslB);const h=lerp$2(_hslA.h,_hslB.h,alpha),s2=lerp$2(_hslA.s,_hslB.s,alpha),l2=lerp$2(_hslA.l,_hslB.l,alpha);return this.setHSL(h,s2,l2),this}setFromVector3(v){return this.r=v.x,this.g=v.y,this.b=v.z,this}applyMatrix3(m){const r2=this.r,g=this.g,b=this.b,e2=m.elements;return this.r=e2[0]*r2+e2[3]*g+e2[6]*b,this.g=e2[1]*r2+e2[4]*g+e2[7]*b,this.b=e2[2]*r2+e2[5]*g+e2[8]*b,this}equals(c2){return c2.r===this.r&&c2.g===this.g&&c2.b===this.b}fromArray(array2,offset=0){return this.r=array2[offset],this.g=array2[offset+1],this.b=array2[offset+2],this}toArray(array2=[],offset=0){return array2[offset]=this.r,array2[offset+1]=this.g,array2[offset+2]=this.b,array2}fromBufferAttribute(attribute2,index){return this.r=attribute2.getX(index),this.g=attribute2.getY(index),this.b=attribute2.getZ(index),this}toJSON(){return this.getHex()}*[Symbol.iterator](){yield this.r,yield this.g,yield this.b}}const _color=new Color;Color.NAMES=_colorKeywords;let _materialId=0;class Material extends EventDispatcher{constructor(){super(),this.isMaterial=!0,Object.defineProperty(this,"id",{value:_materialId++}),this.uuid=generateUUID(),this.name="",this.type="Material",this.blending=NormalBlending,this.side=FrontSide,this.vertexColors=!1,this.opacity=1,this.transparent=!1,this.alphaHash=!1,this.blendSrc=SrcAlphaFactor,this.blendDst=OneMinusSrcAlphaFactor,this.blendEquation=AddEquation,this.blendSrcAlpha=null,this.blendDstAlpha=null,this.blendEquationAlpha=null,this.blendColor=new Color(0,0,0),this.blendAlpha=0,this.depthFunc=LessEqualDepth,this.depthTest=!0,this.depthWrite=!0,this.stencilWriteMask=255,this.stencilFunc=AlwaysStencilFunc,this.stencilRef=0,this.stencilFuncMask=255,this.stencilFail=KeepStencilOp,this.stencilZFail=KeepStencilOp,this.stencilZPass=KeepStencilOp,this.stencilWrite=!1,this.clippingPlanes=null,this.clipIntersection=!1,this.clipShadows=!1,this.shadowSide=null,this.colorWrite=!0,this.precision=null,this.polygonOffset=!1,this.polygonOffsetFactor=0,this.polygonOffsetUnits=0,this.dithering=!1,this.alphaToCoverage=!1,this.premultipliedAlpha=!1,this.forceSinglePass=!1,this.visible=!0,this.toneMapped=!0,this.userData={},this.version=0,this._alphaTest=0}get alphaTest(){return this._alphaTest}set alphaTest(value){this._alphaTest>0!=value>0&&this.version++,this._alphaTest=value}onBeforeRender(){}onBeforeCompile(){}customProgramCacheKey(){return this.onBeforeCompile.toString()}setValues(values){if(values!==void 0)for(const key2 in values){const newValue=values[key2];if(newValue===void 0){console.warn(`THREE.Material: parameter '${key2}' has value of undefined.`);continue}const currentValue=this[key2];if(currentValue===void 0){console.warn(`THREE.Material: '${key2}' is not a property of THREE.${this.type}.`);continue}currentValue&&currentValue.isColor?currentValue.set(newValue):currentValue&&currentValue.isVector3&&newValue&&newValue.isVector3?currentValue.copy(newValue):this[key2]=newValue}}toJSON(meta){const isRootObject=meta===void 0||typeof meta=="string";isRootObject&&(meta={textures:{},images:{}});const data={metadata:{version:4.6,type:"Material",generator:"Material.toJSON"}};data.uuid=this.uuid,data.type=this.type,this.name!==""&&(data.name=this.name),this.color&&this.color.isColor&&(data.color=this.color.getHex()),this.roughness!==void 0&&(data.roughness=this.roughness),this.metalness!==void 0&&(data.metalness=this.metalness),this.sheen!==void 0&&(data.sheen=this.sheen),this.sheenColor&&this.sheenColor.isColor&&(data.sheenColor=this.sheenColor.getHex()),this.sheenRoughness!==void 0&&(data.sheenRoughness=this.sheenRoughness),this.emissive&&this.emissive.isColor&&(data.emissive=this.emissive.getHex()),this.emissiveIntensity!==void 0&&this.emissiveIntensity!==1&&(data.emissiveIntensity=this.emissiveIntensity),this.specular&&this.specular.isColor&&(data.specular=this.specular.getHex()),this.specularIntensity!==void 0&&(data.specularIntensity=this.specularIntensity),this.specularColor&&this.specularColor.isColor&&(data.specularColor=this.specularColor.getHex()),this.shininess!==void 0&&(data.shininess=this.shininess),this.clearcoat!==void 0&&(data.clearcoat=this.clearcoat),this.clearcoatRoughness!==void 0&&(data.clearcoatRoughness=this.clearcoatRoughness),this.clearcoatMap&&this.clearcoatMap.isTexture&&(data.clearcoatMap=this.clearcoatMap.toJSON(meta).uuid),this.clearcoatRoughnessMap&&this.clearcoatRoughnessMap.isTexture&&(data.clearcoatRoughnessMap=this.clearcoatRoughnessMap.toJSON(meta).uuid),this.clearcoatNormalMap&&this.clearcoatNormalMap.isTexture&&(data.clearcoatNormalMap=this.clearcoatNormalMap.toJSON(meta).uuid,data.clearcoatNormalScale=this.clearcoatNormalScale.toArray()),this.dispersion!==void 0&&(data.dispersion=this.dispersion),this.iridescence!==void 0&&(data.iridescence=this.iridescence),this.iridescenceIOR!==void 0&&(data.iridescenceIOR=this.iridescenceIOR),this.iridescenceThicknessRange!==void 0&&(data.iridescenceThicknessRange=this.iridescenceThicknessRange),this.iridescenceMap&&this.iridescenceMap.isTexture&&(data.iridescenceMap=this.iridescenceMap.toJSON(meta).uuid),this.iridescenceThicknessMap&&this.iridescenceThicknessMap.isTexture&&(data.iridescenceThicknessMap=this.iridescenceThicknessMap.toJSON(meta).uuid),this.anisotropy!==void 0&&(data.anisotropy=this.anisotropy),this.anisotropyRotation!==void 0&&(data.anisotropyRotation=this.anisotropyRotation),this.anisotropyMap&&this.anisotropyMap.isTexture&&(data.anisotropyMap=this.anisotropyMap.toJSON(meta).uuid),this.map&&this.map.isTexture&&(data.map=this.map.toJSON(meta).uuid),this.matcap&&this.matcap.isTexture&&(data.matcap=this.matcap.toJSON(meta).uuid),this.alphaMap&&this.alphaMap.isTexture&&(data.alphaMap=this.alphaMap.toJSON(meta).uuid),this.lightMap&&this.lightMap.isTexture&&(data.lightMap=this.lightMap.toJSON(meta).uuid,data.lightMapIntensity=this.lightMapIntensity),this.aoMap&&this.aoMap.isTexture&&(data.aoMap=this.aoMap.toJSON(meta).uuid,data.aoMapIntensity=this.aoMapIntensity),this.bumpMap&&this.bumpMap.isTexture&&(data.bumpMap=this.bumpMap.toJSON(meta).uuid,data.bumpScale=this.bumpScale),this.normalMap&&this.normalMap.isTexture&&(data.normalMap=this.normalMap.toJSON(meta).uuid,data.normalMapType=this.normalMapType,data.normalScale=this.normalScale.toArray()),this.displacementMap&&this.displacementMap.isTexture&&(data.displacementMap=this.displacementMap.toJSON(meta).uuid,data.displacementScale=this.displacementScale,data.displacementBias=this.displacementBias),this.roughnessMap&&this.roughnessMap.isTexture&&(data.roughnessMap=this.roughnessMap.toJSON(meta).uuid),this.metalnessMap&&this.metalnessMap.isTexture&&(data.metalnessMap=this.metalnessMap.toJSON(meta).uuid),this.emissiveMap&&this.emissiveMap.isTexture&&(data.emissiveMap=this.emissiveMap.toJSON(meta).uuid),this.specularMap&&this.specularMap.isTexture&&(data.specularMap=this.specularMap.toJSON(meta).uuid),this.specularIntensityMap&&this.specularIntensityMap.isTexture&&(data.specularIntensityMap=this.specularIntensityMap.toJSON(meta).uuid),this.specularColorMap&&this.specularColorMap.isTexture&&(data.specularColorMap=this.specularColorMap.toJSON(meta).uuid),this.envMap&&this.envMap.isTexture&&(data.envMap=this.envMap.toJSON(meta).uuid,this.combine!==void 0&&(data.combine=this.combine)),this.envMapRotation!==void 0&&(data.envMapRotation=this.envMapRotation.toArray()),this.envMapIntensity!==void 0&&(data.envMapIntensity=this.envMapIntensity),this.reflectivity!==void 0&&(data.reflectivity=this.reflectivity),this.refractionRatio!==void 0&&(data.refractionRatio=this.refractionRatio),this.gradientMap&&this.gradientMap.isTexture&&(data.gradientMap=this.gradientMap.toJSON(meta).uuid),this.transmission!==void 0&&(data.transmission=this.transmission),this.transmissionMap&&this.transmissionMap.isTexture&&(data.transmissionMap=this.transmissionMap.toJSON(meta).uuid),this.thickness!==void 0&&(data.thickness=this.thickness),this.thicknessMap&&this.thicknessMap.isTexture&&(data.thicknessMap=this.thicknessMap.toJSON(meta).uuid),this.attenuationDistance!==void 0&&this.attenuationDistance!==1/0&&(data.attenuationDistance=this.attenuationDistance),this.attenuationColor!==void 0&&(data.attenuationColor=this.attenuationColor.getHex()),this.size!==void 0&&(data.size=this.size),this.shadowSide!==null&&(data.shadowSide=this.shadowSide),this.sizeAttenuation!==void 0&&(data.sizeAttenuation=this.sizeAttenuation),this.blending!==NormalBlending&&(data.blending=this.blending),this.side!==FrontSide&&(data.side=this.side),this.vertexColors===!0&&(data.vertexColors=!0),this.opacity<1&&(data.opacity=this.opacity),this.transparent===!0&&(data.transparent=!0),this.blendSrc!==SrcAlphaFactor&&(data.blendSrc=this.blendSrc),this.blendDst!==OneMinusSrcAlphaFactor&&(data.blendDst=this.blendDst),this.blendEquation!==AddEquation&&(data.blendEquation=this.blendEquation),this.blendSrcAlpha!==null&&(data.blendSrcAlpha=this.blendSrcAlpha),this.blendDstAlpha!==null&&(data.blendDstAlpha=this.blendDstAlpha),this.blendEquationAlpha!==null&&(data.blendEquationAlpha=this.blendEquationAlpha),this.blendColor&&this.blendColor.isColor&&(data.blendColor=this.blendColor.getHex()),this.blendAlpha!==0&&(data.blendAlpha=this.blendAlpha),this.depthFunc!==LessEqualDepth&&(data.depthFunc=this.depthFunc),this.depthTest===!1&&(data.depthTest=this.depthTest),this.depthWrite===!1&&(data.depthWrite=this.depthWrite),this.colorWrite===!1&&(data.colorWrite=this.colorWrite),this.stencilWriteMask!==255&&(data.stencilWriteMask=this.stencilWriteMask),this.stencilFunc!==AlwaysStencilFunc&&(data.stencilFunc=this.stencilFunc),this.stencilRef!==0&&(data.stencilRef=this.stencilRef),this.stencilFuncMask!==255&&(data.stencilFuncMask=this.stencilFuncMask),this.stencilFail!==KeepStencilOp&&(data.stencilFail=this.stencilFail),this.stencilZFail!==KeepStencilOp&&(data.stencilZFail=this.stencilZFail),this.stencilZPass!==KeepStencilOp&&(data.stencilZPass=this.stencilZPass),this.stencilWrite===!0&&(data.stencilWrite=this.stencilWrite),this.rotation!==void 0&&this.rotation!==0&&(data.rotation=this.rotation),this.polygonOffset===!0&&(data.polygonOffset=!0),this.polygonOffsetFactor!==0&&(data.polygonOffsetFactor=this.polygonOffsetFactor),this.polygonOffsetUnits!==0&&(data.polygonOffsetUnits=this.polygonOffsetUnits),this.linewidth!==void 0&&this.linewidth!==1&&(data.linewidth=this.linewidth),this.dashSize!==void 0&&(data.dashSize=this.dashSize),this.gapSize!==void 0&&(data.gapSize=this.gapSize),this.scale!==void 0&&(data.scale=this.scale),this.dithering===!0&&(data.dithering=!0),this.alphaTest>0&&(data.alphaTest=this.alphaTest),this.alphaHash===!0&&(data.alphaHash=!0),this.alphaToCoverage===!0&&(data.alphaToCoverage=!0),this.premultipliedAlpha===!0&&(data.premultipliedAlpha=!0),this.forceSinglePass===!0&&(data.forceSinglePass=!0),this.wireframe===!0&&(data.wireframe=!0),this.wireframeLinewidth>1&&(data.wireframeLinewidth=this.wireframeLinewidth),this.wireframeLinecap!=="round"&&(data.wireframeLinecap=this.wireframeLinecap),this.wireframeLinejoin!=="round"&&(data.wireframeLinejoin=this.wireframeLinejoin),this.flatShading===!0&&(data.flatShading=!0),this.visible===!1&&(data.visible=!1),this.toneMapped===!1&&(data.toneMapped=!1),this.fog===!1&&(data.fog=!1),Object.keys(this.userData).length>0&&(data.userData=this.userData);function extractFromCache(cache2){const values=[];for(const key2 in cache2){const data2=cache2[key2];delete data2.metadata,values.push(data2)}return values}if(isRootObject){const textures=extractFromCache(meta.textures),images=extractFromCache(meta.images);textures.length>0&&(data.textures=textures),images.length>0&&(data.images=images)}return data}clone(){return new this.constructor().copy(this)}copy(source){this.name=source.name,this.blending=source.blending,this.side=source.side,this.vertexColors=source.vertexColors,this.opacity=source.opacity,this.transparent=source.transparent,this.blendSrc=source.blendSrc,this.blendDst=source.blendDst,this.blendEquation=source.blendEquation,this.blendSrcAlpha=source.blendSrcAlpha,this.blendDstAlpha=source.blendDstAlpha,this.blendEquationAlpha=source.blendEquationAlpha,this.blendColor.copy(source.blendColor),this.blendAlpha=source.blendAlpha,this.depthFunc=source.depthFunc,this.depthTest=source.depthTest,this.depthWrite=source.depthWrite,this.stencilWriteMask=source.stencilWriteMask,this.stencilFunc=source.stencilFunc,this.stencilRef=source.stencilRef,this.stencilFuncMask=source.stencilFuncMask,this.stencilFail=source.stencilFail,this.stencilZFail=source.stencilZFail,this.stencilZPass=source.stencilZPass,this.stencilWrite=source.stencilWrite;const srcPlanes=source.clippingPlanes;let dstPlanes=null;if(srcPlanes!==null){const n2=srcPlanes.length;dstPlanes=new Array(n2);for(let i2=0;i2!==n2;++i2)dstPlanes[i2]=srcPlanes[i2].clone()}return this.clippingPlanes=dstPlanes,this.clipIntersection=source.clipIntersection,this.clipShadows=source.clipShadows,this.shadowSide=source.shadowSide,this.colorWrite=source.colorWrite,this.precision=source.precision,this.polygonOffset=source.polygonOffset,this.polygonOffsetFactor=source.polygonOffsetFactor,this.polygonOffsetUnits=source.polygonOffsetUnits,this.dithering=source.dithering,this.alphaTest=source.alphaTest,this.alphaHash=source.alphaHash,this.alphaToCoverage=source.alphaToCoverage,this.premultipliedAlpha=source.premultipliedAlpha,this.forceSinglePass=source.forceSinglePass,this.visible=source.visible,this.toneMapped=source.toneMapped,this.userData=JSON.parse(JSON.stringify(source.userData)),this}dispose(){this.dispatchEvent({type:"dispose"})}set needsUpdate(value){value===!0&&this.version++}onBuild(){console.warn("Material: onBuild() has been removed.")}}class MeshBasicMaterial extends Material{constructor(parameters){super(),this.isMeshBasicMaterial=!0,this.type="MeshBasicMaterial",this.color=new Color(16777215),this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.envMapRotation=new Euler,this.combine=MultiplyOperation,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.lightMap=source.lightMap,this.lightMapIntensity=source.lightMapIntensity,this.aoMap=source.aoMap,this.aoMapIntensity=source.aoMapIntensity,this.specularMap=source.specularMap,this.alphaMap=source.alphaMap,this.envMap=source.envMap,this.envMapRotation.copy(source.envMapRotation),this.combine=source.combine,this.reflectivity=source.reflectivity,this.refractionRatio=source.refractionRatio,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.wireframeLinecap=source.wireframeLinecap,this.wireframeLinejoin=source.wireframeLinejoin,this.fog=source.fog,this}}const _tables=_generateTables();function _generateTables(){const buffer2=new ArrayBuffer(4),floatView=new Float32Array(buffer2),uint32View=new Uint32Array(buffer2),baseTable=new Uint32Array(512),shiftTable=new Uint32Array(512);for(let i2=0;i2<256;++i2){const e2=i2-127;e2<-27?(baseTable[i2]=0,baseTable[i2|256]=32768,shiftTable[i2]=24,shiftTable[i2|256]=24):e2<-14?(baseTable[i2]=1024>>-e2-14,baseTable[i2|256]=1024>>-e2-14|32768,shiftTable[i2]=-e2-1,shiftTable[i2|256]=-e2-1):e2<=15?(baseTable[i2]=e2+15<<10,baseTable[i2|256]=e2+15<<10|32768,shiftTable[i2]=13,shiftTable[i2|256]=13):e2<128?(baseTable[i2]=31744,baseTable[i2|256]=64512,shiftTable[i2]=24,shiftTable[i2|256]=24):(baseTable[i2]=31744,baseTable[i2|256]=64512,shiftTable[i2]=13,shiftTable[i2|256]=13)}const mantissaTable=new Uint32Array(2048),exponentTable=new Uint32Array(64),offsetTable=new Uint32Array(64);for(let i2=1;i2<1024;++i2){let m=i2<<13,e2=0;for(;!(m&8388608);)m<<=1,e2-=8388608;m&=-8388609,e2+=947912704,mantissaTable[i2]=m|e2}for(let i2=1024;i2<2048;++i2)mantissaTable[i2]=939524096+(i2-1024<<13);for(let i2=1;i2<31;++i2)exponentTable[i2]=i2<<23;exponentTable[31]=1199570944,exponentTable[32]=2147483648;for(let i2=33;i2<63;++i2)exponentTable[i2]=2147483648+(i2-32<<23);exponentTable[63]=3347054592;for(let i2=1;i2<64;++i2)i2!==32&&(offsetTable[i2]=1024);return{floatView,uint32View,baseTable,shiftTable,mantissaTable,exponentTable,offsetTable}}function toHalfFloat(val){Math.abs(val)>65504&&console.warn("THREE.DataUtils.toHalfFloat(): Value out of range."),val=clamp$4(val,-65504,65504),_tables.floatView[0]=val;const f2=_tables.uint32View[0],e2=f2>>23&511;return _tables.baseTable[e2]+((f2&8388607)>>_tables.shiftTable[e2])}function fromHalfFloat(val){const m=val>>10;return _tables.uint32View[0]=_tables.mantissaTable[_tables.offsetTable[m]+(val&1023)]+_tables.exponentTable[m],_tables.floatView[0]}const _vector$9=new Vector3,_vector2$1=new Vector2;let _id$2$1=0;class BufferAttribute{constructor(array2,itemSize,normalized=!1){if(Array.isArray(array2))throw new TypeError("THREE.BufferAttribute: array should be a Typed Array.");this.isBufferAttribute=!0,Object.defineProperty(this,"id",{value:_id$2$1++}),this.name="",this.array=array2,this.itemSize=itemSize,this.count=array2!==void 0?array2.length/itemSize:0,this.normalized=normalized,this.usage=StaticDrawUsage,this.updateRanges=[],this.gpuType=FloatType,this.version=0}onUploadCallback(){}set needsUpdate(value){value===!0&&this.version++}setUsage(value){return this.usage=value,this}addUpdateRange(start,count){this.updateRanges.push({start,count})}clearUpdateRanges(){this.updateRanges.length=0}copy(source){return this.name=source.name,this.array=new source.array.constructor(source.array),this.itemSize=source.itemSize,this.count=source.count,this.normalized=source.normalized,this.usage=source.usage,this.gpuType=source.gpuType,this}copyAt(index1,attribute2,index2){index1*=this.itemSize,index2*=attribute2.itemSize;for(let i2=0,l2=this.itemSize;i2<l2;i2++)this.array[index1+i2]=attribute2.array[index2+i2];return this}copyArray(array2){return this.array.set(array2),this}applyMatrix3(m){if(this.itemSize===2)for(let i2=0,l2=this.count;i2<l2;i2++)_vector2$1.fromBufferAttribute(this,i2),_vector2$1.applyMatrix3(m),this.setXY(i2,_vector2$1.x,_vector2$1.y);else if(this.itemSize===3)for(let i2=0,l2=this.count;i2<l2;i2++)_vector$9.fromBufferAttribute(this,i2),_vector$9.applyMatrix3(m),this.setXYZ(i2,_vector$9.x,_vector$9.y,_vector$9.z);return this}applyMatrix4(m){for(let i2=0,l2=this.count;i2<l2;i2++)_vector$9.fromBufferAttribute(this,i2),_vector$9.applyMatrix4(m),this.setXYZ(i2,_vector$9.x,_vector$9.y,_vector$9.z);return this}applyNormalMatrix(m){for(let i2=0,l2=this.count;i2<l2;i2++)_vector$9.fromBufferAttribute(this,i2),_vector$9.applyNormalMatrix(m),this.setXYZ(i2,_vector$9.x,_vector$9.y,_vector$9.z);return this}transformDirection(m){for(let i2=0,l2=this.count;i2<l2;i2++)_vector$9.fromBufferAttribute(this,i2),_vector$9.transformDirection(m),this.setXYZ(i2,_vector$9.x,_vector$9.y,_vector$9.z);return this}set(value,offset=0){return this.array.set(value,offset),this}getComponent(index,component){let value=this.array[index*this.itemSize+component];return this.normalized&&(value=denormalize(value,this.array)),value}setComponent(index,component,value){return this.normalized&&(value=normalize$2(value,this.array)),this.array[index*this.itemSize+component]=value,this}getX(index){let x=this.array[index*this.itemSize];return this.normalized&&(x=denormalize(x,this.array)),x}setX(index,x){return this.normalized&&(x=normalize$2(x,this.array)),this.array[index*this.itemSize]=x,this}getY(index){let y=this.array[index*this.itemSize+1];return this.normalized&&(y=denormalize(y,this.array)),y}setY(index,y){return this.normalized&&(y=normalize$2(y,this.array)),this.array[index*this.itemSize+1]=y,this}getZ(index){let z=this.array[index*this.itemSize+2];return this.normalized&&(z=denormalize(z,this.array)),z}setZ(index,z){return this.normalized&&(z=normalize$2(z,this.array)),this.array[index*this.itemSize+2]=z,this}getW(index){let w=this.array[index*this.itemSize+3];return this.normalized&&(w=denormalize(w,this.array)),w}setW(index,w){return this.normalized&&(w=normalize$2(w,this.array)),this.array[index*this.itemSize+3]=w,this}setXY(index,x,y){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array)),this.array[index+0]=x,this.array[index+1]=y,this}setXYZ(index,x,y,z){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array)),this.array[index+0]=x,this.array[index+1]=y,this.array[index+2]=z,this}setXYZW(index,x,y,z,w){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array),w=normalize$2(w,this.array)),this.array[index+0]=x,this.array[index+1]=y,this.array[index+2]=z,this.array[index+3]=w,this}onUpload(callback){return this.onUploadCallback=callback,this}clone(){return new this.constructor(this.array,this.itemSize).copy(this)}toJSON(){const data={itemSize:this.itemSize,type:this.array.constructor.name,array:Array.from(this.array),normalized:this.normalized};return this.name!==""&&(data.name=this.name),this.usage!==StaticDrawUsage&&(data.usage=this.usage),data}}class Uint16BufferAttribute extends BufferAttribute{constructor(array2,itemSize,normalized){super(new Uint16Array(array2),itemSize,normalized)}}class Uint32BufferAttribute extends BufferAttribute{constructor(array2,itemSize,normalized){super(new Uint32Array(array2),itemSize,normalized)}}class Float16BufferAttribute extends BufferAttribute{constructor(array2,itemSize,normalized){super(new Uint16Array(array2),itemSize,normalized),this.isFloat16BufferAttribute=!0}getX(index){let x=fromHalfFloat(this.array[index*this.itemSize]);return this.normalized&&(x=denormalize(x,this.array)),x}setX(index,x){return this.normalized&&(x=normalize$2(x,this.array)),this.array[index*this.itemSize]=toHalfFloat(x),this}getY(index){let y=fromHalfFloat(this.array[index*this.itemSize+1]);return this.normalized&&(y=denormalize(y,this.array)),y}setY(index,y){return this.normalized&&(y=normalize$2(y,this.array)),this.array[index*this.itemSize+1]=toHalfFloat(y),this}getZ(index){let z=fromHalfFloat(this.array[index*this.itemSize+2]);return this.normalized&&(z=denormalize(z,this.array)),z}setZ(index,z){return this.normalized&&(z=normalize$2(z,this.array)),this.array[index*this.itemSize+2]=toHalfFloat(z),this}getW(index){let w=fromHalfFloat(this.array[index*this.itemSize+3]);return this.normalized&&(w=denormalize(w,this.array)),w}setW(index,w){return this.normalized&&(w=normalize$2(w,this.array)),this.array[index*this.itemSize+3]=toHalfFloat(w),this}setXY(index,x,y){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array)),this.array[index+0]=toHalfFloat(x),this.array[index+1]=toHalfFloat(y),this}setXYZ(index,x,y,z){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array)),this.array[index+0]=toHalfFloat(x),this.array[index+1]=toHalfFloat(y),this.array[index+2]=toHalfFloat(z),this}setXYZW(index,x,y,z,w){return index*=this.itemSize,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array),w=normalize$2(w,this.array)),this.array[index+0]=toHalfFloat(x),this.array[index+1]=toHalfFloat(y),this.array[index+2]=toHalfFloat(z),this.array[index+3]=toHalfFloat(w),this}}class Float32BufferAttribute extends BufferAttribute{constructor(array2,itemSize,normalized){super(new Float32Array(array2),itemSize,normalized)}}let _id$1$1=0;const _m1$3=new Matrix4,_obj=new Object3D,_offset=new Vector3,_box$2=new Box3,_boxMorphTargets=new Box3,_vector$8=new Vector3;class BufferGeometry extends EventDispatcher{constructor(){super(),this.isBufferGeometry=!0,Object.defineProperty(this,"id",{value:_id$1$1++}),this.uuid=generateUUID(),this.name="",this.type="BufferGeometry",this.index=null,this.indirect=null,this.attributes={},this.morphAttributes={},this.morphTargetsRelative=!1,this.groups=[],this.boundingBox=null,this.boundingSphere=null,this.drawRange={start:0,count:1/0},this.userData={}}getIndex(){return this.index}setIndex(index){return Array.isArray(index)?this.index=new(arrayNeedsUint32(index)?Uint32BufferAttribute:Uint16BufferAttribute)(index,1):this.index=index,this}setIndirect(indirect){return this.indirect=indirect,this}getIndirect(){return this.indirect}getAttribute(name){return this.attributes[name]}setAttribute(name,attribute2){return this.attributes[name]=attribute2,this}deleteAttribute(name){return delete this.attributes[name],this}hasAttribute(name){return this.attributes[name]!==void 0}addGroup(start,count,materialIndex=0){this.groups.push({start,count,materialIndex})}clearGroups(){this.groups=[]}setDrawRange(start,count){this.drawRange.start=start,this.drawRange.count=count}applyMatrix4(matrix){const position=this.attributes.position;position!==void 0&&(position.applyMatrix4(matrix),position.needsUpdate=!0);const normal2=this.attributes.normal;if(normal2!==void 0){const normalMatrix=new Matrix3().getNormalMatrix(matrix);normal2.applyNormalMatrix(normalMatrix),normal2.needsUpdate=!0}const tangent=this.attributes.tangent;return tangent!==void 0&&(tangent.transformDirection(matrix),tangent.needsUpdate=!0),this.boundingBox!==null&&this.computeBoundingBox(),this.boundingSphere!==null&&this.computeBoundingSphere(),this}applyQuaternion(q){return _m1$3.makeRotationFromQuaternion(q),this.applyMatrix4(_m1$3),this}rotateX(angle){return _m1$3.makeRotationX(angle),this.applyMatrix4(_m1$3),this}rotateY(angle){return _m1$3.makeRotationY(angle),this.applyMatrix4(_m1$3),this}rotateZ(angle){return _m1$3.makeRotationZ(angle),this.applyMatrix4(_m1$3),this}translate(x,y,z){return _m1$3.makeTranslation(x,y,z),this.applyMatrix4(_m1$3),this}scale(x,y,z){return _m1$3.makeScale(x,y,z),this.applyMatrix4(_m1$3),this}lookAt(vector){return _obj.lookAt(vector),_obj.updateMatrix(),this.applyMatrix4(_obj.matrix),this}center(){return this.computeBoundingBox(),this.boundingBox.getCenter(_offset).negate(),this.translate(_offset.x,_offset.y,_offset.z),this}setFromPoints(points){const positionAttribute=this.getAttribute("position");if(positionAttribute===void 0){const position=[];for(let i2=0,l2=points.length;i2<l2;i2++){const point=points[i2];position.push(point.x,point.y,point.z||0)}this.setAttribute("position",new Float32BufferAttribute(position,3))}else{const l2=Math.min(points.length,positionAttribute.count);for(let i2=0;i2<l2;i2++){const point=points[i2];positionAttribute.setXYZ(i2,point.x,point.y,point.z||0)}points.length>positionAttribute.count&&console.warn("THREE.BufferGeometry: Buffer size too small for points data. Use .dispose() and create a new geometry."),positionAttribute.needsUpdate=!0}return this}computeBoundingBox(){this.boundingBox===null&&(this.boundingBox=new Box3);const position=this.attributes.position,morphAttributesPosition=this.morphAttributes.position;if(position&&position.isGLBufferAttribute){console.error("THREE.BufferGeometry.computeBoundingBox(): GLBufferAttribute requires a manual bounding box.",this),this.boundingBox.set(new Vector3(-1/0,-1/0,-1/0),new Vector3(1/0,1/0,1/0));return}if(position!==void 0){if(this.boundingBox.setFromBufferAttribute(position),morphAttributesPosition)for(let i2=0,il=morphAttributesPosition.length;i2<il;i2++){const morphAttribute=morphAttributesPosition[i2];_box$2.setFromBufferAttribute(morphAttribute),this.morphTargetsRelative?(_vector$8.addVectors(this.boundingBox.min,_box$2.min),this.boundingBox.expandByPoint(_vector$8),_vector$8.addVectors(this.boundingBox.max,_box$2.max),this.boundingBox.expandByPoint(_vector$8)):(this.boundingBox.expandByPoint(_box$2.min),this.boundingBox.expandByPoint(_box$2.max))}}else this.boundingBox.makeEmpty();(isNaN(this.boundingBox.min.x)||isNaN(this.boundingBox.min.y)||isNaN(this.boundingBox.min.z))&&console.error('THREE.BufferGeometry.computeBoundingBox(): Computed min/max have NaN values. The "position" attribute is likely to have NaN values.',this)}computeBoundingSphere(){this.boundingSphere===null&&(this.boundingSphere=new Sphere);const position=this.attributes.position,morphAttributesPosition=this.morphAttributes.position;if(position&&position.isGLBufferAttribute){console.error("THREE.BufferGeometry.computeBoundingSphere(): GLBufferAttribute requires a manual bounding sphere.",this),this.boundingSphere.set(new Vector3,1/0);return}if(position){const center=this.boundingSphere.center;if(_box$2.setFromBufferAttribute(position),morphAttributesPosition)for(let i2=0,il=morphAttributesPosition.length;i2<il;i2++){const morphAttribute=morphAttributesPosition[i2];_boxMorphTargets.setFromBufferAttribute(morphAttribute),this.morphTargetsRelative?(_vector$8.addVectors(_box$2.min,_boxMorphTargets.min),_box$2.expandByPoint(_vector$8),_vector$8.addVectors(_box$2.max,_boxMorphTargets.max),_box$2.expandByPoint(_vector$8)):(_box$2.expandByPoint(_boxMorphTargets.min),_box$2.expandByPoint(_boxMorphTargets.max))}_box$2.getCenter(center);let maxRadiusSq=0;for(let i2=0,il=position.count;i2<il;i2++)_vector$8.fromBufferAttribute(position,i2),maxRadiusSq=Math.max(maxRadiusSq,center.distanceToSquared(_vector$8));if(morphAttributesPosition)for(let i2=0,il=morphAttributesPosition.length;i2<il;i2++){const morphAttribute=morphAttributesPosition[i2],morphTargetsRelative=this.morphTargetsRelative;for(let j=0,jl=morphAttribute.count;j<jl;j++)_vector$8.fromBufferAttribute(morphAttribute,j),morphTargetsRelative&&(_offset.fromBufferAttribute(position,j),_vector$8.add(_offset)),maxRadiusSq=Math.max(maxRadiusSq,center.distanceToSquared(_vector$8))}this.boundingSphere.radius=Math.sqrt(maxRadiusSq),isNaN(this.boundingSphere.radius)&&console.error('THREE.BufferGeometry.computeBoundingSphere(): Computed radius is NaN. The "position" attribute is likely to have NaN values.',this)}}computeTangents(){const index=this.index,attributes=this.attributes;if(index===null||attributes.position===void 0||attributes.normal===void 0||attributes.uv===void 0){console.error("THREE.BufferGeometry: .computeTangents() failed. Missing required attributes (index, position, normal or uv)");return}const positionAttribute=attributes.position,normalAttribute=attributes.normal,uvAttribute=attributes.uv;this.hasAttribute("tangent")===!1&&this.setAttribute("tangent",new BufferAttribute(new Float32Array(4*positionAttribute.count),4));const tangentAttribute=this.getAttribute("tangent"),tan1=[],tan2=[];for(let i2=0;i2<positionAttribute.count;i2++)tan1[i2]=new Vector3,tan2[i2]=new Vector3;const vA=new Vector3,vB=new Vector3,vC=new Vector3,uvA=new Vector2,uvB=new Vector2,uvC=new Vector2,sdir=new Vector3,tdir=new Vector3;function handleTriangle(a2,b,c2){vA.fromBufferAttribute(positionAttribute,a2),vB.fromBufferAttribute(positionAttribute,b),vC.fromBufferAttribute(positionAttribute,c2),uvA.fromBufferAttribute(uvAttribute,a2),uvB.fromBufferAttribute(uvAttribute,b),uvC.fromBufferAttribute(uvAttribute,c2),vB.sub(vA),vC.sub(vA),uvB.sub(uvA),uvC.sub(uvA);const r2=1/(uvB.x*uvC.y-uvC.x*uvB.y);isFinite(r2)&&(sdir.copy(vB).multiplyScalar(uvC.y).addScaledVector(vC,-uvB.y).multiplyScalar(r2),tdir.copy(vC).multiplyScalar(uvB.x).addScaledVector(vB,-uvC.x).multiplyScalar(r2),tan1[a2].add(sdir),tan1[b].add(sdir),tan1[c2].add(sdir),tan2[a2].add(tdir),tan2[b].add(tdir),tan2[c2].add(tdir))}let groups=this.groups;groups.length===0&&(groups=[{start:0,count:index.count}]);for(let i2=0,il=groups.length;i2<il;++i2){const group=groups[i2],start=group.start,count=group.count;for(let j=start,jl=start+count;j<jl;j+=3)handleTriangle(index.getX(j+0),index.getX(j+1),index.getX(j+2))}const tmp=new Vector3,tmp2=new Vector3,n2=new Vector3,n22=new Vector3;function handleVertex(v){n2.fromBufferAttribute(normalAttribute,v),n22.copy(n2);const t2=tan1[v];tmp.copy(t2),tmp.sub(n2.multiplyScalar(n2.dot(t2))).normalize(),tmp2.crossVectors(n22,t2);const w=tmp2.dot(tan2[v])<0?-1:1;tangentAttribute.setXYZW(v,tmp.x,tmp.y,tmp.z,w)}for(let i2=0,il=groups.length;i2<il;++i2){const group=groups[i2],start=group.start,count=group.count;for(let j=start,jl=start+count;j<jl;j+=3)handleVertex(index.getX(j+0)),handleVertex(index.getX(j+1)),handleVertex(index.getX(j+2))}}computeVertexNormals(){const index=this.index,positionAttribute=this.getAttribute("position");if(positionAttribute!==void 0){let normalAttribute=this.getAttribute("normal");if(normalAttribute===void 0)normalAttribute=new BufferAttribute(new Float32Array(positionAttribute.count*3),3),this.setAttribute("normal",normalAttribute);else for(let i2=0,il=normalAttribute.count;i2<il;i2++)normalAttribute.setXYZ(i2,0,0,0);const pA=new Vector3,pB=new Vector3,pC=new Vector3,nA=new Vector3,nB=new Vector3,nC=new Vector3,cb=new Vector3,ab=new Vector3;if(index)for(let i2=0,il=index.count;i2<il;i2+=3){const vA=index.getX(i2+0),vB=index.getX(i2+1),vC=index.getX(i2+2);pA.fromBufferAttribute(positionAttribute,vA),pB.fromBufferAttribute(positionAttribute,vB),pC.fromBufferAttribute(positionAttribute,vC),cb.subVectors(pC,pB),ab.subVectors(pA,pB),cb.cross(ab),nA.fromBufferAttribute(normalAttribute,vA),nB.fromBufferAttribute(normalAttribute,vB),nC.fromBufferAttribute(normalAttribute,vC),nA.add(cb),nB.add(cb),nC.add(cb),normalAttribute.setXYZ(vA,nA.x,nA.y,nA.z),normalAttribute.setXYZ(vB,nB.x,nB.y,nB.z),normalAttribute.setXYZ(vC,nC.x,nC.y,nC.z)}else for(let i2=0,il=positionAttribute.count;i2<il;i2+=3)pA.fromBufferAttribute(positionAttribute,i2+0),pB.fromBufferAttribute(positionAttribute,i2+1),pC.fromBufferAttribute(positionAttribute,i2+2),cb.subVectors(pC,pB),ab.subVectors(pA,pB),cb.cross(ab),normalAttribute.setXYZ(i2+0,cb.x,cb.y,cb.z),normalAttribute.setXYZ(i2+1,cb.x,cb.y,cb.z),normalAttribute.setXYZ(i2+2,cb.x,cb.y,cb.z);this.normalizeNormals(),normalAttribute.needsUpdate=!0}}normalizeNormals(){const normals=this.attributes.normal;for(let i2=0,il=normals.count;i2<il;i2++)_vector$8.fromBufferAttribute(normals,i2),_vector$8.normalize(),normals.setXYZ(i2,_vector$8.x,_vector$8.y,_vector$8.z)}toNonIndexed(){function convertBufferAttribute(attribute2,indices2){const array2=attribute2.array,itemSize=attribute2.itemSize,normalized=attribute2.normalized,array22=new array2.constructor(indices2.length*itemSize);let index=0,index2=0;for(let i2=0,l2=indices2.length;i2<l2;i2++){attribute2.isInterleavedBufferAttribute?index=indices2[i2]*attribute2.data.stride+attribute2.offset:index=indices2[i2]*itemSize;for(let j=0;j<itemSize;j++)array22[index2++]=array2[index++]}return new BufferAttribute(array22,itemSize,normalized)}if(this.index===null)return console.warn("THREE.BufferGeometry.toNonIndexed(): BufferGeometry is already non-indexed."),this;const geometry2=new BufferGeometry,indices=this.index.array,attributes=this.attributes;for(const name in attributes){const attribute2=attributes[name],newAttribute=convertBufferAttribute(attribute2,indices);geometry2.setAttribute(name,newAttribute)}const morphAttributes=this.morphAttributes;for(const name in morphAttributes){const morphArray=[],morphAttribute=morphAttributes[name];for(let i2=0,il=morphAttribute.length;i2<il;i2++){const attribute2=morphAttribute[i2],newAttribute=convertBufferAttribute(attribute2,indices);morphArray.push(newAttribute)}geometry2.morphAttributes[name]=morphArray}geometry2.morphTargetsRelative=this.morphTargetsRelative;const groups=this.groups;for(let i2=0,l2=groups.length;i2<l2;i2++){const group=groups[i2];geometry2.addGroup(group.start,group.count,group.materialIndex)}return geometry2}toJSON(){const data={metadata:{version:4.6,type:"BufferGeometry",generator:"BufferGeometry.toJSON"}};if(data.uuid=this.uuid,data.type=this.type,this.name!==""&&(data.name=this.name),Object.keys(this.userData).length>0&&(data.userData=this.userData),this.parameters!==void 0){const parameters=this.parameters;for(const key2 in parameters)parameters[key2]!==void 0&&(data[key2]=parameters[key2]);return data}data.data={attributes:{}};const index=this.index;index!==null&&(data.data.index={type:index.array.constructor.name,array:Array.prototype.slice.call(index.array)});const attributes=this.attributes;for(const key2 in attributes){const attribute2=attributes[key2];data.data.attributes[key2]=attribute2.toJSON(data.data)}const morphAttributes={};let hasMorphAttributes=!1;for(const key2 in this.morphAttributes){const attributeArray2=this.morphAttributes[key2],array2=[];for(let i2=0,il=attributeArray2.length;i2<il;i2++){const attribute2=attributeArray2[i2];array2.push(attribute2.toJSON(data.data))}array2.length>0&&(morphAttributes[key2]=array2,hasMorphAttributes=!0)}hasMorphAttributes&&(data.data.morphAttributes=morphAttributes,data.data.morphTargetsRelative=this.morphTargetsRelative);const groups=this.groups;groups.length>0&&(data.data.groups=JSON.parse(JSON.stringify(groups)));const boundingSphere=this.boundingSphere;return boundingSphere!==null&&(data.data.boundingSphere={center:boundingSphere.center.toArray(),radius:boundingSphere.radius}),data}clone(){return new this.constructor().copy(this)}copy(source){this.index=null,this.attributes={},this.morphAttributes={},this.groups=[],this.boundingBox=null,this.boundingSphere=null;const data={};this.name=source.name;const index=source.index;index!==null&&this.setIndex(index.clone(data));const attributes=source.attributes;for(const name in attributes){const attribute2=attributes[name];this.setAttribute(name,attribute2.clone(data))}const morphAttributes=source.morphAttributes;for(const name in morphAttributes){const array2=[],morphAttribute=morphAttributes[name];for(let i2=0,l2=morphAttribute.length;i2<l2;i2++)array2.push(morphAttribute[i2].clone(data));this.morphAttributes[name]=array2}this.morphTargetsRelative=source.morphTargetsRelative;const groups=source.groups;for(let i2=0,l2=groups.length;i2<l2;i2++){const group=groups[i2];this.addGroup(group.start,group.count,group.materialIndex)}const boundingBox=source.boundingBox;boundingBox!==null&&(this.boundingBox=boundingBox.clone());const boundingSphere=source.boundingSphere;return boundingSphere!==null&&(this.boundingSphere=boundingSphere.clone()),this.drawRange.start=source.drawRange.start,this.drawRange.count=source.drawRange.count,this.userData=source.userData,this}dispose(){this.dispatchEvent({type:"dispose"})}}const _inverseMatrix$3=new Matrix4,_ray$3=new Ray,_sphere$6=new Sphere,_sphereHitAt=new Vector3,_vA$1=new Vector3,_vB$1=new Vector3,_vC$1=new Vector3,_tempA=new Vector3,_morphA=new Vector3,_intersectionPoint=new Vector3,_intersectionPointWorld=new Vector3;class Mesh extends Object3D{constructor(geometry2=new BufferGeometry,material=new MeshBasicMaterial){super(),this.isMesh=!0,this.type="Mesh",this.geometry=geometry2,this.material=material,this.updateMorphTargets()}copy(source,recursive){return super.copy(source,recursive),source.morphTargetInfluences!==void 0&&(this.morphTargetInfluences=source.morphTargetInfluences.slice()),source.morphTargetDictionary!==void 0&&(this.morphTargetDictionary=Object.assign({},source.morphTargetDictionary)),this.material=Array.isArray(source.material)?source.material.slice():source.material,this.geometry=source.geometry,this}updateMorphTargets(){const morphAttributes=this.geometry.morphAttributes,keys=Object.keys(morphAttributes);if(keys.length>0){const morphAttribute=morphAttributes[keys[0]];if(morphAttribute!==void 0){this.morphTargetInfluences=[],this.morphTargetDictionary={};for(let m=0,ml=morphAttribute.length;m<ml;m++){const name=morphAttribute[m].name||String(m);this.morphTargetInfluences.push(0),this.morphTargetDictionary[name]=m}}}}getVertexPosition(index,target){const geometry2=this.geometry,position=geometry2.attributes.position,morphPosition=geometry2.morphAttributes.position,morphTargetsRelative=geometry2.morphTargetsRelative;target.fromBufferAttribute(position,index);const morphInfluences=this.morphTargetInfluences;if(morphPosition&&morphInfluences){_morphA.set(0,0,0);for(let i2=0,il=morphPosition.length;i2<il;i2++){const influence=morphInfluences[i2],morphAttribute=morphPosition[i2];influence!==0&&(_tempA.fromBufferAttribute(morphAttribute,index),morphTargetsRelative?_morphA.addScaledVector(_tempA,influence):_morphA.addScaledVector(_tempA.sub(target),influence))}target.add(_morphA)}return target}raycast(raycaster,intersects2){const geometry2=this.geometry,material=this.material,matrixWorld=this.matrixWorld;material!==void 0&&(geometry2.boundingSphere===null&&geometry2.computeBoundingSphere(),_sphere$6.copy(geometry2.boundingSphere),_sphere$6.applyMatrix4(matrixWorld),_ray$3.copy(raycaster.ray).recast(raycaster.near),!(_sphere$6.containsPoint(_ray$3.origin)===!1&&(_ray$3.intersectSphere(_sphere$6,_sphereHitAt)===null||_ray$3.origin.distanceToSquared(_sphereHitAt)>(raycaster.far-raycaster.near)**2))&&(_inverseMatrix$3.copy(matrixWorld).invert(),_ray$3.copy(raycaster.ray).applyMatrix4(_inverseMatrix$3),!(geometry2.boundingBox!==null&&_ray$3.intersectsBox(geometry2.boundingBox)===!1)&&this._computeIntersections(raycaster,intersects2,_ray$3)))}_computeIntersections(raycaster,intersects2,rayLocalSpace){let intersection;const geometry2=this.geometry,material=this.material,index=geometry2.index,position=geometry2.attributes.position,uv2=geometry2.attributes.uv,uv1=geometry2.attributes.uv1,normal2=geometry2.attributes.normal,groups=geometry2.groups,drawRange=geometry2.drawRange;if(index!==null)if(Array.isArray(material))for(let i2=0,il=groups.length;i2<il;i2++){const group=groups[i2],groupMaterial=material[group.materialIndex],start=Math.max(group.start,drawRange.start),end=Math.min(index.count,Math.min(group.start+group.count,drawRange.start+drawRange.count));for(let j=start,jl=end;j<jl;j+=3){const a2=index.getX(j),b=index.getX(j+1),c2=index.getX(j+2);intersection=checkGeometryIntersection(this,groupMaterial,raycaster,rayLocalSpace,uv2,uv1,normal2,a2,b,c2),intersection&&(intersection.faceIndex=Math.floor(j/3),intersection.face.materialIndex=group.materialIndex,intersects2.push(intersection))}}else{const start=Math.max(0,drawRange.start),end=Math.min(index.count,drawRange.start+drawRange.count);for(let i2=start,il=end;i2<il;i2+=3){const a2=index.getX(i2),b=index.getX(i2+1),c2=index.getX(i2+2);intersection=checkGeometryIntersection(this,material,raycaster,rayLocalSpace,uv2,uv1,normal2,a2,b,c2),intersection&&(intersection.faceIndex=Math.floor(i2/3),intersects2.push(intersection))}}else if(position!==void 0)if(Array.isArray(material))for(let i2=0,il=groups.length;i2<il;i2++){const group=groups[i2],groupMaterial=material[group.materialIndex],start=Math.max(group.start,drawRange.start),end=Math.min(position.count,Math.min(group.start+group.count,drawRange.start+drawRange.count));for(let j=start,jl=end;j<jl;j+=3){const a2=j,b=j+1,c2=j+2;intersection=checkGeometryIntersection(this,groupMaterial,raycaster,rayLocalSpace,uv2,uv1,normal2,a2,b,c2),intersection&&(intersection.faceIndex=Math.floor(j/3),intersection.face.materialIndex=group.materialIndex,intersects2.push(intersection))}}else{const start=Math.max(0,drawRange.start),end=Math.min(position.count,drawRange.start+drawRange.count);for(let i2=start,il=end;i2<il;i2+=3){const a2=i2,b=i2+1,c2=i2+2;intersection=checkGeometryIntersection(this,material,raycaster,rayLocalSpace,uv2,uv1,normal2,a2,b,c2),intersection&&(intersection.faceIndex=Math.floor(i2/3),intersects2.push(intersection))}}}}function checkIntersection$1(object,material,raycaster,ray,pA,pB,pC,point){let intersect;if(material.side===BackSide?intersect=ray.intersectTriangle(pC,pB,pA,!0,point):intersect=ray.intersectTriangle(pA,pB,pC,material.side===FrontSide,point),intersect===null)return null;_intersectionPointWorld.copy(point),_intersectionPointWorld.applyMatrix4(object.matrixWorld);const distance2=raycaster.ray.origin.distanceTo(_intersectionPointWorld);return distance2<raycaster.near||distance2>raycaster.far?null:{distance:distance2,point:_intersectionPointWorld.clone(),object}}function checkGeometryIntersection(object,material,raycaster,ray,uv2,uv1,normal2,a2,b,c2){object.getVertexPosition(a2,_vA$1),object.getVertexPosition(b,_vB$1),object.getVertexPosition(c2,_vC$1);const intersection=checkIntersection$1(object,material,raycaster,ray,_vA$1,_vB$1,_vC$1,_intersectionPoint);if(intersection){const barycoord=new Vector3;Triangle.getBarycoord(_intersectionPoint,_vA$1,_vB$1,_vC$1,barycoord),uv2&&(intersection.uv=Triangle.getInterpolatedAttribute(uv2,a2,b,c2,barycoord,new Vector2)),uv1&&(intersection.uv1=Triangle.getInterpolatedAttribute(uv1,a2,b,c2,barycoord,new Vector2)),normal2&&(intersection.normal=Triangle.getInterpolatedAttribute(normal2,a2,b,c2,barycoord,new Vector3),intersection.normal.dot(ray.direction)>0&&intersection.normal.multiplyScalar(-1));const face={a:a2,b,c:c2,normal:new Vector3,materialIndex:0};Triangle.getNormal(_vA$1,_vB$1,_vC$1,face.normal),intersection.face=face,intersection.barycoord=barycoord}return intersection}class BoxGeometry extends BufferGeometry{constructor(width=1,height=1,depth2=1,widthSegments=1,heightSegments=1,depthSegments=1){super(),this.type="BoxGeometry",this.parameters={width,height,depth:depth2,widthSegments,heightSegments,depthSegments};const scope=this;widthSegments=Math.floor(widthSegments),heightSegments=Math.floor(heightSegments),depthSegments=Math.floor(depthSegments);const indices=[],vertices=[],normals=[],uvs=[];let numberOfVertices=0,groupStart=0;buildPlane("z","y","x",-1,-1,depth2,height,width,depthSegments,heightSegments,0),buildPlane("z","y","x",1,-1,depth2,height,-width,depthSegments,heightSegments,1),buildPlane("x","z","y",1,1,width,depth2,height,widthSegments,depthSegments,2),buildPlane("x","z","y",1,-1,width,depth2,-height,widthSegments,depthSegments,3),buildPlane("x","y","z",1,-1,width,height,depth2,widthSegments,heightSegments,4),buildPlane("x","y","z",-1,-1,width,height,-depth2,widthSegments,heightSegments,5),this.setIndex(indices),this.setAttribute("position",new Float32BufferAttribute(vertices,3)),this.setAttribute("normal",new Float32BufferAttribute(normals,3)),this.setAttribute("uv",new Float32BufferAttribute(uvs,2));function buildPlane(u,v,w,udir,vdir,width2,height2,depth3,gridX,gridY,materialIndex){const segmentWidth=width2/gridX,segmentHeight=height2/gridY,widthHalf=width2/2,heightHalf=height2/2,depthHalf=depth3/2,gridX1=gridX+1,gridY1=gridY+1;let vertexCounter=0,groupCount=0;const vector=new Vector3;for(let iy=0;iy<gridY1;iy++){const y=iy*segmentHeight-heightHalf;for(let ix=0;ix<gridX1;ix++){const x=ix*segmentWidth-widthHalf;vector[u]=x*udir,vector[v]=y*vdir,vector[w]=depthHalf,vertices.push(vector.x,vector.y,vector.z),vector[u]=0,vector[v]=0,vector[w]=depth3>0?1:-1,normals.push(vector.x,vector.y,vector.z),uvs.push(ix/gridX),uvs.push(1-iy/gridY),vertexCounter+=1}}for(let iy=0;iy<gridY;iy++)for(let ix=0;ix<gridX;ix++){const a2=numberOfVertices+ix+gridX1*iy,b=numberOfVertices+ix+gridX1*(iy+1),c2=numberOfVertices+(ix+1)+gridX1*(iy+1),d2=numberOfVertices+(ix+1)+gridX1*iy;indices.push(a2,b,d2),indices.push(b,c2,d2),groupCount+=6}scope.addGroup(groupStart,groupCount,materialIndex),groupStart+=groupCount,numberOfVertices+=vertexCounter}}copy(source){return super.copy(source),this.parameters=Object.assign({},source.parameters),this}static fromJSON(data){return new BoxGeometry(data.width,data.height,data.depth,data.widthSegments,data.heightSegments,data.depthSegments)}}function cloneUniforms(src){const dst={};for(const u in src){dst[u]={};for(const p in src[u]){const property2=src[u][p];property2&&(property2.isColor||property2.isMatrix3||property2.isMatrix4||property2.isVector2||property2.isVector3||property2.isVector4||property2.isTexture||property2.isQuaternion)?property2.isRenderTargetTexture?(console.warn("UniformsUtils: Textures of render targets cannot be cloned via cloneUniforms() or mergeUniforms()."),dst[u][p]=null):dst[u][p]=property2.clone():Array.isArray(property2)?dst[u][p]=property2.slice():dst[u][p]=property2}}return dst}function cloneUniformsGroups(src){const dst=[];for(let u=0;u<src.length;u++)dst.push(src[u].clone());return dst}var default_vertex=`void main() {
	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );
}`,default_fragment=`void main() {
	gl_FragColor = vec4( 1.0, 0.0, 0.0, 1.0 );
}`;class ShaderMaterial extends Material{constructor(parameters){super(),this.isShaderMaterial=!0,this.type="ShaderMaterial",this.defines={},this.uniforms={},this.uniformsGroups=[],this.vertexShader=default_vertex,this.fragmentShader=default_fragment,this.linewidth=1,this.wireframe=!1,this.wireframeLinewidth=1,this.fog=!1,this.lights=!1,this.clipping=!1,this.forceSinglePass=!0,this.extensions={clipCullDistance:!1,multiDraw:!1},this.defaultAttributeValues={color:[1,1,1],uv:[0,0],uv1:[0,0]},this.index0AttributeName=void 0,this.uniformsNeedUpdate=!1,this.glslVersion=null,parameters!==void 0&&this.setValues(parameters)}copy(source){return super.copy(source),this.fragmentShader=source.fragmentShader,this.vertexShader=source.vertexShader,this.uniforms=cloneUniforms(source.uniforms),this.uniformsGroups=cloneUniformsGroups(source.uniformsGroups),this.defines=Object.assign({},source.defines),this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.fog=source.fog,this.lights=source.lights,this.clipping=source.clipping,this.extensions=Object.assign({},source.extensions),this.glslVersion=source.glslVersion,this}toJSON(meta){const data=super.toJSON(meta);data.glslVersion=this.glslVersion,data.uniforms={};for(const name in this.uniforms){const value=this.uniforms[name].value;value&&value.isTexture?data.uniforms[name]={type:"t",value:value.toJSON(meta).uuid}:value&&value.isColor?data.uniforms[name]={type:"c",value:value.getHex()}:value&&value.isVector2?data.uniforms[name]={type:"v2",value:value.toArray()}:value&&value.isVector3?data.uniforms[name]={type:"v3",value:value.toArray()}:value&&value.isVector4?data.uniforms[name]={type:"v4",value:value.toArray()}:value&&value.isMatrix3?data.uniforms[name]={type:"m3",value:value.toArray()}:value&&value.isMatrix4?data.uniforms[name]={type:"m4",value:value.toArray()}:data.uniforms[name]={value}}Object.keys(this.defines).length>0&&(data.defines=this.defines),data.vertexShader=this.vertexShader,data.fragmentShader=this.fragmentShader,data.lights=this.lights,data.clipping=this.clipping;const extensions={};for(const key2 in this.extensions)this.extensions[key2]===!0&&(extensions[key2]=!0);return Object.keys(extensions).length>0&&(data.extensions=extensions),data}}class Camera extends Object3D{constructor(){super(),this.isCamera=!0,this.type="Camera",this.matrixWorldInverse=new Matrix4,this.projectionMatrix=new Matrix4,this.projectionMatrixInverse=new Matrix4,this.coordinateSystem=WebGLCoordinateSystem}copy(source,recursive){return super.copy(source,recursive),this.matrixWorldInverse.copy(source.matrixWorldInverse),this.projectionMatrix.copy(source.projectionMatrix),this.projectionMatrixInverse.copy(source.projectionMatrixInverse),this.coordinateSystem=source.coordinateSystem,this}getWorldDirection(target){return super.getWorldDirection(target).negate()}updateMatrixWorld(force){super.updateMatrixWorld(force),this.matrixWorldInverse.copy(this.matrixWorld).invert()}updateWorldMatrix(updateParents,updateChildren){super.updateWorldMatrix(updateParents,updateChildren),this.matrixWorldInverse.copy(this.matrixWorld).invert()}clone(){return new this.constructor().copy(this)}}const _v3$1=new Vector3,_minTarget=new Vector2,_maxTarget=new Vector2;class PerspectiveCamera extends Camera{constructor(fov2=50,aspect2=1,near=.1,far=2e3){super(),this.isPerspectiveCamera=!0,this.type="PerspectiveCamera",this.fov=fov2,this.zoom=1,this.near=near,this.far=far,this.focus=10,this.aspect=aspect2,this.view=null,this.filmGauge=35,this.filmOffset=0,this.updateProjectionMatrix()}copy(source,recursive){return super.copy(source,recursive),this.fov=source.fov,this.zoom=source.zoom,this.near=source.near,this.far=source.far,this.focus=source.focus,this.aspect=source.aspect,this.view=source.view===null?null:Object.assign({},source.view),this.filmGauge=source.filmGauge,this.filmOffset=source.filmOffset,this}setFocalLength(focalLength){const vExtentSlope=.5*this.getFilmHeight()/focalLength;this.fov=RAD2DEG*2*Math.atan(vExtentSlope),this.updateProjectionMatrix()}getFocalLength(){const vExtentSlope=Math.tan(DEG2RAD*.5*this.fov);return .5*this.getFilmHeight()/vExtentSlope}getEffectiveFOV(){return RAD2DEG*2*Math.atan(Math.tan(DEG2RAD*.5*this.fov)/this.zoom)}getFilmWidth(){return this.filmGauge*Math.min(this.aspect,1)}getFilmHeight(){return this.filmGauge/Math.max(this.aspect,1)}getViewBounds(distance2,minTarget,maxTarget){_v3$1.set(-1,-1,.5).applyMatrix4(this.projectionMatrixInverse),minTarget.set(_v3$1.x,_v3$1.y).multiplyScalar(-distance2/_v3$1.z),_v3$1.set(1,1,.5).applyMatrix4(this.projectionMatrixInverse),maxTarget.set(_v3$1.x,_v3$1.y).multiplyScalar(-distance2/_v3$1.z)}getViewSize(distance2,target){return this.getViewBounds(distance2,_minTarget,_maxTarget),target.subVectors(_maxTarget,_minTarget)}setViewOffset(fullWidth,fullHeight,x,y,width,height){this.aspect=fullWidth/fullHeight,this.view===null&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=fullWidth,this.view.fullHeight=fullHeight,this.view.offsetX=x,this.view.offsetY=y,this.view.width=width,this.view.height=height,this.updateProjectionMatrix()}clearViewOffset(){this.view!==null&&(this.view.enabled=!1),this.updateProjectionMatrix()}updateProjectionMatrix(){const near=this.near;let top=near*Math.tan(DEG2RAD*.5*this.fov)/this.zoom,height=2*top,width=this.aspect*height,left=-.5*width;const view=this.view;if(this.view!==null&&this.view.enabled){const fullWidth=view.fullWidth,fullHeight=view.fullHeight;left+=view.offsetX*width/fullWidth,top-=view.offsetY*height/fullHeight,width*=view.width/fullWidth,height*=view.height/fullHeight}const skew=this.filmOffset;skew!==0&&(left+=near*skew/this.getFilmWidth()),this.projectionMatrix.makePerspective(left,left+width,top,top-height,near,this.far,this.coordinateSystem),this.projectionMatrixInverse.copy(this.projectionMatrix).invert()}toJSON(meta){const data=super.toJSON(meta);return data.object.fov=this.fov,data.object.zoom=this.zoom,data.object.near=this.near,data.object.far=this.far,data.object.focus=this.focus,data.object.aspect=this.aspect,this.view!==null&&(data.object.view=Object.assign({},this.view)),data.object.filmGauge=this.filmGauge,data.object.filmOffset=this.filmOffset,data}}const fov=-90,aspect=1;class CubeCamera extends Object3D{constructor(near,far,renderTarget){super(),this.type="CubeCamera",this.renderTarget=renderTarget,this.coordinateSystem=null,this.activeMipmapLevel=0;const cameraPX=new PerspectiveCamera(fov,aspect,near,far);cameraPX.layers=this.layers,this.add(cameraPX);const cameraNX=new PerspectiveCamera(fov,aspect,near,far);cameraNX.layers=this.layers,this.add(cameraNX);const cameraPY=new PerspectiveCamera(fov,aspect,near,far);cameraPY.layers=this.layers,this.add(cameraPY);const cameraNY=new PerspectiveCamera(fov,aspect,near,far);cameraNY.layers=this.layers,this.add(cameraNY);const cameraPZ=new PerspectiveCamera(fov,aspect,near,far);cameraPZ.layers=this.layers,this.add(cameraPZ);const cameraNZ=new PerspectiveCamera(fov,aspect,near,far);cameraNZ.layers=this.layers,this.add(cameraNZ)}updateCoordinateSystem(){const coordinateSystem=this.coordinateSystem,cameras=this.children.concat(),[cameraPX,cameraNX,cameraPY,cameraNY,cameraPZ,cameraNZ]=cameras;for(const camera of cameras)this.remove(camera);if(coordinateSystem===WebGLCoordinateSystem)cameraPX.up.set(0,1,0),cameraPX.lookAt(1,0,0),cameraNX.up.set(0,1,0),cameraNX.lookAt(-1,0,0),cameraPY.up.set(0,0,-1),cameraPY.lookAt(0,1,0),cameraNY.up.set(0,0,1),cameraNY.lookAt(0,-1,0),cameraPZ.up.set(0,1,0),cameraPZ.lookAt(0,0,1),cameraNZ.up.set(0,1,0),cameraNZ.lookAt(0,0,-1);else if(coordinateSystem===WebGPUCoordinateSystem)cameraPX.up.set(0,-1,0),cameraPX.lookAt(-1,0,0),cameraNX.up.set(0,-1,0),cameraNX.lookAt(1,0,0),cameraPY.up.set(0,0,1),cameraPY.lookAt(0,1,0),cameraNY.up.set(0,0,-1),cameraNY.lookAt(0,-1,0),cameraPZ.up.set(0,-1,0),cameraPZ.lookAt(0,0,1),cameraNZ.up.set(0,-1,0),cameraNZ.lookAt(0,0,-1);else throw new Error("THREE.CubeCamera.updateCoordinateSystem(): Invalid coordinate system: "+coordinateSystem);for(const camera of cameras)this.add(camera),camera.updateMatrixWorld()}update(renderer,scene){this.parent===null&&this.updateMatrixWorld();const{renderTarget,activeMipmapLevel}=this;this.coordinateSystem!==renderer.coordinateSystem&&(this.coordinateSystem=renderer.coordinateSystem,this.updateCoordinateSystem());const[cameraPX,cameraNX,cameraPY,cameraNY,cameraPZ,cameraNZ]=this.children,currentRenderTarget=renderer.getRenderTarget(),currentActiveCubeFace=renderer.getActiveCubeFace(),currentActiveMipmapLevel=renderer.getActiveMipmapLevel(),currentXrEnabled=renderer.xr.enabled;renderer.xr.enabled=!1;const generateMipmaps=renderTarget.texture.generateMipmaps;renderTarget.texture.generateMipmaps=!1,renderer.setRenderTarget(renderTarget,0,activeMipmapLevel),renderer.render(scene,cameraPX),renderer.setRenderTarget(renderTarget,1,activeMipmapLevel),renderer.render(scene,cameraNX),renderer.setRenderTarget(renderTarget,2,activeMipmapLevel),renderer.render(scene,cameraPY),renderer.setRenderTarget(renderTarget,3,activeMipmapLevel),renderer.render(scene,cameraNY),renderer.setRenderTarget(renderTarget,4,activeMipmapLevel),renderer.render(scene,cameraPZ),renderTarget.texture.generateMipmaps=generateMipmaps,renderer.setRenderTarget(renderTarget,5,activeMipmapLevel),renderer.render(scene,cameraNZ),renderer.setRenderTarget(currentRenderTarget,currentActiveCubeFace,currentActiveMipmapLevel),renderer.xr.enabled=currentXrEnabled,renderTarget.texture.needsPMREMUpdate=!0}}class CubeTexture extends Texture{constructor(images,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2,colorSpace){images=images!==void 0?images:[],mapping=mapping!==void 0?mapping:CubeReflectionMapping,super(images,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2,colorSpace),this.isCubeTexture=!0,this.flipY=!1}get images(){return this.image}set images(value){this.image=value}}class WebGLCubeRenderTarget extends WebGLRenderTarget{constructor(size=1,options={}){super(size,size,options),this.isWebGLCubeRenderTarget=!0;const image={width:size,height:size,depth:1},images=[image,image,image,image,image,image];this.texture=new CubeTexture(images,options.mapping,options.wrapS,options.wrapT,options.magFilter,options.minFilter,options.format,options.type,options.anisotropy,options.colorSpace),this.texture.isRenderTargetTexture=!0,this.texture.generateMipmaps=options.generateMipmaps!==void 0?options.generateMipmaps:!1,this.texture.minFilter=options.minFilter!==void 0?options.minFilter:LinearFilter}fromEquirectangularTexture(renderer,texture2){this.texture.type=texture2.type,this.texture.colorSpace=texture2.colorSpace,this.texture.generateMipmaps=texture2.generateMipmaps,this.texture.minFilter=texture2.minFilter,this.texture.magFilter=texture2.magFilter;const shader={uniforms:{tEquirect:{value:null}},vertexShader:`

				varying vec3 vWorldDirection;

				vec3 transformDirection( in vec3 dir, in mat4 matrix ) {

					return normalize( ( matrix * vec4( dir, 0.0 ) ).xyz );

				}

				void main() {

					vWorldDirection = transformDirection( position, modelMatrix );

					#include <begin_vertex>
					#include <project_vertex>

				}
			`,fragmentShader:`

				uniform sampler2D tEquirect;

				varying vec3 vWorldDirection;

				#include <common>

				void main() {

					vec3 direction = normalize( vWorldDirection );

					vec2 sampleUV = equirectUv( direction );

					gl_FragColor = texture2D( tEquirect, sampleUV );

				}
			`},geometry2=new BoxGeometry(5,5,5),material=new ShaderMaterial({name:"CubemapFromEquirect",uniforms:cloneUniforms(shader.uniforms),vertexShader:shader.vertexShader,fragmentShader:shader.fragmentShader,side:BackSide,blending:NoBlending});material.uniforms.tEquirect.value=texture2;const mesh=new Mesh(geometry2,material),currentMinFilter=texture2.minFilter;return texture2.minFilter===LinearMipmapLinearFilter&&(texture2.minFilter=LinearFilter),new CubeCamera(1,10,this).update(renderer,mesh),texture2.minFilter=currentMinFilter,mesh.geometry.dispose(),mesh.material.dispose(),this}clear(renderer,color2,depth2,stencil){const currentRenderTarget=renderer.getRenderTarget();for(let i2=0;i2<6;i2++)renderer.setRenderTarget(this,i2),renderer.clear(color2,depth2,stencil);renderer.setRenderTarget(currentRenderTarget)}}class Group extends Object3D{constructor(){super(),this.isGroup=!0,this.type="Group"}}const _moveEvent={type:"move"};class WebXRController{constructor(){this._targetRay=null,this._grip=null,this._hand=null}getHandSpace(){return this._hand===null&&(this._hand=new Group,this._hand.matrixAutoUpdate=!1,this._hand.visible=!1,this._hand.joints={},this._hand.inputState={pinching:!1}),this._hand}getTargetRaySpace(){return this._targetRay===null&&(this._targetRay=new Group,this._targetRay.matrixAutoUpdate=!1,this._targetRay.visible=!1,this._targetRay.hasLinearVelocity=!1,this._targetRay.linearVelocity=new Vector3,this._targetRay.hasAngularVelocity=!1,this._targetRay.angularVelocity=new Vector3),this._targetRay}getGripSpace(){return this._grip===null&&(this._grip=new Group,this._grip.matrixAutoUpdate=!1,this._grip.visible=!1,this._grip.hasLinearVelocity=!1,this._grip.linearVelocity=new Vector3,this._grip.hasAngularVelocity=!1,this._grip.angularVelocity=new Vector3),this._grip}dispatchEvent(event){return this._targetRay!==null&&this._targetRay.dispatchEvent(event),this._grip!==null&&this._grip.dispatchEvent(event),this._hand!==null&&this._hand.dispatchEvent(event),this}connect(inputSource){if(inputSource&&inputSource.hand){const hand=this._hand;if(hand)for(const inputjoint of inputSource.hand.values())this._getHandJoint(hand,inputjoint)}return this.dispatchEvent({type:"connected",data:inputSource}),this}disconnect(inputSource){return this.dispatchEvent({type:"disconnected",data:inputSource}),this._targetRay!==null&&(this._targetRay.visible=!1),this._grip!==null&&(this._grip.visible=!1),this._hand!==null&&(this._hand.visible=!1),this}update(inputSource,frame,referenceSpace){let inputPose=null,gripPose=null,handPose=null;const targetRay=this._targetRay,grip=this._grip,hand=this._hand;if(inputSource&&frame.session.visibilityState!=="visible-blurred"){if(hand&&inputSource.hand){handPose=!0;for(const inputjoint of inputSource.hand.values()){const jointPose=frame.getJointPose(inputjoint,referenceSpace),joint=this._getHandJoint(hand,inputjoint);jointPose!==null&&(joint.matrix.fromArray(jointPose.transform.matrix),joint.matrix.decompose(joint.position,joint.rotation,joint.scale),joint.matrixWorldNeedsUpdate=!0,joint.jointRadius=jointPose.radius),joint.visible=jointPose!==null}const indexTip=hand.joints["index-finger-tip"],thumbTip=hand.joints["thumb-tip"],distance2=indexTip.position.distanceTo(thumbTip.position),distanceToPinch=.02,threshold=.005;hand.inputState.pinching&&distance2>distanceToPinch+threshold?(hand.inputState.pinching=!1,this.dispatchEvent({type:"pinchend",handedness:inputSource.handedness,target:this})):!hand.inputState.pinching&&distance2<=distanceToPinch-threshold&&(hand.inputState.pinching=!0,this.dispatchEvent({type:"pinchstart",handedness:inputSource.handedness,target:this}))}else grip!==null&&inputSource.gripSpace&&(gripPose=frame.getPose(inputSource.gripSpace,referenceSpace),gripPose!==null&&(grip.matrix.fromArray(gripPose.transform.matrix),grip.matrix.decompose(grip.position,grip.rotation,grip.scale),grip.matrixWorldNeedsUpdate=!0,gripPose.linearVelocity?(grip.hasLinearVelocity=!0,grip.linearVelocity.copy(gripPose.linearVelocity)):grip.hasLinearVelocity=!1,gripPose.angularVelocity?(grip.hasAngularVelocity=!0,grip.angularVelocity.copy(gripPose.angularVelocity)):grip.hasAngularVelocity=!1));targetRay!==null&&(inputPose=frame.getPose(inputSource.targetRaySpace,referenceSpace),inputPose===null&&gripPose!==null&&(inputPose=gripPose),inputPose!==null&&(targetRay.matrix.fromArray(inputPose.transform.matrix),targetRay.matrix.decompose(targetRay.position,targetRay.rotation,targetRay.scale),targetRay.matrixWorldNeedsUpdate=!0,inputPose.linearVelocity?(targetRay.hasLinearVelocity=!0,targetRay.linearVelocity.copy(inputPose.linearVelocity)):targetRay.hasLinearVelocity=!1,inputPose.angularVelocity?(targetRay.hasAngularVelocity=!0,targetRay.angularVelocity.copy(inputPose.angularVelocity)):targetRay.hasAngularVelocity=!1,this.dispatchEvent(_moveEvent)))}return targetRay!==null&&(targetRay.visible=inputPose!==null),grip!==null&&(grip.visible=gripPose!==null),hand!==null&&(hand.visible=handPose!==null),this}_getHandJoint(hand,inputjoint){if(hand.joints[inputjoint.jointName]===void 0){const joint=new Group;joint.matrixAutoUpdate=!1,joint.visible=!1,hand.joints[inputjoint.jointName]=joint,hand.add(joint)}return hand.joints[inputjoint.jointName]}}class Scene extends Object3D{constructor(){super(),this.isScene=!0,this.type="Scene",this.background=null,this.environment=null,this.fog=null,this.backgroundBlurriness=0,this.backgroundIntensity=1,this.backgroundRotation=new Euler,this.environmentIntensity=1,this.environmentRotation=new Euler,this.overrideMaterial=null,typeof __THREE_DEVTOOLS__<"u"&&__THREE_DEVTOOLS__.dispatchEvent(new CustomEvent("observe",{detail:this}))}copy(source,recursive){return super.copy(source,recursive),source.background!==null&&(this.background=source.background.clone()),source.environment!==null&&(this.environment=source.environment.clone()),source.fog!==null&&(this.fog=source.fog.clone()),this.backgroundBlurriness=source.backgroundBlurriness,this.backgroundIntensity=source.backgroundIntensity,this.backgroundRotation.copy(source.backgroundRotation),this.environmentIntensity=source.environmentIntensity,this.environmentRotation.copy(source.environmentRotation),source.overrideMaterial!==null&&(this.overrideMaterial=source.overrideMaterial.clone()),this.matrixAutoUpdate=source.matrixAutoUpdate,this}toJSON(meta){const data=super.toJSON(meta);return this.fog!==null&&(data.object.fog=this.fog.toJSON()),this.backgroundBlurriness>0&&(data.object.backgroundBlurriness=this.backgroundBlurriness),this.backgroundIntensity!==1&&(data.object.backgroundIntensity=this.backgroundIntensity),data.object.backgroundRotation=this.backgroundRotation.toArray(),this.environmentIntensity!==1&&(data.object.environmentIntensity=this.environmentIntensity),data.object.environmentRotation=this.environmentRotation.toArray(),data}}class InterleavedBuffer{constructor(array2,stride){this.isInterleavedBuffer=!0,this.array=array2,this.stride=stride,this.count=array2!==void 0?array2.length/stride:0,this.usage=StaticDrawUsage,this.updateRanges=[],this.version=0,this.uuid=generateUUID()}onUploadCallback(){}set needsUpdate(value){value===!0&&this.version++}setUsage(value){return this.usage=value,this}addUpdateRange(start,count){this.updateRanges.push({start,count})}clearUpdateRanges(){this.updateRanges.length=0}copy(source){return this.array=new source.array.constructor(source.array),this.count=source.count,this.stride=source.stride,this.usage=source.usage,this}copyAt(index1,attribute2,index2){index1*=this.stride,index2*=attribute2.stride;for(let i2=0,l2=this.stride;i2<l2;i2++)this.array[index1+i2]=attribute2.array[index2+i2];return this}set(value,offset=0){return this.array.set(value,offset),this}clone(data){data.arrayBuffers===void 0&&(data.arrayBuffers={}),this.array.buffer._uuid===void 0&&(this.array.buffer._uuid=generateUUID()),data.arrayBuffers[this.array.buffer._uuid]===void 0&&(data.arrayBuffers[this.array.buffer._uuid]=this.array.slice(0).buffer);const array2=new this.array.constructor(data.arrayBuffers[this.array.buffer._uuid]),ib=new this.constructor(array2,this.stride);return ib.setUsage(this.usage),ib}onUpload(callback){return this.onUploadCallback=callback,this}toJSON(data){return data.arrayBuffers===void 0&&(data.arrayBuffers={}),this.array.buffer._uuid===void 0&&(this.array.buffer._uuid=generateUUID()),data.arrayBuffers[this.array.buffer._uuid]===void 0&&(data.arrayBuffers[this.array.buffer._uuid]=Array.from(new Uint32Array(this.array.buffer))),{uuid:this.uuid,buffer:this.array.buffer._uuid,type:this.array.constructor.name,stride:this.stride}}}const _vector$7=new Vector3;class InterleavedBufferAttribute{constructor(interleavedBuffer,itemSize,offset,normalized=!1){this.isInterleavedBufferAttribute=!0,this.name="",this.data=interleavedBuffer,this.itemSize=itemSize,this.offset=offset,this.normalized=normalized}get count(){return this.data.count}get array(){return this.data.array}set needsUpdate(value){this.data.needsUpdate=value}applyMatrix4(m){for(let i2=0,l2=this.data.count;i2<l2;i2++)_vector$7.fromBufferAttribute(this,i2),_vector$7.applyMatrix4(m),this.setXYZ(i2,_vector$7.x,_vector$7.y,_vector$7.z);return this}applyNormalMatrix(m){for(let i2=0,l2=this.count;i2<l2;i2++)_vector$7.fromBufferAttribute(this,i2),_vector$7.applyNormalMatrix(m),this.setXYZ(i2,_vector$7.x,_vector$7.y,_vector$7.z);return this}transformDirection(m){for(let i2=0,l2=this.count;i2<l2;i2++)_vector$7.fromBufferAttribute(this,i2),_vector$7.transformDirection(m),this.setXYZ(i2,_vector$7.x,_vector$7.y,_vector$7.z);return this}getComponent(index,component){let value=this.array[index*this.data.stride+this.offset+component];return this.normalized&&(value=denormalize(value,this.array)),value}setComponent(index,component,value){return this.normalized&&(value=normalize$2(value,this.array)),this.data.array[index*this.data.stride+this.offset+component]=value,this}setX(index,x){return this.normalized&&(x=normalize$2(x,this.array)),this.data.array[index*this.data.stride+this.offset]=x,this}setY(index,y){return this.normalized&&(y=normalize$2(y,this.array)),this.data.array[index*this.data.stride+this.offset+1]=y,this}setZ(index,z){return this.normalized&&(z=normalize$2(z,this.array)),this.data.array[index*this.data.stride+this.offset+2]=z,this}setW(index,w){return this.normalized&&(w=normalize$2(w,this.array)),this.data.array[index*this.data.stride+this.offset+3]=w,this}getX(index){let x=this.data.array[index*this.data.stride+this.offset];return this.normalized&&(x=denormalize(x,this.array)),x}getY(index){let y=this.data.array[index*this.data.stride+this.offset+1];return this.normalized&&(y=denormalize(y,this.array)),y}getZ(index){let z=this.data.array[index*this.data.stride+this.offset+2];return this.normalized&&(z=denormalize(z,this.array)),z}getW(index){let w=this.data.array[index*this.data.stride+this.offset+3];return this.normalized&&(w=denormalize(w,this.array)),w}setXY(index,x,y){return index=index*this.data.stride+this.offset,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array)),this.data.array[index+0]=x,this.data.array[index+1]=y,this}setXYZ(index,x,y,z){return index=index*this.data.stride+this.offset,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array)),this.data.array[index+0]=x,this.data.array[index+1]=y,this.data.array[index+2]=z,this}setXYZW(index,x,y,z,w){return index=index*this.data.stride+this.offset,this.normalized&&(x=normalize$2(x,this.array),y=normalize$2(y,this.array),z=normalize$2(z,this.array),w=normalize$2(w,this.array)),this.data.array[index+0]=x,this.data.array[index+1]=y,this.data.array[index+2]=z,this.data.array[index+3]=w,this}clone(data){if(data===void 0){console.log("THREE.InterleavedBufferAttribute.clone(): Cloning an interleaved buffer attribute will de-interleave buffer data.");const array2=[];for(let i2=0;i2<this.count;i2++){const index=i2*this.data.stride+this.offset;for(let j=0;j<this.itemSize;j++)array2.push(this.data.array[index+j])}return new BufferAttribute(new this.array.constructor(array2),this.itemSize,this.normalized)}else return data.interleavedBuffers===void 0&&(data.interleavedBuffers={}),data.interleavedBuffers[this.data.uuid]===void 0&&(data.interleavedBuffers[this.data.uuid]=this.data.clone(data)),new InterleavedBufferAttribute(data.interleavedBuffers[this.data.uuid],this.itemSize,this.offset,this.normalized)}toJSON(data){if(data===void 0){console.log("THREE.InterleavedBufferAttribute.toJSON(): Serializing an interleaved buffer attribute will de-interleave buffer data.");const array2=[];for(let i2=0;i2<this.count;i2++){const index=i2*this.data.stride+this.offset;for(let j=0;j<this.itemSize;j++)array2.push(this.data.array[index+j])}return{itemSize:this.itemSize,type:this.array.constructor.name,array:array2,normalized:this.normalized}}else return data.interleavedBuffers===void 0&&(data.interleavedBuffers={}),data.interleavedBuffers[this.data.uuid]===void 0&&(data.interleavedBuffers[this.data.uuid]=this.data.toJSON(data)),{isInterleavedBufferAttribute:!0,itemSize:this.itemSize,data:this.data.uuid,offset:this.offset,normalized:this.normalized}}}class SpriteMaterial extends Material{constructor(parameters){super(),this.isSpriteMaterial=!0,this.type="SpriteMaterial",this.color=new Color(16777215),this.map=null,this.alphaMap=null,this.rotation=0,this.sizeAttenuation=!0,this.transparent=!0,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.alphaMap=source.alphaMap,this.rotation=source.rotation,this.sizeAttenuation=source.sizeAttenuation,this.fog=source.fog,this}}let _geometry$1;const _intersectPoint=new Vector3,_worldScale=new Vector3,_mvPosition=new Vector3,_alignedPosition=new Vector2,_rotatedPosition=new Vector2,_viewWorldMatrix=new Matrix4,_vA=new Vector3,_vB=new Vector3,_vC=new Vector3,_uvA=new Vector2,_uvB=new Vector2,_uvC=new Vector2;class Sprite extends Object3D{constructor(material=new SpriteMaterial){if(super(),this.isSprite=!0,this.type="Sprite",_geometry$1===void 0){_geometry$1=new BufferGeometry;const float32Array=new Float32Array([-.5,-.5,0,0,0,.5,-.5,0,1,0,.5,.5,0,1,1,-.5,.5,0,0,1]),interleavedBuffer=new InterleavedBuffer(float32Array,5);_geometry$1.setIndex([0,1,2,0,2,3]),_geometry$1.setAttribute("position",new InterleavedBufferAttribute(interleavedBuffer,3,0,!1)),_geometry$1.setAttribute("uv",new InterleavedBufferAttribute(interleavedBuffer,2,3,!1))}this.geometry=_geometry$1,this.material=material,this.center=new Vector2(.5,.5)}raycast(raycaster,intersects2){raycaster.camera===null&&console.error('THREE.Sprite: "Raycaster.camera" needs to be set in order to raycast against sprites.'),_worldScale.setFromMatrixScale(this.matrixWorld),_viewWorldMatrix.copy(raycaster.camera.matrixWorld),this.modelViewMatrix.multiplyMatrices(raycaster.camera.matrixWorldInverse,this.matrixWorld),_mvPosition.setFromMatrixPosition(this.modelViewMatrix),raycaster.camera.isPerspectiveCamera&&this.material.sizeAttenuation===!1&&_worldScale.multiplyScalar(-_mvPosition.z);const rotation2=this.material.rotation;let sin2,cos2;rotation2!==0&&(cos2=Math.cos(rotation2),sin2=Math.sin(rotation2));const center=this.center;transformVertex(_vA.set(-.5,-.5,0),_mvPosition,center,_worldScale,sin2,cos2),transformVertex(_vB.set(.5,-.5,0),_mvPosition,center,_worldScale,sin2,cos2),transformVertex(_vC.set(.5,.5,0),_mvPosition,center,_worldScale,sin2,cos2),_uvA.set(0,0),_uvB.set(1,0),_uvC.set(1,1);let intersect=raycaster.ray.intersectTriangle(_vA,_vB,_vC,!1,_intersectPoint);if(intersect===null&&(transformVertex(_vB.set(-.5,.5,0),_mvPosition,center,_worldScale,sin2,cos2),_uvB.set(0,1),intersect=raycaster.ray.intersectTriangle(_vA,_vC,_vB,!1,_intersectPoint),intersect===null))return;const distance2=raycaster.ray.origin.distanceTo(_intersectPoint);distance2<raycaster.near||distance2>raycaster.far||intersects2.push({distance:distance2,point:_intersectPoint.clone(),uv:Triangle.getInterpolation(_intersectPoint,_vA,_vB,_vC,_uvA,_uvB,_uvC,new Vector2),face:null,object:this})}copy(source,recursive){return super.copy(source,recursive),source.center!==void 0&&this.center.copy(source.center),this.material=source.material,this}}function transformVertex(vertexPosition,mvPosition,center,scale2,sin2,cos2){_alignedPosition.subVectors(vertexPosition,center).addScalar(.5).multiply(scale2),sin2!==void 0?(_rotatedPosition.x=cos2*_alignedPosition.x-sin2*_alignedPosition.y,_rotatedPosition.y=sin2*_alignedPosition.x+cos2*_alignedPosition.y):_rotatedPosition.copy(_alignedPosition),vertexPosition.copy(mvPosition),vertexPosition.x+=_rotatedPosition.x,vertexPosition.y+=_rotatedPosition.y,vertexPosition.applyMatrix4(_viewWorldMatrix)}class DataTexture extends Texture{constructor(data=null,width=1,height=1,format,type,mapping,wrapS,wrapT,magFilter=NearestFilter,minFilter=NearestFilter,anisotropy2,colorSpace){super(null,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2,colorSpace),this.isDataTexture=!0,this.image={data,width,height},this.generateMipmaps=!1,this.flipY=!1,this.unpackAlignment=1}}class InstancedBufferAttribute extends BufferAttribute{constructor(array2,itemSize,normalized,meshPerAttribute=1){super(array2,itemSize,normalized),this.isInstancedBufferAttribute=!0,this.meshPerAttribute=meshPerAttribute}copy(source){return super.copy(source),this.meshPerAttribute=source.meshPerAttribute,this}toJSON(){const data=super.toJSON();return data.meshPerAttribute=this.meshPerAttribute,data.isInstancedBufferAttribute=!0,data}}const _instanceLocalMatrix=new Matrix4,_instanceWorldMatrix=new Matrix4,_instanceIntersects=[],_box3=new Box3,_identity=new Matrix4,_mesh$1=new Mesh,_sphere$4=new Sphere;class InstancedMesh extends Mesh{constructor(geometry2,material,count){super(geometry2,material),this.isInstancedMesh=!0,this.instanceMatrix=new InstancedBufferAttribute(new Float32Array(count*16),16),this.instanceColor=null,this.morphTexture=null,this.count=count,this.boundingBox=null,this.boundingSphere=null;for(let i2=0;i2<count;i2++)this.setMatrixAt(i2,_identity)}computeBoundingBox(){const geometry2=this.geometry,count=this.count;this.boundingBox===null&&(this.boundingBox=new Box3),geometry2.boundingBox===null&&geometry2.computeBoundingBox(),this.boundingBox.makeEmpty();for(let i2=0;i2<count;i2++)this.getMatrixAt(i2,_instanceLocalMatrix),_box3.copy(geometry2.boundingBox).applyMatrix4(_instanceLocalMatrix),this.boundingBox.union(_box3)}computeBoundingSphere(){const geometry2=this.geometry,count=this.count;this.boundingSphere===null&&(this.boundingSphere=new Sphere),geometry2.boundingSphere===null&&geometry2.computeBoundingSphere(),this.boundingSphere.makeEmpty();for(let i2=0;i2<count;i2++)this.getMatrixAt(i2,_instanceLocalMatrix),_sphere$4.copy(geometry2.boundingSphere).applyMatrix4(_instanceLocalMatrix),this.boundingSphere.union(_sphere$4)}copy(source,recursive){return super.copy(source,recursive),this.instanceMatrix.copy(source.instanceMatrix),source.morphTexture!==null&&(this.morphTexture=source.morphTexture.clone()),source.instanceColor!==null&&(this.instanceColor=source.instanceColor.clone()),this.count=source.count,source.boundingBox!==null&&(this.boundingBox=source.boundingBox.clone()),source.boundingSphere!==null&&(this.boundingSphere=source.boundingSphere.clone()),this}getColorAt(index,color2){color2.fromArray(this.instanceColor.array,index*3)}getMatrixAt(index,matrix){matrix.fromArray(this.instanceMatrix.array,index*16)}getMorphAt(index,object){const objectInfluences=object.morphTargetInfluences,array2=this.morphTexture.source.data.data,len=objectInfluences.length+1,dataIndex=index*len+1;for(let i2=0;i2<objectInfluences.length;i2++)objectInfluences[i2]=array2[dataIndex+i2]}raycast(raycaster,intersects2){const matrixWorld=this.matrixWorld,raycastTimes=this.count;if(_mesh$1.geometry=this.geometry,_mesh$1.material=this.material,_mesh$1.material!==void 0&&(this.boundingSphere===null&&this.computeBoundingSphere(),_sphere$4.copy(this.boundingSphere),_sphere$4.applyMatrix4(matrixWorld),raycaster.ray.intersectsSphere(_sphere$4)!==!1))for(let instanceId=0;instanceId<raycastTimes;instanceId++){this.getMatrixAt(instanceId,_instanceLocalMatrix),_instanceWorldMatrix.multiplyMatrices(matrixWorld,_instanceLocalMatrix),_mesh$1.matrixWorld=_instanceWorldMatrix,_mesh$1.raycast(raycaster,_instanceIntersects);for(let i2=0,l2=_instanceIntersects.length;i2<l2;i2++){const intersect=_instanceIntersects[i2];intersect.instanceId=instanceId,intersect.object=this,intersects2.push(intersect)}_instanceIntersects.length=0}}setColorAt(index,color2){this.instanceColor===null&&(this.instanceColor=new InstancedBufferAttribute(new Float32Array(this.instanceMatrix.count*3).fill(1),3)),color2.toArray(this.instanceColor.array,index*3)}setMatrixAt(index,matrix){matrix.toArray(this.instanceMatrix.array,index*16)}setMorphAt(index,object){const objectInfluences=object.morphTargetInfluences,len=objectInfluences.length+1;this.morphTexture===null&&(this.morphTexture=new DataTexture(new Float32Array(len*this.count),len,this.count,RedFormat,FloatType));const array2=this.morphTexture.source.data.data;let morphInfluencesSum=0;for(let i2=0;i2<objectInfluences.length;i2++)morphInfluencesSum+=objectInfluences[i2];const morphBaseInfluence=this.geometry.morphTargetsRelative?1:1-morphInfluencesSum,dataIndex=len*index;array2[dataIndex]=morphBaseInfluence,array2.set(objectInfluences,dataIndex+1)}updateMorphTargets(){}dispose(){return this.dispatchEvent({type:"dispose"}),this.morphTexture!==null&&(this.morphTexture.dispose(),this.morphTexture=null),this}}const _vector1=new Vector3,_vector2$2=new Vector3,_normalMatrix=new Matrix3;class Plane{constructor(normal2=new Vector3(1,0,0),constant=0){this.isPlane=!0,this.normal=normal2,this.constant=constant}set(normal2,constant){return this.normal.copy(normal2),this.constant=constant,this}setComponents(x,y,z,w){return this.normal.set(x,y,z),this.constant=w,this}setFromNormalAndCoplanarPoint(normal2,point){return this.normal.copy(normal2),this.constant=-point.dot(this.normal),this}setFromCoplanarPoints(a2,b,c2){const normal2=_vector1.subVectors(c2,b).cross(_vector2$2.subVectors(a2,b)).normalize();return this.setFromNormalAndCoplanarPoint(normal2,a2),this}copy(plane){return this.normal.copy(plane.normal),this.constant=plane.constant,this}normalize(){const inverseNormalLength=1/this.normal.length();return this.normal.multiplyScalar(inverseNormalLength),this.constant*=inverseNormalLength,this}negate(){return this.constant*=-1,this.normal.negate(),this}distanceToPoint(point){return this.normal.dot(point)+this.constant}distanceToSphere(sphere){return this.distanceToPoint(sphere.center)-sphere.radius}projectPoint(point,target){return target.copy(point).addScaledVector(this.normal,-this.distanceToPoint(point))}intersectLine(line,target){const direction=line.delta(_vector1),denominator=this.normal.dot(direction);if(denominator===0)return this.distanceToPoint(line.start)===0?target.copy(line.start):null;const t2=-(line.start.dot(this.normal)+this.constant)/denominator;return t2<0||t2>1?null:target.copy(line.start).addScaledVector(direction,t2)}intersectsLine(line){const startSign=this.distanceToPoint(line.start),endSign=this.distanceToPoint(line.end);return startSign<0&&endSign>0||endSign<0&&startSign>0}intersectsBox(box){return box.intersectsPlane(this)}intersectsSphere(sphere){return sphere.intersectsPlane(this)}coplanarPoint(target){return target.copy(this.normal).multiplyScalar(-this.constant)}applyMatrix4(matrix,optionalNormalMatrix){const normalMatrix=optionalNormalMatrix||_normalMatrix.getNormalMatrix(matrix),referencePoint=this.coplanarPoint(_vector1).applyMatrix4(matrix),normal2=this.normal.applyMatrix3(normalMatrix).normalize();return this.constant=-referencePoint.dot(normal2),this}translate(offset){return this.constant-=offset.dot(this.normal),this}equals(plane){return plane.normal.equals(this.normal)&&plane.constant===this.constant}clone(){return new this.constructor().copy(this)}}const _sphere$3=new Sphere,_vector$6=new Vector3;class Frustum{constructor(p0=new Plane,p1=new Plane,p2=new Plane,p3=new Plane,p4=new Plane,p5=new Plane){this.planes=[p0,p1,p2,p3,p4,p5]}set(p0,p1,p2,p3,p4,p5){const planes=this.planes;return planes[0].copy(p0),planes[1].copy(p1),planes[2].copy(p2),planes[3].copy(p3),planes[4].copy(p4),planes[5].copy(p5),this}copy(frustum){const planes=this.planes;for(let i2=0;i2<6;i2++)planes[i2].copy(frustum.planes[i2]);return this}setFromProjectionMatrix(m,coordinateSystem=WebGLCoordinateSystem){const planes=this.planes,me=m.elements,me0=me[0],me1=me[1],me2=me[2],me3=me[3],me4=me[4],me5=me[5],me6=me[6],me7=me[7],me8=me[8],me9=me[9],me10=me[10],me11=me[11],me12=me[12],me13=me[13],me14=me[14],me15=me[15];if(planes[0].setComponents(me3-me0,me7-me4,me11-me8,me15-me12).normalize(),planes[1].setComponents(me3+me0,me7+me4,me11+me8,me15+me12).normalize(),planes[2].setComponents(me3+me1,me7+me5,me11+me9,me15+me13).normalize(),planes[3].setComponents(me3-me1,me7-me5,me11-me9,me15-me13).normalize(),planes[4].setComponents(me3-me2,me7-me6,me11-me10,me15-me14).normalize(),coordinateSystem===WebGLCoordinateSystem)planes[5].setComponents(me3+me2,me7+me6,me11+me10,me15+me14).normalize();else if(coordinateSystem===WebGPUCoordinateSystem)planes[5].setComponents(me2,me6,me10,me14).normalize();else throw new Error("THREE.Frustum.setFromProjectionMatrix(): Invalid coordinate system: "+coordinateSystem);return this}intersectsObject(object){if(object.boundingSphere!==void 0)object.boundingSphere===null&&object.computeBoundingSphere(),_sphere$3.copy(object.boundingSphere).applyMatrix4(object.matrixWorld);else{const geometry2=object.geometry;geometry2.boundingSphere===null&&geometry2.computeBoundingSphere(),_sphere$3.copy(geometry2.boundingSphere).applyMatrix4(object.matrixWorld)}return this.intersectsSphere(_sphere$3)}intersectsSprite(sprite){return _sphere$3.center.set(0,0,0),_sphere$3.radius=.7071067811865476,_sphere$3.applyMatrix4(sprite.matrixWorld),this.intersectsSphere(_sphere$3)}intersectsSphere(sphere){const planes=this.planes,center=sphere.center,negRadius=-sphere.radius;for(let i2=0;i2<6;i2++)if(planes[i2].distanceToPoint(center)<negRadius)return!1;return!0}intersectsBox(box){const planes=this.planes;for(let i2=0;i2<6;i2++){const plane=planes[i2];if(_vector$6.x=plane.normal.x>0?box.max.x:box.min.x,_vector$6.y=plane.normal.y>0?box.max.y:box.min.y,_vector$6.z=plane.normal.z>0?box.max.z:box.min.z,plane.distanceToPoint(_vector$6)<0)return!1}return!0}containsPoint(point){const planes=this.planes;for(let i2=0;i2<6;i2++)if(planes[i2].distanceToPoint(point)<0)return!1;return!0}clone(){return new this.constructor().copy(this)}}class LineBasicMaterial extends Material{constructor(parameters){super(),this.isLineBasicMaterial=!0,this.type="LineBasicMaterial",this.color=new Color(16777215),this.map=null,this.linewidth=1,this.linecap="round",this.linejoin="round",this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.linewidth=source.linewidth,this.linecap=source.linecap,this.linejoin=source.linejoin,this.fog=source.fog,this}}class PointsMaterial extends Material{constructor(parameters){super(),this.isPointsMaterial=!0,this.type="PointsMaterial",this.color=new Color(16777215),this.map=null,this.alphaMap=null,this.size=1,this.sizeAttenuation=!0,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.alphaMap=source.alphaMap,this.size=source.size,this.sizeAttenuation=source.sizeAttenuation,this.fog=source.fog,this}}class FramebufferTexture extends Texture{constructor(width,height){super({width,height}),this.isFramebufferTexture=!0,this.magFilter=NearestFilter,this.minFilter=NearestFilter,this.generateMipmaps=!1,this.needsUpdate=!0}}class CanvasTexture extends Texture{constructor(canvas,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2){super(canvas,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2),this.isCanvasTexture=!0,this.needsUpdate=!0}}class DepthTexture extends Texture{constructor(width,height,type,mapping,wrapS,wrapT,magFilter,minFilter,anisotropy2,format=DepthFormat){if(format!==DepthFormat&&format!==DepthStencilFormat)throw new Error("DepthTexture format must be either THREE.DepthFormat or THREE.DepthStencilFormat");type===void 0&&format===DepthFormat&&(type=UnsignedIntType),type===void 0&&format===DepthStencilFormat&&(type=UnsignedInt248Type),super(null,mapping,wrapS,wrapT,magFilter,minFilter,format,type,anisotropy2),this.isDepthTexture=!0,this.image={width,height},this.magFilter=magFilter!==void 0?magFilter:NearestFilter,this.minFilter=minFilter!==void 0?minFilter:NearestFilter,this.flipY=!1,this.generateMipmaps=!1,this.compareFunction=null}copy(source){return super.copy(source),this.compareFunction=source.compareFunction,this}toJSON(meta){const data=super.toJSON(meta);return this.compareFunction!==null&&(data.compareFunction=this.compareFunction),data}}class PlaneGeometry extends BufferGeometry{constructor(width=1,height=1,widthSegments=1,heightSegments=1){super(),this.type="PlaneGeometry",this.parameters={width,height,widthSegments,heightSegments};const width_half=width/2,height_half=height/2,gridX=Math.floor(widthSegments),gridY=Math.floor(heightSegments),gridX1=gridX+1,gridY1=gridY+1,segment_width=width/gridX,segment_height=height/gridY,indices=[],vertices=[],normals=[],uvs=[];for(let iy=0;iy<gridY1;iy++){const y=iy*segment_height-height_half;for(let ix=0;ix<gridX1;ix++){const x=ix*segment_width-width_half;vertices.push(x,-y,0),normals.push(0,0,1),uvs.push(ix/gridX),uvs.push(1-iy/gridY)}}for(let iy=0;iy<gridY;iy++)for(let ix=0;ix<gridX;ix++){const a2=ix+gridX1*iy,b=ix+gridX1*(iy+1),c2=ix+1+gridX1*(iy+1),d2=ix+1+gridX1*iy;indices.push(a2,b,d2),indices.push(b,c2,d2)}this.setIndex(indices),this.setAttribute("position",new Float32BufferAttribute(vertices,3)),this.setAttribute("normal",new Float32BufferAttribute(normals,3)),this.setAttribute("uv",new Float32BufferAttribute(uvs,2))}copy(source){return super.copy(source),this.parameters=Object.assign({},source.parameters),this}static fromJSON(data){return new PlaneGeometry(data.width,data.height,data.widthSegments,data.heightSegments)}}class SphereGeometry extends BufferGeometry{constructor(radius=1,widthSegments=32,heightSegments=16,phiStart=0,phiLength=Math.PI*2,thetaStart=0,thetaLength=Math.PI){super(),this.type="SphereGeometry",this.parameters={radius,widthSegments,heightSegments,phiStart,phiLength,thetaStart,thetaLength},widthSegments=Math.max(3,Math.floor(widthSegments)),heightSegments=Math.max(2,Math.floor(heightSegments));const thetaEnd=Math.min(thetaStart+thetaLength,Math.PI);let index=0;const grid=[],vertex=new Vector3,normal2=new Vector3,indices=[],vertices=[],normals=[],uvs=[];for(let iy=0;iy<=heightSegments;iy++){const verticesRow=[],v=iy/heightSegments;let uOffset=0;iy===0&&thetaStart===0?uOffset=.5/widthSegments:iy===heightSegments&&thetaEnd===Math.PI&&(uOffset=-.5/widthSegments);for(let ix=0;ix<=widthSegments;ix++){const u=ix/widthSegments;vertex.x=-radius*Math.cos(phiStart+u*phiLength)*Math.sin(thetaStart+v*thetaLength),vertex.y=radius*Math.cos(thetaStart+v*thetaLength),vertex.z=radius*Math.sin(phiStart+u*phiLength)*Math.sin(thetaStart+v*thetaLength),vertices.push(vertex.x,vertex.y,vertex.z),normal2.copy(vertex).normalize(),normals.push(normal2.x,normal2.y,normal2.z),uvs.push(u+uOffset,1-v),verticesRow.push(index++)}grid.push(verticesRow)}for(let iy=0;iy<heightSegments;iy++)for(let ix=0;ix<widthSegments;ix++){const a2=grid[iy][ix+1],b=grid[iy][ix],c2=grid[iy+1][ix],d2=grid[iy+1][ix+1];(iy!==0||thetaStart>0)&&indices.push(a2,b,d2),(iy!==heightSegments-1||thetaEnd<Math.PI)&&indices.push(b,c2,d2)}this.setIndex(indices),this.setAttribute("position",new Float32BufferAttribute(vertices,3)),this.setAttribute("normal",new Float32BufferAttribute(normals,3)),this.setAttribute("uv",new Float32BufferAttribute(uvs,2))}copy(source){return super.copy(source),this.parameters=Object.assign({},source.parameters),this}static fromJSON(data){return new SphereGeometry(data.radius,data.widthSegments,data.heightSegments,data.phiStart,data.phiLength,data.thetaStart,data.thetaLength)}}class ShadowMaterial extends Material{constructor(parameters){super(),this.isShadowMaterial=!0,this.type="ShadowMaterial",this.color=new Color(0),this.transparent=!0,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.fog=source.fog,this}}class MeshStandardMaterial extends Material{constructor(parameters){super(),this.isMeshStandardMaterial=!0,this.type="MeshStandardMaterial",this.defines={STANDARD:""},this.color=new Color(16777215),this.roughness=1,this.metalness=0,this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.emissive=new Color(0),this.emissiveIntensity=1,this.emissiveMap=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.roughnessMap=null,this.metalnessMap=null,this.alphaMap=null,this.envMap=null,this.envMapRotation=new Euler,this.envMapIntensity=1,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.flatShading=!1,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.defines={STANDARD:""},this.color.copy(source.color),this.roughness=source.roughness,this.metalness=source.metalness,this.map=source.map,this.lightMap=source.lightMap,this.lightMapIntensity=source.lightMapIntensity,this.aoMap=source.aoMap,this.aoMapIntensity=source.aoMapIntensity,this.emissive.copy(source.emissive),this.emissiveMap=source.emissiveMap,this.emissiveIntensity=source.emissiveIntensity,this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.roughnessMap=source.roughnessMap,this.metalnessMap=source.metalnessMap,this.alphaMap=source.alphaMap,this.envMap=source.envMap,this.envMapRotation.copy(source.envMapRotation),this.envMapIntensity=source.envMapIntensity,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.wireframeLinecap=source.wireframeLinecap,this.wireframeLinejoin=source.wireframeLinejoin,this.flatShading=source.flatShading,this.fog=source.fog,this}}class MeshPhysicalMaterial extends MeshStandardMaterial{constructor(parameters){super(),this.isMeshPhysicalMaterial=!0,this.defines={STANDARD:"",PHYSICAL:""},this.type="MeshPhysicalMaterial",this.anisotropyRotation=0,this.anisotropyMap=null,this.clearcoatMap=null,this.clearcoatRoughness=0,this.clearcoatRoughnessMap=null,this.clearcoatNormalScale=new Vector2(1,1),this.clearcoatNormalMap=null,this.ior=1.5,Object.defineProperty(this,"reflectivity",{get:function(){return clamp$4(2.5*(this.ior-1)/(this.ior+1),0,1)},set:function(reflectivity){this.ior=(1+.4*reflectivity)/(1-.4*reflectivity)}}),this.iridescenceMap=null,this.iridescenceIOR=1.3,this.iridescenceThicknessRange=[100,400],this.iridescenceThicknessMap=null,this.sheenColor=new Color(0),this.sheenColorMap=null,this.sheenRoughness=1,this.sheenRoughnessMap=null,this.transmissionMap=null,this.thickness=0,this.thicknessMap=null,this.attenuationDistance=1/0,this.attenuationColor=new Color(1,1,1),this.specularIntensity=1,this.specularIntensityMap=null,this.specularColor=new Color(1,1,1),this.specularColorMap=null,this._anisotropy=0,this._clearcoat=0,this._dispersion=0,this._iridescence=0,this._sheen=0,this._transmission=0,this.setValues(parameters)}get anisotropy(){return this._anisotropy}set anisotropy(value){this._anisotropy>0!=value>0&&this.version++,this._anisotropy=value}get clearcoat(){return this._clearcoat}set clearcoat(value){this._clearcoat>0!=value>0&&this.version++,this._clearcoat=value}get iridescence(){return this._iridescence}set iridescence(value){this._iridescence>0!=value>0&&this.version++,this._iridescence=value}get dispersion(){return this._dispersion}set dispersion(value){this._dispersion>0!=value>0&&this.version++,this._dispersion=value}get sheen(){return this._sheen}set sheen(value){this._sheen>0!=value>0&&this.version++,this._sheen=value}get transmission(){return this._transmission}set transmission(value){this._transmission>0!=value>0&&this.version++,this._transmission=value}copy(source){return super.copy(source),this.defines={STANDARD:"",PHYSICAL:""},this.anisotropy=source.anisotropy,this.anisotropyRotation=source.anisotropyRotation,this.anisotropyMap=source.anisotropyMap,this.clearcoat=source.clearcoat,this.clearcoatMap=source.clearcoatMap,this.clearcoatRoughness=source.clearcoatRoughness,this.clearcoatRoughnessMap=source.clearcoatRoughnessMap,this.clearcoatNormalMap=source.clearcoatNormalMap,this.clearcoatNormalScale.copy(source.clearcoatNormalScale),this.dispersion=source.dispersion,this.ior=source.ior,this.iridescence=source.iridescence,this.iridescenceMap=source.iridescenceMap,this.iridescenceIOR=source.iridescenceIOR,this.iridescenceThicknessRange=[...source.iridescenceThicknessRange],this.iridescenceThicknessMap=source.iridescenceThicknessMap,this.sheen=source.sheen,this.sheenColor.copy(source.sheenColor),this.sheenColorMap=source.sheenColorMap,this.sheenRoughness=source.sheenRoughness,this.sheenRoughnessMap=source.sheenRoughnessMap,this.transmission=source.transmission,this.transmissionMap=source.transmissionMap,this.thickness=source.thickness,this.thicknessMap=source.thicknessMap,this.attenuationDistance=source.attenuationDistance,this.attenuationColor.copy(source.attenuationColor),this.specularIntensity=source.specularIntensity,this.specularIntensityMap=source.specularIntensityMap,this.specularColor.copy(source.specularColor),this.specularColorMap=source.specularColorMap,this}}class MeshPhongMaterial extends Material{constructor(parameters){super(),this.isMeshPhongMaterial=!0,this.type="MeshPhongMaterial",this.color=new Color(16777215),this.specular=new Color(1118481),this.shininess=30,this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.emissive=new Color(0),this.emissiveIntensity=1,this.emissiveMap=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.envMapRotation=new Euler,this.combine=MultiplyOperation,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.flatShading=!1,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.specular.copy(source.specular),this.shininess=source.shininess,this.map=source.map,this.lightMap=source.lightMap,this.lightMapIntensity=source.lightMapIntensity,this.aoMap=source.aoMap,this.aoMapIntensity=source.aoMapIntensity,this.emissive.copy(source.emissive),this.emissiveMap=source.emissiveMap,this.emissiveIntensity=source.emissiveIntensity,this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.specularMap=source.specularMap,this.alphaMap=source.alphaMap,this.envMap=source.envMap,this.envMapRotation.copy(source.envMapRotation),this.combine=source.combine,this.reflectivity=source.reflectivity,this.refractionRatio=source.refractionRatio,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.wireframeLinecap=source.wireframeLinecap,this.wireframeLinejoin=source.wireframeLinejoin,this.flatShading=source.flatShading,this.fog=source.fog,this}}class MeshToonMaterial extends Material{constructor(parameters){super(),this.isMeshToonMaterial=!0,this.defines={TOON:""},this.type="MeshToonMaterial",this.color=new Color(16777215),this.map=null,this.gradientMap=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.emissive=new Color(0),this.emissiveIntensity=1,this.emissiveMap=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.alphaMap=null,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.gradientMap=source.gradientMap,this.lightMap=source.lightMap,this.lightMapIntensity=source.lightMapIntensity,this.aoMap=source.aoMap,this.aoMapIntensity=source.aoMapIntensity,this.emissive.copy(source.emissive),this.emissiveMap=source.emissiveMap,this.emissiveIntensity=source.emissiveIntensity,this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.alphaMap=source.alphaMap,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.wireframeLinecap=source.wireframeLinecap,this.wireframeLinejoin=source.wireframeLinejoin,this.fog=source.fog,this}}class MeshNormalMaterial extends Material{constructor(parameters){super(),this.isMeshNormalMaterial=!0,this.type="MeshNormalMaterial",this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.wireframe=!1,this.wireframeLinewidth=1,this.flatShading=!1,this.setValues(parameters)}copy(source){return super.copy(source),this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.flatShading=source.flatShading,this}}class MeshLambertMaterial extends Material{constructor(parameters){super(),this.isMeshLambertMaterial=!0,this.type="MeshLambertMaterial",this.color=new Color(16777215),this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.emissive=new Color(0),this.emissiveIntensity=1,this.emissiveMap=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.envMapRotation=new Euler,this.combine=MultiplyOperation,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.flatShading=!1,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.color.copy(source.color),this.map=source.map,this.lightMap=source.lightMap,this.lightMapIntensity=source.lightMapIntensity,this.aoMap=source.aoMap,this.aoMapIntensity=source.aoMapIntensity,this.emissive.copy(source.emissive),this.emissiveMap=source.emissiveMap,this.emissiveIntensity=source.emissiveIntensity,this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.specularMap=source.specularMap,this.alphaMap=source.alphaMap,this.envMap=source.envMap,this.envMapRotation.copy(source.envMapRotation),this.combine=source.combine,this.reflectivity=source.reflectivity,this.refractionRatio=source.refractionRatio,this.wireframe=source.wireframe,this.wireframeLinewidth=source.wireframeLinewidth,this.wireframeLinecap=source.wireframeLinecap,this.wireframeLinejoin=source.wireframeLinejoin,this.flatShading=source.flatShading,this.fog=source.fog,this}}class MeshMatcapMaterial extends Material{constructor(parameters){super(),this.isMeshMatcapMaterial=!0,this.defines={MATCAP:""},this.type="MeshMatcapMaterial",this.color=new Color(16777215),this.matcap=null,this.map=null,this.bumpMap=null,this.bumpScale=1,this.normalMap=null,this.normalMapType=TangentSpaceNormalMap,this.normalScale=new Vector2(1,1),this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.alphaMap=null,this.flatShading=!1,this.fog=!0,this.setValues(parameters)}copy(source){return super.copy(source),this.defines={MATCAP:""},this.color.copy(source.color),this.matcap=source.matcap,this.map=source.map,this.bumpMap=source.bumpMap,this.bumpScale=source.bumpScale,this.normalMap=source.normalMap,this.normalMapType=source.normalMapType,this.normalScale.copy(source.normalScale),this.displacementMap=source.displacementMap,this.displacementScale=source.displacementScale,this.displacementBias=source.displacementBias,this.alphaMap=source.alphaMap,this.flatShading=source.flatShading,this.fog=source.fog,this}}class LineDashedMaterial extends LineBasicMaterial{constructor(parameters){super(),this.isLineDashedMaterial=!0,this.type="LineDashedMaterial",this.scale=1,this.dashSize=3,this.gapSize=1,this.setValues(parameters)}copy(source){return super.copy(source),this.scale=source.scale,this.dashSize=source.dashSize,this.gapSize=source.gapSize,this}}const Cache={enabled:!1,files:{},add:function(key2,file){this.enabled!==!1&&(this.files[key2]=file)},get:function(key2){if(this.enabled!==!1)return this.files[key2]},remove:function(key2){delete this.files[key2]},clear:function(){this.files={}}};class LoadingManager{constructor(onLoad,onProgress,onError){const scope=this;let isLoading=!1,itemsLoaded=0,itemsTotal=0,urlModifier;const handlers=[];this.onStart=void 0,this.onLoad=onLoad,this.onProgress=onProgress,this.onError=onError,this.itemStart=function(url){itemsTotal++,isLoading===!1&&scope.onStart!==void 0&&scope.onStart(url,itemsLoaded,itemsTotal),isLoading=!0},this.itemEnd=function(url){itemsLoaded++,scope.onProgress!==void 0&&scope.onProgress(url,itemsLoaded,itemsTotal),itemsLoaded===itemsTotal&&(isLoading=!1,scope.onLoad!==void 0&&scope.onLoad())},this.itemError=function(url){scope.onError!==void 0&&scope.onError(url)},this.resolveURL=function(url){return urlModifier?urlModifier(url):url},this.setURLModifier=function(transform2){return urlModifier=transform2,this},this.addHandler=function(regex,loader){return handlers.push(regex,loader),this},this.removeHandler=function(regex){const index=handlers.indexOf(regex);return index!==-1&&handlers.splice(index,2),this},this.getHandler=function(file){for(let i2=0,l2=handlers.length;i2<l2;i2+=2){const regex=handlers[i2],loader=handlers[i2+1];if(regex.global&&(regex.lastIndex=0),regex.test(file))return loader}return null}}}const DefaultLoadingManager=new LoadingManager;class Loader{constructor(manager){this.manager=manager!==void 0?manager:DefaultLoadingManager,this.crossOrigin="anonymous",this.withCredentials=!1,this.path="",this.resourcePath="",this.requestHeader={}}load(){}loadAsync(url,onProgress){const scope=this;return new Promise(function(resolve,reject){scope.load(url,resolve,onProgress,reject)})}parse(){}setCrossOrigin(crossOrigin){return this.crossOrigin=crossOrigin,this}setWithCredentials(value){return this.withCredentials=value,this}setPath(path){return this.path=path,this}setResourcePath(resourcePath){return this.resourcePath=resourcePath,this}setRequestHeader(requestHeader){return this.requestHeader=requestHeader,this}}Loader.DEFAULT_MATERIAL_NAME="__DEFAULT";class ImageLoader extends Loader{constructor(manager){super(manager)}load(url,onLoad,onProgress,onError){this.path!==void 0&&(url=this.path+url),url=this.manager.resolveURL(url);const scope=this,cached=Cache.get(url);if(cached!==void 0)return scope.manager.itemStart(url),setTimeout(function(){onLoad&&onLoad(cached),scope.manager.itemEnd(url)},0),cached;const image=createElementNS("img");function onImageLoad(){removeEventListeners(),Cache.add(url,this),onLoad&&onLoad(this),scope.manager.itemEnd(url)}function onImageError(event){removeEventListeners(),onError&&onError(event),scope.manager.itemError(url),scope.manager.itemEnd(url)}function removeEventListeners(){image.removeEventListener("load",onImageLoad,!1),image.removeEventListener("error",onImageError,!1)}return image.addEventListener("load",onImageLoad,!1),image.addEventListener("error",onImageError,!1),url.slice(0,5)!=="data:"&&this.crossOrigin!==void 0&&(image.crossOrigin=this.crossOrigin),scope.manager.itemStart(url),image.src=url,image}}class TextureLoader extends Loader{constructor(manager){super(manager)}load(url,onLoad,onProgress,onError){const texture2=new Texture,loader=new ImageLoader(this.manager);return loader.setCrossOrigin(this.crossOrigin),loader.setPath(this.path),loader.load(url,function(image){texture2.image=image,texture2.needsUpdate=!0,onLoad!==void 0&&onLoad(texture2)},onProgress,onError),texture2}}class Light extends Object3D{constructor(color2,intensity=1){super(),this.isLight=!0,this.type="Light",this.color=new Color(color2),this.intensity=intensity}dispose(){}copy(source,recursive){return super.copy(source,recursive),this.color.copy(source.color),this.intensity=source.intensity,this}toJSON(meta){const data=super.toJSON(meta);return data.object.color=this.color.getHex(),data.object.intensity=this.intensity,this.groundColor!==void 0&&(data.object.groundColor=this.groundColor.getHex()),this.distance!==void 0&&(data.object.distance=this.distance),this.angle!==void 0&&(data.object.angle=this.angle),this.decay!==void 0&&(data.object.decay=this.decay),this.penumbra!==void 0&&(data.object.penumbra=this.penumbra),this.shadow!==void 0&&(data.object.shadow=this.shadow.toJSON()),this.target!==void 0&&(data.object.target=this.target.uuid),data}}class HemisphereLight extends Light{constructor(skyColor,groundColor,intensity){super(skyColor,intensity),this.isHemisphereLight=!0,this.type="HemisphereLight",this.position.copy(Object3D.DEFAULT_UP),this.updateMatrix(),this.groundColor=new Color(groundColor)}copy(source,recursive){return super.copy(source,recursive),this.groundColor.copy(source.groundColor),this}}const _projScreenMatrix$1=new Matrix4,_lightPositionWorld$1=new Vector3,_lookTarget$1=new Vector3;class LightShadow{constructor(camera){this.camera=camera,this.intensity=1,this.bias=0,this.normalBias=0,this.radius=1,this.blurSamples=8,this.mapSize=new Vector2(512,512),this.map=null,this.mapPass=null,this.matrix=new Matrix4,this.autoUpdate=!0,this.needsUpdate=!1,this._frustum=new Frustum,this._frameExtents=new Vector2(1,1),this._viewportCount=1,this._viewports=[new Vector4(0,0,1,1)]}getViewportCount(){return this._viewportCount}getFrustum(){return this._frustum}updateMatrices(light){const shadowCamera=this.camera,shadowMatrix=this.matrix;_lightPositionWorld$1.setFromMatrixPosition(light.matrixWorld),shadowCamera.position.copy(_lightPositionWorld$1),_lookTarget$1.setFromMatrixPosition(light.target.matrixWorld),shadowCamera.lookAt(_lookTarget$1),shadowCamera.updateMatrixWorld(),_projScreenMatrix$1.multiplyMatrices(shadowCamera.projectionMatrix,shadowCamera.matrixWorldInverse),this._frustum.setFromProjectionMatrix(_projScreenMatrix$1),shadowMatrix.set(.5,0,0,.5,0,.5,0,.5,0,0,.5,.5,0,0,0,1),shadowMatrix.multiply(_projScreenMatrix$1)}getViewport(viewportIndex){return this._viewports[viewportIndex]}getFrameExtents(){return this._frameExtents}dispose(){this.map&&this.map.dispose(),this.mapPass&&this.mapPass.dispose()}copy(source){return this.camera=source.camera.clone(),this.intensity=source.intensity,this.bias=source.bias,this.radius=source.radius,this.mapSize.copy(source.mapSize),this}clone(){return new this.constructor().copy(this)}toJSON(){const object={};return this.intensity!==1&&(object.intensity=this.intensity),this.bias!==0&&(object.bias=this.bias),this.normalBias!==0&&(object.normalBias=this.normalBias),this.radius!==1&&(object.radius=this.radius),(this.mapSize.x!==512||this.mapSize.y!==512)&&(object.mapSize=this.mapSize.toArray()),object.camera=this.camera.toJSON(!1).object,delete object.camera.matrix,object}}class SpotLightShadow extends LightShadow{constructor(){super(new PerspectiveCamera(50,1,.5,500)),this.isSpotLightShadow=!0,this.focus=1}updateMatrices(light){const camera=this.camera,fov2=RAD2DEG*2*light.angle*this.focus,aspect2=this.mapSize.width/this.mapSize.height,far=light.distance||camera.far;(fov2!==camera.fov||aspect2!==camera.aspect||far!==camera.far)&&(camera.fov=fov2,camera.aspect=aspect2,camera.far=far,camera.updateProjectionMatrix()),super.updateMatrices(light)}copy(source){return super.copy(source),this.focus=source.focus,this}}class SpotLight extends Light{constructor(color2,intensity,distance2=0,angle=Math.PI/3,penumbra=0,decay=2){super(color2,intensity),this.isSpotLight=!0,this.type="SpotLight",this.position.copy(Object3D.DEFAULT_UP),this.updateMatrix(),this.target=new Object3D,this.distance=distance2,this.angle=angle,this.penumbra=penumbra,this.decay=decay,this.map=null,this.shadow=new SpotLightShadow}get power(){return this.intensity*Math.PI}set power(power){this.intensity=power/Math.PI}dispose(){this.shadow.dispose()}copy(source,recursive){return super.copy(source,recursive),this.distance=source.distance,this.angle=source.angle,this.penumbra=source.penumbra,this.decay=source.decay,this.target=source.target.clone(),this.shadow=source.shadow.clone(),this}}const _projScreenMatrix$2=new Matrix4,_lightPositionWorld=new Vector3,_lookTarget=new Vector3;class PointLightShadow extends LightShadow{constructor(){super(new PerspectiveCamera(90,1,.5,500)),this.isPointLightShadow=!0,this._frameExtents=new Vector2(4,2),this._viewportCount=6,this._viewports=[new Vector4(2,1,1,1),new Vector4(0,1,1,1),new Vector4(3,1,1,1),new Vector4(1,1,1,1),new Vector4(3,0,1,1),new Vector4(1,0,1,1)],this._cubeDirections=[new Vector3(1,0,0),new Vector3(-1,0,0),new Vector3(0,0,1),new Vector3(0,0,-1),new Vector3(0,1,0),new Vector3(0,-1,0)],this._cubeUps=[new Vector3(0,1,0),new Vector3(0,1,0),new Vector3(0,1,0),new Vector3(0,1,0),new Vector3(0,0,1),new Vector3(0,0,-1)]}updateMatrices(light,viewportIndex=0){const camera=this.camera,shadowMatrix=this.matrix,far=light.distance||camera.far;far!==camera.far&&(camera.far=far,camera.updateProjectionMatrix()),_lightPositionWorld.setFromMatrixPosition(light.matrixWorld),camera.position.copy(_lightPositionWorld),_lookTarget.copy(camera.position),_lookTarget.add(this._cubeDirections[viewportIndex]),camera.up.copy(this._cubeUps[viewportIndex]),camera.lookAt(_lookTarget),camera.updateMatrixWorld(),shadowMatrix.makeTranslation(-_lightPositionWorld.x,-_lightPositionWorld.y,-_lightPositionWorld.z),_projScreenMatrix$2.multiplyMatrices(camera.projectionMatrix,camera.matrixWorldInverse),this._frustum.setFromProjectionMatrix(_projScreenMatrix$2)}}class PointLight extends Light{constructor(color2,intensity,distance2=0,decay=2){super(color2,intensity),this.isPointLight=!0,this.type="PointLight",this.distance=distance2,this.decay=decay,this.shadow=new PointLightShadow}get power(){return this.intensity*4*Math.PI}set power(power){this.intensity=power/(4*Math.PI)}dispose(){this.shadow.dispose()}copy(source,recursive){return super.copy(source,recursive),this.distance=source.distance,this.decay=source.decay,this.shadow=source.shadow.clone(),this}}class OrthographicCamera extends Camera{constructor(left=-1,right=1,top=1,bottom=-1,near=.1,far=2e3){super(),this.isOrthographicCamera=!0,this.type="OrthographicCamera",this.zoom=1,this.view=null,this.left=left,this.right=right,this.top=top,this.bottom=bottom,this.near=near,this.far=far,this.updateProjectionMatrix()}copy(source,recursive){return super.copy(source,recursive),this.left=source.left,this.right=source.right,this.top=source.top,this.bottom=source.bottom,this.near=source.near,this.far=source.far,this.zoom=source.zoom,this.view=source.view===null?null:Object.assign({},source.view),this}setViewOffset(fullWidth,fullHeight,x,y,width,height){this.view===null&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=fullWidth,this.view.fullHeight=fullHeight,this.view.offsetX=x,this.view.offsetY=y,this.view.width=width,this.view.height=height,this.updateProjectionMatrix()}clearViewOffset(){this.view!==null&&(this.view.enabled=!1),this.updateProjectionMatrix()}updateProjectionMatrix(){const dx=(this.right-this.left)/(2*this.zoom),dy=(this.top-this.bottom)/(2*this.zoom),cx=(this.right+this.left)/2,cy=(this.top+this.bottom)/2;let left=cx-dx,right=cx+dx,top=cy+dy,bottom=cy-dy;if(this.view!==null&&this.view.enabled){const scaleW=(this.right-this.left)/this.view.fullWidth/this.zoom,scaleH=(this.top-this.bottom)/this.view.fullHeight/this.zoom;left+=scaleW*this.view.offsetX,right=left+scaleW*this.view.width,top-=scaleH*this.view.offsetY,bottom=top-scaleH*this.view.height}this.projectionMatrix.makeOrthographic(left,right,top,bottom,this.near,this.far,this.coordinateSystem),this.projectionMatrixInverse.copy(this.projectionMatrix).invert()}toJSON(meta){const data=super.toJSON(meta);return data.object.zoom=this.zoom,data.object.left=this.left,data.object.right=this.right,data.object.top=this.top,data.object.bottom=this.bottom,data.object.near=this.near,data.object.far=this.far,this.view!==null&&(data.object.view=Object.assign({},this.view)),data}}class DirectionalLightShadow extends LightShadow{constructor(){super(new OrthographicCamera(-5,5,5,-5,.5,500)),this.isDirectionalLightShadow=!0}}class DirectionalLight extends Light{constructor(color2,intensity){super(color2,intensity),this.isDirectionalLight=!0,this.type="DirectionalLight",this.position.copy(Object3D.DEFAULT_UP),this.updateMatrix(),this.target=new Object3D,this.shadow=new DirectionalLightShadow}dispose(){this.shadow.dispose()}copy(source){return super.copy(source),this.target=source.target.clone(),this.shadow=source.shadow.clone(),this}}class AmbientLight extends Light{constructor(color2,intensity){super(color2,intensity),this.isAmbientLight=!0,this.type="AmbientLight"}}class RectAreaLight extends Light{constructor(color2,intensity,width=10,height=10){super(color2,intensity),this.isRectAreaLight=!0,this.type="RectAreaLight",this.width=width,this.height=height}get power(){return this.intensity*this.width*this.height*Math.PI}set power(power){this.intensity=power/(this.width*this.height*Math.PI)}copy(source){return super.copy(source),this.width=source.width,this.height=source.height,this}toJSON(meta){const data=super.toJSON(meta);return data.object.width=this.width,data.object.height=this.height,data}}class SphericalHarmonics3{constructor(){this.isSphericalHarmonics3=!0,this.coefficients=[];for(let i2=0;i2<9;i2++)this.coefficients.push(new Vector3)}set(coefficients){for(let i2=0;i2<9;i2++)this.coefficients[i2].copy(coefficients[i2]);return this}zero(){for(let i2=0;i2<9;i2++)this.coefficients[i2].set(0,0,0);return this}getAt(normal2,target){const x=normal2.x,y=normal2.y,z=normal2.z,coeff=this.coefficients;return target.copy(coeff[0]).multiplyScalar(.282095),target.addScaledVector(coeff[1],.488603*y),target.addScaledVector(coeff[2],.488603*z),target.addScaledVector(coeff[3],.488603*x),target.addScaledVector(coeff[4],1.092548*(x*y)),target.addScaledVector(coeff[5],1.092548*(y*z)),target.addScaledVector(coeff[6],.315392*(3*z*z-1)),target.addScaledVector(coeff[7],1.092548*(x*z)),target.addScaledVector(coeff[8],.546274*(x*x-y*y)),target}getIrradianceAt(normal2,target){const x=normal2.x,y=normal2.y,z=normal2.z,coeff=this.coefficients;return target.copy(coeff[0]).multiplyScalar(.886227),target.addScaledVector(coeff[1],2*.511664*y),target.addScaledVector(coeff[2],2*.511664*z),target.addScaledVector(coeff[3],2*.511664*x),target.addScaledVector(coeff[4],2*.429043*x*y),target.addScaledVector(coeff[5],2*.429043*y*z),target.addScaledVector(coeff[6],.743125*z*z-.247708),target.addScaledVector(coeff[7],2*.429043*x*z),target.addScaledVector(coeff[8],.429043*(x*x-y*y)),target}add(sh){for(let i2=0;i2<9;i2++)this.coefficients[i2].add(sh.coefficients[i2]);return this}addScaledSH(sh,s2){for(let i2=0;i2<9;i2++)this.coefficients[i2].addScaledVector(sh.coefficients[i2],s2);return this}scale(s2){for(let i2=0;i2<9;i2++)this.coefficients[i2].multiplyScalar(s2);return this}lerp(sh,alpha){for(let i2=0;i2<9;i2++)this.coefficients[i2].lerp(sh.coefficients[i2],alpha);return this}equals(sh){for(let i2=0;i2<9;i2++)if(!this.coefficients[i2].equals(sh.coefficients[i2]))return!1;return!0}copy(sh){return this.set(sh.coefficients)}clone(){return new this.constructor().copy(this)}fromArray(array2,offset=0){const coefficients=this.coefficients;for(let i2=0;i2<9;i2++)coefficients[i2].fromArray(array2,offset+i2*3);return this}toArray(array2=[],offset=0){const coefficients=this.coefficients;for(let i2=0;i2<9;i2++)coefficients[i2].toArray(array2,offset+i2*3);return array2}static getBasisAt(normal2,shBasis){const x=normal2.x,y=normal2.y,z=normal2.z;shBasis[0]=.282095,shBasis[1]=.488603*y,shBasis[2]=.488603*z,shBasis[3]=.488603*x,shBasis[4]=1.092548*x*y,shBasis[5]=1.092548*y*z,shBasis[6]=.315392*(3*z*z-1),shBasis[7]=1.092548*x*z,shBasis[8]=.546274*(x*x-y*y)}}class LightProbe extends Light{constructor(sh=new SphericalHarmonics3,intensity=1){super(void 0,intensity),this.isLightProbe=!0,this.sh=sh}copy(source){return super.copy(source),this.sh.copy(source.sh),this}fromJSON(json){return this.intensity=json.intensity,this.sh.fromArray(json.sh),this}toJSON(meta){const data=super.toJSON(meta);return data.object.sh=this.sh.toArray(),data}}class ArrayCamera extends PerspectiveCamera{constructor(array2=[]){super(),this.isArrayCamera=!0,this.cameras=array2,this.index=0}}class InstancedInterleavedBuffer extends InterleavedBuffer{constructor(array2,stride,meshPerAttribute=1){super(array2,stride),this.isInstancedInterleavedBuffer=!0,this.meshPerAttribute=meshPerAttribute}copy(source){return super.copy(source),this.meshPerAttribute=source.meshPerAttribute,this}clone(data){const ib=super.clone(data);return ib.meshPerAttribute=this.meshPerAttribute,ib}toJSON(data){const json=super.toJSON(data);return json.isInstancedInterleavedBuffer=!0,json.meshPerAttribute=this.meshPerAttribute,json}}class Matrix2{constructor(n11,n12,n21,n22){Matrix2.prototype.isMatrix2=!0,this.elements=[1,0,0,1],n11!==void 0&&this.set(n11,n12,n21,n22)}identity(){return this.set(1,0,0,1),this}fromArray(array2,offset=0){for(let i2=0;i2<4;i2++)this.elements[i2]=array2[i2+offset];return this}set(n11,n12,n21,n22){const te=this.elements;return te[0]=n11,te[2]=n12,te[1]=n21,te[3]=n22,this}}typeof __THREE_DEVTOOLS__<"u"&&__THREE_DEVTOOLS__.dispatchEvent(new CustomEvent("register",{detail:{revision:REVISION}}));typeof window<"u"&&(window.__THREE__?console.warn("WARNING: Multiple instances of Three.js being imported."):window.__THREE__=REVISION);const refreshUniforms=["alphaMap","alphaTest","anisotropy","anisotropyMap","anisotropyRotation","aoMap","attenuationColor","attenuationDistance","bumpMap","clearcoat","clearcoatMap","clearcoatNormalMap","clearcoatNormalScale","clearcoatRoughness","color","dispersion","displacementMap","emissive","emissiveMap","envMap","gradientMap","ior","iridescence","iridescenceIOR","iridescenceMap","iridescenceThicknessMap","lightMap","map","matcap","metalness","metalnessMap","normalMap","normalScale","opacity","roughness","roughnessMap","sheen","sheenColor","sheenColorMap","sheenRoughnessMap","shininess","specular","specularColor","specularColorMap","specularIntensity","specularIntensityMap","specularMap","thickness","transmission","transmissionMap"];class NodeMaterialObserver{constructor(builder){this.renderObjects=new WeakMap,this.hasNode=this.containsNode(builder),this.hasAnimation=builder.object.isSkinnedMesh===!0,this.refreshUniforms=refreshUniforms,this.renderId=0}firstInitialization(renderObject){return this.renderObjects.has(renderObject)===!1?(this.getRenderObjectData(renderObject),!0):!1}getRenderObjectData(renderObject){let data=this.renderObjects.get(renderObject);if(data===void 0){const{geometry:geometry2,material,object}=renderObject;if(data={material:this.getMaterialData(material),geometry:{id:geometry2.id,attributes:this.getAttributesData(geometry2.attributes),indexVersion:geometry2.index?geometry2.index.version:null,drawRange:{start:geometry2.drawRange.start,count:geometry2.drawRange.count}},worldMatrix:object.matrixWorld.clone()},object.center&&(data.center=object.center.clone()),object.morphTargetInfluences&&(data.morphTargetInfluences=object.morphTargetInfluences.slice()),renderObject.bundle!==null&&(data.version=renderObject.bundle.version),data.material.transmission>0){const{width,height}=renderObject.context;data.bufferWidth=width,data.bufferHeight=height}this.renderObjects.set(renderObject,data)}return data}getAttributesData(attributes){const attributesData={};for(const name in attributes){const attribute2=attributes[name];attributesData[name]={version:attribute2.version}}return attributesData}containsNode(builder){const material=builder.material;for(const property2 in material)if(material[property2]&&material[property2].isNode)return!0;return builder.renderer.nodes.modelViewMatrix!==null||builder.renderer.nodes.modelNormalViewMatrix!==null}getMaterialData(material){const data={};for(const property2 of this.refreshUniforms){const value=material[property2];value!=null&&(typeof value=="object"&&value.clone!==void 0?value.isTexture===!0?data[property2]={id:value.id,version:value.version}:data[property2]=value.clone():data[property2]=value)}return data}equals(renderObject){const{object,material,geometry:geometry2}=renderObject,renderObjectData=this.getRenderObjectData(renderObject);if(renderObjectData.worldMatrix.equals(object.matrixWorld)!==!0)return renderObjectData.worldMatrix.copy(object.matrixWorld),!1;const materialData=renderObjectData.material;for(const property2 in materialData){const value=materialData[property2],mtlValue=material[property2];if(value.equals!==void 0){if(value.equals(mtlValue)===!1)return value.copy(mtlValue),!1}else if(mtlValue.isTexture===!0){if(value.id!==mtlValue.id||value.version!==mtlValue.version)return value.id=mtlValue.id,value.version=mtlValue.version,!1}else if(value!==mtlValue)return materialData[property2]=mtlValue,!1}if(materialData.transmission>0){const{width,height}=renderObject.context;if(renderObjectData.bufferWidth!==width||renderObjectData.bufferHeight!==height)return renderObjectData.bufferWidth=width,renderObjectData.bufferHeight=height,!1}const storedGeometryData=renderObjectData.geometry,attributes=geometry2.attributes,storedAttributes=storedGeometryData.attributes,storedAttributeNames=Object.keys(storedAttributes),currentAttributeNames=Object.keys(attributes);if(storedGeometryData.id!==geometry2.id)return storedGeometryData.id=geometry2.id,!1;if(storedAttributeNames.length!==currentAttributeNames.length)return renderObjectData.geometry.attributes=this.getAttributesData(attributes),!1;for(const name of storedAttributeNames){const storedAttributeData=storedAttributes[name],attribute2=attributes[name];if(attribute2===void 0)return delete storedAttributes[name],!1;if(storedAttributeData.version!==attribute2.version)return storedAttributeData.version=attribute2.version,!1}const index=geometry2.index,storedIndexVersion=storedGeometryData.indexVersion,currentIndexVersion=index?index.version:null;if(storedIndexVersion!==currentIndexVersion)return storedGeometryData.indexVersion=currentIndexVersion,!1;if(storedGeometryData.drawRange.start!==geometry2.drawRange.start||storedGeometryData.drawRange.count!==geometry2.drawRange.count)return storedGeometryData.drawRange.start=geometry2.drawRange.start,storedGeometryData.drawRange.count=geometry2.drawRange.count,!1;if(renderObjectData.morphTargetInfluences){let morphChanged=!1;for(let i2=0;i2<renderObjectData.morphTargetInfluences.length;i2++)renderObjectData.morphTargetInfluences[i2]!==object.morphTargetInfluences[i2]&&(morphChanged=!0);if(morphChanged)return!0}return renderObjectData.center&&renderObjectData.center.equals(object.center)===!1?(renderObjectData.center.copy(object.center),!0):(renderObject.bundle!==null&&(renderObjectData.version=renderObject.bundle.version),!0)}needsRefresh(renderObject,nodeFrame){if(this.hasNode||this.hasAnimation||this.firstInitialization(renderObject))return!0;const{renderId}=nodeFrame;if(this.renderId!==renderId)return this.renderId=renderId,!0;const isStatic=renderObject.object.static===!0,isBundle=renderObject.bundle!==null&&renderObject.bundle.static===!0&&this.getRenderObjectData(renderObject).version===renderObject.bundle.version;return isStatic||isBundle?!1:this.equals(renderObject)!==!0}}function cyrb53(value,seed=0){let h12=3735928559^seed,h2=1103547991^seed;if(value instanceof Array)for(let i2=0,val;i2<value.length;i2++)val=value[i2],h12=Math.imul(h12^val,2654435761),h2=Math.imul(h2^val,1597334677);else for(let i2=0,ch;i2<value.length;i2++)ch=value.charCodeAt(i2),h12=Math.imul(h12^ch,2654435761),h2=Math.imul(h2^ch,1597334677);return h12=Math.imul(h12^h12>>>16,2246822507),h12^=Math.imul(h2^h2>>>13,3266489909),h2=Math.imul(h2^h2>>>16,2246822507),h2^=Math.imul(h12^h12>>>13,3266489909),4294967296*(2097151&h2)+(h12>>>0)}const hashString=str=>cyrb53(str),hashArray=array2=>cyrb53(array2),hash$1=(...params)=>cyrb53(params);function getCacheKey$1$1(object,force=!1){const values=[];object.isNode===!0&&(values.push(object.id),object=object.getSelf());for(const{property:property2,childNode}of getNodeChildren(object))values.push(cyrb53(property2.slice(0,-4)),childNode.getCacheKey(force));return cyrb53(values)}function*getNodeChildren(node,toJSON=!1){for(const property2 in node){if(property2.startsWith("_")===!0)continue;const object=node[property2];if(Array.isArray(object)===!0)for(let i2=0;i2<object.length;i2++){const child=object[i2];child&&(child.isNode===!0||toJSON&&typeof child.toJSON=="function")&&(yield{property:property2,index:i2,childNode:child})}else if(object&&object.isNode===!0)yield{property:property2,childNode:object};else if(typeof object=="object")for(const subProperty in object){const child=object[subProperty];child&&(child.isNode===!0||toJSON&&typeof child.toJSON=="function")&&(yield{property:property2,index:subProperty,childNode:child})}}}const typeFromLength=new Map([[1,"float"],[2,"vec2"],[3,"vec3"],[4,"vec4"],[9,"mat3"],[16,"mat4"]]),dataFromObject=new WeakMap;function getTypeFromLength(length2){return typeFromLength.get(length2)}function getTypedArrayFromType(type){if(/[iu]?vec\d/.test(type))return type.startsWith("ivec")?Int32Array:type.startsWith("uvec")?Uint32Array:Float32Array;if(/mat\d/.test(type)||/float/.test(type))return Float32Array;if(/uint/.test(type))return Uint32Array;if(/int/.test(type))return Int32Array;throw new Error(`THREE.NodeUtils: Unsupported type: ${type}`)}function getLengthFromType(type){if(/float|int|uint/.test(type))return 1;if(/vec2/.test(type))return 2;if(/vec3/.test(type))return 3;if(/vec4/.test(type)||/mat2/.test(type))return 4;if(/mat3/.test(type))return 9;if(/mat4/.test(type))return 16;console.error("THREE.TSL: Unsupported type:",type)}function getValueType(value){if(value==null)return null;const typeOf=typeof value;return value.isNode===!0?"node":typeOf==="number"?"float":typeOf==="boolean"?"bool":typeOf==="string"?"string":typeOf==="function"?"shader":value.isVector2===!0?"vec2":value.isVector3===!0?"vec3":value.isVector4===!0?"vec4":value.isMatrix2===!0?"mat2":value.isMatrix3===!0?"mat3":value.isMatrix4===!0?"mat4":value.isColor===!0?"color":value instanceof ArrayBuffer?"ArrayBuffer":null}function getValueFromType(type,...params){const last4=type?type.slice(-4):void 0;return params.length===1&&(last4==="vec2"?params=[params[0],params[0]]:last4==="vec3"?params=[params[0],params[0],params[0]]:last4==="vec4"&&(params=[params[0],params[0],params[0],params[0]])),type==="color"?new Color(...params):last4==="vec2"?new Vector2(...params):last4==="vec3"?new Vector3(...params):last4==="vec4"?new Vector4(...params):last4==="mat2"?new Matrix2(...params):last4==="mat3"?new Matrix3(...params):last4==="mat4"?new Matrix4(...params):type==="bool"?params[0]||!1:type==="float"||type==="int"||type==="uint"?params[0]||0:type==="string"?params[0]||"":type==="ArrayBuffer"?base64ToArrayBuffer(params[0]):null}function getDataFromObject(object){let data=dataFromObject.get(object);return data===void 0&&(data={},dataFromObject.set(object,data)),data}function arrayBufferToBase64(arrayBuffer2){let chars="";const array2=new Uint8Array(arrayBuffer2);for(let i2=0;i2<array2.length;i2++)chars+=String.fromCharCode(array2[i2]);return btoa(chars)}function base64ToArrayBuffer(base64){return Uint8Array.from(atob(base64),c2=>c2.charCodeAt(0)).buffer}const NodeShaderStage={VERTEX:"vertex",FRAGMENT:"fragment"},NodeUpdateType={NONE:"none",FRAME:"frame",RENDER:"render",OBJECT:"object"},NodeType={BOOLEAN:"bool",INTEGER:"int",FLOAT:"float",VECTOR2:"vec2",VECTOR3:"vec3",VECTOR4:"vec4",MATRIX2:"mat2",MATRIX3:"mat3",MATRIX4:"mat4"},NodeAccess={READ_ONLY:"readOnly",WRITE_ONLY:"writeOnly",READ_WRITE:"readWrite"},defaultShaderStages=["fragment","vertex"],defaultBuildStages=["setup","analyze","generate"],shaderStages=[...defaultShaderStages,"compute"],vectorComponents=["x","y","z","w"];let _nodeId=0;class Node extends EventDispatcher{static get type(){return"Node"}constructor(nodeType=null){super(),this.nodeType=nodeType,this.updateType=NodeUpdateType.NONE,this.updateBeforeType=NodeUpdateType.NONE,this.updateAfterType=NodeUpdateType.NONE,this.uuid=MathUtils.generateUUID(),this.version=0,this.global=!1,this.isNode=!0,this._cacheKey=null,this._cacheKeyVersion=0,Object.defineProperty(this,"id",{value:_nodeId++})}set needsUpdate(value){value===!0&&this.version++}get type(){return this.constructor.type}onUpdate(callback,updateType){return this.updateType=updateType,this.update=callback.bind(this.getSelf()),this}onFrameUpdate(callback){return this.onUpdate(callback,NodeUpdateType.FRAME)}onRenderUpdate(callback){return this.onUpdate(callback,NodeUpdateType.RENDER)}onObjectUpdate(callback){return this.onUpdate(callback,NodeUpdateType.OBJECT)}onReference(callback){return this.updateReference=callback.bind(this.getSelf()),this}getSelf(){return this.self||this}updateReference(){return this}isGlobal(){return this.global}*getChildren(){for(const{childNode}of getNodeChildren(this))yield childNode}dispose(){this.dispatchEvent({type:"dispose"})}traverse(callback){callback(this);for(const childNode of this.getChildren())childNode.traverse(callback)}getCacheKey(force=!1){return force=force||this.version!==this._cacheKeyVersion,(force===!0||this._cacheKey===null)&&(this._cacheKey=hash$1(getCacheKey$1$1(this,force),this.customCacheKey()),this._cacheKeyVersion=this.version),this._cacheKey}customCacheKey(){return 0}getScope(){return this}getHash(){return this.uuid}getUpdateType(){return this.updateType}getUpdateBeforeType(){return this.updateBeforeType}getUpdateAfterType(){return this.updateAfterType}getElementType(builder){const type=this.getNodeType(builder);return builder.getElementType(type)}getMemberType(){return"void"}getNodeType(builder){const nodeProperties=builder.getNodeProperties(this);return nodeProperties.outputNode?nodeProperties.outputNode.getNodeType(builder):this.nodeType}getShared(builder){const hash2=this.getHash(builder);return builder.getNodeFromHash(hash2)||this}setup(builder){const nodeProperties=builder.getNodeProperties(this);let index=0;for(const childNode of this.getChildren())nodeProperties["node"+index++]=childNode;return nodeProperties.outputNode||null}analyze(builder){if(builder.increaseUsage(this)===1){const nodeProperties=builder.getNodeProperties(this);for(const childNode of Object.values(nodeProperties))childNode&&childNode.isNode===!0&&childNode.build(builder)}}generate(builder,output2){const{outputNode}=builder.getNodeProperties(this);if(outputNode&&outputNode.isNode===!0)return outputNode.build(builder,output2)}updateBefore(){console.warn("Abstract function.")}updateAfter(){console.warn("Abstract function.")}update(){console.warn("Abstract function.")}build(builder,output2=null){const refNode=this.getShared(builder);if(this!==refNode)return refNode.build(builder,output2);builder.addNode(this),builder.addChain(this);let result=null;const buildStage=builder.getBuildStage();if(buildStage==="setup"){this.updateReference(builder);const properties=builder.getNodeProperties(this);if(properties.initialized!==!0){properties.initialized=!0;const outputNode=this.setup(builder),isNodeOutput=outputNode&&outputNode.isNode===!0;for(const childNode of Object.values(properties))childNode&&childNode.isNode===!0&&childNode.build(builder);isNodeOutput&&outputNode.build(builder),properties.outputNode=outputNode}}else if(buildStage==="analyze")this.analyze(builder);else if(buildStage==="generate")if(this.generate.length===1){const type=this.getNodeType(builder),nodeData=builder.getDataFromNode(this);result=nodeData.snippet,result===void 0?(result=this.generate(builder)||"",nodeData.snippet=result):nodeData.flowCodes!==void 0&&builder.context.nodeBlock!==void 0&&builder.addFlowCodeHierarchy(this,builder.context.nodeBlock),result=builder.format(result,type,output2)}else result=this.generate(builder,output2)||"";return builder.removeChain(this),builder.addSequentialNode(this),result}getSerializeChildren(){return getNodeChildren(this)}serialize(json){const nodeChildren=this.getSerializeChildren(),inputNodes={};for(const{property:property2,index,childNode}of nodeChildren)index!==void 0?(inputNodes[property2]===void 0&&(inputNodes[property2]=Number.isInteger(index)?[]:{}),inputNodes[property2][index]=childNode.toJSON(json.meta).uuid):inputNodes[property2]=childNode.toJSON(json.meta).uuid;Object.keys(inputNodes).length>0&&(json.inputNodes=inputNodes)}deserialize(json){if(json.inputNodes!==void 0){const nodes=json.meta.nodes;for(const property2 in json.inputNodes)if(Array.isArray(json.inputNodes[property2])){const inputArray=[];for(const uuid of json.inputNodes[property2])inputArray.push(nodes[uuid]);this[property2]=inputArray}else if(typeof json.inputNodes[property2]=="object"){const inputObject={};for(const subProperty in json.inputNodes[property2]){const uuid=json.inputNodes[property2][subProperty];inputObject[subProperty]=nodes[uuid]}this[property2]=inputObject}else{const uuid=json.inputNodes[property2];this[property2]=nodes[uuid]}}}toJSON(meta){const{uuid,type}=this,isRoot=meta===void 0||typeof meta=="string";isRoot&&(meta={textures:{},images:{},nodes:{}});let data=meta.nodes[uuid];data===void 0&&(data={uuid,type,meta,metadata:{version:4.6,type:"Node",generator:"Node.toJSON"}},isRoot!==!0&&(meta.nodes[data.uuid]=data),this.serialize(data),delete data.meta);function extractFromCache(cache2){const values=[];for(const key2 in cache2){const data2=cache2[key2];delete data2.metadata,values.push(data2)}return values}if(isRoot){const textures=extractFromCache(meta.textures),images=extractFromCache(meta.images),nodes=extractFromCache(meta.nodes);textures.length>0&&(data.textures=textures),images.length>0&&(data.images=images),nodes.length>0&&(data.nodes=nodes)}return data}}class ArrayElementNode extends Node{static get type(){return"ArrayElementNode"}constructor(node,indexNode){super(),this.node=node,this.indexNode=indexNode,this.isArrayElementNode=!0}getNodeType(builder){return this.node.getElementType(builder)}generate(builder){const nodeSnippet=this.node.build(builder),indexSnippet=this.indexNode.build(builder,"uint");return`${nodeSnippet}[ ${indexSnippet} ]`}}class ConvertNode extends Node{static get type(){return"ConvertNode"}constructor(node,convertTo){super(),this.node=node,this.convertTo=convertTo}getNodeType(builder){const requestType=this.node.getNodeType(builder);let convertTo=null;for(const overloadingType of this.convertTo.split("|"))(convertTo===null||builder.getTypeLength(requestType)===builder.getTypeLength(overloadingType))&&(convertTo=overloadingType);return convertTo}serialize(data){super.serialize(data),data.convertTo=this.convertTo}deserialize(data){super.deserialize(data),this.convertTo=data.convertTo}generate(builder,output2){const node=this.node,type=this.getNodeType(builder),snippet=node.build(builder,type);return builder.format(snippet,type,output2)}}class TempNode extends Node{static get type(){return"TempNode"}constructor(nodeType=null){super(nodeType),this.isTempNode=!0}hasDependencies(builder){return builder.getDataFromNode(this).usageCount>1}build(builder,output2){if(builder.getBuildStage()==="generate"){const type=builder.getVectorType(this.getNodeType(builder,output2)),nodeData=builder.getDataFromNode(this);if(nodeData.propertyName!==void 0)return builder.format(nodeData.propertyName,type,output2);if(type!=="void"&&output2!=="void"&&this.hasDependencies(builder)){const snippet=super.build(builder,type),nodeVar=builder.getVarFromNode(this,null,type),propertyName=builder.getPropertyName(nodeVar);return builder.addLineFlowCode(`${propertyName} = ${snippet}`,this),nodeData.snippet=snippet,nodeData.propertyName=propertyName,builder.format(nodeData.propertyName,type,output2)}}return super.build(builder,output2)}}class JoinNode extends TempNode{static get type(){return"JoinNode"}constructor(nodes=[],nodeType=null){super(nodeType),this.nodes=nodes}getNodeType(builder){return this.nodeType!==null?builder.getVectorType(this.nodeType):builder.getTypeFromLength(this.nodes.reduce((count,cur)=>count+builder.getTypeLength(cur.getNodeType(builder)),0))}generate(builder,output2){const type=this.getNodeType(builder),nodes=this.nodes,primitiveType=builder.getComponentType(type),snippetValues=[];for(const input of nodes){let inputSnippet=input.build(builder);const inputPrimitiveType=builder.getComponentType(input.getNodeType(builder));inputPrimitiveType!==primitiveType&&(inputSnippet=builder.format(inputSnippet,inputPrimitiveType,primitiveType)),snippetValues.push(inputSnippet)}const snippet=`${builder.getType(type)}( ${snippetValues.join(", ")} )`;return builder.format(snippet,type,output2)}}const _stringVectorComponents=vectorComponents.join("");class SplitNode extends Node{static get type(){return"SplitNode"}constructor(node,components="x"){super(),this.node=node,this.components=components,this.isSplitNode=!0}getVectorLength(){let vectorLength=this.components.length;for(const c2 of this.components)vectorLength=Math.max(vectorComponents.indexOf(c2)+1,vectorLength);return vectorLength}getComponentType(builder){return builder.getComponentType(this.node.getNodeType(builder))}getNodeType(builder){return builder.getTypeFromLength(this.components.length,this.getComponentType(builder))}generate(builder,output2){const node=this.node,nodeTypeLength=builder.getTypeLength(node.getNodeType(builder));let snippet=null;if(nodeTypeLength>1){let type=null;this.getVectorLength()>=nodeTypeLength&&(type=builder.getTypeFromLength(this.getVectorLength(),this.getComponentType(builder)));const nodeSnippet=node.build(builder,type);this.components.length===nodeTypeLength&&this.components===_stringVectorComponents.slice(0,this.components.length)?snippet=builder.format(nodeSnippet,type,output2):snippet=builder.format(`${nodeSnippet}.${this.components}`,this.getNodeType(builder),output2)}else snippet=node.build(builder,output2);return snippet}serialize(data){super.serialize(data),data.components=this.components}deserialize(data){super.deserialize(data),this.components=data.components}}class SetNode extends TempNode{static get type(){return"SetNode"}constructor(sourceNode,components,targetNode){super(),this.sourceNode=sourceNode,this.components=components,this.targetNode=targetNode}getNodeType(builder){return this.sourceNode.getNodeType(builder)}generate(builder){const{sourceNode,components,targetNode}=this,sourceType=this.getNodeType(builder),componentType=builder.getComponentType(targetNode.getNodeType(builder)),targetType=builder.getTypeFromLength(components.length,componentType),targetSnippet=targetNode.build(builder,targetType),sourceSnippet=sourceNode.build(builder,sourceType),length2=builder.getTypeLength(sourceType),snippetValues=[];for(let i2=0;i2<length2;i2++){const component=vectorComponents[i2];component===components[0]?(snippetValues.push(targetSnippet),i2+=components.length-1):snippetValues.push(sourceSnippet+"."+component)}return`${builder.getType(sourceType)}( ${snippetValues.join(", ")} )`}}class FlipNode extends TempNode{static get type(){return"FlipNode"}constructor(sourceNode,components){super(),this.sourceNode=sourceNode,this.components=components}getNodeType(builder){return this.sourceNode.getNodeType(builder)}generate(builder){const{components,sourceNode}=this,sourceType=this.getNodeType(builder),sourceSnippet=sourceNode.build(builder),sourceCache=builder.getVarFromNode(this),sourceProperty=builder.getPropertyName(sourceCache);builder.addLineFlowCode(sourceProperty+" = "+sourceSnippet,this);const length2=builder.getTypeLength(sourceType),snippetValues=[];let componentIndex=0;for(let i2=0;i2<length2;i2++){const component=vectorComponents[i2];component===components[componentIndex]?(snippetValues.push("1.0 - "+(sourceProperty+"."+component)),componentIndex++):snippetValues.push(sourceProperty+"."+component)}return`${builder.getType(sourceType)}( ${snippetValues.join(", ")} )`}}class InputNode extends Node{static get type(){return"InputNode"}constructor(value,nodeType=null){super(nodeType),this.isInputNode=!0,this.value=value,this.precision=null}getNodeType(){return this.nodeType===null?getValueType(this.value):this.nodeType}getInputType(builder){return this.getNodeType(builder)}setPrecision(precision){return this.precision=precision,this}serialize(data){super.serialize(data),data.value=this.value,this.value&&this.value.toArray&&(data.value=this.value.toArray()),data.valueType=getValueType(this.value),data.nodeType=this.nodeType,data.valueType==="ArrayBuffer"&&(data.value=arrayBufferToBase64(data.value)),data.precision=this.precision}deserialize(data){super.deserialize(data),this.nodeType=data.nodeType,this.value=Array.isArray(data.value)?getValueFromType(data.valueType,...data.value):data.value,this.precision=data.precision||null,this.value&&this.value.fromArray&&(this.value=this.value.fromArray(data.value))}generate(){console.warn("Abstract function.")}}const _regNum=/float|u?int/;class ConstNode extends InputNode{static get type(){return"ConstNode"}constructor(value,nodeType=null){super(value,nodeType),this.isConstNode=!0}generateConst(builder){return builder.generateConst(this.getNodeType(builder),this.value)}generate(builder,output2){const type=this.getNodeType(builder);return _regNum.test(type)&&_regNum.test(output2)?builder.generateConst(output2,this.value):builder.format(this.generateConst(builder),type,output2)}}class MemberNode extends Node{static get type(){return"MemberNode"}constructor(node,property2){super(),this.node=node,this.property=property2,this.isMemberNode=!0}getNodeType(builder){return this.node.getMemberType(builder,this.property)}generate(builder){return this.node.build(builder)+"."+this.property}}let currentStack=null;const NodeElements=new Map;function addMethodChaining(name,nodeElement){if(NodeElements.has(name)){console.warn(`Redefinition of method chaining ${name}`);return}if(typeof nodeElement!="function")throw new Error(`Node element ${name} is not a function`);NodeElements.set(name,nodeElement)}const parseSwizzle=props=>props.replace(/r|s/g,"x").replace(/g|t/g,"y").replace(/b|p/g,"z").replace(/a|q/g,"w"),parseSwizzleAndSort=props=>parseSwizzle(props).split("").sort().join(""),shaderNodeHandler={setup(NodeClosure,params){const inputs=params.shift();return NodeClosure(nodeObjects(inputs),...params)},get(node,prop,nodeObj){if(typeof prop=="string"&&node[prop]===void 0){if(node.isStackNode!==!0&&prop==="assign")return(...params)=>(currentStack.assign(nodeObj,...params),nodeObj);if(NodeElements.has(prop)){const nodeElement=NodeElements.get(prop);return node.isStackNode?(...params)=>nodeObj.add(nodeElement(...params)):(...params)=>nodeElement(nodeObj,...params)}else{if(prop==="self")return node;if(prop.endsWith("Assign")&&NodeElements.has(prop.slice(0,prop.length-6))){const nodeElement=NodeElements.get(prop.slice(0,prop.length-6));return node.isStackNode?(...params)=>nodeObj.assign(params[0],nodeElement(...params)):(...params)=>nodeObj.assign(nodeElement(nodeObj,...params))}else{if(/^[xyzwrgbastpq]{1,4}$/.test(prop)===!0)return prop=parseSwizzle(prop),nodeObject$1(new SplitNode(nodeObj,prop));if(/^set[XYZWRGBASTPQ]{1,4}$/.test(prop)===!0)return prop=parseSwizzleAndSort(prop.slice(3).toLowerCase()),value=>nodeObject$1(new SetNode(node,prop,value));if(/^flip[XYZWRGBASTPQ]{1,4}$/.test(prop)===!0)return prop=parseSwizzleAndSort(prop.slice(4).toLowerCase()),()=>nodeObject$1(new FlipNode(nodeObject$1(node),prop));if(prop==="width"||prop==="height"||prop==="depth")return prop==="width"?prop="x":prop==="height"?prop="y":prop==="depth"&&(prop="z"),nodeObject$1(new SplitNode(node,prop));if(/^\d+$/.test(prop)===!0)return nodeObject$1(new ArrayElementNode(nodeObj,new ConstNode(Number(prop),"uint")));if(/^get$/.test(prop)===!0)return value=>nodeObject$1(new MemberNode(nodeObj,value))}}}return Reflect.get(node,prop,nodeObj)},set(node,prop,value,nodeObj){return typeof prop=="string"&&node[prop]===void 0&&(/^[xyzwrgbastpq]{1,4}$/.test(prop)===!0||prop==="width"||prop==="height"||prop==="depth"||/^\d+$/.test(prop)===!0)?(nodeObj[prop].assign(value),!0):Reflect.set(node,prop,value,nodeObj)}},nodeObjectsCacheMap=new WeakMap,nodeBuilderFunctionsCacheMap=new WeakMap,ShaderNodeObject=function(obj,altType=null){const type=getValueType(obj);if(type==="node"){let nodeObject2=nodeObjectsCacheMap.get(obj);return nodeObject2===void 0&&(nodeObject2=new Proxy(obj,shaderNodeHandler),nodeObjectsCacheMap.set(obj,nodeObject2),nodeObjectsCacheMap.set(nodeObject2,nodeObject2)),nodeObject2}else{if(altType===null&&(type==="float"||type==="boolean")||type&&type!=="shader"&&type!=="string")return nodeObject$1(getConstNode(obj,altType));if(type==="shader")return Fn$1(obj)}return obj},ShaderNodeObjects=function(objects,altType=null){for(const name in objects)objects[name]=nodeObject$1(objects[name],altType);return objects},ShaderNodeArray=function(array2,altType=null){const len=array2.length;for(let i2=0;i2<len;i2++)array2[i2]=nodeObject$1(array2[i2],altType);return array2},ShaderNodeProxy=function(NodeClass,scope=null,factor=null,settings=null){const assignNode=node=>nodeObject$1(settings!==null?Object.assign(node,settings):node);return scope===null?(...params)=>assignNode(new NodeClass(...nodeArray(params))):factor!==null?(factor=nodeObject$1(factor),(...params)=>assignNode(new NodeClass(scope,...nodeArray(params),factor))):(...params)=>assignNode(new NodeClass(scope,...nodeArray(params)))},ShaderNodeImmutable=function(NodeClass,...params){return nodeObject$1(new NodeClass(...nodeArray(params)))};class ShaderCallNodeInternal extends Node{constructor(shaderNode,inputNodes){super(),this.shaderNode=shaderNode,this.inputNodes=inputNodes}getNodeType(builder){return this.shaderNode.nodeType||this.getOutputNode(builder).getNodeType(builder)}getMemberType(builder,name){return this.getOutputNode(builder).getMemberType(builder,name)}call(builder){const{shaderNode,inputNodes}=this,properties=builder.getNodeProperties(shaderNode);if(properties.onceOutput)return properties.onceOutput;let result=null;if(shaderNode.layout){let functionNodesCacheMap=nodeBuilderFunctionsCacheMap.get(builder.constructor);functionNodesCacheMap===void 0&&(functionNodesCacheMap=new WeakMap,nodeBuilderFunctionsCacheMap.set(builder.constructor,functionNodesCacheMap));let functionNode=functionNodesCacheMap.get(shaderNode);functionNode===void 0&&(functionNode=nodeObject$1(builder.buildFunctionNode(shaderNode)),functionNodesCacheMap.set(shaderNode,functionNode)),builder.addInclude(functionNode),result=nodeObject$1(functionNode.call(inputNodes))}else{const jsFunc=shaderNode.jsFunc,outputNode=inputNodes!==null||jsFunc.length>1?jsFunc(inputNodes||[],builder):jsFunc(builder);result=nodeObject$1(outputNode)}return shaderNode.once&&(properties.onceOutput=result),result}getOutputNode(builder){const properties=builder.getNodeProperties(this);return properties.outputNode===null&&(properties.outputNode=this.setupOutput(builder)),properties.outputNode}setup(builder){return this.getOutputNode(builder)}setupOutput(builder){return builder.addStack(),builder.stack.outputNode=this.call(builder),builder.removeStack()}generate(builder,output2){return this.getOutputNode(builder).build(builder,output2)}}class ShaderNodeInternal extends Node{constructor(jsFunc,nodeType){super(nodeType),this.jsFunc=jsFunc,this.layout=null,this.global=!0,this.once=!1}setLayout(layout){return this.layout=layout,this}call(inputs=null){return nodeObjects(inputs),nodeObject$1(new ShaderCallNodeInternal(this,inputs))}setup(){return this.call()}}const bools=[!1,!0],uints=[0,1,2,3],ints=[-1,-2],floats=[.5,1.5,1/3,1e-6,1e6,Math.PI,Math.PI*2,1/Math.PI,2/Math.PI,1/(Math.PI*2),Math.PI/2],boolsCacheMap=new Map;for(const bool2 of bools)boolsCacheMap.set(bool2,new ConstNode(bool2));const uintsCacheMap=new Map;for(const uint2 of uints)uintsCacheMap.set(uint2,new ConstNode(uint2,"uint"));const intsCacheMap=new Map([...uintsCacheMap].map(el=>new ConstNode(el.value,"int")));for(const int2 of ints)intsCacheMap.set(int2,new ConstNode(int2,"int"));const floatsCacheMap=new Map([...intsCacheMap].map(el=>new ConstNode(el.value)));for(const float2 of floats)floatsCacheMap.set(float2,new ConstNode(float2));for(const float2 of floats)floatsCacheMap.set(-float2,new ConstNode(-float2));const cacheMaps={bool:boolsCacheMap,uint:uintsCacheMap,ints:intsCacheMap,float:floatsCacheMap},constNodesCacheMap=new Map([...boolsCacheMap,...floatsCacheMap]),getConstNode=(value,type)=>constNodesCacheMap.has(value)?constNodesCacheMap.get(value):value.isNode===!0?value:new ConstNode(value,type),safeGetNodeType=node=>{try{return node.getNodeType()}catch{return}},ConvertType=function(type,cacheMap=null){return(...params)=>{if((params.length===0||!["bool","float","int","uint"].includes(type)&&params.every(param=>typeof param!="object"))&&(params=[getValueFromType(type,...params)]),params.length===1&&cacheMap!==null&&cacheMap.has(params[0]))return nodeObject$1(cacheMap.get(params[0]));if(params.length===1){const node=getConstNode(params[0],type);return safeGetNodeType(node)===type?nodeObject$1(node):nodeObject$1(new ConvertNode(node,type))}const nodes=params.map(param=>getConstNode(param));return nodeObject$1(new JoinNode(nodes,type))}},defined=v=>typeof v=="object"&&v!==null?v.value:v,getConstNodeType=value=>value!=null?value.nodeType||value.convertTo||(typeof value=="string"?value:null):null;function ShaderNode(jsFunc,nodeType){return new Proxy(new ShaderNodeInternal(jsFunc,nodeType),shaderNodeHandler)}const nodeObject$1=(val,altType=null)=>ShaderNodeObject(val,altType),nodeObjects=(val,altType=null)=>new ShaderNodeObjects(val,altType),nodeArray=(val,altType=null)=>new ShaderNodeArray(val,altType),nodeProxy=(...params)=>new ShaderNodeProxy(...params),nodeImmutable=(...params)=>new ShaderNodeImmutable(...params),Fn$1=(jsFunc,nodeType)=>{const shaderNode=new ShaderNode(jsFunc,nodeType),fn=(...params)=>{let inputs;return nodeObjects(params),params[0]&&params[0].isNode?inputs=[...params]:inputs=params[0],shaderNode.call(inputs)};return fn.shaderNode=shaderNode,fn.setLayout=layout=>(shaderNode.setLayout(layout),fn),fn.once=()=>(shaderNode.once=!0,fn),fn},tslFn=(...params)=>(console.warn("TSL.ShaderNode: tslFn() has been renamed to Fn()."),Fn$1(...params));addMethodChaining("toGlobal",node=>(node.global=!0,node));const setCurrentStack=stack2=>{currentStack=stack2},getCurrentStack=()=>currentStack,If$1=(...params)=>currentStack.If(...params);function append(node){return currentStack&&currentStack.add(node),node}addMethodChaining("append",append);const color=new ConvertType("color"),float$1=new ConvertType("float",cacheMaps.float),int=new ConvertType("int",cacheMaps.ints),uint=new ConvertType("uint",cacheMaps.uint),bool=new ConvertType("bool",cacheMaps.bool),vec2$1=new ConvertType("vec2"),ivec2=new ConvertType("ivec2"),uvec2=new ConvertType("uvec2"),bvec2=new ConvertType("bvec2"),vec3$1=new ConvertType("vec3"),ivec3=new ConvertType("ivec3"),uvec3=new ConvertType("uvec3"),bvec3=new ConvertType("bvec3"),vec4$1=new ConvertType("vec4"),ivec4=new ConvertType("ivec4"),uvec4=new ConvertType("uvec4"),bvec4=new ConvertType("bvec4"),mat2=new ConvertType("mat2"),mat3=new ConvertType("mat3"),mat4=new ConvertType("mat4"),string=(value="")=>nodeObject$1(new ConstNode(value,"string")),arrayBuffer=value=>nodeObject$1(new ConstNode(value,"ArrayBuffer"));addMethodChaining("toColor",color);addMethodChaining("toFloat",float$1);addMethodChaining("toInt",int);addMethodChaining("toUint",uint);addMethodChaining("toBool",bool);addMethodChaining("toVec2",vec2$1);addMethodChaining("toIVec2",ivec2);addMethodChaining("toUVec2",uvec2);addMethodChaining("toBVec2",bvec2);addMethodChaining("toVec3",vec3$1);addMethodChaining("toIVec3",ivec3);addMethodChaining("toUVec3",uvec3);addMethodChaining("toBVec3",bvec3);addMethodChaining("toVec4",vec4$1);addMethodChaining("toIVec4",ivec4);addMethodChaining("toUVec4",uvec4);addMethodChaining("toBVec4",bvec4);addMethodChaining("toMat2",mat2);addMethodChaining("toMat3",mat3);addMethodChaining("toMat4",mat4);const element=nodeProxy(ArrayElementNode),convert=(node,types)=>nodeObject$1(new ConvertNode(nodeObject$1(node),types)),split=(node,channels)=>nodeObject$1(new SplitNode(nodeObject$1(node),channels));addMethodChaining("element",element);addMethodChaining("convert",convert);class ArrayNode extends TempNode{static get type(){return"ArrayNode"}constructor(nodeType,count,values=null){super(nodeType),this.count=count,this.values=values,this.isArrayNode=!0}getNodeType(builder){return this.nodeType===null&&(this.nodeType=this.values[0].getNodeType(builder)),this.nodeType}getElementType(builder){return this.getNodeType(builder)}generate(builder){const type=this.getNodeType(builder);return builder.generateArray(type,this.count,this.values)}}const array=(...params)=>{let node;if(params.length===1){const values=params[0];node=new ArrayNode(null,values.length,values)}else{const nodeType=params[0],count=params[1];node=new ArrayNode(nodeType,count)}return nodeObject$1(node)};addMethodChaining("toArray",(node,count)=>array(Array(count).fill(node)));class UniformGroupNode extends Node{static get type(){return"UniformGroupNode"}constructor(name,shared2=!1,order=1){super("string"),this.name=name,this.shared=shared2,this.order=order,this.isUniformGroup=!0}serialize(data){super.serialize(data),data.name=this.name,data.version=this.version,data.shared=this.shared}deserialize(data){super.deserialize(data),this.name=data.name,this.version=data.version,this.shared=data.shared}}const uniformGroup=name=>new UniformGroupNode(name),sharedUniformGroup=(name,order=0)=>new UniformGroupNode(name,!0,order),frameGroup=sharedUniformGroup("frame"),renderGroup=sharedUniformGroup("render"),objectGroup=uniformGroup("object");class UniformNode extends InputNode{static get type(){return"UniformNode"}constructor(value,nodeType=null){super(value,nodeType),this.isUniformNode=!0,this.name="",this.groupNode=objectGroup}label(name){return this.name=name,this}setGroup(group){return this.groupNode=group,this}getGroup(){return this.groupNode}getUniformHash(builder){return this.getHash(builder)}onUpdate(callback,updateType){const self2=this.getSelf();return callback=callback.bind(self2),super.onUpdate(frame=>{const value=callback(frame,self2);value!==void 0&&(this.value=value)},updateType)}generate(builder,output2){const type=this.getNodeType(builder),hash2=this.getUniformHash(builder);let sharedNode=builder.getNodeFromHash(hash2);sharedNode===void 0&&(builder.setHashNode(this,hash2),sharedNode=this);const sharedNodeType=sharedNode.getInputType(builder),nodeUniform=builder.getUniformFromNode(sharedNode,sharedNodeType,builder.shaderStage,this.name||builder.context.label),propertyName=builder.getPropertyName(nodeUniform);return builder.context.label!==void 0&&delete builder.context.label,builder.format(propertyName,type,output2)}}const uniform$1=(arg1,arg2)=>{const nodeType=getConstNodeType(arg2||arg1),value=arg1&&arg1.isNode===!0?arg1.node&&arg1.node.value||arg1.value:arg1;return nodeObject$1(new UniformNode(value,nodeType))};class PropertyNode extends Node{static get type(){return"PropertyNode"}constructor(nodeType,name=null,varying2=!1){super(nodeType),this.name=name,this.varying=varying2,this.isPropertyNode=!0}getHash(builder){return this.name||super.getHash(builder)}isGlobal(){return!0}generate(builder){let nodeVar;return this.varying===!0?(nodeVar=builder.getVaryingFromNode(this,this.name),nodeVar.needsInterpolation=!0):nodeVar=builder.getVarFromNode(this,this.name),builder.getPropertyName(nodeVar)}}const property=(type,name)=>nodeObject$1(new PropertyNode(type,name)),varyingProperty=(type,name)=>nodeObject$1(new PropertyNode(type,name,!0)),diffuseColor=nodeImmutable(PropertyNode,"vec4","DiffuseColor"),emissive=nodeImmutable(PropertyNode,"vec3","EmissiveColor"),roughness=nodeImmutable(PropertyNode,"float","Roughness"),metalness=nodeImmutable(PropertyNode,"float","Metalness"),clearcoat=nodeImmutable(PropertyNode,"float","Clearcoat"),clearcoatRoughness=nodeImmutable(PropertyNode,"float","ClearcoatRoughness"),sheen=nodeImmutable(PropertyNode,"vec3","Sheen"),sheenRoughness=nodeImmutable(PropertyNode,"float","SheenRoughness"),iridescence=nodeImmutable(PropertyNode,"float","Iridescence"),iridescenceIOR=nodeImmutable(PropertyNode,"float","IridescenceIOR"),iridescenceThickness=nodeImmutable(PropertyNode,"float","IridescenceThickness"),alphaT=nodeImmutable(PropertyNode,"float","AlphaT"),anisotropy=nodeImmutable(PropertyNode,"float","Anisotropy"),anisotropyT=nodeImmutable(PropertyNode,"vec3","AnisotropyT"),anisotropyB=nodeImmutable(PropertyNode,"vec3","AnisotropyB"),specularColor=nodeImmutable(PropertyNode,"color","SpecularColor"),specularF90=nodeImmutable(PropertyNode,"float","SpecularF90"),shininess=nodeImmutable(PropertyNode,"float","Shininess"),output=nodeImmutable(PropertyNode,"vec4","Output"),dashSize=nodeImmutable(PropertyNode,"float","dashSize"),gapSize=nodeImmutable(PropertyNode,"float","gapSize"),pointWidth=nodeImmutable(PropertyNode,"float","pointWidth"),ior=nodeImmutable(PropertyNode,"float","IOR"),transmission=nodeImmutable(PropertyNode,"float","Transmission"),thickness=nodeImmutable(PropertyNode,"float","Thickness"),attenuationDistance=nodeImmutable(PropertyNode,"float","AttenuationDistance"),attenuationColor=nodeImmutable(PropertyNode,"color","AttenuationColor"),dispersion=nodeImmutable(PropertyNode,"float","Dispersion");class AssignNode extends TempNode{static get type(){return"AssignNode"}constructor(targetNode,sourceNode){super(),this.targetNode=targetNode,this.sourceNode=sourceNode}hasDependencies(){return!1}getNodeType(builder,output2){return output2!=="void"?this.targetNode.getNodeType(builder):"void"}needsSplitAssign(builder){const{targetNode}=this;if(builder.isAvailable("swizzleAssign")===!1&&targetNode.isSplitNode&&targetNode.components.length>1){const targetLength=builder.getTypeLength(targetNode.node.getNodeType(builder));return vectorComponents.join("").slice(0,targetLength)!==targetNode.components}return!1}generate(builder,output2){const{targetNode,sourceNode}=this,needsSplitAssign=this.needsSplitAssign(builder),targetType=targetNode.getNodeType(builder),target=targetNode.context({assign:!0}).build(builder),source=sourceNode.build(builder,targetType),sourceType=sourceNode.getNodeType(builder),nodeData=builder.getDataFromNode(this);let snippet;if(nodeData.initialized===!0)output2!=="void"&&(snippet=target);else if(needsSplitAssign){const sourceVar=builder.getVarFromNode(this,null,targetType),sourceProperty=builder.getPropertyName(sourceVar);builder.addLineFlowCode(`${sourceProperty} = ${source}`,this);const targetRoot=targetNode.node.context({assign:!0}).build(builder);for(let i2=0;i2<targetNode.components.length;i2++){const component=targetNode.components[i2];builder.addLineFlowCode(`${targetRoot}.${component} = ${sourceProperty}[ ${i2} ]`,this)}output2!=="void"&&(snippet=target)}else snippet=`${target} = ${source}`,(output2==="void"||sourceType==="void")&&(builder.addLineFlowCode(snippet,this),output2!=="void"&&(snippet=target));return nodeData.initialized=!0,builder.format(snippet,targetType,output2)}}const assign=nodeProxy(AssignNode);addMethodChaining("assign",assign);class FunctionCallNode extends TempNode{static get type(){return"FunctionCallNode"}constructor(functionNode=null,parameters={}){super(),this.functionNode=functionNode,this.parameters=parameters}setParameters(parameters){return this.parameters=parameters,this}getParameters(){return this.parameters}getNodeType(builder){return this.functionNode.getNodeType(builder)}generate(builder){const params=[],functionNode=this.functionNode,inputs=functionNode.getInputs(builder),parameters=this.parameters,generateInput=(node,inputNode)=>{const type=inputNode.type,pointer=type==="pointer";let output2;return pointer?output2="&"+node.build(builder):output2=node.build(builder,type),output2};if(Array.isArray(parameters))for(let i2=0;i2<parameters.length;i2++)params.push(generateInput(parameters[i2],inputs[i2]));else for(const inputNode of inputs){const node=parameters[inputNode.name];if(node!==void 0)params.push(generateInput(node,inputNode));else throw new Error(`FunctionCallNode: Input '${inputNode.name}' not found in FunctionNode.`)}return`${functionNode.build(builder,"property")}( ${params.join(", ")} )`}}const call=(func,...params)=>(params=params.length>1||params[0]&&params[0].isNode===!0?nodeArray(params):nodeObjects(params[0]),nodeObject$1(new FunctionCallNode(nodeObject$1(func),params)));addMethodChaining("call",call);class OperatorNode extends TempNode{static get type(){return"OperatorNode"}constructor(op,aNode,bNode,...params){if(super(),params.length>0){let finalOp=new OperatorNode(op,aNode,bNode);for(let i2=0;i2<params.length-1;i2++)finalOp=new OperatorNode(op,finalOp,params[i2]);aNode=finalOp,bNode=params[params.length-1]}this.op=op,this.aNode=aNode,this.bNode=bNode,this.isOperatorNode=!0}getNodeType(builder,output2){const op=this.op,aNode=this.aNode,bNode=this.bNode,typeA=aNode.getNodeType(builder),typeB=typeof bNode<"u"?bNode.getNodeType(builder):null;if(typeA==="void"||typeB==="void")return"void";if(op==="%")return typeA;if(op==="~"||op==="&"||op==="|"||op==="^"||op===">>"||op==="<<")return builder.getIntegerType(typeA);if(op==="!"||op==="=="||op==="&&"||op==="||"||op==="^^")return"bool";if(op==="<"||op===">"||op==="<="||op===">="){const typeLength=output2?builder.getTypeLength(output2):Math.max(builder.getTypeLength(typeA),builder.getTypeLength(typeB));return typeLength>1?`bvec${typeLength}`:"bool"}else{if(builder.isMatrix(typeA)){if(typeB==="float")return typeA;if(builder.isVector(typeB))return builder.getVectorFromMatrix(typeA);if(builder.isMatrix(typeB))return typeA}else if(builder.isMatrix(typeB)){if(typeA==="float")return typeB;if(builder.isVector(typeA))return builder.getVectorFromMatrix(typeB)}return builder.getTypeLength(typeB)>builder.getTypeLength(typeA)?typeB:typeA}}generate(builder,output2){const op=this.op,aNode=this.aNode,bNode=this.bNode,type=this.getNodeType(builder,output2);let typeA=null,typeB=null;type!=="void"?(typeA=aNode.getNodeType(builder),typeB=typeof bNode<"u"?bNode.getNodeType(builder):null,op==="<"||op===">"||op==="<="||op===">="||op==="=="?builder.isVector(typeA)?typeB=typeA:typeA!==typeB&&(typeA=typeB="float"):op===">>"||op==="<<"?(typeA=type,typeB=builder.changeComponentType(typeB,"uint")):builder.isMatrix(typeA)?typeB==="float"?typeB="float":builder.isVector(typeB)?typeB=builder.getVectorFromMatrix(typeA):builder.isMatrix(typeB)||(typeA=typeB=type):builder.isMatrix(typeB)?typeA==="float"?typeA="float":builder.isVector(typeA)?typeA=builder.getVectorFromMatrix(typeB):typeA=typeB=type:typeA=typeB=type):typeA=typeB=type;const a2=aNode.build(builder,typeA),b=typeof bNode<"u"?bNode.build(builder,typeB):null,outputLength=builder.getTypeLength(output2),fnOpSnippet=builder.getFunctionOperator(op);if(output2!=="void")return op==="<"&&outputLength>1?builder.useComparisonMethod?builder.format(`${builder.getMethod("lessThan",output2)}( ${a2}, ${b} )`,type,output2):builder.format(`( ${a2} < ${b} )`,type,output2):op==="<="&&outputLength>1?builder.useComparisonMethod?builder.format(`${builder.getMethod("lessThanEqual",output2)}( ${a2}, ${b} )`,type,output2):builder.format(`( ${a2} <= ${b} )`,type,output2):op===">"&&outputLength>1?builder.useComparisonMethod?builder.format(`${builder.getMethod("greaterThan",output2)}( ${a2}, ${b} )`,type,output2):builder.format(`( ${a2} > ${b} )`,type,output2):op===">="&&outputLength>1?builder.useComparisonMethod?builder.format(`${builder.getMethod("greaterThanEqual",output2)}( ${a2}, ${b} )`,type,output2):builder.format(`( ${a2} >= ${b} )`,type,output2):op==="!"||op==="~"?builder.format(`(${op}${a2})`,typeA,output2):fnOpSnippet?builder.format(`${fnOpSnippet}( ${a2}, ${b} )`,type,output2):builder.isMatrix(typeA)&&typeB==="float"?builder.format(`( ${b} ${op} ${a2} )`,type,output2):typeA==="float"&&builder.isMatrix(typeB)?builder.format(`${a2} ${op} ${b}`,type,output2):builder.format(`( ${a2} ${op} ${b} )`,type,output2);if(typeA!=="void")return fnOpSnippet?builder.format(`${fnOpSnippet}( ${a2}, ${b} )`,type,output2):builder.isMatrix(typeA)&&typeB==="float"?builder.format(`${b} ${op} ${a2}`,type,output2):builder.format(`${a2} ${op} ${b}`,type,output2)}serialize(data){super.serialize(data),data.op=this.op}deserialize(data){super.deserialize(data),this.op=data.op}}const add$3=nodeProxy(OperatorNode,"+"),sub=nodeProxy(OperatorNode,"-"),mul$1=nodeProxy(OperatorNode,"*"),div=nodeProxy(OperatorNode,"/"),modInt=nodeProxy(OperatorNode,"%"),equal=nodeProxy(OperatorNode,"=="),notEqual=nodeProxy(OperatorNode,"!="),lessThan=nodeProxy(OperatorNode,"<"),greaterThan=nodeProxy(OperatorNode,">"),lessThanEqual=nodeProxy(OperatorNode,"<="),greaterThanEqual=nodeProxy(OperatorNode,">="),and=nodeProxy(OperatorNode,"&&"),or=nodeProxy(OperatorNode,"||"),not=nodeProxy(OperatorNode,"!"),xor=nodeProxy(OperatorNode,"^^"),bitAnd=nodeProxy(OperatorNode,"&"),bitNot=nodeProxy(OperatorNode,"~"),bitOr=nodeProxy(OperatorNode,"|"),bitXor=nodeProxy(OperatorNode,"^"),shiftLeft=nodeProxy(OperatorNode,"<<"),shiftRight=nodeProxy(OperatorNode,">>");addMethodChaining("add",add$3);addMethodChaining("sub",sub);addMethodChaining("mul",mul$1);addMethodChaining("div",div);addMethodChaining("modInt",modInt);addMethodChaining("equal",equal);addMethodChaining("notEqual",notEqual);addMethodChaining("lessThan",lessThan);addMethodChaining("greaterThan",greaterThan);addMethodChaining("lessThanEqual",lessThanEqual);addMethodChaining("greaterThanEqual",greaterThanEqual);addMethodChaining("and",and);addMethodChaining("or",or);addMethodChaining("not",not);addMethodChaining("xor",xor);addMethodChaining("bitAnd",bitAnd);addMethodChaining("bitNot",bitNot);addMethodChaining("bitOr",bitOr);addMethodChaining("bitXor",bitXor);addMethodChaining("shiftLeft",shiftLeft);addMethodChaining("shiftRight",shiftRight);const remainder=(...params)=>(console.warn("TSL.OperatorNode: .remainder() has been renamed to .modInt()."),modInt(...params));addMethodChaining("remainder",remainder);class MathNode extends TempNode{static get type(){return"MathNode"}constructor(method,aNode,bNode=null,cNode=null){super(),this.method=method,this.aNode=aNode,this.bNode=bNode,this.cNode=cNode,this.isMathNode=!0}getInputType(builder){const aType=this.aNode.getNodeType(builder),bType=this.bNode?this.bNode.getNodeType(builder):null,cType=this.cNode?this.cNode.getNodeType(builder):null,aLen=builder.isMatrix(aType)?0:builder.getTypeLength(aType),bLen=builder.isMatrix(bType)?0:builder.getTypeLength(bType),cLen=builder.isMatrix(cType)?0:builder.getTypeLength(cType);return aLen>bLen&&aLen>cLen?aType:bLen>cLen?bType:cLen>aLen?cType:aType}getNodeType(builder){const method=this.method;return method===MathNode.LENGTH||method===MathNode.DISTANCE||method===MathNode.DOT?"float":method===MathNode.CROSS?"vec3":method===MathNode.ALL?"bool":method===MathNode.EQUALS?builder.changeComponentType(this.aNode.getNodeType(builder),"bool"):method===MathNode.MOD?this.aNode.getNodeType(builder):this.getInputType(builder)}generate(builder,output2){let method=this.method;const type=this.getNodeType(builder),inputType=this.getInputType(builder),a2=this.aNode,b=this.bNode,c2=this.cNode,coordinateSystem=builder.renderer.coordinateSystem;if(method===MathNode.TRANSFORM_DIRECTION){let tA=a2,tB=b;builder.isMatrix(tA.getNodeType(builder))?tB=vec4$1(vec3$1(tB),0):tA=vec4$1(vec3$1(tA),0);const mulNode=mul$1(tA,tB).xyz;return normalize$1(mulNode).build(builder,output2)}else{if(method===MathNode.NEGATE)return builder.format("( - "+a2.build(builder,inputType)+" )",type,output2);if(method===MathNode.ONE_MINUS)return sub(1,a2).build(builder,output2);if(method===MathNode.RECIPROCAL)return div(1,a2).build(builder,output2);if(method===MathNode.DIFFERENCE)return abs$2(sub(a2,b)).build(builder,output2);{const params=[];return method===MathNode.CROSS||method===MathNode.MOD?params.push(a2.build(builder,type),b.build(builder,type)):coordinateSystem===WebGLCoordinateSystem&&method===MathNode.STEP?params.push(a2.build(builder,builder.getTypeLength(a2.getNodeType(builder))===1?"float":inputType),b.build(builder,inputType)):coordinateSystem===WebGLCoordinateSystem&&(method===MathNode.MIN||method===MathNode.MAX)||method===MathNode.MOD?params.push(a2.build(builder,inputType),b.build(builder,builder.getTypeLength(b.getNodeType(builder))===1?"float":inputType)):method===MathNode.REFRACT?params.push(a2.build(builder,inputType),b.build(builder,inputType),c2.build(builder,"float")):method===MathNode.MIX?params.push(a2.build(builder,inputType),b.build(builder,inputType),c2.build(builder,builder.getTypeLength(c2.getNodeType(builder))===1?"float":inputType)):(coordinateSystem===WebGPUCoordinateSystem&&method===MathNode.ATAN&&b!==null&&(method="atan2"),params.push(a2.build(builder,inputType)),b!==null&&params.push(b.build(builder,inputType)),c2!==null&&params.push(c2.build(builder,inputType))),builder.format(`${builder.getMethod(method,type)}( ${params.join(", ")} )`,type,output2)}}}serialize(data){super.serialize(data),data.method=this.method}deserialize(data){super.deserialize(data),this.method=data.method}}MathNode.ALL="all";MathNode.ANY="any";MathNode.RADIANS="radians";MathNode.DEGREES="degrees";MathNode.EXP="exp";MathNode.EXP2="exp2";MathNode.LOG="log";MathNode.LOG2="log2";MathNode.SQRT="sqrt";MathNode.INVERSE_SQRT="inversesqrt";MathNode.FLOOR="floor";MathNode.CEIL="ceil";MathNode.NORMALIZE="normalize";MathNode.FRACT="fract";MathNode.SIN="sin";MathNode.COS="cos";MathNode.TAN="tan";MathNode.ASIN="asin";MathNode.ACOS="acos";MathNode.ATAN="atan";MathNode.ABS="abs";MathNode.SIGN="sign";MathNode.LENGTH="length";MathNode.NEGATE="negate";MathNode.ONE_MINUS="oneMinus";MathNode.DFDX="dFdx";MathNode.DFDY="dFdy";MathNode.ROUND="round";MathNode.RECIPROCAL="reciprocal";MathNode.TRUNC="trunc";MathNode.FWIDTH="fwidth";MathNode.TRANSPOSE="transpose";MathNode.BITCAST="bitcast";MathNode.EQUALS="equals";MathNode.MIN="min";MathNode.MAX="max";MathNode.MOD="mod";MathNode.STEP="step";MathNode.REFLECT="reflect";MathNode.DISTANCE="distance";MathNode.DIFFERENCE="difference";MathNode.DOT="dot";MathNode.CROSS="cross";MathNode.POW="pow";MathNode.TRANSFORM_DIRECTION="transformDirection";MathNode.MIX="mix";MathNode.CLAMP="clamp";MathNode.REFRACT="refract";MathNode.SMOOTHSTEP="smoothstep";MathNode.FACEFORWARD="faceforward";const EPSILON=float$1(1e-6),INFINITY=float$1(1e6),PI$1=float$1(Math.PI),PI2=float$1(Math.PI*2),all$1=nodeProxy(MathNode,MathNode.ALL),any=nodeProxy(MathNode,MathNode.ANY),radians=nodeProxy(MathNode,MathNode.RADIANS),degrees=nodeProxy(MathNode,MathNode.DEGREES),exp=nodeProxy(MathNode,MathNode.EXP),exp2=nodeProxy(MathNode,MathNode.EXP2),log=nodeProxy(MathNode,MathNode.LOG),log2=nodeProxy(MathNode,MathNode.LOG2),sqrt$2=nodeProxy(MathNode,MathNode.SQRT),inverseSqrt=nodeProxy(MathNode,MathNode.INVERSE_SQRT),floor$3=nodeProxy(MathNode,MathNode.FLOOR),ceil$2=nodeProxy(MathNode,MathNode.CEIL),normalize$1=nodeProxy(MathNode,MathNode.NORMALIZE),fract=nodeProxy(MathNode,MathNode.FRACT),sin$2=nodeProxy(MathNode,MathNode.SIN),cos$2=nodeProxy(MathNode,MathNode.COS),tan=nodeProxy(MathNode,MathNode.TAN),asin$1=nodeProxy(MathNode,MathNode.ASIN),acos=nodeProxy(MathNode,MathNode.ACOS),atan$1=nodeProxy(MathNode,MathNode.ATAN),abs$2=nodeProxy(MathNode,MathNode.ABS),sign$1=nodeProxy(MathNode,MathNode.SIGN),length$1=nodeProxy(MathNode,MathNode.LENGTH),negate=nodeProxy(MathNode,MathNode.NEGATE),oneMinus=nodeProxy(MathNode,MathNode.ONE_MINUS),dFdx=nodeProxy(MathNode,MathNode.DFDX),dFdy=nodeProxy(MathNode,MathNode.DFDY),round$1=nodeProxy(MathNode,MathNode.ROUND),reciprocal=nodeProxy(MathNode,MathNode.RECIPROCAL),trunc=nodeProxy(MathNode,MathNode.TRUNC),fwidth=nodeProxy(MathNode,MathNode.FWIDTH),transpose=nodeProxy(MathNode,MathNode.TRANSPOSE),bitcast=nodeProxy(MathNode,MathNode.BITCAST),equals$3=nodeProxy(MathNode,MathNode.EQUALS),min$1=nodeProxy(MathNode,MathNode.MIN),max$1=nodeProxy(MathNode,MathNode.MAX),mod=nodeProxy(MathNode,MathNode.MOD),step$1=nodeProxy(MathNode,MathNode.STEP),reflect=nodeProxy(MathNode,MathNode.REFLECT),distance=nodeProxy(MathNode,MathNode.DISTANCE),difference=nodeProxy(MathNode,MathNode.DIFFERENCE),dot=nodeProxy(MathNode,MathNode.DOT),cross=nodeProxy(MathNode,MathNode.CROSS),pow$1=nodeProxy(MathNode,MathNode.POW),pow2=nodeProxy(MathNode,MathNode.POW,2),pow3=nodeProxy(MathNode,MathNode.POW,3),pow4=nodeProxy(MathNode,MathNode.POW,4),transformDirection=nodeProxy(MathNode,MathNode.TRANSFORM_DIRECTION),cbrt=a2=>mul$1(sign$1(a2),pow$1(abs$2(a2),1/3)),lengthSq=a2=>dot(a2,a2),mix$1=nodeProxy(MathNode,MathNode.MIX),clamp$3=(value,low=0,high=1)=>nodeObject$1(new MathNode(MathNode.CLAMP,nodeObject$1(value),nodeObject$1(low),nodeObject$1(high))),saturate=value=>clamp$3(value),refract=nodeProxy(MathNode,MathNode.REFRACT),smoothstep$1=nodeProxy(MathNode,MathNode.SMOOTHSTEP),faceForward=nodeProxy(MathNode,MathNode.FACEFORWARD),rand$1=Fn$1(([uv2])=>{const c2=43758.5453,dt=dot(uv2.xy,vec2$1(12.9898,78.233)),sn=mod(dt,PI$1);return fract(sin$2(sn).mul(c2))}),mixElement=(t2,e1,e2)=>mix$1(e1,e2,t2),smoothstepElement=(x,low,high)=>smoothstep$1(low,high,x),atan2=(y,x)=>(console.warn('THREE.TSL: "atan2" is overloaded. Use "atan" instead.'),atan$1(y,x)),faceforward=faceForward,inversesqrt=inverseSqrt;addMethodChaining("all",all$1);addMethodChaining("any",any);addMethodChaining("equals",equals$3);addMethodChaining("radians",radians);addMethodChaining("degrees",degrees);addMethodChaining("exp",exp);addMethodChaining("exp2",exp2);addMethodChaining("log",log);addMethodChaining("log2",log2);addMethodChaining("sqrt",sqrt$2);addMethodChaining("inverseSqrt",inverseSqrt);addMethodChaining("floor",floor$3);addMethodChaining("ceil",ceil$2);addMethodChaining("normalize",normalize$1);addMethodChaining("fract",fract);addMethodChaining("sin",sin$2);addMethodChaining("cos",cos$2);addMethodChaining("tan",tan);addMethodChaining("asin",asin$1);addMethodChaining("acos",acos);addMethodChaining("atan",atan$1);addMethodChaining("abs",abs$2);addMethodChaining("sign",sign$1);addMethodChaining("length",length$1);addMethodChaining("lengthSq",lengthSq);addMethodChaining("negate",negate);addMethodChaining("oneMinus",oneMinus);addMethodChaining("dFdx",dFdx);addMethodChaining("dFdy",dFdy);addMethodChaining("round",round$1);addMethodChaining("reciprocal",reciprocal);addMethodChaining("trunc",trunc);addMethodChaining("fwidth",fwidth);addMethodChaining("atan2",atan2);addMethodChaining("min",min$1);addMethodChaining("max",max$1);addMethodChaining("mod",mod);addMethodChaining("step",step$1);addMethodChaining("reflect",reflect);addMethodChaining("distance",distance);addMethodChaining("dot",dot);addMethodChaining("cross",cross);addMethodChaining("pow",pow$1);addMethodChaining("pow2",pow2);addMethodChaining("pow3",pow3);addMethodChaining("pow4",pow4);addMethodChaining("transformDirection",transformDirection);addMethodChaining("mix",mixElement);addMethodChaining("clamp",clamp$3);addMethodChaining("refract",refract);addMethodChaining("smoothstep",smoothstepElement);addMethodChaining("faceForward",faceForward);addMethodChaining("difference",difference);addMethodChaining("saturate",saturate);addMethodChaining("cbrt",cbrt);addMethodChaining("transpose",transpose);addMethodChaining("rand",rand$1);class ConditionalNode extends Node{static get type(){return"ConditionalNode"}constructor(condNode,ifNode,elseNode=null){super(),this.condNode=condNode,this.ifNode=ifNode,this.elseNode=elseNode}getNodeType(builder){const{ifNode,elseNode}=builder.getNodeProperties(this);if(ifNode===void 0)return this.setup(builder),this.getNodeType(builder);const ifType=ifNode.getNodeType(builder);if(elseNode!==null){const elseType=elseNode.getNodeType(builder);if(builder.getTypeLength(elseType)>builder.getTypeLength(ifType))return elseType}return ifType}setup(builder){const condNode=this.condNode.cache(),ifNode=this.ifNode.cache(),elseNode=this.elseNode?this.elseNode.cache():null,currentNodeBlock=builder.context.nodeBlock;builder.getDataFromNode(ifNode).parentNodeBlock=currentNodeBlock,elseNode!==null&&(builder.getDataFromNode(elseNode).parentNodeBlock=currentNodeBlock);const properties=builder.getNodeProperties(this);properties.condNode=condNode,properties.ifNode=ifNode.context({nodeBlock:ifNode}),properties.elseNode=elseNode?elseNode.context({nodeBlock:elseNode}):null}generate(builder,output2){const type=this.getNodeType(builder),nodeData=builder.getDataFromNode(this);if(nodeData.nodeProperty!==void 0)return nodeData.nodeProperty;const{condNode,ifNode,elseNode}=builder.getNodeProperties(this),needsOutput=output2!=="void",nodeProperty=needsOutput?property(type).build(builder):"";nodeData.nodeProperty=nodeProperty;const nodeSnippet=condNode.build(builder,"bool");builder.addFlowCode(`
${builder.tab}if ( ${nodeSnippet} ) {

`).addFlowTab();let ifSnippet=ifNode.build(builder,type);if(ifSnippet&&(needsOutput?ifSnippet=nodeProperty+" = "+ifSnippet+";":ifSnippet="return "+ifSnippet+";"),builder.removeFlowTab().addFlowCode(builder.tab+"	"+ifSnippet+`

`+builder.tab+"}"),elseNode!==null){builder.addFlowCode(` else {

`).addFlowTab();let elseSnippet=elseNode.build(builder,type);elseSnippet&&(needsOutput?elseSnippet=nodeProperty+" = "+elseSnippet+";":elseSnippet="return "+elseSnippet+";"),builder.removeFlowTab().addFlowCode(builder.tab+"	"+elseSnippet+`

`+builder.tab+`}

`)}else builder.addFlowCode(`

`);return builder.format(nodeProperty,type,output2)}}const select=nodeProxy(ConditionalNode);addMethodChaining("select",select);const cond=(...params)=>(console.warn("TSL.ConditionalNode: cond() has been renamed to select()."),select(...params));addMethodChaining("cond",cond);class ContextNode extends Node{static get type(){return"ContextNode"}constructor(node,value={}){super(),this.isContextNode=!0,this.node=node,this.value=value}getScope(){return this.node.getScope()}getNodeType(builder){return this.node.getNodeType(builder)}analyze(builder){this.node.build(builder)}setup(builder){const previousContext=builder.getContext();builder.setContext({...builder.context,...this.value});const node=this.node.build(builder);return builder.setContext(previousContext),node}generate(builder,output2){const previousContext=builder.getContext();builder.setContext({...builder.context,...this.value});const snippet=this.node.build(builder,output2);return builder.setContext(previousContext),snippet}}const context=nodeProxy(ContextNode),label=(node,name)=>context(node,{label:name});addMethodChaining("context",context);addMethodChaining("label",label);class VarNode extends Node{static get type(){return"VarNode"}constructor(node,name=null,readOnly=!1){super(),this.node=node,this.name=name,this.global=!0,this.isVarNode=!0,this.readOnly=readOnly}getHash(builder){return this.name||super.getHash(builder)}getMemberType(builder,name){return this.node.getMemberType(builder,name)}getElementType(builder){return this.node.getElementType(builder)}getNodeType(builder){return this.node.getNodeType(builder)}generate(builder){const{node,name,readOnly}=this,{renderer}=builder,isWebGPUBackend=renderer.backend.isWebGPUBackend===!0;let isDeterministic=!1,shouldTreatAsReadOnly=!1;readOnly&&(isDeterministic=builder.isDeterministic(node),shouldTreatAsReadOnly=isWebGPUBackend?readOnly:isDeterministic);const vectorType=builder.getVectorType(this.getNodeType(builder)),snippet=node.build(builder,vectorType),nodeVar=builder.getVarFromNode(this,name,vectorType,void 0,shouldTreatAsReadOnly),propertyName=builder.getPropertyName(nodeVar);let declarationPrefix=propertyName;if(shouldTreatAsReadOnly)if(isWebGPUBackend)declarationPrefix=isDeterministic?`const ${propertyName}`:`let ${propertyName}`;else{const count=builder.getArrayCount(node);declarationPrefix=`const ${builder.getVar(nodeVar.type,propertyName,count)}`}return builder.addLineFlowCode(`${declarationPrefix} = ${snippet}`,this),propertyName}}const createVar=nodeProxy(VarNode),Var=(node,name=null)=>createVar(node,name).append(),Const=(node,name=null)=>createVar(node,name,!0).append();addMethodChaining("toVar",Var);addMethodChaining("toConst",Const);const temp=node=>(console.warn('TSL: "temp( node )" is deprecated. Use "Var( node )" or "node.toVar()" instead.'),createVar(node));addMethodChaining("temp",temp);class VaryingNode extends Node{static get type(){return"VaryingNode"}constructor(node,name=null){super(),this.node=node,this.name=name,this.isVaryingNode=!0}isGlobal(){return!0}getHash(builder){return this.name||super.getHash(builder)}getNodeType(builder){return this.node.getNodeType(builder)}setupVarying(builder){const properties=builder.getNodeProperties(this);let varying2=properties.varying;if(varying2===void 0){const name=this.name,type=this.getNodeType(builder);properties.varying=varying2=builder.getVaryingFromNode(this,name,type),properties.node=this.node}return varying2.needsInterpolation||(varying2.needsInterpolation=builder.shaderStage==="fragment"),varying2}setup(builder){this.setupVarying(builder)}analyze(builder){return this.setupVarying(builder),this.node.analyze(builder)}generate(builder){const properties=builder.getNodeProperties(this),varying2=this.setupVarying(builder),needsReassign=builder.shaderStage==="fragment"&&properties.reassignPosition===!0&&builder.context.needsPositionReassign;if(properties.propertyName===void 0||needsReassign){const type=this.getNodeType(builder),propertyName=builder.getPropertyName(varying2,NodeShaderStage.VERTEX);builder.flowNodeFromShaderStage(NodeShaderStage.VERTEX,this.node,type,propertyName),properties.propertyName=propertyName,needsReassign?properties.reassignPosition=!1:properties.reassignPosition===void 0&&builder.context.isPositionNodeInput&&(properties.reassignPosition=!0)}return builder.getPropertyName(varying2)}}const varying=nodeProxy(VaryingNode),vertexStage=node=>varying(node);addMethodChaining("toVarying",varying);addMethodChaining("toVertexStage",vertexStage);addMethodChaining("varying",(...params)=>(console.warn("TSL.VaryingNode: .varying() has been renamed to .toVarying()."),varying(...params)));addMethodChaining("vertexStage",(...params)=>(console.warn("TSL.VaryingNode: .vertexStage() has been renamed to .toVertexStage()."),varying(...params)));const sRGBTransferEOTF=Fn$1(([color2])=>{const a2=color2.mul(.9478672986).add(.0521327014).pow(2.4),b=color2.mul(.0773993808),factor=color2.lessThanEqual(.04045);return mix$1(a2,b,factor)}).setLayout({name:"sRGBTransferEOTF",type:"vec3",inputs:[{name:"color",type:"vec3"}]}),sRGBTransferOETF=Fn$1(([color2])=>{const a2=color2.pow(.41666).mul(1.055).sub(.055),b=color2.mul(12.92),factor=color2.lessThanEqual(.0031308);return mix$1(a2,b,factor)}).setLayout({name:"sRGBTransferOETF",type:"vec3",inputs:[{name:"color",type:"vec3"}]}),WORKING_COLOR_SPACE="WorkingColorSpace",OUTPUT_COLOR_SPACE="OutputColorSpace";class ColorSpaceNode extends TempNode{static get type(){return"ColorSpaceNode"}constructor(colorNode,source,target){super("vec4"),this.colorNode=colorNode,this.source=source,this.target=target}resolveColorSpace(builder,colorSpace){return colorSpace===WORKING_COLOR_SPACE?ColorManagement.workingColorSpace:colorSpace===OUTPUT_COLOR_SPACE?builder.context.outputColorSpace||builder.renderer.outputColorSpace:colorSpace}setup(builder){const{colorNode}=this,source=this.resolveColorSpace(builder,this.source),target=this.resolveColorSpace(builder,this.target);let outputNode=colorNode;return ColorManagement.enabled===!1||source===target||!source||!target||(ColorManagement.getTransfer(source)===SRGBTransfer&&(outputNode=vec4$1(sRGBTransferEOTF(outputNode.rgb),outputNode.a)),ColorManagement.getPrimaries(source)!==ColorManagement.getPrimaries(target)&&(outputNode=vec4$1(mat3(ColorManagement._getMatrix(new Matrix3,source,target)).mul(outputNode.rgb),outputNode.a)),ColorManagement.getTransfer(target)===SRGBTransfer&&(outputNode=vec4$1(sRGBTransferOETF(outputNode.rgb),outputNode.a))),outputNode}}const toOutputColorSpace=node=>nodeObject$1(new ColorSpaceNode(nodeObject$1(node),WORKING_COLOR_SPACE,OUTPUT_COLOR_SPACE)),toWorkingColorSpace=node=>nodeObject$1(new ColorSpaceNode(nodeObject$1(node),OUTPUT_COLOR_SPACE,WORKING_COLOR_SPACE)),workingToColorSpace=(node,colorSpace)=>nodeObject$1(new ColorSpaceNode(nodeObject$1(node),WORKING_COLOR_SPACE,colorSpace)),colorSpaceToWorking=(node,colorSpace)=>nodeObject$1(new ColorSpaceNode(nodeObject$1(node),colorSpace,WORKING_COLOR_SPACE)),convertColorSpace=(node,sourceColorSpace,targetColorSpace)=>nodeObject$1(new ColorSpaceNode(nodeObject$1(node),sourceColorSpace,targetColorSpace));addMethodChaining("toOutputColorSpace",toOutputColorSpace);addMethodChaining("toWorkingColorSpace",toWorkingColorSpace);addMethodChaining("workingToColorSpace",workingToColorSpace);addMethodChaining("colorSpaceToWorking",colorSpaceToWorking);let ReferenceElementNode$1=class extends ArrayElementNode{static get type(){return"ReferenceElementNode"}constructor(referenceNode,indexNode){super(referenceNode,indexNode),this.referenceNode=referenceNode,this.isReferenceElementNode=!0}getNodeType(){return this.referenceNode.uniformType}generate(builder){const snippet=super.generate(builder),arrayType=this.referenceNode.getNodeType(),elementType=this.getNodeType();return builder.format(snippet,arrayType,elementType)}};class ReferenceBaseNode extends Node{static get type(){return"ReferenceBaseNode"}constructor(property2,uniformType,object=null,count=null){super(),this.property=property2,this.uniformType=uniformType,this.object=object,this.count=count,this.properties=property2.split("."),this.reference=object,this.node=null,this.group=null,this.updateType=NodeUpdateType.OBJECT}setGroup(group){return this.group=group,this}element(indexNode){return nodeObject$1(new ReferenceElementNode$1(this,nodeObject$1(indexNode)))}setNodeType(uniformType){const node=uniform$1(null,uniformType).getSelf();this.group!==null&&node.setGroup(this.group),this.node=node}getNodeType(builder){return this.node===null&&(this.updateReference(builder),this.updateValue()),this.node.getNodeType(builder)}getValueFromReference(object=this.reference){const{properties}=this;let value=object[properties[0]];for(let i2=1;i2<properties.length;i2++)value=value[properties[i2]];return value}updateReference(state){return this.reference=this.object!==null?this.object:state.object,this.reference}setup(){return this.updateValue(),this.node}update(){this.updateValue()}updateValue(){this.node===null&&this.setNodeType(this.uniformType);const value=this.getValueFromReference();Array.isArray(value)?this.node.array=value:this.node.value=value}}const reference$1=(name,type,object)=>nodeObject$1(new ReferenceBaseNode(name,type,object));class RendererReferenceNode extends ReferenceBaseNode{static get type(){return"RendererReferenceNode"}constructor(property2,inputType,renderer=null){super(property2,inputType,renderer),this.renderer=renderer,this.setGroup(renderGroup)}updateReference(state){return this.reference=this.renderer!==null?this.renderer:state.renderer,this.reference}}const rendererReference=(name,type,renderer=null)=>nodeObject$1(new RendererReferenceNode(name,type,renderer));class ToneMappingNode extends TempNode{static get type(){return"ToneMappingNode"}constructor(toneMapping2,exposureNode=toneMappingExposure,colorNode=null){super("vec3"),this.toneMapping=toneMapping2,this.exposureNode=exposureNode,this.colorNode=colorNode}customCacheKey(){return hash$1(this.toneMapping)}setup(builder){const colorNode=this.colorNode||builder.context.color,toneMapping2=this.toneMapping;if(toneMapping2===NoToneMapping)return colorNode;let outputNode=null;const toneMappingFn=builder.renderer.library.getToneMappingFunction(toneMapping2);return toneMappingFn!==null?outputNode=vec4$1(toneMappingFn(colorNode.rgb,this.exposureNode),colorNode.a):(console.error("ToneMappingNode: Unsupported Tone Mapping configuration.",toneMapping2),outputNode=colorNode),outputNode}}const toneMapping=(mapping,exposure,color2)=>nodeObject$1(new ToneMappingNode(mapping,nodeObject$1(exposure),nodeObject$1(color2))),toneMappingExposure=rendererReference("toneMappingExposure","float");addMethodChaining("toneMapping",(color2,mapping,exposure)=>toneMapping(mapping,exposure,color2));class BufferAttributeNode extends InputNode{static get type(){return"BufferAttributeNode"}constructor(value,bufferType=null,bufferStride=0,bufferOffset=0){super(value,bufferType),this.isBufferNode=!0,this.bufferType=bufferType,this.bufferStride=bufferStride,this.bufferOffset=bufferOffset,this.usage=StaticDrawUsage,this.instanced=!1,this.attribute=null,this.global=!0,value&&value.isBufferAttribute===!0&&(this.attribute=value,this.usage=value.usage,this.instanced=value.isInstancedBufferAttribute)}getHash(builder){if(this.bufferStride===0&&this.bufferOffset===0){let bufferData=builder.globalCache.getData(this.value);return bufferData===void 0&&(bufferData={node:this},builder.globalCache.setData(this.value,bufferData)),bufferData.node.uuid}return this.uuid}getNodeType(builder){return this.bufferType===null&&(this.bufferType=builder.getTypeFromAttribute(this.attribute)),this.bufferType}setup(builder){if(this.attribute!==null)return;const type=this.getNodeType(builder),array2=this.value,itemSize=builder.getTypeLength(type),stride=this.bufferStride||itemSize,offset=this.bufferOffset,buffer2=array2.isInterleavedBuffer===!0?array2:new InterleavedBuffer(array2,stride),bufferAttribute2=new InterleavedBufferAttribute(buffer2,itemSize,offset);buffer2.setUsage(this.usage),this.attribute=bufferAttribute2,this.attribute.isInstancedBufferAttribute=this.instanced}generate(builder){const nodeType=this.getNodeType(builder),nodeAttribute=builder.getBufferAttributeFromNode(this,nodeType),propertyName=builder.getPropertyName(nodeAttribute);let output2=null;return builder.shaderStage==="vertex"||builder.shaderStage==="compute"?(this.name=propertyName,output2=propertyName):output2=varying(this).build(builder,nodeType),output2}getInputType(){return"bufferAttribute"}setUsage(value){return this.usage=value,this.attribute&&this.attribute.isBufferAttribute===!0&&(this.attribute.usage=value),this}setInstanced(value){return this.instanced=value,this}}const bufferAttribute=(array2,type=null,stride=0,offset=0)=>nodeObject$1(new BufferAttributeNode(array2,type,stride,offset)),dynamicBufferAttribute=(array2,type=null,stride=0,offset=0)=>bufferAttribute(array2,type,stride,offset).setUsage(DynamicDrawUsage),instancedBufferAttribute$1=(array2,type=null,stride=0,offset=0)=>bufferAttribute(array2,type,stride,offset).setInstanced(!0),instancedDynamicBufferAttribute=(array2,type=null,stride=0,offset=0)=>dynamicBufferAttribute(array2,type,stride,offset).setInstanced(!0);addMethodChaining("toAttribute",bufferNode=>bufferAttribute(bufferNode.value));class ComputeNode extends Node{static get type(){return"ComputeNode"}constructor(computeNode,count,workgroupSize=[64]){super("void"),this.isComputeNode=!0,this.computeNode=computeNode,this.count=count,this.workgroupSize=workgroupSize,this.dispatchCount=0,this.version=1,this.name="",this.updateBeforeType=NodeUpdateType.OBJECT,this.onInitFunction=null,this.updateDispatchCount()}dispose(){this.dispatchEvent({type:"dispose"})}label(name){return this.name=name,this}updateDispatchCount(){const{count,workgroupSize}=this;let size=workgroupSize[0];for(let i2=1;i2<workgroupSize.length;i2++)size*=workgroupSize[i2];this.dispatchCount=Math.ceil(count/size)}onInit(callback){return this.onInitFunction=callback,this}updateBefore({renderer}){renderer.compute(this)}generate(builder){const{shaderStage}=builder;if(shaderStage==="compute"){const snippet=this.computeNode.build(builder,"void");snippet!==""&&builder.addLineFlowCode(snippet,this)}}}const compute=(node,count,workgroupSize)=>nodeObject$1(new ComputeNode(nodeObject$1(node),count,workgroupSize));addMethodChaining("compute",compute);class CacheNode extends Node{static get type(){return"CacheNode"}constructor(node,parent=!0){super(),this.node=node,this.parent=parent,this.isCacheNode=!0}getNodeType(builder){const previousCache=builder.getCache(),cache2=builder.getCacheFromNode(this,this.parent);builder.setCache(cache2);const nodeType=this.node.getNodeType(builder);return builder.setCache(previousCache),nodeType}build(builder,...params){const previousCache=builder.getCache(),cache2=builder.getCacheFromNode(this,this.parent);builder.setCache(cache2);const data=this.node.build(builder,...params);return builder.setCache(previousCache),data}}const cache$2=(node,parent)=>nodeObject$1(new CacheNode(nodeObject$1(node),parent));addMethodChaining("cache",cache$2);class BypassNode extends Node{static get type(){return"BypassNode"}constructor(outputNode,callNode){super(),this.isBypassNode=!0,this.outputNode=outputNode,this.callNode=callNode}getNodeType(builder){return this.outputNode.getNodeType(builder)}generate(builder){const snippet=this.callNode.build(builder,"void");return snippet!==""&&builder.addLineFlowCode(snippet,this),this.outputNode.build(builder)}}const bypass=nodeProxy(BypassNode);addMethodChaining("bypass",bypass);class RemapNode extends Node{static get type(){return"RemapNode"}constructor(node,inLowNode,inHighNode,outLowNode=float$1(0),outHighNode=float$1(1)){super(),this.node=node,this.inLowNode=inLowNode,this.inHighNode=inHighNode,this.outLowNode=outLowNode,this.outHighNode=outHighNode,this.doClamp=!0}setup(){const{node,inLowNode,inHighNode,outLowNode,outHighNode,doClamp}=this;let t2=node.sub(inLowNode).div(inHighNode.sub(inLowNode));return doClamp===!0&&(t2=t2.clamp()),t2.mul(outHighNode.sub(outLowNode)).add(outLowNode)}}const remap$1=nodeProxy(RemapNode,null,null,{doClamp:!1}),remapClamp$1=nodeProxy(RemapNode);addMethodChaining("remap",remap$1);addMethodChaining("remapClamp",remapClamp$1);class ExpressionNode extends Node{static get type(){return"ExpressionNode"}constructor(snippet="",nodeType="void"){super(nodeType),this.snippet=snippet}generate(builder,output2){const type=this.getNodeType(builder),snippet=this.snippet;if(type==="void")builder.addLineFlowCode(snippet,this);else return builder.format(`( ${snippet} )`,type,output2)}}const expression=nodeProxy(ExpressionNode),Discard$1=conditional=>(conditional?select(conditional,expression("discard")):expression("discard")).append(),Return=()=>expression("return").append();addMethodChaining("discard",Discard$1);class RenderOutputNode extends TempNode{static get type(){return"RenderOutputNode"}constructor(colorNode,toneMapping2,outputColorSpace){super("vec4"),this.colorNode=colorNode,this.toneMapping=toneMapping2,this.outputColorSpace=outputColorSpace,this.isRenderOutputNode=!0}setup({context:context2}){let outputNode=this.colorNode||context2.color;const toneMapping2=(this.toneMapping!==null?this.toneMapping:context2.toneMapping)||NoToneMapping,outputColorSpace=(this.outputColorSpace!==null?this.outputColorSpace:context2.outputColorSpace)||NoColorSpace;return toneMapping2!==NoToneMapping&&(outputNode=outputNode.toneMapping(toneMapping2)),outputColorSpace!==NoColorSpace&&outputColorSpace!==ColorManagement.workingColorSpace&&(outputNode=outputNode.workingToColorSpace(outputColorSpace)),outputNode}}const renderOutput=(color2,toneMapping2=null,outputColorSpace=null)=>nodeObject$1(new RenderOutputNode(nodeObject$1(color2),toneMapping2,outputColorSpace));addMethodChaining("renderOutput",renderOutput);function addNodeElement(name){console.warn("THREE.TSLBase: AddNodeElement has been removed in favor of tree-shaking. Trying add",name)}class AttributeNode extends Node{static get type(){return"AttributeNode"}constructor(attributeName,nodeType=null){super(nodeType),this.global=!0,this._attributeName=attributeName}getHash(builder){return this.getAttributeName(builder)}getNodeType(builder){let nodeType=this.nodeType;if(nodeType===null){const attributeName=this.getAttributeName(builder);if(builder.hasGeometryAttribute(attributeName)){const attribute2=builder.geometry.getAttribute(attributeName);nodeType=builder.getTypeFromAttribute(attribute2)}else nodeType="float"}return nodeType}setAttributeName(attributeName){return this._attributeName=attributeName,this}getAttributeName(){return this._attributeName}generate(builder){const attributeName=this.getAttributeName(builder),nodeType=this.getNodeType(builder);if(builder.hasGeometryAttribute(attributeName)===!0){const attribute2=builder.geometry.getAttribute(attributeName),attributeType=builder.getTypeFromAttribute(attribute2),nodeAttribute=builder.getAttribute(attributeName,attributeType);return builder.shaderStage==="vertex"?builder.format(nodeAttribute.name,attributeType,nodeType):varying(this).build(builder,nodeType)}else return console.warn(`AttributeNode: Vertex attribute "${attributeName}" not found on geometry.`),builder.generateConst(nodeType)}serialize(data){super.serialize(data),data.global=this.global,data._attributeName=this._attributeName}deserialize(data){super.deserialize(data),this.global=data.global,this._attributeName=data._attributeName}}const attribute=(name,nodeType)=>nodeObject$1(new AttributeNode(name,nodeType)),uv$1=(index=0)=>attribute("uv"+(index>0?index:""),"vec2");class TextureSizeNode extends Node{static get type(){return"TextureSizeNode"}constructor(textureNode,levelNode=null){super("uvec2"),this.isTextureSizeNode=!0,this.textureNode=textureNode,this.levelNode=levelNode}generate(builder,output2){const textureProperty=this.textureNode.build(builder,"property"),level=this.levelNode===null?"0":this.levelNode.build(builder,"int");return builder.format(`${builder.getMethod("textureDimensions")}( ${textureProperty}, ${level} )`,this.getNodeType(builder),output2)}}const textureSize=nodeProxy(TextureSizeNode);class MaxMipLevelNode extends UniformNode{static get type(){return"MaxMipLevelNode"}constructor(textureNode){super(0),this._textureNode=textureNode,this.updateType=NodeUpdateType.FRAME}get textureNode(){return this._textureNode}get texture(){return this._textureNode.value}update(){const texture2=this.texture,images=texture2.images,image=images&&images.length>0?images[0]&&images[0].image||images[0]:texture2.image;if(image&&image.width!==void 0){const{width,height}=image;this.value=Math.log2(Math.max(width,height))}}}const maxMipLevel=nodeProxy(MaxMipLevelNode);class TextureNode extends UniformNode{static get type(){return"TextureNode"}constructor(value,uvNode=null,levelNode=null,biasNode=null){super(value),this.isTextureNode=!0,this.uvNode=uvNode,this.levelNode=levelNode,this.biasNode=biasNode,this.compareNode=null,this.depthNode=null,this.gradNode=null,this.sampler=!0,this.updateMatrix=!1,this.updateType=NodeUpdateType.NONE,this.referenceNode=null,this._value=value,this._matrixUniform=null,this.setUpdateMatrix(uvNode===null)}set value(value){this.referenceNode?this.referenceNode.value=value:this._value=value}get value(){return this.referenceNode?this.referenceNode.value:this._value}getUniformHash(){return this.value.uuid}getNodeType(){return this.value.isDepthTexture===!0?"float":this.value.type===UnsignedIntType?"uvec4":this.value.type===IntType?"ivec4":"vec4"}getInputType(){return"texture"}getDefaultUV(){return uv$1(this.value.channel)}updateReference(){return this.value}getTransformedUV(uvNode){return this._matrixUniform===null&&(this._matrixUniform=uniform$1(this.value.matrix)),this._matrixUniform.mul(vec3$1(uvNode,1)).xy}setUpdateMatrix(value){return this.updateMatrix=value,this.updateType=value?NodeUpdateType.RENDER:NodeUpdateType.NONE,this}setupUV(builder,uvNode){const texture2=this.value;return builder.isFlipY()&&(texture2.image instanceof ImageBitmap&&texture2.flipY===!0||texture2.isRenderTargetTexture===!0||texture2.isFramebufferTexture===!0||texture2.isDepthTexture===!0)&&(this.sampler?uvNode=uvNode.flipY():uvNode=uvNode.setY(int(textureSize(this,this.levelNode).y).sub(uvNode.y).sub(1))),uvNode}setup(builder){const properties=builder.getNodeProperties(this);properties.referenceNode=this.referenceNode;const texture2=this.value;if(!texture2||texture2.isTexture!==!0)throw new Error("THREE.TSL: `texture( value )` function expects a valid instance of THREE.Texture().");let uvNode=this.uvNode;(uvNode===null||builder.context.forceUVContext===!0)&&builder.context.getUV&&(uvNode=builder.context.getUV(this)),uvNode||(uvNode=this.getDefaultUV()),this.updateMatrix===!0&&(uvNode=this.getTransformedUV(uvNode)),uvNode=this.setupUV(builder,uvNode);let levelNode=this.levelNode;levelNode===null&&builder.context.getTextureLevel&&(levelNode=builder.context.getTextureLevel(this)),properties.uvNode=uvNode,properties.levelNode=levelNode,properties.biasNode=this.biasNode,properties.compareNode=this.compareNode,properties.gradNode=this.gradNode,properties.depthNode=this.depthNode}generateUV(builder,uvNode){return uvNode.build(builder,this.sampler===!0?"vec2":"ivec2")}generateSnippet(builder,textureProperty,uvSnippet,levelSnippet,biasSnippet,depthSnippet,compareSnippet,gradSnippet){const texture2=this.value;let snippet;return levelSnippet?snippet=builder.generateTextureLevel(texture2,textureProperty,uvSnippet,levelSnippet,depthSnippet):biasSnippet?snippet=builder.generateTextureBias(texture2,textureProperty,uvSnippet,biasSnippet,depthSnippet):gradSnippet?snippet=builder.generateTextureGrad(texture2,textureProperty,uvSnippet,gradSnippet,depthSnippet):compareSnippet?snippet=builder.generateTextureCompare(texture2,textureProperty,uvSnippet,compareSnippet,depthSnippet):this.sampler===!1?snippet=builder.generateTextureLoad(texture2,textureProperty,uvSnippet,depthSnippet):snippet=builder.generateTexture(texture2,textureProperty,uvSnippet,depthSnippet),snippet}generate(builder,output2){const texture2=this.value,properties=builder.getNodeProperties(this),textureProperty=super.generate(builder,"property");if(output2==="sampler")return textureProperty+"_sampler";if(builder.isReference(output2))return textureProperty;{const nodeData=builder.getDataFromNode(this);let propertyName=nodeData.propertyName;if(propertyName===void 0){const{uvNode,levelNode,biasNode,compareNode,depthNode,gradNode}=properties,uvSnippet=this.generateUV(builder,uvNode),levelSnippet=levelNode?levelNode.build(builder,"float"):null,biasSnippet=biasNode?biasNode.build(builder,"float"):null,depthSnippet=depthNode?depthNode.build(builder,"int"):null,compareSnippet=compareNode?compareNode.build(builder,"float"):null,gradSnippet=gradNode?[gradNode[0].build(builder,"vec2"),gradNode[1].build(builder,"vec2")]:null,nodeVar=builder.getVarFromNode(this);propertyName=builder.getPropertyName(nodeVar);const snippet2=this.generateSnippet(builder,textureProperty,uvSnippet,levelSnippet,biasSnippet,depthSnippet,compareSnippet,gradSnippet);builder.addLineFlowCode(`${propertyName} = ${snippet2}`,this),nodeData.snippet=snippet2,nodeData.propertyName=propertyName}let snippet=propertyName;const nodeType=this.getNodeType(builder);return builder.needsToWorkingColorSpace(texture2)&&(snippet=colorSpaceToWorking(expression(snippet,nodeType),texture2.colorSpace).setup(builder).build(builder,nodeType)),builder.format(snippet,nodeType,output2)}}setSampler(value){return this.sampler=value,this}getSampler(){return this.sampler}uv(uvNode){return console.warn("THREE.TextureNode: .uv() has been renamed. Use .sample() instead."),this.sample(uvNode)}sample(uvNode){const textureNode=this.clone();return textureNode.uvNode=nodeObject$1(uvNode),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}blur(amountNode){const textureNode=this.clone();return textureNode.biasNode=nodeObject$1(amountNode).mul(maxMipLevel(textureNode)),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}level(levelNode){const textureNode=this.clone();return textureNode.levelNode=nodeObject$1(levelNode),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}size(levelNode){return textureSize(this,levelNode)}bias(biasNode){const textureNode=this.clone();return textureNode.biasNode=nodeObject$1(biasNode),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}compare(compareNode){const textureNode=this.clone();return textureNode.compareNode=nodeObject$1(compareNode),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}grad(gradNodeX,gradNodeY){const textureNode=this.clone();return textureNode.gradNode=[nodeObject$1(gradNodeX),nodeObject$1(gradNodeY)],textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}depth(depthNode){const textureNode=this.clone();return textureNode.depthNode=nodeObject$1(depthNode),textureNode.referenceNode=this.getSelf(),nodeObject$1(textureNode)}serialize(data){super.serialize(data),data.value=this.value.toJSON(data.meta).uuid,data.sampler=this.sampler,data.updateMatrix=this.updateMatrix,data.updateType=this.updateType}deserialize(data){super.deserialize(data),this.value=data.meta.textures[data.value],this.sampler=data.sampler,this.updateMatrix=data.updateMatrix,this.updateType=data.updateType}update(){const texture2=this.value,matrixUniform=this._matrixUniform;matrixUniform!==null&&(matrixUniform.value=texture2.matrix),texture2.matrixAutoUpdate===!0&&texture2.updateMatrix()}clone(){const newNode=new this.constructor(this.value,this.uvNode,this.levelNode,this.biasNode);return newNode.sampler=this.sampler,newNode}}const texture$1=nodeProxy(TextureNode),textureLoad=(...params)=>texture$1(...params).setSampler(!1),sampler=aTexture=>(aTexture.isNode===!0?aTexture:texture$1(aTexture)).convert("sampler");class BufferNode extends UniformNode{static get type(){return"BufferNode"}constructor(value,bufferType,bufferCount=0){super(value,bufferType),this.isBufferNode=!0,this.bufferType=bufferType,this.bufferCount=bufferCount}getElementType(builder){return this.getNodeType(builder)}getInputType(){return"buffer"}}const buffer=(value,type,count)=>nodeObject$1(new BufferNode(value,type,count));class UniformArrayElementNode extends ArrayElementNode{static get type(){return"UniformArrayElementNode"}constructor(uniformArrayNode,indexNode){super(uniformArrayNode,indexNode),this.isArrayBufferElementNode=!0}generate(builder){const snippet=super.generate(builder),type=this.getNodeType(),paddedType=this.node.getPaddedType();return builder.format(snippet,paddedType,type)}}class UniformArrayNode extends BufferNode{static get type(){return"UniformArrayNode"}constructor(value,elementType=null){super(null),this.array=value,this.elementType=elementType===null?getValueType(value[0]):elementType,this.paddedType=this.getPaddedType(),this.updateType=NodeUpdateType.RENDER,this.isArrayBufferNode=!0}getNodeType(){return this.paddedType}getElementType(){return this.elementType}getPaddedType(){const elementType=this.elementType;let paddedType="vec4";return elementType==="mat2"?paddedType="mat2":/mat/.test(elementType)===!0?paddedType="mat4":elementType.charAt(0)==="i"?paddedType="ivec4":elementType.charAt(0)==="u"&&(paddedType="uvec4"),paddedType}update(){const{array:array2,value}=this,elementType=this.elementType;if(elementType==="float"||elementType==="int"||elementType==="uint")for(let i2=0;i2<array2.length;i2++){const index=i2*4;value[index]=array2[i2]}else if(elementType==="color")for(let i2=0;i2<array2.length;i2++){const index=i2*4,vector=array2[i2];value[index]=vector.r,value[index+1]=vector.g,value[index+2]=vector.b||0}else if(elementType==="mat2")for(let i2=0;i2<array2.length;i2++){const index=i2*4,matrix=array2[i2];value[index]=matrix.elements[0],value[index+1]=matrix.elements[1],value[index+2]=matrix.elements[2],value[index+3]=matrix.elements[3]}else if(elementType==="mat3")for(let i2=0;i2<array2.length;i2++){const index=i2*16,matrix=array2[i2];value[index]=matrix.elements[0],value[index+1]=matrix.elements[1],value[index+2]=matrix.elements[2],value[index+4]=matrix.elements[3],value[index+5]=matrix.elements[4],value[index+6]=matrix.elements[5],value[index+8]=matrix.elements[6],value[index+9]=matrix.elements[7],value[index+10]=matrix.elements[8],value[index+15]=1}else if(elementType==="mat4")for(let i2=0;i2<array2.length;i2++){const index=i2*16,matrix=array2[i2];for(let i3=0;i3<matrix.elements.length;i3++)value[index+i3]=matrix.elements[i3]}else for(let i2=0;i2<array2.length;i2++){const index=i2*4,vector=array2[i2];value[index]=vector.x,value[index+1]=vector.y,value[index+2]=vector.z||0,value[index+3]=vector.w||0}}setup(builder){const length2=this.array.length,elementType=this.elementType;let arrayType=Float32Array;const paddedType=this.paddedType,paddedElementLength=builder.getTypeLength(paddedType);return elementType.charAt(0)==="i"&&(arrayType=Int32Array),elementType.charAt(0)==="u"&&(arrayType=Uint32Array),this.value=new arrayType(length2*paddedElementLength),this.bufferCount=length2,this.bufferType=paddedType,super.setup(builder)}element(indexNode){return nodeObject$1(new UniformArrayElementNode(this,nodeObject$1(indexNode)))}}const uniformArray=(values,nodeType)=>nodeObject$1(new UniformArrayNode(values,nodeType)),uniforms=(values,nodeType)=>(console.warn("TSL.UniformArrayNode: uniforms() has been renamed to uniformArray()."),nodeObject$1(new UniformArrayNode(values,nodeType))),cameraIndex=uniform$1(0,"uint").setGroup(sharedUniformGroup("cameraIndex")).toVarying("v_cameraIndex"),cameraNear=uniform$1("float").label("cameraNear").setGroup(renderGroup).onRenderUpdate(({camera})=>camera.near),cameraFar=uniform$1("float").label("cameraFar").setGroup(renderGroup).onRenderUpdate(({camera})=>camera.far),cameraProjectionMatrix=Fn$1(({camera})=>{let cameraProjectionMatrix2;if(camera.isArrayCamera&&camera.cameras.length>0){const matrices=[];for(const subCamera of camera.cameras)matrices.push(subCamera.projectionMatrix);cameraProjectionMatrix2=uniformArray(matrices).setGroup(renderGroup).label("cameraProjectionMatrices").element(cameraIndex).toVar("cameraProjectionMatrix")}else cameraProjectionMatrix2=uniform$1("mat4").label("cameraProjectionMatrix").setGroup(renderGroup).onRenderUpdate(({camera:camera2})=>camera2.projectionMatrix);return cameraProjectionMatrix2}).once()(),cameraProjectionMatrixInverse=uniform$1("mat4").label("cameraProjectionMatrixInverse").setGroup(renderGroup).onRenderUpdate(({camera})=>camera.projectionMatrixInverse),cameraViewMatrix=Fn$1(({camera})=>{let cameraViewMatrix2;if(camera.isArrayCamera&&camera.cameras.length>0){const matrices=[];for(const subCamera of camera.cameras)matrices.push(subCamera.matrixWorldInverse);cameraViewMatrix2=uniformArray(matrices).setGroup(renderGroup).label("cameraViewMatrices").element(cameraIndex).toVar("cameraViewMatrix")}else cameraViewMatrix2=uniform$1("mat4").label("cameraViewMatrix").setGroup(renderGroup).onRenderUpdate(({camera:camera2})=>camera2.matrixWorldInverse);return cameraViewMatrix2}).once()(),cameraWorldMatrix=uniform$1("mat4").label("cameraWorldMatrix").setGroup(renderGroup).onRenderUpdate(({camera})=>camera.matrixWorld),cameraNormalMatrix=uniform$1("mat3").label("cameraNormalMatrix").setGroup(renderGroup).onRenderUpdate(({camera})=>camera.normalMatrix),cameraPosition=uniform$1(new Vector3).label("cameraPosition").setGroup(renderGroup).onRenderUpdate(({camera},self2)=>self2.value.setFromMatrixPosition(camera.matrixWorld)),_sphere=new Sphere;class Object3DNode extends Node{static get type(){return"Object3DNode"}constructor(scope,object3d=null){super(),this.scope=scope,this.object3d=object3d,this.updateType=NodeUpdateType.OBJECT,this._uniformNode=new UniformNode(null)}getNodeType(){const scope=this.scope;if(scope===Object3DNode.WORLD_MATRIX)return"mat4";if(scope===Object3DNode.POSITION||scope===Object3DNode.VIEW_POSITION||scope===Object3DNode.DIRECTION||scope===Object3DNode.SCALE)return"vec3";if(scope===Object3DNode.RADIUS)return"float"}update(frame){const object=this.object3d,uniformNode=this._uniformNode,scope=this.scope;if(scope===Object3DNode.WORLD_MATRIX)uniformNode.value=object.matrixWorld;else if(scope===Object3DNode.POSITION)uniformNode.value=uniformNode.value||new Vector3,uniformNode.value.setFromMatrixPosition(object.matrixWorld);else if(scope===Object3DNode.SCALE)uniformNode.value=uniformNode.value||new Vector3,uniformNode.value.setFromMatrixScale(object.matrixWorld);else if(scope===Object3DNode.DIRECTION)uniformNode.value=uniformNode.value||new Vector3,object.getWorldDirection(uniformNode.value);else if(scope===Object3DNode.VIEW_POSITION){const camera=frame.camera;uniformNode.value=uniformNode.value||new Vector3,uniformNode.value.setFromMatrixPosition(object.matrixWorld),uniformNode.value.applyMatrix4(camera.matrixWorldInverse)}else if(scope===Object3DNode.RADIUS){const geometry2=frame.object.geometry;geometry2.boundingSphere===null&&geometry2.computeBoundingSphere(),_sphere.copy(geometry2.boundingSphere).applyMatrix4(object.matrixWorld),uniformNode.value=_sphere.radius}}generate(builder){const scope=this.scope;return scope===Object3DNode.WORLD_MATRIX?this._uniformNode.nodeType="mat4":scope===Object3DNode.POSITION||scope===Object3DNode.VIEW_POSITION||scope===Object3DNode.DIRECTION||scope===Object3DNode.SCALE?this._uniformNode.nodeType="vec3":scope===Object3DNode.RADIUS&&(this._uniformNode.nodeType="float"),this._uniformNode.build(builder)}serialize(data){super.serialize(data),data.scope=this.scope}deserialize(data){super.deserialize(data),this.scope=data.scope}}Object3DNode.WORLD_MATRIX="worldMatrix";Object3DNode.POSITION="position";Object3DNode.SCALE="scale";Object3DNode.VIEW_POSITION="viewPosition";Object3DNode.DIRECTION="direction";Object3DNode.RADIUS="radius";const objectDirection=nodeProxy(Object3DNode,Object3DNode.DIRECTION),objectWorldMatrix=nodeProxy(Object3DNode,Object3DNode.WORLD_MATRIX),objectPosition=nodeProxy(Object3DNode,Object3DNode.POSITION),objectScale=nodeProxy(Object3DNode,Object3DNode.SCALE),objectViewPosition=nodeProxy(Object3DNode,Object3DNode.VIEW_POSITION),objectRadius=nodeProxy(Object3DNode,Object3DNode.RADIUS);class ModelNode extends Object3DNode{static get type(){return"ModelNode"}constructor(scope){super(scope)}update(frame){this.object3d=frame.object,super.update(frame)}}const modelDirection=nodeImmutable(ModelNode,ModelNode.DIRECTION),modelWorldMatrix=nodeImmutable(ModelNode,ModelNode.WORLD_MATRIX),modelPosition=nodeImmutable(ModelNode,ModelNode.POSITION),modelScale=nodeImmutable(ModelNode,ModelNode.SCALE),modelViewPosition=nodeImmutable(ModelNode,ModelNode.VIEW_POSITION),modelRadius=nodeImmutable(ModelNode,ModelNode.RADIUS),modelNormalMatrix=uniform$1(new Matrix3).onObjectUpdate(({object},self2)=>self2.value.getNormalMatrix(object.matrixWorld)),modelWorldMatrixInverse=uniform$1(new Matrix4).onObjectUpdate(({object},self2)=>self2.value.copy(object.matrixWorld).invert()),modelViewMatrix=Fn$1(builder=>builder.renderer.nodes.modelViewMatrix||mediumpModelViewMatrix).once()().toVar("modelViewMatrix"),mediumpModelViewMatrix=cameraViewMatrix.mul(modelWorldMatrix),highpModelViewMatrix=Fn$1(builder=>(builder.context.isHighPrecisionModelViewMatrix=!0,uniform$1("mat4").onObjectUpdate(({object,camera})=>object.modelViewMatrix.multiplyMatrices(camera.matrixWorldInverse,object.matrixWorld)))).once()().toVar("highpModelViewMatrix"),highpModelNormalViewMatrix=Fn$1(builder=>{const isHighPrecisionModelViewMatrix=builder.context.isHighPrecisionModelViewMatrix;return uniform$1("mat3").onObjectUpdate(({object,camera})=>(isHighPrecisionModelViewMatrix!==!0&&object.modelViewMatrix.multiplyMatrices(camera.matrixWorldInverse,object.matrixWorld),object.normalMatrix.getNormalMatrix(object.modelViewMatrix)))}).once()().toVar("highpModelNormalViewMatrix"),positionGeometry$1=attribute("position","vec3"),positionLocal=positionGeometry$1.toVarying("positionLocal"),positionPrevious=positionGeometry$1.toVarying("positionPrevious"),positionWorld=modelWorldMatrix.mul(positionLocal).xyz.toVarying("v_positionWorld").context({needsPositionReassign:!0}),positionWorldDirection=positionLocal.transformDirection(modelWorldMatrix).toVarying("v_positionWorldDirection").normalize().toVar("positionWorldDirection").context({needsPositionReassign:!0}),positionView=Fn$1(builder=>builder.context.setupPositionView(),"vec3").once()().toVarying("v_positionView").context({needsPositionReassign:!0}),positionViewDirection=positionView.negate().toVarying("v_positionViewDirection").normalize().toVar("positionViewDirection");class FrontFacingNode extends Node{static get type(){return"FrontFacingNode"}constructor(){super("bool"),this.isFrontFacingNode=!0}generate(builder){const{renderer,material}=builder;return renderer.coordinateSystem===WebGLCoordinateSystem&&material.side===BackSide?"false":builder.getFrontFacing()}}const frontFacing=nodeImmutable(FrontFacingNode),faceDirection=float$1(frontFacing).mul(2).sub(1),normalGeometry=attribute("normal","vec3"),normalLocal=Fn$1(builder=>builder.geometry.hasAttribute("normal")===!1?(console.warn('TSL.NormalNode: Vertex attribute "normal" not found on geometry.'),vec3$1(0,1,0)):normalGeometry,"vec3").once()().toVar("normalLocal"),normalFlat=positionView.dFdx().cross(positionView.dFdy()).normalize().toVar("normalFlat"),normalView=Fn$1(builder=>{let node;return builder.material.flatShading===!0?node=normalFlat:node=varying(transformNormalToView(normalLocal),"v_normalView").normalize(),node},"vec3").once()().toVar("normalView"),normalWorld=varying(normalView.transformDirection(cameraViewMatrix),"v_normalWorld").normalize().toVar("normalWorld"),transformedNormalView=Fn$1(builder=>builder.context.setupNormal().context({getUV:null}),"vec3").once()().mul(faceDirection).toVar("transformedNormalView"),transformedNormalWorld=transformedNormalView.transformDirection(cameraViewMatrix).toVar("transformedNormalWorld"),transformedClearcoatNormalView=Fn$1(builder=>builder.context.setupClearcoatNormal().context({getUV:null}),"vec3").once()().mul(faceDirection).toVar("transformedClearcoatNormalView"),transformNormal=Fn$1(([normal2,matrix=modelWorldMatrix])=>{const m=mat3(matrix),transformedNormal=normal2.div(vec3$1(m[0].dot(m[0]),m[1].dot(m[1]),m[2].dot(m[2])));return m.mul(transformedNormal).xyz}),transformNormalToView=Fn$1(([normal2],builder)=>{const modelNormalViewMatrix=builder.renderer.nodes.modelNormalViewMatrix;if(modelNormalViewMatrix!==null)return modelNormalViewMatrix.transformDirection(normal2);const transformedNormal=modelNormalMatrix.mul(normal2);return cameraViewMatrix.transformDirection(transformedNormal)}),_e1$1=new Euler,_m1$1=new Matrix4,materialRefractionRatio=uniform$1(0).onReference(({material})=>material).onObjectUpdate(({material})=>material.refractionRatio),materialEnvIntensity=uniform$1(1).onReference(({material})=>material).onObjectUpdate(function({material,scene}){return material.envMap?material.envMapIntensity:scene.environmentIntensity}),materialEnvRotation=uniform$1(new Matrix4).onReference(function(frame){return frame.material}).onObjectUpdate(function({material,scene}){const rotation2=scene.environment!==null&&material.envMap===null?scene.environmentRotation:material.envMapRotation;return rotation2?(_e1$1.copy(rotation2),_m1$1.makeRotationFromEuler(_e1$1)):_m1$1.identity(),_m1$1}),reflectView=positionViewDirection.negate().reflect(transformedNormalView),refractView=positionViewDirection.negate().refract(transformedNormalView,materialRefractionRatio),reflectVector=reflectView.transformDirection(cameraViewMatrix).toVar("reflectVector"),refractVector=refractView.transformDirection(cameraViewMatrix).toVar("reflectVector");class CubeTextureNode extends TextureNode{static get type(){return"CubeTextureNode"}constructor(value,uvNode=null,levelNode=null,biasNode=null){super(value,uvNode,levelNode,biasNode),this.isCubeTextureNode=!0}getInputType(){return"cubeTexture"}getDefaultUV(){const texture2=this.value;return texture2.mapping===CubeReflectionMapping?reflectVector:texture2.mapping===CubeRefractionMapping?refractVector:(console.error('THREE.CubeTextureNode: Mapping "%s" not supported.',texture2.mapping),vec3$1(0,0,0))}setUpdateMatrix(){}setupUV(builder,uvNode){const texture2=this.value;return(builder.renderer.coordinateSystem===WebGPUCoordinateSystem||!texture2.isRenderTargetTexture)&&(uvNode=vec3$1(uvNode.x.negate(),uvNode.yz)),materialEnvRotation.mul(uvNode)}generateUV(builder,cubeUV){return cubeUV.build(builder,"vec3")}}const cubeTexture=nodeProxy(CubeTextureNode);class ReferenceElementNode2 extends ArrayElementNode{static get type(){return"ReferenceElementNode"}constructor(referenceNode,indexNode){super(referenceNode,indexNode),this.referenceNode=referenceNode,this.isReferenceElementNode=!0}getNodeType(){return this.referenceNode.uniformType}generate(builder){const snippet=super.generate(builder),arrayType=this.referenceNode.getNodeType(),elementType=this.getNodeType();return builder.format(snippet,arrayType,elementType)}}class ReferenceNode extends Node{static get type(){return"ReferenceNode"}constructor(property2,uniformType,object=null,count=null){super(),this.property=property2,this.uniformType=uniformType,this.object=object,this.count=count,this.properties=property2.split("."),this.reference=object,this.node=null,this.group=null,this.name=null,this.updateType=NodeUpdateType.OBJECT}element(indexNode){return nodeObject$1(new ReferenceElementNode2(this,nodeObject$1(indexNode)))}setGroup(group){return this.group=group,this}label(name){return this.name=name,this}setNodeType(uniformType){let node=null;this.count!==null?node=buffer(null,uniformType,this.count):Array.isArray(this.getValueFromReference())?node=uniformArray(null,uniformType):uniformType==="texture"?node=texture$1(null):uniformType==="cubeTexture"?node=cubeTexture(null):node=uniform$1(null,uniformType),this.group!==null&&node.setGroup(this.group),this.name!==null&&node.label(this.name),this.node=node.getSelf()}getNodeType(builder){return this.node===null&&(this.updateReference(builder),this.updateValue()),this.node.getNodeType(builder)}getValueFromReference(object=this.reference){const{properties}=this;let value=object[properties[0]];for(let i2=1;i2<properties.length;i2++)value=value[properties[i2]];return value}updateReference(state){return this.reference=this.object!==null?this.object:state.object,this.reference}setup(){return this.updateValue(),this.node}update(){this.updateValue()}updateValue(){this.node===null&&this.setNodeType(this.uniformType);const value=this.getValueFromReference();Array.isArray(value)?this.node.array=value:this.node.value=value}}const reference=(name,type,object)=>nodeObject$1(new ReferenceNode(name,type,object)),referenceBuffer=(name,type,count,object)=>nodeObject$1(new ReferenceNode(name,type,object,count));class MaterialReferenceNode extends ReferenceNode{static get type(){return"MaterialReferenceNode"}constructor(property2,inputType,material=null){super(property2,inputType,material),this.material=material,this.isMaterialReferenceNode=!0}updateReference(state){return this.reference=this.material!==null?this.material:state.material,this.reference}}const materialReference=(name,type,material=null)=>nodeObject$1(new MaterialReferenceNode(name,type,material)),tangentGeometry=Fn$1(builder=>(builder.geometry.hasAttribute("tangent")===!1&&builder.geometry.computeTangents(),attribute("tangent","vec4")))(),tangentLocal=tangentGeometry.xyz.toVar("tangentLocal"),tangentView=modelViewMatrix.mul(vec4$1(tangentLocal,0)).xyz.toVarying("v_tangentView").normalize().toVar("tangentView"),tangentWorld=tangentView.transformDirection(cameraViewMatrix).toVarying("v_tangentWorld").normalize().toVar("tangentWorld"),transformedTangentView=tangentView.toVar("transformedTangentView"),transformedTangentWorld=transformedTangentView.transformDirection(cameraViewMatrix).normalize().toVar("transformedTangentWorld"),getBitangent=crossNormalTangent=>crossNormalTangent.mul(tangentGeometry.w).xyz,bitangentGeometry=varying(getBitangent(normalGeometry.cross(tangentGeometry)),"v_bitangentGeometry").normalize().toVar("bitangentGeometry"),bitangentLocal=varying(getBitangent(normalLocal.cross(tangentLocal)),"v_bitangentLocal").normalize().toVar("bitangentLocal"),bitangentView=varying(getBitangent(normalView.cross(tangentView)),"v_bitangentView").normalize().toVar("bitangentView"),bitangentWorld=varying(getBitangent(normalWorld.cross(tangentWorld)),"v_bitangentWorld").normalize().toVar("bitangentWorld"),transformedBitangentView=getBitangent(transformedNormalView.cross(transformedTangentView)).normalize().toVar("transformedBitangentView"),transformedBitangentWorld=transformedBitangentView.transformDirection(cameraViewMatrix).normalize().toVar("transformedBitangentWorld"),TBNViewMatrix=mat3(tangentView,bitangentView,normalView),parallaxDirection=positionViewDirection.mul(TBNViewMatrix),parallaxUV=(uv2,scale2)=>uv2.sub(parallaxDirection.mul(scale2)),transformedBentNormalView=(()=>{let bentNormal=anisotropyB.cross(positionViewDirection);return bentNormal=bentNormal.cross(anisotropyB).normalize(),bentNormal=mix$1(bentNormal,transformedNormalView,anisotropy.mul(roughness.oneMinus()).oneMinus().pow2().pow2()).normalize(),bentNormal})(),perturbNormal2Arb=Fn$1(inputs=>{const{eye_pos,surf_norm,mapN,uv:uv2}=inputs,q0=eye_pos.dFdx(),q1=eye_pos.dFdy(),st0=uv2.dFdx(),st1=uv2.dFdy(),N=surf_norm,q1perp=q1.cross(N),q0perp=N.cross(q0),T=q1perp.mul(st0.x).add(q0perp.mul(st1.x)),B=q1perp.mul(st0.y).add(q0perp.mul(st1.y)),det=T.dot(T).max(B.dot(B)),scale2=faceDirection.mul(det.inverseSqrt());return add$3(T.mul(mapN.x,scale2),B.mul(mapN.y,scale2),N.mul(mapN.z)).normalize()});class NormalMapNode extends TempNode{static get type(){return"NormalMapNode"}constructor(node,scaleNode=null){super("vec3"),this.node=node,this.scaleNode=scaleNode,this.normalMapType=TangentSpaceNormalMap}setup(builder){const{normalMapType,scaleNode}=this;let normalMap2=this.node.mul(2).sub(1);scaleNode!==null&&(normalMap2=vec3$1(normalMap2.xy.mul(scaleNode),normalMap2.z));let outputNode=null;return normalMapType===ObjectSpaceNormalMap?outputNode=transformNormalToView(normalMap2):normalMapType===TangentSpaceNormalMap&&(builder.hasGeometryAttribute("tangent")===!0?outputNode=TBNViewMatrix.mul(normalMap2).normalize():outputNode=perturbNormal2Arb({eye_pos:positionView,surf_norm:normalView,mapN:normalMap2,uv:uv$1()})),outputNode}}const normalMap=nodeProxy(NormalMapNode),dHdxy_fwd=Fn$1(({textureNode,bumpScale})=>{const sampleTexture=callback=>textureNode.cache().context({getUV:texNode=>callback(texNode.uvNode||uv$1()),forceUVContext:!0}),Hll=float$1(sampleTexture(uvNode=>uvNode));return vec2$1(float$1(sampleTexture(uvNode=>uvNode.add(uvNode.dFdx()))).sub(Hll),float$1(sampleTexture(uvNode=>uvNode.add(uvNode.dFdy()))).sub(Hll)).mul(bumpScale)}),perturbNormalArb=Fn$1(inputs=>{const{surf_pos,surf_norm,dHdxy}=inputs,vSigmaX=surf_pos.dFdx().normalize(),vSigmaY=surf_pos.dFdy().normalize(),vN=surf_norm,R1=vSigmaY.cross(vN),R2=vN.cross(vSigmaX),fDet=vSigmaX.dot(R1).mul(faceDirection),vGrad=fDet.sign().mul(dHdxy.x.mul(R1).add(dHdxy.y.mul(R2)));return fDet.abs().mul(surf_norm).sub(vGrad).normalize()});class BumpMapNode extends TempNode{static get type(){return"BumpMapNode"}constructor(textureNode,scaleNode=null){super("vec3"),this.textureNode=textureNode,this.scaleNode=scaleNode}setup(){const bumpScale=this.scaleNode!==null?this.scaleNode:1,dHdxy=dHdxy_fwd({textureNode:this.textureNode,bumpScale});return perturbNormalArb({surf_pos:positionView,surf_norm:normalView,dHdxy})}}const bumpMap=nodeProxy(BumpMapNode),_propertyCache=new Map;class MaterialNode extends Node{static get type(){return"MaterialNode"}constructor(scope){super(),this.scope=scope}getCache(property2,type){let node=_propertyCache.get(property2);return node===void 0&&(node=materialReference(property2,type),_propertyCache.set(property2,node)),node}getFloat(property2){return this.getCache(property2,"float")}getColor(property2){return this.getCache(property2,"color")}getTexture(property2){return this.getCache(property2==="map"?"map":property2+"Map","texture")}setup(builder){const material=builder.context.material,scope=this.scope;let node=null;if(scope===MaterialNode.COLOR){const colorNode=material.color!==void 0?this.getColor(scope):vec3$1();material.map&&material.map.isTexture===!0?node=colorNode.mul(this.getTexture("map")):node=colorNode}else if(scope===MaterialNode.OPACITY){const opacityNode=this.getFloat(scope);material.alphaMap&&material.alphaMap.isTexture===!0?node=opacityNode.mul(this.getTexture("alpha")):node=opacityNode}else if(scope===MaterialNode.SPECULAR_STRENGTH)material.specularMap&&material.specularMap.isTexture===!0?node=this.getTexture("specular").r:node=float$1(1);else if(scope===MaterialNode.SPECULAR_INTENSITY){const specularIntensityNode=this.getFloat(scope);material.specularIntensityMap&&material.specularIntensityMap.isTexture===!0?node=specularIntensityNode.mul(this.getTexture(scope).a):node=specularIntensityNode}else if(scope===MaterialNode.SPECULAR_COLOR){const specularColorNode=this.getColor(scope);material.specularColorMap&&material.specularColorMap.isTexture===!0?node=specularColorNode.mul(this.getTexture(scope).rgb):node=specularColorNode}else if(scope===MaterialNode.ROUGHNESS){const roughnessNode=this.getFloat(scope);material.roughnessMap&&material.roughnessMap.isTexture===!0?node=roughnessNode.mul(this.getTexture(scope).g):node=roughnessNode}else if(scope===MaterialNode.METALNESS){const metalnessNode=this.getFloat(scope);material.metalnessMap&&material.metalnessMap.isTexture===!0?node=metalnessNode.mul(this.getTexture(scope).b):node=metalnessNode}else if(scope===MaterialNode.EMISSIVE){const emissiveIntensityNode=this.getFloat("emissiveIntensity"),emissiveNode=this.getColor(scope).mul(emissiveIntensityNode);material.emissiveMap&&material.emissiveMap.isTexture===!0?node=emissiveNode.mul(this.getTexture(scope)):node=emissiveNode}else if(scope===MaterialNode.NORMAL)material.normalMap?(node=normalMap(this.getTexture("normal"),this.getCache("normalScale","vec2")),node.normalMapType=material.normalMapType):material.bumpMap?node=bumpMap(this.getTexture("bump").r,this.getFloat("bumpScale")):node=normalView;else if(scope===MaterialNode.CLEARCOAT){const clearcoatNode=this.getFloat(scope);material.clearcoatMap&&material.clearcoatMap.isTexture===!0?node=clearcoatNode.mul(this.getTexture(scope).r):node=clearcoatNode}else if(scope===MaterialNode.CLEARCOAT_ROUGHNESS){const clearcoatRoughnessNode=this.getFloat(scope);material.clearcoatRoughnessMap&&material.clearcoatRoughnessMap.isTexture===!0?node=clearcoatRoughnessNode.mul(this.getTexture(scope).r):node=clearcoatRoughnessNode}else if(scope===MaterialNode.CLEARCOAT_NORMAL)material.clearcoatNormalMap?node=normalMap(this.getTexture(scope),this.getCache(scope+"Scale","vec2")):node=normalView;else if(scope===MaterialNode.SHEEN){const sheenNode=this.getColor("sheenColor").mul(this.getFloat("sheen"));material.sheenColorMap&&material.sheenColorMap.isTexture===!0?node=sheenNode.mul(this.getTexture("sheenColor").rgb):node=sheenNode}else if(scope===MaterialNode.SHEEN_ROUGHNESS){const sheenRoughnessNode=this.getFloat(scope);material.sheenRoughnessMap&&material.sheenRoughnessMap.isTexture===!0?node=sheenRoughnessNode.mul(this.getTexture(scope).a):node=sheenRoughnessNode,node=node.clamp(.07,1)}else if(scope===MaterialNode.ANISOTROPY)if(material.anisotropyMap&&material.anisotropyMap.isTexture===!0){const anisotropyPolar=this.getTexture(scope);node=mat2(materialAnisotropyVector.x,materialAnisotropyVector.y,materialAnisotropyVector.y.negate(),materialAnisotropyVector.x).mul(anisotropyPolar.rg.mul(2).sub(vec2$1(1)).normalize().mul(anisotropyPolar.b))}else node=materialAnisotropyVector;else if(scope===MaterialNode.IRIDESCENCE_THICKNESS){const iridescenceThicknessMaximum=reference("1","float",material.iridescenceThicknessRange);if(material.iridescenceThicknessMap){const iridescenceThicknessMinimum=reference("0","float",material.iridescenceThicknessRange);node=iridescenceThicknessMaximum.sub(iridescenceThicknessMinimum).mul(this.getTexture(scope).g).add(iridescenceThicknessMinimum)}else node=iridescenceThicknessMaximum}else if(scope===MaterialNode.TRANSMISSION){const transmissionNode=this.getFloat(scope);material.transmissionMap?node=transmissionNode.mul(this.getTexture(scope).r):node=transmissionNode}else if(scope===MaterialNode.THICKNESS){const thicknessNode=this.getFloat(scope);material.thicknessMap?node=thicknessNode.mul(this.getTexture(scope).g):node=thicknessNode}else if(scope===MaterialNode.IOR)node=this.getFloat(scope);else if(scope===MaterialNode.LIGHT_MAP)node=this.getTexture(scope).rgb.mul(this.getFloat("lightMapIntensity"));else if(scope===MaterialNode.AO)node=this.getTexture(scope).r.sub(1).mul(this.getFloat("aoMapIntensity")).add(1);else{const outputType=this.getNodeType(builder);node=this.getCache(scope,outputType)}return node}}MaterialNode.ALPHA_TEST="alphaTest";MaterialNode.COLOR="color";MaterialNode.OPACITY="opacity";MaterialNode.SHININESS="shininess";MaterialNode.SPECULAR="specular";MaterialNode.SPECULAR_STRENGTH="specularStrength";MaterialNode.SPECULAR_INTENSITY="specularIntensity";MaterialNode.SPECULAR_COLOR="specularColor";MaterialNode.REFLECTIVITY="reflectivity";MaterialNode.ROUGHNESS="roughness";MaterialNode.METALNESS="metalness";MaterialNode.NORMAL="normal";MaterialNode.CLEARCOAT="clearcoat";MaterialNode.CLEARCOAT_ROUGHNESS="clearcoatRoughness";MaterialNode.CLEARCOAT_NORMAL="clearcoatNormal";MaterialNode.EMISSIVE="emissive";MaterialNode.ROTATION="rotation";MaterialNode.SHEEN="sheen";MaterialNode.SHEEN_ROUGHNESS="sheenRoughness";MaterialNode.ANISOTROPY="anisotropy";MaterialNode.IRIDESCENCE="iridescence";MaterialNode.IRIDESCENCE_IOR="iridescenceIOR";MaterialNode.IRIDESCENCE_THICKNESS="iridescenceThickness";MaterialNode.IOR="ior";MaterialNode.TRANSMISSION="transmission";MaterialNode.THICKNESS="thickness";MaterialNode.ATTENUATION_DISTANCE="attenuationDistance";MaterialNode.ATTENUATION_COLOR="attenuationColor";MaterialNode.LINE_SCALE="scale";MaterialNode.LINE_DASH_SIZE="dashSize";MaterialNode.LINE_GAP_SIZE="gapSize";MaterialNode.LINE_WIDTH="linewidth";MaterialNode.LINE_DASH_OFFSET="dashOffset";MaterialNode.POINT_SIZE="size";MaterialNode.DISPERSION="dispersion";MaterialNode.LIGHT_MAP="light";MaterialNode.AO="ao";const materialAlphaTest=nodeImmutable(MaterialNode,MaterialNode.ALPHA_TEST),materialColor=nodeImmutable(MaterialNode,MaterialNode.COLOR),materialShininess=nodeImmutable(MaterialNode,MaterialNode.SHININESS),materialEmissive=nodeImmutable(MaterialNode,MaterialNode.EMISSIVE),materialOpacity=nodeImmutable(MaterialNode,MaterialNode.OPACITY),materialSpecular=nodeImmutable(MaterialNode,MaterialNode.SPECULAR),materialSpecularIntensity=nodeImmutable(MaterialNode,MaterialNode.SPECULAR_INTENSITY),materialSpecularColor=nodeImmutable(MaterialNode,MaterialNode.SPECULAR_COLOR),materialSpecularStrength=nodeImmutable(MaterialNode,MaterialNode.SPECULAR_STRENGTH),materialReflectivity=nodeImmutable(MaterialNode,MaterialNode.REFLECTIVITY),materialRoughness=nodeImmutable(MaterialNode,MaterialNode.ROUGHNESS),materialMetalness=nodeImmutable(MaterialNode,MaterialNode.METALNESS),materialNormal=nodeImmutable(MaterialNode,MaterialNode.NORMAL),materialClearcoat=nodeImmutable(MaterialNode,MaterialNode.CLEARCOAT),materialClearcoatRoughness=nodeImmutable(MaterialNode,MaterialNode.CLEARCOAT_ROUGHNESS),materialClearcoatNormal=nodeImmutable(MaterialNode,MaterialNode.CLEARCOAT_NORMAL),materialRotation=nodeImmutable(MaterialNode,MaterialNode.ROTATION),materialSheen=nodeImmutable(MaterialNode,MaterialNode.SHEEN),materialSheenRoughness=nodeImmutable(MaterialNode,MaterialNode.SHEEN_ROUGHNESS),materialAnisotropy=nodeImmutable(MaterialNode,MaterialNode.ANISOTROPY),materialIridescence=nodeImmutable(MaterialNode,MaterialNode.IRIDESCENCE),materialIridescenceIOR=nodeImmutable(MaterialNode,MaterialNode.IRIDESCENCE_IOR),materialIridescenceThickness=nodeImmutable(MaterialNode,MaterialNode.IRIDESCENCE_THICKNESS),materialTransmission=nodeImmutable(MaterialNode,MaterialNode.TRANSMISSION),materialThickness=nodeImmutable(MaterialNode,MaterialNode.THICKNESS),materialIOR=nodeImmutable(MaterialNode,MaterialNode.IOR),materialAttenuationDistance=nodeImmutable(MaterialNode,MaterialNode.ATTENUATION_DISTANCE),materialAttenuationColor=nodeImmutable(MaterialNode,MaterialNode.ATTENUATION_COLOR),materialLineScale=nodeImmutable(MaterialNode,MaterialNode.LINE_SCALE),materialLineDashSize=nodeImmutable(MaterialNode,MaterialNode.LINE_DASH_SIZE),materialLineGapSize=nodeImmutable(MaterialNode,MaterialNode.LINE_GAP_SIZE),materialLineWidth=nodeImmutable(MaterialNode,MaterialNode.LINE_WIDTH),materialLineDashOffset=nodeImmutable(MaterialNode,MaterialNode.LINE_DASH_OFFSET),materialPointSize=nodeImmutable(MaterialNode,MaterialNode.POINT_SIZE),materialDispersion=nodeImmutable(MaterialNode,MaterialNode.DISPERSION),materialLightMap=nodeImmutable(MaterialNode,MaterialNode.LIGHT_MAP),materialAO=nodeImmutable(MaterialNode,MaterialNode.AO),materialAnisotropyVector=uniform$1(new Vector2).onReference(function(frame){return frame.material}).onRenderUpdate(function({material}){this.value.set(material.anisotropy*Math.cos(material.anisotropyRotation),material.anisotropy*Math.sin(material.anisotropyRotation))}),modelViewProjection=Fn$1(builder=>builder.context.setupModelViewProjection(),"vec4").once()().toVarying("v_modelViewProjection");class IndexNode extends Node{static get type(){return"IndexNode"}constructor(scope){super("uint"),this.scope=scope,this.isIndexNode=!0}generate(builder){const nodeType=this.getNodeType(builder),scope=this.scope;let propertyName;if(scope===IndexNode.VERTEX)propertyName=builder.getVertexIndex();else if(scope===IndexNode.INSTANCE)propertyName=builder.getInstanceIndex();else if(scope===IndexNode.DRAW)propertyName=builder.getDrawIndex();else if(scope===IndexNode.INVOCATION_LOCAL)propertyName=builder.getInvocationLocalIndex();else if(scope===IndexNode.INVOCATION_SUBGROUP)propertyName=builder.getInvocationSubgroupIndex();else if(scope===IndexNode.SUBGROUP)propertyName=builder.getSubgroupIndex();else throw new Error("THREE.IndexNode: Unknown scope: "+scope);let output2;return builder.shaderStage==="vertex"||builder.shaderStage==="compute"?output2=propertyName:output2=varying(this).build(builder,nodeType),output2}}IndexNode.VERTEX="vertex";IndexNode.INSTANCE="instance";IndexNode.SUBGROUP="subgroup";IndexNode.INVOCATION_LOCAL="invocationLocal";IndexNode.INVOCATION_SUBGROUP="invocationSubgroup";IndexNode.DRAW="draw";const vertexIndex=nodeImmutable(IndexNode,IndexNode.VERTEX),instanceIndex$1=nodeImmutable(IndexNode,IndexNode.INSTANCE),subgroupIndex=nodeImmutable(IndexNode,IndexNode.SUBGROUP),invocationSubgroupIndex=nodeImmutable(IndexNode,IndexNode.INVOCATION_SUBGROUP),invocationLocalIndex=nodeImmutable(IndexNode,IndexNode.INVOCATION_LOCAL),drawIndex=nodeImmutable(IndexNode,IndexNode.DRAW);class InstanceNode extends Node{static get type(){return"InstanceNode"}constructor(count,instanceMatrix,instanceColor){super("void"),this.count=count,this.instanceMatrix=instanceMatrix,this.instanceColor=instanceColor,this.instanceMatrixNode=null,this.instanceColorNode=null,this.updateType=NodeUpdateType.FRAME,this.buffer=null,this.bufferColor=null}setup(builder){const{count,instanceMatrix,instanceColor}=this;let{instanceMatrixNode,instanceColorNode}=this;if(instanceMatrixNode===null){if(count<=1e3)instanceMatrixNode=buffer(instanceMatrix.array,"mat4",Math.max(count,1)).element(instanceIndex$1);else{const buffer2=new InstancedInterleavedBuffer(instanceMatrix.array,16,1);this.buffer=buffer2;const bufferFn=instanceMatrix.usage===DynamicDrawUsage?instancedDynamicBufferAttribute:instancedBufferAttribute$1,instanceBuffers=[bufferFn(buffer2,"vec4",16,0),bufferFn(buffer2,"vec4",16,4),bufferFn(buffer2,"vec4",16,8),bufferFn(buffer2,"vec4",16,12)];instanceMatrixNode=mat4(...instanceBuffers)}this.instanceMatrixNode=instanceMatrixNode}if(instanceColor&&instanceColorNode===null){const buffer2=new InstancedBufferAttribute(instanceColor.array,3),bufferFn=instanceColor.usage===DynamicDrawUsage?instancedDynamicBufferAttribute:instancedBufferAttribute$1;this.bufferColor=buffer2,instanceColorNode=vec3$1(bufferFn(buffer2,"vec3",3,0)),this.instanceColorNode=instanceColorNode}const instancePosition=instanceMatrixNode.mul(positionLocal).xyz;if(positionLocal.assign(instancePosition),builder.hasGeometryAttribute("normal")){const instanceNormal=transformNormal(normalLocal,instanceMatrixNode);normalLocal.assign(instanceNormal)}this.instanceColorNode!==null&&varyingProperty("vec3","vInstanceColor").assign(this.instanceColorNode)}update(){this.instanceMatrix.usage!==DynamicDrawUsage&&this.buffer!==null&&this.instanceMatrix.version!==this.buffer.version&&(this.buffer.version=this.instanceMatrix.version),this.instanceColor&&this.instanceColor.usage!==DynamicDrawUsage&&this.bufferColor!==null&&this.instanceColor.version!==this.bufferColor.version&&(this.bufferColor.version=this.instanceColor.version)}}const instance=nodeProxy(InstanceNode);class InstancedMeshNode extends InstanceNode{static get type(){return"InstancedMeshNode"}constructor(instancedMesh2){const{count,instanceMatrix,instanceColor}=instancedMesh2;super(count,instanceMatrix,instanceColor),this.instancedMesh=instancedMesh2}}const instancedMesh=nodeProxy(InstancedMeshNode);class BatchNode extends Node{static get type(){return"BatchNode"}constructor(batchMesh){super("void"),this.batchMesh=batchMesh,this.batchingIdNode=null}setup(builder){this.batchingIdNode===null&&(builder.getDrawIndex()===null?this.batchingIdNode=instanceIndex$1:this.batchingIdNode=drawIndex);const indirectId=Fn$1(([id])=>{const size2=int(textureSize(textureLoad(this.batchMesh._indirectTexture),0)),x2=int(id).modInt(size2),y2=int(id).div(size2);return textureLoad(this.batchMesh._indirectTexture,ivec2(x2,y2)).x}).setLayout({name:"getIndirectIndex",type:"uint",inputs:[{name:"id",type:"int"}]})(int(this.batchingIdNode)),matricesTexture=this.batchMesh._matricesTexture,size=textureSize(textureLoad(matricesTexture),0),j=float$1(indirectId).mul(4).toInt().toVar(),x=j.modInt(size),y=j.div(int(size)),batchingMatrix=mat4(textureLoad(matricesTexture,ivec2(x,y)),textureLoad(matricesTexture,ivec2(x.add(1),y)),textureLoad(matricesTexture,ivec2(x.add(2),y)),textureLoad(matricesTexture,ivec2(x.add(3),y))),colorsTexture=this.batchMesh._colorsTexture;if(colorsTexture!==null){const color2=Fn$1(([id])=>{const size2=textureSize(textureLoad(colorsTexture),0).x,j2=id,x2=j2.modInt(size2),y2=j2.div(size2);return textureLoad(colorsTexture,ivec2(x2,y2)).rgb}).setLayout({name:"getBatchingColor",type:"vec3",inputs:[{name:"id",type:"int"}]})(indirectId);varyingProperty("vec3","vBatchColor").assign(color2)}const bm=mat3(batchingMatrix);positionLocal.assign(batchingMatrix.mul(positionLocal));const transformedNormal=normalLocal.div(vec3$1(bm[0].dot(bm[0]),bm[1].dot(bm[1]),bm[2].dot(bm[2]))),batchingNormal=bm.mul(transformedNormal).xyz;normalLocal.assign(batchingNormal),builder.hasGeometryAttribute("tangent")&&tangentLocal.mulAssign(bm)}}const batch$1=nodeProxy(BatchNode),_frameId=new WeakMap;class SkinningNode extends Node{static get type(){return"SkinningNode"}constructor(skinnedMesh,useReference=!1){super("void"),this.skinnedMesh=skinnedMesh,this.useReference=useReference,this.updateType=NodeUpdateType.OBJECT,this.skinIndexNode=attribute("skinIndex","uvec4"),this.skinWeightNode=attribute("skinWeight","vec4");let bindMatrixNode,bindMatrixInverseNode,boneMatricesNode;useReference?(bindMatrixNode=reference("bindMatrix","mat4"),bindMatrixInverseNode=reference("bindMatrixInverse","mat4"),boneMatricesNode=referenceBuffer("skeleton.boneMatrices","mat4",skinnedMesh.skeleton.bones.length)):(bindMatrixNode=uniform$1(skinnedMesh.bindMatrix,"mat4"),bindMatrixInverseNode=uniform$1(skinnedMesh.bindMatrixInverse,"mat4"),boneMatricesNode=buffer(skinnedMesh.skeleton.boneMatrices,"mat4",skinnedMesh.skeleton.bones.length)),this.bindMatrixNode=bindMatrixNode,this.bindMatrixInverseNode=bindMatrixInverseNode,this.boneMatricesNode=boneMatricesNode,this.previousBoneMatricesNode=null}getSkinnedPosition(boneMatrices=this.boneMatricesNode,position=positionLocal){const{skinIndexNode,skinWeightNode,bindMatrixNode,bindMatrixInverseNode}=this,boneMatX=boneMatrices.element(skinIndexNode.x),boneMatY=boneMatrices.element(skinIndexNode.y),boneMatZ=boneMatrices.element(skinIndexNode.z),boneMatW=boneMatrices.element(skinIndexNode.w),skinVertex=bindMatrixNode.mul(position),skinned=add$3(boneMatX.mul(skinWeightNode.x).mul(skinVertex),boneMatY.mul(skinWeightNode.y).mul(skinVertex),boneMatZ.mul(skinWeightNode.z).mul(skinVertex),boneMatW.mul(skinWeightNode.w).mul(skinVertex));return bindMatrixInverseNode.mul(skinned).xyz}getSkinnedNormal(boneMatrices=this.boneMatricesNode,normal2=normalLocal){const{skinIndexNode,skinWeightNode,bindMatrixNode,bindMatrixInverseNode}=this,boneMatX=boneMatrices.element(skinIndexNode.x),boneMatY=boneMatrices.element(skinIndexNode.y),boneMatZ=boneMatrices.element(skinIndexNode.z),boneMatW=boneMatrices.element(skinIndexNode.w);let skinMatrix=add$3(skinWeightNode.x.mul(boneMatX),skinWeightNode.y.mul(boneMatY),skinWeightNode.z.mul(boneMatZ),skinWeightNode.w.mul(boneMatW));return skinMatrix=bindMatrixInverseNode.mul(skinMatrix).mul(bindMatrixNode),skinMatrix.transformDirection(normal2).xyz}getPreviousSkinnedPosition(builder){const skinnedMesh=builder.object;return this.previousBoneMatricesNode===null&&(skinnedMesh.skeleton.previousBoneMatrices=new Float32Array(skinnedMesh.skeleton.boneMatrices),this.previousBoneMatricesNode=referenceBuffer("skeleton.previousBoneMatrices","mat4",skinnedMesh.skeleton.bones.length)),this.getSkinnedPosition(this.previousBoneMatricesNode,positionPrevious)}needsPreviousBoneMatrices(builder){const mrt2=builder.renderer.getMRT();return mrt2&&mrt2.has("velocity")||getDataFromObject(builder.object).useVelocity===!0}setup(builder){this.needsPreviousBoneMatrices(builder)&&positionPrevious.assign(this.getPreviousSkinnedPosition(builder));const skinPosition=this.getSkinnedPosition();if(positionLocal.assign(skinPosition),builder.hasGeometryAttribute("normal")){const skinNormal=this.getSkinnedNormal();normalLocal.assign(skinNormal),builder.hasGeometryAttribute("tangent")&&tangentLocal.assign(skinNormal)}}generate(builder,output2){if(output2!=="void")return positionLocal.build(builder,output2)}update(frame){const skeleton=(this.useReference?frame.object:this.skinnedMesh).skeleton;_frameId.get(skeleton)!==frame.frameId&&(_frameId.set(skeleton,frame.frameId),this.previousBoneMatricesNode!==null&&skeleton.previousBoneMatrices.set(skeleton.boneMatrices),skeleton.update())}}const skinning=skinnedMesh=>nodeObject$1(new SkinningNode(skinnedMesh)),skinningReference=skinnedMesh=>nodeObject$1(new SkinningNode(skinnedMesh,!0));class LoopNode extends Node{static get type(){return"LoopNode"}constructor(params=[]){super(),this.params=params}getVarName(index){return String.fromCharCode(105+index)}getProperties(builder){const properties=builder.getNodeProperties(this);if(properties.stackNode!==void 0)return properties;const inputs={};for(let i2=0,l2=this.params.length-1;i2<l2;i2++){const param=this.params[i2],name=param.isNode!==!0&&param.name||this.getVarName(i2),type=param.isNode!==!0&&param.type||"int";inputs[name]=expression(name,type)}const stack2=builder.addStack();return properties.returnsNode=this.params[this.params.length-1](inputs,stack2,builder),properties.stackNode=stack2,builder.removeStack(),properties}getNodeType(builder){const{returnsNode}=this.getProperties(builder);return returnsNode?returnsNode.getNodeType(builder):"void"}setup(builder){this.getProperties(builder)}generate(builder){const properties=this.getProperties(builder),params=this.params,stackNode=properties.stackNode;for(let i2=0,l2=params.length-1;i2<l2;i2++){const param=params[i2];let start=null,end=null,name=null,type=null,condition=null,update=null;param.isNode?(type="int",name=this.getVarName(i2),start="0",end=param.build(builder,type),condition="<"):(type=param.type||"int",name=param.name||this.getVarName(i2),start=param.start,end=param.end,condition=param.condition,update=param.update,typeof start=="number"?start=builder.generateConst(type,start):start&&start.isNode&&(start=start.build(builder,type)),typeof end=="number"?end=builder.generateConst(type,end):end&&end.isNode&&(end=end.build(builder,type)),start!==void 0&&end===void 0?(start=start+" - 1",end="0",condition=">="):end!==void 0&&start===void 0&&(start="0",condition="<"),condition===void 0&&(Number(start)>Number(end)?condition=">=":condition="<"));const internalParam={start,end},startSnippet=internalParam.start,endSnippet=internalParam.end;let declarationSnippet="",conditionalSnippet="",updateSnippet="";update||(type==="int"||type==="uint"?condition.includes("<")?update="++":update="--":condition.includes("<")?update="+= 1.":update="-= 1."),declarationSnippet+=builder.getVar(type,name)+" = "+startSnippet,conditionalSnippet+=name+" "+condition+" "+endSnippet,updateSnippet+=name+" "+update;const forSnippet=`for ( ${declarationSnippet}; ${conditionalSnippet}; ${updateSnippet} )`;builder.addFlowCode((i2===0?`
`:"")+builder.tab+forSnippet+` {

`).addFlowTab()}const stackSnippet=stackNode.build(builder,"void"),returnsSnippet=properties.returnsNode?properties.returnsNode.build(builder):"";builder.removeFlowTab().addFlowCode(`
`+builder.tab+stackSnippet);for(let i2=0,l2=this.params.length-1;i2<l2;i2++)builder.addFlowCode((i2===0?"":builder.tab)+`}

`).removeFlowTab();return builder.addFlowTab(),returnsSnippet}}const Loop=(...params)=>nodeObject$1(new LoopNode(nodeArray(params,"int"))).append(),Continue=()=>expression("continue").append(),Break=()=>expression("break").append(),loop=(...params)=>(console.warn("TSL.LoopNode: loop() has been renamed to Loop()."),Loop(...params)),_morphTextures=new WeakMap,_morphVec4=new Vector4,getMorph=Fn$1(({bufferMap,influence,stride,width,depth:depth2,offset})=>{const texelIndex=int(vertexIndex).mul(stride).add(offset),y=texelIndex.div(width),x=texelIndex.sub(y.mul(width));return textureLoad(bufferMap,ivec2(x,y)).depth(depth2).mul(influence)});function getEntry(geometry2){const hasMorphPosition=geometry2.morphAttributes.position!==void 0,hasMorphNormals=geometry2.morphAttributes.normal!==void 0,hasMorphColors=geometry2.morphAttributes.color!==void 0,morphAttribute=geometry2.morphAttributes.position||geometry2.morphAttributes.normal||geometry2.morphAttributes.color,morphTargetsCount=morphAttribute!==void 0?morphAttribute.length:0;let entry=_morphTextures.get(geometry2);if(entry===void 0||entry.count!==morphTargetsCount){let disposeTexture=function(){bufferTexture.dispose(),_morphTextures.delete(geometry2),geometry2.removeEventListener("dispose",disposeTexture)};entry!==void 0&&entry.texture.dispose();const morphTargets=geometry2.morphAttributes.position||[],morphNormals=geometry2.morphAttributes.normal||[],morphColors=geometry2.morphAttributes.color||[];let vertexDataCount=0;hasMorphPosition===!0&&(vertexDataCount=1),hasMorphNormals===!0&&(vertexDataCount=2),hasMorphColors===!0&&(vertexDataCount=3);let width=geometry2.attributes.position.count*vertexDataCount,height=1;const maxTextureSize=4096;width>maxTextureSize&&(height=Math.ceil(width/maxTextureSize),width=maxTextureSize);const buffer2=new Float32Array(width*height*4*morphTargetsCount),bufferTexture=new DataArrayTexture(buffer2,width,height,morphTargetsCount);bufferTexture.type=FloatType,bufferTexture.needsUpdate=!0;const vertexDataStride=vertexDataCount*4;for(let i2=0;i2<morphTargetsCount;i2++){const morphTarget=morphTargets[i2],morphNormal=morphNormals[i2],morphColor=morphColors[i2],offset=width*height*4*i2;for(let j=0;j<morphTarget.count;j++){const stride=j*vertexDataStride;hasMorphPosition===!0&&(_morphVec4.fromBufferAttribute(morphTarget,j),buffer2[offset+stride+0]=_morphVec4.x,buffer2[offset+stride+1]=_morphVec4.y,buffer2[offset+stride+2]=_morphVec4.z,buffer2[offset+stride+3]=0),hasMorphNormals===!0&&(_morphVec4.fromBufferAttribute(morphNormal,j),buffer2[offset+stride+4]=_morphVec4.x,buffer2[offset+stride+5]=_morphVec4.y,buffer2[offset+stride+6]=_morphVec4.z,buffer2[offset+stride+7]=0),hasMorphColors===!0&&(_morphVec4.fromBufferAttribute(morphColor,j),buffer2[offset+stride+8]=_morphVec4.x,buffer2[offset+stride+9]=_morphVec4.y,buffer2[offset+stride+10]=_morphVec4.z,buffer2[offset+stride+11]=morphColor.itemSize===4?_morphVec4.w:1)}}entry={count:morphTargetsCount,texture:bufferTexture,stride:vertexDataCount,size:new Vector2(width,height)},_morphTextures.set(geometry2,entry),geometry2.addEventListener("dispose",disposeTexture)}return entry}class MorphNode extends Node{static get type(){return"MorphNode"}constructor(mesh){super("void"),this.mesh=mesh,this.morphBaseInfluence=uniform$1(1),this.updateType=NodeUpdateType.OBJECT}setup(builder){const{geometry:geometry2}=builder,hasMorphPosition=geometry2.morphAttributes.position!==void 0,hasMorphNormals=geometry2.hasAttribute("normal")&&geometry2.morphAttributes.normal!==void 0,morphAttribute=geometry2.morphAttributes.position||geometry2.morphAttributes.normal||geometry2.morphAttributes.color,morphTargetsCount=morphAttribute!==void 0?morphAttribute.length:0,{texture:bufferMap,stride,size}=getEntry(geometry2);hasMorphPosition===!0&&positionLocal.mulAssign(this.morphBaseInfluence),hasMorphNormals===!0&&normalLocal.mulAssign(this.morphBaseInfluence);const width=int(size.width);Loop(morphTargetsCount,({i:i2})=>{const influence=float$1(0).toVar();this.mesh.count>1&&this.mesh.morphTexture!==null&&this.mesh.morphTexture!==void 0?influence.assign(textureLoad(this.mesh.morphTexture,ivec2(int(i2).add(1),int(instanceIndex$1))).r):influence.assign(reference("morphTargetInfluences","float").element(i2).toVar()),hasMorphPosition===!0&&positionLocal.addAssign(getMorph({bufferMap,influence,stride,width,depth:i2,offset:int(0)})),hasMorphNormals===!0&&normalLocal.addAssign(getMorph({bufferMap,influence,stride,width,depth:i2,offset:int(1)}))})}update(){const morphBaseInfluence=this.morphBaseInfluence;this.mesh.geometry.morphTargetsRelative?morphBaseInfluence.value=1:morphBaseInfluence.value=1-this.mesh.morphTargetInfluences.reduce((a2,b)=>a2+b,0)}}const morphReference=nodeProxy(MorphNode);class LightingNode extends Node{static get type(){return"LightingNode"}constructor(){super("vec3"),this.isLightingNode=!0}}class AONode extends LightingNode{static get type(){return"AONode"}constructor(aoNode=null){super(),this.aoNode=aoNode}setup(builder){builder.context.ambientOcclusion.mulAssign(this.aoNode)}}class LightingContextNode extends ContextNode{static get type(){return"LightingContextNode"}constructor(lightsNode,lightingModel=null,backdropNode=null,backdropAlphaNode=null){super(lightsNode),this.lightingModel=lightingModel,this.backdropNode=backdropNode,this.backdropAlphaNode=backdropAlphaNode,this._value=null}getContext(){const{backdropNode,backdropAlphaNode}=this,directDiffuse=vec3$1().toVar("directDiffuse"),directSpecular=vec3$1().toVar("directSpecular"),indirectDiffuse=vec3$1().toVar("indirectDiffuse"),indirectSpecular=vec3$1().toVar("indirectSpecular"),reflectedLight={directDiffuse,directSpecular,indirectDiffuse,indirectSpecular};return{radiance:vec3$1().toVar("radiance"),irradiance:vec3$1().toVar("irradiance"),iblIrradiance:vec3$1().toVar("iblIrradiance"),ambientOcclusion:float$1(1).toVar("ambientOcclusion"),reflectedLight,backdrop:backdropNode,backdropAlpha:backdropAlphaNode}}setup(builder){return this.value=this._value||(this._value=this.getContext()),this.value.lightingModel=this.lightingModel||builder.context.lightingModel,super.setup(builder)}}const lightingContext=nodeProxy(LightingContextNode);class IrradianceNode extends LightingNode{static get type(){return"IrradianceNode"}constructor(node){super(),this.node=node}setup(builder){builder.context.irradiance.addAssign(this.node)}}let screenSizeVec,viewportVec;class ScreenNode extends Node{static get type(){return"ScreenNode"}constructor(scope){super(),this.scope=scope,this.isViewportNode=!0}getNodeType(){return this.scope===ScreenNode.VIEWPORT?"vec4":"vec2"}getUpdateType(){let updateType=NodeUpdateType.NONE;return(this.scope===ScreenNode.SIZE||this.scope===ScreenNode.VIEWPORT)&&(updateType=NodeUpdateType.RENDER),this.updateType=updateType,updateType}update({renderer}){const renderTarget=renderer.getRenderTarget();this.scope===ScreenNode.VIEWPORT?renderTarget!==null?viewportVec.copy(renderTarget.viewport):(renderer.getViewport(viewportVec),viewportVec.multiplyScalar(renderer.getPixelRatio())):renderTarget!==null?(screenSizeVec.width=renderTarget.width,screenSizeVec.height=renderTarget.height):renderer.getDrawingBufferSize(screenSizeVec)}setup(){const scope=this.scope;let output2=null;return scope===ScreenNode.SIZE?output2=uniform$1(screenSizeVec||(screenSizeVec=new Vector2)):scope===ScreenNode.VIEWPORT?output2=uniform$1(viewportVec||(viewportVec=new Vector4)):output2=vec2$1(screenCoordinate.div(screenSize)),output2}generate(builder){if(this.scope===ScreenNode.COORDINATE){let coord=builder.getFragCoord();if(builder.isFlipY()){const size=builder.getNodeProperties(screenSize).outputNode.build(builder);coord=`${builder.getType("vec2")}( ${coord}.x, ${size}.y - ${coord}.y )`}return coord}return super.generate(builder)}}ScreenNode.COORDINATE="coordinate";ScreenNode.VIEWPORT="viewport";ScreenNode.SIZE="size";ScreenNode.UV="uv";const screenUV=nodeImmutable(ScreenNode,ScreenNode.UV),screenSize=nodeImmutable(ScreenNode,ScreenNode.SIZE),screenCoordinate=nodeImmutable(ScreenNode,ScreenNode.COORDINATE),viewport=nodeImmutable(ScreenNode,ScreenNode.VIEWPORT),viewportSize=viewport.zw,viewportCoordinate=screenCoordinate.sub(viewport.xy),viewportUV=viewportCoordinate.div(viewportSize),viewportResolution=Fn$1(()=>(console.warn('TSL.ViewportNode: "viewportResolution" is deprecated. Use "screenSize" instead.'),screenSize),"vec2").once()(),viewportTopLeft=Fn$1(()=>(console.warn('TSL.ViewportNode: "viewportTopLeft" is deprecated. Use "screenUV" instead.'),screenUV),"vec2").once()(),viewportBottomLeft=Fn$1(()=>(console.warn('TSL.ViewportNode: "viewportBottomLeft" is deprecated. Use "screenUV.flipY()" instead.'),screenUV.flipY()),"vec2").once()(),_size$4=new Vector2;class ViewportTextureNode extends TextureNode{static get type(){return"ViewportTextureNode"}constructor(uvNode=screenUV,levelNode=null,framebufferTexture=null){framebufferTexture===null&&(framebufferTexture=new FramebufferTexture,framebufferTexture.minFilter=LinearMipmapLinearFilter),super(framebufferTexture,uvNode,levelNode),this.generateMipmaps=!1,this.isOutputTextureNode=!0,this.updateBeforeType=NodeUpdateType.FRAME}updateBefore(frame){const renderer=frame.renderer;renderer.getDrawingBufferSize(_size$4);const framebufferTexture=this.value;(framebufferTexture.image.width!==_size$4.width||framebufferTexture.image.height!==_size$4.height)&&(framebufferTexture.image.width=_size$4.width,framebufferTexture.image.height=_size$4.height,framebufferTexture.needsUpdate=!0);const currentGenerateMipmaps=framebufferTexture.generateMipmaps;framebufferTexture.generateMipmaps=this.generateMipmaps,renderer.copyFramebufferToTexture(framebufferTexture),framebufferTexture.generateMipmaps=currentGenerateMipmaps}clone(){const viewportTextureNode=new this.constructor(this.uvNode,this.levelNode,this.value);return viewportTextureNode.generateMipmaps=this.generateMipmaps,viewportTextureNode}}const viewportTexture=nodeProxy(ViewportTextureNode),viewportMipTexture=nodeProxy(ViewportTextureNode,null,null,{generateMipmaps:!0});let sharedDepthbuffer=null;class ViewportDepthTextureNode extends ViewportTextureNode{static get type(){return"ViewportDepthTextureNode"}constructor(uvNode=screenUV,levelNode=null){sharedDepthbuffer===null&&(sharedDepthbuffer=new DepthTexture),super(uvNode,levelNode,sharedDepthbuffer)}}const viewportDepthTexture=nodeProxy(ViewportDepthTextureNode);class ViewportDepthNode extends Node{static get type(){return"ViewportDepthNode"}constructor(scope,valueNode=null){super("float"),this.scope=scope,this.valueNode=valueNode,this.isViewportDepthNode=!0}generate(builder){const{scope}=this;return scope===ViewportDepthNode.DEPTH_BASE?builder.getFragDepth():super.generate(builder)}setup({camera}){const{scope}=this,value=this.valueNode;let node=null;if(scope===ViewportDepthNode.DEPTH_BASE)value!==null&&(node=depthBase().assign(value));else if(scope===ViewportDepthNode.DEPTH)camera.isPerspectiveCamera?node=viewZToPerspectiveDepth(positionView.z,cameraNear,cameraFar):node=viewZToOrthographicDepth(positionView.z,cameraNear,cameraFar);else if(scope===ViewportDepthNode.LINEAR_DEPTH)if(value!==null)if(camera.isPerspectiveCamera){const viewZ=perspectiveDepthToViewZ(value,cameraNear,cameraFar);node=viewZToOrthographicDepth(viewZ,cameraNear,cameraFar)}else node=value;else node=viewZToOrthographicDepth(positionView.z,cameraNear,cameraFar);return node}}ViewportDepthNode.DEPTH_BASE="depthBase";ViewportDepthNode.DEPTH="depth";ViewportDepthNode.LINEAR_DEPTH="linearDepth";const viewZToOrthographicDepth=(viewZ,near,far)=>viewZ.add(near).div(near.sub(far)),orthographicDepthToViewZ=(depth2,near,far)=>near.sub(far).mul(depth2).sub(near),viewZToPerspectiveDepth=(viewZ,near,far)=>near.add(viewZ).mul(far).div(far.sub(near).mul(viewZ)),perspectiveDepthToViewZ=(depth2,near,far)=>near.mul(far).div(far.sub(near).mul(depth2).sub(far)),viewZToLogarithmicDepth=(viewZ,near,far)=>{near=near.max(1e-6).toVar();const numerator=log2(viewZ.negate().div(near)),denominator=log2(far.div(near));return numerator.div(denominator)},logarithmicDepthToViewZ=(depth2,near,far)=>{const exponent=depth2.mul(log(far.div(near)));return float$1(Math.E).pow(exponent).mul(near).negate()},depthBase=nodeProxy(ViewportDepthNode,ViewportDepthNode.DEPTH_BASE),depth=nodeImmutable(ViewportDepthNode,ViewportDepthNode.DEPTH),linearDepth=nodeProxy(ViewportDepthNode,ViewportDepthNode.LINEAR_DEPTH),viewportLinearDepth=linearDepth(viewportDepthTexture());depth.assign=value=>depthBase(value);class BuiltinNode extends Node{constructor(name){super("float"),this.name=name,this.isBuiltinNode=!0}generate(){return this.name}}const builtin=nodeProxy(BuiltinNode);class ClippingNode extends Node{static get type(){return"ClippingNode"}constructor(scope=ClippingNode.DEFAULT){super(),this.scope=scope}setup(builder){super.setup(builder);const clippingContext=builder.clippingContext,{intersectionPlanes,unionPlanes}=clippingContext;return this.hardwareClipping=builder.material.hardwareClipping,this.scope===ClippingNode.ALPHA_TO_COVERAGE?this.setupAlphaToCoverage(intersectionPlanes,unionPlanes):this.scope===ClippingNode.HARDWARE?this.setupHardwareClipping(unionPlanes,builder):this.setupDefault(intersectionPlanes,unionPlanes)}setupAlphaToCoverage(intersectionPlanes,unionPlanes){return Fn$1(()=>{const distanceToPlane=float$1().toVar("distanceToPlane"),distanceGradient=float$1().toVar("distanceToGradient"),clipOpacity=float$1(1).toVar("clipOpacity"),numUnionPlanes=unionPlanes.length;if(this.hardwareClipping===!1&&numUnionPlanes>0){const clippingPlanes=uniformArray(unionPlanes);Loop(numUnionPlanes,({i:i2})=>{const plane=clippingPlanes.element(i2);distanceToPlane.assign(positionView.dot(plane.xyz).negate().add(plane.w)),distanceGradient.assign(distanceToPlane.fwidth().div(2)),clipOpacity.mulAssign(smoothstep$1(distanceGradient.negate(),distanceGradient,distanceToPlane))})}const numIntersectionPlanes=intersectionPlanes.length;if(numIntersectionPlanes>0){const clippingPlanes=uniformArray(intersectionPlanes),intersectionClipOpacity=float$1(1).toVar("intersectionClipOpacity");Loop(numIntersectionPlanes,({i:i2})=>{const plane=clippingPlanes.element(i2);distanceToPlane.assign(positionView.dot(plane.xyz).negate().add(plane.w)),distanceGradient.assign(distanceToPlane.fwidth().div(2)),intersectionClipOpacity.mulAssign(smoothstep$1(distanceGradient.negate(),distanceGradient,distanceToPlane).oneMinus())}),clipOpacity.mulAssign(intersectionClipOpacity.oneMinus())}diffuseColor.a.mulAssign(clipOpacity),diffuseColor.a.equal(0).discard()})()}setupDefault(intersectionPlanes,unionPlanes){return Fn$1(()=>{const numUnionPlanes=unionPlanes.length;if(this.hardwareClipping===!1&&numUnionPlanes>0){const clippingPlanes=uniformArray(unionPlanes);Loop(numUnionPlanes,({i:i2})=>{const plane=clippingPlanes.element(i2);positionView.dot(plane.xyz).greaterThan(plane.w).discard()})}const numIntersectionPlanes=intersectionPlanes.length;if(numIntersectionPlanes>0){const clippingPlanes=uniformArray(intersectionPlanes),clipped=bool(!0).toVar("clipped");Loop(numIntersectionPlanes,({i:i2})=>{const plane=clippingPlanes.element(i2);clipped.assign(positionView.dot(plane.xyz).greaterThan(plane.w).and(clipped))}),clipped.discard()}})()}setupHardwareClipping(unionPlanes,builder){const numUnionPlanes=unionPlanes.length;return builder.enableHardwareClipping(numUnionPlanes),Fn$1(()=>{const clippingPlanes=uniformArray(unionPlanes),hw_clip_distances=builtin(builder.getClipDistance());Loop(numUnionPlanes,({i:i2})=>{const plane=clippingPlanes.element(i2),distance2=positionView.dot(plane.xyz).sub(plane.w).negate();hw_clip_distances.element(i2).assign(distance2)})})()}}ClippingNode.ALPHA_TO_COVERAGE="alphaToCoverage";ClippingNode.DEFAULT="default";ClippingNode.HARDWARE="hardware";const clipping=()=>nodeObject$1(new ClippingNode),clippingAlpha=()=>nodeObject$1(new ClippingNode(ClippingNode.ALPHA_TO_COVERAGE)),hardwareClipping=()=>nodeObject$1(new ClippingNode(ClippingNode.HARDWARE)),ALPHA_HASH_SCALE=.05,hash2D=Fn$1(([value])=>fract(mul$1(1e4,sin$2(mul$1(17,value.x).add(mul$1(.1,value.y)))).mul(add$3(.1,abs$2(sin$2(mul$1(13,value.y).add(value.x))))))),hash3D=Fn$1(([value])=>hash2D(vec2$1(hash2D(value.xy),value.z))),getAlphaHashThreshold=Fn$1(([position])=>{const maxDeriv=max$1(length$1(dFdx(position.xyz)),length$1(dFdy(position.xyz))),pixScale=float$1(1).div(float$1(ALPHA_HASH_SCALE).mul(maxDeriv)).toVar("pixScale"),pixScales=vec2$1(exp2(floor$3(log2(pixScale))),exp2(ceil$2(log2(pixScale)))),alpha=vec2$1(hash3D(floor$3(pixScales.x.mul(position.xyz))),hash3D(floor$3(pixScales.y.mul(position.xyz)))),lerpFactor=fract(log2(pixScale)),x=add$3(mul$1(lerpFactor.oneMinus(),alpha.x),mul$1(lerpFactor,alpha.y)),a2=min$1(lerpFactor,lerpFactor.oneMinus()),cases=vec3$1(x.mul(x).div(mul$1(2,a2).mul(sub(1,a2))),x.sub(mul$1(.5,a2)).div(sub(1,a2)),sub(1,sub(1,x).mul(sub(1,x)).div(mul$1(2,a2).mul(sub(1,a2))))),threshold=x.lessThan(a2.oneMinus()).select(x.lessThan(a2).select(cases.x,cases.y),cases.z);return clamp$3(threshold,1e-6,1)}).setLayout({name:"getAlphaHashThreshold",type:"float",inputs:[{name:"position",type:"vec3"}]});class NodeMaterial extends Material{static get type(){return"NodeMaterial"}get type(){return this.constructor.type}set type(_value){}constructor(){super(),this.isNodeMaterial=!0,this.fog=!0,this.lights=!1,this.hardwareClipping=!1,this.lightsNode=null,this.envNode=null,this.aoNode=null,this.colorNode=null,this.normalNode=null,this.opacityNode=null,this.backdropNode=null,this.backdropAlphaNode=null,this.alphaTestNode=null,this.positionNode=null,this.geometryNode=null,this.depthNode=null,this.shadowPositionNode=null,this.receivedShadowNode=null,this.castShadowNode=null,this.outputNode=null,this.mrtNode=null,this.fragmentNode=null,this.vertexNode=null}customProgramCacheKey(){return this.type+getCacheKey$1$1(this)}build(builder){this.setup(builder)}setupObserver(builder){return new NodeMaterialObserver(builder)}setup(builder){builder.context.setupNormal=()=>this.setupNormal(builder),builder.context.setupPositionView=()=>this.setupPositionView(builder),builder.context.setupModelViewProjection=()=>this.setupModelViewProjection(builder);const renderer=builder.renderer,renderTarget=renderer.getRenderTarget();builder.addStack();const vertexNode=this.vertexNode||this.setupVertex(builder);builder.stack.outputNode=vertexNode,this.setupHardwareClipping(builder),this.geometryNode!==null&&(builder.stack.outputNode=builder.stack.outputNode.bypass(this.geometryNode)),builder.addFlow("vertex",builder.removeStack()),builder.addStack();let resultNode;const clippingNode=this.setupClipping(builder);if((this.depthWrite===!0||this.depthTest===!0)&&(renderTarget!==null?renderTarget.depthBuffer===!0&&this.setupDepth(builder):renderer.depth===!0&&this.setupDepth(builder)),this.fragmentNode===null){this.setupDiffuseColor(builder),this.setupVariants(builder);const outgoingLightNode=this.setupLighting(builder);clippingNode!==null&&builder.stack.add(clippingNode);const basicOutput=vec4$1(outgoingLightNode,diffuseColor.a).max(0);if(resultNode=this.setupOutput(builder,basicOutput),output.assign(resultNode),this.outputNode!==null&&(resultNode=this.outputNode),renderTarget!==null){const mrt2=renderer.getMRT(),materialMRT=this.mrtNode;mrt2!==null?(resultNode=mrt2,materialMRT!==null&&(resultNode=mrt2.merge(materialMRT))):materialMRT!==null&&(resultNode=materialMRT)}}else{let fragmentNode=this.fragmentNode;fragmentNode.isOutputStructNode!==!0&&(fragmentNode=vec4$1(fragmentNode)),resultNode=this.setupOutput(builder,fragmentNode)}builder.stack.outputNode=resultNode,builder.addFlow("fragment",builder.removeStack()),builder.observer=this.setupObserver(builder)}setupClipping(builder){if(builder.clippingContext===null)return null;const{unionPlanes,intersectionPlanes}=builder.clippingContext;let result=null;if(unionPlanes.length>0||intersectionPlanes.length>0){const samples=builder.renderer.samples;this.alphaToCoverage&&samples>1?result=clippingAlpha():builder.stack.add(clipping())}return result}setupHardwareClipping(builder){if(this.hardwareClipping=!1,builder.clippingContext===null)return;const candidateCount=builder.clippingContext.unionPlanes.length;candidateCount>0&&candidateCount<=8&&builder.isAvailable("clipDistance")&&(builder.stack.add(hardwareClipping()),this.hardwareClipping=!0)}setupDepth(builder){const{renderer,camera}=builder;let depthNode=this.depthNode;if(depthNode===null){const mrt2=renderer.getMRT();mrt2&&mrt2.has("depth")?depthNode=mrt2.get("depth"):renderer.logarithmicDepthBuffer===!0&&(camera.isPerspectiveCamera?depthNode=viewZToLogarithmicDepth(positionView.z,cameraNear,cameraFar):depthNode=viewZToOrthographicDepth(positionView.z,cameraNear,cameraFar))}depthNode!==null&&depth.assign(depthNode).append()}setupPositionView(){return modelViewMatrix.mul(positionLocal).xyz}setupModelViewProjection(){return cameraProjectionMatrix.mul(positionView)}setupVertex(builder){return builder.addStack(),this.setupPosition(builder),builder.context.vertex=builder.removeStack(),modelViewProjection}setupPosition(builder){const{object,geometry:geometry2}=builder;if((geometry2.morphAttributes.position||geometry2.morphAttributes.normal||geometry2.morphAttributes.color)&&morphReference(object).append(),object.isSkinnedMesh===!0&&skinningReference(object).append(),this.displacementMap){const displacementMap=materialReference("displacementMap","texture"),displacementScale=materialReference("displacementScale","float"),displacementBias=materialReference("displacementBias","float");positionLocal.addAssign(normalLocal.normalize().mul(displacementMap.x.mul(displacementScale).add(displacementBias)))}return object.isBatchedMesh&&batch$1(object).append(),object.isInstancedMesh&&object.instanceMatrix&&object.instanceMatrix.isInstancedBufferAttribute===!0&&instancedMesh(object).append(),this.positionNode!==null&&positionLocal.assign(this.positionNode.context({isPositionNodeInput:!0})),positionLocal}setupDiffuseColor({object,geometry:geometry2}){let colorNode=this.colorNode?vec4$1(this.colorNode):materialColor;this.vertexColors===!0&&geometry2.hasAttribute("color")&&(colorNode=vec4$1(colorNode.xyz.mul(attribute("color","vec3")),colorNode.a)),object.instanceColor&&(colorNode=varyingProperty("vec3","vInstanceColor").mul(colorNode)),object.isBatchedMesh&&object._colorsTexture&&(colorNode=varyingProperty("vec3","vBatchColor").mul(colorNode)),diffuseColor.assign(colorNode);const opacityNode=this.opacityNode?float$1(this.opacityNode):materialOpacity;if(diffuseColor.a.assign(diffuseColor.a.mul(opacityNode)),this.alphaTestNode!==null||this.alphaTest>0){const alphaTestNode=this.alphaTestNode!==null?float$1(this.alphaTestNode):materialAlphaTest;diffuseColor.a.lessThanEqual(alphaTestNode).discard()}this.alphaHash===!0&&diffuseColor.a.lessThan(getAlphaHashThreshold(positionLocal)).discard(),this.transparent===!1&&this.blending===NormalBlending&&this.alphaToCoverage===!1&&diffuseColor.a.assign(1)}setupVariants(){}setupOutgoingLight(){return this.lights===!0?vec3$1(0):diffuseColor.rgb}setupNormal(){return this.normalNode?vec3$1(this.normalNode):materialNormal}setupEnvironment(){let node=null;return this.envNode?node=this.envNode:this.envMap&&(node=this.envMap.isCubeTexture?materialReference("envMap","cubeTexture"):materialReference("envMap","texture")),node}setupLightMap(builder){let node=null;return builder.material.lightMap&&(node=new IrradianceNode(materialLightMap)),node}setupLights(builder){const materialLightsNode=[],envNode=this.setupEnvironment(builder);envNode&&envNode.isLightingNode&&materialLightsNode.push(envNode);const lightMapNode=this.setupLightMap(builder);if(lightMapNode&&lightMapNode.isLightingNode&&materialLightsNode.push(lightMapNode),this.aoNode!==null||builder.material.aoMap){const aoNode=this.aoNode!==null?this.aoNode:materialAO;materialLightsNode.push(new AONode(aoNode))}let lightsN=this.lightsNode||builder.lightsNode;return materialLightsNode.length>0&&(lightsN=builder.renderer.lighting.createNode([...lightsN.getLights(),...materialLightsNode])),lightsN}setupLightingModel(){}setupLighting(builder){const{material}=builder,{backdropNode,backdropAlphaNode,emissiveNode}=this,lightsNode=this.lights===!0||this.lightsNode!==null?this.setupLights(builder):null;let outgoingLightNode=this.setupOutgoingLight(builder);if(lightsNode&&lightsNode.getScope().hasLights){const lightingModel=this.setupLightingModel(builder)||null;outgoingLightNode=lightingContext(lightsNode,lightingModel,backdropNode,backdropAlphaNode)}else backdropNode!==null&&(outgoingLightNode=vec3$1(backdropAlphaNode!==null?mix$1(outgoingLightNode,backdropNode,backdropAlphaNode):backdropNode));return(emissiveNode&&emissiveNode.isNode===!0||material.emissive&&material.emissive.isColor===!0)&&(emissive.assign(vec3$1(emissiveNode||materialEmissive)),outgoingLightNode=outgoingLightNode.add(emissive)),outgoingLightNode}setupFog(builder,outputNode){const fogNode=builder.fogNode;return fogNode&&(output.assign(outputNode),outputNode=vec4$1(fogNode)),outputNode}setupOutput(builder,outputNode){return this.fog===!0&&(outputNode=this.setupFog(builder,outputNode)),outputNode}setDefaultValues(material){for(const property2 in material){const value=material[property2];this[property2]===void 0&&(this[property2]=value,value&&value.clone&&(this[property2]=value.clone()))}const descriptors=Object.getOwnPropertyDescriptors(material.constructor.prototype);for(const key2 in descriptors)Object.getOwnPropertyDescriptor(this.constructor.prototype,key2)===void 0&&descriptors[key2].get!==void 0&&Object.defineProperty(this.constructor.prototype,key2,descriptors[key2])}toJSON(meta){const isRoot=meta===void 0||typeof meta=="string";isRoot&&(meta={textures:{},images:{},nodes:{}});const data=Material.prototype.toJSON.call(this,meta),nodeChildren=getNodeChildren(this);data.inputNodes={};for(const{property:property2,childNode}of nodeChildren)data.inputNodes[property2]=childNode.toJSON(meta).uuid;function extractFromCache(cache2){const values=[];for(const key2 in cache2){const data2=cache2[key2];delete data2.metadata,values.push(data2)}return values}if(isRoot){const textures=extractFromCache(meta.textures),images=extractFromCache(meta.images),nodes=extractFromCache(meta.nodes);textures.length>0&&(data.textures=textures),images.length>0&&(data.images=images),nodes.length>0&&(data.nodes=nodes)}return data}copy(source){return this.lightsNode=source.lightsNode,this.envNode=source.envNode,this.colorNode=source.colorNode,this.normalNode=source.normalNode,this.opacityNode=source.opacityNode,this.backdropNode=source.backdropNode,this.backdropAlphaNode=source.backdropAlphaNode,this.alphaTestNode=source.alphaTestNode,this.positionNode=source.positionNode,this.geometryNode=source.geometryNode,this.depthNode=source.depthNode,this.shadowPositionNode=source.shadowPositionNode,this.receivedShadowNode=source.receivedShadowNode,this.castShadowNode=source.castShadowNode,this.outputNode=source.outputNode,this.mrtNode=source.mrtNode,this.fragmentNode=source.fragmentNode,this.vertexNode=source.vertexNode,super.copy(source)}}const _defaultValues$d=new LineBasicMaterial;class LineBasicNodeMaterial extends NodeMaterial{static get type(){return"LineBasicNodeMaterial"}constructor(parameters){super(),this.isLineBasicNodeMaterial=!0,this.setDefaultValues(_defaultValues$d),this.setValues(parameters)}}const _defaultValues$c=new LineDashedMaterial;class LineDashedNodeMaterial extends NodeMaterial{static get type(){return"LineDashedNodeMaterial"}constructor(parameters){super(),this.isLineDashedNodeMaterial=!0,this.setDefaultValues(_defaultValues$c),this.dashOffset=0,this.offsetNode=null,this.dashScaleNode=null,this.dashSizeNode=null,this.gapSizeNode=null,this.setValues(parameters)}setupVariants(){const offsetNode=this.offsetNode?float$1(this.offsetNode):materialLineDashOffset,dashScaleNode=this.dashScaleNode?float$1(this.dashScaleNode):materialLineScale,dashSizeNode=this.dashSizeNode?float$1(this.dashSizeNode):materialLineDashSize,gapSizeNode=this.gapSizeNode?float$1(this.gapSizeNode):materialLineGapSize;dashSize.assign(dashSizeNode),gapSize.assign(gapSizeNode);const vLineDistance=varying(attribute("lineDistance").mul(dashScaleNode));(offsetNode?vLineDistance.add(offsetNode):vLineDistance).mod(dashSize.add(gapSize)).greaterThan(dashSize).discard()}}let _sharedFramebuffer=null;class ViewportSharedTextureNode extends ViewportTextureNode{static get type(){return"ViewportSharedTextureNode"}constructor(uvNode=screenUV,levelNode=null){_sharedFramebuffer===null&&(_sharedFramebuffer=new FramebufferTexture),super(uvNode,levelNode,_sharedFramebuffer)}updateReference(){return this}}const viewportSharedTexture=nodeProxy(ViewportSharedTextureNode),directionToColor=node=>nodeObject$1(node).mul(.5).add(.5),colorToDirection=node=>nodeObject$1(node).mul(2).sub(1),_defaultValues$a=new MeshNormalMaterial;class MeshNormalNodeMaterial extends NodeMaterial{static get type(){return"MeshNormalNodeMaterial"}constructor(parameters){super(),this.isMeshNormalNodeMaterial=!0,this.setDefaultValues(_defaultValues$a),this.setValues(parameters)}setupDiffuseColor(){const opacityNode=this.opacityNode?float$1(this.opacityNode):materialOpacity;diffuseColor.assign(vec4$1(directionToColor(transformedNormalView),opacityNode))}}class EquirectUVNode extends TempNode{static get type(){return"EquirectUVNode"}constructor(dirNode=positionWorldDirection){super("vec2"),this.dirNode=dirNode}setup(){const dir=this.dirNode,u=dir.z.atan(dir.x).mul(1/(Math.PI*2)).add(.5),v=dir.y.clamp(-1,1).asin().mul(1/Math.PI).add(.5);return vec2$1(u,v)}}const equirectUV=nodeProxy(EquirectUVNode);class CubeRenderTarget extends WebGLCubeRenderTarget{constructor(size=1,options={}){super(size,options),this.isCubeRenderTarget=!0}fromEquirectangularTexture(renderer,texture$1$1){const currentMinFilter=texture$1$1.minFilter,currentGenerateMipmaps=texture$1$1.generateMipmaps;texture$1$1.generateMipmaps=!0,this.texture.type=texture$1$1.type,this.texture.colorSpace=texture$1$1.colorSpace,this.texture.generateMipmaps=texture$1$1.generateMipmaps,this.texture.minFilter=texture$1$1.minFilter,this.texture.magFilter=texture$1$1.magFilter;const geometry2=new BoxGeometry(5,5,5),uvNode=equirectUV(positionWorldDirection),material=new NodeMaterial;material.colorNode=texture$1(texture$1$1,uvNode,0),material.side=BackSide,material.blending=NoBlending;const mesh=new Mesh(geometry2,material),scene=new Scene;scene.add(mesh),texture$1$1.minFilter===LinearMipmapLinearFilter&&(texture$1$1.minFilter=LinearFilter);const camera=new CubeCamera(1,10,this),currentMRT=renderer.getMRT();return renderer.setMRT(null),camera.update(renderer,scene),renderer.setMRT(currentMRT),texture$1$1.minFilter=currentMinFilter,texture$1$1.currentGenerateMipmaps=currentGenerateMipmaps,mesh.geometry.dispose(),mesh.material.dispose(),this}}const _cache$1=new WeakMap;class CubeMapNode extends TempNode{static get type(){return"CubeMapNode"}constructor(envNode){super("vec3"),this.envNode=envNode,this._cubeTexture=null,this._cubeTextureNode=cubeTexture();const defaultTexture=new CubeTexture;defaultTexture.isRenderTargetTexture=!0,this._defaultTexture=defaultTexture,this.updateBeforeType=NodeUpdateType.RENDER}updateBefore(frame){const{renderer,material}=frame,envNode=this.envNode;if(envNode.isTextureNode||envNode.isMaterialReferenceNode){const texture2=envNode.isTextureNode?envNode.value:material[envNode.property];if(texture2&&texture2.isTexture){const mapping=texture2.mapping;if(mapping===EquirectangularReflectionMapping||mapping===EquirectangularRefractionMapping){if(_cache$1.has(texture2)){const cubeMap=_cache$1.get(texture2);mapTextureMapping(cubeMap,texture2.mapping),this._cubeTexture=cubeMap}else{const image=texture2.image;if(isEquirectangularMapReady$1(image)){const renderTarget=new CubeRenderTarget(image.height);renderTarget.fromEquirectangularTexture(renderer,texture2),mapTextureMapping(renderTarget.texture,texture2.mapping),this._cubeTexture=renderTarget.texture,_cache$1.set(texture2,renderTarget.texture),texture2.addEventListener("dispose",onTextureDispose)}else this._cubeTexture=this._defaultTexture}this._cubeTextureNode.value=this._cubeTexture}else this._cubeTextureNode=this.envNode}}}setup(builder){return this.updateBefore(builder),this._cubeTextureNode}}function isEquirectangularMapReady$1(image){return image==null?!1:image.height>0}function onTextureDispose(event){const texture2=event.target;texture2.removeEventListener("dispose",onTextureDispose);const renderTarget=_cache$1.get(texture2);renderTarget!==void 0&&(_cache$1.delete(texture2),renderTarget.dispose())}function mapTextureMapping(texture2,mapping){mapping===EquirectangularReflectionMapping?texture2.mapping=CubeReflectionMapping:mapping===EquirectangularRefractionMapping&&(texture2.mapping=CubeRefractionMapping)}const cubeMapNode=nodeProxy(CubeMapNode);class BasicEnvironmentNode extends LightingNode{static get type(){return"BasicEnvironmentNode"}constructor(envNode=null){super(),this.envNode=envNode}setup(builder){builder.context.environment=cubeMapNode(this.envNode)}}class BasicLightMapNode extends LightingNode{static get type(){return"BasicLightMapNode"}constructor(lightMapNode=null){super(),this.lightMapNode=lightMapNode}setup(builder){const RECIPROCAL_PI2=float$1(1/Math.PI);builder.context.irradianceLightMap=this.lightMapNode.mul(RECIPROCAL_PI2)}}class LightingModel{start(builder){builder.lightsNode.setupLights(builder,builder.lightsNode.getLightNodes(builder)),this.indirect(builder)}finish(){}direct(){}directRectArea(){}indirect(){}ambientOcclusion(){}}class BasicLightingModel extends LightingModel{constructor(){super()}indirect({context:context2}){const ambientOcclusion=context2.ambientOcclusion,reflectedLight=context2.reflectedLight,irradianceLightMap=context2.irradianceLightMap;reflectedLight.indirectDiffuse.assign(vec4$1(0)),irradianceLightMap?reflectedLight.indirectDiffuse.addAssign(irradianceLightMap):reflectedLight.indirectDiffuse.addAssign(vec4$1(1,1,1,0)),reflectedLight.indirectDiffuse.mulAssign(ambientOcclusion),reflectedLight.indirectDiffuse.mulAssign(diffuseColor.rgb)}finish(builder){const{material,context:context2}=builder,outgoingLight=context2.outgoingLight,envNode=builder.context.environment;if(envNode)switch(material.combine){case MultiplyOperation:outgoingLight.rgb.assign(mix$1(outgoingLight.rgb,outgoingLight.rgb.mul(envNode.rgb),materialSpecularStrength.mul(materialReflectivity)));break;case MixOperation:outgoingLight.rgb.assign(mix$1(outgoingLight.rgb,envNode.rgb,materialSpecularStrength.mul(materialReflectivity)));break;case AddOperation:outgoingLight.rgb.addAssign(envNode.rgb.mul(materialSpecularStrength.mul(materialReflectivity)));break;default:console.warn("THREE.BasicLightingModel: Unsupported .combine value:",material.combine);break}}}const _defaultValues$9=new MeshBasicMaterial;class MeshBasicNodeMaterial extends NodeMaterial{static get type(){return"MeshBasicNodeMaterial"}constructor(parameters){super(),this.isMeshBasicNodeMaterial=!0,this.lights=!0,this.setDefaultValues(_defaultValues$9),this.setValues(parameters)}setupNormal(){return normalView}setupEnvironment(builder){const envNode=super.setupEnvironment(builder);return envNode?new BasicEnvironmentNode(envNode):null}setupLightMap(builder){let node=null;return builder.material.lightMap&&(node=new BasicLightMapNode(materialLightMap)),node}setupOutgoingLight(){return diffuseColor.rgb}setupLightingModel(){return new BasicLightingModel}}const F_Schlick=Fn$1(({f0,f90,dotVH})=>{const fresnel=dotVH.mul(-5.55473).sub(6.98316).mul(dotVH).exp2();return f0.mul(fresnel.oneMinus()).add(f90.mul(fresnel))}),BRDF_Lambert=Fn$1(inputs=>inputs.diffuseColor.mul(1/Math.PI)),G_BlinnPhong_Implicit=()=>float$1(.25),D_BlinnPhong=Fn$1(({dotNH})=>shininess.mul(float$1(.5)).add(1).mul(float$1(1/Math.PI)).mul(dotNH.pow(shininess))),BRDF_BlinnPhong=Fn$1(({lightDirection})=>{const halfDir=lightDirection.add(positionViewDirection).normalize(),dotNH=transformedNormalView.dot(halfDir).clamp(),dotVH=positionViewDirection.dot(halfDir).clamp(),F=F_Schlick({f0:specularColor,f90:1,dotVH}),G=G_BlinnPhong_Implicit(),D=D_BlinnPhong({dotNH});return F.mul(G).mul(D)});class PhongLightingModel extends BasicLightingModel{constructor(specular=!0){super(),this.specular=specular}direct({lightDirection,lightColor,reflectedLight}){const irradiance=transformedNormalView.dot(lightDirection).clamp().mul(lightColor);reflectedLight.directDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor:diffuseColor.rgb}))),this.specular===!0&&reflectedLight.directSpecular.addAssign(irradiance.mul(BRDF_BlinnPhong({lightDirection})).mul(materialSpecularStrength))}indirect(builder){const{ambientOcclusion,irradiance,reflectedLight}=builder.context;reflectedLight.indirectDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor}))),reflectedLight.indirectDiffuse.mulAssign(ambientOcclusion)}}const _defaultValues$8=new MeshLambertMaterial;class MeshLambertNodeMaterial extends NodeMaterial{static get type(){return"MeshLambertNodeMaterial"}constructor(parameters){super(),this.isMeshLambertNodeMaterial=!0,this.lights=!0,this.setDefaultValues(_defaultValues$8),this.setValues(parameters)}setupEnvironment(builder){const envNode=super.setupEnvironment(builder);return envNode?new BasicEnvironmentNode(envNode):null}setupLightingModel(){return new PhongLightingModel(!1)}}const _defaultValues$7=new MeshPhongMaterial;class MeshPhongNodeMaterial extends NodeMaterial{static get type(){return"MeshPhongNodeMaterial"}constructor(parameters){super(),this.isMeshPhongNodeMaterial=!0,this.lights=!0,this.shininessNode=null,this.specularNode=null,this.setDefaultValues(_defaultValues$7),this.setValues(parameters)}setupEnvironment(builder){const envNode=super.setupEnvironment(builder);return envNode?new BasicEnvironmentNode(envNode):null}setupLightingModel(){return new PhongLightingModel}setupVariants(){const shininessNode=(this.shininessNode?float$1(this.shininessNode):materialShininess).max(1e-4);shininess.assign(shininessNode);const specularNode=this.specularNode||materialSpecular;specularColor.assign(specularNode)}copy(source){return this.shininessNode=source.shininessNode,this.specularNode=source.specularNode,super.copy(source)}}const getGeometryRoughness=Fn$1(builder=>{if(builder.geometry.hasAttribute("normal")===!1)return float$1(0);const dxy=normalView.dFdx().abs().max(normalView.dFdy().abs());return dxy.x.max(dxy.y).max(dxy.z)}),getRoughness=Fn$1(inputs=>{const{roughness:roughness2}=inputs,geometryRoughness=getGeometryRoughness();let roughnessFactor=roughness2.max(.0525);return roughnessFactor=roughnessFactor.add(geometryRoughness),roughnessFactor=roughnessFactor.min(1),roughnessFactor}),V_GGX_SmithCorrelated=Fn$1(({alpha,dotNL,dotNV})=>{const a2=alpha.pow2(),gv=dotNL.mul(a2.add(a2.oneMinus().mul(dotNV.pow2())).sqrt()),gl=dotNV.mul(a2.add(a2.oneMinus().mul(dotNL.pow2())).sqrt());return div(.5,gv.add(gl).max(EPSILON))}).setLayout({name:"V_GGX_SmithCorrelated",type:"float",inputs:[{name:"alpha",type:"float"},{name:"dotNL",type:"float"},{name:"dotNV",type:"float"}]}),V_GGX_SmithCorrelated_Anisotropic=Fn$1(({alphaT:alphaT2,alphaB,dotTV,dotBV,dotTL,dotBL,dotNV,dotNL})=>{const gv=dotNL.mul(vec3$1(alphaT2.mul(dotTV),alphaB.mul(dotBV),dotNV).length()),gl=dotNV.mul(vec3$1(alphaT2.mul(dotTL),alphaB.mul(dotBL),dotNL).length());return div(.5,gv.add(gl)).saturate()}).setLayout({name:"V_GGX_SmithCorrelated_Anisotropic",type:"float",inputs:[{name:"alphaT",type:"float",qualifier:"in"},{name:"alphaB",type:"float",qualifier:"in"},{name:"dotTV",type:"float",qualifier:"in"},{name:"dotBV",type:"float",qualifier:"in"},{name:"dotTL",type:"float",qualifier:"in"},{name:"dotBL",type:"float",qualifier:"in"},{name:"dotNV",type:"float",qualifier:"in"},{name:"dotNL",type:"float",qualifier:"in"}]}),D_GGX=Fn$1(({alpha,dotNH})=>{const a2=alpha.pow2(),denom=dotNH.pow2().mul(a2.oneMinus()).oneMinus();return a2.div(denom.pow2()).mul(1/Math.PI)}).setLayout({name:"D_GGX",type:"float",inputs:[{name:"alpha",type:"float"},{name:"dotNH",type:"float"}]}),RECIPROCAL_PI=float$1(1/Math.PI),D_GGX_Anisotropic=Fn$1(({alphaT:alphaT2,alphaB,dotNH,dotTH,dotBH})=>{const a2=alphaT2.mul(alphaB),v=vec3$1(alphaB.mul(dotTH),alphaT2.mul(dotBH),a2.mul(dotNH)),v2=v.dot(v),w22=a2.div(v2);return RECIPROCAL_PI.mul(a2.mul(w22.pow2()))}).setLayout({name:"D_GGX_Anisotropic",type:"float",inputs:[{name:"alphaT",type:"float",qualifier:"in"},{name:"alphaB",type:"float",qualifier:"in"},{name:"dotNH",type:"float",qualifier:"in"},{name:"dotTH",type:"float",qualifier:"in"},{name:"dotBH",type:"float",qualifier:"in"}]}),BRDF_GGX=Fn$1(inputs=>{const{lightDirection,f0,f90,roughness:roughness2,f:f2,USE_IRIDESCENCE,USE_ANISOTROPY}=inputs,normalView2=inputs.normalView||transformedNormalView,alpha=roughness2.pow2(),halfDir=lightDirection.add(positionViewDirection).normalize(),dotNL=normalView2.dot(lightDirection).clamp(),dotNV=normalView2.dot(positionViewDirection).clamp(),dotNH=normalView2.dot(halfDir).clamp(),dotVH=positionViewDirection.dot(halfDir).clamp();let F=F_Schlick({f0,f90,dotVH}),V,D;if(defined(USE_IRIDESCENCE)&&(F=iridescence.mix(F,f2)),defined(USE_ANISOTROPY)){const dotTL=anisotropyT.dot(lightDirection),dotTV=anisotropyT.dot(positionViewDirection),dotTH=anisotropyT.dot(halfDir),dotBL=anisotropyB.dot(lightDirection),dotBV=anisotropyB.dot(positionViewDirection),dotBH=anisotropyB.dot(halfDir);V=V_GGX_SmithCorrelated_Anisotropic({alphaT,alphaB:alpha,dotTV,dotBV,dotTL,dotBL,dotNV,dotNL}),D=D_GGX_Anisotropic({alphaT,alphaB:alpha,dotNH,dotTH,dotBH})}else V=V_GGX_SmithCorrelated({alpha,dotNL,dotNV}),D=D_GGX({alpha,dotNH});return F.mul(V).mul(D)}),DFGApprox=Fn$1(({roughness:roughness2,dotNV})=>{const c0=vec4$1(-1,-.0275,-.572,.022),c1=vec4$1(1,.0425,1.04,-.04),r2=roughness2.mul(c0).add(c1),a004=r2.x.mul(r2.x).min(dotNV.mul(-9.28).exp2()).mul(r2.x).add(r2.y);return vec2$1(-1.04,1.04).mul(a004).add(r2.zw)}).setLayout({name:"DFGApprox",type:"vec2",inputs:[{name:"roughness",type:"float"},{name:"dotNV",type:"vec3"}]}),EnvironmentBRDF=Fn$1(inputs=>{const{dotNV,specularColor:specularColor2,specularF90:specularF902,roughness:roughness2}=inputs,fab=DFGApprox({dotNV,roughness:roughness2});return specularColor2.mul(fab.x).add(specularF902.mul(fab.y))}),Schlick_to_F0=Fn$1(({f:f2,f90,dotVH})=>{const x=dotVH.oneMinus().saturate(),x2=x.mul(x),x5=x.mul(x2,x2).clamp(0,.9999);return f2.sub(vec3$1(f90).mul(x5)).div(x5.oneMinus())}).setLayout({name:"Schlick_to_F0",type:"vec3",inputs:[{name:"f",type:"vec3"},{name:"f90",type:"float"},{name:"dotVH",type:"float"}]}),D_Charlie=Fn$1(({roughness:roughness2,dotNH})=>{const alpha=roughness2.pow2(),invAlpha=float$1(1).div(alpha),sin2h=dotNH.pow2().oneMinus().max(.0078125);return float$1(2).add(invAlpha).mul(sin2h.pow(invAlpha.mul(.5))).div(2*Math.PI)}).setLayout({name:"D_Charlie",type:"float",inputs:[{name:"roughness",type:"float"},{name:"dotNH",type:"float"}]}),V_Neubelt=Fn$1(({dotNV,dotNL})=>float$1(1).div(float$1(4).mul(dotNL.add(dotNV).sub(dotNL.mul(dotNV))))).setLayout({name:"V_Neubelt",type:"float",inputs:[{name:"dotNV",type:"float"},{name:"dotNL",type:"float"}]}),BRDF_Sheen=Fn$1(({lightDirection})=>{const halfDir=lightDirection.add(positionViewDirection).normalize(),dotNL=transformedNormalView.dot(lightDirection).clamp(),dotNV=transformedNormalView.dot(positionViewDirection).clamp(),dotNH=transformedNormalView.dot(halfDir).clamp(),D=D_Charlie({roughness:sheenRoughness,dotNH}),V=V_Neubelt({dotNV,dotNL});return sheen.mul(D).mul(V)}),LTC_Uv=Fn$1(({N,V,roughness:roughness2})=>{const LUT_BIAS=.0078125,dotNV=N.dot(V).saturate(),uv2=vec2$1(roughness2,dotNV.oneMinus().sqrt());return uv2.assign(uv2.mul(.984375).add(LUT_BIAS)),uv2}).setLayout({name:"LTC_Uv",type:"vec2",inputs:[{name:"N",type:"vec3"},{name:"V",type:"vec3"},{name:"roughness",type:"float"}]}),LTC_ClippedSphereFormFactor=Fn$1(({f:f2})=>{const l2=f2.length();return max$1(l2.mul(l2).add(f2.z).div(l2.add(1)),0)}).setLayout({name:"LTC_ClippedSphereFormFactor",type:"float",inputs:[{name:"f",type:"vec3"}]}),LTC_EdgeVectorFormFactor=Fn$1(({v1,v2})=>{const x=v1.dot(v2),y=x.abs().toVar(),a2=y.mul(.0145206).add(.4965155).mul(y).add(.8543985).toVar(),b=y.add(4.1616724).mul(y).add(3.417594).toVar(),v=a2.div(b),theta_sintheta=x.greaterThan(0).select(v,max$1(x.mul(x).oneMinus(),1e-7).inverseSqrt().mul(.5).sub(v));return v1.cross(v2).mul(theta_sintheta)}).setLayout({name:"LTC_EdgeVectorFormFactor",type:"vec3",inputs:[{name:"v1",type:"vec3"},{name:"v2",type:"vec3"}]}),LTC_Evaluate=Fn$1(({N,V,P,mInv,p0,p1,p2,p3})=>{const v1=p1.sub(p0).toVar(),v2=p3.sub(p0).toVar(),lightNormal=v1.cross(v2),result=vec3$1().toVar();return If$1(lightNormal.dot(P.sub(p0)).greaterThanEqual(0),()=>{const T1=V.sub(N.mul(V.dot(N))).normalize(),T2=N.cross(T1).negate(),mat=mInv.mul(mat3(T1,T2,N).transpose()).toVar(),coords0=mat.mul(p0.sub(P)).normalize().toVar(),coords1=mat.mul(p1.sub(P)).normalize().toVar(),coords2=mat.mul(p2.sub(P)).normalize().toVar(),coords3=mat.mul(p3.sub(P)).normalize().toVar(),vectorFormFactor=vec3$1(0).toVar();vectorFormFactor.addAssign(LTC_EdgeVectorFormFactor({v1:coords0,v2:coords1})),vectorFormFactor.addAssign(LTC_EdgeVectorFormFactor({v1:coords1,v2:coords2})),vectorFormFactor.addAssign(LTC_EdgeVectorFormFactor({v1:coords2,v2:coords3})),vectorFormFactor.addAssign(LTC_EdgeVectorFormFactor({v1:coords3,v2:coords0})),result.assign(vec3$1(LTC_ClippedSphereFormFactor({f:vectorFormFactor})))}),result}).setLayout({name:"LTC_Evaluate",type:"vec3",inputs:[{name:"N",type:"vec3"},{name:"V",type:"vec3"},{name:"P",type:"vec3"},{name:"mInv",type:"mat3"},{name:"p0",type:"vec3"},{name:"p1",type:"vec3"},{name:"p2",type:"vec3"},{name:"p3",type:"vec3"}]}),bC=1/6,w0=a2=>mul$1(bC,mul$1(a2,mul$1(a2,a2.negate().add(3)).sub(3)).add(1)),w1=a2=>mul$1(bC,mul$1(a2,mul$1(a2,mul$1(3,a2).sub(6))).add(4)),w2=a2=>mul$1(bC,mul$1(a2,mul$1(a2,mul$1(-3,a2).add(3)).add(3)).add(1)),w3=a2=>mul$1(bC,pow$1(a2,3)),g0=a2=>w0(a2).add(w1(a2)),g1=a2=>w2(a2).add(w3(a2)),h0=a2=>add$3(-1,w1(a2).div(w0(a2).add(w1(a2)))),h1=a2=>add$3(1,w3(a2).div(w2(a2).add(w3(a2)))),bicubic=(textureNode,texelSize,lod)=>{const uv2=textureNode.uvNode,uvScaled=mul$1(uv2,texelSize.zw).add(.5),iuv=floor$3(uvScaled),fuv=fract(uvScaled),g0x=g0(fuv.x),g1x=g1(fuv.x),h0x=h0(fuv.x),h1x=h1(fuv.x),h0y=h0(fuv.y),h1y=h1(fuv.y),p0=vec2$1(iuv.x.add(h0x),iuv.y.add(h0y)).sub(.5).mul(texelSize.xy),p1=vec2$1(iuv.x.add(h1x),iuv.y.add(h0y)).sub(.5).mul(texelSize.xy),p2=vec2$1(iuv.x.add(h0x),iuv.y.add(h1y)).sub(.5).mul(texelSize.xy),p3=vec2$1(iuv.x.add(h1x),iuv.y.add(h1y)).sub(.5).mul(texelSize.xy),a2=g0(fuv.y).mul(add$3(g0x.mul(textureNode.sample(p0).level(lod)),g1x.mul(textureNode.sample(p1).level(lod)))),b=g1(fuv.y).mul(add$3(g0x.mul(textureNode.sample(p2).level(lod)),g1x.mul(textureNode.sample(p3).level(lod))));return a2.add(b)},textureBicubic=Fn$1(([textureNode,lodNode=float$1(3)])=>{const fLodSize=vec2$1(textureNode.size(int(lodNode))),cLodSize=vec2$1(textureNode.size(int(lodNode.add(1)))),fLodSizeInv=div(1,fLodSize),cLodSizeInv=div(1,cLodSize),fSample=bicubic(textureNode,vec4$1(fLodSizeInv,fLodSize),floor$3(lodNode)),cSample=bicubic(textureNode,vec4$1(cLodSizeInv,cLodSize),ceil$2(lodNode));return fract(lodNode).mix(fSample,cSample)}),getVolumeTransmissionRay=Fn$1(([n2,v,thickness2,ior2,modelMatrix])=>{const refractionVector=vec3$1(refract(v.negate(),normalize$1(n2),div(1,ior2))),modelScale2=vec3$1(length$1(modelMatrix[0].xyz),length$1(modelMatrix[1].xyz),length$1(modelMatrix[2].xyz));return normalize$1(refractionVector).mul(thickness2.mul(modelScale2))}).setLayout({name:"getVolumeTransmissionRay",type:"vec3",inputs:[{name:"n",type:"vec3"},{name:"v",type:"vec3"},{name:"thickness",type:"float"},{name:"ior",type:"float"},{name:"modelMatrix",type:"mat4"}]}),applyIorToRoughness=Fn$1(([roughness2,ior2])=>roughness2.mul(clamp$3(ior2.mul(2).sub(2),0,1))).setLayout({name:"applyIorToRoughness",type:"float",inputs:[{name:"roughness",type:"float"},{name:"ior",type:"float"}]}),viewportBackSideTexture=viewportMipTexture(),viewportFrontSideTexture=viewportMipTexture(),getTransmissionSample=Fn$1(([fragCoord,roughness2,ior2],{material})=>{const transmissionSample=(material.side===BackSide?viewportBackSideTexture:viewportFrontSideTexture).sample(fragCoord),lod=log2(screenSize.x).mul(applyIorToRoughness(roughness2,ior2));return textureBicubic(transmissionSample,lod)}),volumeAttenuation=Fn$1(([transmissionDistance,attenuationColor2,attenuationDistance2])=>(If$1(attenuationDistance2.notEqual(0),()=>{const attenuationCoefficient=log(attenuationColor2).negate().div(attenuationDistance2);return exp(attenuationCoefficient.negate().mul(transmissionDistance))}),vec3$1(1))).setLayout({name:"volumeAttenuation",type:"vec3",inputs:[{name:"transmissionDistance",type:"float"},{name:"attenuationColor",type:"vec3"},{name:"attenuationDistance",type:"float"}]}),getIBLVolumeRefraction=Fn$1(([n2,v,roughness2,diffuseColor2,specularColor2,specularF902,position,modelMatrix,viewMatrix,projMatrix,ior2,thickness2,attenuationColor2,attenuationDistance2,dispersion2])=>{let transmittedLight,transmittance;if(dispersion2){transmittedLight=vec4$1().toVar(),transmittance=vec3$1().toVar();const halfSpread=ior2.sub(1).mul(dispersion2.mul(.025)),iors=vec3$1(ior2.sub(halfSpread),ior2,ior2.add(halfSpread));Loop({start:0,end:3},({i:i2})=>{const ior3=iors.element(i2),transmissionRay=getVolumeTransmissionRay(n2,v,thickness2,ior3,modelMatrix),refractedRayExit=position.add(transmissionRay),ndcPos=projMatrix.mul(viewMatrix.mul(vec4$1(refractedRayExit,1))),refractionCoords=vec2$1(ndcPos.xy.div(ndcPos.w)).toVar();refractionCoords.addAssign(1),refractionCoords.divAssign(2),refractionCoords.assign(vec2$1(refractionCoords.x,refractionCoords.y.oneMinus()));const transmissionSample=getTransmissionSample(refractionCoords,roughness2,ior3);transmittedLight.element(i2).assign(transmissionSample.element(i2)),transmittedLight.a.addAssign(transmissionSample.a),transmittance.element(i2).assign(diffuseColor2.element(i2).mul(volumeAttenuation(length$1(transmissionRay),attenuationColor2,attenuationDistance2).element(i2)))}),transmittedLight.a.divAssign(3)}else{const transmissionRay=getVolumeTransmissionRay(n2,v,thickness2,ior2,modelMatrix),refractedRayExit=position.add(transmissionRay),ndcPos=projMatrix.mul(viewMatrix.mul(vec4$1(refractedRayExit,1))),refractionCoords=vec2$1(ndcPos.xy.div(ndcPos.w)).toVar();refractionCoords.addAssign(1),refractionCoords.divAssign(2),refractionCoords.assign(vec2$1(refractionCoords.x,refractionCoords.y.oneMinus())),transmittedLight=getTransmissionSample(refractionCoords,roughness2,ior2),transmittance=diffuseColor2.mul(volumeAttenuation(length$1(transmissionRay),attenuationColor2,attenuationDistance2))}const attenuatedColor=transmittance.rgb.mul(transmittedLight.rgb),dotNV=n2.dot(v).clamp(),F=vec3$1(EnvironmentBRDF({dotNV,specularColor:specularColor2,specularF90:specularF902,roughness:roughness2})),transmittanceFactor=transmittance.r.add(transmittance.g,transmittance.b).div(3);return vec4$1(F.oneMinus().mul(attenuatedColor),transmittedLight.a.oneMinus().mul(transmittanceFactor).oneMinus())}),XYZ_TO_REC709=mat3(3.2404542,-.969266,.0556434,-1.5371385,1.8760108,-.2040259,-.4985314,.041556,1.0572252),Fresnel0ToIor=fresnel0=>{const sqrtF0=fresnel0.sqrt();return vec3$1(1).add(sqrtF0).div(vec3$1(1).sub(sqrtF0))},IorToFresnel0=(transmittedIor,incidentIor)=>transmittedIor.sub(incidentIor).div(transmittedIor.add(incidentIor)).pow2(),evalSensitivity=(OPD,shift)=>{const phase=OPD.mul(2*Math.PI*1e-9),val=vec3$1(54856e-17,44201e-17,52481e-17),pos=vec3$1(1681e3,1795300,2208400),VAR=vec3$1(43278e5,93046e5,66121e5),x=float$1(9747e-17*Math.sqrt(2*Math.PI*45282e5)).mul(phase.mul(2239900).add(shift.x).cos()).mul(phase.pow2().mul(-45282e5).exp());let xyz2=val.mul(VAR.mul(2*Math.PI).sqrt()).mul(pos.mul(phase).add(shift).cos()).mul(phase.pow2().negate().mul(VAR).exp());return xyz2=vec3$1(xyz2.x.add(x),xyz2.y,xyz2.z).div(10685e-11),XYZ_TO_REC709.mul(xyz2)},evalIridescence=Fn$1(({outsideIOR,eta2,cosTheta1,thinFilmThickness,baseF0})=>{const iridescenceIOR2=mix$1(outsideIOR,eta2,smoothstep$1(0,.03,thinFilmThickness)),cosTheta2Sq=outsideIOR.div(iridescenceIOR2).pow2().mul(cosTheta1.pow2().oneMinus()).oneMinus();If$1(cosTheta2Sq.lessThan(0),()=>vec3$1(1));const cosTheta2=cosTheta2Sq.sqrt(),R0=IorToFresnel0(iridescenceIOR2,outsideIOR),R12=F_Schlick({f0:R0,f90:1,dotVH:cosTheta1}),T121=R12.oneMinus(),phi12=iridescenceIOR2.lessThan(outsideIOR).select(Math.PI,0),phi21=float$1(Math.PI).sub(phi12),baseIOR=Fresnel0ToIor(baseF0.clamp(0,.9999)),R1=IorToFresnel0(baseIOR,iridescenceIOR2.toVec3()),R23=F_Schlick({f0:R1,f90:1,dotVH:cosTheta2}),phi23=vec3$1(baseIOR.x.lessThan(iridescenceIOR2).select(Math.PI,0),baseIOR.y.lessThan(iridescenceIOR2).select(Math.PI,0),baseIOR.z.lessThan(iridescenceIOR2).select(Math.PI,0)),OPD=iridescenceIOR2.mul(thinFilmThickness,cosTheta2,2),phi=vec3$1(phi21).add(phi23),R123=R12.mul(R23).clamp(1e-5,.9999),r123=R123.sqrt(),Rs=T121.pow2().mul(R23).div(vec3$1(1).sub(R123)),I=R12.add(Rs).toVar(),Cm=Rs.sub(T121).toVar();return Loop({start:1,end:2,condition:"<=",name:"m"},({m})=>{Cm.mulAssign(r123);const Sm=evalSensitivity(float$1(m).mul(OPD),float$1(m).mul(phi)).mul(2);I.addAssign(Cm.mul(Sm))}),I.max(vec3$1(0))}).setLayout({name:"evalIridescence",type:"vec3",inputs:[{name:"outsideIOR",type:"float"},{name:"eta2",type:"float"},{name:"cosTheta1",type:"float"},{name:"thinFilmThickness",type:"float"},{name:"baseF0",type:"vec3"}]}),IBLSheenBRDF=Fn$1(({normal:normal2,viewDir,roughness:roughness2})=>{const dotNV=normal2.dot(viewDir).saturate(),r2=roughness2.pow2(),a2=select(roughness2.lessThan(.25),float$1(-339.2).mul(r2).add(float$1(161.4).mul(roughness2)).sub(25.9),float$1(-8.48).mul(r2).add(float$1(14.3).mul(roughness2)).sub(9.95)),b=select(roughness2.lessThan(.25),float$1(44).mul(r2).sub(float$1(23.7).mul(roughness2)).add(3.26),float$1(1.97).mul(r2).sub(float$1(3.27).mul(roughness2)).add(.72));return select(roughness2.lessThan(.25),0,float$1(.1).mul(roughness2).sub(.025)).add(a2.mul(dotNV).add(b).exp()).mul(1/Math.PI).saturate()}),clearcoatF0=vec3$1(.04),clearcoatF90=float$1(1);class PhysicalLightingModel extends LightingModel{constructor(clearcoat2=!1,sheen2=!1,iridescence2=!1,anisotropy2=!1,transmission2=!1,dispersion2=!1){super(),this.clearcoat=clearcoat2,this.sheen=sheen2,this.iridescence=iridescence2,this.anisotropy=anisotropy2,this.transmission=transmission2,this.dispersion=dispersion2,this.clearcoatRadiance=null,this.clearcoatSpecularDirect=null,this.clearcoatSpecularIndirect=null,this.sheenSpecularDirect=null,this.sheenSpecularIndirect=null,this.iridescenceFresnel=null,this.iridescenceF0=null}start(builder){if(this.clearcoat===!0&&(this.clearcoatRadiance=vec3$1().toVar("clearcoatRadiance"),this.clearcoatSpecularDirect=vec3$1().toVar("clearcoatSpecularDirect"),this.clearcoatSpecularIndirect=vec3$1().toVar("clearcoatSpecularIndirect")),this.sheen===!0&&(this.sheenSpecularDirect=vec3$1().toVar("sheenSpecularDirect"),this.sheenSpecularIndirect=vec3$1().toVar("sheenSpecularIndirect")),this.iridescence===!0){const dotNVi=transformedNormalView.dot(positionViewDirection).clamp();this.iridescenceFresnel=evalIridescence({outsideIOR:float$1(1),eta2:iridescenceIOR,cosTheta1:dotNVi,thinFilmThickness:iridescenceThickness,baseF0:specularColor}),this.iridescenceF0=Schlick_to_F0({f:this.iridescenceFresnel,f90:1,dotVH:dotNVi})}if(this.transmission===!0){const position=positionWorld,v=cameraPosition.sub(positionWorld).normalize(),n2=transformedNormalWorld,context2=builder.context;context2.backdrop=getIBLVolumeRefraction(n2,v,roughness,diffuseColor,specularColor,specularF90,position,modelWorldMatrix,cameraViewMatrix,cameraProjectionMatrix,ior,thickness,attenuationColor,attenuationDistance,this.dispersion?dispersion:null),context2.backdropAlpha=transmission,diffuseColor.a.mulAssign(mix$1(1,context2.backdrop.a,transmission))}super.start(builder)}computeMultiscattering(singleScatter,multiScatter,specularF902){const dotNV=transformedNormalView.dot(positionViewDirection).clamp(),fab=DFGApprox({roughness,dotNV}),FssEss=(this.iridescenceF0?iridescence.mix(specularColor,this.iridescenceF0):specularColor).mul(fab.x).add(specularF902.mul(fab.y)),Ems=fab.x.add(fab.y).oneMinus(),Favg=specularColor.add(specularColor.oneMinus().mul(.047619)),Fms=FssEss.mul(Favg).div(Ems.mul(Favg).oneMinus());singleScatter.addAssign(FssEss),multiScatter.addAssign(Fms.mul(Ems))}direct({lightDirection,lightColor,reflectedLight}){const irradiance=transformedNormalView.dot(lightDirection).clamp().mul(lightColor);if(this.sheen===!0&&this.sheenSpecularDirect.addAssign(irradiance.mul(BRDF_Sheen({lightDirection}))),this.clearcoat===!0){const ccIrradiance=transformedClearcoatNormalView.dot(lightDirection).clamp().mul(lightColor);this.clearcoatSpecularDirect.addAssign(ccIrradiance.mul(BRDF_GGX({lightDirection,f0:clearcoatF0,f90:clearcoatF90,roughness:clearcoatRoughness,normalView:transformedClearcoatNormalView})))}reflectedLight.directDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor:diffuseColor.rgb}))),reflectedLight.directSpecular.addAssign(irradiance.mul(BRDF_GGX({lightDirection,f0:specularColor,f90:1,roughness,iridescence:this.iridescence,f:this.iridescenceFresnel,USE_IRIDESCENCE:this.iridescence,USE_ANISOTROPY:this.anisotropy})))}directRectArea({lightColor,lightPosition:lightPosition2,halfWidth,halfHeight,reflectedLight,ltc_1,ltc_2}){const p0=lightPosition2.add(halfWidth).sub(halfHeight),p1=lightPosition2.sub(halfWidth).sub(halfHeight),p2=lightPosition2.sub(halfWidth).add(halfHeight),p3=lightPosition2.add(halfWidth).add(halfHeight),N=transformedNormalView,V=positionViewDirection,P=positionView.toVar(),uv2=LTC_Uv({N,V,roughness}),t1=ltc_1.sample(uv2).toVar(),t2=ltc_2.sample(uv2).toVar(),mInv=mat3(vec3$1(t1.x,0,t1.y),vec3$1(0,1,0),vec3$1(t1.z,0,t1.w)).toVar(),fresnel=specularColor.mul(t2.x).add(specularColor.oneMinus().mul(t2.y)).toVar();reflectedLight.directSpecular.addAssign(lightColor.mul(fresnel).mul(LTC_Evaluate({N,V,P,mInv,p0,p1,p2,p3}))),reflectedLight.directDiffuse.addAssign(lightColor.mul(diffuseColor).mul(LTC_Evaluate({N,V,P,mInv:mat3(1,0,0,0,1,0,0,0,1),p0,p1,p2,p3})))}indirect(builder){this.indirectDiffuse(builder),this.indirectSpecular(builder),this.ambientOcclusion(builder)}indirectDiffuse(builder){const{irradiance,reflectedLight}=builder.context;reflectedLight.indirectDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor})))}indirectSpecular(builder){const{radiance,iblIrradiance,reflectedLight}=builder.context;if(this.sheen===!0&&this.sheenSpecularIndirect.addAssign(iblIrradiance.mul(sheen,IBLSheenBRDF({normal:transformedNormalView,viewDir:positionViewDirection,roughness:sheenRoughness}))),this.clearcoat===!0){const dotNVcc=transformedClearcoatNormalView.dot(positionViewDirection).clamp(),clearcoatEnv=EnvironmentBRDF({dotNV:dotNVcc,specularColor:clearcoatF0,specularF90:clearcoatF90,roughness:clearcoatRoughness});this.clearcoatSpecularIndirect.addAssign(this.clearcoatRadiance.mul(clearcoatEnv))}const singleScattering=vec3$1().toVar("singleScattering"),multiScattering=vec3$1().toVar("multiScattering"),cosineWeightedIrradiance=iblIrradiance.mul(1/Math.PI);this.computeMultiscattering(singleScattering,multiScattering,specularF90);const totalScattering=singleScattering.add(multiScattering),diffuse=diffuseColor.mul(totalScattering.r.max(totalScattering.g).max(totalScattering.b).oneMinus());reflectedLight.indirectSpecular.addAssign(radiance.mul(singleScattering)),reflectedLight.indirectSpecular.addAssign(multiScattering.mul(cosineWeightedIrradiance)),reflectedLight.indirectDiffuse.addAssign(diffuse.mul(cosineWeightedIrradiance))}ambientOcclusion(builder){const{ambientOcclusion,reflectedLight}=builder.context,aoNV=transformedNormalView.dot(positionViewDirection).clamp().add(ambientOcclusion),aoExp=roughness.mul(-16).oneMinus().negate().exp2(),aoNode=ambientOcclusion.sub(aoNV.pow(aoExp).oneMinus()).clamp();this.clearcoat===!0&&this.clearcoatSpecularIndirect.mulAssign(ambientOcclusion),this.sheen===!0&&this.sheenSpecularIndirect.mulAssign(ambientOcclusion),reflectedLight.indirectDiffuse.mulAssign(ambientOcclusion),reflectedLight.indirectSpecular.mulAssign(aoNode)}finish({context:context2}){const{outgoingLight}=context2;if(this.clearcoat===!0){const dotNVcc=transformedClearcoatNormalView.dot(positionViewDirection).clamp(),Fcc=F_Schlick({dotVH:dotNVcc,f0:clearcoatF0,f90:clearcoatF90}),clearcoatLight=outgoingLight.mul(clearcoat.mul(Fcc).oneMinus()).add(this.clearcoatSpecularDirect.add(this.clearcoatSpecularIndirect).mul(clearcoat));outgoingLight.assign(clearcoatLight)}if(this.sheen===!0){const sheenEnergyComp=sheen.r.max(sheen.g).max(sheen.b).mul(.157).oneMinus(),sheenLight=outgoingLight.mul(sheenEnergyComp).add(this.sheenSpecularDirect,this.sheenSpecularIndirect);outgoingLight.assign(sheenLight)}}}const cubeUV_r0=float$1(1),cubeUV_m0=float$1(-2),cubeUV_r1=float$1(.8),cubeUV_m1=float$1(-1),cubeUV_r4=float$1(.4),cubeUV_m4=float$1(2),cubeUV_r5=float$1(.305),cubeUV_m5=float$1(3),cubeUV_r6=float$1(.21),cubeUV_m6=float$1(4),cubeUV_minMipLevel=float$1(4),cubeUV_minTileSize=float$1(16),getFace=Fn$1(([direction])=>{const absDirection=vec3$1(abs$2(direction)).toVar(),face=float$1(-1).toVar();return If$1(absDirection.x.greaterThan(absDirection.z),()=>{If$1(absDirection.x.greaterThan(absDirection.y),()=>{face.assign(select(direction.x.greaterThan(0),0,3))}).Else(()=>{face.assign(select(direction.y.greaterThan(0),1,4))})}).Else(()=>{If$1(absDirection.z.greaterThan(absDirection.y),()=>{face.assign(select(direction.z.greaterThan(0),2,5))}).Else(()=>{face.assign(select(direction.y.greaterThan(0),1,4))})}),face}).setLayout({name:"getFace",type:"float",inputs:[{name:"direction",type:"vec3"}]}),getUV=Fn$1(([direction,face])=>{const uv2=vec2$1().toVar();return If$1(face.equal(0),()=>{uv2.assign(vec2$1(direction.z,direction.y).div(abs$2(direction.x)))}).ElseIf(face.equal(1),()=>{uv2.assign(vec2$1(direction.x.negate(),direction.z.negate()).div(abs$2(direction.y)))}).ElseIf(face.equal(2),()=>{uv2.assign(vec2$1(direction.x.negate(),direction.y).div(abs$2(direction.z)))}).ElseIf(face.equal(3),()=>{uv2.assign(vec2$1(direction.z.negate(),direction.y).div(abs$2(direction.x)))}).ElseIf(face.equal(4),()=>{uv2.assign(vec2$1(direction.x.negate(),direction.z).div(abs$2(direction.y)))}).Else(()=>{uv2.assign(vec2$1(direction.x,direction.y).div(abs$2(direction.z)))}),mul$1(.5,uv2.add(1))}).setLayout({name:"getUV",type:"vec2",inputs:[{name:"direction",type:"vec3"},{name:"face",type:"float"}]}),roughnessToMip=Fn$1(([roughness2])=>{const mip=float$1(0).toVar();return If$1(roughness2.greaterThanEqual(cubeUV_r1),()=>{mip.assign(cubeUV_r0.sub(roughness2).mul(cubeUV_m1.sub(cubeUV_m0)).div(cubeUV_r0.sub(cubeUV_r1)).add(cubeUV_m0))}).ElseIf(roughness2.greaterThanEqual(cubeUV_r4),()=>{mip.assign(cubeUV_r1.sub(roughness2).mul(cubeUV_m4.sub(cubeUV_m1)).div(cubeUV_r1.sub(cubeUV_r4)).add(cubeUV_m1))}).ElseIf(roughness2.greaterThanEqual(cubeUV_r5),()=>{mip.assign(cubeUV_r4.sub(roughness2).mul(cubeUV_m5.sub(cubeUV_m4)).div(cubeUV_r4.sub(cubeUV_r5)).add(cubeUV_m4))}).ElseIf(roughness2.greaterThanEqual(cubeUV_r6),()=>{mip.assign(cubeUV_r5.sub(roughness2).mul(cubeUV_m6.sub(cubeUV_m5)).div(cubeUV_r5.sub(cubeUV_r6)).add(cubeUV_m5))}).Else(()=>{mip.assign(float$1(-2).mul(log2(mul$1(1.16,roughness2))))}),mip}).setLayout({name:"roughnessToMip",type:"float",inputs:[{name:"roughness",type:"float"}]}),getDirection=Fn$1(([uv_immutable,face])=>{const uv2=uv_immutable.toVar();uv2.assign(mul$1(2,uv2).sub(1));const direction=vec3$1(uv2,1).toVar();return If$1(face.equal(0),()=>{direction.assign(direction.zyx)}).ElseIf(face.equal(1),()=>{direction.assign(direction.xzy),direction.xz.mulAssign(-1)}).ElseIf(face.equal(2),()=>{direction.x.mulAssign(-1)}).ElseIf(face.equal(3),()=>{direction.assign(direction.zyx),direction.xz.mulAssign(-1)}).ElseIf(face.equal(4),()=>{direction.assign(direction.xzy),direction.xy.mulAssign(-1)}).ElseIf(face.equal(5),()=>{direction.z.mulAssign(-1)}),direction}).setLayout({name:"getDirection",type:"vec3",inputs:[{name:"uv",type:"vec2"},{name:"face",type:"float"}]}),textureCubeUV=Fn$1(([envMap,sampleDir_immutable,roughness_immutable,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP])=>{const roughness2=float$1(roughness_immutable),sampleDir=vec3$1(sampleDir_immutable),mip=clamp$3(roughnessToMip(roughness2),cubeUV_m0,CUBEUV_MAX_MIP),mipF=fract(mip),mipInt=floor$3(mip),color0=vec3$1(bilinearCubeUV(envMap,sampleDir,mipInt,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP)).toVar();return If$1(mipF.notEqual(0),()=>{const color1=vec3$1(bilinearCubeUV(envMap,sampleDir,mipInt.add(1),CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP)).toVar();color0.assign(mix$1(color0,color1,mipF))}),color0}),bilinearCubeUV=Fn$1(([envMap,direction_immutable,mipInt_immutable,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP])=>{const mipInt=float$1(mipInt_immutable).toVar(),direction=vec3$1(direction_immutable),face=float$1(getFace(direction)).toVar(),filterInt=float$1(max$1(cubeUV_minMipLevel.sub(mipInt),0)).toVar();mipInt.assign(max$1(mipInt,cubeUV_minMipLevel));const faceSize=float$1(exp2(mipInt)).toVar(),uv2=vec2$1(getUV(direction,face).mul(faceSize.sub(2)).add(1)).toVar();return If$1(face.greaterThan(2),()=>{uv2.y.addAssign(faceSize),face.subAssign(3)}),uv2.x.addAssign(face.mul(faceSize)),uv2.x.addAssign(filterInt.mul(mul$1(3,cubeUV_minTileSize))),uv2.y.addAssign(mul$1(4,exp2(CUBEUV_MAX_MIP).sub(faceSize))),uv2.x.mulAssign(CUBEUV_TEXEL_WIDTH),uv2.y.mulAssign(CUBEUV_TEXEL_HEIGHT),envMap.sample(uv2).grad(vec2$1(),vec2$1())}),getSample=Fn$1(({envMap,mipInt,outputDirection,theta,axis,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP})=>{const cosTheta=cos$2(theta),sampleDirection=outputDirection.mul(cosTheta).add(axis.cross(outputDirection).mul(sin$2(theta))).add(axis.mul(axis.dot(outputDirection).mul(cosTheta.oneMinus())));return bilinearCubeUV(envMap,sampleDirection,mipInt,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP)}),blur=Fn$1(({n:n2,latitudinal,poleAxis,outputDirection,weights,samples,dTheta,mipInt,envMap,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP})=>{const axis=vec3$1(select(latitudinal,poleAxis,cross(poleAxis,outputDirection))).toVar();If$1(all$1(axis.equals(vec3$1(0))),()=>{axis.assign(vec3$1(outputDirection.z,0,outputDirection.x.negate()))}),axis.assign(normalize$1(axis));const gl_FragColor=vec3$1().toVar();return gl_FragColor.addAssign(weights.element(0).mul(getSample({theta:0,axis,outputDirection,mipInt,envMap,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP}))),Loop({start:int(1),end:n2},({i:i2})=>{If$1(i2.greaterThanEqual(samples),()=>{Break()});const theta=float$1(dTheta.mul(float$1(i2))).toVar();gl_FragColor.addAssign(weights.element(i2).mul(getSample({theta:theta.mul(-1),axis,outputDirection,mipInt,envMap,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP}))),gl_FragColor.addAssign(weights.element(i2).mul(getSample({theta,axis,outputDirection,mipInt,envMap,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP})))}),vec4$1(gl_FragColor,1)}),LOD_MIN=4,EXTRA_LOD_SIGMA=[.125,.215,.35,.446,.526,.582],MAX_SAMPLES=20,_flatCamera=new OrthographicCamera(-1,1,1,-1,0,1),_cubeCamera=new PerspectiveCamera(90,1),_clearColor$2=new Color;let _oldTarget=null,_oldActiveCubeFace=0,_oldActiveMipmapLevel=0;const PHI=(1+Math.sqrt(5))/2,INV_PHI=1/PHI,_axisDirections=[new Vector3(-PHI,INV_PHI,0),new Vector3(PHI,INV_PHI,0),new Vector3(-INV_PHI,0,PHI),new Vector3(INV_PHI,0,PHI),new Vector3(0,PHI,-INV_PHI),new Vector3(0,PHI,INV_PHI),new Vector3(-1,1,-1),new Vector3(1,1,-1),new Vector3(-1,1,1),new Vector3(1,1,1)],_origin=new Vector3,_uniformsMap=new WeakMap,_faceLib=[3,1,5,0,4,2],_direction=getDirection(uv$1(),attribute("faceIndex")).normalize(),_outputDirection=vec3$1(_direction.x,_direction.y,_direction.z);class PMREMGenerator{constructor(renderer){this._renderer=renderer,this._pingPongRenderTarget=null,this._lodMax=0,this._cubeSize=0,this._lodPlanes=[],this._sizeLods=[],this._sigmas=[],this._lodMeshes=[],this._blurMaterial=null,this._cubemapMaterial=null,this._equirectMaterial=null,this._backgroundBox=null}get _hasInitialized(){return this._renderer.hasInitialized()}fromScene(scene,sigma=0,near=.1,far=100,options={}){const{size=256,position=_origin,renderTarget=null}=options;if(this._setSize(size),this._hasInitialized===!1){console.warn("THREE.PMREMGenerator: .fromScene() called before the backend is initialized. Try using .fromSceneAsync() instead.");const cubeUVRenderTarget2=renderTarget||this._allocateTargets();return options.renderTarget=cubeUVRenderTarget2,this.fromSceneAsync(scene,sigma,near,far,options),cubeUVRenderTarget2}_oldTarget=this._renderer.getRenderTarget(),_oldActiveCubeFace=this._renderer.getActiveCubeFace(),_oldActiveMipmapLevel=this._renderer.getActiveMipmapLevel();const cubeUVRenderTarget=renderTarget||this._allocateTargets();return cubeUVRenderTarget.depthBuffer=!0,this._sceneToCubeUV(scene,near,far,cubeUVRenderTarget,position),sigma>0&&this._blur(cubeUVRenderTarget,0,0,sigma),this._applyPMREM(cubeUVRenderTarget),this._cleanup(cubeUVRenderTarget),cubeUVRenderTarget}async fromSceneAsync(scene,sigma=0,near=.1,far=100,options={}){return this._hasInitialized===!1&&await this._renderer.init(),this.fromScene(scene,sigma,near,far,options)}fromEquirectangular(equirectangular,renderTarget=null){if(this._hasInitialized===!1){console.warn("THREE.PMREMGenerator: .fromEquirectangular() called before the backend is initialized. Try using .fromEquirectangularAsync() instead."),this._setSizeFromTexture(equirectangular);const cubeUVRenderTarget=renderTarget||this._allocateTargets();return this.fromEquirectangularAsync(equirectangular,cubeUVRenderTarget),cubeUVRenderTarget}return this._fromTexture(equirectangular,renderTarget)}async fromEquirectangularAsync(equirectangular,renderTarget=null){return this._hasInitialized===!1&&await this._renderer.init(),this._fromTexture(equirectangular,renderTarget)}fromCubemap(cubemap,renderTarget=null){if(this._hasInitialized===!1){console.warn("THREE.PMREMGenerator: .fromCubemap() called before the backend is initialized. Try using .fromCubemapAsync() instead."),this._setSizeFromTexture(cubemap);const cubeUVRenderTarget=renderTarget||this._allocateTargets();return this.fromCubemapAsync(cubemap,renderTarget),cubeUVRenderTarget}return this._fromTexture(cubemap,renderTarget)}async fromCubemapAsync(cubemap,renderTarget=null){return this._hasInitialized===!1&&await this._renderer.init(),this._fromTexture(cubemap,renderTarget)}async compileCubemapShader(){this._cubemapMaterial===null&&(this._cubemapMaterial=_getCubemapMaterial(),await this._compileMaterial(this._cubemapMaterial))}async compileEquirectangularShader(){this._equirectMaterial===null&&(this._equirectMaterial=_getEquirectMaterial(),await this._compileMaterial(this._equirectMaterial))}dispose(){this._dispose(),this._cubemapMaterial!==null&&this._cubemapMaterial.dispose(),this._equirectMaterial!==null&&this._equirectMaterial.dispose(),this._backgroundBox!==null&&(this._backgroundBox.geometry.dispose(),this._backgroundBox.material.dispose())}_setSizeFromTexture(texture2){texture2.mapping===CubeReflectionMapping||texture2.mapping===CubeRefractionMapping?this._setSize(texture2.image.length===0?16:texture2.image[0].width||texture2.image[0].image.width):this._setSize(texture2.image.width/4)}_setSize(cubeSize){this._lodMax=Math.floor(Math.log2(cubeSize)),this._cubeSize=Math.pow(2,this._lodMax)}_dispose(){this._blurMaterial!==null&&this._blurMaterial.dispose(),this._pingPongRenderTarget!==null&&this._pingPongRenderTarget.dispose();for(let i2=0;i2<this._lodPlanes.length;i2++)this._lodPlanes[i2].dispose()}_cleanup(outputTarget){this._renderer.setRenderTarget(_oldTarget,_oldActiveCubeFace,_oldActiveMipmapLevel),outputTarget.scissorTest=!1,_setViewport(outputTarget,0,0,outputTarget.width,outputTarget.height)}_fromTexture(texture2,renderTarget){this._setSizeFromTexture(texture2),_oldTarget=this._renderer.getRenderTarget(),_oldActiveCubeFace=this._renderer.getActiveCubeFace(),_oldActiveMipmapLevel=this._renderer.getActiveMipmapLevel();const cubeUVRenderTarget=renderTarget||this._allocateTargets();return this._textureToCubeUV(texture2,cubeUVRenderTarget),this._applyPMREM(cubeUVRenderTarget),this._cleanup(cubeUVRenderTarget),cubeUVRenderTarget}_allocateTargets(){const width=3*Math.max(this._cubeSize,112),height=4*this._cubeSize,params={magFilter:LinearFilter,minFilter:LinearFilter,generateMipmaps:!1,type:HalfFloatType,format:RGBAFormat,colorSpace:LinearSRGBColorSpace},cubeUVRenderTarget=_createRenderTarget(width,height,params);if(this._pingPongRenderTarget===null||this._pingPongRenderTarget.width!==width||this._pingPongRenderTarget.height!==height){this._pingPongRenderTarget!==null&&this._dispose(),this._pingPongRenderTarget=_createRenderTarget(width,height,params);const{_lodMax}=this;({sizeLods:this._sizeLods,lodPlanes:this._lodPlanes,sigmas:this._sigmas,lodMeshes:this._lodMeshes}=_createPlanes(_lodMax)),this._blurMaterial=_getBlurShader(_lodMax,width,height)}return cubeUVRenderTarget}async _compileMaterial(material){const tmpMesh=new Mesh(this._lodPlanes[0],material);await this._renderer.compile(tmpMesh,_flatCamera)}_sceneToCubeUV(scene,near,far,cubeUVRenderTarget,position){const cubeCamera=_cubeCamera;cubeCamera.near=near,cubeCamera.far=far;const upSign=[1,1,1,1,-1,1],forwardSign=[1,-1,1,-1,1,-1],renderer=this._renderer,originalAutoClear=renderer.autoClear;renderer.getClearColor(_clearColor$2),renderer.autoClear=!1;let backgroundBox=this._backgroundBox;if(backgroundBox===null){const backgroundMaterial=new MeshBasicMaterial({name:"PMREM.Background",side:BackSide,depthWrite:!1,depthTest:!1});backgroundBox=new Mesh(new BoxGeometry,backgroundMaterial)}let useSolidColor=!1;const background=scene.background;background?background.isColor&&(backgroundBox.material.color.copy(background),scene.background=null,useSolidColor=!0):(backgroundBox.material.color.copy(_clearColor$2),useSolidColor=!0),renderer.setRenderTarget(cubeUVRenderTarget),renderer.clear(),useSolidColor&&renderer.render(backgroundBox,cubeCamera);for(let i2=0;i2<6;i2++){const col=i2%3;col===0?(cubeCamera.up.set(0,upSign[i2],0),cubeCamera.position.set(position.x,position.y,position.z),cubeCamera.lookAt(position.x+forwardSign[i2],position.y,position.z)):col===1?(cubeCamera.up.set(0,0,upSign[i2]),cubeCamera.position.set(position.x,position.y,position.z),cubeCamera.lookAt(position.x,position.y+forwardSign[i2],position.z)):(cubeCamera.up.set(0,upSign[i2],0),cubeCamera.position.set(position.x,position.y,position.z),cubeCamera.lookAt(position.x,position.y,position.z+forwardSign[i2]));const size=this._cubeSize;_setViewport(cubeUVRenderTarget,col*size,i2>2?size:0,size,size),renderer.render(scene,cubeCamera)}renderer.autoClear=originalAutoClear,scene.background=background}_textureToCubeUV(texture2,cubeUVRenderTarget){const renderer=this._renderer,isCubeTexture=texture2.mapping===CubeReflectionMapping||texture2.mapping===CubeRefractionMapping;isCubeTexture?this._cubemapMaterial===null&&(this._cubemapMaterial=_getCubemapMaterial(texture2)):this._equirectMaterial===null&&(this._equirectMaterial=_getEquirectMaterial(texture2));const material=isCubeTexture?this._cubemapMaterial:this._equirectMaterial;material.fragmentNode.value=texture2;const mesh=this._lodMeshes[0];mesh.material=material;const size=this._cubeSize;_setViewport(cubeUVRenderTarget,0,0,3*size,2*size),renderer.setRenderTarget(cubeUVRenderTarget),renderer.render(mesh,_flatCamera)}_applyPMREM(cubeUVRenderTarget){const renderer=this._renderer,autoClear=renderer.autoClear;renderer.autoClear=!1;const n2=this._lodPlanes.length;for(let i2=1;i2<n2;i2++){const sigma=Math.sqrt(this._sigmas[i2]*this._sigmas[i2]-this._sigmas[i2-1]*this._sigmas[i2-1]),poleAxis=_axisDirections[(n2-i2-1)%_axisDirections.length];this._blur(cubeUVRenderTarget,i2-1,i2,sigma,poleAxis)}renderer.autoClear=autoClear}_blur(cubeUVRenderTarget,lodIn,lodOut,sigma,poleAxis){const pingPongRenderTarget=this._pingPongRenderTarget;this._halfBlur(cubeUVRenderTarget,pingPongRenderTarget,lodIn,lodOut,sigma,"latitudinal",poleAxis),this._halfBlur(pingPongRenderTarget,cubeUVRenderTarget,lodOut,lodOut,sigma,"longitudinal",poleAxis)}_halfBlur(targetIn,targetOut,lodIn,lodOut,sigmaRadians,direction,poleAxis){const renderer=this._renderer,blurMaterial=this._blurMaterial;direction!=="latitudinal"&&direction!=="longitudinal"&&console.error("blur direction must be either latitudinal or longitudinal!");const STANDARD_DEVIATIONS=3,blurMesh=this._lodMeshes[lodOut];blurMesh.material=blurMaterial;const blurUniforms=_uniformsMap.get(blurMaterial),pixels=this._sizeLods[lodIn]-1,radiansPerPixel=isFinite(sigmaRadians)?Math.PI/(2*pixels):2*Math.PI/(2*MAX_SAMPLES-1),sigmaPixels=sigmaRadians/radiansPerPixel,samples=isFinite(sigmaRadians)?1+Math.floor(STANDARD_DEVIATIONS*sigmaPixels):MAX_SAMPLES;samples>MAX_SAMPLES&&console.warn(`sigmaRadians, ${sigmaRadians}, is too large and will clip, as it requested ${samples} samples when the maximum is set to ${MAX_SAMPLES}`);const weights=[];let sum=0;for(let i2=0;i2<MAX_SAMPLES;++i2){const x2=i2/sigmaPixels,weight=Math.exp(-x2*x2/2);weights.push(weight),i2===0?sum+=weight:i2<samples&&(sum+=2*weight)}for(let i2=0;i2<weights.length;i2++)weights[i2]=weights[i2]/sum;targetIn.texture.frame=(targetIn.texture.frame||0)+1,blurUniforms.envMap.value=targetIn.texture,blurUniforms.samples.value=samples,blurUniforms.weights.array=weights,blurUniforms.latitudinal.value=direction==="latitudinal"?1:0,poleAxis&&(blurUniforms.poleAxis.value=poleAxis);const{_lodMax}=this;blurUniforms.dTheta.value=radiansPerPixel,blurUniforms.mipInt.value=_lodMax-lodIn;const outputSize=this._sizeLods[lodOut],x=3*outputSize*(lodOut>_lodMax-LOD_MIN?lodOut-_lodMax+LOD_MIN:0),y=4*(this._cubeSize-outputSize);_setViewport(targetOut,x,y,3*outputSize,2*outputSize),renderer.setRenderTarget(targetOut),renderer.render(blurMesh,_flatCamera)}}function _createPlanes(lodMax){const lodPlanes=[],sizeLods=[],sigmas=[],lodMeshes=[];let lod=lodMax;const totalLods=lodMax-LOD_MIN+1+EXTRA_LOD_SIGMA.length;for(let i2=0;i2<totalLods;i2++){const sizeLod=Math.pow(2,lod);sizeLods.push(sizeLod);let sigma=1/sizeLod;i2>lodMax-LOD_MIN?sigma=EXTRA_LOD_SIGMA[i2-lodMax+LOD_MIN-1]:i2===0&&(sigma=0),sigmas.push(sigma);const texelSize=1/(sizeLod-2),min2=-texelSize,max2=1+texelSize,uv1=[min2,min2,max2,min2,max2,max2,min2,min2,max2,max2,min2,max2],cubeFaces=6,vertices=6,positionSize=3,uvSize=2,faceIndexSize=1,position=new Float32Array(positionSize*vertices*cubeFaces),uv2=new Float32Array(uvSize*vertices*cubeFaces),faceIndex=new Float32Array(faceIndexSize*vertices*cubeFaces);for(let face=0;face<cubeFaces;face++){const x=face%3*2/3-1,y=face>2?0:-1,coordinates2=[x,y,0,x+2/3,y,0,x+2/3,y+1,0,x,y,0,x+2/3,y+1,0,x,y+1,0],faceIdx=_faceLib[face];position.set(coordinates2,positionSize*vertices*faceIdx),uv2.set(uv1,uvSize*vertices*faceIdx);const fill=[faceIdx,faceIdx,faceIdx,faceIdx,faceIdx,faceIdx];faceIndex.set(fill,faceIndexSize*vertices*faceIdx)}const planes=new BufferGeometry;planes.setAttribute("position",new BufferAttribute(position,positionSize)),planes.setAttribute("uv",new BufferAttribute(uv2,uvSize)),planes.setAttribute("faceIndex",new BufferAttribute(faceIndex,faceIndexSize)),lodPlanes.push(planes),lodMeshes.push(new Mesh(planes,null)),lod>LOD_MIN&&lod--}return{lodPlanes,sizeLods,sigmas,lodMeshes}}function _createRenderTarget(width,height,params){const cubeUVRenderTarget=new RenderTarget(width,height,params);return cubeUVRenderTarget.texture.mapping=CubeUVReflectionMapping,cubeUVRenderTarget.texture.name="PMREM.cubeUv",cubeUVRenderTarget.texture.isPMREMTexture=!0,cubeUVRenderTarget.scissorTest=!0,cubeUVRenderTarget}function _setViewport(target,x,y,width,height){target.viewport.set(x,y,width,height),target.scissor.set(x,y,width,height)}function _getMaterial(type){const material=new NodeMaterial;return material.depthTest=!1,material.depthWrite=!1,material.blending=NoBlending,material.name=`PMREM_${type}`,material}function _getBlurShader(lodMax,width,height){const weights=uniformArray(new Array(MAX_SAMPLES).fill(0)),poleAxis=uniform$1(new Vector3(0,1,0)),dTheta=uniform$1(0),n2=float$1(MAX_SAMPLES),latitudinal=uniform$1(0),samples=uniform$1(1),envMap=texture$1(null),mipInt=uniform$1(0),CUBEUV_TEXEL_WIDTH=float$1(1/width),CUBEUV_TEXEL_HEIGHT=float$1(1/height),CUBEUV_MAX_MIP=float$1(lodMax),materialUniforms={n:n2,latitudinal,weights,poleAxis,outputDirection:_outputDirection,dTheta,samples,envMap,mipInt,CUBEUV_TEXEL_WIDTH,CUBEUV_TEXEL_HEIGHT,CUBEUV_MAX_MIP},material=_getMaterial("blur");return material.fragmentNode=blur({...materialUniforms,latitudinal:latitudinal.equal(1)}),_uniformsMap.set(material,materialUniforms),material}function _getCubemapMaterial(envTexture){const material=_getMaterial("cubemap");return material.fragmentNode=cubeTexture(envTexture,_outputDirection),material}function _getEquirectMaterial(envTexture){const material=_getMaterial("equirect");return material.fragmentNode=texture$1(envTexture,equirectUV(_outputDirection),0),material}const _cache=new WeakMap;function _generateCubeUVSize(imageHeight){const maxMip=Math.log2(imageHeight)-2,texelHeight=1/imageHeight;return{texelWidth:1/(3*Math.max(Math.pow(2,maxMip),7*16)),texelHeight,maxMip}}function _getPMREMFromTexture(texture2,renderer,generator){const cache2=_getCache(renderer);let cacheTexture=cache2.get(texture2);if((cacheTexture!==void 0?cacheTexture.pmremVersion:-1)!==texture2.pmremVersion){const image=texture2.image;if(texture2.isCubeTexture)if(isCubeMapReady(image))cacheTexture=generator.fromCubemap(texture2,cacheTexture);else return null;else if(isEquirectangularMapReady(image))cacheTexture=generator.fromEquirectangular(texture2,cacheTexture);else return null;cacheTexture.pmremVersion=texture2.pmremVersion,cache2.set(texture2,cacheTexture)}return cacheTexture.texture}function _getCache(renderer){let rendererCache2=_cache.get(renderer);return rendererCache2===void 0&&(rendererCache2=new WeakMap,_cache.set(renderer,rendererCache2)),rendererCache2}class PMREMNode extends TempNode{static get type(){return"PMREMNode"}constructor(value,uvNode=null,levelNode=null){super("vec3"),this._value=value,this._pmrem=null,this.uvNode=uvNode,this.levelNode=levelNode,this._generator=null;const defaultTexture=new Texture;defaultTexture.isRenderTargetTexture=!0,this._texture=texture$1(defaultTexture),this._width=uniform$1(0),this._height=uniform$1(0),this._maxMip=uniform$1(0),this.updateBeforeType=NodeUpdateType.RENDER}set value(value){this._value=value,this._pmrem=null}get value(){return this._value}updateFromTexture(texture2){const cubeUVSize=_generateCubeUVSize(texture2.image.height);this._texture.value=texture2,this._width.value=cubeUVSize.texelWidth,this._height.value=cubeUVSize.texelHeight,this._maxMip.value=cubeUVSize.maxMip}updateBefore(frame){let pmrem=this._pmrem;const pmremVersion=pmrem?pmrem.pmremVersion:-1,texture2=this._value;pmremVersion!==texture2.pmremVersion&&(texture2.isPMREMTexture===!0?pmrem=texture2:pmrem=_getPMREMFromTexture(texture2,frame.renderer,this._generator),pmrem!==null&&(this._pmrem=pmrem,this.updateFromTexture(pmrem)))}setup(builder){this._generator===null&&(this._generator=new PMREMGenerator(builder.renderer)),this.updateBefore(builder);let uvNode=this.uvNode;uvNode===null&&builder.context.getUV&&(uvNode=builder.context.getUV(this)),uvNode=materialEnvRotation.mul(vec3$1(uvNode.x,uvNode.y.negate(),uvNode.z));let levelNode=this.levelNode;return levelNode===null&&builder.context.getTextureLevel&&(levelNode=builder.context.getTextureLevel(this)),textureCubeUV(this._texture,uvNode,levelNode,this._width,this._height,this._maxMip)}dispose(){super.dispose(),this._generator!==null&&this._generator.dispose()}}function isCubeMapReady(image){if(image==null)return!1;let count=0;const length2=6;for(let i2=0;i2<length2;i2++)image[i2]!==void 0&&count++;return count===length2}function isEquirectangularMapReady(image){return image==null?!1:image.height>0}const pmremTexture=nodeProxy(PMREMNode),_envNodeCache=new WeakMap;class EnvironmentNode extends LightingNode{static get type(){return"EnvironmentNode"}constructor(envNode=null){super(),this.envNode=envNode}setup(builder){const{material}=builder;let envNode=this.envNode;if(envNode.isTextureNode||envNode.isMaterialReferenceNode){const value=envNode.isTextureNode?envNode.value:material[envNode.property];let cacheEnvNode=_envNodeCache.get(value);cacheEnvNode===void 0&&(cacheEnvNode=pmremTexture(value),_envNodeCache.set(value,cacheEnvNode)),envNode=cacheEnvNode}const radianceNormalView=material.useAnisotropy===!0||material.anisotropy>0?transformedBentNormalView:transformedNormalView,radiance=envNode.context(createRadianceContext(roughness,radianceNormalView)).mul(materialEnvIntensity),irradiance=envNode.context(createIrradianceContext(transformedNormalWorld)).mul(Math.PI).mul(materialEnvIntensity),isolateRadiance=cache$2(radiance),isolateIrradiance=cache$2(irradiance);builder.context.radiance.addAssign(isolateRadiance),builder.context.iblIrradiance.addAssign(isolateIrradiance);const clearcoatRadiance=builder.context.lightingModel.clearcoatRadiance;if(clearcoatRadiance){const clearcoatRadianceContext=envNode.context(createRadianceContext(clearcoatRoughness,transformedClearcoatNormalView)).mul(materialEnvIntensity),isolateClearcoatRadiance=cache$2(clearcoatRadianceContext);clearcoatRadiance.addAssign(isolateClearcoatRadiance)}}}const createRadianceContext=(roughnessNode,normalViewNode)=>{let reflectVec=null;return{getUV:()=>(reflectVec===null&&(reflectVec=positionViewDirection.negate().reflect(normalViewNode),reflectVec=roughnessNode.mul(roughnessNode).mix(reflectVec,normalViewNode).normalize(),reflectVec=reflectVec.transformDirection(cameraViewMatrix)),reflectVec),getTextureLevel:()=>roughnessNode}},createIrradianceContext=normalWorldNode=>({getUV:()=>normalWorldNode,getTextureLevel:()=>float$1(1)}),_defaultValues$6=new MeshStandardMaterial;class MeshStandardNodeMaterial extends NodeMaterial{static get type(){return"MeshStandardNodeMaterial"}constructor(parameters){super(),this.isMeshStandardNodeMaterial=!0,this.lights=!0,this.emissiveNode=null,this.metalnessNode=null,this.roughnessNode=null,this.setDefaultValues(_defaultValues$6),this.setValues(parameters)}setupEnvironment(builder){let envNode=super.setupEnvironment(builder);return envNode===null&&builder.environmentNode&&(envNode=builder.environmentNode),envNode?new EnvironmentNode(envNode):null}setupLightingModel(){return new PhysicalLightingModel}setupSpecular(){const specularColorNode=mix$1(vec3$1(.04),diffuseColor.rgb,metalness);specularColor.assign(specularColorNode),specularF90.assign(1)}setupVariants(){const metalnessNode=this.metalnessNode?float$1(this.metalnessNode):materialMetalness;metalness.assign(metalnessNode);let roughnessNode=this.roughnessNode?float$1(this.roughnessNode):materialRoughness;roughnessNode=getRoughness({roughness:roughnessNode}),roughness.assign(roughnessNode),this.setupSpecular(),diffuseColor.assign(vec4$1(diffuseColor.rgb.mul(metalnessNode.oneMinus()),diffuseColor.a))}copy(source){return this.emissiveNode=source.emissiveNode,this.metalnessNode=source.metalnessNode,this.roughnessNode=source.roughnessNode,super.copy(source)}}const _defaultValues$5=new MeshPhysicalMaterial;class MeshPhysicalNodeMaterial extends MeshStandardNodeMaterial{static get type(){return"MeshPhysicalNodeMaterial"}constructor(parameters){super(),this.isMeshPhysicalNodeMaterial=!0,this.clearcoatNode=null,this.clearcoatRoughnessNode=null,this.clearcoatNormalNode=null,this.sheenNode=null,this.sheenRoughnessNode=null,this.iridescenceNode=null,this.iridescenceIORNode=null,this.iridescenceThicknessNode=null,this.specularIntensityNode=null,this.specularColorNode=null,this.iorNode=null,this.transmissionNode=null,this.thicknessNode=null,this.attenuationDistanceNode=null,this.attenuationColorNode=null,this.dispersionNode=null,this.anisotropyNode=null,this.setDefaultValues(_defaultValues$5),this.setValues(parameters)}get useClearcoat(){return this.clearcoat>0||this.clearcoatNode!==null}get useIridescence(){return this.iridescence>0||this.iridescenceNode!==null}get useSheen(){return this.sheen>0||this.sheenNode!==null}get useAnisotropy(){return this.anisotropy>0||this.anisotropyNode!==null}get useTransmission(){return this.transmission>0||this.transmissionNode!==null}get useDispersion(){return this.dispersion>0||this.dispersionNode!==null}setupSpecular(){const iorNode=this.iorNode?float$1(this.iorNode):materialIOR;ior.assign(iorNode),specularColor.assign(mix$1(min$1(pow2(ior.sub(1).div(ior.add(1))).mul(materialSpecularColor),vec3$1(1)).mul(materialSpecularIntensity),diffuseColor.rgb,metalness)),specularF90.assign(mix$1(materialSpecularIntensity,1,metalness))}setupLightingModel(){return new PhysicalLightingModel(this.useClearcoat,this.useSheen,this.useIridescence,this.useAnisotropy,this.useTransmission,this.useDispersion)}setupVariants(builder){if(super.setupVariants(builder),this.useClearcoat){const clearcoatNode=this.clearcoatNode?float$1(this.clearcoatNode):materialClearcoat,clearcoatRoughnessNode=this.clearcoatRoughnessNode?float$1(this.clearcoatRoughnessNode):materialClearcoatRoughness;clearcoat.assign(clearcoatNode),clearcoatRoughness.assign(getRoughness({roughness:clearcoatRoughnessNode}))}if(this.useSheen){const sheenNode=this.sheenNode?vec3$1(this.sheenNode):materialSheen,sheenRoughnessNode=this.sheenRoughnessNode?float$1(this.sheenRoughnessNode):materialSheenRoughness;sheen.assign(sheenNode),sheenRoughness.assign(sheenRoughnessNode)}if(this.useIridescence){const iridescenceNode=this.iridescenceNode?float$1(this.iridescenceNode):materialIridescence,iridescenceIORNode=this.iridescenceIORNode?float$1(this.iridescenceIORNode):materialIridescenceIOR,iridescenceThicknessNode=this.iridescenceThicknessNode?float$1(this.iridescenceThicknessNode):materialIridescenceThickness;iridescence.assign(iridescenceNode),iridescenceIOR.assign(iridescenceIORNode),iridescenceThickness.assign(iridescenceThicknessNode)}if(this.useAnisotropy){const anisotropyV=(this.anisotropyNode?vec2$1(this.anisotropyNode):materialAnisotropy).toVar();anisotropy.assign(anisotropyV.length()),If$1(anisotropy.equal(0),()=>{anisotropyV.assign(vec2$1(1,0))}).Else(()=>{anisotropyV.divAssign(vec2$1(anisotropy)),anisotropy.assign(anisotropy.saturate())}),alphaT.assign(anisotropy.pow2().mix(roughness.pow2(),1)),anisotropyT.assign(TBNViewMatrix[0].mul(anisotropyV.x).add(TBNViewMatrix[1].mul(anisotropyV.y))),anisotropyB.assign(TBNViewMatrix[1].mul(anisotropyV.x).sub(TBNViewMatrix[0].mul(anisotropyV.y)))}if(this.useTransmission){const transmissionNode=this.transmissionNode?float$1(this.transmissionNode):materialTransmission,thicknessNode=this.thicknessNode?float$1(this.thicknessNode):materialThickness,attenuationDistanceNode=this.attenuationDistanceNode?float$1(this.attenuationDistanceNode):materialAttenuationDistance,attenuationColorNode=this.attenuationColorNode?vec3$1(this.attenuationColorNode):materialAttenuationColor;if(transmission.assign(transmissionNode),thickness.assign(thicknessNode),attenuationDistance.assign(attenuationDistanceNode),attenuationColor.assign(attenuationColorNode),this.useDispersion){const dispersionNode=this.dispersionNode?float$1(this.dispersionNode):materialDispersion;dispersion.assign(dispersionNode)}}}setupClearcoatNormal(){return this.clearcoatNormalNode?vec3$1(this.clearcoatNormalNode):materialClearcoatNormal}setup(builder){builder.context.setupClearcoatNormal=()=>this.setupClearcoatNormal(builder),super.setup(builder)}copy(source){return this.clearcoatNode=source.clearcoatNode,this.clearcoatRoughnessNode=source.clearcoatRoughnessNode,this.clearcoatNormalNode=source.clearcoatNormalNode,this.sheenNode=source.sheenNode,this.sheenRoughnessNode=source.sheenRoughnessNode,this.iridescenceNode=source.iridescenceNode,this.iridescenceIORNode=source.iridescenceIORNode,this.iridescenceThicknessNode=source.iridescenceThicknessNode,this.specularIntensityNode=source.specularIntensityNode,this.specularColorNode=source.specularColorNode,this.transmissionNode=source.transmissionNode,this.thicknessNode=source.thicknessNode,this.attenuationDistanceNode=source.attenuationDistanceNode,this.attenuationColorNode=source.attenuationColorNode,this.dispersionNode=source.dispersionNode,this.anisotropyNode=source.anisotropyNode,super.copy(source)}}const getGradientIrradiance=Fn$1(({normal:normal2,lightDirection,builder})=>{const dotNL=normal2.dot(lightDirection),coord=vec2$1(dotNL.mul(.5).add(.5),0);if(builder.material.gradientMap){const gradientMap=materialReference("gradientMap","texture").context({getUV:()=>coord});return vec3$1(gradientMap.r)}else{const fw=coord.fwidth().mul(.5);return mix$1(vec3$1(.7),vec3$1(1),smoothstep$1(float$1(.7).sub(fw.x),float$1(.7).add(fw.x),coord.x))}});class ToonLightingModel extends LightingModel{direct({lightDirection,lightColor,reflectedLight},builder){const irradiance=getGradientIrradiance({normal:normalGeometry,lightDirection,builder}).mul(lightColor);reflectedLight.directDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor:diffuseColor.rgb})))}indirect(builder){const{ambientOcclusion,irradiance,reflectedLight}=builder.context;reflectedLight.indirectDiffuse.addAssign(irradiance.mul(BRDF_Lambert({diffuseColor}))),reflectedLight.indirectDiffuse.mulAssign(ambientOcclusion)}}const _defaultValues$4=new MeshToonMaterial;class MeshToonNodeMaterial extends NodeMaterial{static get type(){return"MeshToonNodeMaterial"}constructor(parameters){super(),this.isMeshToonNodeMaterial=!0,this.lights=!0,this.setDefaultValues(_defaultValues$4),this.setValues(parameters)}setupLightingModel(){return new ToonLightingModel}}class MatcapUVNode extends TempNode{static get type(){return"MatcapUVNode"}constructor(){super("vec2")}setup(){const x=vec3$1(positionViewDirection.z,0,positionViewDirection.x.negate()).normalize(),y=positionViewDirection.cross(x);return vec2$1(x.dot(transformedNormalView),y.dot(transformedNormalView)).mul(.495).add(.5)}}const matcapUV=nodeImmutable(MatcapUVNode),_defaultValues$3=new MeshMatcapMaterial;class MeshMatcapNodeMaterial extends NodeMaterial{static get type(){return"MeshMatcapNodeMaterial"}constructor(parameters){super(),this.isMeshMatcapNodeMaterial=!0,this.setDefaultValues(_defaultValues$3),this.setValues(parameters)}setupVariants(builder){const uv2=matcapUV;let matcapColor;builder.material.matcap?matcapColor=materialReference("matcap","texture").context({getUV:()=>uv2}):matcapColor=vec3$1(mix$1(.2,.8,uv2.y)),diffuseColor.rgb.mulAssign(matcapColor.rgb)}}class RotateNode extends TempNode{static get type(){return"RotateNode"}constructor(positionNode,rotationNode){super(),this.positionNode=positionNode,this.rotationNode=rotationNode}getNodeType(builder){return this.positionNode.getNodeType(builder)}setup(builder){const{rotationNode,positionNode}=this;if(this.getNodeType(builder)==="vec2"){const cosAngle=rotationNode.cos(),sinAngle=rotationNode.sin();return mat2(cosAngle,sinAngle,sinAngle.negate(),cosAngle).mul(positionNode)}else{const rotation2=rotationNode,rotationXMatrix=mat4(vec4$1(1,0,0,0),vec4$1(0,cos$2(rotation2.x),sin$2(rotation2.x).negate(),0),vec4$1(0,sin$2(rotation2.x),cos$2(rotation2.x),0),vec4$1(0,0,0,1)),rotationYMatrix=mat4(vec4$1(cos$2(rotation2.y),0,sin$2(rotation2.y),0),vec4$1(0,1,0,0),vec4$1(sin$2(rotation2.y).negate(),0,cos$2(rotation2.y),0),vec4$1(0,0,0,1)),rotationZMatrix=mat4(vec4$1(cos$2(rotation2.z),sin$2(rotation2.z).negate(),0,0),vec4$1(sin$2(rotation2.z),cos$2(rotation2.z),0,0),vec4$1(0,0,1,0),vec4$1(0,0,0,1));return rotationXMatrix.mul(rotationYMatrix).mul(rotationZMatrix).mul(vec4$1(positionNode,1)).xyz}}}const rotate$2=nodeProxy(RotateNode),_defaultValues$2=new SpriteMaterial;class SpriteNodeMaterial extends NodeMaterial{static get type(){return"SpriteNodeMaterial"}constructor(parameters){super(),this.isSpriteNodeMaterial=!0,this._useSizeAttenuation=!0,this.positionNode=null,this.rotationNode=null,this.scaleNode=null,this.transparent=!0,this.setDefaultValues(_defaultValues$2),this.setValues(parameters)}setupPositionView(builder){const{object,camera}=builder,sizeAttenuation=this.sizeAttenuation,{positionNode,rotationNode,scaleNode}=this,mvPosition=modelViewMatrix.mul(vec3$1(positionNode||0));let scale2=vec2$1(modelWorldMatrix[0].xyz.length(),modelWorldMatrix[1].xyz.length());if(scaleNode!==null&&(scale2=scale2.mul(vec2$1(scaleNode))),sizeAttenuation===!1)if(camera.isPerspectiveCamera)scale2=scale2.mul(mvPosition.z.negate());else{const orthoScale=float$1(2).div(cameraProjectionMatrix.element(1).element(1));scale2=scale2.mul(orthoScale.mul(2))}let alignedPosition=positionGeometry$1.xy;if(object.center&&object.center.isVector2===!0){const center=reference$1("center","vec2",object);alignedPosition=alignedPosition.sub(center.sub(.5))}alignedPosition=alignedPosition.mul(scale2);const rotation2=float$1(rotationNode||materialRotation),rotatedPosition=rotate$2(alignedPosition,rotation2);return vec4$1(mvPosition.xy.add(rotatedPosition),mvPosition.zw)}copy(source){return this.positionNode=source.positionNode,this.rotationNode=source.rotationNode,this.scaleNode=source.scaleNode,super.copy(source)}get sizeAttenuation(){return this._useSizeAttenuation}set sizeAttenuation(value){this._useSizeAttenuation!==value&&(this._useSizeAttenuation=value,this.needsUpdate=!0)}}const _defaultValues$1=new PointsMaterial;class PointsNodeMaterial extends SpriteNodeMaterial{static get type(){return"PointsNodeMaterial"}constructor(parameters){super(),this.sizeNode=null,this.isPointsNodeMaterial=!0,this.setDefaultValues(_defaultValues$1),this.setValues(parameters)}setupPositionView(){const{positionNode}=this;return modelViewMatrix.mul(vec3$1(positionNode||positionLocal)).xyz}setupVertex(builder){const mvp=super.setupVertex(builder);if(builder.material.isNodeMaterial!==!0)return mvp;const{rotationNode,scaleNode,sizeNode}=this,alignedPosition=positionGeometry$1.xy.toVar(),aspect2=viewport.z.div(viewport.w);if(rotationNode&&rotationNode.isNode){const rotation2=float$1(rotationNode);alignedPosition.assign(rotate$2(alignedPosition,rotation2))}let pointSize=sizeNode!==null?vec2$1(sizeNode):materialPointSize;return this.sizeAttenuation===!0&&(pointSize=pointSize.mul(pointSize.div(positionView.z.negate()))),scaleNode&&scaleNode.isNode&&(pointSize=pointSize.mul(vec2$1(scaleNode))),alignedPosition.mulAssign(pointSize.mul(2)),alignedPosition.assign(alignedPosition.div(viewport.z)),alignedPosition.y.assign(alignedPosition.y.mul(aspect2)),alignedPosition.assign(alignedPosition.mul(mvp.w)),mvp.addAssign(vec4$1(alignedPosition,0,0)),mvp}get alphaToCoverage(){return this._useAlphaToCoverage}set alphaToCoverage(value){this._useAlphaToCoverage!==value&&(this._useAlphaToCoverage=value,this.needsUpdate=!0)}}class ShadowMaskModel extends LightingModel{constructor(){super(),this.shadowNode=float$1(1).toVar("shadowMask")}direct({shadowMask}){this.shadowNode.mulAssign(shadowMask)}finish(context2){diffuseColor.a.mulAssign(this.shadowNode.oneMinus()),context2.outgoingLight.rgb.assign(diffuseColor.rgb)}}const _defaultValues=new ShadowMaterial;class ShadowNodeMaterial extends NodeMaterial{static get type(){return"ShadowNodeMaterial"}constructor(parameters){super(),this.isShadowNodeMaterial=!0,this.lights=!0,this.setDefaultValues(_defaultValues),this.setValues(parameters)}setupLightingModel(){return new ShadowMaskModel}}property("vec3");property("vec3");property("vec3");class Animation{constructor(nodes,info){this.nodes=nodes,this.info=info,this._context=self,this._animationLoop=null,this._requestId=null}start(){const update=(time2,xrFrame)=>{this._requestId=this._context.requestAnimationFrame(update),this.info.autoReset===!0&&this.info.reset(),this.nodes.nodeFrame.update(),this.info.frame=this.nodes.nodeFrame.frameId,this._animationLoop!==null&&this._animationLoop(time2,xrFrame)};update()}stop(){this._context.cancelAnimationFrame(this._requestId),this._requestId=null}getAnimationLoop(){return this._animationLoop}setAnimationLoop(callback){this._animationLoop=callback}getContext(){return this._context}setContext(context2){this._context=context2}dispose(){this.stop()}}class ChainMap{constructor(){this.weakMap=new WeakMap}get(keys){let map=this.weakMap;for(let i2=0;i2<keys.length-1;i2++)if(map=map.get(keys[i2]),map===void 0)return;return map.get(keys[keys.length-1])}set(keys,value){let map=this.weakMap;for(let i2=0;i2<keys.length-1;i2++){const key2=keys[i2];map.has(key2)===!1&&map.set(key2,new WeakMap),map=map.get(key2)}return map.set(keys[keys.length-1],value),this}delete(keys){let map=this.weakMap;for(let i2=0;i2<keys.length-1;i2++)if(map=map.get(keys[i2]),map===void 0)return!1;return map.delete(keys[keys.length-1])}}let _id$9=0;function getKeys(obj){const keys=Object.keys(obj);let proto=Object.getPrototypeOf(obj);for(;proto;){const descriptors=Object.getOwnPropertyDescriptors(proto);for(const key2 in descriptors)if(descriptors[key2]!==void 0){const descriptor=descriptors[key2];descriptor&&typeof descriptor.get=="function"&&keys.push(key2)}proto=Object.getPrototypeOf(proto)}return keys}class RenderObject{constructor(nodes,geometries,renderer,object,material,scene,camera,lightsNode,renderContext,clippingContext){this.id=_id$9++,this._nodes=nodes,this._geometries=geometries,this.renderer=renderer,this.object=object,this.material=material,this.scene=scene,this.camera=camera,this.lightsNode=lightsNode,this.context=renderContext,this.geometry=object.geometry,this.version=material.version,this.drawRange=null,this.attributes=null,this.pipeline=null,this.group=null,this.vertexBuffers=null,this.drawParams=null,this.bundle=null,this.clippingContext=clippingContext,this.clippingContextCacheKey=clippingContext!==null?clippingContext.cacheKey:"",this.initialNodesCacheKey=this.getDynamicCacheKey(),this.initialCacheKey=this.getCacheKey(),this._nodeBuilderState=null,this._bindings=null,this._monitor=null,this.onDispose=null,this.isRenderObject=!0,this.onMaterialDispose=()=>{this.dispose()},this.material.addEventListener("dispose",this.onMaterialDispose)}updateClipping(context2){this.clippingContext=context2}get clippingNeedsUpdate(){return this.clippingContext===null||this.clippingContext.cacheKey===this.clippingContextCacheKey?!1:(this.clippingContextCacheKey=this.clippingContext.cacheKey,!0)}get hardwareClippingPlanes(){return this.material.hardwareClipping===!0?this.clippingContext.unionClippingCount:0}getNodeBuilderState(){return this._nodeBuilderState||(this._nodeBuilderState=this._nodes.getForRender(this))}getMonitor(){return this._monitor||(this._monitor=this.getNodeBuilderState().observer)}getBindings(){return this._bindings||(this._bindings=this.getNodeBuilderState().createBindings())}getBindingGroup(name){for(const bindingGroup of this.getBindings())if(bindingGroup.name===name)return bindingGroup}getIndex(){return this._geometries.getIndex(this)}getIndirect(){return this._geometries.getIndirect(this)}getChainArray(){return[this.object,this.material,this.context,this.lightsNode]}setGeometry(geometry2){this.geometry=geometry2,this.attributes=null}getAttributes(){if(this.attributes!==null)return this.attributes;const nodeAttributes=this.getNodeBuilderState().nodeAttributes,geometry2=this.geometry,attributes=[],vertexBuffers=new Set;for(const nodeAttribute of nodeAttributes){const attribute2=nodeAttribute.node&&nodeAttribute.node.attribute?nodeAttribute.node.attribute:geometry2.getAttribute(nodeAttribute.name);if(attribute2===void 0)continue;attributes.push(attribute2);const bufferAttribute2=attribute2.isInterleavedBufferAttribute?attribute2.data:attribute2;vertexBuffers.add(bufferAttribute2)}return this.attributes=attributes,this.vertexBuffers=Array.from(vertexBuffers.values()),attributes}getVertexBuffers(){return this.vertexBuffers===null&&this.getAttributes(),this.vertexBuffers}getDrawParameters(){const{object,material,geometry:geometry2,group,drawRange}=this,drawParams=this.drawParams||(this.drawParams={vertexCount:0,firstVertex:0,instanceCount:0,firstInstance:0}),index=this.getIndex(),hasIndex=index!==null,instanceCount=geometry2.isInstancedBufferGeometry?geometry2.instanceCount:object.count>1?object.count:1;if(instanceCount===0)return null;if(drawParams.instanceCount=instanceCount,object.isBatchedMesh===!0)return drawParams;let rangeFactor=1;material.wireframe===!0&&!object.isPoints&&!object.isLineSegments&&!object.isLine&&!object.isLineLoop&&(rangeFactor=2);let firstVertex=drawRange.start*rangeFactor,lastVertex=(drawRange.start+drawRange.count)*rangeFactor;group!==null&&(firstVertex=Math.max(firstVertex,group.start*rangeFactor),lastVertex=Math.min(lastVertex,(group.start+group.count)*rangeFactor));const position=geometry2.attributes.position;let itemCount=1/0;hasIndex?itemCount=index.count:position!=null&&(itemCount=position.count),firstVertex=Math.max(firstVertex,0),lastVertex=Math.min(lastVertex,itemCount);const count=lastVertex-firstVertex;return count<0||count===1/0?null:(drawParams.vertexCount=count,drawParams.firstVertex=firstVertex,drawParams)}getGeometryCacheKey(){const{geometry:geometry2}=this;let cacheKey="";for(const name of Object.keys(geometry2.attributes).sort()){const attribute2=geometry2.attributes[name];cacheKey+=name+",",attribute2.data&&(cacheKey+=attribute2.data.stride+","),attribute2.offset&&(cacheKey+=attribute2.offset+","),attribute2.itemSize&&(cacheKey+=attribute2.itemSize+","),attribute2.normalized&&(cacheKey+="n,")}for(const name of Object.keys(geometry2.morphAttributes).sort()){const targets=geometry2.morphAttributes[name];cacheKey+="morph-"+name+",";for(let i2=0,l2=targets.length;i2<l2;i2++){const attribute2=targets[i2];cacheKey+=attribute2.id+","}}return geometry2.index&&(cacheKey+="index,"),cacheKey}getMaterialCacheKey(){const{object,material}=this;let cacheKey=material.customProgramCacheKey();for(const property2 of getKeys(material)){if(/^(is[A-Z]|_)|^(visible|version|uuid|name|opacity|userData)$/.test(property2))continue;const value=material[property2];let valueKey;if(value!==null){const type=typeof value;type==="number"?valueKey=value!==0?"1":"0":type==="object"?(valueKey="{",value.isTexture&&(valueKey+=value.mapping),valueKey+="}"):valueKey=String(value)}else valueKey=String(value);cacheKey+=valueKey+","}return cacheKey+=this.clippingContextCacheKey+",",object.geometry&&(cacheKey+=this.getGeometryCacheKey()),object.skeleton&&(cacheKey+=object.skeleton.bones.length+","),object.isBatchedMesh&&(cacheKey+=object._matricesTexture.uuid+",",object._colorsTexture!==null&&(cacheKey+=object._colorsTexture.uuid+",")),object.count>1&&(cacheKey+=object.uuid+","),cacheKey+=object.receiveShadow+",",hashString(cacheKey)}get needsGeometryUpdate(){return this.geometry.id!==this.object.geometry.id}get needsUpdate(){return this.initialNodesCacheKey!==this.getDynamicCacheKey()||this.clippingNeedsUpdate}getDynamicCacheKey(){let cacheKey=0;return this.material.isShadowPassMaterial!==!0&&(cacheKey=this._nodes.getCacheKey(this.scene,this.lightsNode)),this.camera.isArrayCamera&&(cacheKey=hash$1(cacheKey,this.camera.cameras.length)),this.object.receiveShadow&&(cacheKey=hash$1(cacheKey,1)),cacheKey}getCacheKey(){return this.getMaterialCacheKey()+this.getDynamicCacheKey()}dispose(){this.material.removeEventListener("dispose",this.onMaterialDispose),this.onDispose()}}const _chainKeys$5=[];class RenderObjects{constructor(renderer,nodes,geometries,pipelines,bindings,info){this.renderer=renderer,this.nodes=nodes,this.geometries=geometries,this.pipelines=pipelines,this.bindings=bindings,this.info=info,this.chainMaps={}}get(object,material,scene,camera,lightsNode,renderContext,clippingContext,passId){const chainMap=this.getChainMap(passId);_chainKeys$5[0]=object,_chainKeys$5[1]=material,_chainKeys$5[2]=renderContext,_chainKeys$5[3]=lightsNode;let renderObject=chainMap.get(_chainKeys$5);return renderObject===void 0?(renderObject=this.createRenderObject(this.nodes,this.geometries,this.renderer,object,material,scene,camera,lightsNode,renderContext,clippingContext,passId),chainMap.set(_chainKeys$5,renderObject)):(renderObject.updateClipping(clippingContext),renderObject.needsGeometryUpdate&&renderObject.setGeometry(object.geometry),(renderObject.version!==material.version||renderObject.needsUpdate)&&(renderObject.initialCacheKey!==renderObject.getCacheKey()?(renderObject.dispose(),renderObject=this.get(object,material,scene,camera,lightsNode,renderContext,clippingContext,passId)):renderObject.version=material.version)),_chainKeys$5.length=0,renderObject}getChainMap(passId="default"){return this.chainMaps[passId]||(this.chainMaps[passId]=new ChainMap)}dispose(){this.chainMaps={}}createRenderObject(nodes,geometries,renderer,object,material,scene,camera,lightsNode,renderContext,clippingContext,passId){const chainMap=this.getChainMap(passId),renderObject=new RenderObject(nodes,geometries,renderer,object,material,scene,camera,lightsNode,renderContext,clippingContext);return renderObject.onDispose=()=>{this.pipelines.delete(renderObject),this.bindings.delete(renderObject),this.nodes.delete(renderObject),chainMap.delete(renderObject.getChainArray())},renderObject}}class DataMap{constructor(){this.data=new WeakMap}get(object){let map=this.data.get(object);return map===void 0&&(map={},this.data.set(object,map)),map}delete(object){let map=null;return this.data.has(object)&&(map=this.data.get(object),this.data.delete(object)),map}has(object){return this.data.has(object)}dispose(){this.data=new WeakMap}}const AttributeType={VERTEX:1,INDEX:2,STORAGE:3,INDIRECT:4},GPU_CHUNK_BYTES=16,BlendColorFactor=211,OneMinusBlendColorFactor=212;class Attributes extends DataMap{constructor(backend){super(),this.backend=backend}delete(attribute2){const attributeData=super.delete(attribute2);return attributeData!==void 0&&this.backend.destroyAttribute(attribute2),attributeData}update(attribute2,type){const data=this.get(attribute2);if(data.version===void 0)type===AttributeType.VERTEX?this.backend.createAttribute(attribute2):type===AttributeType.INDEX?this.backend.createIndexAttribute(attribute2):type===AttributeType.STORAGE?this.backend.createStorageAttribute(attribute2):type===AttributeType.INDIRECT&&this.backend.createIndirectStorageAttribute(attribute2),data.version=this._getBufferAttribute(attribute2).version;else{const bufferAttribute2=this._getBufferAttribute(attribute2);(data.version<bufferAttribute2.version||bufferAttribute2.usage===DynamicDrawUsage)&&(this.backend.updateAttribute(attribute2),data.version=bufferAttribute2.version)}}_getBufferAttribute(attribute2){return attribute2.isInterleavedBufferAttribute&&(attribute2=attribute2.data),attribute2}}function getWireframeVersion(geometry2){return geometry2.index!==null?geometry2.index.version:geometry2.attributes.position.version}function getWireframeIndex(geometry2){const indices=[],geometryIndex=geometry2.index,geometryPosition=geometry2.attributes.position;if(geometryIndex!==null){const array2=geometryIndex.array;for(let i2=0,l2=array2.length;i2<l2;i2+=3){const a2=array2[i2+0],b=array2[i2+1],c2=array2[i2+2];indices.push(a2,b,b,c2,c2,a2)}}else{const array2=geometryPosition.array;for(let i2=0,l2=array2.length/3-1;i2<l2;i2+=3){const a2=i2+0,b=i2+1,c2=i2+2;indices.push(a2,b,b,c2,c2,a2)}}const attribute2=new(arrayNeedsUint32(indices)?Uint32BufferAttribute:Uint16BufferAttribute)(indices,1);return attribute2.version=getWireframeVersion(geometry2),attribute2}class Geometries extends DataMap{constructor(attributes,info){super(),this.attributes=attributes,this.info=info,this.wireframes=new WeakMap,this.attributeCall=new WeakMap}has(renderObject){const geometry2=renderObject.geometry;return super.has(geometry2)&&this.get(geometry2).initialized===!0}updateForRender(renderObject){this.has(renderObject)===!1&&this.initGeometry(renderObject),this.updateAttributes(renderObject)}initGeometry(renderObject){const geometry2=renderObject.geometry,geometryData=this.get(geometry2);geometryData.initialized=!0,this.info.memory.geometries++;const onDispose=()=>{this.info.memory.geometries--;const index=geometry2.index,geometryAttributes=renderObject.getAttributes();index!==null&&this.attributes.delete(index);for(const geometryAttribute of geometryAttributes)this.attributes.delete(geometryAttribute);const wireframeAttribute=this.wireframes.get(geometry2);wireframeAttribute!==void 0&&this.attributes.delete(wireframeAttribute),geometry2.removeEventListener("dispose",onDispose)};geometry2.addEventListener("dispose",onDispose)}updateAttributes(renderObject){const attributes=renderObject.getAttributes();for(const attribute2 of attributes)attribute2.isStorageBufferAttribute||attribute2.isStorageInstancedBufferAttribute?this.updateAttribute(attribute2,AttributeType.STORAGE):this.updateAttribute(attribute2,AttributeType.VERTEX);const index=this.getIndex(renderObject);index!==null&&this.updateAttribute(index,AttributeType.INDEX);const indirect=renderObject.geometry.indirect;indirect!==null&&this.updateAttribute(indirect,AttributeType.INDIRECT)}updateAttribute(attribute2,type){const callId=this.info.render.calls;attribute2.isInterleavedBufferAttribute?this.attributeCall.get(attribute2)===void 0?(this.attributes.update(attribute2,type),this.attributeCall.set(attribute2,callId)):this.attributeCall.get(attribute2.data)!==callId&&(this.attributes.update(attribute2,type),this.attributeCall.set(attribute2.data,callId),this.attributeCall.set(attribute2,callId)):this.attributeCall.get(attribute2)!==callId&&(this.attributes.update(attribute2,type),this.attributeCall.set(attribute2,callId))}getIndirect(renderObject){return renderObject.geometry.indirect}getIndex(renderObject){const{geometry:geometry2,material}=renderObject;let index=geometry2.index;if(material.wireframe===!0){const wireframes=this.wireframes;let wireframeAttribute=wireframes.get(geometry2);wireframeAttribute===void 0?(wireframeAttribute=getWireframeIndex(geometry2),wireframes.set(geometry2,wireframeAttribute)):wireframeAttribute.version!==getWireframeVersion(geometry2)&&(this.attributes.delete(wireframeAttribute),wireframeAttribute=getWireframeIndex(geometry2),wireframes.set(geometry2,wireframeAttribute)),index=wireframeAttribute}return index}}class Info{constructor(){this.autoReset=!0,this.frame=0,this.calls=0,this.render={calls:0,frameCalls:0,drawCalls:0,triangles:0,points:0,lines:0,timestamp:0},this.compute={calls:0,frameCalls:0,timestamp:0},this.memory={geometries:0,textures:0}}update(object,count,instanceCount){this.render.drawCalls++,object.isMesh||object.isSprite?this.render.triangles+=instanceCount*(count/3):object.isPoints?this.render.points+=instanceCount*count:object.isLineSegments?this.render.lines+=instanceCount*(count/2):object.isLine?this.render.lines+=instanceCount*(count-1):console.error("THREE.WebGPUInfo: Unknown object type.")}reset(){this.render.drawCalls=0,this.render.frameCalls=0,this.compute.frameCalls=0,this.render.triangles=0,this.render.points=0,this.render.lines=0}dispose(){this.reset(),this.calls=0,this.render.calls=0,this.compute.calls=0,this.render.timestamp=0,this.compute.timestamp=0,this.memory.geometries=0,this.memory.textures=0}}class Pipeline{constructor(cacheKey){this.cacheKey=cacheKey,this.usedTimes=0}}class RenderPipeline extends Pipeline{constructor(cacheKey,vertexProgram,fragmentProgram){super(cacheKey),this.vertexProgram=vertexProgram,this.fragmentProgram=fragmentProgram}}class ComputePipeline extends Pipeline{constructor(cacheKey,computeProgram){super(cacheKey),this.computeProgram=computeProgram,this.isComputePipeline=!0}}let _id$8=0;class ProgrammableStage{constructor(code2,stage2,name,transforms2=null,attributes=null){this.id=_id$8++,this.code=code2,this.stage=stage2,this.name=name,this.transforms=transforms2,this.attributes=attributes,this.usedTimes=0}}class Pipelines extends DataMap{constructor(backend,nodes){super(),this.backend=backend,this.nodes=nodes,this.bindings=null,this.caches=new Map,this.programs={vertex:new Map,fragment:new Map,compute:new Map}}getForCompute(computeNode,bindings){const{backend}=this,data=this.get(computeNode);if(this._needsComputeUpdate(computeNode)){const previousPipeline=data.pipeline;previousPipeline&&(previousPipeline.usedTimes--,previousPipeline.computeProgram.usedTimes--);const nodeBuilderState=this.nodes.getForCompute(computeNode);let stageCompute=this.programs.compute.get(nodeBuilderState.computeShader);stageCompute===void 0&&(previousPipeline&&previousPipeline.computeProgram.usedTimes===0&&this._releaseProgram(previousPipeline.computeProgram),stageCompute=new ProgrammableStage(nodeBuilderState.computeShader,"compute",computeNode.name,nodeBuilderState.transforms,nodeBuilderState.nodeAttributes),this.programs.compute.set(nodeBuilderState.computeShader,stageCompute),backend.createProgram(stageCompute));const cacheKey=this._getComputeCacheKey(computeNode,stageCompute);let pipeline=this.caches.get(cacheKey);pipeline===void 0&&(previousPipeline&&previousPipeline.usedTimes===0&&this._releasePipeline(previousPipeline),pipeline=this._getComputePipeline(computeNode,stageCompute,cacheKey,bindings)),pipeline.usedTimes++,stageCompute.usedTimes++,data.version=computeNode.version,data.pipeline=pipeline}return data.pipeline}getForRender(renderObject,promises=null){const{backend}=this,data=this.get(renderObject);if(this._needsRenderUpdate(renderObject)){const previousPipeline=data.pipeline;previousPipeline&&(previousPipeline.usedTimes--,previousPipeline.vertexProgram.usedTimes--,previousPipeline.fragmentProgram.usedTimes--);const nodeBuilderState=renderObject.getNodeBuilderState(),name=renderObject.material?renderObject.material.name:"";let stageVertex=this.programs.vertex.get(nodeBuilderState.vertexShader);stageVertex===void 0&&(previousPipeline&&previousPipeline.vertexProgram.usedTimes===0&&this._releaseProgram(previousPipeline.vertexProgram),stageVertex=new ProgrammableStage(nodeBuilderState.vertexShader,"vertex",name),this.programs.vertex.set(nodeBuilderState.vertexShader,stageVertex),backend.createProgram(stageVertex));let stageFragment=this.programs.fragment.get(nodeBuilderState.fragmentShader);stageFragment===void 0&&(previousPipeline&&previousPipeline.fragmentProgram.usedTimes===0&&this._releaseProgram(previousPipeline.fragmentProgram),stageFragment=new ProgrammableStage(nodeBuilderState.fragmentShader,"fragment",name),this.programs.fragment.set(nodeBuilderState.fragmentShader,stageFragment),backend.createProgram(stageFragment));const cacheKey=this._getRenderCacheKey(renderObject,stageVertex,stageFragment);let pipeline=this.caches.get(cacheKey);pipeline===void 0?(previousPipeline&&previousPipeline.usedTimes===0&&this._releasePipeline(previousPipeline),pipeline=this._getRenderPipeline(renderObject,stageVertex,stageFragment,cacheKey,promises)):renderObject.pipeline=pipeline,pipeline.usedTimes++,stageVertex.usedTimes++,stageFragment.usedTimes++,data.pipeline=pipeline}return data.pipeline}delete(object){const pipeline=this.get(object).pipeline;return pipeline&&(pipeline.usedTimes--,pipeline.usedTimes===0&&this._releasePipeline(pipeline),pipeline.isComputePipeline?(pipeline.computeProgram.usedTimes--,pipeline.computeProgram.usedTimes===0&&this._releaseProgram(pipeline.computeProgram)):(pipeline.fragmentProgram.usedTimes--,pipeline.vertexProgram.usedTimes--,pipeline.vertexProgram.usedTimes===0&&this._releaseProgram(pipeline.vertexProgram),pipeline.fragmentProgram.usedTimes===0&&this._releaseProgram(pipeline.fragmentProgram))),super.delete(object)}dispose(){super.dispose(),this.caches=new Map,this.programs={vertex:new Map,fragment:new Map,compute:new Map}}updateForRender(renderObject){this.getForRender(renderObject)}_getComputePipeline(computeNode,stageCompute,cacheKey,bindings){cacheKey=cacheKey||this._getComputeCacheKey(computeNode,stageCompute);let pipeline=this.caches.get(cacheKey);return pipeline===void 0&&(pipeline=new ComputePipeline(cacheKey,stageCompute),this.caches.set(cacheKey,pipeline),this.backend.createComputePipeline(pipeline,bindings)),pipeline}_getRenderPipeline(renderObject,stageVertex,stageFragment,cacheKey,promises){cacheKey=cacheKey||this._getRenderCacheKey(renderObject,stageVertex,stageFragment);let pipeline=this.caches.get(cacheKey);return pipeline===void 0&&(pipeline=new RenderPipeline(cacheKey,stageVertex,stageFragment),this.caches.set(cacheKey,pipeline),renderObject.pipeline=pipeline,this.backend.createRenderPipeline(renderObject,promises)),pipeline}_getComputeCacheKey(computeNode,stageCompute){return computeNode.id+","+stageCompute.id}_getRenderCacheKey(renderObject,stageVertex,stageFragment){return stageVertex.id+","+stageFragment.id+","+this.backend.getRenderCacheKey(renderObject)}_releasePipeline(pipeline){this.caches.delete(pipeline.cacheKey)}_releaseProgram(program){const code2=program.code,stage2=program.stage;this.programs[stage2].delete(code2)}_needsComputeUpdate(computeNode){const data=this.get(computeNode);return data.pipeline===void 0||data.version!==computeNode.version}_needsRenderUpdate(renderObject){return this.get(renderObject).pipeline===void 0||this.backend.needsRenderUpdate(renderObject)}}class Bindings extends DataMap{constructor(backend,nodes,textures,attributes,pipelines,info){super(),this.backend=backend,this.textures=textures,this.pipelines=pipelines,this.attributes=attributes,this.nodes=nodes,this.info=info,this.pipelines.bindings=this}getForRender(renderObject){const bindings=renderObject.getBindings();for(const bindGroup of bindings){const groupData=this.get(bindGroup);groupData.bindGroup===void 0&&(this._init(bindGroup),this.backend.createBindings(bindGroup,bindings,0),groupData.bindGroup=bindGroup)}return bindings}getForCompute(computeNode){const bindings=this.nodes.getForCompute(computeNode).bindings;for(const bindGroup of bindings){const groupData=this.get(bindGroup);groupData.bindGroup===void 0&&(this._init(bindGroup),this.backend.createBindings(bindGroup,bindings,0),groupData.bindGroup=bindGroup)}return bindings}updateForCompute(computeNode){this._updateBindings(this.getForCompute(computeNode))}updateForRender(renderObject){this._updateBindings(this.getForRender(renderObject))}_updateBindings(bindings){for(const bindGroup of bindings)this._update(bindGroup,bindings)}_init(bindGroup){for(const binding of bindGroup.bindings)if(binding.isSampledTexture)this.textures.updateTexture(binding.texture);else if(binding.isStorageBuffer){const attribute2=binding.attribute,attributeType=attribute2.isIndirectStorageBufferAttribute?AttributeType.INDIRECT:AttributeType.STORAGE;this.attributes.update(attribute2,attributeType)}}_update(bindGroup,bindings){const{backend}=this;let needsBindingsUpdate=!1,cacheBindings=!0,cacheIndex=0,version=0;for(const binding of bindGroup.bindings)if(!(binding.isNodeUniformsGroup&&this.nodes.updateGroup(binding)===!1)){if(binding.isStorageBuffer){const attribute2=binding.attribute,attributeType=attribute2.isIndirectStorageBufferAttribute?AttributeType.INDIRECT:AttributeType.STORAGE;this.attributes.update(attribute2,attributeType)}if(binding.isUniformBuffer)binding.update()&&backend.updateBinding(binding);else if(binding.isSampler)binding.update();else if(binding.isSampledTexture){const texturesTextureData=this.textures.get(binding.texture);binding.needsBindingsUpdate(texturesTextureData.generation)&&(needsBindingsUpdate=!0);const updated=binding.update(),texture2=binding.texture;updated&&this.textures.updateTexture(texture2);const textureData=backend.get(texture2);if(textureData.externalTexture!==void 0||texturesTextureData.isDefaultTexture?cacheBindings=!1:(cacheIndex=cacheIndex*10+texture2.id,version+=texture2.version),backend.isWebGPUBackend===!0&&textureData.texture===void 0&&textureData.externalTexture===void 0&&(console.error("Bindings._update: binding should be available:",binding,updated,texture2,binding.textureNode.value,needsBindingsUpdate),this.textures.updateTexture(texture2),needsBindingsUpdate=!0),texture2.isStorageTexture===!0){const textureData2=this.get(texture2);binding.store===!0?textureData2.needsMipmap=!0:this.textures.needsMipmaps(texture2)&&textureData2.needsMipmap===!0&&(this.backend.generateMipmaps(texture2),textureData2.needsMipmap=!1)}}}needsBindingsUpdate===!0&&this.backend.updateBindings(bindGroup,bindings,cacheBindings?cacheIndex:0,version)}}function painterSortStable(a2,b){return a2.groupOrder!==b.groupOrder?a2.groupOrder-b.groupOrder:a2.renderOrder!==b.renderOrder?a2.renderOrder-b.renderOrder:a2.material.id!==b.material.id?a2.material.id-b.material.id:a2.z!==b.z?a2.z-b.z:a2.id-b.id}function reversePainterSortStable(a2,b){return a2.groupOrder!==b.groupOrder?a2.groupOrder-b.groupOrder:a2.renderOrder!==b.renderOrder?a2.renderOrder-b.renderOrder:a2.z!==b.z?b.z-a2.z:a2.id-b.id}function needsDoublePass(material){return(material.transmission>0||material.transmissionNode)&&material.side===DoubleSide&&material.forceSinglePass===!1}class RenderList{constructor(lighting,scene,camera){this.renderItems=[],this.renderItemsIndex=0,this.opaque=[],this.transparentDoublePass=[],this.transparent=[],this.bundles=[],this.lightsNode=lighting.getNode(scene,camera),this.lightsArray=[],this.scene=scene,this.camera=camera,this.occlusionQueryCount=0}begin(){return this.renderItemsIndex=0,this.opaque.length=0,this.transparentDoublePass.length=0,this.transparent.length=0,this.bundles.length=0,this.lightsArray.length=0,this.occlusionQueryCount=0,this}getNextRenderItem(object,geometry2,material,groupOrder,z,group,clippingContext){let renderItem=this.renderItems[this.renderItemsIndex];return renderItem===void 0?(renderItem={id:object.id,object,geometry:geometry2,material,groupOrder,renderOrder:object.renderOrder,z,group,clippingContext},this.renderItems[this.renderItemsIndex]=renderItem):(renderItem.id=object.id,renderItem.object=object,renderItem.geometry=geometry2,renderItem.material=material,renderItem.groupOrder=groupOrder,renderItem.renderOrder=object.renderOrder,renderItem.z=z,renderItem.group=group,renderItem.clippingContext=clippingContext),this.renderItemsIndex++,renderItem}push(object,geometry2,material,groupOrder,z,group,clippingContext){const renderItem=this.getNextRenderItem(object,geometry2,material,groupOrder,z,group,clippingContext);object.occlusionTest===!0&&this.occlusionQueryCount++,material.transparent===!0||material.transmission>0?(needsDoublePass(material)&&this.transparentDoublePass.push(renderItem),this.transparent.push(renderItem)):this.opaque.push(renderItem)}unshift(object,geometry2,material,groupOrder,z,group,clippingContext){const renderItem=this.getNextRenderItem(object,geometry2,material,groupOrder,z,group,clippingContext);material.transparent===!0||material.transmission>0?(needsDoublePass(material)&&this.transparentDoublePass.unshift(renderItem),this.transparent.unshift(renderItem)):this.opaque.unshift(renderItem)}pushBundle(group){this.bundles.push(group)}pushLight(light){this.lightsArray.push(light)}sort(customOpaqueSort,customTransparentSort){this.opaque.length>1&&this.opaque.sort(customOpaqueSort||painterSortStable),this.transparentDoublePass.length>1&&this.transparentDoublePass.sort(customTransparentSort||reversePainterSortStable),this.transparent.length>1&&this.transparent.sort(customTransparentSort||reversePainterSortStable)}finish(){this.lightsNode.setLights(this.lightsArray);for(let i2=this.renderItemsIndex,il=this.renderItems.length;i2<il;i2++){const renderItem=this.renderItems[i2];if(renderItem.id===null)break;renderItem.id=null,renderItem.object=null,renderItem.geometry=null,renderItem.material=null,renderItem.groupOrder=null,renderItem.renderOrder=null,renderItem.z=null,renderItem.group=null,renderItem.clippingContext=null}}}const _chainKeys$4=[];class RenderLists{constructor(lighting){this.lighting=lighting,this.lists=new ChainMap}get(scene,camera){const lists=this.lists;_chainKeys$4[0]=scene,_chainKeys$4[1]=camera;let list=lists.get(_chainKeys$4);return list===void 0&&(list=new RenderList(this.lighting,scene,camera),lists.set(_chainKeys$4,list)),_chainKeys$4.length=0,list}dispose(){this.lists=new ChainMap}}let _id$7=0;class RenderContext{constructor(){this.id=_id$7++,this.color=!0,this.clearColor=!0,this.clearColorValue={r:0,g:0,b:0,a:1},this.depth=!0,this.clearDepth=!0,this.clearDepthValue=1,this.stencil=!1,this.clearStencil=!0,this.clearStencilValue=1,this.viewport=!1,this.viewportValue=new Vector4,this.scissor=!1,this.scissorValue=new Vector4,this.renderTarget=null,this.textures=null,this.depthTexture=null,this.activeCubeFace=0,this.activeMipmapLevel=0,this.sampleCount=1,this.width=0,this.height=0,this.occlusionQueryCount=0,this.clippingContext=null,this.isRenderContext=!0}getCacheKey(){return getCacheKey$2(this)}}function getCacheKey$2(renderContext){const{textures,activeCubeFace}=renderContext,values=[activeCubeFace];for(const texture2 of textures)values.push(texture2.id);return hashArray(values)}const _chainKeys$3=[],_defaultScene=new Scene,_defaultCamera=new Camera;class RenderContexts{constructor(){this.chainMaps={}}get(scene,camera,renderTarget=null){_chainKeys$3[0]=scene,_chainKeys$3[1]=camera;let attachmentState;if(renderTarget===null)attachmentState="default";else{const format=renderTarget.texture.format;attachmentState=`${renderTarget.textures.length}:${format}:${renderTarget.samples}:${renderTarget.depthBuffer}:${renderTarget.stencilBuffer}`}const chainMap=this._getChainMap(attachmentState);let renderState=chainMap.get(_chainKeys$3);return renderState===void 0&&(renderState=new RenderContext,chainMap.set(_chainKeys$3,renderState)),_chainKeys$3.length=0,renderTarget!==null&&(renderState.sampleCount=renderTarget.samples===0?1:renderTarget.samples),renderState}getForClear(renderTarget=null){return this.get(_defaultScene,_defaultCamera,renderTarget)}_getChainMap(attachmentState){return this.chainMaps[attachmentState]||(this.chainMaps[attachmentState]=new ChainMap)}dispose(){this.chainMaps={}}}const _size$3=new Vector3;class Textures extends DataMap{constructor(renderer,backend,info){super(),this.renderer=renderer,this.backend=backend,this.info=info}updateRenderTarget(renderTarget,activeMipmapLevel=0){const renderTargetData=this.get(renderTarget),sampleCount=renderTarget.samples===0?1:renderTarget.samples,depthTextureMips=renderTargetData.depthTextureMips||(renderTargetData.depthTextureMips={}),textures=renderTarget.textures,size=this.getSize(textures[0]),mipWidth=size.width>>activeMipmapLevel,mipHeight=size.height>>activeMipmapLevel;let depthTexture=renderTarget.depthTexture||depthTextureMips[activeMipmapLevel];const useDepthTexture=renderTarget.depthBuffer===!0||renderTarget.stencilBuffer===!0;let textureNeedsUpdate=!1;depthTexture===void 0&&useDepthTexture&&(depthTexture=new DepthTexture,depthTexture.format=renderTarget.stencilBuffer?DepthStencilFormat:DepthFormat,depthTexture.type=renderTarget.stencilBuffer?UnsignedInt248Type:UnsignedIntType,depthTexture.image.width=mipWidth,depthTexture.image.height=mipHeight,depthTextureMips[activeMipmapLevel]=depthTexture),(renderTargetData.width!==size.width||size.height!==renderTargetData.height)&&(textureNeedsUpdate=!0,depthTexture&&(depthTexture.needsUpdate=!0,depthTexture.image.width=mipWidth,depthTexture.image.height=mipHeight)),renderTargetData.width=size.width,renderTargetData.height=size.height,renderTargetData.textures=textures,renderTargetData.depthTexture=depthTexture||null,renderTargetData.depth=renderTarget.depthBuffer,renderTargetData.stencil=renderTarget.stencilBuffer,renderTargetData.renderTarget=renderTarget,renderTargetData.sampleCount!==sampleCount&&(textureNeedsUpdate=!0,depthTexture&&(depthTexture.needsUpdate=!0),renderTargetData.sampleCount=sampleCount);const options={sampleCount};if(renderTarget.isXRRenderTarget!==!0){for(let i2=0;i2<textures.length;i2++){const texture2=textures[i2];textureNeedsUpdate&&(texture2.needsUpdate=!0),this.updateTexture(texture2,options)}depthTexture&&this.updateTexture(depthTexture,options)}if(renderTargetData.initialized!==!0){renderTargetData.initialized=!0;const onDispose=()=>{renderTarget.removeEventListener("dispose",onDispose);for(let i2=0;i2<textures.length;i2++)this._destroyTexture(textures[i2]);depthTexture&&this._destroyTexture(depthTexture),this.delete(renderTarget)};renderTarget.addEventListener("dispose",onDispose)}}updateTexture(texture2,options={}){const textureData=this.get(texture2);if(textureData.initialized===!0&&textureData.version===texture2.version)return;const isRenderTarget=texture2.isRenderTargetTexture||texture2.isDepthTexture||texture2.isFramebufferTexture,backend=this.backend;if(isRenderTarget&&textureData.initialized===!0&&(backend.destroySampler(texture2),backend.destroyTexture(texture2)),texture2.isFramebufferTexture){const renderTarget=this.renderer.getRenderTarget();renderTarget?texture2.type=renderTarget.texture.type:texture2.type=UnsignedByteType}const{width,height,depth:depth2}=this.getSize(texture2);if(options.width=width,options.height=height,options.depth=depth2,options.needsMipmaps=this.needsMipmaps(texture2),options.levels=options.needsMipmaps?this.getMipLevels(texture2,width,height):1,isRenderTarget||texture2.isStorageTexture===!0)backend.createSampler(texture2),backend.createTexture(texture2,options),textureData.generation=texture2.version;else if(textureData.initialized!==!0&&backend.createSampler(texture2),texture2.version>0){const image=texture2.image;if(image===void 0)console.warn("THREE.Renderer: Texture marked for update but image is undefined.");else if(image.complete===!1)console.warn("THREE.Renderer: Texture marked for update but image is incomplete.");else{if(texture2.images){const images=[];for(const image2 of texture2.images)images.push(image2);options.images=images}else options.image=image;(textureData.isDefaultTexture===void 0||textureData.isDefaultTexture===!0)&&(backend.createTexture(texture2,options),textureData.isDefaultTexture=!1,textureData.generation=texture2.version),texture2.source.dataReady===!0&&backend.updateTexture(texture2,options),options.needsMipmaps&&texture2.mipmaps.length===0&&backend.generateMipmaps(texture2)}}else backend.createDefaultTexture(texture2),textureData.isDefaultTexture=!0,textureData.generation=texture2.version;if(textureData.initialized!==!0){textureData.initialized=!0,textureData.generation=texture2.version,this.info.memory.textures++;const onDispose=()=>{texture2.removeEventListener("dispose",onDispose),this._destroyTexture(texture2),this.info.memory.textures--};texture2.addEventListener("dispose",onDispose)}textureData.version=texture2.version}getSize(texture2,target=_size$3){let image=texture2.images?texture2.images[0]:texture2.image;return image?(image.image!==void 0&&(image=image.image),target.width=image.width||1,target.height=image.height||1,target.depth=texture2.isCubeTexture?6:image.depth||1):target.width=target.height=target.depth=1,target}getMipLevels(texture2,width,height){let mipLevelCount;return texture2.isCompressedTexture?texture2.mipmaps?mipLevelCount=texture2.mipmaps.length:mipLevelCount=1:mipLevelCount=Math.floor(Math.log2(Math.max(width,height)))+1,mipLevelCount}needsMipmaps(texture2){return this.isEnvironmentTexture(texture2)||texture2.isCompressedTexture===!0||texture2.generateMipmaps}isEnvironmentTexture(texture2){const mapping=texture2.mapping;return mapping===EquirectangularReflectionMapping||mapping===EquirectangularRefractionMapping||mapping===CubeReflectionMapping||mapping===CubeRefractionMapping}_destroyTexture(texture2){this.backend.destroySampler(texture2),this.backend.destroyTexture(texture2),this.delete(texture2)}}class Color4 extends Color{constructor(r2,g,b,a2=1){super(r2,g,b),this.a=a2}set(r2,g,b,a2=1){return this.a=a2,super.set(r2,g,b)}copy(color2){return color2.a!==void 0&&(this.a=color2.a),super.copy(color2)}clone(){return new this.constructor(this.r,this.g,this.b,this.a)}}class ParameterNode extends PropertyNode{static get type(){return"ParameterNode"}constructor(nodeType,name=null){super(nodeType,name),this.isParameterNode=!0}getHash(){return this.uuid}generate(){return this.name}}const parameter=(type,name)=>nodeObject$1(new ParameterNode(type,name));class StackNode extends Node{static get type(){return"StackNode"}constructor(parent=null){super(),this.nodes=[],this.outputNode=null,this.parent=parent,this._currentCond=null,this.isStackNode=!0}getNodeType(builder){return this.outputNode?this.outputNode.getNodeType(builder):"void"}getMemberType(builder,name){return this.outputNode?this.outputNode.getMemberType(builder,name):"void"}add(node){return this.nodes.push(node),this}If(boolNode,method){const methodNode=new ShaderNode(method);return this._currentCond=select(boolNode,methodNode),this.add(this._currentCond)}ElseIf(boolNode,method){const methodNode=new ShaderNode(method),ifNode=select(boolNode,methodNode);return this._currentCond.elseNode=ifNode,this._currentCond=ifNode,this}Else(method){return this._currentCond.elseNode=new ShaderNode(method),this}build(builder,...params){const previousStack=getCurrentStack();setCurrentStack(this);for(const node of this.nodes)node.build(builder,"void");return setCurrentStack(previousStack),this.outputNode?this.outputNode.build(builder,...params):super.build(builder,...params)}else(...params){return console.warn("TSL.StackNode: .else() has been renamed to .Else()."),this.Else(...params)}elseif(...params){return console.warn("TSL.StackNode: .elseif() has been renamed to .ElseIf()."),this.ElseIf(...params)}}const stack=nodeProxy(StackNode);function getMembersLayout(members){return Object.entries(members).map(([name,value])=>typeof value=="string"?{name,type:value,atomic:!1}:{name,type:value.type,atomic:value.atomic||!1})}class StructTypeNode extends Node{static get type(){return"StructTypeNode"}constructor(membersLayout,name=null){super("struct"),this.membersLayout=getMembersLayout(membersLayout),this.name=name,this.isStructLayoutNode=!0}getLength(){let length2=0;for(const member of this.membersLayout)length2+=getLengthFromType(member.type);return length2}getMemberType(builder,name){const member=this.membersLayout.find(m=>m.name===name);return member?member.type:"void"}getNodeType(builder){return builder.getStructTypeFromNode(this,this.membersLayout,this.name).name}setup(builder){builder.addInclude(this)}generate(builder){return this.getNodeType(builder)}}class StructNode extends Node{static get type(){return"StructNode"}constructor(structLayoutNode,values){super("vec3"),this.structLayoutNode=structLayoutNode,this.values=values,this.isStructNode=!0}getNodeType(builder){return this.structLayoutNode.getNodeType(builder)}getMemberType(builder,name){return this.structLayoutNode.getMemberType(builder,name)}generate(builder){const nodeVar=builder.getVarFromNode(this),structType=nodeVar.type,propertyName=builder.getPropertyName(nodeVar);return builder.addLineFlowCode(`${propertyName} = ${builder.generateStruct(structType,this.structLayoutNode.membersLayout,this.values)}`,this),nodeVar.name}}const struct=(membersLayout,name=null)=>{const structLayout=new StructTypeNode(membersLayout,name),struct2=(...params)=>{let values=null;if(params.length>0)if(params[0].isNode){values={};const names2=Object.keys(membersLayout);for(let i2=0;i2<params.length;i2++)values[names2[i2]]=params[i2]}else values=params[0];return nodeObject$1(new StructNode(structLayout,values))};return struct2.layout=structLayout,struct2.isStruct=!0,struct2};class OutputStructNode extends Node{static get type(){return"OutputStructNode"}constructor(...members){super(),this.members=members,this.isOutputStructNode=!0}getNodeType(builder){const properties=builder.getNodeProperties(this);if(properties.membersLayout===void 0){const members=this.members,membersLayout=[];for(let i2=0;i2<members.length;i2++){const name="m"+i2,type=members[i2].getNodeType(builder);membersLayout.push({name,type,index:i2})}properties.membersLayout=membersLayout,properties.structType=builder.getOutputStructTypeFromNode(this,properties.membersLayout)}return properties.structType.name}generate(builder){const propertyName=builder.getOutputStructName(),members=this.members,structPrefix=propertyName!==""?propertyName+".":"";for(let i2=0;i2<members.length;i2++){const snippet=members[i2].build(builder);builder.addLineFlowCode(`${structPrefix}m${i2} = ${snippet}`,this)}return propertyName}}const outputStruct=nodeProxy(OutputStructNode);function getTextureIndex(textures,name){for(let i2=0;i2<textures.length;i2++)if(textures[i2].name===name)return i2;return-1}class MRTNode extends OutputStructNode{static get type(){return"MRTNode"}constructor(outputNodes){super(),this.outputNodes=outputNodes,this.isMRTNode=!0}has(name){return this.outputNodes[name]!==void 0}get(name){return this.outputNodes[name]}merge(mrtNode){const outputs={...this.outputNodes,...mrtNode.outputNodes};return mrt(outputs)}setup(builder){const outputNodes=this.outputNodes,mrt2=builder.renderer.getRenderTarget(),members=[],textures=mrt2.textures;for(const name in outputNodes){const index=getTextureIndex(textures,name);members[index]=vec4$1(outputNodes[name])}return this.members=members,super.setup(builder)}}const mrt=nodeProxy(MRTNode),hash$2=Fn$1(([seed])=>{const state=seed.toUint().mul(747796405).add(2891336453),word=state.shiftRight(state.shiftRight(28).add(4)).bitXor(state).mul(277803737);return word.shiftRight(22).bitXor(word).toFloat().mul(1/2**32)}),parabola=(x,k)=>pow$1(mul$1(4,x.mul(sub(1,x))),k),gain=(x,k)=>x.lessThan(.5)?parabola(x.mul(2),k).div(2):sub(1,parabola(mul$1(sub(1,x),2),k).div(2)),pcurve=(x,a2,b)=>pow$1(div(pow$1(x,a2),add$3(pow$1(x,a2),pow$1(sub(1,x),b))),1/a2),sinc=(x,k)=>sin$2(PI$1.mul(k.mul(x).sub(1))).div(PI$1.mul(k.mul(x).sub(1))),tri=Fn$1(([x])=>x.fract().sub(.5).abs()).setLayout({name:"tri",type:"float",inputs:[{name:"x",type:"float"}]}),tri3=Fn$1(([p])=>vec3$1(tri(p.z.add(tri(p.y.mul(1)))),tri(p.z.add(tri(p.x.mul(1)))),tri(p.y.add(tri(p.x.mul(1)))))).setLayout({name:"tri3",type:"vec3",inputs:[{name:"p",type:"vec3"}]}),triNoise3D=Fn$1(([position,speed,time2])=>{const p=vec3$1(position).toVar(),z=float$1(1.4).toVar(),rz=float$1(0).toVar(),bp=vec3$1(p).toVar();return Loop({start:float$1(0),end:float$1(3),type:"float",condition:"<="},()=>{const dg=vec3$1(tri3(bp.mul(2))).toVar();p.addAssign(dg.add(time2.mul(float$1(.1).mul(speed)))),bp.mulAssign(1.8),z.mulAssign(1.5),p.mulAssign(1.2);const t2=float$1(tri(p.z.add(tri(p.x.add(tri(p.y)))))).toVar();rz.addAssign(t2.div(z)),bp.addAssign(.14)}),rz}).setLayout({name:"triNoise3D",type:"float",inputs:[{name:"position",type:"vec3"},{name:"speed",type:"float"},{name:"time",type:"float"}]});class FunctionOverloadingNode extends Node{static get type(){return"FunctionOverloadingNode"}constructor(functionNodes=[],...parametersNodes){super(),this.functionNodes=functionNodes,this.parametersNodes=parametersNodes,this._candidateFnCall=null,this.global=!0}getNodeType(){return this.functionNodes[0].shaderNode.layout.type}setup(builder){const params=this.parametersNodes;let candidateFnCall=this._candidateFnCall;if(candidateFnCall===null){let candidateFn=null,candidateScore=-1;for(const functionNode of this.functionNodes){const layout=functionNode.shaderNode.layout;if(layout===null)throw new Error("FunctionOverloadingNode: FunctionNode must be a layout.");const inputs=layout.inputs;if(params.length===inputs.length){let score=0;for(let i2=0;i2<params.length;i2++){const param=params[i2],input=inputs[i2];param.getNodeType(builder)===input.type?score++:score=0}score>candidateScore&&(candidateFn=functionNode,candidateScore=score)}}this._candidateFnCall=candidateFnCall=candidateFn(...params)}return candidateFnCall}}const overloadingBaseFn=nodeProxy(FunctionOverloadingNode),overloadingFn=functionNodes=>(...params)=>overloadingBaseFn(functionNodes,...params),time$1=uniform$1(0).setGroup(renderGroup).onRenderUpdate(frame=>frame.time),deltaTime=uniform$1(0).setGroup(renderGroup).onRenderUpdate(frame=>frame.deltaTime),frameId=uniform$1(0,"uint").setGroup(renderGroup).onRenderUpdate(frame=>frame.frameId),timerLocal=(timeScale=1)=>(console.warn('TSL: timerLocal() is deprecated. Use "time" instead.'),time$1.mul(timeScale)),timerGlobal=(timeScale=1)=>(console.warn('TSL: timerGlobal() is deprecated. Use "time" instead.'),time$1.mul(timeScale)),timerDelta=(timeScale=1)=>(console.warn('TSL: timerDelta() is deprecated. Use "deltaTime" instead.'),deltaTime.mul(timeScale)),oscSine=(t2=time$1)=>t2.add(.75).mul(Math.PI*2).sin().mul(.5).add(.5),oscSquare=(t2=time$1)=>t2.fract().round(),oscTriangle=(t2=time$1)=>t2.add(.5).fract().mul(2).sub(1).abs(),oscSawtooth=(t2=time$1)=>t2.fract(),rotateUV=Fn$1(([uv2,rotation2,center=vec2$1(.5)])=>rotate$2(uv2.sub(center),rotation2).add(center)),spherizeUV=Fn$1(([uv2,strength,center=vec2$1(.5)])=>{const delta=uv2.sub(center),delta2=delta.dot(delta),deltaOffset=delta2.mul(delta2).mul(strength);return uv2.add(delta.mul(deltaOffset))}),billboarding=Fn$1(({position=null,horizontal=!0,vertical=!1})=>{let worldMatrix;position!==null?(worldMatrix=modelWorldMatrix.toVar(),worldMatrix[3][0]=position.x,worldMatrix[3][1]=position.y,worldMatrix[3][2]=position.z):worldMatrix=modelWorldMatrix;const modelViewMatrix2=cameraViewMatrix.mul(worldMatrix);return defined(horizontal)&&(modelViewMatrix2[0][0]=modelWorldMatrix[0].length(),modelViewMatrix2[0][1]=0,modelViewMatrix2[0][2]=0),defined(vertical)&&(modelViewMatrix2[1][0]=0,modelViewMatrix2[1][1]=modelWorldMatrix[1].length(),modelViewMatrix2[1][2]=0),modelViewMatrix2[2][0]=0,modelViewMatrix2[2][1]=0,modelViewMatrix2[2][2]=1,cameraProjectionMatrix.mul(modelViewMatrix2).mul(positionLocal)}),viewportSafeUV=Fn$1(([uv2=null])=>{const depth2=linearDepth();return linearDepth(viewportDepthTexture(uv2)).sub(depth2).lessThan(0).select(screenUV,uv2)});class SpriteSheetUVNode extends Node{static get type(){return"SpriteSheetUVNode"}constructor(countNode,uvNode=uv$1(),frameNode=float$1(0)){super("vec2"),this.countNode=countNode,this.uvNode=uvNode,this.frameNode=frameNode}setup(){const{frameNode,uvNode,countNode}=this,{width,height}=countNode,frameNum=frameNode.mod(width.mul(height)).floor(),column=frameNum.mod(width),row=height.sub(frameNum.add(1).div(width).ceil()),scale2=countNode.reciprocal(),uvFrameOffset=vec2$1(column,row);return uvNode.add(uvFrameOffset).mul(scale2)}}const spritesheetUV=nodeProxy(SpriteSheetUVNode);class TriplanarTexturesNode extends Node{static get type(){return"TriplanarTexturesNode"}constructor(textureXNode,textureYNode=null,textureZNode=null,scaleNode=float$1(1),positionNode=positionLocal,normalNode=normalLocal){super("vec4"),this.textureXNode=textureXNode,this.textureYNode=textureYNode,this.textureZNode=textureZNode,this.scaleNode=scaleNode,this.positionNode=positionNode,this.normalNode=normalNode}setup(){const{textureXNode,textureYNode,textureZNode,scaleNode,positionNode,normalNode}=this;let bf=normalNode.abs().normalize();bf=bf.div(bf.dot(vec3$1(1)));const tx=positionNode.yz.mul(scaleNode),ty=positionNode.zx.mul(scaleNode),tz=positionNode.xy.mul(scaleNode),textureX=textureXNode.value,textureY=textureYNode!==null?textureYNode.value:textureX,textureZ=textureZNode!==null?textureZNode.value:textureX,cx=texture$1(textureX,tx).mul(bf.x),cy=texture$1(textureY,ty).mul(bf.y),cz=texture$1(textureZ,tz).mul(bf.z);return add$3(cx,cy,cz)}}const triplanarTextures=nodeProxy(TriplanarTexturesNode),triplanarTexture=(...params)=>triplanarTextures(...params),_reflectorPlane=new Plane,_normal=new Vector3,_reflectorWorldPosition=new Vector3,_cameraWorldPosition=new Vector3,_rotationMatrix=new Matrix4,_lookAtPosition=new Vector3(0,0,-1),clipPlane=new Vector4,_view=new Vector3,_target=new Vector3,_q=new Vector4,_size$2=new Vector2,_defaultRT=new RenderTarget,_defaultUV=screenUV.flipX();_defaultRT.depthTexture=new DepthTexture(1,1);let _inReflector=!1;class ReflectorNode extends TextureNode{static get type(){return"ReflectorNode"}constructor(parameters={}){super(parameters.defaultTexture||_defaultRT.texture,_defaultUV),this._reflectorBaseNode=parameters.reflector||new ReflectorBaseNode(this,parameters),this._depthNode=null,this.setUpdateMatrix(!1)}get reflector(){return this._reflectorBaseNode}get target(){return this._reflectorBaseNode.target}getDepthNode(){if(this._depthNode===null){if(this._reflectorBaseNode.depth!==!0)throw new Error("THREE.ReflectorNode: Depth node can only be requested when the reflector is created with { depth: true }. ");this._depthNode=nodeObject$1(new ReflectorNode({defaultTexture:_defaultRT.depthTexture,reflector:this._reflectorBaseNode}))}return this._depthNode}setup(builder){return builder.object.isQuadMesh||this._reflectorBaseNode.build(builder),super.setup(builder)}clone(){const texture2=new this.constructor(this.reflectorNode);return texture2._reflectorBaseNode=this._reflectorBaseNode,texture2}}class ReflectorBaseNode extends Node{static get type(){return"ReflectorBaseNode"}constructor(textureNode,parameters={}){super();const{target=new Object3D,resolution=1,generateMipmaps=!1,bounces=!0,depth:depth2=!1}=parameters;this.textureNode=textureNode,this.target=target,this.resolution=resolution,this.generateMipmaps=generateMipmaps,this.bounces=bounces,this.depth=depth2,this.updateBeforeType=bounces?NodeUpdateType.RENDER:NodeUpdateType.FRAME,this.virtualCameras=new WeakMap,this.renderTargets=new WeakMap}_updateResolution(renderTarget,renderer){const resolution=this.resolution;renderer.getDrawingBufferSize(_size$2),renderTarget.setSize(Math.round(_size$2.width*resolution),Math.round(_size$2.height*resolution))}setup(builder){return this._updateResolution(_defaultRT,builder.renderer),super.setup(builder)}getVirtualCamera(camera){let virtualCamera=this.virtualCameras.get(camera);return virtualCamera===void 0&&(virtualCamera=camera.clone(),this.virtualCameras.set(camera,virtualCamera)),virtualCamera}getRenderTarget(camera){let renderTarget=this.renderTargets.get(camera);return renderTarget===void 0&&(renderTarget=new RenderTarget(0,0,{type:HalfFloatType}),this.generateMipmaps===!0&&(renderTarget.texture.minFilter=LinearMipMapLinearFilter,renderTarget.texture.generateMipmaps=!0),this.depth===!0&&(renderTarget.depthTexture=new DepthTexture),this.renderTargets.set(camera,renderTarget)),renderTarget}updateBefore(frame){if(this.bounces===!1&&_inReflector)return!1;_inReflector=!0;const{scene,camera,renderer,material}=frame,{target}=this,virtualCamera=this.getVirtualCamera(camera),renderTarget=this.getRenderTarget(virtualCamera);if(renderer.getDrawingBufferSize(_size$2),this._updateResolution(renderTarget,renderer),_reflectorWorldPosition.setFromMatrixPosition(target.matrixWorld),_cameraWorldPosition.setFromMatrixPosition(camera.matrixWorld),_rotationMatrix.extractRotation(target.matrixWorld),_normal.set(0,0,1),_normal.applyMatrix4(_rotationMatrix),_view.subVectors(_reflectorWorldPosition,_cameraWorldPosition),_view.dot(_normal)>0)return;_view.reflect(_normal).negate(),_view.add(_reflectorWorldPosition),_rotationMatrix.extractRotation(camera.matrixWorld),_lookAtPosition.set(0,0,-1),_lookAtPosition.applyMatrix4(_rotationMatrix),_lookAtPosition.add(_cameraWorldPosition),_target.subVectors(_reflectorWorldPosition,_lookAtPosition),_target.reflect(_normal).negate(),_target.add(_reflectorWorldPosition),virtualCamera.coordinateSystem=camera.coordinateSystem,virtualCamera.position.copy(_view),virtualCamera.up.set(0,1,0),virtualCamera.up.applyMatrix4(_rotationMatrix),virtualCamera.up.reflect(_normal),virtualCamera.lookAt(_target),virtualCamera.near=camera.near,virtualCamera.far=camera.far,virtualCamera.updateMatrixWorld(),virtualCamera.projectionMatrix.copy(camera.projectionMatrix),_reflectorPlane.setFromNormalAndCoplanarPoint(_normal,_reflectorWorldPosition),_reflectorPlane.applyMatrix4(virtualCamera.matrixWorldInverse),clipPlane.set(_reflectorPlane.normal.x,_reflectorPlane.normal.y,_reflectorPlane.normal.z,_reflectorPlane.constant);const projectionMatrix=virtualCamera.projectionMatrix;_q.x=(Math.sign(clipPlane.x)+projectionMatrix.elements[8])/projectionMatrix.elements[0],_q.y=(Math.sign(clipPlane.y)+projectionMatrix.elements[9])/projectionMatrix.elements[5],_q.z=-1,_q.w=(1+projectionMatrix.elements[10])/projectionMatrix.elements[14],clipPlane.multiplyScalar(1/clipPlane.dot(_q));const clipBias=0;projectionMatrix.elements[2]=clipPlane.x,projectionMatrix.elements[6]=clipPlane.y,projectionMatrix.elements[10]=renderer.coordinateSystem===WebGPUCoordinateSystem?clipPlane.z-clipBias:clipPlane.z+1-clipBias,projectionMatrix.elements[14]=clipPlane.w,this.textureNode.value=renderTarget.texture,this.depth===!0&&(this.textureNode.getDepthNode().value=renderTarget.depthTexture),material.visible=!1;const currentRenderTarget=renderer.getRenderTarget(),currentMRT=renderer.getMRT(),currentAutoClear=renderer.autoClear;renderer.setMRT(null),renderer.setRenderTarget(renderTarget),renderer.autoClear=!0,renderer.render(scene,virtualCamera),renderer.setMRT(currentMRT),renderer.setRenderTarget(currentRenderTarget),renderer.autoClear=currentAutoClear,material.visible=!0,_inReflector=!1}}const reflector=parameters=>nodeObject$1(new ReflectorNode(parameters)),_camera=new OrthographicCamera(-1,1,1,-1,0,1);class QuadGeometry extends BufferGeometry{constructor(flipY=!1){super();const uv2=flipY===!1?[0,-1,0,1,2,1]:[0,2,0,0,2,0];this.setAttribute("position",new Float32BufferAttribute([-1,3,0,-1,-1,0,3,-1,0],3)),this.setAttribute("uv",new Float32BufferAttribute(uv2,2))}}const _geometry=new QuadGeometry;class QuadMesh extends Mesh{constructor(material=null){super(_geometry,material),this.camera=_camera,this.isQuadMesh=!0}async renderAsync(renderer){return renderer.renderAsync(this,_camera)}render(renderer){renderer.render(this,_camera)}}const _size$1=new Vector2;class RTTNode extends TextureNode{static get type(){return"RTTNode"}constructor(node,width=null,height=null,options={type:HalfFloatType}){const renderTarget=new RenderTarget(width,height,options);super(renderTarget.texture,uv$1()),this.node=node,this.width=width,this.height=height,this.pixelRatio=1,this.renderTarget=renderTarget,this.textureNeedsUpdate=!0,this.autoUpdate=!0,this._rttNode=null,this._quadMesh=new QuadMesh(new NodeMaterial),this.updateBeforeType=NodeUpdateType.RENDER}get autoSize(){return this.width===null}setup(builder){return this._rttNode=this.node.context(builder.getSharedContext()),this._quadMesh.material.name="RTT",this._quadMesh.material.needsUpdate=!0,super.setup(builder)}setSize(width,height){this.width=width,this.height=height;const effectiveWidth=width*this.pixelRatio,effectiveHeight=height*this.pixelRatio;this.renderTarget.setSize(effectiveWidth,effectiveHeight),this.textureNeedsUpdate=!0}setPixelRatio(pixelRatio){this.pixelRatio=pixelRatio,this.setSize(this.width,this.height)}updateBefore({renderer}){if(this.textureNeedsUpdate===!1&&this.autoUpdate===!1)return;if(this.textureNeedsUpdate=!1,this.autoSize===!0){this.pixelRatio=renderer.getPixelRatio();const size=renderer.getSize(_size$1);this.setSize(size.width,size.height)}this._quadMesh.material.fragmentNode=this._rttNode;const currentRenderTarget=renderer.getRenderTarget();renderer.setRenderTarget(this.renderTarget),this._quadMesh.render(renderer),renderer.setRenderTarget(currentRenderTarget)}clone(){const newNode=new TextureNode(this.value,this.uvNode,this.levelNode);return newNode.sampler=this.sampler,newNode.referenceNode=this,newNode}}const rtt=(node,...params)=>nodeObject$1(new RTTNode(nodeObject$1(node),...params)),convertToTexture$1=(node,...params)=>node.isTextureNode?node:node.isPassNode?node.getTextureNode():rtt(node,...params),getViewPosition=Fn$1(([screenPosition,depth2,projectionMatrixInverse],builder)=>{let clipSpacePosition;builder.renderer.coordinateSystem===WebGPUCoordinateSystem?(screenPosition=vec2$1(screenPosition.x,screenPosition.y.oneMinus()).mul(2).sub(1),clipSpacePosition=vec4$1(vec3$1(screenPosition,depth2),1)):clipSpacePosition=vec4$1(vec3$1(screenPosition.x,screenPosition.y.oneMinus(),depth2).mul(2).sub(1),1);const viewSpacePosition=vec4$1(projectionMatrixInverse.mul(clipSpacePosition));return viewSpacePosition.xyz.div(viewSpacePosition.w)}),getScreenPosition=Fn$1(([viewPosition,projectionMatrix])=>{const sampleClipPos=projectionMatrix.mul(vec4$1(viewPosition,1)),sampleUv=sampleClipPos.xy.div(sampleClipPos.w).mul(.5).add(.5).toVar();return vec2$1(sampleUv.x,sampleUv.y.oneMinus())}),getNormalFromDepth=Fn$1(([uv2,depthTexture,projectionMatrixInverse])=>{const size=textureSize(textureLoad(depthTexture)),p=ivec2(uv2.mul(size)).toVar(),c0=textureLoad(depthTexture,p).toVar(),l2=textureLoad(depthTexture,p.sub(ivec2(2,0))).toVar(),l1=textureLoad(depthTexture,p.sub(ivec2(1,0))).toVar(),r1=textureLoad(depthTexture,p.add(ivec2(1,0))).toVar(),r2=textureLoad(depthTexture,p.add(ivec2(2,0))).toVar(),b2=textureLoad(depthTexture,p.add(ivec2(0,2))).toVar(),b1=textureLoad(depthTexture,p.add(ivec2(0,1))).toVar(),t1=textureLoad(depthTexture,p.sub(ivec2(0,1))).toVar(),t2=textureLoad(depthTexture,p.sub(ivec2(0,2))).toVar(),dl=abs$2(sub(float$1(2).mul(l1).sub(l2),c0)).toVar(),dr=abs$2(sub(float$1(2).mul(r1).sub(r2),c0)).toVar(),db=abs$2(sub(float$1(2).mul(b1).sub(b2),c0)).toVar(),dt=abs$2(sub(float$1(2).mul(t1).sub(t2),c0)).toVar(),ce=getViewPosition(uv2,c0,projectionMatrixInverse).toVar(),dpdx=dl.lessThan(dr).select(ce.sub(getViewPosition(uv2.sub(vec2$1(float$1(1).div(size.x),0)),l1,projectionMatrixInverse)),ce.negate().add(getViewPosition(uv2.add(vec2$1(float$1(1).div(size.x),0)),r1,projectionMatrixInverse))),dpdy=db.lessThan(dt).select(ce.sub(getViewPosition(uv2.add(vec2$1(0,float$1(1).div(size.y))),b1,projectionMatrixInverse)),ce.negate().add(getViewPosition(uv2.sub(vec2$1(0,float$1(1).div(size.y))),t1,projectionMatrixInverse)));return normalize$1(cross(dpdx,dpdy))});class StorageInstancedBufferAttribute extends InstancedBufferAttribute{constructor(count,itemSize,typeClass=Float32Array){const array2=ArrayBuffer.isView(count)?count:new typeClass(count*itemSize);super(array2,itemSize),this.isStorageInstancedBufferAttribute=!0}}class StorageBufferAttribute extends BufferAttribute{constructor(count,itemSize,typeClass=Float32Array){const array2=ArrayBuffer.isView(count)?count:new typeClass(count*itemSize);super(array2,itemSize),this.isStorageBufferAttribute=!0}}class StorageArrayElementNode extends ArrayElementNode{static get type(){return"StorageArrayElementNode"}constructor(storageBufferNode,indexNode){super(storageBufferNode,indexNode),this.isStorageArrayElementNode=!0}set storageBufferNode(value){this.node=value}get storageBufferNode(){return this.node}getMemberType(builder,name){const structTypeNode=this.storageBufferNode.structTypeNode;return structTypeNode?structTypeNode.getMemberType(builder,name):"void"}setup(builder){return builder.isAvailable("storageBuffer")===!1&&this.node.isPBO===!0&&builder.setupPBO(this.node),super.setup(builder)}generate(builder,output2){let snippet;const isAssignContext=builder.context.assign;if(builder.isAvailable("storageBuffer")===!1?this.node.isPBO===!0&&isAssignContext!==!0&&(this.node.value.isInstancedBufferAttribute||builder.shaderStage!=="compute")?snippet=builder.generatePBO(this):snippet=this.node.build(builder):snippet=super.generate(builder),isAssignContext!==!0){const type=this.getNodeType(builder);snippet=builder.format(snippet,type,output2)}return snippet}}const storageElement=nodeProxy(StorageArrayElementNode);class StorageBufferNode extends BufferNode{static get type(){return"StorageBufferNode"}constructor(value,bufferType=null,bufferCount=0){let nodeType,structTypeNode=null;bufferType&&bufferType.isStruct?(nodeType="struct",structTypeNode=bufferType.layout):bufferType===null&&(value.isStorageBufferAttribute||value.isStorageInstancedBufferAttribute)?(nodeType=getTypeFromLength(value.itemSize),bufferCount=value.count):nodeType=bufferType,super(value,nodeType,bufferCount),this.isStorageBufferNode=!0,this.structTypeNode=structTypeNode,this.access=NodeAccess.READ_WRITE,this.isAtomic=!1,this.isPBO=!1,this._attribute=null,this._varying=null,this.global=!0,value.isStorageBufferAttribute!==!0&&value.isStorageInstancedBufferAttribute!==!0&&(value.isInstancedBufferAttribute?value.isStorageInstancedBufferAttribute=!0:value.isStorageBufferAttribute=!0)}getHash(builder){if(this.bufferCount===0){let bufferData=builder.globalCache.getData(this.value);return bufferData===void 0&&(bufferData={node:this},builder.globalCache.setData(this.value,bufferData)),bufferData.node.uuid}return this.uuid}getInputType(){return this.value.isIndirectStorageBufferAttribute?"indirectStorageBuffer":"storageBuffer"}element(indexNode){return storageElement(this,indexNode)}setPBO(value){return this.isPBO=value,this}getPBO(){return this.isPBO}setAccess(value){return this.access=value,this}toReadOnly(){return this.setAccess(NodeAccess.READ_ONLY)}setAtomic(value){return this.isAtomic=value,this}toAtomic(){return this.setAtomic(!0)}getAttributeData(){return this._attribute===null&&(this._attribute=bufferAttribute(this.value),this._varying=varying(this._attribute)),{attribute:this._attribute,varying:this._varying}}getNodeType(builder){if(this.structTypeNode!==null)return this.structTypeNode.getNodeType(builder);if(builder.isAvailable("storageBuffer")||builder.isAvailable("indirectStorageBuffer"))return super.getNodeType(builder);const{attribute:attribute2}=this.getAttributeData();return attribute2.getNodeType(builder)}generate(builder){if(this.structTypeNode!==null&&this.structTypeNode.build(builder),builder.isAvailable("storageBuffer")||builder.isAvailable("indirectStorageBuffer"))return super.generate(builder);const{attribute:attribute2,varying:varying2}=this.getAttributeData(),output2=varying2.build(builder);return builder.registerTransform(output2,attribute2),output2}}const storage=(value,type=null,count=0)=>nodeObject$1(new StorageBufferNode(value,type,count)),storageObject=(value,type,count)=>(console.warn('THREE.TSL: "storageObject()" is deprecated. Use "storage().setPBO( true )" instead.'),storage(value,type,count).setPBO(!0)),attributeArray=(count,type="float")=>{let itemSize,typedArray;type.isStruct===!0?(itemSize=type.layout.getLength(),typedArray=getTypedArrayFromType("float")):(itemSize=getLengthFromType(type),typedArray=getTypedArrayFromType(type));const buffer2=new StorageBufferAttribute(count,itemSize,typedArray);return storage(buffer2,type,count)},instancedArray$1=(count,type="float")=>{let itemSize,typedArray;type.isStruct===!0?(itemSize=type.layout.getLength(),typedArray=getTypedArrayFromType("float")):(itemSize=getLengthFromType(type),typedArray=getTypedArrayFromType(type));const buffer2=new StorageInstancedBufferAttribute(count,itemSize,typedArray);return storage(buffer2,type,count)};class VertexColorNode extends AttributeNode{static get type(){return"VertexColorNode"}constructor(index=0){super(null,"vec4"),this.isVertexColorNode=!0,this.index=index}getAttributeName(){const index=this.index;return"color"+(index>0?index:"")}generate(builder){const attributeName=this.getAttributeName(builder),geometryAttribute=builder.hasGeometryAttribute(attributeName);let result;return geometryAttribute===!0?result=super.generate(builder):result=builder.generateConst(this.nodeType,new Vector4(1,1,1,1)),result}serialize(data){super.serialize(data),data.index=this.index}deserialize(data){super.deserialize(data),this.index=data.index}}const vertexColor=index=>nodeObject$1(new VertexColorNode(index));class PointUVNode extends Node{static get type(){return"PointUVNode"}constructor(){super("vec2"),this.isPointUVNode=!0}generate(){return"vec2( gl_PointCoord.x, 1.0 - gl_PointCoord.y )"}}const pointUV=nodeImmutable(PointUVNode),_e1=new Euler,_m1=new Matrix4;class SceneNode extends Node{static get type(){return"SceneNode"}constructor(scope=SceneNode.BACKGROUND_BLURRINESS,scene=null){super(),this.scope=scope,this.scene=scene}setup(builder){const scope=this.scope,scene=this.scene!==null?this.scene:builder.scene;let output2;return scope===SceneNode.BACKGROUND_BLURRINESS?output2=reference("backgroundBlurriness","float",scene):scope===SceneNode.BACKGROUND_INTENSITY?output2=reference("backgroundIntensity","float",scene):scope===SceneNode.BACKGROUND_ROTATION?output2=uniform$1("mat4").label("backgroundRotation").setGroup(renderGroup).onRenderUpdate(()=>{const background=scene.background;return background!==null&&background.isTexture&&background.mapping!==UVMapping?(_e1.copy(scene.backgroundRotation),_e1.x*=-1,_e1.y*=-1,_e1.z*=-1,_m1.makeRotationFromEuler(_e1)):_m1.identity(),_m1}):console.error("THREE.SceneNode: Unknown scope:",scope),output2}}SceneNode.BACKGROUND_BLURRINESS="backgroundBlurriness";SceneNode.BACKGROUND_INTENSITY="backgroundIntensity";SceneNode.BACKGROUND_ROTATION="backgroundRotation";const backgroundBlurriness=nodeImmutable(SceneNode,SceneNode.BACKGROUND_BLURRINESS),backgroundIntensity=nodeImmutable(SceneNode,SceneNode.BACKGROUND_INTENSITY),backgroundRotation=nodeImmutable(SceneNode,SceneNode.BACKGROUND_ROTATION);class StorageTextureNode extends TextureNode{static get type(){return"StorageTextureNode"}constructor(value,uvNode,storeNode=null){super(value,uvNode),this.storeNode=storeNode,this.isStorageTextureNode=!0,this.access=NodeAccess.WRITE_ONLY}getInputType(){return"storageTexture"}setup(builder){super.setup(builder);const properties=builder.getNodeProperties(this);properties.storeNode=this.storeNode}setAccess(value){return this.access=value,this}generate(builder,output2){let snippet;return this.storeNode!==null?snippet=this.generateStore(builder):snippet=super.generate(builder,output2),snippet}toReadWrite(){return this.setAccess(NodeAccess.READ_WRITE)}toReadOnly(){return this.setAccess(NodeAccess.READ_ONLY)}toWriteOnly(){return this.setAccess(NodeAccess.WRITE_ONLY)}generateStore(builder){const properties=builder.getNodeProperties(this),{uvNode,storeNode}=properties,textureProperty=super.generate(builder,"property"),uvSnippet=uvNode.build(builder,"uvec2"),storeSnippet=storeNode.build(builder,"vec4"),snippet=builder.generateTextureStore(builder,textureProperty,uvSnippet,storeSnippet);builder.addLineFlowCode(snippet,this)}}const storageTexture=nodeProxy(StorageTextureNode),textureStore=(value,uvNode,storeNode)=>{const node=storageTexture(value,uvNode,storeNode);return storeNode!==null&&node.append(),node},normal=Fn$1(({texture:texture2,uv:uv2})=>{const ret=vec3$1().toVar();return If$1(uv2.x.lessThan(1e-4),()=>{ret.assign(vec3$1(1,0,0))}).ElseIf(uv2.y.lessThan(1e-4),()=>{ret.assign(vec3$1(0,1,0))}).ElseIf(uv2.z.lessThan(1e-4),()=>{ret.assign(vec3$1(0,0,1))}).ElseIf(uv2.x.greaterThan(1-1e-4),()=>{ret.assign(vec3$1(-1,0,0))}).ElseIf(uv2.y.greaterThan(1-1e-4),()=>{ret.assign(vec3$1(0,-1,0))}).ElseIf(uv2.z.greaterThan(1-1e-4),()=>{ret.assign(vec3$1(0,0,-1))}).Else(()=>{const x=texture2.sample(uv2.add(vec3$1(-.01,0,0))).r.sub(texture2.sample(uv2.add(vec3$1(.01,0,0))).r),y=texture2.sample(uv2.add(vec3$1(0,-.01,0))).r.sub(texture2.sample(uv2.add(vec3$1(0,.01,0))).r),z=texture2.sample(uv2.add(vec3$1(0,0,-.01))).r.sub(texture2.sample(uv2.add(vec3$1(0,0,.01))).r);ret.assign(vec3$1(x,y,z))}),ret.normalize()});class Texture3DNode extends TextureNode{static get type(){return"Texture3DNode"}constructor(value,uvNode=null,levelNode=null){super(value,uvNode,levelNode),this.isTexture3DNode=!0}getInputType(){return"texture3D"}getDefaultUV(){return vec3$1(.5,.5,.5)}setUpdateMatrix(){}setupUV(builder,uvNode){const texture2=this.value;return builder.isFlipY()&&(texture2.isRenderTargetTexture===!0||texture2.isFramebufferTexture===!0)&&(this.sampler?uvNode=uvNode.flipY():uvNode=uvNode.setY(int(textureSize(this,this.levelNode).y).sub(uvNode.y).sub(1))),uvNode}generateUV(builder,uvNode){return uvNode.build(builder,"vec3")}normal(uvNode){return normal({texture:this,uv:uvNode})}}const texture3D=nodeProxy(Texture3DNode);class UserDataNode extends ReferenceNode{static get type(){return"UserDataNode"}constructor(property2,inputType,userData2=null){super(property2,inputType,userData2),this.userData=userData2}updateReference(state){return this.reference=this.userData!==null?this.userData:state.object.userData,this.reference}}const userData=(name,inputType,userData2)=>nodeObject$1(new UserDataNode(name,inputType,userData2)),_objectData=new WeakMap;class VelocityNode extends TempNode{static get type(){return"VelocityNode"}constructor(){super("vec2"),this.projectionMatrix=null,this.updateType=NodeUpdateType.OBJECT,this.updateAfterType=NodeUpdateType.OBJECT,this.previousModelWorldMatrix=uniform$1(new Matrix4),this.previousProjectionMatrix=uniform$1(new Matrix4).setGroup(renderGroup),this.previousCameraViewMatrix=uniform$1(new Matrix4)}setProjectionMatrix(projectionMatrix){this.projectionMatrix=projectionMatrix}update({frameId:frameId2,camera,object}){const previousModelMatrix=getPreviousMatrix(object);this.previousModelWorldMatrix.value.copy(previousModelMatrix);const cameraData=getData(camera);cameraData.frameId!==frameId2&&(cameraData.frameId=frameId2,cameraData.previousProjectionMatrix===void 0?(cameraData.previousProjectionMatrix=new Matrix4,cameraData.previousCameraViewMatrix=new Matrix4,cameraData.currentProjectionMatrix=new Matrix4,cameraData.currentCameraViewMatrix=new Matrix4,cameraData.previousProjectionMatrix.copy(this.projectionMatrix||camera.projectionMatrix),cameraData.previousCameraViewMatrix.copy(camera.matrixWorldInverse)):(cameraData.previousProjectionMatrix.copy(cameraData.currentProjectionMatrix),cameraData.previousCameraViewMatrix.copy(cameraData.currentCameraViewMatrix)),cameraData.currentProjectionMatrix.copy(this.projectionMatrix||camera.projectionMatrix),cameraData.currentCameraViewMatrix.copy(camera.matrixWorldInverse),this.previousProjectionMatrix.value.copy(cameraData.previousProjectionMatrix),this.previousCameraViewMatrix.value.copy(cameraData.previousCameraViewMatrix))}updateAfter({object}){getPreviousMatrix(object).copy(object.matrixWorld)}setup(){const projectionMatrix=this.projectionMatrix===null?cameraProjectionMatrix:uniform$1(this.projectionMatrix),previousModelViewMatrix=this.previousCameraViewMatrix.mul(this.previousModelWorldMatrix),clipPositionCurrent=projectionMatrix.mul(modelViewMatrix).mul(positionLocal),clipPositionPrevious=this.previousProjectionMatrix.mul(previousModelViewMatrix).mul(positionPrevious),ndcPositionCurrent=clipPositionCurrent.xy.div(clipPositionCurrent.w),ndcPositionPrevious=clipPositionPrevious.xy.div(clipPositionPrevious.w);return sub(ndcPositionCurrent,ndcPositionPrevious)}}function getData(object){let objectData=_objectData.get(object);return objectData===void 0&&(objectData={},_objectData.set(object,objectData)),objectData}function getPreviousMatrix(object,index=0){const objectData=getData(object);let matrix=objectData[index];return matrix===void 0&&(objectData[index]=matrix=new Matrix4),matrix}const velocity=nodeImmutable(VelocityNode),blendBurn=Fn$1(([base,blend])=>min$1(1,base.oneMinus().div(blend)).oneMinus()).setLayout({name:"blendBurn",type:"vec3",inputs:[{name:"base",type:"vec3"},{name:"blend",type:"vec3"}]}),blendDodge=Fn$1(([base,blend])=>min$1(base.div(blend.oneMinus()),1)).setLayout({name:"blendDodge",type:"vec3",inputs:[{name:"base",type:"vec3"},{name:"blend",type:"vec3"}]}),blendScreen=Fn$1(([base,blend])=>base.oneMinus().mul(blend.oneMinus()).oneMinus()).setLayout({name:"blendScreen",type:"vec3",inputs:[{name:"base",type:"vec3"},{name:"blend",type:"vec3"}]}),blendOverlay=Fn$1(([base,blend])=>mix$1(base.mul(2).mul(blend),base.oneMinus().mul(2).mul(blend.oneMinus()).oneMinus(),step$1(.5,base))).setLayout({name:"blendOverlay",type:"vec3",inputs:[{name:"base",type:"vec3"},{name:"blend",type:"vec3"}]}),blendColor=Fn$1(([base,blend])=>{const outAlpha=blend.a.add(base.a.mul(blend.a.oneMinus()));return vec4$1(blend.rgb.mul(blend.a).add(base.rgb.mul(base.a).mul(blend.a.oneMinus())).div(outAlpha),outAlpha)}).setLayout({name:"blendColor",type:"vec4",inputs:[{name:"base",type:"vec4"},{name:"blend",type:"vec4"}]}),burn=(...params)=>(console.warn('THREE.TSL: "burn" has been renamed. Use "blendBurn" instead.'),blendBurn(params)),dodge=(...params)=>(console.warn('THREE.TSL: "dodge" has been renamed. Use "blendDodge" instead.'),blendDodge(params)),screen=(...params)=>(console.warn('THREE.TSL: "screen" has been renamed. Use "blendScreen" instead.'),blendScreen(params)),overlay=(...params)=>(console.warn('THREE.TSL: "overlay" has been renamed. Use "blendOverlay" instead.'),blendOverlay(params)),grayscale=Fn$1(([color2])=>luminance(color2.rgb)),saturation=Fn$1(([color2,adjustment=float$1(1)])=>adjustment.mix(luminance(color2.rgb),color2.rgb)),vibrance=Fn$1(([color2,adjustment=float$1(1)])=>{const average=add$3(color2.r,color2.g,color2.b).div(3),mx=color2.r.max(color2.g.max(color2.b)),amt=mx.sub(average).mul(adjustment).mul(-3);return mix$1(color2.rgb,mx,amt)}),hue=Fn$1(([color2,adjustment=float$1(1)])=>{const k=vec3$1(.57735,.57735,.57735),cosAngle=adjustment.cos();return vec3$1(color2.rgb.mul(cosAngle).add(k.cross(color2.rgb).mul(adjustment.sin()).add(k.mul(dot(k,color2.rgb).mul(cosAngle.oneMinus())))))}),luminance=(color2,luminanceCoefficients=vec3$1(ColorManagement.getLuminanceCoefficients(new Vector3)))=>dot(color2,luminanceCoefficients),cdl=Fn$1(([color2,slope=vec3$1(1),offset=vec3$1(0),power=vec3$1(1),saturation2=float$1(1),luminanceCoefficients=vec3$1(ColorManagement.getLuminanceCoefficients(new Vector3,LinearSRGBColorSpace))])=>{const luma=color2.rgb.dot(vec3$1(luminanceCoefficients)),v=max$1(color2.rgb.mul(slope).add(offset),0).toVar(),pv=v.pow(power).toVar();return If$1(v.r.greaterThan(0),()=>{v.r.assign(pv.r)}),If$1(v.g.greaterThan(0),()=>{v.g.assign(pv.g)}),If$1(v.b.greaterThan(0),()=>{v.b.assign(pv.b)}),v.assign(luma.add(v.sub(luma).mul(saturation2))),vec4$1(v.rgb,color2.a)});class PosterizeNode extends TempNode{static get type(){return"PosterizeNode"}constructor(sourceNode,stepsNode){super(),this.sourceNode=sourceNode,this.stepsNode=stepsNode}setup(){const{sourceNode,stepsNode}=this;return sourceNode.mul(stepsNode).floor().div(stepsNode)}}const posterize=nodeProxy(PosterizeNode),_size$5=new Vector2;class PassTextureNode extends TextureNode{static get type(){return"PassTextureNode"}constructor(passNode,texture2){super(texture2),this.passNode=passNode,this.setUpdateMatrix(!1)}setup(builder){return builder.object.isQuadMesh&&this.passNode.build(builder),super.setup(builder)}clone(){return new this.constructor(this.passNode,this.value)}}class PassMultipleTextureNode extends PassTextureNode{static get type(){return"PassMultipleTextureNode"}constructor(passNode,textureName,previousTexture=!1){super(passNode,null),this.textureName=textureName,this.previousTexture=previousTexture}updateTexture(){this.value=this.previousTexture?this.passNode.getPreviousTexture(this.textureName):this.passNode.getTexture(this.textureName)}setup(builder){return this.updateTexture(),super.setup(builder)}clone(){return new this.constructor(this.passNode,this.textureName,this.previousTexture)}}class PassNode extends TempNode{static get type(){return"PassNode"}constructor(scope,scene,camera,options={}){super("vec4"),this.scope=scope,this.scene=scene,this.camera=camera,this.options=options,this._pixelRatio=1,this._width=1,this._height=1;const depthTexture=new DepthTexture;depthTexture.isRenderTargetTexture=!0,depthTexture.name="depth";const renderTarget=new RenderTarget(this._width*this._pixelRatio,this._height*this._pixelRatio,{type:HalfFloatType,...options});renderTarget.texture.name="output",renderTarget.depthTexture=depthTexture,this.renderTarget=renderTarget,this._textures={output:renderTarget.texture,depth:depthTexture},this._textureNodes={},this._linearDepthNodes={},this._viewZNodes={},this._previousTextures={},this._previousTextureNodes={},this._cameraNear=uniform$1(0),this._cameraFar=uniform$1(0),this._mrt=null,this._layers=null,this._resolution=1,this.isPassNode=!0,this.updateBeforeType=NodeUpdateType.FRAME}setResolution(resolution){return this._resolution=resolution,this}getResolution(){return this._resolution}setLayers(layers2){return this._layers=layers2,this}getLayers(){return this._layers}setMRT(mrt2){return this._mrt=mrt2,this}getMRT(){return this._mrt}isGlobal(){return!0}getTexture(name){let texture2=this._textures[name];return texture2===void 0&&(texture2=this.renderTarget.texture.clone(),texture2.name=name,this._textures[name]=texture2,this.renderTarget.textures.push(texture2)),texture2}getPreviousTexture(name){let texture2=this._previousTextures[name];return texture2===void 0&&(texture2=this.getTexture(name).clone(),this._previousTextures[name]=texture2),texture2}toggleTexture(name){const prevTexture=this._previousTextures[name];if(prevTexture!==void 0){const texture2=this._textures[name],index=this.renderTarget.textures.indexOf(texture2);this.renderTarget.textures[index]=prevTexture,this._textures[name]=prevTexture,this._previousTextures[name]=texture2,this._textureNodes[name].updateTexture(),this._previousTextureNodes[name].updateTexture()}}getTextureNode(name="output"){let textureNode=this._textureNodes[name];return textureNode===void 0&&(textureNode=nodeObject$1(new PassMultipleTextureNode(this,name)),textureNode.updateTexture(),this._textureNodes[name]=textureNode),textureNode}getPreviousTextureNode(name="output"){let textureNode=this._previousTextureNodes[name];return textureNode===void 0&&(this._textureNodes[name]===void 0&&this.getTextureNode(name),textureNode=nodeObject$1(new PassMultipleTextureNode(this,name,!0)),textureNode.updateTexture(),this._previousTextureNodes[name]=textureNode),textureNode}getViewZNode(name="depth"){let viewZNode=this._viewZNodes[name];if(viewZNode===void 0){const cameraNear2=this._cameraNear,cameraFar2=this._cameraFar;this._viewZNodes[name]=viewZNode=perspectiveDepthToViewZ(this.getTextureNode(name),cameraNear2,cameraFar2)}return viewZNode}getLinearDepthNode(name="depth"){let linearDepthNode=this._linearDepthNodes[name];if(linearDepthNode===void 0){const cameraNear2=this._cameraNear,cameraFar2=this._cameraFar,viewZNode=this.getViewZNode(name);this._linearDepthNodes[name]=linearDepthNode=viewZToOrthographicDepth(viewZNode,cameraNear2,cameraFar2)}return linearDepthNode}setup({renderer}){return this.renderTarget.samples=this.options.samples===void 0?renderer.samples:this.options.samples,renderer.backend.isWebGLBackend===!0&&(this.renderTarget.samples=0),this.renderTarget.texture.type=renderer.getColorBufferType(),this.scope===PassNode.COLOR?this.getTextureNode():this.getLinearDepthNode()}updateBefore(frame){const{renderer}=frame,{scene}=this;let camera,pixelRatio;const outputRenderTarget=renderer.getOutputRenderTarget();outputRenderTarget&&outputRenderTarget.isXRRenderTarget===!0?(pixelRatio=1,camera=renderer.xr.getCamera(),renderer.xr.updateCamera(camera),_size$5.set(outputRenderTarget.width,outputRenderTarget.height)):(camera=this.camera,pixelRatio=renderer.getPixelRatio(),renderer.getSize(_size$5)),this._pixelRatio=pixelRatio,this.setSize(_size$5.width,_size$5.height);const currentRenderTarget=renderer.getRenderTarget(),currentMRT=renderer.getMRT(),currentMask=camera.layers.mask;this._cameraNear.value=camera.near,this._cameraFar.value=camera.far,this._layers!==null&&(camera.layers.mask=this._layers.mask);for(const name in this._previousTextures)this.toggleTexture(name);renderer.setRenderTarget(this.renderTarget),renderer.setMRT(this._mrt),renderer.render(scene,camera),renderer.setRenderTarget(currentRenderTarget),renderer.setMRT(currentMRT),camera.layers.mask=currentMask}setSize(width,height){this._width=width,this._height=height;const effectiveWidth=this._width*this._pixelRatio*this._resolution,effectiveHeight=this._height*this._pixelRatio*this._resolution;this.renderTarget.setSize(effectiveWidth,effectiveHeight)}setPixelRatio(pixelRatio){this._pixelRatio=pixelRatio,this.setSize(this._width,this._height)}dispose(){this.renderTarget.dispose()}}PassNode.COLOR="color";PassNode.DEPTH="depth";const pass$1=(scene,camera,options)=>nodeObject$1(new PassNode(PassNode.COLOR,scene,camera,options)),passTexture$1=(pass2,texture2)=>nodeObject$1(new PassTextureNode(pass2,texture2)),depthPass=(scene,camera,options)=>nodeObject$1(new PassNode(PassNode.DEPTH,scene,camera,options));class ToonOutlinePassNode extends PassNode{static get type(){return"ToonOutlinePassNode"}constructor(scene,camera,colorNode,thicknessNode,alphaNode){super(PassNode.COLOR,scene,camera),this.colorNode=colorNode,this.thicknessNode=thicknessNode,this.alphaNode=alphaNode,this._materialCache=new WeakMap}updateBefore(frame){const{renderer}=frame,currentRenderObjectFunction=renderer.getRenderObjectFunction();renderer.setRenderObjectFunction((object,scene,camera,geometry2,material,group,lightsNode,clippingContext)=>{if((material.isMeshToonMaterial||material.isMeshToonNodeMaterial)&&material.wireframe===!1){const outlineMaterial=this._getOutlineMaterial(material);renderer.renderObject(object,scene,camera,geometry2,outlineMaterial,group,lightsNode,clippingContext)}renderer.renderObject(object,scene,camera,geometry2,material,group,lightsNode,clippingContext)}),super.updateBefore(frame),renderer.setRenderObjectFunction(currentRenderObjectFunction)}_createMaterial(){const material=new NodeMaterial;material.isMeshToonOutlineMaterial=!0,material.name="Toon_Outline",material.side=BackSide;const outlineNormal=normalLocal.negate(),mvp=cameraProjectionMatrix.mul(modelViewMatrix),ratio=float$1(1),pos=mvp.mul(vec4$1(positionLocal,1)),pos2=mvp.mul(vec4$1(positionLocal.add(outlineNormal),1)),norm=normalize$1(pos.sub(pos2));return material.vertexNode=pos.add(norm.mul(this.thicknessNode).mul(pos.w).mul(ratio)),material.colorNode=vec4$1(this.colorNode,this.alphaNode),material}_getOutlineMaterial(originalMaterial){let outlineMaterial=this._materialCache.get(originalMaterial);return outlineMaterial===void 0&&(outlineMaterial=this._createMaterial(),this._materialCache.set(originalMaterial,outlineMaterial)),outlineMaterial}}const toonOutlinePass=(scene,camera,color2=new Color(0,0,0),thickness2=.003,alpha=1)=>nodeObject$1(new ToonOutlinePassNode(scene,camera,nodeObject$1(color2),nodeObject$1(thickness2),nodeObject$1(alpha))),linearToneMapping=Fn$1(([color2,exposure])=>color2.mul(exposure).clamp()).setLayout({name:"linearToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]}),reinhardToneMapping=Fn$1(([color2,exposure])=>(color2=color2.mul(exposure),color2.div(color2.add(1)).clamp())).setLayout({name:"reinhardToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]}),cineonToneMapping=Fn$1(([color2,exposure])=>{color2=color2.mul(exposure),color2=color2.sub(.004).max(0);const a2=color2.mul(color2.mul(6.2).add(.5)),b=color2.mul(color2.mul(6.2).add(1.7)).add(.06);return a2.div(b).pow(2.2)}).setLayout({name:"cineonToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]}),RRTAndODTFit=Fn$1(([color2])=>{const a2=color2.mul(color2.add(.0245786)).sub(90537e-9),b=color2.mul(color2.add(.432951).mul(.983729)).add(.238081);return a2.div(b)}),acesFilmicToneMapping=Fn$1(([color2,exposure])=>{const ACESInputMat=mat3(.59719,.35458,.04823,.076,.90834,.01566,.0284,.13383,.83777),ACESOutputMat=mat3(1.60475,-.53108,-.07367,-.10208,1.10813,-.00605,-.00327,-.07276,1.07602);return color2=color2.mul(exposure).div(.6),color2=ACESInputMat.mul(color2),color2=RRTAndODTFit(color2),color2=ACESOutputMat.mul(color2),color2.clamp()}).setLayout({name:"acesFilmicToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]}),LINEAR_REC2020_TO_LINEAR_SRGB=mat3(vec3$1(1.6605,-.1246,-.0182),vec3$1(-.5876,1.1329,-.1006),vec3$1(-.0728,-.0083,1.1187)),LINEAR_SRGB_TO_LINEAR_REC2020=mat3(vec3$1(.6274,.0691,.0164),vec3$1(.3293,.9195,.088),vec3$1(.0433,.0113,.8956)),agxDefaultContrastApprox=Fn$1(([x_immutable])=>{const x=vec3$1(x_immutable).toVar(),x2=vec3$1(x.mul(x)).toVar(),x4=vec3$1(x2.mul(x2)).toVar();return float$1(15.5).mul(x4.mul(x2)).sub(mul$1(40.14,x4.mul(x))).add(mul$1(31.96,x4).sub(mul$1(6.868,x2.mul(x))).add(mul$1(.4298,x2).add(mul$1(.1191,x).sub(.00232))))}),agxToneMapping=Fn$1(([color2,exposure])=>{const colortone=vec3$1(color2).toVar(),AgXInsetMatrix=mat3(vec3$1(.856627153315983,.137318972929847,.11189821299995),vec3$1(.0951212405381588,.761241990602591,.0767994186031903),vec3$1(.0482516061458583,.101439036467562,.811302368396859)),AgXOutsetMatrix=mat3(vec3$1(1.1271005818144368,-.1413297634984383,-.14132976349843826),vec3$1(-.11060664309660323,1.157823702216272,-.11060664309660294),vec3$1(-.016493938717834573,-.016493938717834257,1.2519364065950405)),AgxMinEv=float$1(-12.47393),AgxMaxEv=float$1(4.026069);return colortone.mulAssign(exposure),colortone.assign(LINEAR_SRGB_TO_LINEAR_REC2020.mul(colortone)),colortone.assign(AgXInsetMatrix.mul(colortone)),colortone.assign(max$1(colortone,1e-10)),colortone.assign(log2(colortone)),colortone.assign(colortone.sub(AgxMinEv).div(AgxMaxEv.sub(AgxMinEv))),colortone.assign(clamp$3(colortone,0,1)),colortone.assign(agxDefaultContrastApprox(colortone)),colortone.assign(AgXOutsetMatrix.mul(colortone)),colortone.assign(pow$1(max$1(vec3$1(0),colortone),vec3$1(2.2))),colortone.assign(LINEAR_REC2020_TO_LINEAR_SRGB.mul(colortone)),colortone.assign(clamp$3(colortone,0,1)),colortone}).setLayout({name:"agxToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]}),neutralToneMapping=Fn$1(([color2,exposure])=>{const StartCompression=float$1(.76),Desaturation=float$1(.15);color2=color2.mul(exposure);const x=min$1(color2.r,min$1(color2.g,color2.b)),offset=select(x.lessThan(.08),x.sub(mul$1(6.25,x.mul(x))),.04);color2.subAssign(offset);const peak=max$1(color2.r,max$1(color2.g,color2.b));If$1(peak.lessThan(StartCompression),()=>color2);const d2=sub(1,StartCompression),newPeak=sub(1,d2.mul(d2).div(peak.add(d2.sub(StartCompression))));color2.mulAssign(newPeak.div(peak));const g=sub(1,div(1,Desaturation.mul(peak.sub(newPeak)).add(1)));return mix$1(color2,vec3$1(newPeak),g)}).setLayout({name:"neutralToneMapping",type:"vec3",inputs:[{name:"color",type:"vec3"},{name:"exposure",type:"float"}]});class CodeNode extends Node{static get type(){return"CodeNode"}constructor(code2="",includes=[],language=""){super("code"),this.isCodeNode=!0,this.code=code2,this.includes=includes,this.language=language}isGlobal(){return!0}setIncludes(includes){return this.includes=includes,this}getIncludes(){return this.includes}generate(builder){const includes=this.getIncludes(builder);for(const include of includes)include.build(builder);const nodeCode=builder.getCodeFromNode(this,this.getNodeType(builder));return nodeCode.code=this.code,nodeCode.code}serialize(data){super.serialize(data),data.code=this.code,data.language=this.language}deserialize(data){super.deserialize(data),this.code=data.code,this.language=data.language}}const code=nodeProxy(CodeNode),js=(src,includes)=>code(src,includes,"js"),wgsl=(src,includes)=>code(src,includes,"wgsl"),glsl=(src,includes)=>code(src,includes,"glsl");class FunctionNode extends CodeNode{static get type(){return"FunctionNode"}constructor(code2="",includes=[],language=""){super(code2,includes,language)}getNodeType(builder){return this.getNodeFunction(builder).type}getInputs(builder){return this.getNodeFunction(builder).inputs}getNodeFunction(builder){const nodeData=builder.getDataFromNode(this);let nodeFunction=nodeData.nodeFunction;return nodeFunction===void 0&&(nodeFunction=builder.parser.parseFunction(this.code),nodeData.nodeFunction=nodeFunction),nodeFunction}generate(builder,output2){super.generate(builder);const nodeFunction=this.getNodeFunction(builder),name=nodeFunction.name,type=nodeFunction.type,nodeCode=builder.getCodeFromNode(this,type);name!==""&&(nodeCode.name=name);const propertyName=builder.getPropertyName(nodeCode),code2=this.getNodeFunction(builder).getCode(propertyName);return nodeCode.code=code2+`
`,output2==="property"?propertyName:builder.format(`${propertyName}()`,type,output2)}}const nativeFn=(code2,includes=[],language="")=>{for(let i2=0;i2<includes.length;i2++){const include=includes[i2];typeof include=="function"&&(includes[i2]=include.functionNode)}const functionNode=nodeObject$1(new FunctionNode(code2,includes,language)),fn=(...params)=>functionNode.call(...params);return fn.functionNode=functionNode,fn},glslFn=(code2,includes)=>nativeFn(code2,includes,"glsl"),wgslFn=(code2,includes)=>nativeFn(code2,includes,"wgsl");class ScriptableValueNode extends Node{static get type(){return"ScriptableValueNode"}constructor(value=null){super(),this._value=value,this._cache=null,this.inputType=null,this.outputType=null,this.events=new EventDispatcher,this.isScriptableValueNode=!0}get isScriptableOutputNode(){return this.outputType!==null}set value(val){this._value!==val&&(this._cache&&this.inputType==="URL"&&this.value.value instanceof ArrayBuffer&&(URL.revokeObjectURL(this._cache),this._cache=null),this._value=val,this.events.dispatchEvent({type:"change"}),this.refresh())}get value(){return this._value}refresh(){this.events.dispatchEvent({type:"refresh"})}getValue(){const value=this.value;if(value&&this._cache===null&&this.inputType==="URL"&&value.value instanceof ArrayBuffer)this._cache=URL.createObjectURL(new Blob([value.value]));else if(value&&value.value!==null&&value.value!==void 0&&((this.inputType==="URL"||this.inputType==="String")&&typeof value.value=="string"||this.inputType==="Number"&&typeof value.value=="number"||this.inputType==="Vector2"&&value.value.isVector2||this.inputType==="Vector3"&&value.value.isVector3||this.inputType==="Vector4"&&value.value.isVector4||this.inputType==="Color"&&value.value.isColor||this.inputType==="Matrix3"&&value.value.isMatrix3||this.inputType==="Matrix4"&&value.value.isMatrix4))return value.value;return this._cache||value}getNodeType(builder){return this.value&&this.value.isNode?this.value.getNodeType(builder):"float"}setup(){return this.value&&this.value.isNode?this.value:float$1()}serialize(data){super.serialize(data),this.value!==null?this.inputType==="ArrayBuffer"?data.value=arrayBufferToBase64(this.value):data.value=this.value?this.value.toJSON(data.meta).uuid:null:data.value=null,data.inputType=this.inputType,data.outputType=this.outputType}deserialize(data){super.deserialize(data);let value=null;data.value!==null&&(data.inputType==="ArrayBuffer"?value=base64ToArrayBuffer(data.value):data.inputType==="Texture"?value=data.meta.textures[data.value]:value=data.meta.nodes[data.value]||null),this.value=value,this.inputType=data.inputType,this.outputType=data.outputType}}const scriptableValue=nodeProxy(ScriptableValueNode);class Resources extends Map{get(key2,callback=null,...params){if(this.has(key2))return super.get(key2);if(callback!==null){const value=callback(...params);return this.set(key2,value),value}}}class Parameters{constructor(scriptableNode){this.scriptableNode=scriptableNode}get parameters(){return this.scriptableNode.parameters}get layout(){return this.scriptableNode.getLayout()}getInputLayout(id){return this.scriptableNode.getInputLayout(id)}get(name){const param=this.parameters[name];return param?param.getValue():null}}const ScriptableNodeResources=new Resources;class ScriptableNode extends Node{static get type(){return"ScriptableNode"}constructor(codeNode=null,parameters={}){super(),this.codeNode=codeNode,this.parameters=parameters,this._local=new Resources,this._output=scriptableValue(),this._outputs={},this._source=this.source,this._method=null,this._object=null,this._value=null,this._needsOutputUpdate=!0,this.onRefresh=this.onRefresh.bind(this),this.isScriptableNode=!0}get source(){return this.codeNode?this.codeNode.code:""}setLocal(name,value){return this._local.set(name,value)}getLocal(name){return this._local.get(name)}onRefresh(){this._refresh()}getInputLayout(id){for(const element2 of this.getLayout())if(element2.inputType&&(element2.id===id||element2.name===id))return element2}getOutputLayout(id){for(const element2 of this.getLayout())if(element2.outputType&&(element2.id===id||element2.name===id))return element2}setOutput(name,value){const outputs=this._outputs;return outputs[name]===void 0?outputs[name]=scriptableValue(value):outputs[name].value=value,this}getOutput(name){return this._outputs[name]}getParameter(name){return this.parameters[name]}setParameter(name,value){const parameters=this.parameters;return value&&value.isScriptableNode?(this.deleteParameter(name),parameters[name]=value,parameters[name].getDefaultOutput().events.addEventListener("refresh",this.onRefresh)):value&&value.isScriptableValueNode?(this.deleteParameter(name),parameters[name]=value,parameters[name].events.addEventListener("refresh",this.onRefresh)):parameters[name]===void 0?(parameters[name]=scriptableValue(value),parameters[name].events.addEventListener("refresh",this.onRefresh)):parameters[name].value=value,this}getValue(){return this.getDefaultOutput().getValue()}deleteParameter(name){let valueNode=this.parameters[name];return valueNode&&(valueNode.isScriptableNode&&(valueNode=valueNode.getDefaultOutput()),valueNode.events.removeEventListener("refresh",this.onRefresh)),this}clearParameters(){for(const name of Object.keys(this.parameters))this.deleteParameter(name);return this.needsUpdate=!0,this}call(name,...params){const method=this.getObject()[name];if(typeof method=="function")return method(...params)}async callAsync(name,...params){const method=this.getObject()[name];if(typeof method=="function")return method.constructor.name==="AsyncFunction"?await method(...params):method(...params)}getNodeType(builder){return this.getDefaultOutputNode().getNodeType(builder)}refresh(output2=null){output2!==null?this.getOutput(output2).refresh():this._refresh()}getObject(){if(this.needsUpdate&&this.dispose(),this._object!==null)return this._object;const refresh=()=>this.refresh(),setOutput=(id,value)=>this.setOutput(id,value),parameters=new Parameters(this),THREE=ScriptableNodeResources.get("THREE"),TSL2=ScriptableNodeResources.get("TSL"),method=this.getMethod(),params=[parameters,this._local,ScriptableNodeResources,refresh,setOutput,THREE,TSL2];this._object=method(...params);const layout=this._object.layout;if(layout&&(layout.cache===!1&&this._local.clear(),this._output.outputType=layout.outputType||null,Array.isArray(layout.elements)))for(const element2 of layout.elements){const id=element2.id||element2.name;element2.inputType&&(this.getParameter(id)===void 0&&this.setParameter(id,null),this.getParameter(id).inputType=element2.inputType),element2.outputType&&(this.getOutput(id)===void 0&&this.setOutput(id,null),this.getOutput(id).outputType=element2.outputType)}return this._object}deserialize(data){super.deserialize(data);for(const name in this.parameters){let valueNode=this.parameters[name];valueNode.isScriptableNode&&(valueNode=valueNode.getDefaultOutput()),valueNode.events.addEventListener("refresh",this.onRefresh)}}getLayout(){return this.getObject().layout}getDefaultOutputNode(){const output2=this.getDefaultOutput().value;return output2&&output2.isNode?output2:float$1()}getDefaultOutput(){return this._exec()._output}getMethod(){if(this.needsUpdate&&this.dispose(),this._method!==null)return this._method;const parametersProps=["parameters","local","global","refresh","setOutput","THREE","TSL"],properties=["layout","init","main","dispose"].join(", "),declarations="var "+properties+`; var output = {};
`,returns=`
return { ...output, `+properties+" };",code2=declarations+this.codeNode.code+returns;return this._method=new Function(...parametersProps,code2),this._method}dispose(){this._method!==null&&(this._object&&typeof this._object.dispose=="function"&&this._object.dispose(),this._method=null,this._object=null,this._source=null,this._value=null,this._needsOutputUpdate=!0,this._output.value=null,this._outputs={})}setup(){return this.getDefaultOutputNode()}getCacheKey(force){const values=[hashString(this.source),this.getDefaultOutputNode().getCacheKey(force)];for(const param in this.parameters)values.push(this.parameters[param].getCacheKey(force));return hashArray(values)}set needsUpdate(value){value===!0&&this.dispose()}get needsUpdate(){return this.source!==this._source}_exec(){return this.codeNode===null?this:(this._needsOutputUpdate===!0&&(this._value=this.call("main"),this._needsOutputUpdate=!1),this._output.value=this._value,this)}_refresh(){this.needsUpdate=!0,this._exec(),this._output.refresh()}}const scriptable=nodeProxy(ScriptableNode);function getViewZNode(builder){let viewZ;const getViewZ=builder.context.getViewZ;return getViewZ!==void 0&&(viewZ=getViewZ(this)),(viewZ||positionView.z).negate()}const rangeFogFactor=Fn$1(([near,far],builder)=>{const viewZ=getViewZNode(builder);return smoothstep$1(near,far,viewZ)}),densityFogFactor=Fn$1(([density],builder)=>{const viewZ=getViewZNode(builder);return density.mul(density,viewZ,viewZ).negate().exp().oneMinus()}),fog=Fn$1(([color2,factor])=>vec4$1(factor.toFloat().mix(output.rgb,color2.toVec3()),output.a));function rangeFog(color2,near,far){return console.warn('THREE.TSL: "rangeFog( color, near, far )" is deprecated. Use "fog( color, rangeFogFactor( near, far ) )" instead.'),fog(color2,rangeFogFactor(near,far))}function densityFog(color2,density){return console.warn('THREE.TSL: "densityFog( color, density )" is deprecated. Use "fog( color, densityFogFactor( density ) )" instead.'),fog(color2,densityFogFactor(density))}let min=null,max$2=null;class RangeNode extends Node{static get type(){return"RangeNode"}constructor(minNode=float$1(),maxNode=float$1()){super(),this.minNode=minNode,this.maxNode=maxNode}getVectorLength(builder){const minLength=builder.getTypeLength(getValueType(this.minNode.value)),maxLength=builder.getTypeLength(getValueType(this.maxNode.value));return minLength>maxLength?minLength:maxLength}getNodeType(builder){return builder.object.count>1?builder.getTypeFromLength(this.getVectorLength(builder)):"float"}setup(builder){const object=builder.object;let output2=null;if(object.count>1){const minValue2=this.minNode.value,maxValue2=this.maxNode.value,minLength=builder.getTypeLength(getValueType(minValue2)),maxLength=builder.getTypeLength(getValueType(maxValue2));min=min||new Vector4,max$2=max$2||new Vector4,min.setScalar(0),max$2.setScalar(0),minLength===1?min.setScalar(minValue2):minValue2.isColor?min.set(minValue2.r,minValue2.g,minValue2.b,1):min.set(minValue2.x,minValue2.y,minValue2.z||0,minValue2.w||0),maxLength===1?max$2.setScalar(maxValue2):maxValue2.isColor?max$2.set(maxValue2.r,maxValue2.g,maxValue2.b,1):max$2.set(maxValue2.x,maxValue2.y,maxValue2.z||0,maxValue2.w||0);const stride=4,length2=stride*object.count,array2=new Float32Array(length2);for(let i2=0;i2<length2;i2++){const index=i2%stride,minElementValue=min.getComponent(index),maxElementValue=max$2.getComponent(index);array2[i2]=MathUtils.lerp(minElementValue,maxElementValue,Math.random())}const nodeType=this.getNodeType(builder);if(object.count<=4096)output2=buffer(array2,"vec4",object.count).element(instanceIndex$1).convert(nodeType);else{const bufferAttribute2=new InstancedBufferAttribute(array2,4);builder.geometry.setAttribute("__range"+this.id,bufferAttribute2),output2=instancedBufferAttribute$1(bufferAttribute2).convert(nodeType)}}else output2=float$1(0);return output2}}const range=nodeProxy(RangeNode);class ComputeBuiltinNode extends Node{static get type(){return"ComputeBuiltinNode"}constructor(builtinName,nodeType){super(nodeType),this._builtinName=builtinName}getHash(builder){return this.getBuiltinName(builder)}getNodeType(){return this.nodeType}setBuiltinName(builtinName){return this._builtinName=builtinName,this}getBuiltinName(){return this._builtinName}hasBuiltin(builder){return builder.hasBuiltin(this._builtinName)}generate(builder,output2){const builtinName=this.getBuiltinName(builder),nodeType=this.getNodeType(builder);return builder.shaderStage==="compute"?builder.format(builtinName,nodeType,output2):(console.warn(`ComputeBuiltinNode: Compute built-in value ${builtinName} can not be accessed in the ${builder.shaderStage} stage`),builder.generateConst(nodeType))}serialize(data){super.serialize(data),data.global=this.global,data._builtinName=this._builtinName}deserialize(data){super.deserialize(data),this.global=data.global,this._builtinName=data._builtinName}}const computeBuiltin=(name,nodeType)=>nodeObject$1(new ComputeBuiltinNode(name,nodeType)),numWorkgroups=computeBuiltin("numWorkgroups","uvec3"),workgroupId=computeBuiltin("workgroupId","uvec3"),globalId=computeBuiltin("globalId","uvec3"),localId=computeBuiltin("localId","uvec3"),subgroupSize=computeBuiltin("subgroupSize","uint");class BarrierNode extends Node{constructor(scope){super(),this.scope=scope}generate(builder){const{scope}=this,{renderer}=builder;renderer.backend.isWebGLBackend===!0?builder.addFlowCode(`	// ${scope}Barrier 
`):builder.addLineFlowCode(`${scope}Barrier()`,this)}}const barrier=nodeProxy(BarrierNode),workgroupBarrier=()=>barrier("workgroup").append(),storageBarrier=()=>barrier("storage").append(),textureBarrier=()=>barrier("texture").append();class WorkgroupInfoElementNode extends ArrayElementNode{constructor(workgroupInfoNode,indexNode){super(workgroupInfoNode,indexNode),this.isWorkgroupInfoElementNode=!0}generate(builder,output2){let snippet;const isAssignContext=builder.context.assign;if(snippet=super.generate(builder),isAssignContext!==!0){const type=this.getNodeType(builder);snippet=builder.format(snippet,type,output2)}return snippet}}class WorkgroupInfoNode extends Node{constructor(scope,bufferType,bufferCount=0){super(bufferType),this.bufferType=bufferType,this.bufferCount=bufferCount,this.isWorkgroupInfoNode=!0,this.elementType=bufferType,this.scope=scope}label(name){return this.name=name,this}setScope(scope){return this.scope=scope,this}getElementType(){return this.elementType}getInputType(){return`${this.scope}Array`}element(indexNode){return nodeObject$1(new WorkgroupInfoElementNode(this,indexNode))}generate(builder){return builder.getScopedArray(this.name||`${this.scope}Array_${this.id}`,this.scope.toLowerCase(),this.bufferType,this.bufferCount)}}const workgroupArray=(type,count)=>nodeObject$1(new WorkgroupInfoNode("Workgroup",type,count));class AtomicFunctionNode extends TempNode{static get type(){return"AtomicFunctionNode"}constructor(method,pointerNode,valueNode,storeNode=null){super("uint"),this.method=method,this.pointerNode=pointerNode,this.valueNode=valueNode,this.storeNode=storeNode}getInputType(builder){return this.pointerNode.getNodeType(builder)}getNodeType(builder){return this.getInputType(builder)}generate(builder){const method=this.method,type=this.getNodeType(builder),inputType=this.getInputType(builder),a2=this.pointerNode,b=this.valueNode,params=[];params.push(`&${a2.build(builder,inputType)}`),b!==null&&params.push(b.build(builder,inputType));const methodSnippet=`${builder.getMethod(method,type)}( ${params.join(", ")} )`;if(this.storeNode!==null){const varSnippet=this.storeNode.build(builder,inputType);builder.addLineFlowCode(`${varSnippet} = ${methodSnippet}`,this)}else builder.addLineFlowCode(methodSnippet,this)}}AtomicFunctionNode.ATOMIC_LOAD="atomicLoad";AtomicFunctionNode.ATOMIC_STORE="atomicStore";AtomicFunctionNode.ATOMIC_ADD="atomicAdd";AtomicFunctionNode.ATOMIC_SUB="atomicSub";AtomicFunctionNode.ATOMIC_MAX="atomicMax";AtomicFunctionNode.ATOMIC_MIN="atomicMin";AtomicFunctionNode.ATOMIC_AND="atomicAnd";AtomicFunctionNode.ATOMIC_OR="atomicOr";AtomicFunctionNode.ATOMIC_XOR="atomicXor";const atomicNode=nodeProxy(AtomicFunctionNode),atomicFunc=(method,pointerNode,valueNode,storeNode=null)=>{const node=atomicNode(method,pointerNode,valueNode,storeNode);return node.append(),node},atomicLoad=(pointerNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_LOAD,pointerNode,null,storeNode),atomicStore=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_STORE,pointerNode,valueNode,storeNode),atomicAdd=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_ADD,pointerNode,valueNode,storeNode),atomicSub=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_SUB,pointerNode,valueNode,storeNode),atomicMax=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_MAX,pointerNode,valueNode,storeNode),atomicMin=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_MIN,pointerNode,valueNode,storeNode),atomicAnd=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_AND,pointerNode,valueNode,storeNode),atomicOr=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_OR,pointerNode,valueNode,storeNode),atomicXor=(pointerNode,valueNode,storeNode=null)=>atomicFunc(AtomicFunctionNode.ATOMIC_XOR,pointerNode,valueNode,storeNode);let uniformsLib;function getLightData(light){uniformsLib=uniformsLib||new WeakMap;let uniforms2=uniformsLib.get(light);return uniforms2===void 0&&uniformsLib.set(light,uniforms2={}),uniforms2}function lightShadowMatrix(light){const data=getLightData(light);return data.shadowMatrix||(data.shadowMatrix=uniform$1("mat4").setGroup(renderGroup).onRenderUpdate(()=>(light.castShadow!==!0&&light.shadow.updateMatrices(light),light.shadow.matrix)))}function lightProjectionUV(light,position=positionWorld){const spotLightCoord=lightShadowMatrix(light).mul(position);return spotLightCoord.xyz.div(spotLightCoord.w)}function lightPosition(light){const data=getLightData(light);return data.position||(data.position=uniform$1(new Vector3).setGroup(renderGroup).onRenderUpdate((_,self2)=>self2.value.setFromMatrixPosition(light.matrixWorld)))}function lightTargetPosition(light){const data=getLightData(light);return data.targetPosition||(data.targetPosition=uniform$1(new Vector3).setGroup(renderGroup).onRenderUpdate((_,self2)=>self2.value.setFromMatrixPosition(light.target.matrixWorld)))}function lightViewPosition(light){const data=getLightData(light);return data.viewPosition||(data.viewPosition=uniform$1(new Vector3).setGroup(renderGroup).onRenderUpdate(({camera},self2)=>{self2.value=self2.value||new Vector3,self2.value.setFromMatrixPosition(light.matrixWorld),self2.value.applyMatrix4(camera.matrixWorldInverse)}))}const lightTargetDirection=light=>cameraViewMatrix.transformDirection(lightPosition(light).sub(lightTargetPosition(light))),sortLights=lights2=>lights2.sort((a2,b)=>a2.id-b.id),getLightNodeById=(id,lightNodes)=>{for(const lightNode of lightNodes)if(lightNode.isAnalyticLightNode&&lightNode.light.id===id)return lightNode;return null},_lightsNodeRef=new WeakMap;class LightsNode extends Node{static get type(){return"LightsNode"}constructor(){super("vec3"),this.totalDiffuseNode=vec3$1().toVar("totalDiffuse"),this.totalSpecularNode=vec3$1().toVar("totalSpecular"),this.outgoingLightNode=vec3$1().toVar("outgoingLight"),this._lights=[],this._lightNodes=null,this._lightNodesHash=null,this.global=!0}customCacheKey(){const lightIDs=[],lights2=this._lights;for(let i2=0;i2<lights2.length;i2++)lightIDs.push(lights2[i2].id);return hashArray(lightIDs)}getHash(builder){if(this._lightNodesHash===null){this._lightNodes===null&&this.setupLightsNode(builder);const hash2=[];for(const lightNode of this._lightNodes)hash2.push(lightNode.getSelf().getHash());this._lightNodesHash="lights-"+hash2.join(",")}return this._lightNodesHash}analyze(builder){const properties=builder.getDataFromNode(this);for(const node of properties.nodes)node.build(builder)}setupLightsNode(builder){const lightNodes=[],previousLightNodes=this._lightNodes,lights2=sortLights(this._lights),nodeLibrary=builder.renderer.library;for(const light of lights2)if(light.isNode)lightNodes.push(nodeObject$1(light));else{let lightNode=null;if(previousLightNodes!==null&&(lightNode=getLightNodeById(light.id,previousLightNodes)),lightNode===null){const lightNodeClass=nodeLibrary.getLightNodeClass(light.constructor);if(lightNodeClass===null){console.warn(`LightsNode.setupNodeLights: Light node not found for ${light.constructor.name}`);continue}let lightNode2=null;_lightsNodeRef.has(light)?lightNode2=_lightsNodeRef.get(light):(lightNode2=nodeObject$1(new lightNodeClass(light)),_lightsNodeRef.set(light,lightNode2)),lightNodes.push(lightNode2)}}this._lightNodes=lightNodes}setupDirectLight(builder,lightNode,lightData){const{lightingModel,reflectedLight}=builder.context;lightingModel.direct({...lightData,lightNode,reflectedLight},builder)}setupDirectRectAreaLight(builder,lightNode,lightData){const{lightingModel,reflectedLight}=builder.context;lightingModel.directRectArea({...lightData,lightNode,reflectedLight},builder)}setupLights(builder,lightNodes){for(const lightNode of lightNodes)lightNode.build(builder)}getLightNodes(builder){return this._lightNodes===null&&this.setupLightsNode(builder),this._lightNodes}setup(builder){const currentLightsNode=builder.lightsNode;builder.lightsNode=this;let outgoingLightNode=this.outgoingLightNode;const context2=builder.context,lightingModel=context2.lightingModel,properties=builder.getDataFromNode(this);if(lightingModel){const{totalDiffuseNode,totalSpecularNode}=this;context2.outgoingLight=outgoingLightNode;const stack2=builder.addStack();properties.nodes=stack2.nodes,lightingModel.start(builder);const{backdrop,backdropAlpha}=context2,{directDiffuse,directSpecular,indirectDiffuse,indirectSpecular}=context2.reflectedLight;let totalDiffuse=directDiffuse.add(indirectDiffuse);backdrop!==null&&(backdropAlpha!==null?totalDiffuse=vec3$1(backdropAlpha.mix(totalDiffuse,backdrop)):totalDiffuse=vec3$1(backdrop),context2.material.transparent=!0),totalDiffuseNode.assign(totalDiffuse),totalSpecularNode.assign(directSpecular.add(indirectSpecular)),outgoingLightNode.assign(totalDiffuseNode.add(totalSpecularNode)),lightingModel.finish(builder),outgoingLightNode=outgoingLightNode.bypass(builder.removeStack())}else properties.nodes=[];return builder.lightsNode=currentLightsNode,outgoingLightNode}setLights(lights2){return this._lights=lights2,this._lightNodes=null,this._lightNodesHash=null,this}getLights(){return this._lights}get hasLights(){return this._lights.length>0}}const lights=(lights2=[])=>nodeObject$1(new LightsNode).setLights(lights2);class ShadowBaseNode extends Node{static get type(){return"ShadowBaseNode"}constructor(light){super(),this.light=light,this.updateBeforeType=NodeUpdateType.RENDER,this.isShadowBaseNode=!0}setupShadowPosition({context:context2,material}){shadowPositionWorld.assign(material.shadowPositionNode||context2.shadowPositionWorld||positionWorld)}dispose(){this.updateBeforeType=NodeUpdateType.NONE}}const shadowPositionWorld=property("vec3","shadowPositionWorld");function saveRendererState(renderer,state={}){return state.toneMapping=renderer.toneMapping,state.toneMappingExposure=renderer.toneMappingExposure,state.outputColorSpace=renderer.outputColorSpace,state.renderTarget=renderer.getRenderTarget(),state.activeCubeFace=renderer.getActiveCubeFace(),state.activeMipmapLevel=renderer.getActiveMipmapLevel(),state.renderObjectFunction=renderer.getRenderObjectFunction(),state.pixelRatio=renderer.getPixelRatio(),state.mrt=renderer.getMRT(),state.clearColor=renderer.getClearColor(state.clearColor||new Color),state.clearAlpha=renderer.getClearAlpha(),state.autoClear=renderer.autoClear,state.scissorTest=renderer.getScissorTest(),state}function resetRendererState(renderer,state){return state=saveRendererState(renderer,state),renderer.setMRT(null),renderer.setRenderObjectFunction(null),renderer.setClearColor(0,1),renderer.autoClear=!0,state}function restoreRendererState(renderer,state){renderer.toneMapping=state.toneMapping,renderer.toneMappingExposure=state.toneMappingExposure,renderer.outputColorSpace=state.outputColorSpace,renderer.setRenderTarget(state.renderTarget,state.activeCubeFace,state.activeMipmapLevel),renderer.setRenderObjectFunction(state.renderObjectFunction),renderer.setPixelRatio(state.pixelRatio),renderer.setMRT(state.mrt),renderer.setClearColor(state.clearColor,state.clearAlpha),renderer.autoClear=state.autoClear,renderer.setScissorTest(state.scissorTest)}function saveSceneState(scene,state={}){return state.background=scene.background,state.backgroundNode=scene.backgroundNode,state.overrideMaterial=scene.overrideMaterial,state}function resetSceneState(scene,state){return state=saveSceneState(scene,state),scene.background=null,scene.backgroundNode=null,scene.overrideMaterial=null,state}function restoreSceneState(scene,state){scene.background=state.background,scene.backgroundNode=state.backgroundNode,scene.overrideMaterial=state.overrideMaterial}function saveRendererAndSceneState(renderer,scene,state={}){return state=saveRendererState(renderer,state),state=saveSceneState(scene,state),state}function resetRendererAndSceneState(renderer,scene,state){return state=resetRendererState(renderer,state),state=resetSceneState(scene,state),state}function restoreRendererAndSceneState(renderer,scene,state){restoreRendererState(renderer,state),restoreSceneState(scene,state)}var RendererUtils=Object.freeze({__proto__:null,resetRendererAndSceneState,resetRendererState,resetSceneState,restoreRendererAndSceneState,restoreRendererState,restoreSceneState,saveRendererAndSceneState,saveRendererState,saveSceneState});const shadowMaterialLib=new WeakMap,linearDistance=Fn$1(([position,cameraNear2,cameraFar2])=>{let dist=positionWorld.sub(position).length();return dist=dist.sub(cameraNear2).div(cameraFar2.sub(cameraNear2)),dist=dist.saturate(),dist}),linearShadowDistance=light=>{const camera=light.shadow.camera,nearDistance=reference("near","float",camera).setGroup(renderGroup),farDistance=reference("far","float",camera).setGroup(renderGroup),referencePosition=objectPosition(light);return linearDistance(referencePosition,nearDistance,farDistance)},getShadowMaterial=light=>{let material=shadowMaterialLib.get(light);if(material===void 0){const depthNode=light.isPointLight?linearShadowDistance(light):null;material=new NodeMaterial,material.colorNode=vec4$1(0,0,0,1),material.depthNode=depthNode,material.isShadowPassMaterial=!0,material.name="ShadowMaterial",material.fog=!1,shadowMaterialLib.set(light,material)}return material},BasicShadowFilter=Fn$1(({depthTexture,shadowCoord})=>texture$1(depthTexture,shadowCoord.xy).compare(shadowCoord.z)),PCFShadowFilter=Fn$1(({depthTexture,shadowCoord,shadow:shadow2})=>{const depthCompare=(uv2,compare)=>texture$1(depthTexture,uv2).compare(compare),mapSize=reference("mapSize","vec2",shadow2).setGroup(renderGroup),radius=reference("radius","float",shadow2).setGroup(renderGroup),texelSize=vec2$1(1).div(mapSize),dx0=texelSize.x.negate().mul(radius),dy0=texelSize.y.negate().mul(radius),dx1=texelSize.x.mul(radius),dy1=texelSize.y.mul(radius),dx2=dx0.div(2),dy2=dy0.div(2),dx3=dx1.div(2),dy3=dy1.div(2);return add$3(depthCompare(shadowCoord.xy.add(vec2$1(dx0,dy0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(0,dy0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx1,dy0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx2,dy2)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(0,dy2)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx3,dy2)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx0,0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx2,0)),shadowCoord.z),depthCompare(shadowCoord.xy,shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx3,0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx1,0)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx2,dy3)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(0,dy3)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx3,dy3)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx0,dy1)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(0,dy1)),shadowCoord.z),depthCompare(shadowCoord.xy.add(vec2$1(dx1,dy1)),shadowCoord.z)).mul(1/17)}),PCFSoftShadowFilter=Fn$1(({depthTexture,shadowCoord,shadow:shadow2})=>{const depthCompare=(uv3,compare)=>texture$1(depthTexture,uv3).compare(compare),mapSize=reference("mapSize","vec2",shadow2).setGroup(renderGroup),texelSize=vec2$1(1).div(mapSize),dx=texelSize.x,dy=texelSize.y,uv2=shadowCoord.xy,f2=fract(uv2.mul(mapSize).add(.5));return uv2.subAssign(f2.mul(texelSize)),add$3(depthCompare(uv2,shadowCoord.z),depthCompare(uv2.add(vec2$1(dx,0)),shadowCoord.z),depthCompare(uv2.add(vec2$1(0,dy)),shadowCoord.z),depthCompare(uv2.add(texelSize),shadowCoord.z),mix$1(depthCompare(uv2.add(vec2$1(dx.negate(),0)),shadowCoord.z),depthCompare(uv2.add(vec2$1(dx.mul(2),0)),shadowCoord.z),f2.x),mix$1(depthCompare(uv2.add(vec2$1(dx.negate(),dy)),shadowCoord.z),depthCompare(uv2.add(vec2$1(dx.mul(2),dy)),shadowCoord.z),f2.x),mix$1(depthCompare(uv2.add(vec2$1(0,dy.negate())),shadowCoord.z),depthCompare(uv2.add(vec2$1(0,dy.mul(2))),shadowCoord.z),f2.y),mix$1(depthCompare(uv2.add(vec2$1(dx,dy.negate())),shadowCoord.z),depthCompare(uv2.add(vec2$1(dx,dy.mul(2))),shadowCoord.z),f2.y),mix$1(mix$1(depthCompare(uv2.add(vec2$1(dx.negate(),dy.negate())),shadowCoord.z),depthCompare(uv2.add(vec2$1(dx.mul(2),dy.negate())),shadowCoord.z),f2.x),mix$1(depthCompare(uv2.add(vec2$1(dx.negate(),dy.mul(2))),shadowCoord.z),depthCompare(uv2.add(vec2$1(dx.mul(2),dy.mul(2))),shadowCoord.z),f2.x),f2.y)).mul(1/9)}),VSMShadowFilter=Fn$1(({depthTexture,shadowCoord})=>{const occlusion=float$1(1).toVar(),distribution=texture$1(depthTexture).sample(shadowCoord.xy).rg,hardShadow=step$1(shadowCoord.z,distribution.x);return If$1(hardShadow.notEqual(float$1(1)),()=>{const distance2=shadowCoord.z.sub(distribution.x),variance=max$1(0,distribution.y.mul(distribution.y));let softnessProbability=variance.div(variance.add(distance2.mul(distance2)));softnessProbability=clamp$3(sub(softnessProbability,.3).div(.95-.3)),occlusion.assign(clamp$3(max$1(hardShadow,softnessProbability)))}),occlusion}),VSMPassVertical=Fn$1(({samples,radius,size,shadowPass})=>{const mean=float$1(0).toVar(),squaredMean=float$1(0).toVar(),uvStride=samples.lessThanEqual(float$1(1)).select(float$1(0),float$1(2).div(samples.sub(1))),uvStart=samples.lessThanEqual(float$1(1)).select(float$1(0),float$1(-1));Loop({start:int(0),end:int(samples),type:"int",condition:"<"},({i:i2})=>{const uvOffset=uvStart.add(float$1(i2).mul(uvStride)),depth2=shadowPass.sample(add$3(screenCoordinate.xy,vec2$1(0,uvOffset).mul(radius)).div(size)).x;mean.addAssign(depth2),squaredMean.addAssign(depth2.mul(depth2))}),mean.divAssign(samples),squaredMean.divAssign(samples);const std_dev=sqrt$2(squaredMean.sub(mean.mul(mean)));return vec2$1(mean,std_dev)}),VSMPassHorizontal=Fn$1(({samples,radius,size,shadowPass})=>{const mean=float$1(0).toVar(),squaredMean=float$1(0).toVar(),uvStride=samples.lessThanEqual(float$1(1)).select(float$1(0),float$1(2).div(samples.sub(1))),uvStart=samples.lessThanEqual(float$1(1)).select(float$1(0),float$1(-1));Loop({start:int(0),end:int(samples),type:"int",condition:"<"},({i:i2})=>{const uvOffset=uvStart.add(float$1(i2).mul(uvStride)),distribution=shadowPass.sample(add$3(screenCoordinate.xy,vec2$1(uvOffset,0).mul(radius)).div(size));mean.addAssign(distribution.x),squaredMean.addAssign(add$3(distribution.y.mul(distribution.y),distribution.x.mul(distribution.x)))}),mean.divAssign(samples),squaredMean.divAssign(samples);const std_dev=sqrt$2(squaredMean.sub(mean.mul(mean)));return vec2$1(mean,std_dev)}),_shadowFilterLib=[BasicShadowFilter,PCFShadowFilter,PCFSoftShadowFilter,VSMShadowFilter];let _rendererState$2;const _quadMesh$1=new QuadMesh;class ShadowNode extends ShadowBaseNode{static get type(){return"ShadowNode"}constructor(light,shadow2=null){super(light),this.shadow=shadow2||light.shadow,this.shadowMap=null,this.vsmShadowMapVertical=null,this.vsmShadowMapHorizontal=null,this.vsmMaterialVertical=null,this.vsmMaterialHorizontal=null,this._node=null,this._cameraFrameId=new WeakMap,this.isShadowNode=!0}setupShadowFilter(builder,{filterFn,depthTexture,shadowCoord,shadow:shadow2}){const frustumTest=shadowCoord.x.greaterThanEqual(0).and(shadowCoord.x.lessThanEqual(1)).and(shadowCoord.y.greaterThanEqual(0)).and(shadowCoord.y.lessThanEqual(1)).and(shadowCoord.z.lessThanEqual(1)),shadowNode=filterFn({depthTexture,shadowCoord,shadow:shadow2});return frustumTest.select(shadowNode,float$1(1))}setupShadowCoord(builder,shadowPosition){const{shadow:shadow2}=this,{renderer}=builder,bias=reference("bias","float",shadow2).setGroup(renderGroup);let shadowCoord=shadowPosition,coordZ;if(shadow2.camera.isOrthographicCamera||renderer.logarithmicDepthBuffer!==!0)shadowCoord=shadowCoord.xyz.div(shadowCoord.w),coordZ=shadowCoord.z,renderer.coordinateSystem===WebGPUCoordinateSystem&&(coordZ=coordZ.mul(2).sub(1));else{const w=shadowCoord.w;shadowCoord=shadowCoord.xy.div(w);const cameraNearLocal=reference("near","float",shadow2.camera).setGroup(renderGroup),cameraFarLocal=reference("far","float",shadow2.camera).setGroup(renderGroup);coordZ=viewZToLogarithmicDepth(w.negate(),cameraNearLocal,cameraFarLocal)}return shadowCoord=vec3$1(shadowCoord.x,shadowCoord.y.oneMinus(),coordZ.add(bias)),shadowCoord}getShadowFilterFn(type){return _shadowFilterLib[type]}setupShadow(builder){const{renderer}=builder,{light,shadow:shadow2}=this,shadowMapType=renderer.shadowMap.type,depthTexture=new DepthTexture(shadow2.mapSize.width,shadow2.mapSize.height);depthTexture.compareFunction=LessCompare;const shadowMap=builder.createRenderTarget(shadow2.mapSize.width,shadow2.mapSize.height);if(shadowMap.depthTexture=depthTexture,shadow2.camera.updateProjectionMatrix(),shadowMapType===VSMShadowMap){depthTexture.compareFunction=null,this.vsmShadowMapVertical=builder.createRenderTarget(shadow2.mapSize.width,shadow2.mapSize.height,{format:RGFormat,type:HalfFloatType}),this.vsmShadowMapHorizontal=builder.createRenderTarget(shadow2.mapSize.width,shadow2.mapSize.height,{format:RGFormat,type:HalfFloatType});const shadowPassVertical=texture$1(depthTexture),shadowPassHorizontal=texture$1(this.vsmShadowMapVertical.texture),samples=reference("blurSamples","float",shadow2).setGroup(renderGroup),radius=reference("radius","float",shadow2).setGroup(renderGroup),size=reference("mapSize","vec2",shadow2).setGroup(renderGroup);let material=this.vsmMaterialVertical||(this.vsmMaterialVertical=new NodeMaterial);material.fragmentNode=VSMPassVertical({samples,radius,size,shadowPass:shadowPassVertical}).context(builder.getSharedContext()),material.name="VSMVertical",material=this.vsmMaterialHorizontal||(this.vsmMaterialHorizontal=new NodeMaterial),material.fragmentNode=VSMPassHorizontal({samples,radius,size,shadowPass:shadowPassHorizontal}).context(builder.getSharedContext()),material.name="VSMHorizontal"}const shadowIntensity=reference("intensity","float",shadow2).setGroup(renderGroup),normalBias=reference("normalBias","float",shadow2).setGroup(renderGroup),shadowPosition=lightShadowMatrix(light).mul(shadowPositionWorld.add(transformedNormalWorld.mul(normalBias))),shadowCoord=this.setupShadowCoord(builder,shadowPosition),filterFn=shadow2.filterNode||this.getShadowFilterFn(renderer.shadowMap.type)||null;if(filterFn===null)throw new Error("THREE.WebGPURenderer: Shadow map type not supported yet.");const shadowDepthTexture=shadowMapType===VSMShadowMap?this.vsmShadowMapHorizontal.texture:depthTexture,shadowNode=this.setupShadowFilter(builder,{filterFn,shadowTexture:shadowMap.texture,depthTexture:shadowDepthTexture,shadowCoord,shadow:shadow2}),shadowColor=texture$1(shadowMap.texture,shadowCoord),shadowOutput=mix$1(1,shadowNode.rgb.mix(shadowColor,1),shadowIntensity.mul(shadowColor.a)).toVar();return this.shadowMap=shadowMap,this.shadow.map=shadowMap,shadowOutput}setup(builder){if(builder.renderer.shadowMap.enabled!==!1)return Fn$1(()=>{let node=this._node;return this.setupShadowPosition(builder),node===null&&(this._node=node=this.setupShadow(builder)),builder.material.shadowNode&&console.warn('THREE.NodeMaterial: ".shadowNode" is deprecated. Use ".castShadowNode" instead.'),builder.material.receivedShadowNode&&(node=builder.material.receivedShadowNode(node)),node})()}renderShadow(frame){const{shadow:shadow2,shadowMap,light}=this,{renderer,scene}=frame;shadow2.updateMatrices(light),shadowMap.setSize(shadow2.mapSize.width,shadow2.mapSize.height),renderer.render(scene,shadow2.camera)}updateShadow(frame){const{shadowMap,light,shadow:shadow2}=this,{renderer,scene,camera}=frame,shadowType=renderer.shadowMap.type,depthVersion=shadowMap.depthTexture.version;this._depthVersionCached=depthVersion,shadow2.camera.layers.mask=camera.layers.mask;const currentRenderObjectFunction=renderer.getRenderObjectFunction(),currentMRT=renderer.getMRT(),useVelocity=currentMRT?currentMRT.has("velocity"):!1;_rendererState$2=resetRendererAndSceneState(renderer,scene,_rendererState$2),scene.overrideMaterial=getShadowMaterial(light),renderer.setRenderObjectFunction((object,scene2,_camera2,geometry2,material,group,...params)=>{(object.castShadow===!0||object.receiveShadow&&shadowType===VSMShadowMap)&&(useVelocity&&(getDataFromObject(object).useVelocity=!0),object.onBeforeShadow(renderer,object,camera,shadow2.camera,geometry2,scene2.overrideMaterial,group),renderer.renderObject(object,scene2,_camera2,geometry2,material,group,...params),object.onAfterShadow(renderer,object,camera,shadow2.camera,geometry2,scene2.overrideMaterial,group))}),renderer.setRenderTarget(shadowMap),this.renderShadow(frame),renderer.setRenderObjectFunction(currentRenderObjectFunction),light.isPointLight!==!0&&shadowType===VSMShadowMap&&this.vsmPass(renderer),restoreRendererAndSceneState(renderer,scene,_rendererState$2)}vsmPass(renderer){const{shadow:shadow2}=this;this.vsmShadowMapVertical.setSize(shadow2.mapSize.width,shadow2.mapSize.height),this.vsmShadowMapHorizontal.setSize(shadow2.mapSize.width,shadow2.mapSize.height),renderer.setRenderTarget(this.vsmShadowMapVertical),_quadMesh$1.material=this.vsmMaterialVertical,_quadMesh$1.render(renderer),renderer.setRenderTarget(this.vsmShadowMapHorizontal),_quadMesh$1.material=this.vsmMaterialHorizontal,_quadMesh$1.render(renderer)}dispose(){this.shadowMap.dispose(),this.shadowMap=null,this.vsmShadowMapVertical!==null&&(this.vsmShadowMapVertical.dispose(),this.vsmShadowMapVertical=null,this.vsmMaterialVertical.dispose(),this.vsmMaterialVertical=null),this.vsmShadowMapHorizontal!==null&&(this.vsmShadowMapHorizontal.dispose(),this.vsmShadowMapHorizontal=null,this.vsmMaterialHorizontal.dispose(),this.vsmMaterialHorizontal=null),super.dispose()}updateBefore(frame){const{shadow:shadow2}=this;let needsUpdate=shadow2.needsUpdate||shadow2.autoUpdate;needsUpdate&&(this._cameraFrameId[frame.camera]===frame.frameId&&(needsUpdate=!1),this._cameraFrameId[frame.camera]=frame.frameId),needsUpdate&&(this.updateShadow(frame),this.shadowMap.depthTexture.version===this._depthVersionCached&&(shadow2.needsUpdate=!1))}}const shadow=(light,shadow2)=>nodeObject$1(new ShadowNode(light,shadow2)),_clearColor$1=new Color,cubeToUV=Fn$1(([pos,texelSizeY])=>{const v=pos.toVar(),absV=abs$2(v),scaleToCube=div(1,max$1(absV.x,max$1(absV.y,absV.z)));absV.mulAssign(scaleToCube),v.mulAssign(scaleToCube.mul(texelSizeY.mul(2).oneMinus()));const planar=vec2$1(v.xy).toVar(),almostOne=texelSizeY.mul(1.5).oneMinus();return If$1(absV.z.greaterThanEqual(almostOne),()=>{If$1(v.z.greaterThan(0),()=>{planar.x.assign(sub(4,v.x))})}).ElseIf(absV.x.greaterThanEqual(almostOne),()=>{const signX=sign$1(v.x);planar.x.assign(v.z.mul(signX).add(signX.mul(2)))}).ElseIf(absV.y.greaterThanEqual(almostOne),()=>{const signY=sign$1(v.y);planar.x.assign(v.x.add(signY.mul(2)).add(2)),planar.y.assign(v.z.mul(signY).sub(2))}),vec2$1(.125,.25).mul(planar).add(vec2$1(.375,.75)).flipY()}).setLayout({name:"cubeToUV",type:"vec2",inputs:[{name:"pos",type:"vec3"},{name:"texelSizeY",type:"float"}]}),BasicPointShadowFilter=Fn$1(({depthTexture,bd3D,dp,texelSize})=>texture$1(depthTexture,cubeToUV(bd3D,texelSize.y)).compare(dp)),PointShadowFilter=Fn$1(({depthTexture,bd3D,dp,texelSize,shadow:shadow2})=>{const radius=reference("radius","float",shadow2).setGroup(renderGroup),offset=vec2$1(-1,1).mul(radius).mul(texelSize.y);return texture$1(depthTexture,cubeToUV(bd3D.add(offset.xyy),texelSize.y)).compare(dp).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.yyy),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.xyx),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.yyx),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D,texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.xxy),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.yxy),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.xxx),texelSize.y)).compare(dp)).add(texture$1(depthTexture,cubeToUV(bd3D.add(offset.yxx),texelSize.y)).compare(dp)).mul(1/9)}),pointShadowFilter=Fn$1(({filterFn,depthTexture,shadowCoord,shadow:shadow2})=>{const lightToPosition=shadowCoord.xyz.toVar(),lightToPositionLength=lightToPosition.length(),cameraNearLocal=uniform$1("float").setGroup(renderGroup).onRenderUpdate(()=>shadow2.camera.near),cameraFarLocal=uniform$1("float").setGroup(renderGroup).onRenderUpdate(()=>shadow2.camera.far),bias=reference("bias","float",shadow2).setGroup(renderGroup),mapSize=uniform$1(shadow2.mapSize).setGroup(renderGroup),result=float$1(1).toVar();return If$1(lightToPositionLength.sub(cameraFarLocal).lessThanEqual(0).and(lightToPositionLength.sub(cameraNearLocal).greaterThanEqual(0)),()=>{const dp=lightToPositionLength.sub(cameraNearLocal).div(cameraFarLocal.sub(cameraNearLocal)).toVar();dp.addAssign(bias);const bd3D=lightToPosition.normalize(),texelSize=vec2$1(1).div(mapSize.mul(vec2$1(4,2)));result.assign(filterFn({depthTexture,bd3D,dp,texelSize,shadow:shadow2}))}),result}),_viewport=new Vector4,_viewportSize=new Vector2,_shadowMapSize=new Vector2;class PointShadowNode extends ShadowNode{static get type(){return"PointShadowNode"}constructor(light,shadow2=null){super(light,shadow2)}getShadowFilterFn(type){return type===BasicShadowMap?BasicPointShadowFilter:PointShadowFilter}setupShadowCoord(builder,shadowPosition){return shadowPosition}setupShadowFilter(builder,{filterFn,shadowTexture,depthTexture,shadowCoord,shadow:shadow2}){return pointShadowFilter({filterFn,shadowTexture,depthTexture,shadowCoord,shadow:shadow2})}renderShadow(frame){const{shadow:shadow2,shadowMap,light}=this,{renderer,scene}=frame,shadowFrameExtents=shadow2.getFrameExtents();_shadowMapSize.copy(shadow2.mapSize),_shadowMapSize.multiply(shadowFrameExtents),shadowMap.setSize(_shadowMapSize.width,_shadowMapSize.height),_viewportSize.copy(shadow2.mapSize);const previousAutoClear=renderer.autoClear,previousClearColor=renderer.getClearColor(_clearColor$1),previousClearAlpha=renderer.getClearAlpha();renderer.autoClear=!1,renderer.setClearColor(shadow2.clearColor,shadow2.clearAlpha),renderer.clear();const viewportCount=shadow2.getViewportCount();for(let vp=0;vp<viewportCount;vp++){const viewport2=shadow2.getViewport(vp),x=_viewportSize.x*viewport2.x,y=_shadowMapSize.y-_viewportSize.y-_viewportSize.y*viewport2.y;_viewport.set(x,y,_viewportSize.x*viewport2.z,_viewportSize.y*viewport2.w),shadowMap.viewport.copy(_viewport),shadow2.updateMatrices(light,vp),renderer.render(scene,shadow2.camera)}renderer.autoClear=previousAutoClear,renderer.setClearColor(previousClearColor,previousClearAlpha)}}const pointShadow=(light,shadow2)=>nodeObject$1(new PointShadowNode(light,shadow2));class AnalyticLightNode extends LightingNode{static get type(){return"AnalyticLightNode"}constructor(light=null){super(),this.light=light,this.color=new Color,this.colorNode=light&&light.colorNode||uniform$1(this.color).setGroup(renderGroup),this.baseColorNode=null,this.shadowNode=null,this.shadowColorNode=null,this.isAnalyticLightNode=!0,this.updateType=NodeUpdateType.FRAME}customCacheKey(){return hash$1(this.light.id,this.light.castShadow?1:0)}getHash(){return this.light.uuid}getLightVector(builder){return lightViewPosition(this.light).sub(builder.context.positionView||positionView)}setupDirect(){}setupDirectRectArea(){}setupShadowNode(){return shadow(this.light)}setupShadow(builder){const{renderer}=builder;if(renderer.shadowMap.enabled===!1)return;let shadowColorNode=this.shadowColorNode;if(shadowColorNode===null){const customShadowNode=this.light.shadow.shadowNode;let shadowNode;customShadowNode!==void 0?shadowNode=nodeObject$1(customShadowNode):shadowNode=this.setupShadowNode(builder),this.shadowNode=shadowNode,this.shadowColorNode=shadowColorNode=this.colorNode.mul(shadowNode),this.baseColorNode=this.colorNode}this.colorNode=shadowColorNode}setup(builder){this.colorNode=this.baseColorNode||this.colorNode,this.light.castShadow?builder.object.receiveShadow&&this.setupShadow(builder):this.shadowNode!==null&&(this.shadowNode.dispose(),this.shadowNode=null,this.shadowColorNode=null);const directLightData=this.setupDirect(builder),directRectAreaLightData=this.setupDirectRectArea(builder);directLightData&&builder.lightsNode.setupDirectLight(builder,this,directLightData),directRectAreaLightData&&builder.lightsNode.setupDirectRectAreaLight(builder,this,directRectAreaLightData)}update(){const{light}=this;this.color.copy(light.color).multiplyScalar(light.intensity)}}const getDistanceAttenuation=Fn$1(({lightDistance,cutoffDistance,decayExponent})=>{const distanceFalloff=lightDistance.pow(decayExponent).max(.01).reciprocal();return cutoffDistance.greaterThan(0).select(distanceFalloff.mul(lightDistance.div(cutoffDistance).pow4().oneMinus().clamp().pow2()),distanceFalloff)}),directPointLight=({color:color2,lightVector,cutoffDistance,decayExponent})=>{const lightDirection=lightVector.normalize(),lightDistance=lightVector.length(),attenuation=getDistanceAttenuation({lightDistance,cutoffDistance,decayExponent}),lightColor=color2.mul(attenuation);return{lightDirection,lightColor}};class PointLightNode extends AnalyticLightNode{static get type(){return"PointLightNode"}constructor(light=null){super(light),this.cutoffDistanceNode=uniform$1(0).setGroup(renderGroup),this.decayExponentNode=uniform$1(2).setGroup(renderGroup)}update(frame){const{light}=this;super.update(frame),this.cutoffDistanceNode.value=light.distance,this.decayExponentNode.value=light.decay}setupShadowNode(){return pointShadow(this.light)}setupDirect(builder){return directPointLight({color:this.colorNode,lightVector:this.getLightVector(builder),cutoffDistance:this.cutoffDistanceNode,decayExponent:this.decayExponentNode})}}const checker=Fn$1(([coord=uv$1()])=>{const uv2=coord.mul(2),cx=uv2.x.floor(),cy=uv2.y.floor();return cx.add(cy).mod(2).sign()}),shapeCircle=Fn$1(([coord=uv$1()],{renderer,material})=>{const alpha=float$1(1).toVar(),len2=lengthSq(coord.mul(2).sub(1));if(material.alphaToCoverage&&renderer.samples>1){const dlen=float$1(len2.fwidth()).toVar();alpha.assign(smoothstep$1(dlen.oneMinus(),dlen.add(1),len2).oneMinus())}else len2.greaterThan(1).discard();return alpha}),mx_select=Fn$1(([b_immutable,t_immutable,f_immutable])=>{const f2=float$1(f_immutable).toVar(),t2=float$1(t_immutable).toVar(),b=bool(b_immutable).toVar();return select(b,t2,f2)}).setLayout({name:"mx_select",type:"float",inputs:[{name:"b",type:"bool"},{name:"t",type:"float"},{name:"f",type:"float"}]}),mx_negate_if=Fn$1(([val_immutable,b_immutable])=>{const b=bool(b_immutable).toVar(),val=float$1(val_immutable).toVar();return select(b,val.negate(),val)}).setLayout({name:"mx_negate_if",type:"float",inputs:[{name:"val",type:"float"},{name:"b",type:"bool"}]}),mx_floor=Fn$1(([x_immutable])=>{const x=float$1(x_immutable).toVar();return int(floor$3(x))}).setLayout({name:"mx_floor",type:"int",inputs:[{name:"x",type:"float"}]}),mx_floorfrac=Fn$1(([x_immutable,i2])=>{const x=float$1(x_immutable).toVar();return i2.assign(mx_floor(x)),x.sub(float$1(i2))}),mx_bilerp_0=Fn$1(([v0_immutable,v1_immutable,v2_immutable,v3_immutable,s_immutable,t_immutable])=>{const t2=float$1(t_immutable).toVar(),s2=float$1(s_immutable).toVar(),v3=float$1(v3_immutable).toVar(),v2=float$1(v2_immutable).toVar(),v1=float$1(v1_immutable).toVar(),v0=float$1(v0_immutable).toVar(),s1=float$1(sub(1,s2)).toVar();return sub(1,t2).mul(v0.mul(s1).add(v1.mul(s2))).add(t2.mul(v2.mul(s1).add(v3.mul(s2))))}).setLayout({name:"mx_bilerp_0",type:"float",inputs:[{name:"v0",type:"float"},{name:"v1",type:"float"},{name:"v2",type:"float"},{name:"v3",type:"float"},{name:"s",type:"float"},{name:"t",type:"float"}]}),mx_bilerp_1=Fn$1(([v0_immutable,v1_immutable,v2_immutable,v3_immutable,s_immutable,t_immutable])=>{const t2=float$1(t_immutable).toVar(),s2=float$1(s_immutable).toVar(),v3=vec3$1(v3_immutable).toVar(),v2=vec3$1(v2_immutable).toVar(),v1=vec3$1(v1_immutable).toVar(),v0=vec3$1(v0_immutable).toVar(),s1=float$1(sub(1,s2)).toVar();return sub(1,t2).mul(v0.mul(s1).add(v1.mul(s2))).add(t2.mul(v2.mul(s1).add(v3.mul(s2))))}).setLayout({name:"mx_bilerp_1",type:"vec3",inputs:[{name:"v0",type:"vec3"},{name:"v1",type:"vec3"},{name:"v2",type:"vec3"},{name:"v3",type:"vec3"},{name:"s",type:"float"},{name:"t",type:"float"}]}),mx_bilerp=overloadingFn([mx_bilerp_0,mx_bilerp_1]),mx_trilerp_0=Fn$1(([v0_immutable,v1_immutable,v2_immutable,v3_immutable,v4_immutable,v5_immutable,v6_immutable,v7_immutable,s_immutable,t_immutable,r_immutable])=>{const r2=float$1(r_immutable).toVar(),t2=float$1(t_immutable).toVar(),s2=float$1(s_immutable).toVar(),v7=float$1(v7_immutable).toVar(),v6=float$1(v6_immutable).toVar(),v5=float$1(v5_immutable).toVar(),v4=float$1(v4_immutable).toVar(),v3=float$1(v3_immutable).toVar(),v2=float$1(v2_immutable).toVar(),v1=float$1(v1_immutable).toVar(),v0=float$1(v0_immutable).toVar(),s1=float$1(sub(1,s2)).toVar(),t1=float$1(sub(1,t2)).toVar();return float$1(sub(1,r2)).toVar().mul(t1.mul(v0.mul(s1).add(v1.mul(s2))).add(t2.mul(v2.mul(s1).add(v3.mul(s2))))).add(r2.mul(t1.mul(v4.mul(s1).add(v5.mul(s2))).add(t2.mul(v6.mul(s1).add(v7.mul(s2))))))}).setLayout({name:"mx_trilerp_0",type:"float",inputs:[{name:"v0",type:"float"},{name:"v1",type:"float"},{name:"v2",type:"float"},{name:"v3",type:"float"},{name:"v4",type:"float"},{name:"v5",type:"float"},{name:"v6",type:"float"},{name:"v7",type:"float"},{name:"s",type:"float"},{name:"t",type:"float"},{name:"r",type:"float"}]}),mx_trilerp_1=Fn$1(([v0_immutable,v1_immutable,v2_immutable,v3_immutable,v4_immutable,v5_immutable,v6_immutable,v7_immutable,s_immutable,t_immutable,r_immutable])=>{const r2=float$1(r_immutable).toVar(),t2=float$1(t_immutable).toVar(),s2=float$1(s_immutable).toVar(),v7=vec3$1(v7_immutable).toVar(),v6=vec3$1(v6_immutable).toVar(),v5=vec3$1(v5_immutable).toVar(),v4=vec3$1(v4_immutable).toVar(),v3=vec3$1(v3_immutable).toVar(),v2=vec3$1(v2_immutable).toVar(),v1=vec3$1(v1_immutable).toVar(),v0=vec3$1(v0_immutable).toVar(),s1=float$1(sub(1,s2)).toVar(),t1=float$1(sub(1,t2)).toVar();return float$1(sub(1,r2)).toVar().mul(t1.mul(v0.mul(s1).add(v1.mul(s2))).add(t2.mul(v2.mul(s1).add(v3.mul(s2))))).add(r2.mul(t1.mul(v4.mul(s1).add(v5.mul(s2))).add(t2.mul(v6.mul(s1).add(v7.mul(s2))))))}).setLayout({name:"mx_trilerp_1",type:"vec3",inputs:[{name:"v0",type:"vec3"},{name:"v1",type:"vec3"},{name:"v2",type:"vec3"},{name:"v3",type:"vec3"},{name:"v4",type:"vec3"},{name:"v5",type:"vec3"},{name:"v6",type:"vec3"},{name:"v7",type:"vec3"},{name:"s",type:"float"},{name:"t",type:"float"},{name:"r",type:"float"}]}),mx_trilerp=overloadingFn([mx_trilerp_0,mx_trilerp_1]),mx_gradient_float_0=Fn$1(([hash_immutable,x_immutable,y_immutable])=>{const y=float$1(y_immutable).toVar(),x=float$1(x_immutable).toVar(),hash2=uint(hash_immutable).toVar(),h=uint(hash2.bitAnd(uint(7))).toVar(),u=float$1(mx_select(h.lessThan(uint(4)),x,y)).toVar(),v=float$1(mul$1(2,mx_select(h.lessThan(uint(4)),y,x))).toVar();return mx_negate_if(u,bool(h.bitAnd(uint(1)))).add(mx_negate_if(v,bool(h.bitAnd(uint(2)))))}).setLayout({name:"mx_gradient_float_0",type:"float",inputs:[{name:"hash",type:"uint"},{name:"x",type:"float"},{name:"y",type:"float"}]}),mx_gradient_float_1=Fn$1(([hash_immutable,x_immutable,y_immutable,z_immutable])=>{const z=float$1(z_immutable).toVar(),y=float$1(y_immutable).toVar(),x=float$1(x_immutable).toVar(),hash2=uint(hash_immutable).toVar(),h=uint(hash2.bitAnd(uint(15))).toVar(),u=float$1(mx_select(h.lessThan(uint(8)),x,y)).toVar(),v=float$1(mx_select(h.lessThan(uint(4)),y,mx_select(h.equal(uint(12)).or(h.equal(uint(14))),x,z))).toVar();return mx_negate_if(u,bool(h.bitAnd(uint(1)))).add(mx_negate_if(v,bool(h.bitAnd(uint(2)))))}).setLayout({name:"mx_gradient_float_1",type:"float",inputs:[{name:"hash",type:"uint"},{name:"x",type:"float"},{name:"y",type:"float"},{name:"z",type:"float"}]}),mx_gradient_float=overloadingFn([mx_gradient_float_0,mx_gradient_float_1]),mx_gradient_vec3_0=Fn$1(([hash_immutable,x_immutable,y_immutable])=>{const y=float$1(y_immutable).toVar(),x=float$1(x_immutable).toVar(),hash2=uvec3(hash_immutable).toVar();return vec3$1(mx_gradient_float(hash2.x,x,y),mx_gradient_float(hash2.y,x,y),mx_gradient_float(hash2.z,x,y))}).setLayout({name:"mx_gradient_vec3_0",type:"vec3",inputs:[{name:"hash",type:"uvec3"},{name:"x",type:"float"},{name:"y",type:"float"}]}),mx_gradient_vec3_1=Fn$1(([hash_immutable,x_immutable,y_immutable,z_immutable])=>{const z=float$1(z_immutable).toVar(),y=float$1(y_immutable).toVar(),x=float$1(x_immutable).toVar(),hash2=uvec3(hash_immutable).toVar();return vec3$1(mx_gradient_float(hash2.x,x,y,z),mx_gradient_float(hash2.y,x,y,z),mx_gradient_float(hash2.z,x,y,z))}).setLayout({name:"mx_gradient_vec3_1",type:"vec3",inputs:[{name:"hash",type:"uvec3"},{name:"x",type:"float"},{name:"y",type:"float"},{name:"z",type:"float"}]}),mx_gradient_vec3=overloadingFn([mx_gradient_vec3_0,mx_gradient_vec3_1]),mx_gradient_scale2d_0=Fn$1(([v_immutable])=>{const v=float$1(v_immutable).toVar();return mul$1(.6616,v)}).setLayout({name:"mx_gradient_scale2d_0",type:"float",inputs:[{name:"v",type:"float"}]}),mx_gradient_scale3d_0=Fn$1(([v_immutable])=>{const v=float$1(v_immutable).toVar();return mul$1(.982,v)}).setLayout({name:"mx_gradient_scale3d_0",type:"float",inputs:[{name:"v",type:"float"}]}),mx_gradient_scale2d_1=Fn$1(([v_immutable])=>{const v=vec3$1(v_immutable).toVar();return mul$1(.6616,v)}).setLayout({name:"mx_gradient_scale2d_1",type:"vec3",inputs:[{name:"v",type:"vec3"}]}),mx_gradient_scale2d=overloadingFn([mx_gradient_scale2d_0,mx_gradient_scale2d_1]),mx_gradient_scale3d_1=Fn$1(([v_immutable])=>{const v=vec3$1(v_immutable).toVar();return mul$1(.982,v)}).setLayout({name:"mx_gradient_scale3d_1",type:"vec3",inputs:[{name:"v",type:"vec3"}]}),mx_gradient_scale3d=overloadingFn([mx_gradient_scale3d_0,mx_gradient_scale3d_1]),mx_rotl32=Fn$1(([x_immutable,k_immutable])=>{const k=int(k_immutable).toVar(),x=uint(x_immutable).toVar();return x.shiftLeft(k).bitOr(x.shiftRight(int(32).sub(k)))}).setLayout({name:"mx_rotl32",type:"uint",inputs:[{name:"x",type:"uint"},{name:"k",type:"int"}]}),mx_bjmix=Fn$1(([a2,b,c2])=>{a2.subAssign(c2),a2.bitXorAssign(mx_rotl32(c2,int(4))),c2.addAssign(b),b.subAssign(a2),b.bitXorAssign(mx_rotl32(a2,int(6))),a2.addAssign(c2),c2.subAssign(b),c2.bitXorAssign(mx_rotl32(b,int(8))),b.addAssign(a2),a2.subAssign(c2),a2.bitXorAssign(mx_rotl32(c2,int(16))),c2.addAssign(b),b.subAssign(a2),b.bitXorAssign(mx_rotl32(a2,int(19))),a2.addAssign(c2),c2.subAssign(b),c2.bitXorAssign(mx_rotl32(b,int(4))),b.addAssign(a2)}),mx_bjfinal=Fn$1(([a_immutable,b_immutable,c_immutable])=>{const c2=uint(c_immutable).toVar(),b=uint(b_immutable).toVar(),a2=uint(a_immutable).toVar();return c2.bitXorAssign(b),c2.subAssign(mx_rotl32(b,int(14))),a2.bitXorAssign(c2),a2.subAssign(mx_rotl32(c2,int(11))),b.bitXorAssign(a2),b.subAssign(mx_rotl32(a2,int(25))),c2.bitXorAssign(b),c2.subAssign(mx_rotl32(b,int(16))),a2.bitXorAssign(c2),a2.subAssign(mx_rotl32(c2,int(4))),b.bitXorAssign(a2),b.subAssign(mx_rotl32(a2,int(14))),c2.bitXorAssign(b),c2.subAssign(mx_rotl32(b,int(24))),c2}).setLayout({name:"mx_bjfinal",type:"uint",inputs:[{name:"a",type:"uint"},{name:"b",type:"uint"},{name:"c",type:"uint"}]}),mx_bits_to_01=Fn$1(([bits_immutable])=>{const bits=uint(bits_immutable).toVar();return float$1(bits).div(float$1(uint(int(4294967295))))}).setLayout({name:"mx_bits_to_01",type:"float",inputs:[{name:"bits",type:"uint"}]}),mx_fade=Fn$1(([t_immutable])=>{const t2=float$1(t_immutable).toVar();return t2.mul(t2).mul(t2).mul(t2.mul(t2.mul(6).sub(15)).add(10))}).setLayout({name:"mx_fade",type:"float",inputs:[{name:"t",type:"float"}]}),mx_hash_int_0=Fn$1(([x_immutable])=>{const x=int(x_immutable).toVar(),len=uint(uint(1)).toVar(),seed=uint(uint(int(3735928559)).add(len.shiftLeft(uint(2))).add(uint(13))).toVar();return mx_bjfinal(seed.add(uint(x)),seed,seed)}).setLayout({name:"mx_hash_int_0",type:"uint",inputs:[{name:"x",type:"int"}]}),mx_hash_int_1=Fn$1(([x_immutable,y_immutable])=>{const y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),len=uint(uint(2)).toVar(),a2=uint().toVar(),b=uint().toVar(),c2=uint().toVar();return a2.assign(b.assign(c2.assign(uint(int(3735928559)).add(len.shiftLeft(uint(2))).add(uint(13))))),a2.addAssign(uint(x)),b.addAssign(uint(y)),mx_bjfinal(a2,b,c2)}).setLayout({name:"mx_hash_int_1",type:"uint",inputs:[{name:"x",type:"int"},{name:"y",type:"int"}]}),mx_hash_int_2=Fn$1(([x_immutable,y_immutable,z_immutable])=>{const z=int(z_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),len=uint(uint(3)).toVar(),a2=uint().toVar(),b=uint().toVar(),c2=uint().toVar();return a2.assign(b.assign(c2.assign(uint(int(3735928559)).add(len.shiftLeft(uint(2))).add(uint(13))))),a2.addAssign(uint(x)),b.addAssign(uint(y)),c2.addAssign(uint(z)),mx_bjfinal(a2,b,c2)}).setLayout({name:"mx_hash_int_2",type:"uint",inputs:[{name:"x",type:"int"},{name:"y",type:"int"},{name:"z",type:"int"}]}),mx_hash_int_3=Fn$1(([x_immutable,y_immutable,z_immutable,xx_immutable])=>{const xx=int(xx_immutable).toVar(),z=int(z_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),len=uint(uint(4)).toVar(),a2=uint().toVar(),b=uint().toVar(),c2=uint().toVar();return a2.assign(b.assign(c2.assign(uint(int(3735928559)).add(len.shiftLeft(uint(2))).add(uint(13))))),a2.addAssign(uint(x)),b.addAssign(uint(y)),c2.addAssign(uint(z)),mx_bjmix(a2,b,c2),a2.addAssign(uint(xx)),mx_bjfinal(a2,b,c2)}).setLayout({name:"mx_hash_int_3",type:"uint",inputs:[{name:"x",type:"int"},{name:"y",type:"int"},{name:"z",type:"int"},{name:"xx",type:"int"}]}),mx_hash_int_4=Fn$1(([x_immutable,y_immutable,z_immutable,xx_immutable,yy_immutable])=>{const yy=int(yy_immutable).toVar(),xx=int(xx_immutable).toVar(),z=int(z_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),len=uint(uint(5)).toVar(),a2=uint().toVar(),b=uint().toVar(),c2=uint().toVar();return a2.assign(b.assign(c2.assign(uint(int(3735928559)).add(len.shiftLeft(uint(2))).add(uint(13))))),a2.addAssign(uint(x)),b.addAssign(uint(y)),c2.addAssign(uint(z)),mx_bjmix(a2,b,c2),a2.addAssign(uint(xx)),b.addAssign(uint(yy)),mx_bjfinal(a2,b,c2)}).setLayout({name:"mx_hash_int_4",type:"uint",inputs:[{name:"x",type:"int"},{name:"y",type:"int"},{name:"z",type:"int"},{name:"xx",type:"int"},{name:"yy",type:"int"}]}),mx_hash_int=overloadingFn([mx_hash_int_0,mx_hash_int_1,mx_hash_int_2,mx_hash_int_3,mx_hash_int_4]),mx_hash_vec3_0=Fn$1(([x_immutable,y_immutable])=>{const y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),h=uint(mx_hash_int(x,y)).toVar(),result=uvec3().toVar();return result.x.assign(h.bitAnd(int(255))),result.y.assign(h.shiftRight(int(8)).bitAnd(int(255))),result.z.assign(h.shiftRight(int(16)).bitAnd(int(255))),result}).setLayout({name:"mx_hash_vec3_0",type:"uvec3",inputs:[{name:"x",type:"int"},{name:"y",type:"int"}]}),mx_hash_vec3_1=Fn$1(([x_immutable,y_immutable,z_immutable])=>{const z=int(z_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),h=uint(mx_hash_int(x,y,z)).toVar(),result=uvec3().toVar();return result.x.assign(h.bitAnd(int(255))),result.y.assign(h.shiftRight(int(8)).bitAnd(int(255))),result.z.assign(h.shiftRight(int(16)).bitAnd(int(255))),result}).setLayout({name:"mx_hash_vec3_1",type:"uvec3",inputs:[{name:"x",type:"int"},{name:"y",type:"int"},{name:"z",type:"int"}]}),mx_hash_vec3=overloadingFn([mx_hash_vec3_0,mx_hash_vec3_1]),mx_perlin_noise_float_0=Fn$1(([p_immutable])=>{const p=vec2$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),fx=float$1(mx_floorfrac(p.x,X)).toVar(),fy=float$1(mx_floorfrac(p.y,Y)).toVar(),u=float$1(mx_fade(fx)).toVar(),v=float$1(mx_fade(fy)).toVar(),result=float$1(mx_bilerp(mx_gradient_float(mx_hash_int(X,Y),fx,fy),mx_gradient_float(mx_hash_int(X.add(int(1)),Y),fx.sub(1),fy),mx_gradient_float(mx_hash_int(X,Y.add(int(1))),fx,fy.sub(1)),mx_gradient_float(mx_hash_int(X.add(int(1)),Y.add(int(1))),fx.sub(1),fy.sub(1)),u,v)).toVar();return mx_gradient_scale2d(result)}).setLayout({name:"mx_perlin_noise_float_0",type:"float",inputs:[{name:"p",type:"vec2"}]}),mx_perlin_noise_float_1=Fn$1(([p_immutable])=>{const p=vec3$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),Z=int().toVar(),fx=float$1(mx_floorfrac(p.x,X)).toVar(),fy=float$1(mx_floorfrac(p.y,Y)).toVar(),fz=float$1(mx_floorfrac(p.z,Z)).toVar(),u=float$1(mx_fade(fx)).toVar(),v=float$1(mx_fade(fy)).toVar(),w=float$1(mx_fade(fz)).toVar(),result=float$1(mx_trilerp(mx_gradient_float(mx_hash_int(X,Y,Z),fx,fy,fz),mx_gradient_float(mx_hash_int(X.add(int(1)),Y,Z),fx.sub(1),fy,fz),mx_gradient_float(mx_hash_int(X,Y.add(int(1)),Z),fx,fy.sub(1),fz),mx_gradient_float(mx_hash_int(X.add(int(1)),Y.add(int(1)),Z),fx.sub(1),fy.sub(1),fz),mx_gradient_float(mx_hash_int(X,Y,Z.add(int(1))),fx,fy,fz.sub(1)),mx_gradient_float(mx_hash_int(X.add(int(1)),Y,Z.add(int(1))),fx.sub(1),fy,fz.sub(1)),mx_gradient_float(mx_hash_int(X,Y.add(int(1)),Z.add(int(1))),fx,fy.sub(1),fz.sub(1)),mx_gradient_float(mx_hash_int(X.add(int(1)),Y.add(int(1)),Z.add(int(1))),fx.sub(1),fy.sub(1),fz.sub(1)),u,v,w)).toVar();return mx_gradient_scale3d(result)}).setLayout({name:"mx_perlin_noise_float_1",type:"float",inputs:[{name:"p",type:"vec3"}]}),mx_perlin_noise_float=overloadingFn([mx_perlin_noise_float_0,mx_perlin_noise_float_1]),mx_perlin_noise_vec3_0=Fn$1(([p_immutable])=>{const p=vec2$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),fx=float$1(mx_floorfrac(p.x,X)).toVar(),fy=float$1(mx_floorfrac(p.y,Y)).toVar(),u=float$1(mx_fade(fx)).toVar(),v=float$1(mx_fade(fy)).toVar(),result=vec3$1(mx_bilerp(mx_gradient_vec3(mx_hash_vec3(X,Y),fx,fy),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y),fx.sub(1),fy),mx_gradient_vec3(mx_hash_vec3(X,Y.add(int(1))),fx,fy.sub(1)),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y.add(int(1))),fx.sub(1),fy.sub(1)),u,v)).toVar();return mx_gradient_scale2d(result)}).setLayout({name:"mx_perlin_noise_vec3_0",type:"vec3",inputs:[{name:"p",type:"vec2"}]}),mx_perlin_noise_vec3_1=Fn$1(([p_immutable])=>{const p=vec3$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),Z=int().toVar(),fx=float$1(mx_floorfrac(p.x,X)).toVar(),fy=float$1(mx_floorfrac(p.y,Y)).toVar(),fz=float$1(mx_floorfrac(p.z,Z)).toVar(),u=float$1(mx_fade(fx)).toVar(),v=float$1(mx_fade(fy)).toVar(),w=float$1(mx_fade(fz)).toVar(),result=vec3$1(mx_trilerp(mx_gradient_vec3(mx_hash_vec3(X,Y,Z),fx,fy,fz),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y,Z),fx.sub(1),fy,fz),mx_gradient_vec3(mx_hash_vec3(X,Y.add(int(1)),Z),fx,fy.sub(1),fz),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y.add(int(1)),Z),fx.sub(1),fy.sub(1),fz),mx_gradient_vec3(mx_hash_vec3(X,Y,Z.add(int(1))),fx,fy,fz.sub(1)),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y,Z.add(int(1))),fx.sub(1),fy,fz.sub(1)),mx_gradient_vec3(mx_hash_vec3(X,Y.add(int(1)),Z.add(int(1))),fx,fy.sub(1),fz.sub(1)),mx_gradient_vec3(mx_hash_vec3(X.add(int(1)),Y.add(int(1)),Z.add(int(1))),fx.sub(1),fy.sub(1),fz.sub(1)),u,v,w)).toVar();return mx_gradient_scale3d(result)}).setLayout({name:"mx_perlin_noise_vec3_1",type:"vec3",inputs:[{name:"p",type:"vec3"}]}),mx_perlin_noise_vec3=overloadingFn([mx_perlin_noise_vec3_0,mx_perlin_noise_vec3_1]),mx_cell_noise_float_0=Fn$1(([p_immutable])=>{const p=float$1(p_immutable).toVar(),ix=int(mx_floor(p)).toVar();return mx_bits_to_01(mx_hash_int(ix))}).setLayout({name:"mx_cell_noise_float_0",type:"float",inputs:[{name:"p",type:"float"}]}),mx_cell_noise_float_1=Fn$1(([p_immutable])=>{const p=vec2$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar();return mx_bits_to_01(mx_hash_int(ix,iy))}).setLayout({name:"mx_cell_noise_float_1",type:"float",inputs:[{name:"p",type:"vec2"}]}),mx_cell_noise_float_2=Fn$1(([p_immutable])=>{const p=vec3$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar(),iz=int(mx_floor(p.z)).toVar();return mx_bits_to_01(mx_hash_int(ix,iy,iz))}).setLayout({name:"mx_cell_noise_float_2",type:"float",inputs:[{name:"p",type:"vec3"}]}),mx_cell_noise_float_3=Fn$1(([p_immutable])=>{const p=vec4$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar(),iz=int(mx_floor(p.z)).toVar(),iw=int(mx_floor(p.w)).toVar();return mx_bits_to_01(mx_hash_int(ix,iy,iz,iw))}).setLayout({name:"mx_cell_noise_float_3",type:"float",inputs:[{name:"p",type:"vec4"}]}),mx_cell_noise_float$1=overloadingFn([mx_cell_noise_float_0,mx_cell_noise_float_1,mx_cell_noise_float_2,mx_cell_noise_float_3]),mx_cell_noise_vec3_0=Fn$1(([p_immutable])=>{const p=float$1(p_immutable).toVar(),ix=int(mx_floor(p)).toVar();return vec3$1(mx_bits_to_01(mx_hash_int(ix,int(0))),mx_bits_to_01(mx_hash_int(ix,int(1))),mx_bits_to_01(mx_hash_int(ix,int(2))))}).setLayout({name:"mx_cell_noise_vec3_0",type:"vec3",inputs:[{name:"p",type:"float"}]}),mx_cell_noise_vec3_1=Fn$1(([p_immutable])=>{const p=vec2$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar();return vec3$1(mx_bits_to_01(mx_hash_int(ix,iy,int(0))),mx_bits_to_01(mx_hash_int(ix,iy,int(1))),mx_bits_to_01(mx_hash_int(ix,iy,int(2))))}).setLayout({name:"mx_cell_noise_vec3_1",type:"vec3",inputs:[{name:"p",type:"vec2"}]}),mx_cell_noise_vec3_2=Fn$1(([p_immutable])=>{const p=vec3$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar(),iz=int(mx_floor(p.z)).toVar();return vec3$1(mx_bits_to_01(mx_hash_int(ix,iy,iz,int(0))),mx_bits_to_01(mx_hash_int(ix,iy,iz,int(1))),mx_bits_to_01(mx_hash_int(ix,iy,iz,int(2))))}).setLayout({name:"mx_cell_noise_vec3_2",type:"vec3",inputs:[{name:"p",type:"vec3"}]}),mx_cell_noise_vec3_3=Fn$1(([p_immutable])=>{const p=vec4$1(p_immutable).toVar(),ix=int(mx_floor(p.x)).toVar(),iy=int(mx_floor(p.y)).toVar(),iz=int(mx_floor(p.z)).toVar(),iw=int(mx_floor(p.w)).toVar();return vec3$1(mx_bits_to_01(mx_hash_int(ix,iy,iz,iw,int(0))),mx_bits_to_01(mx_hash_int(ix,iy,iz,iw,int(1))),mx_bits_to_01(mx_hash_int(ix,iy,iz,iw,int(2))))}).setLayout({name:"mx_cell_noise_vec3_3",type:"vec3",inputs:[{name:"p",type:"vec4"}]}),mx_cell_noise_vec3=overloadingFn([mx_cell_noise_vec3_0,mx_cell_noise_vec3_1,mx_cell_noise_vec3_2,mx_cell_noise_vec3_3]),mx_fractal_noise_float$1=Fn$1(([p_immutable,octaves_immutable,lacunarity_immutable,diminish_immutable])=>{const diminish=float$1(diminish_immutable).toVar(),lacunarity=float$1(lacunarity_immutable).toVar(),octaves=int(octaves_immutable).toVar(),p=vec3$1(p_immutable).toVar(),result=float$1(0).toVar(),amplitude=float$1(1).toVar();return Loop(octaves,()=>{result.addAssign(amplitude.mul(mx_perlin_noise_float(p))),amplitude.mulAssign(diminish),p.mulAssign(lacunarity)}),result}).setLayout({name:"mx_fractal_noise_float",type:"float",inputs:[{name:"p",type:"vec3"},{name:"octaves",type:"int"},{name:"lacunarity",type:"float"},{name:"diminish",type:"float"}]}),mx_fractal_noise_vec3$1=Fn$1(([p_immutable,octaves_immutable,lacunarity_immutable,diminish_immutable])=>{const diminish=float$1(diminish_immutable).toVar(),lacunarity=float$1(lacunarity_immutable).toVar(),octaves=int(octaves_immutable).toVar(),p=vec3$1(p_immutable).toVar(),result=vec3$1(0).toVar(),amplitude=float$1(1).toVar();return Loop(octaves,()=>{result.addAssign(amplitude.mul(mx_perlin_noise_vec3(p))),amplitude.mulAssign(diminish),p.mulAssign(lacunarity)}),result}).setLayout({name:"mx_fractal_noise_vec3",type:"vec3",inputs:[{name:"p",type:"vec3"},{name:"octaves",type:"int"},{name:"lacunarity",type:"float"},{name:"diminish",type:"float"}]}),mx_fractal_noise_vec2$1=Fn$1(([p_immutable,octaves_immutable,lacunarity_immutable,diminish_immutable])=>{const diminish=float$1(diminish_immutable).toVar(),lacunarity=float$1(lacunarity_immutable).toVar(),octaves=int(octaves_immutable).toVar(),p=vec3$1(p_immutable).toVar();return vec2$1(mx_fractal_noise_float$1(p,octaves,lacunarity,diminish),mx_fractal_noise_float$1(p.add(vec3$1(int(19),int(193),int(17))),octaves,lacunarity,diminish))}).setLayout({name:"mx_fractal_noise_vec2",type:"vec2",inputs:[{name:"p",type:"vec3"},{name:"octaves",type:"int"},{name:"lacunarity",type:"float"},{name:"diminish",type:"float"}]}),mx_fractal_noise_vec4$1=Fn$1(([p_immutable,octaves_immutable,lacunarity_immutable,diminish_immutable])=>{const diminish=float$1(diminish_immutable).toVar(),lacunarity=float$1(lacunarity_immutable).toVar(),octaves=int(octaves_immutable).toVar(),p=vec3$1(p_immutable).toVar(),c2=vec3$1(mx_fractal_noise_vec3$1(p,octaves,lacunarity,diminish)).toVar(),f2=float$1(mx_fractal_noise_float$1(p.add(vec3$1(int(19),int(193),int(17))),octaves,lacunarity,diminish)).toVar();return vec4$1(c2,f2)}).setLayout({name:"mx_fractal_noise_vec4",type:"vec4",inputs:[{name:"p",type:"vec3"},{name:"octaves",type:"int"},{name:"lacunarity",type:"float"},{name:"diminish",type:"float"}]}),mx_worley_distance_0=Fn$1(([p_immutable,x_immutable,y_immutable,xoff_immutable,yoff_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),yoff=int(yoff_immutable).toVar(),xoff=int(xoff_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),p=vec2$1(p_immutable).toVar(),tmp=vec3$1(mx_cell_noise_vec3(vec2$1(x.add(xoff),y.add(yoff)))).toVar(),off=vec2$1(tmp.x,tmp.y).toVar();off.subAssign(.5),off.mulAssign(jitter),off.addAssign(.5);const cellpos=vec2$1(vec2$1(float$1(x),float$1(y)).add(off)).toVar(),diff=vec2$1(cellpos.sub(p)).toVar();return If$1(metric.equal(int(2)),()=>abs$2(diff.x).add(abs$2(diff.y))),If$1(metric.equal(int(3)),()=>max$1(abs$2(diff.x),abs$2(diff.y))),dot(diff,diff)}).setLayout({name:"mx_worley_distance_0",type:"float",inputs:[{name:"p",type:"vec2"},{name:"x",type:"int"},{name:"y",type:"int"},{name:"xoff",type:"int"},{name:"yoff",type:"int"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_distance_1=Fn$1(([p_immutable,x_immutable,y_immutable,z_immutable,xoff_immutable,yoff_immutable,zoff_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),zoff=int(zoff_immutable).toVar(),yoff=int(yoff_immutable).toVar(),xoff=int(xoff_immutable).toVar(),z=int(z_immutable).toVar(),y=int(y_immutable).toVar(),x=int(x_immutable).toVar(),p=vec3$1(p_immutable).toVar(),off=vec3$1(mx_cell_noise_vec3(vec3$1(x.add(xoff),y.add(yoff),z.add(zoff)))).toVar();off.subAssign(.5),off.mulAssign(jitter),off.addAssign(.5);const cellpos=vec3$1(vec3$1(float$1(x),float$1(y),float$1(z)).add(off)).toVar(),diff=vec3$1(cellpos.sub(p)).toVar();return If$1(metric.equal(int(2)),()=>abs$2(diff.x).add(abs$2(diff.y)).add(abs$2(diff.z))),If$1(metric.equal(int(3)),()=>max$1(max$1(abs$2(diff.x),abs$2(diff.y)),abs$2(diff.z))),dot(diff,diff)}).setLayout({name:"mx_worley_distance_1",type:"float",inputs:[{name:"p",type:"vec3"},{name:"x",type:"int"},{name:"y",type:"int"},{name:"z",type:"int"},{name:"xoff",type:"int"},{name:"yoff",type:"int"},{name:"zoff",type:"int"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_distance=overloadingFn([mx_worley_distance_0,mx_worley_distance_1]),mx_worley_noise_float_0=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec2$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),localpos=vec2$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y)).toVar(),sqdist=float$1(1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{const dist=float$1(mx_worley_distance(localpos,x,y,X,Y,jitter,metric)).toVar();sqdist.assign(min$1(sqdist,dist))})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_float_0",type:"float",inputs:[{name:"p",type:"vec2"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_vec2_0=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec2$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),localpos=vec2$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y)).toVar(),sqdist=vec2$1(1e6,1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{const dist=float$1(mx_worley_distance(localpos,x,y,X,Y,jitter,metric)).toVar();If$1(dist.lessThan(sqdist.x),()=>{sqdist.y.assign(sqdist.x),sqdist.x.assign(dist)}).ElseIf(dist.lessThan(sqdist.y),()=>{sqdist.y.assign(dist)})})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_vec2_0",type:"vec2",inputs:[{name:"p",type:"vec2"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_vec3_0=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec2$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),localpos=vec2$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y)).toVar(),sqdist=vec3$1(1e6,1e6,1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{const dist=float$1(mx_worley_distance(localpos,x,y,X,Y,jitter,metric)).toVar();If$1(dist.lessThan(sqdist.x),()=>{sqdist.z.assign(sqdist.y),sqdist.y.assign(sqdist.x),sqdist.x.assign(dist)}).ElseIf(dist.lessThan(sqdist.y),()=>{sqdist.z.assign(sqdist.y),sqdist.y.assign(dist)}).ElseIf(dist.lessThan(sqdist.z),()=>{sqdist.z.assign(dist)})})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_vec3_0",type:"vec3",inputs:[{name:"p",type:"vec2"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_float_1=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec3$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),Z=int().toVar(),localpos=vec3$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y),mx_floorfrac(p.z,Z)).toVar(),sqdist=float$1(1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{Loop({start:-1,end:int(1),name:"z",condition:"<="},({z})=>{const dist=float$1(mx_worley_distance(localpos,x,y,z,X,Y,Z,jitter,metric)).toVar();sqdist.assign(min$1(sqdist,dist))})})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_float_1",type:"float",inputs:[{name:"p",type:"vec3"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_float$1=overloadingFn([mx_worley_noise_float_0,mx_worley_noise_float_1]),mx_worley_noise_vec2_1=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec3$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),Z=int().toVar(),localpos=vec3$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y),mx_floorfrac(p.z,Z)).toVar(),sqdist=vec2$1(1e6,1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{Loop({start:-1,end:int(1),name:"z",condition:"<="},({z})=>{const dist=float$1(mx_worley_distance(localpos,x,y,z,X,Y,Z,jitter,metric)).toVar();If$1(dist.lessThan(sqdist.x),()=>{sqdist.y.assign(sqdist.x),sqdist.x.assign(dist)}).ElseIf(dist.lessThan(sqdist.y),()=>{sqdist.y.assign(dist)})})})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_vec2_1",type:"vec2",inputs:[{name:"p",type:"vec3"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_vec2$1=overloadingFn([mx_worley_noise_vec2_0,mx_worley_noise_vec2_1]),mx_worley_noise_vec3_1=Fn$1(([p_immutable,jitter_immutable,metric_immutable])=>{const metric=int(metric_immutable).toVar(),jitter=float$1(jitter_immutable).toVar(),p=vec3$1(p_immutable).toVar(),X=int().toVar(),Y=int().toVar(),Z=int().toVar(),localpos=vec3$1(mx_floorfrac(p.x,X),mx_floorfrac(p.y,Y),mx_floorfrac(p.z,Z)).toVar(),sqdist=vec3$1(1e6,1e6,1e6).toVar();return Loop({start:-1,end:int(1),name:"x",condition:"<="},({x})=>{Loop({start:-1,end:int(1),name:"y",condition:"<="},({y})=>{Loop({start:-1,end:int(1),name:"z",condition:"<="},({z})=>{const dist=float$1(mx_worley_distance(localpos,x,y,z,X,Y,Z,jitter,metric)).toVar();If$1(dist.lessThan(sqdist.x),()=>{sqdist.z.assign(sqdist.y),sqdist.y.assign(sqdist.x),sqdist.x.assign(dist)}).ElseIf(dist.lessThan(sqdist.y),()=>{sqdist.z.assign(sqdist.y),sqdist.y.assign(dist)}).ElseIf(dist.lessThan(sqdist.z),()=>{sqdist.z.assign(dist)})})})}),If$1(metric.equal(int(0)),()=>{sqdist.assign(sqrt$2(sqdist))}),sqdist}).setLayout({name:"mx_worley_noise_vec3_1",type:"vec3",inputs:[{name:"p",type:"vec3"},{name:"jitter",type:"float"},{name:"metric",type:"int"}]}),mx_worley_noise_vec3$1=overloadingFn([mx_worley_noise_vec3_0,mx_worley_noise_vec3_1]),mx_hsvtorgb=Fn$1(([hsv])=>{const s2=hsv.y,v=hsv.z,result=vec3$1().toVar();return If$1(s2.lessThan(1e-4),()=>{result.assign(vec3$1(v,v,v))}).Else(()=>{let h=hsv.x;h=h.sub(floor$3(h)).mul(6).toVar();const hi=int(trunc(h)),f2=h.sub(float$1(hi)),p=v.mul(s2.oneMinus()),q=v.mul(s2.mul(f2).oneMinus()),t2=v.mul(s2.mul(f2.oneMinus()).oneMinus());If$1(hi.equal(int(0)),()=>{result.assign(vec3$1(v,t2,p))}).ElseIf(hi.equal(int(1)),()=>{result.assign(vec3$1(q,v,p))}).ElseIf(hi.equal(int(2)),()=>{result.assign(vec3$1(p,v,t2))}).ElseIf(hi.equal(int(3)),()=>{result.assign(vec3$1(p,q,v))}).ElseIf(hi.equal(int(4)),()=>{result.assign(vec3$1(t2,p,v))}).Else(()=>{result.assign(vec3$1(v,p,q))})}),result}).setLayout({name:"mx_hsvtorgb",type:"vec3",inputs:[{name:"hsv",type:"vec3"}]}),mx_rgbtohsv=Fn$1(([c_immutable])=>{const c2=vec3$1(c_immutable).toVar(),r2=float$1(c2.x).toVar(),g=float$1(c2.y).toVar(),b=float$1(c2.z).toVar(),mincomp=float$1(min$1(r2,min$1(g,b))).toVar(),maxcomp=float$1(max$1(r2,max$1(g,b))).toVar(),delta=float$1(maxcomp.sub(mincomp)).toVar(),h=float$1().toVar(),s2=float$1().toVar(),v=float$1().toVar();return v.assign(maxcomp),If$1(maxcomp.greaterThan(0),()=>{s2.assign(delta.div(maxcomp))}).Else(()=>{s2.assign(0)}),If$1(s2.lessThanEqual(0),()=>{h.assign(0)}).Else(()=>{If$1(r2.greaterThanEqual(maxcomp),()=>{h.assign(g.sub(b).div(delta))}).ElseIf(g.greaterThanEqual(maxcomp),()=>{h.assign(add$3(2,b.sub(r2).div(delta)))}).Else(()=>{h.assign(add$3(4,r2.sub(g).div(delta)))}),h.mulAssign(1/6),If$1(h.lessThan(0),()=>{h.addAssign(1)})}),vec3$1(h,s2,v)}).setLayout({name:"mx_rgbtohsv",type:"vec3",inputs:[{name:"c",type:"vec3"}]}),mx_srgb_texture_to_lin_rec709=Fn$1(([color_immutable])=>{const color2=vec3$1(color_immutable).toVar(),isAbove=bvec3(greaterThan(color2,vec3$1(.04045))).toVar(),linSeg=vec3$1(color2.div(12.92)).toVar(),powSeg=vec3$1(pow$1(max$1(color2.add(vec3$1(.055)),vec3$1(0)).div(1.055),vec3$1(2.4))).toVar();return mix$1(linSeg,powSeg,isAbove)}).setLayout({name:"mx_srgb_texture_to_lin_rec709",type:"vec3",inputs:[{name:"color",type:"vec3"}]}),mx_aastep=(threshold,value)=>{threshold=float$1(threshold),value=float$1(value);const afwidth=vec2$1(value.dFdx(),value.dFdy()).length().mul(.7071067811865476);return smoothstep$1(threshold.sub(afwidth),threshold.add(afwidth),value)},_ramp=(a2,b,uv2,p)=>mix$1(a2,b,uv2[p].clamp()),mx_ramplr=(valuel,valuer,texcoord=uv$1())=>_ramp(valuel,valuer,texcoord,"x"),mx_ramptb=(valuet,valueb,texcoord=uv$1())=>_ramp(valuet,valueb,texcoord,"y"),_split=(a2,b,center,uv2,p)=>mix$1(a2,b,mx_aastep(center,uv2[p])),mx_splitlr=(valuel,valuer,center,texcoord=uv$1())=>_split(valuel,valuer,center,texcoord,"x"),mx_splittb=(valuet,valueb,center,texcoord=uv$1())=>_split(valuet,valueb,center,texcoord,"y"),mx_transform_uv=(uv_scale=1,uv_offset=0,uv_geo=uv$1())=>uv_geo.mul(uv_scale).add(uv_offset),mx_safepower=(in1,in2=1)=>(in1=float$1(in1),in1.abs().pow(in2).mul(in1.sign())),mx_contrast=(input,amount=1,pivot=.5)=>float$1(input).sub(pivot).mul(amount).add(pivot),mx_noise_float=(texcoord=uv$1(),amplitude=1,pivot=0)=>mx_perlin_noise_float(texcoord.convert("vec2|vec3")).mul(amplitude).add(pivot),mx_noise_vec3=(texcoord=uv$1(),amplitude=1,pivot=0)=>mx_perlin_noise_vec3(texcoord.convert("vec2|vec3")).mul(amplitude).add(pivot),mx_noise_vec4=(texcoord=uv$1(),amplitude=1,pivot=0)=>(texcoord=texcoord.convert("vec2|vec3"),vec4$1(mx_perlin_noise_vec3(texcoord),mx_perlin_noise_float(texcoord.add(vec2$1(19,73)))).mul(amplitude).add(pivot)),mx_worley_noise_float=(texcoord=uv$1(),jitter=1)=>mx_worley_noise_float$1(texcoord.convert("vec2|vec3"),jitter,int(1)),mx_worley_noise_vec2=(texcoord=uv$1(),jitter=1)=>mx_worley_noise_vec2$1(texcoord.convert("vec2|vec3"),jitter,int(1)),mx_worley_noise_vec3=(texcoord=uv$1(),jitter=1)=>mx_worley_noise_vec3$1(texcoord.convert("vec2|vec3"),jitter,int(1)),mx_cell_noise_float=(texcoord=uv$1())=>mx_cell_noise_float$1(texcoord.convert("vec2|vec3")),mx_fractal_noise_float=(position=uv$1(),octaves=3,lacunarity=2,diminish=.5,amplitude=1)=>mx_fractal_noise_float$1(position,int(octaves),lacunarity,diminish).mul(amplitude),mx_fractal_noise_vec2=(position=uv$1(),octaves=3,lacunarity=2,diminish=.5,amplitude=1)=>mx_fractal_noise_vec2$1(position,int(octaves),lacunarity,diminish).mul(amplitude),mx_fractal_noise_vec3=(position=uv$1(),octaves=3,lacunarity=2,diminish=.5,amplitude=1)=>mx_fractal_noise_vec3$1(position,int(octaves),lacunarity,diminish).mul(amplitude),mx_fractal_noise_vec4=(position=uv$1(),octaves=3,lacunarity=2,diminish=.5,amplitude=1)=>mx_fractal_noise_vec4$1(position,int(octaves),lacunarity,diminish).mul(amplitude),getParallaxCorrectNormal=Fn$1(([normal2,cubeSize,cubePos])=>{const nDir=normalize$1(normal2).toVar("nDir"),rbmax=sub(float$1(.5).mul(cubeSize.sub(cubePos)),positionWorld).div(nDir).toVar("rbmax"),rbmin=sub(float$1(-.5).mul(cubeSize.sub(cubePos)),positionWorld).div(nDir).toVar("rbmin"),rbminmax=vec3$1().toVar("rbminmax");rbminmax.x=nDir.x.greaterThan(float$1(0)).select(rbmax.x,rbmin.x),rbminmax.y=nDir.y.greaterThan(float$1(0)).select(rbmax.y,rbmin.y),rbminmax.z=nDir.z.greaterThan(float$1(0)).select(rbmax.z,rbmin.z);const correction=min$1(min$1(rbminmax.x,rbminmax.y),rbminmax.z).toVar("correction");return positionWorld.add(nDir.mul(correction)).toVar("boxIntersection").sub(cubePos)}),getShIrradianceAt=Fn$1(([normal2,shCoefficients])=>{const x=normal2.x,y=normal2.y,z=normal2.z;let result=shCoefficients.element(0).mul(.886227);return result=result.add(shCoefficients.element(1).mul(2*.511664).mul(y)),result=result.add(shCoefficients.element(2).mul(2*.511664).mul(z)),result=result.add(shCoefficients.element(3).mul(2*.511664).mul(x)),result=result.add(shCoefficients.element(4).mul(2*.429043).mul(x).mul(y)),result=result.add(shCoefficients.element(5).mul(2*.429043).mul(y).mul(z)),result=result.add(shCoefficients.element(6).mul(z.mul(z).mul(.743125).sub(.247708))),result=result.add(shCoefficients.element(7).mul(2*.429043).mul(x).mul(z)),result=result.add(shCoefficients.element(8).mul(.429043).mul(mul$1(x,x).sub(mul$1(y,y)))),result});var TSL=Object.freeze({__proto__:null,BRDF_GGX,BRDF_Lambert,BasicPointShadowFilter,BasicShadowFilter,Break,Const,Continue,DFGApprox,D_GGX,Discard:Discard$1,EPSILON,F_Schlick,Fn:Fn$1,INFINITY,If:If$1,Loop,NodeAccess,NodeShaderStage,NodeType,NodeUpdateType,PCFShadowFilter,PCFSoftShadowFilter,PI:PI$1,PI2,PointShadowFilter,Return,Schlick_to_F0,ScriptableNodeResources,ShaderNode,TBNViewMatrix,VSMShadowFilter,V_GGX_SmithCorrelated,Var,abs:abs$2,acesFilmicToneMapping,acos,add:add$3,addMethodChaining,addNodeElement,agxToneMapping,all:all$1,alphaT,and,anisotropy,anisotropyB,anisotropyT,any,append,array,arrayBuffer,asin:asin$1,assign,atan:atan$1,atan2,atomicAdd,atomicAnd,atomicFunc,atomicLoad,atomicMax,atomicMin,atomicOr,atomicStore,atomicSub,atomicXor,attenuationColor,attenuationDistance,attribute,attributeArray,backgroundBlurriness,backgroundIntensity,backgroundRotation,batch:batch$1,billboarding,bitAnd,bitNot,bitOr,bitXor,bitangentGeometry,bitangentLocal,bitangentView,bitangentWorld,bitcast,blendBurn,blendColor,blendDodge,blendOverlay,blendScreen,blur,bool,buffer,bufferAttribute,bumpMap,burn,bvec2,bvec3,bvec4,bypass,cache:cache$2,call,cameraFar,cameraIndex,cameraNear,cameraNormalMatrix,cameraPosition,cameraProjectionMatrix,cameraProjectionMatrixInverse,cameraViewMatrix,cameraWorldMatrix,cbrt,cdl,ceil:ceil$2,checker,cineonToneMapping,clamp:clamp$3,clearcoat,clearcoatRoughness,code,color,colorSpaceToWorking,colorToDirection,compute,cond,context,convert,convertColorSpace,convertToTexture:convertToTexture$1,cos:cos$2,cross,cubeTexture,cubeToUV,dFdx,dFdy,dashSize,defaultBuildStages,defaultShaderStages,defined,degrees,deltaTime,densityFog,densityFogFactor,depth,depthPass,difference,diffuseColor,directPointLight,directionToColor,dispersion,distance,div,dodge,dot,drawIndex,dynamicBufferAttribute,element,emissive,equal,equals:equals$3,equirectUV,exp,exp2,expression,faceDirection,faceForward,faceforward,float:float$1,floor:floor$3,fog,fract,frameGroup,frameId,frontFacing,fwidth,gain,gapSize,getConstNodeType,getCurrentStack,getDirection,getDistanceAttenuation,getGeometryRoughness,getNormalFromDepth,getParallaxCorrectNormal,getRoughness,getScreenPosition,getShIrradianceAt,getTextureIndex,getViewPosition,globalId,glsl,glslFn,grayscale,greaterThan,greaterThanEqual,hash:hash$2,highpModelNormalViewMatrix,highpModelViewMatrix,hue,instance,instanceIndex:instanceIndex$1,instancedArray:instancedArray$1,instancedBufferAttribute:instancedBufferAttribute$1,instancedDynamicBufferAttribute,instancedMesh,int,inverseSqrt,inversesqrt,invocationLocalIndex,invocationSubgroupIndex,ior,iridescence,iridescenceIOR,iridescenceThickness,ivec2,ivec3,ivec4,js,label,length:length$1,lengthSq,lessThan,lessThanEqual,lightPosition,lightProjectionUV,lightShadowMatrix,lightTargetDirection,lightTargetPosition,lightViewPosition,lightingContext,lights,linearDepth,linearToneMapping,localId,log,log2,logarithmicDepthToViewZ,loop,luminance,mat2,mat3,mat4,matcapUV,materialAO,materialAlphaTest,materialAnisotropy,materialAnisotropyVector,materialAttenuationColor,materialAttenuationDistance,materialClearcoat,materialClearcoatNormal,materialClearcoatRoughness,materialColor,materialDispersion,materialEmissive,materialEnvIntensity,materialEnvRotation,materialIOR,materialIridescence,materialIridescenceIOR,materialIridescenceThickness,materialLightMap,materialLineDashOffset,materialLineDashSize,materialLineGapSize,materialLineScale,materialLineWidth,materialMetalness,materialNormal,materialOpacity,materialPointSize,materialReference,materialReflectivity,materialRefractionRatio,materialRotation,materialRoughness,materialSheen,materialSheenRoughness,materialShininess,materialSpecular,materialSpecularColor,materialSpecularIntensity,materialSpecularStrength,materialThickness,materialTransmission,max:max$1,maxMipLevel,mediumpModelViewMatrix,metalness,min:min$1,mix:mix$1,mixElement,mod,modInt,modelDirection,modelNormalMatrix,modelPosition,modelRadius,modelScale,modelViewMatrix,modelViewPosition,modelViewProjection,modelWorldMatrix,modelWorldMatrixInverse,morphReference,mrt,mul:mul$1,mx_aastep,mx_cell_noise_float,mx_contrast,mx_fractal_noise_float,mx_fractal_noise_vec2,mx_fractal_noise_vec3,mx_fractal_noise_vec4,mx_hsvtorgb,mx_noise_float,mx_noise_vec3,mx_noise_vec4,mx_ramplr,mx_ramptb,mx_rgbtohsv,mx_safepower,mx_splitlr,mx_splittb,mx_srgb_texture_to_lin_rec709,mx_transform_uv,mx_worley_noise_float,mx_worley_noise_vec2,mx_worley_noise_vec3,negate,neutralToneMapping,nodeArray,nodeImmutable,nodeObject:nodeObject$1,nodeObjects,nodeProxy,normalFlat,normalGeometry,normalLocal,normalMap,normalView,normalWorld,normalize:normalize$1,not,notEqual,numWorkgroups,objectDirection,objectGroup,objectPosition,objectRadius,objectScale,objectViewPosition,objectWorldMatrix,oneMinus,or,orthographicDepthToViewZ,oscSawtooth,oscSine,oscSquare,oscTriangle,output,outputStruct,overlay,overloadingFn,parabola,parallaxDirection,parallaxUV,parameter,pass:pass$1,passTexture:passTexture$1,pcurve,perspectiveDepthToViewZ,pmremTexture,pointShadow,pointUV,pointWidth,positionGeometry:positionGeometry$1,positionLocal,positionPrevious,positionView,positionViewDirection,positionWorld,positionWorldDirection,posterize,pow:pow$1,pow2,pow3,pow4,property,radians,rand:rand$1,range,rangeFog,rangeFogFactor,reciprocal,reference,referenceBuffer,reflect,reflectVector,reflectView,reflector,refract,refractVector,refractView,reinhardToneMapping,remainder,remap:remap$1,remapClamp:remapClamp$1,renderGroup,renderOutput,rendererReference,rotate:rotate$2,rotateUV,roughness,round:round$1,rtt,sRGBTransferEOTF,sRGBTransferOETF,sampler,saturate,saturation,screen,screenCoordinate,screenSize,screenUV,scriptable,scriptableValue,select,setCurrentStack,shaderStages,shadow,shadowPositionWorld,shapeCircle,sharedUniformGroup,sheen,sheenRoughness,shiftLeft,shiftRight,shininess,sign:sign$1,sin:sin$2,sinc,skinning,skinningReference,smoothstep:smoothstep$1,smoothstepElement,specularColor,specularF90,spherizeUV,split,spritesheetUV,sqrt:sqrt$2,stack,step:step$1,storage,storageBarrier,storageObject,storageTexture,string,struct,sub,subgroupIndex,subgroupSize,tan,tangentGeometry,tangentLocal,tangentView,tangentWorld,temp,texture:texture$1,texture3D,textureBarrier,textureBicubic,textureCubeUV,textureLoad,textureSize,textureStore,thickness,time:time$1,timerDelta,timerGlobal,timerLocal,toOutputColorSpace,toWorkingColorSpace,toneMapping,toneMappingExposure,toonOutlinePass,transformDirection,transformNormal,transformNormalToView,transformedBentNormalView,transformedBitangentView,transformedBitangentWorld,transformedClearcoatNormalView,transformedNormalView,transformedNormalWorld,transformedTangentView,transformedTangentWorld,transmission,transpose,triNoise3D,triplanarTexture,triplanarTextures,trunc,tslFn,uint,uniform:uniform$1,uniformArray,uniformGroup,uniforms,userData,uv:uv$1,uvec2,uvec3,uvec4,varying,varyingProperty,vec2:vec2$1,vec3:vec3$1,vec4:vec4$1,vectorComponents,velocity,vertexColor,vertexIndex,vertexStage,vibrance,viewZToLogarithmicDepth,viewZToOrthographicDepth,viewZToPerspectiveDepth,viewport,viewportBottomLeft,viewportCoordinate,viewportDepthTexture,viewportLinearDepth,viewportMipTexture,viewportResolution,viewportSafeUV,viewportSharedTexture,viewportSize,viewportTexture,viewportTopLeft,viewportUV,wgsl,wgslFn,workgroupArray,workgroupBarrier,workgroupId,workingToColorSpace,xor});const _clearColor=new Color4;class Background extends DataMap{constructor(renderer,nodes){super(),this.renderer=renderer,this.nodes=nodes}update(scene,renderList,renderContext){const renderer=this.renderer,background=this.nodes.getBackgroundNode(scene)||scene.background;let forceClear=!1;if(background===null)renderer._clearColor.getRGB(_clearColor),_clearColor.a=renderer._clearColor.a;else if(background.isColor===!0)background.getRGB(_clearColor),_clearColor.a=1,forceClear=!0;else if(background.isNode===!0){const sceneData=this.get(scene),backgroundNode=background;_clearColor.copy(renderer._clearColor);let backgroundMesh=sceneData.backgroundMesh;if(backgroundMesh===void 0){const backgroundMeshNode=context(vec4$1(backgroundNode).mul(backgroundIntensity),{getUV:()=>backgroundRotation.mul(normalWorld),getTextureLevel:()=>backgroundBlurriness});let viewProj=modelViewProjection;viewProj=viewProj.setZ(viewProj.w);const nodeMaterial=new NodeMaterial;nodeMaterial.name="Background.material",nodeMaterial.side=BackSide,nodeMaterial.depthTest=!1,nodeMaterial.depthWrite=!1,nodeMaterial.fog=!1,nodeMaterial.lights=!1,nodeMaterial.vertexNode=viewProj,nodeMaterial.colorNode=backgroundMeshNode,sceneData.backgroundMeshNode=backgroundMeshNode,sceneData.backgroundMesh=backgroundMesh=new Mesh(new SphereGeometry(1,32,32),nodeMaterial),backgroundMesh.frustumCulled=!1,backgroundMesh.name="Background.mesh",backgroundMesh.onBeforeRender=function(renderer2,scene2,camera){this.matrixWorld.copyPosition(camera.matrixWorld)}}const backgroundCacheKey=backgroundNode.getCacheKey();sceneData.backgroundCacheKey!==backgroundCacheKey&&(sceneData.backgroundMeshNode.node=vec4$1(backgroundNode).mul(backgroundIntensity),sceneData.backgroundMeshNode.needsUpdate=!0,backgroundMesh.material.needsUpdate=!0,sceneData.backgroundCacheKey=backgroundCacheKey),renderList.unshift(backgroundMesh,backgroundMesh.geometry,backgroundMesh.material,0,0,null,null)}else console.error("THREE.Renderer: Unsupported background configuration.",background);const environmentBlendMode=renderer.xr.getEnvironmentBlendMode();if(environmentBlendMode==="additive"?_clearColor.set(0,0,0,1):environmentBlendMode==="alpha-blend"&&_clearColor.set(0,0,0,0),renderer.autoClear===!0||forceClear===!0){const clearColorValue=renderContext.clearColorValue;clearColorValue.r=_clearColor.r,clearColorValue.g=_clearColor.g,clearColorValue.b=_clearColor.b,clearColorValue.a=_clearColor.a,(renderer.backend.isWebGLBackend===!0||renderer.alpha===!0)&&(clearColorValue.r*=clearColorValue.a,clearColorValue.g*=clearColorValue.a,clearColorValue.b*=clearColorValue.a),renderContext.depthClearValue=renderer._clearDepth,renderContext.stencilClearValue=renderer._clearStencil,renderContext.clearColor=renderer.autoClearColor===!0,renderContext.clearDepth=renderer.autoClearDepth===!0,renderContext.clearStencil=renderer.autoClearStencil===!0}else renderContext.clearColor=!1,renderContext.clearDepth=!1,renderContext.clearStencil=!1}}let _id$6=0;class BindGroup{constructor(name="",bindings=[],index=0,bindingsReference=[]){this.name=name,this.bindings=bindings,this.index=index,this.bindingsReference=bindingsReference,this.id=_id$6++}}class NodeBuilderState{constructor(vertexShader,fragmentShader,computeShader,nodeAttributes,bindings,updateNodes,updateBeforeNodes,updateAfterNodes,observer,transforms2=[]){this.vertexShader=vertexShader,this.fragmentShader=fragmentShader,this.computeShader=computeShader,this.transforms=transforms2,this.nodeAttributes=nodeAttributes,this.bindings=bindings,this.updateNodes=updateNodes,this.updateBeforeNodes=updateBeforeNodes,this.updateAfterNodes=updateAfterNodes,this.observer=observer,this.usedTimes=0}createBindings(){const bindings=[];for(const instanceGroup of this.bindings)if(instanceGroup.bindings[0].groupNode.shared!==!0){const bindingsGroup=new BindGroup(instanceGroup.name,[],instanceGroup.index,instanceGroup);bindings.push(bindingsGroup);for(const instanceBinding of instanceGroup.bindings)bindingsGroup.bindings.push(instanceBinding.clone())}else bindings.push(instanceGroup);return bindings}}class NodeAttribute{constructor(name,type,node=null){this.isNodeAttribute=!0,this.name=name,this.type=type,this.node=node}}class NodeUniform{constructor(name,type,node){this.isNodeUniform=!0,this.name=name,this.type=type,this.node=node.getSelf()}get value(){return this.node.value}set value(val){this.node.value=val}get id(){return this.node.id}get groupNode(){return this.node.groupNode}}class NodeVar{constructor(name,type,readOnly=!1,count=null){this.isNodeVar=!0,this.name=name,this.type=type,this.readOnly=readOnly,this.count=count}}class NodeVarying extends NodeVar{constructor(name,type){super(name,type),this.needsInterpolation=!1,this.isNodeVarying=!0}}class NodeCode{constructor(name,type,code2=""){this.name=name,this.type=type,this.code=code2,Object.defineProperty(this,"isNodeCode",{value:!0})}}let _id$5=0;class NodeCache{constructor(parent=null){this.id=_id$5++,this.nodesData=new WeakMap,this.parent=parent}getData(node){let data=this.nodesData.get(node);return data===void 0&&this.parent!==null&&(data=this.parent.getData(node)),data}setData(node,data){this.nodesData.set(node,data)}}class StructType{constructor(name,members){this.name=name,this.members=members,this.output=!1}}class Uniform{constructor(name,value){this.name=name,this.value=value,this.boundary=0,this.itemSize=0,this.offset=0}setValue(value){this.value=value}getValue(){return this.value}}class NumberUniform extends Uniform{constructor(name,value=0){super(name,value),this.isNumberUniform=!0,this.boundary=4,this.itemSize=1}}class Vector2Uniform extends Uniform{constructor(name,value=new Vector2){super(name,value),this.isVector2Uniform=!0,this.boundary=8,this.itemSize=2}}class Vector3Uniform extends Uniform{constructor(name,value=new Vector3){super(name,value),this.isVector3Uniform=!0,this.boundary=16,this.itemSize=3}}class Vector4Uniform extends Uniform{constructor(name,value=new Vector4){super(name,value),this.isVector4Uniform=!0,this.boundary=16,this.itemSize=4}}class ColorUniform extends Uniform{constructor(name,value=new Color){super(name,value),this.isColorUniform=!0,this.boundary=16,this.itemSize=3}}class Matrix2Uniform extends Uniform{constructor(name,value=new Matrix2){super(name,value),this.isMatrix2Uniform=!0,this.boundary=16,this.itemSize=4}}class Matrix3Uniform extends Uniform{constructor(name,value=new Matrix3){super(name,value),this.isMatrix3Uniform=!0,this.boundary=48,this.itemSize=12}}class Matrix4Uniform extends Uniform{constructor(name,value=new Matrix4){super(name,value),this.isMatrix4Uniform=!0,this.boundary=64,this.itemSize=16}}class NumberNodeUniform extends NumberUniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Vector2NodeUniform extends Vector2Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Vector3NodeUniform extends Vector3Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Vector4NodeUniform extends Vector4Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class ColorNodeUniform extends ColorUniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Matrix2NodeUniform extends Matrix2Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Matrix3NodeUniform extends Matrix3Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}class Matrix4NodeUniform extends Matrix4Uniform{constructor(nodeUniform){super(nodeUniform.name,nodeUniform.value),this.nodeUniform=nodeUniform}getValue(){return this.nodeUniform.value}getType(){return this.nodeUniform.type}}const rendererCache=new WeakMap,typeFromArray=new Map([[Int8Array,"int"],[Int16Array,"int"],[Int32Array,"int"],[Uint8Array,"uint"],[Uint16Array,"uint"],[Uint32Array,"uint"],[Float32Array,"float"]]),toFloat=value=>/e/g.test(value)?String(value).replace(/\+/g,""):(value=Number(value),value+(value%1?"":".0"));class NodeBuilder{constructor(object,renderer,parser){this.object=object,this.material=object&&object.material||null,this.geometry=object&&object.geometry||null,this.renderer=renderer,this.parser=parser,this.scene=null,this.camera=null,this.nodes=[],this.sequentialNodes=[],this.updateNodes=[],this.updateBeforeNodes=[],this.updateAfterNodes=[],this.hashNodes={},this.observer=null,this.lightsNode=null,this.environmentNode=null,this.fogNode=null,this.clippingContext=null,this.vertexShader=null,this.fragmentShader=null,this.computeShader=null,this.flowNodes={vertex:[],fragment:[],compute:[]},this.flowCode={vertex:"",fragment:"",compute:""},this.uniforms={vertex:[],fragment:[],compute:[],index:0},this.structs={vertex:[],fragment:[],compute:[],index:0},this.bindings={vertex:{},fragment:{},compute:{}},this.bindingsIndexes={},this.bindGroups=null,this.attributes=[],this.bufferAttributes=[],this.varyings=[],this.codes={},this.vars={},this.flow={code:""},this.chaining=[],this.stack=stack(),this.stacks=[],this.tab="	",this.currentFunctionNode=null,this.context={material:this.material},this.cache=new NodeCache,this.globalCache=this.cache,this.flowsData=new WeakMap,this.shaderStage=null,this.buildStage=null,this.useComparisonMethod=!1}getBindGroupsCache(){let bindGroupsCache=rendererCache.get(this.renderer);return bindGroupsCache===void 0&&(bindGroupsCache=new ChainMap,rendererCache.set(this.renderer,bindGroupsCache)),bindGroupsCache}createRenderTarget(width,height,options){return new RenderTarget(width,height,options)}createCubeRenderTarget(size,options){return new CubeRenderTarget(size,options)}includes(node){return this.nodes.includes(node)}getOutputStructName(){}_getBindGroup(groupName,bindings){const bindGroupsCache=this.getBindGroupsCache(),bindingsArray=[];let sharedGroup=!0;for(const binding of bindings)bindingsArray.push(binding),sharedGroup=sharedGroup&&binding.groupNode.shared!==!0;let bindGroup;return sharedGroup?(bindGroup=bindGroupsCache.get(bindingsArray),bindGroup===void 0&&(bindGroup=new BindGroup(groupName,bindingsArray,this.bindingsIndexes[groupName].group,bindingsArray),bindGroupsCache.set(bindingsArray,bindGroup))):bindGroup=new BindGroup(groupName,bindingsArray,this.bindingsIndexes[groupName].group,bindingsArray),bindGroup}getBindGroupArray(groupName,shaderStage){const bindings=this.bindings[shaderStage];let bindGroup=bindings[groupName];return bindGroup===void 0&&(this.bindingsIndexes[groupName]===void 0&&(this.bindingsIndexes[groupName]={binding:0,group:Object.keys(this.bindingsIndexes).length}),bindings[groupName]=bindGroup=[]),bindGroup}getBindings(){let bindingsGroups=this.bindGroups;if(bindingsGroups===null){const groups={},bindings=this.bindings;for(const shaderStage of shaderStages)for(const groupName in bindings[shaderStage]){const uniforms2=bindings[shaderStage][groupName];(groups[groupName]||(groups[groupName]=[])).push(...uniforms2)}bindingsGroups=[];for(const groupName in groups){const group=groups[groupName],bindingsGroup=this._getBindGroup(groupName,group);bindingsGroups.push(bindingsGroup)}this.bindGroups=bindingsGroups}return bindingsGroups}sortBindingGroups(){const bindingsGroups=this.getBindings();bindingsGroups.sort((a2,b)=>a2.bindings[0].groupNode.order-b.bindings[0].groupNode.order);for(let i2=0;i2<bindingsGroups.length;i2++){const bindingGroup=bindingsGroups[i2];this.bindingsIndexes[bindingGroup.name].group=i2,bindingGroup.index=i2}}setHashNode(node,hash2){this.hashNodes[hash2]=node}addNode(node){this.nodes.includes(node)===!1&&(this.nodes.push(node),this.setHashNode(node,node.getHash(this)))}addSequentialNode(node){this.sequentialNodes.includes(node)===!1&&this.sequentialNodes.push(node)}buildUpdateNodes(){for(const node of this.nodes)node.getUpdateType()!==NodeUpdateType.NONE&&this.updateNodes.push(node.getSelf());for(const node of this.sequentialNodes){const updateBeforeType=node.getUpdateBeforeType(),updateAfterType=node.getUpdateAfterType();updateBeforeType!==NodeUpdateType.NONE&&this.updateBeforeNodes.push(node.getSelf()),updateAfterType!==NodeUpdateType.NONE&&this.updateAfterNodes.push(node.getSelf())}}get currentNode(){return this.chaining[this.chaining.length-1]}isFilteredTexture(texture2){return texture2.magFilter===LinearFilter||texture2.magFilter===LinearMipmapNearestFilter||texture2.magFilter===NearestMipmapLinearFilter||texture2.magFilter===LinearMipmapLinearFilter||texture2.minFilter===LinearFilter||texture2.minFilter===LinearMipmapNearestFilter||texture2.minFilter===NearestMipmapLinearFilter||texture2.minFilter===LinearMipmapLinearFilter}addChain(node){this.chaining.push(node)}removeChain(node){if(this.chaining.pop()!==node)throw new Error("NodeBuilder: Invalid node chaining!")}getMethod(method){return method}getNodeFromHash(hash2){return this.hashNodes[hash2]}addFlow(shaderStage,node){return this.flowNodes[shaderStage].push(node),node}setContext(context2){this.context=context2}getContext(){return this.context}getSharedContext(){return{...this.context},this.context}setCache(cache2){this.cache=cache2}getCache(){return this.cache}getCacheFromNode(node,parent=!0){const data=this.getDataFromNode(node);return data.cache===void 0&&(data.cache=new NodeCache(parent?this.getCache():null)),data.cache}isAvailable(){return!1}getVertexIndex(){console.warn("Abstract function.")}getInstanceIndex(){console.warn("Abstract function.")}getDrawIndex(){console.warn("Abstract function.")}getFrontFacing(){console.warn("Abstract function.")}getFragCoord(){console.warn("Abstract function.")}isFlipY(){return!1}increaseUsage(node){const nodeData=this.getDataFromNode(node);return nodeData.usageCount=nodeData.usageCount===void 0?1:nodeData.usageCount+1,nodeData.usageCount}generateTexture(){console.warn("Abstract function.")}generateTextureLod(){console.warn("Abstract function.")}generateArrayDeclaration(type,count){return this.getType(type)+"[ "+count+" ]"}generateArray(type,count,values=null){let snippet=this.generateArrayDeclaration(type,count)+"( ";for(let i2=0;i2<count;i2++){const value=values?values[i2]:null;value!==null?snippet+=value.build(this,type):snippet+=this.generateConst(type),i2<count-1&&(snippet+=", ")}return snippet+=" )",snippet}generateStruct(type,membersLayout,values=null){const snippets=[];for(const member of membersLayout){const{name,type:type2}=member;values&&values[name]&&values[name].isNode?snippets.push(values[name].build(this,type2)):snippets.push(this.generateConst(type2))}return type+"( "+snippets.join(", ")+" )"}generateConst(type,value=null){if(value===null&&(type==="float"||type==="int"||type==="uint"?value=0:type==="bool"?value=!1:type==="color"?value=new Color:type==="vec2"?value=new Vector2:type==="vec3"?value=new Vector3:type==="vec4"&&(value=new Vector4)),type==="float")return toFloat(value);if(type==="int")return`${Math.round(value)}`;if(type==="uint")return value>=0?`${Math.round(value)}u`:"0u";if(type==="bool")return value?"true":"false";if(type==="color")return`${this.getType("vec3")}( ${toFloat(value.r)}, ${toFloat(value.g)}, ${toFloat(value.b)} )`;const typeLength=this.getTypeLength(type),componentType=this.getComponentType(type),generateConst=value2=>this.generateConst(componentType,value2);if(typeLength===2)return`${this.getType(type)}( ${generateConst(value.x)}, ${generateConst(value.y)} )`;if(typeLength===3)return`${this.getType(type)}( ${generateConst(value.x)}, ${generateConst(value.y)}, ${generateConst(value.z)} )`;if(typeLength===4&&type!=="mat2")return`${this.getType(type)}( ${generateConst(value.x)}, ${generateConst(value.y)}, ${generateConst(value.z)}, ${generateConst(value.w)} )`;if(typeLength>=4&&value&&(value.isMatrix2||value.isMatrix3||value.isMatrix4))return`${this.getType(type)}( ${value.elements.map(generateConst).join(", ")} )`;if(typeLength>4)return`${this.getType(type)}()`;throw new Error(`NodeBuilder: Type '${type}' not found in generate constant attempt.`)}getType(type){return type==="color"?"vec3":type}hasGeometryAttribute(name){return this.geometry&&this.geometry.getAttribute(name)!==void 0}getAttribute(name,type){const attributes=this.attributes;for(const attribute3 of attributes)if(attribute3.name===name)return attribute3;const attribute2=new NodeAttribute(name,type);return attributes.push(attribute2),attribute2}getPropertyName(node){return node.name}isVector(type){return/vec\d/.test(type)}isMatrix(type){return/mat\d/.test(type)}isReference(type){return type==="void"||type==="property"||type==="sampler"||type==="texture"||type==="cubeTexture"||type==="storageTexture"||type==="depthTexture"||type==="texture3D"}needsToWorkingColorSpace(){return!1}getComponentTypeFromTexture(texture2){const type=texture2.type;if(texture2.isDataTexture){if(type===IntType)return"int";if(type===UnsignedIntType)return"uint"}return"float"}getElementType(type){return type==="mat2"?"vec2":type==="mat3"?"vec3":type==="mat4"?"vec4":this.getComponentType(type)}getComponentType(type){if(type=this.getVectorType(type),type==="float"||type==="bool"||type==="int"||type==="uint")return type;const componentType=/(b|i|u|)(vec|mat)([2-4])/.exec(type);return componentType===null?null:componentType[1]==="b"?"bool":componentType[1]==="i"?"int":componentType[1]==="u"?"uint":"float"}getVectorType(type){return type==="color"?"vec3":type==="texture"||type==="cubeTexture"||type==="storageTexture"||type==="texture3D"?"vec4":type}getTypeFromLength(length2,componentType="float"){if(length2===1)return componentType;let baseType=getTypeFromLength(length2);const prefix=componentType==="float"?"":componentType[0];return/mat2/.test(componentType)===!0&&(baseType=baseType.replace("vec","mat")),prefix+baseType}getTypeFromArray(array2){return typeFromArray.get(array2.constructor)}getTypeFromAttribute(attribute2){let dataAttribute=attribute2;attribute2.isInterleavedBufferAttribute&&(dataAttribute=attribute2.data);const array2=dataAttribute.array,itemSize=attribute2.itemSize,normalized=attribute2.normalized;let arrayType;return!(attribute2 instanceof Float16BufferAttribute)&&normalized!==!0&&(arrayType=this.getTypeFromArray(array2)),this.getTypeFromLength(itemSize,arrayType)}getTypeLength(type){const vecType=this.getVectorType(type),vecNum=/vec([2-4])/.exec(vecType);return vecNum!==null?Number(vecNum[1]):vecType==="float"||vecType==="bool"||vecType==="int"||vecType==="uint"?1:/mat2/.test(type)===!0?4:/mat3/.test(type)===!0?9:/mat4/.test(type)===!0?16:0}getVectorFromMatrix(type){return type.replace("mat","vec")}changeComponentType(type,newComponentType){return this.getTypeFromLength(this.getTypeLength(type),newComponentType)}getIntegerType(type){const componentType=this.getComponentType(type);return componentType==="int"||componentType==="uint"?type:this.changeComponentType(type,"int")}addStack(){return this.stack=stack(this.stack),this.stacks.push(getCurrentStack()||this.stack),setCurrentStack(this.stack),this.stack}removeStack(){const lastStack=this.stack;return this.stack=lastStack.parent,setCurrentStack(this.stacks.pop()),lastStack}getDataFromNode(node,shaderStage=this.shaderStage,cache2=null){cache2=cache2===null?node.isGlobal(this)?this.globalCache:this.cache:cache2;let nodeData=cache2.getData(node);return nodeData===void 0&&(nodeData={},cache2.setData(node,nodeData)),nodeData[shaderStage]===void 0&&(nodeData[shaderStage]={}),nodeData[shaderStage]}getNodeProperties(node,shaderStage="any"){const nodeData=this.getDataFromNode(node,shaderStage);return nodeData.properties||(nodeData.properties={outputNode:null})}getBufferAttributeFromNode(node,type){const nodeData=this.getDataFromNode(node);let bufferAttribute2=nodeData.bufferAttribute;if(bufferAttribute2===void 0){const index=this.uniforms.index++;bufferAttribute2=new NodeAttribute("nodeAttribute"+index,type,node),this.bufferAttributes.push(bufferAttribute2),nodeData.bufferAttribute=bufferAttribute2}return bufferAttribute2}getStructTypeFromNode(node,membersLayout,name=null,shaderStage=this.shaderStage){const nodeData=this.getDataFromNode(node,shaderStage,this.globalCache);let structType=nodeData.structType;if(structType===void 0){const index=this.structs.index++;name===null&&(name="StructType"+index),structType=new StructType(name,membersLayout),this.structs[shaderStage].push(structType),nodeData.structType=structType}return structType}getOutputStructTypeFromNode(node,membersLayout){const structType=this.getStructTypeFromNode(node,membersLayout,"OutputType","fragment");return structType.output=!0,structType}getUniformFromNode(node,type,shaderStage=this.shaderStage,name=null){const nodeData=this.getDataFromNode(node,shaderStage,this.globalCache);let nodeUniform=nodeData.uniform;if(nodeUniform===void 0){const index=this.uniforms.index++;nodeUniform=new NodeUniform(name||"nodeUniform"+index,type,node),this.uniforms[shaderStage].push(nodeUniform),nodeData.uniform=nodeUniform}return nodeUniform}getArrayCount(node){let count=null;return node.isArrayNode?count=node.count:node.isVarNode&&node.node.isArrayNode&&(count=node.node.count),count}getVarFromNode(node,name=null,type=node.getNodeType(this),shaderStage=this.shaderStage,readOnly=!1){const nodeData=this.getDataFromNode(node,shaderStage);let nodeVar=nodeData.variable;if(nodeVar===void 0){const idNS=readOnly?"_const":"_var",vars=this.vars[shaderStage]||(this.vars[shaderStage]=[]),id=this.vars[idNS]||(this.vars[idNS]=0);name===null&&(name=(readOnly?"nodeConst":"nodeVar")+id,this.vars[idNS]++);const count=this.getArrayCount(node);nodeVar=new NodeVar(name,type,readOnly,count),readOnly||vars.push(nodeVar),nodeData.variable=nodeVar}return nodeVar}isDeterministic(node){if(node.isMathNode)return this.isDeterministic(node.aNode)&&(node.bNode?this.isDeterministic(node.bNode):!0)&&(node.cNode?this.isDeterministic(node.cNode):!0);if(node.isOperatorNode)return this.isDeterministic(node.aNode)&&(node.bNode?this.isDeterministic(node.bNode):!0);if(node.isArrayNode){if(node.values!==null){for(const n2 of node.values)if(!this.isDeterministic(n2))return!1}return!0}else if(node.isConstNode)return!0;return!1}getVaryingFromNode(node,name=null,type=node.getNodeType(this)){const nodeData=this.getDataFromNode(node,"any");let nodeVarying=nodeData.varying;if(nodeVarying===void 0){const varyings=this.varyings,index=varyings.length;name===null&&(name="nodeVarying"+index),nodeVarying=new NodeVarying(name,type),varyings.push(nodeVarying),nodeData.varying=nodeVarying}return nodeVarying}getCodeFromNode(node,type,shaderStage=this.shaderStage){const nodeData=this.getDataFromNode(node);let nodeCode=nodeData.code;if(nodeCode===void 0){const codes=this.codes[shaderStage]||(this.codes[shaderStage]=[]),index=codes.length;nodeCode=new NodeCode("nodeCode"+index,type),codes.push(nodeCode),nodeData.code=nodeCode}return nodeCode}addFlowCodeHierarchy(node,nodeBlock){const{flowCodes,flowCodeBlock}=this.getDataFromNode(node);let needsFlowCode=!0,nodeBlockHierarchy=nodeBlock;for(;nodeBlockHierarchy;){if(flowCodeBlock.get(nodeBlockHierarchy)===!0){needsFlowCode=!1;break}nodeBlockHierarchy=this.getDataFromNode(nodeBlockHierarchy).parentNodeBlock}if(needsFlowCode)for(const flowCode of flowCodes)this.addLineFlowCode(flowCode)}addLineFlowCodeBlock(node,code2,nodeBlock){const nodeData=this.getDataFromNode(node),flowCodes=nodeData.flowCodes||(nodeData.flowCodes=[]),codeBlock=nodeData.flowCodeBlock||(nodeData.flowCodeBlock=new WeakMap);flowCodes.push(code2),codeBlock.set(nodeBlock,!0)}addLineFlowCode(code2,node=null){return code2===""?this:(node!==null&&this.context.nodeBlock&&this.addLineFlowCodeBlock(node,code2,this.context.nodeBlock),code2=this.tab+code2,/;\s*$/.test(code2)||(code2=code2+`;
`),this.flow.code+=code2,this)}addFlowCode(code2){return this.flow.code+=code2,this}addFlowTab(){return this.tab+="	",this}removeFlowTab(){return this.tab=this.tab.slice(0,-1),this}getFlowData(node){return this.flowsData.get(node)}flowNode(node){const output2=node.getNodeType(this),flowData=this.flowChildNode(node,output2);return this.flowsData.set(node,flowData),flowData}addInclude(node){this.currentFunctionNode!==null&&this.currentFunctionNode.includes.push(node)}buildFunctionNode(shaderNode){const fn=new FunctionNode,previous=this.currentFunctionNode;return this.currentFunctionNode=fn,fn.code=this.buildFunctionCode(shaderNode),this.currentFunctionNode=previous,fn}flowShaderNode(shaderNode){const layout=shaderNode.layout,inputs={[Symbol.iterator](){let index=0;const values=Object.values(this);return{next:()=>({value:values[index],done:index++>=values.length})}}};for(const input of layout.inputs)inputs[input.name]=new ParameterNode(input.type,input.name);shaderNode.layout=null;const callNode=shaderNode.call(inputs),flowData=this.flowStagesNode(callNode,layout.type);return shaderNode.layout=layout,flowData}flowStagesNode(node,output2=null){const previousFlow=this.flow,previousVars=this.vars,previousCache=this.cache,previousBuildStage=this.buildStage,previousStack=this.stack,flow={code:""};this.flow=flow,this.vars={},this.cache=new NodeCache,this.stack=stack();for(const buildStage of defaultBuildStages)this.setBuildStage(buildStage),flow.result=node.build(this,output2);return flow.vars=this.getVars(this.shaderStage),this.flow=previousFlow,this.vars=previousVars,this.cache=previousCache,this.stack=previousStack,this.setBuildStage(previousBuildStage),flow}getFunctionOperator(){return null}flowChildNode(node,output2=null){const previousFlow=this.flow,flow={code:""};return this.flow=flow,flow.result=node.build(this,output2),this.flow=previousFlow,flow}flowNodeFromShaderStage(shaderStage,node,output2=null,propertyName=null){const previousShaderStage=this.shaderStage;this.setShaderStage(shaderStage);const flowData=this.flowChildNode(node,output2);return propertyName!==null&&(flowData.code+=`${this.tab+propertyName} = ${flowData.result};
`),this.flowCode[shaderStage]=this.flowCode[shaderStage]+flowData.code,this.setShaderStage(previousShaderStage),flowData}getAttributesArray(){return this.attributes.concat(this.bufferAttributes)}getAttributes(){console.warn("Abstract function.")}getVaryings(){console.warn("Abstract function.")}getVar(type,name,count=null){return`${count!==null?this.generateArrayDeclaration(type,count):this.getType(type)} ${name}`}getVars(shaderStage){let snippet="";const vars=this.vars[shaderStage];if(vars!==void 0)for(const variable of vars)snippet+=`${this.getVar(variable.type,variable.name)}; `;return snippet}getUniforms(){console.warn("Abstract function.")}getCodes(shaderStage){const codes=this.codes[shaderStage];let code2="";if(codes!==void 0)for(const nodeCode of codes)code2+=nodeCode.code+`
`;return code2}getHash(){return this.vertexShader+this.fragmentShader+this.computeShader}setShaderStage(shaderStage){this.shaderStage=shaderStage}getShaderStage(){return this.shaderStage}setBuildStage(buildStage){this.buildStage=buildStage}getBuildStage(){return this.buildStage}buildCode(){console.warn("Abstract function.")}build(){const{object,material,renderer}=this;if(material!==null){let nodeMaterial=renderer.library.fromMaterial(material);nodeMaterial===null&&(console.error(`NodeMaterial: Material "${material.type}" is not compatible.`),nodeMaterial=new NodeMaterial),nodeMaterial.build(this)}else this.addFlow("compute",object);for(const buildStage of defaultBuildStages){this.setBuildStage(buildStage),this.context.vertex&&this.context.vertex.isNode&&this.flowNodeFromShaderStage("vertex",this.context.vertex);for(const shaderStage of shaderStages){this.setShaderStage(shaderStage);const flowNodes=this.flowNodes[shaderStage];for(const node of flowNodes)buildStage==="generate"?this.flowNode(node):node.build(this)}}return this.setBuildStage(null),this.setShaderStage(null),this.buildCode(),this.buildUpdateNodes(),this}getNodeUniform(uniformNode,type){if(type==="float"||type==="int"||type==="uint")return new NumberNodeUniform(uniformNode);if(type==="vec2"||type==="ivec2"||type==="uvec2")return new Vector2NodeUniform(uniformNode);if(type==="vec3"||type==="ivec3"||type==="uvec3")return new Vector3NodeUniform(uniformNode);if(type==="vec4"||type==="ivec4"||type==="uvec4")return new Vector4NodeUniform(uniformNode);if(type==="color")return new ColorNodeUniform(uniformNode);if(type==="mat2")return new Matrix2NodeUniform(uniformNode);if(type==="mat3")return new Matrix3NodeUniform(uniformNode);if(type==="mat4")return new Matrix4NodeUniform(uniformNode);throw new Error(`Uniform "${type}" not declared.`)}format(snippet,fromType,toType){if(fromType=this.getVectorType(fromType),toType=this.getVectorType(toType),fromType===toType||toType===null||this.isReference(toType))return snippet;const fromTypeLength=this.getTypeLength(fromType),toTypeLength=this.getTypeLength(toType);return fromTypeLength===16&&toTypeLength===9?`${this.getType(toType)}(${snippet}[0].xyz, ${snippet}[1].xyz, ${snippet}[2].xyz)`:fromTypeLength===9&&toTypeLength===4?`${this.getType(toType)}(${snippet}[0].xy, ${snippet}[1].xy)`:fromTypeLength>4||toTypeLength>4||toTypeLength===0?snippet:fromTypeLength===toTypeLength?`${this.getType(toType)}( ${snippet} )`:fromTypeLength>toTypeLength?this.format(`${snippet}.${"xyz".slice(0,toTypeLength)}`,this.getTypeFromLength(toTypeLength,this.getComponentType(fromType)),toType):toTypeLength===4&&fromTypeLength>1?`${this.getType(toType)}( ${this.format(snippet,fromType,"vec3")}, 1.0 )`:fromTypeLength===2?`${this.getType(toType)}( ${this.format(snippet,fromType,"vec2")}, 0.0 )`:(fromTypeLength===1&&toTypeLength>1&&fromType!==this.getComponentType(toType)&&(snippet=`${this.getType(this.getComponentType(toType))}( ${snippet} )`),`${this.getType(toType)}( ${snippet} )`)}getSignature(){return`// Three.js r${REVISION} - Node System
`}createNodeMaterial(type="NodeMaterial"){throw new Error(`THREE.NodeBuilder: createNodeMaterial() was deprecated. Use new ${type}() instead.`)}}class NodeFrame{constructor(){this.time=0,this.deltaTime=0,this.frameId=0,this.renderId=0,this.updateMap=new WeakMap,this.updateBeforeMap=new WeakMap,this.updateAfterMap=new WeakMap,this.renderer=null,this.material=null,this.camera=null,this.object=null,this.scene=null}_getMaps(referenceMap,nodeRef){let maps=referenceMap.get(nodeRef);return maps===void 0&&(maps={renderMap:new WeakMap,frameMap:new WeakMap},referenceMap.set(nodeRef,maps)),maps}updateBeforeNode(node){const updateType=node.getUpdateBeforeType(),reference2=node.updateReference(this);if(updateType===NodeUpdateType.FRAME){const{frameMap}=this._getMaps(this.updateBeforeMap,reference2);frameMap.get(reference2)!==this.frameId&&node.updateBefore(this)!==!1&&frameMap.set(reference2,this.frameId)}else if(updateType===NodeUpdateType.RENDER){const{renderMap}=this._getMaps(this.updateBeforeMap,reference2);renderMap.get(reference2)!==this.renderId&&node.updateBefore(this)!==!1&&renderMap.set(reference2,this.renderId)}else updateType===NodeUpdateType.OBJECT&&node.updateBefore(this)}updateAfterNode(node){const updateType=node.getUpdateAfterType(),reference2=node.updateReference(this);if(updateType===NodeUpdateType.FRAME){const{frameMap}=this._getMaps(this.updateAfterMap,reference2);frameMap.get(reference2)!==this.frameId&&node.updateAfter(this)!==!1&&frameMap.set(reference2,this.frameId)}else if(updateType===NodeUpdateType.RENDER){const{renderMap}=this._getMaps(this.updateAfterMap,reference2);renderMap.get(reference2)!==this.renderId&&node.updateAfter(this)!==!1&&renderMap.set(reference2,this.renderId)}else updateType===NodeUpdateType.OBJECT&&node.updateAfter(this)}updateNode(node){const updateType=node.getUpdateType(),reference2=node.updateReference(this);if(updateType===NodeUpdateType.FRAME){const{frameMap}=this._getMaps(this.updateMap,reference2);frameMap.get(reference2)!==this.frameId&&node.update(this)!==!1&&frameMap.set(reference2,this.frameId)}else if(updateType===NodeUpdateType.RENDER){const{renderMap}=this._getMaps(this.updateMap,reference2);renderMap.get(reference2)!==this.renderId&&node.update(this)!==!1&&renderMap.set(reference2,this.renderId)}else updateType===NodeUpdateType.OBJECT&&node.update(this)}update(){this.frameId++,this.lastTime===void 0&&(this.lastTime=performance.now()),this.deltaTime=(performance.now()-this.lastTime)/1e3,this.lastTime=performance.now(),this.time+=this.deltaTime}}class NodeFunctionInput{constructor(type,name,count=null,qualifier="",isConst=!1){this.type=type,this.name=name,this.count=count,this.qualifier=qualifier,this.isConst=isConst}}NodeFunctionInput.isNodeFunctionInput=!0;class DirectionalLightNode extends AnalyticLightNode{static get type(){return"DirectionalLightNode"}constructor(light=null){super(light)}setupDirect(){const lightColor=this.colorNode;return{lightDirection:lightTargetDirection(this.light),lightColor}}}const _matrix41=new Matrix4,_matrix42=new Matrix4;let _ltcLib=null;class RectAreaLightNode extends AnalyticLightNode{static get type(){return"RectAreaLightNode"}constructor(light=null){super(light),this.halfHeight=uniform$1(new Vector3).setGroup(renderGroup),this.halfWidth=uniform$1(new Vector3).setGroup(renderGroup),this.updateType=NodeUpdateType.RENDER}update(frame){super.update(frame);const{light}=this,viewMatrix=frame.camera.matrixWorldInverse;_matrix42.identity(),_matrix41.copy(light.matrixWorld),_matrix41.premultiply(viewMatrix),_matrix42.extractRotation(_matrix41),this.halfWidth.value.set(light.width*.5,0,0),this.halfHeight.value.set(0,light.height*.5,0),this.halfWidth.value.applyMatrix4(_matrix42),this.halfHeight.value.applyMatrix4(_matrix42)}setupDirectRectArea(builder){let ltc_1,ltc_2;builder.isAvailable("float32Filterable")?(ltc_1=texture$1(_ltcLib.LTC_FLOAT_1),ltc_2=texture$1(_ltcLib.LTC_FLOAT_2)):(ltc_1=texture$1(_ltcLib.LTC_HALF_1),ltc_2=texture$1(_ltcLib.LTC_HALF_2));const{colorNode,light}=this,lightPosition2=lightViewPosition(light);return{lightColor:colorNode,lightPosition:lightPosition2,halfWidth:this.halfWidth,halfHeight:this.halfHeight,ltc_1,ltc_2}}static setLTC(ltc){_ltcLib=ltc}}class SpotLightNode extends AnalyticLightNode{static get type(){return"SpotLightNode"}constructor(light=null){super(light),this.coneCosNode=uniform$1(0).setGroup(renderGroup),this.penumbraCosNode=uniform$1(0).setGroup(renderGroup),this.cutoffDistanceNode=uniform$1(0).setGroup(renderGroup),this.decayExponentNode=uniform$1(0).setGroup(renderGroup)}update(frame){super.update(frame);const{light}=this;this.coneCosNode.value=Math.cos(light.angle),this.penumbraCosNode.value=Math.cos(light.angle*(1-light.penumbra)),this.cutoffDistanceNode.value=light.distance,this.decayExponentNode.value=light.decay}getSpotAttenuation(angleCosine){const{coneCosNode,penumbraCosNode}=this;return smoothstep$1(coneCosNode,penumbraCosNode,angleCosine)}setupDirect(builder){const{colorNode,cutoffDistanceNode,decayExponentNode,light}=this,lightVector=this.getLightVector(builder),lightDirection=lightVector.normalize(),angleCos=lightDirection.dot(lightTargetDirection(light)),spotAttenuation=this.getSpotAttenuation(angleCos),lightDistance=lightVector.length(),lightAttenuation=getDistanceAttenuation({lightDistance,cutoffDistance:cutoffDistanceNode,decayExponent:decayExponentNode});let lightColor=colorNode.mul(spotAttenuation).mul(lightAttenuation);if(light.map){const spotLightCoord=lightProjectionUV(light,builder.context.positionWorld),projectedTexture=texture$1(light.map,spotLightCoord.xy).onRenderUpdate(()=>light.map);lightColor=spotLightCoord.mul(2).sub(1).abs().lessThan(1).all().select(lightColor.mul(projectedTexture),lightColor)}return{lightColor,lightDirection}}}class IESSpotLightNode extends SpotLightNode{static get type(){return"IESSpotLightNode"}getSpotAttenuation(angleCosine){const iesMap=this.light.iesMap;let spotAttenuation=null;if(iesMap&&iesMap.isTexture===!0){const angle=angleCosine.acos().mul(1/Math.PI);spotAttenuation=texture$1(iesMap,vec2$1(angle,0),0).r}else spotAttenuation=super.getSpotAttenuation(angleCosine);return spotAttenuation}}class AmbientLightNode extends AnalyticLightNode{static get type(){return"AmbientLightNode"}constructor(light=null){super(light)}setup({context:context2}){context2.irradiance.addAssign(this.colorNode)}}class HemisphereLightNode extends AnalyticLightNode{static get type(){return"HemisphereLightNode"}constructor(light=null){super(light),this.lightPositionNode=lightPosition(light),this.lightDirectionNode=this.lightPositionNode.normalize(),this.groundColorNode=uniform$1(new Color).setGroup(renderGroup)}update(frame){const{light}=this;super.update(frame),this.lightPositionNode.object3d=light,this.groundColorNode.value.copy(light.groundColor).multiplyScalar(light.intensity)}setup(builder){const{colorNode,groundColorNode,lightDirectionNode}=this,hemiDiffuseWeight=normalView.dot(lightDirectionNode).mul(.5).add(.5),irradiance=mix$1(groundColorNode,colorNode,hemiDiffuseWeight);builder.context.irradiance.addAssign(irradiance)}}class LightProbeNode extends AnalyticLightNode{static get type(){return"LightProbeNode"}constructor(light=null){super(light);const array2=[];for(let i2=0;i2<9;i2++)array2.push(new Vector3);this.lightProbe=uniformArray(array2)}update(frame){const{light}=this;super.update(frame);for(let i2=0;i2<9;i2++)this.lightProbe.array[i2].copy(light.sh.coefficients[i2]).multiplyScalar(light.intensity)}setup(builder){const irradiance=getShIrradianceAt(normalWorld,this.lightProbe);builder.context.irradiance.addAssign(irradiance)}}class NodeParser{parseFunction(){console.warn("Abstract function.")}}class NodeFunction{constructor(type,inputs,name="",precision=""){this.type=type,this.inputs=inputs,this.name=name,this.precision=precision}getCode(){console.warn("Abstract function.")}}NodeFunction.isNodeFunction=!0;const declarationRegexp$1=/^\s*(highp|mediump|lowp)?\s*([a-z_0-9]+)\s*([a-z_0-9]+)?\s*\(([\s\S]*?)\)/i,propertiesRegexp$1=/[a-z_0-9]+/ig,pragmaMain="#pragma main",parse$1$1=source=>{source=source.trim();const pragmaMainIndex=source.indexOf(pragmaMain),mainCode=pragmaMainIndex!==-1?source.slice(pragmaMainIndex+pragmaMain.length):source,declaration=mainCode.match(declarationRegexp$1);if(declaration!==null&&declaration.length===5){const inputsCode=declaration[4],propsMatches=[];let nameMatch=null;for(;(nameMatch=propertiesRegexp$1.exec(inputsCode))!==null;)propsMatches.push(nameMatch);const inputs=[];let i2=0;for(;i2<propsMatches.length;){const isConst=propsMatches[i2][0]==="const";isConst===!0&&i2++;let qualifier=propsMatches[i2][0];qualifier==="in"||qualifier==="out"||qualifier==="inout"?i2++:qualifier="";const type2=propsMatches[i2++][0];let count=Number.parseInt(propsMatches[i2][0]);Number.isNaN(count)===!1?i2++:count=null;const name2=propsMatches[i2++][0];inputs.push(new NodeFunctionInput(type2,name2,count,qualifier,isConst))}const blockCode=mainCode.substring(declaration[0].length),name=declaration[3]!==void 0?declaration[3]:"",type=declaration[2],precision=declaration[1]!==void 0?declaration[1]:"",headerCode=pragmaMainIndex!==-1?source.slice(0,pragmaMainIndex):"";return{type,inputs,name,precision,inputsCode,blockCode,headerCode}}else throw new Error("FunctionNode: Function is not a GLSL code.")};class GLSLNodeFunction extends NodeFunction{constructor(source){const{type,inputs,name,precision,inputsCode,blockCode,headerCode}=parse$1$1(source);super(type,inputs,name,precision),this.inputsCode=inputsCode,this.blockCode=blockCode,this.headerCode=headerCode}getCode(name=this.name){let code2;const blockCode=this.blockCode;if(blockCode!==""){const{type,inputsCode,headerCode,precision}=this;let declarationCode=`${type} ${name} ( ${inputsCode.trim()} )`;precision!==""&&(declarationCode=`${precision} ${declarationCode}`),code2=headerCode+declarationCode+blockCode}else code2="";return code2}}class GLSLNodeParser extends NodeParser{parseFunction(source){return new GLSLNodeFunction(source)}}const _outputNodeMap=new WeakMap,_chainKeys$2=[],_cacheKeyValues=[];class Nodes extends DataMap{constructor(renderer,backend){super(),this.renderer=renderer,this.backend=backend,this.nodeFrame=new NodeFrame,this.nodeBuilderCache=new Map,this.callHashCache=new ChainMap,this.groupsData=new ChainMap,this.cacheLib={}}updateGroup(nodeUniformsGroup){const groupNode=nodeUniformsGroup.groupNode,name=groupNode.name;if(name===objectGroup.name)return!0;if(name===renderGroup.name){const uniformsGroupData=this.get(nodeUniformsGroup),renderId=this.nodeFrame.renderId;return uniformsGroupData.renderId!==renderId?(uniformsGroupData.renderId=renderId,!0):!1}if(name===frameGroup.name){const uniformsGroupData=this.get(nodeUniformsGroup),frameId2=this.nodeFrame.frameId;return uniformsGroupData.frameId!==frameId2?(uniformsGroupData.frameId=frameId2,!0):!1}_chainKeys$2[0]=groupNode,_chainKeys$2[1]=nodeUniformsGroup;let groupData=this.groupsData.get(_chainKeys$2);return groupData===void 0&&this.groupsData.set(_chainKeys$2,groupData={}),_chainKeys$2.length=0,groupData.version!==groupNode.version?(groupData.version=groupNode.version,!0):!1}getForRenderCacheKey(renderObject){return renderObject.initialCacheKey}getForRender(renderObject){const renderObjectData=this.get(renderObject);let nodeBuilderState=renderObjectData.nodeBuilderState;if(nodeBuilderState===void 0){const{nodeBuilderCache}=this,cacheKey=this.getForRenderCacheKey(renderObject);if(nodeBuilderState=nodeBuilderCache.get(cacheKey),nodeBuilderState===void 0){const nodeBuilder=this.backend.createNodeBuilder(renderObject.object,this.renderer);nodeBuilder.scene=renderObject.scene,nodeBuilder.material=renderObject.material,nodeBuilder.camera=renderObject.camera,nodeBuilder.context.material=renderObject.material,nodeBuilder.lightsNode=renderObject.lightsNode,nodeBuilder.environmentNode=this.getEnvironmentNode(renderObject.scene),nodeBuilder.fogNode=this.getFogNode(renderObject.scene),nodeBuilder.clippingContext=renderObject.clippingContext,nodeBuilder.build(),nodeBuilderState=this._createNodeBuilderState(nodeBuilder),nodeBuilderCache.set(cacheKey,nodeBuilderState)}nodeBuilderState.usedTimes++,renderObjectData.nodeBuilderState=nodeBuilderState}return nodeBuilderState}delete(object){if(object.isRenderObject){const nodeBuilderState=this.get(object).nodeBuilderState;nodeBuilderState.usedTimes--,nodeBuilderState.usedTimes===0&&this.nodeBuilderCache.delete(this.getForRenderCacheKey(object))}return super.delete(object)}getForCompute(computeNode){const computeData=this.get(computeNode);let nodeBuilderState=computeData.nodeBuilderState;if(nodeBuilderState===void 0){const nodeBuilder=this.backend.createNodeBuilder(computeNode,this.renderer);nodeBuilder.build(),nodeBuilderState=this._createNodeBuilderState(nodeBuilder),computeData.nodeBuilderState=nodeBuilderState}return nodeBuilderState}_createNodeBuilderState(nodeBuilder){return new NodeBuilderState(nodeBuilder.vertexShader,nodeBuilder.fragmentShader,nodeBuilder.computeShader,nodeBuilder.getAttributesArray(),nodeBuilder.getBindings(),nodeBuilder.updateNodes,nodeBuilder.updateBeforeNodes,nodeBuilder.updateAfterNodes,nodeBuilder.observer,nodeBuilder.transforms)}getEnvironmentNode(scene){this.updateEnvironment(scene);let environmentNode=null;if(scene.environmentNode&&scene.environmentNode.isNode)environmentNode=scene.environmentNode;else{const sceneData=this.get(scene);sceneData.environmentNode&&(environmentNode=sceneData.environmentNode)}return environmentNode}getBackgroundNode(scene){this.updateBackground(scene);let backgroundNode=null;if(scene.backgroundNode&&scene.backgroundNode.isNode)backgroundNode=scene.backgroundNode;else{const sceneData=this.get(scene);sceneData.backgroundNode&&(backgroundNode=sceneData.backgroundNode)}return backgroundNode}getFogNode(scene){return this.updateFog(scene),scene.fogNode||this.get(scene).fogNode||null}getCacheKey(scene,lightsNode){_chainKeys$2[0]=scene,_chainKeys$2[1]=lightsNode;const callId=this.renderer.info.calls,cacheKeyData=this.callHashCache.get(_chainKeys$2)||{};if(cacheKeyData.callId!==callId){const environmentNode=this.getEnvironmentNode(scene),fogNode=this.getFogNode(scene);lightsNode&&_cacheKeyValues.push(lightsNode.getCacheKey(!0)),environmentNode&&_cacheKeyValues.push(environmentNode.getCacheKey()),fogNode&&_cacheKeyValues.push(fogNode.getCacheKey()),_cacheKeyValues.push(this.renderer.shadowMap.enabled?1:0),cacheKeyData.callId=callId,cacheKeyData.cacheKey=hashArray(_cacheKeyValues),this.callHashCache.set(_chainKeys$2,cacheKeyData),_cacheKeyValues.length=0}return _chainKeys$2.length=0,cacheKeyData.cacheKey}get isToneMappingState(){return!this.renderer.getRenderTarget()}updateBackground(scene){const sceneData=this.get(scene),background=scene.background;if(background){const forceUpdate=scene.backgroundBlurriness===0&&sceneData.backgroundBlurriness>0||scene.backgroundBlurriness>0&&sceneData.backgroundBlurriness===0;if(sceneData.background!==background||forceUpdate){const backgroundNode=this.getCacheNode("background",background,()=>{if(background.isCubeTexture===!0||background.mapping===EquirectangularReflectionMapping||background.mapping===EquirectangularRefractionMapping||background.mapping===CubeUVReflectionMapping){if(scene.backgroundBlurriness>0||background.mapping===CubeUVReflectionMapping)return pmremTexture(background);{let envMap;return background.isCubeTexture===!0?envMap=cubeTexture(background):envMap=texture$1(background),cubeMapNode(envMap)}}else{if(background.isTexture===!0)return texture$1(background,screenUV.flipY()).setUpdateMatrix(!0);background.isColor!==!0&&console.error("WebGPUNodes: Unsupported background configuration.",background)}},forceUpdate);sceneData.backgroundNode=backgroundNode,sceneData.background=background,sceneData.backgroundBlurriness=scene.backgroundBlurriness}}else sceneData.backgroundNode&&(delete sceneData.backgroundNode,delete sceneData.background)}getCacheNode(type,object,callback,forceUpdate=!1){const nodeCache=this.cacheLib[type]||(this.cacheLib[type]=new WeakMap);let node=nodeCache.get(object);return(node===void 0||forceUpdate)&&(node=callback(),nodeCache.set(object,node)),node}updateFog(scene){const sceneData=this.get(scene),sceneFog=scene.fog;if(sceneFog){if(sceneData.fog!==sceneFog){const fogNode=this.getCacheNode("fog",sceneFog,()=>{if(sceneFog.isFogExp2){const color2=reference("color","color",sceneFog).setGroup(renderGroup),density=reference("density","float",sceneFog).setGroup(renderGroup);return fog(color2,densityFogFactor(density))}else if(sceneFog.isFog){const color2=reference("color","color",sceneFog).setGroup(renderGroup),near=reference("near","float",sceneFog).setGroup(renderGroup),far=reference("far","float",sceneFog).setGroup(renderGroup);return fog(color2,rangeFogFactor(near,far))}else console.error("THREE.Renderer: Unsupported fog configuration.",sceneFog)});sceneData.fogNode=fogNode,sceneData.fog=sceneFog}}else delete sceneData.fogNode,delete sceneData.fog}updateEnvironment(scene){const sceneData=this.get(scene),environment=scene.environment;if(environment){if(sceneData.environment!==environment){const environmentNode=this.getCacheNode("environment",environment,()=>{if(environment.isCubeTexture===!0)return cubeTexture(environment);if(environment.isTexture===!0)return texture$1(environment);console.error("Nodes: Unsupported environment configuration.",environment)});sceneData.environmentNode=environmentNode,sceneData.environment=environment}}else sceneData.environmentNode&&(delete sceneData.environmentNode,delete sceneData.environment)}getNodeFrame(renderer=this.renderer,scene=null,object=null,camera=null,material=null){const nodeFrame=this.nodeFrame;return nodeFrame.renderer=renderer,nodeFrame.scene=scene,nodeFrame.object=object,nodeFrame.camera=camera,nodeFrame.material=material,nodeFrame}getNodeFrameForRender(renderObject){return this.getNodeFrame(renderObject.renderer,renderObject.scene,renderObject.object,renderObject.camera,renderObject.material)}getOutputCacheKey(){const renderer=this.renderer;return renderer.toneMapping+","+renderer.currentColorSpace}hasOutputChange(outputTarget){return _outputNodeMap.get(outputTarget)!==this.getOutputCacheKey()}getOutputNode(outputTarget){const renderer=this.renderer,cacheKey=this.getOutputCacheKey(),output2=texture$1(outputTarget,screenUV).renderOutput(renderer.toneMapping,renderer.currentColorSpace);return _outputNodeMap.set(outputTarget,cacheKey),output2}updateBefore(renderObject){const nodeBuilder=renderObject.getNodeBuilderState();for(const node of nodeBuilder.updateBeforeNodes)this.getNodeFrameForRender(renderObject).updateBeforeNode(node)}updateAfter(renderObject){const nodeBuilder=renderObject.getNodeBuilderState();for(const node of nodeBuilder.updateAfterNodes)this.getNodeFrameForRender(renderObject).updateAfterNode(node)}updateForCompute(computeNode){const nodeFrame=this.getNodeFrame(),nodeBuilder=this.getForCompute(computeNode);for(const node of nodeBuilder.updateNodes)nodeFrame.updateNode(node)}updateForRender(renderObject){const nodeFrame=this.getNodeFrameForRender(renderObject),nodeBuilder=renderObject.getNodeBuilderState();for(const node of nodeBuilder.updateNodes)nodeFrame.updateNode(node)}needsRefresh(renderObject){const nodeFrame=this.getNodeFrameForRender(renderObject);return renderObject.getMonitor().needsRefresh(renderObject,nodeFrame)}dispose(){super.dispose(),this.nodeFrame=new NodeFrame,this.nodeBuilderCache=new Map,this.cacheLib={}}}const _plane=new Plane;class ClippingContext{constructor(parentContext=null){this.version=0,this.clipIntersection=null,this.cacheKey="",this.shadowPass=!1,this.viewNormalMatrix=new Matrix3,this.clippingGroupContexts=new WeakMap,this.intersectionPlanes=[],this.unionPlanes=[],this.parentVersion=null,parentContext!==null&&(this.viewNormalMatrix=parentContext.viewNormalMatrix,this.clippingGroupContexts=parentContext.clippingGroupContexts,this.shadowPass=parentContext.shadowPass,this.viewMatrix=parentContext.viewMatrix)}projectPlanes(source,destination,offset){const l2=source.length;for(let i2=0;i2<l2;i2++){_plane.copy(source[i2]).applyMatrix4(this.viewMatrix,this.viewNormalMatrix);const v=destination[offset+i2],normal2=_plane.normal;v.x=-normal2.x,v.y=-normal2.y,v.z=-normal2.z,v.w=_plane.constant}}updateGlobal(scene,camera){this.shadowPass=scene.overrideMaterial!==null&&scene.overrideMaterial.isShadowPassMaterial,this.viewMatrix=camera.matrixWorldInverse,this.viewNormalMatrix.getNormalMatrix(this.viewMatrix)}update(parentContext,clippingGroup){let update=!1;parentContext.version!==this.parentVersion&&(this.intersectionPlanes=Array.from(parentContext.intersectionPlanes),this.unionPlanes=Array.from(parentContext.unionPlanes),this.parentVersion=parentContext.version),this.clipIntersection!==clippingGroup.clipIntersection&&(this.clipIntersection=clippingGroup.clipIntersection,this.clipIntersection?this.unionPlanes.length=parentContext.unionPlanes.length:this.intersectionPlanes.length=parentContext.intersectionPlanes.length);const srcClippingPlanes=clippingGroup.clippingPlanes,l2=srcClippingPlanes.length;let dstClippingPlanes,offset;if(this.clipIntersection?(dstClippingPlanes=this.intersectionPlanes,offset=parentContext.intersectionPlanes.length):(dstClippingPlanes=this.unionPlanes,offset=parentContext.unionPlanes.length),dstClippingPlanes.length!==offset+l2){dstClippingPlanes.length=offset+l2;for(let i2=0;i2<l2;i2++)dstClippingPlanes[offset+i2]=new Vector4;update=!0}this.projectPlanes(srcClippingPlanes,dstClippingPlanes,offset),update&&(this.version++,this.cacheKey=`${this.intersectionPlanes.length}:${this.unionPlanes.length}`)}getGroupContext(clippingGroup){if(this.shadowPass&&!clippingGroup.clipShadows)return this;let context2=this.clippingGroupContexts.get(clippingGroup);return context2===void 0&&(context2=new ClippingContext(this),this.clippingGroupContexts.set(clippingGroup,context2)),context2.update(this,clippingGroup),context2}get unionClippingCount(){return this.unionPlanes.length}}class RenderBundle{constructor(bundleGroup,camera){this.bundleGroup=bundleGroup,this.camera=camera}}const _chainKeys$1=[];class RenderBundles{constructor(){this.bundles=new ChainMap}get(bundleGroup,camera){const bundles=this.bundles;_chainKeys$1[0]=bundleGroup,_chainKeys$1[1]=camera;let bundle=bundles.get(_chainKeys$1);return bundle===void 0&&(bundle=new RenderBundle(bundleGroup,camera),bundles.set(_chainKeys$1,bundle)),_chainKeys$1.length=0,bundle}dispose(){this.bundles=new ChainMap}}class NodeLibrary{constructor(){this.lightNodes=new WeakMap,this.materialNodes=new Map,this.toneMappingNodes=new Map}fromMaterial(material){if(material.isNodeMaterial)return material;let nodeMaterial=null;const nodeMaterialClass=this.getMaterialNodeClass(material.type);if(nodeMaterialClass!==null){nodeMaterial=new nodeMaterialClass;for(const key2 in material)nodeMaterial[key2]=material[key2]}return nodeMaterial}addToneMapping(toneMappingNode,toneMapping2){this.addType(toneMappingNode,toneMapping2,this.toneMappingNodes)}getToneMappingFunction(toneMapping2){return this.toneMappingNodes.get(toneMapping2)||null}getMaterialNodeClass(materialType){return this.materialNodes.get(materialType)||null}addMaterial(materialNodeClass,materialClassType){this.addType(materialNodeClass,materialClassType,this.materialNodes)}getLightNodeClass(light){return this.lightNodes.get(light)||null}addLight(lightNodeClass,lightClass){this.addClass(lightNodeClass,lightClass,this.lightNodes)}addType(nodeClass,type,library){if(library.has(type)){console.warn(`Redefinition of node ${type}`);return}if(typeof nodeClass!="function")throw new Error(`Node class ${nodeClass.name} is not a class.`);if(typeof type=="function"||typeof type=="object")throw new Error(`Base class ${type} is not a class.`);library.set(type,nodeClass)}addClass(nodeClass,baseClass,library){if(library.has(baseClass)){console.warn(`Redefinition of node ${baseClass.name}`);return}if(typeof nodeClass!="function")throw new Error(`Node class ${nodeClass.name} is not a class.`);if(typeof baseClass!="function")throw new Error(`Base class ${baseClass.name} is not a class.`);library.set(baseClass,nodeClass)}}const _defaultLights=new LightsNode,_chainKeys=[];class Lighting extends ChainMap{constructor(){super()}createNode(lights2=[]){return new LightsNode().setLights(lights2)}getNode(scene,camera){if(scene.isQuadMesh)return _defaultLights;_chainKeys[0]=scene,_chainKeys[1]=camera;let node=this.get(_chainKeys);return node===void 0&&(node=this.createNode(),this.set(_chainKeys,node)),_chainKeys.length=0,node}}class XRRenderTarget extends RenderTarget{constructor(width=1,height=1,options={}){super(width,height,options),this.isXRRenderTarget=!0,this.hasExternalTextures=!1,this.autoAllocateDepthBuffer=!0}copy(source){return super.copy(source),this.hasExternalTextures=source.hasExternalTextures,this.autoAllocateDepthBuffer=source.autoAllocateDepthBuffer,this}}const _cameraLPos=new Vector3,_cameraRPos=new Vector3;class XRManager extends EventDispatcher{constructor(renderer){super(),this.enabled=!1,this.isPresenting=!1,this.cameraAutoUpdate=!0,this._renderer=renderer,this._cameraL=new PerspectiveCamera,this._cameraL.viewport=new Vector4,this._cameraR=new PerspectiveCamera,this._cameraR.viewport=new Vector4,this._cameras=[this._cameraL,this._cameraR],this._cameraXR=new ArrayCamera,this._currentDepthNear=null,this._currentDepthFar=null,this._controllers=[],this._controllerInputSources=[],this._xrRenderTarget=null,this._currentAnimationContext=null,this._currentAnimationLoop=null,this._currentPixelRatio=null,this._currentSize=new Vector2,this._onSessionEvent=onSessionEvent.bind(this),this._onSessionEnd=onSessionEnd.bind(this),this._onInputSourcesChange=onInputSourcesChange.bind(this),this._onAnimationFrame=onAnimationFrame.bind(this),this._referenceSpace=null,this._referenceSpaceType="local-floor",this._customReferenceSpace=null,this._framebufferScaleFactor=1,this._foveation=1,this._session=null,this._glBaseLayer=null,this._glBinding=null,this._glProjLayer=null,this._xrFrame=null,this._useLayers=typeof XRWebGLBinding<"u"&&"createProjectionLayer"in XRWebGLBinding.prototype}getController(index){return this._getController(index).getTargetRaySpace()}getControllerGrip(index){return this._getController(index).getGripSpace()}getHand(index){return this._getController(index).getHandSpace()}getFoveation(){if(!(this._glProjLayer===null&&this._glBaseLayer===null))return this._foveation}setFoveation(foveation){this._foveation=foveation,this._glProjLayer!==null&&(this._glProjLayer.fixedFoveation=foveation),this._glBaseLayer!==null&&this._glBaseLayer.fixedFoveation!==void 0&&(this._glBaseLayer.fixedFoveation=foveation)}getFramebufferScaleFactor(){return this._framebufferScaleFactor}setFramebufferScaleFactor(factor){this._framebufferScaleFactor=factor,this.isPresenting===!0&&console.warn("THREE.XRManager: Cannot change framebuffer scale while presenting.")}getReferenceSpaceType(){return this._referenceSpaceType}setReferenceSpaceType(type){this._referenceSpaceType=type,this.isPresenting===!0&&console.warn("THREE.XRManager: Cannot change reference space type while presenting.")}getReferenceSpace(){return this._customReferenceSpace||this._referenceSpace}setReferenceSpace(space){this._customReferenceSpace=space}getCamera(){return this._cameraXR}getEnvironmentBlendMode(){if(this._session!==null)return this._session.environmentBlendMode}getFrame(){return this._xrFrame}getSession(){return this._session}async setSession(session){const renderer=this._renderer,backend=renderer.backend,gl=renderer.getContext();if(this._session=session,session!==null){if(backend.isWebGPUBackend===!0)throw new Error('THREE.XRManager: XR is currently not supported with a WebGPU backend. Use WebGL by passing "{ forceWebGL: true }" to the constructor of the renderer.');if(session.addEventListener("select",this._onSessionEvent),session.addEventListener("selectstart",this._onSessionEvent),session.addEventListener("selectend",this._onSessionEvent),session.addEventListener("squeeze",this._onSessionEvent),session.addEventListener("squeezestart",this._onSessionEvent),session.addEventListener("squeezeend",this._onSessionEvent),session.addEventListener("end",this._onSessionEnd),session.addEventListener("inputsourceschange",this._onInputSourcesChange),await backend.makeXRCompatible(),this._currentPixelRatio=renderer.getPixelRatio(),renderer.getSize(this._currentSize),this._currentAnimationContext=renderer._animation.getContext(),this._currentAnimationLoop=renderer._animation.getAnimationLoop(),renderer._animation.stop(),this._useLayers===!0){let depthFormat=null,depthType=null,glDepthFormat=null;renderer.depth&&(glDepthFormat=renderer.stencil?gl.DEPTH24_STENCIL8:gl.DEPTH_COMPONENT24,depthFormat=renderer.stencil?DepthStencilFormat:DepthFormat,depthType=renderer.stencil?UnsignedInt248Type:UnsignedIntType);const projectionlayerInit={colorFormat:gl.RGBA8,depthFormat:glDepthFormat,scaleFactor:this._framebufferScaleFactor},glBinding=new XRWebGLBinding(session,gl),glProjLayer=glBinding.createProjectionLayer(projectionlayerInit);this._glBinding=glBinding,this._glProjLayer=glProjLayer,session.updateRenderState({layers:[glProjLayer]}),renderer.setPixelRatio(1),renderer.setSize(glProjLayer.textureWidth,glProjLayer.textureHeight,!1),this._xrRenderTarget=new XRRenderTarget(glProjLayer.textureWidth,glProjLayer.textureHeight,{format:RGBAFormat,type:UnsignedByteType,colorSpace:renderer.outputColorSpace,depthTexture:new DepthTexture(glProjLayer.textureWidth,glProjLayer.textureHeight,depthType,void 0,void 0,void 0,void 0,void 0,void 0,depthFormat),stencilBuffer:renderer.stencil}),this._xrRenderTarget.hasExternalTextures=!0}else{const layerInit={antialias:renderer.samples>0,alpha:!0,depth:renderer.depth,stencil:renderer.stencil,framebufferScaleFactor:this.getFramebufferScaleFactor()},glBaseLayer=new XRWebGLLayer(session,gl,layerInit);this._glBaseLayer=glBaseLayer,session.updateRenderState({baseLayer:glBaseLayer}),renderer.setPixelRatio(1),renderer.setSize(glBaseLayer.framebufferWidth,glBaseLayer.framebufferHeight,!1),this._xrRenderTarget=new XRRenderTarget(glBaseLayer.framebufferWidth,glBaseLayer.framebufferHeight,{format:RGBAFormat,type:UnsignedByteType,colorSpace:renderer.outputColorSpace,stencilBuffer:renderer.stencil})}this.setFoveation(this.getFoveation()),this._referenceSpace=await session.requestReferenceSpace(this.getReferenceSpaceType()),renderer._animation.setAnimationLoop(this._onAnimationFrame),renderer._animation.setContext(session),renderer._animation.start(),this.isPresenting=!0,this.dispatchEvent({type:"sessionstart"})}}updateCamera(camera){const session=this._session;if(session===null)return;const depthNear=camera.near,depthFar=camera.far,cameraXR=this._cameraXR,cameraL=this._cameraL,cameraR=this._cameraR;cameraXR.near=cameraR.near=cameraL.near=depthNear,cameraXR.far=cameraR.far=cameraL.far=depthFar,(this._currentDepthNear!==cameraXR.near||this._currentDepthFar!==cameraXR.far)&&(session.updateRenderState({depthNear:cameraXR.near,depthFar:cameraXR.far}),this._currentDepthNear=cameraXR.near,this._currentDepthFar=cameraXR.far),cameraL.layers.mask=camera.layers.mask|2,cameraR.layers.mask=camera.layers.mask|4,cameraXR.layers.mask=cameraL.layers.mask|cameraR.layers.mask;const parent=camera.parent,cameras=cameraXR.cameras;updateCamera(cameraXR,parent);for(let i2=0;i2<cameras.length;i2++)updateCamera(cameras[i2],parent);cameras.length===2?setProjectionFromUnion(cameraXR,cameraL,cameraR):cameraXR.projectionMatrix.copy(cameraL.projectionMatrix),updateUserCamera(camera,cameraXR,parent)}_getController(index){let controller=this._controllers[index];return controller===void 0&&(controller=new WebXRController,this._controllers[index]=controller),controller}}function setProjectionFromUnion(camera,cameraL,cameraR){_cameraLPos.setFromMatrixPosition(cameraL.matrixWorld),_cameraRPos.setFromMatrixPosition(cameraR.matrixWorld);const ipd=_cameraLPos.distanceTo(_cameraRPos),projL=cameraL.projectionMatrix.elements,projR=cameraR.projectionMatrix.elements,near=projL[14]/(projL[10]-1),far=projL[14]/(projL[10]+1),topFov=(projL[9]+1)/projL[5],bottomFov=(projL[9]-1)/projL[5],leftFov=(projL[8]-1)/projL[0],rightFov=(projR[8]+1)/projR[0],left=near*leftFov,right=near*rightFov,zOffset=ipd/(-leftFov+rightFov),xOffset=zOffset*-leftFov;if(cameraL.matrixWorld.decompose(camera.position,camera.quaternion,camera.scale),camera.translateX(xOffset),camera.translateZ(zOffset),camera.matrixWorld.compose(camera.position,camera.quaternion,camera.scale),camera.matrixWorldInverse.copy(camera.matrixWorld).invert(),projL[10]===-1)camera.projectionMatrix.copy(cameraL.projectionMatrix),camera.projectionMatrixInverse.copy(cameraL.projectionMatrixInverse);else{const near2=near+zOffset,far2=far+zOffset,left2=left-xOffset,right2=right+(ipd-xOffset),top2=topFov*far/far2*near2,bottom2=bottomFov*far/far2*near2;camera.projectionMatrix.makePerspective(left2,right2,top2,bottom2,near2,far2),camera.projectionMatrixInverse.copy(camera.projectionMatrix).invert()}}function updateCamera(camera,parent){parent===null?camera.matrixWorld.copy(camera.matrix):camera.matrixWorld.multiplyMatrices(parent.matrixWorld,camera.matrix),camera.matrixWorldInverse.copy(camera.matrixWorld).invert()}function updateUserCamera(camera,cameraXR,parent){parent===null?camera.matrix.copy(cameraXR.matrixWorld):(camera.matrix.copy(parent.matrixWorld),camera.matrix.invert(),camera.matrix.multiply(cameraXR.matrixWorld)),camera.matrix.decompose(camera.position,camera.quaternion,camera.scale),camera.updateMatrixWorld(!0),camera.projectionMatrix.copy(cameraXR.projectionMatrix),camera.projectionMatrixInverse.copy(cameraXR.projectionMatrixInverse),camera.isPerspectiveCamera&&(camera.fov=RAD2DEG*2*Math.atan(1/camera.projectionMatrix.elements[5]),camera.zoom=1)}function onSessionEvent(event){const controllerIndex=this._controllerInputSources.indexOf(event.inputSource);if(controllerIndex===-1)return;const controller=this._controllers[controllerIndex];if(controller!==void 0){const referenceSpace=this.getReferenceSpace();controller.update(event.inputSource,event.frame,referenceSpace),controller.dispatchEvent({type:event.type,data:event.inputSource})}}function onSessionEnd(){const session=this._session,renderer=this._renderer;session.removeEventListener("select",this._onSessionEvent),session.removeEventListener("selectstart",this._onSessionEvent),session.removeEventListener("selectend",this._onSessionEvent),session.removeEventListener("squeeze",this._onSessionEvent),session.removeEventListener("squeezestart",this._onSessionEvent),session.removeEventListener("squeezeend",this._onSessionEvent),session.removeEventListener("end",this._onSessionEnd),session.removeEventListener("inputsourceschange",this._onInputSourcesChange);for(let i2=0;i2<this._controllers.length;i2++){const inputSource=this._controllerInputSources[i2];inputSource!==null&&(this._controllerInputSources[i2]=null,this._controllers[i2].disconnect(inputSource))}this._currentDepthNear=null,this._currentDepthFar=null,renderer.backend.setXRTarget(null),renderer.setOutputRenderTarget(null),this._session=null,this._xrRenderTarget=null,this.isPresenting=!1,renderer._animation.stop(),renderer._animation.setAnimationLoop(this._currentAnimationLoop),renderer._animation.setContext(this._currentAnimationContext),renderer._animation.start(),renderer.setPixelRatio(this._currentPixelRatio),renderer.setSize(this._currentSize.width,this._currentSize.height,!1),this.dispatchEvent({type:"sessionend"})}function onInputSourcesChange(event){const controllers=this._controllers,controllerInputSources=this._controllerInputSources;for(let i2=0;i2<event.removed.length;i2++){const inputSource=event.removed[i2],index=controllerInputSources.indexOf(inputSource);index>=0&&(controllerInputSources[index]=null,controllers[index].disconnect(inputSource))}for(let i2=0;i2<event.added.length;i2++){const inputSource=event.added[i2];let controllerIndex=controllerInputSources.indexOf(inputSource);if(controllerIndex===-1){for(let i3=0;i3<controllers.length;i3++)if(i3>=controllerInputSources.length){controllerInputSources.push(inputSource),controllerIndex=i3;break}else if(controllerInputSources[i3]===null){controllerInputSources[i3]=inputSource,controllerIndex=i3;break}if(controllerIndex===-1)break}const controller=controllers[controllerIndex];controller&&controller.connect(inputSource)}}function onAnimationFrame(time2,frame){if(frame===void 0)return;const cameraXR=this._cameraXR,renderer=this._renderer,backend=renderer.backend,glBaseLayer=this._glBaseLayer,referenceSpace=this.getReferenceSpace(),pose=frame.getViewerPose(referenceSpace);if(this._xrFrame=frame,pose!==null){const views=pose.views;this._glBaseLayer!==null&&backend.setXRTarget(glBaseLayer.framebuffer);let cameraXRNeedsUpdate=!1;views.length!==cameraXR.cameras.length&&(cameraXR.cameras.length=0,cameraXRNeedsUpdate=!0);for(let i2=0;i2<views.length;i2++){const view=views[i2];let viewport2;if(this._useLayers===!0){const glSubImage=this._glBinding.getViewSubImage(this._glProjLayer,view);viewport2=glSubImage.viewport,i2===0&&backend.setXRRenderTargetTextures(this._xrRenderTarget,glSubImage.colorTexture,this._glProjLayer.ignoreDepthValues?void 0:glSubImage.depthStencilTexture)}else viewport2=glBaseLayer.getViewport(view);let camera=this._cameras[i2];camera===void 0&&(camera=new PerspectiveCamera,camera.layers.enable(i2),camera.viewport=new Vector4,this._cameras[i2]=camera),camera.matrix.fromArray(view.transform.matrix),camera.matrix.decompose(camera.position,camera.quaternion,camera.scale),camera.projectionMatrix.fromArray(view.projectionMatrix),camera.projectionMatrixInverse.copy(camera.projectionMatrix).invert(),camera.viewport.set(viewport2.x,viewport2.y,viewport2.width,viewport2.height),i2===0&&(cameraXR.matrix.copy(camera.matrix),cameraXR.matrix.decompose(cameraXR.position,cameraXR.quaternion,cameraXR.scale)),cameraXRNeedsUpdate===!0&&cameraXR.cameras.push(camera)}renderer.setOutputRenderTarget(this._xrRenderTarget)}for(let i2=0;i2<this._controllers.length;i2++){const inputSource=this._controllerInputSources[i2],controller=this._controllers[i2];inputSource!==null&&controller!==void 0&&controller.update(inputSource,frame,referenceSpace)}this._currentAnimationLoop&&this._currentAnimationLoop(time2,frame),frame.detectedPlanes&&this.dispatchEvent({type:"planesdetected",data:frame}),this._xrFrame=null}const _scene=new Scene,_drawingBufferSize=new Vector2,_screen=new Vector4,_frustum=new Frustum,_projScreenMatrix=new Matrix4,_vector4=new Vector4;class Renderer{constructor(backend,parameters={}){this.isRenderer=!0;const{logarithmicDepthBuffer=!1,alpha=!0,depth:depth2=!0,stencil=!1,antialias=!1,samples=0,getFallback=null,colorBufferType=HalfFloatType}=parameters;this.domElement=backend.getDomElement(),this.backend=backend,this.samples=samples||antialias===!0?4:0,this.autoClear=!0,this.autoClearColor=!0,this.autoClearDepth=!0,this.autoClearStencil=!0,this.alpha=alpha,this.logarithmicDepthBuffer=logarithmicDepthBuffer,this.outputColorSpace=SRGBColorSpace,this.toneMapping=NoToneMapping,this.toneMappingExposure=1,this.sortObjects=!0,this.depth=depth2,this.stencil=stencil,this.info=new Info,this.nodes={modelViewMatrix:null,modelNormalViewMatrix:null},this.library=new NodeLibrary,this.lighting=new Lighting,this._getFallback=getFallback,this._pixelRatio=1,this._width=this.domElement.width,this._height=this.domElement.height,this._viewport=new Vector4(0,0,this._width,this._height),this._scissor=new Vector4(0,0,this._width,this._height),this._scissorTest=!1,this._attributes=null,this._geometries=null,this._nodes=null,this._animation=null,this._bindings=null,this._objects=null,this._pipelines=null,this._bundles=null,this._renderLists=null,this._renderContexts=null,this._textures=null,this._background=null,this._quad=new QuadMesh(new NodeMaterial),this._quad.material.name="Renderer_output",this._currentRenderContext=null,this._opaqueSort=null,this._transparentSort=null,this._frameBufferTarget=null;const alphaClear=this.alpha===!0?0:1;this._clearColor=new Color4(0,0,0,alphaClear),this._clearDepth=1,this._clearStencil=0,this._renderTarget=null,this._activeCubeFace=0,this._activeMipmapLevel=0,this._outputRenderTarget=null,this._mrt=null,this._renderObjectFunction=null,this._currentRenderObjectFunction=null,this._currentRenderBundle=null,this._handleObjectFunction=this._renderObjectDirect,this._isDeviceLost=!1,this.onDeviceLost=this._onDeviceLost,this._colorBufferType=colorBufferType,this._initialized=!1,this._initPromise=null,this._compilationPromises=null,this.transparent=!0,this.opaque=!0,this.shadowMap={enabled:!1,type:PCFShadowMap},this.xr=new XRManager(this),this.debug={checkShaderErrors:!0,onShaderError:null,getShaderAsync:async(scene,camera,object)=>{await this.compileAsync(scene,camera);const renderList=this._renderLists.get(scene,camera),renderContext=this._renderContexts.get(scene,camera,this._renderTarget),material=scene.overrideMaterial||object.material,renderObject=this._objects.get(object,material,scene,camera,renderList.lightsNode,renderContext,renderContext.clippingContext),{fragmentShader,vertexShader}=renderObject.getNodeBuilderState();return{fragmentShader,vertexShader}}}}async init(){if(this._initialized)throw new Error("Renderer: Backend has already been initialized.");return this._initPromise!==null?this._initPromise:(this._initPromise=new Promise(async(resolve,reject)=>{let backend=this.backend;try{await backend.init(this)}catch(error){if(this._getFallback!==null)try{this.backend=backend=this._getFallback(error),await backend.init(this)}catch(error2){reject(error2);return}else{reject(error);return}}this._nodes=new Nodes(this,backend),this._animation=new Animation(this._nodes,this.info),this._attributes=new Attributes(backend),this._background=new Background(this,this._nodes),this._geometries=new Geometries(this._attributes,this.info),this._textures=new Textures(this,backend,this.info),this._pipelines=new Pipelines(backend,this._nodes),this._bindings=new Bindings(backend,this._nodes,this._textures,this._attributes,this._pipelines,this.info),this._objects=new RenderObjects(this,this._nodes,this._geometries,this._pipelines,this._bindings,this.info),this._renderLists=new RenderLists(this.lighting),this._bundles=new RenderBundles,this._renderContexts=new RenderContexts,this._animation.start(),this._initialized=!0,resolve(this)}),this._initPromise)}get coordinateSystem(){return this.backend.coordinateSystem}async compileAsync(scene,camera,targetScene=null){if(this._isDeviceLost===!0)return;this._initialized===!1&&await this.init();const nodeFrame=this._nodes.nodeFrame,previousRenderId=nodeFrame.renderId,previousRenderContext=this._currentRenderContext,previousRenderObjectFunction=this._currentRenderObjectFunction,previousCompilationPromises=this._compilationPromises,sceneRef=scene.isScene===!0?scene:_scene;targetScene===null&&(targetScene=scene);const renderTarget=this._renderTarget,renderContext=this._renderContexts.get(targetScene,camera,renderTarget),activeMipmapLevel=this._activeMipmapLevel,compilationPromises=[];this._currentRenderContext=renderContext,this._currentRenderObjectFunction=this.renderObject,this._handleObjectFunction=this._createObjectPipeline,this._compilationPromises=compilationPromises,nodeFrame.renderId++,nodeFrame.update(),renderContext.depth=this.depth,renderContext.stencil=this.stencil,renderContext.clippingContext||(renderContext.clippingContext=new ClippingContext),renderContext.clippingContext.updateGlobal(sceneRef,camera),sceneRef.onBeforeRender(this,scene,camera,renderTarget);const renderList=this._renderLists.get(scene,camera);if(renderList.begin(),this._projectObject(scene,camera,0,renderList,renderContext.clippingContext),targetScene!==scene&&targetScene.traverseVisible(function(object){object.isLight&&object.layers.test(camera.layers)&&renderList.pushLight(object)}),renderList.finish(),renderTarget!==null){this._textures.updateRenderTarget(renderTarget,activeMipmapLevel);const renderTargetData=this._textures.get(renderTarget);renderContext.textures=renderTargetData.textures,renderContext.depthTexture=renderTargetData.depthTexture}else renderContext.textures=null,renderContext.depthTexture=null;this._background.update(sceneRef,renderList,renderContext);const opaqueObjects=renderList.opaque,transparentObjects=renderList.transparent,transparentDoublePassObjects=renderList.transparentDoublePass,lightsNode=renderList.lightsNode;this.opaque===!0&&opaqueObjects.length>0&&this._renderObjects(opaqueObjects,camera,sceneRef,lightsNode),this.transparent===!0&&transparentObjects.length>0&&this._renderTransparents(transparentObjects,transparentDoublePassObjects,camera,sceneRef,lightsNode),nodeFrame.renderId=previousRenderId,this._currentRenderContext=previousRenderContext,this._currentRenderObjectFunction=previousRenderObjectFunction,this._compilationPromises=previousCompilationPromises,this._handleObjectFunction=this._renderObjectDirect,await Promise.all(compilationPromises)}async renderAsync(scene,camera){this._initialized===!1&&await this.init(),this._renderScene(scene,camera)}async waitForGPU(){await this.backend.waitForGPU()}setMRT(mrt2){return this._mrt=mrt2,this}getMRT(){return this._mrt}getColorBufferType(){return this._colorBufferType}_onDeviceLost(info){let errorMessage=`THREE.WebGPURenderer: ${info.api} Device Lost:

Message: ${info.message}`;info.reason&&(errorMessage+=`
Reason: ${info.reason}`),console.error(errorMessage),this._isDeviceLost=!0}_renderBundle(bundle,sceneRef,lightsNode){const{bundleGroup,camera,renderList}=bundle,renderContext=this._currentRenderContext,renderBundle=this._bundles.get(bundleGroup,camera),renderBundleData=this.backend.get(renderBundle);renderBundleData.renderContexts===void 0&&(renderBundleData.renderContexts=new Set);const needsUpdate=bundleGroup.version!==renderBundleData.version,renderBundleNeedsUpdate=renderBundleData.renderContexts.has(renderContext)===!1||needsUpdate;if(renderBundleData.renderContexts.add(renderContext),renderBundleNeedsUpdate){this.backend.beginBundle(renderContext),(renderBundleData.renderObjects===void 0||needsUpdate)&&(renderBundleData.renderObjects=[]),this._currentRenderBundle=renderBundle;const opaqueObjects=renderList.opaque;this.opaque===!0&&opaqueObjects.length>0&&this._renderObjects(opaqueObjects,camera,sceneRef,lightsNode),this._currentRenderBundle=null,this.backend.finishBundle(renderContext,renderBundle),renderBundleData.version=bundleGroup.version}else{const{renderObjects}=renderBundleData;for(let i2=0,l2=renderObjects.length;i2<l2;i2++){const renderObject=renderObjects[i2];this._nodes.needsRefresh(renderObject)&&(this._nodes.updateBefore(renderObject),this._nodes.updateForRender(renderObject),this._bindings.updateForRender(renderObject),this._nodes.updateAfter(renderObject))}}this.backend.addBundle(renderContext,renderBundle)}render(scene,camera){if(this._initialized===!1)return console.warn("THREE.Renderer: .render() called before the backend is initialized. Try using .renderAsync() instead."),this.renderAsync(scene,camera);this._renderScene(scene,camera)}_getFrameBufferTarget(){const{currentToneMapping,currentColorSpace}=this;if(currentToneMapping!==NoToneMapping===!1&&currentColorSpace!==LinearSRGBColorSpace===!1)return null;const{width,height}=this.getDrawingBufferSize(_drawingBufferSize),{depth:depth2,stencil}=this;let frameBufferTarget=this._frameBufferTarget;return frameBufferTarget===null&&(frameBufferTarget=new RenderTarget(width,height,{depthBuffer:depth2,stencilBuffer:stencil,type:this._colorBufferType,format:RGBAFormat,colorSpace:LinearSRGBColorSpace,generateMipmaps:!1,minFilter:LinearFilter,magFilter:LinearFilter,samples:this.samples}),frameBufferTarget.isPostProcessingRenderTarget=!0,this._frameBufferTarget=frameBufferTarget),frameBufferTarget.depthBuffer=depth2,frameBufferTarget.stencilBuffer=stencil,frameBufferTarget.setSize(width,height),frameBufferTarget.viewport.copy(this._viewport),frameBufferTarget.scissor.copy(this._scissor),frameBufferTarget.viewport.multiplyScalar(this._pixelRatio),frameBufferTarget.scissor.multiplyScalar(this._pixelRatio),frameBufferTarget.scissorTest=this._scissorTest,frameBufferTarget}_renderScene(scene,camera,useFrameBufferTarget=!0){if(this._isDeviceLost===!0)return;const frameBufferTarget=useFrameBufferTarget?this._getFrameBufferTarget():null,nodeFrame=this._nodes.nodeFrame,previousRenderId=nodeFrame.renderId,previousRenderContext=this._currentRenderContext,previousRenderObjectFunction=this._currentRenderObjectFunction,sceneRef=scene.isScene===!0?scene:_scene,outputRenderTarget=this._renderTarget||this._outputRenderTarget,activeCubeFace=this._activeCubeFace,activeMipmapLevel=this._activeMipmapLevel;let renderTarget;frameBufferTarget!==null?(renderTarget=frameBufferTarget,this.setRenderTarget(renderTarget)):renderTarget=outputRenderTarget;const renderContext=this._renderContexts.get(scene,camera,renderTarget);this._currentRenderContext=renderContext,this._currentRenderObjectFunction=this._renderObjectFunction||this.renderObject,this.info.calls++,this.info.render.calls++,this.info.render.frameCalls++,nodeFrame.renderId=this.info.calls;const coordinateSystem=this.coordinateSystem,xr=this.xr;if(camera.coordinateSystem!==coordinateSystem&&xr.isPresenting===!1&&(camera.coordinateSystem=coordinateSystem,camera.updateProjectionMatrix(),camera.isArrayCamera))for(const subCamera of camera.cameras)subCamera.coordinateSystem=coordinateSystem,subCamera.updateProjectionMatrix();scene.matrixWorldAutoUpdate===!0&&scene.updateMatrixWorld(),camera.parent===null&&camera.matrixWorldAutoUpdate===!0&&camera.updateMatrixWorld(),xr.enabled===!0&&xr.isPresenting===!0&&(xr.cameraAutoUpdate===!0&&xr.updateCamera(camera),camera=xr.getCamera());let viewport2=this._viewport,scissor=this._scissor,pixelRatio=this._pixelRatio;renderTarget!==null&&(viewport2=renderTarget.viewport,scissor=renderTarget.scissor,pixelRatio=1),this.getDrawingBufferSize(_drawingBufferSize),_screen.set(0,0,_drawingBufferSize.width,_drawingBufferSize.height);const minDepth=viewport2.minDepth===void 0?0:viewport2.minDepth,maxDepth=viewport2.maxDepth===void 0?1:viewport2.maxDepth;renderContext.viewportValue.copy(viewport2).multiplyScalar(pixelRatio).floor(),renderContext.viewportValue.width>>=activeMipmapLevel,renderContext.viewportValue.height>>=activeMipmapLevel,renderContext.viewportValue.minDepth=minDepth,renderContext.viewportValue.maxDepth=maxDepth,renderContext.viewport=renderContext.viewportValue.equals(_screen)===!1,renderContext.scissorValue.copy(scissor).multiplyScalar(pixelRatio).floor(),renderContext.scissor=this._scissorTest&&renderContext.scissorValue.equals(_screen)===!1,renderContext.scissorValue.width>>=activeMipmapLevel,renderContext.scissorValue.height>>=activeMipmapLevel,renderContext.clippingContext||(renderContext.clippingContext=new ClippingContext),renderContext.clippingContext.updateGlobal(sceneRef,camera),sceneRef.onBeforeRender(this,scene,camera,renderTarget),_projScreenMatrix.multiplyMatrices(camera.projectionMatrix,camera.matrixWorldInverse),_frustum.setFromProjectionMatrix(_projScreenMatrix,coordinateSystem);const renderList=this._renderLists.get(scene,camera);if(renderList.begin(),this._projectObject(scene,camera,0,renderList,renderContext.clippingContext),renderList.finish(),this.sortObjects===!0&&renderList.sort(this._opaqueSort,this._transparentSort),renderTarget!==null){this._textures.updateRenderTarget(renderTarget,activeMipmapLevel);const renderTargetData=this._textures.get(renderTarget);renderContext.textures=renderTargetData.textures,renderContext.depthTexture=renderTargetData.depthTexture,renderContext.width=renderTargetData.width,renderContext.height=renderTargetData.height,renderContext.renderTarget=renderTarget,renderContext.depth=renderTarget.depthBuffer,renderContext.stencil=renderTarget.stencilBuffer}else renderContext.textures=null,renderContext.depthTexture=null,renderContext.width=this.domElement.width,renderContext.height=this.domElement.height,renderContext.depth=this.depth,renderContext.stencil=this.stencil;renderContext.width>>=activeMipmapLevel,renderContext.height>>=activeMipmapLevel,renderContext.activeCubeFace=activeCubeFace,renderContext.activeMipmapLevel=activeMipmapLevel,renderContext.occlusionQueryCount=renderList.occlusionQueryCount,this._background.update(sceneRef,renderList,renderContext),this.backend.beginRender(renderContext);const{bundles,lightsNode,transparentDoublePass:transparentDoublePassObjects,transparent:transparentObjects,opaque:opaqueObjects}=renderList;return bundles.length>0&&this._renderBundles(bundles,sceneRef,lightsNode),this.opaque===!0&&opaqueObjects.length>0&&this._renderObjects(opaqueObjects,camera,sceneRef,lightsNode),this.transparent===!0&&transparentObjects.length>0&&this._renderTransparents(transparentObjects,transparentDoublePassObjects,camera,sceneRef,lightsNode),this.backend.finishRender(renderContext),nodeFrame.renderId=previousRenderId,this._currentRenderContext=previousRenderContext,this._currentRenderObjectFunction=previousRenderObjectFunction,frameBufferTarget!==null&&(this.setRenderTarget(outputRenderTarget,activeCubeFace,activeMipmapLevel),this._renderOutput(renderTarget)),sceneRef.onAfterRender(this,scene,camera,renderTarget),renderContext}_renderOutput(renderTarget){const quad=this._quad;this._nodes.hasOutputChange(renderTarget.texture)&&(quad.material.fragmentNode=this._nodes.getOutputNode(renderTarget.texture),quad.material.needsUpdate=!0);const currentAutoClear=this.autoClear,currentXR=this.xr.enabled;this.autoClear=!1,this.xr.enabled=!1,this._renderScene(quad,quad.camera,!1),this.autoClear=currentAutoClear,this.xr.enabled=currentXR}getMaxAnisotropy(){return this.backend.getMaxAnisotropy()}getActiveCubeFace(){return this._activeCubeFace}getActiveMipmapLevel(){return this._activeMipmapLevel}async setAnimationLoop(callback){this._initialized===!1&&await this.init(),this._animation.setAnimationLoop(callback)}async getArrayBufferAsync(attribute2){return await this.backend.getArrayBufferAsync(attribute2)}getContext(){return this.backend.getContext()}getPixelRatio(){return this._pixelRatio}getDrawingBufferSize(target){return target.set(this._width*this._pixelRatio,this._height*this._pixelRatio).floor()}getSize(target){return target.set(this._width,this._height)}setPixelRatio(value=1){this._pixelRatio!==value&&(this._pixelRatio=value,this.setSize(this._width,this._height,!1))}setDrawingBufferSize(width,height,pixelRatio){this._width=width,this._height=height,this._pixelRatio=pixelRatio,this.domElement.width=Math.floor(width*pixelRatio),this.domElement.height=Math.floor(height*pixelRatio),this.setViewport(0,0,width,height),this._initialized&&this.backend.updateSize()}setSize(width,height,updateStyle=!0){this._width=width,this._height=height,this.domElement.width=Math.floor(width*this._pixelRatio),this.domElement.height=Math.floor(height*this._pixelRatio),updateStyle===!0&&(this.domElement.style.width=width+"px",this.domElement.style.height=height+"px"),this.setViewport(0,0,width,height),this._initialized&&this.backend.updateSize()}setOpaqueSort(method){this._opaqueSort=method}setTransparentSort(method){this._transparentSort=method}getScissor(target){const scissor=this._scissor;return target.x=scissor.x,target.y=scissor.y,target.width=scissor.width,target.height=scissor.height,target}setScissor(x,y,width,height){const scissor=this._scissor;x.isVector4?scissor.copy(x):scissor.set(x,y,width,height)}getScissorTest(){return this._scissorTest}setScissorTest(boolean){this._scissorTest=boolean,this.backend.setScissorTest(boolean)}getViewport(target){return target.copy(this._viewport)}setViewport(x,y,width,height,minDepth=0,maxDepth=1){const viewport2=this._viewport;x.isVector4?viewport2.copy(x):viewport2.set(x,y,width,height),viewport2.minDepth=minDepth,viewport2.maxDepth=maxDepth}getClearColor(target){return target.copy(this._clearColor)}setClearColor(color2,alpha=1){this._clearColor.set(color2),this._clearColor.a=alpha}getClearAlpha(){return this._clearColor.a}setClearAlpha(alpha){this._clearColor.a=alpha}getClearDepth(){return this._clearDepth}setClearDepth(depth2){this._clearDepth=depth2}getClearStencil(){return this._clearStencil}setClearStencil(stencil){this._clearStencil=stencil}isOccluded(object){const renderContext=this._currentRenderContext;return renderContext&&this.backend.isOccluded(renderContext,object)}clear(color2=!0,depth2=!0,stencil=!0){if(this._initialized===!1)return console.warn("THREE.Renderer: .clear() called before the backend is initialized. Try using .clearAsync() instead."),this.clearAsync(color2,depth2,stencil);const renderTarget=this._renderTarget||this._getFrameBufferTarget();let renderContext=null;if(renderTarget!==null){this._textures.updateRenderTarget(renderTarget);const renderTargetData=this._textures.get(renderTarget);renderContext=this._renderContexts.getForClear(renderTarget),renderContext.textures=renderTargetData.textures,renderContext.depthTexture=renderTargetData.depthTexture,renderContext.width=renderTargetData.width,renderContext.height=renderTargetData.height,renderContext.renderTarget=renderTarget,renderContext.depth=renderTarget.depthBuffer,renderContext.stencil=renderTarget.stencilBuffer,renderContext.clearColorValue=this.backend.getClearColor()}this.backend.clear(color2,depth2,stencil,renderContext),renderTarget!==null&&this._renderTarget===null&&this._renderOutput(renderTarget)}clearColor(){return this.clear(!0,!1,!1)}clearDepth(){return this.clear(!1,!0,!1)}clearStencil(){return this.clear(!1,!1,!0)}async clearAsync(color2=!0,depth2=!0,stencil=!0){this._initialized===!1&&await this.init(),this.clear(color2,depth2,stencil)}async clearColorAsync(){this.clearAsync(!0,!1,!1)}async clearDepthAsync(){this.clearAsync(!1,!0,!1)}async clearStencilAsync(){this.clearAsync(!1,!1,!0)}get currentToneMapping(){return this.isOutputTarget?this.toneMapping:NoToneMapping}get currentColorSpace(){return this.isOutputTarget?this.outputColorSpace:LinearSRGBColorSpace}get isOutputTarget(){return this._renderTarget===this._outputRenderTarget||this._renderTarget===null}dispose(){this.info.dispose(),this.backend.dispose(),this._animation.dispose(),this._objects.dispose(),this._pipelines.dispose(),this._nodes.dispose(),this._bindings.dispose(),this._renderLists.dispose(),this._renderContexts.dispose(),this._textures.dispose(),this._frameBufferTarget!==null&&this._frameBufferTarget.dispose(),Object.values(this.backend.timestampQueryPool).forEach(queryPool=>{queryPool!==null&&queryPool.dispose()}),this.setRenderTarget(null),this.setAnimationLoop(null)}setRenderTarget(renderTarget,activeCubeFace=0,activeMipmapLevel=0){this._renderTarget=renderTarget,this._activeCubeFace=activeCubeFace,this._activeMipmapLevel=activeMipmapLevel}getRenderTarget(){return this._renderTarget}setOutputRenderTarget(renderTarget){this._outputRenderTarget=renderTarget}getOutputRenderTarget(){return this._outputRenderTarget}setRenderObjectFunction(renderObjectFunction){this._renderObjectFunction=renderObjectFunction}getRenderObjectFunction(){return this._renderObjectFunction}compute(computeNodes){if(this._isDeviceLost===!0)return;if(this._initialized===!1)return console.warn("THREE.Renderer: .compute() called before the backend is initialized. Try using .computeAsync() instead."),this.computeAsync(computeNodes);const nodeFrame=this._nodes.nodeFrame,previousRenderId=nodeFrame.renderId;this.info.calls++,this.info.compute.calls++,this.info.compute.frameCalls++,nodeFrame.renderId=this.info.calls;const backend=this.backend,pipelines=this._pipelines,bindings=this._bindings,nodes=this._nodes,computeList=Array.isArray(computeNodes)?computeNodes:[computeNodes];if(computeList[0]===void 0||computeList[0].isComputeNode!==!0)throw new Error("THREE.Renderer: .compute() expects a ComputeNode.");backend.beginCompute(computeNodes);for(const computeNode of computeList){if(pipelines.has(computeNode)===!1){const dispose=()=>{computeNode.removeEventListener("dispose",dispose),pipelines.delete(computeNode),bindings.delete(computeNode),nodes.delete(computeNode)};computeNode.addEventListener("dispose",dispose);const onInitFn=computeNode.onInitFunction;onInitFn!==null&&onInitFn.call(computeNode,{renderer:this})}nodes.updateForCompute(computeNode),bindings.updateForCompute(computeNode);const computeBindings=bindings.getForCompute(computeNode),computePipeline=pipelines.getForCompute(computeNode,computeBindings);backend.compute(computeNodes,computeNode,computeBindings,computePipeline)}backend.finishCompute(computeNodes),nodeFrame.renderId=previousRenderId}async computeAsync(computeNodes){this._initialized===!1&&await this.init(),this.compute(computeNodes)}async hasFeatureAsync(name){return this._initialized===!1&&await this.init(),this.backend.hasFeature(name)}async resolveTimestampsAsync(type="render"){return this._initialized===!1&&await this.init(),this.backend.resolveTimestampsAsync(type)}hasFeature(name){return this._initialized===!1?(console.warn("THREE.Renderer: .hasFeature() called before the backend is initialized. Try using .hasFeatureAsync() instead."),!1):this.backend.hasFeature(name)}hasInitialized(){return this._initialized}async initTextureAsync(texture2){this._initialized===!1&&await this.init(),this._textures.updateTexture(texture2)}initTexture(texture2){this._initialized===!1&&console.warn("THREE.Renderer: .initTexture() called before the backend is initialized. Try using .initTextureAsync() instead."),this._textures.updateTexture(texture2)}copyFramebufferToTexture(framebufferTexture,rectangle=null){if(rectangle!==null)if(rectangle.isVector2)rectangle=_vector4.set(rectangle.x,rectangle.y,framebufferTexture.image.width,framebufferTexture.image.height).floor();else if(rectangle.isVector4)rectangle=_vector4.copy(rectangle).floor();else{console.error("THREE.Renderer.copyFramebufferToTexture: Invalid rectangle.");return}else rectangle=_vector4.set(0,0,framebufferTexture.image.width,framebufferTexture.image.height);let renderContext=this._currentRenderContext,renderTarget;renderContext!==null?renderTarget=renderContext.renderTarget:(renderTarget=this._renderTarget||this._getFrameBufferTarget(),renderTarget!==null&&(this._textures.updateRenderTarget(renderTarget),renderContext=this._textures.get(renderTarget))),this._textures.updateTexture(framebufferTexture,{renderTarget}),this.backend.copyFramebufferToTexture(framebufferTexture,renderContext,rectangle)}copyTextureToTexture(srcTexture,dstTexture,srcRegion=null,dstPosition=null,level=0){this._textures.updateTexture(srcTexture),this._textures.updateTexture(dstTexture),this.backend.copyTextureToTexture(srcTexture,dstTexture,srcRegion,dstPosition,level)}async readRenderTargetPixelsAsync(renderTarget,x,y,width,height,textureIndex=0,faceIndex=0){return this.backend.copyTextureToBuffer(renderTarget.textures[textureIndex],x,y,width,height,faceIndex)}_projectObject(object,camera,groupOrder,renderList,clippingContext){if(object.visible===!1)return;if(object.layers.test(camera.layers)){if(object.isGroup)groupOrder=object.renderOrder,object.isClippingGroup&&object.enabled&&(clippingContext=clippingContext.getGroupContext(object));else if(object.isLOD)object.autoUpdate===!0&&object.update(camera);else if(object.isLight)renderList.pushLight(object);else if(object.isSprite){if(!object.frustumCulled||_frustum.intersectsSprite(object)){this.sortObjects===!0&&_vector4.setFromMatrixPosition(object.matrixWorld).applyMatrix4(_projScreenMatrix);const{geometry:geometry2,material}=object;material.visible&&renderList.push(object,geometry2,material,groupOrder,_vector4.z,null,clippingContext)}}else if(object.isLineLoop)console.error("THREE.Renderer: Objects of type THREE.LineLoop are not supported. Please use THREE.Line or THREE.LineSegments.");else if((object.isMesh||object.isLine||object.isPoints)&&(!object.frustumCulled||_frustum.intersectsObject(object))){const{geometry:geometry2,material}=object;if(this.sortObjects===!0&&(geometry2.boundingSphere===null&&geometry2.computeBoundingSphere(),_vector4.copy(geometry2.boundingSphere.center).applyMatrix4(object.matrixWorld).applyMatrix4(_projScreenMatrix)),Array.isArray(material)){const groups=geometry2.groups;for(let i2=0,l2=groups.length;i2<l2;i2++){const group=groups[i2],groupMaterial=material[group.materialIndex];groupMaterial&&groupMaterial.visible&&renderList.push(object,geometry2,groupMaterial,groupOrder,_vector4.z,group,clippingContext)}}else material.visible&&renderList.push(object,geometry2,material,groupOrder,_vector4.z,null,clippingContext)}}if(object.isBundleGroup===!0&&this.backend.beginBundle!==void 0){const baseRenderList=renderList;renderList=this._renderLists.get(object,camera),renderList.begin(),baseRenderList.pushBundle({bundleGroup:object,camera,renderList}),renderList.finish()}const children=object.children;for(let i2=0,l2=children.length;i2<l2;i2++)this._projectObject(children[i2],camera,groupOrder,renderList,clippingContext)}_renderBundles(bundles,sceneRef,lightsNode){for(const bundle of bundles)this._renderBundle(bundle,sceneRef,lightsNode)}_renderTransparents(renderList,doublePassList,camera,scene,lightsNode){if(doublePassList.length>0){for(const{material}of doublePassList)material.side=BackSide;this._renderObjects(doublePassList,camera,scene,lightsNode,"backSide");for(const{material}of doublePassList)material.side=FrontSide;this._renderObjects(renderList,camera,scene,lightsNode);for(const{material}of doublePassList)material.side=DoubleSide}else this._renderObjects(renderList,camera,scene,lightsNode)}_renderObjects(renderList,camera,scene,lightsNode,passId=null){for(let i2=0,il=renderList.length;i2<il;i2++){const{object,geometry:geometry2,material,group,clippingContext}=renderList[i2];this._currentRenderObjectFunction(object,scene,camera,geometry2,material,group,lightsNode,clippingContext,passId)}}renderObject(object,scene,camera,geometry2,material,group,lightsNode,clippingContext=null,passId=null){let overridePositionNode,overrideColorNode,overrideDepthNode;if(object.onBeforeRender(this,scene,camera,geometry2,material,group),scene.overrideMaterial!==null){const overrideMaterial=scene.overrideMaterial;material.positionNode&&material.positionNode.isNode&&(overridePositionNode=overrideMaterial.positionNode,overrideMaterial.positionNode=material.positionNode),overrideMaterial.alphaTest=material.alphaTest,overrideMaterial.alphaMap=material.alphaMap,overrideMaterial.transparent=material.transparent||material.transmission>0,overrideMaterial.isShadowPassMaterial&&(overrideMaterial.side=material.shadowSide===null?material.side:material.shadowSide,material.depthNode&&material.depthNode.isNode&&(overrideDepthNode=overrideMaterial.depthNode,overrideMaterial.depthNode=material.depthNode),material.castShadowNode&&material.castShadowNode.isNode&&(overrideColorNode=overrideMaterial.colorNode,overrideMaterial.colorNode=material.castShadowNode)),material=overrideMaterial}material.transparent===!0&&material.side===DoubleSide&&material.forceSinglePass===!1?(material.side=BackSide,this._handleObjectFunction(object,material,scene,camera,lightsNode,group,clippingContext,"backSide"),material.side=FrontSide,this._handleObjectFunction(object,material,scene,camera,lightsNode,group,clippingContext,passId),material.side=DoubleSide):this._handleObjectFunction(object,material,scene,camera,lightsNode,group,clippingContext,passId),overridePositionNode!==void 0&&(scene.overrideMaterial.positionNode=overridePositionNode),overrideDepthNode!==void 0&&(scene.overrideMaterial.depthNode=overrideDepthNode),overrideColorNode!==void 0&&(scene.overrideMaterial.colorNode=overrideColorNode),object.onAfterRender(this,scene,camera,geometry2,material,group)}_renderObjectDirect(object,material,scene,camera,lightsNode,group,clippingContext,passId){const renderObject=this._objects.get(object,material,scene,camera,lightsNode,this._currentRenderContext,clippingContext,passId);renderObject.drawRange=object.geometry.drawRange,renderObject.group=group;const needsRefresh=this._nodes.needsRefresh(renderObject);needsRefresh&&(this._nodes.updateBefore(renderObject),this._geometries.updateForRender(renderObject),this._nodes.updateForRender(renderObject),this._bindings.updateForRender(renderObject)),this._pipelines.updateForRender(renderObject),this._currentRenderBundle!==null&&(this.backend.get(this._currentRenderBundle).renderObjects.push(renderObject),renderObject.bundle=this._currentRenderBundle.bundleGroup),this.backend.draw(renderObject,this.info),needsRefresh&&this._nodes.updateAfter(renderObject)}_createObjectPipeline(object,material,scene,camera,lightsNode,group,clippingContext,passId){const renderObject=this._objects.get(object,material,scene,camera,lightsNode,this._currentRenderContext,clippingContext,passId);renderObject.drawRange=object.geometry.drawRange,renderObject.group=group,this._nodes.updateBefore(renderObject),this._geometries.updateForRender(renderObject),this._nodes.updateForRender(renderObject),this._bindings.updateForRender(renderObject),this._pipelines.getForRender(renderObject,this._compilationPromises),this._nodes.updateAfter(renderObject)}get compile(){return this.compileAsync}}class Binding{constructor(name=""){this.name=name,this.visibility=0}setVisibility(visibility){this.visibility|=visibility}clone(){return Object.assign(new this.constructor,this)}}function getFloatLength(floatLength){return floatLength+(GPU_CHUNK_BYTES-floatLength%GPU_CHUNK_BYTES)%GPU_CHUNK_BYTES}class Buffer extends Binding{constructor(name,buffer2=null){super(name),this.isBuffer=!0,this.bytesPerElement=Float32Array.BYTES_PER_ELEMENT,this._buffer=buffer2}get byteLength(){return getFloatLength(this._buffer.byteLength)}get buffer(){return this._buffer}update(){return!0}}class UniformBuffer extends Buffer{constructor(name,buffer2=null){super(name,buffer2),this.isUniformBuffer=!0}}let _id$4=0;class NodeUniformBuffer extends UniformBuffer{constructor(nodeUniform,groupNode){super("UniformBuffer_"+_id$4++,nodeUniform?nodeUniform.value:null),this.nodeUniform=nodeUniform,this.groupNode=groupNode}get buffer(){return this.nodeUniform.value}}class UniformsGroup extends UniformBuffer{constructor(name){super(name),this.isUniformsGroup=!0,this._values=null,this.uniforms=[]}addUniform(uniform2){return this.uniforms.push(uniform2),this}removeUniform(uniform2){const index=this.uniforms.indexOf(uniform2);return index!==-1&&this.uniforms.splice(index,1),this}get values(){return this._values===null&&(this._values=Array.from(this.buffer)),this._values}get buffer(){let buffer2=this._buffer;if(buffer2===null){const byteLength=this.byteLength;buffer2=new Float32Array(new ArrayBuffer(byteLength)),this._buffer=buffer2}return buffer2}get byteLength(){let offset=0;for(let i2=0,l2=this.uniforms.length;i2<l2;i2++){const uniform2=this.uniforms[i2],{boundary,itemSize}=uniform2,chunkOffset=offset%GPU_CHUNK_BYTES,remainingSizeInChunk=GPU_CHUNK_BYTES-chunkOffset;chunkOffset!==0&&remainingSizeInChunk-boundary<0?offset+=GPU_CHUNK_BYTES-chunkOffset:chunkOffset%boundary!==0&&(offset+=chunkOffset%boundary),uniform2.offset=offset/this.bytesPerElement,offset+=itemSize*this.bytesPerElement}return Math.ceil(offset/GPU_CHUNK_BYTES)*GPU_CHUNK_BYTES}update(){let updated=!1;for(const uniform2 of this.uniforms)this.updateByType(uniform2)===!0&&(updated=!0);return updated}updateByType(uniform2){if(uniform2.isNumberUniform)return this.updateNumber(uniform2);if(uniform2.isVector2Uniform)return this.updateVector2(uniform2);if(uniform2.isVector3Uniform)return this.updateVector3(uniform2);if(uniform2.isVector4Uniform)return this.updateVector4(uniform2);if(uniform2.isColorUniform)return this.updateColor(uniform2);if(uniform2.isMatrix3Uniform)return this.updateMatrix3(uniform2);if(uniform2.isMatrix4Uniform)return this.updateMatrix4(uniform2);console.error("THREE.WebGPUUniformsGroup: Unsupported uniform type.",uniform2)}updateNumber(uniform2){let updated=!1;const a2=this.values,v=uniform2.getValue(),offset=uniform2.offset,type=uniform2.getType();if(a2[offset]!==v){const b=this._getBufferForType(type);b[offset]=a2[offset]=v,updated=!0}return updated}updateVector2(uniform2){let updated=!1;const a2=this.values,v=uniform2.getValue(),offset=uniform2.offset,type=uniform2.getType();if(a2[offset+0]!==v.x||a2[offset+1]!==v.y){const b=this._getBufferForType(type);b[offset+0]=a2[offset+0]=v.x,b[offset+1]=a2[offset+1]=v.y,updated=!0}return updated}updateVector3(uniform2){let updated=!1;const a2=this.values,v=uniform2.getValue(),offset=uniform2.offset,type=uniform2.getType();if(a2[offset+0]!==v.x||a2[offset+1]!==v.y||a2[offset+2]!==v.z){const b=this._getBufferForType(type);b[offset+0]=a2[offset+0]=v.x,b[offset+1]=a2[offset+1]=v.y,b[offset+2]=a2[offset+2]=v.z,updated=!0}return updated}updateVector4(uniform2){let updated=!1;const a2=this.values,v=uniform2.getValue(),offset=uniform2.offset,type=uniform2.getType();if(a2[offset+0]!==v.x||a2[offset+1]!==v.y||a2[offset+2]!==v.z||a2[offset+4]!==v.w){const b=this._getBufferForType(type);b[offset+0]=a2[offset+0]=v.x,b[offset+1]=a2[offset+1]=v.y,b[offset+2]=a2[offset+2]=v.z,b[offset+3]=a2[offset+3]=v.w,updated=!0}return updated}updateColor(uniform2){let updated=!1;const a2=this.values,c2=uniform2.getValue(),offset=uniform2.offset;if(a2[offset+0]!==c2.r||a2[offset+1]!==c2.g||a2[offset+2]!==c2.b){const b=this.buffer;b[offset+0]=a2[offset+0]=c2.r,b[offset+1]=a2[offset+1]=c2.g,b[offset+2]=a2[offset+2]=c2.b,updated=!0}return updated}updateMatrix3(uniform2){let updated=!1;const a2=this.values,e2=uniform2.getValue().elements,offset=uniform2.offset;if(a2[offset+0]!==e2[0]||a2[offset+1]!==e2[1]||a2[offset+2]!==e2[2]||a2[offset+4]!==e2[3]||a2[offset+5]!==e2[4]||a2[offset+6]!==e2[5]||a2[offset+8]!==e2[6]||a2[offset+9]!==e2[7]||a2[offset+10]!==e2[8]){const b=this.buffer;b[offset+0]=a2[offset+0]=e2[0],b[offset+1]=a2[offset+1]=e2[1],b[offset+2]=a2[offset+2]=e2[2],b[offset+4]=a2[offset+4]=e2[3],b[offset+5]=a2[offset+5]=e2[4],b[offset+6]=a2[offset+6]=e2[5],b[offset+8]=a2[offset+8]=e2[6],b[offset+9]=a2[offset+9]=e2[7],b[offset+10]=a2[offset+10]=e2[8],updated=!0}return updated}updateMatrix4(uniform2){let updated=!1;const a2=this.values,e2=uniform2.getValue().elements,offset=uniform2.offset;return arraysEqual(a2,e2,offset)===!1&&(this.buffer.set(e2,offset),setArray(a2,e2,offset),updated=!0),updated}_getBufferForType(type){return type==="int"||type==="ivec2"||type==="ivec3"||type==="ivec4"?new Int32Array(this.buffer.buffer):type==="uint"||type==="uvec2"||type==="uvec3"||type==="uvec4"?new Uint32Array(this.buffer.buffer):this.buffer}}function setArray(a2,b,offset){for(let i2=0,l2=b.length;i2<l2;i2++)a2[offset+i2]=b[i2]}function arraysEqual(a2,b,offset){for(let i2=0,l2=b.length;i2<l2;i2++)if(a2[offset+i2]!==b[i2])return!1;return!0}let _id$3=0;class NodeUniformsGroup extends UniformsGroup{constructor(name,groupNode){super(name),this.id=_id$3++,this.groupNode=groupNode,this.isNodeUniformsGroup=!0}}let _id$2=0;class SampledTexture extends Binding{constructor(name,texture2){super(name),this.id=_id$2++,this.texture=texture2,this.version=texture2?texture2.version:0,this.store=!1,this.generation=null,this.isSampledTexture=!0}needsBindingsUpdate(generation){const{texture:texture2}=this;return generation!==this.generation?(this.generation=generation,!0):texture2.isVideoTexture}update(){const{texture:texture2,version}=this;return version!==texture2.version?(this.version=texture2.version,!0):!1}}class NodeSampledTexture extends SampledTexture{constructor(name,textureNode,groupNode,access=null){super(name,textureNode?textureNode.value:null),this.textureNode=textureNode,this.groupNode=groupNode,this.access=access}needsBindingsUpdate(generation){return this.textureNode.value!==this.texture||super.needsBindingsUpdate(generation)}update(){const{textureNode}=this;return this.texture!==textureNode.value?(this.texture=textureNode.value,!0):super.update()}}class NodeSampledCubeTexture extends NodeSampledTexture{constructor(name,textureNode,groupNode,access=null){super(name,textureNode,groupNode,access),this.isSampledCubeTexture=!0}}class NodeSampledTexture3D extends NodeSampledTexture{constructor(name,textureNode,groupNode,access=null){super(name,textureNode,groupNode,access),this.isSampledTexture3D=!0}}const glslMethods={textureDimensions:"textureSize",equals:"equal"},precisionLib={low:"lowp",medium:"mediump",high:"highp"},supports$1={swizzleAssign:!0,storageBuffer:!1},defaultPrecisions=`
precision highp float;
precision highp int;
precision highp sampler2D;
precision highp sampler3D;
precision highp samplerCube;
precision highp sampler2DArray;

precision highp usampler2D;
precision highp usampler3D;
precision highp usamplerCube;
precision highp usampler2DArray;

precision highp isampler2D;
precision highp isampler3D;
precision highp isamplerCube;
precision highp isampler2DArray;

precision lowp sampler2DShadow;
`;class GLSLNodeBuilder extends NodeBuilder{constructor(object,renderer){super(object,renderer,new GLSLNodeParser),this.uniformGroups={},this.transforms=[],this.extensions={},this.builtins={vertex:[],fragment:[],compute:[]},this.useComparisonMethod=!0}needsToWorkingColorSpace(texture2){return texture2.isVideoTexture===!0&&texture2.colorSpace!==NoColorSpace}getMethod(method){return glslMethods[method]||method}getOutputStructName(){return""}buildFunctionCode(shaderNode){const layout=shaderNode.layout,flowData=this.flowShaderNode(shaderNode),parameters=[];for(const input of layout.inputs)parameters.push(this.getType(input.type)+" "+input.name);return`${this.getType(layout.type)} ${layout.name}( ${parameters.join(", ")} ) {

	${flowData.vars}

${flowData.code}
	return ${flowData.result};

}`}setupPBO(storageBufferNode){const attribute2=storageBufferNode.value;if(attribute2.pbo===void 0){const originalArray=attribute2.array,numElements=attribute2.count*attribute2.itemSize,{itemSize}=attribute2,isInteger=attribute2.array.constructor.name.toLowerCase().includes("int");let format=isInteger?RedIntegerFormat:RedFormat;itemSize===2?format=isInteger?RGIntegerFormat:RGFormat:itemSize===3?format=isInteger?RGBIntegerFormat:RGBFormat:itemSize===4&&(format=isInteger?RGBAIntegerFormat:RGBAFormat);const typeMap={Float32Array:FloatType,Uint8Array:UnsignedByteType,Uint16Array:UnsignedShortType,Uint32Array:UnsignedIntType,Int8Array:ByteType,Int16Array:ShortType,Int32Array:IntType,Uint8ClampedArray:UnsignedByteType},width=Math.pow(2,Math.ceil(Math.log2(Math.sqrt(numElements/itemSize))));let height=Math.ceil(numElements/itemSize/width);width*height*itemSize<numElements&&height++;const newSize=width*height*itemSize,newArray=new originalArray.constructor(newSize);newArray.set(originalArray,0),attribute2.array=newArray;const pboTexture=new DataTexture(attribute2.array,width,height,format,typeMap[attribute2.array.constructor.name]||FloatType);pboTexture.needsUpdate=!0,pboTexture.isPBOTexture=!0;const pbo=new TextureNode(pboTexture,null,null);pbo.setPrecision("high"),attribute2.pboNode=pbo,attribute2.pbo=pbo.value,this.getUniformFromNode(attribute2.pboNode,"texture",this.shaderStage,this.context.label)}}getPropertyName(node,shaderStage=this.shaderStage){return node.isNodeUniform&&node.node.isTextureNode!==!0&&node.node.isBufferNode!==!0?shaderStage.charAt(0)+"_"+node.name:super.getPropertyName(node,shaderStage)}generatePBO(storageArrayElementNode){const{node,indexNode}=storageArrayElementNode,attribute2=node.value;if(this.renderer.backend.has(attribute2)){const attributeData=this.renderer.backend.get(attribute2);attributeData.pbo=attribute2.pbo}const nodeUniform=this.getUniformFromNode(attribute2.pboNode,"texture",this.shaderStage,this.context.label),textureName=this.getPropertyName(nodeUniform);this.increaseUsage(indexNode);const indexSnippet=indexNode.build(this,"uint"),elementNodeData=this.getDataFromNode(storageArrayElementNode);let propertyName=elementNodeData.propertyName;if(propertyName===void 0){const nodeVar=this.getVarFromNode(storageArrayElementNode);propertyName=this.getPropertyName(nodeVar);const bufferNodeData=this.getDataFromNode(node);let propertySizeName=bufferNodeData.propertySizeName;propertySizeName===void 0&&(propertySizeName=propertyName+"Size",this.getVarFromNode(node,propertySizeName,"uint"),this.addLineFlowCode(`${propertySizeName} = uint( textureSize( ${textureName}, 0 ).x )`,storageArrayElementNode),bufferNodeData.propertySizeName=propertySizeName);const{itemSize}=attribute2,channel="."+vectorComponents.join("").slice(0,itemSize),uvSnippet=`ivec2(${indexSnippet} % ${propertySizeName}, ${indexSnippet} / ${propertySizeName})`,snippet=this.generateTextureLoad(null,textureName,uvSnippet,null,"0");let prefix="vec4";attribute2.pbo.type===UnsignedIntType?prefix="uvec4":attribute2.pbo.type===IntType&&(prefix="ivec4"),this.addLineFlowCode(`${propertyName} = ${prefix}(${snippet})${channel}`,storageArrayElementNode),elementNodeData.propertyName=propertyName}return propertyName}generateTextureLoad(texture2,textureProperty,uvIndexSnippet,depthSnippet,levelSnippet="0"){return depthSnippet?`texelFetch( ${textureProperty}, ivec3( ${uvIndexSnippet}, ${depthSnippet} ), ${levelSnippet} )`:`texelFetch( ${textureProperty}, ${uvIndexSnippet}, ${levelSnippet} )`}generateTexture(texture2,textureProperty,uvSnippet,depthSnippet){return texture2.isDepthTexture?`texture( ${textureProperty}, ${uvSnippet} ).x`:(depthSnippet&&(uvSnippet=`vec3( ${uvSnippet}, ${depthSnippet} )`),`texture( ${textureProperty}, ${uvSnippet} )`)}generateTextureLevel(texture2,textureProperty,uvSnippet,levelSnippet){return`textureLod( ${textureProperty}, ${uvSnippet}, ${levelSnippet} )`}generateTextureBias(texture2,textureProperty,uvSnippet,biasSnippet){return`texture( ${textureProperty}, ${uvSnippet}, ${biasSnippet} )`}generateTextureGrad(texture2,textureProperty,uvSnippet,gradSnippet){return`textureGrad( ${textureProperty}, ${uvSnippet}, ${gradSnippet[0]}, ${gradSnippet[1]} )`}generateTextureCompare(texture2,textureProperty,uvSnippet,compareSnippet,depthSnippet,shaderStage=this.shaderStage){if(shaderStage==="fragment")return`texture( ${textureProperty}, vec3( ${uvSnippet}, ${compareSnippet} ) )`;console.error(`WebGPURenderer: THREE.DepthTexture.compareFunction() does not support ${shaderStage} shader.`)}getVars(shaderStage){const snippets=[],vars=this.vars[shaderStage];if(vars!==void 0)for(const variable of vars)snippets.push(`${this.getVar(variable.type,variable.name,variable.count)};`);return snippets.join(`
	`)}getUniforms(shaderStage){const uniforms2=this.uniforms[shaderStage],bindingSnippets=[],uniformGroups={};for(const uniform2 of uniforms2){let snippet=null,group=!1;if(uniform2.type==="texture"){const texture2=uniform2.node.value;let typePrefix="";texture2.isDataTexture===!0&&(texture2.type===UnsignedIntType?typePrefix="u":texture2.type===IntType&&(typePrefix="i")),texture2.compareFunction?snippet=`sampler2DShadow ${uniform2.name};`:texture2.isDataArrayTexture===!0||texture2.isCompressedArrayTexture===!0?snippet=`${typePrefix}sampler2DArray ${uniform2.name};`:snippet=`${typePrefix}sampler2D ${uniform2.name};`}else if(uniform2.type==="cubeTexture")snippet=`samplerCube ${uniform2.name};`;else if(uniform2.type==="texture3D")snippet=`sampler3D ${uniform2.name};`;else if(uniform2.type==="buffer"){const bufferNode=uniform2.node,bufferType=this.getType(bufferNode.bufferType),bufferCount=bufferNode.bufferCount,bufferCountSnippet=bufferCount>0?bufferCount:"";snippet=`${bufferNode.name} {
	${bufferType} ${uniform2.name}[${bufferCountSnippet}];
};
`}else snippet=`${this.getVectorType(uniform2.type)} ${this.getPropertyName(uniform2,shaderStage)};`,group=!0;const precision=uniform2.node.precision;if(precision!==null&&(snippet=precisionLib[precision]+" "+snippet),group){snippet="	"+snippet;const groupName=uniform2.groupNode.name;(uniformGroups[groupName]||(uniformGroups[groupName]=[])).push(snippet)}else snippet="uniform "+snippet,bindingSnippets.push(snippet)}let output2="";for(const name in uniformGroups){const groupSnippets=uniformGroups[name];output2+=this._getGLSLUniformStruct(shaderStage+"_"+name,groupSnippets.join(`
`))+`
`}return output2+=bindingSnippets.join(`
`),output2}getTypeFromAttribute(attribute2){let nodeType=super.getTypeFromAttribute(attribute2);if(/^[iu]/.test(nodeType)&&attribute2.gpuType!==IntType){let dataAttribute=attribute2;attribute2.isInterleavedBufferAttribute&&(dataAttribute=attribute2.data);const array2=dataAttribute.array;array2 instanceof Uint32Array||array2 instanceof Int32Array||(nodeType=nodeType.slice(1))}return nodeType}getAttributes(shaderStage){let snippet="";if(shaderStage==="vertex"||shaderStage==="compute"){const attributes=this.getAttributesArray();let location=0;for(const attribute2 of attributes)snippet+=`layout( location = ${location++} ) in ${attribute2.type} ${attribute2.name};
`}return snippet}getStructMembers(struct2){const snippets=[];for(const member of struct2.members)snippets.push(`	${member.type} ${member.name};`);return snippets.join(`
`)}getStructs(shaderStage){const snippets=[],structs=this.structs[shaderStage],outputSnippet=[];for(const struct2 of structs)if(struct2.output)for(const member of struct2.members)outputSnippet.push(`layout( location = ${member.index} ) out ${member.type} ${member.name};`);else{let snippet="struct "+struct2.name+` {
`;snippet+=this.getStructMembers(struct2),snippet+=`
};
`,snippets.push(snippet)}return outputSnippet.length===0&&outputSnippet.push("layout( location = 0 ) out vec4 fragColor;"),`
`+outputSnippet.join(`
`)+`

`+snippets.join(`
`)}getVaryings(shaderStage){let snippet="";const varyings=this.varyings;if(shaderStage==="vertex"||shaderStage==="compute")for(const varying2 of varyings){shaderStage==="compute"&&(varying2.needsInterpolation=!0);const type=this.getType(varying2.type);if(varying2.needsInterpolation){const flat=type.includes("int")||type.includes("uv")||type.includes("iv")?"flat ":"";snippet+=`${flat} out ${type} ${varying2.name};
`}else snippet+=`${type} ${varying2.name};
`}else if(shaderStage==="fragment"){for(const varying2 of varyings)if(varying2.needsInterpolation){const type=this.getType(varying2.type),flat=type.includes("int")||type.includes("uv")||type.includes("iv")?"flat ":"";snippet+=`${flat}in ${type} ${varying2.name};
`}}for(const builtin2 of this.builtins[shaderStage])snippet+=`${builtin2};
`;return snippet}getVertexIndex(){return"uint( gl_VertexID )"}getInstanceIndex(){return"uint( gl_InstanceID )"}getInvocationLocalIndex(){return`uint( gl_InstanceID ) % ${this.object.workgroupSize.reduce((acc,curr)=>acc*curr,1)}u`}getDrawIndex(){return this.renderer.backend.extensions.has("WEBGL_multi_draw")?"uint( gl_DrawID )":null}getFrontFacing(){return"gl_FrontFacing"}getFragCoord(){return"gl_FragCoord.xy"}getFragDepth(){return"gl_FragDepth"}enableExtension(name,behavior,shaderStage=this.shaderStage){const map=this.extensions[shaderStage]||(this.extensions[shaderStage]=new Map);map.has(name)===!1&&map.set(name,{name,behavior})}getExtensions(shaderStage){const snippets=[];if(shaderStage==="vertex"){const ext=this.renderer.backend.extensions;this.object.isBatchedMesh&&ext.has("WEBGL_multi_draw")&&this.enableExtension("GL_ANGLE_multi_draw","require",shaderStage)}const extensions=this.extensions[shaderStage];if(extensions!==void 0)for(const{name,behavior}of extensions.values())snippets.push(`#extension ${name} : ${behavior}`);return snippets.join(`
`)}getClipDistance(){return"gl_ClipDistance"}isAvailable(name){let result=supports$1[name];if(result===void 0){let extensionName;switch(result=!1,name){case"float32Filterable":extensionName="OES_texture_float_linear";break;case"clipDistance":extensionName="WEBGL_clip_cull_distance";break}if(extensionName!==void 0){const extensions=this.renderer.backend.extensions;extensions.has(extensionName)&&(extensions.get(extensionName),result=!0)}supports$1[name]=result}return result}isFlipY(){return!0}enableHardwareClipping(planeCount){this.enableExtension("GL_ANGLE_clip_cull_distance","require"),this.builtins.vertex.push(`out float gl_ClipDistance[ ${planeCount} ]`)}registerTransform(varyingName,attributeNode){this.transforms.push({varyingName,attributeNode})}getTransforms(){const transforms2=this.transforms;let snippet="";for(let i2=0;i2<transforms2.length;i2++){const transform2=transforms2[i2],attributeName=this.getPropertyName(transform2.attributeNode);snippet+=`${transform2.varyingName} = ${attributeName};
	`}return snippet}_getGLSLUniformStruct(name,vars){return`
layout( std140 ) uniform ${name} {
${vars}
};`}_getGLSLVertexCode(shaderData){return`#version 300 es

${this.getSignature()}

// extensions 
${shaderData.extensions}

// precision
${defaultPrecisions}

// uniforms
${shaderData.uniforms}

// varyings
${shaderData.varyings}

// attributes
${shaderData.attributes}

// codes
${shaderData.codes}

void main() {

	// vars
	${shaderData.vars}

	// transforms
	${shaderData.transforms}

	// flow
	${shaderData.flow}

	gl_PointSize = 1.0;

}
`}_getGLSLFragmentCode(shaderData){return`#version 300 es

${this.getSignature()}

// precision
${defaultPrecisions}

// uniforms
${shaderData.uniforms}

// varyings
${shaderData.varyings}

// codes
${shaderData.codes}

// structs
${shaderData.structs}

void main() {

	// vars
	${shaderData.vars}

	// flow
	${shaderData.flow}

}
`}buildCode(){const shadersData=this.material!==null?{fragment:{},vertex:{}}:{compute:{}};this.sortBindingGroups();for(const shaderStage in shadersData){let flow=`// code

`;flow+=this.flowCode[shaderStage];const flowNodes=this.flowNodes[shaderStage],mainNode=flowNodes[flowNodes.length-1];for(const node of flowNodes){const flowSlotData=this.getFlowData(node),slotName=node.name;slotName&&(flow.length>0&&(flow+=`
`),flow+=`	// flow -> ${slotName}
	`),flow+=`${flowSlotData.code}
	`,node===mainNode&&shaderStage!=="compute"&&(flow+=`// result
	`,shaderStage==="vertex"?(flow+="gl_Position = ",flow+=`${flowSlotData.result};`):shaderStage==="fragment"&&(node.outputNode.isOutputStructNode||(flow+="fragColor = ",flow+=`${flowSlotData.result};`)))}const stageData=shadersData[shaderStage];stageData.extensions=this.getExtensions(shaderStage),stageData.uniforms=this.getUniforms(shaderStage),stageData.attributes=this.getAttributes(shaderStage),stageData.varyings=this.getVaryings(shaderStage),stageData.vars=this.getVars(shaderStage),stageData.structs=this.getStructs(shaderStage),stageData.codes=this.getCodes(shaderStage),stageData.transforms=this.getTransforms(shaderStage),stageData.flow=flow}this.material!==null?(this.vertexShader=this._getGLSLVertexCode(shadersData.vertex),this.fragmentShader=this._getGLSLFragmentCode(shadersData.fragment)):this.computeShader=this._getGLSLVertexCode(shadersData.compute)}getUniformFromNode(node,type,shaderStage,name=null){const uniformNode=super.getUniformFromNode(node,type,shaderStage,name),nodeData=this.getDataFromNode(node,shaderStage,this.globalCache);let uniformGPU=nodeData.uniformGPU;if(uniformGPU===void 0){const group=node.groupNode,groupName=group.name,bindings=this.getBindGroupArray(groupName,shaderStage);if(type==="texture")uniformGPU=new NodeSampledTexture(uniformNode.name,uniformNode.node,group),bindings.push(uniformGPU);else if(type==="cubeTexture")uniformGPU=new NodeSampledCubeTexture(uniformNode.name,uniformNode.node,group),bindings.push(uniformGPU);else if(type==="texture3D")uniformGPU=new NodeSampledTexture3D(uniformNode.name,uniformNode.node,group),bindings.push(uniformGPU);else if(type==="buffer"){node.name=`NodeBuffer_${node.id}`,uniformNode.name=`buffer${node.id}`;const buffer2=new NodeUniformBuffer(node,group);buffer2.name=node.name,bindings.push(buffer2),uniformGPU=buffer2}else{const uniformsStage=this.uniformGroups[shaderStage]||(this.uniformGroups[shaderStage]={});let uniformsGroup=uniformsStage[groupName];uniformsGroup===void 0&&(uniformsGroup=new NodeUniformsGroup(shaderStage+"_"+groupName,group),uniformsStage[groupName]=uniformsGroup,bindings.push(uniformsGroup)),uniformGPU=this.getNodeUniform(uniformNode,type),uniformsGroup.addUniform(uniformGPU)}nodeData.uniformGPU=uniformGPU}return uniformNode}}let _vector2=null,_color4=null;class Backend{constructor(parameters={}){this.parameters=Object.assign({},parameters),this.data=new WeakMap,this.renderer=null,this.domElement=null,this.timestampQueryPool={render:null,compute:null}}async init(renderer){this.renderer=renderer}get coordinateSystem(){}beginRender(){}finishRender(){}beginCompute(){}finishCompute(){}draw(){}compute(){}createProgram(){}destroyProgram(){}createBindings(){}updateBindings(){}updateBinding(){}createRenderPipeline(){}createComputePipeline(){}needsRenderUpdate(){}getRenderCacheKey(){}createNodeBuilder(){}createSampler(){}destroySampler(){}createDefaultTexture(){}createTexture(){}updateTexture(){}generateMipmaps(){}destroyTexture(){}async copyTextureToBuffer(){}copyTextureToTexture(){}copyFramebufferToTexture(){}createAttribute(){}createIndexAttribute(){}createStorageAttribute(){}updateAttribute(){}destroyAttribute(){}getContext(){}updateSize(){}updateViewport(){}isOccluded(){}async resolveTimestampsAsync(type="render"){if(!this.trackTimestamp){warnOnce("WebGPURenderer: Timestamp tracking is disabled.");return}const queryPool=this.timestampQueryPool[type];if(!queryPool){warnOnce(`WebGPURenderer: No timestamp query pool for type '${type}' found.`);return}const duration=await queryPool.resolveQueriesAsync();return this.renderer.info[type].timestamp=duration,duration}async waitForGPU(){}async getArrayBufferAsync(){}async hasFeatureAsync(){}hasFeature(){}getMaxAnisotropy(){}getDrawingBufferSize(){return _vector2=_vector2||new Vector2,this.renderer.getDrawingBufferSize(_vector2)}setScissorTest(){}getClearColor(){const renderer=this.renderer;return _color4=_color4||new Color4,renderer.getClearColor(_color4),_color4.getRGB(_color4),_color4}getDomElement(){let domElement=this.domElement;return domElement===null&&(domElement=this.parameters.canvas!==void 0?this.parameters.canvas:createCanvasElement(),"setAttribute"in domElement&&domElement.setAttribute("data-engine",`three.js r${REVISION} webgpu`),this.domElement=domElement),domElement}set(object,value){this.data.set(object,value)}get(object){let map=this.data.get(object);return map===void 0&&(map={},this.data.set(object,map)),map}has(object){return this.data.has(object)}delete(object){this.data.delete(object)}dispose(){}}let _id$1=0;class DualAttributeData{constructor(attributeData,dualBuffer){this.buffers=[attributeData.bufferGPU,dualBuffer],this.type=attributeData.type,this.bufferType=attributeData.bufferType,this.pbo=attributeData.pbo,this.byteLength=attributeData.byteLength,this.bytesPerElement=attributeData.BYTES_PER_ELEMENT,this.version=attributeData.version,this.isInteger=attributeData.isInteger,this.activeBufferIndex=0,this.baseId=attributeData.id}get id(){return`${this.baseId}|${this.activeBufferIndex}`}get bufferGPU(){return this.buffers[this.activeBufferIndex]}get transformBuffer(){return this.buffers[this.activeBufferIndex^1]}switchBuffers(){this.activeBufferIndex^=1}}class WebGLAttributeUtils{constructor(backend){this.backend=backend}createAttribute(attribute2,bufferType){const backend=this.backend,{gl}=backend,array2=attribute2.array,usage=attribute2.usage||gl.STATIC_DRAW,bufferAttribute2=attribute2.isInterleavedBufferAttribute?attribute2.data:attribute2,bufferData=backend.get(bufferAttribute2);let bufferGPU=bufferData.bufferGPU;bufferGPU===void 0&&(bufferGPU=this._createBuffer(gl,bufferType,array2,usage),bufferData.bufferGPU=bufferGPU,bufferData.bufferType=bufferType,bufferData.version=bufferAttribute2.version);let type;if(array2 instanceof Float32Array)type=gl.FLOAT;else if(array2 instanceof Uint16Array)attribute2.isFloat16BufferAttribute?type=gl.HALF_FLOAT:type=gl.UNSIGNED_SHORT;else if(array2 instanceof Int16Array)type=gl.SHORT;else if(array2 instanceof Uint32Array)type=gl.UNSIGNED_INT;else if(array2 instanceof Int32Array)type=gl.INT;else if(array2 instanceof Int8Array)type=gl.BYTE;else if(array2 instanceof Uint8Array)type=gl.UNSIGNED_BYTE;else if(array2 instanceof Uint8ClampedArray)type=gl.UNSIGNED_BYTE;else throw new Error("THREE.WebGLBackend: Unsupported buffer data format: "+array2);let attributeData={bufferGPU,bufferType,type,byteLength:array2.byteLength,bytesPerElement:array2.BYTES_PER_ELEMENT,version:attribute2.version,pbo:attribute2.pbo,isInteger:type===gl.INT||type===gl.UNSIGNED_INT||attribute2.gpuType===IntType,id:_id$1++};if(attribute2.isStorageBufferAttribute||attribute2.isStorageInstancedBufferAttribute){const bufferGPUDual=this._createBuffer(gl,bufferType,array2,usage);attributeData=new DualAttributeData(attributeData,bufferGPUDual)}backend.set(attribute2,attributeData)}updateAttribute(attribute2){const backend=this.backend,{gl}=backend,array2=attribute2.array,bufferAttribute2=attribute2.isInterleavedBufferAttribute?attribute2.data:attribute2,bufferData=backend.get(bufferAttribute2),bufferType=bufferData.bufferType,updateRanges=attribute2.isInterleavedBufferAttribute?attribute2.data.updateRanges:attribute2.updateRanges;if(gl.bindBuffer(bufferType,bufferData.bufferGPU),updateRanges.length===0)gl.bufferSubData(bufferType,0,array2);else{for(let i2=0,l2=updateRanges.length;i2<l2;i2++){const range2=updateRanges[i2];gl.bufferSubData(bufferType,range2.start*array2.BYTES_PER_ELEMENT,array2,range2.start,range2.count)}bufferAttribute2.clearUpdateRanges()}gl.bindBuffer(bufferType,null),bufferData.version=bufferAttribute2.version}destroyAttribute(attribute2){const backend=this.backend,{gl}=backend;attribute2.isInterleavedBufferAttribute&&backend.delete(attribute2.data);const attributeData=backend.get(attribute2);gl.deleteBuffer(attributeData.bufferGPU),backend.delete(attribute2)}async getArrayBufferAsync(attribute2){const backend=this.backend,{gl}=backend,bufferAttribute2=attribute2.isInterleavedBufferAttribute?attribute2.data:attribute2,{bufferGPU}=backend.get(bufferAttribute2),array2=attribute2.array,byteLength=array2.byteLength;gl.bindBuffer(gl.COPY_READ_BUFFER,bufferGPU);const writeBuffer=gl.createBuffer();gl.bindBuffer(gl.COPY_WRITE_BUFFER,writeBuffer),gl.bufferData(gl.COPY_WRITE_BUFFER,byteLength,gl.STREAM_READ),gl.copyBufferSubData(gl.COPY_READ_BUFFER,gl.COPY_WRITE_BUFFER,0,0,byteLength),await backend.utils._clientWaitAsync();const dstBuffer=new attribute2.array.constructor(array2.length);return gl.bindBuffer(gl.COPY_WRITE_BUFFER,writeBuffer),gl.getBufferSubData(gl.COPY_WRITE_BUFFER,0,dstBuffer),gl.deleteBuffer(writeBuffer),gl.bindBuffer(gl.COPY_READ_BUFFER,null),gl.bindBuffer(gl.COPY_WRITE_BUFFER,null),dstBuffer.buffer}_createBuffer(gl,bufferType,array2,usage){const bufferGPU=gl.createBuffer();return gl.bindBuffer(bufferType,bufferGPU),gl.bufferData(bufferType,array2,usage),gl.bindBuffer(bufferType,null),bufferGPU}}let equationToGL,factorToGL;class WebGLState{constructor(backend){this.backend=backend,this.gl=this.backend.gl,this.enabled={},this.currentFlipSided=null,this.currentCullFace=null,this.currentProgram=null,this.currentBlendingEnabled=!1,this.currentBlending=null,this.currentBlendSrc=null,this.currentBlendDst=null,this.currentBlendSrcAlpha=null,this.currentBlendDstAlpha=null,this.currentPremultipledAlpha=null,this.currentPolygonOffsetFactor=null,this.currentPolygonOffsetUnits=null,this.currentColorMask=null,this.currentDepthFunc=null,this.currentDepthMask=null,this.currentStencilFunc=null,this.currentStencilRef=null,this.currentStencilFuncMask=null,this.currentStencilFail=null,this.currentStencilZFail=null,this.currentStencilZPass=null,this.currentStencilMask=null,this.currentLineWidth=null,this.currentClippingPlanes=0,this.currentBoundFramebuffers={},this.currentDrawbuffers=new WeakMap,this.maxTextures=this.gl.getParameter(this.gl.MAX_TEXTURE_IMAGE_UNITS),this.currentTextureSlot=null,this.currentBoundTextures={},this.currentBoundBufferBases={},this._init()}_init(){const gl=this.gl;equationToGL={[AddEquation]:gl.FUNC_ADD,[SubtractEquation]:gl.FUNC_SUBTRACT,[ReverseSubtractEquation]:gl.FUNC_REVERSE_SUBTRACT},factorToGL={[ZeroFactor]:gl.ZERO,[OneFactor]:gl.ONE,[SrcColorFactor]:gl.SRC_COLOR,[SrcAlphaFactor]:gl.SRC_ALPHA,[SrcAlphaSaturateFactor]:gl.SRC_ALPHA_SATURATE,[DstColorFactor]:gl.DST_COLOR,[DstAlphaFactor]:gl.DST_ALPHA,[OneMinusSrcColorFactor]:gl.ONE_MINUS_SRC_COLOR,[OneMinusSrcAlphaFactor]:gl.ONE_MINUS_SRC_ALPHA,[OneMinusDstColorFactor]:gl.ONE_MINUS_DST_COLOR,[OneMinusDstAlphaFactor]:gl.ONE_MINUS_DST_ALPHA};const scissorParam=gl.getParameter(gl.SCISSOR_BOX),viewportParam=gl.getParameter(gl.VIEWPORT);this.currentScissor=new Vector4().fromArray(scissorParam),this.currentViewport=new Vector4().fromArray(viewportParam),this._tempVec4=new Vector4}enable(id){const{enabled}=this;enabled[id]!==!0&&(this.gl.enable(id),enabled[id]=!0)}disable(id){const{enabled}=this;enabled[id]!==!1&&(this.gl.disable(id),enabled[id]=!1)}setFlipSided(flipSided){if(this.currentFlipSided!==flipSided){const{gl}=this;flipSided?gl.frontFace(gl.CW):gl.frontFace(gl.CCW),this.currentFlipSided=flipSided}}setCullFace(cullFace){const{gl}=this;cullFace!==CullFaceNone?(this.enable(gl.CULL_FACE),cullFace!==this.currentCullFace&&(cullFace===CullFaceBack?gl.cullFace(gl.BACK):cullFace===CullFaceFront?gl.cullFace(gl.FRONT):gl.cullFace(gl.FRONT_AND_BACK))):this.disable(gl.CULL_FACE),this.currentCullFace=cullFace}setLineWidth(width){const{currentLineWidth,gl}=this;width!==currentLineWidth&&(gl.lineWidth(width),this.currentLineWidth=width)}setBlending(blending,blendEquation,blendSrc,blendDst,blendEquationAlpha,blendSrcAlpha,blendDstAlpha,premultipliedAlpha){const{gl}=this;if(blending===NoBlending){this.currentBlendingEnabled===!0&&(this.disable(gl.BLEND),this.currentBlendingEnabled=!1);return}if(this.currentBlendingEnabled===!1&&(this.enable(gl.BLEND),this.currentBlendingEnabled=!0),blending!==CustomBlending){if(blending!==this.currentBlending||premultipliedAlpha!==this.currentPremultipledAlpha){if((this.currentBlendEquation!==AddEquation||this.currentBlendEquationAlpha!==AddEquation)&&(gl.blendEquation(gl.FUNC_ADD),this.currentBlendEquation=AddEquation,this.currentBlendEquationAlpha=AddEquation),premultipliedAlpha)switch(blending){case NormalBlending:gl.blendFuncSeparate(gl.ONE,gl.ONE_MINUS_SRC_ALPHA,gl.ONE,gl.ONE_MINUS_SRC_ALPHA);break;case AdditiveBlending:gl.blendFunc(gl.ONE,gl.ONE);break;case SubtractiveBlending:gl.blendFuncSeparate(gl.ZERO,gl.ONE_MINUS_SRC_COLOR,gl.ZERO,gl.ONE);break;case MultiplyBlending:gl.blendFuncSeparate(gl.ZERO,gl.SRC_COLOR,gl.ZERO,gl.SRC_ALPHA);break;default:console.error("THREE.WebGLState: Invalid blending: ",blending);break}else switch(blending){case NormalBlending:gl.blendFuncSeparate(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA,gl.ONE,gl.ONE_MINUS_SRC_ALPHA);break;case AdditiveBlending:gl.blendFunc(gl.SRC_ALPHA,gl.ONE);break;case SubtractiveBlending:gl.blendFuncSeparate(gl.ZERO,gl.ONE_MINUS_SRC_COLOR,gl.ZERO,gl.ONE);break;case MultiplyBlending:gl.blendFunc(gl.ZERO,gl.SRC_COLOR);break;default:console.error("THREE.WebGLState: Invalid blending: ",blending);break}this.currentBlendSrc=null,this.currentBlendDst=null,this.currentBlendSrcAlpha=null,this.currentBlendDstAlpha=null,this.currentBlending=blending,this.currentPremultipledAlpha=premultipliedAlpha}return}blendEquationAlpha=blendEquationAlpha||blendEquation,blendSrcAlpha=blendSrcAlpha||blendSrc,blendDstAlpha=blendDstAlpha||blendDst,(blendEquation!==this.currentBlendEquation||blendEquationAlpha!==this.currentBlendEquationAlpha)&&(gl.blendEquationSeparate(equationToGL[blendEquation],equationToGL[blendEquationAlpha]),this.currentBlendEquation=blendEquation,this.currentBlendEquationAlpha=blendEquationAlpha),(blendSrc!==this.currentBlendSrc||blendDst!==this.currentBlendDst||blendSrcAlpha!==this.currentBlendSrcAlpha||blendDstAlpha!==this.currentBlendDstAlpha)&&(gl.blendFuncSeparate(factorToGL[blendSrc],factorToGL[blendDst],factorToGL[blendSrcAlpha],factorToGL[blendDstAlpha]),this.currentBlendSrc=blendSrc,this.currentBlendDst=blendDst,this.currentBlendSrcAlpha=blendSrcAlpha,this.currentBlendDstAlpha=blendDstAlpha),this.currentBlending=blending,this.currentPremultipledAlpha=!1}setColorMask(colorMask){this.currentColorMask!==colorMask&&(this.gl.colorMask(colorMask,colorMask,colorMask,colorMask),this.currentColorMask=colorMask)}setDepthTest(depthTest){const{gl}=this;depthTest?this.enable(gl.DEPTH_TEST):this.disable(gl.DEPTH_TEST)}setDepthMask(depthMask){this.currentDepthMask!==depthMask&&(this.gl.depthMask(depthMask),this.currentDepthMask=depthMask)}setDepthFunc(depthFunc){if(this.currentDepthFunc!==depthFunc){const{gl}=this;switch(depthFunc){case NeverDepth:gl.depthFunc(gl.NEVER);break;case AlwaysDepth:gl.depthFunc(gl.ALWAYS);break;case LessDepth:gl.depthFunc(gl.LESS);break;case LessEqualDepth:gl.depthFunc(gl.LEQUAL);break;case EqualDepth:gl.depthFunc(gl.EQUAL);break;case GreaterEqualDepth:gl.depthFunc(gl.GEQUAL);break;case GreaterDepth:gl.depthFunc(gl.GREATER);break;case NotEqualDepth:gl.depthFunc(gl.NOTEQUAL);break;default:gl.depthFunc(gl.LEQUAL)}this.currentDepthFunc=depthFunc}}scissor(x,y,width,height){const scissor=this._tempVec4.set(x,y,width,height);if(this.currentScissor.equals(scissor)===!1){const{gl}=this;gl.scissor(scissor.x,scissor.y,scissor.z,scissor.w),this.currentScissor.copy(scissor)}}viewport(x,y,width,height){const viewport2=this._tempVec4.set(x,y,width,height);if(this.currentViewport.equals(viewport2)===!1){const{gl}=this;gl.viewport(viewport2.x,viewport2.y,viewport2.z,viewport2.w),this.currentViewport.copy(viewport2)}}setScissorTest(boolean){const gl=this.gl;boolean?gl.enable(gl.SCISSOR_TEST):gl.disable(gl.SCISSOR_TEST)}setStencilTest(stencilTest){const{gl}=this;stencilTest?this.enable(gl.STENCIL_TEST):this.disable(gl.STENCIL_TEST)}setStencilMask(stencilMask){this.currentStencilMask!==stencilMask&&(this.gl.stencilMask(stencilMask),this.currentStencilMask=stencilMask)}setStencilFunc(stencilFunc,stencilRef,stencilMask){(this.currentStencilFunc!==stencilFunc||this.currentStencilRef!==stencilRef||this.currentStencilFuncMask!==stencilMask)&&(this.gl.stencilFunc(stencilFunc,stencilRef,stencilMask),this.currentStencilFunc=stencilFunc,this.currentStencilRef=stencilRef,this.currentStencilFuncMask=stencilMask)}setStencilOp(stencilFail,stencilZFail,stencilZPass){(this.currentStencilFail!==stencilFail||this.currentStencilZFail!==stencilZFail||this.currentStencilZPass!==stencilZPass)&&(this.gl.stencilOp(stencilFail,stencilZFail,stencilZPass),this.currentStencilFail=stencilFail,this.currentStencilZFail=stencilZFail,this.currentStencilZPass=stencilZPass)}setMaterial(material,frontFaceCW,hardwareClippingPlanes){const{gl}=this;material.side===DoubleSide?this.disable(gl.CULL_FACE):this.enable(gl.CULL_FACE);let flipSided=material.side===BackSide;frontFaceCW&&(flipSided=!flipSided),this.setFlipSided(flipSided),material.blending===NormalBlending&&material.transparent===!1?this.setBlending(NoBlending):this.setBlending(material.blending,material.blendEquation,material.blendSrc,material.blendDst,material.blendEquationAlpha,material.blendSrcAlpha,material.blendDstAlpha,material.premultipliedAlpha),this.setDepthFunc(material.depthFunc),this.setDepthTest(material.depthTest),this.setDepthMask(material.depthWrite),this.setColorMask(material.colorWrite);const stencilWrite=material.stencilWrite;if(this.setStencilTest(stencilWrite),stencilWrite&&(this.setStencilMask(material.stencilWriteMask),this.setStencilFunc(material.stencilFunc,material.stencilRef,material.stencilFuncMask),this.setStencilOp(material.stencilFail,material.stencilZFail,material.stencilZPass)),this.setPolygonOffset(material.polygonOffset,material.polygonOffsetFactor,material.polygonOffsetUnits),material.alphaToCoverage===!0&&this.backend.renderer.samples>1?this.enable(gl.SAMPLE_ALPHA_TO_COVERAGE):this.disable(gl.SAMPLE_ALPHA_TO_COVERAGE),hardwareClippingPlanes>0&&this.currentClippingPlanes!==hardwareClippingPlanes)for(let i2=0;i2<8;i2++)i2<hardwareClippingPlanes?this.enable(12288+i2):this.disable(12288+i2)}setPolygonOffset(polygonOffset,factor,units){const{gl}=this;polygonOffset?(this.enable(gl.POLYGON_OFFSET_FILL),(this.currentPolygonOffsetFactor!==factor||this.currentPolygonOffsetUnits!==units)&&(gl.polygonOffset(factor,units),this.currentPolygonOffsetFactor=factor,this.currentPolygonOffsetUnits=units)):this.disable(gl.POLYGON_OFFSET_FILL)}useProgram(program){return this.currentProgram!==program?(this.gl.useProgram(program),this.currentProgram=program,!0):!1}bindFramebuffer(target,framebuffer){const{gl,currentBoundFramebuffers}=this;return currentBoundFramebuffers[target]!==framebuffer?(gl.bindFramebuffer(target,framebuffer),currentBoundFramebuffers[target]=framebuffer,target===gl.DRAW_FRAMEBUFFER&&(currentBoundFramebuffers[gl.FRAMEBUFFER]=framebuffer),target===gl.FRAMEBUFFER&&(currentBoundFramebuffers[gl.DRAW_FRAMEBUFFER]=framebuffer),!0):!1}drawBuffers(renderContext,framebuffer){const{gl}=this;let drawBuffers=[],needsUpdate=!1;if(renderContext.textures!==null){drawBuffers=this.currentDrawbuffers.get(framebuffer),drawBuffers===void 0&&(drawBuffers=[],this.currentDrawbuffers.set(framebuffer,drawBuffers));const textures=renderContext.textures;if(drawBuffers.length!==textures.length||drawBuffers[0]!==gl.COLOR_ATTACHMENT0){for(let i2=0,il=textures.length;i2<il;i2++)drawBuffers[i2]=gl.COLOR_ATTACHMENT0+i2;drawBuffers.length=textures.length,needsUpdate=!0}}else drawBuffers[0]!==gl.BACK&&(drawBuffers[0]=gl.BACK,needsUpdate=!0);needsUpdate&&gl.drawBuffers(drawBuffers)}activeTexture(webglSlot){const{gl,currentTextureSlot,maxTextures}=this;webglSlot===void 0&&(webglSlot=gl.TEXTURE0+maxTextures-1),currentTextureSlot!==webglSlot&&(gl.activeTexture(webglSlot),this.currentTextureSlot=webglSlot)}bindTexture(webglType,webglTexture,webglSlot){const{gl,currentTextureSlot,currentBoundTextures,maxTextures}=this;webglSlot===void 0&&(currentTextureSlot===null?webglSlot=gl.TEXTURE0+maxTextures-1:webglSlot=currentTextureSlot);let boundTexture=currentBoundTextures[webglSlot];boundTexture===void 0&&(boundTexture={type:void 0,texture:void 0},currentBoundTextures[webglSlot]=boundTexture),(boundTexture.type!==webglType||boundTexture.texture!==webglTexture)&&(currentTextureSlot!==webglSlot&&(gl.activeTexture(webglSlot),this.currentTextureSlot=webglSlot),gl.bindTexture(webglType,webglTexture),boundTexture.type=webglType,boundTexture.texture=webglTexture)}bindBufferBase(target,index,buffer2){const{gl}=this,key2=`${target}-${index}`;return this.currentBoundBufferBases[key2]!==buffer2?(gl.bindBufferBase(target,index,buffer2),this.currentBoundBufferBases[key2]=buffer2,!0):!1}unbindTexture(){const{gl,currentTextureSlot,currentBoundTextures}=this,boundTexture=currentBoundTextures[currentTextureSlot];boundTexture!==void 0&&boundTexture.type!==void 0&&(gl.bindTexture(boundTexture.type,null),boundTexture.type=void 0,boundTexture.texture=void 0)}}class WebGLUtils{constructor(backend){this.backend=backend,this.gl=this.backend.gl,this.extensions=backend.extensions}convert(p,colorSpace=NoColorSpace){const{gl,extensions}=this;let extension;if(p===UnsignedByteType)return gl.UNSIGNED_BYTE;if(p===UnsignedShort4444Type)return gl.UNSIGNED_SHORT_4_4_4_4;if(p===UnsignedShort5551Type)return gl.UNSIGNED_SHORT_5_5_5_1;if(p===UnsignedInt5999Type)return gl.UNSIGNED_INT_5_9_9_9_REV;if(p===ByteType)return gl.BYTE;if(p===ShortType)return gl.SHORT;if(p===UnsignedShortType)return gl.UNSIGNED_SHORT;if(p===IntType)return gl.INT;if(p===UnsignedIntType)return gl.UNSIGNED_INT;if(p===FloatType)return gl.FLOAT;if(p===HalfFloatType)return gl.HALF_FLOAT;if(p===AlphaFormat)return gl.ALPHA;if(p===RGBFormat)return gl.RGB;if(p===RGBAFormat)return gl.RGBA;if(p===LuminanceFormat)return gl.LUMINANCE;if(p===LuminanceAlphaFormat)return gl.LUMINANCE_ALPHA;if(p===DepthFormat)return gl.DEPTH_COMPONENT;if(p===DepthStencilFormat)return gl.DEPTH_STENCIL;if(p===RedFormat)return gl.RED;if(p===RedIntegerFormat)return gl.RED_INTEGER;if(p===RGFormat)return gl.RG;if(p===RGIntegerFormat)return gl.RG_INTEGER;if(p===RGBAIntegerFormat)return gl.RGBA_INTEGER;if(p===RGB_S3TC_DXT1_Format||p===RGBA_S3TC_DXT1_Format||p===RGBA_S3TC_DXT3_Format||p===RGBA_S3TC_DXT5_Format)if(colorSpace===SRGBColorSpace)if(extension=extensions.get("WEBGL_compressed_texture_s3tc_srgb"),extension!==null){if(p===RGB_S3TC_DXT1_Format)return extension.COMPRESSED_SRGB_S3TC_DXT1_EXT;if(p===RGBA_S3TC_DXT1_Format)return extension.COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT;if(p===RGBA_S3TC_DXT3_Format)return extension.COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT;if(p===RGBA_S3TC_DXT5_Format)return extension.COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT}else return null;else if(extension=extensions.get("WEBGL_compressed_texture_s3tc"),extension!==null){if(p===RGB_S3TC_DXT1_Format)return extension.COMPRESSED_RGB_S3TC_DXT1_EXT;if(p===RGBA_S3TC_DXT1_Format)return extension.COMPRESSED_RGBA_S3TC_DXT1_EXT;if(p===RGBA_S3TC_DXT3_Format)return extension.COMPRESSED_RGBA_S3TC_DXT3_EXT;if(p===RGBA_S3TC_DXT5_Format)return extension.COMPRESSED_RGBA_S3TC_DXT5_EXT}else return null;if(p===RGB_PVRTC_4BPPV1_Format||p===RGB_PVRTC_2BPPV1_Format||p===RGBA_PVRTC_4BPPV1_Format||p===RGBA_PVRTC_2BPPV1_Format)if(extension=extensions.get("WEBGL_compressed_texture_pvrtc"),extension!==null){if(p===RGB_PVRTC_4BPPV1_Format)return extension.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;if(p===RGB_PVRTC_2BPPV1_Format)return extension.COMPRESSED_RGB_PVRTC_2BPPV1_IMG;if(p===RGBA_PVRTC_4BPPV1_Format)return extension.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG;if(p===RGBA_PVRTC_2BPPV1_Format)return extension.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG}else return null;if(p===RGB_ETC1_Format||p===RGB_ETC2_Format||p===RGBA_ETC2_EAC_Format)if(extension=extensions.get("WEBGL_compressed_texture_etc"),extension!==null){if(p===RGB_ETC1_Format||p===RGB_ETC2_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ETC2:extension.COMPRESSED_RGB8_ETC2;if(p===RGBA_ETC2_EAC_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:extension.COMPRESSED_RGBA8_ETC2_EAC}else return null;if(p===RGBA_ASTC_4x4_Format||p===RGBA_ASTC_5x4_Format||p===RGBA_ASTC_5x5_Format||p===RGBA_ASTC_6x5_Format||p===RGBA_ASTC_6x6_Format||p===RGBA_ASTC_8x5_Format||p===RGBA_ASTC_8x6_Format||p===RGBA_ASTC_8x8_Format||p===RGBA_ASTC_10x5_Format||p===RGBA_ASTC_10x6_Format||p===RGBA_ASTC_10x8_Format||p===RGBA_ASTC_10x10_Format||p===RGBA_ASTC_12x10_Format||p===RGBA_ASTC_12x12_Format)if(extension=extensions.get("WEBGL_compressed_texture_astc"),extension!==null){if(p===RGBA_ASTC_4x4_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR:extension.COMPRESSED_RGBA_ASTC_4x4_KHR;if(p===RGBA_ASTC_5x4_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR:extension.COMPRESSED_RGBA_ASTC_5x4_KHR;if(p===RGBA_ASTC_5x5_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR:extension.COMPRESSED_RGBA_ASTC_5x5_KHR;if(p===RGBA_ASTC_6x5_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR:extension.COMPRESSED_RGBA_ASTC_6x5_KHR;if(p===RGBA_ASTC_6x6_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR:extension.COMPRESSED_RGBA_ASTC_6x6_KHR;if(p===RGBA_ASTC_8x5_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR:extension.COMPRESSED_RGBA_ASTC_8x5_KHR;if(p===RGBA_ASTC_8x6_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR:extension.COMPRESSED_RGBA_ASTC_8x6_KHR;if(p===RGBA_ASTC_8x8_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR:extension.COMPRESSED_RGBA_ASTC_8x8_KHR;if(p===RGBA_ASTC_10x5_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR:extension.COMPRESSED_RGBA_ASTC_10x5_KHR;if(p===RGBA_ASTC_10x6_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR:extension.COMPRESSED_RGBA_ASTC_10x6_KHR;if(p===RGBA_ASTC_10x8_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR:extension.COMPRESSED_RGBA_ASTC_10x8_KHR;if(p===RGBA_ASTC_10x10_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR:extension.COMPRESSED_RGBA_ASTC_10x10_KHR;if(p===RGBA_ASTC_12x10_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR:extension.COMPRESSED_RGBA_ASTC_12x10_KHR;if(p===RGBA_ASTC_12x12_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR:extension.COMPRESSED_RGBA_ASTC_12x12_KHR}else return null;if(p===RGBA_BPTC_Format)if(extension=extensions.get("EXT_texture_compression_bptc"),extension!==null){if(p===RGBA_BPTC_Format)return colorSpace===SRGBColorSpace?extension.COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT:extension.COMPRESSED_RGBA_BPTC_UNORM_EXT}else return null;if(p===RED_RGTC1_Format||p===SIGNED_RED_RGTC1_Format||p===RED_GREEN_RGTC2_Format||p===SIGNED_RED_GREEN_RGTC2_Format)if(extension=extensions.get("EXT_texture_compression_rgtc"),extension!==null){if(p===RGBA_BPTC_Format)return extension.COMPRESSED_RED_RGTC1_EXT;if(p===SIGNED_RED_RGTC1_Format)return extension.COMPRESSED_SIGNED_RED_RGTC1_EXT;if(p===RED_GREEN_RGTC2_Format)return extension.COMPRESSED_RED_GREEN_RGTC2_EXT;if(p===SIGNED_RED_GREEN_RGTC2_Format)return extension.COMPRESSED_SIGNED_RED_GREEN_RGTC2_EXT}else return null;return p===UnsignedInt248Type?gl.UNSIGNED_INT_24_8:gl[p]!==void 0?gl[p]:null}_clientWaitAsync(){const{gl}=this,sync2=gl.fenceSync(gl.SYNC_GPU_COMMANDS_COMPLETE,0);return gl.flush(),new Promise((resolve,reject)=>{function test(){const res=gl.clientWaitSync(sync2,gl.SYNC_FLUSH_COMMANDS_BIT,0);if(res===gl.WAIT_FAILED){gl.deleteSync(sync2),reject();return}if(res===gl.TIMEOUT_EXPIRED){requestAnimationFrame(test);return}gl.deleteSync(sync2),resolve()}test()})}}let initialized=!1,wrappingToGL,filterToGL,compareToGL;class WebGLTextureUtils{constructor(backend){this.backend=backend,this.gl=backend.gl,this.extensions=backend.extensions,this.defaultTextures={},initialized===!1&&(this._init(),initialized=!0)}_init(){const gl=this.gl;wrappingToGL={[RepeatWrapping]:gl.REPEAT,[ClampToEdgeWrapping]:gl.CLAMP_TO_EDGE,[MirroredRepeatWrapping]:gl.MIRRORED_REPEAT},filterToGL={[NearestFilter]:gl.NEAREST,[NearestMipmapNearestFilter]:gl.NEAREST_MIPMAP_NEAREST,[NearestMipmapLinearFilter]:gl.NEAREST_MIPMAP_LINEAR,[LinearFilter]:gl.LINEAR,[LinearMipmapNearestFilter]:gl.LINEAR_MIPMAP_NEAREST,[LinearMipmapLinearFilter]:gl.LINEAR_MIPMAP_LINEAR},compareToGL={[NeverCompare]:gl.NEVER,[AlwaysCompare]:gl.ALWAYS,[LessCompare]:gl.LESS,[LessEqualCompare]:gl.LEQUAL,[EqualCompare]:gl.EQUAL,[GreaterEqualCompare]:gl.GEQUAL,[GreaterCompare]:gl.GREATER,[NotEqualCompare]:gl.NOTEQUAL}}getGLTextureType(texture2){const{gl}=this;let glTextureType;return texture2.isCubeTexture===!0?glTextureType=gl.TEXTURE_CUBE_MAP:texture2.isDataArrayTexture===!0||texture2.isCompressedArrayTexture===!0?glTextureType=gl.TEXTURE_2D_ARRAY:texture2.isData3DTexture===!0?glTextureType=gl.TEXTURE_3D:glTextureType=gl.TEXTURE_2D,glTextureType}getInternalFormat(internalFormatName,glFormat,glType,colorSpace,forceLinearTransfer=!1){const{gl,extensions}=this;if(internalFormatName!==null){if(gl[internalFormatName]!==void 0)return gl[internalFormatName];console.warn("THREE.WebGLRenderer: Attempt to use non-existing WebGL internal format '"+internalFormatName+"'")}let internalFormat=glFormat;return glFormat===gl.RED&&(glType===gl.FLOAT&&(internalFormat=gl.R32F),glType===gl.HALF_FLOAT&&(internalFormat=gl.R16F),glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.R8),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.R16),glType===gl.UNSIGNED_INT&&(internalFormat=gl.R32UI),glType===gl.BYTE&&(internalFormat=gl.R8I),glType===gl.SHORT&&(internalFormat=gl.R16I),glType===gl.INT&&(internalFormat=gl.R32I)),glFormat===gl.RED_INTEGER&&(glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.R8UI),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.R16UI),glType===gl.UNSIGNED_INT&&(internalFormat=gl.R32UI),glType===gl.BYTE&&(internalFormat=gl.R8I),glType===gl.SHORT&&(internalFormat=gl.R16I),glType===gl.INT&&(internalFormat=gl.R32I)),glFormat===gl.RG&&(glType===gl.FLOAT&&(internalFormat=gl.RG32F),glType===gl.HALF_FLOAT&&(internalFormat=gl.RG16F),glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RG8),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RG16),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RG32UI),glType===gl.BYTE&&(internalFormat=gl.RG8I),glType===gl.SHORT&&(internalFormat=gl.RG16I),glType===gl.INT&&(internalFormat=gl.RG32I)),glFormat===gl.RG_INTEGER&&(glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RG8UI),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RG16UI),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RG32UI),glType===gl.BYTE&&(internalFormat=gl.RG8I),glType===gl.SHORT&&(internalFormat=gl.RG16I),glType===gl.INT&&(internalFormat=gl.RG32I)),glFormat===gl.RGB&&(glType===gl.FLOAT&&(internalFormat=gl.RGB32F),glType===gl.HALF_FLOAT&&(internalFormat=gl.RGB16F),glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RGB8),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RGB16),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RGB32UI),glType===gl.BYTE&&(internalFormat=gl.RGB8I),glType===gl.SHORT&&(internalFormat=gl.RGB16I),glType===gl.INT&&(internalFormat=gl.RGB32I),glType===gl.UNSIGNED_BYTE&&(internalFormat=colorSpace===SRGBColorSpace&&forceLinearTransfer===!1?gl.SRGB8:gl.RGB8),glType===gl.UNSIGNED_SHORT_5_6_5&&(internalFormat=gl.RGB565),glType===gl.UNSIGNED_SHORT_5_5_5_1&&(internalFormat=gl.RGB5_A1),glType===gl.UNSIGNED_SHORT_4_4_4_4&&(internalFormat=gl.RGB4),glType===gl.UNSIGNED_INT_5_9_9_9_REV&&(internalFormat=gl.RGB9_E5)),glFormat===gl.RGB_INTEGER&&(glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RGB8UI),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RGB16UI),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RGB32UI),glType===gl.BYTE&&(internalFormat=gl.RGB8I),glType===gl.SHORT&&(internalFormat=gl.RGB16I),glType===gl.INT&&(internalFormat=gl.RGB32I)),glFormat===gl.RGBA&&(glType===gl.FLOAT&&(internalFormat=gl.RGBA32F),glType===gl.HALF_FLOAT&&(internalFormat=gl.RGBA16F),glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RGBA8),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RGBA16),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RGBA32UI),glType===gl.BYTE&&(internalFormat=gl.RGBA8I),glType===gl.SHORT&&(internalFormat=gl.RGBA16I),glType===gl.INT&&(internalFormat=gl.RGBA32I),glType===gl.UNSIGNED_BYTE&&(internalFormat=colorSpace===SRGBColorSpace&&forceLinearTransfer===!1?gl.SRGB8_ALPHA8:gl.RGBA8),glType===gl.UNSIGNED_SHORT_4_4_4_4&&(internalFormat=gl.RGBA4),glType===gl.UNSIGNED_SHORT_5_5_5_1&&(internalFormat=gl.RGB5_A1)),glFormat===gl.RGBA_INTEGER&&(glType===gl.UNSIGNED_BYTE&&(internalFormat=gl.RGBA8UI),glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.RGBA16UI),glType===gl.UNSIGNED_INT&&(internalFormat=gl.RGBA32UI),glType===gl.BYTE&&(internalFormat=gl.RGBA8I),glType===gl.SHORT&&(internalFormat=gl.RGBA16I),glType===gl.INT&&(internalFormat=gl.RGBA32I)),glFormat===gl.DEPTH_COMPONENT&&(glType===gl.UNSIGNED_SHORT&&(internalFormat=gl.DEPTH_COMPONENT16),glType===gl.UNSIGNED_INT&&(internalFormat=gl.DEPTH_COMPONENT24),glType===gl.FLOAT&&(internalFormat=gl.DEPTH_COMPONENT32F)),glFormat===gl.DEPTH_STENCIL&&glType===gl.UNSIGNED_INT_24_8&&(internalFormat=gl.DEPTH24_STENCIL8),(internalFormat===gl.R16F||internalFormat===gl.R32F||internalFormat===gl.RG16F||internalFormat===gl.RG32F||internalFormat===gl.RGBA16F||internalFormat===gl.RGBA32F)&&extensions.get("EXT_color_buffer_float"),internalFormat}setTextureParameters(textureType,texture2){const{gl,extensions,backend}=this;gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL,texture2.flipY),gl.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,texture2.premultiplyAlpha),gl.pixelStorei(gl.UNPACK_ALIGNMENT,texture2.unpackAlignment),gl.pixelStorei(gl.UNPACK_COLORSPACE_CONVERSION_WEBGL,gl.NONE),gl.texParameteri(textureType,gl.TEXTURE_WRAP_S,wrappingToGL[texture2.wrapS]),gl.texParameteri(textureType,gl.TEXTURE_WRAP_T,wrappingToGL[texture2.wrapT]),(textureType===gl.TEXTURE_3D||textureType===gl.TEXTURE_2D_ARRAY)&&gl.texParameteri(textureType,gl.TEXTURE_WRAP_R,wrappingToGL[texture2.wrapR]),gl.texParameteri(textureType,gl.TEXTURE_MAG_FILTER,filterToGL[texture2.magFilter]);const hasMipmaps=texture2.mipmaps!==void 0&&texture2.mipmaps.length>0,minFilter=texture2.minFilter===LinearFilter&&hasMipmaps?LinearMipmapLinearFilter:texture2.minFilter;if(gl.texParameteri(textureType,gl.TEXTURE_MIN_FILTER,filterToGL[minFilter]),texture2.compareFunction&&(gl.texParameteri(textureType,gl.TEXTURE_COMPARE_MODE,gl.COMPARE_REF_TO_TEXTURE),gl.texParameteri(textureType,gl.TEXTURE_COMPARE_FUNC,compareToGL[texture2.compareFunction])),extensions.has("EXT_texture_filter_anisotropic")===!0){if(texture2.magFilter===NearestFilter||texture2.minFilter!==NearestMipmapLinearFilter&&texture2.minFilter!==LinearMipmapLinearFilter||texture2.type===FloatType&&extensions.has("OES_texture_float_linear")===!1)return;if(texture2.anisotropy>1){const extension=extensions.get("EXT_texture_filter_anisotropic");gl.texParameterf(textureType,extension.TEXTURE_MAX_ANISOTROPY_EXT,Math.min(texture2.anisotropy,backend.getMaxAnisotropy()))}}}createDefaultTexture(texture2){const{gl,backend,defaultTextures}=this,glTextureType=this.getGLTextureType(texture2);let textureGPU=defaultTextures[glTextureType];textureGPU===void 0&&(textureGPU=gl.createTexture(),backend.state.bindTexture(glTextureType,textureGPU),gl.texParameteri(glTextureType,gl.TEXTURE_MIN_FILTER,gl.NEAREST),gl.texParameteri(glTextureType,gl.TEXTURE_MAG_FILTER,gl.NEAREST),defaultTextures[glTextureType]=textureGPU),backend.set(texture2,{textureGPU,glTextureType,isDefault:!0})}createTexture(texture2,options){const{gl,backend}=this,{levels,width,height,depth:depth2}=options,glFormat=backend.utils.convert(texture2.format,texture2.colorSpace),glType=backend.utils.convert(texture2.type),glInternalFormat=this.getInternalFormat(texture2.internalFormat,glFormat,glType,texture2.colorSpace,texture2.isVideoTexture),textureGPU=gl.createTexture(),glTextureType=this.getGLTextureType(texture2);backend.state.bindTexture(glTextureType,textureGPU),this.setTextureParameters(glTextureType,texture2),texture2.isDataArrayTexture||texture2.isCompressedArrayTexture?gl.texStorage3D(gl.TEXTURE_2D_ARRAY,levels,glInternalFormat,width,height,depth2):texture2.isData3DTexture?gl.texStorage3D(gl.TEXTURE_3D,levels,glInternalFormat,width,height,depth2):texture2.isVideoTexture||gl.texStorage2D(glTextureType,levels,glInternalFormat,width,height),backend.set(texture2,{textureGPU,glTextureType,glFormat,glType,glInternalFormat})}copyBufferToTexture(buffer2,texture2){const{gl,backend}=this,{textureGPU,glTextureType,glFormat,glType}=backend.get(texture2),{width,height}=texture2.source.data;gl.bindBuffer(gl.PIXEL_UNPACK_BUFFER,buffer2),backend.state.bindTexture(glTextureType,textureGPU),gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL,!1),gl.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!1),gl.texSubImage2D(glTextureType,0,0,0,width,height,glFormat,glType,0),gl.bindBuffer(gl.PIXEL_UNPACK_BUFFER,null),backend.state.unbindTexture()}updateTexture(texture2,options){const{gl}=this,{width,height}=options,{textureGPU,glTextureType,glFormat,glType,glInternalFormat}=this.backend.get(texture2);if(texture2.isRenderTargetTexture||textureGPU===void 0)return;const getImage=source=>source.isDataTexture?source.image.data:typeof HTMLImageElement<"u"&&source instanceof HTMLImageElement||typeof HTMLCanvasElement<"u"&&source instanceof HTMLCanvasElement||typeof ImageBitmap<"u"&&source instanceof ImageBitmap||source instanceof OffscreenCanvas?source:source.data;if(this.backend.state.bindTexture(glTextureType,textureGPU),this.setTextureParameters(glTextureType,texture2),texture2.isCompressedTexture){const mipmaps=texture2.mipmaps,image=options.image;for(let i2=0;i2<mipmaps.length;i2++){const mipmap=mipmaps[i2];texture2.isCompressedArrayTexture?texture2.format!==gl.RGBA?glFormat!==null?gl.compressedTexSubImage3D(gl.TEXTURE_2D_ARRAY,i2,0,0,0,mipmap.width,mipmap.height,image.depth,glFormat,mipmap.data):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .uploadTexture()"):gl.texSubImage3D(gl.TEXTURE_2D_ARRAY,i2,0,0,0,mipmap.width,mipmap.height,image.depth,glFormat,glType,mipmap.data):glFormat!==null?gl.compressedTexSubImage2D(gl.TEXTURE_2D,i2,0,0,mipmap.width,mipmap.height,glFormat,mipmap.data):console.warn("Unsupported compressed texture format")}}else if(texture2.isCubeTexture){const images=options.images;for(let i2=0;i2<6;i2++){const image=getImage(images[i2]);gl.texSubImage2D(gl.TEXTURE_CUBE_MAP_POSITIVE_X+i2,0,0,0,width,height,glFormat,glType,image)}}else if(texture2.isDataArrayTexture){const image=options.image;gl.texSubImage3D(gl.TEXTURE_2D_ARRAY,0,0,0,0,image.width,image.height,image.depth,glFormat,glType,image.data)}else if(texture2.isData3DTexture){const image=options.image;gl.texSubImage3D(gl.TEXTURE_3D,0,0,0,0,image.width,image.height,image.depth,glFormat,glType,image.data)}else if(texture2.isVideoTexture)texture2.update(),gl.texImage2D(glTextureType,0,glInternalFormat,glFormat,glType,options.image);else{const image=getImage(options.image);gl.texSubImage2D(glTextureType,0,0,0,width,height,glFormat,glType,image)}}generateMipmaps(texture2){const{gl,backend}=this,{textureGPU,glTextureType}=backend.get(texture2);backend.state.bindTexture(glTextureType,textureGPU),gl.generateMipmap(glTextureType)}deallocateRenderBuffers(renderTarget){const{gl,backend}=this;if(renderTarget){const renderContextData=backend.get(renderTarget);if(renderContextData.renderBufferStorageSetup=void 0,renderContextData.framebuffers){for(const cacheKey in renderContextData.framebuffers)gl.deleteFramebuffer(renderContextData.framebuffers[cacheKey]);delete renderContextData.framebuffers}if(renderContextData.depthRenderbuffer&&(gl.deleteRenderbuffer(renderContextData.depthRenderbuffer),delete renderContextData.depthRenderbuffer),renderContextData.stencilRenderbuffer&&(gl.deleteRenderbuffer(renderContextData.stencilRenderbuffer),delete renderContextData.stencilRenderbuffer),renderContextData.msaaFrameBuffer&&(gl.deleteFramebuffer(renderContextData.msaaFrameBuffer),delete renderContextData.msaaFrameBuffer),renderContextData.msaaRenderbuffers){for(let i2=0;i2<renderContextData.msaaRenderbuffers.length;i2++)gl.deleteRenderbuffer(renderContextData.msaaRenderbuffers[i2]);delete renderContextData.msaaRenderbuffers}}}destroyTexture(texture2){const{gl,backend}=this,{textureGPU,renderTarget}=backend.get(texture2);this.deallocateRenderBuffers(renderTarget),gl.deleteTexture(textureGPU),backend.delete(texture2)}copyTextureToTexture(srcTexture,dstTexture,srcRegion=null,dstPosition=null,level=0){const{gl,backend}=this,{state}=this.backend,{textureGPU:dstTextureGPU,glTextureType,glType,glFormat}=backend.get(dstTexture);let width,height,minX,minY,dstX,dstY;srcRegion!==null?(width=srcRegion.max.x-srcRegion.min.x,height=srcRegion.max.y-srcRegion.min.y,minX=srcRegion.min.x,minY=srcRegion.min.y):(width=srcTexture.image.width,height=srcTexture.image.height,minX=0,minY=0),dstPosition!==null?(dstX=dstPosition.x,dstY=dstPosition.y):(dstX=0,dstY=0),state.bindTexture(glTextureType,dstTextureGPU),gl.pixelStorei(gl.UNPACK_ALIGNMENT,dstTexture.unpackAlignment),gl.pixelStorei(gl.UNPACK_FLIP_Y_WEBGL,dstTexture.flipY),gl.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,dstTexture.premultiplyAlpha),gl.pixelStorei(gl.UNPACK_ALIGNMENT,dstTexture.unpackAlignment);const currentUnpackRowLen=gl.getParameter(gl.UNPACK_ROW_LENGTH),currentUnpackImageHeight=gl.getParameter(gl.UNPACK_IMAGE_HEIGHT),currentUnpackSkipPixels=gl.getParameter(gl.UNPACK_SKIP_PIXELS),currentUnpackSkipRows=gl.getParameter(gl.UNPACK_SKIP_ROWS),currentUnpackSkipImages=gl.getParameter(gl.UNPACK_SKIP_IMAGES),image=srcTexture.isCompressedTexture?srcTexture.mipmaps[level]:srcTexture.image;if(gl.pixelStorei(gl.UNPACK_ROW_LENGTH,image.width),gl.pixelStorei(gl.UNPACK_IMAGE_HEIGHT,image.height),gl.pixelStorei(gl.UNPACK_SKIP_PIXELS,minX),gl.pixelStorei(gl.UNPACK_SKIP_ROWS,minY),srcTexture.isRenderTargetTexture||srcTexture.isDepthTexture){const srcTextureData=backend.get(srcTexture),dstTextureData=backend.get(dstTexture),srcRenderContextData=backend.get(srcTextureData.renderTarget),dstRenderContextData=backend.get(dstTextureData.renderTarget),srcFramebuffer=srcRenderContextData.framebuffers[srcTextureData.cacheKey],dstFramebuffer=dstRenderContextData.framebuffers[dstTextureData.cacheKey];state.bindFramebuffer(gl.READ_FRAMEBUFFER,srcFramebuffer),state.bindFramebuffer(gl.DRAW_FRAMEBUFFER,dstFramebuffer);let mask=gl.COLOR_BUFFER_BIT;srcTexture.isDepthTexture&&(mask=gl.DEPTH_BUFFER_BIT),gl.blitFramebuffer(minX,minY,width,height,dstX,dstY,width,height,mask,gl.NEAREST),state.bindFramebuffer(gl.READ_FRAMEBUFFER,null),state.bindFramebuffer(gl.DRAW_FRAMEBUFFER,null)}else srcTexture.isDataTexture?gl.texSubImage2D(gl.TEXTURE_2D,level,dstX,dstY,width,height,glFormat,glType,image.data):srcTexture.isCompressedTexture?gl.compressedTexSubImage2D(gl.TEXTURE_2D,level,dstX,dstY,image.width,image.height,glFormat,image.data):gl.texSubImage2D(gl.TEXTURE_2D,level,dstX,dstY,width,height,glFormat,glType,image);gl.pixelStorei(gl.UNPACK_ROW_LENGTH,currentUnpackRowLen),gl.pixelStorei(gl.UNPACK_IMAGE_HEIGHT,currentUnpackImageHeight),gl.pixelStorei(gl.UNPACK_SKIP_PIXELS,currentUnpackSkipPixels),gl.pixelStorei(gl.UNPACK_SKIP_ROWS,currentUnpackSkipRows),gl.pixelStorei(gl.UNPACK_SKIP_IMAGES,currentUnpackSkipImages),level===0&&dstTexture.generateMipmaps&&gl.generateMipmap(gl.TEXTURE_2D),state.unbindTexture()}copyFramebufferToTexture(texture2,renderContext,rectangle){const{gl}=this,{state}=this.backend,{textureGPU}=this.backend.get(texture2),{x,y,z:width,w:height}=rectangle,requireDrawFrameBuffer=texture2.isDepthTexture===!0||renderContext.renderTarget&&renderContext.renderTarget.samples>0,srcHeight=renderContext.renderTarget?renderContext.renderTarget.height:this.backend.getDrawingBufferSize().y;if(requireDrawFrameBuffer){const partial=x!==0||y!==0;let mask,attachment;if(texture2.isDepthTexture===!0?(mask=gl.DEPTH_BUFFER_BIT,attachment=gl.DEPTH_ATTACHMENT,renderContext.stencil&&(mask|=gl.STENCIL_BUFFER_BIT)):(mask=gl.COLOR_BUFFER_BIT,attachment=gl.COLOR_ATTACHMENT0),partial){const renderTargetContextData=this.backend.get(renderContext.renderTarget),fb=renderTargetContextData.framebuffers[renderContext.getCacheKey()],msaaFrameBuffer=renderTargetContextData.msaaFrameBuffer;state.bindFramebuffer(gl.DRAW_FRAMEBUFFER,fb),state.bindFramebuffer(gl.READ_FRAMEBUFFER,msaaFrameBuffer);const flippedY=srcHeight-y-height;gl.blitFramebuffer(x,flippedY,x+width,flippedY+height,x,flippedY,x+width,flippedY+height,mask,gl.NEAREST),state.bindFramebuffer(gl.READ_FRAMEBUFFER,fb),state.bindTexture(gl.TEXTURE_2D,textureGPU),gl.copyTexSubImage2D(gl.TEXTURE_2D,0,0,0,x,flippedY,width,height),state.unbindTexture()}else{const fb=gl.createFramebuffer();state.bindFramebuffer(gl.DRAW_FRAMEBUFFER,fb),gl.framebufferTexture2D(gl.DRAW_FRAMEBUFFER,attachment,gl.TEXTURE_2D,textureGPU,0),gl.blitFramebuffer(0,0,width,height,0,0,width,height,mask,gl.NEAREST),gl.deleteFramebuffer(fb)}}else state.bindTexture(gl.TEXTURE_2D,textureGPU),gl.copyTexSubImage2D(gl.TEXTURE_2D,0,0,0,x,srcHeight-height-y,width,height),state.unbindTexture();texture2.generateMipmaps&&this.generateMipmaps(texture2),this.backend._setFramebuffer(renderContext)}setupRenderBufferStorage(renderbuffer,renderContext,samples,useMultisampledRTT=!1){const{gl}=this,renderTarget=renderContext.renderTarget,{depthTexture,depthBuffer,stencilBuffer,width,height}=renderTarget;if(gl.bindRenderbuffer(gl.RENDERBUFFER,renderbuffer),depthBuffer&&!stencilBuffer){let glInternalFormat=gl.DEPTH_COMPONENT24;useMultisampledRTT===!0?this.extensions.get("WEBGL_multisampled_render_to_texture").renderbufferStorageMultisampleEXT(gl.RENDERBUFFER,renderTarget.samples,glInternalFormat,width,height):samples>0?(depthTexture&&depthTexture.isDepthTexture&&depthTexture.type===gl.FLOAT&&(glInternalFormat=gl.DEPTH_COMPONENT32F),gl.renderbufferStorageMultisample(gl.RENDERBUFFER,samples,glInternalFormat,width,height)):gl.renderbufferStorage(gl.RENDERBUFFER,glInternalFormat,width,height),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.DEPTH_ATTACHMENT,gl.RENDERBUFFER,renderbuffer)}else depthBuffer&&stencilBuffer&&(samples>0?gl.renderbufferStorageMultisample(gl.RENDERBUFFER,samples,gl.DEPTH24_STENCIL8,width,height):gl.renderbufferStorage(gl.RENDERBUFFER,gl.DEPTH_STENCIL,width,height),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.DEPTH_STENCIL_ATTACHMENT,gl.RENDERBUFFER,renderbuffer))}async copyTextureToBuffer(texture2,x,y,width,height,faceIndex){const{backend,gl}=this,{textureGPU,glFormat,glType}=this.backend.get(texture2),fb=gl.createFramebuffer();gl.bindFramebuffer(gl.READ_FRAMEBUFFER,fb);const target=texture2.isCubeTexture?gl.TEXTURE_CUBE_MAP_POSITIVE_X+faceIndex:gl.TEXTURE_2D;gl.framebufferTexture2D(gl.READ_FRAMEBUFFER,gl.COLOR_ATTACHMENT0,target,textureGPU,0);const typedArrayType=this._getTypedArrayType(glType),bytesPerTexel=this._getBytesPerTexel(glType,glFormat),byteLength=width*height*bytesPerTexel,buffer2=gl.createBuffer();gl.bindBuffer(gl.PIXEL_PACK_BUFFER,buffer2),gl.bufferData(gl.PIXEL_PACK_BUFFER,byteLength,gl.STREAM_READ),gl.readPixels(x,y,width,height,glFormat,glType,0),gl.bindBuffer(gl.PIXEL_PACK_BUFFER,null),await backend.utils._clientWaitAsync();const dstBuffer=new typedArrayType(byteLength/typedArrayType.BYTES_PER_ELEMENT);return gl.bindBuffer(gl.PIXEL_PACK_BUFFER,buffer2),gl.getBufferSubData(gl.PIXEL_PACK_BUFFER,0,dstBuffer),gl.bindBuffer(gl.PIXEL_PACK_BUFFER,null),gl.deleteFramebuffer(fb),dstBuffer}_getTypedArrayType(glType){const{gl}=this;if(glType===gl.UNSIGNED_BYTE)return Uint8Array;if(glType===gl.UNSIGNED_SHORT_4_4_4_4||glType===gl.UNSIGNED_SHORT_5_5_5_1||glType===gl.UNSIGNED_SHORT_5_6_5||glType===gl.UNSIGNED_SHORT)return Uint16Array;if(glType===gl.UNSIGNED_INT)return Uint32Array;if(glType===gl.HALF_FLOAT)return Uint16Array;if(glType===gl.FLOAT)return Float32Array;throw new Error(`Unsupported WebGL type: ${glType}`)}_getBytesPerTexel(glType,glFormat){const{gl}=this;let bytesPerComponent=0;if(glType===gl.UNSIGNED_BYTE&&(bytesPerComponent=1),(glType===gl.UNSIGNED_SHORT_4_4_4_4||glType===gl.UNSIGNED_SHORT_5_5_5_1||glType===gl.UNSIGNED_SHORT_5_6_5||glType===gl.UNSIGNED_SHORT||glType===gl.HALF_FLOAT)&&(bytesPerComponent=2),(glType===gl.UNSIGNED_INT||glType===gl.FLOAT)&&(bytesPerComponent=4),glFormat===gl.RGBA)return bytesPerComponent*4;if(glFormat===gl.RGB)return bytesPerComponent*3;if(glFormat===gl.ALPHA)return bytesPerComponent}}class WebGLExtensions{constructor(backend){this.backend=backend,this.gl=this.backend.gl,this.availableExtensions=this.gl.getSupportedExtensions(),this.extensions={}}get(name){let extension=this.extensions[name];return extension===void 0&&(extension=this.gl.getExtension(name),this.extensions[name]=extension),extension}has(name){return this.availableExtensions.includes(name)}}class WebGLCapabilities{constructor(backend){this.backend=backend,this.maxAnisotropy=null}getMaxAnisotropy(){if(this.maxAnisotropy!==null)return this.maxAnisotropy;const gl=this.backend.gl,extensions=this.backend.extensions;if(extensions.has("EXT_texture_filter_anisotropic")===!0){const extension=extensions.get("EXT_texture_filter_anisotropic");this.maxAnisotropy=gl.getParameter(extension.MAX_TEXTURE_MAX_ANISOTROPY_EXT)}else this.maxAnisotropy=0;return this.maxAnisotropy}}const GLFeatureName={WEBGL_multi_draw:"WEBGL_multi_draw",WEBGL_compressed_texture_astc:"texture-compression-astc",WEBGL_compressed_texture_etc:"texture-compression-etc2",WEBGL_compressed_texture_etc1:"texture-compression-etc1",WEBGL_compressed_texture_pvrtc:"texture-compression-pvrtc",WEBKIT_WEBGL_compressed_texture_pvrtc:"texture-compression-pvrtc",WEBGL_compressed_texture_s3tc:"texture-compression-bc",EXT_texture_compression_bptc:"texture-compression-bptc",EXT_disjoint_timer_query_webgl2:"timestamp-query"};class WebGLBufferRenderer{constructor(backend){this.gl=backend.gl,this.extensions=backend.extensions,this.info=backend.renderer.info,this.mode=null,this.index=0,this.type=null,this.object=null}render(start,count){const{gl,mode,object,type,info,index}=this;index!==0?gl.drawElements(mode,count,type,start):gl.drawArrays(mode,start,count),info.update(object,count,1)}renderInstances(start,count,primcount){const{gl,mode,type,index,object,info}=this;primcount!==0&&(index!==0?gl.drawElementsInstanced(mode,count,type,start,primcount):gl.drawArraysInstanced(mode,start,count,primcount),info.update(object,count,primcount))}renderMultiDraw(starts,counts,drawCount){const{extensions,mode,object,info}=this;if(drawCount===0)return;const extension=extensions.get("WEBGL_multi_draw");if(extension===null)for(let i2=0;i2<drawCount;i2++)this.render(starts[i2],counts[i2]);else{this.index!==0?extension.multiDrawElementsWEBGL(mode,counts,0,this.type,starts,0,drawCount):extension.multiDrawArraysWEBGL(mode,starts,0,counts,0,drawCount);let elementCount=0;for(let i2=0;i2<drawCount;i2++)elementCount+=counts[i2];info.update(object,elementCount,1)}}renderMultiDrawInstances(starts,counts,drawCount,primcount){const{extensions,mode,object,info}=this;if(drawCount===0)return;const extension=extensions.get("WEBGL_multi_draw");if(extension===null)for(let i2=0;i2<drawCount;i2++)this.renderInstances(starts[i2],counts[i2],primcount[i2]);else{this.index!==0?extension.multiDrawElementsInstancedWEBGL(mode,counts,0,this.type,starts,0,primcount,0,drawCount):extension.multiDrawArraysInstancedWEBGL(mode,starts,0,counts,0,primcount,0,drawCount);let elementCount=0;for(let i2=0;i2<drawCount;i2++)elementCount+=counts[i2]*primcount[i2];info.update(object,elementCount,1)}}}class TimestampQueryPool{constructor(maxQueries=256){this.trackTimestamp=!0,this.maxQueries=maxQueries,this.currentQueryIndex=0,this.queryOffsets=new Map,this.isDisposed=!1,this.lastValue=0,this.pendingResolve=!1}allocateQueriesForContext(){}async resolveQueriesAsync(){}dispose(){}}class WebGLTimestampQueryPool extends TimestampQueryPool{constructor(gl,type,maxQueries=2048){if(super(maxQueries),this.gl=gl,this.type=type,this.ext=gl.getExtension("EXT_disjoint_timer_query_webgl2")||gl.getExtension("EXT_disjoint_timer_query"),!this.ext){console.warn("EXT_disjoint_timer_query not supported; timestamps will be disabled."),this.trackTimestamp=!1;return}this.queries=[];for(let i2=0;i2<this.maxQueries;i2++)this.queries.push(gl.createQuery());this.activeQuery=null,this.queryStates=new Map}allocateQueriesForContext(renderContext){if(!this.trackTimestamp)return null;if(this.currentQueryIndex+2>this.maxQueries)return warnOnce(`WebGPUTimestampQueryPool [${this.type}]: Maximum number of queries exceeded, when using trackTimestamp it is necessary to resolves the queries via renderer.resolveTimestampsAsync( THREE.TimestampQuery.${this.type.toUpperCase()} ).`),null;const baseOffset=this.currentQueryIndex;return this.currentQueryIndex+=2,this.queryStates.set(baseOffset,"inactive"),this.queryOffsets.set(renderContext.id,baseOffset),baseOffset}beginQuery(renderContext){if(!this.trackTimestamp||this.isDisposed)return;const baseOffset=this.queryOffsets.get(renderContext.id);if(baseOffset==null||this.activeQuery!==null)return;const query=this.queries[baseOffset];if(query)try{this.queryStates.get(baseOffset)==="inactive"&&(this.gl.beginQuery(this.ext.TIME_ELAPSED_EXT,query),this.activeQuery=baseOffset,this.queryStates.set(baseOffset,"started"))}catch(error){console.error("Error in beginQuery:",error),this.activeQuery=null,this.queryStates.set(baseOffset,"inactive")}}endQuery(renderContext){if(!this.trackTimestamp||this.isDisposed)return;const baseOffset=this.queryOffsets.get(renderContext.id);if(baseOffset!=null&&this.activeQuery===baseOffset)try{this.gl.endQuery(this.ext.TIME_ELAPSED_EXT),this.queryStates.set(baseOffset,"ended"),this.activeQuery=null}catch(error){console.error("Error in endQuery:",error),this.queryStates.set(baseOffset,"inactive"),this.activeQuery=null}}async resolveQueriesAsync(){if(!this.trackTimestamp||this.pendingResolve)return this.lastValue;this.pendingResolve=!0;try{const resolvePromises=[];for(const[baseOffset,state]of this.queryStates)if(state==="ended"){const query=this.queries[baseOffset];resolvePromises.push(this.resolveQuery(query))}if(resolvePromises.length===0)return this.lastValue;const totalDuration=(await Promise.all(resolvePromises)).reduce((acc,val)=>acc+val,0);return this.lastValue=totalDuration,this.currentQueryIndex=0,this.queryOffsets.clear(),this.queryStates.clear(),this.activeQuery=null,totalDuration}catch(error){return console.error("Error resolving queries:",error),this.lastValue}finally{this.pendingResolve=!1}}async resolveQuery(query){return new Promise(resolve=>{if(this.isDisposed){resolve(this.lastValue);return}let timeoutId,isResolved=!1;const cleanup=()=>{timeoutId&&(clearTimeout(timeoutId),timeoutId=null)},finalizeResolution=value=>{isResolved||(isResolved=!0,cleanup(),resolve(value))},checkQuery=()=>{if(this.isDisposed){finalizeResolution(this.lastValue);return}try{if(this.gl.getParameter(this.ext.GPU_DISJOINT_EXT)){finalizeResolution(this.lastValue);return}if(!this.gl.getQueryParameter(query,this.gl.QUERY_RESULT_AVAILABLE)){timeoutId=setTimeout(checkQuery,1);return}const elapsed=this.gl.getQueryParameter(query,this.gl.QUERY_RESULT);resolve(Number(elapsed)/1e6)}catch(error){console.error("Error checking query:",error),resolve(this.lastValue)}};checkQuery()})}dispose(){if(!this.isDisposed&&(this.isDisposed=!0,!!this.trackTimestamp)){for(const query of this.queries)this.gl.deleteQuery(query);this.queries=[],this.queryStates.clear(),this.queryOffsets.clear(),this.lastValue=0,this.activeQuery=null}}}class WebGLBackend extends Backend{constructor(parameters={}){super(parameters),this.isWebGLBackend=!0,this.attributeUtils=null,this.extensions=null,this.capabilities=null,this.textureUtils=null,this.bufferRenderer=null,this.gl=null,this.state=null,this.utils=null,this.vaoCache={},this.transformFeedbackCache={},this.discard=!1,this.disjoint=null,this.parallel=null,this.trackTimestamp=parameters.trackTimestamp===!0,this._currentContext=null,this._knownBindings=new WeakSet,this._xrFramebuffer=null}init(renderer){super.init(renderer);const parameters=this.parameters,contextAttributes={antialias:renderer.samples>0,alpha:!0,depth:renderer.depth,stencil:renderer.stencil},glContext=parameters.context!==void 0?parameters.context:renderer.domElement.getContext("webgl2",contextAttributes);function onContextLost(event){event.preventDefault();const contextLossInfo={api:"WebGL",message:event.statusMessage||"Unknown reason",reason:null,originalEvent:event};renderer.onDeviceLost(contextLossInfo)}this._onContextLost=onContextLost,renderer.domElement.addEventListener("webglcontextlost",onContextLost,!1),this.gl=glContext,this.extensions=new WebGLExtensions(this),this.capabilities=new WebGLCapabilities(this),this.attributeUtils=new WebGLAttributeUtils(this),this.textureUtils=new WebGLTextureUtils(this),this.bufferRenderer=new WebGLBufferRenderer(this),this.state=new WebGLState(this),this.utils=new WebGLUtils(this),this.extensions.get("EXT_color_buffer_float"),this.extensions.get("WEBGL_clip_cull_distance"),this.extensions.get("OES_texture_float_linear"),this.extensions.get("EXT_color_buffer_half_float"),this.extensions.get("WEBGL_multisampled_render_to_texture"),this.extensions.get("WEBGL_render_shared_exponent"),this.extensions.get("WEBGL_multi_draw"),this.disjoint=this.extensions.get("EXT_disjoint_timer_query_webgl2"),this.parallel=this.extensions.get("KHR_parallel_shader_compile")}get coordinateSystem(){return WebGLCoordinateSystem}async getArrayBufferAsync(attribute2){return await this.attributeUtils.getArrayBufferAsync(attribute2)}async waitForGPU(){await this.utils._clientWaitAsync()}async makeXRCompatible(){this.gl.getContextAttributes().xrCompatible!==!0&&await this.gl.makeXRCompatible()}setXRTarget(xrFramebuffer){this._xrFramebuffer=xrFramebuffer}setXRRenderTargetTextures(renderTarget,colorTexture,depthTexture=null){const gl=this.gl;if(this.set(renderTarget.texture,{textureGPU:colorTexture,glInternalFormat:gl.RGBA8}),depthTexture!==null){const glInternalFormat=renderTarget.stencilBuffer?gl.DEPTH24_STENCIL8:gl.DEPTH_COMPONENT24;this.set(renderTarget.depthTexture,{textureGPU:depthTexture,glInternalFormat}),renderTarget.autoAllocateDepthBuffer=!1,this.extensions.has("WEBGL_multisampled_render_to_texture")===!0&&console.warn("THREE.WebGLBackend: Render-to-texture extension was disabled because an external texture was provided")}}initTimestampQuery(renderContext){if(!this.disjoint||!this.trackTimestamp)return;const type=renderContext.isComputeNode?"compute":"render";this.timestampQueryPool[type]||(this.timestampQueryPool[type]=new WebGLTimestampQueryPool(this.gl,type,2048));const timestampQueryPool=this.timestampQueryPool[type];timestampQueryPool.allocateQueriesForContext(renderContext)!==null&&timestampQueryPool.beginQuery(renderContext)}prepareTimestampBuffer(renderContext){if(!this.disjoint||!this.trackTimestamp)return;const type=renderContext.isComputeNode?"compute":"render";this.timestampQueryPool[type].endQuery(renderContext)}getContext(){return this.gl}beginRender(renderContext){const{state,gl}=this,renderContextData=this.get(renderContext);if(renderContext.viewport?this.updateViewport(renderContext):state.viewport(0,0,gl.drawingBufferWidth,gl.drawingBufferHeight),renderContext.scissor){const{x,y,width,height}=renderContext.scissorValue;state.scissor(x,renderContext.height-height-y,width,height)}this.initTimestampQuery(renderContext),renderContextData.previousContext=this._currentContext,this._currentContext=renderContext,this._setFramebuffer(renderContext),this.clear(renderContext.clearColor,renderContext.clearDepth,renderContext.clearStencil,renderContext,!1);const occlusionQueryCount=renderContext.occlusionQueryCount;occlusionQueryCount>0&&(renderContextData.currentOcclusionQueries=renderContextData.occlusionQueries,renderContextData.currentOcclusionQueryObjects=renderContextData.occlusionQueryObjects,renderContextData.lastOcclusionObject=null,renderContextData.occlusionQueries=new Array(occlusionQueryCount),renderContextData.occlusionQueryObjects=new Array(occlusionQueryCount),renderContextData.occlusionQueryIndex=0)}finishRender(renderContext){const{gl,state}=this,renderContextData=this.get(renderContext),previousContext=renderContextData.previousContext,occlusionQueryCount=renderContext.occlusionQueryCount;occlusionQueryCount>0&&(occlusionQueryCount>renderContextData.occlusionQueryIndex&&gl.endQuery(gl.ANY_SAMPLES_PASSED),this.resolveOccludedAsync(renderContext));const textures=renderContext.textures;if(textures!==null)for(let i2=0;i2<textures.length;i2++){const texture2=textures[i2];texture2.generateMipmaps&&this.generateMipmaps(texture2)}if(this._currentContext=previousContext,renderContext.textures!==null&&renderContext.renderTarget){const renderTargetContextData=this.get(renderContext.renderTarget),{samples}=renderContext.renderTarget;if(samples>0&&this._useMultisampledRTT(renderContext.renderTarget)===!1){const fb=renderTargetContextData.framebuffers[renderContext.getCacheKey()],mask=gl.COLOR_BUFFER_BIT,msaaFrameBuffer=renderTargetContextData.msaaFrameBuffer,textures2=renderContext.textures;state.bindFramebuffer(gl.READ_FRAMEBUFFER,msaaFrameBuffer),state.bindFramebuffer(gl.DRAW_FRAMEBUFFER,fb);for(let i2=0;i2<textures2.length;i2++)if(renderContext.scissor){const{x,y,width,height}=renderContext.scissorValue,viewY=renderContext.height-height-y;gl.blitFramebuffer(x,viewY,x+width,viewY+height,x,viewY,x+width,viewY+height,mask,gl.NEAREST),gl.invalidateSubFramebuffer(gl.READ_FRAMEBUFFER,renderTargetContextData.invalidationArray,x,viewY,width,height)}else gl.blitFramebuffer(0,0,renderContext.width,renderContext.height,0,0,renderContext.width,renderContext.height,mask,gl.NEAREST),gl.invalidateFramebuffer(gl.READ_FRAMEBUFFER,renderTargetContextData.invalidationArray)}}previousContext!==null&&(this._setFramebuffer(previousContext),previousContext.viewport?this.updateViewport(previousContext):state.viewport(0,0,gl.drawingBufferWidth,gl.drawingBufferHeight)),this.prepareTimestampBuffer(renderContext)}resolveOccludedAsync(renderContext){const renderContextData=this.get(renderContext),{currentOcclusionQueries,currentOcclusionQueryObjects}=renderContextData;if(currentOcclusionQueries&&currentOcclusionQueryObjects){const occluded=new WeakSet,{gl}=this;renderContextData.currentOcclusionQueryObjects=null,renderContextData.currentOcclusionQueries=null;const check=()=>{let completed=0;for(let i2=0;i2<currentOcclusionQueries.length;i2++){const query=currentOcclusionQueries[i2];query!==null&&gl.getQueryParameter(query,gl.QUERY_RESULT_AVAILABLE)&&(gl.getQueryParameter(query,gl.QUERY_RESULT)===0&&occluded.add(currentOcclusionQueryObjects[i2]),currentOcclusionQueries[i2]=null,gl.deleteQuery(query),completed++)}completed<currentOcclusionQueries.length?requestAnimationFrame(check):renderContextData.occluded=occluded};check()}}isOccluded(renderContext,object){const renderContextData=this.get(renderContext);return renderContextData.occluded&&renderContextData.occluded.has(object)}updateViewport(renderContext){const{state}=this,{x,y,width,height}=renderContext.viewportValue;state.viewport(x,renderContext.height-height-y,width,height)}setScissorTest(boolean){this.state.setScissorTest(boolean)}getClearColor(){const clearColor=super.getClearColor();return clearColor.r*=clearColor.a,clearColor.g*=clearColor.a,clearColor.b*=clearColor.a,clearColor}clear(color2,depth2,stencil,descriptor=null,setFrameBuffer=!0){const{gl,renderer}=this;descriptor===null&&(descriptor={textures:null,clearColorValue:this.getClearColor()});let clear2=0;if(color2&&(clear2|=gl.COLOR_BUFFER_BIT),depth2&&(clear2|=gl.DEPTH_BUFFER_BIT),stencil&&(clear2|=gl.STENCIL_BUFFER_BIT),clear2!==0){let clearColor;descriptor.clearColorValue?clearColor=descriptor.clearColorValue:clearColor=this.getClearColor();const clearDepth=renderer.getClearDepth(),clearStencil=renderer.getClearStencil();if(depth2&&this.state.setDepthMask(!0),descriptor.textures===null)gl.clearColor(clearColor.r,clearColor.g,clearColor.b,clearColor.a),gl.clear(clear2);else{if(setFrameBuffer&&this._setFramebuffer(descriptor),color2)for(let i2=0;i2<descriptor.textures.length;i2++)gl.clearBufferfv(gl.COLOR,i2,[clearColor.r,clearColor.g,clearColor.b,clearColor.a]);depth2&&stencil?gl.clearBufferfi(gl.DEPTH_STENCIL,0,clearDepth,clearStencil):depth2?gl.clearBufferfv(gl.DEPTH,0,[clearDepth]):stencil&&gl.clearBufferiv(gl.STENCIL,0,[clearStencil])}}}beginCompute(computeGroup){const{state,gl}=this;state.bindFramebuffer(gl.FRAMEBUFFER,null),this.initTimestampQuery(computeGroup)}compute(computeGroup,computeNode,bindings,pipeline){const{state,gl}=this;this.discard===!1&&(gl.enable(gl.RASTERIZER_DISCARD),this.discard=!0);const{programGPU,transformBuffers,attributes}=this.get(pipeline),vaoKey=this._getVaoKey(null,attributes),vaoGPU=this.vaoCache[vaoKey];vaoGPU===void 0?this._createVao(null,attributes):gl.bindVertexArray(vaoGPU),state.useProgram(programGPU),this._bindUniforms(bindings);const transformFeedbackGPU=this._getTransformFeedback(transformBuffers);gl.bindTransformFeedback(gl.TRANSFORM_FEEDBACK,transformFeedbackGPU),gl.beginTransformFeedback(gl.POINTS),attributes[0].isStorageInstancedBufferAttribute?gl.drawArraysInstanced(gl.POINTS,0,1,computeNode.count):gl.drawArrays(gl.POINTS,0,computeNode.count),gl.endTransformFeedback(),gl.bindTransformFeedback(gl.TRANSFORM_FEEDBACK,null);for(let i2=0;i2<transformBuffers.length;i2++){const dualAttributeData=transformBuffers[i2];dualAttributeData.pbo&&this.textureUtils.copyBufferToTexture(dualAttributeData.transformBuffer,dualAttributeData.pbo),dualAttributeData.switchBuffers()}}finishCompute(computeGroup){const gl=this.gl;this.discard=!1,gl.disable(gl.RASTERIZER_DISCARD),this.prepareTimestampBuffer(computeGroup),this._currentContext&&this._setFramebuffer(this._currentContext)}draw(renderObject){const{object,pipeline,material,context:context2,hardwareClippingPlanes}=renderObject,{programGPU}=this.get(pipeline),{gl,state}=this,contextData=this.get(context2),drawParams=renderObject.getDrawParameters();if(drawParams===null)return;this._bindUniforms(renderObject.getBindings());const frontFaceCW=object.isMesh&&object.matrixWorld.determinant()<0;state.setMaterial(material,frontFaceCW,hardwareClippingPlanes),state.useProgram(programGPU);const renderObjectData=this.get(renderObject);let vaoGPU=renderObjectData.staticVao;if(vaoGPU===void 0||renderObjectData.geometryId!==renderObject.geometry.id){const vaoKey=this._getVaoKey(renderObject.getIndex(),renderObject.getAttributes());if(vaoGPU=this.vaoCache[vaoKey],vaoGPU===void 0){let staticVao;({vaoGPU,staticVao}=this._createVao(renderObject.getIndex(),renderObject.getAttributes())),staticVao&&(renderObjectData.staticVao=vaoGPU,renderObjectData.geometryId=renderObject.geometry.id)}}gl.bindVertexArray(vaoGPU);const index=renderObject.getIndex(),lastObject=contextData.lastOcclusionObject;if(lastObject!==object&&lastObject!==void 0){if(lastObject!==null&&lastObject.occlusionTest===!0&&(gl.endQuery(gl.ANY_SAMPLES_PASSED),contextData.occlusionQueryIndex++),object.occlusionTest===!0){const query=gl.createQuery();gl.beginQuery(gl.ANY_SAMPLES_PASSED,query),contextData.occlusionQueries[contextData.occlusionQueryIndex]=query,contextData.occlusionQueryObjects[contextData.occlusionQueryIndex]=object}contextData.lastOcclusionObject=object}const renderer=this.bufferRenderer;object.isPoints?renderer.mode=gl.POINTS:object.isLineSegments?renderer.mode=gl.LINES:object.isLine?renderer.mode=gl.LINE_STRIP:object.isLineLoop?renderer.mode=gl.LINE_LOOP:material.wireframe===!0?(state.setLineWidth(material.wireframeLinewidth*this.renderer.getPixelRatio()),renderer.mode=gl.LINES):renderer.mode=gl.TRIANGLES;const{vertexCount,instanceCount}=drawParams;let{firstVertex}=drawParams;if(renderer.object=object,index!==null){firstVertex*=index.array.BYTES_PER_ELEMENT;const indexData=this.get(index);renderer.index=index.count,renderer.type=indexData.type}else renderer.index=0;const draw=()=>{object.isBatchedMesh?object._multiDrawInstances!==null?(warnOnce("THREE.WebGLBackend: renderMultiDrawInstances has been deprecated and will be removed in r184. Append to renderMultiDraw arguments and use indirection."),renderer.renderMultiDrawInstances(object._multiDrawStarts,object._multiDrawCounts,object._multiDrawCount,object._multiDrawInstances)):this.hasFeature("WEBGL_multi_draw")?renderer.renderMultiDraw(object._multiDrawStarts,object._multiDrawCounts,object._multiDrawCount):warnOnce("THREE.WebGLRenderer: WEBGL_multi_draw not supported."):instanceCount>1?renderer.renderInstances(firstVertex,vertexCount,instanceCount):renderer.render(firstVertex,vertexCount)};if(renderObject.camera.isArrayCamera&&renderObject.camera.cameras.length>0){const cameraData=this.get(renderObject.camera),cameras=renderObject.camera.cameras,cameraIndex2=renderObject.getBindingGroup("cameraIndex").bindings[0];if(cameraData.indexesGPU===void 0||cameraData.indexesGPU.length!==cameras.length){const data=new Uint32Array([0,0,0,0]),indexesGPU=[];for(let i2=0,len=cameras.length;i2<len;i2++){const bufferGPU=gl.createBuffer();data[0]=i2,gl.bindBuffer(gl.UNIFORM_BUFFER,bufferGPU),gl.bufferData(gl.UNIFORM_BUFFER,data,gl.STATIC_DRAW),indexesGPU.push(bufferGPU)}cameraData.indexesGPU=indexesGPU}const cameraIndexData=this.get(cameraIndex2),pixelRatio=this.renderer.getPixelRatio();for(let i2=0,len=cameras.length;i2<len;i2++){const subCamera=cameras[i2];if(object.layers.test(subCamera.layers)){const vp=subCamera.viewport,x=vp.x*pixelRatio,y=vp.y*pixelRatio,width=vp.width*pixelRatio,height=vp.height*pixelRatio;state.viewport(Math.floor(x),Math.floor(renderObject.context.height-height-y),Math.floor(width),Math.floor(height)),state.bindBufferBase(gl.UNIFORM_BUFFER,cameraIndexData.index,cameraData.indexesGPU[i2]),draw()}}}else draw();gl.bindVertexArray(null)}needsRenderUpdate(){return!1}getRenderCacheKey(){return""}createDefaultTexture(texture2){this.textureUtils.createDefaultTexture(texture2)}createTexture(texture2,options){this.textureUtils.createTexture(texture2,options)}updateTexture(texture2,options){this.textureUtils.updateTexture(texture2,options)}generateMipmaps(texture2){this.textureUtils.generateMipmaps(texture2)}destroyTexture(texture2){this.textureUtils.destroyTexture(texture2)}async copyTextureToBuffer(texture2,x,y,width,height,faceIndex){return this.textureUtils.copyTextureToBuffer(texture2,x,y,width,height,faceIndex)}createSampler(){}destroySampler(){}createNodeBuilder(object,renderer){return new GLSLNodeBuilder(object,renderer)}createProgram(program){const gl=this.gl,{stage:stage2,code:code2}=program,shader=stage2==="fragment"?gl.createShader(gl.FRAGMENT_SHADER):gl.createShader(gl.VERTEX_SHADER);gl.shaderSource(shader,code2),gl.compileShader(shader),this.set(program,{shaderGPU:shader})}destroyProgram(program){this.delete(program)}createRenderPipeline(renderObject,promises){const gl=this.gl,pipeline=renderObject.pipeline,{fragmentProgram,vertexProgram}=pipeline,programGPU=gl.createProgram(),fragmentShader=this.get(fragmentProgram).shaderGPU,vertexShader=this.get(vertexProgram).shaderGPU;if(gl.attachShader(programGPU,fragmentShader),gl.attachShader(programGPU,vertexShader),gl.linkProgram(programGPU),this.set(pipeline,{programGPU,fragmentShader,vertexShader}),promises!==null&&this.parallel){const p=new Promise(resolve=>{const parallel=this.parallel,checkStatus=()=>{gl.getProgramParameter(programGPU,parallel.COMPLETION_STATUS_KHR)?(this._completeCompile(renderObject,pipeline),resolve()):requestAnimationFrame(checkStatus)};checkStatus()});promises.push(p);return}this._completeCompile(renderObject,pipeline)}_handleSource(string2,errorLine){const lines=string2.split(`
`),lines2=[],from=Math.max(errorLine-6,0),to=Math.min(errorLine+6,lines.length);for(let i2=from;i2<to;i2++){const line=i2+1;lines2.push(`${line===errorLine?">":" "} ${line}: ${lines[i2]}`)}return lines2.join(`
`)}_getShaderErrors(gl,shader,type){const status=gl.getShaderParameter(shader,gl.COMPILE_STATUS),errors=gl.getShaderInfoLog(shader).trim();if(status&&errors==="")return"";const errorMatches=/ERROR: 0:(\d+)/.exec(errors);if(errorMatches){const errorLine=parseInt(errorMatches[1]);return type.toUpperCase()+`

`+errors+`

`+this._handleSource(gl.getShaderSource(shader),errorLine)}else return errors}_logProgramError(programGPU,glFragmentShader,glVertexShader){if(this.renderer.debug.checkShaderErrors){const gl=this.gl,programLog=gl.getProgramInfoLog(programGPU).trim();if(gl.getProgramParameter(programGPU,gl.LINK_STATUS)===!1)if(typeof this.renderer.debug.onShaderError=="function")this.renderer.debug.onShaderError(gl,programGPU,glVertexShader,glFragmentShader);else{const vertexErrors=this._getShaderErrors(gl,glVertexShader,"vertex"),fragmentErrors=this._getShaderErrors(gl,glFragmentShader,"fragment");console.error("THREE.WebGLProgram: Shader Error "+gl.getError()+" - VALIDATE_STATUS "+gl.getProgramParameter(programGPU,gl.VALIDATE_STATUS)+`

Program Info Log: `+programLog+`
`+vertexErrors+`
`+fragmentErrors)}else programLog!==""&&console.warn("THREE.WebGLProgram: Program Info Log:",programLog)}}_completeCompile(renderObject,pipeline){const{state,gl}=this,pipelineData=this.get(pipeline),{programGPU,fragmentShader,vertexShader}=pipelineData;gl.getProgramParameter(programGPU,gl.LINK_STATUS)===!1&&this._logProgramError(programGPU,fragmentShader,vertexShader),state.useProgram(programGPU);const bindings=renderObject.getBindings();this._setupBindings(bindings,programGPU),this.set(pipeline,{programGPU})}createComputePipeline(computePipeline,bindings){const{state,gl}=this,fragmentProgram={stage:"fragment",code:`#version 300 es
precision highp float;
void main() {}`};this.createProgram(fragmentProgram);const{computeProgram}=computePipeline,programGPU=gl.createProgram(),fragmentShader=this.get(fragmentProgram).shaderGPU,vertexShader=this.get(computeProgram).shaderGPU,transforms2=computeProgram.transforms,transformVaryingNames=[],transformAttributeNodes=[];for(let i2=0;i2<transforms2.length;i2++){const transform2=transforms2[i2];transformVaryingNames.push(transform2.varyingName),transformAttributeNodes.push(transform2.attributeNode)}gl.attachShader(programGPU,fragmentShader),gl.attachShader(programGPU,vertexShader),gl.transformFeedbackVaryings(programGPU,transformVaryingNames,gl.SEPARATE_ATTRIBS),gl.linkProgram(programGPU),gl.getProgramParameter(programGPU,gl.LINK_STATUS)===!1&&this._logProgramError(programGPU,fragmentShader,vertexShader),state.useProgram(programGPU),this._setupBindings(bindings,programGPU);const attributeNodes=computeProgram.attributes,attributes=[],transformBuffers=[];for(let i2=0;i2<attributeNodes.length;i2++){const attribute2=attributeNodes[i2].node.attribute;attributes.push(attribute2),this.has(attribute2)||this.attributeUtils.createAttribute(attribute2,gl.ARRAY_BUFFER)}for(let i2=0;i2<transformAttributeNodes.length;i2++){const attribute2=transformAttributeNodes[i2].attribute;this.has(attribute2)||this.attributeUtils.createAttribute(attribute2,gl.ARRAY_BUFFER);const attributeData=this.get(attribute2);transformBuffers.push(attributeData)}this.set(computePipeline,{programGPU,transformBuffers,attributes})}createBindings(bindGroup,bindings){if(this._knownBindings.has(bindings)===!1){this._knownBindings.add(bindings);let uniformBuffers=0,textures=0;for(const bindGroup2 of bindings){this.set(bindGroup2,{textures,uniformBuffers});for(const binding of bindGroup2.bindings)binding.isUniformBuffer&&uniformBuffers++,binding.isSampledTexture&&textures++}}this.updateBindings(bindGroup,bindings)}updateBindings(bindGroup){const{gl}=this,bindGroupData=this.get(bindGroup);let i2=bindGroupData.uniformBuffers,t2=bindGroupData.textures;for(const binding of bindGroup.bindings)if(binding.isUniformsGroup||binding.isUniformBuffer){const data=binding.buffer,bufferGPU=gl.createBuffer();gl.bindBuffer(gl.UNIFORM_BUFFER,bufferGPU),gl.bufferData(gl.UNIFORM_BUFFER,data,gl.DYNAMIC_DRAW),this.set(binding,{index:i2++,bufferGPU})}else if(binding.isSampledTexture){const{textureGPU,glTextureType}=this.get(binding.texture);this.set(binding,{index:t2++,textureGPU,glTextureType})}}updateBinding(binding){const gl=this.gl;if(binding.isUniformsGroup||binding.isUniformBuffer){const bufferGPU=this.get(binding).bufferGPU,data=binding.buffer;gl.bindBuffer(gl.UNIFORM_BUFFER,bufferGPU),gl.bufferData(gl.UNIFORM_BUFFER,data,gl.DYNAMIC_DRAW)}}createIndexAttribute(attribute2){const gl=this.gl;this.attributeUtils.createAttribute(attribute2,gl.ELEMENT_ARRAY_BUFFER)}createAttribute(attribute2){if(this.has(attribute2))return;const gl=this.gl;this.attributeUtils.createAttribute(attribute2,gl.ARRAY_BUFFER)}createStorageAttribute(attribute2){if(this.has(attribute2))return;const gl=this.gl;this.attributeUtils.createAttribute(attribute2,gl.ARRAY_BUFFER)}updateAttribute(attribute2){this.attributeUtils.updateAttribute(attribute2)}destroyAttribute(attribute2){this.attributeUtils.destroyAttribute(attribute2)}hasFeature(name){const keysMatching=Object.keys(GLFeatureName).filter(key2=>GLFeatureName[key2]===name),extensions=this.extensions;for(let i2=0;i2<keysMatching.length;i2++)if(extensions.has(keysMatching[i2]))return!0;return!1}getMaxAnisotropy(){return this.capabilities.getMaxAnisotropy()}copyTextureToTexture(srcTexture,dstTexture,srcRegion=null,dstPosition=null,level=0){this.textureUtils.copyTextureToTexture(srcTexture,dstTexture,srcRegion,dstPosition,level)}copyFramebufferToTexture(texture2,renderContext,rectangle){this.textureUtils.copyFramebufferToTexture(texture2,renderContext,rectangle)}_setFramebuffer(descriptor){const{gl,state}=this;let currentFrameBuffer=null;if(descriptor.textures!==null){const renderTarget=descriptor.renderTarget,renderTargetContextData=this.get(renderTarget),{samples,depthBuffer,stencilBuffer}=renderTarget,isCube=renderTarget.isWebGLCubeRenderTarget===!0,isRenderTarget3D=renderTarget.isRenderTarget3D===!0,isRenderTargetArray=renderTarget.isRenderTargetArray===!0,isXRRenderTarget=renderTarget.isXRRenderTarget===!0,hasExternalTextures=isXRRenderTarget===!0&&renderTarget.hasExternalTextures===!0;let msaaFb=renderTargetContextData.msaaFrameBuffer,depthRenderbuffer=renderTargetContextData.depthRenderbuffer;const multisampledRTTExt=this.extensions.get("WEBGL_multisampled_render_to_texture"),useMultisampledRTT=this._useMultisampledRTT(renderTarget),cacheKey=getCacheKey$2(descriptor);let fb;if(isCube?(renderTargetContextData.cubeFramebuffers||(renderTargetContextData.cubeFramebuffers={}),fb=renderTargetContextData.cubeFramebuffers[cacheKey]):isXRRenderTarget&&hasExternalTextures===!1?fb=this._xrFramebuffer:(renderTargetContextData.framebuffers||(renderTargetContextData.framebuffers={}),fb=renderTargetContextData.framebuffers[cacheKey]),fb===void 0){fb=gl.createFramebuffer(),state.bindFramebuffer(gl.FRAMEBUFFER,fb);const textures=descriptor.textures;if(isCube){renderTargetContextData.cubeFramebuffers[cacheKey]=fb;const{textureGPU}=this.get(textures[0]),cubeFace=this.renderer._activeCubeFace;gl.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_CUBE_MAP_POSITIVE_X+cubeFace,textureGPU,0)}else{renderTargetContextData.framebuffers[cacheKey]=fb;for(let i2=0;i2<textures.length;i2++){const texture2=textures[i2],textureData=this.get(texture2);textureData.renderTarget=descriptor.renderTarget,textureData.cacheKey=cacheKey;const attachment=gl.COLOR_ATTACHMENT0+i2;if(isRenderTarget3D||isRenderTargetArray){const layer=this.renderer._activeCubeFace;gl.framebufferTextureLayer(gl.FRAMEBUFFER,attachment,textureData.textureGPU,0,layer)}else useMultisampledRTT?multisampledRTTExt.framebufferTexture2DMultisampleEXT(gl.FRAMEBUFFER,attachment,gl.TEXTURE_2D,textureData.textureGPU,0,samples):gl.framebufferTexture2D(gl.FRAMEBUFFER,attachment,gl.TEXTURE_2D,textureData.textureGPU,0)}state.drawBuffers(descriptor,fb)}if(renderTarget.isXRRenderTarget&&renderTarget.autoAllocateDepthBuffer===!0){const renderbuffer=gl.createRenderbuffer();this.textureUtils.setupRenderBufferStorage(renderbuffer,descriptor,0,useMultisampledRTT),renderTargetContextData.xrDepthRenderbuffer=renderbuffer}else if(descriptor.depthTexture!==null){const textureData=this.get(descriptor.depthTexture),depthStyle=stencilBuffer?gl.DEPTH_STENCIL_ATTACHMENT:gl.DEPTH_ATTACHMENT;textureData.renderTarget=descriptor.renderTarget,textureData.cacheKey=cacheKey,useMultisampledRTT?multisampledRTTExt.framebufferTexture2DMultisampleEXT(gl.FRAMEBUFFER,depthStyle,gl.TEXTURE_2D,textureData.textureGPU,0,samples):gl.framebufferTexture2D(gl.FRAMEBUFFER,depthStyle,gl.TEXTURE_2D,textureData.textureGPU,0)}}else if(isXRRenderTarget&&hasExternalTextures){state.bindFramebuffer(gl.FRAMEBUFFER,fb);const textureData=this.get(descriptor.textures[0]);useMultisampledRTT?multisampledRTTExt.framebufferTexture2DMultisampleEXT(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_2D,textureData.textureGPU,0,samples):gl.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,gl.TEXTURE_2D,textureData.textureGPU,0);const depthStyle=stencilBuffer?gl.DEPTH_STENCIL_ATTACHMENT:gl.DEPTH_ATTACHMENT;if(renderTarget.autoAllocateDepthBuffer===!0){const renderbuffer=renderTargetContextData.xrDepthRenderbuffer;gl.bindRenderbuffer(gl.RENDERBUFFER,renderbuffer),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,depthStyle,gl.RENDERBUFFER,renderbuffer)}else{const textureData2=this.get(descriptor.depthTexture);useMultisampledRTT?multisampledRTTExt.framebufferTexture2DMultisampleEXT(gl.FRAMEBUFFER,depthStyle,gl.TEXTURE_2D,textureData2.textureGPU,0,samples):gl.framebufferTexture2D(gl.FRAMEBUFFER,depthStyle,gl.TEXTURE_2D,textureData2.textureGPU,0)}}if(samples>0&&useMultisampledRTT===!1){if(msaaFb===void 0){const invalidationArray=[];msaaFb=gl.createFramebuffer(),state.bindFramebuffer(gl.FRAMEBUFFER,msaaFb);const msaaRenderbuffers=[],textures=descriptor.textures;for(let i2=0;i2<textures.length;i2++){if(msaaRenderbuffers[i2]=gl.createRenderbuffer(),gl.bindRenderbuffer(gl.RENDERBUFFER,msaaRenderbuffers[i2]),invalidationArray.push(gl.COLOR_ATTACHMENT0+i2),depthBuffer){const depthStyle=stencilBuffer?gl.DEPTH_STENCIL_ATTACHMENT:gl.DEPTH_ATTACHMENT;invalidationArray.push(depthStyle)}const texture2=descriptor.textures[i2],textureData=this.get(texture2);gl.renderbufferStorageMultisample(gl.RENDERBUFFER,samples,textureData.glInternalFormat,descriptor.width,descriptor.height),gl.framebufferRenderbuffer(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0+i2,gl.RENDERBUFFER,msaaRenderbuffers[i2])}if(renderTargetContextData.msaaFrameBuffer=msaaFb,renderTargetContextData.msaaRenderbuffers=msaaRenderbuffers,depthRenderbuffer===void 0){depthRenderbuffer=gl.createRenderbuffer(),this.textureUtils.setupRenderBufferStorage(depthRenderbuffer,descriptor,samples),renderTargetContextData.depthRenderbuffer=depthRenderbuffer;const depthStyle=stencilBuffer?gl.DEPTH_STENCIL_ATTACHMENT:gl.DEPTH_ATTACHMENT;invalidationArray.push(depthStyle)}renderTargetContextData.invalidationArray=invalidationArray}currentFrameBuffer=renderTargetContextData.msaaFrameBuffer}else currentFrameBuffer=fb}state.bindFramebuffer(gl.FRAMEBUFFER,currentFrameBuffer)}_getVaoKey(index,attributes){let key2="";if(index!==null){const indexData=this.get(index);key2+=":"+indexData.id}for(let i2=0;i2<attributes.length;i2++){const attributeData=this.get(attributes[i2]);key2+=":"+attributeData.id}return key2}_createVao(index,attributes){const{gl}=this,vaoGPU=gl.createVertexArray();let key2="",staticVao=!0;if(gl.bindVertexArray(vaoGPU),index!==null){const indexData=this.get(index);gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,indexData.bufferGPU),key2+=":"+indexData.id}for(let i2=0;i2<attributes.length;i2++){const attribute2=attributes[i2],attributeData=this.get(attribute2);key2+=":"+attributeData.id,gl.bindBuffer(gl.ARRAY_BUFFER,attributeData.bufferGPU),gl.enableVertexAttribArray(i2),(attribute2.isStorageBufferAttribute||attribute2.isStorageInstancedBufferAttribute)&&(staticVao=!1);let stride,offset;attribute2.isInterleavedBufferAttribute===!0?(stride=attribute2.data.stride*attributeData.bytesPerElement,offset=attribute2.offset*attributeData.bytesPerElement):(stride=0,offset=0),attributeData.isInteger?gl.vertexAttribIPointer(i2,attribute2.itemSize,attributeData.type,stride,offset):gl.vertexAttribPointer(i2,attribute2.itemSize,attributeData.type,attribute2.normalized,stride,offset),attribute2.isInstancedBufferAttribute&&!attribute2.isInterleavedBufferAttribute?gl.vertexAttribDivisor(i2,attribute2.meshPerAttribute):attribute2.isInterleavedBufferAttribute&&attribute2.data.isInstancedInterleavedBuffer&&gl.vertexAttribDivisor(i2,attribute2.data.meshPerAttribute)}return gl.bindBuffer(gl.ARRAY_BUFFER,null),this.vaoCache[key2]=vaoGPU,{vaoGPU,staticVao}}_getTransformFeedback(transformBuffers){let key2="";for(let i2=0;i2<transformBuffers.length;i2++)key2+=":"+transformBuffers[i2].id;let transformFeedbackGPU=this.transformFeedbackCache[key2];if(transformFeedbackGPU!==void 0)return transformFeedbackGPU;const{gl}=this;transformFeedbackGPU=gl.createTransformFeedback(),gl.bindTransformFeedback(gl.TRANSFORM_FEEDBACK,transformFeedbackGPU);for(let i2=0;i2<transformBuffers.length;i2++){const attributeData=transformBuffers[i2];gl.bindBufferBase(gl.TRANSFORM_FEEDBACK_BUFFER,i2,attributeData.transformBuffer)}return gl.bindTransformFeedback(gl.TRANSFORM_FEEDBACK,null),this.transformFeedbackCache[key2]=transformFeedbackGPU,transformFeedbackGPU}_setupBindings(bindings,programGPU){const gl=this.gl;for(const bindGroup of bindings)for(const binding of bindGroup.bindings){const index=this.get(binding).index;if(binding.isUniformsGroup||binding.isUniformBuffer){const location=gl.getUniformBlockIndex(programGPU,binding.name);gl.uniformBlockBinding(programGPU,location,index)}else if(binding.isSampledTexture){const location=gl.getUniformLocation(programGPU,binding.name);gl.uniform1i(location,index)}}}_bindUniforms(bindings){const{gl,state}=this;for(const bindGroup of bindings)for(const binding of bindGroup.bindings){const bindingData=this.get(binding),index=bindingData.index;binding.isUniformsGroup||binding.isUniformBuffer?state.bindBufferBase(gl.UNIFORM_BUFFER,index,bindingData.bufferGPU):binding.isSampledTexture&&state.bindTexture(bindingData.glTextureType,bindingData.textureGPU,gl.TEXTURE0+index)}}_useMultisampledRTT(renderTarget){return renderTarget.samples>0&&this.extensions.has("WEBGL_multisampled_render_to_texture")===!0&&renderTarget.autoAllocateDepthBuffer!==!1}dispose(){const extension=this.extensions.get("WEBGL_lose_context");extension&&extension.loseContext(),this.renderer.domElement.removeEventListener("webglcontextlost",this._onContextLost)}}const GPUPrimitiveTopology={PointList:"point-list",LineList:"line-list",LineStrip:"line-strip",TriangleList:"triangle-list",TriangleStrip:"triangle-strip"},GPUCompareFunction={Never:"never",Less:"less",Equal:"equal",LessEqual:"less-equal",Greater:"greater",NotEqual:"not-equal",GreaterEqual:"greater-equal",Always:"always"},GPUStoreOp={Store:"store"},GPULoadOp={Load:"load",Clear:"clear"},GPUFrontFace={CCW:"ccw"},GPUCullMode={None:"none",Front:"front",Back:"back"},GPUIndexFormat={Uint16:"uint16",Uint32:"uint32"},GPUTextureFormat={R8Unorm:"r8unorm",R8Snorm:"r8snorm",R8Uint:"r8uint",R8Sint:"r8sint",R16Uint:"r16uint",R16Sint:"r16sint",R16Float:"r16float",RG8Unorm:"rg8unorm",RG8Snorm:"rg8snorm",RG8Uint:"rg8uint",RG8Sint:"rg8sint",R32Uint:"r32uint",R32Sint:"r32sint",R32Float:"r32float",RG16Uint:"rg16uint",RG16Sint:"rg16sint",RG16Float:"rg16float",RGBA8Unorm:"rgba8unorm",RGBA8UnormSRGB:"rgba8unorm-srgb",RGBA8Snorm:"rgba8snorm",RGBA8Uint:"rgba8uint",RGBA8Sint:"rgba8sint",BGRA8Unorm:"bgra8unorm",BGRA8UnormSRGB:"bgra8unorm-srgb",RGB9E5UFloat:"rgb9e5ufloat",RGB10A2Unorm:"rgb10a2unorm",RG32Uint:"rg32uint",RG32Sint:"rg32sint",RG32Float:"rg32float",RGBA16Uint:"rgba16uint",RGBA16Sint:"rgba16sint",RGBA16Float:"rgba16float",RGBA32Uint:"rgba32uint",RGBA32Sint:"rgba32sint",RGBA32Float:"rgba32float",Depth16Unorm:"depth16unorm",Depth24Plus:"depth24plus",Depth24PlusStencil8:"depth24plus-stencil8",Depth32Float:"depth32float",Depth32FloatStencil8:"depth32float-stencil8",BC1RGBAUnorm:"bc1-rgba-unorm",BC1RGBAUnormSRGB:"bc1-rgba-unorm-srgb",BC2RGBAUnorm:"bc2-rgba-unorm",BC2RGBAUnormSRGB:"bc2-rgba-unorm-srgb",BC3RGBAUnorm:"bc3-rgba-unorm",BC3RGBAUnormSRGB:"bc3-rgba-unorm-srgb",BC4RUnorm:"bc4-r-unorm",BC5RGUnorm:"bc5-rg-unorm",BC5RGSnorm:"bc5-rg-snorm",BC6HRGBUFloat:"bc6h-rgb-ufloat",BC6HRGBFloat:"bc6h-rgb-float",BC7RGBAUnorm:"bc7-rgba-unorm",BC7RGBAUnormSRGB:"bc7-rgba-srgb",ETC2RGB8Unorm:"etc2-rgb8unorm",ETC2RGB8UnormSRGB:"etc2-rgb8unorm-srgb",ETC2RGB8A1Unorm:"etc2-rgb8a1unorm",ETC2RGB8A1UnormSRGB:"etc2-rgb8a1unorm-srgb",ETC2RGBA8Unorm:"etc2-rgba8unorm",ETC2RGBA8UnormSRGB:"etc2-rgba8unorm-srgb",EACR11Unorm:"eac-r11unorm",EACR11Snorm:"eac-r11snorm",EACRG11Unorm:"eac-rg11unorm",EACRG11Snorm:"eac-rg11snorm",ASTC4x4Unorm:"astc-4x4-unorm",ASTC4x4UnormSRGB:"astc-4x4-unorm-srgb",ASTC5x4Unorm:"astc-5x4-unorm",ASTC5x4UnormSRGB:"astc-5x4-unorm-srgb",ASTC5x5Unorm:"astc-5x5-unorm",ASTC5x5UnormSRGB:"astc-5x5-unorm-srgb",ASTC6x5Unorm:"astc-6x5-unorm",ASTC6x5UnormSRGB:"astc-6x5-unorm-srgb",ASTC6x6Unorm:"astc-6x6-unorm",ASTC6x6UnormSRGB:"astc-6x6-unorm-srgb",ASTC8x5Unorm:"astc-8x5-unorm",ASTC8x5UnormSRGB:"astc-8x5-unorm-srgb",ASTC8x6Unorm:"astc-8x6-unorm",ASTC8x6UnormSRGB:"astc-8x6-unorm-srgb",ASTC8x8Unorm:"astc-8x8-unorm",ASTC8x8UnormSRGB:"astc-8x8-unorm-srgb",ASTC10x5Unorm:"astc-10x5-unorm",ASTC10x5UnormSRGB:"astc-10x5-unorm-srgb",ASTC10x6Unorm:"astc-10x6-unorm",ASTC10x6UnormSRGB:"astc-10x6-unorm-srgb",ASTC10x8Unorm:"astc-10x8-unorm",ASTC10x8UnormSRGB:"astc-10x8-unorm-srgb",ASTC10x10Unorm:"astc-10x10-unorm",ASTC10x10UnormSRGB:"astc-10x10-unorm-srgb",ASTC12x10Unorm:"astc-12x10-unorm",ASTC12x10UnormSRGB:"astc-12x10-unorm-srgb",ASTC12x12Unorm:"astc-12x12-unorm",ASTC12x12UnormSRGB:"astc-12x12-unorm-srgb"},GPUAddressMode={ClampToEdge:"clamp-to-edge",Repeat:"repeat",MirrorRepeat:"mirror-repeat"},GPUFilterMode={Linear:"linear",Nearest:"nearest"},GPUBlendFactor={Zero:"zero",One:"one",Src:"src",OneMinusSrc:"one-minus-src",SrcAlpha:"src-alpha",OneMinusSrcAlpha:"one-minus-src-alpha",Dst:"dst",OneMinusDstColor:"one-minus-dst",DstAlpha:"dst-alpha",OneMinusDstAlpha:"one-minus-dst-alpha",SrcAlphaSaturated:"src-alpha-saturated",Constant:"constant",OneMinusConstant:"one-minus-constant"},GPUBlendOperation={Add:"add",Subtract:"subtract",ReverseSubtract:"reverse-subtract",Min:"min",Max:"max"},GPUColorWriteFlags={None:0,All:15},GPUStencilOperation={Keep:"keep",Zero:"zero",Replace:"replace",Invert:"invert",IncrementClamp:"increment-clamp",DecrementClamp:"decrement-clamp",IncrementWrap:"increment-wrap",DecrementWrap:"decrement-wrap"},GPUBufferBindingType={Storage:"storage",ReadOnlyStorage:"read-only-storage"},GPUStorageTextureAccess={WriteOnly:"write-only",ReadOnly:"read-only",ReadWrite:"read-write"},GPUTextureSampleType={Float:"float",UnfilterableFloat:"unfilterable-float",Depth:"depth",SInt:"sint",UInt:"uint"},GPUTextureDimension={TwoD:"2d",ThreeD:"3d"},GPUTextureViewDimension={TwoD:"2d",TwoDArray:"2d-array",Cube:"cube",ThreeD:"3d"},GPUTextureAspect={All:"all"},GPUInputStepMode={Vertex:"vertex",Instance:"instance"},GPUFeatureName={DepthClipControl:"depth-clip-control",Depth32FloatStencil8:"depth32float-stencil8",TextureCompressionBC:"texture-compression-bc",TextureCompressionETC2:"texture-compression-etc2",TextureCompressionASTC:"texture-compression-astc",TimestampQuery:"timestamp-query",IndirectFirstInstance:"indirect-first-instance",ShaderF16:"shader-f16",RG11B10UFloat:"rg11b10ufloat-renderable",BGRA8UNormStorage:"bgra8unorm-storage",Float32Filterable:"float32-filterable",ClipDistances:"clip-distances",DualSourceBlending:"dual-source-blending",Subgroups:"subgroups"};class Sampler extends Binding{constructor(name,texture2){super(name),this.texture=texture2,this.version=texture2?texture2.version:0,this.isSampler=!0}}class NodeSampler extends Sampler{constructor(name,textureNode,groupNode){super(name,textureNode?textureNode.value:null),this.textureNode=textureNode,this.groupNode=groupNode}update(){this.texture=this.textureNode.value}}class StorageBuffer extends Buffer{constructor(name,attribute2){super(name,attribute2?attribute2.array:null),this.attribute=attribute2,this.isStorageBuffer=!0}}let _id=0;class NodeStorageBuffer extends StorageBuffer{constructor(nodeUniform,groupNode){super("StorageBuffer_"+_id++,nodeUniform?nodeUniform.value:null),this.nodeUniform=nodeUniform,this.access=nodeUniform?nodeUniform.access:NodeAccess.READ_WRITE,this.groupNode=groupNode}get buffer(){return this.nodeUniform.value}}class WebGPUTexturePassUtils extends DataMap{constructor(device){super(),this.device=device;const mipmapVertexSource=`
struct VarysStruct {
	@builtin( position ) Position: vec4<f32>,
	@location( 0 ) vTex : vec2<f32>
};

@vertex
fn main( @builtin( vertex_index ) vertexIndex : u32 ) -> VarysStruct {

	var Varys : VarysStruct;

	var pos = array< vec2<f32>, 4 >(
		vec2<f32>( -1.0,  1.0 ),
		vec2<f32>(  1.0,  1.0 ),
		vec2<f32>( -1.0, -1.0 ),
		vec2<f32>(  1.0, -1.0 )
	);

	var tex = array< vec2<f32>, 4 >(
		vec2<f32>( 0.0, 0.0 ),
		vec2<f32>( 1.0, 0.0 ),
		vec2<f32>( 0.0, 1.0 ),
		vec2<f32>( 1.0, 1.0 )
	);

	Varys.vTex = tex[ vertexIndex ];
	Varys.Position = vec4<f32>( pos[ vertexIndex ], 0.0, 1.0 );

	return Varys;

}
`,mipmapFragmentSource=`
@group( 0 ) @binding( 0 )
var imgSampler : sampler;

@group( 0 ) @binding( 1 )
var img : texture_2d<f32>;

@fragment
fn main( @location( 0 ) vTex : vec2<f32> ) -> @location( 0 ) vec4<f32> {

	return textureSample( img, imgSampler, vTex );

}
`,flipYFragmentSource=`
@group( 0 ) @binding( 0 )
var imgSampler : sampler;

@group( 0 ) @binding( 1 )
var img : texture_2d<f32>;

@fragment
fn main( @location( 0 ) vTex : vec2<f32> ) -> @location( 0 ) vec4<f32> {

	return textureSample( img, imgSampler, vec2( vTex.x, 1.0 - vTex.y ) );

}
`;this.mipmapSampler=device.createSampler({minFilter:GPUFilterMode.Linear}),this.flipYSampler=device.createSampler({minFilter:GPUFilterMode.Nearest}),this.transferPipelines={},this.flipYPipelines={},this.mipmapVertexShaderModule=device.createShaderModule({label:"mipmapVertex",code:mipmapVertexSource}),this.mipmapFragmentShaderModule=device.createShaderModule({label:"mipmapFragment",code:mipmapFragmentSource}),this.flipYFragmentShaderModule=device.createShaderModule({label:"flipYFragment",code:flipYFragmentSource})}getTransferPipeline(format){let pipeline=this.transferPipelines[format];return pipeline===void 0&&(pipeline=this.device.createRenderPipeline({label:`mipmap-${format}`,vertex:{module:this.mipmapVertexShaderModule,entryPoint:"main"},fragment:{module:this.mipmapFragmentShaderModule,entryPoint:"main",targets:[{format}]},primitive:{topology:GPUPrimitiveTopology.TriangleStrip,stripIndexFormat:GPUIndexFormat.Uint32},layout:"auto"}),this.transferPipelines[format]=pipeline),pipeline}getFlipYPipeline(format){let pipeline=this.flipYPipelines[format];return pipeline===void 0&&(pipeline=this.device.createRenderPipeline({label:`flipY-${format}`,vertex:{module:this.mipmapVertexShaderModule,entryPoint:"main"},fragment:{module:this.flipYFragmentShaderModule,entryPoint:"main",targets:[{format}]},primitive:{topology:GPUPrimitiveTopology.TriangleStrip,stripIndexFormat:GPUIndexFormat.Uint32},layout:"auto"}),this.flipYPipelines[format]=pipeline),pipeline}flipY(textureGPU,textureGPUDescriptor,baseArrayLayer=0){const format=textureGPUDescriptor.format,{width,height}=textureGPUDescriptor.size,transferPipeline=this.getTransferPipeline(format),flipYPipeline=this.getFlipYPipeline(format),tempTexture=this.device.createTexture({size:{width,height,depthOrArrayLayers:1},format,usage:GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.TEXTURE_BINDING}),srcView=textureGPU.createView({baseMipLevel:0,mipLevelCount:1,dimension:GPUTextureViewDimension.TwoD,baseArrayLayer}),dstView=tempTexture.createView({baseMipLevel:0,mipLevelCount:1,dimension:GPUTextureViewDimension.TwoD,baseArrayLayer:0}),commandEncoder=this.device.createCommandEncoder({}),pass2=(pipeline,sourceView,destinationView)=>{const bindGroupLayout=pipeline.getBindGroupLayout(0),bindGroup=this.device.createBindGroup({layout:bindGroupLayout,entries:[{binding:0,resource:this.flipYSampler},{binding:1,resource:sourceView}]}),passEncoder=commandEncoder.beginRenderPass({colorAttachments:[{view:destinationView,loadOp:GPULoadOp.Clear,storeOp:GPUStoreOp.Store,clearValue:[0,0,0,0]}]});passEncoder.setPipeline(pipeline),passEncoder.setBindGroup(0,bindGroup),passEncoder.draw(4,1,0,0),passEncoder.end()};pass2(transferPipeline,srcView,dstView),pass2(flipYPipeline,dstView,srcView),this.device.queue.submit([commandEncoder.finish()]),tempTexture.destroy()}generateMipmaps(textureGPU,textureGPUDescriptor,baseArrayLayer=0){const textureData=this.get(textureGPU);textureData.useCount===void 0&&(textureData.useCount=0,textureData.layers=[]);const passes=textureData.layers[baseArrayLayer]||this._mipmapCreateBundles(textureGPU,textureGPUDescriptor,baseArrayLayer),commandEncoder=this.device.createCommandEncoder({});this._mipmapRunBundles(commandEncoder,passes),this.device.queue.submit([commandEncoder.finish()]),textureData.useCount!==0&&(textureData.layers[baseArrayLayer]=passes),textureData.useCount++}_mipmapCreateBundles(textureGPU,textureGPUDescriptor,baseArrayLayer){const pipeline=this.getTransferPipeline(textureGPUDescriptor.format),bindGroupLayout=pipeline.getBindGroupLayout(0);let srcView=textureGPU.createView({baseMipLevel:0,mipLevelCount:1,dimension:GPUTextureViewDimension.TwoD,baseArrayLayer});const passes=[];for(let i2=1;i2<textureGPUDescriptor.mipLevelCount;i2++){const bindGroup=this.device.createBindGroup({layout:bindGroupLayout,entries:[{binding:0,resource:this.mipmapSampler},{binding:1,resource:srcView}]}),dstView=textureGPU.createView({baseMipLevel:i2,mipLevelCount:1,dimension:GPUTextureViewDimension.TwoD,baseArrayLayer}),passDescriptor={colorAttachments:[{view:dstView,loadOp:GPULoadOp.Clear,storeOp:GPUStoreOp.Store,clearValue:[0,0,0,0]}]},passEncoder=this.device.createRenderBundleEncoder({colorFormats:[textureGPUDescriptor.format]});passEncoder.setPipeline(pipeline),passEncoder.setBindGroup(0,bindGroup),passEncoder.draw(4,1,0,0),passes.push({renderBundles:[passEncoder.finish()],passDescriptor}),srcView=dstView}return passes}_mipmapRunBundles(commandEncoder,passes){const levels=passes.length;for(let i2=0;i2<levels;i2++){const pass2=passes[i2],passEncoder=commandEncoder.beginRenderPass(pass2.passDescriptor);passEncoder.executeBundles(pass2.renderBundles),passEncoder.end()}}}const _compareToWebGPU={[NeverCompare]:"never",[LessCompare]:"less",[EqualCompare]:"equal",[LessEqualCompare]:"less-equal",[GreaterCompare]:"greater",[GreaterEqualCompare]:"greater-equal",[AlwaysCompare]:"always",[NotEqualCompare]:"not-equal"},_flipMap=[0,1,3,2,4,5];class WebGPUTextureUtils{constructor(backend){this.backend=backend,this._passUtils=null,this.defaultTexture={},this.defaultCubeTexture={},this.defaultVideoFrame=null,this.colorBuffer=null,this.depthTexture=new DepthTexture,this.depthTexture.name="depthBuffer"}createSampler(texture2){const backend=this.backend,device=backend.device,textureGPU=backend.get(texture2),samplerDescriptorGPU={addressModeU:this._convertAddressMode(texture2.wrapS),addressModeV:this._convertAddressMode(texture2.wrapT),addressModeW:this._convertAddressMode(texture2.wrapR),magFilter:this._convertFilterMode(texture2.magFilter),minFilter:this._convertFilterMode(texture2.minFilter),mipmapFilter:this._convertFilterMode(texture2.minFilter),maxAnisotropy:1};samplerDescriptorGPU.magFilter===GPUFilterMode.Linear&&samplerDescriptorGPU.minFilter===GPUFilterMode.Linear&&samplerDescriptorGPU.mipmapFilter===GPUFilterMode.Linear&&(samplerDescriptorGPU.maxAnisotropy=texture2.anisotropy),texture2.isDepthTexture&&texture2.compareFunction!==null&&(samplerDescriptorGPU.compare=_compareToWebGPU[texture2.compareFunction]),textureGPU.sampler=device.createSampler(samplerDescriptorGPU)}createDefaultTexture(texture2){let textureGPU;const format=getFormat(texture2);texture2.isCubeTexture?textureGPU=this._getDefaultCubeTextureGPU(format):texture2.isVideoTexture?this.backend.get(texture2).externalTexture=this._getDefaultVideoFrame():textureGPU=this._getDefaultTextureGPU(format),this.backend.get(texture2).texture=textureGPU}createTexture(texture2,options={}){const backend=this.backend,textureData=backend.get(texture2);if(textureData.initialized)throw new Error("WebGPUTextureUtils: Texture already initialized.");options.needsMipmaps===void 0&&(options.needsMipmaps=!1),options.levels===void 0&&(options.levels=1),options.depth===void 0&&(options.depth=1);const{width,height,depth:depth2,levels}=options;texture2.isFramebufferTexture&&(options.renderTarget?options.format=this.backend.utils.getCurrentColorFormat(options.renderTarget):options.format=this.backend.utils.getPreferredCanvasFormat());const dimension=this._getDimension(texture2),format=texture2.internalFormat||options.format||getFormat(texture2,backend.device);textureData.format=format;const{samples,primarySamples,isMSAA}=backend.utils.getTextureSampleData(texture2);let usage=GPUTextureUsage.TEXTURE_BINDING|GPUTextureUsage.COPY_DST|GPUTextureUsage.COPY_SRC;texture2.isStorageTexture===!0&&(usage|=GPUTextureUsage.STORAGE_BINDING),texture2.isCompressedTexture!==!0&&texture2.isCompressedArrayTexture!==!0&&(usage|=GPUTextureUsage.RENDER_ATTACHMENT);const textureDescriptorGPU={label:texture2.name,size:{width,height,depthOrArrayLayers:depth2},mipLevelCount:levels,sampleCount:primarySamples,dimension,format,usage};if(texture2.isVideoTexture){const video=texture2.source.data,videoFrame=new VideoFrame(video);textureDescriptorGPU.size.width=videoFrame.displayWidth,textureDescriptorGPU.size.height=videoFrame.displayHeight,videoFrame.close(),textureData.externalTexture=video}else{if(format===void 0)return console.warn("WebGPURenderer: Texture format not supported."),this.createDefaultTexture(texture2);textureData.texture=backend.device.createTexture(textureDescriptorGPU)}if(isMSAA){const msaaTextureDescriptorGPU=Object.assign({},textureDescriptorGPU);msaaTextureDescriptorGPU.label=msaaTextureDescriptorGPU.label+"-msaa",msaaTextureDescriptorGPU.sampleCount=samples,textureData.msaaTexture=backend.device.createTexture(msaaTextureDescriptorGPU)}textureData.initialized=!0,textureData.textureDescriptorGPU=textureDescriptorGPU}destroyTexture(texture2){const backend=this.backend,textureData=backend.get(texture2);textureData.texture!==void 0&&textureData.texture.destroy(),textureData.msaaTexture!==void 0&&textureData.msaaTexture.destroy(),backend.delete(texture2)}destroySampler(texture2){const textureData=this.backend.get(texture2);delete textureData.sampler}generateMipmaps(texture2){const textureData=this.backend.get(texture2);if(texture2.isCubeTexture)for(let i2=0;i2<6;i2++)this._generateMipmaps(textureData.texture,textureData.textureDescriptorGPU,i2);else{const depth2=texture2.image.depth||1;for(let i2=0;i2<depth2;i2++)this._generateMipmaps(textureData.texture,textureData.textureDescriptorGPU,i2)}}getColorBuffer(){this.colorBuffer&&this.colorBuffer.destroy();const backend=this.backend,{width,height}=backend.getDrawingBufferSize();return this.colorBuffer=backend.device.createTexture({label:"colorBuffer",size:{width,height,depthOrArrayLayers:1},sampleCount:backend.utils.getSampleCount(backend.renderer.samples),format:backend.utils.getPreferredCanvasFormat(),usage:GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.COPY_SRC}),this.colorBuffer}getDepthBuffer(depth2=!0,stencil=!1){const backend=this.backend,{width,height}=backend.getDrawingBufferSize(),depthTexture=this.depthTexture,depthTextureGPU=backend.get(depthTexture).texture;let format,type;if(stencil?(format=DepthStencilFormat,type=UnsignedInt248Type):depth2&&(format=DepthFormat,type=UnsignedIntType),depthTextureGPU!==void 0){if(depthTexture.image.width===width&&depthTexture.image.height===height&&depthTexture.format===format&&depthTexture.type===type)return depthTextureGPU;this.destroyTexture(depthTexture)}return depthTexture.name="depthBuffer",depthTexture.format=format,depthTexture.type=type,depthTexture.image.width=width,depthTexture.image.height=height,this.createTexture(depthTexture,{width,height}),backend.get(depthTexture).texture}updateTexture(texture2,options){const textureData=this.backend.get(texture2),{textureDescriptorGPU}=textureData;if(!(texture2.isRenderTargetTexture||textureDescriptorGPU===void 0)){if(texture2.isDataTexture)this._copyBufferToTexture(options.image,textureData.texture,textureDescriptorGPU,0,texture2.flipY);else if(texture2.isDataArrayTexture||texture2.isData3DTexture)for(let i2=0;i2<options.image.depth;i2++)this._copyBufferToTexture(options.image,textureData.texture,textureDescriptorGPU,i2,texture2.flipY,i2);else if(texture2.isCompressedTexture||texture2.isCompressedArrayTexture)this._copyCompressedBufferToTexture(texture2.mipmaps,textureData.texture,textureDescriptorGPU);else if(texture2.isCubeTexture)this._copyCubeMapToTexture(options.images,textureData.texture,textureDescriptorGPU,texture2.flipY);else if(texture2.isVideoTexture){const video=texture2.source.data;textureData.externalTexture=video}else this._copyImageToTexture(options.image,textureData.texture,textureDescriptorGPU,0,texture2.flipY);textureData.version=texture2.version,texture2.onUpdate&&texture2.onUpdate(texture2)}}async copyTextureToBuffer(texture2,x,y,width,height,faceIndex){const device=this.backend.device,textureData=this.backend.get(texture2),textureGPU=textureData.texture,format=textureData.textureDescriptorGPU.format,bytesPerTexel=this._getBytesPerTexel(format);let bytesPerRow=width*bytesPerTexel;bytesPerRow=Math.ceil(bytesPerRow/256)*256;const readBuffer=device.createBuffer({size:width*height*bytesPerTexel,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ}),encoder=device.createCommandEncoder();encoder.copyTextureToBuffer({texture:textureGPU,origin:{x,y,z:faceIndex}},{buffer:readBuffer,bytesPerRow},{width,height});const typedArrayType=this._getTypedArrayType(format);device.queue.submit([encoder.finish()]),await readBuffer.mapAsync(GPUMapMode.READ);const buffer2=readBuffer.getMappedRange();return new typedArrayType(buffer2)}_isEnvironmentTexture(texture2){const mapping=texture2.mapping;return mapping===EquirectangularReflectionMapping||mapping===EquirectangularRefractionMapping||mapping===CubeReflectionMapping||mapping===CubeRefractionMapping}_getDefaultTextureGPU(format){let defaultTexture=this.defaultTexture[format];if(defaultTexture===void 0){const texture2=new Texture;texture2.minFilter=NearestFilter,texture2.magFilter=NearestFilter,this.createTexture(texture2,{width:1,height:1,format}),this.defaultTexture[format]=defaultTexture=texture2}return this.backend.get(defaultTexture).texture}_getDefaultCubeTextureGPU(format){let defaultCubeTexture=this.defaultTexture[format];if(defaultCubeTexture===void 0){const texture2=new CubeTexture;texture2.minFilter=NearestFilter,texture2.magFilter=NearestFilter,this.createTexture(texture2,{width:1,height:1,depth:6}),this.defaultCubeTexture[format]=defaultCubeTexture=texture2}return this.backend.get(defaultCubeTexture).texture}_getDefaultVideoFrame(){let defaultVideoFrame=this.defaultVideoFrame;if(defaultVideoFrame===null){const init={timestamp:0,codedWidth:1,codedHeight:1,format:"RGBA"};this.defaultVideoFrame=defaultVideoFrame=new VideoFrame(new Uint8Array([0,0,0,255]),init)}return defaultVideoFrame}_copyCubeMapToTexture(images,textureGPU,textureDescriptorGPU,flipY){for(let i2=0;i2<6;i2++){const image=images[i2],flipIndex=flipY===!0?_flipMap[i2]:i2;image.isDataTexture?this._copyBufferToTexture(image.image,textureGPU,textureDescriptorGPU,flipIndex,flipY):this._copyImageToTexture(image,textureGPU,textureDescriptorGPU,flipIndex,flipY)}}_copyImageToTexture(image,textureGPU,textureDescriptorGPU,originDepth,flipY){this.backend.device.queue.copyExternalImageToTexture({source:image,flipY},{texture:textureGPU,mipLevel:0,origin:{x:0,y:0,z:originDepth}},{width:image.width,height:image.height,depthOrArrayLayers:1})}_getPassUtils(){let passUtils=this._passUtils;return passUtils===null&&(this._passUtils=passUtils=new WebGPUTexturePassUtils(this.backend.device)),passUtils}_generateMipmaps(textureGPU,textureDescriptorGPU,baseArrayLayer=0){this._getPassUtils().generateMipmaps(textureGPU,textureDescriptorGPU,baseArrayLayer)}_flipY(textureGPU,textureDescriptorGPU,originDepth=0){this._getPassUtils().flipY(textureGPU,textureDescriptorGPU,originDepth)}_copyBufferToTexture(image,textureGPU,textureDescriptorGPU,originDepth,flipY,depth2=0){const device=this.backend.device,data=image.data,bytesPerTexel=this._getBytesPerTexel(textureDescriptorGPU.format),bytesPerRow=image.width*bytesPerTexel;device.queue.writeTexture({texture:textureGPU,mipLevel:0,origin:{x:0,y:0,z:originDepth}},data,{offset:image.width*image.height*bytesPerTexel*depth2,bytesPerRow},{width:image.width,height:image.height,depthOrArrayLayers:1}),flipY===!0&&this._flipY(textureGPU,textureDescriptorGPU,originDepth)}_copyCompressedBufferToTexture(mipmaps,textureGPU,textureDescriptorGPU){const device=this.backend.device,blockData=this._getBlockData(textureDescriptorGPU.format),isTextureArray=textureDescriptorGPU.size.depthOrArrayLayers>1;for(let i2=0;i2<mipmaps.length;i2++){const mipmap=mipmaps[i2],width=mipmap.width,height=mipmap.height,depth2=isTextureArray?textureDescriptorGPU.size.depthOrArrayLayers:1,bytesPerRow=Math.ceil(width/blockData.width)*blockData.byteLength,bytesPerImage=bytesPerRow*Math.ceil(height/blockData.height);for(let j=0;j<depth2;j++)device.queue.writeTexture({texture:textureGPU,mipLevel:i2,origin:{x:0,y:0,z:j}},mipmap.data,{offset:j*bytesPerImage,bytesPerRow,rowsPerImage:Math.ceil(height/blockData.height)},{width:Math.ceil(width/blockData.width)*blockData.width,height:Math.ceil(height/blockData.height)*blockData.height,depthOrArrayLayers:1})}}_getBlockData(format){if(format===GPUTextureFormat.BC1RGBAUnorm||format===GPUTextureFormat.BC1RGBAUnormSRGB)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.BC2RGBAUnorm||format===GPUTextureFormat.BC2RGBAUnormSRGB)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.BC3RGBAUnorm||format===GPUTextureFormat.BC3RGBAUnormSRGB)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.BC4RUnorm||format===GPUTextureFormat.BC4RSNorm)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.BC5RGUnorm||format===GPUTextureFormat.BC5RGSnorm)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.BC6HRGBUFloat||format===GPUTextureFormat.BC6HRGBFloat)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.BC7RGBAUnorm||format===GPUTextureFormat.BC7RGBAUnormSRGB)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.ETC2RGB8Unorm||format===GPUTextureFormat.ETC2RGB8UnormSRGB)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.ETC2RGB8A1Unorm||format===GPUTextureFormat.ETC2RGB8A1UnormSRGB)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.ETC2RGBA8Unorm||format===GPUTextureFormat.ETC2RGBA8UnormSRGB)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.EACR11Unorm)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.EACR11Snorm)return{byteLength:8,width:4,height:4};if(format===GPUTextureFormat.EACRG11Unorm)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.EACRG11Snorm)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.ASTC4x4Unorm||format===GPUTextureFormat.ASTC4x4UnormSRGB)return{byteLength:16,width:4,height:4};if(format===GPUTextureFormat.ASTC5x4Unorm||format===GPUTextureFormat.ASTC5x4UnormSRGB)return{byteLength:16,width:5,height:4};if(format===GPUTextureFormat.ASTC5x5Unorm||format===GPUTextureFormat.ASTC5x5UnormSRGB)return{byteLength:16,width:5,height:5};if(format===GPUTextureFormat.ASTC6x5Unorm||format===GPUTextureFormat.ASTC6x5UnormSRGB)return{byteLength:16,width:6,height:5};if(format===GPUTextureFormat.ASTC6x6Unorm||format===GPUTextureFormat.ASTC6x6UnormSRGB)return{byteLength:16,width:6,height:6};if(format===GPUTextureFormat.ASTC8x5Unorm||format===GPUTextureFormat.ASTC8x5UnormSRGB)return{byteLength:16,width:8,height:5};if(format===GPUTextureFormat.ASTC8x6Unorm||format===GPUTextureFormat.ASTC8x6UnormSRGB)return{byteLength:16,width:8,height:6};if(format===GPUTextureFormat.ASTC8x8Unorm||format===GPUTextureFormat.ASTC8x8UnormSRGB)return{byteLength:16,width:8,height:8};if(format===GPUTextureFormat.ASTC10x5Unorm||format===GPUTextureFormat.ASTC10x5UnormSRGB)return{byteLength:16,width:10,height:5};if(format===GPUTextureFormat.ASTC10x6Unorm||format===GPUTextureFormat.ASTC10x6UnormSRGB)return{byteLength:16,width:10,height:6};if(format===GPUTextureFormat.ASTC10x8Unorm||format===GPUTextureFormat.ASTC10x8UnormSRGB)return{byteLength:16,width:10,height:8};if(format===GPUTextureFormat.ASTC10x10Unorm||format===GPUTextureFormat.ASTC10x10UnormSRGB)return{byteLength:16,width:10,height:10};if(format===GPUTextureFormat.ASTC12x10Unorm||format===GPUTextureFormat.ASTC12x10UnormSRGB)return{byteLength:16,width:12,height:10};if(format===GPUTextureFormat.ASTC12x12Unorm||format===GPUTextureFormat.ASTC12x12UnormSRGB)return{byteLength:16,width:12,height:12}}_convertAddressMode(value){let addressMode=GPUAddressMode.ClampToEdge;return value===RepeatWrapping?addressMode=GPUAddressMode.Repeat:value===MirroredRepeatWrapping&&(addressMode=GPUAddressMode.MirrorRepeat),addressMode}_convertFilterMode(value){let filterMode=GPUFilterMode.Linear;return(value===NearestFilter||value===NearestMipmapNearestFilter||value===NearestMipmapLinearFilter)&&(filterMode=GPUFilterMode.Nearest),filterMode}_getBytesPerTexel(format){if(format===GPUTextureFormat.R8Unorm||format===GPUTextureFormat.R8Snorm||format===GPUTextureFormat.R8Uint||format===GPUTextureFormat.R8Sint)return 1;if(format===GPUTextureFormat.R16Uint||format===GPUTextureFormat.R16Sint||format===GPUTextureFormat.R16Float||format===GPUTextureFormat.RG8Unorm||format===GPUTextureFormat.RG8Snorm||format===GPUTextureFormat.RG8Uint||format===GPUTextureFormat.RG8Sint)return 2;if(format===GPUTextureFormat.R32Uint||format===GPUTextureFormat.R32Sint||format===GPUTextureFormat.R32Float||format===GPUTextureFormat.RG16Uint||format===GPUTextureFormat.RG16Sint||format===GPUTextureFormat.RG16Float||format===GPUTextureFormat.RGBA8Unorm||format===GPUTextureFormat.RGBA8UnormSRGB||format===GPUTextureFormat.RGBA8Snorm||format===GPUTextureFormat.RGBA8Uint||format===GPUTextureFormat.RGBA8Sint||format===GPUTextureFormat.BGRA8Unorm||format===GPUTextureFormat.BGRA8UnormSRGB||format===GPUTextureFormat.RGB9E5UFloat||format===GPUTextureFormat.RGB10A2Unorm||format===GPUTextureFormat.RG11B10UFloat||format===GPUTextureFormat.Depth32Float||format===GPUTextureFormat.Depth24Plus||format===GPUTextureFormat.Depth24PlusStencil8||format===GPUTextureFormat.Depth32FloatStencil8)return 4;if(format===GPUTextureFormat.RG32Uint||format===GPUTextureFormat.RG32Sint||format===GPUTextureFormat.RG32Float||format===GPUTextureFormat.RGBA16Uint||format===GPUTextureFormat.RGBA16Sint||format===GPUTextureFormat.RGBA16Float)return 8;if(format===GPUTextureFormat.RGBA32Uint||format===GPUTextureFormat.RGBA32Sint||format===GPUTextureFormat.RGBA32Float)return 16}_getTypedArrayType(format){if(format===GPUTextureFormat.R8Uint)return Uint8Array;if(format===GPUTextureFormat.R8Sint)return Int8Array;if(format===GPUTextureFormat.R8Unorm)return Uint8Array;if(format===GPUTextureFormat.R8Snorm)return Int8Array;if(format===GPUTextureFormat.RG8Uint)return Uint8Array;if(format===GPUTextureFormat.RG8Sint)return Int8Array;if(format===GPUTextureFormat.RG8Unorm)return Uint8Array;if(format===GPUTextureFormat.RG8Snorm)return Int8Array;if(format===GPUTextureFormat.RGBA8Uint)return Uint8Array;if(format===GPUTextureFormat.RGBA8Sint)return Int8Array;if(format===GPUTextureFormat.RGBA8Unorm)return Uint8Array;if(format===GPUTextureFormat.RGBA8Snorm)return Int8Array;if(format===GPUTextureFormat.R16Uint)return Uint16Array;if(format===GPUTextureFormat.R16Sint)return Int16Array;if(format===GPUTextureFormat.RG16Uint)return Uint16Array;if(format===GPUTextureFormat.RG16Sint)return Int16Array;if(format===GPUTextureFormat.RGBA16Uint)return Uint16Array;if(format===GPUTextureFormat.RGBA16Sint)return Int16Array;if(format===GPUTextureFormat.R16Float||format===GPUTextureFormat.RG16Float||format===GPUTextureFormat.RGBA16Float)return Uint16Array;if(format===GPUTextureFormat.R32Uint)return Uint32Array;if(format===GPUTextureFormat.R32Sint)return Int32Array;if(format===GPUTextureFormat.R32Float)return Float32Array;if(format===GPUTextureFormat.RG32Uint)return Uint32Array;if(format===GPUTextureFormat.RG32Sint)return Int32Array;if(format===GPUTextureFormat.RG32Float)return Float32Array;if(format===GPUTextureFormat.RGBA32Uint)return Uint32Array;if(format===GPUTextureFormat.RGBA32Sint)return Int32Array;if(format===GPUTextureFormat.RGBA32Float)return Float32Array;if(format===GPUTextureFormat.BGRA8Unorm||format===GPUTextureFormat.BGRA8UnormSRGB)return Uint8Array;if(format===GPUTextureFormat.RGB10A2Unorm||format===GPUTextureFormat.RGB9E5UFloat||format===GPUTextureFormat.RG11B10UFloat)return Uint32Array;if(format===GPUTextureFormat.Depth32Float)return Float32Array;if(format===GPUTextureFormat.Depth24Plus||format===GPUTextureFormat.Depth24PlusStencil8)return Uint32Array;if(format===GPUTextureFormat.Depth32FloatStencil8)return Float32Array}_getDimension(texture2){let dimension;return texture2.isData3DTexture?dimension=GPUTextureDimension.ThreeD:dimension=GPUTextureDimension.TwoD,dimension}}function getFormat(texture2,device=null){const format=texture2.format,type=texture2.type,colorSpace=texture2.colorSpace;let formatGPU;if(texture2.isCompressedTexture===!0||texture2.isCompressedArrayTexture===!0)switch(format){case RGBA_S3TC_DXT1_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.BC1RGBAUnormSRGB:GPUTextureFormat.BC1RGBAUnorm;break;case RGBA_S3TC_DXT3_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.BC2RGBAUnormSRGB:GPUTextureFormat.BC2RGBAUnorm;break;case RGBA_S3TC_DXT5_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.BC3RGBAUnormSRGB:GPUTextureFormat.BC3RGBAUnorm;break;case RGB_ETC2_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ETC2RGB8UnormSRGB:GPUTextureFormat.ETC2RGB8Unorm;break;case RGBA_ETC2_EAC_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ETC2RGBA8UnormSRGB:GPUTextureFormat.ETC2RGBA8Unorm;break;case RGBA_ASTC_4x4_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC4x4UnormSRGB:GPUTextureFormat.ASTC4x4Unorm;break;case RGBA_ASTC_5x4_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC5x4UnormSRGB:GPUTextureFormat.ASTC5x4Unorm;break;case RGBA_ASTC_5x5_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC5x5UnormSRGB:GPUTextureFormat.ASTC5x5Unorm;break;case RGBA_ASTC_6x5_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC6x5UnormSRGB:GPUTextureFormat.ASTC6x5Unorm;break;case RGBA_ASTC_6x6_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC6x6UnormSRGB:GPUTextureFormat.ASTC6x6Unorm;break;case RGBA_ASTC_8x5_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC8x5UnormSRGB:GPUTextureFormat.ASTC8x5Unorm;break;case RGBA_ASTC_8x6_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC8x6UnormSRGB:GPUTextureFormat.ASTC8x6Unorm;break;case RGBA_ASTC_8x8_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC8x8UnormSRGB:GPUTextureFormat.ASTC8x8Unorm;break;case RGBA_ASTC_10x5_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC10x5UnormSRGB:GPUTextureFormat.ASTC10x5Unorm;break;case RGBA_ASTC_10x6_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC10x6UnormSRGB:GPUTextureFormat.ASTC10x6Unorm;break;case RGBA_ASTC_10x8_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC10x8UnormSRGB:GPUTextureFormat.ASTC10x8Unorm;break;case RGBA_ASTC_10x10_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC10x10UnormSRGB:GPUTextureFormat.ASTC10x10Unorm;break;case RGBA_ASTC_12x10_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC12x10UnormSRGB:GPUTextureFormat.ASTC12x10Unorm;break;case RGBA_ASTC_12x12_Format:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.ASTC12x12UnormSRGB:GPUTextureFormat.ASTC12x12Unorm;break;case RGBAFormat:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.RGBA8UnormSRGB:GPUTextureFormat.RGBA8Unorm;break;default:console.error("WebGPURenderer: Unsupported texture format.",format)}else switch(format){case RGBAFormat:switch(type){case ByteType:formatGPU=GPUTextureFormat.RGBA8Snorm;break;case ShortType:formatGPU=GPUTextureFormat.RGBA16Sint;break;case UnsignedShortType:formatGPU=GPUTextureFormat.RGBA16Uint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.RGBA32Uint;break;case IntType:formatGPU=GPUTextureFormat.RGBA32Sint;break;case UnsignedByteType:formatGPU=colorSpace===SRGBColorSpace?GPUTextureFormat.RGBA8UnormSRGB:GPUTextureFormat.RGBA8Unorm;break;case HalfFloatType:formatGPU=GPUTextureFormat.RGBA16Float;break;case FloatType:formatGPU=GPUTextureFormat.RGBA32Float;break;default:console.error("WebGPURenderer: Unsupported texture type with RGBAFormat.",type)}break;case RGBFormat:switch(type){case UnsignedInt5999Type:formatGPU=GPUTextureFormat.RGB9E5UFloat;break;default:console.error("WebGPURenderer: Unsupported texture type with RGBFormat.",type)}break;case RedFormat:switch(type){case ByteType:formatGPU=GPUTextureFormat.R8Snorm;break;case ShortType:formatGPU=GPUTextureFormat.R16Sint;break;case UnsignedShortType:formatGPU=GPUTextureFormat.R16Uint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.R32Uint;break;case IntType:formatGPU=GPUTextureFormat.R32Sint;break;case UnsignedByteType:formatGPU=GPUTextureFormat.R8Unorm;break;case HalfFloatType:formatGPU=GPUTextureFormat.R16Float;break;case FloatType:formatGPU=GPUTextureFormat.R32Float;break;default:console.error("WebGPURenderer: Unsupported texture type with RedFormat.",type)}break;case RGFormat:switch(type){case ByteType:formatGPU=GPUTextureFormat.RG8Snorm;break;case ShortType:formatGPU=GPUTextureFormat.RG16Sint;break;case UnsignedShortType:formatGPU=GPUTextureFormat.RG16Uint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.RG32Uint;break;case IntType:formatGPU=GPUTextureFormat.RG32Sint;break;case UnsignedByteType:formatGPU=GPUTextureFormat.RG8Unorm;break;case HalfFloatType:formatGPU=GPUTextureFormat.RG16Float;break;case FloatType:formatGPU=GPUTextureFormat.RG32Float;break;default:console.error("WebGPURenderer: Unsupported texture type with RGFormat.",type)}break;case DepthFormat:switch(type){case UnsignedShortType:formatGPU=GPUTextureFormat.Depth16Unorm;break;case UnsignedIntType:formatGPU=GPUTextureFormat.Depth24Plus;break;case FloatType:formatGPU=GPUTextureFormat.Depth32Float;break;default:console.error("WebGPURenderer: Unsupported texture type with DepthFormat.",type)}break;case DepthStencilFormat:switch(type){case UnsignedInt248Type:formatGPU=GPUTextureFormat.Depth24PlusStencil8;break;case FloatType:device&&device.features.has(GPUFeatureName.Depth32FloatStencil8)===!1&&console.error('WebGPURenderer: Depth textures with DepthStencilFormat + FloatType can only be used with the "depth32float-stencil8" GPU feature.'),formatGPU=GPUTextureFormat.Depth32FloatStencil8;break;default:console.error("WebGPURenderer: Unsupported texture type with DepthStencilFormat.",type)}break;case RedIntegerFormat:switch(type){case IntType:formatGPU=GPUTextureFormat.R32Sint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.R32Uint;break;default:console.error("WebGPURenderer: Unsupported texture type with RedIntegerFormat.",type)}break;case RGIntegerFormat:switch(type){case IntType:formatGPU=GPUTextureFormat.RG32Sint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.RG32Uint;break;default:console.error("WebGPURenderer: Unsupported texture type with RGIntegerFormat.",type)}break;case RGBAIntegerFormat:switch(type){case IntType:formatGPU=GPUTextureFormat.RGBA32Sint;break;case UnsignedIntType:formatGPU=GPUTextureFormat.RGBA32Uint;break;default:console.error("WebGPURenderer: Unsupported texture type with RGBAIntegerFormat.",type)}break;default:console.error("WebGPURenderer: Unsupported texture format.",format)}return formatGPU}const declarationRegexp=/^[fn]*\s*([a-z_0-9]+)?\s*\(([\s\S]*?)\)\s*[\-\>]*\s*([a-z_0-9]+(?:<[\s\S]+?>)?)/i,propertiesRegexp=/([a-z_0-9]+)\s*:\s*([a-z_0-9]+(?:<[\s\S]+?>)?)/ig,wgslTypeLib$1={f32:"float",i32:"int",u32:"uint",bool:"bool","vec2<f32>":"vec2","vec2<i32>":"ivec2","vec2<u32>":"uvec2","vec2<bool>":"bvec2",vec2f:"vec2",vec2i:"ivec2",vec2u:"uvec2",vec2b:"bvec2","vec3<f32>":"vec3","vec3<i32>":"ivec3","vec3<u32>":"uvec3","vec3<bool>":"bvec3",vec3f:"vec3",vec3i:"ivec3",vec3u:"uvec3",vec3b:"bvec3","vec4<f32>":"vec4","vec4<i32>":"ivec4","vec4<u32>":"uvec4","vec4<bool>":"bvec4",vec4f:"vec4",vec4i:"ivec4",vec4u:"uvec4",vec4b:"bvec4","mat2x2<f32>":"mat2",mat2x2f:"mat2","mat3x3<f32>":"mat3",mat3x3f:"mat3","mat4x4<f32>":"mat4",mat4x4f:"mat4",sampler:"sampler",texture_1d:"texture",texture_2d:"texture",texture_2d_array:"texture",texture_multisampled_2d:"cubeTexture",texture_depth_2d:"depthTexture",texture_depth_multisampled_2d:"depthTexture",texture_3d:"texture3D",texture_cube:"cubeTexture",texture_cube_array:"cubeTexture",texture_storage_1d:"storageTexture",texture_storage_2d:"storageTexture",texture_storage_2d_array:"storageTexture",texture_storage_3d:"storageTexture"},parse$2=source=>{source=source.trim();const declaration=source.match(declarationRegexp);if(declaration!==null&&declaration.length===4){const inputsCode=declaration[2],propsMatches=[];let match=null;for(;(match=propertiesRegexp.exec(inputsCode))!==null;)propsMatches.push({name:match[1],type:match[2]});const inputs=[];for(let i2=0;i2<propsMatches.length;i2++){const{name:name2,type:type2}=propsMatches[i2];let resolvedType=type2;resolvedType.startsWith("ptr")?resolvedType="pointer":(resolvedType.startsWith("texture")&&(resolvedType=type2.split("<")[0]),resolvedType=wgslTypeLib$1[resolvedType]),inputs.push(new NodeFunctionInput(resolvedType,name2))}const blockCode=source.substring(declaration[0].length),outputType=declaration[3]||"void",name=declaration[1]!==void 0?declaration[1]:"";return{type:wgslTypeLib$1[outputType]||outputType,inputs,name,inputsCode,blockCode,outputType}}else throw new Error("FunctionNode: Function is not a WGSL code.")};class WGSLNodeFunction extends NodeFunction{constructor(source){const{type,inputs,name,inputsCode,blockCode,outputType}=parse$2(source);super(type,inputs,name),this.inputsCode=inputsCode,this.blockCode=blockCode,this.outputType=outputType}getCode(name=this.name){const outputType=this.outputType!=="void"?"-> "+this.outputType:"";return`fn ${name} ( ${this.inputsCode.trim()} ) ${outputType}`+this.blockCode}}class WGSLNodeParser extends NodeParser{parseFunction(source){return new WGSLNodeFunction(source)}}const GPUShaderStage=typeof self<"u"?self.GPUShaderStage:{VERTEX:1,FRAGMENT:2,COMPUTE:4},accessNames={[NodeAccess.READ_ONLY]:"read",[NodeAccess.WRITE_ONLY]:"write",[NodeAccess.READ_WRITE]:"read_write"},wrapNames={[RepeatWrapping]:"repeat",[ClampToEdgeWrapping]:"clamp",[MirroredRepeatWrapping]:"mirror"},gpuShaderStageLib={vertex:GPUShaderStage?GPUShaderStage.VERTEX:1,fragment:GPUShaderStage?GPUShaderStage.FRAGMENT:2,compute:GPUShaderStage?GPUShaderStage.COMPUTE:4},supports={instance:!0,swizzleAssign:!1,storageBuffer:!0},wgslFnOpLib={"^^":"tsl_xor"},wgslTypeLib={float:"f32",int:"i32",uint:"u32",bool:"bool",color:"vec3<f32>",vec2:"vec2<f32>",ivec2:"vec2<i32>",uvec2:"vec2<u32>",bvec2:"vec2<bool>",vec3:"vec3<f32>",ivec3:"vec3<i32>",uvec3:"vec3<u32>",bvec3:"vec3<bool>",vec4:"vec4<f32>",ivec4:"vec4<i32>",uvec4:"vec4<u32>",bvec4:"vec4<bool>",mat2:"mat2x2<f32>",mat3:"mat3x3<f32>",mat4:"mat4x4<f32>"},wgslCodeCache={},wgslPolyfill={tsl_xor:new CodeNode("fn tsl_xor( a : bool, b : bool ) -> bool { return ( a || b ) && !( a && b ); }"),mod_float:new CodeNode("fn tsl_mod_float( x : f32, y : f32 ) -> f32 { return x - y * floor( x / y ); }"),mod_vec2:new CodeNode("fn tsl_mod_vec2( x : vec2f, y : vec2f ) -> vec2f { return x - y * floor( x / y ); }"),mod_vec3:new CodeNode("fn tsl_mod_vec3( x : vec3f, y : vec3f ) -> vec3f { return x - y * floor( x / y ); }"),mod_vec4:new CodeNode("fn tsl_mod_vec4( x : vec4f, y : vec4f ) -> vec4f { return x - y * floor( x / y ); }"),equals_bool:new CodeNode("fn tsl_equals_bool( a : bool, b : bool ) -> bool { return a == b; }"),equals_bvec2:new CodeNode("fn tsl_equals_bvec2( a : vec2f, b : vec2f ) -> vec2<bool> { return vec2<bool>( a.x == b.x, a.y == b.y ); }"),equals_bvec3:new CodeNode("fn tsl_equals_bvec3( a : vec3f, b : vec3f ) -> vec3<bool> { return vec3<bool>( a.x == b.x, a.y == b.y, a.z == b.z ); }"),equals_bvec4:new CodeNode("fn tsl_equals_bvec4( a : vec4f, b : vec4f ) -> vec4<bool> { return vec4<bool>( a.x == b.x, a.y == b.y, a.z == b.z, a.w == b.w ); }"),repeatWrapping_float:new CodeNode("fn tsl_repeatWrapping_float( coord: f32 ) -> f32 { return fract( coord ); }"),mirrorWrapping_float:new CodeNode("fn tsl_mirrorWrapping_float( coord: f32 ) -> f32 { let mirrored = fract( coord * 0.5 ) * 2.0; return 1.0 - abs( 1.0 - mirrored ); }"),clampWrapping_float:new CodeNode("fn tsl_clampWrapping_float( coord: f32 ) -> f32 { return clamp( coord, 0.0, 1.0 ); }"),biquadraticTexture:new CodeNode(`
fn tsl_biquadraticTexture( map : texture_2d<f32>, coord : vec2f, iRes : vec2u, level : u32 ) -> vec4f {

	let res = vec2f( iRes );

	let uvScaled = coord * res;
	let uvWrapping = ( ( uvScaled % res ) + res ) % res;

	// https://www.shadertoy.com/view/WtyXRy

	let uv = uvWrapping - 0.5;
	let iuv = floor( uv );
	let f = fract( uv );

	let rg1 = textureLoad( map, vec2u( iuv + vec2( 0.5, 0.5 ) ) % iRes, level );
	let rg2 = textureLoad( map, vec2u( iuv + vec2( 1.5, 0.5 ) ) % iRes, level );
	let rg3 = textureLoad( map, vec2u( iuv + vec2( 0.5, 1.5 ) ) % iRes, level );
	let rg4 = textureLoad( map, vec2u( iuv + vec2( 1.5, 1.5 ) ) % iRes, level );

	return mix( mix( rg1, rg2, f.x ), mix( rg3, rg4, f.x ), f.y );

}
`)},wgslMethods={dFdx:"dpdx",dFdy:"- dpdy",mod_float:"tsl_mod_float",mod_vec2:"tsl_mod_vec2",mod_vec3:"tsl_mod_vec3",mod_vec4:"tsl_mod_vec4",equals_bool:"tsl_equals_bool",equals_bvec2:"tsl_equals_bvec2",equals_bvec3:"tsl_equals_bvec3",equals_bvec4:"tsl_equals_bvec4",inversesqrt:"inverseSqrt",bitcast:"bitcast<f32>"};typeof navigator<"u"&&/Windows/g.test(navigator.userAgent)&&(wgslPolyfill.pow_float=new CodeNode("fn tsl_pow_float( a : f32, b : f32 ) -> f32 { return select( -pow( -a, b ), pow( a, b ), a > 0.0 ); }"),wgslPolyfill.pow_vec2=new CodeNode("fn tsl_pow_vec2( a : vec2f, b : vec2f ) -> vec2f { return vec2f( tsl_pow_float( a.x, b.x ), tsl_pow_float( a.y, b.y ) ); }",[wgslPolyfill.pow_float]),wgslPolyfill.pow_vec3=new CodeNode("fn tsl_pow_vec3( a : vec3f, b : vec3f ) -> vec3f { return vec3f( tsl_pow_float( a.x, b.x ), tsl_pow_float( a.y, b.y ), tsl_pow_float( a.z, b.z ) ); }",[wgslPolyfill.pow_float]),wgslPolyfill.pow_vec4=new CodeNode("fn tsl_pow_vec4( a : vec4f, b : vec4f ) -> vec4f { return vec4f( tsl_pow_float( a.x, b.x ), tsl_pow_float( a.y, b.y ), tsl_pow_float( a.z, b.z ), tsl_pow_float( a.w, b.w ) ); }",[wgslPolyfill.pow_float]),wgslMethods.pow_float="tsl_pow_float",wgslMethods.pow_vec2="tsl_pow_vec2",wgslMethods.pow_vec3="tsl_pow_vec3",wgslMethods.pow_vec4="tsl_pow_vec4");let diagnostics="";(typeof navigator<"u"&&/Firefox|Deno/g.test(navigator.userAgent))!==!0&&(diagnostics+=`diagnostic( off, derivative_uniformity );
`);class WGSLNodeBuilder extends NodeBuilder{constructor(object,renderer){super(object,renderer,new WGSLNodeParser),this.uniformGroups={},this.builtins={},this.directives={},this.scopedArrays=new Map}needsToWorkingColorSpace(texture2){return texture2.isVideoTexture===!0&&texture2.colorSpace!==NoColorSpace}_generateTextureSample(texture2,textureProperty,uvSnippet,depthSnippet,shaderStage=this.shaderStage){return shaderStage==="fragment"?depthSnippet?`textureSample( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet}, ${depthSnippet} )`:`textureSample( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet} )`:this.isFilteredTexture(texture2)?this.generateFilteredTexture(texture2,textureProperty,uvSnippet):this.generateTextureLod(texture2,textureProperty,uvSnippet,depthSnippet,"0")}_generateVideoSample(textureProperty,uvSnippet,shaderStage=this.shaderStage){if(shaderStage==="fragment")return`textureSampleBaseClampToEdge( ${textureProperty}, ${textureProperty}_sampler, vec2<f32>( ${uvSnippet}.x, 1.0 - ${uvSnippet}.y ) )`;console.error(`WebGPURenderer: THREE.VideoTexture does not support ${shaderStage} shader.`)}_generateTextureSampleLevel(texture2,textureProperty,uvSnippet,levelSnippet,depthSnippet,shaderStage=this.shaderStage){return(shaderStage==="fragment"||shaderStage==="compute")&&this.isUnfilterable(texture2)===!1?`textureSampleLevel( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet}, ${levelSnippet} )`:this.isFilteredTexture(texture2)?this.generateFilteredTexture(texture2,textureProperty,uvSnippet,levelSnippet):this.generateTextureLod(texture2,textureProperty,uvSnippet,depthSnippet,levelSnippet)}generateWrapFunction(texture2){const functionName=`tsl_coord_${wrapNames[texture2.wrapS]}S_${wrapNames[texture2.wrapT]}_${texture2.isData3DTexture?"3d":"2d"}T`;let nodeCode=wgslCodeCache[functionName];if(nodeCode===void 0){const includes=[],coordType=texture2.isData3DTexture?"vec3f":"vec2f";let code2=`fn ${functionName}( coord : ${coordType} ) -> ${coordType} {

	return ${coordType}(
`;const addWrapSnippet=(wrap2,axis)=>{wrap2===RepeatWrapping?(includes.push(wgslPolyfill.repeatWrapping_float),code2+=`		tsl_repeatWrapping_float( coord.${axis} )`):wrap2===ClampToEdgeWrapping?(includes.push(wgslPolyfill.clampWrapping_float),code2+=`		tsl_clampWrapping_float( coord.${axis} )`):wrap2===MirroredRepeatWrapping?(includes.push(wgslPolyfill.mirrorWrapping_float),code2+=`		tsl_mirrorWrapping_float( coord.${axis} )`):(code2+=`		coord.${axis}`,console.warn(`WebGPURenderer: Unsupported texture wrap type "${wrap2}" for vertex shader.`))};addWrapSnippet(texture2.wrapS,"x"),code2+=`,
`,addWrapSnippet(texture2.wrapT,"y"),texture2.isData3DTexture&&(code2+=`,
`,addWrapSnippet(texture2.wrapR,"z")),code2+=`
	);

}
`,wgslCodeCache[functionName]=nodeCode=new CodeNode(code2,includes)}return nodeCode.build(this),functionName}generateArrayDeclaration(type,count){return`array< ${this.getType(type)}, ${count} >`}generateTextureDimension(texture2,textureProperty,levelSnippet){const textureData=this.getDataFromNode(texture2,this.shaderStage,this.globalCache);textureData.dimensionsSnippet===void 0&&(textureData.dimensionsSnippet={});let textureDimensionNode=textureData.dimensionsSnippet[levelSnippet];if(textureData.dimensionsSnippet[levelSnippet]===void 0){let textureDimensionsParams,dimensionType;const{primarySamples}=this.renderer.backend.utils.getTextureSampleData(texture2),isMultisampled=primarySamples>1;texture2.isData3DTexture?dimensionType="vec3<u32>":dimensionType="vec2<u32>",isMultisampled||texture2.isVideoTexture||texture2.isStorageTexture?textureDimensionsParams=textureProperty:textureDimensionsParams=`${textureProperty}${levelSnippet?`, u32( ${levelSnippet} )`:""}`,textureDimensionNode=new VarNode(new ExpressionNode(`textureDimensions( ${textureDimensionsParams} )`,dimensionType)),textureData.dimensionsSnippet[levelSnippet]=textureDimensionNode,(texture2.isDataArrayTexture||texture2.isData3DTexture)&&(textureData.arrayLayerCount=new VarNode(new ExpressionNode(`textureNumLayers(${textureProperty})`,"u32"))),texture2.isTextureCube&&(textureData.cubeFaceCount=new VarNode(new ExpressionNode("6u","u32")))}return textureDimensionNode.build(this)}generateFilteredTexture(texture2,textureProperty,uvSnippet,levelSnippet="0u"){this._include("biquadraticTexture");const wrapFunction=this.generateWrapFunction(texture2),textureDimension=this.generateTextureDimension(texture2,textureProperty,levelSnippet);return`tsl_biquadraticTexture( ${textureProperty}, ${wrapFunction}( ${uvSnippet} ), ${textureDimension}, u32( ${levelSnippet} ) )`}generateTextureLod(texture2,textureProperty,uvSnippet,depthSnippet,levelSnippet="0u"){const wrapFunction=this.generateWrapFunction(texture2),textureDimension=this.generateTextureDimension(texture2,textureProperty,levelSnippet),vecType=texture2.isData3DTexture?"vec3":"vec2",coordSnippet=`${vecType}<u32>(${wrapFunction}(${uvSnippet}) * ${vecType}<f32>(${textureDimension}))`;return this.generateTextureLoad(texture2,textureProperty,coordSnippet,depthSnippet,levelSnippet)}generateTextureLoad(texture2,textureProperty,uvIndexSnippet,depthSnippet,levelSnippet="0u"){return texture2.isVideoTexture===!0||texture2.isStorageTexture===!0?`textureLoad( ${textureProperty}, ${uvIndexSnippet} )`:depthSnippet?`textureLoad( ${textureProperty}, ${uvIndexSnippet}, ${depthSnippet}, u32( ${levelSnippet} ) )`:`textureLoad( ${textureProperty}, ${uvIndexSnippet}, u32( ${levelSnippet} ) )`}generateTextureStore(texture2,textureProperty,uvIndexSnippet,valueSnippet){return`textureStore( ${textureProperty}, ${uvIndexSnippet}, ${valueSnippet} )`}isSampleCompare(texture2){return texture2.isDepthTexture===!0&&texture2.compareFunction!==null}isUnfilterable(texture2){return this.getComponentTypeFromTexture(texture2)!=="float"||!this.isAvailable("float32Filterable")&&texture2.isDataTexture===!0&&texture2.type===FloatType||this.isSampleCompare(texture2)===!1&&texture2.minFilter===NearestFilter&&texture2.magFilter===NearestFilter||this.renderer.backend.utils.getTextureSampleData(texture2).primarySamples>1}generateTexture(texture2,textureProperty,uvSnippet,depthSnippet,shaderStage=this.shaderStage){let snippet=null;return texture2.isVideoTexture===!0?snippet=this._generateVideoSample(textureProperty,uvSnippet,shaderStage):this.isUnfilterable(texture2)?snippet=this.generateTextureLod(texture2,textureProperty,uvSnippet,depthSnippet,"0",shaderStage):snippet=this._generateTextureSample(texture2,textureProperty,uvSnippet,depthSnippet,shaderStage),snippet}generateTextureGrad(texture2,textureProperty,uvSnippet,gradSnippet,depthSnippet,shaderStage=this.shaderStage){if(shaderStage==="fragment")return`textureSampleGrad( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet},  ${gradSnippet[0]}, ${gradSnippet[1]} )`;console.error(`WebGPURenderer: THREE.TextureNode.gradient() does not support ${shaderStage} shader.`)}generateTextureCompare(texture2,textureProperty,uvSnippet,compareSnippet,depthSnippet,shaderStage=this.shaderStage){if(shaderStage==="fragment")return`textureSampleCompare( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet}, ${compareSnippet} )`;console.error(`WebGPURenderer: THREE.DepthTexture.compareFunction() does not support ${shaderStage} shader.`)}generateTextureLevel(texture2,textureProperty,uvSnippet,levelSnippet,depthSnippet,shaderStage=this.shaderStage){let snippet=null;return texture2.isVideoTexture===!0?snippet=this._generateVideoSample(textureProperty,uvSnippet,shaderStage):snippet=this._generateTextureSampleLevel(texture2,textureProperty,uvSnippet,levelSnippet,depthSnippet,shaderStage),snippet}generateTextureBias(texture2,textureProperty,uvSnippet,biasSnippet,depthSnippet,shaderStage=this.shaderStage){if(shaderStage==="fragment")return`textureSampleBias( ${textureProperty}, ${textureProperty}_sampler, ${uvSnippet}, ${biasSnippet} )`;console.error(`WebGPURenderer: THREE.TextureNode.biasNode does not support ${shaderStage} shader.`)}getPropertyName(node,shaderStage=this.shaderStage){if(node.isNodeVarying===!0&&node.needsInterpolation===!0){if(shaderStage==="vertex")return`varyings.${node.name}`}else if(node.isNodeUniform===!0){const name=node.name,type=node.type;return type==="texture"||type==="cubeTexture"||type==="storageTexture"||type==="texture3D"?name:type==="buffer"||type==="storageBuffer"||type==="indirectStorageBuffer"?this.isCustomStruct(node)?name:name+".value":node.groupNode.name+"."+name}return super.getPropertyName(node)}getOutputStructName(){return"output"}getFunctionOperator(op){const fnOp=wgslFnOpLib[op];return fnOp!==void 0?(this._include(fnOp),fnOp):null}getNodeAccess(node,shaderStage){return shaderStage!=="compute"?NodeAccess.READ_ONLY:node.access}getStorageAccess(node,shaderStage){return accessNames[this.getNodeAccess(node,shaderStage)]}getUniformFromNode(node,type,shaderStage,name=null){const uniformNode=super.getUniformFromNode(node,type,shaderStage,name),nodeData=this.getDataFromNode(node,shaderStage,this.globalCache);if(nodeData.uniformGPU===void 0){let uniformGPU;const group=node.groupNode,groupName=group.name,bindings=this.getBindGroupArray(groupName,shaderStage);if(type==="texture"||type==="cubeTexture"||type==="storageTexture"||type==="texture3D"){let texture2=null;const access=this.getNodeAccess(node,shaderStage);if(type==="texture"||type==="storageTexture"?texture2=new NodeSampledTexture(uniformNode.name,uniformNode.node,group,access):type==="cubeTexture"?texture2=new NodeSampledCubeTexture(uniformNode.name,uniformNode.node,group,access):type==="texture3D"&&(texture2=new NodeSampledTexture3D(uniformNode.name,uniformNode.node,group,access)),texture2.store=node.isStorageTextureNode===!0,texture2.setVisibility(gpuShaderStageLib[shaderStage]),(shaderStage==="fragment"||shaderStage==="compute")&&this.isUnfilterable(node.value)===!1&&texture2.store===!1){const sampler2=new NodeSampler(`${uniformNode.name}_sampler`,uniformNode.node,group);sampler2.setVisibility(gpuShaderStageLib[shaderStage]),bindings.push(sampler2,texture2),uniformGPU=[sampler2,texture2]}else bindings.push(texture2),uniformGPU=[texture2]}else if(type==="buffer"||type==="storageBuffer"||type==="indirectStorageBuffer"){const bufferClass=type==="buffer"?NodeUniformBuffer:NodeStorageBuffer,buffer2=new bufferClass(node,group);buffer2.setVisibility(gpuShaderStageLib[shaderStage]),bindings.push(buffer2),uniformGPU=buffer2,uniformNode.name=name||"NodeBuffer_"+uniformNode.id}else{const uniformsStage=this.uniformGroups[shaderStage]||(this.uniformGroups[shaderStage]={});let uniformsGroup=uniformsStage[groupName];uniformsGroup===void 0&&(uniformsGroup=new NodeUniformsGroup(groupName,group),uniformsGroup.setVisibility(gpuShaderStageLib[shaderStage]),uniformsStage[groupName]=uniformsGroup,bindings.push(uniformsGroup)),uniformGPU=this.getNodeUniform(uniformNode,type),uniformsGroup.addUniform(uniformGPU)}nodeData.uniformGPU=uniformGPU}return uniformNode}getBuiltin(name,property2,type,shaderStage=this.shaderStage){const map=this.builtins[shaderStage]||(this.builtins[shaderStage]=new Map);return map.has(name)===!1&&map.set(name,{name,property:property2,type}),property2}hasBuiltin(name,shaderStage=this.shaderStage){return this.builtins[shaderStage]!==void 0&&this.builtins[shaderStage].has(name)}getVertexIndex(){return this.shaderStage==="vertex"?this.getBuiltin("vertex_index","vertexIndex","u32","attribute"):"vertexIndex"}buildFunctionCode(shaderNode){const layout=shaderNode.layout,flowData=this.flowShaderNode(shaderNode),parameters=[];for(const input of layout.inputs)parameters.push(input.name+" : "+this.getType(input.type));let code2=`fn ${layout.name}( ${parameters.join(", ")} ) -> ${this.getType(layout.type)} {
${flowData.vars}
${flowData.code}
`;return flowData.result&&(code2+=`	return ${flowData.result};
`),code2+=`
}
`,code2}getInstanceIndex(){return this.shaderStage==="vertex"?this.getBuiltin("instance_index","instanceIndex","u32","attribute"):"instanceIndex"}getInvocationLocalIndex(){return this.getBuiltin("local_invocation_index","invocationLocalIndex","u32","attribute")}getSubgroupSize(){return this.enableSubGroups(),this.getBuiltin("subgroup_size","subgroupSize","u32","attribute")}getInvocationSubgroupIndex(){return this.enableSubGroups(),this.getBuiltin("subgroup_invocation_id","invocationSubgroupIndex","u32","attribute")}getSubgroupIndex(){return this.enableSubGroups(),this.getBuiltin("subgroup_id","subgroupIndex","u32","attribute")}getDrawIndex(){return null}getFrontFacing(){return this.getBuiltin("front_facing","isFront","bool")}getFragCoord(){return this.getBuiltin("position","fragCoord","vec4<f32>")+".xy"}getFragDepth(){return"output."+this.getBuiltin("frag_depth","depth","f32","output")}getClipDistance(){return"varyings.hw_clip_distances"}isFlipY(){return!1}enableDirective(name,shaderStage=this.shaderStage){(this.directives[shaderStage]||(this.directives[shaderStage]=new Set)).add(name)}getDirectives(shaderStage){const snippets=[],directives=this.directives[shaderStage];if(directives!==void 0)for(const directive of directives)snippets.push(`enable ${directive};`);return snippets.join(`
`)}enableSubGroups(){this.enableDirective("subgroups")}enableSubgroupsF16(){this.enableDirective("subgroups-f16")}enableClipDistances(){this.enableDirective("clip_distances")}enableShaderF16(){this.enableDirective("f16")}enableDualSourceBlending(){this.enableDirective("dual_source_blending")}enableHardwareClipping(planeCount){this.enableClipDistances(),this.getBuiltin("clip_distances","hw_clip_distances",`array<f32, ${planeCount} >`,"vertex")}getBuiltins(shaderStage){const snippets=[],builtins=this.builtins[shaderStage];if(builtins!==void 0)for(const{name,property:property2,type}of builtins.values())snippets.push(`@builtin( ${name} ) ${property2} : ${type}`);return snippets.join(`,
	`)}getScopedArray(name,scope,bufferType,bufferCount){return this.scopedArrays.has(name)===!1&&this.scopedArrays.set(name,{name,scope,bufferType,bufferCount}),name}getScopedArrays(shaderStage){if(shaderStage!=="compute")return;const snippets=[];for(const{name,scope,bufferType,bufferCount}of this.scopedArrays.values()){const type=this.getType(bufferType);snippets.push(`var<${scope}> ${name}: array< ${type}, ${bufferCount} >;`)}return snippets.join(`
`)}getAttributes(shaderStage){const snippets=[];if(shaderStage==="compute"&&(this.getBuiltin("global_invocation_id","globalId","vec3<u32>","attribute"),this.getBuiltin("workgroup_id","workgroupId","vec3<u32>","attribute"),this.getBuiltin("local_invocation_id","localId","vec3<u32>","attribute"),this.getBuiltin("num_workgroups","numWorkgroups","vec3<u32>","attribute"),this.renderer.hasFeature("subgroups")&&(this.enableDirective("subgroups",shaderStage),this.getBuiltin("subgroup_size","subgroupSize","u32","attribute"))),shaderStage==="vertex"||shaderStage==="compute"){const builtins=this.getBuiltins("attribute");builtins&&snippets.push(builtins);const attributes=this.getAttributesArray();for(let index=0,length2=attributes.length;index<length2;index++){const attribute2=attributes[index],name=attribute2.name,type=this.getType(attribute2.type);snippets.push(`@location( ${index} ) ${name} : ${type}`)}}return snippets.join(`,
	`)}getStructMembers(struct2){const snippets=[];for(const member of struct2.members){const prefix=struct2.output?"@location( "+member.index+" ) ":"";let type=this.getType(member.type);member.atomic&&(type="atomic< "+type+" >"),snippets.push(`	${prefix+member.name} : ${type}`)}return struct2.output&&snippets.push(`	${this.getBuiltins("output")}`),snippets.join(`,
`)}getStructs(shaderStage){let result="";const structs=this.structs[shaderStage];if(structs.length>0){const snippets=[];for(const struct2 of structs){let snippet=`struct ${struct2.name} {
`;snippet+=this.getStructMembers(struct2),snippet+=`
};`,snippets.push(snippet)}result=`
`+snippets.join(`

`)+`
`}return result}getVar(type,name,count=null){let snippet=`var ${name} : `;return count!==null?snippet+=this.generateArrayDeclaration(type,count):snippet+=this.getType(type),snippet}getVars(shaderStage){const snippets=[],vars=this.vars[shaderStage];if(vars!==void 0)for(const variable of vars)snippets.push(`	${this.getVar(variable.type,variable.name,variable.count)};`);return`
${snippets.join(`
`)}
`}getVaryings(shaderStage){const snippets=[];if(shaderStage==="vertex"&&this.getBuiltin("position","Vertex","vec4<f32>","vertex"),shaderStage==="vertex"||shaderStage==="fragment"){const varyings=this.varyings,vars=this.vars[shaderStage];for(let index=0;index<varyings.length;index++){const varying2=varyings[index];if(varying2.needsInterpolation){let attributesSnippet=`@location( ${index} )`;/^(int|uint|ivec|uvec)/.test(varying2.type)&&(attributesSnippet+=" @interpolate( flat )"),snippets.push(`${attributesSnippet} ${varying2.name} : ${this.getType(varying2.type)}`)}else shaderStage==="vertex"&&vars.includes(varying2)===!1&&vars.push(varying2)}}const builtins=this.getBuiltins(shaderStage);builtins&&snippets.push(builtins);const code2=snippets.join(`,
	`);return shaderStage==="vertex"?this._getWGSLStruct("VaryingsStruct","	"+code2):code2}isCustomStruct(nodeUniform){return nodeUniform.value.isStorageBufferAttribute&&nodeUniform.node.structTypeNode!==null}getUniforms(shaderStage){const uniforms2=this.uniforms[shaderStage],bindingSnippets=[],bufferSnippets=[],structSnippets=[],uniformGroups={};for(const uniform2 of uniforms2){const groupName=uniform2.groupNode.name,uniformIndexes=this.bindingsIndexes[groupName];if(uniform2.type==="texture"||uniform2.type==="cubeTexture"||uniform2.type==="storageTexture"||uniform2.type==="texture3D"){const texture2=uniform2.node.value;(shaderStage==="fragment"||shaderStage==="compute")&&this.isUnfilterable(texture2)===!1&&uniform2.node.isStorageTextureNode!==!0&&(this.isSampleCompare(texture2)?bindingSnippets.push(`@binding( ${uniformIndexes.binding++} ) @group( ${uniformIndexes.group} ) var ${uniform2.name}_sampler : sampler_comparison;`):bindingSnippets.push(`@binding( ${uniformIndexes.binding++} ) @group( ${uniformIndexes.group} ) var ${uniform2.name}_sampler : sampler;`));let textureType,multisampled="";const{primarySamples}=this.renderer.backend.utils.getTextureSampleData(texture2);if(primarySamples>1&&(multisampled="_multisampled"),texture2.isCubeTexture===!0)textureType="texture_cube<f32>";else if(texture2.isDataArrayTexture===!0||texture2.isCompressedArrayTexture===!0)textureType="texture_2d_array<f32>";else if(texture2.isDepthTexture===!0)textureType=`texture_depth${multisampled}_2d`;else if(texture2.isVideoTexture===!0)textureType="texture_external";else if(texture2.isData3DTexture===!0)textureType="texture_3d<f32>";else if(uniform2.node.isStorageTextureNode===!0){const format=getFormat(texture2),access=this.getStorageAccess(uniform2.node,shaderStage);textureType=`texture_storage_2d<${format}, ${access}>`}else{const componentPrefix=this.getComponentTypeFromTexture(texture2).charAt(0);textureType=`texture${multisampled}_2d<${componentPrefix}32>`}bindingSnippets.push(`@binding( ${uniformIndexes.binding++} ) @group( ${uniformIndexes.group} ) var ${uniform2.name} : ${textureType};`)}else if(uniform2.type==="buffer"||uniform2.type==="storageBuffer"||uniform2.type==="indirectStorageBuffer"){const bufferNode=uniform2.node,bufferType=this.getType(bufferNode.getNodeType(this)),bufferCount=bufferNode.bufferCount,bufferCountSnippet=bufferCount>0&&uniform2.type==="buffer"?", "+bufferCount:"",bufferAccessMode=bufferNode.isStorageBufferNode?`storage, ${this.getStorageAccess(bufferNode,shaderStage)}`:"uniform";if(this.isCustomStruct(uniform2))bufferSnippets.push(`@binding( ${uniformIndexes.binding++} ) @group( ${uniformIndexes.group} ) var<${bufferAccessMode}> ${uniform2.name} : ${bufferType};`);else{const bufferSnippet=`	value : array< ${bufferNode.isAtomic?`atomic<${bufferType}>`:`${bufferType}`}${bufferCountSnippet} >`;bufferSnippets.push(this._getWGSLStructBinding(uniform2.name,bufferSnippet,bufferAccessMode,uniformIndexes.binding++,uniformIndexes.group))}}else{const vectorType=this.getType(this.getVectorType(uniform2.type)),groupName2=uniform2.groupNode.name;(uniformGroups[groupName2]||(uniformGroups[groupName2]={index:uniformIndexes.binding++,id:uniformIndexes.group,snippets:[]})).snippets.push(`	${uniform2.name} : ${vectorType}`)}}for(const name in uniformGroups){const group=uniformGroups[name];structSnippets.push(this._getWGSLStructBinding(name,group.snippets.join(`,
`),"uniform",group.index,group.id))}let code2=bindingSnippets.join(`
`);return code2+=bufferSnippets.join(`
`),code2+=structSnippets.join(`
`),code2}buildCode(){const shadersData=this.material!==null?{fragment:{},vertex:{}}:{compute:{}};this.sortBindingGroups();for(const shaderStage in shadersData){this.shaderStage=shaderStage;const stageData=shadersData[shaderStage];stageData.uniforms=this.getUniforms(shaderStage),stageData.attributes=this.getAttributes(shaderStage),stageData.varyings=this.getVaryings(shaderStage),stageData.structs=this.getStructs(shaderStage),stageData.vars=this.getVars(shaderStage),stageData.codes=this.getCodes(shaderStage),stageData.directives=this.getDirectives(shaderStage),stageData.scopedArrays=this.getScopedArrays(shaderStage);let flow=`// code

`;flow+=this.flowCode[shaderStage];const flowNodes=this.flowNodes[shaderStage],mainNode=flowNodes[flowNodes.length-1],outputNode=mainNode.outputNode,isOutputStruct=outputNode!==void 0&&outputNode.isOutputStructNode===!0;for(const node of flowNodes){const flowSlotData=this.getFlowData(node),slotName=node.name;if(slotName&&(flow.length>0&&(flow+=`
`),flow+=`	// flow -> ${slotName}
`),flow+=`${flowSlotData.code}
	`,node===mainNode&&shaderStage!=="compute"){if(flow+=`// result

	`,shaderStage==="vertex")flow+=`varyings.Vertex = ${flowSlotData.result};`;else if(shaderStage==="fragment")if(isOutputStruct)stageData.returnType=outputNode.getNodeType(this),stageData.structs+="var<private> output : "+stageData.returnType+";",flow+=`return ${flowSlotData.result};`;else{let structSnippet="	@location(0) color: vec4<f32>";const builtins=this.getBuiltins("output");builtins&&(structSnippet+=`,
	`+builtins),stageData.returnType="OutputStruct",stageData.structs+=this._getWGSLStruct("OutputStruct",structSnippet),stageData.structs+=`
var<private> output : OutputStruct;`,flow+=`output.color = ${flowSlotData.result};

	return output;`}}}stageData.flow=flow}this.shaderStage=null,this.material!==null?(this.vertexShader=this._getWGSLVertexCode(shadersData.vertex),this.fragmentShader=this._getWGSLFragmentCode(shadersData.fragment)):this.computeShader=this._getWGSLComputeCode(shadersData.compute,(this.object.workgroupSize||[64]).join(", "))}getMethod(method,output2=null){let wgslMethod;return output2!==null&&(wgslMethod=this._getWGSLMethod(method+"_"+output2)),wgslMethod===void 0&&(wgslMethod=this._getWGSLMethod(method)),wgslMethod||method}getType(type){return wgslTypeLib[type]||type}isAvailable(name){let result=supports[name];return result===void 0&&(name==="float32Filterable"?result=this.renderer.hasFeature("float32-filterable"):name==="clipDistance"&&(result=this.renderer.hasFeature("clip-distances")),supports[name]=result),result}_getWGSLMethod(method){return wgslPolyfill[method]!==void 0&&this._include(method),wgslMethods[method]}_include(name){const codeNode=wgslPolyfill[name];return codeNode.build(this),this.currentFunctionNode!==null&&this.currentFunctionNode.includes.push(codeNode),codeNode}_getWGSLVertexCode(shaderData){return`${this.getSignature()}
// directives
${shaderData.directives}

// structs
${shaderData.structs}

// uniforms
${shaderData.uniforms}

// varyings
${shaderData.varyings}
var<private> varyings : VaryingsStruct;

// codes
${shaderData.codes}

@vertex
fn main( ${shaderData.attributes} ) -> VaryingsStruct {

	// vars
	${shaderData.vars}

	// flow
	${shaderData.flow}

	return varyings;

}
`}_getWGSLFragmentCode(shaderData){return`${this.getSignature()}
// global
${diagnostics}

// structs
${shaderData.structs}

// uniforms
${shaderData.uniforms}

// codes
${shaderData.codes}

@fragment
fn main( ${shaderData.varyings} ) -> ${shaderData.returnType} {

	// vars
	${shaderData.vars}

	// flow
	${shaderData.flow}

}
`}_getWGSLComputeCode(shaderData,workgroupSize){return`${this.getSignature()}
// directives
${shaderData.directives}

// system
var<private> instanceIndex : u32;

// locals
${shaderData.scopedArrays}

// structs
${shaderData.structs}

// uniforms
${shaderData.uniforms}

// codes
${shaderData.codes}

@compute @workgroup_size( ${workgroupSize} )
fn main( ${shaderData.attributes} ) {

	// system
	instanceIndex = globalId.x + globalId.y * numWorkgroups.x * u32(${workgroupSize}) + globalId.z * numWorkgroups.x * numWorkgroups.y * u32(${workgroupSize});

	// vars
	${shaderData.vars}

	// flow
	${shaderData.flow}

}
`}_getWGSLStruct(name,vars){return`
struct ${name} {
${vars}
};`}_getWGSLStructBinding(name,vars,access,binding=0,group=0){const structName=name+"Struct";return`${this._getWGSLStruct(structName,vars)}
@binding( ${binding} ) @group( ${group} )
var<${access}> ${name} : ${structName};`}}class WebGPUUtils{constructor(backend){this.backend=backend}getCurrentDepthStencilFormat(renderContext){let format;return renderContext.depthTexture!==null?format=this.getTextureFormatGPU(renderContext.depthTexture):renderContext.depth&&renderContext.stencil?format=GPUTextureFormat.Depth24PlusStencil8:renderContext.depth&&(format=GPUTextureFormat.Depth24Plus),format}getTextureFormatGPU(texture2){return this.backend.get(texture2).format}getTextureSampleData(texture2){let samples;if(texture2.isFramebufferTexture)samples=1;else if(texture2.isDepthTexture&&!texture2.renderTarget){const renderer=this.backend.renderer,renderTarget=renderer.getRenderTarget();samples=renderTarget?renderTarget.samples:renderer.samples}else texture2.renderTarget&&(samples=texture2.renderTarget.samples);samples=samples||1;const isMSAA=samples>1&&texture2.renderTarget!==null&&texture2.isDepthTexture!==!0&&texture2.isFramebufferTexture!==!0;return{samples,primarySamples:isMSAA?1:samples,isMSAA}}getCurrentColorFormat(renderContext){let format;return renderContext.textures!==null?format=this.getTextureFormatGPU(renderContext.textures[0]):format=this.getPreferredCanvasFormat(),format}getCurrentColorSpace(renderContext){return renderContext.textures!==null?renderContext.textures[0].colorSpace:this.backend.renderer.outputColorSpace}getPrimitiveTopology(object,material){if(object.isPoints)return GPUPrimitiveTopology.PointList;if(object.isLineSegments||object.isMesh&&material.wireframe===!0)return GPUPrimitiveTopology.LineList;if(object.isLine)return GPUPrimitiveTopology.LineStrip;if(object.isMesh)return GPUPrimitiveTopology.TriangleList}getSampleCount(sampleCount){let count=1;return sampleCount>1&&(count=Math.pow(2,Math.floor(Math.log2(sampleCount))),count===2&&(count=4)),count}getSampleCountRenderContext(renderContext){return renderContext.textures!==null?this.getSampleCount(renderContext.sampleCount):this.getSampleCount(this.backend.renderer.samples)}getPreferredCanvasFormat(){const outputType=this.backend.parameters.outputType;if(outputType===void 0)return navigator.gpu.getPreferredCanvasFormat();if(outputType===UnsignedByteType)return GPUTextureFormat.BGRA8Unorm;if(outputType===HalfFloatType)return GPUTextureFormat.RGBA16Float;throw new Error("Unsupported outputType")}}const typedArraysToVertexFormatPrefix=new Map([[Int8Array,["sint8","snorm8"]],[Uint8Array,["uint8","unorm8"]],[Int16Array,["sint16","snorm16"]],[Uint16Array,["uint16","unorm16"]],[Int32Array,["sint32","snorm32"]],[Uint32Array,["uint32","unorm32"]],[Float32Array,["float32"]]]),typedAttributeToVertexFormatPrefix=new Map([[Float16BufferAttribute,["float16"]]]),typeArraysToVertexFormatPrefixForItemSize1=new Map([[Int32Array,"sint32"],[Int16Array,"sint32"],[Uint32Array,"uint32"],[Uint16Array,"uint32"],[Float32Array,"float32"]]);class WebGPUAttributeUtils{constructor(backend){this.backend=backend}createAttribute(attribute2,usage){const bufferAttribute2=this._getBufferAttribute(attribute2),backend=this.backend,bufferData=backend.get(bufferAttribute2);let buffer2=bufferData.buffer;if(buffer2===void 0){const device=backend.device;let array2=bufferAttribute2.array;if(attribute2.normalized===!1){if(array2.constructor===Int16Array)array2=new Int32Array(array2);else if(array2.constructor===Uint16Array&&(array2=new Uint32Array(array2),usage&GPUBufferUsage.INDEX))for(let i2=0;i2<array2.length;i2++)array2[i2]===65535&&(array2[i2]=4294967295)}if(bufferAttribute2.array=array2,(bufferAttribute2.isStorageBufferAttribute||bufferAttribute2.isStorageInstancedBufferAttribute)&&bufferAttribute2.itemSize===3){array2=new array2.constructor(bufferAttribute2.count*4);for(let i2=0;i2<bufferAttribute2.count;i2++)array2.set(bufferAttribute2.array.subarray(i2*3,i2*3+3),i2*4);bufferAttribute2.itemSize=4,bufferAttribute2.array=array2,bufferData._force3to4BytesAlignment=!0}const size=array2.byteLength+(4-array2.byteLength%4)%4;buffer2=device.createBuffer({label:bufferAttribute2.name,size,usage,mappedAtCreation:!0}),new array2.constructor(buffer2.getMappedRange()).set(array2),buffer2.unmap(),bufferData.buffer=buffer2}}updateAttribute(attribute2){const bufferAttribute2=this._getBufferAttribute(attribute2),backend=this.backend,device=backend.device,bufferData=backend.get(bufferAttribute2),buffer2=backend.get(bufferAttribute2).buffer;let array2=bufferAttribute2.array;if(bufferData._force3to4BytesAlignment===!0){array2=new array2.constructor(bufferAttribute2.count*4);for(let i2=0;i2<bufferAttribute2.count;i2++)array2.set(bufferAttribute2.array.subarray(i2*3,i2*3+3),i2*4);bufferAttribute2.array=array2}const isTypedArray=this._isTypedArray(array2),updateRanges=bufferAttribute2.updateRanges;if(updateRanges.length===0)device.queue.writeBuffer(buffer2,0,array2,0);else{const byteOffsetFactor=isTypedArray?1:array2.BYTES_PER_ELEMENT;for(let i2=0,l2=updateRanges.length;i2<l2;i2++){const range2=updateRanges[i2];let dataOffset,size;if(bufferData._force3to4BytesAlignment===!0){const vertexStart=Math.floor(range2.start/3),vertexCount=Math.ceil(range2.count/3);dataOffset=vertexStart*4*byteOffsetFactor,size=vertexCount*4*byteOffsetFactor}else dataOffset=range2.start*byteOffsetFactor,size=range2.count*byteOffsetFactor;device.queue.writeBuffer(buffer2,0,array2,dataOffset,size)}bufferAttribute2.clearUpdateRanges()}}createShaderVertexBuffers(renderObject){const attributes=renderObject.getAttributes(),vertexBuffers=new Map;for(let slot=0;slot<attributes.length;slot++){const geometryAttribute=attributes[slot],bytesPerElement=geometryAttribute.array.BYTES_PER_ELEMENT,bufferAttribute2=this._getBufferAttribute(geometryAttribute);let vertexBufferLayout=vertexBuffers.get(bufferAttribute2);if(vertexBufferLayout===void 0){let arrayStride,stepMode;geometryAttribute.isInterleavedBufferAttribute===!0?(arrayStride=geometryAttribute.data.stride*bytesPerElement,stepMode=geometryAttribute.data.isInstancedInterleavedBuffer?GPUInputStepMode.Instance:GPUInputStepMode.Vertex):(arrayStride=geometryAttribute.itemSize*bytesPerElement,stepMode=geometryAttribute.isInstancedBufferAttribute?GPUInputStepMode.Instance:GPUInputStepMode.Vertex),geometryAttribute.normalized===!1&&(geometryAttribute.array.constructor===Int16Array||geometryAttribute.array.constructor===Uint16Array)&&(arrayStride=4),vertexBufferLayout={arrayStride,attributes:[],stepMode},vertexBuffers.set(bufferAttribute2,vertexBufferLayout)}const format=this._getVertexFormat(geometryAttribute),offset=geometryAttribute.isInterleavedBufferAttribute===!0?geometryAttribute.offset*bytesPerElement:0;vertexBufferLayout.attributes.push({shaderLocation:slot,offset,format})}return Array.from(vertexBuffers.values())}destroyAttribute(attribute2){const backend=this.backend;backend.get(this._getBufferAttribute(attribute2)).buffer.destroy(),backend.delete(attribute2)}async getArrayBufferAsync(attribute2){const backend=this.backend,device=backend.device,bufferGPU=backend.get(this._getBufferAttribute(attribute2)).buffer,size=bufferGPU.size,readBufferGPU=device.createBuffer({label:`${attribute2.name}_readback`,size,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ}),cmdEncoder=device.createCommandEncoder({label:`readback_encoder_${attribute2.name}`});cmdEncoder.copyBufferToBuffer(bufferGPU,0,readBufferGPU,0,size);const gpuCommands=cmdEncoder.finish();device.queue.submit([gpuCommands]),await readBufferGPU.mapAsync(GPUMapMode.READ);const arrayBuffer2=readBufferGPU.getMappedRange(),dstBuffer=new attribute2.array.constructor(arrayBuffer2.slice(0));return readBufferGPU.unmap(),dstBuffer.buffer}_getVertexFormat(geometryAttribute){const{itemSize,normalized}=geometryAttribute,ArrayType=geometryAttribute.array.constructor,AttributeType2=geometryAttribute.constructor;let format;if(itemSize===1)format=typeArraysToVertexFormatPrefixForItemSize1.get(ArrayType);else{const prefix=(typedAttributeToVertexFormatPrefix.get(AttributeType2)||typedArraysToVertexFormatPrefix.get(ArrayType))[normalized?1:0];if(prefix){const bytesPerUnit=ArrayType.BYTES_PER_ELEMENT*itemSize,paddedItemSize=Math.floor((bytesPerUnit+3)/4)*4/ArrayType.BYTES_PER_ELEMENT;if(paddedItemSize%1)throw new Error("THREE.WebGPUAttributeUtils: Bad vertex format item size.");format=`${prefix}x${paddedItemSize}`}}return format||console.error("THREE.WebGPUAttributeUtils: Vertex format not supported yet."),format}_isTypedArray(array2){return ArrayBuffer.isView(array2)&&!(array2 instanceof DataView)}_getBufferAttribute(attribute2){return attribute2.isInterleavedBufferAttribute&&(attribute2=attribute2.data),attribute2}}class WebGPUBindingUtils{constructor(backend){this.backend=backend,this.bindGroupLayoutCache=new WeakMap}createBindingsLayout(bindGroup){const backend=this.backend,device=backend.device,entries=[];let index=0;for(const binding of bindGroup.bindings){const bindingGPU={binding:index++,visibility:binding.visibility};if(binding.isUniformBuffer||binding.isStorageBuffer){const buffer2={};binding.isStorageBuffer&&(binding.visibility&4&&(binding.access===NodeAccess.READ_WRITE||binding.access===NodeAccess.WRITE_ONLY)?buffer2.type=GPUBufferBindingType.Storage:buffer2.type=GPUBufferBindingType.ReadOnlyStorage),bindingGPU.buffer=buffer2}else if(binding.isSampler){const sampler2={};binding.texture.isDepthTexture&&binding.texture.compareFunction!==null&&(sampler2.type="comparison"),bindingGPU.sampler=sampler2}else if(binding.isSampledTexture&&binding.texture.isVideoTexture)bindingGPU.externalTexture={};else if(binding.isSampledTexture&&binding.store){const storageTexture2={};storageTexture2.format=this.backend.get(binding.texture).texture.format;const access=binding.access;access===NodeAccess.READ_WRITE?storageTexture2.access=GPUStorageTextureAccess.ReadWrite:access===NodeAccess.WRITE_ONLY?storageTexture2.access=GPUStorageTextureAccess.WriteOnly:storageTexture2.access=GPUStorageTextureAccess.ReadOnly,bindingGPU.storageTexture=storageTexture2}else if(binding.isSampledTexture){const texture2={},{primarySamples}=backend.utils.getTextureSampleData(binding.texture);if(primarySamples>1&&(texture2.multisampled=!0,binding.texture.isDepthTexture||(texture2.sampleType=GPUTextureSampleType.UnfilterableFloat)),binding.texture.isDepthTexture)texture2.sampleType=GPUTextureSampleType.Depth;else if(binding.texture.isDataTexture||binding.texture.isDataArrayTexture||binding.texture.isData3DTexture){const type=binding.texture.type;type===IntType?texture2.sampleType=GPUTextureSampleType.SInt:type===UnsignedIntType?texture2.sampleType=GPUTextureSampleType.UInt:type===FloatType&&(this.backend.hasFeature("float32-filterable")?texture2.sampleType=GPUTextureSampleType.Float:texture2.sampleType=GPUTextureSampleType.UnfilterableFloat)}binding.isSampledCubeTexture?texture2.viewDimension=GPUTextureViewDimension.Cube:binding.texture.isDataArrayTexture||binding.texture.isCompressedArrayTexture?texture2.viewDimension=GPUTextureViewDimension.TwoDArray:binding.isSampledTexture3D&&(texture2.viewDimension=GPUTextureViewDimension.ThreeD),bindingGPU.texture=texture2}else console.error(`WebGPUBindingUtils: Unsupported binding "${binding}".`);entries.push(bindingGPU)}return device.createBindGroupLayout({entries})}createBindings(bindGroup,bindings,cacheIndex,version=0){const{backend,bindGroupLayoutCache}=this,bindingsData=backend.get(bindGroup);let bindLayoutGPU=bindGroupLayoutCache.get(bindGroup.bindingsReference);bindLayoutGPU===void 0&&(bindLayoutGPU=this.createBindingsLayout(bindGroup),bindGroupLayoutCache.set(bindGroup.bindingsReference,bindLayoutGPU));let bindGroupGPU;cacheIndex>0&&(bindingsData.groups===void 0&&(bindingsData.groups=[],bindingsData.versions=[]),bindingsData.versions[cacheIndex]===version&&(bindGroupGPU=bindingsData.groups[cacheIndex])),bindGroupGPU===void 0&&(bindGroupGPU=this.createBindGroup(bindGroup,bindLayoutGPU),cacheIndex>0&&(bindingsData.groups[cacheIndex]=bindGroupGPU,bindingsData.versions[cacheIndex]=version)),bindingsData.group=bindGroupGPU,bindingsData.layout=bindLayoutGPU}updateBinding(binding){const backend=this.backend,device=backend.device,buffer2=binding.buffer,bufferGPU=backend.get(binding).buffer;device.queue.writeBuffer(bufferGPU,0,buffer2,0)}createBindGroupIndex(data,layout){const device=this.backend.device,usage=GPUBufferUsage.UNIFORM|GPUBufferUsage.COPY_DST,index=data[0],buffer2=device.createBuffer({label:"bindingCameraIndex_"+index,size:16,usage});device.queue.writeBuffer(buffer2,0,data,0);const entries=[{binding:0,resource:{buffer:buffer2}}];return device.createBindGroup({label:"bindGroupCameraIndex_"+index,layout,entries})}createBindGroup(bindGroup,layoutGPU){const backend=this.backend,device=backend.device;let bindingPoint=0;const entriesGPU=[];for(const binding of bindGroup.bindings){if(binding.isUniformBuffer){const bindingData=backend.get(binding);if(bindingData.buffer===void 0){const byteLength=binding.byteLength,usage=GPUBufferUsage.UNIFORM|GPUBufferUsage.COPY_DST,bufferGPU=device.createBuffer({label:"bindingBuffer_"+binding.name,size:byteLength,usage});bindingData.buffer=bufferGPU}entriesGPU.push({binding:bindingPoint,resource:{buffer:bindingData.buffer}})}else if(binding.isStorageBuffer){const bindingData=backend.get(binding);if(bindingData.buffer===void 0){const attribute2=binding.attribute;bindingData.buffer=backend.get(attribute2).buffer}entriesGPU.push({binding:bindingPoint,resource:{buffer:bindingData.buffer}})}else if(binding.isSampler){const textureGPU=backend.get(binding.texture);entriesGPU.push({binding:bindingPoint,resource:textureGPU.sampler})}else if(binding.isSampledTexture){const textureData=backend.get(binding.texture);let resourceGPU;if(textureData.externalTexture!==void 0)resourceGPU=device.importExternalTexture({source:textureData.externalTexture});else{const mipLevelCount=binding.store?1:textureData.texture.mipLevelCount,propertyName=`view-${textureData.texture.width}-${textureData.texture.height}-${mipLevelCount}`;if(resourceGPU=textureData[propertyName],resourceGPU===void 0){const aspectGPU=GPUTextureAspect.All;let dimensionViewGPU;binding.isSampledCubeTexture?dimensionViewGPU=GPUTextureViewDimension.Cube:binding.isSampledTexture3D?dimensionViewGPU=GPUTextureViewDimension.ThreeD:binding.texture.isDataArrayTexture||binding.texture.isCompressedArrayTexture?dimensionViewGPU=GPUTextureViewDimension.TwoDArray:dimensionViewGPU=GPUTextureViewDimension.TwoD,resourceGPU=textureData[propertyName]=textureData.texture.createView({aspect:aspectGPU,dimension:dimensionViewGPU,mipLevelCount})}}entriesGPU.push({binding:bindingPoint,resource:resourceGPU})}bindingPoint++}return device.createBindGroup({label:"bindGroup_"+bindGroup.name,layout:layoutGPU,entries:entriesGPU})}}class WebGPUPipelineUtils{constructor(backend){this.backend=backend}_getSampleCount(renderContext){return this.backend.utils.getSampleCountRenderContext(renderContext)}createRenderPipeline(renderObject,promises){const{object,material,geometry:geometry2,pipeline}=renderObject,{vertexProgram,fragmentProgram}=pipeline,backend=this.backend,device=backend.device,utils2=backend.utils,pipelineData=backend.get(pipeline),bindGroupLayouts=[];for(const bindGroup of renderObject.getBindings()){const bindingsData=backend.get(bindGroup);bindGroupLayouts.push(bindingsData.layout)}const vertexBuffers=backend.attributeUtils.createShaderVertexBuffers(renderObject);let blending;material.transparent===!0&&material.blending!==NoBlending&&(blending=this._getBlending(material));let stencilFront={};material.stencilWrite===!0&&(stencilFront={compare:this._getStencilCompare(material),failOp:this._getStencilOperation(material.stencilFail),depthFailOp:this._getStencilOperation(material.stencilZFail),passOp:this._getStencilOperation(material.stencilZPass)});const colorWriteMask=this._getColorWriteMask(material),targets=[];if(renderObject.context.textures!==null){const textures=renderObject.context.textures;for(let i2=0;i2<textures.length;i2++){const colorFormat=utils2.getTextureFormatGPU(textures[i2]);targets.push({format:colorFormat,blend:blending,writeMask:colorWriteMask})}}else{const colorFormat=utils2.getCurrentColorFormat(renderObject.context);targets.push({format:colorFormat,blend:blending,writeMask:colorWriteMask})}const vertexModule=backend.get(vertexProgram).module,fragmentModule=backend.get(fragmentProgram).module,primitiveState=this._getPrimitiveState(object,geometry2,material),depthCompare=this._getDepthCompare(material),depthStencilFormat=utils2.getCurrentDepthStencilFormat(renderObject.context),sampleCount=this._getSampleCount(renderObject.context),pipelineDescriptor={label:`renderPipeline_${material.name||material.type}_${material.id}`,vertex:Object.assign({},vertexModule,{buffers:vertexBuffers}),fragment:Object.assign({},fragmentModule,{targets}),primitive:primitiveState,multisample:{count:sampleCount,alphaToCoverageEnabled:material.alphaToCoverage&&sampleCount>1},layout:device.createPipelineLayout({bindGroupLayouts})},depthStencil={},renderDepth=renderObject.context.depth,renderStencil=renderObject.context.stencil;if((renderDepth===!0||renderStencil===!0)&&(renderDepth===!0&&(depthStencil.format=depthStencilFormat,depthStencil.depthWriteEnabled=material.depthWrite,depthStencil.depthCompare=depthCompare),renderStencil===!0&&(depthStencil.stencilFront=stencilFront,depthStencil.stencilBack={},depthStencil.stencilReadMask=material.stencilFuncMask,depthStencil.stencilWriteMask=material.stencilWriteMask),material.polygonOffset===!0&&(depthStencil.depthBias=material.polygonOffsetUnits,depthStencil.depthBiasSlopeScale=material.polygonOffsetFactor,depthStencil.depthBiasClamp=0),pipelineDescriptor.depthStencil=depthStencil),promises===null)pipelineData.pipeline=device.createRenderPipeline(pipelineDescriptor);else{const p=new Promise(resolve=>{device.createRenderPipelineAsync(pipelineDescriptor).then(pipeline2=>{pipelineData.pipeline=pipeline2,resolve()})});promises.push(p)}}createBundleEncoder(renderContext){const backend=this.backend,{utils:utils2,device}=backend,depthStencilFormat=utils2.getCurrentDepthStencilFormat(renderContext),colorFormat=utils2.getCurrentColorFormat(renderContext),sampleCount=this._getSampleCount(renderContext),descriptor={label:"renderBundleEncoder",colorFormats:[colorFormat],depthStencilFormat,sampleCount};return device.createRenderBundleEncoder(descriptor)}createComputePipeline(pipeline,bindings){const backend=this.backend,device=backend.device,computeProgram=backend.get(pipeline.computeProgram).module,pipelineGPU=backend.get(pipeline),bindGroupLayouts=[];for(const bindingsGroup of bindings){const bindingsData=backend.get(bindingsGroup);bindGroupLayouts.push(bindingsData.layout)}pipelineGPU.pipeline=device.createComputePipeline({compute:computeProgram,layout:device.createPipelineLayout({bindGroupLayouts})})}_getBlending(material){let color2,alpha;const blending=material.blending,blendSrc=material.blendSrc,blendDst=material.blendDst,blendEquation=material.blendEquation;if(blending===CustomBlending){const blendSrcAlpha=material.blendSrcAlpha!==null?material.blendSrcAlpha:blendSrc,blendDstAlpha=material.blendDstAlpha!==null?material.blendDstAlpha:blendDst,blendEquationAlpha=material.blendEquationAlpha!==null?material.blendEquationAlpha:blendEquation;color2={srcFactor:this._getBlendFactor(blendSrc),dstFactor:this._getBlendFactor(blendDst),operation:this._getBlendOperation(blendEquation)},alpha={srcFactor:this._getBlendFactor(blendSrcAlpha),dstFactor:this._getBlendFactor(blendDstAlpha),operation:this._getBlendOperation(blendEquationAlpha)}}else{const premultipliedAlpha=material.premultipliedAlpha,setBlend=(srcRGB,dstRGB,srcAlpha,dstAlpha)=>{color2={srcFactor:srcRGB,dstFactor:dstRGB,operation:GPUBlendOperation.Add},alpha={srcFactor:srcAlpha,dstFactor:dstAlpha,operation:GPUBlendOperation.Add}};if(premultipliedAlpha)switch(blending){case NormalBlending:setBlend(GPUBlendFactor.One,GPUBlendFactor.OneMinusSrcAlpha,GPUBlendFactor.One,GPUBlendFactor.OneMinusSrcAlpha);break;case AdditiveBlending:setBlend(GPUBlendFactor.One,GPUBlendFactor.One,GPUBlendFactor.One,GPUBlendFactor.One);break;case SubtractiveBlending:setBlend(GPUBlendFactor.Zero,GPUBlendFactor.OneMinusSrc,GPUBlendFactor.Zero,GPUBlendFactor.One);break;case MultiplyBlending:setBlend(GPUBlendFactor.Zero,GPUBlendFactor.Src,GPUBlendFactor.Zero,GPUBlendFactor.SrcAlpha);break}else switch(blending){case NormalBlending:setBlend(GPUBlendFactor.SrcAlpha,GPUBlendFactor.OneMinusSrcAlpha,GPUBlendFactor.One,GPUBlendFactor.OneMinusSrcAlpha);break;case AdditiveBlending:setBlend(GPUBlendFactor.SrcAlpha,GPUBlendFactor.One,GPUBlendFactor.SrcAlpha,GPUBlendFactor.One);break;case SubtractiveBlending:setBlend(GPUBlendFactor.Zero,GPUBlendFactor.OneMinusSrc,GPUBlendFactor.Zero,GPUBlendFactor.One);break;case MultiplyBlending:setBlend(GPUBlendFactor.Zero,GPUBlendFactor.Src,GPUBlendFactor.Zero,GPUBlendFactor.Src);break}}if(color2!==void 0&&alpha!==void 0)return{color:color2,alpha};console.error("THREE.WebGPURenderer: Invalid blending: ",blending)}_getBlendFactor(blend){let blendFactor;switch(blend){case ZeroFactor:blendFactor=GPUBlendFactor.Zero;break;case OneFactor:blendFactor=GPUBlendFactor.One;break;case SrcColorFactor:blendFactor=GPUBlendFactor.Src;break;case OneMinusSrcColorFactor:blendFactor=GPUBlendFactor.OneMinusSrc;break;case SrcAlphaFactor:blendFactor=GPUBlendFactor.SrcAlpha;break;case OneMinusSrcAlphaFactor:blendFactor=GPUBlendFactor.OneMinusSrcAlpha;break;case DstColorFactor:blendFactor=GPUBlendFactor.Dst;break;case OneMinusDstColorFactor:blendFactor=GPUBlendFactor.OneMinusDstColor;break;case DstAlphaFactor:blendFactor=GPUBlendFactor.DstAlpha;break;case OneMinusDstAlphaFactor:blendFactor=GPUBlendFactor.OneMinusDstAlpha;break;case SrcAlphaSaturateFactor:blendFactor=GPUBlendFactor.SrcAlphaSaturated;break;case BlendColorFactor:blendFactor=GPUBlendFactor.Constant;break;case OneMinusBlendColorFactor:blendFactor=GPUBlendFactor.OneMinusConstant;break;default:console.error("THREE.WebGPURenderer: Blend factor not supported.",blend)}return blendFactor}_getStencilCompare(material){let stencilCompare;const stencilFunc=material.stencilFunc;switch(stencilFunc){case NeverStencilFunc:stencilCompare=GPUCompareFunction.Never;break;case AlwaysStencilFunc:stencilCompare=GPUCompareFunction.Always;break;case LessStencilFunc:stencilCompare=GPUCompareFunction.Less;break;case LessEqualStencilFunc:stencilCompare=GPUCompareFunction.LessEqual;break;case EqualStencilFunc:stencilCompare=GPUCompareFunction.Equal;break;case GreaterEqualStencilFunc:stencilCompare=GPUCompareFunction.GreaterEqual;break;case GreaterStencilFunc:stencilCompare=GPUCompareFunction.Greater;break;case NotEqualStencilFunc:stencilCompare=GPUCompareFunction.NotEqual;break;default:console.error("THREE.WebGPURenderer: Invalid stencil function.",stencilFunc)}return stencilCompare}_getStencilOperation(op){let stencilOperation;switch(op){case KeepStencilOp:stencilOperation=GPUStencilOperation.Keep;break;case ZeroStencilOp:stencilOperation=GPUStencilOperation.Zero;break;case ReplaceStencilOp:stencilOperation=GPUStencilOperation.Replace;break;case InvertStencilOp:stencilOperation=GPUStencilOperation.Invert;break;case IncrementStencilOp:stencilOperation=GPUStencilOperation.IncrementClamp;break;case DecrementStencilOp:stencilOperation=GPUStencilOperation.DecrementClamp;break;case IncrementWrapStencilOp:stencilOperation=GPUStencilOperation.IncrementWrap;break;case DecrementWrapStencilOp:stencilOperation=GPUStencilOperation.DecrementWrap;break;default:console.error("THREE.WebGPURenderer: Invalid stencil operation.",stencilOperation)}return stencilOperation}_getBlendOperation(blendEquation){let blendOperation;switch(blendEquation){case AddEquation:blendOperation=GPUBlendOperation.Add;break;case SubtractEquation:blendOperation=GPUBlendOperation.Subtract;break;case ReverseSubtractEquation:blendOperation=GPUBlendOperation.ReverseSubtract;break;case MinEquation:blendOperation=GPUBlendOperation.Min;break;case MaxEquation:blendOperation=GPUBlendOperation.Max;break;default:console.error("THREE.WebGPUPipelineUtils: Blend equation not supported.",blendEquation)}return blendOperation}_getPrimitiveState(object,geometry2,material){const descriptor={},utils2=this.backend.utils;switch(descriptor.topology=utils2.getPrimitiveTopology(object,material),geometry2.index!==null&&object.isLine===!0&&object.isLineSegments!==!0&&(descriptor.stripIndexFormat=geometry2.index.array instanceof Uint16Array?GPUIndexFormat.Uint16:GPUIndexFormat.Uint32),material.side){case FrontSide:descriptor.frontFace=GPUFrontFace.CCW,descriptor.cullMode=GPUCullMode.Back;break;case BackSide:descriptor.frontFace=GPUFrontFace.CCW,descriptor.cullMode=GPUCullMode.Front;break;case DoubleSide:descriptor.frontFace=GPUFrontFace.CCW,descriptor.cullMode=GPUCullMode.None;break;default:console.error("THREE.WebGPUPipelineUtils: Unknown material.side value.",material.side);break}return descriptor}_getColorWriteMask(material){return material.colorWrite===!0?GPUColorWriteFlags.All:GPUColorWriteFlags.None}_getDepthCompare(material){let depthCompare;if(material.depthTest===!1)depthCompare=GPUCompareFunction.Always;else{const depthFunc=material.depthFunc;switch(depthFunc){case NeverDepth:depthCompare=GPUCompareFunction.Never;break;case AlwaysDepth:depthCompare=GPUCompareFunction.Always;break;case LessDepth:depthCompare=GPUCompareFunction.Less;break;case LessEqualDepth:depthCompare=GPUCompareFunction.LessEqual;break;case EqualDepth:depthCompare=GPUCompareFunction.Equal;break;case GreaterEqualDepth:depthCompare=GPUCompareFunction.GreaterEqual;break;case GreaterDepth:depthCompare=GPUCompareFunction.Greater;break;case NotEqualDepth:depthCompare=GPUCompareFunction.NotEqual;break;default:console.error("THREE.WebGPUPipelineUtils: Invalid depth function.",depthFunc)}}return depthCompare}}class WebGPUTimestampQueryPool extends TimestampQueryPool{constructor(device,type,maxQueries=2048){super(maxQueries),this.device=device,this.type=type,this.querySet=this.device.createQuerySet({type:"timestamp",count:this.maxQueries,label:`queryset_global_timestamp_${type}`});const bufferSize=this.maxQueries*8;this.resolveBuffer=this.device.createBuffer({label:`buffer_timestamp_resolve_${type}`,size:bufferSize,usage:GPUBufferUsage.QUERY_RESOLVE|GPUBufferUsage.COPY_SRC}),this.resultBuffer=this.device.createBuffer({label:`buffer_timestamp_result_${type}`,size:bufferSize,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ})}allocateQueriesForContext(renderContext){if(!this.trackTimestamp||this.isDisposed)return null;if(this.currentQueryIndex+2>this.maxQueries)return warnOnce(`WebGPUTimestampQueryPool [${this.type}]: Maximum number of queries exceeded, when using trackTimestamp it is necessary to resolves the queries via renderer.resolveTimestampsAsync( THREE.TimestampQuery.${this.type.toUpperCase()} ).`),null;const baseOffset=this.currentQueryIndex;return this.currentQueryIndex+=2,this.queryOffsets.set(renderContext.id,baseOffset),baseOffset}async resolveQueriesAsync(){if(!this.trackTimestamp||this.currentQueryIndex===0||this.isDisposed)return this.lastValue;if(this.pendingResolve)return this.pendingResolve;this.pendingResolve=this._resolveQueries();try{return await this.pendingResolve}finally{this.pendingResolve=null}}async _resolveQueries(){if(this.isDisposed)return this.lastValue;try{if(this.resultBuffer.mapState!=="unmapped")return this.lastValue;const currentOffsets=new Map(this.queryOffsets),queryCount=this.currentQueryIndex,bytesUsed=queryCount*8;this.currentQueryIndex=0,this.queryOffsets.clear();const commandEncoder=this.device.createCommandEncoder();commandEncoder.resolveQuerySet(this.querySet,0,queryCount,this.resolveBuffer,0),commandEncoder.copyBufferToBuffer(this.resolveBuffer,0,this.resultBuffer,0,bytesUsed);const commandBuffer=commandEncoder.finish();if(this.device.queue.submit([commandBuffer]),this.resultBuffer.mapState!=="unmapped")return this.lastValue;if(await this.resultBuffer.mapAsync(GPUMapMode.READ,0,bytesUsed),this.isDisposed)return this.resultBuffer.mapState==="mapped"&&this.resultBuffer.unmap(),this.lastValue;const times=new BigUint64Array(this.resultBuffer.getMappedRange(0,bytesUsed));let totalDuration=0;for(const[,baseOffset]of currentOffsets){const startTime=times[baseOffset],endTime=times[baseOffset+1],duration=Number(endTime-startTime)/1e6;totalDuration+=duration}return this.resultBuffer.unmap(),this.lastValue=totalDuration,totalDuration}catch(error){return console.error("Error resolving queries:",error),this.resultBuffer.mapState==="mapped"&&this.resultBuffer.unmap(),this.lastValue}}async dispose(){if(!this.isDisposed){if(this.isDisposed=!0,this.pendingResolve)try{await this.pendingResolve}catch(error){console.error("Error waiting for pending resolve:",error)}if(this.resultBuffer&&this.resultBuffer.mapState==="mapped")try{this.resultBuffer.unmap()}catch(error){console.error("Error unmapping buffer:",error)}this.querySet&&(this.querySet.destroy(),this.querySet=null),this.resolveBuffer&&(this.resolveBuffer.destroy(),this.resolveBuffer=null),this.resultBuffer&&(this.resultBuffer.destroy(),this.resultBuffer=null),this.queryOffsets.clear(),this.pendingResolve=null}}}class WebGPUBackend extends Backend{constructor(parameters={}){super(parameters),this.isWebGPUBackend=!0,this.parameters.alpha=parameters.alpha===void 0?!0:parameters.alpha,this.parameters.requiredLimits=parameters.requiredLimits===void 0?{}:parameters.requiredLimits,this.trackTimestamp=parameters.trackTimestamp===!0,this.device=null,this.context=null,this.colorBuffer=null,this.defaultRenderPassdescriptor=null,this.utils=new WebGPUUtils(this),this.attributeUtils=new WebGPUAttributeUtils(this),this.bindingUtils=new WebGPUBindingUtils(this),this.pipelineUtils=new WebGPUPipelineUtils(this),this.textureUtils=new WebGPUTextureUtils(this),this.occludedResolveCache=new Map}async init(renderer){await super.init(renderer);const parameters=this.parameters;let device;if(parameters.device===void 0){const adapterOptions={powerPreference:parameters.powerPreference},adapter=typeof navigator<"u"?await navigator.gpu.requestAdapter(adapterOptions):null;if(adapter===null)throw new Error("WebGPUBackend: Unable to create WebGPU adapter.");const features=Object.values(GPUFeatureName),supportedFeatures=[];for(const name of features)adapter.features.has(name)&&supportedFeatures.push(name);const deviceDescriptor={requiredFeatures:supportedFeatures,requiredLimits:parameters.requiredLimits};device=await adapter.requestDevice(deviceDescriptor)}else device=parameters.device;device.lost.then(info=>{const deviceLossInfo={api:"WebGPU",message:info.message||"Unknown reason",reason:info.reason||null,originalEvent:info};renderer.onDeviceLost(deviceLossInfo)});const context2=parameters.context!==void 0?parameters.context:renderer.domElement.getContext("webgpu");this.device=device,this.context=context2;const alphaMode=parameters.alpha?"premultiplied":"opaque";this.trackTimestamp=this.trackTimestamp&&this.hasFeature(GPUFeatureName.TimestampQuery),this.context.configure({device:this.device,format:this.utils.getPreferredCanvasFormat(),usage:GPUTextureUsage.RENDER_ATTACHMENT|GPUTextureUsage.COPY_SRC,alphaMode}),this.updateSize()}get coordinateSystem(){return WebGPUCoordinateSystem}async getArrayBufferAsync(attribute2){return await this.attributeUtils.getArrayBufferAsync(attribute2)}getContext(){return this.context}_getDefaultRenderPassDescriptor(){let descriptor=this.defaultRenderPassdescriptor;if(descriptor===null){const renderer=this.renderer;descriptor={colorAttachments:[{view:null}]},(this.renderer.depth===!0||this.renderer.stencil===!0)&&(descriptor.depthStencilAttachment={view:this.textureUtils.getDepthBuffer(renderer.depth,renderer.stencil).createView()});const colorAttachment2=descriptor.colorAttachments[0];this.renderer.samples>0?colorAttachment2.view=this.colorBuffer.createView():colorAttachment2.resolveTarget=void 0,this.defaultRenderPassdescriptor=descriptor}const colorAttachment=descriptor.colorAttachments[0];return this.renderer.samples>0?colorAttachment.resolveTarget=this.context.getCurrentTexture().createView():colorAttachment.view=this.context.getCurrentTexture().createView(),descriptor}_getRenderPassDescriptor(renderContext,colorAttachmentsConfig={}){const renderTarget=renderContext.renderTarget,renderTargetData=this.get(renderTarget);let descriptors=renderTargetData.descriptors;if(descriptors===void 0||renderTargetData.width!==renderTarget.width||renderTargetData.height!==renderTarget.height||renderTargetData.dimensions!==renderTarget.dimensions||renderTargetData.activeMipmapLevel!==renderTarget.activeMipmapLevel||renderTargetData.activeCubeFace!==renderContext.activeCubeFace||renderTargetData.samples!==renderTarget.samples||renderTargetData.loadOp!==colorAttachmentsConfig.loadOp){descriptors={},renderTargetData.descriptors=descriptors;const onDispose=()=>{renderTarget.removeEventListener("dispose",onDispose),this.delete(renderTarget)};renderTarget.addEventListener("dispose",onDispose)}const cacheKey=renderContext.getCacheKey();let descriptor=descriptors[cacheKey];if(descriptor===void 0){const textures=renderContext.textures,colorAttachments=[];let sliceIndex;for(let i2=0;i2<textures.length;i2++){const textureData=this.get(textures[i2]),viewDescriptor={label:`colorAttachment_${i2}`,baseMipLevel:renderContext.activeMipmapLevel,mipLevelCount:1,baseArrayLayer:renderContext.activeCubeFace,arrayLayerCount:1,dimension:GPUTextureViewDimension.TwoD};renderTarget.isRenderTarget3D?(sliceIndex=renderContext.activeCubeFace,viewDescriptor.baseArrayLayer=0,viewDescriptor.dimension=GPUTextureViewDimension.ThreeD,viewDescriptor.depthOrArrayLayers=textures[i2].image.depth):renderTarget.isRenderTargetArray&&(viewDescriptor.dimension=GPUTextureViewDimension.TwoDArray,viewDescriptor.depthOrArrayLayers=textures[i2].image.depth);const textureView=textureData.texture.createView(viewDescriptor);let view,resolveTarget;textureData.msaaTexture!==void 0?(view=textureData.msaaTexture.createView(),resolveTarget=textureView):(view=textureView,resolveTarget=void 0),colorAttachments.push({view,depthSlice:sliceIndex,resolveTarget,loadOp:GPULoadOp.Load,storeOp:GPUStoreOp.Store,...colorAttachmentsConfig})}if(descriptor={colorAttachments},renderContext.depth){const depthStencilAttachment={view:this.get(renderContext.depthTexture).texture.createView()};descriptor.depthStencilAttachment=depthStencilAttachment}descriptors[cacheKey]=descriptor,renderTargetData.width=renderTarget.width,renderTargetData.height=renderTarget.height,renderTargetData.samples=renderTarget.samples,renderTargetData.activeMipmapLevel=renderContext.activeMipmapLevel,renderTargetData.activeCubeFace=renderContext.activeCubeFace,renderTargetData.dimensions=renderTarget.dimensions,renderTargetData.depthSlice=sliceIndex,renderTargetData.loadOp=colorAttachments[0].loadOp}return descriptor}beginRender(renderContext){const renderContextData=this.get(renderContext),device=this.device,occlusionQueryCount=renderContext.occlusionQueryCount;let occlusionQuerySet;occlusionQueryCount>0&&(renderContextData.currentOcclusionQuerySet&&renderContextData.currentOcclusionQuerySet.destroy(),renderContextData.currentOcclusionQueryBuffer&&renderContextData.currentOcclusionQueryBuffer.destroy(),renderContextData.currentOcclusionQuerySet=renderContextData.occlusionQuerySet,renderContextData.currentOcclusionQueryBuffer=renderContextData.occlusionQueryBuffer,renderContextData.currentOcclusionQueryObjects=renderContextData.occlusionQueryObjects,occlusionQuerySet=device.createQuerySet({type:"occlusion",count:occlusionQueryCount,label:`occlusionQuerySet_${renderContext.id}`}),renderContextData.occlusionQuerySet=occlusionQuerySet,renderContextData.occlusionQueryIndex=0,renderContextData.occlusionQueryObjects=new Array(occlusionQueryCount),renderContextData.lastOcclusionObject=null);let descriptor;renderContext.textures===null?descriptor=this._getDefaultRenderPassDescriptor():descriptor=this._getRenderPassDescriptor(renderContext,{loadOp:GPULoadOp.Load}),this.initTimestampQuery(renderContext,descriptor),descriptor.occlusionQuerySet=occlusionQuerySet;const depthStencilAttachment=descriptor.depthStencilAttachment;if(renderContext.textures!==null){const colorAttachments=descriptor.colorAttachments;for(let i2=0;i2<colorAttachments.length;i2++){const colorAttachment=colorAttachments[i2];renderContext.clearColor?(colorAttachment.clearValue=i2===0?renderContext.clearColorValue:{r:0,g:0,b:0,a:1},colorAttachment.loadOp=GPULoadOp.Clear,colorAttachment.storeOp=GPUStoreOp.Store):(colorAttachment.loadOp=GPULoadOp.Load,colorAttachment.storeOp=GPUStoreOp.Store)}}else{const colorAttachment=descriptor.colorAttachments[0];renderContext.clearColor?(colorAttachment.clearValue=renderContext.clearColorValue,colorAttachment.loadOp=GPULoadOp.Clear,colorAttachment.storeOp=GPUStoreOp.Store):(colorAttachment.loadOp=GPULoadOp.Load,colorAttachment.storeOp=GPUStoreOp.Store)}renderContext.depth&&(renderContext.clearDepth?(depthStencilAttachment.depthClearValue=renderContext.clearDepthValue,depthStencilAttachment.depthLoadOp=GPULoadOp.Clear,depthStencilAttachment.depthStoreOp=GPUStoreOp.Store):(depthStencilAttachment.depthLoadOp=GPULoadOp.Load,depthStencilAttachment.depthStoreOp=GPUStoreOp.Store)),renderContext.stencil&&(renderContext.clearStencil?(depthStencilAttachment.stencilClearValue=renderContext.clearStencilValue,depthStencilAttachment.stencilLoadOp=GPULoadOp.Clear,depthStencilAttachment.stencilStoreOp=GPUStoreOp.Store):(depthStencilAttachment.stencilLoadOp=GPULoadOp.Load,depthStencilAttachment.stencilStoreOp=GPUStoreOp.Store));const encoder=device.createCommandEncoder({label:"renderContext_"+renderContext.id}),currentPass=encoder.beginRenderPass(descriptor);if(renderContextData.descriptor=descriptor,renderContextData.encoder=encoder,renderContextData.currentPass=currentPass,renderContextData.currentSets={attributes:{},bindingGroups:[],pipeline:null,index:null},renderContextData.renderBundles=[],renderContext.viewport&&this.updateViewport(renderContext),renderContext.scissor){const{x,y,width,height}=renderContext.scissorValue;currentPass.setScissorRect(x,y,width,height)}}finishRender(renderContext){const renderContextData=this.get(renderContext),occlusionQueryCount=renderContext.occlusionQueryCount;if(renderContextData.renderBundles.length>0&&renderContextData.currentPass.executeBundles(renderContextData.renderBundles),occlusionQueryCount>renderContextData.occlusionQueryIndex&&renderContextData.currentPass.endOcclusionQuery(),renderContextData.currentPass.end(),occlusionQueryCount>0){const bufferSize=occlusionQueryCount*8;let queryResolveBuffer=this.occludedResolveCache.get(bufferSize);queryResolveBuffer===void 0&&(queryResolveBuffer=this.device.createBuffer({size:bufferSize,usage:GPUBufferUsage.QUERY_RESOLVE|GPUBufferUsage.COPY_SRC}),this.occludedResolveCache.set(bufferSize,queryResolveBuffer));const readBuffer=this.device.createBuffer({size:bufferSize,usage:GPUBufferUsage.COPY_DST|GPUBufferUsage.MAP_READ});renderContextData.encoder.resolveQuerySet(renderContextData.occlusionQuerySet,0,occlusionQueryCount,queryResolveBuffer,0),renderContextData.encoder.copyBufferToBuffer(queryResolveBuffer,0,readBuffer,0,bufferSize),renderContextData.occlusionQueryBuffer=readBuffer,this.resolveOccludedAsync(renderContext)}if(this.device.queue.submit([renderContextData.encoder.finish()]),renderContext.textures!==null){const textures=renderContext.textures;for(let i2=0;i2<textures.length;i2++){const texture2=textures[i2];texture2.generateMipmaps===!0&&this.textureUtils.generateMipmaps(texture2)}}}isOccluded(renderContext,object){const renderContextData=this.get(renderContext);return renderContextData.occluded&&renderContextData.occluded.has(object)}async resolveOccludedAsync(renderContext){const renderContextData=this.get(renderContext),{currentOcclusionQueryBuffer,currentOcclusionQueryObjects}=renderContextData;if(currentOcclusionQueryBuffer&&currentOcclusionQueryObjects){const occluded=new WeakSet;renderContextData.currentOcclusionQueryObjects=null,renderContextData.currentOcclusionQueryBuffer=null,await currentOcclusionQueryBuffer.mapAsync(GPUMapMode.READ);const buffer2=currentOcclusionQueryBuffer.getMappedRange(),results=new BigUint64Array(buffer2);for(let i2=0;i2<currentOcclusionQueryObjects.length;i2++)results[i2]===BigInt(0)&&occluded.add(currentOcclusionQueryObjects[i2]);currentOcclusionQueryBuffer.destroy(),renderContextData.occluded=occluded}}updateViewport(renderContext){const{currentPass}=this.get(renderContext),{x,y,width,height,minDepth,maxDepth}=renderContext.viewportValue;currentPass.setViewport(x,y,width,height,minDepth,maxDepth)}getClearColor(){const clearColor=super.getClearColor();return this.renderer.alpha===!0&&(clearColor.r*=clearColor.a,clearColor.g*=clearColor.a,clearColor.b*=clearColor.a),clearColor}clear(color2,depth2,stencil,renderTargetContext=null){const device=this.device,renderer=this.renderer;let colorAttachments=[],depthStencilAttachment,clearValue,supportsDepth,supportsStencil;if(color2){const clearColor=this.getClearColor();clearValue={r:clearColor.r,g:clearColor.g,b:clearColor.b,a:clearColor.a}}if(renderTargetContext===null){supportsDepth=renderer.depth,supportsStencil=renderer.stencil;const descriptor=this._getDefaultRenderPassDescriptor();if(color2){colorAttachments=descriptor.colorAttachments;const colorAttachment=colorAttachments[0];colorAttachment.clearValue=clearValue,colorAttachment.loadOp=GPULoadOp.Clear,colorAttachment.storeOp=GPUStoreOp.Store}(supportsDepth||supportsStencil)&&(depthStencilAttachment=descriptor.depthStencilAttachment)}else supportsDepth=renderTargetContext.depth,supportsStencil=renderTargetContext.stencil,color2&&(colorAttachments=this._getRenderPassDescriptor(renderTargetContext,{loadOp:GPULoadOp.Clear,clearValue}).colorAttachments),(supportsDepth||supportsStencil)&&(depthStencilAttachment={view:this.get(renderTargetContext.depthTexture).texture.createView()});supportsDepth&&(depth2?(depthStencilAttachment.depthLoadOp=GPULoadOp.Clear,depthStencilAttachment.depthClearValue=renderer.getClearDepth(),depthStencilAttachment.depthStoreOp=GPUStoreOp.Store):(depthStencilAttachment.depthLoadOp=GPULoadOp.Load,depthStencilAttachment.depthStoreOp=GPUStoreOp.Store)),supportsStencil&&(stencil?(depthStencilAttachment.stencilLoadOp=GPULoadOp.Clear,depthStencilAttachment.stencilClearValue=renderer.getClearStencil(),depthStencilAttachment.stencilStoreOp=GPUStoreOp.Store):(depthStencilAttachment.stencilLoadOp=GPULoadOp.Load,depthStencilAttachment.stencilStoreOp=GPUStoreOp.Store));const encoder=device.createCommandEncoder({label:"clear"});encoder.beginRenderPass({colorAttachments,depthStencilAttachment}).end(),device.queue.submit([encoder.finish()])}beginCompute(computeGroup){const groupGPU=this.get(computeGroup),descriptor={label:"computeGroup_"+computeGroup.id};this.initTimestampQuery(computeGroup,descriptor),groupGPU.cmdEncoderGPU=this.device.createCommandEncoder({label:"computeGroup_"+computeGroup.id}),groupGPU.passEncoderGPU=groupGPU.cmdEncoderGPU.beginComputePass(descriptor)}compute(computeGroup,computeNode,bindings,pipeline){const{passEncoderGPU}=this.get(computeGroup),pipelineGPU=this.get(pipeline).pipeline;passEncoderGPU.setPipeline(pipelineGPU);for(let i2=0,l2=bindings.length;i2<l2;i2++){const bindGroup=bindings[i2],bindingsData=this.get(bindGroup);passEncoderGPU.setBindGroup(i2,bindingsData.group)}const maxComputeWorkgroupsPerDimension=this.device.limits.maxComputeWorkgroupsPerDimension,computeNodeData=this.get(computeNode);computeNodeData.dispatchSize===void 0&&(computeNodeData.dispatchSize={x:0,y:1,z:1});const{dispatchSize}=computeNodeData;computeNode.dispatchCount>maxComputeWorkgroupsPerDimension?(dispatchSize.x=Math.min(computeNode.dispatchCount,maxComputeWorkgroupsPerDimension),dispatchSize.y=Math.ceil(computeNode.dispatchCount/maxComputeWorkgroupsPerDimension)):dispatchSize.x=computeNode.dispatchCount,passEncoderGPU.dispatchWorkgroups(dispatchSize.x,dispatchSize.y,dispatchSize.z)}finishCompute(computeGroup){const groupData=this.get(computeGroup);groupData.passEncoderGPU.end(),this.device.queue.submit([groupData.cmdEncoderGPU.finish()])}async waitForGPU(){await this.device.queue.onSubmittedWorkDone()}draw(renderObject,info){const{object,material,context:context2,pipeline}=renderObject,bindings=renderObject.getBindings(),renderContextData=this.get(context2),pipelineGPU=this.get(pipeline).pipeline,currentSets=renderContextData.currentSets,passEncoderGPU=renderContextData.currentPass,drawParams=renderObject.getDrawParameters();if(drawParams===null)return;currentSets.pipeline!==pipelineGPU&&(passEncoderGPU.setPipeline(pipelineGPU),currentSets.pipeline=pipelineGPU);const currentBindingGroups=currentSets.bindingGroups;for(let i2=0,l2=bindings.length;i2<l2;i2++){const bindGroup=bindings[i2],bindingsData=this.get(bindGroup);currentBindingGroups[bindGroup.index]!==bindGroup.id&&(passEncoderGPU.setBindGroup(bindGroup.index,bindingsData.group),currentBindingGroups[bindGroup.index]=bindGroup.id)}const index=renderObject.getIndex(),hasIndex=index!==null;if(hasIndex===!0&&currentSets.index!==index){const buffer2=this.get(index).buffer,indexFormat=index.array instanceof Uint16Array?GPUIndexFormat.Uint16:GPUIndexFormat.Uint32;passEncoderGPU.setIndexBuffer(buffer2,indexFormat),currentSets.index=index}const vertexBuffers=renderObject.getVertexBuffers();for(let i2=0,l2=vertexBuffers.length;i2<l2;i2++){const vertexBuffer=vertexBuffers[i2];if(currentSets.attributes[i2]!==vertexBuffer){const buffer2=this.get(vertexBuffer).buffer;passEncoderGPU.setVertexBuffer(i2,buffer2),currentSets.attributes[i2]=vertexBuffer}}if(renderContextData.occlusionQuerySet!==void 0){const lastObject=renderContextData.lastOcclusionObject;lastObject!==object&&(lastObject!==null&&lastObject.occlusionTest===!0&&(passEncoderGPU.endOcclusionQuery(),renderContextData.occlusionQueryIndex++),object.occlusionTest===!0&&(passEncoderGPU.beginOcclusionQuery(renderContextData.occlusionQueryIndex),renderContextData.occlusionQueryObjects[renderContextData.occlusionQueryIndex]=object),renderContextData.lastOcclusionObject=object)}context2.stencil===!0&&material.stencilWrite===!0&&renderContextData.currentStencilRef!==material.stencilRef&&(passEncoderGPU.setStencilReference(material.stencilRef),renderContextData.currentStencilRef=material.stencilRef);const draw=()=>{if(object.isBatchedMesh===!0){const starts=object._multiDrawStarts,counts=object._multiDrawCounts,drawCount=object._multiDrawCount,drawInstances=object._multiDrawInstances;drawInstances!==null&&warnOnce("THREE.WebGPUBackend: renderMultiDrawInstances has been deprecated and will be removed in r184. Append to renderMultiDraw arguments and use indirection.");for(let i2=0;i2<drawCount;i2++){const count=drawInstances?drawInstances[i2]:1,firstInstance=count>1?0:i2;hasIndex===!0?passEncoderGPU.drawIndexed(counts[i2],count,starts[i2]/index.array.BYTES_PER_ELEMENT,0,firstInstance):passEncoderGPU.draw(counts[i2],count,starts[i2],firstInstance),info.update(object,counts[i2],count)}}else if(hasIndex===!0){const{vertexCount:indexCount,instanceCount,firstVertex:firstIndex}=drawParams,indirect=renderObject.getIndirect();if(indirect!==null){const buffer2=this.get(indirect).buffer;passEncoderGPU.drawIndexedIndirect(buffer2,0)}else passEncoderGPU.drawIndexed(indexCount,instanceCount,firstIndex,0,0);info.update(object,indexCount,instanceCount)}else{const{vertexCount,instanceCount,firstVertex}=drawParams,indirect=renderObject.getIndirect();if(indirect!==null){const buffer2=this.get(indirect).buffer;passEncoderGPU.drawIndirect(buffer2,0)}else passEncoderGPU.draw(vertexCount,instanceCount,firstVertex,0);info.update(object,vertexCount,instanceCount)}};if(renderObject.camera.isArrayCamera&&renderObject.camera.cameras.length>0){const cameraData=this.get(renderObject.camera),cameras=renderObject.camera.cameras,cameraIndex2=renderObject.getBindingGroup("cameraIndex");if(cameraData.indexesGPU===void 0||cameraData.indexesGPU.length!==cameras.length){const bindingsData=this.get(cameraIndex2),indexesGPU=[],data=new Uint32Array([0,0,0,0]);for(let i2=0,len=cameras.length;i2<len;i2++){data[0]=i2;const bindGroupIndex=this.bindingUtils.createBindGroupIndex(data,bindingsData.layout);indexesGPU.push(bindGroupIndex)}cameraData.indexesGPU=indexesGPU}const pixelRatio=this.renderer.getPixelRatio();for(let i2=0,len=cameras.length;i2<len;i2++){const subCamera=cameras[i2];if(object.layers.test(subCamera.layers)){const vp=subCamera.viewport;passEncoderGPU.setViewport(Math.floor(vp.x*pixelRatio),Math.floor(vp.y*pixelRatio),Math.floor(vp.width*pixelRatio),Math.floor(vp.height*pixelRatio),context2.viewportValue.minDepth,context2.viewportValue.maxDepth),passEncoderGPU.setBindGroup(cameraIndex2.index,cameraData.indexesGPU[i2]),draw()}}}else draw()}needsRenderUpdate(renderObject){const data=this.get(renderObject),{object,material}=renderObject,utils2=this.utils,sampleCount=utils2.getSampleCountRenderContext(renderObject.context),colorSpace=utils2.getCurrentColorSpace(renderObject.context),colorFormat=utils2.getCurrentColorFormat(renderObject.context),depthStencilFormat=utils2.getCurrentDepthStencilFormat(renderObject.context),primitiveTopology=utils2.getPrimitiveTopology(object,material);let needsUpdate=!1;return(data.material!==material||data.materialVersion!==material.version||data.transparent!==material.transparent||data.blending!==material.blending||data.premultipliedAlpha!==material.premultipliedAlpha||data.blendSrc!==material.blendSrc||data.blendDst!==material.blendDst||data.blendEquation!==material.blendEquation||data.blendSrcAlpha!==material.blendSrcAlpha||data.blendDstAlpha!==material.blendDstAlpha||data.blendEquationAlpha!==material.blendEquationAlpha||data.colorWrite!==material.colorWrite||data.depthWrite!==material.depthWrite||data.depthTest!==material.depthTest||data.depthFunc!==material.depthFunc||data.stencilWrite!==material.stencilWrite||data.stencilFunc!==material.stencilFunc||data.stencilFail!==material.stencilFail||data.stencilZFail!==material.stencilZFail||data.stencilZPass!==material.stencilZPass||data.stencilFuncMask!==material.stencilFuncMask||data.stencilWriteMask!==material.stencilWriteMask||data.side!==material.side||data.alphaToCoverage!==material.alphaToCoverage||data.sampleCount!==sampleCount||data.colorSpace!==colorSpace||data.colorFormat!==colorFormat||data.depthStencilFormat!==depthStencilFormat||data.primitiveTopology!==primitiveTopology||data.clippingContextCacheKey!==renderObject.clippingContextCacheKey)&&(data.material=material,data.materialVersion=material.version,data.transparent=material.transparent,data.blending=material.blending,data.premultipliedAlpha=material.premultipliedAlpha,data.blendSrc=material.blendSrc,data.blendDst=material.blendDst,data.blendEquation=material.blendEquation,data.blendSrcAlpha=material.blendSrcAlpha,data.blendDstAlpha=material.blendDstAlpha,data.blendEquationAlpha=material.blendEquationAlpha,data.colorWrite=material.colorWrite,data.depthWrite=material.depthWrite,data.depthTest=material.depthTest,data.depthFunc=material.depthFunc,data.stencilWrite=material.stencilWrite,data.stencilFunc=material.stencilFunc,data.stencilFail=material.stencilFail,data.stencilZFail=material.stencilZFail,data.stencilZPass=material.stencilZPass,data.stencilFuncMask=material.stencilFuncMask,data.stencilWriteMask=material.stencilWriteMask,data.side=material.side,data.alphaToCoverage=material.alphaToCoverage,data.sampleCount=sampleCount,data.colorSpace=colorSpace,data.colorFormat=colorFormat,data.depthStencilFormat=depthStencilFormat,data.primitiveTopology=primitiveTopology,data.clippingContextCacheKey=renderObject.clippingContextCacheKey,needsUpdate=!0),needsUpdate}getRenderCacheKey(renderObject){const{object,material}=renderObject,utils2=this.utils,renderContext=renderObject.context;return[material.transparent,material.blending,material.premultipliedAlpha,material.blendSrc,material.blendDst,material.blendEquation,material.blendSrcAlpha,material.blendDstAlpha,material.blendEquationAlpha,material.colorWrite,material.depthWrite,material.depthTest,material.depthFunc,material.stencilWrite,material.stencilFunc,material.stencilFail,material.stencilZFail,material.stencilZPass,material.stencilFuncMask,material.stencilWriteMask,material.side,utils2.getSampleCountRenderContext(renderContext),utils2.getCurrentColorSpace(renderContext),utils2.getCurrentColorFormat(renderContext),utils2.getCurrentDepthStencilFormat(renderContext),utils2.getPrimitiveTopology(object,material),renderObject.getGeometryCacheKey(),renderObject.clippingContextCacheKey].join()}createSampler(texture2){this.textureUtils.createSampler(texture2)}destroySampler(texture2){this.textureUtils.destroySampler(texture2)}createDefaultTexture(texture2){this.textureUtils.createDefaultTexture(texture2)}createTexture(texture2,options){this.textureUtils.createTexture(texture2,options)}updateTexture(texture2,options){this.textureUtils.updateTexture(texture2,options)}generateMipmaps(texture2){this.textureUtils.generateMipmaps(texture2)}destroyTexture(texture2){this.textureUtils.destroyTexture(texture2)}async copyTextureToBuffer(texture2,x,y,width,height,faceIndex){return this.textureUtils.copyTextureToBuffer(texture2,x,y,width,height,faceIndex)}initTimestampQuery(renderContext,descriptor){if(!this.trackTimestamp)return;const type=renderContext.isComputeNode?"compute":"render";this.timestampQueryPool[type]||(this.timestampQueryPool[type]=new WebGPUTimestampQueryPool(this.device,type,2048));const timestampQueryPool=this.timestampQueryPool[type],baseOffset=timestampQueryPool.allocateQueriesForContext(renderContext);descriptor.timestampWrites={querySet:timestampQueryPool.querySet,beginningOfPassWriteIndex:baseOffset,endOfPassWriteIndex:baseOffset+1}}createNodeBuilder(object,renderer){return new WGSLNodeBuilder(object,renderer)}createProgram(program){const programGPU=this.get(program);programGPU.module={module:this.device.createShaderModule({code:program.code,label:program.stage+(program.name!==""?`_${program.name}`:"")}),entryPoint:"main"}}destroyProgram(program){this.delete(program)}createRenderPipeline(renderObject,promises){this.pipelineUtils.createRenderPipeline(renderObject,promises)}createComputePipeline(computePipeline,bindings){this.pipelineUtils.createComputePipeline(computePipeline,bindings)}beginBundle(renderContext){const renderContextData=this.get(renderContext);renderContextData._currentPass=renderContextData.currentPass,renderContextData._currentSets=renderContextData.currentSets,renderContextData.currentSets={attributes:{},bindingGroups:[],pipeline:null,index:null},renderContextData.currentPass=this.pipelineUtils.createBundleEncoder(renderContext)}finishBundle(renderContext,bundle){const renderContextData=this.get(renderContext),bundleGPU=renderContextData.currentPass.finish();this.get(bundle).bundleGPU=bundleGPU,renderContextData.currentSets=renderContextData._currentSets,renderContextData.currentPass=renderContextData._currentPass}addBundle(renderContext,bundle){this.get(renderContext).renderBundles.push(this.get(bundle).bundleGPU)}createBindings(bindGroup,bindings,cacheIndex,version){this.bindingUtils.createBindings(bindGroup,bindings,cacheIndex,version)}updateBindings(bindGroup,bindings,cacheIndex,version){this.bindingUtils.createBindings(bindGroup,bindings,cacheIndex,version)}updateBinding(binding){this.bindingUtils.updateBinding(binding)}createIndexAttribute(attribute2){this.attributeUtils.createAttribute(attribute2,GPUBufferUsage.INDEX|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST)}createAttribute(attribute2){this.attributeUtils.createAttribute(attribute2,GPUBufferUsage.VERTEX|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST)}createStorageAttribute(attribute2){this.attributeUtils.createAttribute(attribute2,GPUBufferUsage.STORAGE|GPUBufferUsage.VERTEX|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST)}createIndirectStorageAttribute(attribute2){this.attributeUtils.createAttribute(attribute2,GPUBufferUsage.STORAGE|GPUBufferUsage.INDIRECT|GPUBufferUsage.COPY_SRC|GPUBufferUsage.COPY_DST)}updateAttribute(attribute2){this.attributeUtils.updateAttribute(attribute2)}destroyAttribute(attribute2){this.attributeUtils.destroyAttribute(attribute2)}updateSize(){this.colorBuffer=this.textureUtils.getColorBuffer(),this.defaultRenderPassdescriptor=null}getMaxAnisotropy(){return 16}hasFeature(name){return this.device.features.has(name)}copyTextureToTexture(srcTexture,dstTexture,srcRegion=null,dstPosition=null,level=0){let dstX=0,dstY=0,dstLayer=0,srcX=0,srcY=0,srcLayer=0,srcWidth=srcTexture.image.width,srcHeight=srcTexture.image.height;srcRegion!==null&&(srcX=srcRegion.x,srcY=srcRegion.y,srcLayer=srcRegion.z||0,srcWidth=srcRegion.width,srcHeight=srcRegion.height),dstPosition!==null&&(dstX=dstPosition.x,dstY=dstPosition.y,dstLayer=dstPosition.z||0);const encoder=this.device.createCommandEncoder({label:"copyTextureToTexture_"+srcTexture.id+"_"+dstTexture.id}),sourceGPU=this.get(srcTexture).texture,destinationGPU=this.get(dstTexture).texture;encoder.copyTextureToTexture({texture:sourceGPU,mipLevel:level,origin:{x:srcX,y:srcY,z:srcLayer}},{texture:destinationGPU,mipLevel:level,origin:{x:dstX,y:dstY,z:dstLayer}},[srcWidth,srcHeight,1]),this.device.queue.submit([encoder.finish()])}copyFramebufferToTexture(texture2,renderContext,rectangle){const renderContextData=this.get(renderContext);let sourceGPU=null;renderContext.renderTarget?texture2.isDepthTexture?sourceGPU=this.get(renderContext.depthTexture).texture:sourceGPU=this.get(renderContext.textures[0]).texture:texture2.isDepthTexture?sourceGPU=this.textureUtils.getDepthBuffer(renderContext.depth,renderContext.stencil):sourceGPU=this.context.getCurrentTexture();const destinationGPU=this.get(texture2).texture;if(sourceGPU.format!==destinationGPU.format){console.error("WebGPUBackend: copyFramebufferToTexture: Source and destination formats do not match.",sourceGPU.format,destinationGPU.format);return}let encoder;if(renderContextData.currentPass?(renderContextData.currentPass.end(),encoder=renderContextData.encoder):encoder=this.device.createCommandEncoder({label:"copyFramebufferToTexture_"+texture2.id}),encoder.copyTextureToTexture({texture:sourceGPU,origin:[rectangle.x,rectangle.y,0]},{texture:destinationGPU},[rectangle.z,rectangle.w]),texture2.generateMipmaps&&this.textureUtils.generateMipmaps(texture2),renderContextData.currentPass){const{descriptor}=renderContextData;for(let i2=0;i2<descriptor.colorAttachments.length;i2++)descriptor.colorAttachments[i2].loadOp=GPULoadOp.Load;if(renderContext.depth&&(descriptor.depthStencilAttachment.depthLoadOp=GPULoadOp.Load),renderContext.stencil&&(descriptor.depthStencilAttachment.stencilLoadOp=GPULoadOp.Load),renderContextData.currentPass=encoder.beginRenderPass(descriptor),renderContextData.currentSets={attributes:{},bindingGroups:[],pipeline:null,index:null},renderContext.viewport&&this.updateViewport(renderContext),renderContext.scissor){const{x,y,width,height}=renderContext.scissorValue;renderContextData.currentPass.setScissorRect(x,y,width,height)}}else this.device.queue.submit([encoder.finish()])}}class IESSpotLight extends SpotLight{constructor(color2,intensity,distance2,angle,penumbra,decay){super(color2,intensity,distance2,angle,penumbra,decay),this.iesMap=null}copy(source,recursive){return super.copy(source,recursive),this.iesMap=source.iesMap,this}}class StandardNodeLibrary extends NodeLibrary{constructor(){super(),this.addMaterial(MeshPhongNodeMaterial,"MeshPhongMaterial"),this.addMaterial(MeshStandardNodeMaterial,"MeshStandardMaterial"),this.addMaterial(MeshPhysicalNodeMaterial,"MeshPhysicalMaterial"),this.addMaterial(MeshToonNodeMaterial,"MeshToonMaterial"),this.addMaterial(MeshBasicNodeMaterial,"MeshBasicMaterial"),this.addMaterial(MeshLambertNodeMaterial,"MeshLambertMaterial"),this.addMaterial(MeshNormalNodeMaterial,"MeshNormalMaterial"),this.addMaterial(MeshMatcapNodeMaterial,"MeshMatcapMaterial"),this.addMaterial(LineBasicNodeMaterial,"LineBasicMaterial"),this.addMaterial(LineDashedNodeMaterial,"LineDashedMaterial"),this.addMaterial(PointsNodeMaterial,"PointsMaterial"),this.addMaterial(SpriteNodeMaterial,"SpriteMaterial"),this.addMaterial(ShadowNodeMaterial,"ShadowMaterial"),this.addLight(PointLightNode,PointLight),this.addLight(DirectionalLightNode,DirectionalLight),this.addLight(RectAreaLightNode,RectAreaLight),this.addLight(SpotLightNode,SpotLight),this.addLight(AmbientLightNode,AmbientLight),this.addLight(HemisphereLightNode,HemisphereLight),this.addLight(LightProbeNode,LightProbe),this.addLight(IESSpotLightNode,IESSpotLight),this.addToneMapping(linearToneMapping,LinearToneMapping),this.addToneMapping(reinhardToneMapping,ReinhardToneMapping),this.addToneMapping(cineonToneMapping,CineonToneMapping),this.addToneMapping(acesFilmicToneMapping,ACESFilmicToneMapping),this.addToneMapping(agxToneMapping,AgXToneMapping),this.addToneMapping(neutralToneMapping,NeutralToneMapping)}}class WebGPURenderer extends Renderer{constructor(parameters={}){let BackendClass;parameters.forceWebGL?BackendClass=WebGLBackend:(BackendClass=WebGPUBackend,parameters.getFallback=()=>(console.warn("THREE.WebGPURenderer: WebGPU is not available, running under WebGL2 backend."),new WebGLBackend(parameters)));const backend=new BackendClass(parameters);super(backend,parameters),this.library=new StandardNodeLibrary,this.isWebGPURenderer=!0}}class PostProcessing{constructor(renderer,outputNode=vec4$1(0,0,1,1)){this.renderer=renderer,this.outputNode=outputNode,this.outputColorTransform=!0,this.needsUpdate=!0;const material=new NodeMaterial;material.name="PostProcessing",this._quadMesh=new QuadMesh(material)}render(){this._update();const renderer=this.renderer,toneMapping2=renderer.toneMapping,outputColorSpace=renderer.outputColorSpace;renderer.toneMapping=NoToneMapping,renderer.outputColorSpace=LinearSRGBColorSpace;const currentXR=renderer.xr.enabled;renderer.xr.enabled=!1,this._quadMesh.render(renderer),renderer.xr.enabled=currentXR,renderer.toneMapping=toneMapping2,renderer.outputColorSpace=outputColorSpace}dispose(){this._quadMesh.material.dispose()}_update(){if(this.needsUpdate===!0){const renderer=this.renderer,toneMapping2=renderer.toneMapping,outputColorSpace=renderer.outputColorSpace;this._quadMesh.material.fragmentNode=this.outputColorTransform===!0?renderOutput(this.outputNode,toneMapping2,outputColorSpace):this.outputNode.context({toneMapping:toneMapping2,outputColorSpace}),this._quadMesh.material.needsUpdate=!0,this.needsUpdate=!1}}async renderAsync(){this._update();const renderer=this.renderer,toneMapping2=renderer.toneMapping,outputColorSpace=renderer.outputColorSpace;renderer.toneMapping=NoToneMapping,renderer.outputColorSpace=LinearSRGBColorSpace;const currentXR=renderer.xr.enabled;renderer.xr.enabled=!1,await this._quadMesh.renderAsync(renderer),renderer.xr.enabled=currentXR,renderer.toneMapping=toneMapping2,renderer.outputColorSpace=outputColorSpace}}class StageClass{constructor(){this.pause=!1,this.lastTime=Date.now(),this.width=window.innerWidth,this.height=window.innerHeight,this.ratioX=1,this.ratioY=1,this.autoScale=!0,this.devicePixelRatio=this.pixelRatio=Math.min(1.5,window.devicePixelRatio),this.onResize=new Signal,this.onUpdate=new Signal,window.addEventListener("resize",()=>{this.autoScale&&this.resize()},!1),window.addEventListener("orientationchange",()=>{this.autoScale&&this.resize()},!1),this.resize(),requestAnimationFrame(this.update)}resize=(width=-1,height=-1)=>{width!=-1&&(this.ratioX=width/window.innerWidth),height!=-1&&(this.ratioY=height/window.innerHeight),this.width=Math.ceil(window.innerWidth*this.ratioX),this.height=Math.ceil(window.innerHeight*this.ratioY),this.documentHeight=document.documentElement.clientHeight,this.onResize.dispatch()};update=()=>{const t2=performance.now(),dt=t2-this.lastTime;this.lastTime=t2,requestAnimationFrame(this.update),!this.pause&&this.onUpdate.dispatch(dt)}}const stage=new StageClass;class Panel{constructor(name,fg,bg){this.id=0,this.name=name,this.fg=fg,this.bg=bg,this.gradient=null,this.PR=Math.round(window.devicePixelRatio||1),this.WIDTH=90*this.PR,this.HEIGHT=48*this.PR,this.TEXT_X=3*this.PR,this.TEXT_Y=2*this.PR,this.GRAPH_X=3*this.PR,this.GRAPH_Y=15*this.PR,this.GRAPH_WIDTH=84*this.PR,this.GRAPH_HEIGHT=30*this.PR,this.canvas=document.createElement("canvas"),this.canvas.width=this.WIDTH,this.canvas.height=this.HEIGHT,this.canvas.style.width="90px",this.canvas.style.height="48px",this.canvas.style.position="absolute",this.canvas.style.cssText="width:90px;height:48px;background-color: transparent !important;",this.context=this.canvas.getContext("2d"),this.initializeCanvas()}createGradient(){if(!this.context)throw new Error("No context");const gradient=this.context.createLinearGradient(0,this.GRAPH_Y,0,this.GRAPH_Y+this.GRAPH_HEIGHT);let startColor;const endColor=this.fg;switch(this.fg.toLowerCase()){case"#0ff":startColor="#006666";break;case"#0f0":startColor="#006600";break;case"#ff0":startColor="#666600";break;case"#e1e1e1":startColor="#666666";break;default:startColor=this.bg;break}return gradient.addColorStop(0,startColor),gradient.addColorStop(1,endColor),gradient}initializeCanvas(){this.context&&(this.context.imageSmoothingEnabled=!1,this.context.font="bold "+9*this.PR+"px Helvetica,Arial,sans-serif",this.context.textBaseline="top",this.gradient=this.createGradient(),this.context.fillStyle=this.bg,this.context.fillRect(0,0,this.WIDTH,this.HEIGHT),this.context.fillStyle=this.fg,this.context.fillText(this.name,this.TEXT_X,this.TEXT_Y),this.context.fillStyle=this.bg,this.context.globalAlpha=.9,this.context.fillRect(this.GRAPH_X,this.GRAPH_Y,this.GRAPH_WIDTH,this.GRAPH_HEIGHT))}update(value,maxValue2,decimals=0){if(!this.context||!this.gradient)return;const min2=Math.min(1/0,value),max2=Math.max(maxValue2,value);this.context.globalAlpha=1,this.context.fillStyle=this.bg,this.context.fillRect(0,0,this.WIDTH,this.GRAPH_Y),this.context.fillStyle=this.fg,this.context.fillText(`${value.toFixed(decimals)} ${this.name} (${min2.toFixed(decimals)}-${parseFloat(max2.toFixed(decimals))})`,this.TEXT_X,this.TEXT_Y)}updateGraph(valueGraph,maxGraph){if(!this.context||!this.gradient)return;valueGraph===0&&maxGraph===0&&(maxGraph=1),maxGraph=Math.max(maxGraph,valueGraph,.1),valueGraph=Math.max(valueGraph,0);const graphX=Math.round(this.GRAPH_X),graphY=Math.round(this.GRAPH_Y),graphWidth=Math.round(this.GRAPH_WIDTH),graphHeight=Math.round(this.GRAPH_HEIGHT),pr=Math.round(this.PR);this.context.drawImage(this.canvas,graphX+pr,graphY,graphWidth-pr,graphHeight,graphX,graphY,graphWidth-pr,graphHeight),this.context.fillStyle=this.bg,this.context.fillRect(graphX+graphWidth-pr,graphY,pr,graphHeight);const columnHeight=Math.min(graphHeight,Math.round(valueGraph/maxGraph*graphHeight));columnHeight>0&&(this.context.globalAlpha=.9,this.context.fillStyle=this.gradient,this.context.fillRect(graphX+graphWidth-pr,graphY+(graphHeight-columnHeight),pr,columnHeight)),this.context.globalAlpha=1}}class PanelVSync extends Panel{constructor(name,fg,bg){super(name,fg,bg),this.vsyncValue=0,this.SMALL_HEIGHT=9*this.PR,this.HEIGHT=this.SMALL_HEIGHT,this.WIDTH=35*this.PR,this.TEXT_Y=0*this.PR,this.canvas.height=this.HEIGHT,this.canvas.width=this.WIDTH,this.canvas.style.height="9px",this.canvas.style.width="35px",this.canvas.style.cssText=`
            width: 35px;
            height: 9px;
            position: absolute;
            top: 0;
            left: 0;
            background-color: transparent !important;
            pointer-events: none;
        `,this.initializeCanvas()}initializeCanvas(){this.context&&(this.context.imageSmoothingEnabled=!1,this.context.font="bold "+9*this.PR+"px Helvetica,Arial,sans-serif",this.context.textBaseline="top",this.context.globalAlpha=1)}update(value,_maxValue,_decimals=0){this.context&&(this.vsyncValue=value,this.context.clearRect(0,0,this.WIDTH,this.HEIGHT),this.context.globalAlpha=1,this.context.fillStyle=this.bg,this.context.fillText(`${value.toFixed(0)}Hz`,this.TEXT_X,this.TEXT_Y))}updateGraph(_valueGraph,_maxGraph){}setOffset(x,y){this.canvas.style.transform=`translate(${x}px, ${y}px)`}}const _Stats=class _Stats2{constructor({trackGPU=!1,trackCPT=!1,trackHz=!1,logsPerSecond=4,graphsPerSecond=30,samplesLog=40,samplesGraph=10,precision=2,minimal=!1,horizontal=!0,mode=0}={}){this.gl=null,this.ext=null,this.activeQuery=null,this.gpuQueries=[],this.threeRendererPatched=!1,this.frameTimes=[],this.renderCount=0,this.totalCpuDuration=0,this.totalGpuDuration=0,this.totalGpuDurationCompute=0,this.gpuPanel=null,this.gpuPanelCompute=null,this.vsyncPanel=null,this.averageFps={logs:[],graph:[]},this.averageCpu={logs:[],graph:[]},this.averageGpu={logs:[],graph:[]},this.averageGpuCompute={logs:[],graph:[]},this.updateCounter=0,this.lastMin={},this.lastMax={},this.lastValue={},this.VSYNC_RATES=[{refreshRate:60,frameTime:16.67},{refreshRate:75,frameTime:13.33},{refreshRate:90,frameTime:11.11},{refreshRate:120,frameTime:8.33},{refreshRate:144,frameTime:6.94},{refreshRate:165,frameTime:6.06},{refreshRate:240,frameTime:4.17}],this.detectedVSync=null,this.frameTimeHistory=[],this.HISTORY_SIZE=120,this.VSYNC_THRESHOLD=.05,this.lastFrameTime=0,this.handleClick=event=>{event.preventDefault(),this.showPanel(++this.mode%this.dom.children.length)},this.handleResize=()=>{this.resizePanel(this.fpsPanel),this.resizePanel(this.msPanel),this.gpuPanel&&this.resizePanel(this.gpuPanel),this.gpuPanelCompute&&this.resizePanel(this.gpuPanelCompute)},this.mode=mode,this.horizontal=horizontal,this.minimal=minimal,this.trackGPU=trackGPU,this.trackCPT=trackCPT,this.trackHz=trackHz,this.samplesLog=samplesLog,this.samplesGraph=samplesGraph,this.precision=precision,this.logsPerSecond=logsPerSecond,this.graphsPerSecond=graphsPerSecond;const prevGraphTime=performance.now();this.prevGraphTime=prevGraphTime,this.dom=document.createElement("div"),this.initializeDOM(),this.beginTime=performance.now(),this.prevTextTime=this.beginTime,this.prevCpuTime=this.beginTime,this._panelId=0,this.fpsPanel=this.addPanel(new _Stats2.Panel("FPS","#0ff","#002")),this.msPanel=this.addPanel(new _Stats2.Panel("CPU","#0f0","#020")),this.trackHz===!0&&(this.vsyncPanel=new PanelVSync("","#f0f","#202"),this.dom.appendChild(this.vsyncPanel.canvas),this.vsyncPanel.setOffset(56,35)),this.setupEventListeners()}initializeDOM(){this.dom.style.cssText=`
      position: fixed;
      top: 0;
      left: 0;
      opacity: 0.9;
      z-index: 10000;
      ${this.minimal?"cursor: pointer;":""}
    `}setupEventListeners(){this.minimal?(this.dom.addEventListener("click",this.handleClick),this.showPanel(this.mode)):window.addEventListener("resize",this.handleResize)}async init(canvasOrGL){if(!canvasOrGL){console.error('Stats: The "canvas" parameter is undefined.');return}if(!this.handleThreeRenderer(canvasOrGL)&&!await this.handleWebGPURenderer(canvasOrGL))if(this.initializeWebGL(canvasOrGL)){this.trackGPU&&this.initializeGPUTracking();return}else console.error("Stats-gl: Failed to initialize WebGL context")}handleThreeRenderer(renderer){return renderer.isWebGLRenderer&&!this.threeRendererPatched?(this.patchThreeRenderer(renderer),this.gl=renderer.getContext(),this.trackGPU&&this.initializeGPUTracking(),!0):!1}async handleWebGPURenderer(renderer){return renderer.isWebGPURenderer?((this.trackGPU||this.trackCPT)&&(renderer.backend.trackTimestamp=!0,await renderer.hasFeatureAsync("timestamp-query")&&this.initializeWebGPUPanels()),this.info=renderer.info,this.patchThreeWebGPU(renderer),!0):!1}initializeWebGPUPanels(){this.trackGPU&&(this.gpuPanel=this.addPanel(new _Stats2.Panel("GPU","#ff0","#220"))),this.trackCPT&&(this.gpuPanelCompute=this.addPanel(new _Stats2.Panel("CPT","#e1e1e1","#212121")))}initializeWebGL(canvasOrGL){if(canvasOrGL instanceof WebGL2RenderingContext)this.gl=canvasOrGL;else if(canvasOrGL instanceof HTMLCanvasElement||canvasOrGL instanceof OffscreenCanvas){if(this.gl=canvasOrGL.getContext("webgl2"),!this.gl)return console.error("Stats: Unable to obtain WebGL2 context."),!1}else return console.error("Stats: Invalid input type. Expected WebGL2RenderingContext, HTMLCanvasElement, or OffscreenCanvas."),!1;return!0}initializeGPUTracking(){this.gl&&(this.ext=this.gl.getExtension("EXT_disjoint_timer_query_webgl2"),this.ext&&(this.gpuPanel=this.addPanel(new _Stats2.Panel("GPU","#ff0","#220"))))}begin(){this.beginProfiling("cpu-started"),!(!this.gl||!this.ext)&&(this.activeQuery&&this.gl.endQuery(this.ext.TIME_ELAPSED_EXT),this.activeQuery=this.gl.createQuery(),this.activeQuery&&this.gl.beginQuery(this.ext.TIME_ELAPSED_EXT,this.activeQuery))}end(){this.renderCount++,this.gl&&this.ext&&this.activeQuery&&(this.gl.endQuery(this.ext.TIME_ELAPSED_EXT),this.gpuQueries.push({query:this.activeQuery}),this.activeQuery=null),this.endProfiling("cpu-started","cpu-finished","cpu-duration")}update(){this.endProfiling("cpu-started","cpu-finished","cpu-duration"),this.info?this.processWebGPUTimestamps():this.processGpuQueries(),this.updateAverages(),this.resetCounters()}processWebGPUTimestamps(){this.totalGpuDuration=this.info.render.timestamp,this.totalGpuDurationCompute=this.info.compute.timestamp}resetCounters(){this.renderCount=0,this.totalCpuDuration=0,this.beginTime=this.endInternal()}resizePanel(panel){panel.canvas.style.position="absolute",this.minimal?panel.canvas.style.display="none":(panel.canvas.style.display="block",this.horizontal?(panel.canvas.style.top="0px",panel.canvas.style.left=panel.id*panel.WIDTH/panel.PR+"px"):(panel.canvas.style.left="0px",panel.canvas.style.top=panel.id*panel.HEIGHT/panel.PR+"px"))}addPanel(panel){return panel.canvas&&(this.dom.appendChild(panel.canvas),panel.id=this._panelId,this.resizePanel(panel),this._panelId++),panel}showPanel(id){for(let i2=0;i2<this.dom.children.length;i2++){const child=this.dom.children[i2];child.style.display=i2===id?"block":"none"}this.mode=id}processGpuQueries(){!this.gl||!this.ext||(this.totalGpuDuration=0,this.gpuQueries.forEach((queryInfo,index)=>{if(this.gl){const available=this.gl.getQueryParameter(queryInfo.query,this.gl.QUERY_RESULT_AVAILABLE),disjoint=this.gl.getParameter(this.ext.GPU_DISJOINT_EXT);if(available&&!disjoint){const duration=this.gl.getQueryParameter(queryInfo.query,this.gl.QUERY_RESULT)*1e-6;this.totalGpuDuration+=duration,this.gl.deleteQuery(queryInfo.query),this.gpuQueries.splice(index,1)}}}))}detectVSync(currentTime){if(this.lastFrameTime===0){this.lastFrameTime=currentTime;return}const frameTime=currentTime-this.lastFrameTime;if(this.lastFrameTime=currentTime,this.frameTimeHistory.push(frameTime),this.frameTimeHistory.length>this.HISTORY_SIZE&&this.frameTimeHistory.shift(),this.frameTimeHistory.length<60)return;const avgFrameTime=this.frameTimeHistory.reduce((a2,b)=>a2+b)/this.frameTimeHistory.length,variance=this.frameTimeHistory.reduce((acc,time2)=>acc+Math.pow(time2-avgFrameTime,2),0)/this.frameTimeHistory.length;if(Math.sqrt(variance)>2){this.detectedVSync=null;return}let closestMatch=null,smallestDiff=1/0;for(const rate of this.VSYNC_RATES){const diff=Math.abs(avgFrameTime-rate.frameTime);diff<smallestDiff&&(smallestDiff=diff,closestMatch=rate)}closestMatch&&smallestDiff/closestMatch.frameTime<=this.VSYNC_THRESHOLD?this.detectedVSync=closestMatch:this.detectedVSync=null}endInternal(){var _a;const currentTime=performance.now();for(this.frameTimes.push(currentTime);this.frameTimes.length>0&&this.frameTimes[0]<=currentTime-1e3;)this.frameTimes.shift();const fps=Math.round(this.frameTimes.length);this.addToAverage(fps,this.averageFps);const shouldUpdateText=currentTime>=this.prevTextTime+1e3/this.logsPerSecond,shouldUpdateGraph=currentTime>=this.prevGraphTime+1e3/this.graphsPerSecond;if(this.updatePanelComponents(this.fpsPanel,this.averageFps,0,shouldUpdateText,shouldUpdateGraph),this.updatePanelComponents(this.msPanel,this.averageCpu,this.precision,shouldUpdateText,shouldUpdateGraph),this.gpuPanel&&this.updatePanelComponents(this.gpuPanel,this.averageGpu,this.precision,shouldUpdateText,shouldUpdateGraph),this.trackCPT&&this.gpuPanelCompute&&this.updatePanelComponents(this.gpuPanelCompute,this.averageGpuCompute,this.precision,shouldUpdateText,shouldUpdateGraph),shouldUpdateText&&(this.prevTextTime=currentTime),shouldUpdateGraph&&(this.prevGraphTime=currentTime),this.vsyncPanel!==null){this.detectVSync(currentTime);const vsyncValue=((_a=this.detectedVSync)==null?void 0:_a.refreshRate)||0;shouldUpdateText&&vsyncValue>0&&this.vsyncPanel.update(vsyncValue,vsyncValue)}return currentTime}updatePanelComponents(panel,averageArray,precision,shouldUpdateText,shouldUpdateGraph){if(!panel||averageArray.logs.length===0)return;panel.name in this.lastMin||(this.lastMin[panel.name]=1/0,this.lastMax[panel.name]=0,this.lastValue[panel.name]=0);const currentValue=averageArray.logs[averageArray.logs.length-1];this.lastMax[panel.name]=Math.max(...averageArray.logs),this.lastMin[panel.name]=Math.min(this.lastMin[panel.name],currentValue),this.lastValue[panel.name]=this.lastValue[panel.name]*.7+currentValue*.3;const graphMax=Math.max(Math.max(...averageArray.logs),...averageArray.graph.slice(-this.samplesGraph));this.updateCounter++,shouldUpdateText&&panel.update(this.lastValue[panel.name],this.lastMax[panel.name],precision),shouldUpdateGraph&&panel.updateGraph(currentValue,graphMax)}beginProfiling(marker){if(window.performance)try{window.performance.clearMarks(marker),window.performance.mark(marker)}catch(error){console.debug("Stats: Performance marking failed:",error)}}endProfiling(startMarker,endMarker,measureName){if(!(!window.performance||!endMarker||!startMarker))try{window.performance.getEntriesByName(startMarker,"mark").length===0&&this.beginProfiling(startMarker),window.performance.clearMarks(endMarker),window.performance.mark(endMarker),window.performance.clearMeasures(measureName);const cpuMeasure=performance.measure(measureName,startMarker,endMarker);this.totalCpuDuration+=cpuMeasure.duration,window.performance.clearMarks(startMarker),window.performance.clearMarks(endMarker),window.performance.clearMeasures(measureName)}catch(error){console.debug("Stats: Performance measurement failed:",error)}}updatePanel(panel,averageArray,precision=2){if(!panel||averageArray.logs.length===0)return;const currentTime=performance.now();panel.name in this.lastMin||(this.lastMin[panel.name]=1/0,this.lastMax[panel.name]=0,this.lastValue[panel.name]=0);const currentValue=averageArray.logs[averageArray.logs.length-1],recentMax=Math.max(...averageArray.logs.slice(-30));this.lastMin[panel.name]=Math.min(this.lastMin[panel.name],currentValue),this.lastMax[panel.name]=Math.max(this.lastMax[panel.name],currentValue),this.lastValue[panel.name]=this.lastValue[panel.name]*.7+currentValue*.3;const graphMax=Math.max(recentMax,...averageArray.graph.slice(-this.samplesGraph));this.updateCounter++,this.updateCounter%(this.logsPerSecond*2)===0&&(this.lastMax[panel.name]=recentMax,this.lastMin[panel.name]=currentValue),panel.update&&(currentTime>=this.prevCpuTime+1e3/this.logsPerSecond&&panel.update(this.lastValue[panel.name],currentValue,this.lastMax[panel.name],graphMax,precision),currentTime>=this.prevGraphTime+1e3/this.graphsPerSecond&&(panel.updateGraph(currentValue,graphMax),this.prevGraphTime=currentTime))}updateAverages(){this.addToAverage(this.totalCpuDuration,this.averageCpu),this.addToAverage(this.totalGpuDuration,this.averageGpu),this.info&&this.totalGpuDurationCompute!==void 0&&this.addToAverage(this.totalGpuDurationCompute,this.averageGpuCompute)}addToAverage(value,averageArray){averageArray.logs.push(value),averageArray.logs.length>this.samplesLog&&(averageArray.logs=averageArray.logs.slice(-this.samplesLog)),averageArray.graph.push(value),averageArray.graph.length>this.samplesGraph&&(averageArray.graph=averageArray.graph.slice(-this.samplesGraph))}get domElement(){return this.dom}patchThreeWebGPU(renderer){const originalAnimationLoop=renderer.info.reset,statsInstance=this;renderer.info.reset=function(){statsInstance.beginProfiling("cpu-started"),originalAnimationLoop.call(this)}}patchThreeRenderer(renderer){const originalRenderMethod=renderer.render,statsInstance=this;renderer.render=function(scene,camera){statsInstance.begin(),originalRenderMethod.call(this,scene,camera),statsInstance.end()},this.threeRendererPatched=!0}};_Stats.Panel=Panel;let Stats=_Stats;const showStats=window.location.search.includes("stats");class Stage3D{constructor(){this.scene=new Scene,this.renderTime=1,this.frustumSize=1,this.camera=new OrthographicCamera(-1,1,1,-1,0,100),this.camera.position.set(0,0,10),this.camera.lookAt(0,0,0)}async initRender(options={}){if(!this.renderer){let forceWebGL=window.location.search.includes("webgl");this.renderer=new WebGPURenderer({antialias:!1,logarithmicDepthBuffer:!1,alpha:!1,forceWebGL}),mapJS.log(`BackEnd ${this.renderer.backend.isWebGPUBackend?"WebGPU":"WebGL2"}`),await this.renderer.init();let ratio1=window.location.search.includes("ratio1");this.renderer.setPixelRatio(ratio1?1:stage.devicePixelRatio),this.renderer.setSize(stage.width,stage.height),this.renderer.setClearColor(options.background||14540253,1),this.renderer.domElement.classList.add("three"),this.renderer.domElement.style.position="absolute",this.renderer.domElement.style.inset="0",this.renderer.domElement.style.zIndex="-1",this.renderer.domElement.style.pointerEvents="none",this.renderer.domElement.style.userSelect="none",(options.domElement||document.body.querySelector("#map")||document.body).appendChild(this.renderer.domElement),showStats&&(this.stats=new Stats({trackGPU:!0}),document.body.appendChild(this.stats.dom),this.stats.init(this.renderer))}this.isPaused=!1,stage.onResize.add(this.resize),stage.onUpdate.add(this.update),this.resize()}update=dt=>{this.isPaused||!this.renderer||(this.control?.update(dt),this.renderTime-=dt,this.renderTime>0&&this.render())};render=async()=>{this.postProcessing?this.postProcessing.render():(await this.renderer.renderAsync(this.scene,this.camera),this.stats&&(this.renderer.resolveTimestampsAsync(TimestampQuery.RENDER),this.stats.update()))};renderNext=(ms=500)=>{this.renderTime=ms};add=obj=>{this.scene.add(obj)};remove=obj=>{this.scene.remove(obj)};removeAll=()=>{for(;this.scene.children.length>0;)this.scene.remove(this.scene.children[0])};pause=()=>{this.isPaused||(this.isPaused=!0,this.control&&(this.control.isActive=!1))};resume=()=>{this.isPaused&&(this.isPaused=!1,this.control&&(this.control.isActive=!0))};resize=()=>{const w=stage.width,h=stage.height,aspect2=w/h;this.camera.isOrthographicCamera?(this.camera.left=-this.frustumSize/2,this.camera.right=this.frustumSize/2,this.camera.top=this.frustumSize/2,this.camera.bottom=-this.frustumSize/2):this.camera.aspect=aspect2,this.camera.updateProjectionMatrix(),this.renderer?.setSize(w,h),this.render()};set fov(value){this.camera.fov=value,this.camera.updateProjectionMatrix()}get fov(){return this.camera.fov}dispose(){this.removeAll(),this.control?.disable(),stage.onResize.remove(this.resize),stage.onUpdate.remove(this.render),this.renderer?.clear(),this.renderer?.dispose()}async gpuUpload(objects){this.compileScene=this.compileScene||new Scene,this.compileCamera=this.compileCamera||new PerspectiveCamera(60,stage.width/stage.height,1e-4,1e4),this.compileCamera.position.set(0,0,1e4),this.compileCamera.lookAt(0,0,0),this.compileGeometry=this.compileGeometry||new PlaneGeometry(1,1),this.compileMeshs=[],this.compileScene.environment=this.scene.environment;const initialStates=[];for(const obj of objects)if(obj&&!obj.isLight&&!obj.isCamera)if(obj.isTexture)if(obj.needsUpdate=!0,this.renderer.initTexture)this.renderer.initTexture?.(obj);else{const mesh=new Mesh(this.compileGeometry,new MeshBasicNodeMaterial({map:obj}));mesh.frustumCulled=!1,this.compileMeshs.push(mesh),this.compileScene.add(mesh)}else if(obj.isMaterial){const mesh=new Mesh(this.compileGeometry,obj);this.compileScene.add(mesh)}else obj.isObject3D&&(initialStates.push({parent:obj.parent,frustumCulled:obj.frustumCulled}),obj.frustumCulled=!1,this.compileScene.add(obj));await this.renderer.compileAsync(this.compileScene,this.compileCamera,this.scene);let k=0;for(const obj of objects)obj&&(obj.isLight||obj.isCamera||obj.isMaterial||obj.isTexture||(initialStates[k]&&(initialStates[k].parent&&initialStates[k].parent.add(obj),obj.frustumCulled=initialStates[k].frustumCulled),k++));for(const mesh of this.compileMeshs)mesh.parent.remove(mesh),mesh.material.dispose();this.compileMeshs=[],this.compileGeometry.dispose()}screenshot(render2=!0){render2&&this.render();const{promise,resolve,reject}=Promise.withResolvers();return this.renderer.domElement.toBlob(blob=>{let img2=new Image;const url=URL.createObjectURL(blob);img2.onload=()=>{URL.revokeObjectURL(url),resolve(img2)},img2.src=url},"image/png",100),promise}}const stage3d=new Stage3D,CollectionEventType={ADD:"add",REMOVE:"remove"},ObjectEventType={PROPERTYCHANGE:"propertychange"},EventType={CHANGE:"change",ERROR:"error",CONTEXTMENU:"contextmenu",CLICK:"click",DBLCLICK:"dblclick",KEYDOWN:"keydown",KEYPRESS:"keypress",LOAD:"load",TOUCHMOVE:"touchmove",WHEEL:"wheel"};class Disposable{constructor(){this.disposed=!1}dispose(){this.disposed||(this.disposed=!0,this.disposeInternal())}disposeInternal(){}}function ascending(a2,b){return a2>b?1:a2<b?-1:0}function descending(a2,b){return a2<b?1:a2>b?-1:0}function linearFindNearest(arr,target,direction){if(arr[0]<=target)return 0;const n2=arr.length;if(target<=arr[n2-1])return n2-1;if(typeof direction=="function"){for(let i2=1;i2<n2;++i2){const candidate=arr[i2];if(candidate===target)return i2;if(candidate<target)return direction(target,arr[i2-1],candidate)>0?i2-1:i2}return n2-1}if(direction>0){for(let i2=1;i2<n2;++i2)if(arr[i2]<target)return i2-1;return n2-1}if(direction<0){for(let i2=1;i2<n2;++i2)if(arr[i2]<=target)return i2;return n2-1}for(let i2=1;i2<n2;++i2){if(arr[i2]==target)return i2;if(arr[i2]<target)return arr[i2-1]-target<target-arr[i2]?i2-1:i2}return n2-1}function extend$3(arr,data){const extension=Array.isArray(data)?data:[data],length2=extension.length;for(let i2=0;i2<length2;i2++)arr[arr.length]=extension[i2]}function equals$2(arr1,arr2){const len1=arr1.length;if(len1!==arr2.length)return!1;for(let i2=0;i2<len1;i2++)if(arr1[i2]!==arr2[i2])return!1;return!0}function isSorted(arr,func,strict){const compare=func||ascending;return arr.every(function(currentVal,index){if(index===0)return!0;const res=compare(arr[index-1],currentVal);return!(res>0||res===0)})}function TRUE(){return!0}function FALSE(){return!1}function VOID(){}function memoizeOne(fn){let lastResult,lastArgs,lastThis;return function(){const nextArgs=Array.prototype.slice.call(arguments);return(!lastArgs||this!==lastThis||!equals$2(nextArgs,lastArgs))&&(lastThis=this,lastArgs=nextArgs,lastResult=fn.apply(this,arguments)),lastResult}}function toPromise(getter){function promiseGetter(){let value;try{value=getter()}catch(err){return Promise.reject(err)}return value instanceof Promise?value:Promise.resolve(value)}return promiseGetter()}function clear(object){for(const property2 in object)delete object[property2]}function isEmpty$1(object){let property2;for(property2 in object)return!1;return!property2}class BaseEvent{constructor(type){this.propagationStopped,this.defaultPrevented,this.type=type,this.target=null}preventDefault(){this.defaultPrevented=!0}stopPropagation(){this.propagationStopped=!0}}class Target extends Disposable{constructor(target){super(),this.eventTarget_=target,this.pendingRemovals_=null,this.dispatching_=null,this.listeners_=null}addEventListener(type,listener){if(!type||!listener)return;const listeners=this.listeners_||(this.listeners_={}),listenersForType=listeners[type]||(listeners[type]=[]);listenersForType.includes(listener)||listenersForType.push(listener)}dispatchEvent(event){const isString2=typeof event=="string",type=isString2?event:event.type,listeners=this.listeners_&&this.listeners_[type];if(!listeners)return;const evt=isString2?new BaseEvent(event):event;evt.target||(evt.target=this.eventTarget_||this);const dispatching=this.dispatching_||(this.dispatching_={}),pendingRemovals=this.pendingRemovals_||(this.pendingRemovals_={});type in dispatching||(dispatching[type]=0,pendingRemovals[type]=0),++dispatching[type];let propagate;for(let i2=0,ii=listeners.length;i2<ii;++i2)if("handleEvent"in listeners[i2]?propagate=listeners[i2].handleEvent(evt):propagate=listeners[i2].call(this,evt),propagate===!1||evt.propagationStopped){propagate=!1;break}if(--dispatching[type]===0){let pr=pendingRemovals[type];for(delete pendingRemovals[type];pr--;)this.removeEventListener(type,VOID);delete dispatching[type]}return propagate}disposeInternal(){this.listeners_&&clear(this.listeners_)}getListeners(type){return this.listeners_&&this.listeners_[type]||void 0}hasListener(type){return this.listeners_?type?type in this.listeners_:Object.keys(this.listeners_).length>0:!1}removeEventListener(type,listener){if(!this.listeners_)return;const listeners=this.listeners_[type];if(!listeners)return;const index=listeners.indexOf(listener);index!==-1&&(this.pendingRemovals_&&type in this.pendingRemovals_?(listeners[index]=VOID,++this.pendingRemovals_[type]):(listeners.splice(index,1),listeners.length===0&&delete this.listeners_[type]))}}function listen(target,type,listener,thisArg,once){if(once){const originalListener=listener;listener=function(event){return target.removeEventListener(type,listener),originalListener.call(thisArg??this,event)}}else thisArg&&thisArg!==target&&(listener=listener.bind(thisArg));const eventsKey={target,type,listener};return target.addEventListener(type,listener),eventsKey}function listenOnce(target,type,listener,thisArg){return listen(target,type,listener,thisArg,!0)}function unlistenByKey(key2){key2&&key2.target&&(key2.target.removeEventListener(key2.type,key2.listener),clear(key2))}class Observable extends Target{constructor(){super(),this.on=this.onInternal,this.once=this.onceInternal,this.un=this.unInternal,this.revision_=0}changed(){++this.revision_,this.dispatchEvent(EventType.CHANGE)}getRevision(){return this.revision_}onInternal(type,listener){if(Array.isArray(type)){const len=type.length,keys=new Array(len);for(let i2=0;i2<len;++i2)keys[i2]=listen(this,type[i2],listener);return keys}return listen(this,type,listener)}onceInternal(type,listener){let key2;if(Array.isArray(type)){const len=type.length;key2=new Array(len);for(let i2=0;i2<len;++i2)key2[i2]=listenOnce(this,type[i2],listener)}else key2=listenOnce(this,type,listener);return listener.ol_key=key2,key2}unInternal(type,listener){const key2=listener.ol_key;if(key2)unByKey(key2);else if(Array.isArray(type))for(let i2=0,ii=type.length;i2<ii;++i2)this.removeEventListener(type[i2],listener);else this.removeEventListener(type,listener)}}Observable.prototype.on;Observable.prototype.once;Observable.prototype.un;function unByKey(key2){if(Array.isArray(key2))for(let i2=0,ii=key2.length;i2<ii;++i2)unlistenByKey(key2[i2]);else unlistenByKey(key2)}function abstract(){throw new Error("Unimplemented abstract method.")}let uidCounter_=0;function getUid(obj){return obj.ol_uid||(obj.ol_uid=String(++uidCounter_))}class ObjectEvent extends BaseEvent{constructor(type,key2,oldValue){super(type),this.key=key2,this.oldValue=oldValue}}class BaseObject extends Observable{constructor(values){super(),this.on,this.once,this.un,getUid(this),this.values_=null,values!==void 0&&this.setProperties(values)}get(key2){let value;return this.values_&&this.values_.hasOwnProperty(key2)&&(value=this.values_[key2]),value}getKeys(){return this.values_&&Object.keys(this.values_)||[]}getProperties(){return this.values_&&Object.assign({},this.values_)||{}}getPropertiesInternal(){return this.values_}hasProperties(){return!!this.values_}notify(key2,oldValue){let eventType;eventType=`change:${key2}`,this.hasListener(eventType)&&this.dispatchEvent(new ObjectEvent(eventType,key2,oldValue)),eventType=ObjectEventType.PROPERTYCHANGE,this.hasListener(eventType)&&this.dispatchEvent(new ObjectEvent(eventType,key2,oldValue))}addChangeListener(key2,listener){this.addEventListener(`change:${key2}`,listener)}removeChangeListener(key2,listener){this.removeEventListener(`change:${key2}`,listener)}set(key2,value,silent){const values=this.values_||(this.values_={});if(silent)values[key2]=value;else{const oldValue=values[key2];values[key2]=value,oldValue!==value&&this.notify(key2,oldValue)}}setProperties(values,silent){for(const key2 in values)this.set(key2,values[key2],silent)}applyProperties(source){source.values_&&Object.assign(this.values_||(this.values_={}),source.values_)}unset(key2,silent){if(this.values_&&key2 in this.values_){const oldValue=this.values_[key2];delete this.values_[key2],isEmpty$1(this.values_)&&(this.values_=null),silent||this.notify(key2,oldValue)}}}const Property$2={LENGTH:"length"};class CollectionEvent extends BaseEvent{constructor(type,element2,index){super(type),this.element=element2,this.index=index}}class Collection extends BaseObject{constructor(array2,options){if(super(),this.on,this.once,this.un,options=options||{},this.unique_=!!options.unique,this.array_=array2||[],this.unique_)for(let i2=0,ii=this.array_.length;i2<ii;++i2)this.assertUnique_(this.array_[i2],i2);this.updateLength_()}clear(){for(;this.getLength()>0;)this.pop()}extend(arr){for(let i2=0,ii=arr.length;i2<ii;++i2)this.push(arr[i2]);return this}forEach(f2){const array2=this.array_;for(let i2=0,ii=array2.length;i2<ii;++i2)f2(array2[i2],i2,array2)}getArray(){return this.array_}item(index){return this.array_[index]}getLength(){return this.get(Property$2.LENGTH)}insertAt(index,elem){if(index<0||index>this.getLength())throw new Error("Index out of bounds: "+index);this.unique_&&this.assertUnique_(elem),this.array_.splice(index,0,elem),this.updateLength_(),this.dispatchEvent(new CollectionEvent(CollectionEventType.ADD,elem,index))}pop(){return this.removeAt(this.getLength()-1)}push(elem){this.unique_&&this.assertUnique_(elem);const n2=this.getLength();return this.insertAt(n2,elem),this.getLength()}remove(elem){const arr=this.array_;for(let i2=0,ii=arr.length;i2<ii;++i2)if(arr[i2]===elem)return this.removeAt(i2)}removeAt(index){if(index<0||index>=this.getLength())return;const prev=this.array_[index];return this.array_.splice(index,1),this.updateLength_(),this.dispatchEvent(new CollectionEvent(CollectionEventType.REMOVE,prev,index)),prev}setAt(index,elem){const n2=this.getLength();if(index>=n2){this.insertAt(index,elem);return}if(index<0)throw new Error("Index out of bounds: "+index);this.unique_&&this.assertUnique_(elem,index);const prev=this.array_[index];this.array_[index]=elem,this.dispatchEvent(new CollectionEvent(CollectionEventType.REMOVE,prev,index)),this.dispatchEvent(new CollectionEvent(CollectionEventType.ADD,elem,index))}updateLength_(){this.set(Property$2.LENGTH,this.array_.length)}assertUnique_(elem,except){for(let i2=0,ii=this.array_.length;i2<ii;++i2)if(this.array_[i2]===elem&&i2!==except)throw new Error("Duplicate item added to a unique collection")}}class MapEvent extends BaseEvent{constructor(type,map,frameState2){super(type),this.map=map,this.frameState=frameState2!==void 0?frameState2:null}}class MapBrowserEvent extends MapEvent{constructor(type,map,originalEvent,dragging,frameState2,activePointers){super(type,map,frameState2),this.originalEvent=originalEvent,this.pixel_=null,this.coordinate_=null,this.dragging=dragging!==void 0?dragging:!1,this.activePointers=activePointers}get pixel(){return this.pixel_||(this.pixel_=this.map.getEventPixel(this.originalEvent)),this.pixel_}set pixel(pixel){this.pixel_=pixel}get coordinate(){return this.coordinate_||(this.coordinate_=this.map.getCoordinateFromPixel(this.pixel)),this.coordinate_}set coordinate(coordinate){this.coordinate_=coordinate}preventDefault(){super.preventDefault(),"preventDefault"in this.originalEvent&&this.originalEvent.preventDefault()}stopPropagation(){super.stopPropagation(),"stopPropagation"in this.originalEvent&&this.originalEvent.stopPropagation()}}const MapBrowserEventType={SINGLECLICK:"singleclick",CLICK:EventType.CLICK,DBLCLICK:EventType.DBLCLICK,POINTERDRAG:"pointerdrag",POINTERMOVE:"pointermove",POINTERDOWN:"pointerdown",POINTERUP:"pointerup",POINTEROVER:"pointerover",POINTEROUT:"pointerout",POINTERENTER:"pointerenter",POINTERLEAVE:"pointerleave",POINTERCANCEL:"pointercancel"},ua=typeof navigator<"u"&&typeof navigator.userAgent<"u"?navigator.userAgent.toLowerCase():"",FIREFOX=ua.includes("firefox"),SAFARI=ua.includes("safari")&&!ua.includes("chrom");SAFARI&&(ua.includes("version/15.4")||/cpu (os|iphone os) 15_4 like mac os x/.test(ua));const WEBKIT=ua.includes("webkit")&&!ua.includes("edge"),MAC=ua.includes("macintosh"),DEVICE_PIXEL_RATIO=typeof devicePixelRatio<"u"?devicePixelRatio:1,WORKER_OFFSCREEN_CANVAS=typeof WorkerGlobalScope<"u"&&typeof OffscreenCanvas<"u"&&self instanceof WorkerGlobalScope,IMAGE_DECODE=typeof Image<"u"&&Image.prototype.decode,PASSIVE_EVENT_LISTENERS=function(){let passive=!1;try{const options=Object.defineProperty({},"passive",{get:function(){passive=!0}});window.addEventListener("_",null,options),window.removeEventListener("_",null,options)}catch{}return passive}(),PointerEventType={POINTERMOVE:"pointermove",POINTERDOWN:"pointerdown"};class MapBrowserEventHandler extends Target{constructor(map,moveTolerance){super(map),this.map_=map,this.clickTimeoutId_,this.emulateClicks_=!1,this.dragging_=!1,this.dragListenerKeys_=[],this.moveTolerance_=moveTolerance===void 0?1:moveTolerance,this.down_=null;const element2=this.map_.getViewport();this.activePointers_=[],this.trackedTouches_={},this.element_=element2,this.pointerdownListenerKey_=listen(element2,PointerEventType.POINTERDOWN,this.handlePointerDown_,this),this.originalPointerMoveEvent_,this.relayedListenerKey_=listen(element2,PointerEventType.POINTERMOVE,this.relayMoveEvent_,this),this.boundHandleTouchMove_=this.handleTouchMove_.bind(this),this.element_.addEventListener(EventType.TOUCHMOVE,this.boundHandleTouchMove_,PASSIVE_EVENT_LISTENERS?{passive:!1}:!1)}emulateClick_(pointerEvent){let newEvent=new MapBrowserEvent(MapBrowserEventType.CLICK,this.map_,pointerEvent);this.dispatchEvent(newEvent),this.clickTimeoutId_!==void 0?(clearTimeout(this.clickTimeoutId_),this.clickTimeoutId_=void 0,newEvent=new MapBrowserEvent(MapBrowserEventType.DBLCLICK,this.map_,pointerEvent),this.dispatchEvent(newEvent)):this.clickTimeoutId_=setTimeout(()=>{this.clickTimeoutId_=void 0;const newEvent2=new MapBrowserEvent(MapBrowserEventType.SINGLECLICK,this.map_,pointerEvent);this.dispatchEvent(newEvent2)},250)}updateActivePointers_(pointerEvent){const event=pointerEvent,id=event.pointerId;if(event.type==MapBrowserEventType.POINTERUP||event.type==MapBrowserEventType.POINTERCANCEL){delete this.trackedTouches_[id];for(const pointerId in this.trackedTouches_)if(this.trackedTouches_[pointerId].target!==event.target){delete this.trackedTouches_[pointerId];break}}else(event.type==MapBrowserEventType.POINTERDOWN||event.type==MapBrowserEventType.POINTERMOVE)&&(this.trackedTouches_[id]=event);this.activePointers_=Object.values(this.trackedTouches_)}handlePointerUp_(pointerEvent){this.updateActivePointers_(pointerEvent);const newEvent=new MapBrowserEvent(MapBrowserEventType.POINTERUP,this.map_,pointerEvent,void 0,void 0,this.activePointers_);this.dispatchEvent(newEvent),this.emulateClicks_&&!newEvent.defaultPrevented&&!this.dragging_&&this.isMouseActionButton_(pointerEvent)&&this.emulateClick_(this.down_),this.activePointers_.length===0&&(this.dragListenerKeys_.forEach(unlistenByKey),this.dragListenerKeys_.length=0,this.dragging_=!1,this.down_=null)}isMouseActionButton_(pointerEvent){return pointerEvent.button===0}handlePointerDown_(pointerEvent){this.emulateClicks_=this.activePointers_.length===0,this.updateActivePointers_(pointerEvent);const newEvent=new MapBrowserEvent(MapBrowserEventType.POINTERDOWN,this.map_,pointerEvent,void 0,void 0,this.activePointers_);if(this.dispatchEvent(newEvent),this.down_=new PointerEvent(pointerEvent.type,pointerEvent),Object.defineProperty(this.down_,"target",{writable:!1,value:pointerEvent.target}),this.dragListenerKeys_.length===0){const doc2=this.map_.getOwnerDocument();this.dragListenerKeys_.push(listen(doc2,MapBrowserEventType.POINTERMOVE,this.handlePointerMove_,this),listen(doc2,MapBrowserEventType.POINTERUP,this.handlePointerUp_,this),listen(this.element_,MapBrowserEventType.POINTERCANCEL,this.handlePointerUp_,this)),this.element_.getRootNode&&this.element_.getRootNode()!==doc2&&this.dragListenerKeys_.push(listen(this.element_.getRootNode(),MapBrowserEventType.POINTERUP,this.handlePointerUp_,this))}}handlePointerMove_(pointerEvent){if(this.isMoving_(pointerEvent)){this.updateActivePointers_(pointerEvent),this.dragging_=!0;const newEvent=new MapBrowserEvent(MapBrowserEventType.POINTERDRAG,this.map_,pointerEvent,this.dragging_,void 0,this.activePointers_);this.dispatchEvent(newEvent)}}relayMoveEvent_(pointerEvent){this.originalPointerMoveEvent_=pointerEvent;const dragging=!!(this.down_&&this.isMoving_(pointerEvent));this.dispatchEvent(new MapBrowserEvent(MapBrowserEventType.POINTERMOVE,this.map_,pointerEvent,dragging))}handleTouchMove_(event){const originalEvent=this.originalPointerMoveEvent_;(!originalEvent||originalEvent.defaultPrevented)&&(typeof event.cancelable!="boolean"||event.cancelable===!0)&&event.preventDefault()}isMoving_(pointerEvent){return this.dragging_||Math.abs(pointerEvent.clientX-this.down_.clientX)>this.moveTolerance_||Math.abs(pointerEvent.clientY-this.down_.clientY)>this.moveTolerance_}disposeInternal(){this.relayedListenerKey_&&(unlistenByKey(this.relayedListenerKey_),this.relayedListenerKey_=null),this.element_.removeEventListener(EventType.TOUCHMOVE,this.boundHandleTouchMove_),this.pointerdownListenerKey_&&(unlistenByKey(this.pointerdownListenerKey_),this.pointerdownListenerKey_=null),this.dragListenerKeys_.forEach(unlistenByKey),this.dragListenerKeys_.length=0,this.element_=null,super.disposeInternal()}}const MapEventType={POSTRENDER:"postrender",MOVESTART:"movestart",MOVEEND:"moveend",LOADSTART:"loadstart",LOADEND:"loadend"},MapProperty={LAYERGROUP:"layergroup",SIZE:"size",TARGET:"target",VIEW:"view"},TileState={IDLE:0,LOADING:1,LOADED:2,ERROR:3,EMPTY:4};function assert(assertion,errorMessage){if(!assertion)throw new Error(errorMessage)}const DROP=1/0;class PriorityQueue{constructor(priorityFunction,keyFunction){this.priorityFunction_=priorityFunction,this.keyFunction_=keyFunction,this.elements_=[],this.priorities_=[],this.queuedElements_={}}clear(){this.elements_.length=0,this.priorities_.length=0,clear(this.queuedElements_)}dequeue(){const elements=this.elements_,priorities=this.priorities_,element2=elements[0];elements.length==1?(elements.length=0,priorities.length=0):(elements[0]=elements.pop(),priorities[0]=priorities.pop(),this.siftUp_(0));const elementKey=this.keyFunction_(element2);return delete this.queuedElements_[elementKey],element2}enqueue(element2){assert(!(this.keyFunction_(element2)in this.queuedElements_),"Tried to enqueue an `element` that was already added to the queue");const priority=this.priorityFunction_(element2);return priority!=DROP?(this.elements_.push(element2),this.priorities_.push(priority),this.queuedElements_[this.keyFunction_(element2)]=!0,this.siftDown_(0,this.elements_.length-1),!0):!1}getCount(){return this.elements_.length}getLeftChildIndex_(index){return index*2+1}getRightChildIndex_(index){return index*2+2}getParentIndex_(index){return index-1>>1}heapify_(){let i2;for(i2=(this.elements_.length>>1)-1;i2>=0;i2--)this.siftUp_(i2)}isEmpty(){return this.elements_.length===0}isKeyQueued(key2){return key2 in this.queuedElements_}isQueued(element2){return this.isKeyQueued(this.keyFunction_(element2))}siftUp_(index){const elements=this.elements_,priorities=this.priorities_,count=elements.length,element2=elements[index],priority=priorities[index],startIndex=index;for(;index<count>>1;){const lIndex=this.getLeftChildIndex_(index),rIndex=this.getRightChildIndex_(index),smallerChildIndex=rIndex<count&&priorities[rIndex]<priorities[lIndex]?rIndex:lIndex;elements[index]=elements[smallerChildIndex],priorities[index]=priorities[smallerChildIndex],index=smallerChildIndex}elements[index]=element2,priorities[index]=priority,this.siftDown_(startIndex,index)}siftDown_(startIndex,index){const elements=this.elements_,priorities=this.priorities_,element2=elements[index],priority=priorities[index];for(;index>startIndex;){const parentIndex=this.getParentIndex_(index);if(priorities[parentIndex]>priority)elements[index]=elements[parentIndex],priorities[index]=priorities[parentIndex],index=parentIndex;else break}elements[index]=element2,priorities[index]=priority}reprioritize(){const priorityFunction=this.priorityFunction_,elements=this.elements_,priorities=this.priorities_;let index=0;const n2=elements.length;let element2,i2,priority;for(i2=0;i2<n2;++i2)element2=elements[i2],priority=priorityFunction(element2),priority==DROP?delete this.queuedElements_[this.keyFunction_(element2)]:(priorities[index]=priority,elements[index++]=element2);elements.length=index,priorities.length=index,this.heapify_()}}class TileQueue extends PriorityQueue{constructor(tilePriorityFunction,tileChangeCallback){super(element2=>tilePriorityFunction.apply(null,element2),element2=>element2[0].getKey()),this.boundHandleTileChange_=this.handleTileChange.bind(this),this.tileChangeCallback_=tileChangeCallback,this.tilesLoading_=0,this.tilesLoadingKeys_={}}enqueue(element2){const added=super.enqueue(element2);return added&&element2[0].addEventListener(EventType.CHANGE,this.boundHandleTileChange_),added}getTilesLoading(){return this.tilesLoading_}handleTileChange(event){const tile=event.target,state=tile.getState();if(state===TileState.LOADED||state===TileState.ERROR||state===TileState.EMPTY){state!==TileState.ERROR&&tile.removeEventListener(EventType.CHANGE,this.boundHandleTileChange_);const tileKey=tile.getKey();tileKey in this.tilesLoadingKeys_&&(delete this.tilesLoadingKeys_[tileKey],--this.tilesLoading_),this.tileChangeCallback_()}}loadMoreTiles(maxTotalLoading,maxNewLoads){let newLoads=0;for(;this.tilesLoading_<maxTotalLoading&&newLoads<maxNewLoads&&this.getCount()>0;){const tile=this.dequeue()[0],tileKey=tile.getKey();tile.getState()===TileState.IDLE&&!(tileKey in this.tilesLoadingKeys_)&&(this.tilesLoadingKeys_[tileKey]=!0,++this.tilesLoading_,++newLoads,tile.load())}}}function getTilePriority(frameState2,tile,tileSourceKey,tileCenter,tileResolution){if(!frameState2||!(tileSourceKey in frameState2.wantedTiles)||!frameState2.wantedTiles[tileSourceKey][tile.getKey()])return DROP;const center=frameState2.viewState.center,deltaX=tileCenter[0]-center[0],deltaY=tileCenter[1]-center[1];return 65536*Math.log(tileResolution)+Math.sqrt(deltaX*deltaX+deltaY*deltaY)/tileResolution}const ViewHint={ANIMATING:0,INTERACTING:1},ViewProperty={CENTER:"center",RESOLUTION:"resolution",ROTATION:"rotation"};function clamp$2(value,min2,max2){return Math.min(Math.max(value,min2),max2)}function squaredSegmentDistance(x,y,x1,y1,x2,y2){const dx=x2-x1,dy=y2-y1;if(dx!==0||dy!==0){const t2=((x-x1)*dx+(y-y1)*dy)/(dx*dx+dy*dy);t2>1?(x1=x2,y1=y2):t2>0&&(x1+=dx*t2,y1+=dy*t2)}return squaredDistance(x,y,x1,y1)}function squaredDistance(x1,y1,x2,y2){const dx=x2-x1,dy=y2-y1;return dx*dx+dy*dy}function solveLinearSystem(mat){const n2=mat.length;for(let i2=0;i2<n2;i2++){let maxRow=i2,maxEl=Math.abs(mat[i2][i2]);for(let r2=i2+1;r2<n2;r2++){const absValue=Math.abs(mat[r2][i2]);absValue>maxEl&&(maxEl=absValue,maxRow=r2)}if(maxEl===0)return null;const tmp=mat[maxRow];mat[maxRow]=mat[i2],mat[i2]=tmp;for(let j=i2+1;j<n2;j++){const coef=-mat[j][i2]/mat[i2][i2];for(let k=i2;k<n2+1;k++)i2==k?mat[j][k]=0:mat[j][k]+=coef*mat[i2][k]}}const x=new Array(n2);for(let l2=n2-1;l2>=0;l2--){x[l2]=mat[l2][n2]/mat[l2][l2];for(let m=l2-1;m>=0;m--)mat[m][n2]-=mat[m][l2]*x[l2]}return x}function toDegrees(angleInRadians){return angleInRadians*180/Math.PI}function toRadians(angleInDegrees){return angleInDegrees*Math.PI/180}function modulo(a2,b){const r2=a2%b;return r2*b<0?r2+b:r2}function lerp$1(a2,b,x){return a2+x*(b-a2)}function toFixed(n2,decimals){const factor=Math.pow(10,decimals);return Math.round(n2*factor)/factor}function floor$2(n2,decimals){return Math.floor(toFixed(n2,decimals))}function ceil$1(n2,decimals){return Math.ceil(toFixed(n2,decimals))}function wrap$1(n2,min2,max2){if(n2>=min2&&n2<max2)return n2;const range2=max2-min2;return((n2-min2)%range2+range2)%range2+min2}function createExtent(extent,onlyCenter,smooth){return function(center,resolution,size,isMoving,centerShift){if(!center)return;if(!resolution&&!onlyCenter)return center;const viewWidth=onlyCenter?0:size[0]*resolution,viewHeight=onlyCenter?0:size[1]*resolution,shiftX=centerShift?centerShift[0]:0,shiftY=centerShift?centerShift[1]:0;let minX=extent[0]+viewWidth/2+shiftX,maxX=extent[2]-viewWidth/2+shiftX,minY=extent[1]+viewHeight/2+shiftY,maxY=extent[3]-viewHeight/2+shiftY;minX>maxX&&(minX=(maxX+minX)/2,maxX=minX),minY>maxY&&(minY=(maxY+minY)/2,maxY=minY);let x=clamp$2(center[0],minX,maxX),y=clamp$2(center[1],minY,maxY);if(isMoving&&smooth&&resolution){const ratio=30*resolution;x+=-ratio*Math.log(1+Math.max(0,minX-center[0])/ratio)+ratio*Math.log(1+Math.max(0,center[0]-maxX)/ratio),y+=-ratio*Math.log(1+Math.max(0,minY-center[1])/ratio)+ratio*Math.log(1+Math.max(0,center[1]-maxY)/ratio)}return[x,y]}}function none$2(center){return center}const Relationship={UNKNOWN:0,INTERSECTING:1,ABOVE:2,RIGHT:4,BELOW:8,LEFT:16};function boundingExtent(coordinates2){const extent=createEmpty();for(let i2=0,ii=coordinates2.length;i2<ii;++i2)extendCoordinate(extent,coordinates2[i2]);return extent}function _boundingExtentXYs(xs,ys,dest){const minX=Math.min.apply(null,xs),minY=Math.min.apply(null,ys),maxX=Math.max.apply(null,xs),maxY=Math.max.apply(null,ys);return createOrUpdate$2(minX,minY,maxX,maxY,dest)}function clone(extent,dest){return dest?(dest[0]=extent[0],dest[1]=extent[1],dest[2]=extent[2],dest[3]=extent[3],dest):extent.slice()}function closestSquaredDistanceXY(extent,x,y){let dx,dy;return x<extent[0]?dx=extent[0]-x:extent[2]<x?dx=x-extent[2]:dx=0,y<extent[1]?dy=extent[1]-y:extent[3]<y?dy=y-extent[3]:dy=0,dx*dx+dy*dy}function containsCoordinate(extent,coordinate){return containsXY(extent,coordinate[0],coordinate[1])}function containsXY(extent,x,y){return extent[0]<=x&&x<=extent[2]&&extent[1]<=y&&y<=extent[3]}function coordinateRelationship(extent,coordinate){const minX=extent[0],minY=extent[1],maxX=extent[2],maxY=extent[3],x=coordinate[0],y=coordinate[1];let relationship=Relationship.UNKNOWN;return x<minX?relationship=relationship|Relationship.LEFT:x>maxX&&(relationship=relationship|Relationship.RIGHT),y<minY?relationship=relationship|Relationship.BELOW:y>maxY&&(relationship=relationship|Relationship.ABOVE),relationship===Relationship.UNKNOWN&&(relationship=Relationship.INTERSECTING),relationship}function createEmpty(){return[1/0,1/0,-1/0,-1/0]}function createOrUpdate$2(minX,minY,maxX,maxY,dest){return dest?(dest[0]=minX,dest[1]=minY,dest[2]=maxX,dest[3]=maxY,dest):[minX,minY,maxX,maxY]}function createOrUpdateEmpty(dest){return createOrUpdate$2(1/0,1/0,-1/0,-1/0,dest)}function createOrUpdateFromCoordinate(coordinate,dest){const x=coordinate[0],y=coordinate[1];return createOrUpdate$2(x,y,x,y,dest)}function createOrUpdateFromFlatCoordinates(flatCoordinates,offset,end,stride,dest){const extent=createOrUpdateEmpty(dest);return extendFlatCoordinates(extent,flatCoordinates,offset,end,stride)}function equals$1(extent1,extent2){return extent1[0]==extent2[0]&&extent1[2]==extent2[2]&&extent1[1]==extent2[1]&&extent1[3]==extent2[3]}function extend$2(extent1,extent2){return extent2[0]<extent1[0]&&(extent1[0]=extent2[0]),extent2[2]>extent1[2]&&(extent1[2]=extent2[2]),extent2[1]<extent1[1]&&(extent1[1]=extent2[1]),extent2[3]>extent1[3]&&(extent1[3]=extent2[3]),extent1}function extendCoordinate(extent,coordinate){coordinate[0]<extent[0]&&(extent[0]=coordinate[0]),coordinate[0]>extent[2]&&(extent[2]=coordinate[0]),coordinate[1]<extent[1]&&(extent[1]=coordinate[1]),coordinate[1]>extent[3]&&(extent[3]=coordinate[1])}function extendFlatCoordinates(extent,flatCoordinates,offset,end,stride){for(;offset<end;offset+=stride)extendXY(extent,flatCoordinates[offset],flatCoordinates[offset+1]);return extent}function extendXY(extent,x,y){extent[0]=Math.min(extent[0],x),extent[1]=Math.min(extent[1],y),extent[2]=Math.max(extent[2],x),extent[3]=Math.max(extent[3],y)}function forEachCorner(extent,callback){let val;return val=callback(getBottomLeft(extent)),val||(val=callback(getBottomRight(extent)),val)||(val=callback(getTopRight(extent)),val)||(val=callback(getTopLeft(extent)),val)?val:!1}function getArea(extent){let area=0;return isEmpty(extent)||(area=getWidth(extent)*getHeight(extent)),area}function getBottomLeft(extent){return[extent[0],extent[1]]}function getBottomRight(extent){return[extent[2],extent[1]]}function getCenter(extent){return[(extent[0]+extent[2])/2,(extent[1]+extent[3])/2]}function getCorner(extent,corner){let coordinate;if(corner==="bottom-left")coordinate=getBottomLeft(extent);else if(corner==="bottom-right")coordinate=getBottomRight(extent);else if(corner==="top-left")coordinate=getTopLeft(extent);else if(corner==="top-right")coordinate=getTopRight(extent);else throw new Error("Invalid corner");return coordinate}function getForViewAndSize(center,resolution,rotation2,size,dest){const[x0,y0,x1,y1,x2,y2,x3,y3]=getRotatedViewport(center,resolution,rotation2,size);return createOrUpdate$2(Math.min(x0,x1,x2,x3),Math.min(y0,y1,y2,y3),Math.max(x0,x1,x2,x3),Math.max(y0,y1,y2,y3),dest)}function getRotatedViewport(center,resolution,rotation2,size){const dx=resolution*size[0]/2,dy=resolution*size[1]/2,cosRotation=Math.cos(rotation2),sinRotation=Math.sin(rotation2),xCos=dx*cosRotation,xSin=dx*sinRotation,yCos=dy*cosRotation,ySin=dy*sinRotation,x=center[0],y=center[1];return[x-xCos+ySin,y-xSin-yCos,x-xCos-ySin,y-xSin+yCos,x+xCos-ySin,y+xSin+yCos,x+xCos+ySin,y+xSin-yCos,x-xCos+ySin,y-xSin-yCos]}function getHeight(extent){return extent[3]-extent[1]}function getIntersection(extent1,extent2,dest){const intersection=dest||createEmpty();return intersects$1(extent1,extent2)?(extent1[0]>extent2[0]?intersection[0]=extent1[0]:intersection[0]=extent2[0],extent1[1]>extent2[1]?intersection[1]=extent1[1]:intersection[1]=extent2[1],extent1[2]<extent2[2]?intersection[2]=extent1[2]:intersection[2]=extent2[2],extent1[3]<extent2[3]?intersection[3]=extent1[3]:intersection[3]=extent2[3]):createOrUpdateEmpty(intersection),intersection}function getTopLeft(extent){return[extent[0],extent[3]]}function getTopRight(extent){return[extent[2],extent[3]]}function getWidth(extent){return extent[2]-extent[0]}function intersects$1(extent1,extent2){return extent1[0]<=extent2[2]&&extent1[2]>=extent2[0]&&extent1[1]<=extent2[3]&&extent1[3]>=extent2[1]}function isEmpty(extent){return extent[2]<extent[0]||extent[3]<extent[1]}function returnOrUpdate(extent,dest){return dest?(dest[0]=extent[0],dest[1]=extent[1],dest[2]=extent[2],dest[3]=extent[3],dest):extent}function intersectsSegment(extent,start,end){let intersects2=!1;const startRel=coordinateRelationship(extent,start),endRel=coordinateRelationship(extent,end);if(startRel===Relationship.INTERSECTING||endRel===Relationship.INTERSECTING)intersects2=!0;else{const minX=extent[0],minY=extent[1],maxX=extent[2],maxY=extent[3],startX=start[0],startY=start[1],endX=end[0],endY=end[1],slope=(endY-startY)/(endX-startX);let x,y;endRel&Relationship.ABOVE&&!(startRel&Relationship.ABOVE)&&(x=endX-(endY-maxY)/slope,intersects2=x>=minX&&x<=maxX),!intersects2&&endRel&Relationship.RIGHT&&!(startRel&Relationship.RIGHT)&&(y=endY-(endX-maxX)*slope,intersects2=y>=minY&&y<=maxY),!intersects2&&endRel&Relationship.BELOW&&!(startRel&Relationship.BELOW)&&(x=endX-(endY-minY)/slope,intersects2=x>=minX&&x<=maxX),!intersects2&&endRel&Relationship.LEFT&&!(startRel&Relationship.LEFT)&&(y=endY-(endX-minX)*slope,intersects2=y>=minY&&y<=maxY)}return intersects2}function applyTransform(extent,transformFn,dest,stops){if(isEmpty(extent))return createOrUpdateEmpty(dest);let coordinates2=[];coordinates2=[extent[0],extent[1],extent[2],extent[1],extent[2],extent[3],extent[0],extent[3]],transformFn(coordinates2,coordinates2,2);const xs=[],ys=[];for(let i2=0,l2=coordinates2.length;i2<l2;i2+=2)xs.push(coordinates2[i2]),ys.push(coordinates2[i2+1]);return _boundingExtentXYs(xs,ys,dest)}function wrapX$2(extent,projection){const projectionExtent=projection.getExtent(),center=getCenter(extent);if(projection.canWrapX()&&(center[0]<projectionExtent[0]||center[0]>=projectionExtent[2])){const worldWidth=getWidth(projectionExtent),offset=Math.floor((center[0]-projectionExtent[0])/worldWidth)*worldWidth;extent[0]-=offset,extent[2]-=offset}return extent}function wrapAndSliceX(extent,projection,multiWorld){if(projection.canWrapX()){const projectionExtent=projection.getExtent();if(!isFinite(extent[0])||!isFinite(extent[2]))return[[projectionExtent[0],extent[1],projectionExtent[2],extent[3]]];wrapX$2(extent,projection);const worldWidth=getWidth(projectionExtent);if(getWidth(extent)>worldWidth,extent[0]<projectionExtent[0])return[[extent[0]+worldWidth,extent[1],projectionExtent[2],extent[3]],[projectionExtent[0],extent[1],extent[2],extent[3]]];if(extent[2]>projectionExtent[2])return[[extent[0],extent[1],projectionExtent[2],extent[3]],[projectionExtent[0],extent[1],extent[2]-worldWidth,extent[3]]]}return[extent]}function add$2(coordinate,delta){return coordinate[0]+=+delta[0],coordinate[1]+=+delta[1],coordinate}function equals(coordinate1,coordinate2){let equals2=!0;for(let i2=coordinate1.length-1;i2>=0;--i2)if(coordinate1[i2]!=coordinate2[i2]){equals2=!1;break}return equals2}function rotate$1(coordinate,angle){const cosAngle=Math.cos(angle),sinAngle=Math.sin(angle),x=coordinate[0]*cosAngle-coordinate[1]*sinAngle,y=coordinate[1]*cosAngle+coordinate[0]*sinAngle;return coordinate[0]=x,coordinate[1]=y,coordinate}function scale$2(coordinate,scale2){return coordinate[0]*=scale2,coordinate[1]*=scale2,coordinate}function wrapX$1(coordinate,projection){if(projection.canWrapX()){const worldWidth=getWidth(projection.getExtent()),worldsAway=getWorldsAway(coordinate,projection,worldWidth);worldsAway&&(coordinate[0]-=worldsAway*worldWidth)}return coordinate}function getWorldsAway(coordinate,projection,sourceExtentWidth){const projectionExtent=projection.getExtent();let worldsAway=0;return projection.canWrapX()&&(coordinate[0]<projectionExtent[0]||coordinate[0]>projectionExtent[2])&&(sourceExtentWidth=sourceExtentWidth||getWidth(projectionExtent),worldsAway=Math.floor((coordinate[0]-projectionExtent[0])/sourceExtentWidth)),worldsAway}function easeIn(t2){return Math.pow(t2,3)}function easeOut(t2){return 1-easeIn(1-t2)}function inAndOut(t2){return 3*t2*t2-2*t2*t2*t2}function linear$1(t2){return t2}const DEFAULT_RADIUS=63710088e-1;function getDistance(c1,c2,radius){radius=radius||DEFAULT_RADIUS;const lat1=toRadians(c1[1]),lat2=toRadians(c2[1]),deltaLatBy2=(lat2-lat1)/2,deltaLonBy2=toRadians(c2[0]-c1[0])/2,a2=Math.sin(deltaLatBy2)*Math.sin(deltaLatBy2)+Math.sin(deltaLonBy2)*Math.sin(deltaLonBy2)*Math.cos(lat1)*Math.cos(lat2);return 2*radius*Math.atan2(Math.sqrt(a2),Math.sqrt(1-a2))}function warn(...args){console.warn(...args)}const METERS_PER_UNIT$1={radians:6370997/(2*Math.PI),degrees:2*Math.PI*6370997/360,ft:.3048,m:1,"us-ft":1200/3937};class Projection{constructor(options){this.code_=options.code,this.units_=options.units,this.extent_=options.extent!==void 0?options.extent:null,this.worldExtent_=options.worldExtent!==void 0?options.worldExtent:null,this.axisOrientation_=options.axisOrientation!==void 0?options.axisOrientation:"enu",this.global_=options.global!==void 0?options.global:!1,this.canWrapX_=!!(this.global_&&this.extent_),this.getPointResolutionFunc_=options.getPointResolution,this.defaultTileGrid_=null,this.metersPerUnit_=options.metersPerUnit}canWrapX(){return this.canWrapX_}getCode(){return this.code_}getExtent(){return this.extent_}getUnits(){return this.units_}getMetersPerUnit(){return this.metersPerUnit_||METERS_PER_UNIT$1[this.units_]}getWorldExtent(){return this.worldExtent_}getAxisOrientation(){return this.axisOrientation_}isGlobal(){return this.global_}setGlobal(global2){this.global_=global2,this.canWrapX_=!!(global2&&this.extent_)}getDefaultTileGrid(){return this.defaultTileGrid_}setDefaultTileGrid(tileGrid){this.defaultTileGrid_=tileGrid}setExtent(extent){this.extent_=extent,this.canWrapX_=!!(this.global_&&extent)}setWorldExtent(worldExtent){this.worldExtent_=worldExtent}setGetPointResolution(func){this.getPointResolutionFunc_=func}getPointResolutionFunc(){return this.getPointResolutionFunc_}}const RADIUS$1=6378137,HALF_SIZE=Math.PI*RADIUS$1,EXTENT$1=[-HALF_SIZE,-HALF_SIZE,HALF_SIZE,HALF_SIZE],WORLD_EXTENT=[-180,-85,180,85],MAX_SAFE_Y=RADIUS$1*Math.log(Math.tan(Math.PI/2));class EPSG3857Projection extends Projection{constructor(code2){super({code:code2,units:"m",extent:EXTENT$1,global:!0,worldExtent:WORLD_EXTENT,getPointResolution:function(resolution,point){return resolution/Math.cosh(point[1]/RADIUS$1)}})}}const PROJECTIONS$1=[new EPSG3857Projection("EPSG:3857"),new EPSG3857Projection("EPSG:102100"),new EPSG3857Projection("EPSG:102113"),new EPSG3857Projection("EPSG:900913"),new EPSG3857Projection("http://www.opengis.net/def/crs/EPSG/0/3857"),new EPSG3857Projection("http://www.opengis.net/gml/srs/epsg.xml#3857")];function fromEPSG4326(input,output2,dimension,stride){const length2=input.length;dimension=dimension>1?dimension:2,stride=stride??dimension,output2===void 0&&(dimension>2?output2=input.slice():output2=new Array(length2));for(let i2=0;i2<length2;i2+=stride){output2[i2]=HALF_SIZE*input[i2]/180;let y=RADIUS$1*Math.log(Math.tan(Math.PI*(+input[i2+1]+90)/360));y>MAX_SAFE_Y?y=MAX_SAFE_Y:y<-MAX_SAFE_Y&&(y=-MAX_SAFE_Y),output2[i2+1]=y}return output2}function toEPSG4326(input,output2,dimension,stride){const length2=input.length;dimension=dimension>1?dimension:2,stride=stride??dimension,output2===void 0&&(dimension>2?output2=input.slice():output2=new Array(length2));for(let i2=0;i2<length2;i2+=stride)output2[i2]=180*input[i2]/HALF_SIZE,output2[i2+1]=360*Math.atan(Math.exp(input[i2+1]/RADIUS$1))/Math.PI-90;return output2}const RADIUS=6378137,EXTENT=[-180,-90,180,90],METERS_PER_UNIT=Math.PI*RADIUS/180;class EPSG4326Projection extends Projection{constructor(code2,axisOrientation){super({code:code2,units:"degrees",extent:EXTENT,axisOrientation,global:!0,metersPerUnit:METERS_PER_UNIT,worldExtent:EXTENT})}}const PROJECTIONS=[new EPSG4326Projection("CRS:84"),new EPSG4326Projection("EPSG:4326","neu"),new EPSG4326Projection("urn:ogc:def:crs:OGC:1.3:CRS84"),new EPSG4326Projection("urn:ogc:def:crs:OGC:2:84"),new EPSG4326Projection("http://www.opengis.net/def/crs/OGC/1.3/CRS84"),new EPSG4326Projection("http://www.opengis.net/gml/srs/epsg.xml#4326","neu"),new EPSG4326Projection("http://www.opengis.net/def/crs/EPSG/0/4326","neu")];let cache$1={};function get$3(code2){return cache$1[code2]||cache$1[code2.replace(/urn:(x-)?ogc:def:crs:EPSG:(.*:)?(\w+)$/,"EPSG:$3")]||null}function add$1(code2,projection){cache$1[code2]=projection}let transforms={};function add(source,destination,transformFn){const sourceCode=source.getCode(),destinationCode=destination.getCode();sourceCode in transforms||(transforms[sourceCode]={}),transforms[sourceCode][destinationCode]=transformFn}function get$2(sourceCode,destinationCode){return sourceCode in transforms&&destinationCode in transforms[sourceCode]?transforms[sourceCode][destinationCode]:null}const K0=.9996,E=.00669438,E2=E*E,E3=E2*E,E_P2=E/(1-E),SQRT_E=Math.sqrt(1-E),_E=(1-SQRT_E)/(1+SQRT_E),_E2=_E*_E,_E3=_E2*_E,_E4=_E3*_E,_E5=_E4*_E,M1=1-E/4-3*E2/64-5*E3/256,M2=3*E/8+3*E2/32+45*E3/1024,M3=15*E2/256+45*E3/1024,M4=35*E3/3072,P2=3/2*_E-27/32*_E3+269/512*_E5,P3=21/16*_E2-55/32*_E4,P4=151/96*_E3-417/128*_E5,P5=1097/512*_E4,R=6378137;function toLonLat(easting,northing,zone){const x=easting-5e5,mu=(zone.north?northing:northing-1e7)/K0/(R*M1),pRad=mu+P2*Math.sin(2*mu)+P3*Math.sin(4*mu)+P4*Math.sin(6*mu)+P5*Math.sin(8*mu),pSin=Math.sin(pRad),pSin2=pSin*pSin,pCos=Math.cos(pRad),pTan=pSin/pCos,pTan2=pTan*pTan,pTan4=pTan2*pTan2,epSin=1-E*pSin2,epSinSqrt=Math.sqrt(1-E*pSin2),n2=R/epSinSqrt,r2=(1-E)/epSin,c2=E_P2*pCos**2,c22=c2*c2,d2=x/(n2*K0),d22=d2*d2,d3=d22*d2,d4=d3*d2,d5=d4*d2,d6=d5*d2,latitude=pRad-pTan/r2*(d22/2-d4/24*(5+3*pTan2+10*c2-4*c22-9*E_P2))+d6/720*(61+90*pTan2+298*c2+45*pTan4-252*E_P2-3*c22);let longitude=(d2-d3/6*(1+2*pTan2+c2)+d5/120*(5-2*c2+28*pTan2-3*c22+8*E_P2+24*pTan4))/pCos;return longitude=wrap$1(longitude+toRadians(zoneToCentralLongitude(zone.number)),-Math.PI,Math.PI),[toDegrees(longitude),toDegrees(latitude)]}const MIN_LATITUDE=-80,MAX_LATITUDE=84,MIN_LONGITUDE=-180,MAX_LONGITUDE=180;function fromLonLat$1(longitude,latitude,zone){longitude=wrap$1(longitude,MIN_LONGITUDE,MAX_LONGITUDE),latitude<MIN_LATITUDE?latitude=MIN_LATITUDE:latitude>MAX_LATITUDE&&(latitude=MAX_LATITUDE);const latRad=toRadians(latitude),latSin=Math.sin(latRad),latCos=Math.cos(latRad),latTan=latSin/latCos,latTan2=latTan*latTan,latTan4=latTan2*latTan2,lonRad=toRadians(longitude),centralLon=zoneToCentralLongitude(zone.number),centralLonRad=toRadians(centralLon),n2=R/Math.sqrt(1-E*latSin**2),c2=E_P2*latCos**2,a2=latCos*wrap$1(lonRad-centralLonRad,-Math.PI,Math.PI),a22=a2*a2,a3=a22*a2,a4=a3*a2,a5=a4*a2,a6=a5*a2,m=R*(M1*latRad-M2*Math.sin(2*latRad)+M3*Math.sin(4*latRad)-M4*Math.sin(6*latRad)),easting=K0*n2*(a2+a3/6*(1-latTan2+c2)+a5/120*(5-18*latTan2+latTan4+72*c2-58*E_P2))+5e5;let northing=K0*(m+n2*latTan*(a22/2+a4/24*(5-latTan2+9*c2+4*c2**2)+a6/720*(61-58*latTan2+latTan4+600*c2-330*E_P2)));return zone.north||(northing+=1e7),[easting,northing]}function zoneToCentralLongitude(zone){return(zone-1)*6-180+3}const epsgRegExes=[/^EPSG:(\d+)$/,/^urn:ogc:def:crs:EPSG::(\d+)$/,/^http:\/\/www\.opengis\.net\/def\/crs\/EPSG\/0\/(\d+)$/];function zoneFromCode(code2){let epsgId=0;for(const re of epsgRegExes){const match=code2.match(re);if(match){epsgId=parseInt(match[1]);break}}if(!epsgId)return null;let number=0,north=!1;return epsgId>32700&&epsgId<32761?number=epsgId-32700:epsgId>32600&&epsgId<32661&&(north=!0,number=epsgId-32600),number?{number,north}:null}function makeTransformFunction(transformer,zone){return function(input,output2,dimension,stride){const length2=input.length;dimension=dimension>1?dimension:2,stride=stride??dimension,output2||(dimension>2?output2=input.slice():output2=new Array(length2));for(let i2=0;i2<length2;i2+=stride){const x=input[i2],y=input[i2+1],coord=transformer(x,y,zone);output2[i2]=coord[0],output2[i2+1]=coord[1]}return output2}}function makeProjection(code2){return zoneFromCode(code2)?new Projection({code:code2,units:"m"}):null}function makeTransforms(projection){const zone=zoneFromCode(projection.getCode());return zone?{forward:makeTransformFunction(fromLonLat$1,zone),inverse:makeTransformFunction(toLonLat,zone)}:null}const transformFactories=[makeTransforms],projectionFactories=[makeProjection];let showCoordinateWarning=!0;function disableCoordinateWarning(disable2){showCoordinateWarning=!1}function cloneTransform(input,output2){if(output2!==void 0){for(let i2=0,ii=input.length;i2<ii;++i2)output2[i2]=input[i2];output2=output2}else output2=input.slice();return output2}function addProjection(projection){add$1(projection.getCode(),projection),add(projection,projection,cloneTransform)}function addProjections(projections){projections.forEach(addProjection)}function get$1(projectionLike){if(typeof projectionLike!="string")return projectionLike;const projection=get$3(projectionLike);if(projection)return projection;for(const makeProjection2 of projectionFactories){const projection2=makeProjection2(projectionLike);if(projection2)return projection2}return null}function getPointResolution(projection,resolution,point,units){projection=get$1(projection);let pointResolution;const getter=projection.getPointResolutionFunc();if(getter)pointResolution=getter(resolution,point);else{const projUnits=projection.getUnits();if(projUnits=="degrees"||units=="degrees")pointResolution=resolution;else{const toEPSG43262=getTransformFromProjections(projection,get$1("EPSG:4326"));if(!toEPSG43262&&projUnits!=="degrees")pointResolution=resolution*projection.getMetersPerUnit();else{let vertices=[point[0]-resolution/2,point[1],point[0]+resolution/2,point[1],point[0],point[1]-resolution/2,point[0],point[1]+resolution/2];vertices=toEPSG43262(vertices,vertices,2);const width=getDistance(vertices.slice(0,2),vertices.slice(2,4)),height=getDistance(vertices.slice(4,6),vertices.slice(6,8));pointResolution=(width+height)/2}const metersPerUnit=projection.getMetersPerUnit();metersPerUnit!==void 0&&(pointResolution/=metersPerUnit)}}return pointResolution}function addEquivalentProjections(projections){addProjections(projections),projections.forEach(function(source){projections.forEach(function(destination){source!==destination&&add(source,destination,cloneTransform)})})}function addEquivalentTransforms(projections1,projections2,forwardTransform,inverseTransform){projections1.forEach(function(projection1){projections2.forEach(function(projection2){add(projection1,projection2,forwardTransform),add(projection2,projection1,inverseTransform)})})}function createProjection(projection,defaultCode){return projection?typeof projection=="string"?get$1(projection):projection:get$1(defaultCode)}function createTransformFromCoordinateTransform(coordTransform){return function(input,output2,dimension,stride){const length2=input.length;dimension=dimension!==void 0?dimension:2,stride=stride??dimension,output2=output2!==void 0?output2:new Array(length2);for(let i2=0;i2<length2;i2+=stride){const point=coordTransform(input.slice(i2,i2+dimension)),pointLength=point.length;for(let j=0,jj=stride;j<jj;++j)output2[i2+j]=j>=pointLength?input[i2+j]:point[j]}return output2}}function fromLonLat(coordinate,projection){return disableCoordinateWarning(),transform(coordinate,"EPSG:4326","EPSG:3857")}function equivalent(projection1,projection2){if(projection1===projection2)return!0;const equalUnits=projection1.getUnits()===projection2.getUnits();return(projection1.getCode()===projection2.getCode()||getTransformFromProjections(projection1,projection2)===cloneTransform)&&equalUnits}function getTransformFromProjections(source,destination){const sourceCode=source.getCode(),destinationCode=destination.getCode();let transformFunc=get$2(sourceCode,destinationCode);if(transformFunc)return transformFunc;let sourceTransforms=null,destinationTransforms=null;for(const makeTransforms2 of transformFactories)sourceTransforms||(sourceTransforms=makeTransforms2(source)),destinationTransforms||(destinationTransforms=makeTransforms2(destination));if(!sourceTransforms&&!destinationTransforms)return null;const intermediateCode="EPSG:4326";if(destinationTransforms)if(sourceTransforms)transformFunc=composeTransformFuncs(sourceTransforms.inverse,destinationTransforms.forward);else{const fromSource=get$2(sourceCode,intermediateCode);fromSource&&(transformFunc=composeTransformFuncs(fromSource,destinationTransforms.forward))}else{const toDestination=get$2(intermediateCode,destinationCode);toDestination&&(transformFunc=composeTransformFuncs(sourceTransforms.inverse,toDestination))}return transformFunc&&(addProjection(source),addProjection(destination),add(source,destination,transformFunc)),transformFunc}function composeTransformFuncs(t1,t2){return function(input,output2,dimensions,stride){return output2=t1(input,output2,dimensions,stride),t2(output2,output2,dimensions,stride)}}function getTransform(source,destination){const sourceProjection=get$1(source),destinationProjection=get$1(destination);return getTransformFromProjections(sourceProjection,destinationProjection)}function transform(coordinate,source,destination){const transformFunc=getTransform(source,destination);if(!transformFunc){const sourceCode=get$1(source).getCode(),destinationCode=get$1(destination).getCode();throw new Error(`No transform available between ${sourceCode} and ${destinationCode}`)}return transformFunc(coordinate,void 0,coordinate.length)}function transformExtent(extent,source,destination,stops){const transformFunc=getTransform(source,destination);return applyTransform(extent,transformFunc,void 0)}let userProjection=null;function setUserProjection(projection){userProjection=get$1(projection)}function getUserProjection(){return userProjection}function useGeographic(){setUserProjection("EPSG:4326")}function toUserCoordinate(coordinate,sourceProjection){return userProjection?transform(coordinate,sourceProjection,userProjection):coordinate}function fromUserCoordinate(coordinate,destProjection){return userProjection?transform(coordinate,userProjection,destProjection):(showCoordinateWarning&&!equals(coordinate,[0,0])&&coordinate[0]>=-180&&coordinate[0]<=180&&coordinate[1]>=-90&&coordinate[1]<=90&&(showCoordinateWarning=!1,warn("Call useGeographic() from ol/proj once to work with [longitude, latitude] coordinates.")),coordinate)}function toUserExtent(extent,sourceProjection){return userProjection?transformExtent(extent,sourceProjection,userProjection):extent}function fromUserExtent(extent,destProjection){return userProjection?transformExtent(extent,userProjection,destProjection):extent}function addCommon(){addEquivalentProjections(PROJECTIONS$1),addEquivalentProjections(PROJECTIONS),addEquivalentTransforms(PROJECTIONS,PROJECTIONS$1,fromEPSG4326,toEPSG4326)}addCommon();new Array(6);function create(){return[1,0,0,1,0,0]}function apply$1(transform2,coordinate){const x=coordinate[0],y=coordinate[1];return coordinate[0]=transform2[0]*x+transform2[2]*y+transform2[4],coordinate[1]=transform2[1]*x+transform2[3]*y+transform2[5],coordinate}function compose(transform2,dx1,dy1,sx,sy,angle,dx2,dy2){const sin2=Math.sin(angle),cos2=Math.cos(angle);return transform2[0]=sx*cos2,transform2[1]=sy*sin2,transform2[2]=-sx*sin2,transform2[3]=sy*cos2,transform2[4]=dx2*sx*cos2-dy2*sx*sin2+dx1,transform2[5]=dx2*sy*sin2+dy2*sy*cos2+dy1,transform2}function makeInverse(target,source){const det=determinant(source);assert(det!==0,"Transformation matrix cannot be inverted");const a2=source[0],b=source[1],c2=source[2],d2=source[3],e2=source[4],f2=source[5];return target[0]=d2/det,target[1]=-b/det,target[2]=-c2/det,target[3]=a2/det,target[4]=(c2*f2-d2*e2)/det,target[5]=-(a2*f2-b*e2)/det,target}function determinant(mat){return mat[0]*mat[3]-mat[1]*mat[2]}function transform2D(flatCoordinates,offset,end,stride,transform2,dest,destinationStride){dest=dest||[],destinationStride=destinationStride||2;let i2=0;for(let j=offset;j<end;j+=stride){const x=flatCoordinates[j],y=flatCoordinates[j+1];dest[i2++]=transform2[0]*x+transform2[2]*y+transform2[4],dest[i2++]=transform2[1]*x+transform2[3]*y+transform2[5];for(let k=2;k<destinationStride;k++)dest[i2++]=flatCoordinates[j+k]}return dest&&dest.length!=i2&&(dest.length=i2),dest}function rotate(flatCoordinates,offset,end,stride,angle,anchor,dest){dest=dest||[];const cos2=Math.cos(angle),sin2=Math.sin(angle),anchorX=anchor[0],anchorY=anchor[1];let i2=0;for(let j=offset;j<end;j+=stride){const deltaX=flatCoordinates[j]-anchorX,deltaY=flatCoordinates[j+1]-anchorY;dest[i2++]=anchorX+deltaX*cos2-deltaY*sin2,dest[i2++]=anchorY+deltaX*sin2+deltaY*cos2;for(let k=j+2;k<j+stride;++k)dest[i2++]=flatCoordinates[k]}return dest&&dest.length!=i2&&(dest.length=i2),dest}function scale$1(flatCoordinates,offset,end,stride,sx,sy,anchor,dest){dest=dest||[];const anchorX=anchor[0],anchorY=anchor[1];let i2=0;for(let j=offset;j<end;j+=stride){const deltaX=flatCoordinates[j]-anchorX,deltaY=flatCoordinates[j+1]-anchorY;dest[i2++]=anchorX+sx*deltaX,dest[i2++]=anchorY+sy*deltaY;for(let k=j+2;k<j+stride;++k)dest[i2++]=flatCoordinates[k]}return dest&&dest.length!=i2&&(dest.length=i2),dest}function translate(flatCoordinates,offset,end,stride,deltaX,deltaY,dest){dest=dest||[];let i2=0;for(let j=offset;j<end;j+=stride){dest[i2++]=flatCoordinates[j]+deltaX,dest[i2++]=flatCoordinates[j+1]+deltaY;for(let k=j+2;k<j+stride;++k)dest[i2++]=flatCoordinates[k]}return dest&&dest.length!=i2&&(dest.length=i2),dest}const tmpTransform=create(),tmpPoint=[NaN,NaN];class Geometry extends BaseObject{constructor(){super(),this.extent_=createEmpty(),this.extentRevision_=-1,this.simplifiedGeometryMaxMinSquaredTolerance=0,this.simplifiedGeometryRevision=0,this.simplifyTransformedInternal=memoizeOne((revision,squaredTolerance,transform2)=>{if(!transform2)return this.getSimplifiedGeometry(squaredTolerance);const clone2=this.clone();return clone2.applyTransform(transform2),clone2.getSimplifiedGeometry(squaredTolerance)})}simplifyTransformed(squaredTolerance,transform2){return this.simplifyTransformedInternal(this.getRevision(),squaredTolerance,transform2)}clone(){return abstract()}closestPointXY(x,y,closestPoint,minSquaredDistance){return abstract()}containsXY(x,y){return this.closestPointXY(x,y,tmpPoint,Number.MIN_VALUE)===0}getClosestPoint(point,closestPoint){return closestPoint=closestPoint||[NaN,NaN],this.closestPointXY(point[0],point[1],closestPoint,1/0),closestPoint}intersectsCoordinate(coordinate){return this.containsXY(coordinate[0],coordinate[1])}computeExtent(extent){return abstract()}getExtent(extent){if(this.extentRevision_!=this.getRevision()){const extent2=this.computeExtent(this.extent_);(isNaN(extent2[0])||isNaN(extent2[1]))&&createOrUpdateEmpty(extent2),this.extentRevision_=this.getRevision()}return returnOrUpdate(this.extent_,extent)}rotate(angle,anchor){abstract()}scale(sx,sy,anchor){abstract()}simplify(tolerance){return this.getSimplifiedGeometry(tolerance*tolerance)}getSimplifiedGeometry(squaredTolerance){return abstract()}getType(){return abstract()}applyTransform(transformFn){abstract()}intersectsExtent(extent){return abstract()}translate(deltaX,deltaY){abstract()}transform(source,destination){const sourceProj=get$1(source),transformFn=sourceProj.getUnits()=="tile-pixels"?function(inCoordinates,outCoordinates,stride){const pixelExtent=sourceProj.getExtent(),projectedExtent=sourceProj.getWorldExtent(),scale2=getHeight(projectedExtent)/getHeight(pixelExtent);compose(tmpTransform,projectedExtent[0],projectedExtent[3],scale2,-scale2,0,0,0);const transformed=transform2D(inCoordinates,0,inCoordinates.length,stride,tmpTransform,outCoordinates),projTransform=getTransform(sourceProj,destination);return projTransform?projTransform(transformed,transformed,stride):transformed}:getTransform(sourceProj,destination);return this.applyTransform(transformFn),this}}class SimpleGeometry extends Geometry{constructor(){super(),this.layout="XY",this.stride=2,this.flatCoordinates}computeExtent(extent){return createOrUpdateFromFlatCoordinates(this.flatCoordinates,0,this.flatCoordinates.length,this.stride,extent)}getCoordinates(){return abstract()}getFirstCoordinate(){return this.flatCoordinates.slice(0,this.stride)}getFlatCoordinates(){return this.flatCoordinates}getLastCoordinate(){return this.flatCoordinates.slice(this.flatCoordinates.length-this.stride)}getLayout(){return this.layout}getSimplifiedGeometry(squaredTolerance){if(this.simplifiedGeometryRevision!==this.getRevision()&&(this.simplifiedGeometryMaxMinSquaredTolerance=0,this.simplifiedGeometryRevision=this.getRevision()),squaredTolerance<0||this.simplifiedGeometryMaxMinSquaredTolerance!==0&&squaredTolerance<=this.simplifiedGeometryMaxMinSquaredTolerance)return this;const simplifiedGeometry=this.getSimplifiedGeometryInternal(squaredTolerance);return simplifiedGeometry.getFlatCoordinates().length<this.flatCoordinates.length?simplifiedGeometry:(this.simplifiedGeometryMaxMinSquaredTolerance=squaredTolerance,this)}getSimplifiedGeometryInternal(squaredTolerance){return this}getStride(){return this.stride}setFlatCoordinates(layout,flatCoordinates){this.stride=getStrideForLayout(layout),this.layout=layout,this.flatCoordinates=flatCoordinates}setCoordinates(coordinates2,layout){abstract()}setLayout(layout,coordinates2,nesting){let stride;if(layout)stride=getStrideForLayout(layout);else{for(let i2=0;i2<nesting;++i2){if(coordinates2.length===0){this.layout="XY",this.stride=2;return}coordinates2=coordinates2[0]}stride=coordinates2.length,layout=getLayoutForStride(stride)}this.layout=layout,this.stride=stride}applyTransform(transformFn){this.flatCoordinates&&(transformFn(this.flatCoordinates,this.flatCoordinates,this.layout.startsWith("XYZ")?3:2,this.stride),this.changed())}rotate(angle,anchor){const flatCoordinates=this.getFlatCoordinates();if(flatCoordinates){const stride=this.getStride();rotate(flatCoordinates,0,flatCoordinates.length,stride,angle,anchor,flatCoordinates),this.changed()}}scale(sx,sy,anchor){sy===void 0&&(sy=sx),anchor||(anchor=getCenter(this.getExtent()));const flatCoordinates=this.getFlatCoordinates();if(flatCoordinates){const stride=this.getStride();scale$1(flatCoordinates,0,flatCoordinates.length,stride,sx,sy,anchor,flatCoordinates),this.changed()}}translate(deltaX,deltaY){const flatCoordinates=this.getFlatCoordinates();if(flatCoordinates){const stride=this.getStride();translate(flatCoordinates,0,flatCoordinates.length,stride,deltaX,deltaY,flatCoordinates),this.changed()}}}function getLayoutForStride(stride){let layout;return stride==2?layout="XY":stride==3?layout="XYZ":stride==4&&(layout="XYZM"),layout}function getStrideForLayout(layout){let stride;return layout=="XY"?stride=2:layout=="XYZ"||layout=="XYM"?stride=3:layout=="XYZM"&&(stride=4),stride}function linearRing(flatCoordinates,offset,end,stride){let twiceArea=0;const x0=flatCoordinates[end-stride],y0=flatCoordinates[end-stride+1];let dx1=0,dy1=0;for(;offset<end;offset+=stride){const dx2=flatCoordinates[offset]-x0,dy2=flatCoordinates[offset+1]-y0;twiceArea+=dy1*dx2-dx1*dy2,dx1=dx2,dy1=dy2}return twiceArea/2}function linearRings(flatCoordinates,offset,ends,stride){let area=0;for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2];area+=linearRing(flatCoordinates,offset,end,stride),offset=end}return area}function assignClosest(flatCoordinates,offset1,offset2,stride,x,y,closestPoint){const x1=flatCoordinates[offset1],y1=flatCoordinates[offset1+1],dx=flatCoordinates[offset2]-x1,dy=flatCoordinates[offset2+1]-y1;let offset;if(dx===0&&dy===0)offset=offset1;else{const t2=((x-x1)*dx+(y-y1)*dy)/(dx*dx+dy*dy);if(t2>1)offset=offset2;else if(t2>0){for(let i2=0;i2<stride;++i2)closestPoint[i2]=lerp$1(flatCoordinates[offset1+i2],flatCoordinates[offset2+i2],t2);closestPoint.length=stride;return}else offset=offset1}for(let i2=0;i2<stride;++i2)closestPoint[i2]=flatCoordinates[offset+i2];closestPoint.length=stride}function maxSquaredDelta(flatCoordinates,offset,end,stride,max2){let x1=flatCoordinates[offset],y1=flatCoordinates[offset+1];for(offset+=stride;offset<end;offset+=stride){const x2=flatCoordinates[offset],y2=flatCoordinates[offset+1],squaredDelta=squaredDistance(x1,y1,x2,y2);squaredDelta>max2&&(max2=squaredDelta),x1=x2,y1=y2}return max2}function arrayMaxSquaredDelta(flatCoordinates,offset,ends,stride,max2){for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2];max2=maxSquaredDelta(flatCoordinates,offset,end,stride,max2),offset=end}return max2}function assignClosestPoint(flatCoordinates,offset,end,stride,maxDelta,isRing,x,y,closestPoint,minSquaredDistance,tmpPoint2){if(offset==end)return minSquaredDistance;let i2,squaredDistance$1;if(maxDelta===0){if(squaredDistance$1=squaredDistance(x,y,flatCoordinates[offset],flatCoordinates[offset+1]),squaredDistance$1<minSquaredDistance){for(i2=0;i2<stride;++i2)closestPoint[i2]=flatCoordinates[offset+i2];return closestPoint.length=stride,squaredDistance$1}return minSquaredDistance}tmpPoint2=tmpPoint2||[NaN,NaN];let index=offset+stride;for(;index<end;)if(assignClosest(flatCoordinates,index-stride,index,stride,x,y,tmpPoint2),squaredDistance$1=squaredDistance(x,y,tmpPoint2[0],tmpPoint2[1]),squaredDistance$1<minSquaredDistance){for(minSquaredDistance=squaredDistance$1,i2=0;i2<stride;++i2)closestPoint[i2]=tmpPoint2[i2];closestPoint.length=stride,index+=stride}else index+=stride*Math.max((Math.sqrt(squaredDistance$1)-Math.sqrt(minSquaredDistance))/maxDelta|0,1);if(assignClosest(flatCoordinates,end-stride,offset,stride,x,y,tmpPoint2),squaredDistance$1=squaredDistance(x,y,tmpPoint2[0],tmpPoint2[1]),squaredDistance$1<minSquaredDistance){for(minSquaredDistance=squaredDistance$1,i2=0;i2<stride;++i2)closestPoint[i2]=tmpPoint2[i2];closestPoint.length=stride}return minSquaredDistance}function assignClosestArrayPoint(flatCoordinates,offset,ends,stride,maxDelta,isRing,x,y,closestPoint,minSquaredDistance,tmpPoint2){tmpPoint2=tmpPoint2||[NaN,NaN];for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2];minSquaredDistance=assignClosestPoint(flatCoordinates,offset,end,stride,maxDelta,isRing,x,y,closestPoint,minSquaredDistance,tmpPoint2),offset=end}return minSquaredDistance}function deflateCoordinate(flatCoordinates,offset,coordinate,stride){for(let i2=0,ii=coordinate.length;i2<ii;++i2)flatCoordinates[offset++]=coordinate[i2];return offset}function deflateCoordinates(flatCoordinates,offset,coordinates2,stride){for(let i2=0,ii=coordinates2.length;i2<ii;++i2){const coordinate=coordinates2[i2];for(let j=0;j<stride;++j)flatCoordinates[offset++]=coordinate[j]}return offset}function deflateCoordinatesArray(flatCoordinates,offset,coordinatess,stride,ends){ends=ends||[];let i2=0;for(let j=0,jj=coordinatess.length;j<jj;++j){const end=deflateCoordinates(flatCoordinates,offset,coordinatess[j],stride);ends[i2++]=end,offset=end}return ends.length=i2,ends}function inflateCoordinates(flatCoordinates,offset,end,stride,coordinates2){coordinates2=coordinates2!==void 0?coordinates2:[];let i2=0;for(let j=offset;j<end;j+=stride)coordinates2[i2++]=flatCoordinates.slice(j,j+stride);return coordinates2.length=i2,coordinates2}function inflateCoordinatesArray(flatCoordinates,offset,ends,stride,coordinatess){coordinatess=coordinatess!==void 0?coordinatess:[];let i2=0;for(let j=0,jj=ends.length;j<jj;++j){const end=ends[j];coordinatess[i2++]=inflateCoordinates(flatCoordinates,offset,end,stride,coordinatess[i2]),offset=end}return coordinatess.length=i2,coordinatess}function douglasPeucker(flatCoordinates,offset,end,stride,squaredTolerance,simplifiedFlatCoordinates,simplifiedOffset){const n2=(end-offset)/stride;if(n2<3){for(;offset<end;offset+=stride)simplifiedFlatCoordinates[simplifiedOffset++]=flatCoordinates[offset],simplifiedFlatCoordinates[simplifiedOffset++]=flatCoordinates[offset+1];return simplifiedOffset}const markers=new Array(n2);markers[0]=1,markers[n2-1]=1;const stack2=[offset,end-stride];let index=0;for(;stack2.length>0;){const last=stack2.pop(),first=stack2.pop();let maxSquaredDistance=0;const x1=flatCoordinates[first],y1=flatCoordinates[first+1],x2=flatCoordinates[last],y2=flatCoordinates[last+1];for(let i2=first+stride;i2<last;i2+=stride){const x=flatCoordinates[i2],y=flatCoordinates[i2+1],squaredDistance2=squaredSegmentDistance(x,y,x1,y1,x2,y2);squaredDistance2>maxSquaredDistance&&(index=i2,maxSquaredDistance=squaredDistance2)}maxSquaredDistance>squaredTolerance&&(markers[(index-offset)/stride]=1,first+stride<index&&stack2.push(first,index),index+stride<last&&stack2.push(index,last))}for(let i2=0;i2<n2;++i2)markers[i2]&&(simplifiedFlatCoordinates[simplifiedOffset++]=flatCoordinates[offset+i2*stride],simplifiedFlatCoordinates[simplifiedOffset++]=flatCoordinates[offset+i2*stride+1]);return simplifiedOffset}function snap$1(value,tolerance){return tolerance*Math.round(value/tolerance)}function quantize(flatCoordinates,offset,end,stride,tolerance,simplifiedFlatCoordinates,simplifiedOffset){if(offset==end)return simplifiedOffset;let x1=snap$1(flatCoordinates[offset],tolerance),y1=snap$1(flatCoordinates[offset+1],tolerance);offset+=stride,simplifiedFlatCoordinates[simplifiedOffset++]=x1,simplifiedFlatCoordinates[simplifiedOffset++]=y1;let x2,y2;do if(x2=snap$1(flatCoordinates[offset],tolerance),y2=snap$1(flatCoordinates[offset+1],tolerance),offset+=stride,offset==end)return simplifiedFlatCoordinates[simplifiedOffset++]=x2,simplifiedFlatCoordinates[simplifiedOffset++]=y2,simplifiedOffset;while(x2==x1&&y2==y1);for(;offset<end;){const x3=snap$1(flatCoordinates[offset],tolerance),y3=snap$1(flatCoordinates[offset+1],tolerance);if(offset+=stride,x3==x2&&y3==y2)continue;const dx1=x2-x1,dy1=y2-y1,dx2=x3-x1,dy2=y3-y1;if(dx1*dy2==dy1*dx2&&(dx1<0&&dx2<dx1||dx1==dx2||dx1>0&&dx2>dx1)&&(dy1<0&&dy2<dy1||dy1==dy2||dy1>0&&dy2>dy1)){x2=x3,y2=y3;continue}simplifiedFlatCoordinates[simplifiedOffset++]=x2,simplifiedFlatCoordinates[simplifiedOffset++]=y2,x1=x2,y1=y2,x2=x3,y2=y3}return simplifiedFlatCoordinates[simplifiedOffset++]=x2,simplifiedFlatCoordinates[simplifiedOffset++]=y2,simplifiedOffset}function quantizeArray(flatCoordinates,offset,ends,stride,tolerance,simplifiedFlatCoordinates,simplifiedOffset,simplifiedEnds){for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2];simplifiedOffset=quantize(flatCoordinates,offset,end,stride,tolerance,simplifiedFlatCoordinates,simplifiedOffset),simplifiedEnds.push(simplifiedOffset),offset=end}return simplifiedOffset}class LinearRing extends SimpleGeometry{constructor(coordinates2,layout){super(),this.maxDelta_=-1,this.maxDeltaRevision_=-1,layout!==void 0&&!Array.isArray(coordinates2[0])?this.setFlatCoordinates(layout,coordinates2):this.setCoordinates(coordinates2,layout)}clone(){return new LinearRing(this.flatCoordinates.slice(),this.layout)}closestPointXY(x,y,closestPoint,minSquaredDistance){return minSquaredDistance<closestSquaredDistanceXY(this.getExtent(),x,y)?minSquaredDistance:(this.maxDeltaRevision_!=this.getRevision()&&(this.maxDelta_=Math.sqrt(maxSquaredDelta(this.flatCoordinates,0,this.flatCoordinates.length,this.stride,0)),this.maxDeltaRevision_=this.getRevision()),assignClosestPoint(this.flatCoordinates,0,this.flatCoordinates.length,this.stride,this.maxDelta_,!0,x,y,closestPoint,minSquaredDistance))}getArea(){return linearRing(this.flatCoordinates,0,this.flatCoordinates.length,this.stride)}getCoordinates(){return inflateCoordinates(this.flatCoordinates,0,this.flatCoordinates.length,this.stride)}getSimplifiedGeometryInternal(squaredTolerance){const simplifiedFlatCoordinates=[];return simplifiedFlatCoordinates.length=douglasPeucker(this.flatCoordinates,0,this.flatCoordinates.length,this.stride,squaredTolerance,simplifiedFlatCoordinates,0),new LinearRing(simplifiedFlatCoordinates,"XY")}getType(){return"LinearRing"}intersectsExtent(extent){return!1}setCoordinates(coordinates2,layout){this.setLayout(layout,coordinates2,1),this.flatCoordinates||(this.flatCoordinates=[]),this.flatCoordinates.length=deflateCoordinates(this.flatCoordinates,0,coordinates2,this.stride),this.changed()}}class Point extends SimpleGeometry{constructor(coordinates2,layout){super(),this.setCoordinates(coordinates2,layout)}clone(){const point=new Point(this.flatCoordinates.slice(),this.layout);return point.applyProperties(this),point}closestPointXY(x,y,closestPoint,minSquaredDistance){const flatCoordinates=this.flatCoordinates,squaredDistance$1=squaredDistance(x,y,flatCoordinates[0],flatCoordinates[1]);if(squaredDistance$1<minSquaredDistance){const stride=this.stride;for(let i2=0;i2<stride;++i2)closestPoint[i2]=flatCoordinates[i2];return closestPoint.length=stride,squaredDistance$1}return minSquaredDistance}getCoordinates(){return this.flatCoordinates.slice()}computeExtent(extent){return createOrUpdateFromCoordinate(this.flatCoordinates,extent)}getType(){return"Point"}intersectsExtent(extent){return containsXY(extent,this.flatCoordinates[0],this.flatCoordinates[1])}setCoordinates(coordinates2,layout){this.setLayout(layout,coordinates2,0),this.flatCoordinates||(this.flatCoordinates=[]),this.flatCoordinates.length=deflateCoordinate(this.flatCoordinates,0,coordinates2,this.stride),this.changed()}}function linearRingContainsExtent(flatCoordinates,offset,end,stride,extent){return!forEachCorner(extent,function(coordinate){return!linearRingContainsXY(flatCoordinates,offset,end,stride,coordinate[0],coordinate[1])})}function linearRingContainsXY(flatCoordinates,offset,end,stride,x,y){let wn=0,x1=flatCoordinates[end-stride],y1=flatCoordinates[end-stride+1];for(;offset<end;offset+=stride){const x2=flatCoordinates[offset],y2=flatCoordinates[offset+1];y1<=y?y2>y&&(x2-x1)*(y-y1)-(x-x1)*(y2-y1)>0&&wn++:y2<=y&&(x2-x1)*(y-y1)-(x-x1)*(y2-y1)<0&&wn--,x1=x2,y1=y2}return wn!==0}function linearRingsContainsXY(flatCoordinates,offset,ends,stride,x,y){if(ends.length===0||!linearRingContainsXY(flatCoordinates,offset,ends[0],stride,x,y))return!1;for(let i2=1,ii=ends.length;i2<ii;++i2)if(linearRingContainsXY(flatCoordinates,ends[i2-1],ends[i2],stride,x,y))return!1;return!0}function getInteriorPointOfArray(flatCoordinates,offset,ends,stride,flatCenters,flatCentersOffset,dest){let i2,ii,x,x1,x2,y1,y2;const y=flatCenters[flatCentersOffset+1],intersections=[];for(let r2=0,rr=ends.length;r2<rr;++r2){const end=ends[r2];for(x1=flatCoordinates[end-stride],y1=flatCoordinates[end-stride+1],i2=offset;i2<end;i2+=stride)x2=flatCoordinates[i2],y2=flatCoordinates[i2+1],(y<=y1&&y2<=y||y1<=y&&y<=y2)&&(x=(y-y1)/(y2-y1)*(x2-x1)+x1,intersections.push(x)),x1=x2,y1=y2}let pointX=NaN,maxSegmentLength=-1/0;for(intersections.sort(ascending),x1=intersections[0],i2=1,ii=intersections.length;i2<ii;++i2){x2=intersections[i2];const segmentLength=Math.abs(x2-x1);segmentLength>maxSegmentLength&&(x=(x1+x2)/2,linearRingsContainsXY(flatCoordinates,offset,ends,stride,x,y)&&(pointX=x,maxSegmentLength=segmentLength)),x1=x2}return isNaN(pointX)&&(pointX=flatCenters[flatCentersOffset]),[pointX,y,maxSegmentLength]}function forEach(flatCoordinates,offset,end,stride,callback){let ret;for(offset+=stride;offset<end;offset+=stride)if(ret=callback(flatCoordinates.slice(offset-stride,offset),flatCoordinates.slice(offset,offset+stride)),ret)return ret;return!1}function intersectsLineString(flatCoordinates,offset,end,stride,extent,coordinatesExtent){return coordinatesExtent=coordinatesExtent??extendFlatCoordinates(createEmpty(),flatCoordinates,offset,end,stride),intersects$1(extent,coordinatesExtent)?coordinatesExtent[0]>=extent[0]&&coordinatesExtent[2]<=extent[2]||coordinatesExtent[1]>=extent[1]&&coordinatesExtent[3]<=extent[3]?!0:forEach(flatCoordinates,offset,end,stride,function(point1,point2){return intersectsSegment(extent,point1,point2)}):!1}function intersectsLinearRing(flatCoordinates,offset,end,stride,extent){return!!(intersectsLineString(flatCoordinates,offset,end,stride,extent)||linearRingContainsXY(flatCoordinates,offset,end,stride,extent[0],extent[1])||linearRingContainsXY(flatCoordinates,offset,end,stride,extent[0],extent[3])||linearRingContainsXY(flatCoordinates,offset,end,stride,extent[2],extent[1])||linearRingContainsXY(flatCoordinates,offset,end,stride,extent[2],extent[3]))}function intersectsLinearRingArray(flatCoordinates,offset,ends,stride,extent){if(!intersectsLinearRing(flatCoordinates,offset,ends[0],stride,extent))return!1;if(ends.length===1)return!0;for(let i2=1,ii=ends.length;i2<ii;++i2)if(linearRingContainsExtent(flatCoordinates,ends[i2-1],ends[i2],stride,extent)&&!intersectsLineString(flatCoordinates,ends[i2-1],ends[i2],stride,extent))return!1;return!0}function coordinates(flatCoordinates,offset,end,stride){for(;offset<end-stride;){for(let i2=0;i2<stride;++i2){const tmp=flatCoordinates[offset+i2];flatCoordinates[offset+i2]=flatCoordinates[end-stride+i2],flatCoordinates[end-stride+i2]=tmp}offset+=stride,end-=stride}}function linearRingIsClockwise(flatCoordinates,offset,end,stride){let edge=0,x1=flatCoordinates[end-stride],y1=flatCoordinates[end-stride+1];for(;offset<end;offset+=stride){const x2=flatCoordinates[offset],y2=flatCoordinates[offset+1];edge+=(x2-x1)*(y2+y1),x1=x2,y1=y2}return edge===0?void 0:edge>0}function linearRingsAreOriented(flatCoordinates,offset,ends,stride,right){right=right!==void 0?right:!1;for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2],isClockwise=linearRingIsClockwise(flatCoordinates,offset,end,stride);if(i2===0){if(right&&isClockwise||!right&&!isClockwise)return!1}else if(right&&!isClockwise||!right&&isClockwise)return!1;offset=end}return!0}function orientLinearRings(flatCoordinates,offset,ends,stride,right){right=right!==void 0?right:!1;for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2],isClockwise=linearRingIsClockwise(flatCoordinates,offset,end,stride);(i2===0?right&&isClockwise||!right&&!isClockwise:right&&!isClockwise||!right&&isClockwise)&&coordinates(flatCoordinates,offset,end,stride),offset=end}return offset}class Polygon extends SimpleGeometry{constructor(coordinates2,layout,ends){super(),this.ends_=[],this.flatInteriorPointRevision_=-1,this.flatInteriorPoint_=null,this.maxDelta_=-1,this.maxDeltaRevision_=-1,this.orientedRevision_=-1,this.orientedFlatCoordinates_=null,layout!==void 0&&ends?(this.setFlatCoordinates(layout,coordinates2),this.ends_=ends):this.setCoordinates(coordinates2,layout)}appendLinearRing(linearRing2){this.flatCoordinates?extend$3(this.flatCoordinates,linearRing2.getFlatCoordinates()):this.flatCoordinates=linearRing2.getFlatCoordinates().slice(),this.ends_.push(this.flatCoordinates.length),this.changed()}clone(){const polygon=new Polygon(this.flatCoordinates.slice(),this.layout,this.ends_.slice());return polygon.applyProperties(this),polygon}closestPointXY(x,y,closestPoint,minSquaredDistance){return minSquaredDistance<closestSquaredDistanceXY(this.getExtent(),x,y)?minSquaredDistance:(this.maxDeltaRevision_!=this.getRevision()&&(this.maxDelta_=Math.sqrt(arrayMaxSquaredDelta(this.flatCoordinates,0,this.ends_,this.stride,0)),this.maxDeltaRevision_=this.getRevision()),assignClosestArrayPoint(this.flatCoordinates,0,this.ends_,this.stride,this.maxDelta_,!0,x,y,closestPoint,minSquaredDistance))}containsXY(x,y){return linearRingsContainsXY(this.getOrientedFlatCoordinates(),0,this.ends_,this.stride,x,y)}getArea(){return linearRings(this.getOrientedFlatCoordinates(),0,this.ends_,this.stride)}getCoordinates(right){let flatCoordinates;return right!==void 0?(flatCoordinates=this.getOrientedFlatCoordinates().slice(),orientLinearRings(flatCoordinates,0,this.ends_,this.stride,right)):flatCoordinates=this.flatCoordinates,inflateCoordinatesArray(flatCoordinates,0,this.ends_,this.stride)}getEnds(){return this.ends_}getFlatInteriorPoint(){if(this.flatInteriorPointRevision_!=this.getRevision()){const flatCenter=getCenter(this.getExtent());this.flatInteriorPoint_=getInteriorPointOfArray(this.getOrientedFlatCoordinates(),0,this.ends_,this.stride,flatCenter,0),this.flatInteriorPointRevision_=this.getRevision()}return this.flatInteriorPoint_}getInteriorPoint(){return new Point(this.getFlatInteriorPoint(),"XYM")}getLinearRingCount(){return this.ends_.length}getLinearRing(index){return index<0||this.ends_.length<=index?null:new LinearRing(this.flatCoordinates.slice(index===0?0:this.ends_[index-1],this.ends_[index]),this.layout)}getLinearRings(){const layout=this.layout,flatCoordinates=this.flatCoordinates,ends=this.ends_,linearRings2=[];let offset=0;for(let i2=0,ii=ends.length;i2<ii;++i2){const end=ends[i2],linearRing2=new LinearRing(flatCoordinates.slice(offset,end),layout);linearRings2.push(linearRing2),offset=end}return linearRings2}getOrientedFlatCoordinates(){if(this.orientedRevision_!=this.getRevision()){const flatCoordinates=this.flatCoordinates;linearRingsAreOriented(flatCoordinates,0,this.ends_,this.stride)?this.orientedFlatCoordinates_=flatCoordinates:(this.orientedFlatCoordinates_=flatCoordinates.slice(),this.orientedFlatCoordinates_.length=orientLinearRings(this.orientedFlatCoordinates_,0,this.ends_,this.stride)),this.orientedRevision_=this.getRevision()}return this.orientedFlatCoordinates_}getSimplifiedGeometryInternal(squaredTolerance){const simplifiedFlatCoordinates=[],simplifiedEnds=[];return simplifiedFlatCoordinates.length=quantizeArray(this.flatCoordinates,0,this.ends_,this.stride,Math.sqrt(squaredTolerance),simplifiedFlatCoordinates,0,simplifiedEnds),new Polygon(simplifiedFlatCoordinates,"XY",simplifiedEnds)}getType(){return"Polygon"}intersectsExtent(extent){return intersectsLinearRingArray(this.getOrientedFlatCoordinates(),0,this.ends_,this.stride,extent)}setCoordinates(coordinates2,layout){this.setLayout(layout,coordinates2,2),this.flatCoordinates||(this.flatCoordinates=[]);const ends=deflateCoordinatesArray(this.flatCoordinates,0,coordinates2,this.stride,this.ends_);this.flatCoordinates.length=ends.length===0?0:ends[ends.length-1],this.changed()}}function fromExtent(extent){if(isEmpty(extent))throw new Error("Cannot create polygon from empty extent");const minX=extent[0],minY=extent[1],maxX=extent[2],maxY=extent[3],flatCoordinates=[minX,minY,minX,maxY,maxX,maxY,maxX,minY,minX,minY];return new Polygon(flatCoordinates,"XY",[flatCoordinates.length])}function getViewportClampedResolution(resolution,maxExtent,viewportSize2,showFullExtent){const xResolution=getWidth(maxExtent)/viewportSize2[0],yResolution=getHeight(maxExtent)/viewportSize2[1];return showFullExtent?Math.min(resolution,Math.max(xResolution,yResolution)):Math.min(resolution,Math.min(xResolution,yResolution))}function getSmoothClampedResolution(resolution,maxResolution,minResolution){let result=Math.min(resolution,maxResolution);const ratio=50;return result*=Math.log(1+ratio*Math.max(0,resolution/maxResolution-1))/ratio+1,minResolution&&(result=Math.max(result,minResolution),result/=Math.log(1+ratio*Math.max(0,minResolution/resolution-1))/ratio+1),clamp$2(result,minResolution/2,maxResolution*2)}function createSnapToResolutions(resolutions,smooth,maxExtent,showFullExtent){return smooth=smooth!==void 0?smooth:!0,function(resolution,direction,size,isMoving){if(resolution!==void 0){const maxResolution=resolutions[0],minResolution=resolutions[resolutions.length-1],cappedMaxRes=maxExtent?getViewportClampedResolution(maxResolution,maxExtent,size,showFullExtent):maxResolution;if(isMoving)return smooth?getSmoothClampedResolution(resolution,cappedMaxRes,minResolution):clamp$2(resolution,minResolution,cappedMaxRes);const capped=Math.min(cappedMaxRes,resolution),z=Math.floor(linearFindNearest(resolutions,capped,direction));return resolutions[z]>cappedMaxRes&&z<resolutions.length-1?resolutions[z+1]:resolutions[z]}}}function createSnapToPower(power,maxResolution,minResolution,smooth,maxExtent,showFullExtent){return smooth=smooth!==void 0?smooth:!0,minResolution=minResolution!==void 0?minResolution:0,function(resolution,direction,size,isMoving){if(resolution!==void 0){const cappedMaxRes=maxExtent?getViewportClampedResolution(maxResolution,maxExtent,size,showFullExtent):maxResolution;if(isMoving)return smooth?getSmoothClampedResolution(resolution,cappedMaxRes,minResolution):clamp$2(resolution,minResolution,cappedMaxRes);const tolerance=1e-9,minZoomLevel=Math.ceil(Math.log(maxResolution/cappedMaxRes)/Math.log(power)-tolerance),offset=-direction*(.5-tolerance)+.5,capped=Math.min(cappedMaxRes,resolution),cappedZoomLevel=Math.floor(Math.log(maxResolution/capped)/Math.log(power)+offset),zoomLevel=Math.max(minZoomLevel,cappedZoomLevel),newResolution=maxResolution/Math.pow(power,zoomLevel);return clamp$2(newResolution,minResolution,cappedMaxRes)}}}function createMinMaxResolution(maxResolution,minResolution,smooth,maxExtent,showFullExtent){return smooth=smooth!==void 0?smooth:!0,function(resolution,direction,size,isMoving){if(resolution!==void 0){const cappedMaxRes=maxExtent?getViewportClampedResolution(maxResolution,maxExtent,size,showFullExtent):maxResolution;return!smooth||!isMoving?clamp$2(resolution,minResolution,cappedMaxRes):getSmoothClampedResolution(resolution,cappedMaxRes,minResolution)}}}function disable(rotation2){if(rotation2!==void 0)return 0}function none$1(rotation2){if(rotation2!==void 0)return rotation2}function createSnapToN(n2){const theta=2*Math.PI/n2;return function(rotation2,isMoving){if(isMoving)return rotation2;if(rotation2!==void 0)return rotation2=Math.floor(rotation2/theta+.5)*theta,rotation2}}function createSnapToZero(tolerance){const t2=toRadians(5);return function(rotation2,isMoving){return isMoving||rotation2===void 0?rotation2:Math.abs(rotation2)<=t2?0:rotation2}}const DEFAULT_MAX_ZOOM=42,DEFAULT_TILE_SIZE=256,DEFAULT_MIN_ZOOM=0;class View extends BaseObject{constructor(options){super(),this.on,this.once,this.un,options=Object.assign({},options),this.hints_=[0,0],this.animations_=[],this.updateAnimationKey_,this.projection_=createProjection(options.projection,"EPSG:3857"),this.viewportSize_=[100,100],this.targetCenter_=null,this.targetResolution_,this.targetRotation_,this.nextCenter_=null,this.nextResolution_,this.nextRotation_,this.cancelAnchor_=void 0,options.projection&&disableCoordinateWarning(),options.center&&(options.center=fromUserCoordinate(options.center,this.projection_)),options.extent&&(options.extent=fromUserExtent(options.extent,this.projection_)),this.applyOptions_(options)}applyOptions_(options){const properties=Object.assign({},options);for(const key2 in ViewProperty)delete properties[key2];this.setProperties(properties,!0);const resolutionConstraintInfo=createResolutionConstraint(options);this.maxResolution_=resolutionConstraintInfo.maxResolution,this.minResolution_=resolutionConstraintInfo.minResolution,this.zoomFactor_=resolutionConstraintInfo.zoomFactor,this.resolutions_=options.resolutions,this.padding_=options.padding,this.minZoom_=resolutionConstraintInfo.minZoom;const centerConstraint=createCenterConstraint(options),resolutionConstraint=resolutionConstraintInfo.constraint,rotationConstraint=createRotationConstraint(options);this.constraints_={center:centerConstraint,resolution:resolutionConstraint,rotation:rotationConstraint},this.setRotation(options.rotation!==void 0?options.rotation:0),this.setCenterInternal(options.center!==void 0?options.center:null),options.resolution!==void 0?this.setResolution(options.resolution):options.zoom!==void 0&&this.setZoom(options.zoom)}get padding(){return this.padding_}set padding(padding){let oldPadding=this.padding_;this.padding_=padding;const center=this.getCenterInternal();if(center){const newPadding=padding||[0,0,0,0];oldPadding=oldPadding||[0,0,0,0];const resolution=this.getResolution(),offsetX=resolution/2*(newPadding[3]-oldPadding[3]+oldPadding[1]-newPadding[1]),offsetY=resolution/2*(newPadding[0]-oldPadding[0]+oldPadding[2]-newPadding[2]);this.setCenterInternal([center[0]+offsetX,center[1]-offsetY])}}getUpdatedOptions_(newOptions){const options=this.getProperties();return options.resolution!==void 0?options.resolution=this.getResolution():options.zoom=this.getZoom(),options.center=this.getCenterInternal(),options.rotation=this.getRotation(),Object.assign({},options,newOptions)}animate(var_args){this.isDef()&&!this.getAnimating()&&this.resolveConstraints(0);const args=new Array(arguments.length);for(let i2=0;i2<args.length;++i2){let options=arguments[i2];options.center&&(options=Object.assign({},options),options.center=fromUserCoordinate(options.center,this.getProjection())),options.anchor&&(options=Object.assign({},options),options.anchor=fromUserCoordinate(options.anchor,this.getProjection())),args[i2]=options}this.animateInternal.apply(this,args)}animateInternal(var_args){let animationCount=arguments.length,callback;animationCount>1&&typeof arguments[animationCount-1]=="function"&&(callback=arguments[animationCount-1],--animationCount);let i2=0;for(;i2<animationCount&&!this.isDef();++i2){const state=arguments[i2];state.center&&this.setCenterInternal(state.center),state.zoom!==void 0?this.setZoom(state.zoom):state.resolution&&this.setResolution(state.resolution),state.rotation!==void 0&&this.setRotation(state.rotation)}if(i2===animationCount){callback&&animationCallback(callback,!0);return}let start=Date.now(),center=this.targetCenter_.slice(),resolution=this.targetResolution_,rotation2=this.targetRotation_;const series=[];for(;i2<animationCount;++i2){const options=arguments[i2],animation={start,complete:!1,anchor:options.anchor,duration:options.duration!==void 0?options.duration:1e3,easing:options.easing||inAndOut,callback};if(options.center&&(animation.sourceCenter=center,animation.targetCenter=options.center.slice(),center=animation.targetCenter),options.zoom!==void 0?(animation.sourceResolution=resolution,animation.targetResolution=this.getResolutionForZoom(options.zoom),resolution=animation.targetResolution):options.resolution&&(animation.sourceResolution=resolution,animation.targetResolution=options.resolution,resolution=animation.targetResolution),options.rotation!==void 0){animation.sourceRotation=rotation2;const delta=modulo(options.rotation-rotation2+Math.PI,2*Math.PI)-Math.PI;animation.targetRotation=rotation2+delta,rotation2=animation.targetRotation}isNoopAnimation(animation)?animation.complete=!0:start+=animation.duration,series.push(animation)}this.animations_.push(series),this.setHint(ViewHint.ANIMATING,1),this.updateAnimations_()}getAnimating(){return this.hints_[ViewHint.ANIMATING]>0}getInteracting(){return this.hints_[ViewHint.INTERACTING]>0}cancelAnimations(){this.setHint(ViewHint.ANIMATING,-this.hints_[ViewHint.ANIMATING]);let anchor;for(let i2=0,ii=this.animations_.length;i2<ii;++i2){const series=this.animations_[i2];if(series[0].callback&&animationCallback(series[0].callback,!1),!anchor)for(let j=0,jj=series.length;j<jj;++j){const animation=series[j];if(!animation.complete){anchor=animation.anchor;break}}}this.animations_.length=0,this.cancelAnchor_=anchor,this.nextCenter_=null,this.nextResolution_=NaN,this.nextRotation_=NaN}updateAnimations_(){if(this.updateAnimationKey_!==void 0&&(cancelAnimationFrame(this.updateAnimationKey_),this.updateAnimationKey_=void 0),!this.getAnimating())return;const now2=Date.now();let more=!1;for(let i2=this.animations_.length-1;i2>=0;--i2){const series=this.animations_[i2];let seriesComplete=!0;for(let j=0,jj=series.length;j<jj;++j){const animation=series[j];if(animation.complete)continue;const elapsed=now2-animation.start;let fraction=animation.duration>0?elapsed/animation.duration:1;fraction>=1?(animation.complete=!0,fraction=1):seriesComplete=!1;const progress=animation.easing(fraction);if(animation.sourceCenter){const x0=animation.sourceCenter[0],y0=animation.sourceCenter[1],x1=animation.targetCenter[0],y1=animation.targetCenter[1];this.nextCenter_=animation.targetCenter;const x=x0+progress*(x1-x0),y=y0+progress*(y1-y0);this.targetCenter_=[x,y]}if(animation.sourceResolution&&animation.targetResolution){const resolution=progress===1?animation.targetResolution:animation.sourceResolution+progress*(animation.targetResolution-animation.sourceResolution);if(animation.anchor){const size=this.getViewportSize_(this.getRotation()),constrainedResolution=this.constraints_.resolution(resolution,0,size,!0);this.targetCenter_=this.calculateCenterZoom(constrainedResolution,animation.anchor)}this.nextResolution_=animation.targetResolution,this.targetResolution_=resolution,this.applyTargetState_(!0)}if(animation.sourceRotation!==void 0&&animation.targetRotation!==void 0){const rotation2=progress===1?modulo(animation.targetRotation+Math.PI,2*Math.PI)-Math.PI:animation.sourceRotation+progress*(animation.targetRotation-animation.sourceRotation);if(animation.anchor){const constrainedRotation=this.constraints_.rotation(rotation2,!0);this.targetCenter_=this.calculateCenterRotate(constrainedRotation,animation.anchor)}this.nextRotation_=animation.targetRotation,this.targetRotation_=rotation2}if(this.applyTargetState_(!0),more=!0,!animation.complete)break}if(seriesComplete){this.animations_[i2]=null,this.setHint(ViewHint.ANIMATING,-1),this.nextCenter_=null,this.nextResolution_=NaN,this.nextRotation_=NaN;const callback=series[0].callback;callback&&animationCallback(callback,!0)}}this.animations_=this.animations_.filter(Boolean),more&&this.updateAnimationKey_===void 0&&(this.updateAnimationKey_=requestAnimationFrame(this.updateAnimations_.bind(this)))}calculateCenterRotate(rotation2,anchor){let center;const currentCenter=this.getCenterInternal();return currentCenter!==void 0&&(center=[currentCenter[0]-anchor[0],currentCenter[1]-anchor[1]],rotate$1(center,rotation2-this.getRotation()),add$2(center,anchor)),center}calculateCenterZoom(resolution,anchor){let center;const currentCenter=this.getCenterInternal(),currentResolution=this.getResolution();if(currentCenter!==void 0&&currentResolution!==void 0){const x=anchor[0]-resolution*(anchor[0]-currentCenter[0])/currentResolution,y=anchor[1]-resolution*(anchor[1]-currentCenter[1])/currentResolution;center=[x,y]}return center}getViewportSize_(rotation2){const size=this.viewportSize_;if(rotation2){const w=size[0],h=size[1];return[Math.abs(w*Math.cos(rotation2))+Math.abs(h*Math.sin(rotation2)),Math.abs(w*Math.sin(rotation2))+Math.abs(h*Math.cos(rotation2))]}return size}setViewportSize(size){this.viewportSize_=Array.isArray(size)?size.slice():[100,100],this.getAnimating()||this.resolveConstraints(0)}getCenter(){const center=this.getCenterInternal();return center&&toUserCoordinate(center,this.getProjection())}getCenterInternal(){return this.get(ViewProperty.CENTER)}getConstraints(){return this.constraints_}getConstrainResolution(){return this.get("constrainResolution")}getHints(hints){return hints!==void 0?(hints[0]=this.hints_[0],hints[1]=this.hints_[1],hints):this.hints_.slice()}calculateExtent(size){const extent=this.calculateExtentInternal(size);return toUserExtent(extent,this.getProjection())}calculateExtentInternal(size){size=size||this.getViewportSizeMinusPadding_();const center=this.getCenterInternal();assert(center,"The view center is not defined");const resolution=this.getResolution();assert(resolution!==void 0,"The view resolution is not defined");const rotation2=this.getRotation();return assert(rotation2!==void 0,"The view rotation is not defined"),getForViewAndSize(center,resolution,rotation2,size)}getMaxResolution(){return this.maxResolution_}getMinResolution(){return this.minResolution_}getMaxZoom(){return this.getZoomForResolution(this.minResolution_)}setMaxZoom(zoom){this.applyOptions_(this.getUpdatedOptions_({maxZoom:zoom}))}getMinZoom(){return this.getZoomForResolution(this.maxResolution_)}setMinZoom(zoom){this.applyOptions_(this.getUpdatedOptions_({minZoom:zoom}))}setConstrainResolution(enabled){this.applyOptions_(this.getUpdatedOptions_({constrainResolution:enabled}))}getProjection(){return this.projection_}getResolution(){return this.get(ViewProperty.RESOLUTION)}getResolutions(){return this.resolutions_}getResolutionForExtent(extent,size){return this.getResolutionForExtentInternal(fromUserExtent(extent,this.getProjection()),size)}getResolutionForExtentInternal(extent,size){size=size||this.getViewportSizeMinusPadding_();const xResolution=getWidth(extent)/size[0],yResolution=getHeight(extent)/size[1];return Math.max(xResolution,yResolution)}getResolutionForValueFunction(power){power=power||2;const maxResolution=this.getConstrainedResolution(this.maxResolution_),minResolution=this.minResolution_,max2=Math.log(maxResolution/minResolution)/Math.log(power);return function(value){return maxResolution/Math.pow(power,value*max2)}}getRotation(){return this.get(ViewProperty.ROTATION)}getValueForResolutionFunction(power){const logPower=Math.log(power||2),maxResolution=this.getConstrainedResolution(this.maxResolution_),minResolution=this.minResolution_,max2=Math.log(maxResolution/minResolution)/logPower;return function(resolution){return Math.log(maxResolution/resolution)/logPower/max2}}getViewportSizeMinusPadding_(rotation2){let size=this.getViewportSize_(rotation2);const padding=this.padding_;return padding&&(size=[size[0]-padding[1]-padding[3],size[1]-padding[0]-padding[2]]),size}getState(){const projection=this.getProjection(),resolution=this.getResolution(),rotation2=this.getRotation();let center=this.getCenterInternal();const padding=this.padding_;if(padding){const reducedSize=this.getViewportSizeMinusPadding_();center=calculateCenterOn(center,this.getViewportSize_(),[reducedSize[0]/2+padding[3],reducedSize[1]/2+padding[0]],resolution,rotation2)}return{center:center.slice(0),projection:projection!==void 0?projection:null,resolution,nextCenter:this.nextCenter_,nextResolution:this.nextResolution_,nextRotation:this.nextRotation_,rotation:rotation2,zoom:this.getZoom()}}getViewStateAndExtent(){return{viewState:this.getState(),extent:this.calculateExtent()}}getZoom(){let zoom;const resolution=this.getResolution();return resolution!==void 0&&(zoom=this.getZoomForResolution(resolution)),zoom}getZoomForResolution(resolution){let offset=this.minZoom_||0,max2,zoomFactor;if(this.resolutions_){const nearest=linearFindNearest(this.resolutions_,resolution,1);offset=nearest,max2=this.resolutions_[nearest],nearest==this.resolutions_.length-1?zoomFactor=2:zoomFactor=max2/this.resolutions_[nearest+1]}else max2=this.maxResolution_,zoomFactor=this.zoomFactor_;return offset+Math.log(max2/resolution)/Math.log(zoomFactor)}getResolutionForZoom(zoom){if(this.resolutions_?.length){if(this.resolutions_.length===1)return this.resolutions_[0];const baseLevel=clamp$2(Math.floor(zoom),0,this.resolutions_.length-2),zoomFactor=this.resolutions_[baseLevel]/this.resolutions_[baseLevel+1];return this.resolutions_[baseLevel]/Math.pow(zoomFactor,clamp$2(zoom-baseLevel,0,1))}return this.maxResolution_/Math.pow(this.zoomFactor_,zoom-this.minZoom_)}fit(geometryOrExtent,options){let geometry2;if(assert(Array.isArray(geometryOrExtent)||typeof geometryOrExtent.getSimplifiedGeometry=="function","Invalid extent or geometry provided as `geometry`"),Array.isArray(geometryOrExtent)){assert(!isEmpty(geometryOrExtent),"Cannot fit empty extent provided as `geometry`");const extent=fromUserExtent(geometryOrExtent,this.getProjection());geometry2=fromExtent(extent)}else if(geometryOrExtent.getType()==="Circle"){const extent=fromUserExtent(geometryOrExtent.getExtent(),this.getProjection());geometry2=fromExtent(extent),geometry2.rotate(this.getRotation(),getCenter(extent))}else{const userProjection2=getUserProjection();userProjection2?geometry2=geometryOrExtent.clone().transform(userProjection2,this.getProjection()):geometry2=geometryOrExtent}this.fitInternal(geometry2,options)}rotatedExtentForGeometry(geometry2){const rotation2=this.getRotation(),cosAngle=Math.cos(rotation2),sinAngle=Math.sin(-rotation2),coords=geometry2.getFlatCoordinates(),stride=geometry2.getStride();let minRotX=1/0,minRotY=1/0,maxRotX=-1/0,maxRotY=-1/0;for(let i2=0,ii=coords.length;i2<ii;i2+=stride){const rotX=coords[i2]*cosAngle-coords[i2+1]*sinAngle,rotY=coords[i2]*sinAngle+coords[i2+1]*cosAngle;minRotX=Math.min(minRotX,rotX),minRotY=Math.min(minRotY,rotY),maxRotX=Math.max(maxRotX,rotX),maxRotY=Math.max(maxRotY,rotY)}return[minRotX,minRotY,maxRotX,maxRotY]}fitInternal(geometry2,options){options=options||{};let size=options.size;size||(size=this.getViewportSizeMinusPadding_());const padding=options.padding!==void 0?options.padding:[0,0,0,0],nearest=options.nearest!==void 0?options.nearest:!1;let minResolution;options.minResolution!==void 0?minResolution=options.minResolution:options.maxZoom!==void 0?minResolution=this.getResolutionForZoom(options.maxZoom):minResolution=0;const rotatedExtent=this.rotatedExtentForGeometry(geometry2);let resolution=this.getResolutionForExtentInternal(rotatedExtent,[size[0]-padding[1]-padding[3],size[1]-padding[0]-padding[2]]);resolution=isNaN(resolution)?minResolution:Math.max(resolution,minResolution),resolution=this.getConstrainedResolution(resolution,nearest?0:1);const rotation2=this.getRotation(),sinAngle=Math.sin(rotation2),cosAngle=Math.cos(rotation2),centerRot=getCenter(rotatedExtent);centerRot[0]+=(padding[1]-padding[3])/2*resolution,centerRot[1]+=(padding[0]-padding[2])/2*resolution;const centerX=centerRot[0]*cosAngle-centerRot[1]*sinAngle,centerY=centerRot[1]*cosAngle+centerRot[0]*sinAngle,center=this.getConstrainedCenter([centerX,centerY],resolution),callback=options.callback?options.callback:VOID;options.duration!==void 0?this.animateInternal({resolution,center,duration:options.duration,easing:options.easing},callback):(this.targetResolution_=resolution,this.targetCenter_=center,this.applyTargetState_(!1,!0),animationCallback(callback,!0))}centerOn(coordinate,size,position){this.centerOnInternal(fromUserCoordinate(coordinate,this.getProjection()),size,position)}centerOnInternal(coordinate,size,position){this.setCenterInternal(calculateCenterOn(coordinate,size,position,this.getResolution(),this.getRotation()))}calculateCenterShift(center,resolution,rotation2,size){let centerShift;const padding=this.padding_;if(padding&&center){const reducedSize=this.getViewportSizeMinusPadding_(-rotation2),shiftedCenter=calculateCenterOn(center,size,[reducedSize[0]/2+padding[3],reducedSize[1]/2+padding[0]],resolution,rotation2);centerShift=[center[0]-shiftedCenter[0],center[1]-shiftedCenter[1]]}return centerShift}isDef(){return!!this.getCenterInternal()&&this.getResolution()!==void 0}adjustCenter(deltaCoordinates){const center=toUserCoordinate(this.targetCenter_,this.getProjection());this.setCenter([center[0]+deltaCoordinates[0],center[1]+deltaCoordinates[1]])}adjustCenterInternal(deltaCoordinates){const center=this.targetCenter_;this.setCenterInternal([center[0]+deltaCoordinates[0],center[1]+deltaCoordinates[1]])}adjustResolution(ratio,anchor){anchor=anchor&&fromUserCoordinate(anchor,this.getProjection()),this.adjustResolutionInternal(ratio,anchor)}adjustResolutionInternal(ratio,anchor){const isMoving=this.getAnimating()||this.getInteracting(),size=this.getViewportSize_(this.getRotation()),newResolution=this.constraints_.resolution(this.targetResolution_*ratio,0,size,isMoving);anchor&&(this.targetCenter_=this.calculateCenterZoom(newResolution,anchor)),this.targetResolution_*=ratio,this.applyTargetState_()}adjustZoom(delta,anchor){this.adjustResolution(Math.pow(this.zoomFactor_,-delta),anchor)}adjustRotation(delta,anchor){anchor&&(anchor=fromUserCoordinate(anchor,this.getProjection())),this.adjustRotationInternal(delta,anchor)}adjustRotationInternal(delta,anchor){const isMoving=this.getAnimating()||this.getInteracting(),newRotation=this.constraints_.rotation(this.targetRotation_+delta,isMoving);anchor&&(this.targetCenter_=this.calculateCenterRotate(newRotation,anchor)),this.targetRotation_+=delta,this.applyTargetState_()}setCenter(center){this.setCenterInternal(center&&fromUserCoordinate(center,this.getProjection()))}setCenterInternal(center){this.targetCenter_=center,this.applyTargetState_()}setHint(hint,delta){return this.hints_[hint]+=delta,this.changed(),this.hints_[hint]}setResolution(resolution){this.targetResolution_=resolution,this.applyTargetState_()}setRotation(rotation2){this.targetRotation_=rotation2,this.applyTargetState_()}setZoom(zoom){this.setResolution(this.getResolutionForZoom(zoom))}applyTargetState_(doNotCancelAnims,forceMoving){const isMoving=this.getAnimating()||this.getInteracting()||forceMoving,newRotation=this.constraints_.rotation(this.targetRotation_,isMoving),size=this.getViewportSize_(newRotation),newResolution=this.constraints_.resolution(this.targetResolution_,0,size,isMoving),newCenter=this.constraints_.center(this.targetCenter_,newResolution,size,isMoving,this.calculateCenterShift(this.targetCenter_,newResolution,newRotation,size));this.get(ViewProperty.ROTATION)!==newRotation&&this.set(ViewProperty.ROTATION,newRotation),this.get(ViewProperty.RESOLUTION)!==newResolution&&(this.set(ViewProperty.RESOLUTION,newResolution),this.set("zoom",this.getZoom(),!0)),(!newCenter||!this.get(ViewProperty.CENTER)||!equals(this.get(ViewProperty.CENTER),newCenter))&&this.set(ViewProperty.CENTER,newCenter),this.getAnimating()&&!doNotCancelAnims&&this.cancelAnimations(),this.cancelAnchor_=void 0}resolveConstraints(duration,resolutionDirection,anchor){duration=duration!==void 0?duration:200;const direction=resolutionDirection||0,newRotation=this.constraints_.rotation(this.targetRotation_),size=this.getViewportSize_(newRotation),newResolution=this.constraints_.resolution(this.targetResolution_,direction,size),newCenter=this.constraints_.center(this.targetCenter_,newResolution,size,!1,this.calculateCenterShift(this.targetCenter_,newResolution,newRotation,size));if(duration===0&&!this.cancelAnchor_){this.targetResolution_=newResolution,this.targetRotation_=newRotation,this.targetCenter_=newCenter,this.applyTargetState_();return}anchor=anchor||(duration===0?this.cancelAnchor_:void 0),this.cancelAnchor_=void 0,(this.getResolution()!==newResolution||this.getRotation()!==newRotation||!this.getCenterInternal()||!equals(this.getCenterInternal(),newCenter))&&(this.getAnimating()&&this.cancelAnimations(),this.animateInternal({rotation:newRotation,center:newCenter,resolution:newResolution,duration,easing:easeOut,anchor}))}beginInteraction(){this.resolveConstraints(0),this.setHint(ViewHint.INTERACTING,1)}endInteraction(duration,resolutionDirection,anchor){anchor=anchor&&fromUserCoordinate(anchor,this.getProjection()),this.endInteractionInternal(duration,resolutionDirection,anchor)}endInteractionInternal(duration,resolutionDirection,anchor){this.getInteracting()&&(this.setHint(ViewHint.INTERACTING,-1),this.resolveConstraints(duration,resolutionDirection,anchor))}getConstrainedCenter(targetCenter,targetResolution){const size=this.getViewportSize_(this.getRotation());return this.constraints_.center(targetCenter,targetResolution||this.getResolution(),size)}getConstrainedZoom(targetZoom,direction){const targetRes=this.getResolutionForZoom(targetZoom);return this.getZoomForResolution(this.getConstrainedResolution(targetRes,direction))}getConstrainedResolution(targetResolution,direction){direction=direction||0;const size=this.getViewportSize_(this.getRotation());return this.constraints_.resolution(targetResolution,direction,size)}}function animationCallback(callback,returnValue){setTimeout(function(){callback(returnValue)},0)}function createCenterConstraint(options){if(options.extent!==void 0){const smooth=options.smoothExtentConstraint!==void 0?options.smoothExtentConstraint:!0;return createExtent(options.extent,options.constrainOnlyCenter,smooth)}const projection=createProjection(options.projection,"EPSG:3857");if(options.multiWorld!==!0&&projection.isGlobal()){const extent=projection.getExtent().slice();return extent[0]=-1/0,extent[2]=1/0,createExtent(extent,!1,!1)}return none$2}function createResolutionConstraint(options){let resolutionConstraint,maxResolution,minResolution,minZoom=options.minZoom!==void 0?options.minZoom:DEFAULT_MIN_ZOOM,maxZoom=options.maxZoom!==void 0?options.maxZoom:28;const zoomFactor=options.zoomFactor!==void 0?options.zoomFactor:2,multiWorld=options.multiWorld!==void 0?options.multiWorld:!1,smooth=options.smoothResolutionConstraint!==void 0?options.smoothResolutionConstraint:!0,showFullExtent=options.showFullExtent!==void 0?options.showFullExtent:!1,projection=createProjection(options.projection,"EPSG:3857"),projExtent=projection.getExtent();let constrainOnlyCenter=options.constrainOnlyCenter,extent=options.extent;if(!multiWorld&&!extent&&projection.isGlobal()&&(constrainOnlyCenter=!1,extent=projExtent),options.resolutions!==void 0){const resolutions=options.resolutions;maxResolution=resolutions[minZoom],minResolution=resolutions[maxZoom]!==void 0?resolutions[maxZoom]:resolutions[resolutions.length-1],options.constrainResolution?resolutionConstraint=createSnapToResolutions(resolutions,smooth,!constrainOnlyCenter&&extent,showFullExtent):resolutionConstraint=createMinMaxResolution(maxResolution,minResolution,smooth,!constrainOnlyCenter&&extent,showFullExtent)}else{const defaultMaxResolution=(projExtent?Math.max(getWidth(projExtent),getHeight(projExtent)):360*METERS_PER_UNIT$1.degrees/projection.getMetersPerUnit())/DEFAULT_TILE_SIZE/Math.pow(2,DEFAULT_MIN_ZOOM),defaultMinResolution=defaultMaxResolution/Math.pow(2,28-DEFAULT_MIN_ZOOM);maxResolution=options.maxResolution,maxResolution!==void 0?minZoom=0:maxResolution=defaultMaxResolution/Math.pow(zoomFactor,minZoom),minResolution=options.minResolution,minResolution===void 0&&(options.maxZoom!==void 0?options.maxResolution!==void 0?minResolution=maxResolution/Math.pow(zoomFactor,maxZoom):minResolution=defaultMaxResolution/Math.pow(zoomFactor,maxZoom):minResolution=defaultMinResolution),maxZoom=minZoom+Math.floor(Math.log(maxResolution/minResolution)/Math.log(zoomFactor)),minResolution=maxResolution/Math.pow(zoomFactor,maxZoom-minZoom),options.constrainResolution?resolutionConstraint=createSnapToPower(zoomFactor,maxResolution,minResolution,smooth,!constrainOnlyCenter&&extent,showFullExtent):resolutionConstraint=createMinMaxResolution(maxResolution,minResolution,smooth,!constrainOnlyCenter&&extent,showFullExtent)}return{constraint:resolutionConstraint,maxResolution,minResolution,minZoom,zoomFactor}}function createRotationConstraint(options){if(options.enableRotation!==void 0?options.enableRotation:!0){const constrainRotation=options.constrainRotation;return constrainRotation===void 0||constrainRotation===!0?createSnapToZero():constrainRotation===!1?none$1:typeof constrainRotation=="number"?createSnapToN(constrainRotation):none$1}return disable}function isNoopAnimation(animation){return!(animation.sourceCenter&&animation.targetCenter&&!equals(animation.sourceCenter,animation.targetCenter)||animation.sourceResolution!==animation.targetResolution||animation.sourceRotation!==animation.targetRotation)}function calculateCenterOn(coordinate,size,position,resolution,rotation2){const cosAngle=Math.cos(-rotation2);let sinAngle=Math.sin(-rotation2),rotX=coordinate[0]*cosAngle-coordinate[1]*sinAngle,rotY=coordinate[1]*cosAngle+coordinate[0]*sinAngle;rotX+=(size[0]/2-position[0])*resolution,rotY+=(position[1]-size[1]/2)*resolution,sinAngle=-sinAngle;const centerX=rotX*cosAngle-rotY*sinAngle,centerY=rotY*cosAngle+rotX*sinAngle;return[centerX,centerY]}const CLASS_HIDDEN="ol-hidden",CLASS_UNSELECTABLE="ol-unselectable",CLASS_CONTROL="ol-control",CLASS_COLLAPSED="ol-collapsed";function createCanvasContext2D(width,height,canvasPool2,settings){let canvas;return canvasPool2&&canvasPool2.length?canvas=canvasPool2.shift():WORKER_OFFSCREEN_CANVAS?canvas=new OffscreenCanvas(width||300,height||300):canvas=document.createElement("canvas"),width&&(canvas.width=width),height&&(canvas.height=height),canvas.getContext("2d",settings)}let sharedCanvasContext;function getSharedCanvasContext2D(){return sharedCanvasContext||(sharedCanvasContext=createCanvasContext2D(1,1)),sharedCanvasContext}function releaseCanvas(context2){const canvas=context2.canvas;canvas.width=1,canvas.height=1,context2.clearRect(0,0,1,1)}function replaceNode(newNode,oldNode){const parent=oldNode.parentNode;parent&&parent.replaceChild(newNode,oldNode)}function removeChildren(node){for(;node.lastChild;)node.lastChild.remove()}function replaceChildren(node,children){const oldChildren=node.childNodes;for(let i2=0;;++i2){const oldChild=oldChildren[i2],newChild=children[i2];if(!oldChild&&!newChild)break;if(oldChild!==newChild){if(!oldChild){node.appendChild(newChild);continue}if(!newChild){node.removeChild(oldChild),--i2;continue}node.insertBefore(newChild,oldChild)}}}class Control extends BaseObject{constructor(options){super();const element2=options.element;element2&&!options.target&&!element2.style.pointerEvents&&(element2.style.pointerEvents="auto"),this.element=element2||null,this.target_=null,this.map_=null,this.listenerKeys=[],options.render&&(this.render=options.render),options.target&&this.setTarget(options.target)}disposeInternal(){this.element?.remove(),super.disposeInternal()}getMap(){return this.map_}setMap(map){this.map_&&this.element?.remove();for(let i2=0,ii=this.listenerKeys.length;i2<ii;++i2)unlistenByKey(this.listenerKeys[i2]);if(this.listenerKeys.length=0,this.map_=map,map){const target=this.target_??map.getOverlayContainerStopEvent();this.element&&target.appendChild(this.element),this.render!==VOID&&this.listenerKeys.push(listen(map,MapEventType.POSTRENDER,this.render,this)),map.render()}}render(mapEvent){}setTarget(target){this.target_=typeof target=="string"?document.getElementById(target):target}}class Attribution extends Control{constructor(options){options=options||{},super({element:document.createElement("div"),render:options.render,target:options.target}),this.ulElement_=document.createElement("ul"),this.collapsed_=options.collapsed!==void 0?options.collapsed:!0,this.userCollapsed_=this.collapsed_,this.overrideCollapsible_=options.collapsible!==void 0,this.collapsible_=options.collapsible!==void 0?options.collapsible:!0,this.collapsible_||(this.collapsed_=!1),this.attributions_=options.attributions;const className=options.className!==void 0?options.className:"ol-attribution",tipLabel=options.tipLabel!==void 0?options.tipLabel:"Attributions",expandClassName=options.expandClassName!==void 0?options.expandClassName:className+"-expand",collapseLabel=options.collapseLabel!==void 0?options.collapseLabel:"›",collapseClassName=options.collapseClassName!==void 0?options.collapseClassName:className+"-collapse";typeof collapseLabel=="string"?(this.collapseLabel_=document.createElement("span"),this.collapseLabel_.textContent=collapseLabel,this.collapseLabel_.className=collapseClassName):this.collapseLabel_=collapseLabel;const label2=options.label!==void 0?options.label:"i";typeof label2=="string"?(this.label_=document.createElement("span"),this.label_.textContent=label2,this.label_.className=expandClassName):this.label_=label2;const activeLabel=this.collapsible_&&!this.collapsed_?this.collapseLabel_:this.label_;this.toggleButton_=document.createElement("button"),this.toggleButton_.setAttribute("type","button"),this.toggleButton_.setAttribute("aria-expanded",String(!this.collapsed_)),this.toggleButton_.title=tipLabel,this.toggleButton_.appendChild(activeLabel),this.toggleButton_.addEventListener(EventType.CLICK,this.handleClick_.bind(this),!1);const cssClasses=className+" "+CLASS_UNSELECTABLE+" "+CLASS_CONTROL+(this.collapsed_&&this.collapsible_?" "+CLASS_COLLAPSED:"")+(this.collapsible_?"":" ol-uncollapsible"),element2=this.element;element2.className=cssClasses,element2.appendChild(this.toggleButton_),element2.appendChild(this.ulElement_),this.renderedAttributions_=[],this.renderedVisible_=!0}collectSourceAttributions_(frameState2){const layers2=this.getMap().getAllLayers(),visibleAttributions=new Set(layers2.flatMap(layer=>layer.getAttributions(frameState2)));if(this.attributions_!==void 0&&(Array.isArray(this.attributions_)?this.attributions_.forEach(item=>visibleAttributions.add(item)):visibleAttributions.add(this.attributions_)),!this.overrideCollapsible_){const collapsible=!layers2.some(layer=>layer.getSource()?.getAttributionsCollapsible()===!1);this.setCollapsible(collapsible)}return Array.from(visibleAttributions)}async updateElement_(frameState2){if(!frameState2){this.renderedVisible_&&(this.element.style.display="none",this.renderedVisible_=!1);return}const attributions=await Promise.all(this.collectSourceAttributions_(frameState2).map(attribution=>toPromise(()=>attribution))),visible=attributions.length>0;if(this.renderedVisible_!=visible&&(this.element.style.display=visible?"":"none",this.renderedVisible_=visible),!equals$2(attributions,this.renderedAttributions_)){removeChildren(this.ulElement_);for(let i2=0,ii=attributions.length;i2<ii;++i2){const element2=document.createElement("li");element2.innerHTML=attributions[i2],this.ulElement_.appendChild(element2)}this.renderedAttributions_=attributions}}handleClick_(event){event.preventDefault(),this.handleToggle_(),this.userCollapsed_=this.collapsed_}handleToggle_(){this.element.classList.toggle(CLASS_COLLAPSED),this.collapsed_?replaceNode(this.collapseLabel_,this.label_):replaceNode(this.label_,this.collapseLabel_),this.collapsed_=!this.collapsed_,this.toggleButton_.setAttribute("aria-expanded",String(!this.collapsed_))}getCollapsible(){return this.collapsible_}setCollapsible(collapsible){this.collapsible_!==collapsible&&(this.collapsible_=collapsible,this.element.classList.toggle("ol-uncollapsible"),this.userCollapsed_&&this.handleToggle_())}setCollapsed(collapsed){this.userCollapsed_=collapsed,!(!this.collapsible_||this.collapsed_===collapsed)&&this.handleToggle_()}getCollapsed(){return this.collapsed_}render(mapEvent){this.updateElement_(mapEvent.frameState)}}class Rotate extends Control{constructor(options){options=options||{},super({element:document.createElement("div"),render:options.render,target:options.target});const className=options.className!==void 0?options.className:"ol-rotate",label2=options.label!==void 0?options.label:"⇧",compassClassName=options.compassClassName!==void 0?options.compassClassName:"ol-compass";this.label_=null,typeof label2=="string"?(this.label_=document.createElement("span"),this.label_.className=compassClassName,this.label_.textContent=label2):(this.label_=label2,this.label_.classList.add(compassClassName));const tipLabel=options.tipLabel?options.tipLabel:"Reset rotation",button=document.createElement("button");button.className=className+"-reset",button.setAttribute("type","button"),button.title=tipLabel,button.appendChild(this.label_),button.addEventListener(EventType.CLICK,this.handleClick_.bind(this),!1);const cssClasses=className+" "+CLASS_UNSELECTABLE+" "+CLASS_CONTROL,element2=this.element;element2.className=cssClasses,element2.appendChild(button),this.callResetNorth_=options.resetNorth?options.resetNorth:void 0,this.duration_=options.duration!==void 0?options.duration:250,this.autoHide_=options.autoHide!==void 0?options.autoHide:!0,this.rotation_=void 0,this.autoHide_&&this.element.classList.add(CLASS_HIDDEN)}handleClick_(event){event.preventDefault(),this.callResetNorth_!==void 0?this.callResetNorth_():this.resetNorth_()}resetNorth_(){const view=this.getMap().getView();if(!view)return;const rotation2=view.getRotation();rotation2!==void 0&&(this.duration_>0&&rotation2%(2*Math.PI)!==0?view.animate({rotation:0,duration:this.duration_,easing:easeOut}):view.setRotation(0))}render(mapEvent){const frameState2=mapEvent.frameState;if(!frameState2)return;const rotation2=frameState2.viewState.rotation;if(rotation2!=this.rotation_){const transform2="rotate("+rotation2+"rad)";if(this.autoHide_){const contains2=this.element.classList.contains(CLASS_HIDDEN);!contains2&&rotation2===0?this.element.classList.add(CLASS_HIDDEN):contains2&&rotation2!==0&&this.element.classList.remove(CLASS_HIDDEN)}this.label_.style.transform=transform2}this.rotation_=rotation2}}class Zoom extends Control{constructor(options){options=options||{},super({element:document.createElement("div"),target:options.target});const className=options.className!==void 0?options.className:"ol-zoom",delta=options.delta!==void 0?options.delta:1,zoomInClassName=options.zoomInClassName!==void 0?options.zoomInClassName:className+"-in",zoomOutClassName=options.zoomOutClassName!==void 0?options.zoomOutClassName:className+"-out",zoomInLabel=options.zoomInLabel!==void 0?options.zoomInLabel:"+",zoomOutLabel=options.zoomOutLabel!==void 0?options.zoomOutLabel:"–",zoomInTipLabel=options.zoomInTipLabel!==void 0?options.zoomInTipLabel:"Zoom in",zoomOutTipLabel=options.zoomOutTipLabel!==void 0?options.zoomOutTipLabel:"Zoom out",inElement=document.createElement("button");inElement.className=zoomInClassName,inElement.setAttribute("type","button"),inElement.title=zoomInTipLabel,inElement.appendChild(typeof zoomInLabel=="string"?document.createTextNode(zoomInLabel):zoomInLabel),inElement.addEventListener(EventType.CLICK,this.handleClick_.bind(this,delta),!1);const outElement=document.createElement("button");outElement.className=zoomOutClassName,outElement.setAttribute("type","button"),outElement.title=zoomOutTipLabel,outElement.appendChild(typeof zoomOutLabel=="string"?document.createTextNode(zoomOutLabel):zoomOutLabel),outElement.addEventListener(EventType.CLICK,this.handleClick_.bind(this,-delta),!1);const cssClasses=className+" "+CLASS_UNSELECTABLE+" "+CLASS_CONTROL,element2=this.element;element2.className=cssClasses,element2.appendChild(inElement),element2.appendChild(outElement),this.duration_=options.duration!==void 0?options.duration:250}handleClick_(delta,event){event.preventDefault(),this.zoomByDelta_(delta)}zoomByDelta_(delta){const view=this.getMap().getView();if(!view)return;const currentZoom=view.getZoom();if(currentZoom!==void 0){const newZoom=view.getConstrainedZoom(currentZoom+delta);this.duration_>0?(view.getAnimating()&&view.cancelAnimations(),view.animate({zoom:newZoom,duration:this.duration_,easing:easeOut})):view.setZoom(newZoom)}}}function defaults$2(options){options=options||{};const controls=new Collection;return(options.zoom!==void 0?options.zoom:!0)&&controls.push(new Zoom(options.zoomOptions)),(options.rotate!==void 0?options.rotate:!0)&&controls.push(new Rotate(options.rotateOptions)),(options.attribution!==void 0?options.attribution:!0)&&controls.push(new Attribution(options.attributionOptions)),controls}class Kinetic{constructor(decay,minVelocity,delay){this.decay_=decay,this.minVelocity_=minVelocity,this.delay_=delay,this.points_=[],this.angle_=0,this.initialVelocity_=0}begin(){this.points_.length=0,this.angle_=0,this.initialVelocity_=0}update(x,y){this.points_.push(x,y,Date.now())}end(){if(this.points_.length<6)return!1;const delay=Date.now()-this.delay_,lastIndex=this.points_.length-3;if(this.points_[lastIndex+2]<delay)return!1;let firstIndex=lastIndex-3;for(;firstIndex>0&&this.points_[firstIndex+2]>delay;)firstIndex-=3;const duration=this.points_[lastIndex+2]-this.points_[firstIndex+2];if(duration<1e3/60)return!1;const dx=this.points_[lastIndex]-this.points_[firstIndex],dy=this.points_[lastIndex+1]-this.points_[firstIndex+1];return this.angle_=Math.atan2(dy,dx),this.initialVelocity_=Math.sqrt(dx*dx+dy*dy)/duration,this.initialVelocity_>this.minVelocity_}getDistance(){return(this.minVelocity_-this.initialVelocity_)/this.decay_}getAngle(){return this.angle_}}const InteractionProperty={ACTIVE:"active"};class Interaction extends BaseObject{constructor(options){super(),this.on,this.once,this.un,options&&options.handleEvent&&(this.handleEvent=options.handleEvent),this.map_=null,this.setActive(!0)}getActive(){return this.get(InteractionProperty.ACTIVE)}getMap(){return this.map_}handleEvent(mapBrowserEvent){return!0}setActive(active){this.set(InteractionProperty.ACTIVE,active)}setMap(map){this.map_=map}}function pan(view,delta,duration){const currentCenter=view.getCenterInternal();if(currentCenter){const center=[currentCenter[0]+delta[0],currentCenter[1]+delta[1]];view.animateInternal({duration:duration!==void 0?duration:250,easing:linear$1,center:view.getConstrainedCenter(center)})}}function zoomByDelta(view,delta,anchor,duration){const currentZoom=view.getZoom();if(currentZoom===void 0)return;const newZoom=view.getConstrainedZoom(currentZoom+delta),newResolution=view.getResolutionForZoom(newZoom);view.getAnimating()&&view.cancelAnimations(),view.animate({resolution:newResolution,anchor,duration:duration!==void 0?duration:250,easing:easeOut})}class DoubleClickZoom extends Interaction{constructor(options){super(),options=options||{},this.delta_=options.delta?options.delta:1,this.duration_=options.duration!==void 0?options.duration:250}handleEvent(mapBrowserEvent){let stopEvent=!1;if(mapBrowserEvent.type==MapBrowserEventType.DBLCLICK){const browserEvent=mapBrowserEvent.originalEvent,map=mapBrowserEvent.map,anchor=mapBrowserEvent.coordinate,delta=browserEvent.shiftKey?-this.delta_:this.delta_,view=map.getView();zoomByDelta(view,delta,anchor,this.duration_),browserEvent.preventDefault(),stopEvent=!0}return!stopEvent}}function all(var_args){const conditions=arguments;return function(event){let pass2=!0;for(let i2=0,ii=conditions.length;i2<ii&&(pass2=pass2&&conditions[i2](event),!!pass2);++i2);return pass2}}const altShiftKeysOnly=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent;return originalEvent.altKey&&!(originalEvent.metaKey||originalEvent.ctrlKey)&&originalEvent.shiftKey},focus=function(event){const targetElement=event.map.getTargetElement(),rootNode=targetElement.getRootNode(),activeElement=event.map.getOwnerDocument().activeElement;return rootNode instanceof ShadowRoot?rootNode.host.contains(activeElement):targetElement.contains(activeElement)},focusWithTabindex=function(event){const targetElement=event.map.getTargetElement(),rootNode=targetElement.getRootNode();return(rootNode instanceof ShadowRoot?rootNode.host:targetElement).hasAttribute("tabindex")?focus(event):!0},always$1=TRUE,mouseActionButton=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent;return originalEvent.button==0&&!(WEBKIT&&MAC&&originalEvent.ctrlKey)},noModifierKeys=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent;return!originalEvent.altKey&&!(originalEvent.metaKey||originalEvent.ctrlKey)&&!originalEvent.shiftKey},platformModifierKey=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent;return MAC?originalEvent.metaKey:originalEvent.ctrlKey},shiftKeyOnly=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent;return!originalEvent.altKey&&!(originalEvent.metaKey||originalEvent.ctrlKey)&&originalEvent.shiftKey},targetNotEditable=function(mapBrowserEvent){const originalEvent=mapBrowserEvent.originalEvent,tagName=originalEvent.target.tagName;return tagName!=="INPUT"&&tagName!=="SELECT"&&tagName!=="TEXTAREA"&&!originalEvent.target.isContentEditable},mouseOnly=function(mapBrowserEvent){const pointerEvent=mapBrowserEvent.originalEvent;return assert(pointerEvent!==void 0,"mapBrowserEvent must originate from a pointer event"),pointerEvent.pointerType=="mouse"},primaryAction=function(mapBrowserEvent){const pointerEvent=mapBrowserEvent.originalEvent;return assert(pointerEvent!==void 0,"mapBrowserEvent must originate from a pointer event"),pointerEvent.isPrimary&&pointerEvent.button===0};class PointerInteraction extends Interaction{constructor(options){options=options||{},super(options),options.handleDownEvent&&(this.handleDownEvent=options.handleDownEvent),options.handleDragEvent&&(this.handleDragEvent=options.handleDragEvent),options.handleMoveEvent&&(this.handleMoveEvent=options.handleMoveEvent),options.handleUpEvent&&(this.handleUpEvent=options.handleUpEvent),options.stopDown&&(this.stopDown=options.stopDown),this.handlingDownUpSequence=!1,this.targetPointers=[]}getPointerCount(){return this.targetPointers.length}handleDownEvent(mapBrowserEvent){return!1}handleDragEvent(mapBrowserEvent){}handleEvent(mapBrowserEvent){if(!mapBrowserEvent.originalEvent)return!0;let stopEvent=!1;if(this.updateTrackedPointers_(mapBrowserEvent),this.handlingDownUpSequence){if(mapBrowserEvent.type==MapBrowserEventType.POINTERDRAG)this.handleDragEvent(mapBrowserEvent),mapBrowserEvent.originalEvent.preventDefault();else if(mapBrowserEvent.type==MapBrowserEventType.POINTERUP){const handledUp=this.handleUpEvent(mapBrowserEvent);this.handlingDownUpSequence=handledUp&&this.targetPointers.length>0}}else if(mapBrowserEvent.type==MapBrowserEventType.POINTERDOWN){const handled=this.handleDownEvent(mapBrowserEvent);this.handlingDownUpSequence=handled,stopEvent=this.stopDown(handled)}else mapBrowserEvent.type==MapBrowserEventType.POINTERMOVE&&this.handleMoveEvent(mapBrowserEvent);return!stopEvent}handleMoveEvent(mapBrowserEvent){}handleUpEvent(mapBrowserEvent){return!1}stopDown(handled){return handled}updateTrackedPointers_(mapBrowserEvent){mapBrowserEvent.activePointers&&(this.targetPointers=mapBrowserEvent.activePointers)}}function centroid(pointerEvents){const length2=pointerEvents.length;let clientX=0,clientY=0;for(let i2=0;i2<length2;i2++)clientX+=pointerEvents[i2].clientX,clientY+=pointerEvents[i2].clientY;return{clientX:clientX/length2,clientY:clientY/length2}}class DragPan extends PointerInteraction{constructor(options){super({stopDown:FALSE}),options=options||{},this.kinetic_=options.kinetic,this.lastCentroid=null,this.lastPointersCount_,this.panning_=!1;const condition=options.condition?options.condition:all(noModifierKeys,primaryAction);this.condition_=options.onFocusOnly?all(focusWithTabindex,condition):condition,this.noKinetic_=!1}handleDragEvent(mapBrowserEvent){const map=mapBrowserEvent.map;this.panning_||(this.panning_=!0,map.getView().beginInteraction());const targetPointers=this.targetPointers,centroid$1=map.getEventPixel(centroid(targetPointers));if(targetPointers.length==this.lastPointersCount_){if(this.kinetic_&&this.kinetic_.update(centroid$1[0],centroid$1[1]),this.lastCentroid){const delta=[this.lastCentroid[0]-centroid$1[0],centroid$1[1]-this.lastCentroid[1]],view=mapBrowserEvent.map.getView();scale$2(delta,view.getResolution()),rotate$1(delta,view.getRotation()),view.adjustCenterInternal(delta)}}else this.kinetic_&&this.kinetic_.begin();this.lastCentroid=centroid$1,this.lastPointersCount_=targetPointers.length,mapBrowserEvent.originalEvent.preventDefault()}handleUpEvent(mapBrowserEvent){const map=mapBrowserEvent.map,view=map.getView();if(this.targetPointers.length===0){if(!this.noKinetic_&&this.kinetic_&&this.kinetic_.end()){const distance2=this.kinetic_.getDistance(),angle=this.kinetic_.getAngle(),center=view.getCenterInternal(),centerpx=map.getPixelFromCoordinateInternal(center),dest=map.getCoordinateFromPixelInternal([centerpx[0]-distance2*Math.cos(angle),centerpx[1]-distance2*Math.sin(angle)]);view.animateInternal({center:view.getConstrainedCenter(dest),duration:500,easing:easeOut})}return this.panning_&&(this.panning_=!1,view.endInteraction()),!1}return this.kinetic_&&this.kinetic_.begin(),this.lastCentroid=null,!0}handleDownEvent(mapBrowserEvent){if(this.targetPointers.length>0&&this.condition_(mapBrowserEvent)){const view=mapBrowserEvent.map.getView();return this.lastCentroid=null,view.getAnimating()&&view.cancelAnimations(),this.kinetic_&&this.kinetic_.begin(),this.noKinetic_=this.targetPointers.length>1,!0}return!1}}class DragRotate extends PointerInteraction{constructor(options){options=options||{},super({stopDown:FALSE}),this.condition_=options.condition?options.condition:altShiftKeysOnly,this.lastAngle_=void 0,this.duration_=options.duration!==void 0?options.duration:250}handleDragEvent(mapBrowserEvent){if(!mouseOnly(mapBrowserEvent))return;const map=mapBrowserEvent.map,view=map.getView();if(view.getConstraints().rotation===disable)return;const size=map.getSize(),offset=mapBrowserEvent.pixel,theta=Math.atan2(size[1]/2-offset[1],offset[0]-size[0]/2);if(this.lastAngle_!==void 0){const delta=theta-this.lastAngle_;view.adjustRotationInternal(-delta)}this.lastAngle_=theta}handleUpEvent(mapBrowserEvent){return mouseOnly(mapBrowserEvent)?(mapBrowserEvent.map.getView().endInteraction(this.duration_),!1):!0}handleDownEvent(mapBrowserEvent){return mouseOnly(mapBrowserEvent)&&mouseActionButton(mapBrowserEvent)&&this.condition_(mapBrowserEvent)?(mapBrowserEvent.map.getView().beginInteraction(),this.lastAngle_=void 0,!0):!1}}class RenderBox extends Disposable{constructor(className){super(),this.geometry_=null,this.element_=document.createElement("div"),this.element_.style.position="absolute",this.element_.style.pointerEvents="auto",this.element_.className="ol-box "+className,this.map_=null,this.startPixel_=null,this.endPixel_=null}disposeInternal(){this.setMap(null)}render_(){const startPixel=this.startPixel_,endPixel=this.endPixel_,px="px",style=this.element_.style;style.left=Math.min(startPixel[0],endPixel[0])+px,style.top=Math.min(startPixel[1],endPixel[1])+px,style.width=Math.abs(endPixel[0]-startPixel[0])+px,style.height=Math.abs(endPixel[1]-startPixel[1])+px}setMap(map){if(this.map_){this.map_.getOverlayContainer().removeChild(this.element_);const style=this.element_.style;style.left="inherit",style.top="inherit",style.width="inherit",style.height="inherit"}this.map_=map,this.map_&&this.map_.getOverlayContainer().appendChild(this.element_)}setPixels(startPixel,endPixel){this.startPixel_=startPixel,this.endPixel_=endPixel,this.createOrUpdateGeometry(),this.render_()}createOrUpdateGeometry(){if(!this.map_)return;const startPixel=this.startPixel_,endPixel=this.endPixel_,coordinates2=[startPixel,[startPixel[0],endPixel[1]],endPixel,[endPixel[0],startPixel[1]]].map(this.map_.getCoordinateFromPixelInternal,this.map_);coordinates2[4]=coordinates2[0].slice(),this.geometry_?this.geometry_.setCoordinates([coordinates2]):this.geometry_=new Polygon([coordinates2])}getGeometry(){return this.geometry_}}const DragBoxEventType={BOXSTART:"boxstart",BOXDRAG:"boxdrag",BOXEND:"boxend",BOXCANCEL:"boxcancel"};class DragBoxEvent extends BaseEvent{constructor(type,coordinate,mapBrowserEvent){super(type),this.coordinate=coordinate,this.mapBrowserEvent=mapBrowserEvent}}class DragBox extends PointerInteraction{constructor(options){super(),this.on,this.once,this.un,options=options??{},this.box_=new RenderBox(options.className||"ol-dragbox"),this.minArea_=options.minArea??64,options.onBoxEnd&&(this.onBoxEnd=options.onBoxEnd),this.startPixel_=null,this.condition_=options.condition??mouseActionButton,this.boxEndCondition_=options.boxEndCondition??this.defaultBoxEndCondition}defaultBoxEndCondition(mapBrowserEvent,startPixel,endPixel){const width=endPixel[0]-startPixel[0],height=endPixel[1]-startPixel[1];return width*width+height*height>=this.minArea_}getGeometry(){return this.box_.getGeometry()}handleDragEvent(mapBrowserEvent){this.startPixel_&&(this.box_.setPixels(this.startPixel_,mapBrowserEvent.pixel),this.dispatchEvent(new DragBoxEvent(DragBoxEventType.BOXDRAG,mapBrowserEvent.coordinate,mapBrowserEvent)))}handleUpEvent(mapBrowserEvent){if(!this.startPixel_)return!1;const completeBox=this.boxEndCondition_(mapBrowserEvent,this.startPixel_,mapBrowserEvent.pixel);return completeBox&&this.onBoxEnd(mapBrowserEvent),this.dispatchEvent(new DragBoxEvent(completeBox?DragBoxEventType.BOXEND:DragBoxEventType.BOXCANCEL,mapBrowserEvent.coordinate,mapBrowserEvent)),this.box_.setMap(null),this.startPixel_=null,!1}handleDownEvent(mapBrowserEvent){return this.condition_(mapBrowserEvent)?(this.startPixel_=mapBrowserEvent.pixel,this.box_.setMap(mapBrowserEvent.map),this.box_.setPixels(this.startPixel_,this.startPixel_),this.dispatchEvent(new DragBoxEvent(DragBoxEventType.BOXSTART,mapBrowserEvent.coordinate,mapBrowserEvent)),!0):!1}onBoxEnd(event){}setActive(active){active||(this.box_.setMap(null),this.startPixel_&&(this.dispatchEvent(new DragBoxEvent(DragBoxEventType.BOXCANCEL,this.startPixel_,null)),this.startPixel_=null)),super.setActive(active)}setMap(map){this.getMap()&&(this.box_.setMap(null),this.startPixel_&&(this.dispatchEvent(new DragBoxEvent(DragBoxEventType.BOXCANCEL,this.startPixel_,null)),this.startPixel_=null)),super.setMap(map)}}class DragZoom extends DragBox{constructor(options){options=options||{};const condition=options.condition?options.condition:shiftKeyOnly;super({condition,className:options.className||"ol-dragzoom",minArea:options.minArea}),this.duration_=options.duration!==void 0?options.duration:200,this.out_=options.out!==void 0?options.out:!1}onBoxEnd(event){const view=this.getMap().getView();let geometry2=this.getGeometry();if(this.out_){const rotatedExtent=view.rotatedExtentForGeometry(geometry2),resolution=view.getResolutionForExtentInternal(rotatedExtent),factor=view.getResolution()/resolution;geometry2=geometry2.clone(),geometry2.scale(factor*factor)}view.fitInternal(geometry2,{duration:this.duration_,easing:easeOut})}}const Key={LEFT:"ArrowLeft",UP:"ArrowUp",RIGHT:"ArrowRight",DOWN:"ArrowDown"};class KeyboardPan extends Interaction{constructor(options){super(),options=options||{},this.defaultCondition_=function(mapBrowserEvent){return noModifierKeys(mapBrowserEvent)&&targetNotEditable(mapBrowserEvent)},this.condition_=options.condition!==void 0?options.condition:this.defaultCondition_,this.duration_=options.duration!==void 0?options.duration:100,this.pixelDelta_=options.pixelDelta!==void 0?options.pixelDelta:128}handleEvent(mapBrowserEvent){let stopEvent=!1;if(mapBrowserEvent.type==EventType.KEYDOWN){const keyEvent=mapBrowserEvent.originalEvent,key2=keyEvent.key;if(this.condition_(mapBrowserEvent)&&(key2==Key.DOWN||key2==Key.LEFT||key2==Key.RIGHT||key2==Key.UP)){const view=mapBrowserEvent.map.getView(),mapUnitsDelta=view.getResolution()*this.pixelDelta_;let deltaX=0,deltaY=0;key2==Key.DOWN?deltaY=-mapUnitsDelta:key2==Key.LEFT?deltaX=-mapUnitsDelta:key2==Key.RIGHT?deltaX=mapUnitsDelta:deltaY=mapUnitsDelta;const delta=[deltaX,deltaY];rotate$1(delta,view.getRotation()),pan(view,delta,this.duration_),keyEvent.preventDefault(),stopEvent=!0}}return!stopEvent}}class KeyboardZoom extends Interaction{constructor(options){super(),options=options||{},this.condition_=options.condition?options.condition:function(mapBrowserEvent){return!platformModifierKey(mapBrowserEvent)&&targetNotEditable(mapBrowserEvent)},this.delta_=options.delta?options.delta:1,this.duration_=options.duration!==void 0?options.duration:100}handleEvent(mapBrowserEvent){let stopEvent=!1;if(mapBrowserEvent.type==EventType.KEYDOWN||mapBrowserEvent.type==EventType.KEYPRESS){const keyEvent=mapBrowserEvent.originalEvent,key2=keyEvent.key;if(this.condition_(mapBrowserEvent)&&(key2==="+"||key2==="-")){const map=mapBrowserEvent.map,delta=key2==="+"?this.delta_:-this.delta_,view=map.getView();zoomByDelta(view,delta,void 0,this.duration_),keyEvent.preventDefault(),stopEvent=!0}}return!stopEvent}}class MouseWheelZoom extends Interaction{constructor(options){options=options||{},super(options),this.totalDelta_=0,this.lastDelta_=0,this.maxDelta_=options.maxDelta!==void 0?options.maxDelta:1,this.duration_=options.duration!==void 0?options.duration:250,this.timeout_=options.timeout!==void 0?options.timeout:80,this.useAnchor_=options.useAnchor!==void 0?options.useAnchor:!0,this.constrainResolution_=options.constrainResolution!==void 0?options.constrainResolution:!1;const condition=options.condition?options.condition:always$1;this.condition_=options.onFocusOnly?all(focusWithTabindex,condition):condition,this.lastAnchor_=null,this.startTime_=void 0,this.timeoutId_,this.mode_=void 0,this.trackpadEventGap_=400,this.trackpadTimeoutId_,this.deltaPerZoom_=300}endInteraction_(){this.trackpadTimeoutId_=void 0;const map=this.getMap();if(!map)return;map.getView().endInteraction(void 0,this.lastDelta_?this.lastDelta_>0?1:-1:0,this.lastAnchor_?map.getCoordinateFromPixel(this.lastAnchor_):null)}handleEvent(mapBrowserEvent){if(!this.condition_(mapBrowserEvent)||mapBrowserEvent.type!==EventType.WHEEL)return!0;const map=mapBrowserEvent.map,wheelEvent=mapBrowserEvent.originalEvent;wheelEvent.preventDefault(),this.useAnchor_&&(this.lastAnchor_=mapBrowserEvent.pixel);let delta;if(mapBrowserEvent.type==EventType.WHEEL&&(delta=wheelEvent.deltaY,FIREFOX&&wheelEvent.deltaMode===WheelEvent.DOM_DELTA_PIXEL&&(delta/=DEVICE_PIXEL_RATIO),wheelEvent.deltaMode===WheelEvent.DOM_DELTA_LINE&&(delta*=40)),delta===0)return!1;this.lastDelta_=delta;const now2=Date.now();this.startTime_===void 0&&(this.startTime_=now2),(!this.mode_||now2-this.startTime_>this.trackpadEventGap_)&&(this.mode_=Math.abs(delta)<4?"trackpad":"wheel");const view=map.getView();if(this.mode_==="trackpad"&&!(view.getConstrainResolution()||this.constrainResolution_))return this.trackpadTimeoutId_?clearTimeout(this.trackpadTimeoutId_):(view.getAnimating()&&view.cancelAnimations(),view.beginInteraction()),this.trackpadTimeoutId_=setTimeout(this.endInteraction_.bind(this),this.timeout_),view.adjustZoom(-delta/this.deltaPerZoom_,this.lastAnchor_?map.getCoordinateFromPixel(this.lastAnchor_):null),this.startTime_=now2,!1;this.totalDelta_+=delta;const timeLeft=Math.max(this.timeout_-(now2-this.startTime_),0);return clearTimeout(this.timeoutId_),this.timeoutId_=setTimeout(this.handleWheelZoom_.bind(this,map),timeLeft),!1}handleWheelZoom_(map){const view=map.getView();view.getAnimating()&&view.cancelAnimations();let delta=-clamp$2(this.totalDelta_,-this.maxDelta_*this.deltaPerZoom_,this.maxDelta_*this.deltaPerZoom_)/this.deltaPerZoom_;(view.getConstrainResolution()||this.constrainResolution_)&&(delta=delta?delta>0?1:-1:0),zoomByDelta(view,delta,this.lastAnchor_?map.getCoordinateFromPixel(this.lastAnchor_):null,this.duration_),this.mode_=void 0,this.totalDelta_=0,this.lastAnchor_=null,this.startTime_=void 0,this.timeoutId_=void 0}setMouseAnchor(useAnchor){this.useAnchor_=useAnchor,useAnchor||(this.lastAnchor_=null)}}class PinchRotate extends PointerInteraction{constructor(options){options=options||{};const pointerOptions=options;pointerOptions.stopDown||(pointerOptions.stopDown=FALSE),super(pointerOptions),this.anchor_=null,this.lastAngle_=void 0,this.rotating_=!1,this.rotationDelta_=0,this.threshold_=options.threshold!==void 0?options.threshold:.3,this.duration_=options.duration!==void 0?options.duration:250}handleDragEvent(mapBrowserEvent){let rotationDelta=0;const touch0=this.targetPointers[0],touch1=this.targetPointers[1],angle=Math.atan2(touch1.clientY-touch0.clientY,touch1.clientX-touch0.clientX);if(this.lastAngle_!==void 0){const delta=angle-this.lastAngle_;this.rotationDelta_+=delta,!this.rotating_&&Math.abs(this.rotationDelta_)>this.threshold_&&(this.rotating_=!0),rotationDelta=delta}this.lastAngle_=angle;const map=mapBrowserEvent.map,view=map.getView();view.getConstraints().rotation!==disable&&(this.anchor_=map.getCoordinateFromPixelInternal(map.getEventPixel(centroid(this.targetPointers))),this.rotating_&&(map.render(),view.adjustRotationInternal(rotationDelta,this.anchor_)))}handleUpEvent(mapBrowserEvent){return this.targetPointers.length<2?(mapBrowserEvent.map.getView().endInteraction(this.duration_),!1):!0}handleDownEvent(mapBrowserEvent){if(this.targetPointers.length>=2){const map=mapBrowserEvent.map;return this.anchor_=null,this.lastAngle_=void 0,this.rotating_=!1,this.rotationDelta_=0,this.handlingDownUpSequence||map.getView().beginInteraction(),!0}return!1}}class PinchZoom extends PointerInteraction{constructor(options){options=options||{};const pointerOptions=options;pointerOptions.stopDown||(pointerOptions.stopDown=FALSE),super(pointerOptions),this.anchor_=null,this.duration_=options.duration!==void 0?options.duration:400,this.lastDistance_=void 0,this.lastScaleDelta_=1}handleDragEvent(mapBrowserEvent){let scaleDelta=1;const touch0=this.targetPointers[0],touch1=this.targetPointers[1],dx=touch0.clientX-touch1.clientX,dy=touch0.clientY-touch1.clientY,distance2=Math.sqrt(dx*dx+dy*dy);this.lastDistance_!==void 0&&(scaleDelta=this.lastDistance_/distance2),this.lastDistance_=distance2;const map=mapBrowserEvent.map,view=map.getView();scaleDelta!=1&&(this.lastScaleDelta_=scaleDelta),this.anchor_=map.getCoordinateFromPixelInternal(map.getEventPixel(centroid(this.targetPointers))),map.render(),view.adjustResolutionInternal(scaleDelta,this.anchor_)}handleUpEvent(mapBrowserEvent){if(this.targetPointers.length<2){const view=mapBrowserEvent.map.getView(),direction=this.lastScaleDelta_>1?1:-1;return view.endInteraction(this.duration_,direction),!1}return!0}handleDownEvent(mapBrowserEvent){if(this.targetPointers.length>=2){const map=mapBrowserEvent.map;return this.anchor_=null,this.lastDistance_=void 0,this.lastScaleDelta_=1,this.handlingDownUpSequence||map.getView().beginInteraction(),!0}return!1}}function defaults$1(options){options=options||{};const interactions=new Collection,kinetic=new Kinetic(-.005,.05,100);return(options.altShiftDragRotate!==void 0?options.altShiftDragRotate:!0)&&interactions.push(new DragRotate),(options.doubleClickZoom!==void 0?options.doubleClickZoom:!0)&&interactions.push(new DoubleClickZoom({delta:options.zoomDelta,duration:options.zoomDuration})),(options.dragPan!==void 0?options.dragPan:!0)&&interactions.push(new DragPan({onFocusOnly:options.onFocusOnly,kinetic})),(options.pinchRotate!==void 0?options.pinchRotate:!0)&&interactions.push(new PinchRotate),(options.pinchZoom!==void 0?options.pinchZoom:!0)&&interactions.push(new PinchZoom({duration:options.zoomDuration})),(options.keyboard!==void 0?options.keyboard:!0)&&(interactions.push(new KeyboardPan),interactions.push(new KeyboardZoom({delta:options.zoomDelta,duration:options.zoomDuration}))),(options.mouseWheelZoom!==void 0?options.mouseWheelZoom:!0)&&interactions.push(new MouseWheelZoom({onFocusOnly:options.onFocusOnly,duration:options.zoomDuration})),(options.shiftDragZoom!==void 0?options.shiftDragZoom:!0)&&interactions.push(new DragZoom({duration:options.zoomDuration})),interactions}const LayerProperty={OPACITY:"opacity",VISIBLE:"visible",EXTENT:"extent",Z_INDEX:"zIndex",MAX_RESOLUTION:"maxResolution",MIN_RESOLUTION:"minResolution",MAX_ZOOM:"maxZoom",MIN_ZOOM:"minZoom",SOURCE:"source",MAP:"map"};class BaseLayer extends BaseObject{constructor(options){super(),this.on,this.once,this.un,this.background_=options.background;const properties=Object.assign({},options);typeof options.properties=="object"&&(delete properties.properties,Object.assign(properties,options.properties)),properties[LayerProperty.OPACITY]=options.opacity!==void 0?options.opacity:1,assert(typeof properties[LayerProperty.OPACITY]=="number","Layer opacity must be a number"),properties[LayerProperty.VISIBLE]=options.visible!==void 0?options.visible:!0,properties[LayerProperty.Z_INDEX]=options.zIndex,properties[LayerProperty.MAX_RESOLUTION]=options.maxResolution!==void 0?options.maxResolution:1/0,properties[LayerProperty.MIN_RESOLUTION]=options.minResolution!==void 0?options.minResolution:0,properties[LayerProperty.MIN_ZOOM]=options.minZoom!==void 0?options.minZoom:-1/0,properties[LayerProperty.MAX_ZOOM]=options.maxZoom!==void 0?options.maxZoom:1/0,this.className_=properties.className!==void 0?properties.className:"ol-layer",delete properties.className,this.setProperties(properties),this.state_=null}getBackground(){return this.background_}getClassName(){return this.className_}getLayerState(managed){const state=this.state_||{layer:this,managed:managed===void 0?!0:managed},zIndex=this.getZIndex();return state.opacity=clamp$2(Math.round(this.getOpacity()*100)/100,0,1),state.visible=this.getVisible(),state.extent=this.getExtent(),state.zIndex=zIndex===void 0&&!state.managed?1/0:zIndex,state.maxResolution=this.getMaxResolution(),state.minResolution=Math.max(this.getMinResolution(),0),state.minZoom=this.getMinZoom(),state.maxZoom=this.getMaxZoom(),this.state_=state,state}getLayersArray(array2){return abstract()}getLayerStatesArray(states){return abstract()}getExtent(){return this.get(LayerProperty.EXTENT)}getMaxResolution(){return this.get(LayerProperty.MAX_RESOLUTION)}getMinResolution(){return this.get(LayerProperty.MIN_RESOLUTION)}getMinZoom(){return this.get(LayerProperty.MIN_ZOOM)}getMaxZoom(){return this.get(LayerProperty.MAX_ZOOM)}getOpacity(){return this.get(LayerProperty.OPACITY)}getSourceState(){return abstract()}getVisible(){return this.get(LayerProperty.VISIBLE)}getZIndex(){return this.get(LayerProperty.Z_INDEX)}setBackground(background){this.background_=background,this.changed()}setExtent(extent){this.set(LayerProperty.EXTENT,extent)}setMaxResolution(maxResolution){this.set(LayerProperty.MAX_RESOLUTION,maxResolution)}setMinResolution(minResolution){this.set(LayerProperty.MIN_RESOLUTION,minResolution)}setMaxZoom(maxZoom){this.set(LayerProperty.MAX_ZOOM,maxZoom)}setMinZoom(minZoom){this.set(LayerProperty.MIN_ZOOM,minZoom)}setOpacity(opacity){assert(typeof opacity=="number","Layer opacity must be a number"),this.set(LayerProperty.OPACITY,opacity)}setVisible(visible){this.set(LayerProperty.VISIBLE,visible)}setZIndex(zindex){this.set(LayerProperty.Z_INDEX,zindex)}disposeInternal(){this.state_&&(this.state_.layer=null,this.state_=null),super.disposeInternal()}}class GroupEvent extends BaseEvent{constructor(type,layer){super(type),this.layer=layer}}const Property$1={LAYERS:"layers"};class LayerGroup extends BaseLayer{constructor(options){options=options||{};const baseOptions=Object.assign({},options);delete baseOptions.layers;let layers2=options.layers;super(baseOptions),this.on,this.once,this.un,this.layersListenerKeys_=[],this.listenerKeys_={},this.addChangeListener(Property$1.LAYERS,this.handleLayersChanged_),layers2?Array.isArray(layers2)?layers2=new Collection(layers2.slice(),{unique:!0}):assert(typeof layers2.getArray=="function","Expected `layers` to be an array or a `Collection`"):layers2=new Collection(void 0,{unique:!0}),this.setLayers(layers2)}handleLayerChange_(){this.changed()}handleLayersChanged_(){this.layersListenerKeys_.forEach(unlistenByKey),this.layersListenerKeys_.length=0;const layers2=this.getLayers();this.layersListenerKeys_.push(listen(layers2,CollectionEventType.ADD,this.handleLayersAdd_,this),listen(layers2,CollectionEventType.REMOVE,this.handleLayersRemove_,this));for(const id in this.listenerKeys_)this.listenerKeys_[id].forEach(unlistenByKey);clear(this.listenerKeys_);const layersArray=layers2.getArray();for(let i2=0,ii=layersArray.length;i2<ii;i2++){const layer=layersArray[i2];this.registerLayerListeners_(layer),this.dispatchEvent(new GroupEvent("addlayer",layer))}this.changed()}registerLayerListeners_(layer){const listenerKeys=[listen(layer,ObjectEventType.PROPERTYCHANGE,this.handleLayerChange_,this),listen(layer,EventType.CHANGE,this.handleLayerChange_,this)];layer instanceof LayerGroup&&listenerKeys.push(listen(layer,"addlayer",this.handleLayerGroupAdd_,this),listen(layer,"removelayer",this.handleLayerGroupRemove_,this)),this.listenerKeys_[getUid(layer)]=listenerKeys}handleLayerGroupAdd_(event){this.dispatchEvent(new GroupEvent("addlayer",event.layer))}handleLayerGroupRemove_(event){this.dispatchEvent(new GroupEvent("removelayer",event.layer))}handleLayersAdd_(collectionEvent){const layer=collectionEvent.element;this.registerLayerListeners_(layer),this.dispatchEvent(new GroupEvent("addlayer",layer)),this.changed()}handleLayersRemove_(collectionEvent){const layer=collectionEvent.element,key2=getUid(layer);this.listenerKeys_[key2].forEach(unlistenByKey),delete this.listenerKeys_[key2],this.dispatchEvent(new GroupEvent("removelayer",layer)),this.changed()}getLayers(){return this.get(Property$1.LAYERS)}setLayers(layers2){const collection=this.getLayers();if(collection){const currentLayers2=collection.getArray();for(let i2=0,ii=currentLayers2.length;i2<ii;++i2)this.dispatchEvent(new GroupEvent("removelayer",currentLayers2[i2]))}this.set(Property$1.LAYERS,layers2)}getLayersArray(array2){return array2=array2!==void 0?array2:[],this.getLayers().forEach(function(layer){layer.getLayersArray(array2)}),array2}getLayerStatesArray(dest){const states=dest!==void 0?dest:[],pos=states.length;this.getLayers().forEach(function(layer){layer.getLayerStatesArray(states)});const ownLayerState=this.getLayerState();let defaultZIndex=ownLayerState.zIndex;!dest&&ownLayerState.zIndex===void 0&&(defaultZIndex=0);for(let i2=pos,ii=states.length;i2<ii;i2++){const layerState=states[i2];layerState.opacity*=ownLayerState.opacity,layerState.visible=layerState.visible&&ownLayerState.visible,layerState.maxResolution=Math.min(layerState.maxResolution,ownLayerState.maxResolution),layerState.minResolution=Math.max(layerState.minResolution,ownLayerState.minResolution),layerState.minZoom=Math.max(layerState.minZoom,ownLayerState.minZoom),layerState.maxZoom=Math.min(layerState.maxZoom,ownLayerState.maxZoom),ownLayerState.extent!==void 0&&(layerState.extent!==void 0?layerState.extent=getIntersection(layerState.extent,ownLayerState.extent):layerState.extent=ownLayerState.extent),layerState.zIndex===void 0&&(layerState.zIndex=defaultZIndex)}return states}getSourceState(){return"ready"}}const RenderEventType={PRECOMPOSE:"precompose",POSTCOMPOSE:"postcompose",RENDERCOMPLETE:"rendercomplete"};let Layer$1=class extends BaseLayer{constructor(options){const baseOptions=Object.assign({},options);delete baseOptions.source,super(baseOptions),this.on,this.once,this.un,this.mapPrecomposeKey_=null,this.mapRenderKey_=null,this.sourceChangeKey_=null,this.renderer_=null,this.sourceReady_=!1,this.rendered=!1,options.render&&(this.render=options.render),options.map&&this.setMap(options.map),this.addChangeListener(LayerProperty.SOURCE,this.handleSourcePropertyChange_);const source=options.source?options.source:null;this.setSource(source)}getLayersArray(array2){return array2=array2||[],array2.push(this),array2}getLayerStatesArray(states){return states=states||[],states.push(this.getLayerState()),states}getSource(){return this.get(LayerProperty.SOURCE)||null}getRenderSource(){return this.getSource()}getSourceState(){const source=this.getSource();return source?source.getState():"undefined"}handleSourceChange_(){this.changed(),!(this.sourceReady_||this.getSource().getState()!=="ready")&&(this.sourceReady_=!0,this.dispatchEvent("sourceready"))}handleSourcePropertyChange_(){this.sourceChangeKey_&&(unlistenByKey(this.sourceChangeKey_),this.sourceChangeKey_=null),this.sourceReady_=!1;const source=this.getSource();source&&(this.sourceChangeKey_=listen(source,EventType.CHANGE,this.handleSourceChange_,this),source.getState()==="ready"&&(this.sourceReady_=!0,setTimeout(()=>{this.dispatchEvent("sourceready")},0)),this.clearRenderer()),this.changed()}getFeatures(pixel){return this.renderer_?this.renderer_.getFeatures(pixel):Promise.resolve([])}getData(pixel){return!this.renderer_||!this.rendered?null:this.renderer_.getData(pixel)}isVisible(view){let frameState2;const map=this.getMapInternal();!view&&map&&(view=map.getView()),view instanceof View?frameState2={viewState:view.getState(),extent:view.calculateExtent()}:frameState2=view,!frameState2.layerStatesArray&&map&&(frameState2.layerStatesArray=map.getLayerGroup().getLayerStatesArray());let layerState;if(frameState2.layerStatesArray){if(layerState=frameState2.layerStatesArray.find(layerState2=>layerState2.layer===this),!layerState)return!1}else layerState=this.getLayerState();const layerExtent=this.getExtent();return inView(layerState,frameState2.viewState)&&(!layerExtent||intersects$1(layerExtent,frameState2.extent))}getAttributions(view){if(!this.isVisible(view))return[];const getAttributions=this.getSource()?.getAttributions();if(!getAttributions)return[];const frameState2=view instanceof View?view.getViewStateAndExtent():view;let attributions=getAttributions(frameState2);return Array.isArray(attributions)||(attributions=[attributions]),attributions}render(frameState2,target){const layerRenderer=this.getRenderer();return layerRenderer.prepareFrame(frameState2)?(this.rendered=!0,layerRenderer.renderFrame(frameState2,target)):null}unrender(){this.rendered=!1}getDeclutter(){}renderDeclutter(frameState2,layerState){}renderDeferred(frameState2){const layerRenderer=this.getRenderer();layerRenderer&&layerRenderer.renderDeferred(frameState2)}setMapInternal(map){map||this.unrender(),this.set(LayerProperty.MAP,map)}getMapInternal(){return this.get(LayerProperty.MAP)}setMap(map){this.mapPrecomposeKey_&&(unlistenByKey(this.mapPrecomposeKey_),this.mapPrecomposeKey_=null),map||this.changed(),this.mapRenderKey_&&(unlistenByKey(this.mapRenderKey_),this.mapRenderKey_=null),map&&(this.mapPrecomposeKey_=listen(map,RenderEventType.PRECOMPOSE,this.handlePrecompose_,this),this.mapRenderKey_=listen(this,EventType.CHANGE,map.render,map),this.changed())}handlePrecompose_(renderEvent){const layerStatesArray=renderEvent.frameState.layerStatesArray,layerState=this.getLayerState(!1);assert(!layerStatesArray.some(arrayLayerState=>arrayLayerState.layer===layerState.layer),"A layer can only be added to the map once. Use either `layer.setMap()` or `map.addLayer()`, not both."),layerStatesArray.push(layerState)}setSource(source){this.set(LayerProperty.SOURCE,source)}getRenderer(){return this.renderer_||(this.renderer_=this.createRenderer()),this.renderer_}hasRenderer(){return!!this.renderer_}createRenderer(){return null}clearRenderer(){this.renderer_&&(this.renderer_.dispose(),delete this.renderer_)}disposeInternal(){this.clearRenderer(),this.setSource(null),super.disposeInternal()}};function inView(layerState,viewState){if(!layerState.visible)return!1;const resolution=viewState.resolution;if(resolution<layerState.minResolution||resolution>=layerState.maxResolution)return!1;const zoom=viewState.zoom;return zoom>layerState.minZoom&&zoom<=layerState.maxZoom}function quickselect(arr,k,left,right,compare){quickselectStep(arr,k,left||0,right||arr.length-1,compare||defaultCompare)}function quickselectStep(arr,k,left,right,compare){for(;right>left;){if(right-left>600){var n2=right-left+1,m=k-left+1,z=Math.log(n2),s2=.5*Math.exp(2*z/3),sd=.5*Math.sqrt(z*s2*(n2-s2)/n2)*(m-n2/2<0?-1:1),newLeft=Math.max(left,Math.floor(k-m*s2/n2+sd)),newRight=Math.min(right,Math.floor(k+(n2-m)*s2/n2+sd));quickselectStep(arr,k,newLeft,newRight,compare)}var t2=arr[k],i2=left,j=right;for(swap(arr,left,k),compare(arr[right],t2)>0&&swap(arr,left,right);i2<j;){for(swap(arr,i2,j),i2++,j--;compare(arr[i2],t2)<0;)i2++;for(;compare(arr[j],t2)>0;)j--}compare(arr[left],t2)===0?swap(arr,left,j):(j++,swap(arr,j,right)),j<=k&&(left=j+1),k<=j&&(right=j-1)}}function swap(arr,i2,j){var tmp=arr[i2];arr[i2]=arr[j],arr[j]=tmp}function defaultCompare(a2,b){return a2<b?-1:a2>b?1:0}class RBush{constructor(maxEntries=9){this._maxEntries=Math.max(4,maxEntries),this._minEntries=Math.max(2,Math.ceil(this._maxEntries*.4)),this.clear()}all(){return this._all(this.data,[])}search(bbox){let node=this.data;const result=[];if(!intersects(bbox,node))return result;const toBBox=this.toBBox,nodesToSearch=[];for(;node;){for(let i2=0;i2<node.children.length;i2++){const child=node.children[i2],childBBox=node.leaf?toBBox(child):child;intersects(bbox,childBBox)&&(node.leaf?result.push(child):contains(bbox,childBBox)?this._all(child,result):nodesToSearch.push(child))}node=nodesToSearch.pop()}return result}collides(bbox){let node=this.data;if(!intersects(bbox,node))return!1;const nodesToSearch=[];for(;node;){for(let i2=0;i2<node.children.length;i2++){const child=node.children[i2],childBBox=node.leaf?this.toBBox(child):child;if(intersects(bbox,childBBox)){if(node.leaf||contains(bbox,childBBox))return!0;nodesToSearch.push(child)}}node=nodesToSearch.pop()}return!1}load(data){if(!(data&&data.length))return this;if(data.length<this._minEntries){for(let i2=0;i2<data.length;i2++)this.insert(data[i2]);return this}let node=this._build(data.slice(),0,data.length-1,0);if(!this.data.children.length)this.data=node;else if(this.data.height===node.height)this._splitRoot(this.data,node);else{if(this.data.height<node.height){const tmpNode=this.data;this.data=node,node=tmpNode}this._insert(node,this.data.height-node.height-1,!0)}return this}insert(item){return item&&this._insert(item,this.data.height-1),this}clear(){return this.data=createNode([]),this}remove(item,equalsFn){if(!item)return this;let node=this.data;const bbox=this.toBBox(item),path=[],indexes=[];let i2,parent,goingUp;for(;node||path.length;){if(node||(node=path.pop(),parent=path[path.length-1],i2=indexes.pop(),goingUp=!0),node.leaf){const index=findItem(item,node.children,equalsFn);if(index!==-1)return node.children.splice(index,1),path.push(node),this._condense(path),this}!goingUp&&!node.leaf&&contains(node,bbox)?(path.push(node),indexes.push(i2),i2=0,parent=node,node=node.children[0]):parent?(i2++,node=parent.children[i2],goingUp=!1):node=null}return this}toBBox(item){return item}compareMinX(a2,b){return a2.minX-b.minX}compareMinY(a2,b){return a2.minY-b.minY}toJSON(){return this.data}fromJSON(data){return this.data=data,this}_all(node,result){const nodesToSearch=[];for(;node;)node.leaf?result.push(...node.children):nodesToSearch.push(...node.children),node=nodesToSearch.pop();return result}_build(items,left,right,height){const N=right-left+1;let M=this._maxEntries,node;if(N<=M)return node=createNode(items.slice(left,right+1)),calcBBox(node,this.toBBox),node;height||(height=Math.ceil(Math.log(N)/Math.log(M)),M=Math.ceil(N/Math.pow(M,height-1))),node=createNode([]),node.leaf=!1,node.height=height;const N2=Math.ceil(N/M),N1=N2*Math.ceil(Math.sqrt(M));multiSelect(items,left,right,N1,this.compareMinX);for(let i2=left;i2<=right;i2+=N1){const right2=Math.min(i2+N1-1,right);multiSelect(items,i2,right2,N2,this.compareMinY);for(let j=i2;j<=right2;j+=N2){const right3=Math.min(j+N2-1,right2);node.children.push(this._build(items,j,right3,height-1))}}return calcBBox(node,this.toBBox),node}_chooseSubtree(bbox,node,level,path){for(;path.push(node),!(node.leaf||path.length-1===level);){let minArea=1/0,minEnlargement=1/0,targetNode;for(let i2=0;i2<node.children.length;i2++){const child=node.children[i2],area=bboxArea(child),enlargement=enlargedArea(bbox,child)-area;enlargement<minEnlargement?(minEnlargement=enlargement,minArea=area<minArea?area:minArea,targetNode=child):enlargement===minEnlargement&&area<minArea&&(minArea=area,targetNode=child)}node=targetNode||node.children[0]}return node}_insert(item,level,isNode){const bbox=isNode?item:this.toBBox(item),insertPath=[],node=this._chooseSubtree(bbox,this.data,level,insertPath);for(node.children.push(item),extend$1(node,bbox);level>=0&&insertPath[level].children.length>this._maxEntries;)this._split(insertPath,level),level--;this._adjustParentBBoxes(bbox,insertPath,level)}_split(insertPath,level){const node=insertPath[level],M=node.children.length,m=this._minEntries;this._chooseSplitAxis(node,m,M);const splitIndex=this._chooseSplitIndex(node,m,M),newNode=createNode(node.children.splice(splitIndex,node.children.length-splitIndex));newNode.height=node.height,newNode.leaf=node.leaf,calcBBox(node,this.toBBox),calcBBox(newNode,this.toBBox),level?insertPath[level-1].children.push(newNode):this._splitRoot(node,newNode)}_splitRoot(node,newNode){this.data=createNode([node,newNode]),this.data.height=node.height+1,this.data.leaf=!1,calcBBox(this.data,this.toBBox)}_chooseSplitIndex(node,m,M){let index,minOverlap=1/0,minArea=1/0;for(let i2=m;i2<=M-m;i2++){const bbox1=distBBox(node,0,i2,this.toBBox),bbox2=distBBox(node,i2,M,this.toBBox),overlap=intersectionArea(bbox1,bbox2),area=bboxArea(bbox1)+bboxArea(bbox2);overlap<minOverlap?(minOverlap=overlap,index=i2,minArea=area<minArea?area:minArea):overlap===minOverlap&&area<minArea&&(minArea=area,index=i2)}return index||M-m}_chooseSplitAxis(node,m,M){const compareMinX=node.leaf?this.compareMinX:compareNodeMinX,compareMinY=node.leaf?this.compareMinY:compareNodeMinY,xMargin=this._allDistMargin(node,m,M,compareMinX),yMargin=this._allDistMargin(node,m,M,compareMinY);xMargin<yMargin&&node.children.sort(compareMinX)}_allDistMargin(node,m,M,compare){node.children.sort(compare);const toBBox=this.toBBox,leftBBox=distBBox(node,0,m,toBBox),rightBBox=distBBox(node,M-m,M,toBBox);let margin=bboxMargin(leftBBox)+bboxMargin(rightBBox);for(let i2=m;i2<M-m;i2++){const child=node.children[i2];extend$1(leftBBox,node.leaf?toBBox(child):child),margin+=bboxMargin(leftBBox)}for(let i2=M-m-1;i2>=m;i2--){const child=node.children[i2];extend$1(rightBBox,node.leaf?toBBox(child):child),margin+=bboxMargin(rightBBox)}return margin}_adjustParentBBoxes(bbox,path,level){for(let i2=level;i2>=0;i2--)extend$1(path[i2],bbox)}_condense(path){for(let i2=path.length-1,siblings;i2>=0;i2--)path[i2].children.length===0?i2>0?(siblings=path[i2-1].children,siblings.splice(siblings.indexOf(path[i2]),1)):this.clear():calcBBox(path[i2],this.toBBox)}}function findItem(item,items,equalsFn){if(!equalsFn)return items.indexOf(item);for(let i2=0;i2<items.length;i2++)if(equalsFn(item,items[i2]))return i2;return-1}function calcBBox(node,toBBox){distBBox(node,0,node.children.length,toBBox,node)}function distBBox(node,k,p,toBBox,destNode){destNode||(destNode=createNode(null)),destNode.minX=1/0,destNode.minY=1/0,destNode.maxX=-1/0,destNode.maxY=-1/0;for(let i2=k;i2<p;i2++){const child=node.children[i2];extend$1(destNode,node.leaf?toBBox(child):child)}return destNode}function extend$1(a2,b){return a2.minX=Math.min(a2.minX,b.minX),a2.minY=Math.min(a2.minY,b.minY),a2.maxX=Math.max(a2.maxX,b.maxX),a2.maxY=Math.max(a2.maxY,b.maxY),a2}function compareNodeMinX(a2,b){return a2.minX-b.minX}function compareNodeMinY(a2,b){return a2.minY-b.minY}function bboxArea(a2){return(a2.maxX-a2.minX)*(a2.maxY-a2.minY)}function bboxMargin(a2){return a2.maxX-a2.minX+(a2.maxY-a2.minY)}function enlargedArea(a2,b){return(Math.max(b.maxX,a2.maxX)-Math.min(b.minX,a2.minX))*(Math.max(b.maxY,a2.maxY)-Math.min(b.minY,a2.minY))}function intersectionArea(a2,b){const minX=Math.max(a2.minX,b.minX),minY=Math.max(a2.minY,b.minY),maxX=Math.min(a2.maxX,b.maxX),maxY=Math.min(a2.maxY,b.maxY);return Math.max(0,maxX-minX)*Math.max(0,maxY-minY)}function contains(a2,b){return a2.minX<=b.minX&&a2.minY<=b.minY&&b.maxX<=a2.maxX&&b.maxY<=a2.maxY}function intersects(a2,b){return b.minX<=a2.maxX&&b.minY<=a2.maxY&&b.maxX>=a2.minX&&b.maxY>=a2.minY}function createNode(children){return{children,height:1,leaf:!0,minX:1/0,minY:1/0,maxX:-1/0,maxY:-1/0}}function multiSelect(arr,left,right,n2,compare){const stack2=[left,right];for(;stack2.length;){if(right=stack2.pop(),left=stack2.pop(),right-left<=n2)continue;const mid=left+Math.ceil((right-left)/n2/2)*n2;quickselect(arr,mid,left,right,compare),stack2.push(left,mid,mid,right)}}const names={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]};var baseHues={red:0,orange:60,yellow:120,green:180,blue:240,purple:300};function parse$1(cstr){var m,parts=[],alpha=1,space;if(typeof cstr=="number")return{space:"rgb",values:[cstr>>>16,(cstr&65280)>>>8,cstr&255],alpha:1};if(typeof cstr=="number")return{space:"rgb",values:[cstr>>>16,(cstr&65280)>>>8,cstr&255],alpha:1};if(cstr=String(cstr).toLowerCase(),names[cstr])parts=names[cstr].slice(),space="rgb";else if(cstr==="transparent")alpha=0,space="rgb",parts=[0,0,0];else if(cstr[0]==="#"){var base=cstr.slice(1),size=base.length,isShort=size<=4;alpha=1,isShort?(parts=[parseInt(base[0]+base[0],16),parseInt(base[1]+base[1],16),parseInt(base[2]+base[2],16)],size===4&&(alpha=parseInt(base[3]+base[3],16)/255)):(parts=[parseInt(base[0]+base[1],16),parseInt(base[2]+base[3],16),parseInt(base[4]+base[5],16)],size===8&&(alpha=parseInt(base[6]+base[7],16)/255)),parts[0]||(parts[0]=0),parts[1]||(parts[1]=0),parts[2]||(parts[2]=0),space="rgb"}else if(m=/^((?:rgba?|hs[lvb]a?|hwba?|cmyk?|xy[zy]|gray|lab|lchu?v?|[ly]uv|lms|oklch|oklab|color))\s*\(([^\)]*)\)/.exec(cstr)){var name=m[1];space=name.replace(/a$/,"");var dims=space==="cmyk"?4:space==="gray"?1:3;parts=m[2].trim().split(/\s*[,\/]\s*|\s+/),space==="color"&&(space=parts.shift()),parts=parts.map(function(x,i2){if(x[x.length-1]==="%")return x=parseFloat(x)/100,i2===3?x:space==="rgb"?x*255:space[0]==="h"||space[0]==="l"&&!i2?x*100:space==="lab"?x*125:space==="lch"?i2<2?x*150:x*360:space[0]==="o"&&!i2?x:space==="oklab"?x*.4:space==="oklch"?i2<2?x*.4:x*360:x;if(space[i2]==="h"||i2===2&&space[space.length-1]==="h"){if(baseHues[x]!==void 0)return baseHues[x];if(x.endsWith("deg"))return parseFloat(x);if(x.endsWith("turn"))return parseFloat(x)*360;if(x.endsWith("grad"))return parseFloat(x)*360/400;if(x.endsWith("rad"))return parseFloat(x)*180/Math.PI}return x==="none"?0:parseFloat(x)}),alpha=parts.length>dims?parts.pop():1}else/[0-9](?:\s|\/|,)/.test(cstr)&&(parts=cstr.match(/([0-9]+)/g).map(function(value){return parseFloat(value)}),space=cstr.match(/([a-z])/ig)?.join("")?.toLowerCase()||"rgb");return{space,values:parts,alpha}}const rgb={name:"rgb",min:[0,0,0],max:[255,255,255],channel:["red","green","blue"],alias:["RGB"]},hsl={name:"hsl",min:[0,0,0],max:[360,100,100],channel:["hue","saturation","lightness"],alias:["HSL"],rgb:function(hsl2){var h=hsl2[0]/360,s2=hsl2[1]/100,l2=hsl2[2]/100,t1,t2,t3,rgb2,val,i2=0;if(s2===0)return val=l2*255,[val,val,val];for(t2=l2<.5?l2*(1+s2):l2+s2-l2*s2,t1=2*l2-t2,rgb2=[0,0,0];i2<3;)t3=h+1/3*-(i2-1),t3<0?t3++:t3>1&&t3--,val=6*t3<1?t1+(t2-t1)*6*t3:2*t3<1?t2:3*t3<2?t1+(t2-t1)*(2/3-t3)*6:t1,rgb2[i2++]=val*255;return rgb2}};rgb.hsl=function(rgb2){var r2=rgb2[0]/255,g=rgb2[1]/255,b=rgb2[2]/255,min2=Math.min(r2,g,b),max2=Math.max(r2,g,b),delta=max2-min2,h,s2,l2;return max2===min2?h=0:r2===max2?h=(g-b)/delta:g===max2?h=2+(b-r2)/delta:b===max2&&(h=4+(r2-g)/delta),h=Math.min(h*60,360),h<0&&(h+=360),l2=(min2+max2)/2,max2===min2?s2=0:l2<=.5?s2=delta/(max2+min2):s2=delta/(2-max2-min2),[h,s2*100,l2*100]};function rgba(color2){Array.isArray(color2)&&color2.raw&&(color2=String.raw(...arguments)),color2 instanceof Number&&(color2=+color2);var values,parsed=parse$1(color2);if(!parsed.space)return[];const min2=parsed.space[0]==="h"?hsl.min:rgb.min,max2=parsed.space[0]==="h"?hsl.max:rgb.max;return values=Array(3),values[0]=Math.min(Math.max(parsed.values[0],min2[0]),max2[0]),values[1]=Math.min(Math.max(parsed.values[1],min2[1]),max2[1]),values[2]=Math.min(Math.max(parsed.values[2],min2[2]),max2[2]),parsed.space[0]==="h"&&(values=hsl.rgb(values)),values.push(Math.min(Math.max(parsed.alpha,0),1)),values}var xyz={name:"xyz",min:[0,0,0],channel:["X","Y","Z"],alias:["XYZ","ciexyz","cie1931"]};xyz.whitepoint={2:{A:[109.85,100,35.585],C:[98.074,100,118.232],D50:[96.422,100,82.521],D55:[95.682,100,92.149],D65:[95.045592705167,100,108.9057750759878],D75:[94.972,100,122.638],F2:[99.187,100,67.395],F7:[95.044,100,108.755],F11:[100.966,100,64.37],E:[100,100,100]},10:{A:[111.144,100,35.2],C:[97.285,100,116.145],D50:[96.72,100,81.427],D55:[95.799,100,90.926],D65:[94.811,100,107.304],D75:[94.416,100,120.641],F2:[103.28,100,69.026],F7:[95.792,100,107.687],F11:[103.866,100,65.627],E:[100,100,100]}};xyz.max=xyz.whitepoint[2].D65;xyz.rgb=function(_xyz,white){white=white||xyz.whitepoint[2].E;var x=_xyz[0]/white[0],y=_xyz[1]/white[1],z=_xyz[2]/white[2],r2,g,b;return r2=x*3.240969941904521+y*-1.537383177570093+z*-.498610760293,g=x*-.96924363628087+y*1.87596750150772+z*.041555057407175,b=x*.055630079696993+y*-.20397695888897+z*1.056971514242878,r2=r2>.0031308?1.055*Math.pow(r2,1/2.4)-.055:r2=r2*12.92,g=g>.0031308?1.055*Math.pow(g,1/2.4)-.055:g=g*12.92,b=b>.0031308?1.055*Math.pow(b,1/2.4)-.055:b=b*12.92,r2=Math.min(Math.max(0,r2),1),g=Math.min(Math.max(0,g),1),b=Math.min(Math.max(0,b),1),[r2*255,g*255,b*255]};rgb.xyz=function(rgb2,white){var r2=rgb2[0]/255,g=rgb2[1]/255,b=rgb2[2]/255;r2=r2>.04045?Math.pow((r2+.055)/1.055,2.4):r2/12.92,g=g>.04045?Math.pow((g+.055)/1.055,2.4):g/12.92,b=b>.04045?Math.pow((b+.055)/1.055,2.4):b/12.92;var x=r2*.41239079926595+g*.35758433938387+b*.18048078840183,y=r2*.21263900587151+g*.71516867876775+b*.072192315360733,z=r2*.019330818715591+g*.11919477979462+b*.95053215224966;return white=white||xyz.whitepoint[2].E,[x*white[0],y*white[1],z*white[2]]};const luv={name:"luv",min:[0,-134,-140],max:[100,224,122],channel:["lightness","u","v"],alias:["LUV","cieluv","cie1976"],xyz:function(arg,i2,o2){var _u,_v,l2,u,v,x,y,z,xn,yn,zn,un,vn;if(l2=arg[0],u=arg[1],v=arg[2],l2===0)return[0,0,0];var k=.0011070564598794539;return i2=i2||"D65",o2=o2||2,xn=xyz.whitepoint[o2][i2][0],yn=xyz.whitepoint[o2][i2][1],zn=xyz.whitepoint[o2][i2][2],un=4*xn/(xn+15*yn+3*zn),vn=9*yn/(xn+15*yn+3*zn),_u=u/(13*l2)+un||0,_v=v/(13*l2)+vn||0,y=l2>8?yn*Math.pow((l2+16)/116,3):yn*l2*k,x=y*9*_u/(4*_v)||0,z=y*(12-3*_u-20*_v)/(4*_v)||0,[x,y,z]}};xyz.luv=function(arg,i2,o2){var _u,_v,l2,u,v,x,y,z,xn,yn,zn,un,vn,e2=.008856451679035631,k=903.2962962962961;i2=i2||"D65",o2=o2||2,xn=xyz.whitepoint[o2][i2][0],yn=xyz.whitepoint[o2][i2][1],zn=xyz.whitepoint[o2][i2][2],un=4*xn/(xn+15*yn+3*zn),vn=9*yn/(xn+15*yn+3*zn),x=arg[0],y=arg[1],z=arg[2],_u=4*x/(x+15*y+3*z)||0,_v=9*y/(x+15*y+3*z)||0;var yr=y/yn;return l2=yr<=e2?k*yr:116*Math.pow(yr,1/3)-16,u=13*l2*(_u-un),v=13*l2*(_v-vn),[l2,u,v]};var lchuv={name:"lchuv",channel:["lightness","chroma","hue"],alias:["LCHuv","cielchuv"],min:[0,0,0],max:[100,100,360],luv:function(luv2){var l2=luv2[0],c2=luv2[1],h=luv2[2],u,v,hr;return hr=h/360*2*Math.PI,u=c2*Math.cos(hr),v=c2*Math.sin(hr),[l2,u,v]},xyz:function(arg){return luv.xyz(lchuv.luv(arg))}};luv.lchuv=function(luv2){var l2=luv2[0],u=luv2[1],v=luv2[2],c2=Math.sqrt(u*u+v*v),hr=Math.atan2(v,u),h=hr*360/2/Math.PI;return h<0&&(h+=360),[l2,c2,h]};xyz.lchuv=function(arg){return luv.lchuv(xyz.luv(arg))};const NO_COLOR=[NaN,NaN,NaN,0];function asString(color2){return typeof color2=="string"?color2:toString(color2)}const MAX_CACHE_SIZE=1024,cache={};let cacheSize=0;function withAlpha(color2){if(color2.length===4)return color2;const output2=color2.slice();return output2[3]=1,output2}function rgbaToLcha(color2){const output2=xyz.lchuv(rgb.xyz(color2));return output2[3]=color2[3],output2}function lchaToRgba(color2){const output2=xyz.rgb(lchuv.xyz(color2));return output2[3]=color2[3],output2}function fromString(s2){if(s2==="none")return NO_COLOR;if(cache.hasOwnProperty(s2))return cache[s2];if(cacheSize>=MAX_CACHE_SIZE){let i2=0;for(const key2 in cache)i2++&3||(delete cache[key2],--cacheSize)}const color2=rgba(s2);if(color2.length!==4)throw new Error('failed to parse "'+s2+'" as color');for(const c2 of color2)if(isNaN(c2))throw new Error('failed to parse "'+s2+'" as color');return normalize(color2),cache[s2]=color2,++cacheSize,color2}function asArray(color2){return Array.isArray(color2)?color2:fromString(color2)}function normalize(color2){return color2[0]=clamp$2(color2[0]+.5|0,0,255),color2[1]=clamp$2(color2[1]+.5|0,0,255),color2[2]=clamp$2(color2[2]+.5|0,0,255),color2[3]=clamp$2(color2[3],0,1),color2}function toString(color2){let r2=color2[0];r2!=(r2|0)&&(r2=r2+.5|0);let g=color2[1];g!=(g|0)&&(g=g+.5|0);let b=color2[2];b!=(b|0)&&(b=b+.5|0);const a2=color2[3]===void 0?1:Math.round(color2[3]*1e3)/1e3;return"rgba("+r2+","+g+","+b+","+a2+")"}function hasArea(size){return size[0]>0&&size[1]>0}function scale(size,ratio,dest){return dest===void 0&&(dest=[0,0]),dest[0]=size[0]*ratio+.5|0,dest[1]=size[1]*ratio+.5|0,dest}function toSize(size,dest){return Array.isArray(size)?size:(dest===void 0?dest=[size,size]:(dest[0]=size,dest[1]=size),dest)}let numTypes=0;const BooleanType=1<<numTypes++,NumberType=1<<numTypes++,StringType=1<<numTypes++,ColorType=1<<numTypes++,NumberArrayType=1<<numTypes++,SizeType=1<<numTypes++,AnyType=Math.pow(2,numTypes)-1,typeNames={[BooleanType]:"boolean",[NumberType]:"number",[StringType]:"string",[ColorType]:"color",[NumberArrayType]:"number[]",[SizeType]:"size"},namedTypes=Object.keys(typeNames).map(Number).sort(ascending);function isSpecific(type){return type in typeNames}function typeName(type){const names2=[];for(const namedType of namedTypes)includesType(type,namedType)&&names2.push(typeNames[namedType]);return names2.length===0?"untyped":names2.length<3?names2.join(" or "):names2.slice(0,-1).join(", ")+", or "+names2[names2.length-1]}function includesType(broad,specific){return(broad&specific)===specific}function isType(type,expected){return type===expected}class LiteralExpression{constructor(type,value){if(!isSpecific(type))throw new Error(`literal expressions must have a specific type, got ${typeName(type)}`);this.type=type,this.value=value}}class CallExpression{constructor(type,operator,...args){this.type=type,this.operator=operator,this.args=args}}function newParsingContext(){return{variables:new Set,properties:new Set,featureId:!1,geometryType:!1,mapState:!1}}function parse(encoded,expectedType,context2){switch(typeof encoded){case"boolean":{if(isType(expectedType,StringType))return new LiteralExpression(StringType,encoded?"true":"false");if(!includesType(expectedType,BooleanType))throw new Error(`got a boolean, but expected ${typeName(expectedType)}`);return new LiteralExpression(BooleanType,encoded)}case"number":{if(isType(expectedType,SizeType))return new LiteralExpression(SizeType,toSize(encoded));if(isType(expectedType,BooleanType))return new LiteralExpression(BooleanType,!!encoded);if(isType(expectedType,StringType))return new LiteralExpression(StringType,encoded.toString());if(!includesType(expectedType,NumberType))throw new Error(`got a number, but expected ${typeName(expectedType)}`);return new LiteralExpression(NumberType,encoded)}case"string":{if(isType(expectedType,ColorType))return new LiteralExpression(ColorType,fromString(encoded));if(isType(expectedType,BooleanType))return new LiteralExpression(BooleanType,!!encoded);if(!includesType(expectedType,StringType))throw new Error(`got a string, but expected ${typeName(expectedType)}`);return new LiteralExpression(StringType,encoded)}}if(!Array.isArray(encoded))throw new Error("expression must be an array or a primitive value");if(encoded.length===0)throw new Error("empty expression");if(typeof encoded[0]=="string")return parseCallExpression(encoded,expectedType,context2);for(const item of encoded)if(typeof item!="number")throw new Error("expected an array of numbers");if(isType(expectedType,SizeType)){if(encoded.length!==2)throw new Error(`expected an array of two values for a size, got ${encoded.length}`);return new LiteralExpression(SizeType,encoded)}if(isType(expectedType,ColorType)){if(encoded.length===3)return new LiteralExpression(ColorType,[...encoded,1]);if(encoded.length===4)return new LiteralExpression(ColorType,encoded);throw new Error(`expected an array of 3 or 4 values for a color, got ${encoded.length}`)}if(!includesType(expectedType,NumberArrayType))throw new Error(`got an array of numbers, but expected ${typeName(expectedType)}`);return new LiteralExpression(NumberArrayType,encoded)}const Ops={Get:"get",Var:"var",Concat:"concat",GeometryType:"geometry-type",LineMetric:"line-metric",Any:"any",All:"all",Not:"!",Resolution:"resolution",Zoom:"zoom",Time:"time",Equal:"==",NotEqual:"!=",GreaterThan:">",GreaterThanOrEqualTo:">=",LessThan:"<",LessThanOrEqualTo:"<=",Multiply:"*",Divide:"/",Add:"+",Subtract:"-",Clamp:"clamp",Mod:"%",Pow:"^",Abs:"abs",Floor:"floor",Ceil:"ceil",Round:"round",Sin:"sin",Cos:"cos",Atan:"atan",Sqrt:"sqrt",Match:"match",Between:"between",Interpolate:"interpolate",Coalesce:"coalesce",Case:"case",In:"in",Number:"number",String:"string",Array:"array",Color:"color",Id:"id",Band:"band",Palette:"palette",ToString:"to-string",Has:"has"},parsers={[Ops.Get]:createCallExpressionParser(hasArgsCount(1,1/0),withGetArgs),[Ops.Var]:createCallExpressionParser(hasArgsCount(1,1),withVarArgs),[Ops.Has]:createCallExpressionParser(hasArgsCount(1,1/0),withGetArgs),[Ops.Id]:createCallExpressionParser(usesFeatureId,withNoArgs),[Ops.Concat]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfType(StringType)),[Ops.GeometryType]:createCallExpressionParser(usesGeometryType,withNoArgs),[Ops.LineMetric]:createCallExpressionParser(withNoArgs),[Ops.Resolution]:createCallExpressionParser(usesMapState,withNoArgs),[Ops.Zoom]:createCallExpressionParser(usesMapState,withNoArgs),[Ops.Time]:createCallExpressionParser(usesMapState,withNoArgs),[Ops.Any]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfType(BooleanType)),[Ops.All]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfType(BooleanType)),[Ops.Not]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(BooleanType)),[Ops.Equal]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(AnyType)),[Ops.NotEqual]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(AnyType)),[Ops.GreaterThan]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.GreaterThanOrEqualTo]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.LessThan]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.LessThanOrEqualTo]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.Multiply]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfReturnType),[Ops.Coalesce]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfReturnType),[Ops.Divide]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.Add]:createCallExpressionParser(hasArgsCount(2,1/0),withArgsOfType(NumberType)),[Ops.Subtract]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.Clamp]:createCallExpressionParser(hasArgsCount(3,3),withArgsOfType(NumberType)),[Ops.Mod]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.Pow]:createCallExpressionParser(hasArgsCount(2,2),withArgsOfType(NumberType)),[Ops.Abs]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Floor]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Ceil]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Round]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Sin]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Cos]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Atan]:createCallExpressionParser(hasArgsCount(1,2),withArgsOfType(NumberType)),[Ops.Sqrt]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(NumberType)),[Ops.Match]:createCallExpressionParser(hasArgsCount(4,1/0),hasEvenArgs,withMatchArgs),[Ops.Between]:createCallExpressionParser(hasArgsCount(3,3),withArgsOfType(NumberType)),[Ops.Interpolate]:createCallExpressionParser(hasArgsCount(6,1/0),hasEvenArgs,withInterpolateArgs),[Ops.Case]:createCallExpressionParser(hasArgsCount(3,1/0),hasOddArgs,withCaseArgs),[Ops.In]:createCallExpressionParser(hasArgsCount(2,2),withInArgs),[Ops.Number]:createCallExpressionParser(hasArgsCount(1,1/0),withArgsOfType(AnyType)),[Ops.String]:createCallExpressionParser(hasArgsCount(1,1/0),withArgsOfType(AnyType)),[Ops.Array]:createCallExpressionParser(hasArgsCount(1,1/0),withArgsOfType(NumberType)),[Ops.Color]:createCallExpressionParser(hasArgsCount(1,4),withArgsOfType(NumberType)),[Ops.Band]:createCallExpressionParser(hasArgsCount(1,3),withArgsOfType(NumberType)),[Ops.Palette]:createCallExpressionParser(hasArgsCount(2,2),withPaletteArgs),[Ops.ToString]:createCallExpressionParser(hasArgsCount(1,1),withArgsOfType(BooleanType|NumberType|StringType|ColorType))};function withGetArgs(encoded,returnType,context2){const argsCount=encoded.length-1,args=new Array(argsCount);for(let i2=0;i2<argsCount;++i2){const key2=encoded[i2+1];switch(typeof key2){case"number":{args[i2]=new LiteralExpression(NumberType,key2);break}case"string":{args[i2]=new LiteralExpression(StringType,key2);break}default:throw new Error(`expected a string key or numeric array index for a get operation, got ${key2}`)}i2===0&&context2.properties.add(String(key2))}return args}function withVarArgs(encoded,returnType,context2){const name=encoded[1];if(typeof name!="string")throw new Error("expected a string argument for var operation");return context2.variables.add(name),[new LiteralExpression(StringType,name)]}function usesFeatureId(encoded,returnType,context2){context2.featureId=!0}function usesGeometryType(encoded,returnType,context2){context2.geometryType=!0}function usesMapState(encoded,returnType,context2){context2.mapState=!0}function withNoArgs(encoded,returnType,context2){const operation=encoded[0];if(encoded.length!==1)throw new Error(`expected no arguments for ${operation} operation`);return[]}function hasArgsCount(minArgs,maxArgs){return function(encoded,returnType,context2){const operation=encoded[0],argCount=encoded.length-1;if(minArgs===maxArgs){if(argCount!==minArgs){const plural=minArgs===1?"":"s";throw new Error(`expected ${minArgs} argument${plural} for ${operation}, got ${argCount}`)}}else if(argCount<minArgs||argCount>maxArgs){const range2=maxArgs===1/0?`${minArgs} or more`:`${minArgs} to ${maxArgs}`;throw new Error(`expected ${range2} arguments for ${operation}, got ${argCount}`)}}}function withArgsOfReturnType(encoded,returnType,context2){const argCount=encoded.length-1,args=new Array(argCount);for(let i2=0;i2<argCount;++i2){const expression2=parse(encoded[i2+1],returnType,context2);args[i2]=expression2}return args}function withArgsOfType(argType){return function(encoded,returnType,context2){const argCount=encoded.length-1,args=new Array(argCount);for(let i2=0;i2<argCount;++i2){const expression2=parse(encoded[i2+1],argType,context2);args[i2]=expression2}return args}}function hasOddArgs(encoded,returnType,context2){const operation=encoded[0],argCount=encoded.length-1;if(argCount%2===0)throw new Error(`expected an odd number of arguments for ${operation}, got ${argCount} instead`)}function hasEvenArgs(encoded,returnType,context2){const operation=encoded[0],argCount=encoded.length-1;if(argCount%2===1)throw new Error(`expected an even number of arguments for operation ${operation}, got ${argCount} instead`)}function withMatchArgs(encoded,returnType,context2){const argsCount=encoded.length-1,inputType=StringType|NumberType|BooleanType,input=parse(encoded[1],inputType,context2),fallback=parse(encoded[encoded.length-1],returnType,context2),args=new Array(argsCount-2);for(let i2=0;i2<argsCount-2;i2+=2){try{const match=parse(encoded[i2+2],input.type,context2);args[i2]=match}catch(err){throw new Error(`failed to parse argument ${i2+1} of match expression: ${err.message}`)}try{const output2=parse(encoded[i2+3],fallback.type,context2);args[i2+1]=output2}catch(err){throw new Error(`failed to parse argument ${i2+2} of match expression: ${err.message}`)}}return[input,...args,fallback]}function withInterpolateArgs(encoded,returnType,context2){const interpolationType=encoded[1];let base;switch(interpolationType[0]){case"linear":base=1;break;case"exponential":const b=interpolationType[1];if(typeof b!="number"||b<=0)throw new Error(`expected a number base for exponential interpolation, got ${JSON.stringify(b)} instead`);base=b;break;default:throw new Error(`invalid interpolation type: ${JSON.stringify(interpolationType)}`)}const interpolation=new LiteralExpression(NumberType,base);let input;try{input=parse(encoded[2],NumberType,context2)}catch(err){throw new Error(`failed to parse argument 1 in interpolate expression: ${err.message}`)}const args=new Array(encoded.length-3);for(let i2=0;i2<args.length;i2+=2){try{const stop=parse(encoded[i2+3],NumberType,context2);args[i2]=stop}catch(err){throw new Error(`failed to parse argument ${i2+2} for interpolate expression: ${err.message}`)}try{const output2=parse(encoded[i2+4],returnType,context2);args[i2+1]=output2}catch(err){throw new Error(`failed to parse argument ${i2+3} for interpolate expression: ${err.message}`)}}return[interpolation,input,...args]}function withCaseArgs(encoded,returnType,context2){const fallback=parse(encoded[encoded.length-1],returnType,context2),args=new Array(encoded.length-1);for(let i2=0;i2<args.length-1;i2+=2){try{const condition=parse(encoded[i2+1],BooleanType,context2);args[i2]=condition}catch(err){throw new Error(`failed to parse argument ${i2} of case expression: ${err.message}`)}try{const output2=parse(encoded[i2+2],fallback.type,context2);args[i2+1]=output2}catch(err){throw new Error(`failed to parse argument ${i2+1} of case expression: ${err.message}`)}}return args[args.length-1]=fallback,args}function withInArgs(encoded,returnType,context2){let haystack=encoded[2];if(!Array.isArray(haystack))throw new Error('the second argument for the "in" operator must be an array');let needleType;if(typeof haystack[0]=="string"){if(haystack[0]!=="literal")throw new Error('for the "in" operator, a string array should be wrapped in a "literal" operator to disambiguate from expressions');if(!Array.isArray(haystack[1]))throw new Error('failed to parse "in" expression: the literal operator must be followed by an array');haystack=haystack[1],needleType=StringType}else needleType=NumberType;const args=new Array(haystack.length);for(let i2=0;i2<args.length;i2++)try{const arg=parse(haystack[i2],needleType,context2);args[i2]=arg}catch(err){throw new Error(`failed to parse haystack item ${i2} for "in" expression: ${err.message}`)}return[parse(encoded[1],needleType,context2),...args]}function withPaletteArgs(encoded,returnType,context2){let index;try{index=parse(encoded[1],NumberType,context2)}catch(err){throw new Error(`failed to parse first argument in palette expression: ${err.message}`)}const colors=encoded[2];if(!Array.isArray(colors))throw new Error("the second argument of palette must be an array");const parsedColors=new Array(colors.length);for(let i2=0;i2<parsedColors.length;i2++){let color2;try{color2=parse(colors[i2],ColorType,context2)}catch(err){throw new Error(`failed to parse color at index ${i2} in palette expression: ${err.message}`)}if(!(color2 instanceof LiteralExpression))throw new Error(`the palette color at index ${i2} must be a literal value`);parsedColors[i2]=color2}return[index,...parsedColors]}function createCallExpressionParser(...validators){return function(encoded,returnType,context2){const operator=encoded[0];let args;for(let i2=0;i2<validators.length;i2++){const parsed=validators[i2](encoded,returnType,context2);if(i2==validators.length-1){if(!parsed)throw new Error("expected last argument validator to return the parsed args");args=parsed}}return new CallExpression(returnType,operator,...args)}}function parseCallExpression(encoded,returnType,context2){const operator=encoded[0],parser=parsers[operator];if(!parser)throw new Error(`unknown operator: ${operator}`);return parser(encoded,returnType,context2)}function computeGeometryType(geometry2){if(!geometry2)return"";const type=geometry2.getType();switch(type){case"Point":case"LineString":case"Polygon":return type;case"MultiPoint":case"MultiLineString":case"MultiPolygon":return type.substring(5);case"Circle":return"Polygon";case"GeometryCollection":return computeGeometryType(geometry2.getGeometries()[0]);default:return""}}function newEvaluationContext(){return{variables:{},properties:{},resolution:NaN,featureId:null,geometryType:""}}function buildExpression(encoded,type,context2){const expression2=parse(encoded,type,context2);return compileExpression(expression2)}function compileExpression(expression2,context2){if(expression2 instanceof LiteralExpression){if(expression2.type===ColorType&&typeof expression2.value=="string"){const colorValue=fromString(expression2.value);return function(){return colorValue}}return function(){return expression2.value}}const operator=expression2.operator;switch(operator){case Ops.Number:case Ops.String:case Ops.Coalesce:return compileAssertionExpression(expression2);case Ops.Get:case Ops.Var:case Ops.Has:return compileAccessorExpression(expression2);case Ops.Id:return context3=>context3.featureId;case Ops.GeometryType:return context3=>context3.geometryType;case Ops.Concat:{const args=expression2.args.map(e2=>compileExpression(e2));return context3=>"".concat(...args.map(arg=>arg(context3).toString()))}case Ops.Resolution:return context3=>context3.resolution;case Ops.Any:case Ops.All:case Ops.Between:case Ops.In:case Ops.Not:return compileLogicalExpression(expression2);case Ops.Equal:case Ops.NotEqual:case Ops.LessThan:case Ops.LessThanOrEqualTo:case Ops.GreaterThan:case Ops.GreaterThanOrEqualTo:return compileComparisonExpression(expression2);case Ops.Multiply:case Ops.Divide:case Ops.Add:case Ops.Subtract:case Ops.Clamp:case Ops.Mod:case Ops.Pow:case Ops.Abs:case Ops.Floor:case Ops.Ceil:case Ops.Round:case Ops.Sin:case Ops.Cos:case Ops.Atan:case Ops.Sqrt:return compileNumericExpression(expression2);case Ops.Case:return compileCaseExpression(expression2);case Ops.Match:return compileMatchExpression(expression2);case Ops.Interpolate:return compileInterpolateExpression(expression2);case Ops.ToString:return compileConvertExpression(expression2);default:throw new Error(`Unsupported operator ${operator}`)}}function compileAssertionExpression(expression2,context2){const type=expression2.operator,length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);switch(type){case Ops.Coalesce:return context3=>{for(let i2=0;i2<length2;++i2){const value=args[i2](context3);if(typeof value<"u"&&value!==null)return value}throw new Error("Expected one of the values to be non-null")};case Ops.Number:case Ops.String:return context3=>{for(let i2=0;i2<length2;++i2){const value=args[i2](context3);if(typeof value===type)return value}throw new Error(`Expected one of the values to be a ${type}`)};default:throw new Error(`Unsupported assertion operator ${type}`)}}function compileAccessorExpression(expression2,context2){const name=expression2.args[0].value;switch(expression2.operator){case Ops.Get:return context3=>{const args=expression2.args;let value=context3.properties[name];for(let i2=1,ii=args.length;i2<ii;++i2){const key2=args[i2].value;value=value[key2]}return value};case Ops.Var:return context3=>context3.variables[name];case Ops.Has:return context3=>{const args=expression2.args;if(!(name in context3.properties))return!1;let value=context3.properties[name];for(let i2=1,ii=args.length;i2<ii;++i2){const key2=args[i2].value;if(!value||!Object.hasOwn(value,key2))return!1;value=value[key2]}return!0};default:throw new Error(`Unsupported accessor operator ${expression2.operator}`)}}function compileComparisonExpression(expression2,context2){const op=expression2.operator,left=compileExpression(expression2.args[0]),right=compileExpression(expression2.args[1]);switch(op){case Ops.Equal:return context3=>left(context3)===right(context3);case Ops.NotEqual:return context3=>left(context3)!==right(context3);case Ops.LessThan:return context3=>left(context3)<right(context3);case Ops.LessThanOrEqualTo:return context3=>left(context3)<=right(context3);case Ops.GreaterThan:return context3=>left(context3)>right(context3);case Ops.GreaterThanOrEqualTo:return context3=>left(context3)>=right(context3);default:throw new Error(`Unsupported comparison operator ${op}`)}}function compileLogicalExpression(expression2,context2){const op=expression2.operator,length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);switch(op){case Ops.Any:return context3=>{for(let i2=0;i2<length2;++i2)if(args[i2](context3))return!0;return!1};case Ops.All:return context3=>{for(let i2=0;i2<length2;++i2)if(!args[i2](context3))return!1;return!0};case Ops.Between:return context3=>{const value=args[0](context3),min2=args[1](context3),max2=args[2](context3);return value>=min2&&value<=max2};case Ops.In:return context3=>{const value=args[0](context3);for(let i2=1;i2<length2;++i2)if(value===args[i2](context3))return!0;return!1};case Ops.Not:return context3=>!args[0](context3);default:throw new Error(`Unsupported logical operator ${op}`)}}function compileNumericExpression(expression2,context2){const op=expression2.operator,length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);switch(op){case Ops.Multiply:return context3=>{let value=1;for(let i2=0;i2<length2;++i2)value*=args[i2](context3);return value};case Ops.Divide:return context3=>args[0](context3)/args[1](context3);case Ops.Add:return context3=>{let value=0;for(let i2=0;i2<length2;++i2)value+=args[i2](context3);return value};case Ops.Subtract:return context3=>args[0](context3)-args[1](context3);case Ops.Clamp:return context3=>{const value=args[0](context3),min2=args[1](context3);if(value<min2)return min2;const max2=args[2](context3);return value>max2?max2:value};case Ops.Mod:return context3=>args[0](context3)%args[1](context3);case Ops.Pow:return context3=>Math.pow(args[0](context3),args[1](context3));case Ops.Abs:return context3=>Math.abs(args[0](context3));case Ops.Floor:return context3=>Math.floor(args[0](context3));case Ops.Ceil:return context3=>Math.ceil(args[0](context3));case Ops.Round:return context3=>Math.round(args[0](context3));case Ops.Sin:return context3=>Math.sin(args[0](context3));case Ops.Cos:return context3=>Math.cos(args[0](context3));case Ops.Atan:return length2===2?context3=>Math.atan2(args[0](context3),args[1](context3)):context3=>Math.atan(args[0](context3));case Ops.Sqrt:return context3=>Math.sqrt(args[0](context3));default:throw new Error(`Unsupported numeric operator ${op}`)}}function compileCaseExpression(expression2,context2){const length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);return context3=>{for(let i2=0;i2<length2-1;i2+=2)if(args[i2](context3))return args[i2+1](context3);return args[length2-1](context3)}}function compileMatchExpression(expression2,context2){const length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);return context3=>{const value=args[0](context3);for(let i2=1;i2<length2;i2+=2)if(value===args[i2](context3))return args[i2+1](context3);return args[length2-1](context3)}}function compileInterpolateExpression(expression2,context2){const length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);return context3=>{const base=args[0](context3),value=args[1](context3);let previousInput,previousOutput;for(let i2=2;i2<length2;i2+=2){const input=args[i2](context3);let output2=args[i2+1](context3);const isColor=Array.isArray(output2);if(isColor&&(output2=withAlpha(output2)),input>=value)return i2===2?output2:isColor?interpolateColor(base,value,previousInput,previousOutput,input,output2):interpolateNumber(base,value,previousInput,previousOutput,input,output2);previousInput=input,previousOutput=output2}return previousOutput}}function compileConvertExpression(expression2,context2){const op=expression2.operator,length2=expression2.args.length,args=new Array(length2);for(let i2=0;i2<length2;++i2)args[i2]=compileExpression(expression2.args[i2]);switch(op){case Ops.ToString:return context3=>{const value=args[0](context3);return expression2.args[0].type===ColorType?toString(value):value.toString()};default:throw new Error(`Unsupported convert operator ${op}`)}}function interpolateNumber(base,value,input1,output1,input2,output2){const delta=input2-input1;if(delta===0)return output1;const along=value-input1,factor=base===1?along/delta:(Math.pow(base,along)-1)/(Math.pow(base,delta)-1);return output1+factor*(output2-output1)}function interpolateColor(base,value,input1,rgba1,input2,rgba2){if(input2-input1===0)return rgba1;const lcha1=rgbaToLcha(rgba1),lcha2=rgbaToLcha(rgba2);let deltaHue=lcha2[2]-lcha1[2];deltaHue>180?deltaHue-=360:deltaHue<-180&&(deltaHue+=360);const lcha=[interpolateNumber(base,value,input1,lcha1[0],input2,lcha2[0]),interpolateNumber(base,value,input1,lcha1[1],input2,lcha2[1]),lcha1[2]+interpolateNumber(base,value,input1,0,input2,deltaHue),interpolateNumber(base,value,input1,rgba1[3],input2,rgba2[3])];return normalize(lchaToRgba(lcha))}const ImageState={IDLE:0,LOADING:1,LOADED:2,ERROR:3};function listenImage(image,loadHandler,errorHandler){const img2=image;let listening=!0,decoding=!1,loaded=!1;const listenerKeys=[listenOnce(img2,EventType.LOAD,function(){loaded=!0,decoding||loadHandler()})];return img2.src&&IMAGE_DECODE?(decoding=!0,img2.decode().then(function(){listening&&loadHandler()}).catch(function(error){listening&&(loaded?loadHandler():errorHandler())})):listenerKeys.push(listenOnce(img2,EventType.ERROR,errorHandler)),function(){listening=!1,listenerKeys.forEach(unlistenByKey)}}function load$1(image,src){return new Promise((resolve,reject)=>{function handleLoad(){unlisten(),resolve(image)}function handleError2(){unlisten(),reject(new Error("Image load error"))}function unlisten(){image.removeEventListener("load",handleLoad),image.removeEventListener("error",handleError2)}image.addEventListener("load",handleLoad),image.addEventListener("error",handleError2)})}function decodeFallback(image,src){return src&&(image.src=src),image.src&&IMAGE_DECODE?new Promise((resolve,reject)=>image.decode().then(()=>resolve(image)).catch(e2=>image.complete&&image.width?resolve(image):reject(e2))):load$1(image)}class IconImageCache{constructor(){this.cache_={},this.patternCache_={},this.cacheSize_=0,this.maxCacheSize_=1024}clear(){this.cache_={},this.patternCache_={},this.cacheSize_=0}canExpireCache(){return this.cacheSize_>this.maxCacheSize_}expire(){if(this.canExpireCache()){let i2=0;for(const key2 in this.cache_){const iconImage=this.cache_[key2];!(i2++&3)&&!iconImage.hasListener()&&(delete this.cache_[key2],delete this.patternCache_[key2],--this.cacheSize_)}}}get(src,crossOrigin,color2){const key2=getCacheKey$1(src,crossOrigin,color2);return key2 in this.cache_?this.cache_[key2]:null}getPattern(src,crossOrigin,color2){const key2=getCacheKey$1(src,crossOrigin,color2);return key2 in this.patternCache_?this.patternCache_[key2]:null}set(src,crossOrigin,color2,iconImage,pattern){const key2=getCacheKey$1(src,crossOrigin,color2),update=key2 in this.cache_;this.cache_[key2]=iconImage,pattern&&(iconImage.getImageState()===ImageState.IDLE&&iconImage.load(),iconImage.getImageState()===ImageState.LOADING?iconImage.ready().then(()=>{this.patternCache_[key2]=getSharedCanvasContext2D().createPattern(iconImage.getImage(1),"repeat")}):this.patternCache_[key2]=getSharedCanvasContext2D().createPattern(iconImage.getImage(1),"repeat")),update||++this.cacheSize_}setSize(maxCacheSize){this.maxCacheSize_=maxCacheSize,this.expire()}}function getCacheKey$1(src,crossOrigin,color2){const colorString=color2?asArray(color2):"null";return crossOrigin+":"+src+":"+colorString}const shared=new IconImageCache;let taintedTestContext=null;class IconImage extends Target{constructor(image,src,crossOrigin,imageState,color2){super(),this.hitDetectionImage_=null,this.image_=image,this.crossOrigin_=crossOrigin,this.canvas_={},this.color_=color2,this.imageState_=imageState===void 0?ImageState.IDLE:imageState,this.size_=image&&image.width&&image.height?[image.width,image.height]:null,this.src_=src,this.tainted_,this.ready_=null}initializeImage_(){this.image_=new Image,this.crossOrigin_!==null&&(this.image_.crossOrigin=this.crossOrigin_)}isTainted_(){if(this.tainted_===void 0&&this.imageState_===ImageState.LOADED){taintedTestContext||(taintedTestContext=createCanvasContext2D(1,1,void 0,{willReadFrequently:!0})),taintedTestContext.drawImage(this.image_,0,0);try{taintedTestContext.getImageData(0,0,1,1),this.tainted_=!1}catch{taintedTestContext=null,this.tainted_=!0}}return this.tainted_===!0}dispatchChangeEvent_(){this.dispatchEvent(EventType.CHANGE)}handleImageError_(){this.imageState_=ImageState.ERROR,this.dispatchChangeEvent_()}handleImageLoad_(){this.imageState_=ImageState.LOADED,this.size_=[this.image_.width,this.image_.height],this.dispatchChangeEvent_()}getImage(pixelRatio){return this.image_||this.initializeImage_(),this.replaceColor_(pixelRatio),this.canvas_[pixelRatio]?this.canvas_[pixelRatio]:this.image_}getPixelRatio(pixelRatio){return this.replaceColor_(pixelRatio),this.canvas_[pixelRatio]?pixelRatio:1}getImageState(){return this.imageState_}getHitDetectionImage(){if(this.image_||this.initializeImage_(),!this.hitDetectionImage_)if(this.isTainted_()){const width=this.size_[0],height=this.size_[1],context2=createCanvasContext2D(width,height);context2.fillRect(0,0,width,height),this.hitDetectionImage_=context2.canvas}else this.hitDetectionImage_=this.image_;return this.hitDetectionImage_}getSize(){return this.size_}getSrc(){return this.src_}load(){if(this.imageState_===ImageState.IDLE){this.image_||this.initializeImage_(),this.imageState_=ImageState.LOADING;try{this.src_!==void 0&&(this.image_.src=this.src_)}catch{this.handleImageError_()}this.image_ instanceof HTMLImageElement&&decodeFallback(this.image_,this.src_).then(image=>{this.image_=image,this.handleImageLoad_()}).catch(this.handleImageError_.bind(this))}}replaceColor_(pixelRatio){if(!this.color_||this.canvas_[pixelRatio]||this.imageState_!==ImageState.LOADED)return;const image=this.image_,ctx=createCanvasContext2D(Math.ceil(image.width*pixelRatio),Math.ceil(image.height*pixelRatio)),canvas=ctx.canvas;ctx.scale(pixelRatio,pixelRatio),ctx.drawImage(image,0,0),ctx.globalCompositeOperation="multiply",ctx.fillStyle=asString(this.color_),ctx.fillRect(0,0,canvas.width/pixelRatio,canvas.height/pixelRatio),ctx.globalCompositeOperation="destination-in",ctx.drawImage(image,0,0),this.canvas_[pixelRatio]=canvas}ready(){return this.ready_||(this.ready_=new Promise(resolve=>{if(this.imageState_===ImageState.LOADED||this.imageState_===ImageState.ERROR)resolve();else{const onChange=()=>{(this.imageState_===ImageState.LOADED||this.imageState_===ImageState.ERROR)&&(this.removeEventListener(EventType.CHANGE,onChange),resolve())};this.addEventListener(EventType.CHANGE,onChange)}})),this.ready_}}function get(image,cacheKey,crossOrigin,imageState,color2,pattern){let iconImage=cacheKey===void 0?void 0:shared.get(cacheKey,crossOrigin,color2);return iconImage||(iconImage=new IconImage(image,image&&"src"in image?image.src||void 0:cacheKey,crossOrigin,imageState,color2),shared.set(cacheKey,crossOrigin,color2,iconImage,pattern)),pattern&&iconImage&&!shared.getPattern(cacheKey,crossOrigin,color2)&&shared.set(cacheKey,crossOrigin,color2,iconImage,pattern),iconImage}function asColorLike(color2){return color2?Array.isArray(color2)?toString(color2):typeof color2=="object"&&"src"in color2?asCanvasPattern(color2):color2:null}function asCanvasPattern(pattern){if(!pattern.offset||!pattern.size)return shared.getPattern(pattern.src,"anonymous",pattern.color);const cacheKey=pattern.src+":"+pattern.offset,canvasPattern=shared.getPattern(cacheKey,void 0,pattern.color);if(canvasPattern)return canvasPattern;const iconImage=shared.get(pattern.src,"anonymous",null);if(iconImage.getImageState()!==ImageState.LOADED)return null;const patternCanvasContext=createCanvasContext2D(pattern.size[0],pattern.size[1]);return patternCanvasContext.drawImage(iconImage.getImage(1),pattern.offset[0],pattern.offset[1],pattern.size[0],pattern.size[1],0,0,pattern.size[0],pattern.size[1]),get(patternCanvasContext.canvas,cacheKey,void 0,ImageState.LOADED,pattern.color,!0),shared.getPattern(cacheKey,void 0,pattern.color)}const defaultFillStyle="#000",defaultLineCap="round",defaultLineJoin="round",defaultMiterLimit=10,defaultStrokeStyle="#000",defaultLineWidth=1,checkedFonts=new BaseObject;class ImageStyle{constructor(options){this.opacity_=options.opacity,this.rotateWithView_=options.rotateWithView,this.rotation_=options.rotation,this.scale_=options.scale,this.scaleArray_=toSize(options.scale),this.displacement_=options.displacement,this.declutterMode_=options.declutterMode}clone(){const scale2=this.getScale();return new ImageStyle({opacity:this.getOpacity(),scale:Array.isArray(scale2)?scale2.slice():scale2,rotation:this.getRotation(),rotateWithView:this.getRotateWithView(),displacement:this.getDisplacement().slice(),declutterMode:this.getDeclutterMode()})}getOpacity(){return this.opacity_}getRotateWithView(){return this.rotateWithView_}getRotation(){return this.rotation_}getScale(){return this.scale_}getScaleArray(){return this.scaleArray_}getDisplacement(){return this.displacement_}getDeclutterMode(){return this.declutterMode_}getAnchor(){return abstract()}getImage(pixelRatio){return abstract()}getHitDetectionImage(){return abstract()}getPixelRatio(pixelRatio){return 1}getImageState(){return abstract()}getImageSize(){return abstract()}getOrigin(){return abstract()}getSize(){return abstract()}setDisplacement(displacement){this.displacement_=displacement}setOpacity(opacity){this.opacity_=opacity}setRotateWithView(rotateWithView){this.rotateWithView_=rotateWithView}setRotation(rotation2){this.rotation_=rotation2}setScale(scale2){this.scale_=scale2,this.scaleArray_=toSize(scale2)}listenImageChange(listener){abstract()}load(){abstract()}unlistenImageChange(listener){abstract()}ready(){return Promise.resolve()}}class RegularShape extends ImageStyle{constructor(options){super({opacity:1,rotateWithView:options.rotateWithView!==void 0?options.rotateWithView:!1,rotation:options.rotation!==void 0?options.rotation:0,scale:options.scale!==void 0?options.scale:1,displacement:options.displacement!==void 0?options.displacement:[0,0],declutterMode:options.declutterMode}),this.hitDetectionCanvas_=null,this.fill_=options.fill!==void 0?options.fill:null,this.origin_=[0,0],this.points_=options.points,this.radius=options.radius,this.radius2_=options.radius2,this.angle_=options.angle!==void 0?options.angle:0,this.stroke_=options.stroke!==void 0?options.stroke:null,this.size_,this.renderOptions_,this.imageState_=this.fill_&&this.fill_.loading()?ImageState.LOADING:ImageState.LOADED,this.imageState_===ImageState.LOADING&&this.ready().then(()=>this.imageState_=ImageState.LOADED),this.render()}clone(){const scale2=this.getScale(),style=new RegularShape({fill:this.getFill()?this.getFill().clone():void 0,points:this.getPoints(),radius:this.getRadius(),radius2:this.getRadius2(),angle:this.getAngle(),stroke:this.getStroke()?this.getStroke().clone():void 0,rotation:this.getRotation(),rotateWithView:this.getRotateWithView(),scale:Array.isArray(scale2)?scale2.slice():scale2,displacement:this.getDisplacement().slice(),declutterMode:this.getDeclutterMode()});return style.setOpacity(this.getOpacity()),style}getAnchor(){const size=this.size_,displacement=this.getDisplacement(),scale2=this.getScaleArray();return[size[0]/2-displacement[0]/scale2[0],size[1]/2+displacement[1]/scale2[1]]}getAngle(){return this.angle_}getFill(){return this.fill_}setFill(fill){this.fill_=fill,this.render()}getHitDetectionImage(){return this.hitDetectionCanvas_||(this.hitDetectionCanvas_=this.createHitDetectionCanvas_(this.renderOptions_)),this.hitDetectionCanvas_}getImage(pixelRatio){const fillKey=this.fill_?.getKey(),cacheKey=`${pixelRatio},${this.angle_},${this.radius},${this.radius2_},${this.points_},${fillKey}`+Object.values(this.renderOptions_).join(",");let image=shared.get(cacheKey,null,null)?.getImage(1);if(!image){const renderOptions=this.renderOptions_,size=Math.ceil(renderOptions.size*pixelRatio),context2=createCanvasContext2D(size,size);this.draw_(renderOptions,context2,pixelRatio),image=context2.canvas,shared.set(cacheKey,null,null,new IconImage(image,void 0,null,ImageState.LOADED,null))}return image}getPixelRatio(pixelRatio){return pixelRatio}getImageSize(){return this.size_}getImageState(){return this.imageState_}getOrigin(){return this.origin_}getPoints(){return this.points_}getRadius(){return this.radius}getRadius2(){return this.radius2_}getSize(){return this.size_}getStroke(){return this.stroke_}setStroke(stroke){this.stroke_=stroke,this.render()}listenImageChange(listener){}load(){}unlistenImageChange(listener){}calculateLineJoinSize_(lineJoin,strokeWidth,miterLimit){if(strokeWidth===0||this.points_===1/0||lineJoin!=="bevel"&&lineJoin!=="miter")return strokeWidth;let r1=this.radius,r2=this.radius2_===void 0?r1:this.radius2_;if(r1<r2){const tmp=r1;r1=r2,r2=tmp}const points=this.radius2_===void 0?this.points_:this.points_*2,alpha=2*Math.PI/points,a2=r2*Math.sin(alpha),b=Math.sqrt(r2*r2-a2*a2),d2=r1-b,e2=Math.sqrt(a2*a2+d2*d2),miterRatio=e2/a2;if(lineJoin==="miter"&&miterRatio<=miterLimit)return miterRatio*strokeWidth;const k=strokeWidth/2/miterRatio,l2=strokeWidth/2*(d2/e2),bevelAdd=Math.sqrt((r1+k)*(r1+k)+l2*l2)-r1;if(this.radius2_===void 0||lineJoin==="bevel")return bevelAdd*2;const aa=r1*Math.sin(alpha),bb=Math.sqrt(r1*r1-aa*aa),dd=r2-bb,innerMiterRatio=Math.sqrt(aa*aa+dd*dd)/aa;if(innerMiterRatio<=miterLimit){const innerLength=innerMiterRatio*strokeWidth/2-r2-r1;return 2*Math.max(bevelAdd,innerLength)}return bevelAdd*2}createRenderOptions(){let lineCap=defaultLineCap,lineJoin=defaultLineJoin,miterLimit=0,lineDash=null,lineDashOffset=0,strokeStyle,strokeWidth=0;this.stroke_&&(strokeStyle=asColorLike(this.stroke_.getColor()??defaultStrokeStyle),strokeWidth=this.stroke_.getWidth()??defaultLineWidth,lineDash=this.stroke_.getLineDash(),lineDashOffset=this.stroke_.getLineDashOffset()??0,lineJoin=this.stroke_.getLineJoin()??defaultLineJoin,lineCap=this.stroke_.getLineCap()??defaultLineCap,miterLimit=this.stroke_.getMiterLimit()??defaultMiterLimit);const add2=this.calculateLineJoinSize_(lineJoin,strokeWidth,miterLimit),maxRadius=Math.max(this.radius,this.radius2_||0),size=Math.ceil(2*maxRadius+add2);return{strokeStyle,strokeWidth,size,lineCap,lineDash,lineDashOffset,lineJoin,miterLimit}}render(){this.renderOptions_=this.createRenderOptions();const size=this.renderOptions_.size;this.hitDetectionCanvas_=null,this.size_=[size,size]}draw_(renderOptions,context2,pixelRatio){if(context2.scale(pixelRatio,pixelRatio),context2.translate(renderOptions.size/2,renderOptions.size/2),this.createPath_(context2),this.fill_){let color2=this.fill_.getColor();color2===null&&(color2=defaultFillStyle),context2.fillStyle=asColorLike(color2),context2.fill()}renderOptions.strokeStyle&&(context2.strokeStyle=renderOptions.strokeStyle,context2.lineWidth=renderOptions.strokeWidth,renderOptions.lineDash&&(context2.setLineDash(renderOptions.lineDash),context2.lineDashOffset=renderOptions.lineDashOffset),context2.lineCap=renderOptions.lineCap,context2.lineJoin=renderOptions.lineJoin,context2.miterLimit=renderOptions.miterLimit,context2.stroke())}createHitDetectionCanvas_(renderOptions){let context2;if(this.fill_){let color2=this.fill_.getColor(),opacity=0;typeof color2=="string"&&(color2=asArray(color2)),color2===null?opacity=1:Array.isArray(color2)&&(opacity=color2.length===4?color2[3]:1),opacity===0&&(context2=createCanvasContext2D(renderOptions.size,renderOptions.size),this.drawHitDetectionCanvas_(renderOptions,context2))}return context2?context2.canvas:this.getImage(1)}createPath_(context2){let points=this.points_;const radius=this.radius;if(points===1/0)context2.arc(0,0,radius,0,2*Math.PI);else{const radius2=this.radius2_===void 0?radius:this.radius2_;this.radius2_!==void 0&&(points*=2);const startAngle=this.angle_-Math.PI/2,step2=2*Math.PI/points;for(let i2=0;i2<points;i2++){const angle0=startAngle+i2*step2,radiusC=i2%2===0?radius:radius2;context2.lineTo(radiusC*Math.cos(angle0),radiusC*Math.sin(angle0))}context2.closePath()}}drawHitDetectionCanvas_(renderOptions,context2){context2.translate(renderOptions.size/2,renderOptions.size/2),this.createPath_(context2),context2.fillStyle=defaultFillStyle,context2.fill(),renderOptions.strokeStyle&&(context2.strokeStyle=renderOptions.strokeStyle,context2.lineWidth=renderOptions.strokeWidth,renderOptions.lineDash&&(context2.setLineDash(renderOptions.lineDash),context2.lineDashOffset=renderOptions.lineDashOffset),context2.lineJoin=renderOptions.lineJoin,context2.miterLimit=renderOptions.miterLimit,context2.stroke())}ready(){return this.fill_?this.fill_.ready():Promise.resolve()}}class CircleStyle extends RegularShape{constructor(options){options=options||{radius:5},super({points:1/0,fill:options.fill,radius:options.radius,stroke:options.stroke,scale:options.scale!==void 0?options.scale:1,rotation:options.rotation!==void 0?options.rotation:0,rotateWithView:options.rotateWithView!==void 0?options.rotateWithView:!1,displacement:options.displacement!==void 0?options.displacement:[0,0],declutterMode:options.declutterMode})}clone(){const scale2=this.getScale(),style=new CircleStyle({fill:this.getFill()?this.getFill().clone():void 0,stroke:this.getStroke()?this.getStroke().clone():void 0,radius:this.getRadius(),scale:Array.isArray(scale2)?scale2.slice():scale2,rotation:this.getRotation(),rotateWithView:this.getRotateWithView(),displacement:this.getDisplacement().slice(),declutterMode:this.getDeclutterMode()});return style.setOpacity(this.getOpacity()),style}setRadius(radius){this.radius=radius,this.render()}}class Fill{constructor(options){options=options||{},this.patternImage_=null,this.color_=null,options.color!==void 0&&this.setColor(options.color)}clone(){const color2=this.getColor();return new Fill({color:Array.isArray(color2)?color2.slice():color2||void 0})}getColor(){return this.color_}setColor(color2){if(color2!==null&&typeof color2=="object"&&"src"in color2){const patternImage=get(null,color2.src,"anonymous",void 0,color2.offset?null:color2.color?color2.color:null,!(color2.offset&&color2.size));patternImage.ready().then(()=>{this.patternImage_=null}),patternImage.getImageState()===ImageState.IDLE&&patternImage.load(),patternImage.getImageState()===ImageState.LOADING&&(this.patternImage_=patternImage)}this.color_=color2}getKey(){const fill=this.getColor();return fill?fill instanceof CanvasPattern||fill instanceof CanvasGradient?getUid(fill):typeof fill=="object"&&"src"in fill?fill.src+":"+fill.offset:asArray(fill).toString():""}loading(){return!!this.patternImage_}ready(){return this.patternImage_?this.patternImage_.ready():Promise.resolve()}}function calculateScale(width,height,wantedWidth,wantedHeight){return wantedWidth!==void 0&&wantedHeight!==void 0?[wantedWidth/width,wantedHeight/height]:wantedWidth!==void 0?wantedWidth/width:wantedHeight!==void 0?wantedHeight/height:1}class Icon extends ImageStyle{constructor(options){options=options||{};const opacity=options.opacity!==void 0?options.opacity:1,rotation2=options.rotation!==void 0?options.rotation:0,scale2=options.scale!==void 0?options.scale:1,rotateWithView=options.rotateWithView!==void 0?options.rotateWithView:!1;super({opacity,rotation:rotation2,scale:scale2,displacement:options.displacement!==void 0?options.displacement:[0,0],rotateWithView,declutterMode:options.declutterMode}),this.anchor_=options.anchor!==void 0?options.anchor:[.5,.5],this.normalizedAnchor_=null,this.anchorOrigin_=options.anchorOrigin!==void 0?options.anchorOrigin:"top-left",this.anchorXUnits_=options.anchorXUnits!==void 0?options.anchorXUnits:"fraction",this.anchorYUnits_=options.anchorYUnits!==void 0?options.anchorYUnits:"fraction",this.crossOrigin_=options.crossOrigin!==void 0?options.crossOrigin:null;const image=options.img!==void 0?options.img:null;let cacheKey=options.src;assert(!(cacheKey!==void 0&&image),"`image` and `src` cannot be provided at the same time"),(cacheKey===void 0||cacheKey.length===0)&&image&&(cacheKey=image.src||getUid(image)),assert(cacheKey!==void 0&&cacheKey.length>0,"A defined and non-empty `src` or `image` must be provided"),assert(!((options.width!==void 0||options.height!==void 0)&&options.scale!==void 0),"`width` or `height` cannot be provided together with `scale`");let imageState;if(options.src!==void 0?imageState=ImageState.IDLE:image!==void 0&&("complete"in image?image.complete?imageState=image.src?ImageState.LOADED:ImageState.IDLE:imageState=ImageState.LOADING:imageState=ImageState.LOADED),this.color_=options.color!==void 0?asArray(options.color):null,this.iconImage_=get(image,cacheKey,this.crossOrigin_,imageState,this.color_),this.offset_=options.offset!==void 0?options.offset:[0,0],this.offsetOrigin_=options.offsetOrigin!==void 0?options.offsetOrigin:"top-left",this.origin_=null,this.size_=options.size!==void 0?options.size:null,this.initialOptions_,options.width!==void 0||options.height!==void 0){let width,height;if(options.size)[width,height]=options.size;else{const image2=this.getImage(1);if(image2.width&&image2.height)width=image2.width,height=image2.height;else if(image2 instanceof HTMLImageElement){this.initialOptions_=options;const onload=()=>{if(this.unlistenImageChange(onload),!this.initialOptions_)return;const imageSize=this.iconImage_.getSize();this.setScale(calculateScale(imageSize[0],imageSize[1],options.width,options.height))};this.listenImageChange(onload);return}}width!==void 0&&this.setScale(calculateScale(width,height,options.width,options.height))}}clone(){let scale2,width,height;return this.initialOptions_?(width=this.initialOptions_.width,height=this.initialOptions_.height):(scale2=this.getScale(),scale2=Array.isArray(scale2)?scale2.slice():scale2),new Icon({anchor:this.anchor_.slice(),anchorOrigin:this.anchorOrigin_,anchorXUnits:this.anchorXUnits_,anchorYUnits:this.anchorYUnits_,color:this.color_&&this.color_.slice?this.color_.slice():this.color_||void 0,crossOrigin:this.crossOrigin_,offset:this.offset_.slice(),offsetOrigin:this.offsetOrigin_,opacity:this.getOpacity(),rotateWithView:this.getRotateWithView(),rotation:this.getRotation(),scale:scale2,width,height,size:this.size_!==null?this.size_.slice():void 0,src:this.getSrc(),displacement:this.getDisplacement().slice(),declutterMode:this.getDeclutterMode()})}getAnchor(){let anchor=this.normalizedAnchor_;if(!anchor){anchor=this.anchor_;const size=this.getSize();if(this.anchorXUnits_=="fraction"||this.anchorYUnits_=="fraction"){if(!size)return null;anchor=this.anchor_.slice(),this.anchorXUnits_=="fraction"&&(anchor[0]*=size[0]),this.anchorYUnits_=="fraction"&&(anchor[1]*=size[1])}if(this.anchorOrigin_!="top-left"){if(!size)return null;anchor===this.anchor_&&(anchor=this.anchor_.slice()),(this.anchorOrigin_=="top-right"||this.anchorOrigin_=="bottom-right")&&(anchor[0]=-anchor[0]+size[0]),(this.anchorOrigin_=="bottom-left"||this.anchorOrigin_=="bottom-right")&&(anchor[1]=-anchor[1]+size[1])}this.normalizedAnchor_=anchor}const displacement=this.getDisplacement(),scale2=this.getScaleArray();return[anchor[0]-displacement[0]/scale2[0],anchor[1]+displacement[1]/scale2[1]]}setAnchor(anchor){this.anchor_=anchor,this.normalizedAnchor_=null}getColor(){return this.color_}getImage(pixelRatio){return this.iconImage_.getImage(pixelRatio)}getPixelRatio(pixelRatio){return this.iconImage_.getPixelRatio(pixelRatio)}getImageSize(){return this.iconImage_.getSize()}getImageState(){return this.iconImage_.getImageState()}getHitDetectionImage(){return this.iconImage_.getHitDetectionImage()}getOrigin(){if(this.origin_)return this.origin_;let offset=this.offset_;if(this.offsetOrigin_!="top-left"){const size=this.getSize(),iconImageSize=this.iconImage_.getSize();if(!size||!iconImageSize)return null;offset=offset.slice(),(this.offsetOrigin_=="top-right"||this.offsetOrigin_=="bottom-right")&&(offset[0]=iconImageSize[0]-size[0]-offset[0]),(this.offsetOrigin_=="bottom-left"||this.offsetOrigin_=="bottom-right")&&(offset[1]=iconImageSize[1]-size[1]-offset[1])}return this.origin_=offset,this.origin_}getSrc(){return this.iconImage_.getSrc()}getSize(){return this.size_?this.size_:this.iconImage_.getSize()}getWidth(){const scale2=this.getScaleArray();if(this.size_)return this.size_[0]*scale2[0];if(this.iconImage_.getImageState()==ImageState.LOADED)return this.iconImage_.getSize()[0]*scale2[0]}getHeight(){const scale2=this.getScaleArray();if(this.size_)return this.size_[1]*scale2[1];if(this.iconImage_.getImageState()==ImageState.LOADED)return this.iconImage_.getSize()[1]*scale2[1]}setScale(scale2){delete this.initialOptions_,super.setScale(scale2)}listenImageChange(listener){this.iconImage_.addEventListener(EventType.CHANGE,listener)}load(){this.iconImage_.load()}unlistenImageChange(listener){this.iconImage_.removeEventListener(EventType.CHANGE,listener)}ready(){return this.iconImage_.ready()}}class Stroke{constructor(options){options=options||{},this.color_=options.color!==void 0?options.color:null,this.lineCap_=options.lineCap,this.lineDash_=options.lineDash!==void 0?options.lineDash:null,this.lineDashOffset_=options.lineDashOffset,this.lineJoin_=options.lineJoin,this.miterLimit_=options.miterLimit,this.width_=options.width}clone(){const color2=this.getColor();return new Stroke({color:Array.isArray(color2)?color2.slice():color2||void 0,lineCap:this.getLineCap(),lineDash:this.getLineDash()?this.getLineDash().slice():void 0,lineDashOffset:this.getLineDashOffset(),lineJoin:this.getLineJoin(),miterLimit:this.getMiterLimit(),width:this.getWidth()})}getColor(){return this.color_}getLineCap(){return this.lineCap_}getLineDash(){return this.lineDash_}getLineDashOffset(){return this.lineDashOffset_}getLineJoin(){return this.lineJoin_}getMiterLimit(){return this.miterLimit_}getWidth(){return this.width_}setColor(color2){this.color_=color2}setLineCap(lineCap){this.lineCap_=lineCap}setLineDash(lineDash){this.lineDash_=lineDash}setLineDashOffset(lineDashOffset){this.lineDashOffset_=lineDashOffset}setLineJoin(lineJoin){this.lineJoin_=lineJoin}setMiterLimit(miterLimit){this.miterLimit_=miterLimit}setWidth(width){this.width_=width}}class Style{constructor(options){options=options||{},this.geometry_=null,this.geometryFunction_=defaultGeometryFunction,options.geometry!==void 0&&this.setGeometry(options.geometry),this.fill_=options.fill!==void 0?options.fill:null,this.image_=options.image!==void 0?options.image:null,this.renderer_=options.renderer!==void 0?options.renderer:null,this.hitDetectionRenderer_=options.hitDetectionRenderer!==void 0?options.hitDetectionRenderer:null,this.stroke_=options.stroke!==void 0?options.stroke:null,this.text_=options.text!==void 0?options.text:null,this.zIndex_=options.zIndex}clone(){let geometry2=this.getGeometry();return geometry2&&typeof geometry2=="object"&&(geometry2=geometry2.clone()),new Style({geometry:geometry2??void 0,fill:this.getFill()?this.getFill().clone():void 0,image:this.getImage()?this.getImage().clone():void 0,renderer:this.getRenderer()??void 0,stroke:this.getStroke()?this.getStroke().clone():void 0,text:this.getText()?this.getText().clone():void 0,zIndex:this.getZIndex()})}getRenderer(){return this.renderer_}setRenderer(renderer){this.renderer_=renderer}setHitDetectionRenderer(renderer){this.hitDetectionRenderer_=renderer}getHitDetectionRenderer(){return this.hitDetectionRenderer_}getGeometry(){return this.geometry_}getGeometryFunction(){return this.geometryFunction_}getFill(){return this.fill_}setFill(fill){this.fill_=fill}getImage(){return this.image_}setImage(image){this.image_=image}getStroke(){return this.stroke_}setStroke(stroke){this.stroke_=stroke}getText(){return this.text_}setText(text){this.text_=text}getZIndex(){return this.zIndex_}setGeometry(geometry2){typeof geometry2=="function"?this.geometryFunction_=geometry2:typeof geometry2=="string"?this.geometryFunction_=function(feature){return feature.get(geometry2)}:geometry2?geometry2!==void 0&&(this.geometryFunction_=function(){return geometry2}):this.geometryFunction_=defaultGeometryFunction,this.geometry_=geometry2}setZIndex(zIndex){this.zIndex_=zIndex}}function toFunction(obj){let styleFunction;if(typeof obj=="function")styleFunction=obj;else{let styles;Array.isArray(obj)?styles=obj:(assert(typeof obj.getZIndex=="function","Expected an `Style` or an array of `Style`"),styles=[obj]),styleFunction=function(){return styles}}return styleFunction}let defaultStyles=null;function createDefaultStyle(feature,resolution){if(!defaultStyles){const fill=new Fill({color:"rgba(255,255,255,0.4)"}),stroke=new Stroke({color:"#3399CC",width:1.25});defaultStyles=[new Style({image:new CircleStyle({fill,stroke,radius:5}),fill,stroke})]}return defaultStyles}function defaultGeometryFunction(feature){return feature.getGeometry()}const DEFAULT_FILL_COLOR="#333";class Text{constructor(options){options=options||{},this.font_=options.font,this.rotation_=options.rotation,this.rotateWithView_=options.rotateWithView,this.keepUpright_=options.keepUpright,this.scale_=options.scale,this.scaleArray_=toSize(options.scale!==void 0?options.scale:1),this.text_=options.text,this.textAlign_=options.textAlign,this.justify_=options.justify,this.repeat_=options.repeat,this.textBaseline_=options.textBaseline,this.fill_=options.fill!==void 0?options.fill:new Fill({color:DEFAULT_FILL_COLOR}),this.maxAngle_=options.maxAngle!==void 0?options.maxAngle:Math.PI/4,this.placement_=options.placement!==void 0?options.placement:"point",this.overflow_=!!options.overflow,this.stroke_=options.stroke!==void 0?options.stroke:null,this.offsetX_=options.offsetX!==void 0?options.offsetX:0,this.offsetY_=options.offsetY!==void 0?options.offsetY:0,this.backgroundFill_=options.backgroundFill?options.backgroundFill:null,this.backgroundStroke_=options.backgroundStroke?options.backgroundStroke:null,this.padding_=options.padding===void 0?null:options.padding,this.declutterMode_=options.declutterMode}clone(){const scale2=this.getScale();return new Text({font:this.getFont(),placement:this.getPlacement(),repeat:this.getRepeat(),maxAngle:this.getMaxAngle(),overflow:this.getOverflow(),rotation:this.getRotation(),rotateWithView:this.getRotateWithView(),keepUpright:this.getKeepUpright(),scale:Array.isArray(scale2)?scale2.slice():scale2,text:this.getText(),textAlign:this.getTextAlign(),justify:this.getJustify(),textBaseline:this.getTextBaseline(),fill:this.getFill()?this.getFill().clone():void 0,stroke:this.getStroke()?this.getStroke().clone():void 0,offsetX:this.getOffsetX(),offsetY:this.getOffsetY(),backgroundFill:this.getBackgroundFill()?this.getBackgroundFill().clone():void 0,backgroundStroke:this.getBackgroundStroke()?this.getBackgroundStroke().clone():void 0,padding:this.getPadding()||void 0,declutterMode:this.getDeclutterMode()})}getOverflow(){return this.overflow_}getFont(){return this.font_}getMaxAngle(){return this.maxAngle_}getPlacement(){return this.placement_}getRepeat(){return this.repeat_}getOffsetX(){return this.offsetX_}getOffsetY(){return this.offsetY_}getFill(){return this.fill_}getRotateWithView(){return this.rotateWithView_}getKeepUpright(){return this.keepUpright_}getRotation(){return this.rotation_}getScale(){return this.scale_}getScaleArray(){return this.scaleArray_}getStroke(){return this.stroke_}getText(){return this.text_}getTextAlign(){return this.textAlign_}getJustify(){return this.justify_}getTextBaseline(){return this.textBaseline_}getBackgroundFill(){return this.backgroundFill_}getBackgroundStroke(){return this.backgroundStroke_}getPadding(){return this.padding_}getDeclutterMode(){return this.declutterMode_}setOverflow(overflow){this.overflow_=overflow}setFont(font){this.font_=font}setMaxAngle(maxAngle){this.maxAngle_=maxAngle}setOffsetX(offsetX){this.offsetX_=offsetX}setOffsetY(offsetY){this.offsetY_=offsetY}setPlacement(placement){this.placement_=placement}setRepeat(repeat){this.repeat_=repeat}setRotateWithView(rotateWithView){this.rotateWithView_=rotateWithView}setKeepUpright(keepUpright){this.keepUpright_=keepUpright}setFill(fill){this.fill_=fill}setRotation(rotation2){this.rotation_=rotation2}setScale(scale2){this.scale_=scale2,this.scaleArray_=toSize(scale2!==void 0?scale2:1)}setStroke(stroke){this.stroke_=stroke}setText(text){this.text_=text}setTextAlign(textAlign){this.textAlign_=textAlign}setJustify(justify){this.justify_=justify}setTextBaseline(textBaseline){this.textBaseline_=textBaseline}setBackgroundFill(fill){this.backgroundFill_=fill}setBackgroundStroke(stroke){this.backgroundStroke_=stroke}setPadding(padding){this.padding_=padding}}function always(context2){return!0}function rulesToStyleFunction(rules){const parsingContext=newParsingContext(),evaluator=buildRuleSet(rules,parsingContext),evaluationContext=newEvaluationContext();return function(feature,resolution){if(evaluationContext.properties=feature.getPropertiesInternal(),evaluationContext.resolution=resolution,parsingContext.featureId){const id=feature.getId();id!==void 0?evaluationContext.featureId=id:evaluationContext.featureId=null}return parsingContext.geometryType&&(evaluationContext.geometryType=computeGeometryType(feature.getGeometry())),evaluator(evaluationContext)}}function flatStylesToStyleFunction(flatStyles){const parsingContext=newParsingContext(),length2=flatStyles.length,evaluators=new Array(length2);for(let i2=0;i2<length2;++i2)evaluators[i2]=buildStyle(flatStyles[i2],parsingContext);const evaluationContext=newEvaluationContext(),styles=new Array(length2);return function(feature,resolution){if(evaluationContext.properties=feature.getPropertiesInternal(),evaluationContext.resolution=resolution,parsingContext.featureId){const id=feature.getId();id!==void 0?evaluationContext.featureId=id:evaluationContext.featureId=null}let nonNullCount=0;for(let i2=0;i2<length2;++i2){const style=evaluators[i2](evaluationContext);style&&(styles[nonNullCount]=style,nonNullCount+=1)}return styles.length=nonNullCount,styles}}function buildRuleSet(rules,context2){const length2=rules.length,compiledRules=new Array(length2);for(let i2=0;i2<length2;++i2){const rule=rules[i2],filter="filter"in rule?buildExpression(rule.filter,BooleanType,context2):always;let styles;if(Array.isArray(rule.style)){const styleLength=rule.style.length;styles=new Array(styleLength);for(let j=0;j<styleLength;++j)styles[j]=buildStyle(rule.style[j],context2)}else styles=[buildStyle(rule.style,context2)];compiledRules[i2]={filter,styles}}return function(context3){const styles=[];let someMatched=!1;for(let i2=0;i2<length2;++i2){const filterEvaluator=compiledRules[i2].filter;if(filterEvaluator(context3)&&!(rules[i2].else&&someMatched)){someMatched=!0;for(const styleEvaluator of compiledRules[i2].styles){const style=styleEvaluator(context3);style&&styles.push(style)}}}return styles}}function buildStyle(flatStyle,context2){const evaluateFill=buildFill(flatStyle,"",context2),evaluateStroke=buildStroke(flatStyle,"",context2),evaluateText=buildText(flatStyle,context2),evaluateImage=buildImage(flatStyle,context2),evaluateZIndex=numberEvaluator(flatStyle,"z-index",context2);if(!evaluateFill&&!evaluateStroke&&!evaluateText&&!evaluateImage&&!isEmpty$1(flatStyle))throw new Error("No fill, stroke, point, or text symbolizer properties in style: "+JSON.stringify(flatStyle));const style=new Style;return function(context3){let empty=!0;if(evaluateFill){const fill=evaluateFill(context3);fill&&(empty=!1),style.setFill(fill)}if(evaluateStroke){const stroke=evaluateStroke(context3);stroke&&(empty=!1),style.setStroke(stroke)}if(evaluateText){const text=evaluateText(context3);text&&(empty=!1),style.setText(text)}if(evaluateImage){const image=evaluateImage(context3);image&&(empty=!1),style.setImage(image)}return evaluateZIndex&&style.setZIndex(evaluateZIndex(context3)),empty?null:style}}function buildFill(flatStyle,prefix,context2){let evaluateColor;if(prefix+"fill-pattern-src"in flatStyle)evaluateColor=patternEvaluator(flatStyle,prefix+"fill-",context2);else{if(flatStyle[prefix+"fill-color"]==="none")return context3=>null;evaluateColor=colorLikeEvaluator(flatStyle,prefix+"fill-color",context2)}if(!evaluateColor)return null;const fill=new Fill;return function(context3){const color2=evaluateColor(context3);return color2===NO_COLOR?null:(fill.setColor(color2),fill)}}function buildStroke(flatStyle,prefix,context2){const evaluateWidth=numberEvaluator(flatStyle,prefix+"stroke-width",context2),evaluateColor=colorLikeEvaluator(flatStyle,prefix+"stroke-color",context2);if(!evaluateWidth&&!evaluateColor)return null;const evaluateLineCap=stringEvaluator(flatStyle,prefix+"stroke-line-cap",context2),evaluateLineJoin=stringEvaluator(flatStyle,prefix+"stroke-line-join",context2),evaluateLineDash=numberArrayEvaluator(flatStyle,prefix+"stroke-line-dash",context2),evaluateLineDashOffset=numberEvaluator(flatStyle,prefix+"stroke-line-dash-offset",context2),evaluateMiterLimit=numberEvaluator(flatStyle,prefix+"stroke-miter-limit",context2),stroke=new Stroke;return function(context3){if(evaluateColor){const color2=evaluateColor(context3);if(color2===NO_COLOR)return null;stroke.setColor(color2)}if(evaluateWidth&&stroke.setWidth(evaluateWidth(context3)),evaluateLineCap){const lineCap=evaluateLineCap(context3);if(lineCap!=="butt"&&lineCap!=="round"&&lineCap!=="square")throw new Error("Expected butt, round, or square line cap");stroke.setLineCap(lineCap)}if(evaluateLineJoin){const lineJoin=evaluateLineJoin(context3);if(lineJoin!=="bevel"&&lineJoin!=="round"&&lineJoin!=="miter")throw new Error("Expected bevel, round, or miter line join");stroke.setLineJoin(lineJoin)}return evaluateLineDash&&stroke.setLineDash(evaluateLineDash(context3)),evaluateLineDashOffset&&stroke.setLineDashOffset(evaluateLineDashOffset(context3)),evaluateMiterLimit&&stroke.setMiterLimit(evaluateMiterLimit(context3)),stroke}}function buildText(flatStyle,context2){const prefix="text-",evaluateValue=stringEvaluator(flatStyle,prefix+"value",context2);if(!evaluateValue)return null;const evaluateFill=buildFill(flatStyle,prefix,context2),evaluateBackgroundFill=buildFill(flatStyle,prefix+"background-",context2),evaluateStroke=buildStroke(flatStyle,prefix,context2),evaluateBackgroundStroke=buildStroke(flatStyle,prefix+"background-",context2),evaluateFont=stringEvaluator(flatStyle,prefix+"font",context2),evaluateMaxAngle=numberEvaluator(flatStyle,prefix+"max-angle",context2),evaluateOffsetX=numberEvaluator(flatStyle,prefix+"offset-x",context2),evaluateOffsetY=numberEvaluator(flatStyle,prefix+"offset-y",context2),evaluateOverflow=booleanEvaluator(flatStyle,prefix+"overflow",context2),evaluatePlacement=stringEvaluator(flatStyle,prefix+"placement",context2),evaluateRepeat=numberEvaluator(flatStyle,prefix+"repeat",context2),evaluateScale=sizeLikeEvaluator(flatStyle,prefix+"scale",context2),evaluateRotateWithView=booleanEvaluator(flatStyle,prefix+"rotate-with-view",context2),evaluateRotation=numberEvaluator(flatStyle,prefix+"rotation",context2),evaluateAlign=stringEvaluator(flatStyle,prefix+"align",context2),evaluateJustify=stringEvaluator(flatStyle,prefix+"justify",context2),evaluateBaseline=stringEvaluator(flatStyle,prefix+"baseline",context2),evaluateKeepUpright=booleanEvaluator(flatStyle,prefix+"keep-upright",context2),evaluatePadding=numberArrayEvaluator(flatStyle,prefix+"padding",context2),declutterMode=optionalDeclutterMode(flatStyle,prefix+"declutter-mode"),text=new Text({declutterMode});return function(context3){if(text.setText(evaluateValue(context3)),evaluateFill&&text.setFill(evaluateFill(context3)),evaluateBackgroundFill&&text.setBackgroundFill(evaluateBackgroundFill(context3)),evaluateStroke&&text.setStroke(evaluateStroke(context3)),evaluateBackgroundStroke&&text.setBackgroundStroke(evaluateBackgroundStroke(context3)),evaluateFont&&text.setFont(evaluateFont(context3)),evaluateMaxAngle&&text.setMaxAngle(evaluateMaxAngle(context3)),evaluateOffsetX&&text.setOffsetX(evaluateOffsetX(context3)),evaluateOffsetY&&text.setOffsetY(evaluateOffsetY(context3)),evaluateOverflow&&text.setOverflow(evaluateOverflow(context3)),evaluatePlacement){const placement=evaluatePlacement(context3);if(placement!=="point"&&placement!=="line")throw new Error("Expected point or line for text-placement");text.setPlacement(placement)}if(evaluateRepeat&&text.setRepeat(evaluateRepeat(context3)),evaluateScale&&text.setScale(evaluateScale(context3)),evaluateRotateWithView&&text.setRotateWithView(evaluateRotateWithView(context3)),evaluateRotation&&text.setRotation(evaluateRotation(context3)),evaluateAlign){const textAlign=evaluateAlign(context3);if(textAlign!=="left"&&textAlign!=="center"&&textAlign!=="right"&&textAlign!=="end"&&textAlign!=="start")throw new Error("Expected left, right, center, start, or end for text-align");text.setTextAlign(textAlign)}if(evaluateJustify){const justify=evaluateJustify(context3);if(justify!=="left"&&justify!=="right"&&justify!=="center")throw new Error("Expected left, right, or center for text-justify");text.setJustify(justify)}if(evaluateBaseline){const textBaseline=evaluateBaseline(context3);if(textBaseline!=="bottom"&&textBaseline!=="top"&&textBaseline!=="middle"&&textBaseline!=="alphabetic"&&textBaseline!=="hanging")throw new Error("Expected bottom, top, middle, alphabetic, or hanging for text-baseline");text.setTextBaseline(textBaseline)}return evaluatePadding&&text.setPadding(evaluatePadding(context3)),evaluateKeepUpright&&text.setKeepUpright(evaluateKeepUpright(context3)),text}}function buildImage(flatStyle,context2){return"icon-src"in flatStyle?buildIcon(flatStyle,context2):"shape-points"in flatStyle?buildShape(flatStyle,context2):"circle-radius"in flatStyle?buildCircle(flatStyle,context2):null}function buildIcon(flatStyle,context2){const prefix="icon-",srcName=prefix+"src",src=requireString(flatStyle[srcName],srcName),evaluateAnchor=coordinateEvaluator(flatStyle,prefix+"anchor",context2),evaluateScale=sizeLikeEvaluator(flatStyle,prefix+"scale",context2),evaluateOpacity=numberEvaluator(flatStyle,prefix+"opacity",context2),evaluateDisplacement=coordinateEvaluator(flatStyle,prefix+"displacement",context2),evaluateRotation=numberEvaluator(flatStyle,prefix+"rotation",context2),evaluateRotateWithView=booleanEvaluator(flatStyle,prefix+"rotate-with-view",context2),anchorOrigin=optionalIconOrigin(flatStyle,prefix+"anchor-origin"),anchorXUnits=optionalIconAnchorUnits(flatStyle,prefix+"anchor-x-units"),anchorYUnits=optionalIconAnchorUnits(flatStyle,prefix+"anchor-y-units"),color2=optionalColorLike(flatStyle,prefix+"color"),crossOrigin=optionalString(flatStyle,prefix+"cross-origin"),offset=optionalNumberArray(flatStyle,prefix+"offset"),offsetOrigin=optionalIconOrigin(flatStyle,prefix+"offset-origin"),width=optionalNumber(flatStyle,prefix+"width"),height=optionalNumber(flatStyle,prefix+"height"),size=optionalSize(flatStyle,prefix+"size"),declutterMode=optionalDeclutterMode(flatStyle,prefix+"declutter-mode"),icon=new Icon({src,anchorOrigin,anchorXUnits,anchorYUnits,color:color2,crossOrigin,offset,offsetOrigin,height,width,size,declutterMode});return function(context3){return evaluateOpacity&&icon.setOpacity(evaluateOpacity(context3)),evaluateDisplacement&&icon.setDisplacement(evaluateDisplacement(context3)),evaluateRotation&&icon.setRotation(evaluateRotation(context3)),evaluateRotateWithView&&icon.setRotateWithView(evaluateRotateWithView(context3)),evaluateScale&&icon.setScale(evaluateScale(context3)),evaluateAnchor&&icon.setAnchor(evaluateAnchor(context3)),icon}}function buildShape(flatStyle,context2){const prefix="shape-",pointsName=prefix+"points",radiusName=prefix+"radius",points=requireNumber(flatStyle[pointsName],pointsName),radius=requireNumber(flatStyle[radiusName],radiusName),evaluateFill=buildFill(flatStyle,prefix,context2),evaluateStroke=buildStroke(flatStyle,prefix,context2),evaluateScale=sizeLikeEvaluator(flatStyle,prefix+"scale",context2),evaluateDisplacement=coordinateEvaluator(flatStyle,prefix+"displacement",context2),evaluateRotation=numberEvaluator(flatStyle,prefix+"rotation",context2),evaluateRotateWithView=booleanEvaluator(flatStyle,prefix+"rotate-with-view",context2),radius2=optionalNumber(flatStyle,prefix+"radius2"),angle=optionalNumber(flatStyle,prefix+"angle"),declutterMode=optionalDeclutterMode(flatStyle,prefix+"declutter-mode"),shape=new RegularShape({points,radius,radius2,angle,declutterMode});return function(context3){return evaluateFill&&shape.setFill(evaluateFill(context3)),evaluateStroke&&shape.setStroke(evaluateStroke(context3)),evaluateDisplacement&&shape.setDisplacement(evaluateDisplacement(context3)),evaluateRotation&&shape.setRotation(evaluateRotation(context3)),evaluateRotateWithView&&shape.setRotateWithView(evaluateRotateWithView(context3)),evaluateScale&&shape.setScale(evaluateScale(context3)),shape}}function buildCircle(flatStyle,context2){const prefix="circle-",evaluateFill=buildFill(flatStyle,prefix,context2),evaluateStroke=buildStroke(flatStyle,prefix,context2),evaluateRadius=numberEvaluator(flatStyle,prefix+"radius",context2),evaluateScale=sizeLikeEvaluator(flatStyle,prefix+"scale",context2),evaluateDisplacement=coordinateEvaluator(flatStyle,prefix+"displacement",context2),evaluateRotation=numberEvaluator(flatStyle,prefix+"rotation",context2),evaluateRotateWithView=booleanEvaluator(flatStyle,prefix+"rotate-with-view",context2),declutterMode=optionalDeclutterMode(flatStyle,prefix+"declutter-mode"),circle=new CircleStyle({radius:5,declutterMode});return function(context3){return evaluateRadius&&circle.setRadius(evaluateRadius(context3)),evaluateFill&&circle.setFill(evaluateFill(context3)),evaluateStroke&&circle.setStroke(evaluateStroke(context3)),evaluateDisplacement&&circle.setDisplacement(evaluateDisplacement(context3)),evaluateRotation&&circle.setRotation(evaluateRotation(context3)),evaluateRotateWithView&&circle.setRotateWithView(evaluateRotateWithView(context3)),evaluateScale&&circle.setScale(evaluateScale(context3)),circle}}function numberEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return;const evaluator=buildExpression(flatStyle[name],NumberType,context2);return function(context3){return requireNumber(evaluator(context3),name)}}function stringEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],StringType,context2);return function(context3){return requireString(evaluator(context3),name)}}function patternEvaluator(flatStyle,prefix,context2){const srcEvaluator=stringEvaluator(flatStyle,prefix+"pattern-src",context2),offsetEvaluator=sizeEvaluator(flatStyle,prefix+"pattern-offset",context2),patternSizeEvaluator=sizeEvaluator(flatStyle,prefix+"pattern-size",context2),colorEvaluator=colorLikeEvaluator(flatStyle,prefix+"color",context2);return function(context3){return{src:srcEvaluator(context3),offset:offsetEvaluator&&offsetEvaluator(context3),size:patternSizeEvaluator&&patternSizeEvaluator(context3),color:colorEvaluator&&colorEvaluator(context3)}}}function booleanEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],BooleanType,context2);return function(context3){const value=evaluator(context3);if(typeof value!="boolean")throw new Error(`Expected a boolean for ${name}`);return value}}function colorLikeEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],ColorType,context2);return function(context3){return requireColorLike(evaluator(context3),name)}}function numberArrayEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],NumberArrayType,context2);return function(context3){return requireNumberArray(evaluator(context3),name)}}function coordinateEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],NumberArrayType,context2);return function(context3){const array2=requireNumberArray(evaluator(context3),name);if(array2.length!==2)throw new Error(`Expected two numbers for ${name}`);return array2}}function sizeEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],NumberArrayType,context2);return function(context3){return requireSize(evaluator(context3),name)}}function sizeLikeEvaluator(flatStyle,name,context2){if(!(name in flatStyle))return null;const evaluator=buildExpression(flatStyle[name],NumberArrayType|NumberType,context2);return function(context3){return requireSizeLike(evaluator(context3),name)}}function optionalNumber(flatStyle,property2){const value=flatStyle[property2];if(value!==void 0){if(typeof value!="number")throw new Error(`Expected a number for ${property2}`);return value}}function optionalSize(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0){if(typeof encoded=="number")return toSize(encoded);if(!Array.isArray(encoded))throw new Error(`Expected a number or size array for ${property2}`);if(encoded.length!==2||typeof encoded[0]!="number"||typeof encoded[1]!="number")throw new Error(`Expected a number or size array for ${property2}`);return encoded}}function optionalString(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0){if(typeof encoded!="string")throw new Error(`Expected a string for ${property2}`);return encoded}}function optionalIconOrigin(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0){if(encoded!=="bottom-left"&&encoded!=="bottom-right"&&encoded!=="top-left"&&encoded!=="top-right")throw new Error(`Expected bottom-left, bottom-right, top-left, or top-right for ${property2}`);return encoded}}function optionalIconAnchorUnits(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0){if(encoded!=="pixels"&&encoded!=="fraction")throw new Error(`Expected pixels or fraction for ${property2}`);return encoded}}function optionalNumberArray(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0)return requireNumberArray(encoded,property2)}function optionalDeclutterMode(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0){if(typeof encoded!="string")throw new Error(`Expected a string for ${property2}`);if(encoded!=="declutter"&&encoded!=="obstacle"&&encoded!=="none")throw new Error(`Expected declutter, obstacle, or none for ${property2}`);return encoded}}function optionalColorLike(flatStyle,property2){const encoded=flatStyle[property2];if(encoded!==void 0)return requireColorLike(encoded,property2)}function requireNumberArray(value,property2){if(!Array.isArray(value))throw new Error(`Expected an array for ${property2}`);const length2=value.length;for(let i2=0;i2<length2;++i2)if(typeof value[i2]!="number")throw new Error(`Expected an array of numbers for ${property2}`);return value}function requireString(value,property2){if(typeof value!="string")throw new Error(`Expected a string for ${property2}`);return value}function requireNumber(value,property2){if(typeof value!="number")throw new Error(`Expected a number for ${property2}`);return value}function requireColorLike(value,property2){if(typeof value=="string")return value;const array2=requireNumberArray(value,property2),length2=array2.length;if(length2<3||length2>4)throw new Error(`Expected a color with 3 or 4 values for ${property2}`);return array2}function requireSize(value,property2){const size=requireNumberArray(value,property2);if(size.length!==2)throw new Error(`Expected an array of two numbers for ${property2}`);return size}function requireSizeLike(value,property2){return typeof value=="number"?value:requireSize(value,property2)}const Property={RENDER_ORDER:"renderOrder"};class BaseVectorLayer extends Layer$1{constructor(options){options=options||{};const baseOptions=Object.assign({},options);delete baseOptions.style,delete baseOptions.renderBuffer,delete baseOptions.updateWhileAnimating,delete baseOptions.updateWhileInteracting,super(baseOptions),this.declutter_=options.declutter?String(options.declutter):void 0,this.renderBuffer_=options.renderBuffer!==void 0?options.renderBuffer:100,this.style_=null,this.styleFunction_=void 0,this.setStyle(options.style),this.updateWhileAnimating_=options.updateWhileAnimating!==void 0?options.updateWhileAnimating:!1,this.updateWhileInteracting_=options.updateWhileInteracting!==void 0?options.updateWhileInteracting:!1}getDeclutter(){return this.declutter_}getFeatures(pixel){return super.getFeatures(pixel)}getRenderBuffer(){return this.renderBuffer_}getRenderOrder(){return this.get(Property.RENDER_ORDER)}getStyle(){return this.style_}getStyleFunction(){return this.styleFunction_}getUpdateWhileAnimating(){return this.updateWhileAnimating_}getUpdateWhileInteracting(){return this.updateWhileInteracting_}renderDeclutter(frameState2,layerState){const declutterGroup=this.getDeclutter();declutterGroup in frameState2.declutter||(frameState2.declutter[declutterGroup]=new RBush(9)),this.getRenderer().renderDeclutter(frameState2,layerState)}setRenderOrder(renderOrder){this.set(Property.RENDER_ORDER,renderOrder)}setStyle(style){this.style_=style===void 0?createDefaultStyle:style;const styleLike=toStyleLike(style);this.styleFunction_=style===null?void 0:toFunction(styleLike),this.changed()}setDeclutter(declutter){this.declutter_=declutter?String(declutter):void 0,this.changed()}}function toStyleLike(style){if(style===void 0)return createDefaultStyle;if(!style)return null;if(typeof style=="function"||style instanceof Style)return style;if(!Array.isArray(style))return flatStylesToStyleFunction([style]);if(style.length===0)return[];const length2=style.length,first=style[0];if(first instanceof Style){const styles=new Array(length2);for(let i2=0;i2<length2;++i2){const candidate=style[i2];if(!(candidate instanceof Style))throw new Error("Expected a list of style instances");styles[i2]=candidate}return styles}if("style"in first){const rules=new Array(length2);for(let i2=0;i2<length2;++i2){const candidate=style[i2];if(!("style"in candidate))throw new Error("Expected a list of rules with a style property");rules[i2]=candidate}return rulesToStyleFunction(rules)}return flatStylesToStyleFunction(style)}class RenderEvent extends BaseEvent{constructor(type,inversePixelTransform,frameState2,context2){super(type),this.inversePixelTransform=inversePixelTransform,this.frameState=frameState2,this.context=context2}}class MapRenderer extends Disposable{constructor(map){super(),this.map_=map}dispatchRenderEvent(type,frameState2){abstract()}calculateMatrices2D(frameState2){const viewState=frameState2.viewState,coordinateToPixelTransform=frameState2.coordinateToPixelTransform,pixelToCoordinateTransform=frameState2.pixelToCoordinateTransform;compose(coordinateToPixelTransform,frameState2.size[0]/2,frameState2.size[1]/2,1/viewState.resolution,-1/viewState.resolution,-viewState.rotation,-viewState.center[0],-viewState.center[1]),makeInverse(pixelToCoordinateTransform,coordinateToPixelTransform)}forEachFeatureAtCoordinate(coordinate,frameState2,hitTolerance,checkWrapped,callback,thisArg,layerFilter,thisArg2){let result;const viewState=frameState2.viewState;function forEachFeatureAtCoordinate(managed,feature,layer,geometry2){return callback.call(thisArg,feature,managed?layer:null,geometry2)}const projection=viewState.projection,translatedCoordinate=wrapX$1(coordinate.slice(),projection),offsets=[[0,0]];if(projection.canWrapX()&&checkWrapped){const projectionExtent=projection.getExtent(),worldWidth=getWidth(projectionExtent);offsets.push([-worldWidth,0],[worldWidth,0])}const layerStates=frameState2.layerStatesArray,numLayers=layerStates.length,matches=[],tmpCoord=[];for(let i2=0;i2<offsets.length;i2++)for(let j=numLayers-1;j>=0;--j){const layerState=layerStates[j],layer=layerState.layer;if(layer.hasRenderer()&&inView(layerState,viewState)&&layerFilter.call(thisArg2,layer)){const layerRenderer=layer.getRenderer(),source=layer.getSource();if(layerRenderer&&source){const coordinates2=source.getWrapX()?translatedCoordinate:coordinate,callback2=forEachFeatureAtCoordinate.bind(null,layerState.managed);tmpCoord[0]=coordinates2[0]+offsets[i2][0],tmpCoord[1]=coordinates2[1]+offsets[i2][1],result=layerRenderer.forEachFeatureAtCoordinate(tmpCoord,frameState2,hitTolerance,callback2,matches)}if(result)return result}}if(matches.length===0)return;const order=1/matches.length;return matches.forEach((m,i2)=>m.distanceSq+=i2*order),matches.sort((a2,b)=>a2.distanceSq-b.distanceSq),matches.some(m=>result=m.callback(m.feature,m.layer,m.geometry)),result}hasFeatureAtCoordinate(coordinate,frameState2,hitTolerance,checkWrapped,layerFilter,thisArg){return this.forEachFeatureAtCoordinate(coordinate,frameState2,hitTolerance,checkWrapped,TRUE,this,layerFilter,thisArg)!==void 0}getMap(){return this.map_}renderFrame(frameState2){abstract()}scheduleExpireIconCache(frameState2){shared.canExpireCache()&&frameState2.postRenderFunctions.push(expireIconCache)}}function expireIconCache(map,frameState2){shared.expire()}class CompositeMapRenderer extends MapRenderer{constructor(map){super(map),this.fontChangeListenerKey_=listen(checkedFonts,ObjectEventType.PROPERTYCHANGE,map.redrawText,map),this.element_=document.createElement("div");const style=this.element_.style;style.position="absolute",style.width="100%",style.height="100%",style.zIndex="0",this.element_.className=CLASS_UNSELECTABLE+" ol-layers";const container=map.getViewport();container.insertBefore(this.element_,container.firstChild||null),this.children_=[],this.renderedVisible_=!0}dispatchRenderEvent(type,frameState2){const map=this.getMap();if(map.hasListener(type)){const event=new RenderEvent(type,void 0,frameState2);map.dispatchEvent(event)}}disposeInternal(){unlistenByKey(this.fontChangeListenerKey_),this.element_.remove(),super.disposeInternal()}renderFrame(frameState2){if(!frameState2){this.renderedVisible_&&(this.element_.style.display="none",this.renderedVisible_=!1);return}this.calculateMatrices2D(frameState2),this.dispatchRenderEvent(RenderEventType.PRECOMPOSE,frameState2);const layerStatesArray=frameState2.layerStatesArray.sort((a2,b)=>a2.zIndex-b.zIndex);layerStatesArray.some(layerState=>layerState.layer instanceof BaseVectorLayer&&layerState.layer.getDeclutter())&&(frameState2.declutter={});const viewState=frameState2.viewState;this.children_.length=0;const renderedLayerStates=[];let previousElement=null;for(let i2=0,ii=layerStatesArray.length;i2<ii;++i2){const layerState=layerStatesArray[i2];frameState2.layerIndex=i2;const layer=layerState.layer,sourceState=layer.getSourceState();if(!inView(layerState,viewState)||sourceState!="ready"&&sourceState!="undefined"){layer.unrender();continue}const element2=layer.render(frameState2,previousElement);element2&&(element2!==previousElement&&(this.children_.push(element2),previousElement=element2),renderedLayerStates.push(layerState))}this.declutter(frameState2,renderedLayerStates),replaceChildren(this.element_,this.children_),this.dispatchRenderEvent(RenderEventType.POSTCOMPOSE,frameState2),this.renderedVisible_||(this.element_.style.display="",this.renderedVisible_=!0),this.scheduleExpireIconCache(frameState2)}declutter(frameState2,layerStates){if(frameState2.declutter){for(let i2=layerStates.length-1;i2>=0;--i2){const layerState=layerStates[i2],layer=layerState.layer;layer.getDeclutter()&&layer.renderDeclutter(frameState2,layerState)}layerStates.forEach(layerState=>layerState.layer.renderDeferred(frameState2))}}}function removeLayerMapProperty(layer){if(layer instanceof Layer$1){layer.setMapInternal(null);return}layer instanceof LayerGroup&&layer.getLayers().forEach(removeLayerMapProperty)}function setLayerMapProperty(layer,map){if(layer instanceof Layer$1){layer.setMapInternal(map);return}if(layer instanceof LayerGroup){const layers2=layer.getLayers().getArray();for(let i2=0,ii=layers2.length;i2<ii;++i2)setLayerMapProperty(layers2[i2],map)}}let Map$1=class extends BaseObject{constructor(options){super(),options=options||{},this.on,this.once,this.un;const optionsInternal=createOptionsInternal(options);this.renderComplete_=!1,this.loaded_=!0,this.boundHandleBrowserEvent_=this.handleBrowserEvent.bind(this),this.maxTilesLoading_=options.maxTilesLoading!==void 0?options.maxTilesLoading:16,this.pixelRatio_=options.pixelRatio!==void 0?options.pixelRatio:DEVICE_PIXEL_RATIO,this.postRenderTimeoutHandle_,this.animationDelayKey_,this.animationDelay_=this.animationDelay_.bind(this),this.coordinateToPixelTransform_=create(),this.pixelToCoordinateTransform_=create(),this.frameIndex_=0,this.frameState_=null,this.previousExtent_=null,this.viewPropertyListenerKey_=null,this.viewChangeListenerKey_=null,this.layerGroupPropertyListenerKeys_=null,this.viewport_=document.createElement("div"),this.viewport_.className="ol-viewport"+("ontouchstart"in window?" ol-touch":""),this.viewport_.style.position="relative",this.viewport_.style.overflow="hidden",this.viewport_.style.width="100%",this.viewport_.style.height="100%",this.overlayContainer_=document.createElement("div"),this.overlayContainer_.style.position="absolute",this.overlayContainer_.style.zIndex="0",this.overlayContainer_.style.width="100%",this.overlayContainer_.style.height="100%",this.overlayContainer_.style.pointerEvents="none",this.overlayContainer_.className="ol-overlaycontainer",this.viewport_.appendChild(this.overlayContainer_),this.overlayContainerStopEvent_=document.createElement("div"),this.overlayContainerStopEvent_.style.position="absolute",this.overlayContainerStopEvent_.style.zIndex="0",this.overlayContainerStopEvent_.style.width="100%",this.overlayContainerStopEvent_.style.height="100%",this.overlayContainerStopEvent_.style.pointerEvents="none",this.overlayContainerStopEvent_.className="ol-overlaycontainer-stopevent",this.viewport_.appendChild(this.overlayContainerStopEvent_),this.mapBrowserEventHandler_=null,this.moveTolerance_=options.moveTolerance,this.keyboardEventTarget_=optionsInternal.keyboardEventTarget,this.targetChangeHandlerKeys_=null,this.targetElement_=null,this.resizeObserver_=new ResizeObserver(()=>this.updateSize()),this.controls=optionsInternal.controls||defaults$2(),this.interactions=optionsInternal.interactions||defaults$1({onFocusOnly:!0}),this.overlays_=optionsInternal.overlays,this.overlayIdIndex_={},this.renderer_=null,this.postRenderFunctions_=[],this.tileQueue_=new TileQueue(this.getTilePriority.bind(this),this.handleTileChange_.bind(this)),this.addChangeListener(MapProperty.LAYERGROUP,this.handleLayerGroupChanged_),this.addChangeListener(MapProperty.VIEW,this.handleViewChanged_),this.addChangeListener(MapProperty.SIZE,this.handleSizeChanged_),this.addChangeListener(MapProperty.TARGET,this.handleTargetChanged_),this.setProperties(optionsInternal.values);const map=this;options.view&&!(options.view instanceof View)&&options.view.then(function(viewOptions){map.setView(new View(viewOptions))}),this.controls.addEventListener(CollectionEventType.ADD,event=>{event.element.setMap(this)}),this.controls.addEventListener(CollectionEventType.REMOVE,event=>{event.element.setMap(null)}),this.interactions.addEventListener(CollectionEventType.ADD,event=>{event.element.setMap(this)}),this.interactions.addEventListener(CollectionEventType.REMOVE,event=>{event.element.setMap(null)}),this.overlays_.addEventListener(CollectionEventType.ADD,event=>{this.addOverlayInternal_(event.element)}),this.overlays_.addEventListener(CollectionEventType.REMOVE,event=>{const id=event.element.getId();id!==void 0&&delete this.overlayIdIndex_[id.toString()],event.element.setMap(null)}),this.controls.forEach(control=>{control.setMap(this)}),this.interactions.forEach(interaction=>{interaction.setMap(this)}),this.overlays_.forEach(this.addOverlayInternal_.bind(this))}addControl(control){this.getControls().push(control)}addInteraction(interaction){this.getInteractions().push(interaction)}addLayer(layer){this.getLayerGroup().getLayers().push(layer)}handleLayerAdd_(event){setLayerMapProperty(event.layer,this)}addOverlay(overlay2){this.getOverlays().push(overlay2)}addOverlayInternal_(overlay2){const id=overlay2.getId();id!==void 0&&(this.overlayIdIndex_[id.toString()]=overlay2),overlay2.setMap(this)}disposeInternal(){this.controls.clear(),this.interactions.clear(),this.overlays_.clear(),this.resizeObserver_.disconnect(),this.setTarget(null),super.disposeInternal()}forEachFeatureAtPixel(pixel,callback,options){if(!this.frameState_||!this.renderer_)return;const coordinate=this.getCoordinateFromPixelInternal(pixel);options=options!==void 0?options:{};const hitTolerance=options.hitTolerance!==void 0?options.hitTolerance:0,layerFilter=options.layerFilter!==void 0?options.layerFilter:TRUE,checkWrapped=options.checkWrapped!==!1;return this.renderer_.forEachFeatureAtCoordinate(coordinate,this.frameState_,hitTolerance,checkWrapped,callback,null,layerFilter,null)}getFeaturesAtPixel(pixel,options){const features=[];return this.forEachFeatureAtPixel(pixel,function(feature){features.push(feature)},options),features}getAllLayers(){const layers2=[];function addLayersFrom(layerGroup){layerGroup.forEach(function(layer){layer instanceof LayerGroup?addLayersFrom(layer.getLayers()):layers2.push(layer)})}return addLayersFrom(this.getLayers()),layers2}hasFeatureAtPixel(pixel,options){if(!this.frameState_||!this.renderer_)return!1;const coordinate=this.getCoordinateFromPixelInternal(pixel);options=options!==void 0?options:{};const layerFilter=options.layerFilter!==void 0?options.layerFilter:TRUE,hitTolerance=options.hitTolerance!==void 0?options.hitTolerance:0,checkWrapped=options.checkWrapped!==!1;return this.renderer_.hasFeatureAtCoordinate(coordinate,this.frameState_,hitTolerance,checkWrapped,layerFilter,null)}getEventCoordinate(event){return this.getCoordinateFromPixel(this.getEventPixel(event))}getEventCoordinateInternal(event){return this.getCoordinateFromPixelInternal(this.getEventPixel(event))}getEventPixel(event){const viewportPosition=this.viewport_.getBoundingClientRect(),viewportSize2=this.getSize(),scaleX=viewportPosition.width/viewportSize2[0],scaleY=viewportPosition.height/viewportSize2[1],eventPosition="changedTouches"in event?event.changedTouches[0]:event;return[(eventPosition.clientX-viewportPosition.left)/scaleX,(eventPosition.clientY-viewportPosition.top)/scaleY]}getTarget(){return this.get(MapProperty.TARGET)}getTargetElement(){return this.targetElement_}getCoordinateFromPixel(pixel){return toUserCoordinate(this.getCoordinateFromPixelInternal(pixel),this.getView().getProjection())}getCoordinateFromPixelInternal(pixel){const frameState2=this.frameState_;return frameState2?apply$1(frameState2.pixelToCoordinateTransform,pixel.slice()):null}getControls(){return this.controls}getOverlays(){return this.overlays_}getOverlayById(id){const overlay2=this.overlayIdIndex_[id.toString()];return overlay2!==void 0?overlay2:null}getInteractions(){return this.interactions}getLayerGroup(){return this.get(MapProperty.LAYERGROUP)}setLayers(layers2){const group=this.getLayerGroup();if(layers2 instanceof Collection){group.setLayers(layers2);return}const collection=group.getLayers();collection.clear(),collection.extend(layers2)}getLayers(){return this.getLayerGroup().getLayers()}getLoadingOrNotReady(){const layerStatesArray=this.getLayerGroup().getLayerStatesArray();for(let i2=0,ii=layerStatesArray.length;i2<ii;++i2){const state=layerStatesArray[i2];if(!state.visible)continue;const renderer=state.layer.getRenderer();if(renderer&&!renderer.ready)return!0;const source=state.layer.getSource();if(source&&source.loading)return!0}return!1}getPixelFromCoordinate(coordinate){const viewCoordinate=fromUserCoordinate(coordinate,this.getView().getProjection());return this.getPixelFromCoordinateInternal(viewCoordinate)}getPixelFromCoordinateInternal(coordinate){const frameState2=this.frameState_;return frameState2?apply$1(frameState2.coordinateToPixelTransform,coordinate.slice(0,2)):null}getRenderer(){return this.renderer_}getSize(){return this.get(MapProperty.SIZE)}getView(){return this.get(MapProperty.VIEW)}getViewport(){return this.viewport_}getOverlayContainer(){return this.overlayContainer_}getOverlayContainerStopEvent(){return this.overlayContainerStopEvent_}getOwnerDocument(){const targetElement=this.getTargetElement();return targetElement?targetElement.ownerDocument:document}getTilePriority(tile,tileSourceKey,tileCenter,tileResolution){return getTilePriority(this.frameState_,tile,tileSourceKey,tileCenter,tileResolution)}handleBrowserEvent(browserEvent,type){type=type||browserEvent.type;const mapBrowserEvent=new MapBrowserEvent(type,this,browserEvent);this.handleMapBrowserEvent(mapBrowserEvent)}handleMapBrowserEvent(mapBrowserEvent){if(!this.frameState_)return;const originalEvent=mapBrowserEvent.originalEvent,eventType=originalEvent.type;if(eventType===PointerEventType.POINTERDOWN||eventType===EventType.WHEEL||eventType===EventType.KEYDOWN){const doc2=this.getOwnerDocument(),rootNode=this.viewport_.getRootNode?this.viewport_.getRootNode():doc2,target=originalEvent.target,currentDoc=rootNode instanceof ShadowRoot?rootNode.host===target?rootNode.host.ownerDocument:rootNode:rootNode===doc2?doc2.documentElement:rootNode;if(this.overlayContainerStopEvent_.contains(target)||!currentDoc.contains(target))return}if(mapBrowserEvent.frameState=this.frameState_,this.dispatchEvent(mapBrowserEvent)!==!1){const interactionsArray=this.getInteractions().getArray().slice();for(let i2=interactionsArray.length-1;i2>=0;i2--){const interaction=interactionsArray[i2];if(interaction.getMap()!==this||!interaction.getActive()||!this.getTargetElement())continue;if(!interaction.handleEvent(mapBrowserEvent)||mapBrowserEvent.propagationStopped)break}}}handlePostRender(){const frameState2=this.frameState_,tileQueue=this.tileQueue_;if(!tileQueue.isEmpty()){let maxTotalLoading=this.maxTilesLoading_,maxNewLoads=maxTotalLoading;if(frameState2){const hints=frameState2.viewHints;if(hints[ViewHint.ANIMATING]||hints[ViewHint.INTERACTING]){const lowOnFrameBudget=Date.now()-frameState2.time>8;maxTotalLoading=lowOnFrameBudget?0:8,maxNewLoads=lowOnFrameBudget?0:2}}tileQueue.getTilesLoading()<maxTotalLoading&&(tileQueue.reprioritize(),tileQueue.loadMoreTiles(maxTotalLoading,maxNewLoads))}frameState2&&this.renderer_&&!frameState2.animate&&(this.renderComplete_?(this.hasListener(RenderEventType.RENDERCOMPLETE)&&this.renderer_.dispatchRenderEvent(RenderEventType.RENDERCOMPLETE,frameState2),this.loaded_===!1&&(this.loaded_=!0,this.dispatchEvent(new MapEvent(MapEventType.LOADEND,this,frameState2)))):this.loaded_===!0&&(this.loaded_=!1,this.dispatchEvent(new MapEvent(MapEventType.LOADSTART,this,frameState2))));const postRenderFunctions=this.postRenderFunctions_;if(frameState2)for(let i2=0,ii=postRenderFunctions.length;i2<ii;++i2)postRenderFunctions[i2](this,frameState2);postRenderFunctions.length=0}handleSizeChanged_(){this.getView()&&!this.getView().getAnimating()&&this.getView().resolveConstraints(0),this.render()}handleTargetChanged_(){if(this.mapBrowserEventHandler_){for(let i2=0,ii=this.targetChangeHandlerKeys_.length;i2<ii;++i2)unlistenByKey(this.targetChangeHandlerKeys_[i2]);this.targetChangeHandlerKeys_=null,this.viewport_.removeEventListener(EventType.CONTEXTMENU,this.boundHandleBrowserEvent_),this.viewport_.removeEventListener(EventType.WHEEL,this.boundHandleBrowserEvent_),this.mapBrowserEventHandler_.dispose(),this.mapBrowserEventHandler_=null,this.viewport_.remove()}if(this.targetElement_){this.resizeObserver_.unobserve(this.targetElement_);const rootNode=this.targetElement_.getRootNode();rootNode instanceof ShadowRoot&&this.resizeObserver_.unobserve(rootNode.host),this.setSize(void 0)}const target=this.getTarget(),targetElement=typeof target=="string"?document.getElementById(target):target;if(this.targetElement_=targetElement,!targetElement)this.renderer_&&(clearTimeout(this.postRenderTimeoutHandle_),this.postRenderTimeoutHandle_=void 0,this.postRenderFunctions_.length=0,this.renderer_.dispose(),this.renderer_=null),this.animationDelayKey_&&(cancelAnimationFrame(this.animationDelayKey_),this.animationDelayKey_=void 0);else{targetElement.appendChild(this.viewport_),this.renderer_||(this.renderer_=new CompositeMapRenderer(this)),this.mapBrowserEventHandler_=new MapBrowserEventHandler(this,this.moveTolerance_);for(const key2 in MapBrowserEventType)this.mapBrowserEventHandler_.addEventListener(MapBrowserEventType[key2],this.handleMapBrowserEvent.bind(this));this.viewport_.addEventListener(EventType.CONTEXTMENU,this.boundHandleBrowserEvent_,!1),this.viewport_.addEventListener(EventType.WHEEL,this.boundHandleBrowserEvent_,PASSIVE_EVENT_LISTENERS?{passive:!1}:!1);let keyboardEventTarget;if(this.keyboardEventTarget_)keyboardEventTarget=this.keyboardEventTarget_;else{const targetRoot=targetElement.getRootNode();keyboardEventTarget=targetRoot instanceof ShadowRoot?targetRoot.host:targetElement}this.targetChangeHandlerKeys_=[listen(keyboardEventTarget,EventType.KEYDOWN,this.handleBrowserEvent,this),listen(keyboardEventTarget,EventType.KEYPRESS,this.handleBrowserEvent,this)];const rootNode=targetElement.getRootNode();rootNode instanceof ShadowRoot&&this.resizeObserver_.observe(rootNode.host),this.resizeObserver_.observe(targetElement)}this.updateSize()}handleTileChange_(){this.render()}handleViewPropertyChanged_(){this.render()}handleViewChanged_(){this.viewPropertyListenerKey_&&(unlistenByKey(this.viewPropertyListenerKey_),this.viewPropertyListenerKey_=null),this.viewChangeListenerKey_&&(unlistenByKey(this.viewChangeListenerKey_),this.viewChangeListenerKey_=null);const view=this.getView();view&&(this.updateViewportSize_(this.getSize()),this.viewPropertyListenerKey_=listen(view,ObjectEventType.PROPERTYCHANGE,this.handleViewPropertyChanged_,this),this.viewChangeListenerKey_=listen(view,EventType.CHANGE,this.handleViewPropertyChanged_,this),view.resolveConstraints(0)),this.render()}handleLayerGroupChanged_(){this.layerGroupPropertyListenerKeys_&&(this.layerGroupPropertyListenerKeys_.forEach(unlistenByKey),this.layerGroupPropertyListenerKeys_=null);const layerGroup=this.getLayerGroup();layerGroup&&(this.handleLayerAdd_(new GroupEvent("addlayer",layerGroup)),this.layerGroupPropertyListenerKeys_=[listen(layerGroup,ObjectEventType.PROPERTYCHANGE,this.render,this),listen(layerGroup,EventType.CHANGE,this.render,this),listen(layerGroup,"addlayer",this.handleLayerAdd_,this),listen(layerGroup,"removelayer",this.handleLayerRemove_,this)]),this.render()}isRendered(){return!!this.frameState_}animationDelay_(){this.animationDelayKey_=void 0,this.renderFrame_(Date.now())}renderSync(){this.animationDelayKey_&&cancelAnimationFrame(this.animationDelayKey_),this.animationDelay_()}redrawText(){const layerStates=this.getLayerGroup().getLayerStatesArray();for(let i2=0,ii=layerStates.length;i2<ii;++i2){const layer=layerStates[i2].layer;layer.hasRenderer()&&layer.getRenderer().handleFontsChanged()}}render(){this.renderer_&&this.animationDelayKey_===void 0&&(this.animationDelayKey_=requestAnimationFrame(this.animationDelay_))}removeControl(control){return this.getControls().remove(control)}removeInteraction(interaction){return this.getInteractions().remove(interaction)}removeLayer(layer){return this.getLayerGroup().getLayers().remove(layer)}handleLayerRemove_(event){removeLayerMapProperty(event.layer)}removeOverlay(overlay2){return this.getOverlays().remove(overlay2)}renderFrame_(time2){const size=this.getSize(),view=this.getView(),previousFrameState=this.frameState_;let frameState2=null;if(size!==void 0&&hasArea(size)&&view&&view.isDef()){const viewHints=view.getHints(this.frameState_?this.frameState_.viewHints:void 0),viewState=view.getState();if(frameState2={animate:!1,coordinateToPixelTransform:this.coordinateToPixelTransform_,declutter:null,extent:getForViewAndSize(viewState.center,viewState.resolution,viewState.rotation,size),index:this.frameIndex_++,layerIndex:0,layerStatesArray:this.getLayerGroup().getLayerStatesArray(),pixelRatio:this.pixelRatio_,pixelToCoordinateTransform:this.pixelToCoordinateTransform_,postRenderFunctions:[],size,tileQueue:this.tileQueue_,time:time2,usedTiles:{},viewState,viewHints,wantedTiles:{},mapId:getUid(this),renderTargets:{}},viewState.nextCenter&&viewState.nextResolution){const rotation2=isNaN(viewState.nextRotation)?viewState.rotation:viewState.nextRotation;frameState2.nextExtent=getForViewAndSize(viewState.nextCenter,viewState.nextResolution,rotation2,size)}}this.frameState_=frameState2,this.renderer_.renderFrame(frameState2),frameState2&&(frameState2.animate&&this.render(),Array.prototype.push.apply(this.postRenderFunctions_,frameState2.postRenderFunctions),previousFrameState&&(!this.previousExtent_||!isEmpty(this.previousExtent_)&&!equals$1(frameState2.extent,this.previousExtent_))&&(this.dispatchEvent(new MapEvent(MapEventType.MOVESTART,this,previousFrameState)),this.previousExtent_=createOrUpdateEmpty(this.previousExtent_)),this.previousExtent_&&!frameState2.viewHints[ViewHint.ANIMATING]&&!frameState2.viewHints[ViewHint.INTERACTING]&&!equals$1(frameState2.extent,this.previousExtent_)&&(this.dispatchEvent(new MapEvent(MapEventType.MOVEEND,this,frameState2)),clone(frameState2.extent,this.previousExtent_))),this.dispatchEvent(new MapEvent(MapEventType.POSTRENDER,this,frameState2)),this.renderComplete_=(this.hasListener(MapEventType.LOADSTART)||this.hasListener(MapEventType.LOADEND)||this.hasListener(RenderEventType.RENDERCOMPLETE))&&!this.tileQueue_.getTilesLoading()&&!this.tileQueue_.getCount()&&!this.getLoadingOrNotReady(),this.postRenderTimeoutHandle_||(this.postRenderTimeoutHandle_=setTimeout(()=>{this.postRenderTimeoutHandle_=void 0,this.handlePostRender()},0))}setLayerGroup(layerGroup){const oldLayerGroup=this.getLayerGroup();oldLayerGroup&&this.handleLayerRemove_(new GroupEvent("removelayer",oldLayerGroup)),this.set(MapProperty.LAYERGROUP,layerGroup)}setSize(size){this.set(MapProperty.SIZE,size)}setTarget(target){this.set(MapProperty.TARGET,target)}setView(view){if(!view||view instanceof View){this.set(MapProperty.VIEW,view);return}this.set(MapProperty.VIEW,new View);const map=this;view.then(function(viewOptions){map.setView(new View(viewOptions))})}updateSize(){const targetElement=this.getTargetElement();let size;if(targetElement){const computedStyle=getComputedStyle(targetElement),width=targetElement.offsetWidth-parseFloat(computedStyle.borderLeftWidth)-parseFloat(computedStyle.paddingLeft)-parseFloat(computedStyle.paddingRight)-parseFloat(computedStyle.borderRightWidth),height=targetElement.offsetHeight-parseFloat(computedStyle.borderTopWidth)-parseFloat(computedStyle.paddingTop)-parseFloat(computedStyle.paddingBottom)-parseFloat(computedStyle.borderBottomWidth);!isNaN(width)&&!isNaN(height)&&(size=[Math.max(0,width),Math.max(0,height)],!hasArea(size)&&(targetElement.offsetWidth||targetElement.offsetHeight||targetElement.getClientRects().length)&&warn("No map visible because the map container's width or height are 0."))}const oldSize=this.getSize();size&&(!oldSize||!equals$2(size,oldSize))&&(this.setSize(size),this.updateViewportSize_(size))}updateViewportSize_(size){const view=this.getView();view&&view.setViewportSize(size)}};function createOptionsInternal(options){let keyboardEventTarget=null;options.keyboardEventTarget!==void 0&&(keyboardEventTarget=typeof options.keyboardEventTarget=="string"?document.getElementById(options.keyboardEventTarget):options.keyboardEventTarget);const values={},layerGroup=options.layers&&typeof options.layers.getLayers=="function"?options.layers:new LayerGroup({layers:options.layers});values[MapProperty.LAYERGROUP]=layerGroup,values[MapProperty.TARGET]=options.target,values[MapProperty.VIEW]=options.view instanceof View?options.view:new View;let controls;options.controls!==void 0&&(Array.isArray(options.controls)?controls=new Collection(options.controls.slice()):(assert(typeof options.controls.getArray=="function","Expected `controls` to be an array or an `ol/Collection.js`"),controls=options.controls));let interactions;options.interactions!==void 0&&(Array.isArray(options.interactions)?interactions=new Collection(options.interactions.slice()):(assert(typeof options.interactions.getArray=="function","Expected `interactions` to be an array or an `ol/Collection.js`"),interactions=options.interactions));let overlays;return options.overlays!==void 0?Array.isArray(options.overlays)?overlays=new Collection(options.overlays.slice()):(assert(typeof options.overlays.getArray=="function","Expected `overlays` to be an array or an `ol/Collection.js`"),overlays=options.overlays):overlays=new Collection,{controls,interactions,keyboardEventTarget,overlays,values}}navigator.platform.toUpperCase().indexOf("MAC")>=0;window.opr&&window.opr.addons||window.opera||navigator.userAgent.indexOf(" OPR/")>=0;navigator.userAgent.toLowerCase().includes("firefox");/constructor/i.test(window.HTMLElement)||function(p){return p.toString()==="[object SafariRemoteNotification]"}(!window.safari||typeof window.safari<"u"&&window.safari.pushNotification);window.chrome&&(window.chrome.webstore||window.chrome.runtime);const isLocal=window.location.href.indexOf("localhost")>=0||window.location.href.indexOf("192.168.")>=0;class Logger{constructor(){return Logger.instance||(this.logs=[],Logger.instance=this),Logger.instance}addLog(type,message){this.logs.push({type,message,timestamp:new Date().toISOString()})}log(message){this.addLog("info",message)}warn(message){this.addLog("warning",message)}error(message){this.addLog("error",message)}printLogs(){this.logs.forEach(log3=>{log3.type==="error"?console.error(`[${log3.timestamp}] ERROR: ${log3.message}`):log3.type==="warning"?console.warn(`[${log3.timestamp}] WARNING: ${log3.message}`):console.log(`[${log3.timestamp}] INFO: ${log3.message}`)}),this.clearLogs()}clearLogs(){this.logs=[]}}const logger=new Logger;Object.freeze(logger);function changeTimezone(date,timezone){if(!(date instanceof Date)||isNaN(date))throw new Error("Invalid date provided");try{Intl.DateTimeFormat("en-US",{timeZone:timezone})}catch{throw new Error("Invalid timezone provided")}return new Date(date.toLocaleString("en-US",{timeZone:timezone,year:"numeric",month:"2-digit",day:"2-digit",hour:"2-digit",minute:"2-digit",second:"2-digit",hour12:!1}))}class GroupData{constructor(originalData){this.id=originalData.id,this.name=originalData.name,this.order=originalData.order,this.layers=[]}addLayer(layer){this.layers.push(layer)}}class GroupDataManager{groups=[];init(data){for(const d2 of data)this.groups.push(new GroupData(d2))}getGroupByID(id){return this.groups.find(group=>group.id===id)}}const GroupManager=new GroupDataManager;class LegendType{constructor(data){this.id=data.id,this.name=data.name,this.param=data.param}toString(){return`LegendType-${this.id} ${this.name}`}}class LegendUnit{constructor(data){this.id=data.id,this.name=data.name}toString(){return`LegendUnit-${this.id} ${this.name}`}}class Legend{constructor(data){if(this.id=data.id,this.type=legendsManagerInstance.getLegendTypeByID(data.type),this.unit=legendsManagerInstance.getLegendUnitByID(data.unit),this.values=data.values,this.hexColors=data.colors_hexa,this.hexColors)for(let i2=0;i2<this.hexColors.length;i2++){const color2=this.hexColors[i2];this.hexColors[i2]=color2.length>7?`#${color2.slice(-6)}`:color2}this.textColors=data.text_hexa,this.name=this.unit.name}toString(){return`Legend-${this.id} : ${this.unit.name} ${this.type.name}`}}class LegendsManager{legends=[];types=[];units=[];init(data){for(const t2 of data.types){const legendType=new LegendType(t2);this.types.push(legendType)}for(const units of data.units)for(const u of units){const unit=new LegendUnit(u);this.units.push(unit)}for(const d2 of data.legends){const legend=new Legend(d2);this.legends.push(legend)}}getLegendTypeByID(id){return this.types.find(group=>group.id===id)}getLegendUnitByID(id){return this.units.find(group=>group.id===id)}getLegendByID(id){return this.legends.find(group=>group.id===id)}}const legendsManagerInstance=new LegendsManager;class Overlay{constructor(overlayData){this.id=overlayData.id,this.name=overlayData.name,this.hideInPlayMode=overlayData.hide_in_playmode,this.param=overlayData.param}}class OverlayManager{overlays=[];init(data){for(let i2=0;i2<data.length;i2++)for(const overlayData of data[i2])this.overlays.push(new Overlay(overlayData))}getOverlayByID(id){return this.overlays.find(group=>group.id===id)}}const OverlayManager$1=new OverlayManager;class Model{constructor(data){this.id=data.id,this.name=data.name,this.bounds=data.bounds,this.dateRunFormat=data.date_run_format,this.dateRunTZLocale=data.date_run_tz_locale,this.endDate=data.end_date,this.lastRun=data.last_run,this.lastUpdate=data.last_update,this.nextRun=data.next_run,this.nextUpdate=data.next_update,this.resolution=data.resolution,this.startDate=data.start_date,this.fallback=null,this.forecastDates=[],this.timeReference="",this.jsonLoaded=!1,this.json={}}async loadExtraData(){this.json=await load(`${modelURL.value}/${this.name}`),this.jsonLoaded=!0;const data=this.json.content.contenu.models[0];return this.fallback=data.chronologic_fallback,this.forecastDates=data.forecast_date,this.startDate=data.start_date,this.endDate=data.end_date,this.timeReference=data.time_reference,this.json}async loadParamsData(){}toString(){}}class ModelManager{models=[];init(data){for(const modelData of data){const model=new Model(modelData);this.models.push(model)}}getModelByID(id){return this.models.find(group=>group.id===id)}}const ModelManager$1=new ModelManager;class Provider{constructor(providerData){this.startDate=providerData.start_date,this.endDate=providerData.end_date,this.name=providerData.name,this.logo=providerData.logo,this.flag=providerData.flag,this.source=providerData.source,this.tileType="";const param=providerData.params[0];if(this.model=ModelManager$1.getModelByID(param.model_id),this.layerName=param.param,this.id=providerData.provider_id+"-"+this.layerName,this.legends=null,param.legends.length>0){this.legends=[];for(const legendData of param.legends){const legend=legendsManagerInstance.getLegendByID(legendData.legend_id);this.legends.push({legend,name:legendData.name})}}this.isLoaded=!1}toString(){return`Provider-${this.id} - ${this.name}: ${this.layerName}`}async loadExtraData(){await this.model.loadExtraData();let json=await load(`${modelURL.value}/${this.model.name}/${this.layerName}`);if(json=json.content.contenu.parameters[0],this.tileType=json.source_structure,this.backgroundColor=json.background_color,this.backgroundLayer=json.background_layer=="NO"?null:json.background_layer,this.foregroundLayer=json.foreground_layer=="NO"?null:json.foreground_layer,this.backgroundColor=="esri-worldimagery"&&(this.backgroundColor="BlueMarble"),this.foregroundLayer=="esri-worldimagery"&&(this.foregroundLayer="BlueMarble"),this.zoomCorrespondances=json.source_zoom_correspondance,this.zoomCorrespondances){this.minZoom=3,this.maxZoom=0;for(let i2=0;i2<this.zoomCorrespondances.length;i2++)this.minZoom=Math.min(this.zoomCorrespondances[i2],this.minZoom),this.maxZoom=Math.max(this.zoomCorrespondances[i2],this.maxZoom)}else logger.log(`No zoomCorrespondances for Model-${this.model.name} + Layer-${this.layerName}`),this.minZoom=0,this.maxZoom=0;this.foregroundLayer=json.foreground_layer,this.backgroundLayer=json.background_layer,this.backgroundLayer=="esri-worldimagery"&&(this.backgroundLayer="BlueMarble"),this.backgroundColor=json.background_color,json.legends_infos&&json.legends_infos.length>0&&(this.domain=json.legends_infos[0].domain),this.isLoaded=!0}get forecastDates(){return this.model.forecastDates}}class ProviderManager{providers=[];init(data){for(const d2 of data)this.add(d2)}add(providerData){const provider=new Provider(providerData);return this.providers.push(provider),provider}getProviderByID(id){return this.providers.find(group=>group.id===id)}}const ProviderManager$1=new ProviderManager;class Timeline{constructor(data){this.id=data.id,this.timeZone=data.debug_time_zone,this.startDate=data.start_date,this.endDate=data.end_date,this.currentDate=data.display_date,this.primaryGranularity=data.primary_granularity,this.primaryLabelFormat=data.primary_label_format,this.primaryLabelGranularity=data.primary_label_granularity,this.secondaryGranularity=data.secondary_granularity,this.secondaryLabelFormat=data.secondary_label_format,this.secondaryLabelGranularity=data.secondary_label_granularity,this.cursorGranularity=data.cursor_granularity,this.cursorFormat=data.cursor_format,this.isPlayable=data.play,this.playGranularity=data.play_granularity,this.playSpeed=data.play_speed,this.markerNow=data.marker_now}toString(){return`Timeline from ${this.startDate} to ${this.endDate}`}}function makeMap(str){const map=Object.create(null);for(const key2 of str.split(","))map[key2]=1;return val=>val in map}const EMPTY_OBJ={},NOOP=()=>{},extend=Object.assign,hasOwnProperty$1=Object.prototype.hasOwnProperty,hasOwn=(val,key2)=>hasOwnProperty$1.call(val,key2),isArray=Array.isArray,isMap=val=>toTypeString(val)==="[object Map]",isSet=val=>toTypeString(val)==="[object Set]",isFunction=val=>typeof val=="function",isString=val=>typeof val=="string",isSymbol=val=>typeof val=="symbol",isObject=val=>val!==null&&typeof val=="object",isPromise=val=>(isObject(val)||isFunction(val))&&isFunction(val.then)&&isFunction(val.catch),objectToString=Object.prototype.toString,toTypeString=value=>objectToString.call(value),toRawType=value=>toTypeString(value).slice(8,-1),isPlainObject=val=>toTypeString(val)==="[object Object]",isIntegerKey=key2=>isString(key2)&&key2!=="NaN"&&key2[0]!=="-"&&""+parseInt(key2,10)===key2,hasChanged=(value,oldValue)=>!Object.is(value,oldValue);let _globalThis;const getGlobalThis=()=>_globalThis||(_globalThis=typeof globalThis<"u"?globalThis:typeof self<"u"?self:typeof window<"u"?window:typeof global<"u"?global:{});var define_process_env_default$1={NODE_ENV:"production"};let activeSub;const pausedQueueEffects=new WeakSet;class ReactiveEffect{constructor(fn){this.fn=fn,this.deps=void 0,this.depsTail=void 0,this.flags=5,this.next=void 0,this.cleanup=void 0,this.scheduler=void 0}pause(){this.flags|=64}resume(){this.flags&64&&(this.flags&=-65,pausedQueueEffects.has(this)&&(pausedQueueEffects.delete(this),this.trigger()))}notify(){this.flags&2&&!(this.flags&32)||this.flags&8||batch(this)}run(){if(!(this.flags&1))return this.fn();this.flags|=2,cleanupEffect(this),prepareDeps(this);const prevEffect=activeSub,prevShouldTrack=shouldTrack;activeSub=this,shouldTrack=!0;try{return this.fn()}finally{cleanupDeps(this),activeSub=prevEffect,shouldTrack=prevShouldTrack,this.flags&=-3}}stop(){if(this.flags&1){for(let link=this.deps;link;link=link.nextDep)removeSub(link);this.deps=this.depsTail=void 0,cleanupEffect(this),this.onStop&&this.onStop(),this.flags&=-2}}trigger(){this.flags&64?pausedQueueEffects.add(this):this.scheduler?this.scheduler():this.runIfDirty()}runIfDirty(){isDirty(this)&&this.run()}get dirty(){return isDirty(this)}}let batchDepth=0,batchedSub,batchedComputed;function batch(sub2,isComputed=!1){if(sub2.flags|=8,isComputed){sub2.next=batchedComputed,batchedComputed=sub2;return}sub2.next=batchedSub,batchedSub=sub2}function startBatch(){batchDepth++}function endBatch(){if(--batchDepth>0)return;if(batchedComputed){let e2=batchedComputed;for(batchedComputed=void 0;e2;){const next=e2.next;e2.next=void 0,e2.flags&=-9,e2=next}}let error;for(;batchedSub;){let e2=batchedSub;for(batchedSub=void 0;e2;){const next=e2.next;if(e2.next=void 0,e2.flags&=-9,e2.flags&1)try{e2.trigger()}catch(err){error||(error=err)}e2=next}}if(error)throw error}function prepareDeps(sub2){for(let link=sub2.deps;link;link=link.nextDep)link.version=-1,link.prevActiveLink=link.dep.activeLink,link.dep.activeLink=link}function cleanupDeps(sub2){let head,tail=sub2.depsTail,link=tail;for(;link;){const prev=link.prevDep;link.version===-1?(link===tail&&(tail=prev),removeSub(link),removeDep(link)):head=link,link.dep.activeLink=link.prevActiveLink,link.prevActiveLink=void 0,link=prev}sub2.deps=head,sub2.depsTail=tail}function isDirty(sub2){for(let link=sub2.deps;link;link=link.nextDep)if(link.dep.version!==link.version||link.dep.computed&&(refreshComputed(link.dep.computed)||link.dep.version!==link.version))return!0;return!!sub2._dirty}function refreshComputed(computed2){if(computed2.flags&4&&!(computed2.flags&16)||(computed2.flags&=-17,computed2.globalVersion===globalVersion))return;computed2.globalVersion=globalVersion;const dep=computed2.dep;if(computed2.flags|=2,dep.version>0&&!computed2.isSSR&&computed2.deps&&!isDirty(computed2)){computed2.flags&=-3;return}const prevSub=activeSub,prevShouldTrack=shouldTrack;activeSub=computed2,shouldTrack=!0;try{prepareDeps(computed2);const value=computed2.fn(computed2._value);(dep.version===0||hasChanged(value,computed2._value))&&(computed2._value=value,dep.version++)}catch(err){throw dep.version++,err}finally{activeSub=prevSub,shouldTrack=prevShouldTrack,cleanupDeps(computed2),computed2.flags&=-3}}function removeSub(link,soft=!1){const{dep,prevSub,nextSub}=link;if(prevSub&&(prevSub.nextSub=nextSub,link.prevSub=void 0),nextSub&&(nextSub.prevSub=prevSub,link.nextSub=void 0),dep.subs===link&&(dep.subs=prevSub,!prevSub&&dep.computed)){dep.computed.flags&=-5;for(let l2=dep.computed.deps;l2;l2=l2.nextDep)removeSub(l2,!0)}!soft&&!--dep.sc&&dep.map&&dep.map.delete(dep.key)}function removeDep(link){const{prevDep,nextDep}=link;prevDep&&(prevDep.nextDep=nextDep,link.prevDep=void 0),nextDep&&(nextDep.prevDep=prevDep,link.nextDep=void 0)}let shouldTrack=!0;const trackStack=[];function pauseTracking(){trackStack.push(shouldTrack),shouldTrack=!1}function resetTracking(){const last=trackStack.pop();shouldTrack=last===void 0?!0:last}function cleanupEffect(e2){const{cleanup}=e2;if(e2.cleanup=void 0,cleanup){const prevSub=activeSub;activeSub=void 0;try{cleanup()}finally{activeSub=prevSub}}}let globalVersion=0;class Link{constructor(sub2,dep){this.sub=sub2,this.dep=dep,this.version=dep.version,this.nextDep=this.prevDep=this.nextSub=this.prevSub=this.prevActiveLink=void 0}}class Dep{constructor(computed2){this.computed=computed2,this.version=0,this.activeLink=void 0,this.subs=void 0,this.map=void 0,this.key=void 0,this.sc=0}track(debugInfo){if(!activeSub||!shouldTrack||activeSub===this.computed)return;let link=this.activeLink;if(link===void 0||link.sub!==activeSub)link=this.activeLink=new Link(activeSub,this),activeSub.deps?(link.prevDep=activeSub.depsTail,activeSub.depsTail.nextDep=link,activeSub.depsTail=link):activeSub.deps=activeSub.depsTail=link,addSub(link);else if(link.version===-1&&(link.version=this.version,link.nextDep)){const next=link.nextDep;next.prevDep=link.prevDep,link.prevDep&&(link.prevDep.nextDep=next),link.prevDep=activeSub.depsTail,link.nextDep=void 0,activeSub.depsTail.nextDep=link,activeSub.depsTail=link,activeSub.deps===link&&(activeSub.deps=next)}return link}trigger(debugInfo){this.version++,globalVersion++,this.notify(debugInfo)}notify(debugInfo){startBatch();try{define_process_env_default$1.NODE_ENV;for(let link=this.subs;link;link=link.prevSub)link.sub.notify()&&link.sub.dep.notify()}finally{endBatch()}}}function addSub(link){if(link.dep.sc++,link.sub.flags&4){const computed2=link.dep.computed;if(computed2&&!link.dep.subs){computed2.flags|=20;for(let l2=computed2.deps;l2;l2=l2.nextDep)addSub(l2)}const currentTail=link.dep.subs;currentTail!==link&&(link.prevSub=currentTail,currentTail&&(currentTail.nextSub=link)),link.dep.subs=link}}const targetMap=new WeakMap,ITERATE_KEY=Symbol(""),MAP_KEY_ITERATE_KEY=Symbol(""),ARRAY_ITERATE_KEY=Symbol("");function track(target,type,key2){if(shouldTrack&&activeSub){let depsMap=targetMap.get(target);depsMap||targetMap.set(target,depsMap=new Map);let dep=depsMap.get(key2);dep||(depsMap.set(key2,dep=new Dep),dep.map=depsMap,dep.key=key2),dep.track()}}function trigger(target,type,key2,newValue,oldValue,oldTarget){const depsMap=targetMap.get(target);if(!depsMap){globalVersion++;return}const run=dep=>{dep&&dep.trigger()};if(startBatch(),type==="clear")depsMap.forEach(run);else{const targetIsArray=isArray(target),isArrayIndex=targetIsArray&&isIntegerKey(key2);if(targetIsArray&&key2==="length"){const newLength=Number(newValue);depsMap.forEach((dep,key22)=>{(key22==="length"||key22===ARRAY_ITERATE_KEY||!isSymbol(key22)&&key22>=newLength)&&run(dep)})}else switch((key2!==void 0||depsMap.has(void 0))&&run(depsMap.get(key2)),isArrayIndex&&run(depsMap.get(ARRAY_ITERATE_KEY)),type){case"add":targetIsArray?isArrayIndex&&run(depsMap.get("length")):(run(depsMap.get(ITERATE_KEY)),isMap(target)&&run(depsMap.get(MAP_KEY_ITERATE_KEY)));break;case"delete":targetIsArray||(run(depsMap.get(ITERATE_KEY)),isMap(target)&&run(depsMap.get(MAP_KEY_ITERATE_KEY)));break;case"set":isMap(target)&&run(depsMap.get(ITERATE_KEY));break}}endBatch()}function reactiveReadArray(array2){const raw=toRaw(array2);return raw===array2?raw:(track(raw,"iterate",ARRAY_ITERATE_KEY),isShallow(array2)?raw:raw.map(toReactive))}function shallowReadArray(arr){return track(arr=toRaw(arr),"iterate",ARRAY_ITERATE_KEY),arr}const arrayInstrumentations={__proto__:null,[Symbol.iterator](){return iterator(this,Symbol.iterator,toReactive)},concat(...args){return reactiveReadArray(this).concat(...args.map(x=>isArray(x)?reactiveReadArray(x):x))},entries(){return iterator(this,"entries",value=>(value[1]=toReactive(value[1]),value))},every(fn,thisArg){return apply(this,"every",fn,thisArg,void 0,arguments)},filter(fn,thisArg){return apply(this,"filter",fn,thisArg,v=>v.map(toReactive),arguments)},find(fn,thisArg){return apply(this,"find",fn,thisArg,toReactive,arguments)},findIndex(fn,thisArg){return apply(this,"findIndex",fn,thisArg,void 0,arguments)},findLast(fn,thisArg){return apply(this,"findLast",fn,thisArg,toReactive,arguments)},findLastIndex(fn,thisArg){return apply(this,"findLastIndex",fn,thisArg,void 0,arguments)},forEach(fn,thisArg){return apply(this,"forEach",fn,thisArg,void 0,arguments)},includes(...args){return searchProxy(this,"includes",args)},indexOf(...args){return searchProxy(this,"indexOf",args)},join(separator){return reactiveReadArray(this).join(separator)},lastIndexOf(...args){return searchProxy(this,"lastIndexOf",args)},map(fn,thisArg){return apply(this,"map",fn,thisArg,void 0,arguments)},pop(){return noTracking(this,"pop")},push(...args){return noTracking(this,"push",args)},reduce(fn,...args){return reduce(this,"reduce",fn,args)},reduceRight(fn,...args){return reduce(this,"reduceRight",fn,args)},shift(){return noTracking(this,"shift")},some(fn,thisArg){return apply(this,"some",fn,thisArg,void 0,arguments)},splice(...args){return noTracking(this,"splice",args)},toReversed(){return reactiveReadArray(this).toReversed()},toSorted(comparer){return reactiveReadArray(this).toSorted(comparer)},toSpliced(...args){return reactiveReadArray(this).toSpliced(...args)},unshift(...args){return noTracking(this,"unshift",args)},values(){return iterator(this,"values",toReactive)}};function iterator(self2,method,wrapValue){const arr=shallowReadArray(self2),iter=arr[method]();return arr!==self2&&!isShallow(self2)&&(iter._next=iter.next,iter.next=()=>{const result=iter._next();return result.value&&(result.value=wrapValue(result.value)),result}),iter}const arrayProto=Array.prototype;function apply(self2,method,fn,thisArg,wrappedRetFn,args){const arr=shallowReadArray(self2),needsWrap=arr!==self2&&!isShallow(self2),methodFn=arr[method];if(methodFn!==arrayProto[method]){const result2=methodFn.apply(self2,args);return needsWrap?toReactive(result2):result2}let wrappedFn=fn;arr!==self2&&(needsWrap?wrappedFn=function(item,index){return fn.call(this,toReactive(item),index,self2)}:fn.length>2&&(wrappedFn=function(item,index){return fn.call(this,item,index,self2)}));const result=methodFn.call(arr,wrappedFn,thisArg);return needsWrap&&wrappedRetFn?wrappedRetFn(result):result}function reduce(self2,method,fn,args){const arr=shallowReadArray(self2);let wrappedFn=fn;return arr!==self2&&(isShallow(self2)?fn.length>3&&(wrappedFn=function(acc,item,index){return fn.call(this,acc,item,index,self2)}):wrappedFn=function(acc,item,index){return fn.call(this,acc,toReactive(item),index,self2)}),arr[method](wrappedFn,...args)}function searchProxy(self2,method,args){const arr=toRaw(self2);track(arr,"iterate",ARRAY_ITERATE_KEY);const res=arr[method](...args);return(res===-1||res===!1)&&isProxy(args[0])?(args[0]=toRaw(args[0]),arr[method](...args)):res}function noTracking(self2,method,args=[]){pauseTracking(),startBatch();const res=toRaw(self2)[method].apply(self2,args);return endBatch(),resetTracking(),res}const isNonTrackableKeys=makeMap("__proto__,__v_isRef,__isVue"),builtInSymbols=new Set(Object.getOwnPropertyNames(Symbol).filter(key2=>key2!=="arguments"&&key2!=="caller").map(key2=>Symbol[key2]).filter(isSymbol));function hasOwnProperty(key2){isSymbol(key2)||(key2=String(key2));const obj=toRaw(this);return track(obj,"has",key2),obj.hasOwnProperty(key2)}class BaseReactiveHandler{constructor(_isReadonly=!1,_isShallow=!1){this._isReadonly=_isReadonly,this._isShallow=_isShallow}get(target,key2,receiver){if(key2==="__v_skip")return target.__v_skip;const isReadonly2=this._isReadonly,isShallow2=this._isShallow;if(key2==="__v_isReactive")return!isReadonly2;if(key2==="__v_isReadonly")return isReadonly2;if(key2==="__v_isShallow")return isShallow2;if(key2==="__v_raw")return receiver===(isReadonly2?isShallow2?shallowReadonlyMap:readonlyMap:isShallow2?shallowReactiveMap:reactiveMap).get(target)||Object.getPrototypeOf(target)===Object.getPrototypeOf(receiver)?target:void 0;const targetIsArray=isArray(target);if(!isReadonly2){let fn;if(targetIsArray&&(fn=arrayInstrumentations[key2]))return fn;if(key2==="hasOwnProperty")return hasOwnProperty}const res=Reflect.get(target,key2,isRef(target)?target:receiver);return(isSymbol(key2)?builtInSymbols.has(key2):isNonTrackableKeys(key2))||(isReadonly2||track(target,"get",key2),isShallow2)?res:isRef(res)?targetIsArray&&isIntegerKey(key2)?res:res.value:isObject(res)?isReadonly2?readonly(res):reactive(res):res}}class MutableReactiveHandler extends BaseReactiveHandler{constructor(isShallow2=!1){super(!1,isShallow2)}set(target,key2,value,receiver){let oldValue=target[key2];if(!this._isShallow){const isOldValueReadonly=isReadonly(oldValue);if(!isShallow(value)&&!isReadonly(value)&&(oldValue=toRaw(oldValue),value=toRaw(value)),!isArray(target)&&isRef(oldValue)&&!isRef(value))return isOldValueReadonly?!1:(oldValue.value=value,!0)}const hadKey=isArray(target)&&isIntegerKey(key2)?Number(key2)<target.length:hasOwn(target,key2),result=Reflect.set(target,key2,value,isRef(target)?target:receiver);return target===toRaw(receiver)&&(hadKey?hasChanged(value,oldValue)&&trigger(target,"set",key2,value):trigger(target,"add",key2,value)),result}deleteProperty(target,key2){const hadKey=hasOwn(target,key2);target[key2];const result=Reflect.deleteProperty(target,key2);return result&&hadKey&&trigger(target,"delete",key2,void 0),result}has(target,key2){const result=Reflect.has(target,key2);return(!isSymbol(key2)||!builtInSymbols.has(key2))&&track(target,"has",key2),result}ownKeys(target){return track(target,"iterate",isArray(target)?"length":ITERATE_KEY),Reflect.ownKeys(target)}}class ReadonlyReactiveHandler extends BaseReactiveHandler{constructor(isShallow2=!1){super(!0,isShallow2)}set(target,key2){return!0}deleteProperty(target,key2){return!0}}const mutableHandlers=new MutableReactiveHandler,readonlyHandlers=new ReadonlyReactiveHandler,toShallow=value=>value,getProto=v=>Reflect.getPrototypeOf(v);function createIterableMethod(method,isReadonly2,isShallow2){return function(...args){const target=this.__v_raw,rawTarget=toRaw(target),targetIsMap=isMap(rawTarget),isPair=method==="entries"||method===Symbol.iterator&&targetIsMap,isKeyOnly=method==="keys"&&targetIsMap,innerIterator=target[method](...args),wrap2=isShallow2?toShallow:isReadonly2?toReadonly:toReactive;return!isReadonly2&&track(rawTarget,"iterate",isKeyOnly?MAP_KEY_ITERATE_KEY:ITERATE_KEY),{next(){const{value,done}=innerIterator.next();return done?{value,done}:{value:isPair?[wrap2(value[0]),wrap2(value[1])]:wrap2(value),done}},[Symbol.iterator](){return this}}}}function createReadonlyMethod(type){return function(...args){return type==="delete"?!1:type==="clear"?void 0:this}}function createInstrumentations(readonly2,shallow){const instrumentations={get(key2){const target=this.__v_raw,rawTarget=toRaw(target),rawKey=toRaw(key2);readonly2||(hasChanged(key2,rawKey)&&track(rawTarget,"get",key2),track(rawTarget,"get",rawKey));const{has}=getProto(rawTarget),wrap2=shallow?toShallow:readonly2?toReadonly:toReactive;if(has.call(rawTarget,key2))return wrap2(target.get(key2));if(has.call(rawTarget,rawKey))return wrap2(target.get(rawKey));target!==rawTarget&&target.get(key2)},get size(){const target=this.__v_raw;return!readonly2&&track(toRaw(target),"iterate",ITERATE_KEY),Reflect.get(target,"size",target)},has(key2){const target=this.__v_raw,rawTarget=toRaw(target),rawKey=toRaw(key2);return readonly2||(hasChanged(key2,rawKey)&&track(rawTarget,"has",key2),track(rawTarget,"has",rawKey)),key2===rawKey?target.has(key2):target.has(key2)||target.has(rawKey)},forEach(callback,thisArg){const observed=this,target=observed.__v_raw,rawTarget=toRaw(target),wrap2=shallow?toShallow:readonly2?toReadonly:toReactive;return!readonly2&&track(rawTarget,"iterate",ITERATE_KEY),target.forEach((value,key2)=>callback.call(thisArg,wrap2(value),wrap2(key2),observed))}};return extend(instrumentations,readonly2?{add:createReadonlyMethod("add"),set:createReadonlyMethod("set"),delete:createReadonlyMethod("delete"),clear:createReadonlyMethod("clear")}:{add(value){!shallow&&!isShallow(value)&&!isReadonly(value)&&(value=toRaw(value));const target=toRaw(this);return getProto(target).has.call(target,value)||(target.add(value),trigger(target,"add",value,value)),this},set(key2,value){!shallow&&!isShallow(value)&&!isReadonly(value)&&(value=toRaw(value));const target=toRaw(this),{has,get:get2}=getProto(target);let hadKey=has.call(target,key2);hadKey||(key2=toRaw(key2),hadKey=has.call(target,key2));const oldValue=get2.call(target,key2);return target.set(key2,value),hadKey?hasChanged(value,oldValue)&&trigger(target,"set",key2,value):trigger(target,"add",key2,value),this},delete(key2){const target=toRaw(this),{has,get:get2}=getProto(target);let hadKey=has.call(target,key2);hadKey||(key2=toRaw(key2),hadKey=has.call(target,key2)),get2&&get2.call(target,key2);const result=target.delete(key2);return hadKey&&trigger(target,"delete",key2,void 0),result},clear(){const target=toRaw(this),hadItems=target.size!==0,result=target.clear();return hadItems&&trigger(target,"clear",void 0,void 0),result}}),["keys","values","entries",Symbol.iterator].forEach(method=>{instrumentations[method]=createIterableMethod(method,readonly2,shallow)}),instrumentations}function createInstrumentationGetter(isReadonly2,shallow){const instrumentations=createInstrumentations(isReadonly2,shallow);return(target,key2,receiver)=>key2==="__v_isReactive"?!isReadonly2:key2==="__v_isReadonly"?isReadonly2:key2==="__v_raw"?target:Reflect.get(hasOwn(instrumentations,key2)&&key2 in target?instrumentations:target,key2,receiver)}const mutableCollectionHandlers={get:createInstrumentationGetter(!1,!1)},readonlyCollectionHandlers={get:createInstrumentationGetter(!0,!1)},reactiveMap=new WeakMap,shallowReactiveMap=new WeakMap,readonlyMap=new WeakMap,shallowReadonlyMap=new WeakMap;function targetTypeMap(rawType){switch(rawType){case"Object":case"Array":return 1;case"Map":case"Set":case"WeakMap":case"WeakSet":return 2;default:return 0}}function getTargetType(value){return value.__v_skip||!Object.isExtensible(value)?0:targetTypeMap(toRawType(value))}function reactive(target){return isReadonly(target)?target:createReactiveObject(target,!1,mutableHandlers,mutableCollectionHandlers,reactiveMap)}function readonly(target){return createReactiveObject(target,!0,readonlyHandlers,readonlyCollectionHandlers,readonlyMap)}function createReactiveObject(target,isReadonly2,baseHandlers,collectionHandlers,proxyMap){if(!isObject(target)||target.__v_raw&&!(isReadonly2&&target.__v_isReactive))return target;const existingProxy=proxyMap.get(target);if(existingProxy)return existingProxy;const targetType=getTargetType(target);if(targetType===0)return target;const proxy2=new Proxy(target,targetType===2?collectionHandlers:baseHandlers);return proxyMap.set(target,proxy2),proxy2}function isReactive(value){return isReadonly(value)?isReactive(value.__v_raw):!!(value&&value.__v_isReactive)}function isReadonly(value){return!!(value&&value.__v_isReadonly)}function isShallow(value){return!!(value&&value.__v_isShallow)}function isProxy(value){return value?!!value.__v_raw:!1}function toRaw(observed){const raw=observed&&observed.__v_raw;return raw?toRaw(raw):observed}const toReactive=value=>isObject(value)?reactive(value):value,toReadonly=value=>isObject(value)?readonly(value):value;function isRef(r2){return r2?r2.__v_isRef===!0:!1}function ref(value){return createRef(value,!1)}function createRef(rawValue,shallow){return isRef(rawValue)?rawValue:new RefImpl(rawValue,shallow)}class RefImpl{constructor(value,isShallow2){this.dep=new Dep,this.__v_isRef=!0,this.__v_isShallow=!1,this._rawValue=isShallow2?value:toRaw(value),this._value=isShallow2?value:toReactive(value),this.__v_isShallow=isShallow2}get value(){return this.dep.track(),this._value}set value(newValue){const oldValue=this._rawValue,useDirectValue=this.__v_isShallow||isShallow(newValue)||isReadonly(newValue);newValue=useDirectValue?newValue:toRaw(newValue),hasChanged(newValue,oldValue)&&(this._rawValue=newValue,this._value=useDirectValue?newValue:toReactive(newValue),this.dep.trigger())}}const INITIAL_WATCHER_VALUE={},cleanupMap=new WeakMap;let activeWatcher;function onWatcherCleanup(cleanupFn,failSilently=!1,owner=activeWatcher){if(owner){let cleanups=cleanupMap.get(owner);cleanups||cleanupMap.set(owner,cleanups=[]),cleanups.push(cleanupFn)}}function watch$1(source,cb,options=EMPTY_OBJ){const{immediate,deep,once,scheduler,augmentJob,call:call2}=options,reactiveGetter=source2=>deep?source2:isShallow(source2)||deep===!1||deep===0?traverse(source2,1):traverse(source2);let effect2,getter,cleanup,boundCleanup,forceTrigger=!1,isMultiSource=!1;if(isRef(source)?(getter=()=>source.value,forceTrigger=isShallow(source)):isReactive(source)?(getter=()=>reactiveGetter(source),forceTrigger=!0):isArray(source)?(isMultiSource=!0,forceTrigger=source.some(s2=>isReactive(s2)||isShallow(s2)),getter=()=>source.map(s2=>{if(isRef(s2))return s2.value;if(isReactive(s2))return reactiveGetter(s2);if(isFunction(s2))return call2?call2(s2,2):s2()})):isFunction(source)?cb?getter=call2?()=>call2(source,2):source:getter=()=>{if(cleanup){pauseTracking();try{cleanup()}finally{resetTracking()}}const currentEffect=activeWatcher;activeWatcher=effect2;try{return call2?call2(source,3,[boundCleanup]):source(boundCleanup)}finally{activeWatcher=currentEffect}}:getter=NOOP,cb&&deep){const baseGetter=getter,depth2=deep===!0?1/0:deep;getter=()=>traverse(baseGetter(),depth2)}const watchHandle=()=>{effect2.stop()};if(once&&cb){const _cb=cb;cb=(...args)=>{_cb(...args),watchHandle()}}let oldValue=isMultiSource?new Array(source.length).fill(INITIAL_WATCHER_VALUE):INITIAL_WATCHER_VALUE;const job=immediateFirstRun=>{if(!(!(effect2.flags&1)||!effect2.dirty&&!immediateFirstRun))if(cb){const newValue=effect2.run();if(deep||forceTrigger||(isMultiSource?newValue.some((v,i2)=>hasChanged(v,oldValue[i2])):hasChanged(newValue,oldValue))){cleanup&&cleanup();const currentWatcher=activeWatcher;activeWatcher=effect2;try{const args=[newValue,oldValue===INITIAL_WATCHER_VALUE?void 0:isMultiSource&&oldValue[0]===INITIAL_WATCHER_VALUE?[]:oldValue,boundCleanup];call2?call2(cb,3,args):cb(...args),oldValue=newValue}finally{activeWatcher=currentWatcher}}}else effect2.run()};return augmentJob&&augmentJob(job),effect2=new ReactiveEffect(getter),effect2.scheduler=scheduler?()=>scheduler(job,!1):job,boundCleanup=fn=>onWatcherCleanup(fn,!1,effect2),cleanup=effect2.onStop=()=>{const cleanups=cleanupMap.get(effect2);if(cleanups){if(call2)call2(cleanups,4);else for(const cleanup2 of cleanups)cleanup2();cleanupMap.delete(effect2)}},cb?immediate?job(!0):oldValue=effect2.run():scheduler?scheduler(job.bind(null,!0),!0):effect2.run(),watchHandle.pause=effect2.pause.bind(effect2),watchHandle.resume=effect2.resume.bind(effect2),watchHandle.stop=watchHandle,watchHandle}function traverse(value,depth2=1/0,seen){if(depth2<=0||!isObject(value)||value.__v_skip||(seen=seen||new Set,seen.has(value)))return value;if(seen.add(value),depth2--,isRef(value))traverse(value.value,depth2,seen);else if(isArray(value))for(let i2=0;i2<value.length;i2++)traverse(value[i2],depth2,seen);else if(isSet(value)||isMap(value))value.forEach(v=>{traverse(v,depth2,seen)});else if(isPlainObject(value)){for(const key2 in value)traverse(value[key2],depth2,seen);for(const key2 of Object.getOwnPropertySymbols(value))Object.prototype.propertyIsEnumerable.call(value,key2)&&traverse(value[key2],depth2,seen)}return value}var define_process_env_default={NODE_ENV:"production"};function callWithErrorHandling(fn,instance2,type,args){try{return args?fn(...args):fn()}catch(err){handleError(err,instance2,type)}}function callWithAsyncErrorHandling(fn,instance2,type,args){if(isFunction(fn)){const res=callWithErrorHandling(fn,instance2,type,args);return res&&isPromise(res)&&res.catch(err=>{handleError(err,instance2,type)}),res}if(isArray(fn)){const values=[];for(let i2=0;i2<fn.length;i2++)values.push(callWithAsyncErrorHandling(fn[i2],instance2,type,args));return values}}function handleError(err,instance2,type,throwInDev=!0){const contextVNode=instance2?instance2.vnode:null,{errorHandler,throwUnhandledErrorInProduction}=instance2&&instance2.appContext.config||EMPTY_OBJ;if(instance2){let cur=instance2.parent;const exposedInstance=instance2.proxy,errorInfo=`https://vuejs.org/error-reference/#runtime-${type}`;for(;cur;){const errorCapturedHooks=cur.ec;if(errorCapturedHooks){for(let i2=0;i2<errorCapturedHooks.length;i2++)if(errorCapturedHooks[i2](err,exposedInstance,errorInfo)===!1)return}cur=cur.parent}if(errorHandler){pauseTracking(),callWithErrorHandling(errorHandler,null,10,[err,exposedInstance,errorInfo]),resetTracking();return}}logError(err,type,contextVNode,throwInDev,throwUnhandledErrorInProduction)}function logError(err,type,contextVNode,throwInDev=!0,throwInProd=!1){if(throwInProd)throw err;console.error(err)}const queue=[];let flushIndex=-1;const pendingPostFlushCbs=[];let activePostFlushCbs=null,postFlushIndex=0;const resolvedPromise=Promise.resolve();let currentFlushPromise=null;function findInsertionIndex(id){let start=flushIndex+1,end=queue.length;for(;start<end;){const middle=start+end>>>1,middleJob=queue[middle],middleJobId=getId(middleJob);middleJobId<id||middleJobId===id&&middleJob.flags&2?start=middle+1:end=middle}return start}function queueJob(job){if(!(job.flags&1)){const jobId=getId(job),lastJob=queue[queue.length-1];!lastJob||!(job.flags&2)&&jobId>=getId(lastJob)?queue.push(job):queue.splice(findInsertionIndex(jobId),0,job),job.flags|=1,queueFlush()}}function queueFlush(){currentFlushPromise||(currentFlushPromise=resolvedPromise.then(flushJobs))}function queuePostFlushCb(cb){isArray(cb)?pendingPostFlushCbs.push(...cb):activePostFlushCbs&&cb.id===-1?activePostFlushCbs.splice(postFlushIndex+1,0,cb):cb.flags&1||(pendingPostFlushCbs.push(cb),cb.flags|=1),queueFlush()}function flushPostFlushCbs(seen){if(pendingPostFlushCbs.length){const deduped=[...new Set(pendingPostFlushCbs)].sort((a2,b)=>getId(a2)-getId(b));if(pendingPostFlushCbs.length=0,activePostFlushCbs){activePostFlushCbs.push(...deduped);return}for(activePostFlushCbs=deduped,postFlushIndex=0;postFlushIndex<activePostFlushCbs.length;postFlushIndex++){const cb=activePostFlushCbs[postFlushIndex];cb.flags&4&&(cb.flags&=-2),cb.flags&8||cb(),cb.flags&=-2}activePostFlushCbs=null,postFlushIndex=0}}const getId=job=>job.id==null?job.flags&2?-1:1/0:job.id;function flushJobs(seen){const check=NOOP;try{for(flushIndex=0;flushIndex<queue.length;flushIndex++){const job=queue[flushIndex];job&&!(job.flags&8)&&(define_process_env_default.NODE_ENV!=="production"&&check(job),job.flags&4&&(job.flags&=-2),callWithErrorHandling(job,job.i,job.i?15:14),job.flags&4||(job.flags&=-2))}}finally{for(;flushIndex<queue.length;flushIndex++){const job=queue[flushIndex];job&&(job.flags&=-2)}flushIndex=-1,queue.length=0,flushPostFlushCbs(),currentFlushPromise=null,(queue.length||pendingPostFlushCbs.length)&&flushJobs()}}let currentRenderingInstance=null;getGlobalThis().requestIdleCallback;getGlobalThis().cancelIdleCallback;let currentApp=null;function inject(key2,defaultValue,treatDefaultAsFactory=!1){const instance2=currentInstance||currentRenderingInstance;if(instance2||currentApp){const provides=instance2?instance2.parent==null?instance2.vnode.appContext&&instance2.vnode.appContext.provides:instance2.parent.provides:void 0;if(provides&&key2 in provides)return provides[key2];if(arguments.length>1)return treatDefaultAsFactory&&isFunction(defaultValue)?defaultValue.call(instance2&&instance2.proxy):defaultValue}}const queuePostRenderEffect=queueEffectWithSuspense,ssrContextKey=Symbol.for("v-scx"),useSSRContext=()=>inject(ssrContextKey);function watch(source,cb,options){return doWatch(source,cb,options)}function doWatch(source,cb,options=EMPTY_OBJ){const{immediate,deep,flush,once}=options,baseWatchOptions=extend({},options),runsImmediately=cb&&immediate||!cb&&flush!=="post";let ssrCleanup;if(isInSSRComponentSetup){if(flush==="sync"){const ctx=useSSRContext();ssrCleanup=ctx.__watcherHandles||(ctx.__watcherHandles=[])}else if(!runsImmediately){const watchStopHandle=()=>{};return watchStopHandle.stop=NOOP,watchStopHandle.resume=NOOP,watchStopHandle.pause=NOOP,watchStopHandle}}const instance2=currentInstance;baseWatchOptions.call=(fn,type,args)=>callWithAsyncErrorHandling(fn,instance2,type,args);let isPre=!1;flush==="post"?baseWatchOptions.scheduler=job=>{queuePostRenderEffect(job,instance2&&instance2.suspense)}:flush!=="sync"&&(isPre=!0,baseWatchOptions.scheduler=(job,isFirstRun)=>{isFirstRun?job():queueJob(job)}),baseWatchOptions.augmentJob=job=>{cb&&(job.flags|=4),isPre&&(job.flags|=2,instance2&&(job.id=instance2.uid,job.i=instance2))};const watchHandle=watch$1(source,cb,baseWatchOptions);return isInSSRComponentSetup&&(ssrCleanup?ssrCleanup.push(watchHandle):runsImmediately&&watchHandle()),watchHandle}function queueEffectWithSuspense(fn,suspense){suspense&&suspense.pendingBranch?isArray(fn)?suspense.effects.push(...fn):suspense.effects.push(fn):queuePostFlushCb(fn)}let currentInstance=null;{const g=getGlobalThis(),registerGlobalSetter=(key2,setter)=>{let setters;return(setters=g[key2])||(setters=g[key2]=[]),setters.push(setter),v=>{setters.length>1?setters.forEach(set=>set(v)):setters[0](v)}};registerGlobalSetter("__VUE_INSTANCE_SETTERS__",v=>currentInstance=v),registerGlobalSetter("__VUE_SSR_SETTERS__",v=>isInSSRComponentSetup=v)}let isInSSRComponentSetup=!1;class LayerData{constructor(){this.baseUrl=tilesURL.value,this.imageFormat="webp",this.name="name not defined",this.paramName="",this.legends=null,this.timeline=null,this.providers=[],this.overlays=[],this.zoomFactor=4,this.sizeFactor=1,this.stepForecast=5,this.fadeDuration=.6,this.delayBetween=0,this.opticalFlowLayer=null,this.selectedProvider=ref({}),this.isImgLayer=!1,this.colorOptions={srgb:!1,blur:2,stepColor:0,blending:"normal",gradientMode:"non-linear",useGradient:!0,blackIsAlpha:!1,blueIsAlpha:!1},this.minZoom=3,this.maxZoom=13,this.type="dataTile"}initFromData=async data=>(this.id=data.id,this.name=data.name,this.timeline=new Timeline(data.timeline),this.initGroups(data),this.initOverlays(data),this.initLegends(data),this.initProviders(data),this.selectedProvider.value=this.providers.length>0?this.providers[0]:null,this.selectedProvider.value||logger.warn(`[WARNING] : Layer-${this.id} ${this.name} - No Provider found`),new Promise(async(resolve,reject)=>{switch(await this.loadExtraData(),this.name){case"cloud_t":this.colorOptions.blueIsAlpha=!0,this.colorOptions.useGradient=!1,this.colorOptions.blur=1;break;case"prmsl":this.colorOptions.blur=8,this.stepForecast=3;break;case"vaguemax_cm":this.colorOptions.srgb=!1;break;case"radar":this.baseUrl="https://static1.mclcm.net/images/dynmap/obs",this.colorOptions.blur=0,this.zoomFactor=1,this.stepForecast=1,this.fadeDuration=.2,this.overrideRenderOrder=5e5,this.colorOptions.gradientMode="non-linear",this.colorOptions.blackIsAlpha=!0;break;case"vaguemax_cm":case"vague_cm":this.colorOptions.particleMask=!0;break;case"eumetsat":this.baseUrl="https://static1.mclcm.net/images/dynmap/obs",this.colorOptions.blur=0,this.fadeDuration=.6,this.zoomFactor=1,this.stepForecast=1,this.imageFormat="webp",this.overrideRenderOrder=499999;break;case"precip":this.colorOptions.alphaMode="multiply",this.colorOptions.gradientMode="non-linear",this.colorOptions.powPercent=2,this.colorOptions.discardAlpha=!0,this.colorOptions.blur=2,this.fadeDuration=.2,this.zoomFactor=4,this.stepForecast=2,this.colorOptions.blackIsAlpha=!0;break;case"cumul_precip_hloc":this.colorOptions.alphaMode="multiply",this.colorOptions.gradientMode="non-linear",this.colorOptions.powPercent=2,this.colorOptions.discardAlpha=!0,this.colorOptions.blur=2,this.fadeDuration=.2,this.zoomFactor=4,this.stepForecast=2,this.colorOptions.blackIsAlpha=!0;break;case"frontologie":this.isImgLayer=!0,this.colorOptions.blur=0,this.minZoom=0,this.maxZoom=0,this.getUrl=(run,echeance)=>`${urlProxy(this.getBaseUrl(run,echeance))}0/0/0.png`,this.initImages=(layer3d,layer)=>{layer3d.addImage({imageUrl:this.getUrl(layer.currentForecastDate.value.date_model_run,layer.currentForecastDate.value.date_ech),repeat:!0,extent:[-180,-85,180,85]})};break;case"foudre":this.isParticleLayer=!0,this.colorOptions.blur=0,this.minZoom=0,this.maxZoom=0,this.overrideRenderOrder=500002,this.imageUrl=urlProxy("https://www.meteoconsult.fr/bundles/meteoconsultwebmap/image/map/particle2.jpg"),this.getUrl=(run,echeance)=>{urlProxy(this.getBaseUrl(run,echeance))},this.initParticles=(layer3d,layer)=>{console.log(layer3d);let data2=[[2.333333,48.866667],[139.839478,35.652832]];layer3d.addParticles({imageUrl:this.imageUrl,data:data2})};break}resolve()}));initGroups=data=>{this.group=GroupManager.getGroupByID(data.group),this.group&&this.group.addLayer(this)};initOverlays=data=>{for(const overlayID of data.overlays)this.overlays.push(OverlayManager$1.getOverlayByID(overlayID))};initLegends=data=>{const legendData=data.providers[0].params[0].legends;if(legendData.length>1,legendData.length>0){this.legends=[];for(const legend of legendData)this.legends.push(legendsManagerInstance.getLegendByID(legend.legend_id))}};initProviders=data=>{for(const providerData of data.providers){let provider=ProviderManager$1.getProviderByID(providerData.provider_id);provider?console.log("provider found"):provider=ProviderManager$1.add(providerData),this.providers.push(provider)}this.name=this.providers[0].layerName};loadExtraData=async()=>{!this.isLoaded&&this.selectedProvider.value.loadExtraData&&await this.selectedProvider.value.loadExtraData()};get isLoaded(){return this.selectedProvider.value.isLoaded}get isValid(){return this.selectedProvider.value!=null}get layerName(){return this.selectedProvider.value?this.selectedProvider.value.layerName:(logger.warn(`[WARNING] : Layer-${this.id} ${this.name} - No Provider`),"provider not defined")}get modelName(){return this.selectedProvider.value?this.selectedProvider.value.model?this.selectedProvider.value.model.name:"model not defined":"provider not defined"}getProvider=()=>this.selectedProvider;formatDate(date){const d2=changeTimezone(new Date(date),"Europe/Paris");return`${d2.getFullYear()}${String(d2.getMonth()+1).padStart(2,"0")}${String(d2.getDate()).padStart(2,"0")}0000`}getBaseUrl=(run,echeance)=>`${this.baseUrl}/${this.modelName}/${run}/${this.urlLayerName||this.layerName}/${echeance}/`;getUrl=(run,echeance)=>{this.layerName=="vent_kmh";const url=urlProxy(this.getBaseUrl(run,echeance));return isLocal?`${url}{z}${encodeURIComponent("/")}{x}${encodeURIComponent("/")}{y}${encodeURIComponent("."+this.imageFormat)}`:`${url}{z}/{x}/{y}.${this.imageFormat}`};toString=()=>`${this.name}: ${this.providers.length}providers`;clone=()=>{const cloned=new LayerData;return Object.assign(cloned,this),cloned.providers=[...this.providers],cloned.overlays=[...this.overlays],cloned.colorOptions={...this.colorOptions},cloned.selectedProvider=ref({...this.selectedProvider.value}),this.group&&(cloned.group=this.group.clone?this.group.clone():this.group),cloned}}class LayerDataBlueMarble extends LayerData{constructor(){super(),this.baseUrl="https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/",this.name="BlueMarble",this.imageFormat="jpeg",this.zoomFactor=1,this.colorOptions.blur=0,this.colorOptions.srgb=!0,this.overrideRenderOrder=-1}get isValid(){return!0}getUrl=(run,echeance)=>isLocal?`${urlProxy(this.baseUrl)}{z}${encodeURIComponent("/")}{y}${encodeURIComponent("/")}{x}`:(console.log("test",`${urlProxy(this.baseUrl)}{z}/{y}/{x}`),`${urlProxy(this.baseUrl)}{z}/{y}/{x}`)}class LayerDataBorder extends LayerData{constructor(){super(),this.baseUrl="https://static5.mclcm.net/lcm2018/mapTiles/Borders/",this.name="borders",this.overrideRenderOrder=1e7,this.colorOptions.blur=0,this.zoomFactor=1,this.imageFormat="png",this.directRender=!0}get isValid(){return!0}getUrl=(run,echeance)=>isLocal?`${urlProxy(this.baseUrl)}{z}${encodeURIComponent("/")}{x}${encodeURIComponent("/")}{y}${encodeURIComponent("."+this.imageFormat)}`:`${urlProxy(this.baseUrl)}{z}/{x}/{y}.${this.imageFormat}`}function e(e2,t2,r2,n2){return new(r2||(r2=Promise))(function(o2,a2){function i2(e3){try{d2(n2.next(e3))}catch(e4){a2(e4)}}function c2(e3){try{d2(n2.throw(e3))}catch(e4){a2(e4)}}function d2(e3){var t3;e3.done?o2(e3.value):(t3=e3.value,t3 instanceof r2?t3:new r2(function(e4){e4(t3)})).then(i2,c2)}d2((n2=n2.apply(e2,[])).next())})}const t=["geforce 320m","geforce 8600","geforce 8600m gt","geforce 8800 gs","geforce 8800 gt","geforce 9400","geforce 9400m g","geforce 9400m","geforce 9600m gt","geforce 9600m","geforce fx go5200","geforce gt 120","geforce gt 130","geforce gt 330m","geforce gtx 285","google swiftshader","intel g41","intel g45","intel gma 4500mhd","intel gma x3100","intel hd 3000","intel q45","legacy","mali-2","mali-3","mali-4","quadro fx 1500","quadro fx 4","quadro fx 5","radeon hd 2400","radeon hd 2600","radeon hd 4670","radeon hd 4850","radeon hd 4870","radeon hd 5670","radeon hd 5750","radeon hd 6290","radeon hd 6300","radeon hd 6310","radeon hd 6320","radeon hd 6490m","radeon hd 6630m","radeon hd 6750m","radeon hd 6770m","radeon hd 6970m","sgx 543","sgx543"];function r(e2){return e2=e2.toLowerCase().replace(/.*angle ?\((.+)\)(?: on vulkan [0-9.]+)?$/i,"$1").replace(/\s(\d{1,2}gb|direct3d.+$)|\(r\)| \([^)]+\)$/g,"").replace(/(?:vulkan|opengl) \d+\.\d+(?:\.\d+)?(?: \((.*)\))?/,"$1")}const n=typeof window>"u",o=(()=>{if(n)return;const{userAgent:e2,platform:t2,maxTouchPoints:r2}=window.navigator,o2=/(iphone|ipod|ipad)/i.test(e2),a2=t2==="iPad"||t2==="MacIntel"&&r2>0&&!window.MSStream;return{isIpad:a2,isMobile:/android/i.test(e2)||o2||a2,isSafari12:/Version\/12.+Safari/.test(e2),isFirefox:/Firefox/.test(e2)}})();function a(e2,t2,r2){if(!r2)return[t2];const n2=function(e3){const t3=`
    precision highp float;
    attribute vec3 aPosition;
    varying float vvv;
    void main() {
      vvv = 0.31622776601683794;
      gl_Position = vec4(aPosition, 1.0);
    }
  `,r3=`
    precision highp float;
    varying float vvv;
    void main() {
      vec4 enc = vec4(1.0, 255.0, 65025.0, 16581375.0) * vvv;
      enc = fract(enc);
      enc -= enc.yzww * vec4(1.0 / 255.0, 1.0 / 255.0, 1.0 / 255.0, 0.0);
      gl_FragColor = enc;
    }
  `,n3=e3.createShader(35633),o2=e3.createShader(35632),a3=e3.createProgram();if(!(o2&&n3&&a3))return;e3.shaderSource(n3,t3),e3.shaderSource(o2,r3),e3.compileShader(n3),e3.compileShader(o2),e3.attachShader(a3,n3),e3.attachShader(a3,o2),e3.linkProgram(a3),e3.detachShader(a3,n3),e3.detachShader(a3,o2),e3.deleteShader(n3),e3.deleteShader(o2),e3.useProgram(a3);const i3=e3.createBuffer();e3.bindBuffer(34962,i3),e3.bufferData(34962,new Float32Array([-1,-1,0,3,-1,0,-1,3,0]),35044);const c3=e3.getAttribLocation(a3,"aPosition");e3.vertexAttribPointer(c3,3,5126,!1,0,0),e3.enableVertexAttribArray(c3),e3.clearColor(1,1,1,1),e3.clear(16384),e3.viewport(0,0,1,1),e3.drawArrays(4,0,3);const d3=new Uint8Array(4);return e3.readPixels(0,0,1,1,6408,5121,d3),e3.deleteProgram(a3),e3.deleteBuffer(i3),d3.join("")}(e2),a2="801621810",i2="8016218135",c2="80162181161",d2=o?.isIpad?[["a7",c2,12],["a8",i2,15],["a8x",i2,15],["a9",i2,15],["a9x",i2,15],["a10",i2,15],["a10x",i2,15],["a12",a2,15],["a12x",a2,15],["a12z",a2,15],["a14",a2,15],["a15",a2,15],["m1",a2,15],["m2",a2,15]]:[["a7",c2,12],["a8",i2,12],["a9",i2,15],["a10",i2,15],["a11",a2,15],["a12",a2,15],["a13",a2,15],["a14",a2,15],["a15",a2,15],["a16",a2,15],["a17",a2,15]];let l2;return n2==="80162181255"?l2=d2.filter(([,,e3])=>e3>=14):(l2=d2.filter(([,e3])=>e3===n2),l2.length||(l2=d2)),l2.map(([e3])=>`apple ${e3} gpu`)}class i extends Error{constructor(e2){super(e2),Object.setPrototypeOf(this,new.target.prototype)}}const c=[],d=[];function l(e2,t2){if(e2===t2)return 0;const r2=e2;e2.length>t2.length&&(e2=t2,t2=r2);let n2=e2.length,o2=t2.length;for(;n2>0&&e2.charCodeAt(~-n2)===t2.charCodeAt(~-o2);)n2--,o2--;let a2,i2=0;for(;i2<n2&&e2.charCodeAt(i2)===t2.charCodeAt(i2);)i2++;if(n2-=i2,o2-=i2,n2===0)return o2;let l2,s2,f2=0,u=0,g=0;for(;u<n2;)d[u]=e2.charCodeAt(i2+u),c[u]=++u;for(;g<o2;)for(a2=t2.charCodeAt(i2+g),l2=g++,f2=g,u=0;u<n2;u++)s2=a2===d[u]?l2:l2+1,l2=c[u],f2=c[u]=l2>f2?s2>f2?f2+1:s2:s2>l2?l2+1:s2;return f2}function s(e2){return e2!=null}const f=({mobileTiers:c2=[0,15,30,60],desktopTiers:d2=[0,15,30,60],override:f2={},glContext:u,failIfMajorPerformanceCaveat:g=!1,benchmarksURL:h="https://unpkg.com/detect-gpu@5.0.69/dist/benchmarks"}={})=>e(void 0,void 0,void 0,function*(){const p={};if(n)return{tier:0,type:"SSR"};const{isIpad:m=!!o?.isIpad,isMobile:v=!!o?.isMobile,screenSize:w=window.screen,loadBenchmarks:x=t2=>e(void 0,void 0,void 0,function*(){const e2=yield fetch(`${h}/${t2}`).then(e3=>e3.json());if(parseInt(e2.shift().split(".")[0],10)<4)throw new i("Detect GPU benchmark data is out of date. Please update to version 4x");return e2})}=f2;let{renderer:A}=f2;const P=(e2,t2,r2,n2,o2)=>({device:o2,fps:n2,gpu:r2,isMobile:v,tier:e2,type:t2});let S,b="";if(A)A=r(A),S=[A];else{const e2=u||function(e3,t3=!1){const r2={alpha:!1,antialias:!1,depth:!1,failIfMajorPerformanceCaveat:t3,powerPreference:"high-performance",stencil:!1};e3&&delete r2.powerPreference;const n2=window.document.createElement("canvas"),o2=n2.getContext("webgl",r2)||n2.getContext("experimental-webgl",r2);return o2??void 0}(o?.isSafari12,g);if(!e2)return P(0,"WEBGL_UNSUPPORTED");const t2=o?.isFirefox?null:e2.getExtension("WEBGL_debug_renderer_info");if(A=t2?e2.getParameter(t2.UNMASKED_RENDERER_WEBGL):e2.getParameter(e2.RENDERER),!A)return P(1,"FALLBACK");b=A,A=r(A),S=function(e3,t3,r2){return t3==="apple gpu"?a(e3,t3,r2):[t3]}(e2,A,v)}const E4=(yield Promise.all(S.map(function(t2){var r2;return e(this,void 0,void 0,function*(){const e2=(e3=>{const t3=v?["adreno","apple","mali-t","mali","nvidia","powervr","samsung"]:["intel","apple","amd","radeon","nvidia","geforce","adreno"];for(const r3 of t3)if(e3.includes(r3))return r3})(t2);if(!e2)return;const n2=`${v?"m":"d"}-${e2}${m?"-ipad":""}.json`,o2=p[n2]=(r2=p[n2])!==null&&r2!==void 0?r2:x(n2);let a2;try{a2=yield o2}catch(e3){if(e3 instanceof i)throw e3;return}const c3=function(e3){var t3;const r3=(e3=e3.replace(/\([^)]+\)/,"")).match(/\d+/)||e3.match(/(\W|^)([A-Za-z]{1,3})(\W|$)/g);return(t3=r3?.join("").replace(/\W|amd/g,""))!==null&&t3!==void 0?t3:""}(t2);let d3=a2.filter(([,e3])=>e3===c3);d3.length||(d3=a2.filter(([e3])=>e3.includes(t2)));const s2=d3.length;if(s2===0)return;const f3=t2.split(/[.,()\[\]/\s]/g).sort().filter((e3,t3,r3)=>t3===0||e3!==r3[t3-1]).join(" ");let u2,[g2,,,,h2]=s2>1?d3.map(e3=>[e3,l(f3,e3[2])]).sort(([,e3],[,t3])=>e3-t3)[0][0]:d3[0],A2=Number.MAX_VALUE;const{devicePixelRatio:P6}=window,S2=w.width*P6*w.height*P6;for(const e3 of h2){const[t3,r3]=e3,n3=t3*r3,o3=Math.abs(S2-n3);o3<A2&&(A2=o3,u2=e3)}if(!u2)return;const[,,b2,E5]=u2;return[A2,b2,g2,E5]})}))).filter(s).sort(([e2=Number.MAX_VALUE,t2],[r2=Number.MAX_VALUE,n2])=>e2===r2?t2-n2:e2-r2);if(!E4.length){const e2=t.find(e3=>A.includes(e3));return e2?P(0,"BLOCKLISTED",e2):P(1,"FALLBACK",`${A} (${b})`)}const[,y,C,L]=E4[0];if(y===-1)return P(0,"BLOCKLISTED",C,y,L);const M=v?c2:d2;let $=0;for(let e2=0;e2<M.length;e2++)y>=M[e2]&&($=e2);return P($,"BENCHMARK",C,y,L)});let performance$1={};const performanceTest=async()=>{performance$1=await f({mobileTiers:[0,0,0,0],desktopTiers:[0,30,60,110]}),console.log(performance$1)},getTier=()=>(console.log(performance$1),performance$1.isMobile==!0?5:performance$1.tier);class LayerDataCities extends LayerData{constructor(){super(),this.baseUrl="https://a.basemaps.cartocdn.com/light_only_labels/",this.name="cities",this.directRender=getTier()<2,this.overrideRenderOrder=10000001,this.colorOptions.blur=0,this.zoomFactor=1,this.sizeFactor=1.5,this.imageFormat="png",this.colorOptions.srgb=!0,this.colorOptions.blending="substract"}get isValid(){return!0}getUrl=(run,echeance)=>isLocal?`${urlProxy(this.baseUrl)}{z}${encodeURIComponent("/")}{x}${encodeURIComponent("/")}{y}${encodeURIComponent("."+this.imageFormat)}`:`${urlProxy(this.baseUrl)}{z}/{x}/{y}.${this.imageFormat}`}class LayerDataMarineMask extends LayerData{constructor(){super(),this.baseUrl="https://static5.mclcm.net/lcm2018/mapTiles/MapDataMarine/",this.name="MapDataMarine",this.overrideRenderOrder=1e6,this.colorOptions.blur=0,this.zoomFactor=1,this.directRender=!0,this.imageFormat="png"}get isValid(){return!0}getUrl=(run,echeance)=>isLocal?`${urlProxy(this.baseUrl)}{z}${encodeURIComponent("/")}{x}${encodeURIComponent("/")}{y}${encodeURIComponent("."+this.imageFormat)}`:`${urlProxy(this.baseUrl)}{z}/{x}/{y}${"."+this.imageFormat}`}const maskFromPolygon=(dataMask,options={})=>{const style={...{color:"#000",weight:2,fill:"#000",dashArray:"4",fillOpacity:.8},...options},canvas=document.createElement("canvas");canvas.width=4096,canvas.height=4096;const ctx=canvas.getContext("2d"),mercExtent=transformExtent([-180,-85,180,85],"EPSG:4326","EPSG:3857");function projectPoint([lat,lon]){const[x,y]=transform([lon,lat],"EPSG:4326","EPSG:3857"),ratioX=(x-mercExtent[0])/(mercExtent[2]-mercExtent[0]),ratioY=1-(y-mercExtent[1])/(mercExtent[3]-mercExtent[1]);return[ratioX*canvas.width,ratioY*canvas.height]}return ctx.fillStyle=`rgba(0,0,0,${style.fillOpacity})`,ctx.beginPath(),ctx.rect(0,0,canvas.width,canvas.height),ctx.moveTo(...projectPoint(dataMask[0])),dataMask.forEach((p,i2)=>{const[x,y]=projectPoint(p);i2?ctx.lineTo(x,y):ctx.moveTo(x,y)}),ctx.closePath(),style.dashArray&&ctx.setLineDash(style.dashArray.split(",").map(Number)),ctx.strokeStyle=style.color,ctx.lineWidth=style.weight,ctx.fill("evenodd"),ctx.stroke(),canvas};class LayerDataMask extends LayerData{constructor(){super(),this.name="mask",this.isImgLayer=!0,this.colorOptions.blur=0,this.minZoom=0,this.maxZoom=0,this.overrideRenderOrder=500001}initImages(layer3d){const imageUrl=maskFromPolygon([[51.104,-11.998],[53.463,-11.997],[53.523,-11.938],[53.55,-11.842],[53.705,-11.666],[53.713,-11.601],[53.887,-11.363],[53.957,-11.148],[54.038,-11.061],[54.077,-10.851],[54.292,-10.235],[54.345,-10.19],[54.553,-10.153],[54.825,-10.032],[54.909,-9.936],[55.158,-9.759],[55.551,-9.275],[55.763,-8.882],[55.842,-8.829],[55.903,-8.839],[55.997,-8.939],[56.089,-9.095],[56.098,-9.215],[56.161,-9.247],[56.25,-9.367],[56.31,-9.517],[56.432,-9.64],[56.522,-9.79],[56.658,-9.893],[56.764,-10.032],[57.004,-10.182],[57.036,-10.244],[57.369,-10.395],[57.828,-10.463],[57.891,-10.517],[57.972,-10.516],[58.028,-10.463],[58.457,-10.395],[58.623,-10.308],[58.699,-10.304],[58.904,-10.116],[59.062,-10.032],[59.116,-9.936],[59.365,-9.699],[59.454,-9.549],[59.577,-9.426],[59.617,-9.302],[59.758,-9.124],[59.797,-8.975],[59.97,-8.67],[59.974,-8.563],[60.152,-8.155],[60.186,-7.898],[60.333,-7.4],[60.364,-7.24],[60.364,-6.865],[60.395,-6.786],[60.395,-6.32],[60.425,-6.242],[60.425,-5.894],[60.364,-5.482],[60.363,-5.069],[60.152,-4.132],[60.035,-3.875],[59.94,-3.527],[59.797,-3.312],[59.788,-3.194],[59.676,-3.07],[59.607,-2.891],[59.545,-2.859],[59.464,-2.727],[59.517,-2.428],[59.487,-2.336],[59.517,-2.247],[59.517,-1.778],[59.487,-1.7],[59.425,-.711],[59.334,-.319],[59.248,-.122],[59.244,.045],[59.157,.211],[59.153,.287],[59.101,.35],[59.062,.559],[58.955,.701],[58.699,1.225],[58.575,1.349],[58.517,1.467],[58.366,1.588],[58.336,1.679],[58.124,1.861],[57.997,1.918],[57.791,2.072],[57.453,2.171],[57.308,2.254],[56.794,2.254],[56.708,2.171],[56.491,2.133],[56.098,1.951],[56.005,1.828],[55.867,1.728],[55.806,1.718],[55.656,1.814],[55.527,1.976],[55.188,2.284],[54.76,2.444],[54.643,2.526],[54.276,2.534],[54.112,2.661],[54.038,2.799],[53.705,3.071],[53.463,3.192],[53.156,3.261],[53.093,3.314],[52.715,3.314],[52.652,3.261],[52.524,3.239],[52.439,3.31],[52.415,3.432],[52.432,3.598],[52.46,3.653],[52.546,3.682],[55.549,3.09],[55.695,5.596],[55.793,9.079],[55.907,9.113],[56.194,9.015],[56.369,8.989],[56.432,8.915],[56.266,7.898],[56.239,6.836],[56.288,6.275],[56.388,5.692],[56.636,4.85],[56.876,4.323],[57.207,3.813],[57.623,3.396],[57.95,3.2],[58.298,2.265],[58.525,1.849],[58.734,1.549],[58.962,1.296],[59.18,1.115],[59.349,1.005],[59.691,.873],[60.037,.847],[60.293,.9],[60.569,1.03],[60.919,1.329],[61.009,1.355],[61.368,.975],[61.705,.719],[62.087,.576],[62.424,.567],[62.717,.657],[63.09,.908],[63.435,1.313],[63.715,1.81],[63.987,2.522],[64.203,3.43],[64.335,4.579],[64.351,5.533],[64.634,5.786],[64.865,6.066],[65.165,6.584],[65.272,6.835],[65.343,6.883],[65.574,6.919],[65.832,7.037],[66.324,7.465],[66.414,7.427],[66.606,7.135],[66.869,6.842],[67.234,6.585],[67.457,6.511],[67.754,6.502],[67.974,6.568],[68.223,6.721],[68.43,6.917],[68.612,7.15],[68.973,7.826],[69.285,8.764],[69.526,9.948],[69.874,10.155],[70.101,10.377],[70.331,10.686],[70.639,11.297],[70.852,11.905],[70.993,12.429],[71.2,13.538],[71.338,14.939],[71.366,16.303],[71.654,16.693],[71.953,17.296],[72.229,18.149],[72.431,19.02],[72.63,20.461],[72.717,22.032],[72.716,22.84],[72.663,23.959],[72.566,24.927],[72.4,25.941],[72.545,27.079],[72.621,28.364],[72.325,32.385],[72.104,33.332],[71.925,33.875],[71.71,34.376],[71.358,34.931],[71.14,35.147],[70.881,35.304],[70.578,35.356],[70.403,35.325],[70.199,35.237],[69.778,34.871],[69.507,34.489],[69.252,34.002],[69.018,33.414],[68.777,32.604],[68.596,31.725],[68.54,31.656],[68.428,31.677],[68.142,32.099],[67.833,32.393],[67.481,32.573],[67.227,32.605],[67.071,32.588],[66.805,32.494],[66.384,32.179],[66.011,31.705],[65.894,31.69],[65.851,31.736],[65.586,32.696],[65.366,33.227],[65.111,33.681],[64.962,33.887],[64.741,34.112],[59.785,31.123],[59.754,30.929],[59.385,30.345],[59.117,29.733],[58.884,28.938],[58.729,28.014],[58.516,27.536],[58.242,26.632],[58.098,25.782],[58.046,25.015],[58.051,24.503],[58.139,23.572],[58.032,23.088],[57.935,22.359],[57.878,22.294],[57.345,22.364],[57.082,22.326],[56.871,22.249],[56.448,21.975],[56.166,21.68],[55.993,21.448],[55.896,21.41],[55.841,21.439],[55.548,21.804],[55.278,22.036],[54.926,22.228],[54.503,22.342],[54.27,23.067],[53.932,23.722],[53.569,24.147],[53.128,24.476],[52.813,24.603],[52.443,24.646],[52.137,24.615],[51.893,24.516],[51.758,24.5],[51.387,24.971],[51.09,25.224],[50.757,25.419],[50.41,25.522],[49.994,25.535],[49.799,25.495],[49.467,25.368],[49.115,25.143],[48.784,24.824],[48.442,24.339],[48.201,23.843],[47.965,23.058],[47.87,22.345],[47.858,21.893],[47.965,21.018],[48.138,20.418],[48.149,20.288],[47.966,19.508],[47.764,19.216],[47.45,18.587],[47.199,17.722],[47.162,17.454],[47.162,17.089],[47.187,16.063],[47.231,15.683],[47.126,15.61],[46.809,15.571],[46.369,15.571],[46.123,15.504],[45.672,15.229],[45.372,14.916],[45.143,14.556],[44.982,14.2],[44.844,13.723],[44.717,13.513],[44.626,13.513],[44.582,13.557],[44.416,14.051],[44.219,14.435],[44,14.728],[43.72,14.997],[43.629,15.478],[43.493,15.859],[43.306,16.216],[43.039,16.551],[42.667,16.843],[42.433,16.953],[42.178,17.019],[41.849,17.033],[41.621,16.992],[41.265,16.855],[41.183,16.876],[41.018,17.565],[40.865,17.917],[40.68,18.229],[40.525,18.415],[40.214,18.681],[39.74,18.894],[39.522,18.934],[39.165,18.92],[38.891,18.854],[38.548,18.671],[38.262,18.442],[37.961,18.056],[37.751,17.632],[37.588,17.073],[37.502,17.044],[37.249,17.087],[36.964,17.086],[36.636,17.006],[36.303,16.844],[35.903,16.498],[35.709,16.243],[35.494,15.806],[35.367,15.398],[35.303,14.951],[35.331,14.428],[35.477,13.896],[35.696,13.445],[35.992,13.077],[36.33,12.809],[36.727,12.634],[37.091,12.58],[37.43,12.607],[37.7,12.694],[38.097,12.94],[38.356,13.196],[38.547,13.475],[38.681,13.725],[38.852,14.279],[38.906,14.347],[39.255,14.295],[39.595,14.308],[39.871,14.378],[39.971,14.334],[40.042,13.847],[40.126,13.642],[40.304,13.351],[40.133,12.625],[40.119,11.904],[40.055,11.84],[39.539,11.794],[39.17,11.646],[38.859,11.412],[38.536,11.037],[38.288,10.584],[38.143,10.107],[38.088,9.634],[38.124,8.985],[38.189,8.698],[38.36,8.252],[38.485,8.026],[38.728,7.702],[38.974,7.476],[39.133,7.375],[39.384,7.082],[39.617,6.907],[39.842,6.771],[40.249,6.645],[40.566,6.248],[40.912,5.948],[41.033,5.359],[41.17,4.897],[41.089,4.766],[40.982,4.742],[40.572,5.205],[40.266,5.423],[40.045,5.534],[39.718,5.643],[39.172,5.666],[38.73,5.555],[38.508,5.444],[38.184,5.207],[37.963,4.986],[37.657,4.528],[37.547,4.329],[37.54,4.252],[37.394,3.916],[37.262,3.272],[37.284,2.323],[37.35,1.949],[37.476,1.632],[37.482,1.52],[37.201,.923],[37.184,.775],[37.047,.675],[36.648,.697],[36.397,.652],[35.899,.478],[35.692,.34],[35.352,.022],[35.152,-.244],[34.867,-.793],[34.736,-1.207],[34.668,-1.653],[34.647,-2.145],[34.691,-2.628],[34.825,-3.091],[34.67,-3.386],[34.517,-3.887],[34.451,-4.288],[34.429,-4.76],[34.451,-5.064],[34.539,-5.53],[34.626,-5.813],[34.801,-6.207],[34.923,-6.418],[35.154,-6.714],[35.413,-6.95],[35.588,-7.061],[35.694,-7.492],[35.825,-7.818],[36.067,-8.236],[36.39,-8.604],[36.787,-8.89],[37.25,-9.067],[37.833,-9.09],[38.127,-9.023],[38.433,-8.878],[38.57,-8.847],[38.664,-8.914],[39.125,-9.067],[39.649,-9.089],[40.127,-8.966],[40.592,-8.673],[40.839,-8.43],[40.926,-8.424],[40.985,-8.488],[41.034,-9.061],[41.168,-9.631],[41.341,-10.066],[41.754,-10.697],[42.129,-11.028],[42.5,-11.246],[42.827,-11.355],[43.008,-11.378],[43.511,-11.355],[43.816,-11.268],[43.98,-11.185],[44.285,-10.975],[44.592,-10.691],[44.822,-10.393],[45.063,-9.935],[45.173,-9.646],[45.287,-9.048],[45.327,-8.963],[45.348,-8.232],[45.291,-7.833],[45.543,-7.1],[45.632,-6.5],[45.61,-5.939],[45.631,-5.853],[45.543,-5.325],[45.432,-4.93],[45.231,-4.469],[45.458,-3.859],[45.697,-3.74],[45.79,-3.74],[45.864,-3.864],[46.027,-4.493],[46.182,-4.866],[46.232,-5.335],[46.414,-6.028],[46.664,-6.585],[47.074,-7.177],[47.358,-7.461],[47.597,-7.632],[48.074,-7.848],[48.482,-7.92],[48.804,-8.307],[48.881,-8.351],[48.925,-8.428],[49.105,-8.517],[49.137,-8.579],[49.349,-8.67],[49.62,-8.73],[50.076,-8.716],[50.148,-8.761],[50.195,-9.783],[50.404,-10.561],[50.408,-10.699],[50.576,-11.022],[50.59,-11.152],[50.68,-11.333],[51.104,-11.998]]).toDataURL("image/png");layer3d.addImage({imageUrl,repeat:!0,extent:[-180,-85,180,85]})}get isValid(){return!0}getUrl=(run,echeance)=>""}class LayerDataManager{layers=[];async init(data){const loadLayer=async d2=>{const layer=new LayerData;return await layer.initFromData(d2),layer},loadedLayers=await Promise.all(data.map(loadLayer));this.layers.push(...loadedLayers)}getLayerByID(id){return this.layers.find(group=>group.id===id)}getLayerByName(name){return this.layers.find(group=>group.name===name)}toArray(){return this.layers.map(layer=>layer.toString())}toArrayForCompactTable(){return this.layers.map(layer=>({Layer:layer.toString(),Providers:layer.providers.map(provider=>provider.name).join(", ")}))}toString(){return this.layers.map(layer=>layer.toString()).join(`
`)}}const LayerDataManager$1=new LayerDataManager;class ResourceCache{constructor(dbName="MapJSResourceCacheDB",storeName="resources",expiryTime=60*60*1e3,debug=!1){Object.assign(this,{dbName,storeName,expiryTime,debug}),this.dbPromise=this.openDatabase()}log(msg,type="log"){this.debug&&console[type](`[ResourceCache] ${msg}`)}async openDatabase(){return this.log(`Opening database: ${this.dbName}`),new Promise((resolve,reject)=>{const req=indexedDB.open(this.dbName,1);req.onupgradeneeded=e2=>{const db=e2.target.result;db.objectStoreNames.contains(this.storeName)||(this.log(`Creating object store: ${this.storeName}`),db.createObjectStore(this.storeName))},req.onsuccess=e2=>{this.log("Database opened successfully"),resolve(e2.target.result)},req.onerror=e2=>{this.log(`Error opening database: ${e2.target.error}`,"error"),reject(e2.target.error)}})}async getResource(key2){const db=await this.dbPromise;return new Promise((resolve,reject)=>{const req=db.transaction(this.storeName,"readonly").objectStore(this.storeName).get(key2);req.onsuccess=()=>{req.result?this.log(`Resource found in cache: ${key2}`):this.log(`No cache entry for: ${key2}`),resolve(req.result)},req.onerror=()=>{this.log(`Error retrieving resource: ${req.error}`,"error"),reject(req.error)}})}async saveResource(key2,value){this.log(`Saving resource: ${key2}`);const db=await this.dbPromise;return new Promise((resolve,reject)=>{const store=db.transaction(this.storeName,"readwrite").objectStore(this.storeName),data={...value,timestamp:Date.now()},req=store.put(data,key2);req.onsuccess=()=>{this.log(`Resource saved: ${key2}`),resolve()},req.onerror=()=>{this.log(`Error saving resource: ${req.error}`,"error"),reject(req.error)}})}parseCachedData(cached){return cached.type==="application/json"?JSON.parse(cached.data):cached.type.startsWith("image/")?URL.createObjectURL(cached.data):cached.data}async load(url,fromCache=!1,saveToCache=!1,proxyValue=null,timeout=0){this.log(`Loading resource: ${url}`);let cached;if(fromCache)if(cached=await this.getResource(url),cached){if(!(Date.now()-cached.timestamp>=this.expiryTime))return this.log(`Using cached resource: ${url}`),this.parseCachedData(cached);this.log(`Cache expired for: ${url}`)}else this.log(`No cache entry for: ${url}`);const finalUrl=proxyValue?`${proxyValue}?url=${encodeURIComponent(url)}`:url;this.log(`Fetching from network: ${finalUrl}`);try{const controller=new AbortController,{signal}=controller;let timer;timeout>0&&(timer=setTimeout(()=>controller.abort(),timeout));const res=await fetch(finalUrl,{signal});if(timer&&clearTimeout(timer),!res.ok)throw new Error(`HTTP error, status: ${res.status}`);const contentType=res.headers.get("content-type")||"";let data,toCache;if(contentType.includes("application/json"))data=await res.json(),toCache={type:"application/json",data:JSON.stringify(data)};else if(contentType.startsWith("image/")){const blob=await res.blob();data=URL.createObjectURL(blob),toCache={type:contentType,data:blob}}else if(contentType.startsWith("text/"))data=await res.text(),toCache={type:contentType,data};else{const blob=await res.blob();data=blob,toCache={type:contentType,data:blob}}return saveToCache&&await this.saveResource(url,toCache),data}catch(err){if(err.name==="AbortError"?this.log(`Fetch timeout for: ${url}`,"error"):this.log(`Fetch error: ${err.message}`,"error"),cached)return this.log(`Using expired cache for: ${url}`,"warn"),this.parseCachedData(cached);throw new Error(`Failed to load resource: ${err.message}`)}}async resetCache(){this.log("Resetting cache");const db=await this.dbPromise;return new Promise((resolve,reject)=>{const req=db.transaction(this.storeName,"readwrite").objectStore(this.storeName).clear();req.onsuccess=()=>{this.log("Cache reset successful"),resolve()},req.onerror=()=>{this.log(`Error resetting cache: ${req.error}`,"error"),reject(req.error)}})}}const proxy=ref(null),modelURL=ref(""),parametersURL=ref(""),legendURL=ref(""),tilesURL=ref(""),pickerEnabled=ref(!1),panEnabled=ref(!0),zoomEnabled=ref(!0),pickerValue=ref(null),currentModel=ref("monde_ens__mc"),currentLayers=ref([]),currentOverlays=ref([]),currentLoading=ref(0),layers=ref([]);function urlProxy(url){return proxy.value?`${proxy.value}?url=${encodeURIComponent(url)}`:url}function revertUrlProxy(proxiedUrl){if(proxy.value)try{const originalUrl=new URL(proxiedUrl).searchParams.get("url");return originalUrl?decodeURIComponent(originalUrl):proxiedUrl}catch{return proxiedUrl}else return proxiedUrl}const resourceCache=new ResourceCache;async function load(url,fromCache=!0){try{return await resourceCache.load(urlProxy(url),fromCache,!0,null)}catch(error){console.error("Error loading data:",error)}}async function fetchModels(){const dataUrl=parametersURL.value,jsonParameters=await(await load(dataUrl)).contenu,legendUrl=legendURL.value,jsonLegends=await(await load(legendUrl)).contenu;await ModelManager$1.init(jsonParameters.models),await GroupManager.init(jsonParameters.groups),await OverlayManager$1.init(jsonParameters.overlays),await legendsManagerInstance.init(jsonLegends),await LayerDataManager$1.init(jsonParameters.parameters);for(const layer of LayerDataManager$1.layers)layers.value.push(layer);layers.value.push(new LayerDataBorder),layers.value.push(new LayerDataMarineMask),layers.value.push(new LayerDataBlueMarble),layers.value.push(new LayerDataCities),layers.value.push(new LayerDataMask)}const MapStore={proxy,pickerEnabled,panEnabled,zoomEnabled,currentModel,currentLayers,currentOverlays,layers,fetchModels},TileProperty={PRELOAD:"preload",USE_INTERIM_TILES_ON_ERROR:"useInterimTilesOnError"};class BaseTileLayer extends Layer$1{constructor(options){options=options||{};const baseOptions=Object.assign({},options),cacheSize2=options.cacheSize;delete options.cacheSize,delete baseOptions.preload,delete baseOptions.useInterimTilesOnError,super(baseOptions),this.on,this.once,this.un,this.cacheSize_=cacheSize2,this.setPreload(options.preload!==void 0?options.preload:0),this.setUseInterimTilesOnError(options.useInterimTilesOnError!==void 0?options.useInterimTilesOnError:!0)}getCacheSize(){return this.cacheSize_}getPreload(){return this.get(TileProperty.PRELOAD)}setPreload(preload){this.set(TileProperty.PRELOAD,preload)}getUseInterimTilesOnError(){return this.get(TileProperty.USE_INTERIM_TILES_ON_ERROR)}setUseInterimTilesOnError(useInterimTilesOnError){this.set(TileProperty.USE_INTERIM_TILES_ON_ERROR,useInterimTilesOnError)}getData(pixel){return super.getData(pixel)}}const maxStaleKeys=5;class LayerRenderer extends Observable{constructor(layer){super(),this.ready=!0,this.boundHandleImageChange_=this.handleImageChange_.bind(this),this.layer_=layer,this.staleKeys_=new Array,this.maxStaleKeys=maxStaleKeys}getStaleKeys(){return this.staleKeys_}prependStaleKey(key2){this.staleKeys_.unshift(key2),this.staleKeys_.length>this.maxStaleKeys&&(this.staleKeys_.length=this.maxStaleKeys)}getFeatures(pixel){return abstract()}getData(pixel){return null}prepareFrame(frameState2){return abstract()}renderFrame(frameState2,target){return abstract()}forEachFeatureAtCoordinate(coordinate,frameState2,hitTolerance,callback,matches){}getLayer(){return this.layer_}handleFontsChanged(){}handleImageChange_(event){const image=event.target;(image.getState()===ImageState.LOADED||image.getState()===ImageState.ERROR)&&this.renderIfReadyAndVisible()}loadImage(image){let imageState=image.getState();return imageState!=ImageState.LOADED&&imageState!=ImageState.ERROR&&image.addEventListener(EventType.CHANGE,this.boundHandleImageChange_),imageState==ImageState.IDLE&&(image.load(),imageState=image.getState()),imageState==ImageState.LOADED}renderIfReadyAndVisible(){const layer=this.getLayer();layer&&layer.getVisible()&&layer.getSourceState()==="ready"&&layer.changed()}renderDeferred(frameState2){}disposeInternal(){delete this.layer_,super.disposeInternal()}}function createOrUpdate$1(z,x,y,tileCoord){return tileCoord!==void 0?(tileCoord[0]=z,tileCoord[1]=x,tileCoord[2]=y,tileCoord):[z,x,y]}function getKeyZXY(z,x,y){return z+"/"+x+"/"+y}function getKey(tileCoord){return getKeyZXY(tileCoord[0],tileCoord[1],tileCoord[2])}function hash(tileCoord){return hashZXY(tileCoord[0],tileCoord[1],tileCoord[2])}function hashZXY(z,x,y){return(x<<z)+y}function withinExtentAndZ(tileCoord,tileGrid){const z=tileCoord[0],x=tileCoord[1],y=tileCoord[2];if(tileGrid.getMinZoom()>z||z>tileGrid.getMaxZoom())return!1;const tileRange=tileGrid.getFullTileRange(z);return tileRange?tileRange.containsXY(x,y):!0}class LRUCache{constructor(highWaterMark){this.highWaterMark=highWaterMark!==void 0?highWaterMark:2048,this.count_=0,this.entries_={},this.oldest_=null,this.newest_=null}deleteOldest(){const entry=this.pop();entry instanceof Disposable&&entry.dispose()}canExpireCache(){return this.highWaterMark>0&&this.getCount()>this.highWaterMark}expireCache(keep){for(;this.canExpireCache();)this.deleteOldest()}clear(){for(;this.oldest_;)this.deleteOldest()}containsKey(key2){return this.entries_.hasOwnProperty(key2)}forEach(f2){let entry=this.oldest_;for(;entry;)f2(entry.value_,entry.key_,this),entry=entry.newer}get(key2,options){const entry=this.entries_[key2];return assert(entry!==void 0,"Tried to get a value for a key that does not exist in the cache"),entry===this.newest_||(entry===this.oldest_?(this.oldest_=this.oldest_.newer,this.oldest_.older=null):(entry.newer.older=entry.older,entry.older.newer=entry.newer),entry.newer=null,entry.older=this.newest_,this.newest_.newer=entry,this.newest_=entry),entry.value_}remove(key2){const entry=this.entries_[key2];return assert(entry!==void 0,"Tried to get a value for a key that does not exist in the cache"),entry===this.newest_?(this.newest_=entry.older,this.newest_&&(this.newest_.newer=null)):entry===this.oldest_?(this.oldest_=entry.newer,this.oldest_&&(this.oldest_.older=null)):(entry.newer.older=entry.older,entry.older.newer=entry.newer),delete this.entries_[key2],--this.count_,entry.value_}getCount(){return this.count_}getKeys(){const keys=new Array(this.count_);let i2=0,entry;for(entry=this.newest_;entry;entry=entry.older)keys[i2++]=entry.key_;return keys}getValues(){const values=new Array(this.count_);let i2=0,entry;for(entry=this.newest_;entry;entry=entry.older)values[i2++]=entry.value_;return values}peekLast(){return this.oldest_.value_}peekLastKey(){return this.oldest_.key_}peekFirstKey(){return this.newest_.key_}peek(key2){return this.entries_[key2]?.value_}pop(){const entry=this.oldest_;return delete this.entries_[entry.key_],entry.newer&&(entry.newer.older=null),this.oldest_=entry.newer,this.oldest_||(this.newest_=null),--this.count_,entry.value_}replace(key2,value){this.get(key2),this.entries_[key2].value_=value}set(key2,value){assert(!(key2 in this.entries_),"Tried to set a value for a key that is used already");const entry={key_:key2,newer:null,older:this.newest_,value_:value};this.newest_?this.newest_.newer=entry:this.oldest_=entry,this.newest_=entry,this.entries_[key2]=entry,++this.count_}setSize(size){this.highWaterMark=size}}const textureCache=new Map,geometry=new PlaneGeometry;class TileTexture extends Target{constructor(options){super(options),this.group=options.group,this.tile=options.tile,this.tileGrid=options.tileGrid,this.threejsLayer=options.threejsLayer,this.srgb=options.threejsLayer.srgb,this.alpha=0,this.renderOrder=this.threejsLayer.master.renderOrder,this.loaded=!1,this.ready=!1,this.textures=[],this.plane=new Mesh(geometry,new MeshBasicNodeMaterial({transparent:!0,depthWrite:!1})),this.plane.visible=!1,this.group.add(this.plane),this.tileSize=this.tileGrid.getTileSize(this.tile.tileCoord[0]),this.loaded=this.tile.getState()===TileState.LOADED;const image=this.tile.getImage();image instanceof Image&&!image.crossOrigin&&(image.crossOrigin="anonymous"),this.tile.addEventListener(EventType.CHANGE,this.handleTileChange_)}handleTileChange_=()=>{if(this.tile.getState()===TileState.LOADED){this.loaded=!0,this.ready=!0;const key2=this.tile.getImage().src;if(textureCache.has(key2)){const cachedTexture=textureCache.get(key2);cachedTexture.count++,this.plane.material.map=cachedTexture.texture}else{const texture2=new Texture(this.tile.getImage());texture2.needsUpdate=!0,texture2.minFilter=LinearMipMapLinearFilter,texture2.magFilter=LinearFilter,texture2.anisotropy=1,texture2.generateMipmaps=!0,texture2.colorSpace=this.srgb?SRGBColorSpace:NoColorSpace,textureCache.set(key2,{texture:texture2,count:1}),this.plane.material.map=texture2}this.plane.material.needsUpdate=!0,stage.onUpdate.add(this.update)}};update=dt=>{const previousOpacity=this.plane.material.opacity;this.threejsLayer.master.isPlaying||!this.threejsLayer.master.fadeInTiles?this.plane.material.opacity=1:this.plane.material.opacity=this.alpha,previousOpacity!=this.plane.material.opacity&&(this.threejsLayer.needsRender=!0)};dispose(){stage.onUpdate.remove(this.update),this.tile.removeEventListener(EventType.CHANGE,this.handleTileChange_),this.group.remove(this.plane);const map=this.plane.material.map;if(map){const key2=this.tile.getImage().src,cachedTexture=textureCache.get(key2);cachedTexture&&(cachedTexture.count--,cachedTexture.count===0&&(map.dispose(),textureCache.delete(key2)))}this.plane.material.dispose(),super.dispose()}}const clamp$1=(value,min2=0,max2=1)=>Math.max(min2,Math.min(value,max2)),normalizeBetween=(value,min2,max2)=>(value-min2)/(max2-min2);function getRenderExtent(frameState2,extent){const layerState=frameState2.layerStatesArray[frameState2.layerIndex];layerState.extent&&(extent=getIntersection(extent,fromUserExtent(layerState.extent,frameState2.viewState.projection)));const source=layerState.layer.getRenderSource();if(!source.getWrapX()){const gridExtent=source.getTileGridForProjection(frameState2.viewState.projection).getExtent();gridExtent&&(extent=getIntersection(extent,gridExtent))}return extent}function getCacheKey(source,tileCoord){return`${source.getKey()},${getKey(tileCoord)}`}class TileRepresentationLookup{constructor(){this.tileIds=new Set,this.representationsByZ=new Map}hasTile(tile){return this.tileIds.has(getUid(tile))}addTileRepresentation(tileRepresentation,z){this.representationsByZ.has(z)||this.representationsByZ.set(z,new Set),this.representationsByZ.get(z).add(tileRepresentation),this.tileIds.add(getUid(tileRepresentation.tile))}getRepresentationsByZ(z){return this.representationsByZ.get(z)||new Set}getSortedZoomLevels(){return Array.from(this.representationsByZ.keys()).sort(descending)}}class ThreeJsTileLayerRenderer extends LayerRenderer{static PoolRenderTarget=null;static initPool(){ThreeJsTileLayerRenderer.PoolRenderTarget=new ObjectPool(()=>new RenderTarget(stage.width,stage.height,{depthBuffer:!1,stencilBuffer:!1,samples:1,alpha:!0,minFilter:NearestFilter,magFilter:NearestFilter,type:UnsignedByteType,colorSpace:NoColorSpace}),16,!0)}constructor(tileLayer,options={},master){super(tileLayer),this.options=options,this.master=master,this.renderTarget=null,this.container=new Group,this.container.renderOrder=this.master.renderOrder,this.srgb=master.data.colorOptions.srgb,this.onTilesLoaded=new Signal,this.onTilesDisplayed=new Signal,this.tmpTileCoord=createOrUpdate$1(0,0,0),this.tileRepresentationCache=new LRUCache(options.cacheSize||512);const tileSource=this.getLayer().getRenderSource();tileSource.on("tileloadstart",this.onTileLoadStart),tileSource.on("tileloadend",this.onTileLoadEnd),tileSource.on("tileloaderror",this.onTileLoadEnd),this.loadingTilesCount=0,this.allTilesLoaded=!1,this.allTilesDisplayed=!1,stage.onResize.add(this.resize),stage.onUpdate.add(this.update)}render(frameState2){super.render(frameState2)}resize=()=>{this.renderTarget&&(this.renderTarget.setSize(stage.width,stage.height),this.render3d())};initRT=()=>{this.renderTarget||(this.renderTarget=ThreeJsTileLayerRenderer.PoolRenderTarget.checkOut(),this.render3d())};releaseRT=()=>{this.renderTarget&&(ThreeJsTileLayerRenderer.PoolRenderTarget.checkIn(this.renderTarget),this.renderTarget=null)};render3d=()=>{stage3d.renderNext(),!this.master.directRender&&(this.initRT(),stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(this.renderTarget),stage3d.renderer.render(this.container,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),stage3d.renderNext())};update=dt=>{this.master.opacity<.001||(this.tileRepresentationCache.forEach(tileRepresentation=>{tileRepresentation.update&&tileRepresentation.update(dt)}),this.needsRender&&(this.render3d(),this.needsRender=!1))};onTileLoadStart=()=>{this.loadingTilesCount++,currentLoading.value++,this.allTilesLoaded=!1};onTileLoadEnd=()=>{this.loadingTilesCount--,setTimeout(()=>{currentLoading.value--},200),this.loadingTilesCount===0&&(this.allTilesLoaded=!0,this.onTilesLoaded.dispatch())};renderFrame(frameState2){const{viewState,time:time2}=frameState2,tileSource=this.getLayer().getRenderSource(),tileGrid=tileSource.getTileGridForProjection(viewState.projection),extent=getRenderExtent(frameState2,frameState2.extent),z=tileGrid.getZForResolution(viewState.resolution,tileSource.zDirection),tileRepresentationLookup=new TileRepresentationLookup;this.enqueueTiles(frameState2,extent,z,tileRepresentationLookup,0);const alphaLookup=new Map,uid=getUid(this),currentlyVisibleTiles=new Set;for(tileRepresentationLookup.getRepresentationsByZ(z).forEach(tileRepresentation=>{const{tile}=tileRepresentation,tileCoordKey=getKey(tile.tileCoord);if(currentlyVisibleTiles.add(tileCoordKey),tileRepresentation.ready){const alpha=tile.getAlpha(uid,time2);if(alpha===1){tile.endTransition(uid);return}alphaLookup.set(tileCoordKey,alpha)}if(!this.findAltTiles(tileGrid,tile.tileCoord,z+1,tileRepresentationLookup))for(let parentZ=z-1;parentZ>=tileGrid.getMinZoom()&&parentZ>=z-1&&!this.findAltTiles(tileGrid,tile.tileCoord,parentZ,tileRepresentationLookup);parentZ--);}),tileRepresentationLookup.getSortedZoomLevels().forEach(tileZ=>{tileRepresentationLookup.getRepresentationsByZ(tileZ).forEach(tileRepresentation=>{const tileCoordKey=getKey(tileRepresentation.tile.tileCoord);currentlyVisibleTiles.add(tileCoordKey),alphaLookup.has(tileCoordKey)||this.drawTile(frameState2,tileRepresentation,extent,alphaLookup,tileGrid)})}),tileRepresentationLookup.getRepresentationsByZ(z).forEach(tileRepresentation=>{const tileCoordKey=getKey(tileRepresentation.tile.tileCoord);alphaLookup.has(tileCoordKey)&&this.drawTile(frameState2,tileRepresentation,extent,alphaLookup,tileGrid)}),this.tileRepresentationCache.forEach(tileRepresentation=>{const tileCoordKey=getKey(tileRepresentation.tile.tileCoord);currentlyVisibleTiles.has(tileCoordKey)||(tileRepresentation.plane.visible=!1)});this.tileRepresentationCache.canExpireCache();)this.tileRepresentationCache.pop().dispose();alphaLookup.size===0&&this.allTilesLoaded?(this.onTilesDisplayed.dispatch(),this.allTilesDisplayed=!0):this.allTilesDisplayed=!1,this.needsRender=!0}findAltTiles(tileGrid,tileCoord,altZ,tileRepresentationLookup){const tileRange=tileGrid.getTileRangeForTileCoordAndZ(tileCoord,altZ,this.tempTileRange_);if(!tileRange)return!1;let covered=!0;const tileRepresentationCache=this.tileRepresentationCache,source=this.getLayer().getRenderSource();for(let x=tileRange.minX;x<=tileRange.maxX;++x)for(let y=tileRange.minY;y<=tileRange.maxY;++y){const cacheKey=getCacheKey(source,[altZ,x,y]);let loaded=!1;if(tileRepresentationCache.containsKey(cacheKey)){const tileRepresentation=tileRepresentationCache.get(cacheKey);tileRepresentation.ready&&!tileRepresentationLookup.hasTile(tileRepresentation.tile)&&(tileRepresentationLookup.addTileRepresentation(tileRepresentation,altZ),loaded=!0)}loaded||(covered=!1)}return covered}enqueueTiles(frameState2,extent,initialZ,tileRepresentationLookup,preload){const{viewState}=frameState2,tileLayer=this.getLayer(),tileSource=tileLayer.getRenderSource(),tileGrid=tileSource.getTileGridForProjection(viewState.projection),tileSourceKey=getUid(tileSource);frameState2.wantedTiles[tileSourceKey]||(frameState2.wantedTiles[tileSourceKey]={});const wantedTiles=frameState2.wantedTiles[tileSourceKey],tileRepresentationCache=this.tileRepresentationCache,minZ=Math.max(initialZ-preload,tileGrid.getMinZoom(),tileGrid.getZForResolution(Math.min(tileLayer.getMaxResolution(),tileLayer.getMapInternal()?.getView()?.getResolutionForZoom(Math.max(tileLayer.getMinZoom(),0))||tileGrid.getResolution(0)),tileSource.zDirection));for(let z=initialZ;z>=minZ;z--){const tileRange=tileGrid.getTileRangeForExtentAndZ(extent,z,this.tempTileRange_),tileResolution=tileGrid.getResolution(z);for(let x=tileRange.minX;x<=tileRange.maxX;x++)for(let y=tileRange.minY;y<=tileRange.maxY;y++){const tileCoord=createOrUpdate$1(z,x,y,this.tmpTileCoord),cacheKey=getCacheKey(tileSource,tileCoord);let tileRepresentation=tileRepresentationCache.containsKey(cacheKey)?tileRepresentationCache.get(cacheKey):null,tile=tileRepresentation?.tile;if(!tileRepresentation||tile.key!==tileSource.getKey()){if(tile=tileSource.getTile(z,x,y,frameState2.pixelRatio,viewState.projection),!tile)continue;tileRepresentation=new TileTexture({tile,tileGrid,group:this.container,threejsLayer:this}),tileRepresentationCache.set(cacheKey,tileRepresentation)}tileRepresentationLookup.hasTile(tile)||(tileRepresentationLookup.addTileRepresentation(tileRepresentation,z),wantedTiles[tile.getKey()]=!0,tile.getState()===TileState.IDLE&&!frameState2.tileQueue.isKeyQueued(tile.getKey())&&frameState2.tileQueue.enqueue([tile,tileSourceKey,tileGrid.getTileCoordCenter(tileCoord),tileResolution]))}}}prepareFrame(frameState2){return this.prepareFrameInternal(frameState2)}prepareFrameInternal(frameState2){this.projection_!==frameState2.viewState.projection&&(this.tileRepresentationCache.clear(),this.projection_=frameState2.viewState.projection);const source=this.getLayer()?.getRenderSource();return!source||isEmpty(getRenderExtent(frameState2,frameState2.extent))?!1:source.getState()==="ready"}drawTile(frameState2,tileRepresentation,extentRenderer,alphaLookup,tileGrid){if(!tileRepresentation.ready)return;const tileCoord=tileRepresentation.tile.tileCoord,tileCoordKey=getKey(tileCoord),alpha=alphaLookup.has(tileCoordKey)?alphaLookup.get(tileCoordKey):1,tileExtent=tileGrid.getTileCoordExtent(tileCoord);alpha<1&&(frameState2.animate=!0);const[minXRender,minYRender,maxXRender,maxYRender]=extentRenderer,[minXTile,minYTile,maxXTile,maxYTile]=tileExtent,scaleX=(maxXTile-minXTile)/(maxXRender-minXRender),scaleY=(maxYTile-minYTile)/(maxYRender-minYRender),positionX=normalizeBetween((minXTile+maxXTile)/2,minXRender,maxXRender)-.5,positionY=normalizeBetween((minYTile+maxYTile)/2,minYRender,maxYRender)-.5;tileRepresentation.plane.position.set(positionX,positionY,0),tileRepresentation.plane.scale.set(scaleX,scaleY,1),tileRepresentation.plane.visible=!0,tileRepresentation.alpha=alpha}}class ThreeJsTileLayer extends BaseTileLayer{constructor(options,master){super(options),this.master=master}createRenderer(){return new ThreeJsTileLayerRenderer(this,{},this.master)}initRT=()=>this.getRenderer().initRT();releaseRT=()=>this.getRenderer().releaseRT();set opacity(value){this.getRenderer().opacity=value}get opacity(){return this.getRenderer().opacity}get texture(){return this.renderTarget?this.renderTarget.texture:null}get renderTarget(){return this.getRenderer().renderTarget}get container(){return this.getRenderer().container}get onTilesLoaded(){return this.getRenderer().onTilesLoaded}get onTilesDisplayed(){return this.getRenderer().onTilesDisplayed}get allTilesLoaded(){return this.getRenderer().allTilesLoaded}get allTilesDisplayed(){return this.getRenderer().allTilesDisplayed}}class TileRange{constructor(minX,maxX,minY,maxY){this.minX=minX,this.maxX=maxX,this.minY=minY,this.maxY=maxY}contains(tileCoord){return this.containsXY(tileCoord[1],tileCoord[2])}containsTileRange(tileRange){return this.minX<=tileRange.minX&&tileRange.maxX<=this.maxX&&this.minY<=tileRange.minY&&tileRange.maxY<=this.maxY}containsXY(x,y){return this.minX<=x&&x<=this.maxX&&this.minY<=y&&y<=this.maxY}equals(tileRange){return this.minX==tileRange.minX&&this.minY==tileRange.minY&&this.maxX==tileRange.maxX&&this.maxY==tileRange.maxY}extend(tileRange){tileRange.minX<this.minX&&(this.minX=tileRange.minX),tileRange.maxX>this.maxX&&(this.maxX=tileRange.maxX),tileRange.minY<this.minY&&(this.minY=tileRange.minY),tileRange.maxY>this.maxY&&(this.maxY=tileRange.maxY)}getHeight(){return this.maxY-this.minY+1}getSize(){return[this.getWidth(),this.getHeight()]}getWidth(){return this.maxX-this.minX+1}intersects(tileRange){return this.minX<=tileRange.maxX&&this.maxX>=tileRange.minX&&this.minY<=tileRange.maxY&&this.maxY>=tileRange.minY}}function createOrUpdate(minX,maxX,minY,maxY,tileRange){return tileRange!==void 0?(tileRange.minX=minX,tileRange.maxX=maxX,tileRange.minY=minY,tileRange.maxY=maxY,tileRange):new TileRange(minX,maxX,minY,maxY)}const tmpTileCoord=[0,0,0],DECIMALS=5;class TileGrid{constructor(options){this.minZoom=options.minZoom!==void 0?options.minZoom:0,this.resolutions_=options.resolutions,assert(isSorted(this.resolutions_,(a2,b)=>b-a2),"`resolutions` must be sorted in descending order");let zoomFactor;if(!options.origins){for(let i2=0,ii=this.resolutions_.length-1;i2<ii;++i2)if(!zoomFactor)zoomFactor=this.resolutions_[i2]/this.resolutions_[i2+1];else if(this.resolutions_[i2]/this.resolutions_[i2+1]!==zoomFactor){zoomFactor=void 0;break}}this.zoomFactor_=zoomFactor,this.maxZoom=this.resolutions_.length-1,this.origin_=options.origin!==void 0?options.origin:null,this.origins_=null,options.origins!==void 0&&(this.origins_=options.origins,assert(this.origins_.length==this.resolutions_.length,"Number of `origins` and `resolutions` must be equal"));const extent=options.extent;extent!==void 0&&!this.origin_&&!this.origins_&&(this.origin_=getTopLeft(extent)),assert(!this.origin_&&this.origins_||this.origin_&&!this.origins_,"Either `origin` or `origins` must be configured, never both"),this.tileSizes_=null,options.tileSizes!==void 0&&(this.tileSizes_=options.tileSizes,assert(this.tileSizes_.length==this.resolutions_.length,"Number of `tileSizes` and `resolutions` must be equal")),this.tileSize_=options.tileSize!==void 0?options.tileSize:this.tileSizes_?null:DEFAULT_TILE_SIZE,assert(!this.tileSize_&&this.tileSizes_||this.tileSize_&&!this.tileSizes_,"Either `tileSize` or `tileSizes` must be configured, never both"),this.extent_=extent!==void 0?extent:null,this.fullTileRanges_=null,this.tmpSize_=[0,0],this.tmpExtent_=[0,0,0,0],options.sizes!==void 0?this.fullTileRanges_=options.sizes.map((size,z)=>{const tileRange=new TileRange(Math.min(0,size[0]),Math.max(size[0]-1,-1),Math.min(0,size[1]),Math.max(size[1]-1,-1));if(extent){const restrictedTileRange=this.getTileRangeForExtentAndZ(extent,z);tileRange.minX=Math.max(restrictedTileRange.minX,tileRange.minX),tileRange.maxX=Math.min(restrictedTileRange.maxX,tileRange.maxX),tileRange.minY=Math.max(restrictedTileRange.minY,tileRange.minY),tileRange.maxY=Math.min(restrictedTileRange.maxY,tileRange.maxY)}return tileRange}):extent&&this.calculateTileRanges_(extent)}forEachTileCoord(extent,zoom,callback){const tileRange=this.getTileRangeForExtentAndZ(extent,zoom);for(let i2=tileRange.minX,ii=tileRange.maxX;i2<=ii;++i2)for(let j=tileRange.minY,jj=tileRange.maxY;j<=jj;++j)callback([zoom,i2,j])}forEachTileCoordParentTileRange(tileCoord,callback,tempTileRange,tempExtent){let tileRange,x,y,tileCoordExtent=null,z=tileCoord[0]-1;for(this.zoomFactor_===2?(x=tileCoord[1],y=tileCoord[2]):tileCoordExtent=this.getTileCoordExtent(tileCoord,tempExtent);z>=this.minZoom;){if(x!==void 0&&y!==void 0?(x=Math.floor(x/2),y=Math.floor(y/2),tileRange=createOrUpdate(x,x,y,y,tempTileRange)):tileRange=this.getTileRangeForExtentAndZ(tileCoordExtent,z,tempTileRange),callback(z,tileRange))return!0;--z}return!1}getExtent(){return this.extent_}getMaxZoom(){return this.maxZoom}getMinZoom(){return this.minZoom}getOrigin(z){return this.origin_?this.origin_:this.origins_[z]}getResolution(z){return this.resolutions_[z]}getResolutions(){return this.resolutions_}getTileCoordChildTileRange(tileCoord,tempTileRange,tempExtent){if(tileCoord[0]<this.maxZoom){if(this.zoomFactor_===2){const minX=tileCoord[1]*2,minY=tileCoord[2]*2;return createOrUpdate(minX,minX+1,minY,minY+1,tempTileRange)}const tileCoordExtent=this.getTileCoordExtent(tileCoord,tempExtent||this.tmpExtent_);return this.getTileRangeForExtentAndZ(tileCoordExtent,tileCoord[0]+1,tempTileRange)}return null}getTileRangeForTileCoordAndZ(tileCoord,z,tempTileRange){if(z>this.maxZoom||z<this.minZoom)return null;const tileCoordZ=tileCoord[0],tileCoordX=tileCoord[1],tileCoordY=tileCoord[2];if(z===tileCoordZ)return createOrUpdate(tileCoordX,tileCoordY,tileCoordX,tileCoordY,tempTileRange);if(this.zoomFactor_){const factor=Math.pow(this.zoomFactor_,z-tileCoordZ),minX=Math.floor(tileCoordX*factor),minY=Math.floor(tileCoordY*factor);if(z<tileCoordZ)return createOrUpdate(minX,minX,minY,minY,tempTileRange);const maxX=Math.floor(factor*(tileCoordX+1))-1,maxY=Math.floor(factor*(tileCoordY+1))-1;return createOrUpdate(minX,maxX,minY,maxY,tempTileRange)}const tileCoordExtent=this.getTileCoordExtent(tileCoord,this.tmpExtent_);return this.getTileRangeForExtentAndZ(tileCoordExtent,z,tempTileRange)}getTileRangeForExtentAndZ(extent,z,tempTileRange){this.getTileCoordForXYAndZ_(extent[0],extent[3],z,!1,tmpTileCoord);const minX=tmpTileCoord[1],minY=tmpTileCoord[2];this.getTileCoordForXYAndZ_(extent[2],extent[1],z,!0,tmpTileCoord);const maxX=tmpTileCoord[1],maxY=tmpTileCoord[2];return createOrUpdate(minX,maxX,minY,maxY,tempTileRange)}getTileCoordCenter(tileCoord){const origin=this.getOrigin(tileCoord[0]),resolution=this.getResolution(tileCoord[0]),tileSize=toSize(this.getTileSize(tileCoord[0]),this.tmpSize_);return[origin[0]+(tileCoord[1]+.5)*tileSize[0]*resolution,origin[1]-(tileCoord[2]+.5)*tileSize[1]*resolution]}getTileCoordExtent(tileCoord,tempExtent){const origin=this.getOrigin(tileCoord[0]),resolution=this.getResolution(tileCoord[0]),tileSize=toSize(this.getTileSize(tileCoord[0]),this.tmpSize_),minX=origin[0]+tileCoord[1]*tileSize[0]*resolution,minY=origin[1]-(tileCoord[2]+1)*tileSize[1]*resolution,maxX=minX+tileSize[0]*resolution,maxY=minY+tileSize[1]*resolution;return createOrUpdate$2(minX,minY,maxX,maxY,tempExtent)}getTileCoordForCoordAndResolution(coordinate,resolution,opt_tileCoord){return this.getTileCoordForXYAndResolution_(coordinate[0],coordinate[1],resolution,!1,opt_tileCoord)}getTileCoordForXYAndResolution_(x,y,resolution,reverseIntersectionPolicy,opt_tileCoord){const z=this.getZForResolution(resolution),scale2=resolution/this.getResolution(z),origin=this.getOrigin(z),tileSize=toSize(this.getTileSize(z),this.tmpSize_);let tileCoordX=scale2*(x-origin[0])/resolution/tileSize[0],tileCoordY=scale2*(origin[1]-y)/resolution/tileSize[1];return reverseIntersectionPolicy?(tileCoordX=ceil$1(tileCoordX,DECIMALS)-1,tileCoordY=ceil$1(tileCoordY,DECIMALS)-1):(tileCoordX=floor$2(tileCoordX,DECIMALS),tileCoordY=floor$2(tileCoordY,DECIMALS)),createOrUpdate$1(z,tileCoordX,tileCoordY,opt_tileCoord)}getTileCoordForXYAndZ_(x,y,z,reverseIntersectionPolicy,opt_tileCoord){const origin=this.getOrigin(z),resolution=this.getResolution(z),tileSize=toSize(this.getTileSize(z),this.tmpSize_);let tileCoordX=(x-origin[0])/resolution/tileSize[0],tileCoordY=(origin[1]-y)/resolution/tileSize[1];return reverseIntersectionPolicy?(tileCoordX=ceil$1(tileCoordX,DECIMALS)-1,tileCoordY=ceil$1(tileCoordY,DECIMALS)-1):(tileCoordX=floor$2(tileCoordX,DECIMALS),tileCoordY=floor$2(tileCoordY,DECIMALS)),createOrUpdate$1(z,tileCoordX,tileCoordY,opt_tileCoord)}getTileCoordForCoordAndZ(coordinate,z,opt_tileCoord){return this.getTileCoordForXYAndZ_(coordinate[0],coordinate[1],z,!1,opt_tileCoord)}getTileCoordResolution(tileCoord){return this.resolutions_[tileCoord[0]]}getTileSize(z){return this.tileSize_?this.tileSize_:this.tileSizes_[z]}getFullTileRange(z){return this.fullTileRanges_?this.fullTileRanges_[z]:this.extent_?this.getTileRangeForExtentAndZ(this.extent_,z):null}getZForResolution(resolution,opt_direction){const z=linearFindNearest(this.resolutions_,resolution,opt_direction||0);return clamp$2(z,this.minZoom,this.maxZoom)}tileCoordIntersectsViewport(tileCoord,viewport2){return intersectsLinearRing(viewport2,0,viewport2.length,2,this.getTileCoordExtent(tileCoord))}calculateTileRanges_(extent){const length2=this.resolutions_.length,fullTileRanges=new Array(length2);for(let z=this.minZoom;z<length2;++z)fullTileRanges[z]=this.getTileRangeForExtentAndZ(extent,z);this.fullTileRanges_=fullTileRanges}}function getForProjection(projection){let tileGrid=projection.getDefaultTileGrid();return tileGrid||(tileGrid=createForProjection(projection),projection.setDefaultTileGrid(tileGrid)),tileGrid}function wrapX(tileGrid,tileCoord,projection){const z=tileCoord[0],center=tileGrid.getTileCoordCenter(tileCoord),projectionExtent=extentFromProjection(projection);if(!containsCoordinate(projectionExtent,center)){const worldWidth=getWidth(projectionExtent),worldsAway=Math.ceil((projectionExtent[0]-center[0])/worldWidth);return center[0]+=worldWidth*worldsAway,tileGrid.getTileCoordForCoordAndZ(center,z)}return tileCoord}function createForExtent(extent,maxZoom,tileSize,corner){corner=corner!==void 0?corner:"top-left";const resolutions=resolutionsFromExtent(extent,maxZoom,tileSize);return new TileGrid({extent,origin:getCorner(extent,corner),resolutions,tileSize})}function createXYZ(options){const xyzOptions=options||{},extent=xyzOptions.extent||get$1("EPSG:3857").getExtent(),gridOptions={extent,minZoom:xyzOptions.minZoom,tileSize:xyzOptions.tileSize,resolutions:resolutionsFromExtent(extent,xyzOptions.maxZoom,xyzOptions.tileSize,xyzOptions.maxResolution)};return new TileGrid(gridOptions)}function resolutionsFromExtent(extent,maxZoom,tileSize,maxResolution){maxZoom=maxZoom!==void 0?maxZoom:DEFAULT_MAX_ZOOM,tileSize=toSize(tileSize!==void 0?tileSize:DEFAULT_TILE_SIZE);const height=getHeight(extent),width=getWidth(extent);maxResolution=maxResolution>0?maxResolution:Math.max(width/tileSize[0],height/tileSize[1]);const length2=maxZoom+1,resolutions=new Array(length2);for(let z=0;z<length2;++z)resolutions[z]=maxResolution/Math.pow(2,z);return resolutions}function createForProjection(projection,maxZoom,tileSize,corner){const extent=extentFromProjection(projection);return createForExtent(extent,maxZoom,tileSize,corner)}function extentFromProjection(projection){projection=get$1(projection);let extent=projection.getExtent();if(!extent){const half=180*METERS_PER_UNIT$1.degrees/projection.getMetersPerUnit();extent=createOrUpdate$2(-half,-half,half,half)}return extent}class Tile extends Target{constructor(tileCoord,state,options){super(),options=options||{},this.tileCoord=tileCoord,this.state=state,this.key="",this.transition_=options.transition===void 0?250:options.transition,this.transitionStarts_={},this.interpolate=!!options.interpolate}changed(){this.dispatchEvent(EventType.CHANGE)}release(){this.setState(TileState.EMPTY)}getKey(){return this.key+"/"+this.tileCoord}getTileCoord(){return this.tileCoord}getState(){return this.state}setState(state){if(this.state!==TileState.EMPTY){if(this.state!==TileState.ERROR&&this.state>state)throw new Error("Tile load sequence violation");this.state=state,this.changed()}}load(){abstract()}getAlpha(id,time2){if(!this.transition_)return 1;let start=this.transitionStarts_[id];if(!start)start=time2,this.transitionStarts_[id]=start;else if(start===-1)return 1;const delta=time2-start+1e3/60;return delta>=this.transition_?1:easeIn(delta/this.transition_)}inTransition(id){return this.transition_?this.transitionStarts_[id]!==-1:!1}endTransition(id){this.transition_&&(this.transitionStarts_[id]=-1)}disposeInternal(){this.release(),super.disposeInternal()}}class ImageTile extends Tile{constructor(tileCoord,state,src,crossOrigin,tileLoadFunction,options){super(tileCoord,state,options),this.crossOrigin_=crossOrigin,this.src_=src,this.key=src,this.image_=new Image,crossOrigin!==null&&(this.image_.crossOrigin=crossOrigin),this.unlisten_=null,this.tileLoadFunction_=tileLoadFunction}getImage(){return this.image_}setImage(element2){this.image_=element2,this.state=TileState.LOADED,this.unlistenImage_(),this.changed()}handleImageError_(){this.state=TileState.ERROR,this.unlistenImage_(),this.image_=getBlankImage(),this.changed()}handleImageLoad_(){const image=this.image_;image.naturalWidth&&image.naturalHeight?this.state=TileState.LOADED:this.state=TileState.EMPTY,this.unlistenImage_(),this.changed()}load(){this.state==TileState.ERROR&&(this.state=TileState.IDLE,this.image_=new Image,this.crossOrigin_!==null&&(this.image_.crossOrigin=this.crossOrigin_)),this.state==TileState.IDLE&&(this.state=TileState.LOADING,this.changed(),this.tileLoadFunction_(this,this.src_),this.unlisten_=listenImage(this.image_,this.handleImageLoad_.bind(this),this.handleImageError_.bind(this)))}unlistenImage_(){this.unlisten_&&(this.unlisten_(),this.unlisten_=null)}disposeInternal(){this.unlistenImage_(),this.image_=null,super.disposeInternal()}}function getBlankImage(){const ctx=createCanvasContext2D(1,1);return ctx.fillStyle="rgba(0,0,0,0)",ctx.fillRect(0,0,1,1),ctx.canvas}let brokenDiagonalRendering_;const canvasPool=[];function drawTestTriangle(ctx,u1,v1,u2,v2){ctx.beginPath(),ctx.moveTo(0,0),ctx.lineTo(u1,v1),ctx.lineTo(u2,v2),ctx.closePath(),ctx.save(),ctx.clip(),ctx.fillRect(0,0,Math.max(u1,u2)+1,Math.max(v1,v2)),ctx.restore()}function verifyBrokenDiagonalRendering(data,offset){return Math.abs(data[offset*4]-210)>2||Math.abs(data[offset*4+3]-.75*255)>2}function isBrokenDiagonalRendering(){if(brokenDiagonalRendering_===void 0){const ctx=createCanvasContext2D(6,6,canvasPool);ctx.globalCompositeOperation="lighter",ctx.fillStyle="rgba(210, 0, 0, 0.75)",drawTestTriangle(ctx,4,5,4,0),drawTestTriangle(ctx,4,5,0,5);const data=ctx.getImageData(0,0,3,3).data;brokenDiagonalRendering_=verifyBrokenDiagonalRendering(data,0)||verifyBrokenDiagonalRendering(data,4)||verifyBrokenDiagonalRendering(data,8),releaseCanvas(ctx),canvasPool.push(ctx.canvas)}return brokenDiagonalRendering_}function calculateSourceResolution(sourceProj,targetProj,targetCenter,targetResolution){const sourceCenter=transform(targetCenter,targetProj,sourceProj);let sourceResolution=getPointResolution(targetProj,targetResolution,targetCenter);const targetMetersPerUnit=targetProj.getMetersPerUnit();targetMetersPerUnit!==void 0&&(sourceResolution*=targetMetersPerUnit);const sourceMetersPerUnit=sourceProj.getMetersPerUnit();sourceMetersPerUnit!==void 0&&(sourceResolution/=sourceMetersPerUnit);const sourceExtent=sourceProj.getExtent();if(!sourceExtent||containsCoordinate(sourceExtent,sourceCenter)){const compensationFactor=getPointResolution(sourceProj,sourceResolution,sourceCenter)/sourceResolution;isFinite(compensationFactor)&&compensationFactor>0&&(sourceResolution/=compensationFactor)}return sourceResolution}function calculateSourceExtentResolution(sourceProj,targetProj,targetExtent,targetResolution){const targetCenter=getCenter(targetExtent);let sourceResolution=calculateSourceResolution(sourceProj,targetProj,targetCenter,targetResolution);return(!isFinite(sourceResolution)||sourceResolution<=0)&&forEachCorner(targetExtent,function(corner){return sourceResolution=calculateSourceResolution(sourceProj,targetProj,corner,targetResolution),isFinite(sourceResolution)&&sourceResolution>0}),sourceResolution}function render$1(width,height,pixelRatio,sourceResolution,sourceExtent,targetResolution,targetExtent,triangulation,sources,gutter,renderEdges,interpolate2,drawSingle,clipExtent){const context2=createCanvasContext2D(Math.round(pixelRatio*width),Math.round(pixelRatio*height),canvasPool);if(interpolate2||(context2.imageSmoothingEnabled=!1),sources.length===0)return context2.canvas;context2.scale(pixelRatio,pixelRatio);function pixelRound(value){return Math.round(value*pixelRatio)/pixelRatio}context2.globalCompositeOperation="lighter";const sourceDataExtent=createEmpty();sources.forEach(function(src,i2,arr){extend$2(sourceDataExtent,src.extent)});let stitchContext;const stitchScale=pixelRatio/sourceResolution,inverseScale=(interpolate2?1:1+Math.pow(2,-24))/stitchScale;stitchContext=createCanvasContext2D(Math.round(getWidth(sourceDataExtent)*stitchScale),Math.round(getHeight(sourceDataExtent)*stitchScale),canvasPool),interpolate2||(stitchContext.imageSmoothingEnabled=!1),sources.forEach(function(src,i2,arr){if(src.image.width>0&&src.image.height>0){if(src.clipExtent){stitchContext.save();const xPos2=(src.clipExtent[0]-sourceDataExtent[0])*stitchScale,yPos2=-(src.clipExtent[3]-sourceDataExtent[3])*stitchScale,width2=getWidth(src.clipExtent)*stitchScale,height2=getHeight(src.clipExtent)*stitchScale;stitchContext.rect(interpolate2?xPos2:Math.round(xPos2),interpolate2?yPos2:Math.round(yPos2),interpolate2?width2:Math.round(xPos2+width2)-Math.round(xPos2),interpolate2?height2:Math.round(yPos2+height2)-Math.round(yPos2)),stitchContext.clip()}const xPos=(src.extent[0]-sourceDataExtent[0])*stitchScale,yPos=-(src.extent[3]-sourceDataExtent[3])*stitchScale,srcWidth=getWidth(src.extent)*stitchScale,srcHeight=getHeight(src.extent)*stitchScale;stitchContext.drawImage(src.image,gutter,gutter,src.image.width-2*gutter,src.image.height-2*gutter,interpolate2?xPos:Math.round(xPos),interpolate2?yPos:Math.round(yPos),interpolate2?srcWidth:Math.round(xPos+srcWidth)-Math.round(xPos),interpolate2?srcHeight:Math.round(yPos+srcHeight)-Math.round(yPos)),src.clipExtent&&stitchContext.restore()}});const targetTopLeft=getTopLeft(targetExtent);return triangulation.getTriangles().forEach(function(triangle,i2,arr){const source=triangle.source,target=triangle.target;let x0=source[0][0],y0=source[0][1],x1=source[1][0],y1=source[1][1],x2=source[2][0],y2=source[2][1];const u0=pixelRound((target[0][0]-targetTopLeft[0])/targetResolution),v0=pixelRound(-(target[0][1]-targetTopLeft[1])/targetResolution),u1=pixelRound((target[1][0]-targetTopLeft[0])/targetResolution),v1=pixelRound(-(target[1][1]-targetTopLeft[1])/targetResolution),u2=pixelRound((target[2][0]-targetTopLeft[0])/targetResolution),v2=pixelRound(-(target[2][1]-targetTopLeft[1])/targetResolution),sourceNumericalShiftX=x0,sourceNumericalShiftY=y0;x0=0,y0=0,x1-=sourceNumericalShiftX,y1-=sourceNumericalShiftY,x2-=sourceNumericalShiftX,y2-=sourceNumericalShiftY;const augmentedMatrix=[[x1,y1,0,0,u1-u0],[x2,y2,0,0,u2-u0],[0,0,x1,y1,v1-v0],[0,0,x2,y2,v2-v0]],affineCoefs=solveLinearSystem(augmentedMatrix);if(!affineCoefs)return;if(context2.save(),context2.beginPath(),isBrokenDiagonalRendering()||!interpolate2){context2.moveTo(u1,v1);const steps2=4,ud=u0-u1,vd=v0-v1;for(let step2=0;step2<steps2;step2++)context2.lineTo(u1+pixelRound((step2+1)*ud/steps2),v1+pixelRound(step2*vd/(steps2-1))),step2!=steps2-1&&context2.lineTo(u1+pixelRound((step2+1)*ud/steps2),v1+pixelRound((step2+1)*vd/(steps2-1)));context2.lineTo(u2,v2)}else context2.moveTo(u1,v1),context2.lineTo(u0,v0),context2.lineTo(u2,v2);context2.clip(),context2.transform(affineCoefs[0],affineCoefs[2],affineCoefs[1],affineCoefs[3],u0,v0),context2.translate(sourceDataExtent[0]-sourceNumericalShiftX,sourceDataExtent[3]-sourceNumericalShiftY);let image;if(stitchContext)image=stitchContext.canvas,context2.scale(inverseScale,-inverseScale);else{const source2=sources[0],extent=source2.extent;image=source2.image,context2.scale(getWidth(extent)/image.width,-getHeight(extent)/image.height)}context2.drawImage(image,0,0),context2.restore()}),stitchContext&&(releaseCanvas(stitchContext),canvasPool.push(stitchContext.canvas)),renderEdges&&(context2.save(),context2.globalCompositeOperation="source-over",context2.strokeStyle="black",context2.lineWidth=1,triangulation.getTriangles().forEach(function(triangle,i2,arr){const target=triangle.target,u0=(target[0][0]-targetTopLeft[0])/targetResolution,v0=-(target[0][1]-targetTopLeft[1])/targetResolution,u1=(target[1][0]-targetTopLeft[0])/targetResolution,v1=-(target[1][1]-targetTopLeft[1])/targetResolution,u2=(target[2][0]-targetTopLeft[0])/targetResolution,v2=-(target[2][1]-targetTopLeft[1])/targetResolution;context2.beginPath(),context2.moveTo(u1,v1),context2.lineTo(u0,v0),context2.lineTo(u2,v2),context2.closePath(),context2.stroke()}),context2.restore()),context2.canvas}const MAX_SUBDIVISION=10,MAX_TRIANGLE_WIDTH=.25;class Triangulation{constructor(sourceProj,targetProj,targetExtent,maxSourceExtent,errorThreshold,destinationResolution,sourceMatrix){this.sourceProj_=sourceProj,this.targetProj_=targetProj;let transformInvCache={};const transformInv=sourceMatrix?createTransformFromCoordinateTransform(input=>apply$1(sourceMatrix,transform(input,this.targetProj_,this.sourceProj_))):getTransform(this.targetProj_,this.sourceProj_);this.transformInv_=function(c2){const key2=c2[0]+"/"+c2[1];return transformInvCache[key2]||(transformInvCache[key2]=transformInv(c2)),transformInvCache[key2]},this.maxSourceExtent_=maxSourceExtent,this.errorThresholdSquared_=errorThreshold*errorThreshold,this.triangles_=[],this.wrapsXInSource_=!1,this.canWrapXInSource_=this.sourceProj_.canWrapX()&&!!maxSourceExtent&&!!this.sourceProj_.getExtent()&&getWidth(maxSourceExtent)>=getWidth(this.sourceProj_.getExtent()),this.sourceWorldWidth_=this.sourceProj_.getExtent()?getWidth(this.sourceProj_.getExtent()):null,this.targetWorldWidth_=this.targetProj_.getExtent()?getWidth(this.targetProj_.getExtent()):null;const destinationTopLeft=getTopLeft(targetExtent),destinationTopRight=getTopRight(targetExtent),destinationBottomRight=getBottomRight(targetExtent),destinationBottomLeft=getBottomLeft(targetExtent),sourceTopLeft=this.transformInv_(destinationTopLeft),sourceTopRight=this.transformInv_(destinationTopRight),sourceBottomRight=this.transformInv_(destinationBottomRight),sourceBottomLeft=this.transformInv_(destinationBottomLeft),maxSubdivision=MAX_SUBDIVISION+(destinationResolution?Math.max(0,Math.ceil(Math.log2(getArea(targetExtent)/(destinationResolution*destinationResolution*256*256)))):0);if(this.addQuad_(destinationTopLeft,destinationTopRight,destinationBottomRight,destinationBottomLeft,sourceTopLeft,sourceTopRight,sourceBottomRight,sourceBottomLeft,maxSubdivision),this.wrapsXInSource_){let leftBound=1/0;this.triangles_.forEach(function(triangle,i2,arr){leftBound=Math.min(leftBound,triangle.source[0][0],triangle.source[1][0],triangle.source[2][0])}),this.triangles_.forEach(triangle=>{if(Math.max(triangle.source[0][0],triangle.source[1][0],triangle.source[2][0])-leftBound>this.sourceWorldWidth_/2){const newTriangle=[[triangle.source[0][0],triangle.source[0][1]],[triangle.source[1][0],triangle.source[1][1]],[triangle.source[2][0],triangle.source[2][1]]];newTriangle[0][0]-leftBound>this.sourceWorldWidth_/2&&(newTriangle[0][0]-=this.sourceWorldWidth_),newTriangle[1][0]-leftBound>this.sourceWorldWidth_/2&&(newTriangle[1][0]-=this.sourceWorldWidth_),newTriangle[2][0]-leftBound>this.sourceWorldWidth_/2&&(newTriangle[2][0]-=this.sourceWorldWidth_);const minX=Math.min(newTriangle[0][0],newTriangle[1][0],newTriangle[2][0]);Math.max(newTriangle[0][0],newTriangle[1][0],newTriangle[2][0])-minX<this.sourceWorldWidth_/2&&(triangle.source=newTriangle)}})}transformInvCache={}}addTriangle_(a2,b,c2,aSrc,bSrc,cSrc){this.triangles_.push({source:[aSrc,bSrc,cSrc],target:[a2,b,c2]})}addQuad_(a2,b,c2,d2,aSrc,bSrc,cSrc,dSrc,maxSubdivision){const sourceQuadExtent=boundingExtent([aSrc,bSrc,cSrc,dSrc]),sourceCoverageX=this.sourceWorldWidth_?getWidth(sourceQuadExtent)/this.sourceWorldWidth_:null,sourceWorldWidth=this.sourceWorldWidth_,wrapsX=this.sourceProj_.canWrapX()&&sourceCoverageX>.5&&sourceCoverageX<1;let needsSubdivision=!1;if(maxSubdivision>0){if(this.targetProj_.isGlobal()&&this.targetWorldWidth_){const targetQuadExtent=boundingExtent([a2,b,c2,d2]);needsSubdivision=getWidth(targetQuadExtent)/this.targetWorldWidth_>MAX_TRIANGLE_WIDTH||needsSubdivision}!wrapsX&&this.sourceProj_.isGlobal()&&sourceCoverageX&&(needsSubdivision=sourceCoverageX>MAX_TRIANGLE_WIDTH||needsSubdivision)}if(!needsSubdivision&&this.maxSourceExtent_&&isFinite(sourceQuadExtent[0])&&isFinite(sourceQuadExtent[1])&&isFinite(sourceQuadExtent[2])&&isFinite(sourceQuadExtent[3])&&!intersects$1(sourceQuadExtent,this.maxSourceExtent_))return;let isNotFinite=0;if(!needsSubdivision&&(!isFinite(aSrc[0])||!isFinite(aSrc[1])||!isFinite(bSrc[0])||!isFinite(bSrc[1])||!isFinite(cSrc[0])||!isFinite(cSrc[1])||!isFinite(dSrc[0])||!isFinite(dSrc[1]))){if(maxSubdivision>0)needsSubdivision=!0;else if(isNotFinite=(!isFinite(aSrc[0])||!isFinite(aSrc[1])?8:0)+(!isFinite(bSrc[0])||!isFinite(bSrc[1])?4:0)+(!isFinite(cSrc[0])||!isFinite(cSrc[1])?2:0)+(!isFinite(dSrc[0])||!isFinite(dSrc[1])?1:0),isNotFinite!=1&&isNotFinite!=2&&isNotFinite!=4&&isNotFinite!=8)return}if(maxSubdivision>0){if(!needsSubdivision){const center=[(a2[0]+c2[0])/2,(a2[1]+c2[1])/2],centerSrc=this.transformInv_(center);let dx;wrapsX?dx=(modulo(aSrc[0],sourceWorldWidth)+modulo(cSrc[0],sourceWorldWidth))/2-modulo(centerSrc[0],sourceWorldWidth):dx=(aSrc[0]+cSrc[0])/2-centerSrc[0];const dy=(aSrc[1]+cSrc[1])/2-centerSrc[1];needsSubdivision=dx*dx+dy*dy>this.errorThresholdSquared_}if(needsSubdivision){if(Math.abs(a2[0]-c2[0])<=Math.abs(a2[1]-c2[1])){const bc=[(b[0]+c2[0])/2,(b[1]+c2[1])/2],bcSrc=this.transformInv_(bc),da=[(d2[0]+a2[0])/2,(d2[1]+a2[1])/2],daSrc=this.transformInv_(da);this.addQuad_(a2,b,bc,da,aSrc,bSrc,bcSrc,daSrc,maxSubdivision-1),this.addQuad_(da,bc,c2,d2,daSrc,bcSrc,cSrc,dSrc,maxSubdivision-1)}else{const ab=[(a2[0]+b[0])/2,(a2[1]+b[1])/2],abSrc=this.transformInv_(ab),cd=[(c2[0]+d2[0])/2,(c2[1]+d2[1])/2],cdSrc=this.transformInv_(cd);this.addQuad_(a2,ab,cd,d2,aSrc,abSrc,cdSrc,dSrc,maxSubdivision-1),this.addQuad_(ab,b,c2,cd,abSrc,bSrc,cSrc,cdSrc,maxSubdivision-1)}return}}if(wrapsX){if(!this.canWrapXInSource_)return;this.wrapsXInSource_=!0}isNotFinite&11||this.addTriangle_(a2,c2,d2,aSrc,cSrc,dSrc),isNotFinite&14||this.addTriangle_(a2,c2,b,aSrc,cSrc,bSrc),isNotFinite&&(isNotFinite&13||this.addTriangle_(b,d2,a2,bSrc,dSrc,aSrc),isNotFinite&7||this.addTriangle_(b,d2,c2,bSrc,dSrc,cSrc))}calculateSourceExtent(){const extent=createEmpty();return this.triangles_.forEach(function(triangle,i2,arr){const src=triangle.source;extendCoordinate(extent,src[0]),extendCoordinate(extent,src[1]),extendCoordinate(extent,src[2])}),extent}getTriangles(){return this.triangles_}}const ERROR_THRESHOLD=.5;class ReprojTile extends Tile{constructor(sourceProj,sourceTileGrid,targetProj,targetTileGrid,tileCoord,wrappedTileCoord,pixelRatio,gutter,getTileFunction,errorThreshold,renderEdges,options){super(tileCoord,TileState.IDLE,options),this.renderEdges_=renderEdges!==void 0?renderEdges:!1,this.pixelRatio_=pixelRatio,this.gutter_=gutter,this.canvas_=null,this.sourceTileGrid_=sourceTileGrid,this.targetTileGrid_=targetTileGrid,this.wrappedTileCoord_=wrappedTileCoord||tileCoord,this.sourceTiles_=[],this.sourcesListenerKeys_=null,this.sourceZ_=0,this.clipExtent_=sourceProj.canWrapX()?sourceProj.getExtent():void 0;const targetExtent=targetTileGrid.getTileCoordExtent(this.wrappedTileCoord_),maxTargetExtent=this.targetTileGrid_.getExtent();let maxSourceExtent=this.sourceTileGrid_.getExtent();const limitedTargetExtent=maxTargetExtent?getIntersection(targetExtent,maxTargetExtent):targetExtent;if(getArea(limitedTargetExtent)===0){this.state=TileState.EMPTY;return}const sourceProjExtent=sourceProj.getExtent();sourceProjExtent&&(maxSourceExtent?maxSourceExtent=getIntersection(maxSourceExtent,sourceProjExtent):maxSourceExtent=sourceProjExtent);const targetResolution=targetTileGrid.getResolution(this.wrappedTileCoord_[0]),sourceResolution=calculateSourceExtentResolution(sourceProj,targetProj,limitedTargetExtent,targetResolution);if(!isFinite(sourceResolution)||sourceResolution<=0){this.state=TileState.EMPTY;return}const errorThresholdInPixels=errorThreshold!==void 0?errorThreshold:ERROR_THRESHOLD;if(this.triangulation_=new Triangulation(sourceProj,targetProj,limitedTargetExtent,maxSourceExtent,sourceResolution*errorThresholdInPixels,targetResolution),this.triangulation_.getTriangles().length===0){this.state=TileState.EMPTY;return}this.sourceZ_=sourceTileGrid.getZForResolution(sourceResolution);let sourceExtent=this.triangulation_.calculateSourceExtent();if(maxSourceExtent&&(sourceProj.canWrapX()?(sourceExtent[1]=clamp$2(sourceExtent[1],maxSourceExtent[1],maxSourceExtent[3]),sourceExtent[3]=clamp$2(sourceExtent[3],maxSourceExtent[1],maxSourceExtent[3])):sourceExtent=getIntersection(sourceExtent,maxSourceExtent)),!getArea(sourceExtent))this.state=TileState.EMPTY;else{let worldWidth=0,worldsAway=0;sourceProj.canWrapX()&&(worldWidth=getWidth(sourceProjExtent),worldsAway=Math.floor((sourceExtent[0]-sourceProjExtent[0])/worldWidth)),wrapAndSliceX(sourceExtent.slice(),sourceProj).forEach(extent=>{const sourceRange=sourceTileGrid.getTileRangeForExtentAndZ(extent,this.sourceZ_);for(let srcX=sourceRange.minX;srcX<=sourceRange.maxX;srcX++)for(let srcY=sourceRange.minY;srcY<=sourceRange.maxY;srcY++){const tile=getTileFunction(this.sourceZ_,srcX,srcY,pixelRatio);if(tile){const offset=worldsAway*worldWidth;this.sourceTiles_.push({tile,offset})}}++worldsAway}),this.sourceTiles_.length===0&&(this.state=TileState.EMPTY)}}getImage(){return this.canvas_}reproject_(){const sources=[];if(this.sourceTiles_.forEach(source=>{const tile=source.tile;if(tile&&tile.getState()==TileState.LOADED){const extent=this.sourceTileGrid_.getTileCoordExtent(tile.tileCoord);extent[0]+=source.offset,extent[2]+=source.offset;const clipExtent=this.clipExtent_?.slice();clipExtent&&(clipExtent[0]+=source.offset,clipExtent[2]+=source.offset),sources.push({extent,clipExtent,image:tile.getImage()})}}),this.sourceTiles_.length=0,sources.length===0)this.state=TileState.ERROR;else{const z=this.wrappedTileCoord_[0],size=this.targetTileGrid_.getTileSize(z),width=typeof size=="number"?size:size[0],height=typeof size=="number"?size:size[1],targetResolution=this.targetTileGrid_.getResolution(z),sourceResolution=this.sourceTileGrid_.getResolution(this.sourceZ_),targetExtent=this.targetTileGrid_.getTileCoordExtent(this.wrappedTileCoord_);this.canvas_=render$1(width,height,this.pixelRatio_,sourceResolution,this.sourceTileGrid_.getExtent(),targetResolution,targetExtent,this.triangulation_,sources,this.gutter_,this.renderEdges_,this.interpolate),this.state=TileState.LOADED}this.changed()}load(){if(this.state==TileState.IDLE){this.state=TileState.LOADING,this.changed();let leftToLoad=0;this.sourcesListenerKeys_=[],this.sourceTiles_.forEach(({tile})=>{const state=tile.getState();if(state==TileState.IDLE||state==TileState.LOADING){leftToLoad++;const sourceListenKey=listen(tile,EventType.CHANGE,e2=>{const state2=tile.getState();(state2==TileState.LOADED||state2==TileState.ERROR||state2==TileState.EMPTY)&&(unlistenByKey(sourceListenKey),leftToLoad--,leftToLoad===0&&(this.unlistenSources_(),this.reproject_()))});this.sourcesListenerKeys_.push(sourceListenKey)}}),leftToLoad===0?setTimeout(this.reproject_.bind(this),0):this.sourceTiles_.forEach(function({tile},i2,arr){tile.getState()==TileState.IDLE&&tile.load()})}}unlistenSources_(){this.sourcesListenerKeys_.forEach(unlistenByKey),this.sourcesListenerKeys_=null}release(){this.canvas_&&(releaseCanvas(this.canvas_.getContext("2d")),canvasPool.push(this.canvas_),this.canvas_=null),super.release()}}const zRegEx=/\{z\}/g,xRegEx=/\{x\}/g,yRegEx=/\{y\}/g,dashYRegEx=/\{-y\}/g;function renderXYZTemplate(template,z,x,y,maxY){return template.replace(zRegEx,z.toString()).replace(xRegEx,x.toString()).replace(yRegEx,y.toString()).replace(dashYRegEx,function(){if(maxY===void 0)throw new Error("If the URL template has a {-y} placeholder, the grid extent must be known");return(maxY-y).toString()})}function expandUrl(url){const urls=[];let match=/\{([a-z])-([a-z])\}/.exec(url);if(match){const startCharCode=match[1].charCodeAt(0),stopCharCode=match[2].charCodeAt(0);let charCode;for(charCode=startCharCode;charCode<=stopCharCode;++charCode)urls.push(url.replace(match[0],String.fromCharCode(charCode)));return urls}if(match=/\{(\d+)-(\d+)\}/.exec(url),match){const stop=parseInt(match[2],10);for(let i2=parseInt(match[1],10);i2<=stop;i2++)urls.push(url.replace(match[0],i2.toString()));return urls}return urls.push(url),urls}function createFromTemplate(template,tileGrid){return function(tileCoord,pixelRatio,projection){if(!tileCoord)return;let maxY;const z=tileCoord[0];if(tileGrid){const range2=tileGrid.getFullTileRange(z);range2&&(maxY=range2.getHeight()-1)}return renderXYZTemplate(template,z,tileCoord[1],tileCoord[2],maxY)}}function createFromTemplates(templates,tileGrid){const len=templates.length,tileUrlFunctions=new Array(len);for(let i2=0;i2<len;++i2)tileUrlFunctions[i2]=createFromTemplate(templates[i2],tileGrid);return createFromTileUrlFunctions(tileUrlFunctions)}function createFromTileUrlFunctions(tileUrlFunctions){return tileUrlFunctions.length===1?tileUrlFunctions[0]:function(tileCoord,pixelRatio,projection){if(!tileCoord)return;const h=hash(tileCoord),index=modulo(h,tileUrlFunctions.length);return tileUrlFunctions[index](tileCoord,pixelRatio,projection)}}class Source2 extends BaseObject{constructor(options){super(),this.projection=get$1(options.projection),this.attributions_=adaptAttributions(options.attributions),this.attributionsCollapsible_=options.attributionsCollapsible??!0,this.loading=!1,this.state_=options.state!==void 0?options.state:"ready",this.wrapX_=options.wrapX!==void 0?options.wrapX:!1,this.interpolate_=!!options.interpolate,this.viewResolver=null,this.viewRejector=null;const self2=this;this.viewPromise_=new Promise(function(resolve,reject){self2.viewResolver=resolve,self2.viewRejector=reject})}getAttributions(){return this.attributions_}getAttributionsCollapsible(){return this.attributionsCollapsible_}getProjection(){return this.projection}getResolutions(projection){return null}getView(){return this.viewPromise_}getState(){return this.state_}getWrapX(){return this.wrapX_}getInterpolate(){return this.interpolate_}refresh(){this.changed()}setAttributions(attributions){this.attributions_=adaptAttributions(attributions),this.changed()}setState(state){this.state_=state,this.changed()}}function adaptAttributions(attributionLike){return attributionLike?typeof attributionLike=="function"?attributionLike:(Array.isArray(attributionLike)||(attributionLike=[attributionLike]),frameState2=>attributionLike):null}class TileSource extends Source2{constructor(options){super({attributions:options.attributions,attributionsCollapsible:options.attributionsCollapsible,projection:options.projection,state:options.state,wrapX:options.wrapX,interpolate:options.interpolate}),this.on,this.once,this.un,this.tilePixelRatio_=options.tilePixelRatio!==void 0?options.tilePixelRatio:1,this.tileGrid=options.tileGrid!==void 0?options.tileGrid:null;const tileSize=[256,256];this.tileGrid&&toSize(this.tileGrid.getTileSize(this.tileGrid.getMinZoom()),tileSize),this.tmpSize=[0,0],this.key_=options.key||getUid(this),this.tileOptions={transition:options.transition,interpolate:options.interpolate},this.zDirection=options.zDirection?options.zDirection:0}getGutterForProjection(projection){return 0}getKey(){return this.key_}setKey(key2){this.key_!==key2&&(this.key_=key2,this.changed())}getResolutions(projection){const tileGrid=projection?this.getTileGridForProjection(projection):this.tileGrid;return tileGrid?tileGrid.getResolutions():null}getTile(z,x,y,pixelRatio,projection){return abstract()}getTileGrid(){return this.tileGrid}getTileGridForProjection(projection){return this.tileGrid?this.tileGrid:getForProjection(projection)}getTilePixelRatio(pixelRatio){return this.tilePixelRatio_}getTilePixelSize(z,pixelRatio,projection){const tileGrid=this.getTileGridForProjection(projection),tilePixelRatio=this.getTilePixelRatio(pixelRatio),tileSize=toSize(tileGrid.getTileSize(z),this.tmpSize);return tilePixelRatio==1?tileSize:scale(tileSize,tilePixelRatio,this.tmpSize)}getTileCoordForTileUrlFunction(tileCoord,projection){const gridProjection=projection!==void 0?projection:this.getProjection(),tileGrid=projection!==void 0?this.getTileGridForProjection(gridProjection):this.tileGrid||this.getTileGridForProjection(gridProjection);return this.getWrapX()&&gridProjection.isGlobal()&&(tileCoord=wrapX(tileGrid,tileCoord,gridProjection)),withinExtentAndZ(tileCoord,tileGrid)?tileCoord:null}clear(){}refresh(){this.clear(),super.refresh()}}class TileSourceEvent extends BaseEvent{constructor(type,tile){super(type),this.tile=tile}}const TileEventType={TILELOADSTART:"tileloadstart",TILELOADEND:"tileloadend",TILELOADERROR:"tileloaderror"};class UrlTile extends TileSource{constructor(options){super({attributions:options.attributions,cacheSize:options.cacheSize,projection:options.projection,state:options.state,tileGrid:options.tileGrid,tilePixelRatio:options.tilePixelRatio,wrapX:options.wrapX,transition:options.transition,interpolate:options.interpolate,key:options.key,attributionsCollapsible:options.attributionsCollapsible,zDirection:options.zDirection}),this.generateTileUrlFunction_=this.tileUrlFunction===UrlTile.prototype.tileUrlFunction,this.tileLoadFunction=options.tileLoadFunction,options.tileUrlFunction&&(this.tileUrlFunction=options.tileUrlFunction),this.urls=null,options.urls?this.setUrls(options.urls):options.url&&this.setUrl(options.url),this.tileLoadingKeys_={}}getTileLoadFunction(){return this.tileLoadFunction}getTileUrlFunction(){return Object.getPrototypeOf(this).tileUrlFunction===this.tileUrlFunction?this.tileUrlFunction.bind(this):this.tileUrlFunction}getUrls(){return this.urls}handleTileChange(event){const tile=event.target,uid=getUid(tile),tileState=tile.getState();let type;tileState==TileState.LOADING?(this.tileLoadingKeys_[uid]=!0,type=TileEventType.TILELOADSTART):uid in this.tileLoadingKeys_&&(delete this.tileLoadingKeys_[uid],type=tileState==TileState.ERROR?TileEventType.TILELOADERROR:tileState==TileState.LOADED?TileEventType.TILELOADEND:void 0),type!=null&&this.dispatchEvent(new TileSourceEvent(type,tile))}setTileLoadFunction(tileLoadFunction){this.tileLoadFunction=tileLoadFunction,this.changed()}setTileUrlFunction(tileUrlFunction,key2){this.tileUrlFunction=tileUrlFunction,typeof key2<"u"?this.setKey(key2):this.changed()}setUrl(url){const urls=expandUrl(url);this.urls=urls,this.setUrls(urls)}setUrls(urls){this.urls=urls;const key2=urls.join(`
`);this.generateTileUrlFunction_?this.setTileUrlFunction(createFromTemplates(urls,this.tileGrid),key2):this.setKey(key2)}tileUrlFunction(tileCoord,pixelRatio,projection){}}class TileImage extends UrlTile{constructor(options){super({attributions:options.attributions,cacheSize:options.cacheSize,projection:options.projection,state:options.state,tileGrid:options.tileGrid,tileLoadFunction:options.tileLoadFunction?options.tileLoadFunction:defaultTileLoadFunction,tilePixelRatio:options.tilePixelRatio,tileUrlFunction:options.tileUrlFunction,url:options.url,urls:options.urls,wrapX:options.wrapX,transition:options.transition,interpolate:options.interpolate!==void 0?options.interpolate:!0,key:options.key,attributionsCollapsible:options.attributionsCollapsible,zDirection:options.zDirection}),this.crossOrigin=options.crossOrigin!==void 0?options.crossOrigin:null,this.tileClass=options.tileClass!==void 0?options.tileClass:ImageTile,this.tileGridForProjection={},this.reprojectionErrorThreshold_=options.reprojectionErrorThreshold,this.renderReprojectionEdges_=!1}getGutterForProjection(projection){return this.getProjection()&&projection&&!equivalent(this.getProjection(),projection)?0:this.getGutter()}getGutter(){return 0}getKey(){let key2=super.getKey();return this.getInterpolate()||(key2+=":disable-interpolation"),key2}getTileGridForProjection(projection){const thisProj=this.getProjection();if(this.tileGrid&&(!thisProj||equivalent(thisProj,projection)))return this.tileGrid;const projKey=getUid(projection);return projKey in this.tileGridForProjection||(this.tileGridForProjection[projKey]=getForProjection(projection)),this.tileGridForProjection[projKey]}createTile_(z,x,y,pixelRatio,projection,key2){const tileCoord=[z,x,y],urlTileCoord=this.getTileCoordForTileUrlFunction(tileCoord,projection),tileUrl=urlTileCoord?this.tileUrlFunction(urlTileCoord,pixelRatio,projection):void 0,tile=new this.tileClass(tileCoord,tileUrl!==void 0?TileState.IDLE:TileState.EMPTY,tileUrl!==void 0?tileUrl:"",this.crossOrigin,this.tileLoadFunction,this.tileOptions);return tile.key=key2,tile.addEventListener(EventType.CHANGE,this.handleTileChange.bind(this)),tile}getTile(z,x,y,pixelRatio,projection){const sourceProjection=this.getProjection();if(!sourceProjection||!projection||equivalent(sourceProjection,projection))return this.getTileInternal(z,x,y,pixelRatio,sourceProjection||projection);const tileCoord=[z,x,y],key2=this.getKey(),sourceTileGrid=this.getTileGridForProjection(sourceProjection),targetTileGrid=this.getTileGridForProjection(projection),wrappedTileCoord=this.getTileCoordForTileUrlFunction(tileCoord,projection),tile=new ReprojTile(sourceProjection,sourceTileGrid,projection,targetTileGrid,tileCoord,wrappedTileCoord,this.getTilePixelRatio(pixelRatio),this.getGutter(),(z2,x2,y2,pixelRatio2)=>this.getTileInternal(z2,x2,y2,pixelRatio2,sourceProjection),this.reprojectionErrorThreshold_,this.renderReprojectionEdges_,this.tileOptions);return tile.key=key2,tile}getTileInternal(z,x,y,pixelRatio,projection){const key2=this.getKey();return this.createTile_(z,x,y,pixelRatio,projection,key2)}setRenderReprojectionEdges(render2){this.renderReprojectionEdges_!=render2&&(this.renderReprojectionEdges_=render2,this.changed())}setTileGridForProjection(projection,tilegrid){const proj=get$1(projection);if(proj){const projKey=getUid(proj);projKey in this.tileGridForProjection||(this.tileGridForProjection[projKey]=tilegrid)}}}function defaultTileLoadFunction(imageTile,src){imageTile.getImage().src=src}class XYZ extends TileImage{constructor(options){options=options||{};const projection=options.projection!==void 0?options.projection:"EPSG:3857",tileGrid=options.tileGrid!==void 0?options.tileGrid:createXYZ({extent:extentFromProjection(projection),maxResolution:options.maxResolution,maxZoom:options.maxZoom,minZoom:options.minZoom,tileSize:options.tileSize});super({attributions:options.attributions,cacheSize:options.cacheSize,crossOrigin:options.crossOrigin,interpolate:options.interpolate,projection,reprojectionErrorThreshold:options.reprojectionErrorThreshold,tileGrid,tileLoadFunction:options.tileLoadFunction,tilePixelRatio:options.tilePixelRatio,tileUrlFunction:options.tileUrlFunction,url:options.url,urls:options.urls,wrapX:options.wrapX!==void 0?options.wrapX:!0,transition:options.transition,attributionsCollapsible:options.attributionsCollapsible,zDirection:options.zDirection}),this.gutter_=options.gutter!==void 0?options.gutter:0}getGutter(){return this.gutter_}}const isBrowser=typeof window<"u",win=isBrowser?window:null,doc=isBrowser?document:null,tweenTypes={OBJECT:0,ATTRIBUTE:1,CSS:2,TRANSFORM:3,CSS_VAR:4},valueTypes={NUMBER:0,UNIT:1,COLOR:2,COMPLEX:3},tickModes={NONE:0,AUTO:1,FORCE:2},compositionTypes={replace:0,none:1,blend:2},isRegisteredTargetSymbol=Symbol(),isDomSymbol=Symbol(),isSvgSymbol=Symbol(),transformsSymbol=Symbol(),proxyTargetSymbol=Symbol(),minValue=1e-11,maxValue=1e12,K=1e3,maxFps=120,emptyString="",shortTransforms=new Map;shortTransforms.set("x","translateX");shortTransforms.set("y","translateY");shortTransforms.set("z","translateZ");const validTransforms=["translateX","translateY","translateZ","rotate","rotateX","rotateY","rotateZ","scale","scaleX","scaleY","scaleZ","skew","skewX","skewY","perspective","matrix","matrix3d"],transformsFragmentStrings=validTransforms.reduce((a2,v)=>({...a2,[v]:v+"("}),{}),noop=()=>{},hexTestRgx=/(^#([\da-f]{3}){1,2}$)|(^#([\da-f]{4}){1,2}$)/i,rgbExecRgx=/rgb\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/i,rgbaExecRgx=/rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(-?\d+|-?\d*.\d+)\s*\)/i,hslExecRgx=/hsl\(\s*(-?\d+|-?\d*.\d+)\s*,\s*(-?\d+|-?\d*.\d+)%\s*,\s*(-?\d+|-?\d*.\d+)%\s*\)/i,hslaExecRgx=/hsla\(\s*(-?\d+|-?\d*.\d+)\s*,\s*(-?\d+|-?\d*.\d+)%\s*,\s*(-?\d+|-?\d*.\d+)%\s*,\s*(-?\d+|-?\d*.\d+)\s*\)/i,digitWithExponentRgx=/[-+]?\d*\.?\d+(?:e[-+]?\d)?/gi,unitsExecRgx=/^([-+]?\d*\.?\d+(?:e[-+]?\d+)?)([a-z]+|%)$/i,lowerCaseRgx=/([a-z])([A-Z])/g,transformsExecRgx=/(\w+)(\([^)]+\)+)/g,defaults={id:null,keyframes:null,playbackEase:null,playbackRate:1,frameRate:maxFps,loop:0,reversed:!1,alternate:!1,autoplay:!0,duration:K,delay:0,loopDelay:0,ease:"out(2)",composition:compositionTypes.replace,modifier:v=>v,onBegin:noop,onBeforeUpdate:noop,onUpdate:noop,onLoop:noop,onPause:noop,onComplete:noop,onRender:noop},globals={defaults,root:doc,precision:4,timeScale:1,tickThreshold:200},globalVersions={version:"4.0.0-rc.4",engine:null};isBrowser&&(win.AnimeJS||(win.AnimeJS=[]),win.AnimeJS.push(globalVersions));const toLowerCase=str=>str.replace(lowerCaseRgx,"$1-$2").toLowerCase(),stringStartsWith=(str,sub2)=>str.indexOf(sub2)===0,now=Date.now,isArr=Array.isArray,isObj=a2=>a2&&a2.constructor===Object,isNum=a2=>typeof a2=="number"&&!isNaN(a2),isStr=a2=>typeof a2=="string",isFnc=a2=>typeof a2=="function",isUnd=a2=>typeof a2>"u",isNil=a2=>isUnd(a2)||a2===null,isSvg=a2=>isBrowser&&a2 instanceof SVGElement,isHex=a2=>hexTestRgx.test(a2),isRgb=a2=>stringStartsWith(a2,"rgb"),isHsl=a2=>stringStartsWith(a2,"hsl"),isCol=a2=>isHex(a2)||isRgb(a2)||isHsl(a2),isKey=a2=>!globals.defaults.hasOwnProperty(a2),parseNumber=str=>isStr(str)?parseFloat(str):str,pow=Math.pow,sqrt$1=Math.sqrt,sin$1=Math.sin,cos$1=Math.cos,abs$1=Math.abs,ceil=Math.ceil,floor$1=Math.floor,asin=Math.asin,PI=Math.PI,_round=Math.round,clamp=(v,min2,max2)=>v<min2?min2:v>max2?max2:v,powCache={},round=(v,decimalLength)=>{if(decimalLength<0)return v;if(!decimalLength)return _round(v);let p=powCache[decimalLength];return p||(p=powCache[decimalLength]=10**decimalLength),_round(v*p)/p},snap=(v,increment)=>isArr(increment)?increment.reduce((closest,cv)=>abs$1(cv-v)<abs$1(closest-v)?cv:closest):increment?_round(v/increment)*increment:v,interpolate=(start,end,progress)=>start+(end-start)*progress,clampInfinity=v=>v===1/0?maxValue:v===-1/0?-1e12:v,clampZero=v=>v<minValue?minValue:v,cloneArray=a2=>isArr(a2)?[...a2]:a2,mergeObjects=(o1,o2)=>{const merged={...o1};for(let p in o2){const o1p=o1[p];merged[p]=isUnd(o1p)?o2[p]:o1p}return merged},forEachChildren=(parent,callback,reverse,prevProp="_prev",nextProp="_next")=>{let next=parent._head,adjustedNextProp=nextProp;for(reverse&&(next=parent._tail,adjustedNextProp=prevProp);next;){const currentNext=next[adjustedNextProp];callback(next),next=currentNext}},removeChild=(parent,child,prevProp="_prev",nextProp="_next")=>{const prev=child[prevProp],next=child[nextProp];prev?prev[nextProp]=next:parent._head=next,next?next[prevProp]=prev:parent._tail=prev,child[prevProp]=null,child[nextProp]=null},addChild=(parent,child,sortMethod,prevProp="_prev",nextProp="_next")=>{let prev=parent._tail;for(;prev&&sortMethod&&sortMethod(prev,child);)prev=prev[prevProp];const next=prev?prev[nextProp]:parent._head;prev?prev[nextProp]=child:parent._head=child,next?next[prevProp]=child:parent._tail=child,child[prevProp]=prev,child[nextProp]=next};class Clock{constructor(initTime=0){this.deltaTime=0,this._currentTime=initTime,this._elapsedTime=initTime,this._startTime=initTime,this._lastTime=initTime,this._scheduledTime=0,this._frameDuration=round(K/maxFps,0),this._fps=maxFps,this._speed=1,this._hasChildren=!1,this._head=null,this._tail=null}get fps(){return this._fps}set fps(frameRate){const previousFrameDuration=this._frameDuration,fr=+frameRate,fps=fr<minValue?minValue:fr,frameDuration=round(K/fps,0);this._fps=fps,this._frameDuration=frameDuration,this._scheduledTime+=frameDuration-previousFrameDuration}get speed(){return this._speed}set speed(playbackRate){const pbr=+playbackRate;this._speed=pbr<minValue?minValue:pbr}requestTick(time2){const scheduledTime=this._scheduledTime,elapsedTime=this._elapsedTime;if(this._elapsedTime+=time2-elapsedTime,elapsedTime<scheduledTime)return tickModes.NONE;const frameDuration=this._frameDuration,frameDelta=elapsedTime-scheduledTime;return this._scheduledTime+=frameDelta<frameDuration?frameDuration:frameDelta,tickModes.AUTO}computeDeltaTime(time2){const delta=time2-this._lastTime;return this.deltaTime=delta,this._lastTime=time2,delta}}const render=(tickable,time2,muteCallbacks,internalRender,tickMode)=>{const parent=tickable.parent,duration=tickable.duration,completed=tickable.completed,iterationDuration=tickable.iterationDuration,iterationCount=tickable.iterationCount,_currentIteration=tickable._currentIteration,_loopDelay=tickable._loopDelay,_reversed=tickable._reversed,_alternate=tickable._alternate,_hasChildren=tickable._hasChildren,tickableDelay=tickable._delay,tickablePrevAbsoluteTime=tickable._currentTime,tickableEndTime=tickableDelay+iterationDuration,tickableAbsoluteTime=time2-tickableDelay,tickablePrevTime=clamp(tickablePrevAbsoluteTime,-tickableDelay,duration),tickableCurrentTime=clamp(tickableAbsoluteTime,-tickableDelay,duration),deltaTime2=tickableAbsoluteTime-tickablePrevAbsoluteTime,isCurrentTimeAboveZero=tickableCurrentTime>0,isCurrentTimeEqualOrAboveDuration=tickableCurrentTime>=duration,isSetter=duration<=minValue,forcedTick=tickMode===tickModes.FORCE;let isOdd=0,iterationElapsedTime=tickableAbsoluteTime,hasRendered=0;if(iterationCount>1){const currentIteration=~~(tickableCurrentTime/(iterationDuration+(isCurrentTimeEqualOrAboveDuration?0:_loopDelay)));tickable._currentIteration=clamp(currentIteration,0,iterationCount),isCurrentTimeEqualOrAboveDuration&&tickable._currentIteration--,isOdd=tickable._currentIteration%2,iterationElapsedTime=tickableCurrentTime%(iterationDuration+_loopDelay)||0}const isReversed=_reversed^(_alternate&&isOdd),_ease=tickable._ease;let iterationTime=isCurrentTimeEqualOrAboveDuration?isReversed?0:duration:isReversed?iterationDuration-iterationElapsedTime:iterationElapsedTime;_ease&&(iterationTime=iterationDuration*_ease(iterationTime/iterationDuration)||0);const isRunningBackwards=(parent?parent._backwards:tickableAbsoluteTime<tickablePrevAbsoluteTime)?!isReversed:!!isReversed;if(tickable._currentTime=tickableAbsoluteTime,tickable._iterationTime=iterationTime,tickable._backwards=isRunningBackwards,isCurrentTimeAboveZero&&!tickable.began?(tickable.began=!0,!muteCallbacks&&!(parent&&(isRunningBackwards||!parent.began))&&tickable.onBegin(tickable)):tickableAbsoluteTime<=0&&(tickable.began=!1),forcedTick||tickMode===tickModes.AUTO&&(time2>=tickableDelay&&time2<=tickableEndTime||time2<=tickableDelay&&tickablePrevTime>tickableDelay||time2>=tickableEndTime&&tickablePrevTime!==duration)||iterationTime>=tickableEndTime&&tickablePrevTime!==duration||iterationTime<=tickableDelay&&tickablePrevTime>0||time2<=tickablePrevTime&&tickablePrevTime===duration&&completed||isCurrentTimeEqualOrAboveDuration&&!completed&&isSetter){if(isCurrentTimeAboveZero&&(tickable.computeDeltaTime(tickablePrevTime),muteCallbacks||tickable.onBeforeUpdate(tickable)),!_hasChildren){const forcedRender=forcedTick||(isRunningBackwards?deltaTime2*-1:deltaTime2)>=globals.tickThreshold,absoluteTime=tickable._offset+(parent?parent._offset:0)+tickableDelay+iterationTime;let tween=tickable._head,tweenTarget,tweenStyle,tweenTargetTransforms,tweenTargetTransformsProperties,tweenTransformsNeedUpdate=0;for(;tween;){const tweenComposition=tween._composition,tweenCurrentTime=tween._currentTime,tweenChangeDuration=tween._changeDuration,tweenAbsEndTime=tween._absoluteStartTime+tween._changeDuration,tweenNextRep=tween._nextRep,tweenPrevRep=tween._prevRep,tweenHasComposition=tweenComposition!==compositionTypes.none;if((forcedRender||(tweenCurrentTime!==tweenChangeDuration||absoluteTime<=tweenAbsEndTime+(tweenNextRep?tweenNextRep._delay:0))&&(tweenCurrentTime!==0||absoluteTime>=tween._absoluteStartTime))&&(!tweenHasComposition||!tween._isOverridden&&(!tween._isOverlapped||absoluteTime<=tweenAbsEndTime)&&(!tweenNextRep||tweenNextRep._isOverridden||absoluteTime<=tweenNextRep._absoluteStartTime)&&(!tweenPrevRep||tweenPrevRep._isOverridden||absoluteTime>=tweenPrevRep._absoluteStartTime+tweenPrevRep._changeDuration+tween._delay))){const tweenNewTime=tween._currentTime=clamp(iterationTime-tween._startTime,0,tweenChangeDuration),tweenProgress=tween._ease(tweenNewTime/tween._updateDuration),tweenModifier=tween._modifier,tweenValueType=tween._valueType,tweenType=tween._tweenType,tweenIsObject=tweenType===tweenTypes.OBJECT,tweenIsNumber=tweenValueType===valueTypes.NUMBER,tweenPrecision=tweenIsNumber&&tweenIsObject||tweenProgress===0||tweenProgress===1?-1:globals.precision;let value,number;if(tweenIsNumber)value=number=tweenModifier(round(interpolate(tween._fromNumber,tween._toNumber,tweenProgress),tweenPrecision));else if(tweenValueType===valueTypes.UNIT)number=tweenModifier(round(interpolate(tween._fromNumber,tween._toNumber,tweenProgress),tweenPrecision)),value=`${number}${tween._unit}`;else if(tweenValueType===valueTypes.COLOR){const fn=tween._fromNumbers,tn=tween._toNumbers,r2=round(clamp(tweenModifier(interpolate(fn[0],tn[0],tweenProgress)),0,255),0),g=round(clamp(tweenModifier(interpolate(fn[1],tn[1],tweenProgress)),0,255),0),b=round(clamp(tweenModifier(interpolate(fn[2],tn[2],tweenProgress)),0,255),0),a2=clamp(tweenModifier(round(interpolate(fn[3],tn[3],tweenProgress),tweenPrecision)),0,1);if(value=`rgba(${r2},${g},${b},${a2})`,tweenHasComposition){const ns=tween._numbers;ns[0]=r2,ns[1]=g,ns[2]=b,ns[3]=a2}}else if(tweenValueType===valueTypes.COMPLEX){value=tween._strings[0];for(let j=0,l2=tween._toNumbers.length;j<l2;j++){const n2=tweenModifier(round(interpolate(tween._fromNumbers[j],tween._toNumbers[j],tweenProgress),tweenPrecision)),s2=tween._strings[j+1];value+=`${s2?n2+s2:n2}`,tweenHasComposition&&(tween._numbers[j]=n2)}}if(tweenHasComposition&&(tween._number=number),!internalRender&&tweenComposition!==compositionTypes.blend){const tweenProperty=tween.property;tweenTarget=tween.target,tweenIsObject?tweenTarget[tweenProperty]=value:tweenType===tweenTypes.ATTRIBUTE?tweenTarget.setAttribute(tweenProperty,value):(tweenStyle=tweenTarget.style,tweenType===tweenTypes.TRANSFORM?(tweenTarget!==tweenTargetTransforms&&(tweenTargetTransforms=tweenTarget,tweenTargetTransformsProperties=tweenTarget[transformsSymbol]),tweenTargetTransformsProperties[tweenProperty]=value,tweenTransformsNeedUpdate=1):tweenType===tweenTypes.CSS?tweenStyle[tweenProperty]=value:tweenType===tweenTypes.CSS_VAR&&tweenStyle.setProperty(tweenProperty,value)),isCurrentTimeAboveZero&&(hasRendered=1)}else tween._value=value}if(tweenTransformsNeedUpdate&&tween._renderTransforms){let str=emptyString;for(let key2 in tweenTargetTransformsProperties)str+=`${transformsFragmentStrings[key2]}${tweenTargetTransformsProperties[key2]}) `;tweenStyle.transform=str,tweenTransformsNeedUpdate=0}tween=tween._next}!muteCallbacks&&hasRendered&&tickable.onRender(tickable)}!muteCallbacks&&isCurrentTimeAboveZero&&tickable.onUpdate(tickable)}return!muteCallbacks&&!_hasChildren&&isCurrentTimeAboveZero&&tickable._currentIteration!==_currentIteration&&tickable.onLoop(tickable),parent&&isSetter?!muteCallbacks&&(parent.began&&!isRunningBackwards&&tickableAbsoluteTime>=duration&&!completed||isRunningBackwards&&tickableAbsoluteTime<=minValue&&completed)&&(tickable.onComplete(tickable),tickable.completed=!isRunningBackwards):isCurrentTimeAboveZero&&isCurrentTimeEqualOrAboveDuration?iterationCount===1/0?tickable._startTime+=tickable.duration:tickable._currentIteration>=iterationCount-1&&(tickable.paused=!0,!completed&&!_hasChildren&&(tickable.completed=!0,!muteCallbacks&&!(parent&&(isRunningBackwards||!parent.began))&&(tickable.onComplete(tickable),tickable._resolve(tickable)))):tickable.completed=!1,hasRendered},tick=(tickable,time2,muteCallbacks,internalRender,tickMode)=>{const _currentIteration=tickable._currentIteration;if(render(tickable,time2,muteCallbacks,internalRender,tickMode),tickable._hasChildren){const tl=tickable,tlIsRunningBackwards=tl._backwards,tlChildrenTime=internalRender?time2:tl._iterationTime,tlCildrenTickTime=now();let tlChildrenHasRendered=0,tlChildrenHaveCompleted=!0;if(!internalRender&&tl._currentIteration!==_currentIteration){const tlIterationDuration=tl.iterationDuration;forEachChildren(tl,child=>{if(!tlIsRunningBackwards)!child.completed&&!child._backwards&&child._currentTime<child.iterationDuration&&render(child,tlIterationDuration,muteCallbacks,1,tickModes.FORCE),child.began=!1,child.completed=!1;else{const childDuration=child.duration,childStartTime=child._offset+child._delay,childEndTime=childStartTime+childDuration;!muteCallbacks&&childDuration<=minValue&&(!childStartTime||childEndTime===tlIterationDuration)&&child.onComplete(child)}}),muteCallbacks||tl.onLoop(tl)}forEachChildren(tl,child=>{const childTime=round((tlChildrenTime-child._offset)*child._speed,12),childTickMode=child._fps<tl._fps?child.requestTick(tlCildrenTickTime):tickMode;tlChildrenHasRendered+=render(child,childTime,muteCallbacks,internalRender,childTickMode),!child.completed&&tlChildrenHaveCompleted&&(tlChildrenHaveCompleted=!1)},tlIsRunningBackwards),!muteCallbacks&&tlChildrenHasRendered&&tl.onRender(tl),tlChildrenHaveCompleted&&tl._currentTime>=tl.duration&&(tl.paused=!0,tl.completed||(tl.completed=!0,muteCallbacks||(tl.onComplete(tl),tl._resolve(tl))))}},additive={animation:null,update:noop},addAdditiveAnimation=lookups2=>{let animation=additive.animation;return animation||(animation={duration:minValue,computeDeltaTime:noop,_offset:0,_delay:0,_head:null,_tail:null},additive.animation=animation,additive.update=()=>{lookups2.forEach(propertyAnimation=>{for(let propertyName in propertyAnimation){const tweens=propertyAnimation[propertyName],lookupTween=tweens._head;if(lookupTween){const valueType=lookupTween._valueType,additiveValues=valueType===valueTypes.COMPLEX||valueType===valueTypes.COLOR?cloneArray(lookupTween._fromNumbers):null;let additiveValue=lookupTween._fromNumber,tween=tweens._tail;for(;tween&&tween!==lookupTween;){if(additiveValues)for(let i2=0,l2=tween._numbers.length;i2<l2;i2++)additiveValues[i2]+=tween._numbers[i2];else additiveValue+=tween._number;tween=tween._prevAdd}lookupTween._toNumber=additiveValue,lookupTween._toNumbers=additiveValues}}}),render(animation,1,1,0,tickModes.FORCE)}),animation},engineTickMethod=isBrowser?requestAnimationFrame:setImmediate,engineCancelMethod=isBrowser?cancelAnimationFrame:clearImmediate;class Engine extends Clock{constructor(initTime){super(initTime),this.useDefaultMainLoop=!0,this.pauseOnDocumentHidden=!0,this.defaults=defaults,this.paused=!!(isBrowser&&doc.hidden),this.reqId=null}update(){const time2=this._currentTime=now();if(this.requestTick(time2)){this.computeDeltaTime(time2);const engineSpeed=this._speed,engineFps=this._fps;let activeTickable=this._head;for(;activeTickable;){const nextTickable=activeTickable._next;activeTickable.paused?(removeChild(this,activeTickable),this._hasChildren=!!this._tail,activeTickable._running=!1,activeTickable.completed&&!activeTickable._cancelled&&activeTickable.cancel()):tick(activeTickable,(time2-activeTickable._startTime)*activeTickable._speed*engineSpeed,0,0,activeTickable._fps<engineFps?activeTickable.requestTick(time2):tickModes.AUTO),activeTickable=nextTickable}additive.update()}}wake(){return this.useDefaultMainLoop&&!this.reqId&&!this.paused&&(this.reqId=engineTickMethod(tickEngine)),this}pause(){return this.paused=!0,killEngine()}resume(){if(this.paused)return this.paused=!1,forEachChildren(this,child=>child.resetTime()),this.wake()}get speed(){return this._speed*(globals.timeScale===1?1:K)}set speed(playbackRate){this._speed=playbackRate*globals.timeScale,forEachChildren(this,child=>child.speed=child._speed)}get timeUnit(){return globals.timeScale===1?"ms":"s"}set timeUnit(unit){const isSecond=unit==="s",newScale=isSecond?.001:1;if(globals.timeScale!==newScale){globals.timeScale=newScale,globals.tickThreshold=200*newScale;const scaleFactor=isSecond?.001:K;this.defaults.duration*=scaleFactor,this._speed*=scaleFactor}}get precision(){return globals.precision}set precision(precision){globals.precision=precision}}const engine=(()=>{const engine2=new Engine(now());return isBrowser&&(globalVersions.engine=engine2,doc.addEventListener("visibilitychange",()=>{engine2.pauseOnDocumentHidden&&(doc.hidden?engine2.pause():engine2.resume())})),engine2})(),tickEngine=()=>{engine._head?(engine.reqId=engineTickMethod(tickEngine),engine.update()):engine.reqId=0},killEngine=()=>(engineCancelMethod(engine.reqId),engine.reqId=0,engine),parseInlineTransforms=(target,propName,animationInlineStyles)=>{const inlineTransforms=target.style.transform;let inlinedStylesPropertyValue;if(inlineTransforms){const cachedTransforms=target[transformsSymbol];let t2;for(;t2=transformsExecRgx.exec(inlineTransforms);){const inlinePropertyName=t2[1],inlinePropertyValue=t2[2].slice(1,-1);cachedTransforms[inlinePropertyName]=inlinePropertyValue,inlinePropertyName===propName&&(inlinedStylesPropertyValue=inlinePropertyValue,animationInlineStyles&&(animationInlineStyles[propName]=inlinePropertyValue))}}return inlineTransforms&&!isUnd(inlinedStylesPropertyValue)?inlinedStylesPropertyValue:stringStartsWith(propName,"scale")?"1":stringStartsWith(propName,"rotate")||stringStartsWith(propName,"skew")?"0deg":"0px"};function getNodeList(v){const n2=isStr(v)?globals.root.querySelectorAll(v):v;if(n2 instanceof NodeList||n2 instanceof HTMLCollection)return n2}function parseTargets(targets){if(isNil(targets))return[];if(isArr(targets)){const flattened=targets.flat(1/0),parsed=[];for(let i2=0,l2=flattened.length;i2<l2;i2++){const item=flattened[i2];if(!isNil(item)){const nodeList2=getNodeList(item);if(nodeList2)for(let j=0,jl=nodeList2.length;j<jl;j++){const subItem=nodeList2[j];if(!isNil(subItem)){let isDuplicate=!1;for(let k=0,kl=parsed.length;k<kl;k++)if(parsed[k]===subItem){isDuplicate=!0;break}isDuplicate||parsed.push(subItem)}}else{let isDuplicate=!1;for(let j=0,jl=parsed.length;j<jl;j++)if(parsed[j]===item){isDuplicate=!0;break}isDuplicate||parsed.push(item)}}}return parsed}if(!isBrowser)return[targets];const nodeList=getNodeList(targets);return nodeList?Array.from(nodeList):[targets]}function registerTargets(targets){const parsedTargetsArray=parseTargets(targets),parsedTargetsLength=parsedTargetsArray.length;if(parsedTargetsLength)for(let i2=0;i2<parsedTargetsLength;i2++){const target=parsedTargetsArray[i2];if(!target[isRegisteredTargetSymbol]){target[isRegisteredTargetSymbol]=!0;const isSvgType=isSvg(target);(target.nodeType||isSvgType)&&(target[isDomSymbol]=!0,target[isSvgSymbol]=isSvgType,target[transformsSymbol]={})}}return parsedTargetsArray}const cssReservedProperties=["opacity","rotate","overflow","color"],isValidSVGAttribute=(el,propertyName)=>{if(cssReservedProperties.includes(propertyName))return!1;if(el.getAttribute(propertyName)||propertyName in el){if(propertyName==="scale"){const elParentNode=el.parentNode;return elParentNode&&elParentNode.tagName==="filter"}return!0}},rgbToRgba=rgbValue=>{const rgba2=rgbExecRgx.exec(rgbValue)||rgbaExecRgx.exec(rgbValue),a2=isUnd(rgba2[4])?1:+rgba2[4];return[+rgba2[1],+rgba2[2],+rgba2[3],a2]},hexToRgba=hexValue=>{const hexLength=hexValue.length,isShort=hexLength===4||hexLength===5;return[+("0x"+hexValue[1]+hexValue[isShort?1:2]),+("0x"+hexValue[isShort?2:3]+hexValue[isShort?2:4]),+("0x"+hexValue[isShort?3:5]+hexValue[isShort?3:6]),hexLength===5||hexLength===9?+(+("0x"+hexValue[isShort?4:7]+hexValue[isShort?4:8])/255).toFixed(3):1]},hue2rgb=(p,q,t2)=>(t2<0&&(t2+=1),t2>1&&(t2-=1),t2<1/6?p+(q-p)*6*t2:t2<1/2?q:t2<2/3?p+(q-p)*(2/3-t2)*6:p),hslToRgba=hslValue=>{const hsla=hslExecRgx.exec(hslValue)||hslaExecRgx.exec(hslValue),h=+hsla[1]/360,s2=+hsla[2]/100,l2=+hsla[3]/100,a2=isUnd(hsla[4])?1:+hsla[4];let r2,g,b;if(s2===0)r2=g=b=l2;else{const q=l2<.5?l2*(1+s2):l2+s2-l2*s2,p=2*l2-q;r2=round(hue2rgb(p,q,h+1/3)*255,0),g=round(hue2rgb(p,q,h)*255,0),b=round(hue2rgb(p,q,h-1/3)*255,0)}return[r2,g,b,a2]},convertColorStringValuesToRgbaArray=colorString=>isRgb(colorString)?rgbToRgba(colorString):isHex(colorString)?hexToRgba(colorString):isHsl(colorString)?hslToRgba(colorString):[0,0,0,1],setValue=(targetValue,defaultValue)=>isUnd(targetValue)?defaultValue:targetValue,getFunctionValue=(value,target,index,total,store)=>{if(isFnc(value)){const func=()=>{const computed=value(target,index,total);return isNaN(+computed)?computed||0:+computed};return store&&(store.func=func),func()}else return value},getTweenType=(target,prop)=>target[isDomSymbol]?target[isSvgSymbol]&&isValidSVGAttribute(target,prop)?tweenTypes.ATTRIBUTE:validTransforms.includes(prop)||shortTransforms.get(prop)?tweenTypes.TRANSFORM:stringStartsWith(prop,"--")?tweenTypes.CSS_VAR:prop in target.style?tweenTypes.CSS:prop in target?tweenTypes.OBJECT:tweenTypes.ATTRIBUTE:tweenTypes.OBJECT,getCSSValue=(target,propName,animationInlineStyles)=>{const inlineStyles=target.style[propName];inlineStyles&&animationInlineStyles&&(animationInlineStyles[propName]=inlineStyles);const value=inlineStyles||getComputedStyle(target[proxyTargetSymbol]||target).getPropertyValue(propName);return value==="auto"?"0":value},getOriginalAnimatableValue=(target,propName,tweenType,animationInlineStyles)=>{const type=isUnd(tweenType)?getTweenType(target,propName):tweenType;return type===tweenTypes.OBJECT?target[propName]||0:type===tweenTypes.ATTRIBUTE?target.getAttribute(propName):type===tweenTypes.TRANSFORM?parseInlineTransforms(target,propName,animationInlineStyles):type===tweenTypes.CSS_VAR?getCSSValue(target,propName,animationInlineStyles).trimStart():getCSSValue(target,propName,animationInlineStyles)},getRelativeValue=(x,y,operator)=>operator==="-"?x-y:operator==="+"?x+y:x*y,createDecomposedValueTargetObject=()=>({t:valueTypes.NUMBER,n:0,u:null,o:null,d:null,s:null}),decomposeRawValue=(rawValue,targetObject)=>{if(targetObject.t=valueTypes.NUMBER,targetObject.n=0,targetObject.u=null,targetObject.o=null,targetObject.d=null,targetObject.s=null,!rawValue)return targetObject;const num=+rawValue;if(isNaN(num)){let str=rawValue;str[1]==="="&&(targetObject.o=str[0],str=str.slice(2));const unitMatch=str.includes(" ")?!1:unitsExecRgx.exec(str);if(unitMatch)return targetObject.t=valueTypes.UNIT,targetObject.n=+unitMatch[1],targetObject.u=unitMatch[2],targetObject;if(targetObject.o)return targetObject.n=+str,targetObject;if(isCol(str))return targetObject.t=valueTypes.COLOR,targetObject.d=convertColorStringValuesToRgbaArray(str),targetObject;{const matchedNumbers=str.match(digitWithExponentRgx);return targetObject.t=valueTypes.COMPLEX,targetObject.d=matchedNumbers?matchedNumbers.map(Number):[],targetObject.s=str.split(digitWithExponentRgx)||[],targetObject}}else return targetObject.n=num,targetObject},decomposeTweenValue=(tween,targetObject)=>(targetObject.t=tween._valueType,targetObject.n=tween._toNumber,targetObject.u=tween._unit,targetObject.o=null,targetObject.d=cloneArray(tween._toNumbers),targetObject.s=cloneArray(tween._strings),targetObject),decomposedOriginalValue=createDecomposedValueTargetObject(),lookups={_rep:new WeakMap,_add:new Map},getTweenSiblings=(target,property2,lookup="_rep")=>{const lookupMap=lookups[lookup];let targetLookup=lookupMap.get(target);return targetLookup||(targetLookup={},lookupMap.set(target,targetLookup)),targetLookup[property2]?targetLookup[property2]:targetLookup[property2]={_head:null,_tail:null}},addTweenSortMethod=(p,c2)=>p._isOverridden||p._absoluteStartTime>c2._absoluteStartTime,overrideTween=tween=>{tween._isOverlapped=1,tween._isOverridden=1,tween._changeDuration=minValue,tween._currentTime=minValue},composeTween=(tween,siblings)=>{const tweenCompositionType=tween._composition;if(tweenCompositionType===compositionTypes.replace){const tweenAbsStartTime=tween._absoluteStartTime;addChild(siblings,tween,addTweenSortMethod,"_prevRep","_nextRep");const prevSibling=tween._prevRep;if(prevSibling){const prevParent=prevSibling.parent,prevAbsEndTime=prevSibling._absoluteStartTime+prevSibling._changeDuration;if(tween.parent.id!==prevParent.id&&prevParent.iterationCount>1&&prevAbsEndTime+(prevParent.duration-prevParent.iterationDuration)>tweenAbsStartTime){overrideTween(prevSibling);let prevPrevSibling=prevSibling._prevRep;for(;prevPrevSibling&&prevPrevSibling.parent.id===prevParent.id;)overrideTween(prevPrevSibling),prevPrevSibling=prevPrevSibling._prevRep}const absoluteUpdateStartTime=tweenAbsStartTime-tween._delay;if(prevAbsEndTime>absoluteUpdateStartTime){const prevChangeStartTime=prevSibling._startTime,prevTLOffset=prevAbsEndTime-(prevChangeStartTime+prevSibling._updateDuration);prevSibling._changeDuration=absoluteUpdateStartTime-prevTLOffset-prevChangeStartTime,prevSibling._currentTime=prevSibling._changeDuration,prevSibling._isOverlapped=1,prevSibling._changeDuration<minValue&&overrideTween(prevSibling)}let pausePrevParentAnimation=!0;if(forEachChildren(prevParent,t2=>{t2._isOverlapped||(pausePrevParentAnimation=!1)}),pausePrevParentAnimation){const prevParentTL=prevParent.parent;if(prevParentTL){let pausePrevParentTL=!0;forEachChildren(prevParentTL,a2=>{a2!==prevParent&&forEachChildren(a2,t2=>{t2._isOverlapped||(pausePrevParentTL=!1)})}),pausePrevParentTL&&prevParentTL.cancel()}else prevParent.cancel()}}}else if(tweenCompositionType===compositionTypes.blend){const additiveTweenSiblings=getTweenSiblings(tween.target,tween.property,"_add"),additiveAnimation=addAdditiveAnimation(lookups._add);let lookupTween=additiveTweenSiblings._head;lookupTween||(lookupTween={...tween},lookupTween._composition=compositionTypes.replace,lookupTween._updateDuration=minValue,lookupTween._startTime=0,lookupTween._numbers=cloneArray(tween._fromNumbers),lookupTween._number=0,lookupTween._next=null,lookupTween._prev=null,addChild(additiveTweenSiblings,lookupTween),addChild(additiveAnimation,lookupTween));const toNumber=tween._toNumber;if(tween._fromNumber=lookupTween._fromNumber-toNumber,tween._toNumber=0,tween._numbers=cloneArray(tween._fromNumbers),tween._number=0,lookupTween._fromNumber=toNumber,tween._toNumbers){const toNumbers=cloneArray(tween._toNumbers);toNumbers&&toNumbers.forEach((value,i2)=>{tween._fromNumbers[i2]=lookupTween._fromNumbers[i2]-value,tween._toNumbers[i2]=0}),lookupTween._fromNumbers=toNumbers}addChild(additiveTweenSiblings,tween,null,"_prevAdd","_nextAdd")}return tween},removeTweenSliblings=tween=>{const tweenComposition=tween._composition;if(tweenComposition!==compositionTypes.none){const tweenTarget=tween.target,tweenProperty=tween.property,tweenReplaceSiblings=lookups._rep.get(tweenTarget)[tweenProperty];if(removeChild(tweenReplaceSiblings,tween,"_prevRep","_nextRep"),tweenComposition===compositionTypes.blend){const addTweensLookup=lookups._add,addTargetProps=addTweensLookup.get(tweenTarget);if(!addTargetProps)return;const additiveTweenSiblings=addTargetProps[tweenProperty],additiveAnimation=additive.animation;removeChild(additiveTweenSiblings,tween,"_prevAdd","_nextAdd");const lookupTween=additiveTweenSiblings._head;if(lookupTween&&lookupTween===additiveTweenSiblings._tail){removeChild(additiveTweenSiblings,lookupTween,"_prevAdd","_nextAdd"),removeChild(additiveAnimation,lookupTween);let shouldClean=!0;for(let prop in addTargetProps)if(addTargetProps[prop]._head){shouldClean=!1;break}shouldClean&&addTweensLookup.delete(tweenTarget)}}}return tween},resetTimerProperties=timer=>(timer.paused=!0,timer.began=!1,timer.completed=!1,timer),reviveTimer=timer=>(timer._cancelled&&(timer._hasChildren?forEachChildren(timer,reviveTimer):forEachChildren(timer,tween=>{tween._composition!==compositionTypes.none&&composeTween(tween,getTweenSiblings(tween.target,tween.property))}),timer._cancelled=0),timer);let timerId=0;class Timer extends Clock{constructor(parameters={},parent=null,parentPosition=0){super(0);const{id,delay,duration,reversed,alternate,loop:loop2,loopDelay,autoplay,frameRate,playbackRate,onComplete,onLoop,onPause,onBegin,onBeforeUpdate,onUpdate}=parameters,timerInitTime=parent?0:engine._elapsedTime,timerDefaults=parent?parent.defaults:globals.defaults,timerDelay=isFnc(delay)||isUnd(delay)?timerDefaults.delay:+delay,timerDuration=isFnc(duration)||isUnd(duration)?1/0:+duration,timerLoop=setValue(loop2,timerDefaults.loop),timerLoopDelay=setValue(loopDelay,timerDefaults.loopDelay),timerIterationCount=timerLoop===!0||timerLoop===1/0||timerLoop<0?1/0:timerLoop+1;let offsetPosition=0;if(parent)offsetPosition=parentPosition;else{let startTime=now();engine.paused&&(engine.requestTick(startTime),startTime=engine._elapsedTime),offsetPosition=startTime-engine._startTime}this.id=isUnd(id)?++timerId:id,this.parent=parent,this.duration=clampInfinity((timerDuration+timerLoopDelay)*timerIterationCount-timerLoopDelay)||minValue,this.paused=!0,this.began=!1,this.completed=!1,this.onBegin=onBegin||timerDefaults.onBegin,this.onBeforeUpdate=onBeforeUpdate||timerDefaults.onBeforeUpdate,this.onUpdate=onUpdate||timerDefaults.onUpdate,this.onLoop=onLoop||timerDefaults.onLoop,this.onPause=onPause||timerDefaults.onPause,this.onComplete=onComplete||timerDefaults.onComplete,this.iterationDuration=timerDuration,this.iterationCount=timerIterationCount,this._autoplay=parent?!1:setValue(autoplay,timerDefaults.autoplay),this._offset=offsetPosition,this._delay=timerDelay,this._loopDelay=timerLoopDelay,this._iterationTime=0,this._currentIteration=0,this._resolve=noop,this._running=!1,this._reversed=+setValue(reversed,timerDefaults.reversed),this._reverse=this._reversed,this._cancelled=0,this._alternate=setValue(alternate,timerDefaults.alternate),this._backwards=!1,this._prev=null,this._next=null,this._elapsedTime=timerInitTime,this._startTime=timerInitTime,this._lastTime=timerInitTime,this._fps=setValue(frameRate,timerDefaults.frameRate),this._speed=setValue(playbackRate,timerDefaults.playbackRate)}get cancelled(){return!!this._cancelled}set cancelled(cancelled){cancelled?this.cancel():this.reset(1).play()}get currentTime(){return clamp(round(this._currentTime,globals.precision),-this._delay,this.duration)}set currentTime(time2){const paused=this.paused;this.pause().seek(+time2),paused||this.resume()}get iterationCurrentTime(){return round(this._iterationTime,globals.precision)}set iterationCurrentTime(time2){this.currentTime=this.iterationDuration*this._currentIteration+time2}get progress(){return clamp(round(this._currentTime/this.duration,5),0,1)}set progress(progress){this.currentTime=this.duration*progress}get iterationProgress(){return clamp(round(this._iterationTime/this.iterationDuration,5),0,1)}set iterationProgress(progress){const iterationDuration=this.iterationDuration;this.currentTime=iterationDuration*this._currentIteration+iterationDuration*progress}get currentIteration(){return this._currentIteration}set currentIteration(iterationCount){this.currentTime=this.iterationDuration*clamp(+iterationCount,0,this.iterationCount-1)}get reversed(){return!!this._reversed}set reversed(reverse){reverse?this.reverse():this.play()}get speed(){return super.speed}set speed(playbackRate){super.speed=playbackRate,this.resetTime()}reset(internalRender=0){return reviveTimer(this),this._reversed&&!this._reverse&&(this.reversed=!1),this._iterationTime=this.iterationDuration,tick(this,0,1,internalRender,tickModes.FORCE),resetTimerProperties(this),this._hasChildren&&forEachChildren(this,resetTimerProperties),this}init(internalRender=0){this.fps=this._fps,this.speed=this._speed,!internalRender&&this._hasChildren&&tick(this,this.duration,1,internalRender,tickModes.FORCE),this.reset(internalRender);const autoplay=this._autoplay;return autoplay===!0?this.resume():autoplay&&!isUnd(autoplay.linked)&&autoplay.link(this),this}resetTime(){const timeScale=1/(this._speed*engine._speed);return this._startTime=now()-(this._currentTime+this._delay)*timeScale,this}pause(){return this.paused?this:(this.paused=!0,this.onPause(this),this)}resume(){return this.paused?(this.paused=!1,this.duration<=minValue&&!this._hasChildren?tick(this,minValue,0,0,tickModes.FORCE):(this._running||(addChild(engine,this),engine._hasChildren=!0,this._running=!0),this.resetTime(),this._startTime-=12,engine.wake()),this):this}restart(){return this.reset(0).resume()}seek(time2,muteCallbacks=0,internalRender=0){reviveTimer(this),this.completed=!1;const isPaused=this.paused;return this.paused=!0,tick(this,time2+this._delay,~~muteCallbacks,~~internalRender,tickModes.AUTO),isPaused?this:this.resume()}alternate(){const reversed=this._reversed,count=this.iterationCount,duration=this.iterationDuration,iterations=count===1/0?floor$1(maxValue/duration):count;return this._reversed=+(this._alternate&&!(iterations%2)?reversed:!reversed),count===1/0?this.iterationProgress=this._reversed?1-this.iterationProgress:this.iterationProgress:this.seek(duration*iterations-this._currentTime),this.resetTime(),this}play(){return this._reversed&&this.alternate(),this.resume()}reverse(){return this._reversed||this.alternate(),this.resume()}cancel(){return this._hasChildren?forEachChildren(this,child=>child.cancel(),!0):forEachChildren(this,removeTweenSliblings),this._cancelled=1,this.pause()}stretch(newDuration){const currentDuration=this.duration;if(currentDuration===clampZero(newDuration))return this;const timeScale=newDuration/currentDuration,isSetter=newDuration<=minValue;return this.duration=isSetter?minValue:clampZero(clampInfinity(round(currentDuration*timeScale,12))),this.iterationDuration=isSetter?minValue:clampZero(clampInfinity(round(this.iterationDuration*timeScale,12))),this._offset*=timeScale,this._delay*=timeScale,this._loopDelay*=timeScale,this}revert(){tick(this,0,1,0,tickModes.FORCE);const ap=this._autoplay;return ap&&ap.linked&&ap.linked===this&&ap.revert(),this.cancel()}complete(){return this.seek(this.duration).cancel()}then(callback=noop){const then=this.then,onResolve=()=>{this.then=null,callback(this),this.then=then,this._resolve=noop};return new Promise(r2=>(this._resolve=()=>r2(onResolve()),this.completed&&this._resolve(),this))}}const none=t2=>t2,calcBezier=(aT,aA1,aA2)=>(((1-3*aA2+3*aA1)*aT+(3*aA2-6*aA1))*aT+3*aA1)*aT,binarySubdivide=(aX,mX1,mX2)=>{let aA=0,aB=1,currentX,currentT,i2=0;do currentT=aA+(aB-aA)/2,currentX=calcBezier(currentT,mX1,mX2)-aX,currentX>0?aB=currentT:aA=currentT;while(abs$1(currentX)>1e-7&&++i2<100);return currentT},cubicBezier=(mX1=.5,mY1=0,mX2=.5,mY2=1)=>mX1===mY1&&mX2===mY2?none:t2=>t2===0||t2===1?t2:calcBezier(binarySubdivide(t2,mX1,mX2),mY1,mY2),steps=(steps2=10,fromStart)=>{const roundMethod=fromStart?ceil:floor$1;return t2=>roundMethod(clamp(t2,0,1)*steps2)*(1/steps2)},linear=(...args)=>{const argsLength=args.length;if(!argsLength)return none;const totalPoints=argsLength-1,firstArg=args[0],lastArg=args[totalPoints],xPoints=[0],yPoints=[parseNumber(firstArg)];for(let i2=1;i2<totalPoints;i2++){const arg=args[i2],splitValue=isStr(arg)?arg.trim().split(" "):[arg],value=splitValue[0],percent=splitValue[1];xPoints.push(isUnd(percent)?i2/totalPoints:parseNumber(percent)/100),yPoints.push(parseNumber(value))}return yPoints.push(parseNumber(lastArg)),xPoints.push(1),function(t2){for(let i2=1,l2=xPoints.length;i2<l2;i2++){const currentX=xPoints[i2];if(t2<=currentX){const prevX=xPoints[i2-1],prevY=yPoints[i2-1];return prevY+(yPoints[i2]-prevY)*(t2-prevX)/(currentX-prevX)}}return yPoints[yPoints.length-1]}},irregular=(length2=10,randomness=1)=>{const values=[0],total=length2-1;for(let i2=1;i2<total;i2++){const previousValue=values[i2-1],spacing=i2/total,segmentEnd=(i2+1)/total,randomVariation=spacing+(segmentEnd-spacing)*Math.random(),randomValue=spacing*(1-randomness)+randomVariation*randomness;values.push(clamp(randomValue,previousValue,1))}return values.push(1),linear(...values)},halfPI=PI/2,doublePI=PI*2,easeInPower=(p=1.68)=>t2=>pow(t2,+p),easeInFunctions={[emptyString]:easeInPower,Quad:easeInPower(2),Cubic:easeInPower(3),Quart:easeInPower(4),Quint:easeInPower(5),Sine:t2=>1-cos$1(t2*halfPI),Circ:t2=>1-sqrt$1(1-t2*t2),Expo:t2=>t2?pow(2,10*t2-10):0,Bounce:t2=>{let pow22,b=4;for(;t2<((pow22=pow(2,--b))-1)/11;);return 1/pow(4,3-b)-7.5625*pow((pow22*3-2)/22-t2,2)},Back:(overshoot=1.70158)=>t2=>(+overshoot+1)*t2*t2*t2-+overshoot*t2*t2,Elastic:(amplitude=1,period=.3)=>{const a2=clamp(+amplitude,1,10),p=clamp(+period,minValue,2),s2=p/doublePI*asin(1/a2),e2=doublePI/p;return t2=>t2===0||t2===1?t2:-a2*pow(2,-10*(1-t2))*sin$1((1-t2-s2)*e2)}},easeTypes={in:easeIn2=>t2=>easeIn2(t2),out:easeIn2=>t2=>1-easeIn2(1-t2),inOut:easeIn2=>t2=>t2<.5?easeIn2(t2*2)/2:1-easeIn2(t2*-2+2)/2},parseEaseString=(string2,easesFunctions,easesLookups)=>{if(easesLookups[string2])return easesLookups[string2];if(string2.indexOf("(")<=-1){const parsedFn=easeTypes[string2]||string2.includes("Back")||string2.includes("Elastic")?easesFunctions[string2]():easesFunctions[string2];return parsedFn?easesLookups[string2]=parsedFn:none}else{const split2=string2.slice(0,-1).split("("),parsedFn=easesFunctions[split2[0]];return parsedFn?easesLookups[string2]=parsedFn(...split2[1].split(",")):none}},eases=(()=>{const list={linear,irregular,steps,cubicBezier};for(let type in easeTypes)for(let name in easeInFunctions){const easeIn2=easeInFunctions[name],easeType=easeTypes[type];list[type+name]=name===emptyString||name==="Back"||name==="Elastic"?(a2,b)=>easeType(easeIn2(a2,b)):easeType(easeIn2)}return list})(),JSEasesLookups={linear:none},parseEasings=ease=>isFnc(ease)?ease:isStr(ease)?parseEaseString(ease,eases,JSEasesLookups):none,propertyNamesCache={},sanitizePropertyName=(propertyName,target,tweenType)=>{if(tweenType===tweenTypes.TRANSFORM){const t2=shortTransforms.get(propertyName);return t2||propertyName}else if(tweenType===tweenTypes.CSS||tweenType===tweenTypes.ATTRIBUTE&&isSvg(target)&&propertyName in target.style){const cachedPropertyName=propertyNamesCache[propertyName];if(cachedPropertyName)return cachedPropertyName;{const lowerCaseName=propertyName&&toLowerCase(propertyName);return propertyNamesCache[propertyName]=lowerCaseName,lowerCaseName}}else return propertyName},angleUnitsMap={deg:1,rad:180/PI,turn:360},convertedValuesCache={},convertValueUnit=(el,decomposedValue,unit,force=!1)=>{const currentUnit=decomposedValue.u,currentNumber=decomposedValue.n;if(decomposedValue.t===valueTypes.UNIT&&currentUnit===unit)return decomposedValue;const cachedKey=currentNumber+currentUnit+unit,cached=convertedValuesCache[cachedKey];if(!isUnd(cached)&&!force)decomposedValue.n=cached;else{let convertedValue;if(currentUnit in angleUnitsMap)convertedValue=currentNumber*angleUnitsMap[currentUnit]/angleUnitsMap[unit];else{const tempEl=el.cloneNode(),parentNode=el.parentNode,parentEl=parentNode&&parentNode!==doc?parentNode:doc.body;parentEl.appendChild(tempEl);const elStyle=tempEl.style;elStyle.width=100+currentUnit;const currentUnitWidth=tempEl.offsetWidth||100;elStyle.width=100+unit;const newUnitWidth=tempEl.offsetWidth||100,factor=currentUnitWidth/newUnitWidth;parentEl.removeChild(tempEl),convertedValue=factor*currentNumber}decomposedValue.n=convertedValue,convertedValuesCache[cachedKey]=convertedValue}return decomposedValue.t,valueTypes.UNIT,decomposedValue.u=unit,decomposedValue},cleanInlineStyles=renderable=>{if(renderable._hasChildren)forEachChildren(renderable,cleanInlineStyles,!0);else{const animation=renderable;animation.pause(),forEachChildren(animation,tween=>{const tweenProperty=tween.property,tweenTarget=tween.target;if(tweenTarget[isDomSymbol]){const targetStyle=tweenTarget.style,originalInlinedValue=animation._inlineStyles[tweenProperty];if(tween._tweenType===tweenTypes.TRANSFORM){const cachedTransforms=tweenTarget[transformsSymbol];if(isUnd(originalInlinedValue)||originalInlinedValue===emptyString?delete cachedTransforms[tweenProperty]:cachedTransforms[tweenProperty]=originalInlinedValue,tween._renderTransforms)if(!Object.keys(cachedTransforms).length)targetStyle.removeProperty("transform");else{let str=emptyString;for(let key2 in cachedTransforms)str+=transformsFragmentStrings[key2]+cachedTransforms[key2]+") ";targetStyle.transform=str}}else isUnd(originalInlinedValue)||originalInlinedValue===emptyString?targetStyle.removeProperty(tweenProperty):targetStyle[tweenProperty]=originalInlinedValue;animation._tail===tween&&animation.targets.forEach(t2=>{t2.getAttribute&&t2.getAttribute("style")===emptyString&&t2.removeAttribute("style")})}})}return renderable},fromTargetObject=createDecomposedValueTargetObject(),toTargetObject=createDecomposedValueTargetObject(),toFunctionStore={func:null},keyframesTargetArray=[null],fastSetValuesArray=[null,null],keyObjectTarget={to:null};let tweenId=0,keyframes,key;const generateKeyframes=(keyframes2,parameters)=>{const properties={};if(isArr(keyframes2)){const propertyNames=[].concat(...keyframes2.map(key2=>Object.keys(key2))).filter(isKey);for(let i2=0,l2=propertyNames.length;i2<l2;i2++){const propName=propertyNames[i2],propArray=keyframes2.map(key2=>{const newKey={};for(let p in key2){const keyValue=key2[p];isKey(p)?p===propName&&(newKey.to=keyValue):newKey[p]=keyValue}return newKey});properties[propName]=propArray}}else{const totalDuration=setValue(parameters.duration,globals.defaults.duration);Object.keys(keyframes2).map(key2=>({o:parseFloat(key2)/100,p:keyframes2[key2]})).sort((a2,b)=>a2.o-b.o).forEach(key2=>{const offset=key2.o,prop=key2.p;for(let name in prop)if(isKey(name)){let propArray=properties[name];propArray||(propArray=properties[name]=[]);const duration=offset*totalDuration;let length2=propArray.length,prevKey=propArray[length2-1];const keyObj={to:prop[name]};let durProgress=0;for(let i2=0;i2<length2;i2++)durProgress+=propArray[i2].duration;length2===1&&(keyObj.from=prevKey.to),prop.ease&&(keyObj.ease=prop.ease),keyObj.duration=duration-(length2?durProgress:0),propArray.push(keyObj)}return key2});for(let name in properties){const propArray=properties[name];let prevEase;for(let i2=0,l2=propArray.length;i2<l2;i2++){const prop=propArray[i2],currentEase=prop.ease;prop.ease=prevEase||void 0,prevEase=currentEase}propArray[0].duration||propArray.shift()}}return properties};class JSAnimation extends Timer{constructor(targets,parameters,parent,parentPosition,fastSet=!1,index=0,length2=0){super(parameters,parent,parentPosition);const parsedTargets=registerTargets(targets),targetsLength=parsedTargets.length,kfParams=parameters.keyframes,params=kfParams?mergeObjects(generateKeyframes(kfParams,parameters),parameters):parameters,{delay,duration,ease,playbackEase,modifier,composition,onRender}=params,animDefaults=parent?parent.defaults:globals.defaults,animaPlaybackEase=setValue(playbackEase,animDefaults.playbackEase),animEase=animaPlaybackEase?parseEasings(animaPlaybackEase):null,hasSpring=!isUnd(ease)&&!isUnd(ease.ease),tEasing=hasSpring?ease.ease:setValue(ease,animEase?"linear":animDefaults.ease),tDuration=hasSpring?ease.duration:setValue(duration,animDefaults.duration),tDelay=setValue(delay,animDefaults.delay),tModifier=modifier||animDefaults.modifier,tComposition=isUnd(composition)&&targetsLength>=K?compositionTypes.none:isUnd(composition)?animDefaults.composition:composition,animInlineStyles={},absoluteOffsetTime=this._offset+(parent?parent._offset:0);let iterationDuration=NaN,iterationDelay=NaN,animationAnimationLength=0,shouldTriggerRender=0;for(let targetIndex=0;targetIndex<targetsLength;targetIndex++){const target=parsedTargets[targetIndex],ti=index||targetIndex,tl=length2||targetsLength;let lastTransformGroupIndex=NaN,lastTransformGroupLength=NaN;for(let p in params)if(isKey(p)){const tweenType=getTweenType(target,p),propName=sanitizePropertyName(p,target,tweenType);let propValue=params[p];const isPropValueArray=isArr(propValue);if(fastSet&&!isPropValueArray&&(fastSetValuesArray[0]=propValue,fastSetValuesArray[1]=propValue,propValue=fastSetValuesArray),isPropValueArray){const arrayLength=propValue.length,isNotObjectValue=!isObj(propValue[0]);arrayLength===2&&isNotObjectValue?(keyObjectTarget.to=propValue,keyframesTargetArray[0]=keyObjectTarget,keyframes=keyframesTargetArray):arrayLength>2&&isNotObjectValue?(keyframes=[],propValue.forEach((v,i2)=>{i2?i2===1?(fastSetValuesArray[1]=v,keyframes.push(fastSetValuesArray)):keyframes.push(v):fastSetValuesArray[0]=v})):keyframes=propValue}else keyframesTargetArray[0]=propValue,keyframes=keyframesTargetArray;let siblings=null,prevTween=null,firstTweenChangeStartTime=NaN,lastTweenChangeEndTime=0,tweenIndex=0;for(let l2=keyframes.length;tweenIndex<l2;tweenIndex++){const keyframe=keyframes[tweenIndex];isObj(keyframe)?key=keyframe:(keyObjectTarget.to=keyframe,key=keyObjectTarget),toFunctionStore.func=null;const computedToValue=getFunctionValue(key.to,target,ti,tl,toFunctionStore);let tweenToValue;isObj(computedToValue)&&!isUnd(computedToValue.to)?(key=computedToValue,tweenToValue=computedToValue.to):tweenToValue=computedToValue;const tweenFromValue=getFunctionValue(key.from,target,ti,tl),keyEasing=key.ease,hasSpring2=!isUnd(keyEasing)&&!isUnd(keyEasing.ease),tweenEasing=hasSpring2?keyEasing.ease:keyEasing||tEasing,tweenDuration=hasSpring2?keyEasing.duration:getFunctionValue(setValue(key.duration,l2>1?getFunctionValue(tDuration,target,ti,tl)/l2:tDuration),target,ti,tl),tweenDelay=getFunctionValue(setValue(key.delay,tweenIndex?0:tDelay),target,ti,tl),computedComposition=getFunctionValue(setValue(key.composition,tComposition),target,ti,tl),tweenComposition=isNum(computedComposition)?computedComposition:compositionTypes[computedComposition],tweenModifier=key.modifier||tModifier,hasFromvalue=!isUnd(tweenFromValue),hasToValue=!isUnd(tweenToValue),isFromToArray=isArr(tweenToValue),isFromToValue=isFromToArray||hasFromvalue&&hasToValue,tweenStartTime=prevTween?lastTweenChangeEndTime+tweenDelay:tweenDelay,absoluteStartTime=absoluteOffsetTime+tweenStartTime;!shouldTriggerRender&&(hasFromvalue||isFromToArray)&&(shouldTriggerRender=1);let prevSibling=prevTween;if(tweenComposition!==compositionTypes.none){siblings||(siblings=getTweenSiblings(target,propName));let nextSibling=siblings._head;for(;nextSibling&&!nextSibling._isOverridden&&nextSibling._absoluteStartTime<=absoluteStartTime;)if(prevSibling=nextSibling,nextSibling=nextSibling._nextRep,nextSibling&&nextSibling._absoluteStartTime>=absoluteStartTime)for(;nextSibling;)overrideTween(nextSibling),nextSibling=nextSibling._nextRep}if(isFromToValue?(decomposeRawValue(isFromToArray?getFunctionValue(tweenToValue[0],target,ti,tl):tweenFromValue,fromTargetObject),decomposeRawValue(isFromToArray?getFunctionValue(tweenToValue[1],target,ti,tl,toFunctionStore):tweenToValue,toTargetObject),fromTargetObject.t===valueTypes.NUMBER&&(prevSibling?prevSibling._valueType===valueTypes.UNIT&&(fromTargetObject.t=valueTypes.UNIT,fromTargetObject.u=prevSibling._unit):(decomposeRawValue(getOriginalAnimatableValue(target,propName,tweenType,animInlineStyles),decomposedOriginalValue),decomposedOriginalValue.t===valueTypes.UNIT&&(fromTargetObject.t=valueTypes.UNIT,fromTargetObject.u=decomposedOriginalValue.u)))):(hasToValue?decomposeRawValue(tweenToValue,toTargetObject):prevTween?decomposeTweenValue(prevTween,toTargetObject):decomposeRawValue(parent&&prevSibling&&prevSibling.parent.parent===parent?prevSibling._value:getOriginalAnimatableValue(target,propName,tweenType,animInlineStyles),toTargetObject),hasFromvalue?decomposeRawValue(tweenFromValue,fromTargetObject):prevTween?decomposeTweenValue(prevTween,fromTargetObject):decomposeRawValue(parent&&prevSibling&&prevSibling.parent.parent===parent?prevSibling._value:getOriginalAnimatableValue(target,propName,tweenType,animInlineStyles),fromTargetObject)),fromTargetObject.o&&(fromTargetObject.n=getRelativeValue(prevSibling?prevSibling._toNumber:decomposeRawValue(getOriginalAnimatableValue(target,propName,tweenType,animInlineStyles),decomposedOriginalValue).n,fromTargetObject.n,fromTargetObject.o)),toTargetObject.o&&(toTargetObject.n=getRelativeValue(fromTargetObject.n,toTargetObject.n,toTargetObject.o)),fromTargetObject.t!==toTargetObject.t){if(fromTargetObject.t===valueTypes.COMPLEX||toTargetObject.t===valueTypes.COMPLEX){const complexValue=fromTargetObject.t===valueTypes.COMPLEX?fromTargetObject:toTargetObject,notComplexValue=fromTargetObject.t===valueTypes.COMPLEX?toTargetObject:fromTargetObject;notComplexValue.t=valueTypes.COMPLEX,notComplexValue.s=cloneArray(complexValue.s),notComplexValue.d=complexValue.d.map(()=>notComplexValue.n)}else if(fromTargetObject.t===valueTypes.UNIT||toTargetObject.t===valueTypes.UNIT){const unitValue=fromTargetObject.t===valueTypes.UNIT?fromTargetObject:toTargetObject,notUnitValue=fromTargetObject.t===valueTypes.UNIT?toTargetObject:fromTargetObject;notUnitValue.t=valueTypes.UNIT,notUnitValue.u=unitValue.u}else if(fromTargetObject.t===valueTypes.COLOR||toTargetObject.t===valueTypes.COLOR){const colorValue=fromTargetObject.t===valueTypes.COLOR?fromTargetObject:toTargetObject,notColorValue=fromTargetObject.t===valueTypes.COLOR?toTargetObject:fromTargetObject;notColorValue.t=valueTypes.COLOR,notColorValue.s=colorValue.s,notColorValue.d=[0,0,0,1]}}if(fromTargetObject.u!==toTargetObject.u){let valueToConvert=toTargetObject.u?fromTargetObject:toTargetObject;valueToConvert=convertValueUnit(target,valueToConvert,toTargetObject.u?toTargetObject.u:fromTargetObject.u,!1)}if(toTargetObject.d&&fromTargetObject.d&&toTargetObject.d.length!==fromTargetObject.d.length){const longestValue=fromTargetObject.d.length>toTargetObject.d.length?fromTargetObject:toTargetObject,shortestValue=longestValue===fromTargetObject?toTargetObject:fromTargetObject;shortestValue.d=longestValue.d.map((_,i2)=>isUnd(shortestValue.d[i2])?0:shortestValue.d[i2]),shortestValue.s=cloneArray(longestValue.s)}const tweenUpdateDuration=round(+tweenDuration||minValue,12),tween={parent:this,id:tweenId++,property:propName,target,_value:null,_func:toFunctionStore.func,_ease:parseEasings(tweenEasing),_fromNumbers:cloneArray(fromTargetObject.d),_toNumbers:cloneArray(toTargetObject.d),_strings:cloneArray(toTargetObject.s),_fromNumber:fromTargetObject.n,_toNumber:toTargetObject.n,_numbers:cloneArray(fromTargetObject.d),_number:fromTargetObject.n,_unit:toTargetObject.u,_modifier:tweenModifier,_currentTime:0,_startTime:tweenStartTime,_delay:+tweenDelay,_updateDuration:tweenUpdateDuration,_changeDuration:tweenUpdateDuration,_absoluteStartTime:absoluteStartTime,_tweenType:tweenType,_valueType:toTargetObject.t,_composition:tweenComposition,_isOverlapped:0,_isOverridden:0,_renderTransforms:0,_prevRep:null,_nextRep:null,_prevAdd:null,_nextAdd:null,_prev:null,_next:null};tweenComposition!==compositionTypes.none&&composeTween(tween,siblings),isNaN(firstTweenChangeStartTime)&&(firstTweenChangeStartTime=tween._startTime),lastTweenChangeEndTime=round(tweenStartTime+tweenUpdateDuration,12),prevTween=tween,animationAnimationLength++,addChild(this,tween)}(isNaN(iterationDelay)||firstTweenChangeStartTime<iterationDelay)&&(iterationDelay=firstTweenChangeStartTime),(isNaN(iterationDuration)||lastTweenChangeEndTime>iterationDuration)&&(iterationDuration=lastTweenChangeEndTime),tweenType===tweenTypes.TRANSFORM&&(lastTransformGroupIndex=animationAnimationLength-tweenIndex,lastTransformGroupLength=animationAnimationLength)}if(!isNaN(lastTransformGroupIndex)){let i2=0;forEachChildren(this,tween=>{i2>=lastTransformGroupIndex&&i2<lastTransformGroupLength&&(tween._renderTransforms=1,tween._composition===compositionTypes.blend&&forEachChildren(additive.animation,additiveTween=>{additiveTween.id===tween.id&&(additiveTween._renderTransforms=1)})),i2++})}}targetsLength||console.warn("No target found. Make sure the element you're trying to animate is accessible before creating your animation."),iterationDelay?(forEachChildren(this,tween=>{tween._startTime-tween._delay||(tween._delay-=iterationDelay),tween._startTime-=iterationDelay}),iterationDuration-=iterationDelay):iterationDelay=0,iterationDuration||(iterationDuration=minValue,this.iterationCount=0),this.targets=parsedTargets,this.duration=iterationDuration===minValue?minValue:clampInfinity((iterationDuration+this._loopDelay)*this.iterationCount-this._loopDelay)||minValue,this.onRender=onRender||animDefaults.onRender,this._ease=animEase,this._delay=iterationDelay,this.iterationDuration=iterationDuration,this._inlineStyles=animInlineStyles,!this._autoplay&&shouldTriggerRender&&this.onRender(this)}stretch(newDuration){const currentDuration=this.duration;if(currentDuration===clampZero(newDuration))return this;const timeScale=newDuration/currentDuration;return forEachChildren(this,tween=>{tween._updateDuration=clampZero(round(tween._updateDuration*timeScale,12)),tween._changeDuration=clampZero(round(tween._changeDuration*timeScale,12)),tween._currentTime*=timeScale,tween._startTime*=timeScale,tween._absoluteStartTime*=timeScale}),super.stretch(newDuration)}refresh(){return forEachChildren(this,tween=>{const ogValue=getOriginalAnimatableValue(tween.target,tween.property,tween._tweenType);decomposeRawValue(ogValue,decomposedOriginalValue),tween._fromNumbers=cloneArray(decomposedOriginalValue.d),tween._fromNumber=decomposedOriginalValue.n,tween._func&&(decomposeRawValue(tween._func(),toTargetObject),tween._toNumbers=cloneArray(toTargetObject.d),tween._strings=cloneArray(toTargetObject.s),tween._toNumber=toTargetObject.n)}),this}revert(){return super.revert(),cleanInlineStyles(this)}then(callback){return super.then(callback)}}const animate=(targets,parameters)=>new JSAnimation(targets,parameters,null,0,!1).init(),transformsShorthands=["x","y","z"];[...transformsShorthands,...validTransforms.filter(t2=>["X","Y","Z"].some(axis=>t2.endsWith(axis)))];isBrowser&&(isUnd(CSS)||Object.hasOwnProperty.call(CSS,"registerProperty"));const WAAPIAnimationsLookups={_head:null,_tail:null},removeWAAPIAnimation=($el,property2,parent)=>{let nextLookup=WAAPIAnimationsLookups._head;for(;nextLookup;){const next=nextLookup._next,matchTarget=nextLookup.$el===$el,matchProperty=!property2||nextLookup.property===property2,matchParent=!parent||nextLookup.parent===parent;if(matchTarget&&matchProperty&&matchParent){const anim=nextLookup.animation;anim.commitStyles(),anim.cancel(),removeChild(WAAPIAnimationsLookups,nextLookup);const lookupParent=nextLookup.parent;lookupParent&&(lookupParent._completed++,lookupParent.animations.length===lookupParent._completed&&(lookupParent.completed=!0,lookupParent.muteCallbacks||(lookupParent.paused=!0,lookupParent.onComplete(lookupParent),lookupParent._resolve(lookupParent))))}nextLookup=next}},sync=(callback=noop)=>new Timer({duration:1*globals.timeScale,onComplete:callback},null,0).resume();function getTargetValue(targetSelector,propName,unit){const targets=registerTargets(targetSelector);if(!targets.length)return;const[target]=targets,tweenType=getTweenType(target,propName),normalizePropName=sanitizePropertyName(propName,target,tweenType);let originalValue=getOriginalAnimatableValue(target,normalizePropName);if(isUnd(unit))return originalValue;if(decomposeRawValue(originalValue,decomposedOriginalValue),decomposedOriginalValue.t===valueTypes.NUMBER||decomposedOriginalValue.t===valueTypes.UNIT){if(unit===!1)return decomposedOriginalValue.n;{const convertedValue=convertValueUnit(target,decomposedOriginalValue,unit,!1);return`${round(convertedValue.n,globals.precision)}${convertedValue.u}`}}}const setTargetValues=(targets,parameters)=>{if(!isUnd(parameters))return parameters.duration=minValue,parameters.composition=setValue(parameters.composition,compositionTypes.none),new JSAnimation(targets,parameters,null,0,!0).resume()},removeTargetsFromAnimation=(targetsArray,animation,propertyName)=>{let tweensMatchesTargets=!1;return forEachChildren(animation,tween=>{const tweenTarget=tween.target;if(targetsArray.includes(tweenTarget)){const tweenName=tween.property,tweenType=tween._tweenType,normalizePropName=sanitizePropertyName(propertyName,tweenTarget,tweenType);(!normalizePropName||normalizePropName&&normalizePropName===tweenName)&&(tween.parent._tail===tween&&tween._tweenType===tweenTypes.TRANSFORM&&tween._prev&&tween._prev._tweenType===tweenTypes.TRANSFORM&&(tween._prev._renderTransforms=1),removeChild(animation,tween),removeTweenSliblings(tween),tweensMatchesTargets=!0)}},!0),tweensMatchesTargets},remove=(targets,renderable,propertyName)=>{const targetsArray=parseTargets(targets),parent=renderable||engine,waapiAnimation=renderable&&renderable.controlAnimation&&renderable;for(let i2=0,l2=targetsArray.length;i2<l2;i2++){const $el=targetsArray[i2];removeWAAPIAnimation($el,propertyName,waapiAnimation)}let removeMatches;if(parent._hasChildren){let iterationDuration=0;forEachChildren(parent,child=>{if(!child._hasChildren)if(removeMatches=removeTargetsFromAnimation(targetsArray,child,propertyName),removeMatches&&!child._head)child.cancel(),removeChild(parent,child);else{const childDur=child._offset+child._delay+child.duration;childDur>iterationDuration&&(iterationDuration=childDur)}child._head?remove(targets,child,propertyName):child._hasChildren=!1},!0),isUnd(parent.iterationDuration)||(parent.iterationDuration=iterationDuration)}else removeMatches=removeTargetsFromAnimation(targetsArray,parent,propertyName);return removeMatches&&!parent._head&&(parent._hasChildren=!1,parent.cancel&&parent.cancel()),targetsArray},random=(min2,max2,decimalLength)=>{const m=10**(decimalLength||0);return floor$1((Math.random()*(max2-min2+1/m)+min2)*m)/m},randomPick=items=>items[random(0,items.length-1)],shuffle=items=>{let m=items.length,t2,i2;for(;m;)i2=random(0,--m),t2=items[m],items[m]=items[i2],items[i2]=t2;return items},roundPad=(v,decimalLength)=>(+v).toFixed(decimalLength),padStart=(v,totalLength,padString)=>`${v}`.padStart(totalLength,padString),padEnd=(v,totalLength,padString)=>`${v}`.padEnd(totalLength,padString),wrap=(v,min2,max2)=>((v-min2)%(max2-min2)+(max2-min2))%(max2-min2)+min2,mapRange=(value,inLow,inHigh,outLow,outHigh)=>outLow+(value-inLow)/(inHigh-inLow)*(outHigh-outLow),degToRad=degrees2=>degrees2*PI/180,radToDeg=radians2=>radians2*180/PI,lerp=(start,end,amount,renderable)=>{let dt=K/globals.defaults.frameRate;if(renderable!==!1){const ticker=renderable||engine._hasChildren&&engine;ticker&&ticker.deltaTime&&(dt=ticker.deltaTime)}const t2=1-Math.exp(-amount*dt*.1);return amount?amount===1?end:(1-t2)*start+t2*end:start},curry=(fn,last=0)=>(...args)=>last?v=>fn(...args,v):v=>fn(v,...args),chain=fn=>(...args)=>{const result=fn(...args);return new Proxy(noop,{apply:(_,__,[v])=>result(v),get:(_,prop)=>chain((...nextArgs)=>{const nextResult=utils[prop](...nextArgs);return v=>nextResult(result(v))})})},makeChainable=(fn,right=0)=>(...args)=>(args.length<fn.length?chain(curry(fn,right)):fn)(...args),utils={$:registerTargets,get:getTargetValue,set:setTargetValues,remove,cleanInlineStyles,random,randomPick,shuffle,lerp,sync,clamp:makeChainable(clamp),round:makeChainable(round),snap:makeChainable(snap),wrap:makeChainable(wrap),interpolate:makeChainable(interpolate,1),mapRange:makeChainable(mapRange),roundPad:makeChainable(roundPad),padStart:makeChainable(padStart),padEnd:makeChainable(padEnd),degToRad:makeChainable(degToRad),radToDeg:makeChainable(radToDeg)};TSL.BRDF_GGX;TSL.BRDF_Lambert;TSL.BasicShadowFilter;TSL.Break;TSL.Continue;TSL.DFGApprox;TSL.D_GGX;const Discard=TSL.Discard;TSL.EPSILON;TSL.F_Schlick;const Fn=TSL.Fn;TSL.INFINITY;const If=TSL.If;TSL.Loop;TSL.NodeShaderStage;TSL.NodeType;TSL.NodeUpdateType;TSL.NodeAccess;TSL.PCFShadowFilter;TSL.PCFSoftShadowFilter;TSL.PI;TSL.PI2;TSL.Return;TSL.Schlick_to_F0;TSL.ScriptableNodeResources;TSL.ShaderNode;TSL.TBNViewMatrix;TSL.VSMShadowFilter;TSL.V_GGX_SmithCorrelated;const abs=TSL.abs;TSL.acesFilmicToneMapping;TSL.acos;TSL.add;TSL.addNodeElement;TSL.agxToneMapping;TSL.all;TSL.alphaT;TSL.and;TSL.anisotropy;TSL.anisotropyB;TSL.anisotropyT;TSL.any;TSL.append;TSL.array;TSL.arrayBuffer;TSL.asin;TSL.assign;const atan=TSL.atan;TSL.atan2;TSL.atomicAdd;TSL.atomicAnd;TSL.atomicFunc;TSL.atomicMax;TSL.atomicMin;TSL.atomicOr;TSL.atomicStore;TSL.atomicSub;TSL.atomicXor;TSL.atomicLoad;TSL.attenuationColor;TSL.attenuationDistance;TSL.attribute;TSL.attributeArray;TSL.backgroundBlurriness;TSL.backgroundIntensity;TSL.backgroundRotation;TSL.batch;TSL.billboarding;TSL.bitAnd;TSL.bitNot;TSL.bitOr;TSL.bitXor;TSL.bitangentGeometry;TSL.bitangentLocal;TSL.bitangentView;TSL.bitangentWorld;TSL.bitcast;TSL.blendBurn;TSL.blendColor;TSL.blendDodge;TSL.blendOverlay;TSL.blendScreen;TSL.blur;TSL.bool;TSL.buffer;TSL.bufferAttribute;TSL.bumpMap;TSL.burn;TSL.bvec2;TSL.bvec3;TSL.bvec4;TSL.bypass;TSL.cache;TSL.call;TSL.cameraFar;TSL.cameraIndex;TSL.cameraNear;TSL.cameraNormalMatrix;TSL.cameraPosition;TSL.cameraProjectionMatrix;TSL.cameraProjectionMatrixInverse;TSL.cameraViewMatrix;TSL.cameraWorldMatrix;TSL.cbrt;TSL.cdl;TSL.ceil;TSL.checker;TSL.cineonToneMapping;TSL.clamp;TSL.clearcoat;TSL.clearcoatRoughness;TSL.code;TSL.color;TSL.colorSpaceToWorking;TSL.colorToDirection;TSL.compute;TSL.cond;TSL.Const;TSL.context;TSL.convert;TSL.convertColorSpace;const convertToTexture=TSL.convertToTexture,cos=TSL.cos;TSL.cross;TSL.cubeTexture;TSL.dFdx;TSL.dFdy;TSL.dashSize;TSL.defaultBuildStages;TSL.defaultShaderStages;TSL.defined;TSL.degrees;TSL.deltaTime;TSL.densityFog;TSL.densityFogFactor;TSL.depth;TSL.depthPass;TSL.difference;TSL.diffuseColor;TSL.directPointLight;TSL.directionToColor;TSL.dispersion;TSL.distance;TSL.div;TSL.dodge;TSL.dot;TSL.drawIndex;TSL.dynamicBufferAttribute;TSL.element;TSL.emissive;TSL.equal;TSL.equals;TSL.equirectUV;TSL.exp;TSL.exp2;TSL.expression;TSL.faceDirection;TSL.faceForward;TSL.faceforward;const float=TSL.float,floor=TSL.floor;TSL.fog;TSL.fract;TSL.frameGroup;TSL.frameId;TSL.frontFacing;TSL.fwidth;TSL.gain;TSL.gapSize;TSL.getConstNodeType;TSL.getCurrentStack;TSL.getDirection;TSL.getDistanceAttenuation;TSL.getGeometryRoughness;TSL.getNormalFromDepth;TSL.getParallaxCorrectNormal;TSL.getRoughness;TSL.getScreenPosition;TSL.getShIrradianceAt;TSL.getTextureIndex;TSL.getViewPosition;TSL.glsl;TSL.glslFn;TSL.grayscale;TSL.greaterThan;TSL.greaterThanEqual;TSL.hash;TSL.highpModelNormalViewMatrix;TSL.highpModelViewMatrix;TSL.hue;TSL.instance;const instanceIndex=TSL.instanceIndex,instancedArray=TSL.instancedArray,instancedBufferAttribute=TSL.instancedBufferAttribute;TSL.instancedDynamicBufferAttribute;TSL.instancedMesh;TSL.int;TSL.inverseSqrt;TSL.inversesqrt;TSL.invocationLocalIndex;TSL.invocationSubgroupIndex;TSL.ior;TSL.iridescence;TSL.iridescenceIOR;TSL.iridescenceThickness;TSL.ivec2;TSL.ivec3;TSL.ivec4;TSL.js;TSL.label;const length=TSL.length;TSL.lengthSq;TSL.lessThan;TSL.lessThanEqual;TSL.lightPosition;TSL.lightTargetDirection;TSL.lightTargetPosition;TSL.lightViewPosition;TSL.lightingContext;TSL.lights;TSL.linearDepth;TSL.linearToneMapping;TSL.localId;TSL.globalId;TSL.log;TSL.log2;TSL.logarithmicDepthToViewZ;TSL.loop;TSL.luminance;TSL.mediumpModelViewMatrix;TSL.mat2;TSL.mat3;TSL.mat4;TSL.matcapUV;TSL.materialAO;TSL.materialAlphaTest;TSL.materialAnisotropy;TSL.materialAnisotropyVector;TSL.materialAttenuationColor;TSL.materialAttenuationDistance;TSL.materialClearcoat;TSL.materialClearcoatNormal;TSL.materialClearcoatRoughness;TSL.materialColor;TSL.materialDispersion;TSL.materialEmissive;TSL.materialIOR;TSL.materialIridescence;TSL.materialIridescenceIOR;TSL.materialIridescenceThickness;TSL.materialLightMap;TSL.materialLineDashOffset;TSL.materialLineDashSize;TSL.materialLineGapSize;TSL.materialLineScale;TSL.materialLineWidth;TSL.materialMetalness;TSL.materialNormal;TSL.materialOpacity;TSL.materialPointSize;TSL.materialReference;TSL.materialReflectivity;TSL.materialRefractionRatio;TSL.materialRotation;TSL.materialRoughness;TSL.materialSheen;TSL.materialSheenRoughness;TSL.materialShininess;TSL.materialSpecular;TSL.materialSpecularColor;TSL.materialSpecularIntensity;TSL.materialSpecularStrength;TSL.materialThickness;TSL.materialTransmission;const max=TSL.max;TSL.maxMipLevel;TSL.metalness;TSL.min;const mix=TSL.mix;TSL.mixElement;TSL.mod;TSL.modInt;TSL.modelDirection;TSL.modelNormalMatrix;TSL.modelPosition;TSL.modelRadius;TSL.modelScale;TSL.modelViewMatrix;TSL.modelViewPosition;TSL.modelViewProjection;TSL.modelWorldMatrix;TSL.modelWorldMatrixInverse;TSL.morphReference;TSL.mrt;const mul=TSL.mul;TSL.mx_aastep;TSL.mx_cell_noise_float;TSL.mx_contrast;TSL.mx_fractal_noise_float;TSL.mx_fractal_noise_vec2;TSL.mx_fractal_noise_vec3;TSL.mx_fractal_noise_vec4;TSL.mx_hsvtorgb;TSL.mx_noise_float;TSL.mx_noise_vec3;TSL.mx_noise_vec4;TSL.mx_ramplr;TSL.mx_ramptb;TSL.mx_rgbtohsv;TSL.mx_safepower;TSL.mx_splitlr;TSL.mx_splittb;TSL.mx_srgb_texture_to_lin_rec709;TSL.mx_transform_uv;TSL.mx_worley_noise_float;TSL.mx_worley_noise_vec2;TSL.mx_worley_noise_vec3;TSL.negate;TSL.neutralToneMapping;TSL.nodeArray;TSL.nodeImmutable;const nodeObject=TSL.nodeObject;TSL.nodeObjects;TSL.nodeProxy;TSL.normalFlat;TSL.normalGeometry;TSL.normalLocal;TSL.normalMap;TSL.normalView;TSL.normalWorld;TSL.normalize;TSL.not;TSL.notEqual;TSL.numWorkgroups;TSL.objectDirection;TSL.objectGroup;TSL.objectPosition;TSL.objectRadius;TSL.objectScale;TSL.objectViewPosition;TSL.objectWorldMatrix;TSL.oneMinus;TSL.or;TSL.orthographicDepthToViewZ;TSL.oscSawtooth;TSL.oscSine;TSL.oscSquare;TSL.oscTriangle;TSL.output;TSL.outputStruct;TSL.overlay;TSL.overloadingFn;TSL.parabola;TSL.parallaxDirection;TSL.parallaxUV;TSL.parameter;const pass=TSL.pass,passTexture=TSL.passTexture;TSL.pcurve;TSL.perspectiveDepthToViewZ;TSL.pmremTexture;TSL.pointUV;TSL.pointWidth;const positionGeometry=TSL.positionGeometry;TSL.positionLocal;TSL.positionPrevious;TSL.positionView;TSL.positionViewDirection;TSL.positionWorld;TSL.positionWorldDirection;TSL.posterize;TSL.pow;TSL.pow2;TSL.pow3;TSL.pow4;TSL.property;TSL.radians;const rand=TSL.rand;TSL.range;TSL.rangeFog;TSL.rangeFogFactor;TSL.reciprocal;TSL.lightProjectionUV;TSL.reference;TSL.referenceBuffer;TSL.reflect;TSL.reflectVector;TSL.reflectView;TSL.reflector;TSL.refract;TSL.refractVector;TSL.refractView;TSL.reinhardToneMapping;TSL.remainder;const remap=TSL.remap,remapClamp=TSL.remapClamp;TSL.renderGroup;TSL.renderOutput;TSL.rendererReference;TSL.rotate;TSL.rotateUV;TSL.roughness;TSL.round;TSL.rtt;TSL.sRGBTransferEOTF;TSL.sRGBTransferOETF;TSL.sampler;TSL.saturate;TSL.saturation;TSL.screen;TSL.screenCoordinate;TSL.screenSize;TSL.screenUV;TSL.scriptable;TSL.scriptableValue;TSL.select;TSL.setCurrentStack;TSL.shaderStages;TSL.shadow;TSL.pointShadow;TSL.shadowPositionWorld;TSL.sharedUniformGroup;TSL.shapeCircle;TSL.sheen;TSL.sheenRoughness;TSL.shiftLeft;TSL.shiftRight;TSL.shininess;const sign=TSL.sign,sin=TSL.sin;TSL.sinc;TSL.skinning;TSL.skinningReference;const smoothstep=TSL.smoothstep;TSL.smoothstepElement;TSL.specularColor;TSL.specularF90;TSL.spherizeUV;TSL.split;TSL.spritesheetUV;const sqrt=TSL.sqrt;TSL.stack;const step=TSL.step;TSL.storage;TSL.storageBarrier;TSL.storageObject;TSL.storageTexture;TSL.string;TSL.struct;TSL.sub;TSL.subgroupIndex;TSL.subgroupSize;TSL.tan;TSL.tangentGeometry;TSL.tangentLocal;TSL.tangentView;TSL.tangentWorld;TSL.temp;const texture=TSL.texture;TSL.texture3D;TSL.textureBarrier;TSL.textureBicubic;TSL.textureCubeUV;TSL.textureLoad;TSL.textureSize;TSL.textureStore;TSL.thickness;TSL.threshold;const time=TSL.time;TSL.timerDelta;TSL.timerGlobal;TSL.timerLocal;TSL.toOutputColorSpace;TSL.toWorkingColorSpace;TSL.toneMapping;TSL.toneMappingExposure;TSL.toonOutlinePass;TSL.transformDirection;TSL.transformNormal;TSL.transformNormalToView;TSL.transformedBentNormalView;TSL.transformedBitangentView;TSL.transformedBitangentWorld;TSL.transformedClearcoatNormalView;TSL.transformedNormalView;TSL.transformedNormalWorld;TSL.transformedTangentView;TSL.transformedTangentWorld;TSL.transmission;TSL.transpose;TSL.tri;TSL.tri3;TSL.triNoise3D;TSL.triplanarTexture;TSL.triplanarTextures;TSL.trunc;TSL.tslFn;TSL.uint;const uniform=TSL.uniform;TSL.uniformArray;TSL.uniformGroup;TSL.uniforms;TSL.userData;const uv=TSL.uv;TSL.uvec2;TSL.uvec3;TSL.uvec4;TSL.Var;TSL.varying;TSL.varyingProperty;const vec2=TSL.vec2,vec3=TSL.vec3,vec4=TSL.vec4;TSL.vectorComponents;TSL.velocity;TSL.vertexColor;TSL.vertexIndex;TSL.vibrance;TSL.viewZToLogarithmicDepth;TSL.viewZToOrthographicDepth;TSL.viewZToPerspectiveDepth;TSL.viewport;TSL.viewportBottomLeft;TSL.viewportCoordinate;TSL.viewportDepthTexture;TSL.viewportLinearDepth;TSL.viewportMipTexture;TSL.viewportResolution;TSL.viewportSafeUV;TSL.viewportSharedTexture;TSL.viewportSize;TSL.viewportTexture;TSL.viewportTopLeft;TSL.viewportUV;TSL.wgsl;TSL.wgslFn;TSL.workgroupArray;TSL.workgroupBarrier;TSL.workgroupId;TSL.workingToColorSpace;TSL.xor;const rotation=Fn(([dataMap,iba])=>{let mapUV=iba.xy.add(1).div(2).toVar();mapUV.y=mapUV.y.oneMinus();let color2=dataMap.sample(mapUV).rgb.toVar(),U=remap(float(color2.b),0,1,-25,25).toVar(),V=remap(float(color2.r),0,1,-25,25).toVar(),angle=atan(V,U).mul(180/Math.PI).add(180).mod(360).mul(Math.PI/180).toVar();return angle=angle.mul(Math.PI).toVar(),angle=angle.sub(Math.PI).toVar(),angle});class Arrows extends Group{constructor(){super();let map=Arrows.map||(Arrows.map=new TextureLoader().load(urlProxy("https://www.meteoconsult.fr/bundles/meteoconsultwebmap/image/map/sprite_arrow.png")));this._dataMap=texture(map);let material=new MeshBasicNodeMaterial({map,transparent:!0,alphaTest:.1,blending:SubtractiveBlending}),geometry2=new PlaneGeometry(1,1),gridSize=16,gridX=Math.ceil(stage.width/gridSize),gridY=Math.ceil(stage.height/gridSize),count=gridX*gridY;this.instanced=new InstancedMesh(geometry2,material,count),this.instanced.instanceMatrix.setUsage(DynamicDrawUsage);const positions=[];for(let i2=0;i2<count;i2++){let pxX=i2%gridX*gridSize,pxY=Math.floor(i2/gridX)*gridSize,worldX=pxX*(2/stage.width)-1,worldY=1-pxY*(2/stage.height);positions.push(worldX,worldY,0)}const positionAttribute=new InstancedBufferAttribute(new Float32Array(positions),3),iba=instancedBufferAttribute(positionAttribute);this.uWidth=uniform(stage.width),this.uHeight=uniform(stage.height),this.uSize=uniform(gridSize/stage.width),this.aspectRatio=uniform(stage.width/stage.height),this.uScale=uniform(1);const pos=positionGeometry.xy.toVar(),scaledPosition=vec2(pos.x,pos.y);let angle=atan(scaledPosition.y,scaledPosition.x).add(rotation(this._dataMap,iba));material.positionNode=vec3(cos(angle).div(this.aspectRatio),sin(angle),0).mul(this.uSize).mul(this.uScale).add(iba.div(this.aspectRatio)).mul(this.aspectRatio),this.add(this.instanced),this.scale.setScalar(.5),this.renderOrder=999999,stage.onResize.add(()=>{this.uWidth.value=stage.width,this.uHeight.value=stage.height,this.uSize.value=gridSize/stage.width,this.aspectRatio.value=stage.width/stage.height})}set dataMap(value){this._dataMap.value=value,stage3d.renderNext()}setVisible(visible){this.visible=visible}set opacity(value){this.instanced.material.opacity=value}get opacity(){return this.instanced.material.opacity}}class Barbules extends Group{constructor(){super();let map=Barbules.map||(Barbules.map=new TextureLoader().load(urlProxy("https://www.meteoconsult.fr/bundles/meteoconsultwebmap/image/map/sprite_barb_128.png"))),uMap=texture(map);this._dataMap=texture(map);let material=new MeshBasicNodeMaterial({map,transparent:!0,alphaTest:.1,opacity:1,blending:SubtractiveBlending}),gridSize=40,geometry2=new PlaneGeometry(1,1),gridX=Math.ceil(stage.width/gridSize),gridY=Math.ceil(stage.height/gridSize),count=gridX*gridY;this.instanced=new InstancedMesh(geometry2,material,count),this.instanced.instanceMatrix.setUsage(DynamicDrawUsage);const positions=[];for(let i2=0;i2<count;i2++){let pxX=i2%gridX*gridSize,pxY=Math.floor(i2/gridX)*gridSize,worldX=pxX*(2/stage.width)-1,worldY=1-pxY*(2/stage.height);positions.push(worldX,worldY,0)}const positionAttribute=new InstancedBufferAttribute(new Float32Array(positions),3),iba=instancedBufferAttribute(positionAttribute);this.uWidth=uniform(stage.width),this.uHeight=uniform(stage.height),this.uSize=uniform(gridSize/stage.width),this.aspectRatio=uniform(stage.width/stage.height),this.uScale=uniform(1);const pos=positionGeometry.xy.toVar(),scaledPosition=vec2(pos.x,pos.y);let angle=atan(scaledPosition.y,scaledPosition.x).add(rotation(this._dataMap,iba)).toVar();angle=angle.add(Math.PI),material.positionNode=vec3(cos(angle).div(this.aspectRatio),sin(angle),0).mul(this.uSize).mul(this.uScale).add(iba.div(this.aspectRatio)).mul(this.aspectRatio),stage.onResize.add(()=>{this.uWidth.value=stage.width,this.uHeight.value=stage.height,this.uSize.value=gridSize/stage.width,this.aspectRatio.value=stage.width/stage.height}),this.uOpacity=uniform(0);let color2=Fn(()=>{let mapUV=iba.xy.add(1).div(2).toVar();mapUV.y=mapUV.y.oneMinus();let color3=this._dataMap.sample(mapUV).rgb.toVar(),baseX=uv().x.mul(1/10).toVar(),baseY=uv().y.mul(1/4).toVar(),result=vec3().toVar();return If(color3.b.equal(0).and(color3.r.equal(0)),()=>{result.assign(uMap.sample(vec2(baseX,baseY.oneMinus())).rgb)}).Else(()=>{let U=remap(float(color3.b),0,1,-25,25).toVar(),V=remap(float(color3.r),0,1,-25,25).toVar(),U2=U.mul(U).toVar(),V2=V.mul(V).toVar(),speedRaw=sqrt(U2.add(V2)).toVar(),normalizedSpeed=remap(speedRaw,0,35.355,0,1),idx=floor(normalizedSpeed.oneMinus().mul(8)),x=baseX.add(idx.mod(10).div(10)),y=baseY.add(floor(idx.div(10)).mul(1/4));result.assign(uMap.sample(vec2(x,y.oneMinus())).rgb)}),result});material.colorNode=color2(),this.add(this.instanced),this.scale.setScalar(.5),this.renderOrder=999999}set dataMap(value){this._dataMap.value=value,stage3d.renderNext()}setVisible(visible){this.visible=visible}set opacity(value){this.uOpacity.value=value}get opacity(){return this.uOpacity.value}}const _size=new Vector2,_quadMeshComp=new QuadMesh;let _rendererState$1;class AfterImageNode extends TempNode{static get type(){return"AfterImageNode"}constructor(textureNode,damp2=.96){super("vec4"),this.textureNode=textureNode,this.textureNodeOld=texture(),this.damp=uniform(damp2),this._compRT=new RenderTarget(1,1,{depthBuffer:!1}),this._compRT.texture.name="AfterImageNode.comp",this._oldRT=new RenderTarget(1,1,{depthBuffer:!1}),this._oldRT.texture.name="AfterImageNode.old",this._textureNode=passTexture(this,this._compRT.texture),this.updateBeforeType=NodeUpdateType.FRAME}getTextureNode(){return this._textureNode}setSize(width,height){this._compRT.setSize(width,height),this._oldRT.setSize(width,height)}updateBefore(frame){const{renderer}=frame;_rendererState$1=RendererUtils.resetRendererState(renderer,_rendererState$1);const textureNode=this.textureNode,textureType=textureNode.value.type;this._compRT.texture.type=textureType,this._oldRT.texture.type=textureType,renderer.getDrawingBufferSize(_size),this.setSize(_size.x,_size.y);const currentTexture=textureNode.value;this.textureNodeOld.value=this._oldRT.texture,renderer.setRenderTarget(this._compRT),_quadMeshComp.render(renderer);const temp2=this._oldRT;this._oldRT=this._compRT,this._compRT=temp2,textureNode.value=currentTexture,RendererUtils.restoreRendererState(renderer,_rendererState$1)}setup(builder){const textureNode=this.textureNode,textureNodeOld=this.textureNodeOld;textureNodeOld.uvNode=textureNode.uvNode||uv();const afterImg=Fn(()=>{const texelOld=textureNodeOld.sample().toVar(),texelNew=textureNode.sample().toVar(),threshold=float(.1).toConst(),m=max(sign(texelOld.sub(threshold)),0);return texelOld.mulAssign(this.damp.mul(m)),max(texelNew,texelOld)}),materialComposed=this._materialComposed||(this._materialComposed=new NodeMaterial);materialComposed.name="AfterImage",materialComposed.fragmentNode=afterImg(),_quadMeshComp.material=materialComposed;const properties=builder.getNodeProperties(this);return properties.textureNode=textureNode,this._textureNode}dispose(){this._compRT.dispose(),this._oldRT.dispose()}}const afterImage=(node,damp2)=>nodeObject(new AfterImageNode(convertToTexture(node),damp2));class Particles extends Group{constructor(){super();let map=Particles.map||(Particles.map=new TextureLoader().load(urlProxy("https://www.meteoconsult.fr/bundles/meteoconsultwebmap/image/map/particle2.jpg")));this.nodeMap=Particles.nodeMap||(Particles.nodeMap=texture(map)),this._dataMap=texture(map),this._colorMap=texture(map),this.uOpacity=uniform(0);let geometry2=new PlaneGeometry(1,1),material=new MeshBasicNodeMaterial({transparent:!0,blending:AdditiveBlending,depthWrite:!1}),gridSize=30,gridX=Math.ceil(stage.width/gridSize),gridY=Math.ceil(stage.height/gridSize),count=gridX*gridY;this.instanced=new InstancedMesh(geometry2,material,count),this.instanced.instanceMatrix.setUsage(DynamicDrawUsage);const speed=uniform(1),positionArray=instancedArray(count,"vec3"),lifeArray=instancedArray(count,"float"),computeNode=Fn(()=>{const position=positionArray.element(instanceIndex);let mapUV=position.xy.add(1).div(2).toVar();mapUV.y=mapUV.y.oneMinus();let color2=this._dataMap.sample(mapUV).rgb,U=remap(float(color2.b),0,1,-25,25).toVar(),V=remap(float(color2.r),0,1,-25,25).toVar(),U2=U.mul(U).toVar(),V2=V.mul(V).toVar(),speedRaw=sqrt(U2.add(V2)).toVar(),normalizedSpeed=remapClamp(speedRaw,0,35.355,0,1).oneMinus(),angle=atan(V,U).mul(180/Math.PI).add(180).mod(360).mul(Math.PI/180).toVar();angle=angle.mul(Math.PI).toVar(),angle=angle.add(Math.PI/2).toVar();let windSpeed=remap(normalizedSpeed,0,1,.1,2);position.x=position.x.add(cos(angle).mul(speed.mul(.001).mul(windSpeed))),position.y=position.y.add(sin(angle).mul(speed.mul(.001).mul(windSpeed)));const life2=lifeArray.element(instanceIndex);let l2=life2.add(speed.mul(.01)).toVar();If(l2.greaterThan(1),()=>{position.x=rand(position.xy.add(time)).sub(.5).mul(2),position.y=rand(position.xy.add(time.mul(2))).sub(.5).mul(2),life2.x=l2.mod(1)}).Else(()=>{life2.x=l2})})().compute(count);computeNode.onInit(({renderer})=>{const precomputeShaderNode=Fn(()=>{let positionX=float(instanceIndex).mod(gridX).mul(gridSize),positionY=floor(float(instanceIndex).div(gridX)).mul(gridSize);const position=positionArray.element(instanceIndex);position.x=positionX.mul(2/stage.width).sub(1),position.y=float(1).sub(positionY.mul(2/stage.height)),lifeArray.element(instanceIndex).assign(rand(position.xy).mul(10))});renderer.computeAsync(precomputeShaderNode().compute(count))});let life=lifeArray.element(instanceIndex),positionNode=Fn(()=>{let position=positionArray.element(instanceIndex),sizeX=float(1).div(window.innerWidth/16),sizeY=float(1).div(window.innerHeight/16);return positionGeometry.mul(vec2(sizeX,sizeY)).mul(1).mul(.5).add(position)}),colorNode=Fn(()=>this.nodeMap.sample(uv()).rgb),opacityNode=Fn(()=>this.nodeMap.sample(uv()).a.mul(this.uOpacity).mul(smoothstep(0,.2,life).mul(smoothstep(.8,1,life).oneMinus())));material.positionNode=positionNode(),material.colorNode=colorNode(),material.opacityNode=opacityNode();let isFinish=!0,lastTime=Date.now();const postProcessing=new PostProcessing(stage3d.renderer);let scene=new Scene;scene.add(this.instanced),this.instanced.scale.setScalar(.5);const scenePass=pass(scene,stage3d.camera);let afterPass=afterImage(scenePass.getTextureNode(),.985);postProcessing.outputNode=afterPass;let output2=new RenderTarget(stage.width,stage.height,{minFilter:LinearFilter,magFilter:LinearFilter,samples:1});stage.onUpdate.add(async()=>{if(!this.visible||!isFinish)return;let dt=Date.now()-lastTime;speed.value=dt/16.666,lastTime=Date.now(),isFinish=!1,await stage3d.renderer.computeAsync(computeNode),stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(output2),postProcessing.render(),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),stage3d.renderNext(),isFinish=!0}),this.add(this.renderQuad=new Mesh(new PlaneGeometry(2,2),new MeshBasicNodeMaterial({side:BackSide,map:output2.texture,transparent:!0,opacity:0,depthWrite:!1}))),this.renderQuad.rotation.x=Math.PI;let outputTexture=texture(output2.texture);this.renderQuad.material.colorNode=Fn(()=>this._colorMap.sample(uv()).rgb.oneMinus())(),this.renderQuad.material.opacityNode=outputTexture.sample(uv()).r,this.scale.setScalar(.5),this.renderOrder=999999}updateColorMap(quad){this.visible&&(this.renderTarget||(this.renderTarget=new RenderTarget(stage.width,stage.height,{depthBuffer:!1,stencilBuffer:!1,samples:1,alpha:!0,minFilter:LinearFilter,magFilter:LinearFilter,format:RGBAFormat,type:UnsignedByteType,colorSpace:NoColorSpace})),stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(this.renderTarget),stage3d.renderer.render(quad,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),this.colorMap=this.renderTarget.texture)}set dataMap(value){this._dataMap.value=value,stage3d.renderNext()}set colorMap(value){this._colorMap.value=value,stage3d.renderNext()}setVisible(visible,quad){this.visible=visible,this.renderQuad.visible=visible,this.visible&&this.updateColorMap(quad)}set opacity(value){this.uOpacity.value!=value&&(this.uOpacity.value=value,stage3d.renderNext())}get opacity(){return this.uOpacity.value}}const _quadMesh=new QuadMesh;let _rendererState;const premult=Fn(([color2])=>vec4(color2.rgb.mul(color2.a),color2.a)).setLayout({name:"premult",type:"vec4",inputs:[{name:"color",type:"vec4"}]}),unpremult=Fn(([color2])=>(If(color2.a.equal(0),()=>vec4(0)),vec4(color2.rgb.div(color2.a),color2.a))).setLayout({name:"unpremult",type:"vec4",inputs:[{name:"color",type:"vec4"}]});class GaussianBlurNode extends TempNode{static get type(){return"GaussianBlurNode"}constructor(textureNode,directionNode=null,sigma=2){super("vec4"),this.textureNode=textureNode,this.directionNode=directionNode,this.sigma=sigma,this._invSize=uniform(new Vector2),this._passDirection=uniform(new Vector2),this._horizontalRT=new RenderTarget(1,1,{depthBuffer:!1}),this._horizontalRT.texture.name="GaussianBlurNode.horizontal",this._verticalRT=new RenderTarget(1,1,{depthBuffer:!1}),this._verticalRT.texture.name="GaussianBlurNode.vertical",this._textureNode=passTexture(this,this._verticalRT.texture),this._textureNode.uvNode=textureNode.uvNode,this.updateBeforeType=NodeUpdateType.FRAME,this.resolution=new Vector2(1,1),this.premultipliedAlpha=!1}setPremultipliedAlpha(value){return this.premultipliedAlpha=value,this}getPremultipliedAlpha(){return this.premultipliedAlpha}setSize(width,height){width=Math.max(Math.round(width*this.resolution.x),1),height=Math.max(Math.round(height*this.resolution.y),1),this._invSize.value.set(1/width,1/height),this._horizontalRT.setSize(width,height),this._verticalRT.setSize(width,height)}updateBefore(frame){const{renderer}=frame;_rendererState=RendererUtils.resetRendererState(renderer,_rendererState);const textureNode=this.textureNode,map=textureNode.value,currentTexture=textureNode.value;_quadMesh.material=this._material,this.setSize(map.image.width,map.image.height);const textureType=map.type;this._horizontalRT.texture.type=textureType,this._verticalRT.texture.type=textureType,renderer.setRenderTarget(this._horizontalRT),this._passDirection.value.set(1,0),_quadMesh.render(renderer),textureNode.value=this._horizontalRT.texture,renderer.setRenderTarget(this._verticalRT),this._passDirection.value.set(0,1),_quadMesh.render(renderer),textureNode.value=currentTexture,RendererUtils.restoreRendererState(renderer,_rendererState)}getTextureNode(){return this._textureNode}setup(builder){const textureNode=this.textureNode,uvNode=uv(),directionNode=vec2(this.directionNode||1);let sampleTexture,output2;this.premultipliedAlpha?(sampleTexture=uv2=>premult(textureNode.sample(uv2)),output2=color2=>unpremult(color2)):(sampleTexture=uv2=>textureNode.sample(uv2),output2=color2=>color2);const blur2=Fn(()=>{const kernelSize=3+2*this.sigma,gaussianCoefficients=this._getCoefficients(kernelSize),invSize=this._invSize,direction=directionNode.mul(this._passDirection),weightSum=float(gaussianCoefficients[0]).toVar(),diffuseSum=vec4(sampleTexture(uvNode).mul(weightSum)).toVar();for(let i2=1;i2<kernelSize;i2++){const x=float(i2),w=float(gaussianCoefficients[i2]),uvOffset=vec2(direction.mul(invSize.mul(x))).toVar(),sample1=sampleTexture(uvNode.add(uvOffset)),sample2=sampleTexture(uvNode.sub(uvOffset));diffuseSum.addAssign(sample1.add(sample2).mul(w)),weightSum.addAssign(mul(2,w))}return output2(diffuseSum.div(weightSum))}),material=this._material||(this._material=new NodeMaterial);material.fragmentNode=blur2().context(builder.getSharedContext()),material.name="Gaussian_blur",material.needsUpdate=!0;const properties=builder.getNodeProperties(this);return properties.textureNode=textureNode,this._textureNode}dispose(){this._horizontalRT.dispose(),this._verticalRT.dispose()}_getCoefficients(kernelRadius){const coefficients=[];for(let i2=0;i2<kernelRadius;i2++)coefficients.push(.39894*Math.exp(-.5*i2*i2/(kernelRadius*kernelRadius))/kernelRadius);return coefficients}}const gaussianBlur=(node,directionNode,sigma)=>nodeObject(new GaussianBlurNode(convertToTexture(node),directionNode,sigma));class Isobars extends Group{constructor(master){super(),this.master=master,console.log("new isobar",master.data.name),this._dataMap=uniform(null),this.material=new MeshBasicNodeMaterial({transparent:!0,depthWrite:!1,side:DoubleSide});const f2=Fn(([uv2])=>{const uvFlip=uv2.flipY(),txt=texture(this._dataMap.value,uvFlip);return gaussianBlur(txt,vec2(1),8).b}),grad=Fn(([x])=>{let h=vec2(.01,0);return vec2(f2(x.add(h.xy)).sub(f2(x.sub(h.xy))).div(h.x.mul(2)),f2(x.add(h.yx)).sub(f2(x.sub(h.yx))).div(h.x.mul(2)))});Fn(()=>{let v=f2(uv()).toVar(),g=grad(uv()).toVar(),de=abs(v).div(length(g)).toVar(),eps=float(1).div(.5);return smoothstep(eps.mul(1),eps.mul(2),de)});const colorNode=Fn(()=>{const value=f2(uv()),isoStep=.05,lineWidth=.003,steppedValue=value.div(isoStep).floor().mul(isoStep),difference2=value.sub(steppedValue).abs(),isoline=step(difference2,lineWidth);return vec4(vec3(isoline).oneMinus(),isoline)});this.material.colorNode=colorNode(),this.renderOrder=1e6,this.scale.setScalar(.5),this.quadFirstRender=new Mesh(new PlaneGeometry(1,1),this.material),this.quadFinalRender=new Mesh(new PlaneGeometry(1,1),this.material);let scene=new Scene(this.quad);scene.add(this.quadFirstRender);let output1=new RenderTarget(stage.width,stage.height,{sample:4});new RenderTarget(stage.width,stage.height,{});let isProcessing=!1;stage.onUpdate.add(async()=>{isProcessing||!this.visible||(isProcessing=!0,stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(output1),stage3d.renderer.render(scene,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),stage3d.renderNext(),isProcessing=!1)});let mat=new MeshBasicNodeMaterial({side:BackSide,map:output1.texture,transparent:!0,depthWrite:!1});this.add(this.quadFinalRender=new Mesh(new PlaneGeometry(2,2),mat)),this.quadFinalRender.renderOrder=999999,this.quadFinalRender.rotation.x=Math.PI}set dataMap(value){this._dataMap.value=value,stage3d.renderNext()}}class GradientTexture extends CanvasTexture{constructor(width=1,height=256){const canvas=document.createElement("canvas");canvas.width=width,canvas.height=height,super(canvas),this.ctx=canvas.getContext("2d",{alpha:!0}),this.ctx.clearRect(0,0,width,height),this.canvas=canvas,this.needsUpdate=!0,this.anisotropy=1,this.generateMipmaps=!1,this.colorSpace=NoColorSpace}debug(){this.canvas.style.position="absolute",this.canvas.style.top="0px",this.canvas.style.left="0px",this.canvas.style.zIndex="10000000",document.body.append(this.canvas)}updateGradient(colors,values,gadrientMode="linear",domain=null){this.needsUpdate=!0,this.colorSpace=SRGBColorSpace;const ctx=this.ctx,height=this.canvas.height,gradient=ctx.createLinearGradient(0,0,0,height);let max2=Math.max(...values),min2=Math.min(...values),range2=max2-min2,normalizedValues=values.map(value=>(value-min2)/range2);if(domain){let max3=255,min3=0,range3=max3-min3;normalizedValues=domain.map(value=>(value-min3)/range3)}colors.forEach((color2,index)=>{let pos=0;gadrientMode=="linear"?pos=index/colors.length:pos=normalizedValues[index],gradient.addColorStop(clamp$1(pos),color2)}),ctx.fillStyle=gradient,ctx.fillRect(0,0,this.canvas.width,height),this.needsUpdate=!0}}const transparent64="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mP8/58BAQUBAKgBTk0AAAAASUVORK5CYII=",img=new Image;img.src=transparent64;const transparentTexture=new Texture(img);class LayerMaterial extends MeshBasicNodeMaterial{constructor(layer){super({transparent:!0,depthWrite:!1,opacity:0}),this.layer=layer,this.options=layer.data.colorOptions,this.useGradient=this.layer.data.legends?this.options.useGradient:!1,this.useGradient&&this.updateGradient(),this.uTxtFrom=texture(transparentTexture),this.uTxtTo=texture(transparentTexture),this.uPercent=uniform(1),watch(this.layer.percent,value=>{this.uPercent.value=this.layer.percent.value}),this.update()}update=()=>{this.colorNode=this.colorNodeFn(),this.updateBlendMode(),this.needsUpdate=!0};colorNodeFn=()=>Fn(()=>{const uvFlip=uv().flipY().toVar("uvFlip"),from=this.uTxtFrom.sample(uvFlip),to=this.uTxtTo.sample(uvFlip);let txt=mix(from,to,this.uPercent).toVar();if(Discard(txt.a.lessThan(.01)),this.useGradient){let percent=txt.b.oneMinus().toVar();this.options.stepColor>0&&(percent=percent.mul(this.options.stepColor).round().div(this.options.stepColor)),txt=vec4(this.uGradientTxt.sample(vec2(.5,percent)).rgb,txt.a)}let noBlur=window.location.search.includes("noblur")||getTier()<2;if(console.log("test Tier "),console.log(getTier()),this.options.blur&&!noBlur&&(txt=gaussianBlur(txt,1,this.options.blur)),this.options.blueIsAlpha&&(txt.a.mulAssign(txt.b),txt.rgb.assign(vec3(txt.b))),this.options.blackIsAlpha){let alpha=smoothstep(.01,.02,txt.b.oneMinus());txt.a.mulAssign(alpha)}return txt})();updateGradient=()=>{if(this.useGradient){let legends=this.layer.data.legends[0];this.gradient=this.gradient||new GradientTexture,this.gradient.updateGradient(legends.hexColors,legends.values,this.options.gradientMode,this.layer.provider.value.domain),this.uGradientTxt=texture(this.gradient)}};updateBlendMode=value=>{switch(this.options.blending){case"additive":this.blending=AdditiveBlending;break;case"multiply":this.blending=MultiplyBlending;break;case"subtract":console.log("test"),this.blending=SubtractiveBlending;break;case"normal":default:this.blending=NormalBlending}}}class ThreeJsImageLayerRenderer extends LayerRenderer{constructor(layer,options={},master){super(layer),this.options=options,this.master=master,this.openLayerMap=master.openLayerMap,this.renderTarget=null,this.container=new Group,this.onImageLoaded=new Signal,this.allTilesDisplayed=!1,this.images=[],this.lastFrameState=null,stage.onResize.add(this.resize),stage.onUpdate.add(this.update)}addImage=opts=>{currentLoading.value++,new TextureLoader().load(opts.imageUrl,map=>{currentLoading.value--,opts.repeat&&(map.wrapS=RepeatWrapping,map.wrapT=RepeatWrapping,map.repeat.set(opts.repeatX||1,opts.repeatY||1),map.colorSpace=SRGBColorSpace);const geometry2=new PlaneGeometry(1,1),material=new MeshBasicNodeMaterial({map,transparent:!0}),meshCenter=new Mesh(geometry2,material),meshLeft=new Mesh(geometry2,material),meshRight=new Mesh(geometry2,material);this.container.add(meshLeft,meshCenter,meshRight),this.images.push({opts,meshes:{left:meshLeft,center:meshCenter,right:meshRight}}),this.needsRender=!0,this.updateImage(this.lastFrameState),this.onImageLoaded.dispatch(),this.allTilesDisplayed=!0})};getViewportExtent(){const view=this.openLayerMap.getView(),size=this.openLayerMap.getSize();if(!size)throw new Error("Map size is not available.");return view.calculateExtent(size)}prepareFrame(frameState2){return!0}renderFrame(frameState2){this.updateImage(frameState2)}render(){super.render(frameState)}updateImage=frameState2=>{if(this.lastFrameState=frameState2,!this.lastFrameState||!this.images.length)return;const[vMinX,vMinY,vMaxX,vMaxY]=getRenderExtent(frameState2,frameState2.extent),viewportWidth=vMaxX-vMinX,viewportHeight=vMaxY-vMinY,scaleX=1/viewportWidth,scaleY=1/viewportHeight,viewProj=this.openLayerMap.getView().getProjection().getCode(),mod2=(n2,m)=>(n2%m+m)%m;this.images.forEach(({opts,meshes})=>{const[imgMinX,imgMinY,imgMaxX,imgMaxY]=transformExtent(opts.extent,"EPSG:4326",viewProj),imgWidth=imgMaxX-imgMinX,imgHeight=imgMaxY-imgMinY,[worldMinX,worldMinY,worldMaxX,worldMaxY]=transformExtent([-180,-85,180,85],"EPSG:4326",viewProj),scaledWorldWidth=(worldMaxX-worldMinX)*scaleX,scaledWidth=imgWidth*scaleX,scaledHeight=imgHeight*scaleY,rawCenterX=(imgMinX-vMinX)*scaleX+scaledWidth/2-.5,centerY=(imgMinY-vMinY)*scaleY+scaledHeight/2-.5,halfW=scaledWidth/2,adjustedCenterX=mod2(rawCenterX+halfW,scaledWorldWidth)-halfW;Object.values(meshes).forEach(mesh=>mesh.scale.set(scaledWidth,scaledHeight,1)),meshes.center.position.set(adjustedCenterX,centerY,0),meshes.left.position.set(adjustedCenterX-scaledWorldWidth,centerY,0),meshes.right.position.set(adjustedCenterX+scaledWorldWidth,centerY,0)}),this.needsRender=!0};initRT=()=>{this.renderTarget||(this.renderTarget=ThreeJsTileLayerRenderer.PoolRenderTarget.checkOut())};releaseRT=()=>{this.renderTarget&&(ThreeJsTileLayerRenderer.PoolRenderTarget.checkIn(this.renderTarget),this.renderTarget=null)};resize=()=>{this.renderTarget&&(this.renderTarget.setSize(stage.width,stage.height),this.render3d())};update=dt=>{this.master.opacity<.001||this.needsRender&&this.render3d()};render3d=()=>{this.needsRender=!1,this.initRT(),stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(this.renderTarget),stage3d.renderer.render(this.container,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),stage3d.renderNext()}}class ThreeJsImageLayer extends BaseTileLayer{constructor(options,imgOption,master){super(options),this.imgOption=imgOption,this.master=master}createRenderer(){return new ThreeJsImageLayerRenderer(this,this.imgOption,this.master)}initRT=()=>this.getRenderer().initRT();releaseRT=()=>this.getRenderer().releaseRT();addImage=opts=>this.getRenderer().addImage(opts);get texture(){return this.renderTarget?this.renderTarget.texture:null}get renderTarget(){return this.getRenderer().renderTarget}get container(){return this.getRenderer().container}get onImageLoaded(){return this.getRenderer().onImageLoaded}get onTilesDisplayed(){return this.getRenderer().onImageLoaded}}class ThreeJsParticleLayerRenderer extends LayerRenderer{constructor(layer,options={},master){super(layer),this.options=options,this.master=master,this.openLayerMap=master.openLayerMap,this.renderTarget=null,this.container=new Group,this.onImageLoaded=new Signal,this.allTilesDisplayed=!1,this.lastFrameState=null,stage.onResize.add(this.resize),stage.onUpdate.add(this.update)}addParticles=opts=>{currentLoading.value++,new TextureLoader().load(opts.imageUrl,map=>{currentLoading.value--,this.data=opts.data;const count=this.data.length,positions=new Float32Array(count*3),positionAttribute=new InstancedBufferAttribute(positions,3);positionAttribute.setUsage(DynamicDrawUsage),this.positionAttribute=positionAttribute;const material=new SpriteNodeMaterial({sizeAttenuation:!1,map,transparent:!0,depthTest:!1,depthWrite:!1});material.positionNode=Fn(()=>instancedBufferAttribute(positionAttribute,"vec3").xyz)();const ratio=stage.height/stage.width;this.uScale=uniform(vec2(1/stage.width*16,1/stage.width*16*ratio)),material.scaleNode=this.uScale;const particles=new Sprite(material);particles.count=count,this.container.add(particles),this.needsRender=!0,this.updateImage(this.lastFrameState),this.render3d(),this.onImageLoaded.dispatch(),this.allTilesDisplayed=!0})};getViewportExtent(){const view=this.openLayerMap.getView(),size=this.openLayerMap.getSize();if(!size)throw new Error("Map size is not available.");return view.calculateExtent(size)}prepareFrame(frameState2){return!0}renderFrame(frameState2){this.updateImage(frameState2)}render(){super.render(frameState)}updateImage=frameState2=>{if(this.lastFrameState=frameState2,!this.lastFrameState)return;const[vMinX,vMinY,vMaxX,vMaxY]=getRenderExtent(frameState2,frameState2.extent),viewportWidth=vMaxX-vMinX,viewportHeight=vMaxY-vMinY,scaleX=1/viewportWidth,scaleY=1/viewportHeight,viewProj=this.openLayerMap.getView().getProjection().getCode();if(this.data&&this.positionAttribute){const posArray=this.positionAttribute.array;for(let i2=0;i2<this.data.length;i2++){const[lon,lat]=this.data[i2],[x,y]=transform([lon,lat],"EPSG:4326",viewProj);posArray[i2*3]=(x-vMinX)*scaleX-.5,posArray[i2*3+1]=(y-vMinY)*scaleY-.5,posArray[i2*3+2]=0}this.positionAttribute.needsUpdate=!0}this.needsRender=!0};initRT=()=>{this.renderTarget||(this.renderTarget=ThreeJsTileLayerRenderer.PoolRenderTarget.checkOut())};releaseRT=()=>{this.renderTarget&&(ThreeJsTileLayerRenderer.PoolRenderTarget.checkIn(this.renderTarget),this.renderTarget=null)};resize=()=>{this.renderTarget&&(this.renderTarget.setSize(stage.width,stage.height),this.render3d())};update=dt=>{this.master.opacity<.001||this.needsRender&&this.render3d()};render3d=()=>{this.needsRender=!1,this.initRT(),stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(this.renderTarget),stage3d.renderer.render(this.container,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1),stage3d.renderNext()}}class ThreeJsParticleLayer extends BaseTileLayer{constructor(options,imgOption,master){super(options),this.imgOption=imgOption,this.master=master}createRenderer(){return new ThreeJsParticleLayerRenderer(this,this.imgOption,this.master)}initRT=()=>this.getRenderer().initRT();releaseRT=()=>this.getRenderer().releaseRT();addParticles=opts=>this.getRenderer().addParticles(opts);get texture(){return this.renderTarget?this.renderTarget.texture:null}get renderTarget(){return this.getRenderer().renderTarget}get container(){return this.getRenderer().container}get onImageLoaded(){return this.getRenderer().onImageLoaded}get onTilesDisplayed(){return this.getRenderer().onImageLoaded}}let planeGeometry=new PlaneGeometry(1,1,1,1);class Layer2{static renderOrder=1;constructor(map,data){if(this.openLayerMap=map,this.data=data,this.readyForNext=!1,this.directRender=window.location.search.includes("direct")?this.data.directRender:!1,this.visible=!1,this.opacity=0,this.fadeInTiles=!0,this.isReadingPixel=!1,this.isOptical=!1,this.opticalLayer=null,this.container=new Group,this.container.renderOrder=this.data.overrideRenderOrder?this.data.overrideRenderOrder:Layer2.renderOrder,data.opticalFlowLayer&&this.addOpticalFlow(new Layer2(map,data.opticalFlowLayer)),data.overlays)for(let overlay2 of data.overlays)overlay2.id==2&&this.addParticles(),overlay2.id==3&&this.addArrows(),overlay2.id==4&&this.addBarbules(),overlay2.id==5;this.layers={},this.currentLayer=null,this.prevLayer=null,this.percent=ref(1),this.currentForecastDate=ref(null),this.currentForecastIndex=0,this.material=new LayerMaterial(this),this.directRender||this.container.add(this.quad=new Mesh(planeGeometry,this.material)),stage3d.add(this.container),this.isInit=!1,stage.onUpdate.add(this.update)}init=async()=>{if(this.isInit)return;this.data.loadExtraData();const provider=this.provider;provider&&(provider.value.forecastDates&&(this.currentForecastDate.value=provider.value.forecastDates[0],this.currentForecastIndex=0),watch(provider,()=>{console.log("provider changed"),this.updateExtent(),this.updateLayer()}),watch(this.currentForecastDate,()=>{console.log("forecast changed"),this.updateLayer()})),this.isInit=!0,this.updateLayer()};updateLayer=()=>{this.addLayer(this.getURL())};addLayer(url){this.readyForNext=!1;const newLayer=this.layers[url]||this.addMapLayer(url);this.currentLayer?(this.directRender||this.prevLayer?.releaseRT(),this.prevLayer=this.currentLayer,this.percent.value=0,newLayer.allTilesDisplayed?this.animatePercent():newLayer.onTilesDisplayed.once(()=>{this.animatePercent()})):this.readyForNext=!0,newLayer.onTilesDisplayed.add(()=>{setTimeout(this.updateParticles,1)}),this.currentLayer=newLayer,this.visible&&!this.directRender&&this.currentLayer.initRT(),this.updateTextureRef()}animatePercent=()=>{utils.remove(this.percent,"value");let duration=this.data.fadeDuration;animate(this.percent,{value:[0,1],ease:"linear",duration,onUpdate:()=>{stage3d.renderNext()},onComplete:()=>{stage3d.renderNext(),this.readyForNext=!0,this.updateParticles(),this.prevLayer?.releaseRT()}})};addMapLayer(url){let layer3d=null;const source=this.getXYZSource(url);return this.data.isImgLayer?(layer3d=new ThreeJsImageLayer({source},{},this),this.data.initImages(layer3d,this)):this.data.isParticleLayer?(layer3d=new ThreeJsParticleLayer({source},{},this),this.data.initParticles(layer3d,this)):layer3d=new ThreeJsTileLayer({source},this),this.layers[url]=layer3d,this.openLayerMap.addLayer(layer3d),this.directRender&&(console.log(this.container),this.container.add(layer3d.container)),layer3d}getXYZSource(url){const resolutions=[],tileSizes=[],provider=this.provider.value;let maxZoom=parseInt(provider.maxZoom||13);console.log(this.data.name),(this.data.name=="borders"||this.data.name=="MapDataMarine")&&(maxZoom=11);const zoomFactor=this.data.zoomFactor,sizeFactor=this.data.sizeFactor;for(let i2=0;i2<=maxZoom;i2++){const zoom=Math.min(i2,maxZoom),resolution=this.openLayerMap.getView().getResolutionForZoom(zoom);resolutions.push(resolution/zoomFactor/sizeFactor),tileSizes.push(256*zoomFactor*sizeFactor)}let extent=this.openLayerMap.getView().getProjection().getExtent();this.updateExtent();const tileGrid=new TileGrid({extent,resolutions,tileSizes});return new XYZ({url,tileGrid,preload:1/0,transition:window.location.search.includes("notransition")||getTier()<2?0:.25,tileLoadFunction:async(imageTile,src)=>{let img2="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mP8/58BAQUBAKgBTk0AAAAASUVORK5CYII=";try{img2=await resourceCache.load(src,!0,!0,null,0)}catch{console.log("[404]tile:",revertUrlProxy(src))}imageTile.getImage().src=img2}})}updateExtent(){if(this.provider.value&&this.provider.value.model&&this.provider.value.model.bounds){let clampLatitude=function(lat){return Math.max(Math.min(lat,85.05112878),-85.05112878)},bounds=this.provider.value.model.bounds;const clampedBbox={nw:{lat:clampLatitude(bounds.nw.lat),lon:bounds.nw.lon},se:{lat:clampLatitude(bounds.se.lat),lon:bounds.se.lon}};this.srcExtent=[clampedBbox.nw.lon,clampedBbox.se.lat,clampedBbox.se.lon,clampedBbox.nw.lat]}else this.srcExtent=null}getURL=()=>{let url=null;return this.currentForecastDate.value?url=this.data.getUrl(this.currentForecastDate.value.date_model_run,this.currentForecastDate.value.date_ech):url=this.data.getUrl(),url};async setVisible(value,force=!1){this.visible==value&&!force||(this.visible=value,value?(await this.init(),this.currentLayer&&(this.container.renderOrder=this.data.overrideRenderOrder?this.data.overrideRenderOrder:Layer2.renderOrder++),this.prevLayer?.initRT(),this.currentLayer?.initRT()):this.pause(),utils.remove(this,"opacity"),animate(this,{opacity:value?1:0,duration:.35,onUpdate:v=>{stage3d.renderNext(),this.updateParticles()},onComplete:()=>{stage3d.renderNext(),value?this.updateParticles():(this.prevLayer?.releaseRT(),this.currentLayer?.releaseRT())}}),value&&(this.updateTextureRef(),this.updateRenderMaterial()),this.opticalLayer?.setVisible(value))}updateGradient=()=>{this.directRender||this.quad.material.updateGradient()};updateRenderMaterial=()=>{this.directRender||this.quad.material.update()};updateTextureRef=()=>{this.directRender||(this.currentLayer&&this.currentLayer.texture&&(this.quad.material.uTxtTo.value=this.currentLayer.texture,this.arrows&&(this.arrows.dataMap=this.currentLayer.texture),this.barbules&&(this.barbules.dataMap=this.currentLayer.texture),this.particles&&(this.particles.dataMap=this.currentLayer.texture),this.isobares&&(this.isobares.dataMap=this.currentLayer.texture)),this.prevLayer&&this.prevLayer.texture&&(this.quad.material.uTxtFrom.value=this.prevLayer.texture))};updateParticles=()=>{!this.particles||this.directRender||this.particles.updateColorMap(this.quad)};update=dt=>{this.container.visible=this.opacity>1e-4,this.quad&&(this.quad.material.opacity=this.opacity),this.particles&&(this.particles.opacity=this.opacity),this.arrows&&(this.arrows.opacity=this.opacity),this.barbules&&(this.barbules.opacity=this.opacity),this.isobares&&(this.isobares.opacity=this.opacity),this.currentLayer?.setVisible(this.container.visible),this.prevLayer?.setVisible(this.container.visible),this.visible&&this.isPlaying&&(this.shouldNext-=dt,this.shouldNext<=0&&this.readyForNext&&(this.shouldNext=this.data.delayBetween*1e3,this.nextForecast()))};async getValuePixel(x,y){if(this.isReadingPixel||!this.visible)return null;this.isReadingPixel=!0,this.renderTarget||(this.renderTarget=new RenderTarget(stage.width,stage.height,{depthBuffer:!1,stencilBuffer:!1,samples:1,alpha:!0,minFilter:LinearFilter,magFilter:LinearFilter,format:RGBAFormat,type:UnsignedByteType,colorSpace:NoColorSpace})),this.currentLayer.render();let pixelBuffer=await stage3d.renderer.readRenderTargetPixelsAsync(this.currentLayer.renderTarget,x,y,1,1);const[r2,g,b,a2]=pixelBuffer,result={r:r2,g,b,a:a2};stage3d.renderer.setClearColor(0,0),stage3d.renderer.setRenderTarget(this.renderTarget),stage3d.renderer.render(this.quad,stage3d.camera),stage3d.renderer.setRenderTarget(null),stage3d.renderer.setClearColor(14540253,1);let pixelBuffer2=await stage3d.renderer.readRenderTargetPixelsAsync(this.renderTarget,x,y,1,1);const[colorR,colorG,colorB,colorA]=pixelBuffer2;Object.assign(result,{colorR,colorG,colorB,colorA}),pickerValue.value=result,this.isReadingPixel=!1}addOpticalFlow=opticalLayer=>{opticalLayer.isOptical=!0,this.opticalLayer=opticalLayer};addIsobares=()=>{this.isobares=new Isobars(this),this.isobares.visible=!1,this.container.add(this.isobares)};addParticles=()=>{this.particles=new Particles,this.particles.setVisible(!1),this.container.add(this.particles)};addArrows=()=>{this.arrows=new Arrows,this.arrows.visible=!1,this.container.add(this.arrows)};addBarbules=()=>{this.barbules=new Barbules,this.barbules.visible=!1,this.container.add(this.barbules)};setOverlayVisible=(type,isVisible)=>{type=="particles"?type=2:type=="arrows"?type=3:type=="barbs"?type=4:type=="isobars"&&(type=5),this.arrows&&(this.arrows.visible=!1),this.barbules&&(this.barbules.visible=!1),this.particles&&this.particles.setVisible(!1),type==2&&this.particles&&this.particles.setVisible(isVisible,this.quad),type==3&&this.arrows&&(this.arrows.visible=isVisible),type==4&&this.barbules&&(this.barbules.visible=isVisible),type==5&&this.isobares&&(this.isobares.visible=isVisible)};play(){this.visible&&(this.fadeInTiles=!1,this.isPlaying=!0,this.shouldNext=0)}pause(){this.fadeInTiles=!0,this.isPlaying=!1,this.shouldNext=0}nextForecast=()=>{if(!this.readyForNext)return;const provider=this.provider;provider&&provider.value.forecastDates&&(this.currentForecastIndex+=this.data.stepForecast,this.currentForecastIndex%=provider.value.forecastDates.length,this.currentForecastDate.value=provider.value.forecastDates[this.currentForecastIndex],this.fadeInTiles=!1)};prevForecast=()=>{if(!this.readyForNext)return;const provider=this.provider;provider&&provider.value.forecastDates&&(this.currentForecastIndex-=this.data.stepForecast,this.currentForecastIndex<0&&(this.currentForecastIndex=provider.value.forecastDates.length-1),this.currentForecastDate.value=provider.value.forecastDates[this.currentForecastIndex],this.fadeInTiles=!1)};setForecast=async dateTime=>{const provider=this.provider.value;if(!provider.forecastDates)return;const target=new Date(dateTime);let closest=null;const currentMin=new Date(provider.forecastDates[0].datetime.split("+")[0]),currentMax=new Date(provider.forecastDates[provider.forecastDates.length-1].datetime.split("+")[0]);if(target<currentMin||target>currentMax){const defaultProvider=this.data.providers[0];if(defaultProvider!==provider)return defaultProvider.isLoaded||await defaultProvider.loadExtraData(),this.data.selectedProvider=defaultProvider,this.provider.value=defaultProvider,console.log("here we dispatch chronological fallback"),MapJS.onChronologicFallback.dispatch(),this.setForecast(dateTime)}for(const f2 of provider.forecastDates){const d2=new Date(f2.datetime.split("+")[0]);d2<=target&&(!closest||d2>new Date(closest.datetime.split("+")[0]))&&(closest=f2)}this.currentForecastDate.value=closest};async setModel(modelID){let provider=this.data.providers.find(provider2=>provider2.model.name===modelID);if(provider||(provider=this.data.providers[0]),provider){if(provider===this.provider.value){console.log("same provider, no change");return}provider.isLoaded||await provider.loadExtraData(),this.provider.value=provider,this.updateExtent()}}get isLoading(){return this.currentLayer&&this.currentLayer.isLoading}get label(){return this.data.name}get name(){return this.provider.value.layerName||this.label}get backgroundLayer(){return this.provider.value.backgroundLayer}get foregroundLayer(){return this.provider.value.foregroundLayer}get provider(){let p=this.data.getProvider();return p||null}get modelId(){return!this.provider||!this.provider.value||!this.provider.value.model?null:this.provider.value.model.name}get blur(){return this.data.colorOptions.blur}get renderOrder(){return this.container.renderOrder}dispose=()=>{}}const mouse={isDown:!1,x:stage.width*.5,y:stage.height*.5,moveX:stage.width*.5,moveY:stage.height*.5,isMoveX:!1,isMoveY:!1,e:null,downStart:0,downEnd:0,percentX:.5,percentY:.5,normalizedX:0,normalizedY:0,totalDistance:0},prevMouse={x:mouse.x,y:mouse.y},[onDown,onUp,onMove,onClick,onEnter,onLeave]=Array(6).fill().map(()=>new Signal);function refreshMouseState(e2){return Object.assign(mouse,{x:e2.x,y:e2.y,moveX:e2.x-mouse.x,moveY:e2.y-mouse.y,percentX:e2.x/stage.width,percentY:e2.y/stage.height,normalizedX:(e2.x/stage.width-.5)*2,normalizedY:(e2.y/stage.height-.5)*2,e:e2}),!mouse.isMoveX&&!mouse.isMoveY&&(Math.abs(mouse.moveX)>Math.abs(mouse.moveY)&&Math.abs(mouse.moveX)>15?mouse.isMoveX=!0:Math.abs(mouse.moveY)>Math.abs(mouse.moveX)&&Math.abs(mouse.moveY)>15&&(mouse.isMoveY=!0)),mouse.totalDistance+=Math.abs(mouse.moveX)+Math.abs(mouse.moveY),mouse}function clearMouseState(){Object.assign(mouse,{isDown:!1,moveX:0,moveY:0,isMoveX:!1,isMoveY:!1,downEnd:Date.now()})}if(typeof window<"u"){const leaveOrBlur=()=>{clearMouseState(),onLeave.dispatch()};window.addEventListener("blur",leaveOrBlur),window.addEventListener("pointerleave",leaveOrBlur),window.addEventListener("pointerdown",e2=>{Object.assign(mouse,{isDown:!0,downStart:Date.now(),x:e2.x,y:e2.y,totalDistance:0}),onDown.dispatch(refreshMouseState(e2))}),window.addEventListener("pointermove",e2=>{Object.assign(prevMouse,mouse),onMove.dispatch(refreshMouseState(e2))}),window.addEventListener("pointerup",e2=>{clearMouseState(),onUp.dispatch(refreshMouseState(e2))}),window.addEventListener("pointercancel",e2=>{console.log("pointercancel"),clearMouseState(),onUp.dispatch(refreshMouseState(e2))}),window.addEventListener("click",e2=>{mouse.downEnd-mouse.downStart<=300&&mouse.totalDistance<=10&&onClick.dispatch(refreshMouseState(e2))})}typeof document<"u"&&document.body.addEventListener("pointerenter",()=>{clearMouseState(),onEnter.dispatch()});class LayerManager{constructor(){this.onUpdate=new Signal,this.onHide=new Signal,this.onShow=new Signal,this.openLayerMap=new Map$1({maxTilesLoading:256}),this.layers=new Map,this.lastLayer=null}init(options){this.options=options,this.mode=options.mode,this.initMap(),this.initLayers(),this.listenStore(),this.pickerUpdate()}listenStore(){watch(panEnabled,value=>{this.openLayerMap.getInteractions().forEach(interaction=>{(interaction instanceof DragPan||interaction instanceof KeyboardPan)&&interaction.setActive(value)})}),watch(zoomEnabled,value=>{this.openLayerMap.getInteractions().forEach(interaction=>{(interaction instanceof DoubleClickZoom||interaction instanceof PinchZoom||interaction instanceof KeyboardZoom||interaction instanceof MouseWheelZoom||interaction instanceof DragZoom)&&interaction.setActive(value)})})}pickerUpdate(){this.options.domElement||document.body.querySelector("#map")||console.warn("No map element found"),stage.onUpdate.add(()=>{pickerEnabled.value?this.getLayerByName(this.lastLayer).getValuePixel(parseInt(mouse.x),parseInt(mouse.y)):pickerValue.value=null})}initMap(){useGeographic();const map=this.options.domElement||document.body.querySelector("#map");map||console.warn("No map element found"),this.openLayerMap=new Map$1({target:map,view:new View({center:this.options.latlon.reverse(),zoom:this.options.zoom||4,minZoom:3,maxZoom:13,enableRotation:!1}),controls:[]}),this.openLayerMap.on("error",()=>{console.log("error")});var currentZoom=this.openLayerMap.getView().getZoom();this.openLayerMap.on("moveend",e2=>{var newZoom=this.openLayerMap.getView().getZoom();const centerWebMercator=this.openLayerMap.getView().getCenter();mapJS.onMapMove.dispatch(centerWebMercator,newZoom),currentZoom!=newZoom&&(currentZoom=newZoom,mapJS.onZoom.dispatch(currentZoom));let layer=this.getLayerByName(this.lastLayer);layer&&layer.srcExtent&&this.checkOutOfBounds()}),this.view=this.openLayerMap.getView();const maxZoomTileAvailable=6;for(let i2=0;i2<18;i2++){const zoom=Math.min(i2,maxZoomTileAvailable);this.view.getResolutionForZoom(zoom)}}checkOutOfBounds(){const center=this.openLayerMap.getView().getCenter();if(!center)return;const[centerX,centerY]=center,layer=this.getLayerByName(this.lastLayer);if(!layer||!Array.isArray(layer.srcExtent)||layer.srcExtent.length!==4)return;const[layerMinX,layerMinY,layerMaxX,layerMaxY]=layer.srcExtent;let isOutOfBounds=!1;centerX<layerMinX&&(isOutOfBounds=!0),centerX>layerMaxX&&(isOutOfBounds=!0),centerY>layerMaxY&&(isOutOfBounds=!0),centerY<layerMinY&&(isOutOfBounds=!0),isOutOfBounds&&(layer.data.providers&&layer.data.providers.length>0&&(layer.data.selectedProvider=layer.data.providers[0]),mapJS.onGeographicFallback.dispatch())}getExtentCenter(extent){const[minX,minY,maxX,maxY]=extent;return[(minX+maxX)/2,(minY+maxY)/2]}containsPoint(extent,point){const[minX,minY,maxX,maxY]=extent,[x,y]=point;return x>=minX&&x<=maxX&&y>=minY&&y<=maxY}initLayers(){for(const layer of layers.value)this.layers.set(layer.name,new Layer2(this.openLayerMap,layer))}async setVisibleLayer(layerName,visible=!0){const selectedLayer=this.getLayerByName(layerName);if(this.lastLayer=layerName,visible){for(const layer of this.layers.values())layer.name!=layerName&&(layer.name=="borders"||layer.name=="cities"||selectedLayer.name=="borders"||selectedLayer.name=="cities"||(layerName=="radar"||layerName=="eumetsat"||layerName=="BlueMarble"||layerName=="foudre"||layerName=="mask")&&(layer.name=="radar"||layer.name=="eumetsat"||layer.name=="BlueMarble"||layer.name=="foudre"||layer.name=="mask")||layerName=="precip"&&layer.name=="BlueMarble"||layerName=="BlueMarble"&&layer.name=="precip"||layer.backgroundLayer==layerName||layer.foregroundLayer==layerName||selectedLayer.backgroundLayer==layer.name||selectedLayer.foregroundLayer==layer.name||layer.setVisible(!1,!1));selectedLayer&&selectedLayer.backgroundLayer&&this.getLayerByName(selectedLayer.backgroundLayer)?.setVisible(!0,!0),selectedLayer.name=="radar"&&this.getLayerByName("mask")?.setVisible(!0,!0),selectedLayer&&selectedLayer.foregroundLayer&&this.getLayerByName(selectedLayer.foregroundLayer)?.setVisible(!0,!0)}else selectedLayer.name=="radar"&&this.getLayerByName("mask")?.setVisible(!1,!1);await selectedLayer?.setVisible(visible,!0),visible&&selectedLayer&&selectedLayer.modelId&&selectedLayer.modelId!=currentModel.value&&(await this.setModel(selectedLayer.modelId),currentModel.value=selectedLayer.modelId)}setOverlayVisible(type,isVisible){this.getLayerByName(this.lastLayer)?.setOverlayVisible(type,isVisible),stage3d.renderNext()}isLayerVisible(layerName){const layer=this.layers.get(layerName);return layer?layer.visible:!1}getLayerByName(layerName){return this.layers.get(layerName)}async setModel(modelID){const promises=[];for(let layer of this.layers.values())layer&&promises.push(layer.setModel(modelID));return Promise.all(promises)}wrapLon=lon=>((lon+180)%360+360)%360-180;getCurrentExtent(){const view=this.openLayerMap.getView(),size=this.openLayerMap.getSize();if(!size)throw new Error("Map size is not available.");const extent=view.calculateExtent(size);return extent[0]=this.wrapLon(extent[0]),extent[2]=this.wrapLon(extent[2]),extent}setForecast=dateTime=>{this.getLayerByName(this.lastLayer)?.setForecast(dateTime)};play=()=>{for(const layer of this.layers.values())layer.name!="borders"&&layer.play()};pause=()=>{for(const layer of this.layers.values())layer.name!="borders"&&layer.pause()};prevForecast=()=>{for(const layer of this.layers.values())layer.name!="borders"&&layer.prevForecast()};nextForecast=()=>{for(const layer of this.layers.values())layer.name!="borders"&&layer.nextForecast()};dispose=()=>{};get paramId(){return this.lastLayer||"none"}get modelId(){let layer=this.getLayerByName(this.lastLayer);return layer?layer.modelId:"none"}}const LayerManager$1=new LayerManager;class Picker{constructor(){this.div=document.createElement("div"),this.div.class="mapjs-picker",this.div.style.position="absolute",this.div.style.display="block",this.div.style.zIndex="1000",this.div.style.pointerEvents="none",this.div.style.color="white",this.div.style.fontWeight="bold",this.div.style.fontFamily="Arial",this.div.style.fontSize="12px",this.div.style.padding="4px",this.div.style.borderRadius="4px",this.div.style.backgroundColor="rgba(0,0,0,0.5)",watch(pickerEnabled,value=>{value?this.attach(this.domElement):this.detach()}),watch(pickerValue,value=>{this.updateValue(value)}),stage.onUpdate.add(this.update)}attach(domElement){this.domElement=domElement,domElement.appendChild(this.div)}detach(){this.div.remove()}update=()=>{pickerEnabled.value&&(this.div.style.left=`${mouse.x}px`,this.div.style.top=`${mouse.y}px`)};updateValue=()=>{let value=pickerValue.value;value?this.div.innerHTML=`r: ${value.r}, g: ${value.g}, b:${value.b}<br>r${value.colorR}, g${value.colorG}, b${value.colorB}`:this.div.innerHTML=""}}let MapJS$1=class{constructor(){this.onParametersChange=new Signal,this.onOverlayChange=new Signal,this.onMapReady=new Signal,this.onMapLoading=new Signal,this.onLoadingComplete=new Signal,this.onDeviceLost=new Signal,this.onMapMove=new Signal,this.onModelChange=new Signal,this.onGeographicFallback=new Signal,this.onChronologicFallback=new Signal,this.onChronologicFallback.add(()=>this.onModelChange.dispatch({paramId:LayerManager$1.paramId,newModel:LayerManager$1.modelId,type:1})),this.onGeographicFallback.add(()=>this.onModelChange.dispatch({paramId:LayerManager$1.paramId,newModel:LayerManager$1.modelId,type:2})),this.onLayerSelected=new Signal,this.onProviderSelected=new Signal,this.onRunSelected=new Signal,this.onError=new Signal,this.onZoom=new Signal,this.onPan=new Signal,this.onMarkerClick=new Signal,this.onMarkerHover=new Signal,this.store=MapStore,this.picker=new Picker,window.MapJS=this,this.currentDisplayedLayers=new Set}async init(options){await performanceTest(),proxy.value=options.proxy,options={model:"default",env:"prod",publisher:"meteoconsultmarine",platform:"web",baseURL:"meteoconsult.fr",tilesURL:"https://static5.mclcm.net/images/dynmap/models",latlon:[48.8566,2.3522],zoom:4,cityDisplay:!1,defaultLayer:"",proxy:null,domElement:null,...options},options.env=options.env.replace("prod","ws").replace("phl","phl-ws"),options.modelURL=options.modelURL||`https://${options.env}.${options.baseURL}/interactivemap/${options.publisher}/${options.platform}/fr/v3.0/map_engine/models`,options.parametersURL=options.parametersURL||`https://${options.env}.${options.baseURL}/${options.publisher}/${options.platform}/100/fr/v30/interactivemap/parameters`,options.legendURL=options.legendURL||`https://${options.env}.${options.baseURL}/${options.publisher}/${options.platform}/100/fr/v30/interactivemap/legends`,await stage3d.initRender(options),ThreeJsTileLayerRenderer.initPool(),stage3d.renderer.onDeviceLost=this.onDeviceLostHandler,modelURL.value=options.modelURL,parametersURL.value=options.parametersURL,legendURL.value=options.legendURL,tilesURL.value=options.tilesURL,await fetchModels(options.proxy),this.onMapLoading.dispatch(),await LayerManager$1.init(options),LayerManager$1.setVisibleLayer("borders",!0),options.cityDisplay&&LayerManager$1.setVisibleLayer("cities",!0),options.defaultLayer&&options.defaultLayer!=""&&setTimeout(()=>{LayerManager$1.setVisibleLayer(options.defaultLayer,!0)},1e3),LayerManager$1.setForecast(options.dateTime),engine.timeUnit="s",options.domElement&&this.attachTo(options.domElement),this.log("initialized",options),this.onMapReady.dispatch(),this.loading=-1,watch(currentLoading,value=>{value===0&&this.loading!==value&&this.onLoadingComplete.dispatch(),this.loading=value})}resize(width,height,autoScale=!0){this.log("resize",width,height),stage.autoScale=autoScale,stage.resize(width,height),stage3d.resize(),stage3d.renderNext()}attachTo(domElement,autoScale=!0){this.observer&&this.detach(),stage.autoScale=autoScale,this.observer=this.observer||new ResizeObserver(entries=>{for(const entry of entries)stage.resize(entry.contentRect.width,entry.contentRect.height),stage3d.resize()}),domElement.appendChild(stage3d.renderer.domElement),this.observer.observe(domElement),this.picker.attach(domElement)}detach(){this.observer&&(this.observer.disconnect(),this.observer=null)}setVisibleLayer(layerName,isVisible){LayerManager$1.setVisibleLayer(layerName,isVisible),this.log("setVisibleLayer",layerName,isVisible)}async setLayer({dateTime=null,datas}){const multiple=datas.length>1;for(const{id:layer,model,overlay:overlay2}of datas){if(multiple)layer&&(await this.setVisibleLayer(layer,!0),this.currentDisplayedLayers.add(layer));else{const toHide=new Set(this.currentDisplayedLayers);layer&&(toHide.delete(layer),await this.setVisibleLayer(layer,!0),this.currentDisplayedLayers.add(layer));for(const l2 of toHide)await this.setVisibleLayer(l2,!1),this.currentDisplayedLayers.delete(l2)}model&&await this.setModel(model),dateTime&&await this.setForecast(dateTime),this.setOverlayVisible(overlay2,!!overlay2)}}display(params){console.log("display LibJS is called"),this.setLayer(params)}async setModel(modelID){sessionStorage.setItem("modelID",modelID),await LayerManager$1.setModel(modelID),currentModel.value=modelID,this.log("setModel",modelID)}setForecast(dateTime){dateTime=dateTime.split("+")[0],console.log(dateTime),LayerManager$1.setForecast(dateTime),this.log("setForecast",dateTime)}isLayerVisible(layerName){return LayerManager$1.isLayerVisible(layerName)}getLayerByName(layerName){return LayerManager$1.getLayerByName(layerName)}setOverlayVisible(type,isVisible){this.log("setOverlayVisible",type,isVisible),LayerManager$1.setOverlayVisible(type,isVisible)}showOverlay(type,options){this.setOverlayVisible(type,!0)}hideOverlay(type){this.setOverlayVisible(type,!1)}forecastDate(echeance,run){this.log("forecastDate",echeance,run)}play(options){this.log("play"),options&&options.dateTime&&this.setForecast(options.dateTime),LayerManager$1.play()}pause(){this.log("pause"),LayerManager$1.pause()}nextForecast(){this.log("nextForecast"),LayerManager$1.nextForecast()}prevForecast(){this.log("prevForecast"),LayerManager$1.prevForecast()}panTo(lat,lon,duration=1200){this.log(`panTo (${lat}, ${lon})`),LayerManager$1.view.animate({center:[lon,lat],duration})}zoomTo(zoomLevel){this.log("zoomTo",zoomLevel),LayerManager$1.view.animate({zoom:zoomLevel,duration:500})}updateZoom(additiveValue){this.zoomTo(this.zoom+additiveValue)}zoomIn(){this.zoomTo(this.zoom+1)}zoomOut(){this.zoomTo(this.zoom-1)}get zoom(){return LayerManager$1.view.getZoom()}flyTo(lat,lon){this.log("flyTo",lat,lon),LayerManager$1.view.animate({center:fromLonLat([lon,lat]),duration:1200})}restrictBounds(bounds){this.log("restrictBounds",bounds)}addMarker(lat,lon,options){this.log("addMarker",lat,lon,options)}removeMarker(markerID){this.log("removeMarker",markerID)}preloadForecast(echeanceCount){this.log("preloadForecast",echeanceCount)}preloadTilesLevel(deep){this.log("preloadTilesLevel",deep)}onDeviceLostHandler=()=>{this.log("Device lost"),this.onDeviceLost.dispatch(),window.location.reload()};async screenshot(){return await stage3d.screenshot()}get model(){return currentModel.value}set model(value){this.log("switchModel",value),currentModel.value=value}get panEnabled(){return panEnabled.value}set panEnabled(value){if(typeof value!="boolean"){console.warn("panEnabled must be a boolean");return}this.log("panEnabled",value),panEnabled.value=value}get zoomEnabled(){return zoomEnabled.value}set zoomEnabled(value){if(typeof value!="boolean"){console.warn("zoomEnabled must be a boolean");return}this.log("zoomEnabled",value),zoomEnabled.value=value}get pickerEnabled(){return pickerEnabled.value}set pickerEnabled(value){if(typeof value!="boolean"){console.warn("pickerEnabled must be a boolean");return}this.log("pickerEnabled",value),pickerEnabled.value=value}dispose(){this.log("dispose")}log(...args){console.log("[MapJS]",...args)}};const mapJS=new MapJS$1;window.mapJS=mapJS;module.exports=mapJS;
